<?php // $Revision: 1.32 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: add_announcement.php,v 1.32 2013/01/29 08:46:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
$bodyCommand = "onLoad=\"document.ancForm.subject.focus();\"";

/**
 * Variables init
 */
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$sendty = isset($_POST['sendty'])?$_POST['sendty']:'S';
$sendto = isset($_POST['sendto'])?$_POST['sendto']:'';
$subject = isset($_POST['subject'])?$_POST['subject']:'';
$message = isset($_POST['message'])?$_POST['message']:'';
$error = '';
$to_id = array();

/**
 * Check fields
 */
if ($action != '') {
    if ($sendty == 'C') {           // send to client users
        $querymore1 = " WHERE org.id='$sendto'";
        $clientDetail = new request();
        $clientDetail->openOrganizations($querymore1);
        $comptClientDetail = count($clientDetail->org_id);

        if ($comptClientDetail == '0') {
            header('Location: ../general/newnotifications.php?msg=blankClient');
            exit;
        }

        $querymore2 = " WHERE mem.organization='$sendto' AND mem.active<>'" . enumBoolean::bFalse . "'";
        $listMembers = new request();
        $listMembers->openMembers($querymore2);
        $to_id = $listMembers->mem_id;
    } elseif ($sendty == 'P') {     // send to project team members
        $querymore1 = " WHERE pro.id='$sendto'";
        $projectDetail = new request();
        $projectDetail->openProjects($querymore1);
        $comptProjectDetail = count($projectDetail->pro_id);

        if ($comptProjectDetail == '0') {
            header('Location: ../general/newnotifications.php?msg=blankProject');
            exit;
        }

        $querymore2 = " WHERE tea.project='$sendto' AND mem.active<>'" . enumBoolean::bFalse . "'";
        $listTeams = new request();
        $listTeams->openTeams($querymore2);
        $to_id = $listTeams->tea_member;
    } elseif ($sendty == 'S') {         // send to internal users
        $querymore2 = " WHERE mem.organization='1' AND mem.active<>'" . enumBoolean::bFalse . "'";

        if ($sendto != 'ALL') {
            if (is_array($sendto) && count($sendto) > 0) {
                $querymore2 .= " AND mem.department IN ('" . implode("','", $sendto) . "')";
            } else {
                $querymore2 .= " AND mem.id='0'";
            }
        }

        $listMembers = new request();
        $listMembers->openMembers($querymore2);
        $to_id = $listMembers->mem_id;
    }

    if (count($to_id) <= 0) {
        header('Location: ../general/newnotifications.php?msg=blankUser');
        exit;
    }
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    if ($action == "send") {
        // backup timezone session
        $timezoneBackup = $timezoneSession;

        foreach ($to_id as $mem) {
            $querymore = " WHERE mem.id='$mem'";
            $memberDetail = new request();
            $memberDetail->openMembers($querymore);
            // change timezone
            if ($memberDetail->mem_timezone[0] == '') {
                $timezoneSession = $defaultTimezone;
            } else {
                $timezoneSession = $memberDetail->mem_timezone[0];
            }
            // change language
            if (selectLanguage($memberDetail->mem_language[0])) {
                // currency matrix
                require('../includes/currency.inc.php');
                // load array definitions
                require('../includes/arrays.lib.php');
            }

            $mail = new notification();
            $mail->getUserinfo($idSession, "from");
            $mail->getUserinfo($mem, "to");
            $mail->Subject = $subject;
            $mail->Priority = 3;
            $mail->partMessage = "";
            $mail->openBody();
            $mail->plainContent($message);
            $mail->closeBody();
            $mail->SendItOut();
        }

        // restore timezone session
        $timezoneSession = $timezoneBackup;
        // restore language
        if (selectLanguage($languageSession)) {
            // currency matrix
            require('../includes/currency.inc.php');
            // load array definitions
            require('../includes/arrays.lib.php');
        }

        header("Location: ../general/newnotifications.php?msg=add");
        exit;
    }
}

/**
 * load data
 */
$sendtoVV = array('' => '');

if ($sendty == 'P') {
    $querymore3 = " WHERE pro.status NOT IN ('" . enumProjectStatus::stCanceled . "','" . enumProjectStatus::stCompleted . "') AND EXISTS (SELECT mem.id FROM " . $tablePrefix . "teams tea INNER JOIN " . $tablePrefix . "members mem ON mem.id=tea.member WHERE tea.project=pro.id AND mem.active<>'" . enumBoolean::bFalse . "') ORDER BY pro.name";
    $listProjects = new request();
    $listProjects->openProjects($querymore3);
    $comptListProjects = count($listProjects->pro_id);

    for ($i=0; $i<$comptListProjects; $i++) {
        $sendtoVV[$listProjects->pro_id[$i]] = $listProjects->pro_name[$i];
    }
} else if ($sendty == 'C') {
    $querymore3 = " WHERE org.id<>'1' AND org.locked<>'" . enumBoolean::bTrue . "' AND EXISTS (SELECT mem.id FROM " . $tablePrefix . "members mem WHERE mem.organization=org.id AND mem.active<>'" . enumBoolean::bFalse . "') ORDER BY org.name";
    $listClients = new request();
    $listClients->openOrganizations($querymore3);
    $comptListClients = count($listClients->org_id);

    for ($i=0; $i<$comptListClients; $i++) {
        $sendtoVV[$listClients->org_id[$i]] = $listClients->org_name[$i];
    }
} else if ($sendty == 'S') {
    $sendtoVV = array();
    $querymore3 = " WHERE dep.organization='1' AND dep.locked<>'" . enumBoolean::bTrue . "' ORDER BY dep.name";
    $listDepartments = new request();
    $listDepartments->openDepartments($querymore3);
    $comptListDepartments = count($listDepartments->dep_id);

    for ($i=0; $i<$comptListDepartments; $i++) {
        $sendtoVV[$listDepartments->dep_id[$i]] = $listDepartments->dep_name_print[$i];
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../general/newnotifications.php?", lang_strings("my_notifications"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_announcement"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "anc";
$block1->openForm("../administration/add_announcement.php?#" . $block1->form . "Anchor");
$block1->heading(lang_strings("add_announcement"));
echo '<input type="hidden" id="action" name="action" value="send">';
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$announceTypes = array(
    'S' => $strings['internal'],
    'P' => $strings['project'],
    'C' => $strings['client']
);
setupInputHTML($block1, lang_strings('type'), 'sendty', enumFieldType::ftAlphaNumeric, 'Y', '1', $sendty, $announceTypes, '', false, '', 'onchange="javascript:$(\'#action\').val(\'\');document.ancForm.submit();"');

if ($sendty == 'P') {
    setupInputHTML($block1, lang_strings('project'), 'sendto', enumFieldType::ftNumeric, 'Y', '10', $sendto, $sendtoVV);
} else if ($sendty == 'C') {
    setupInputHTML($block1, lang_strings('client'), 'sendto', enumFieldType::ftNumeric, 'Y', '10', $sendto, $sendtoVV);
} else if ($sendty == 'S') {
    if (count($sendtoVV) > 1) {
        $sendtoSel = '<select name="sendto[]" multiple>';

        foreach ($sendtoVV as $val => $desc) {
            $sendtoSel .= '<option value="' . $val . '" selected>' . $desc . '</option>';
        }

        $sendtoSel .= '</select>';
        $block1->contentRow(lang_strings('department'), $sendtoSel);
    } else {
        echo '<input type="hidden" name="sendto" value="ALL">';
    }
}

$block1->contentTitle(lang_strings("details"));
setupInputHTML($block1, lang_strings("subject"), 'subject', enumFieldType::ftText, 'Y', '255', $subject);
setupInputHTML($block1, lang_strings("message"), 'message', enumFieldType::ftMemo, 'Y', '0', $message);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["send"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
