<?php // $Revision: 1.25 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: request.class.php,v 1.25 2013/02/19 14:15:27 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

class request extends request_dbspec {
    /**
     * result forms
     *
     * @global array $row
     * @global string $tablePrefix
     * @param string $tblnam
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openForms($tblnam, $querymore, $start = "", $rows = "")
    {
        global $row, $tablePrefix;
        $querymore1 = " WHERE tdf.tablename='$tblnam'";
        $this->openTablesDefinitions($querymore1);      // table definitions
        $pe = $this->tdf_publishenabled[0];             // enable publish to customer service site
        $querymore2 = " WHERE fdf.tablename='$tblnam'";
        $this->openFieldsDefinitions($querymore2);      // field definitions

        if (!is_array($this->fdf_dbfieldname)) {
            $this->fdf_dbfieldname = array();
        }

        $this->tablename = $tblnam;                     // The name of table
        $this->dbtablename = $tablePrefix . preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam);  // The real name of table in the database
        $this->connectClass();
        $sql = "SELECT f.id,f.status,f.printed,f.project,f.created,f.cuser,f.modified,f.muser,p.name,c.name,c.email_work,m.name,m.email_work" . (($pe=='Y')?',f.published':'') . " FROM " . $this->dbtablename . " f LEFT OUTER JOIN " . $tablePrefix . "projects p ON p.id=f.project LEFT OUTER JOIN " . $tablePrefix . "members c ON c.id=f.cuser LEFT OUTER JOIN " . $tablePrefix . "members m ON m.id=f.muser " . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->row_index = 0;
        $this->rows = array();

        while ($this->fetch()) {
            $i = 0;
            $id = ($row[$i++]);
            $this->rows[$this->row_index]['id'] = $id;
            $this->rows[$this->row_index]['status'] = ($row[$i++]);
            $this->rows[$this->row_index]['printed'] = ($row[$i++]);
            $this->rows[$this->row_index]['project'] = ($row[$i++]);
            $this->rows[$this->row_index]['created'] = ($row[$i++]);
            $this->rows[$this->row_index]['cuser'] = ($row[$i++]);
            $this->rows[$this->row_index]['modified'] = ($row[$i++]);
            $this->rows[$this->row_index]['muser'] = ($row[$i++]);
            $this->rows[$this->row_index]['project_name'] = HtmlEntityDecodeNOD($row[$i++]);
            $this->rows[$this->row_index]['cuser_name'] = HtmlEntityDecodeNOD($row[$i++]);
            $this->rows[$this->row_index]['cuser_email_work'] = ($row[$i++]);
            $this->rows[$this->row_index]['muser_name'] = HtmlEntityDecodeNOD($row[$i++]);
            $this->rows[$this->row_index]['muser_email_work'] = ($row[$i++]);

            if ($pe == 'Y') {
                $this->rows[$this->row_index]['published'] = ($row[$i++]);
            }

            $this->rows[$this->row_index]['description'] = setupDocDesc($tblnam, $id);
            $this->row_index++;
        }

        $this->row_count = $this->row_index;            // record count
    }
    /**
     * result forms (formfields)
     *
     * @global array $row
     * @global string $tablePrefix
     * @param string $tblnam
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openForms2($tblnam, $querymore, $start = "", $rows = "")
    {
        global $row, $tablePrefix;
        $querymore1 = " WHERE tdf.tablename='$tblnam'";
        $this->openTablesDefinitions($querymore1);      // table definitions
        $querymore2 = " WHERE fdf.tablename='$tblnam'";
        $this->openFieldsDefinitions($querymore2);      // field definitions

        if (!is_array($this->fdf_dbfieldname)) {
            $this->fdf_dbfieldname = array();
        }

        $formfields = explode('+', $this->tdf_formfields[0]);
        $key = array_search('id', $formfields);

        if ($key !== FALSE) {
            unset($formfields[$key]);
        }

        $this->tablename = $tblnam;                     // The name of table
        $this->dbtablename = $tablePrefix . preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam);  // The real name of table in the database
        $this->connectClass();
        $sql = "SELECT f.id,c.name,c.email_work,m.name,m.email_work" . ((count($formfields)==0)?'':',f.' . implode(',f.', $formfields)) . " FROM " . $this->dbtablename . " f LEFT OUTER JOIN " . $tablePrefix . "members c ON c.id=f.cuser LEFT OUTER JOIN " . $tablePrefix . "members m ON m.id=f.muser " . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->row_index = 0;
        $this->rows = array();

        while ($this->fetch()) {
            $i = 0;
            $id = ($row[$i++]);
            $this->rows[$this->row_index]['id'] = $id;
            $this->rows[$this->row_index]['cuser_name'] = HtmlEntityDecodeNOD($row[$i++]);
            $this->rows[$this->row_index]['cuser_email_work'] = ($row[$i++]);
            $this->rows[$this->row_index]['muser_name'] = HtmlEntityDecodeNOD($row[$i++]);
            $this->rows[$this->row_index]['muser_email_work'] = ($row[$i++]);

            if (count($formfields) > 0) {
                foreach ($formfields as $dbfldnam) {
                    $val = ($row[$i++]);
                    $this->rows[$this->row_index][$dbfldnam] = $val;
                }
            }

            $this->row_index++;
        }

        $this->row_count = $this->row_index;            // record count
    }
    /**
     * results sorting
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openSorting($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["sorting"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->sor_member = array();
        $this->sor_sortid = array();
        $this->sor_sortstr = array();

        while ($this->fetch()) {
            $i = 0;
            $this->sor_member[] = ($row[$i++]);
            $this->sor_sortid[] = ($row[$i++]);
            $this->sor_sortstr[] = ($row[$i++]);
        }
    }
    /**
     * results contacts
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openContacts($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["contacts"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->con_id = array();
        $this->con_salutation = array();
        $this->con_first_name = array();
        $this->con_last_name = array();
        $this->con_title = array();
        $this->con_organization = array();
        $this->con_department = array();
        $this->con_do_not_call = array();
        $this->con_email_work = array();
        $this->con_email_home = array();
        $this->con_email_other = array();
        $this->con_phone_work = array();
        $this->con_phone_home = array();
        $this->con_phone_other = array();
        $this->con_mobile = array();
        $this->con_fax = array();
        $this->con_address_street = array();
        $this->con_address_city = array();
        $this->con_address_state = array();
        $this->con_address_postalcode = array();
        $this->con_address_country = array();
        $this->con_alt_address_street = array();
        $this->con_alt_address_city = array();
        $this->con_alt_address_state = array();
        $this->con_alt_address_postalcode = array();
        $this->con_alt_address_country = array();
        $this->con_assistant = array();
        $this->con_assistant_phone = array();
        $this->con_birthdate = array();
        $this->con_description = array();
        $this->con_shared = array();
        $this->con_member = array();
        $this->con_created = array();
        $this->con_cuser = array();
        $this->con_modified = array();
        $this->con_muser = array();
        $this->con_formatted_name = array();
        $this->con_org_name = array();
        $this->con_mem_login = array();
        $this->con_mem_name = array();
        $this->con_mem_email_work = array();
        $this->con_mem1_login = array();
        $this->con_mem1_name = array();
        $this->con_mem1_email_work = array();

        while ($this->fetch()) {
            $i = 0;
            $this->con_id[] = ($row[$i++]);
            $this->con_salutation[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_first_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $ln = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_last_name[] = $ln;
            $this->con_title[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_organization[] = ($row[$i++]);
            $this->con_department[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_do_not_call[] = ($row[$i++]);
            $this->con_email_work[] = ($row[$i++]);
            $this->con_email_home[] = ($row[$i++]);
            $this->con_email_other[] = ($row[$i++]);
            $this->con_phone_work[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_phone_home[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_phone_other[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_mobile[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_fax[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_address_street[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_address_city[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_address_state[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_address_postalcode[] = ($row[$i++]);
            $this->con_address_country[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_alt_address_street[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_alt_address_city[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_alt_address_state[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_alt_address_postalcode[] = ($row[$i++]);
            $this->con_alt_address_country[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_assistant[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_assistant_phone[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_birthdate[] = ($row[$i++]);
            $this->con_description[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_shared[] = ($row[$i++]);
            $this->con_member[] = ($row[$i++]);
            $this->con_created[] = ($row[$i++]);
            $this->con_cuser[] = ($row[$i++]);
            $this->con_modified[] = ($row[$i++]);
            $this->con_muser[] = ($row[$i++]);
            $fn = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_formatted_name[] = ((preg_replace_callback('/[\s|,]/', function ($matches) { return ''; }, $fn)=='')?$ln:$fn);
            $this->con_org_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_mem_login[] = ($row[$i++]);
            $this->con_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_mem_email_work[] = ($row[$i++]);
            $this->con_mem1_login[] = ($row[$i++]);
            $this->con_mem1_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_mem1_email_work[] = ($row[$i++]);
        }
    }
    /**
     * results calendar events
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openCalendarEvents($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["calendar_events"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->cae_id = array();               // calendar event internal id
        $this->cae_target = array();           // target
        $this->cae_target_id = array();        // target id
        $this->cae_subject = array();          // calendar event subject
        $this->cae_description = array();      // calendar event description
        $this->cae_time_start = array();       // start timetamp of calendar event
        $this->cae_time_end = array();         // end timestamp of calendar event
        $this->cae_reminder_time1 = array();   // reminder 1
        $this->cae_reminder_time2 = array();   // reminder 2
        $this->cae_created = array();          // create timestamp
        $this->cae_cuser = array();            // create user id
        $this->cae_modified = array();         // last modify timestamp
        $this->cae_muser = array();            // last modify user id
        $this->cae_target_name = array();
        $this->cae_mem_email_work = array();   // create user work email
        $this->cae_user_timezone = array();
        $this->cae_user_language = array();

        while ($this->fetch()) {
            $i = 0;
            $this->cae_id[] = ($row[$i++]);
            $this->cae_target[] = ($row[$i++]);
            $this->cae_target_id[] = ($row[$i++]);
            $this->cae_subject[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->cae_description[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->cae_time_start[] = ($row[$i++]);
            $this->cae_time_end[] = ($row[$i++]);
            $this->cae_reminder_time1[] = ($row[$i++]);
            $this->cae_reminder_time2[] = ($row[$i++]);
            $this->cae_created[] = ($row[$i++]);
            $this->cae_cuser[] = ($row[$i++]);
            $this->cae_modified[] = ($row[$i++]);
            $this->cae_muser[] = ($row[$i++]);
            $this->cae_target_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->cae_mem_email_work[] = ($row[$i++]);
            $this->cae_user_language[] = ($row[$i++]);
        }
    }
    /**
     * results calendars
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openCalendars($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["calendars"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->cal_owner = array();
        $this->cal_target = array();
        $this->cal_target_id = array();
        $this->cal_target_name = array();

        while ($this->fetch()) {
            $i = 0;
            $this->cal_owner[] = ($row[$i++]);
            $this->cal_target[] = ($row[$i++]);
            $this->cal_target_id[] = ($row[$i++]);
            $this->cal_target_name[] = HtmlEntityDecodeNOD($row[$i++]);
        }
    }
    /**
     * results notes
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openNotes($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["notes"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->note_id = array();
        $this->note_project = array();
        $this->note_owner = array();
        $this->note_topic = array();
        $this->note_subject = array();
        $this->note_description = array();
        $this->note_date = array();
        $this->note_published = array();
        $this->note_mem_id = array();
        $this->note_mem_login = array();
        $this->note_mem_name = array();
        $this->note_mem_email_work = array();
        $this->note_mem_extension_picture = array();
        $this->note_mem_gender = array();
        $this->note_tea_published = array();

        while ($this->fetch()) {
            $i = 0;
            $this->note_id[] = ($row[$i++]);
            $this->note_project[] = ($row[$i++]);
            $this->note_owner[] = ($row[$i++]);
            $this->note_topic[] = ($row[$i++]);
            $this->note_subject[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->note_description[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->note_date[] = ($row[$i++]);
            $this->note_published[] = ($row[$i++]);
            $this->note_mem_id[] = ($row[$i++]);
            $this->note_mem_login[] = ($row[$i++]);
            $this->note_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->note_mem_email_work[] = ($row[$i++]);
            $this->note_mem_extension_picture[] = ($row[$i++]);
            $this->note_mem_gender[] = ($row[$i++]);
            $this->note_tea_published[] = ($row[$i++]);
        }
    }
    /**
     * results logs
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openLogs($querymore, $start = '', $rows = '')
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest['logs'];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->log_id = array();
        $this->log_login = array();
        $this->log_password = array();
        $this->log_ip = array();
        $this->log_session = array();
        $this->log_compt = array();
        $this->log_last_visite = array();
        $this->log_connected = array();
        $this->log_mem_organization = array();

        while ($this->fetch()) {
            $i = 0;
            $this->log_id[] = ($row[$i++]);
            $this->log_login[] = ($row[$i++]);
            $this->log_password[] = ($row[$i++]);
            $this->log_ip[] = ($row[$i++]);
            $this->log_session[] = ($row[$i++]);
            $this->log_compt[] = ($row[$i++]);
            $this->log_last_visite[] = ($row[$i++]);
            $this->log_connected[] = ($row[$i++]);
            $this->log_mem_organization[] = ($row[$i++]);
        }
    }
    /**
     * results notifications
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openNotifications($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["notifications"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->not_member = array();           // member id
        $this->not_notiid = array();           // notification id
        $this->not_block = array();            // block notification
        $this->not_block_string = array();
        $this->not_string_validto = array();
        $this->not_mem_login = array();        // member login id
        $this->not_mem_name = array();         // member name
        $this->not_mem_email_work = array();   // member work email
        $this->not_mem_organization = array(); // member organization id
        $this->not_mem_profil = array();       // member profile
        $this->not_mem_language = array();     // member language
        $this->not_loc_timezone = array();     // timezone of member location

        while ($this->fetch()) {
            $i = 0;
            $this->not_member[] = ($row[$i++]);
            $this->not_notiid[] = ($row[$i++]);
            $this->not_block[] = ($row[$i++]);
            $this->not_block_string[] = ($row[$i++]);
            $this->not_string_validto[] = ($row[$i++]);
            $this->not_mem_login[] = ($row[$i++]);
            $this->not_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->not_mem_email_work[] = ($row[$i++]);
            $this->not_mem_organization[] = ($row[$i++]);
            $this->not_mem_profil[] = ($row[$i++]);
            $this->not_mem_language[] = ($row[$i++]);
            $this->not_loc_timezone[] = ($row[$i++]);
        }
    }
    /**
     * results members
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openMembers($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["members"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->mem_id = array();
        $this->mem_organization = array();
        $this->mem_department = array();
        $this->mem_login = array();
        $this->mem_password = array();
        $this->mem_name = array();
        $this->mem_title = array();
        $this->mem_email_work = array();
        $this->mem_email_home = array();
        $this->mem_phone_work = array();
        $this->mem_phone_home = array();
        $this->mem_mobile = array();
        $this->mem_fax = array();
        $this->mem_comments = array();
        $this->mem_profil = array();
        $this->mem_language = array();
        $this->mem_logout_time = array();
        $this->mem_start_page = array();
        $this->mem_location = array();
        $this->mem_timezone = array();
        $this->mem_date_format = array();
        $this->mem_time_format = array();
        $this->mem_manager = array();
        $this->mem_deputy = array();
        $this->mem_theme = array();
        $this->mem_palette = array();
        $this->mem_gender = array();
        $this->mem_extension_picture = array();
        $this->mem_active = array();
        $this->mem_workcalendar = array();
        $this->mem_enable_flextime = array();
        $this->mem_begin_flextime = array();
        $this->mem_initial_flexibalance = array();
        $this->mem_invalid_logon = array();
        $this->mem_export_format = array();
        $this->mem_ldap_cn = array();
        $this->mem_enable_timeclock = array();
        $this->mem_created = array();
        $this->mem_cuser = array();
        $this->mem_modified = array();
        $this->mem_muser = array();
        $this->mem_org_name = array();
        $this->mem_log_connected = array();
        $this->mem_mem2_id = array();
        $this->mem_mem2_login = array();
        $this->mem_mem2_name = array();
        $this->mem_mem2_email_work = array();
        $this->mem_mem2_deputy = array();
        $this->mem_mem3_login = array();
        $this->mem_mem3_name = array();
        $this->mem_mem3_email_work = array();
        $this->mem_dep_name = array();
        $this->mem_dep_name_print = array();
        $this->mem_loc_name = array();
        $this->mem_loc_name_print = array();
        $this->mem_loc_timezone = array();
        $this->mem_wca_name = array();
        $this->mem_upf_name_print = array();

        while ($this->fetch()) {
            $i = 0;
            $this->mem_id[] = ($row[$i++]);
            $this->mem_organization[] = ($row[$i++]);
            $this->mem_department[] = ($row[$i++]);
            $this->mem_login[] = ($row[$i++]);
            $this->mem_password[] = ($row[$i++]);
            $this->mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mem_title[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mem_email_work[] = ($row[$i++]);
            $this->mem_email_home[] = ($row[$i++]);
            $this->mem_phone_work[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mem_phone_home[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mem_mobile[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mem_fax[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mem_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mem_profil[] = ($row[$i++]);
            $this->mem_language[] = ($row[$i++]);
            $this->mem_logout_time[] = ($row[$i++]);
            $this->mem_start_page[] = ($row[$i++]);
            $this->mem_location[] = ($row[$i++]);
            $this->mem_timezone[] = ($row[$i++]);
            $this->mem_date_format[] = ($row[$i++]);
            $this->mem_time_format[] = ($row[$i++]);
            $this->mem_manager[] = ($row[$i++]);
            $this->mem_deputy[] = ($row[$i++]);
            $this->mem_theme[] = ($row[$i++]);
            $this->mem_palette[] = ($row[$i++]);
            $this->mem_gender[] = ($row[$i++]);
            $this->mem_extension_picture[] = ($row[$i++]);
            $this->mem_active[] = ($row[$i++]);
            $this->mem_workcalendar[] = ($row[$i++]);
            $this->mem_enable_flextime[] = ($row[$i++]);
            $this->mem_begin_flextime[] = ($row[$i++]);
            $this->mem_initial_flexibalance[] = ($row[$i++]);
            $this->mem_invalid_logon[] = ($row[$i++]);
            $this->mem_export_format[] = ($row[$i++]);
            $this->mem_ldap_cn[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mem_enable_timeclock[] = ($row[$i++]);
            $this->mem_created[] = ($row[$i++]);
            $this->mem_cuser[] = ($row[$i++]);
            $this->mem_modified[] = ($row[$i++]);
            $this->mem_muser[] = ($row[$i++]);
            $this->mem_org_name[] = ($row[$i++]);
            $this->mem_log_connected[] = ($row[$i++]);
            $this->mem_mem2_id[] = ($row[$i++]);
            $this->mem_mem2_login[] = ($row[$i++]);
            $this->mem_mem2_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mem_mem2_email_work[] = ($row[$i++]);
            $this->mem_mem2_deputy[] = ($row[$i++]);
            $this->mem_mem3_login[] = ($row[$i++]);
            $this->mem_mem3_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mem_mem3_email_work[] = ($row[$i++]);
            $dep_name = ($row[$i++]);
            $this->mem_dep_name[] = $dep_name;
            $this->mem_dep_name_print[] = ((isset($strings['DEP__' . $dep_name]))?$strings['DEP__' . $dep_name]:$dep_name);
            $loc_name = ($row[$i++]);
            $this->mem_loc_name[] = $loc_name;
            $this->mem_loc_name_print[] = ((isset($strings['LOC__' . $loc_name]))?$strings['LOC__' . $loc_name]:$loc_name);
            $this->mem_loc_timezone[] = ($row[$i++]);
            $this->mem_wca_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $upfnam = ($row[$i++]);
            $this->mem_upf_name_print[] = ((isset($strings['UPF__' . $upfnam]))?$strings['UPF__' . $upfnam]:$upfnam);
        }
    }
    /**
     * results messages
     *
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start
     * @param int $rows@global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openMessages($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["messages"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->mes_id = array();
        $this->mes_from_id = array();
        $this->mes_to_id = array();
        $this->mes_message_type = array();
        $this->mes_message = array();
        $this->mes_extension_picture = array();
        $this->mes_subject = array();
        $this->mes_seen = array();
        $this->mes_archived = array();
        $this->mes_created = array();
        $this->mes_mem_name = array();
        $this->mes_mem_extension_picture = array();
        $this->mes_log_connected = array();
        $this->mes_mem2_name = array();
        $this->mes_mem2_extension_picture = array();
        $this->mes_log2_connected = array();
        $this->mes_mee_name = array();
        $this->mes_mee_status = array();
        $this->mes_mee_agenda = array();

        while ($this->fetch()) {
            $i = 0;
            $this->mes_id[] = ($row[$i++]);
            $this->mes_from_id[] = ($row[$i++]);
            $this->mes_to_id[] = ($row[$i++]);
            $this->mes_message_type[] = ($row[$i++]);
            $this->mes_message[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mes_extension_picture[] = ($row[$i++]);
            $this->mes_subject[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mes_seen[] = ($row[$i++]);
            $this->mes_archived[] = ($row[$i++]);
            $this->mes_created[] = ($row[$i++]);
            $this->mes_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mes_mem_extension_picture[] = ($row[$i++]);
            $this->mes_log_connected[] = ($row[$i++]);
            $this->mes_mem2_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mes_mem2_extension_picture[] = ($row[$i++]);
            $this->mes_log2_connected[] = ($row[$i++]);
            $this->mes_mee_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mes_mee_status[] = ($row[$i++]);
            $this->mes_mee_agenda[] = HtmlEntityDecodeNOD($row[$i++]);
        }
    }
    /**
     * results departments
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openDepartments($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["departments"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->dep_id = array();               // department internal id
        $this->dep_organization = array();     // department organization id
        $this->dep_name = array();             // department name
        $this->dep_location = array();         // department default location id
        $this->dep_locked = array();           // department locked
        $this->dep_created = array();          // timestamp of department creation
        $this->dep_cuser = array();            // user internal id of department creation
        $this->dep_modified = array();         // timestamp of department last modification
        $this->dep_muser = array();            // user internal id of department last modification
        $this->dep_org_name = array();         // department organization name
        $this->dep_loc_name = array();         // department default location name
        $this->dep_name_print = array();       // department name print
        $this->dep_loc_name_print = array();   // department default location name print
        $this->dep_loc_timezone = array();     // default location timezone
        $this->dep_loc_language = array();     // default location language

        while ($this->fetch()) {
            $i = 0;
            $this->dep_id[] = ($row[$i++]);
            $this->dep_organization[] = ($row[$i++]);
            $nam = $row[$i++];
            $this->dep_name[] = $nam;
            $this->dep_location[] = ($row[$i++]);
            $this->dep_locked[] = ($row[$i++]);
            $this->dep_created[] = ($row[$i++]);
            $this->dep_cuser[] = ($row[$i++]);
            $this->dep_modified[] = ($row[$i++]);
            $this->dep_muser[] = ($row[$i++]);
            $this->dep_org_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $locnam = ($row[$i++]);
            $this->dep_loc_name[] = $locnam;
            $this->dep_name_print[] = ((isset($strings['DEP__' . $nam]))?$strings['DEP__' . $nam]:$nam);
            $this->dep_loc_name_print[] = ((isset($strings['LOC__' . $locnam]))?$strings['LOC__' . $locnam]:$locnam);
            $this->dep_loc_timezone[] = ($row[$i++]);
            $this->dep_loc_language[] = ($row[$i++]);
        }
    }
    /**
     * results projects
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openProjects($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["projects"];
        $sql .= " " . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->pro_id = array();
        $this->pro_organization = array();
        $this->pro_owner = array();
        $this->pro_priority = array();
        $this->pro_status = array();
        $this->pro_status_next = array();
        $this->pro_status_approval = array();
        $this->pro_open_date = array();
        $this->pro_complete_date = array();
        $this->pro_name = array();
        $this->pro_description = array();
        $this->pro_published = array();
        $this->pro_phase_set = array();
        $this->pro_type = array();
        $this->pro_upload_dir = array();
        $this->pro_currency = array();
        $this->pro_permission_set = array();
        $this->pro_cost_method = array();
        $this->pro_workcalendar = array();
        $this->pro_created = array();
        $this->pro_cuser = array();
        $this->pro_modified = array();
        $this->pro_muser = array();
        $this->pro_org_id = array();
        $this->pro_org_name = array();
        $this->pro_mem_id = array();
        $this->pro_mem_login = array();
        $this->pro_mem_name = array();
        $this->pro_mem_email_work = array();
        $this->pro_loc_timezone = array();
        $this->phs_name = array();
        $this->phs_description = array();
        $this->pro_wca_name = array();

        while ($this->fetch()) {
            $i = 0;
            $this->pro_id[] = ($row[$i++]);
            $this->pro_organization[] = ($row[$i++]);
            $this->pro_owner[] = ($row[$i++]);
            $this->pro_priority[] = ($row[$i++]);
            $this->pro_status[] = ($row[$i++]);
            $this->pro_status_next[] = ($row[$i++]);
            $this->pro_status_approval[] = ($row[$i++]);
            $this->pro_open_date[] = ($row[$i++]);
            $this->pro_complete_date[] = ($row[$i++]);
            $this->pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->pro_description[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->pro_published[] = ($row[$i++]);
            $this->pro_phase_set[] = ($row[$i++]);
            $this->pro_type[] = ($row[$i++]);
            $this->pro_upload_dir[] = ($row[$i++]);
            $this->pro_currency[] = trim($row[$i++]);
            $this->pro_permission_set[] = ($row[$i++]);
            $this->pro_cost_method[] = ($row[$i++]);
            $this->pro_workcalendar[] = ($row[$i++]);
            $this->pro_created[] = ($row[$i++]);
            $this->pro_cuser[] = ($row[$i++]);
            $this->pro_modified[] = ($row[$i++]);
            $this->pro_muser[] = ($row[$i++]);
            $this->pro_org_id[] = ($row[$i++]);
            $this->pro_org_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->pro_mem_id[] = ($row[$i++]);
            $this->pro_mem_login[] = ($row[$i++]);
            $this->pro_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->pro_mem_email_work[] = ($row[$i++]);
            $this->pro_loc_timezone[] = ($row[$i++]);
            $phsnam = ($row[$i++]);
            $this->phs_name[] = $phsnam;
            $this->phs_description[] = ((isset($strings['PHS__' . $phsnam]))?$strings['PHS__' . $phsnam]:'');
            $this->pro_wca_name[] = ($row[$i++]);
        }
    }
    /**
     * results projects budget
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openProjectsBudget($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["projects_budget"];
        $sql .= " " . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->pjb_id = array();
        $this->pjb_project = array();
        $this->pjb_costtype = array();
        $this->pjb_currency = array();
        $this->pjb_amount = array();
        $this->pjb_created = array();
        $this->pjb_cuser = array();
        $this->pjb_modified = array();
        $this->pjb_muser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->pjb_id[] = ($row[$i++]);
            $this->pjb_project[] = ($row[$i++]);
            $this->pjb_costtype[] = ($row[$i++]);
            $this->pjb_currency[] = trim($row[$i++]);
            $this->pjb_amount[] = ($row[$i++]);
            $this->pjb_created[] = ($row[$i++]);
            $this->pjb_cuser[] = ($row[$i++]);
            $this->pjb_modified[] = ($row[$i++]);
            $this->pjb_cuser[] = ($row[$i++]);
        }
    }
    /**
     * results projects form
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openProjectsForm($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["projects_form"];
        $sql .= " " . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->pfm_project = array();
        $this->pfm_tablename = array();
        $this->pfm_publishenabled = array();
        $this->pfm_created = array();
        $this->pfm_cuser = array();
        $this->pfm_modified = array();
        $this->pfm_muser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->pfm_project[] = ($row[$i++]);
            $this->pfm_tablename[] = ($row[$i++]);
            $this->pfm_publishenabled[] = ($row[$i++]);
            $this->pfm_created[] = ($row[$i++]);
            $this->pfm_cuser[] = ($row[$i++]);
            $this->pfm_modified[] = ($row[$i++]);
            $this->pfm_cuser[] = ($row[$i++]);
        }
    }
    /**
     * results files
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openFiles($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["files"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->fil_id = array();
        $this->fil_owner = array();
        $this->fil_doc_type = array();
        $this->fil_doc_type_ex = array();
        $this->fil_doc_id = array();
        $this->fil_name = array();
        $this->fil_size = array();
        $this->fil_extension = array();
        $this->fil_comments = array();
        $this->fil_published = array();
        $this->fil_status = array();
        $this->fil_vc_status = array();
        $this->fil_vc_version = array();
        $this->fil_vc_parent = array();
        $this->fil_dir = array();
        $this->fil_parent = array();
        $this->fil_fullname = array();
        $this->fil_project = array();
        $this->fil_created = array();
        $this->fil_cuser = array();
        $this->fil_modified = array();
        $this->fil_muser = array();
        $this->fil_mem_login = array();
        $this->fil_mem_name = array();
        $this->fil_mem_email_work = array();
        $this->fil_mem_extension_picture = array();
        $this->fil_mem_gender = array();

        while ($this->fetch()) {
            $i = 0;
            $this->fil_id[] = ($row[$i++]);
            $this->fil_owner[] = ($row[$i++]);
            $this->fil_doc_type[] = ($row[$i++]);
            $this->fil_doc_type_ex[] = ($row[$i++]);
            $this->fil_doc_id[] = ($row[$i++]);
            $this->fil_name[] = ($row[$i++]);
            $this->fil_size[] = ($row[$i++]);
            $this->fil_extension[] = ($row[$i++]);
            $this->fil_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_published[] = ($row[$i++]);
            $this->fil_status[] = ($row[$i++]);
            $this->fil_vc_status[] = ($row[$i++]);
            $this->fil_vc_version[] = ($row[$i++]);
            $this->fil_vc_parent[] = ($row[$i++]);
            $this->fil_dir[] = ($row[$i++]);
            $this->fil_parent[] = ($row[$i++]);
            $this->fil_fullname[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_project[] = ($row[$i++]);
            $this->fil_created[] = ($row[$i++]);
            $this->fil_cuser[] = ($row[$i++]);
            $this->fil_modified[] = ($row[$i++]);
            $this->fil_muser[] = ($row[$i++]);
            $this->fil_mem_login[] = ($row[$i++]);
            $this->fil_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_mem_email_work[] = ($row[$i++]);
            $this->fil_mem_extension_picture[] = ($row[$i++]);
            $this->fil_mem_gender[] = ($row[$i++]);
        }
    }
    /**
     * results files view
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openFilesView($member, $querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql0 = $initrequest["files_view"];
        $sql = str_replace('%member%', $member, $sql0);
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->fil_id = array();
        $this->fil_owner = array();
        $this->fil_doc_type = array();
        $this->fil_doc_type_ex = array();
        $this->fil_doc_id = array();
        $this->fil_name = array();
        $this->fil_size = array();
        $this->fil_extension = array();
        $this->fil_comments = array();
        $this->fil_published = array();
        $this->fil_status = array();
        $this->fil_vc_status = array();
        $this->fil_vc_version = array();
        $this->fil_vc_parent = array();
        $this->fil_dir = array();
        $this->fil_parent = array();
        $this->fil_fullname = array();
        $this->fil_created = array();
        $this->fil_cuser = array();
        $this->fil_modified = array();
        $this->fil_muser = array();
        $this->fil_mem_login = array();
        $this->fil_mem_name = array();
        $this->fil_mem_email_work = array();

        while ($this->fetch()) {
            $i = 0;
            $this->fil_id[] = ($row[$i++]);
            $this->fil_owner[] = ($row[$i++]);
            $this->fil_doc_type[] = ($row[$i++]);
            $this->fil_doc_type_ex[] = ($row[$i++]);
            $this->fil_doc_id[] = ($row[$i++]);
            $this->fil_name[] = ($row[$i++]);
            $this->fil_size[] = ($row[$i++]);
            $this->fil_extension[] = ($row[$i++]);
            $this->fil_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_published[] = ($row[$i++]);
            $this->fil_status[] = ($row[$i++]);
            $this->fil_vc_status[] = ($row[$i++]);
            $this->fil_vc_version[] = ($row[$i++]);
            $this->fil_vc_parent[] = ($row[$i++]);
            $this->fil_dir[] = ($row[$i++]);
            $this->fil_parent[] = ($row[$i++]);
            $this->fil_fullname[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_created[] = ($row[$i++]);
            $this->fil_cuser[] = ($row[$i++]);
            $this->fil_modified[] = ($row[$i++]);
            $this->fil_muser[] = ($row[$i++]);
            $this->fil_mem_login[] = ($row[$i++]);
            $this->fil_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_mem_email_work[] = ($row[$i++]);
        }
    }
    /**
     * results files view without vc detail
     * @global array $row
     * @global array $initrequest
     * @param int $member
     * @param string $querymore
     * @param string $ordermore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openFilesViewNoVC($member, $querymore, $ordermore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql0 = $initrequest["files_view_novc"];
        $sql1 = str_replace('%member%', $member, $sql0);
        $sql2 = str_replace('%querymore%', $querymore, $sql1);
        $sql = str_replace('%ordermore%', $ordermore, $sql2);
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->fil_id = array();
        $this->fil_owner = array();
        $this->fil_doc_type = array();
        $this->fil_doc_type_ex = array();
        $this->fil_doc_id = array();
        $this->fil_name = array();
        $this->fil_size = array();
        $this->fil_extension = array();
        $this->fil_comments = array();
        $this->fil_published = array();
        $this->fil_status = array();
        $this->fil_vc_status = array();
        $this->fil_vc_version = array();
        $this->fil_vc_parent = array();
        $this->fil_dir = array();
        $this->fil_parent = array();
        $this->fil_fullname = array();
        $this->fil_created = array();
        $this->fil_cuser = array();
        $this->fil_modified = array();
        $this->fil_muser = array();
        $this->fil_mem_login = array();
        $this->fil_mem_name = array();
        $this->fil_mem_email_work = array();

        while ($this->fetch()) {
            $i = 0;
            $this->fil_id[] = ($row[$i++]);
            $this->fil_owner[] = ($row[$i++]);
            $this->fil_doc_type[] = ($row[$i++]);
            $this->fil_doc_type_ex[] = ($row[$i++]);
            $this->fil_doc_id[] = ($row[$i++]);
            $this->fil_name[] = ($row[$i++]);
            $this->fil_size[] = ($row[$i++]);
            $this->fil_extension[] = ($row[$i++]);
            $this->fil_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_published[] = ($row[$i++]);
            $this->fil_status[] = ($row[$i++]);
            $this->fil_vc_status[] = ($row[$i++]);
            $this->fil_vc_version[] = ($row[$i++]);
            $this->fil_vc_parent[] = ($row[$i++]);
            $this->fil_dir[] = ($row[$i++]);
            $this->fil_parent[] = ($row[$i++]);
            $this->fil_fullname[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_created[] = ($row[$i++]);
            $this->fil_cuser[] = ($row[$i++]);
            $this->fil_modified[] = ($row[$i++]);
            $this->fil_muser[] = ($row[$i++]);
            $this->fil_mem_login[] = ($row[$i++]);
            $this->fil_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_mem_email_work[] = ($row[$i++]);
        }
    }
    /**
     * results project files
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openProjectFiles($project, $querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql0 = $initrequest["project_files"];
        $sql = str_replace('%project%', $project, $sql0);
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->fil_id = array();
        $this->fil_owner = array();
        $this->fil_doc_type = array();
        $this->fil_doc_id = array();
        $this->fil_name = array();
        $this->fil_size = array();
        $this->fil_extension = array();
        $this->fil_comments = array();
        $this->fil_published = array();
        $this->fil_status = array();
        $this->fil_vc_status = array();
        $this->fil_vc_version = array();
        $this->fil_vc_parent = array();
        $this->fil_dir = array();
        $this->fil_parent = array();
        $this->fil_fullname = array();
        $this->fil_created = array();
        $this->fil_cuser = array();
        $this->fil_modified = array();
        $this->fil_muser = array();
        $this->fil_mem_login = array();
        $this->fil_mem_name = array();
        $this->fil_mem_email_work = array();
        $this->fil_mem_extension_picture = array();
        $this->fil_mem_gender = array();

        while ($this->fetch()) {
            $i = 0;
            $this->fil_id[] = ($row[$i++]);
            $this->fil_owner[] = ($row[$i++]);
            $this->fil_doc_type[] = ($row[$i++]);
            $this->fil_doc_id[] = ($row[$i++]);
            $this->fil_name[] = ($row[$i++]);
            $this->fil_size[] = ($row[$i++]);
            $this->fil_extension[] = ($row[$i++]);
            $this->fil_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_published[] = ($row[$i++]);
            $this->fil_status[] = ($row[$i++]);
            $this->fil_vc_status[] = ($row[$i++]);
            $this->fil_vc_version[] = ($row[$i++]);
            $this->fil_vc_parent[] = ($row[$i++]);
            $this->fil_dir[] = ($row[$i++]);
            $this->fil_parent[] = ($row[$i++]);
            $this->fil_fullname[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_created[] = ($row[$i++]);
            $this->fil_cuser[] = ($row[$i++]);
            $this->fil_modified[] = ($row[$i++]);
            $this->fil_muser[] = ($row[$i++]);
            $this->fil_mem_login[] = ($row[$i++]);
            $this->fil_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_mem_email_work[] = ($row[$i++]);
            $this->fil_mem_extension_picture[] = ($row[$i++]);
            $this->fil_mem_gender[] = ($row[$i++]);
        }
    }
    /**
     * results phase files
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openPhaseFiles($phase, $querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql0 = $initrequest["phase_files"];
        $sql = str_replace('%phase%', $phase, $sql0);
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->fil_id = array();
        $this->fil_owner = array();
        $this->fil_doc_type = array();
        $this->fil_doc_id = array();
        $this->fil_name = array();
        $this->fil_size = array();
        $this->fil_extension = array();
        $this->fil_comments = array();
        $this->fil_published = array();
        $this->fil_status = array();
        $this->fil_vc_status = array();
        $this->fil_vc_version = array();
        $this->fil_vc_parent = array();
        $this->fil_dir = array();
        $this->fil_parent = array();
        $this->fil_fullname = array();
        $this->fil_created = array();
        $this->fil_cuser = array();
        $this->fil_modified = array();
        $this->fil_muser = array();
        $this->fil_mem_login = array();
        $this->fil_mem_name = array();
        $this->fil_mem_email_work = array();

        while ($this->fetch()) {
            $i = 0;
            $this->fil_id[] = ($row[$i++]);
            $this->fil_owner[] = ($row[$i++]);
            $this->fil_doc_type[] = ($row[$i++]);
            $this->fil_doc_id[] = ($row[$i++]);
            $this->fil_name[] = ($row[$i++]);
            $this->fil_size[] = ($row[$i++]);
            $this->fil_extension[] = ($row[$i++]);
            $this->fil_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_published[] = ($row[$i++]);
            $this->fil_status[] = ($row[$i++]);
            $this->fil_vc_status[] = ($row[$i++]);
            $this->fil_vc_version[] = ($row[$i++]);
            $this->fil_vc_parent[] = ($row[$i++]);
            $this->fil_dir[] = ($row[$i++]);
            $this->fil_parent[] = ($row[$i++]);
            $this->fil_fullname[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_created[] = ($row[$i++]);
            $this->fil_cuser[] = ($row[$i++]);
            $this->fil_modified[] = ($row[$i++]);
            $this->fil_muser[] = ($row[$i++]);
            $this->fil_mem_login[] = ($row[$i++]);
            $this->fil_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fil_mem_email_work[] = ($row[$i++]);
        }
    }
    /**
     * results organizations
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openOrganizations($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["organizations"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->org_id = array();
        $this->org_name = array();
        $this->org_address = array();
        $this->org_zip_code = array();
        $this->org_city = array();
        $this->org_country = array();
        $this->org_phone = array();
        $this->org_fax = array();
        $this->org_url = array();
        $this->org_email = array();
        $this->org_comments = array();
        $this->org_sscomments = array();
        $this->org_extension_logo = array();
        $this->org_owner = array();
        $this->org_currency = array();
        $this->org_workcalendar = array();
        $this->org_payment_method = array();
        $this->org_payment_terms = array();
        $this->org_locked = array();
        $this->org_created = array();
        $this->org_cuser = array();
        $this->org_modified = array();
        $this->org_muser = array();
        $this->org_mem_id = array();
        $this->org_mem_login = array();
        $this->org_mem_name = array();
        $this->org_mem_email_work = array();
        $this->org_wca_name = array();
        $this->org_pym_name_print = array();
        $this->org_pyt_name_print = array();

        while ($this->fetch()) {
            $i = 0;
            $this->org_id[] = ($row[$i++]);
            $this->org_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_address[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_zip_code[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_city[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_country[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_phone[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_fax[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_url[] = ($row[$i++]);
            $this->org_email[] = ($row[$i++]);
            $this->org_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_sscomments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_extension_logo[] = ($row[$i++]);
            $this->org_owner[] = ($row[$i++]);
            $this->org_currency[] = trim($row[$i++]);
            $this->org_workcalendar[] = ($row[$i++]);
            $this->org_payment_method[] = ($row[$i++]);
            $this->org_payment_terms[] = ($row[$i++]);
            $this->org_locked[] = ($row[$i++]);
            $this->org_created[] = ($row[$i++]);
            $this->org_cuser[] = ($row[$i++]);
            $this->org_modified[] = ($row[$i++]);
            $this->org_muser[] = ($row[$i++]);
            $this->org_mem_id[] = ($row[$i++]);
            $this->org_mem_login[] = ($row[$i++]);
            $this->org_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_mem_email_work[] = ($row[$i++]);
            $this->org_wca_name[] = ($row[$i++]);
            $pym_name = ($row[$i++]);
            $this->org_pym_name_print[] = (isset($strings['PYM__' . $pym_name])?$strings['PYM__' . $pym_name]:$pym_name);
            $pyt_name = ($row[$i++]);
            $this->org_pyt_name_print[] = (isset($strings['PYT__' . $pyt_name])?$strings['PYT__' . $pyt_name]:$pyt_name);
        }
    }
    /**
     * results organizations 2
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $datefrom
     * @param int $dateto
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openOrganizations2($querymore, $datefrom, $dateto, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql0 = $initrequest["organizations2"];
        $sql1 = str_replace('%DATEFROM%', $datefrom, $sql0);
        $sql = str_replace('%DATETO%', $dateto, $sql1);
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->org_id = array();
        $this->org_name = array();
        $this->org_address = array();
        $this->org_zip_code = array();
        $this->org_city = array();
        $this->org_country = array();
        $this->org_phone = array();
        $this->org_fax = array();
        $this->org_url = array();
        $this->org_email = array();
        $this->org_comments = array();
        $this->org_sscomments = array();
        $this->org_extension_logo = array();
        $this->org_owner = array();
        $this->org_currency = array();
        $this->org_workcalendar = array();
        $this->org_payment_terms = array();
        $this->org_created = array();
        $this->org_cuser = array();
        $this->org_modified = array();
        $this->org_muser = array();
        $this->org_mem_id = array();
        $this->org_mem_login = array();
        $this->org_mem_name = array();
        $this->org_mem_email_work = array();
        $this->org_wca_name = array();
        $this->org_num_open = array();
        $this->org_num_complete = array();

        while ($this->fetch()) {
            $i = 0;
            $this->org_id[] = ($row[$i++]);
            $this->org_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_address[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_zip_code[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_city[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_country[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_phone[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_fax[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_url[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_email[] = ($row[$i++]);
            $this->org_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_sscomments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_extension_logo[] = ($row[$i++]);
            $this->org_owner[] = ($row[$i++]);
            $this->org_currency[] = trim($row[$i++]);
            $this->org_workcalendar[] = ($row[$i++]);
            $this->org_payment_terms[] = ($row[$i++]);
            $this->org_created[] = ($row[$i++]);
            $this->org_cuser[] = ($row[$i++]);
            $this->org_modified[] = ($row[$i++]);
            $this->org_muser[] = ($row[$i++]);
            $this->org_mem_id[] = ($row[$i++]);
            $this->org_mem_login[] = ($row[$i++]);
            $this->org_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->org_mem_email_work[] = ($row[$i++]);
            $this->org_wca_name[] = ($row[$i++]);
            $this->org_num_open[] = ($row[$i++]);
            $this->org_num_complete[] = ($row[$i++]);
        }
    }
    /**
     * results organization extensions
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openOrganizationExtensions($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["organizations_extension"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->oge_organization = array();
        $this->oge_extension = array();
        $this->oge_perm_read = array();
        $this->oge_perm_write = array();
        $this->oge_perm_edit = array();
        $this->oge_perm_admin = array();
        $this->oge_created = array();
        $this->oge_cuser = array();
        $this->oge_ext_name = array();
        $this->oge_ext_title = array();

        while ($this->fetch()) {
            $i = 0;
            $this->oge_organization[] = ($row[$i++]);
            $this->oge_extension[] = ($row[$i++]);
            $this->oge_perm_read[] = ($row[$i++]);
            $this->oge_perm_write[] = ($row[$i++]);
            $this->oge_perm_edit[] = ($row[$i++]);
            $this->oge_perm_admin[] = ($row[$i++]);
            $this->oge_created[] = ($row[$i++]);
            $this->oge_cuser[] = ($row[$i++]);
            $n = ($row[$i++]);
            $this->oge_ext_name[] = $n;
            $this->oge_ext_title[] = ((isset($strings['EXT__' . $n]))?$strings['EXT__' . $n]:$n);
        }
    }
    /**
     * results organization form templates
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openOrganizationForms($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["organizations_form"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->ogf_id = array();
        $this->ogf_organization = array();
        $this->ogf_tablename = array();
        $this->ogf_addenabled = array();
        $this->ogf_modenabled = array();
        $this->ogf_created = array();
        $this->ogf_cuser = array();
        $this->ogf_modified = array();
        $this->ogf_muser = array();
        $this->ogf_dbtablename = array();

        while ($this->fetch()) {
            $i = 0;
            $this->ogf_id[] = ($row[$i++]);
            $this->ogf_organization[] = ($row[$i++]);
            $tblnam = ($row[$i++]);
            $this->ogf_tablename[] = $tblnam;
            $this->ogf_addenabled[] = ($row[$i++]);
            $this->ogf_modenabled[] = ($row[$i++]);
            $this->ogf_created[] = ($row[$i++]);
            $this->ogf_cuser[] = ($row[$i++]);
            $this->ogf_modified[] = ($row[$i++]);
            $this->ogf_muser[] = ($row[$i++]);
            $this->ogf_dbtablename[] = preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam);
        }
    }
    /**
     * results topics
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTopics($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["topics"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->top_id = array();
        $this->top_project = array();
        $this->top_owner = array();
        $this->top_subject = array();
        $this->top_status = array();
        $this->top_last_post = array();
        $this->top_posts = array();
        $this->top_published = array();
        $this->top_mem_id = array();
        $this->top_mem_login = array();
        $this->top_mem_name = array();
        $this->top_mem_email_work = array();
        $this->top_mem_extension_picture = array();
        $this->top_mem_gender = array();
        $this->top_pro_id = array();
        $this->top_pro_name = array();
        $this->top_last_login = array();
        $this->top_last_email_work = array();
        $this->top_last_name = array();

        while ($this->fetch()) {
            $i = 0;
            $this->top_id[] = ($row[$i++]);
            $this->top_project[] = ($row[$i++]);
            $this->top_owner[] = ($row[$i++]);
            $this->top_subject[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->top_status[] = ($row[$i++]);
            $this->top_last_post[] = ($row[$i++]);
            $this->top_posts[] = ($row[$i++]);
            $this->top_published[] = ($row[$i++]);
            $this->top_mem_id[] = ($row[$i++]);
            $this->top_mem_login[] = ($row[$i++]);
            $this->top_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->top_mem_email_work[] = ($row[$i++]);
            $this->top_mem_extension_picture[] = ($row[$i++]);
            $this->top_mem_gender[] = ($row[$i++]);
            $this->top_pro_id[] = ($row[$i++]);
            $this->top_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->top_last_login[] = ($row[$i++]);
            $this->top_last_email_work[] = ($row[$i++]);
            $this->top_last_name[] = HtmlEntityDecodeNOD($row[$i++]);
        }
    }
    /**
     * results posts
     *
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start
     * @param int $rows@global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openPosts($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["posts"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->pos_id = array();
        $this->pos_topic = array();
        $this->pos_member = array();
        $this->pos_created = array();
        $this->pos_message = array();
        $this->pos_mem_id = array();
        $this->pos_mem_login = array();
        $this->pos_mem_name = array();
        $this->pos_mem_email_work = array();
        $this->pos_topic_subject = array();

        while ($this->fetch()) {
            $i = 0;
            $this->pos_id[] = ($row[$i++]);
            $this->pos_topic[] = ($row[$i++]);
            $this->pos_member[] = ($row[$i++]);
            $this->pos_created[] = ($row[$i++]);
            $this->pos_message[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->pos_mem_id[] = ($row[$i++]);
            $this->pos_mem_login[] = ($row[$i++]);
            $this->pos_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->pos_mem_email_work[] = ($row[$i++]);
            $this->pos_topic_subject[] = HtmlEntityDecodeNOD($row[$i++]);
        }
    }
    /**
     * results assignments
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openAssignments($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["assignments"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->ass_id = array();
        $this->ass_task = array();
        $this->ass_owner = array();
        $this->ass_assigned_to = array();
        $this->ass_comments = array();
        $this->ass_assigned = array();
        $this->ass_mem1_id = array();
        $this->ass_mem1_login = array();
        $this->ass_mem1_name = array();
        $this->ass_mem1_email_work = array();
        $this->ass_mem2_id = array();
        $this->ass_mem2_login = array();
        $this->ass_mem2_name = array();
        $this->ass_mem2_email_work = array();

        while ($this->fetch()) {
            $i = 0;
            $this->ass_id[] = ($row[$i++]);
            $this->ass_task[] = ($row[$i++]);
            $this->ass_owner[] = ($row[$i++]);
            $this->ass_assigned_to[] = ($row[$i++]);
            $this->ass_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->ass_assigned[] = ($row[$i++]);
            $this->ass_mem1_id[] = ($row[$i++]);
            $this->ass_mem1_login[] = ($row[$i++]);
            $this->ass_mem1_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->ass_mem1_email_work[] = ($row[$i++]);
            $this->ass_mem2_id[] = ($row[$i++]);
            $this->ass_mem2_login[] = ($row[$i++]);
            $this->ass_mem2_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->ass_mem2_email_work[] = ($row[$i++]);
        }
    }
    /**
     * results report category
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openReportCategory($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["report_category"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->repc_id = array();          // report category id
        $this->repc_name = array();        // report category name
        $this->repc_name_print = array();  // report category name print
        $this->repc_created = array();     // timestamp of report category creation
        $this->repc_cuser = array();       // user internal id of report category creation
        $this->repc_modified = array();    // timestamp of report category last modification
        $this->repc_muser = array();       // user internal id of report category last modification

        while ($this->fetch()) {
            $i = 0;
            $repcid = ($row[$i++]);
            $this->repc_id[] = $repcid;                 // report category id
            $nam = ($row[$i++]);                        // report category name
            $this->repc_name[] = $nam;
            $namp = (($repcid=='1')?$strings[$nam]:(isset($strings['REPC__' . $nam])?$strings['REPC__' . $nam]:$nam));
            $this->repc_name_print[] = $namp;           // report category name print
            $this->repc_created[] = ($row[$i++]);       // timestamp of report category creation
            $this->repc_cuser[] = ($row[$i++]);         // user internal id of report category creation
            $this->repc_modified[] = ($row[$i++]);      // timestamp of report category last modification
            $this->repc_muser[] = ($row[$i++]);         // user internal id of report category last modification
        }
    }
    /**
     * results reports
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openReports($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["reports"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->rep_id = array();               // report id
        $this->rep_category = array();         // report category id
        $this->rep_name = array();             // report name
        $this->rep_url = array();              // report url
        $this->rep_tablename = array();        // report table name
        $this->rep_sysdef = array();           // system defined report
        $this->rep_userquery = array();
        $this->rep_locked = array();           // report locked
        $this->rep_created = array();          // timestamp of report creation
        $this->rep_cuser = array();            // user internal id of report creation
        $this->rep_modified = array();         // timestamp of report last modification
        $this->rep_muser = array();            // user internal id of report last modification
        $this->rep_repc_name = array();        // report category name
        $this->rep_repc_name_print = array();  // report category name print
        $this->rep_name_print = array();       // report name print
        $this->rep_description = array();      // report description
        $this->rep_tdf_sysdef = array();       // system defined table
        $this->rep_tdf_dbtablename = array();  // database table name

        while ($this->fetch()) {
            $i = 0;
            $this->rep_id[] = ($row[$i++]);                 // report id
            $repcid = ($row[$i++]);
            $this->rep_category[] = $repcid;                // report category id
            $nam = ($row[$i++]);
            $this->rep_name[] = $nam;                       // report name
            $this->rep_url[] = ($row[$i++]);                // report url
            $tblnam = ($row[$i++]);
            $this->rep_tablename[] = $tblnam;               // report table name
            $sysdef = ($row[$i++]);
            $this->rep_sysdef[] = $sysdef;                  // system defined report
            $this->rep_userquery[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->rep_locked[] = ($row[$i++]);             // report locked
            $this->rep_created[] = ($row[$i++]);            // timestamp of report creation
            $this->rep_cuser[] = ($row[$i++]);              // user internal id of report creation
            $this->rep_modified[] = ($row[$i++]);           // timestamp of report last modification
            $this->rep_muser[] = ($row[$i++]);              // user internal id of report last modification
            $repcnam = ($row[$i++]);
            $tdf_sysdef = ($row[$i++]);
            $this->rep_tdf_sysdef[] = $tdf_sysdef;          // system defined table
            $this->rep_repc_name[] = $repcnam;              // report category name
            $this->rep_repc_name_print[] = (($repcid=='1')?$strings[$repcnam]:(isset($strings['REPC__' . $repcnam])?$strings['REPC__' . $repcnam]:''));   // report category name print

            if ($sysdef == 'Y') {
                $this->rep_name_print[] = $strings[$nam];   // report name print
                $this->rep_description[] = $strings[$nam . '_desc'];    // report description
            } else {
                $this->rep_name_print[] = isset($strings['REP__' . $nam])?$strings['REP__' . $nam]:$nam; // report name print
                $this->rep_description[] = $strings['REPDESC__' . $nam];    // report description
            }

            if ($tdf_sysdef == 'Y') {
                $this->rep_tdf_dbtablename[] = $tblnam;
            } else {
                $this->rep_tdf_dbtablename[] = preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam);
            }
        }
    }
    /**
     * results reports related tables
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openReportsRelatedTables($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["reports_rel_tables"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->repl_id = array();          // report related table id
        $this->repl_report = array();      // report id
        $this->repl_tablename = array();   // table name
        $this->repl_table_left = array();  // left table id
        $this->repl_tdf_sysdef = array();          // system defined table
        $this->repl_tdf_dbtablename = array();     // database table name
        $this->repl_tdfl_dbtablename = array();    // left database table name

        while ($this->fetch()) {
            $i = 0;
            $this->repl_id[] = ($row[$i++]);            // report related table id
            $this->repl_report[] = ($row[$i++]);        // report id
            $tblnam = ($row[$i++]);
            $this->repl_tablename[] = $tblnam;          // table name
            $this->repl_table_left[] = ($row[$i++]);    // left table id
            $tdf_sysdef = ($row[$i++]);
            $this->repl_tdf_sysdef[] = $tdf_sysdef;     // system defined table

            if ($tdf_sysdef == 'Y') {
                $this->repl_tdf_dbtablename[] = $tblnam;
            } else {
                $this->repl_tdf_dbtablename[] = preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam);
            }

            $tablename_left = ($row[$i++]);             // left table name
            $sysdef_left = ($row[$i++]);                // left table is a system defined table
            // left database table name
            if ($sysdef_left == 'Y') {
                $this->repl_tdfl_dbtablename[] = $tablename_left;
            } else {
                $this->repl_tdfl_dbtablename[] = preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tablename_left);
            }
        }
    }
    /**
     * results reports related fields
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openReportsRelatedFields($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["reports_rel_fields"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->repl_id = array();          // report related field id
        $this->repl_rel_table = array();   // related table id
        $this->repl_report = array();      // report id
        $this->repl_tablename = array();   // table name
        $this->repl_table_left = array();  // left table id
        $this->repl_field_left = array();  // left field name
        $this->repl_field_right = array(); // right field name
        $this->repl_tdf_sysdef = array();          // system defined table
        $this->repl_tdf_dbtablename = array();     // database table name
        $this->repl_tdfl_dbtablename = array();    // left database table name
        $this->repl_fdfl_dbfieldname = array();    // left database field name
        $this->repl_fdfr_dbfieldname = array();    // right database field name
        $this->repl_fdfl_fieldtype = array();      // left field type
        $this->repl_fdfl_length = array();         // left field length
        $this->repl_fdfr_fieldtype = array();      // right field type
        $this->repl_fdfr_length = array();         // right field length

        while ($this->fetch()) {
            $i = 0;
            $this->repl_id[] = ($row[$i++]);            // report realted field id
            $this->repl_rel_table[] = ($row[$i++]);     // related table id
            $this->repl_report[] = ($row[$i++]);        // report id
            $tblnam = ($row[$i++]);
            $this->repl_tablename[] = $tblnam;          // table name
            $this->repl_table_left[] = ($row[$i++]);    // left table id
            $fldnam_left = ($row[$i++]);
            $this->repl_field_left[] = $fldnam_left;    // left field name
            $fldnam_right = ($row[$i++]);
            $this->repl_field_right[] = $fldnam_right;  // right field name
            $tdf_sysdef = ($row[$i++]);
            $this->repl_tdf_sysdef[] = $tdf_sysdef;     // system defined table

            if ($tdf_sysdef == 'Y') {
                $this->repl_tdf_dbtablename[] = $tblnam;
            } else {
                $this->repl_tdf_dbtablename[] = preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam);
            }

            $tablename_left = ($row[$i++]);             // left table name
            $sysdef_left = ($row[$i++]);                // left table is a system defined table
            // left database table name
            if ($sysdef_left == 'Y') {
                $this->repl_tdfl_dbtablename[] = $tablename_left;
            } else {
                $this->repl_tdfl_dbtablename[] = preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tablename_left);
            }

            $sysdef_leftf = ($row[$i++]);               // left field is a system defined field
            // left database field name
            if ($sysdef_leftf == 'Y') {
                $this->repl_fdfl_dbfieldname[] = $fldnam_left;
            } else {
                $this->repl_fdfl_dbfieldname[] = 'U_' . $fldnam_left;
            }

            $sysdef_rightf = ($row[$i++]);              // right field is a system defined field
            // right database field name
            if ($sysdef_rightf == 'Y') {
                $this->repl_fdfr_dbfieldname[] = $fldnam_right;
            } else {
                $this->repl_fdfr_dbfieldname[] = 'U_' . $fldnam_right;
            }

            $this->repl_fdfl_fieldtype[] = ($row[$i++]);    // left field type
            $this->repl_fdfl_length[] = ($row[$i++]);       // left field length
            $this->repl_fdfr_fieldtype[] = ($row[$i++]);    // right field type
            $this->repl_fdfr_length[] = ($row[$i++]);       // right field length
        }
    }
    /**
     * results reports criteria
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openReportsCriteria($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["reports_criteria"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->repr_id = array();              // report criteria id
        $this->repr_report = array();          // report id
        $this->repr_rel_table = array();       // related table id
        $this->repr_fieldname = array();       // field name
        $this->repr_fieldtype = array();       // field type
        $this->repr_ratio = array();           // field operation
        $this->repr_value = array();           // field value/parameter name
        $this->repr_table_right = array();     // right table id
        $this->repr_compare_fields = array();  // compare to another field
        $this->repr_parameter = array();       // field as parameter
        $this->repr_repl_tablename = array();  // related table name
        $this->repr_fdf_fieldtype = array();   // field type
        $this->repr_fdf_length = array();      // field length
        $this->repr_fdf_linkedtable = array(); // field linked table
        $this->repr_tdf_dbtablename = array(); // related database table name
        $this->repr_fdf_dbfieldname = array(); // database field name
        $this->repr_fdf_fieldtype_right = array();     // right field type
        $this->repr_fdf_length_right = array();        // right field length
        $this->repr_tdf_dbtablename_right = array();   // right database table name
        $this->repr_fdf_dbfieldname_right = array();   // right database field name

        while ($this->fetch()) {
            $i = 0;
            $this->repr_id[] = ($row[$i++]);                // report criteria id
            $this->repr_report[] = ($row[$i++]);            // report id
            $this->repr_rel_table[] = ($row[$i++]);         // related table id
            $fldnam = ($row[$i++]);
            $this->repr_fieldname[] = $fldnam;              // field name
            $this->repr_fieldtype[] = trim($row[$i++]);     // field type
            $this->repr_ratio[] = ($row[$i++]);             // field operation
            $repr_value = ($row[$i++]);
            $this->repr_value[] = HtmlEntityDecodeNOD($repr_value); // field value/parameter name
            $this->repr_table_right[] = ($row[$i++]);       // right table id
            $cmp = ($row[$i++]);
            $this->repr_compare_fields[] = $cmp;            // compare to another field
            $this->repr_parameter[] = ($row[$i++]);         // field as parameter
            $tblnam = ($row[$i++]);
            $this->repr_repl_tablename[] = $tblnam;         // related table name
            $sysdef_t = ($row[$i++]);                       // related table is a system defined table
            $sysdef_f = ($row[$i++]);                       // field is a system defined field
            $this->repr_fdf_fieldtype[] = ($row[$i++]);     // field type
            $this->repr_fdf_length[] = ($row[$i++]);        // field length
            $this->repr_fdf_linkedtable[] = ($row[$i++]);   // field linked table
            $tbl_right = ($row[$i++]);                      // right table name
            $sysdef_tr = ($row[$i++]);                      // right table is a system defined table
            $field_right = ($row[$i++]);                    // right field name
            $sysdef_fr = ($row[$i++]);                      // right field is a system defined field
            $this->repr_fdf_fieldtype_right[] = ($row[$i++]);   // right field type
            $this->repr_fdf_length_right[] = ($row[$i++]);      // right field length

            if ($sysdef_t == 'Y') {
                $this->repr_tdf_dbtablename[] = $tblnam;
            } else {
                $this->repr_tdf_dbtablename[] = 'U_' . $tblnam;
            }

            if ($sysdef_f == 'Y') {
                $this->repr_fdf_dbfieldname[] = $fldnam;
            } else {
                $this->repr_fdf_dbfieldname[] = 'U_' . $fldnam;
            }

            if ($cmp == enumBoolean::bTrue) {
                if ($sysdef_tr == 'Y') {
                    $this->repr_tdf_dbtablename_right[] = $tbl_right;
                } else {
                    $this->repr_tdf_dbtablename_right[] = 'U_' . $tbl_right;
                }

                if ($sysdef_fr == 'Y') {
                    $this->repr_fdf_dbfieldname_right[] = $field_right;
                } else {
                    $this->repr_fdf_dbfieldname_right[] = 'U_' . $field_right;
                }
            } else {
                $this->repr_tdf_dbtablename_right[] = '';   // right database table name
                $this->repr_fdf_dbfieldname_right[] = '';   // right database field name
            }
        }
    }
    /**
     * results reports output
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openReportsOutput($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["reports_output"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->repo_id = array();          // report output id
        $this->repo_report = array();      // report id
        $this->repo_rel_table = array();   // related table id
        $this->repo_tablename = array();   // related table name
        $this->repo_fieldname = array();   // field name
        $this->repo_fieldtype = array();   // field type
        $this->repo_title = array();       // title
        $this->repo_disp_order = array();  // field display order
        $this->repo_sort_order = array();  // field sorting order
        $this->repo_sort_type = array();   // field sorting type
        $this->repo_field_group = array(); // field grouping
        $this->repo_field_function = array();  // field function
        $this->repo_fdf_dbfieldname = array(); // database field name
        $this->repo_fdf_fieldtype = array();   // field type
        $this->repo_fdf_length = array();  // field length

        while ($this->fetch()) {
            $i = 0;
            $this->repo_id[] = ($row[$i++]);            // report output id
            $this->repo_report[] = ($row[$i++]);        // report id
            $this->repo_rel_table[] = ($row[$i++]);     // related table id
            $fldnam = ($row[$i++]);
            $this->repo_fieldname[] = $fldnam;          // field name
            $this->repo_fieldtype[] = trim($row[$i++]); // field type
            $this->repo_title[] = HtmlEntityDecodeNOD($row[$i++]);  // title
            $this->repo_disp_order[] = ($row[$i++]);    // field display order
            $this->repo_sort_order[] = ($row[$i++]);    // field sorting order
            $this->repo_sort_type[] = ($row[$i++]);     // field sorting type
            $this->repo_field_group[] = ($row[$i++]);   // field grouping
            $this->repo_field_function[] = ($row[$i++]);    // field function
            $this->repo_tablename[] = ($row[$i++]);     // related table name
            $sysdef_f = ($row[$i++]);
            $this->repo_fdf_fieldtype[] = ($row[$i++]);     // field type
            $this->repo_fdf_length[] = ($row[$i++]);    // field length

            // database field name
            if ($sysdef_f == 'Y') {
                $this->repo_fdf_dbfieldname[] = $fldnam;
            } else {
                $this->repo_fdf_dbfieldname[] = 'U_' . $fldnam;
            }
        }
    }
    /**
     * results teams
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTeams($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["teams"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->tea_id = array();
        $this->tea_project = array();
        $this->tea_member = array();
        $this->tea_published = array();
        $this->tea_authorized = array();
        $this->tea_profil = array();
        $this->tea_service = array();
        $this->tea_comments = array();
        $this->tea_created = array();
        $this->tea_cuser = array();
        $this->tea_modified = array();
        $this->tea_muser = array();
        $this->tea_mem_id = array();
        $this->tea_mem_organization = array();
        $this->tea_mem_login = array();
        $this->tea_mem_name = array();
        $this->tea_mem_email_work = array();
        $this->tea_mem_language = array();
        $this->tea_mem_title = array();
        $this->tea_mem_phone_work = array();
        $this->tea_mem_profil = array();
        $this->tea_mem_password = array();
        $this->tea_mem_active = array();
        $this->tea_mem_extension_picture = array();
        $this->tea_mem_gender = array();
        $this->tea_org_name = array();
        $this->tea_pro_id = array();
        $this->tea_pro_organization = array();
        $this->tea_pro_name = array();
        $this->tea_pro_owner = array();
        $this->tea_pro_priority = array();
        $this->tea_pro_status = array();
        $this->tea_pro_published = array();
        $this->tea_org2_name = array();
        $this->tea_mem2_login = array();
        $this->tea_mem2_name = array();
        $this->tea_mem2_email_work = array();
        $this->tea_mem2_deputy = array();
        $this->tea_org2_id = array();
        $this->tea_log_connected = array();
        $this->tea_loc_timezone = array();

        while ($this->fetch()) {
            $i = 0;
            $this->tea_id[] = ($row[$i++]);
            $this->tea_project[] = ($row[$i++]);
            $this->tea_member[] = ($row[$i++]);
            $this->tea_published[] = ($row[$i++]);
            $this->tea_authorized[] = ($row[$i++]);
            $this->tea_profil[] = ($row[$i++]);
            $this->tea_service[] = ($row[$i++]);
            $this->tea_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tea_created[] = ($row[$i++]);
            $this->tea_cuser[] = ($row[$i++]);
            $this->tea_modified[] = ($row[$i++]);
            $this->tea_muser[] = ($row[$i++]);
            $this->tea_mem_id[] = ($row[$i++]);
            $this->tea_mem_organization[] = ($row[$i++]);
            $this->tea_mem_login[] = ($row[$i++]);
            $this->tea_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tea_mem_email_work[] = ($row[$i++]);
            $this->tea_mem_language[] = ($row[$i++]);
            $this->tea_mem_title[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tea_mem_phone_work[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tea_mem_profil[] = ($row[$i++]);
            $this->tea_mem_password[] = ($row[$i++]);
            $this->tea_mem_active[] = ($row[$i++]);
            $this->tea_mem_extension_picture[] = ($row[$i++]);
            $this->tea_mem_gender[] = ($row[$i++]);
            $this->tea_org_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tea_pro_id[] = ($row[$i++]);
            $this->tea_pro_organization[] = ($row[$i++]);
            $this->tea_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tea_pro_owner[] = ($row[$i++]);
            $this->tea_pro_priority[] = ($row[$i++]);
            $this->tea_pro_status[] = ($row[$i++]);
            $this->tea_pro_published[] = ($row[$i++]);
            $this->tea_org2_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tea_mem2_login[] = ($row[$i++]);
            $this->tea_mem2_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tea_mem2_email_work[] = ($row[$i++]);
            $this->tea_mem2_deputy[] = ($row[$i++]);
            $this->tea_org2_id[] = ($row[$i++]);
            $this->tea_log_connected[] = ($row[$i++]);
            $this->tea_loc_timezone[] = ($row[$i++]);
        }
    }
    /**
     * results tasks
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTasks($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy;
        $this->connectClass();
        $sql = $initrequest["tasks"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->tas_id = array();
        $this->tas_project = array();
        $this->tas_priority = array();
        $this->tas_status = array();
        $this->tas_owner = array();
        $this->tas_assigned_to = array();
        $this->tas_name = array();
        $this->tas_description = array();
        $this->tas_start_date = array();
        $this->tas_due_date = array();
        $this->tas_estimated_time = array();
        $this->tas_actual_time = array();
        $this->tas_comments = array();
        $this->tas_completion = array();
        $this->tas_assigned = array();
        $this->tas_published = array();
        $this->tas_parent_phase = array();
        $this->tas_complete_date = array();
        $this->tas_service = array();
        $this->tas_fixed_duration = array();
        $this->tas_milestone = array();
        $this->tas_type = array();
        $this->tas_task_group = array();
        $this->tas_level = array();
        $this->tas_parent_task = array();
        $this->tas_subtask = array();
        $this->tas_support_request = array();
        $this->tas_created = array();
        $this->tas_cuser = array();
        $this->tas_modified = array();
        $this->tas_muser = array();
        $this->tas_mem2_name = array();
        $this->tas_mem2_login = array();
        $this->tas_mem2_organization = array();
        $this->tas_mem2_email_work = array();
        $this->tas_mem2_profil = array();
        $this->tas_mem2_extension_picture = array();
        $this->tas_mem2_gender = array();
        $this->tas_pro_name = array();
        $this->tas_org_id = array();
        $this->tas_sr_subject = array();
        $this->tas_svc_name = array();

        while ($this->fetch()) {
            $i = 0;
            $this->tas_id[] = ($row[$i++]);
            $this->tas_project[] = ($row[$i++]);
            $this->tas_priority[] = ($row[$i++]);
            $this->tas_status[] = ($row[$i++]);
            $this->tas_owner[] = ($row[$i++]);
            $this->tas_assigned_to[] = ($row[$i++]);
            $this->tas_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tas_description[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tas_start_date[] = ($row[$i++]);
            $this->tas_due_date[] = ($row[$i++]);
            $hours1 = ($row[$i++]);
            $estimated_time = (is_numeric($hours1))?round($hours1, $hourAccuracy):'0';
            $this->tas_estimated_time[] = $estimated_time;
            $hours2 = ($row[$i++]);
            $actual_time = (is_numeric($hours2))?round($hours2, $hourAccuracy):'0';
            $this->tas_actual_time[] = $actual_time;
            $this->tas_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tas_completion[] = ($row[$i++]);
            $this->tas_assigned[] = ($row[$i++]);
            $this->tas_published[] = ($row[$i++]);
            $this->tas_parent_phase[] = ($row[$i++]);
            $this->tas_complete_date[] = ($row[$i++]);
            $this->tas_service[] = ($row[$i++]);
            $this->tas_fixed_duration[] = ($row[$i++]);
            $this->tas_milestone[] = ($row[$i++]);
            $this->tas_type[] = ($row[$i++]);
            $this->tas_task_group[] = ($row[$i++]);
            $this->tas_level[] = ($row[$i++]);
            $this->tas_parent_task[] = ($row[$i++]);
            $this->tas_subtask[] = ($row[$i++]);
            $this->tas_support_request[] = ($row[$i++]);
            $this->tas_created[] = ($row[$i++]);
            $this->tas_cuser[] = ($row[$i++]);
            $this->tas_modified[] = ($row[$i++]);
            $this->tas_muser[] = ($row[$i++]);
            $this->tas_mem2_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tas_mem2_login[] = ($row[$i++]);
            $this->tas_mem2_organization[] = ($row[$i++]);
            $this->tas_mem2_email_work[] = ($row[$i++]);
            $this->tas_mem2_profil[] = ($row[$i++]);
            $this->tas_mem2_extension_picture[] = ($row[$i++]);
            $this->tas_mem2_gender[] = ($row[$i++]);
            $this->tas_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tas_org_id[] = ($row[$i++]);
            $this->tas_sr_subject[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tas_svc_name[] = HtmlEntityDecodeNOD($row[$i++]);
        }
    }
    /**
     * results tasks_predecessor
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTaskPredecessor($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy;
        $this->connectClass();
        $sql = $initrequest["tasks_predecessor"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->pre_id = array();
        $this->pre_task = array();
        $this->pre_predecessor = array();
        $this->pre_type = array();
        $this->pre_lag = array();
        $this->pre_created = array();
        $this->pre_cuser = array();
        $this->pre_modified = array();
        $this->pre_muser = array();
        $this->pre_tas_project = array();
        $this->pre_tas_name = array();
        $this->pre_tas_start_date = array();
        $this->pre_tas_due_date = array();
        $this->pre_tas_estimated_time = array();
        $this->pre_tas_fixed_duration = array();
        $this->pre_tas_milestone = array();
        $this->pre_tas_level = array();
        $this->pre_tas_parent_task = array();
        $this->pre_tas2_name = array();
        $this->pre_tas2_start_date = array();
        $this->pre_tas2_due_date = array();
        $this->pre_tas2_estimated_time = array();
        $this->pre_tas2_fixed_duration = array();
        $this->pre_tas2_milestone = array();
        $this->pre_tas2_completion = array();
        $this->pre_tas2_assigned_to = array();
        $this->pre_mem2_login = array();
        $this->pre_mem2_email_work = array();

        while ($this->fetch()) {
            $i = 0;
            $this->pre_id[] = ($row[$i++]);
            $this->pre_task[] = ($row[$i++]);
            $this->pre_predecessor[] = ($row[$i++]);
            $this->pre_type[] = ($row[$i++]);
            $hours1 = ($row[$i++]);
            $lag = (is_numeric($hours1))?round($hours1, $hourAccuracy):'0';
            $this->pre_lag[] = $lag;
            $this->pre_created[] = ($row[$i++]);
            $this->pre_cuser[] = ($row[$i++]);
            $this->pre_modified[] = ($row[$i++]);
            $this->pre_muser[] = ($row[$i++]);
            $this->pre_tas_project[] = ($row[$i++]);
            $this->pre_tas_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->pre_tas_start_date[] = ($row[$i++]);
            $this->pre_tas_due_date[] = ($row[$i++]);
            $hours2 = ($row[$i++]);
            $estimated_time = (is_numeric($hours2))?round($hours2, $hourAccuracy):'0';
            $this->pre_tas_estimated_time[] = $estimated_time;
            $this->pre_tas_fixed_duration[] = ($row[$i++]);
            $this->pre_tas_milestone[] = ($row[$i++]);
            $this->pre_tas_level[] = ($row[$i++]);
            $this->pre_tas_parent_task[] = ($row[$i++]);
            $this->pre_tas2_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->pre_tas2_start_date[] = ($row[$i++]);
            $this->pre_tas2_due_date[] = ($row[$i++]);
            $this->pre_tas2_estimated_time[] = ($row[$i++]);
            $this->pre_tas2_fixed_duration[] = ($row[$i++]);
            $this->pre_tas2_milestone[] = ($row[$i++]);
            $this->pre_tas2_completion[] = ($row[$i++]);
            $this->pre_tas2_assigned_to[] = ($row[$i++]);
            $this->pre_mem2_login[] = ($row[$i++]);
            $this->pre_mem2_email_work[] = ($row[$i++]);
        }
    }
    /**
     * results task resources
     * @global array $row
     * @global array $initrequest
     * @global int $quantityAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTaskResource($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $quantityAccuracy;
        $this->connectClass();
        $sql = $initrequest["tasks_resource"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->res_id = array();
        $this->res_task = array();
        $this->res_resource = array();
        $this->res_type = array();
        $this->res_quantity = array();
        $this->res_created = array();
        $this->res_cuser = array();
        $this->res_modified = array();
        $this->res_muser = array();
        $this->res_tas_project = array();
        $this->res_tas_name = array();
        $this->res_pro_name = array();
        $this->res_org_id = array();

        while ($this->fetch()) {
            $i = 0;
            $this->res_id[] = ($row[$i++]);
            $this->res_task[] = ($row[$i++]);
            $this->res_resource[] = ($row[$i++]);
            $this->res_type[] = ($row[$i++]);
            $qty = ($row[$i++]);
            $quantity = (is_numeric($qty))?round($qty, $quantityAccuracy):'0';
            $this->res_quantity[] = $quantity;
            $this->res_created[] = ($row[$i++]);
            $this->res_cuser[] = ($row[$i++]);
            $this->res_modified[] = ($row[$i++]);
            $this->res_muser[] = ($row[$i++]);
            $this->res_tas_project[] = ($row[$i++]);
            $this->res_tas_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->res_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->res_org_id[] = ($row[$i++]);
        }
    }
    /**
     * results for task human resources
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTaskHumanResource($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy;
        $this->connectClass();
        $sql = $initrequest["tasks_human_resource"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->res_id = array();                   // resource id
        $this->res_task = array();                 // task id
        $this->res_resource = array();             // member id
        $this->res_created = array();              // create time
        $this->res_cuser = array();                // create user id
        $this->res_modified = array();             // modify time
        $this->res_muser = array();                // modify user id
        $this->res_tas_project = array();          // project id
        $this->res_tas_name = array();             // task name
        $this->res_mem_name = array();             // member name
        $this->res_mem_login = array();            // member login
        $this->res_mem_email_work = array();       // member work email
        $this->res_mem_phone_work = array();       // member work phone
        $this->res_mem_organization = array();     // member organization id
        $this->res_mem_profil = array();           // member profile
        $this->res_mem_language = array();         // member language
        $this->res_mem_extension_picture = array();
        $this->res_mem_gender = array();
        $this->res_pro_name = array();             // project name
        $this->res_org_id = array();               // organization id
        $this->res_tas_description = array();      // task description
        $this->res_tas_status = array();           // task status
        $this->res_tas_start_date = array();       // task start date
        $this->res_tas_due_date = array();         // task due date
        $this->res_tas_estimated_time = array();   // task estimated time (hours)
        $this->res_tas_completion = array();       // task completion percentage
        $this->res_log_connected = array();        // user connected
        $this->res_loc_timezone = array();         // timezone of member location

        while ($this->fetch()) {
            $i = 0;
            $this->res_id[] = ($row[$i++]);
            $this->res_task[] = ($row[$i++]);
            $this->res_resource[] = ($row[$i++]);
            $this->res_created[] = ($row[$i++]);
            $this->res_cuser[] = ($row[$i++]);
            $this->res_modified[] = ($row[$i++]);
            $this->res_muser[] = ($row[$i++]);
            $this->res_tas_project[] = ($row[$i++]);
            $this->res_tas_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->res_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->res_mem_login[] = ($row[$i++]);
            $this->res_mem_email_work[] = ($row[$i++]);
            $this->res_mem_phone_work = HtmlEntityDecodeNOD($row[$i++]);
            $this->res_mem_organization[] = ($row[$i++]);
            $this->res_mem_profil[] = ($row[$i++]);
            $this->res_mem_language[] = ($row[$i++]);
            $this->res_mem_extension_picture[] = ($row[$i++]);
            $this->res_mem_gender[] = ($row[$i++]);
            $this->res_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->res_org_id[] = ($row[$i++]);
            $this->res_tas_description[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->res_tas_status[] = ($row[$i++]);
            $this->res_tas_start_date[] = ($row[$i++]);
            $this->res_tas_due_date[] = ($row[$i++]);
            $hours = ($row[$i++]);
            $estimated_time = (is_numeric($hours))?round($hours, $hourAccuracy):'0';
            $this->res_tas_estimated_time[] = $estimated_time;
            $this->res_tas_completion[] = ($row[$i++]);
            $this->res_log_connected[] = ($row[$i++]);
            $this->res_loc_timezone[] = ($row[$i++]);
        }
    }
    /**
     * results for task material resources
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @global int $costAccuracy
     * @global int $quantityAccuracy
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTaskMaterialResource($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy, $costAccuracy, $quantityAccuracy, $strings;
        $this->connectClass();
        $sql = $initrequest["tasks_material_resource"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->res_id = array();                       // resource id
        $this->res_task = array();                     // task id
        $this->res_resource = array();                 // material internal id
        $this->res_quantity = array();                 // material quantity
        $this->res_created = array();                  // create time
        $this->res_cuser = array();                    // create user id
        $this->res_modified = array();                 // modify time
        $this->res_muser = array();                    // modify user id
        $this->res_tas_project = array();              // project id
        $this->res_tas_name = array();                 // task name
        $this->res_mat_name = array();                 // material name
        $this->res_mat_name_print = array();           // material name print
        $this->res_mat_unit = array();                 // material unit
        $this->res_mat_currency = array();             // material cost currency
        $this->res_mat_costrate = array();             // material cost rate
        $this->res_pro_name = array();                 // project name
        $this->res_org_id = array();                   // organization id
        $this->res_tas_description = array();          // task description
        $this->res_tas_status = array();               // task status
        $this->res_tas_start_date = array();           // task start date
        $this->res_tas_due_date = array();             // task due date
        $this->res_tas_estimated_time = array();       // task estimated time (hours)
        $this->res_tas_completion = array();           // task completion percentage

        while ($this->fetch()) {
            $i = 0;
            $this->res_id[] = ($row[$i++]);                       // resource id
            $this->res_task[] = ($row[$i++]);                     // task id
            $this->res_resource[] = ($row[$i++]);                 // material internal id
            $val0 = ($row[$i++]);
            $qty = (is_numeric($val0))?round($val0, $quantityAccuracy):'0';
            $this->res_quantity[] = $qty;                         // material quantity
            $this->res_created[] = ($row[$i++]);                  // create time
            $this->res_cuser[] = ($row[$i++]);                    // create user id
            $this->res_modified[] = ($row[$i++]);                 // modify time
            $this->res_muser[] = ($row[$i++]);                    // modify user id
            $this->res_tas_project[] = ($row[$i++]);              // project id
            $this->res_tas_name[] = HtmlEntityDecodeNOD($row[$i++]);  // task name
            $matn = ($row[$i++]);
            $this->res_mat_name[] = $matn;                        // material name
            $this->res_mat_name_print[] = ((isset($strings['MAT__' . $matn]))?$strings['MAT__' . $matn]:$matn);    // material name print
            $this->res_mat_unit[] = HtmlEntityDecodeNOD($row[$i++]);    // material unit
            $this->res_mat_currency[] = ($row[$i++]);             // material cost currency
            $val1 = ($row[$i++]);
            $costrate = (is_numeric($val1))?round($val1, $costAccuracy):'0';
            $this->res_mat_costrate[] = $costrate;                // material cost rate
            $this->res_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);  // project name
            $this->res_org_id[] = ($row[$i++]);                   // organization id
            $this->res_tas_description[] = HtmlEntityDecodeNOD($row[$i++]);   // task description
            $this->res_tas_status[] = ($row[$i++]);               // task status
            $this->res_tas_start_date[] = ($row[$i++]);           // task start date
            $this->res_tas_due_date[] = ($row[$i++]);             // task due date
            $val2 = ($row[$i++]);
            $hours = (is_numeric($val2))?round($val2, $hourAccuracy):'0';
            $this->res_tas_estimated_time[] = $hours;             // task estimated time (hours)
            $this->res_tas_completion[] = ($row[$i++]);           // task completion percentage
        }
    }
    /**
     * results for task equipment resources
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTaskEquipmentResource($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy, $strings;
        $this->connectClass();
        $sql = $initrequest["tasks_equipment_resource"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->res_id = array();                       // resource id
        $this->res_task = array();                     // task id
        $this->res_resource = array();                 // equipment internal id
        $this->res_created = array();                  // create time
        $this->res_cuser = array();                    // create user id
        $this->res_modified = array();                 // modify time
        $this->res_muser = array();                    // modify user id
        $this->res_tas_project = array();              // project id
        $this->res_tas_name = array();                 // task name
        $this->res_equ_equipment_id = array();         // equipment id
        $this->res_equ_equipment_category = array();   // equipment category
        $this->res_equ_equipment_type = array();       // equipment type
        $this->res_eqc_name = array();                 // equipment category name
        $this->res_eqc_name_print = array();           // equipment category name print
        $this->res_eqt_name = array();                 // equipment type name
        $this->res_eqt_name_print = array();           // equipment type name print
        $this->res_equ_name = array();                 // equipment name
        $this->res_equ_name_print = array();           // equipment name print
        $this->res_pro_name = array();                 // project name
        $this->res_org_id = array();                   // organization id
        $this->res_tas_description = array();          // task description
        $this->res_tas_status = array();               // task status
        $this->res_tas_start_date = array();           // task start date
        $this->res_tas_due_date = array();             // task due date
        $this->res_tas_estimated_time = array();       // task estimated time (hours)
        $this->res_tas_completion = array();           // task completion percentage

        while ($this->fetch()) {
            $i = 0;
            $this->res_id[] = ($row[$i++]);                       // resource id
            $this->res_task[] = ($row[$i++]);                     // task id
            $this->res_resource[] = ($row[$i++]);                 // equipment internal id
            $this->res_created[] = ($row[$i++]);                  // create time
            $this->res_cuser[] = ($row[$i++]);                    // create user id
            $this->res_modified[] = ($row[$i++]);                 // modify time
            $this->res_muser[] = ($row[$i++]);                    // modify user id
            $this->res_tas_project[] = ($row[$i++]);              // project id
            $this->res_tas_name[] = HtmlEntityDecodeNOD($row[$i++]);  // task name
            $this->res_equ_equipment_id[] = ($row[$i++]);         // equipment id
            $this->res_equ_equipment_category[] = ($row[$i++]);   // equipment category
            $this->res_equ_equipment_type[] = ($row[$i++]);       // equipment type
            $eqc_name = ($row[$i++]);
            $this->res_eqc_name[] = $eqc_name;                    // equipment category name
            $this->res_eqc_name_print[] = ((isset($strings['EQC__' . $eqc_name]))?$strings['EQC__' . $eqc_name]:$eqc_name);    // equipment category name print
            $eqt_name = ($row[$i++]);
            $this->res_eqt_name[] = $eqt_name;                    // equipment type name
            $this->res_eqt_name_print[] = ((isset($strings['EQT__' . $eqt_name]))?$strings['EQT__' . $eqt_name]:$eqt_name);    // equipment type name print
            $equ_name = ($row[$i++]);
            $this->res_equ_name[] = $equ_name;                    // equipment name
            $this->res_equ_name_print[] = ((isset($strings['EQU__' . $equ_name]))?$strings['EQU__' . $equ_name]:$equ_name);    // equipment name print
            $this->res_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);  // project name
            $this->res_org_id[] = ($row[$i++]);                   // organization id
            $this->res_tas_description[] = HtmlEntityDecodeNOD($row[$i++]);   // task description
            $this->res_tas_status[] = ($row[$i++]);               // task status
            $this->res_tas_start_date[] = ($row[$i++]);           // task start date
            $this->res_tas_due_date[] = ($row[$i++]);             // task due date
            $hours = ($row[$i++]);
            $estimated_time = (is_numeric($hours))?round($hours, $hourAccuracy):'0';
            $this->res_tas_estimated_time[] = $estimated_time;    // task estimated time (hours)
            $this->res_tas_completion[] = ($row[$i++]);           // task completion percentage
        }
    }
    /**
     * results tasks_time
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @global int $rateAccuracy
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTaskTime($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy, $rateAccuracy, $strings;
        $this->connectClass();
        $sql = $initrequest["tasks_time"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->tim_id = array();
        $this->tim_project = array();
        $this->tim_task = array();
        $this->tim_owner = array();
        $this->tim_date = array();
        $this->tim_hours = array();
        $this->tim_comments = array();
        $this->tim_billing = array();
        $this->tim_service = array();
        $this->tim_created = array();
        $this->tim_cuser = array();
        $this->tim_modified = array();
        $this->tim_muser = array();
        $this->tim_mem_name = array();
        $this->tim_pro_name = array();
        $this->tim_pro_type = array();
        $this->tim_org_name = array();
        $this->tim_svc_name_print = array();
        $this->tim_svc_hourly_rate = array();
        $this->tim_svc_hourly_rate_i = array();
        $this->tim_svc_currency = array();
        $this->tim_task_name = array();
        $this->tim_task_type = array();
        $this->tim_wcd_hours = array();
        $this->tim_wcd_type = array();
        $this->tim_wcd_comments = array();
        $this->tim_pro_organization = array();

        while ($this->fetch()) {
            $i = 0;
            $this->tim_id[] = ($row[$i++]);
            $this->tim_project[] = ($row[$i++]);
            $this->tim_task[] = ($row[$i++]);
            $this->tim_owner[] = ($row[$i++]);
            $this->tim_date[] = ($row[$i++]);
            $hours0 = ($row[$i++]);
            $hours1 = (is_numeric($hours0))?round($hours0, $hourAccuracy):'0';
            $this->tim_hours[] = $hours1;
            $this->tim_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tim_billing[] = ($row[$i++]);
            $this->tim_service[] = ($row[$i++]);
            $this->tim_created[] = ($row[$i++]);
            $this->tim_cuser[] = ($row[$i++]);
            $this->tim_modified[] = ($row[$i++]);
            $this->tim_muser[] = ($row[$i++]);
            $this->tim_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tim_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tim_pro_type[] = ($row[$i++]);
            $this->tim_org_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $n = ($row[$i++]);
            $this->tim_svc_name_print[] = ((isset($strings['SVC__' . $n]))?$strings['SVC__' . $n]:$n);
            $hourly_rate0 = ($row[$i++]);
            $hourly_rate1 = (is_numeric($hourly_rate0))?round($hourly_rate0, $rateAccuracy):'0';
            $this->tim_svc_hourly_rate[] = $hourly_rate1;
            $hourly_rate2 = ($row[$i++]);
            $hourly_rate3 = (is_numeric($hourly_rate2))?round($hourly_rate2, $rateAccuracy):'0';
            $this->tim_svc_hourly_rate_i[] = $hourly_rate3;
            $this->tim_svc_currency[] = trim($row[$i++]);
            $this->tim_task_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tim_task_type[] = ($row[$i++]);
            $hours2 = ($row[$i++]);
            $hours3 = (is_numeric($hours2))?round($hours2, $hourAccuracy):'0';
            $this->tim_wcd_hours[] = $hours3;
            $this->tim_wcd_type[] = ($row[$i++]);
            $this->tim_wcd_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tim_pro_organization[] = ($row[$i++]);
        }
    }
    /**
     * results work_hours
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @global int $rateAccuracy
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openWorkHours($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy, $rateAccuracy, $strings;
        $this->connectClass();
        $sql = $initrequest["work_hours"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->wkh_id = array();     // The unique id of work hours
        $this->wkh_project = array();// The project of work hours
        $this->wkh_work = array();   // The hour code of work hours
        $this->wkh_owner = array();  // The owner of work hours
        $this->wkh_date = array();   // The date of work hours
        $this->wkh_hours = array();    // The hours of work
        $this->wkh_comments = array(); // The remarks of work hours
        $this->wkh_billing = array();  // whether the work hours billable
        $this->wkh_service = array();  // The service of work hours
        $this->wkh_baseref = array();  // The base reference of work hours (i.e. leave request )
        $this->wkh_created = array();  // The create timestamp of work hours
        $this->wkh_cuser = array();    // The create user of work hours
        $this->wkh_modified = array(); // The modify timestamp of work hours
        $this->wkh_muser = array();    // The modify user of work hours
        $this->wkh_mem_name = array(); // The name of owner
        $this->wkh_pro_name = array(); // The name of project
        $this->wkh_pro_type = array(); // The type of project
        $this->wkh_org_name = array(); // The name of organization
        $this->wkh_svc_name_print = array();  // The name of service
        $this->wkh_svc_hourly_rate = array(); // The external hourly rate of service
        $this->wkh_svc_hourly_rate_i = array();  // The internal hourly rate of service
        $this->wkh_svc_currency = array();   // The currency of service
        $this->wkh_wcd_hours = array();      // The hours of workcalendar detail
        $this->wkh_wcd_type = array();   // The day type of workcalendar detail
        $this->wkh_wcd_comments = array();    // The remarks of workcalendar detail
        $this->wkh_pro_organization = array();   // The organization of project
        $this->wkh_hrc_hourtype = array();     // hour type of work hours

        while ($this->fetch()) {
            $i = 0;
            $this->wkh_id[] = ($row[$i++]);     // The unique id of work hours
            $this->wkh_project[] = ($row[$i++]);// The project of work hours
            $this->wkh_work[] = ($row[$i++]);   // The hour code of work hours
            $this->wkh_owner[] = ($row[$i++]);  // The owner of work hours
            $this->wkh_date[] = ($row[$i++]);   // The date of work hours
            $hours0 = ($row[$i++]);
            $hours1 = (is_numeric($hours0))?round($hours0, $hourAccuracy):'0';
            $this->wkh_hours[] = $hours1;       // The hours of work
            $this->wkh_comments[] = HtmlEntityDecodeNOD($row[$i++]);    // The remarks of work hours
            $this->wkh_billing[] = ($row[$i++]);    // whether the work hours billable
            $this->wkh_service[] = ($row[$i++]);    // The service of work hours
            $this->wkh_baseref[] = ($row[$i++]);    // The base reference of work hours (i.e. leave request )
            $this->wkh_created[] = ($row[$i++]);    // The create timestamp of work hours
            $this->wkh_cuser[] = ($row[$i++]);      // The create user of work hours
            $this->wkh_modified[] = ($row[$i++]);   // The modify timestamp of work hours
            $this->wkh_muser[] = ($row[$i++]);      // The modify user of work hours
            $this->wkh_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);    // The name of owner
            $this->wkh_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);    // The name of project
            $this->wkh_pro_type[] = ($row[$i++]);   // The type of project
            $this->wkh_org_name[] = HtmlEntityDecodeNOD($row[$i++]);    // The name of organization
            $n = ($row[$i++]);
            $this->wkh_svc_name_print[] = ((isset($strings['SVC__' . $n]))?$strings['SVC__' . $n]:$n);  // The name of service
            $hourly_rate0 = ($row[$i++]);
            $hourly_rate1 = (is_numeric($hourly_rate0))?round($hourly_rate0, $rateAccuracy):'0';
            $this->wkh_svc_hourly_rate[] = $hourly_rate1;    // The external hourly rate of service
            $hourly_rate2 = ($row[$i++]);
            $hourly_rate3 = (is_numeric($hourly_rate2))?round($hourly_rate2, $rateAccuracy):'0';
            $this->wkh_svc_hourly_rate_i[] = $hourly_rate3;  // The internal hourly rate of service
            $this->wkh_svc_currency[] = trim($row[$i++]);   // The currency of service
            $hours2 = ($row[$i++]);
            $hours3 = (is_numeric($hours2))?round($hours2, $hourAccuracy):'0';
            $this->wkh_wcd_hours[] = $hours3;       // The hours of workcalendar detail
            $this->wkh_wcd_type[] = ($row[$i++]);   // The day type of workcalendar detail
            $this->wkh_wcd_comments[] = HtmlEntityDecodeNOD($row[$i++]);    // The remarks of workcalendar detail
            $this->wkh_pro_organization[] = ($row[$i++]);   // The organization of project
            $this->wkh_hrc_hourtype[] = ($row[$i++]);       // The hour type of work hours
        }
    }
    /**
     * results timesheet
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTimesheet($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy;
        $this->connectClass();
        $sql = $initrequest["timesheet"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->tim_id = array();
        $this->tim_owner = array();
        $this->tim_period = array();
        $this->tim_standard_hours = array();
        $this->tim_actual_hours = array();
        $this->tim_billable_hours = array();
        $this->tim_overtime_hours = array();
        $this->tim_status = array();
        $this->tim_comments = array();
        $this->tim_created = array();
        $this->tim_cuser = array();
        $this->tim_modified = array();
        $this->tim_muser = array();
        $this->tim_mem_name = array();
        $this->tim_mem_login = array();
        $this->tim_per_fyear = array();
        $this->tim_per_serial_no = array();
        $this->tim_per_date_start = array();
        $this->tim_per_date_end = array();
        $this->tim_per_locked = array();

        while ($this->fetch()) {
            $i = 0;
            $this->tim_id[] = ($row[$i++]);
            $this->tim_owner[] = ($row[$i++]);
            $this->tim_period[] = ($row[$i++]);
            $hours1 = ($row[$i++]);
            $std_hours = (is_numeric($hours1))?round($hours1, $hourAccuracy):'0';
            $this->tim_standard_hours[] = $std_hours;
            $hours2 = ($row[$i++]);
            $act_hours = (is_numeric($hours2))?round($hours2, $hourAccuracy):'0';
            $this->tim_actual_hours[] = $act_hours;
            $hours3 = ($row[$i++]);
            $bil_hours = (is_numeric($hours3))?round($hours3, $hourAccuracy):'0';
            $this->tim_billable_hours[] = $bil_hours;
            $hours4 = ($row[$i++]);
            $ovt_hours = (is_numeric($hours4))?round($hours4, $hourAccuracy):'0';
            $this->tim_overtime_hours[] = $ovt_hours;
            $this->tim_status[] = ($row[$i++]);
            $this->tim_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tim_created[] = ($row[$i++]);
            $this->tim_cuser[] = ($row[$i++]);
            $this->tim_modified[] = ($row[$i++]);
            $this->tim_muser[] = ($row[$i++]);
            $this->tim_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->tim_mem_login[] = ($row[$i++]);
            $this->tim_per_fyear[] = ($row[$i++]);
            $this->tim_per_serial_no[] = ($row[$i++]);
            $this->tim_per_date_start[] = ($row[$i++]);
            $this->tim_per_date_end[] = ($row[$i++]);
            $this->tim_per_locked[] = ($row[$i++]);
        }
    }
    /**
     * results phase_sets
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openPhaseSets($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["phase_sets"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->phs_id = array();
        $this->phs_name = array();
        $this->phs_phase_num = array();
        $this->phs_created = array();
        $this->phs_cuser = array();
        $this->phs_modified = array();
        $this->phs_muser = array();
        $this->project_num = array();
        $this->phs_description = array();

        while ($this->fetch()) {
            $i = 0;
            $this->phs_id[] = ($row[$i++]);
            $nam = ($row[$i++]);
            $this->phs_name[] = $nam;
            $this->phs_phase_num[] = ($row[$i++]);
            $this->phs_created[] = ($row[$i++]);
            $this->phs_cuser[] = ($row[$i++]);
            $this->phs_modified[] = ($row[$i++]);
            $this->phs_muser[] = ($row[$i++]);
            $this->project_num[] = ($row[$i++]);
            $this->phs_description[] = ((isset($strings['PHS__' . $nam]))?$strings['PHS__' . $nam]:'');
        }
    }
    /**
     * results phases
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openPhases($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["phases"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->pha_id = array();
        $this->pha_project = array();
        $this->pha_order_num = array();
        $this->pha_status = array();
        $this->pha_date_start = array();
        $this->pha_date_end = array();
        $this->pha_comments = array();
        $this->phs_name = array();
        $this->phs_description = array();
        $this->pha_description = array();

        while ($this->fetch()) {
            $i = 0;
            $this->pha_id[] = ($row[$i++]);
            $this->pha_project[] = ($row[$i++]);
            $ordernum = ($row[$i++]);
            $this->pha_order_num[] = $ordernum;
            $this->pha_status[] = ($row[$i++]);
            $this->pha_date_start[] = ($row[$i++]);
            $this->pha_date_end[] = ($row[$i++]);
            $this->pha_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $phsnam = ($row[$i++]);
            $this->phs_name[] = $phsnam;
            $this->phs_description[] = ((isset($strings['PHS__' . $phsnam]))?$strings['PHS__' . $phsnam]:'');
            $this->pha_description[] = ((isset($strings['PHS__' . $phsnam . '_' . $ordernum]))?$strings['PHS__' . $phsnam . '_' . $ordernum]:'');
        }
    }
    /**
     * results phases II
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openPhases2($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["phases2"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->pha_id = array();
        $this->pha_project = array();
        $this->pha_order_num = array();
        $this->pha_status = array();
        $this->pha_date_start = array();
        $this->pha_date_end = array();
        $this->pha_comments = array();
        $this->phs_name = array();
        $this->phs_description = array();
        $this->pha_total_tasks = array();
        $this->pha_uncompleted_tasks = array();
        $this->pha_milestones = array();
        $this->pha_description = array();

        while ($this->fetch()) {
            $i = 0;
            $this->pha_id[] = ($row[$i++]);
            $this->pha_project[] = ($row[$i++]);
            $ordernum = ($row[$i++]);
            $this->pha_order_num[] = $ordernum;
            $this->pha_status[] = ($row[$i++]);
            $this->pha_date_start[] = ($row[$i++]);
            $this->pha_date_end[] = ($row[$i++]);
            $this->pha_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $phsnam = ($row[$i++]);
            $this->phs_name[] = $phsnam;
            $this->phs_description[] = ((isset($strings['PHS__' . $phsnam]))?$strings['PHS__' . $phsnam]:'');
            $this->pha_total_tasks[] = ($row[$i++]);
            $this->pha_uncompleted_tasks[] = ($row[$i++]);
            $this->pha_milestones[] = ($row[$i++]);
            $this->pha_description[] = ((isset($strings['PHS__' . $phsnam . '_' . $ordernum]))?$strings['PHS__' . $phsnam . '_' . $ordernum]:'');
        }
    }
    /**
     * results updates
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openUpdates($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["updates"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->upd_id = array();
        $this->upd_type = array();
        $this->upd_item = array();
        $this->upd_member = array();
        $this->upd_comments = array();
        $this->upd_created = array();
        $this->upd_mem_id = array();
        $this->upd_mem_name = array();
        $this->upd_mem_login = array();
        $this->upd_mem_email_work = array();

        while ($this->fetch()) {
            $i = 0;
            $this->upd_id[] = ($row[$i++]);
            $this->upd_type[] = ($row[$i++]);
            $this->upd_item[] = ($row[$i++]);
            $this->upd_member[] = ($row[$i++]);
            $this->upd_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->upd_created[] = ($row[$i++]);
            $this->upd_mem_id[] = ($row[$i++]);
            $this->upd_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->upd_mem_login[] = ($row[$i++]);
            $this->upd_mem_email_work[] = ($row[$i++]);
        }
    }
    /**
     * results support requests
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openSupportRequests($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["support_requests"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->sr_id = array();
        $this->sr_status = array();
        $this->sr_owner = array();
        $this->sr_reproducibility = array();
        $this->sr_severity = array();
        $this->sr_priority = array();
        $this->sr_subject = array();
        $this->sr_message = array();
        $this->sr_date_open = array();
        $this->sr_date_close = array();
        $this->sr_project = array();
        $this->sr_assigned_to = array();
        $this->sr_resolution = array();
        $this->sr_auto_close = array();
        $this->sr_published = array();
        $this->sr_pro_name = array();
        $this->sr_mem_name = array();
        $this->sr_mem_email_work = array();
        $this->sr_mem_profil = array();
        $this->sr_mem_extension_picture = array();
        $this->sr_mem_gender = array();
        $this->sr_mem2_name = array();
        $this->sr_mem2_email_work = array();
        $this->sr_mem2_profil = array();

        while ($this->fetch()) {
            $i = 0;
            $this->sr_id[] = ($row[$i++]);
            $this->sr_status[] = ($row[$i++]);
            $this->sr_owner[] = ($row[$i++]);
            $this->sr_reproducibility[] = ($row[$i++]);
            $this->sr_severity[] = ($row[$i++]);
            $this->sr_priority[] = ($row[$i++]);
            $this->sr_subject[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->sr_message[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->sr_date_open[] = ($row[$i++]);
            $this->sr_date_close[] = ($row[$i++]);
            $this->sr_project[] = ($row[$i++]);
            $this->sr_assigned_to[] = ($row[$i++]);
            $this->sr_resolution[] = ($row[$i++]);
            $this->sr_auto_close[] = ($row[$i++]);
            $this->sr_published[] = ($row[$i++]);
            $this->sr_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->sr_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->sr_mem_email_work[] = ($row[$i++]);
            $this->sr_mem_profil[] = ($row[$i++]);
            $this->sr_mem_extension_picture[] = ($row[$i++]);
            $this->sr_mem_gender[] = ($row[$i++]);
            $this->sr_mem2_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->sr_mem2_email_work[] = ($row[$i++]);
            $this->sr_mem2_profil[] = ($row[$i++]);
        }
    }
    /**
     * results support posts
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openSupportPosts($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["support_posts"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->sp_id = array();
        $this->sp_request_id = array();
        $this->sp_message = array();
        $this->sp_date = array();
        $this->sp_owner = array();
        $this->sp_project = array();
        $this->sp_mem_name = array();
        $this->sp_mem_email_work = array();
        $this->sp_sr_subject = array();

        while ($this->fetch()) {
            $i = 0;
            $this->sp_id[] = ($row[$i++]);
            $this->sp_request_id[] = ($row[$i++]);
            $this->sp_message[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->sp_date[] = ($row[$i++]);
            $this->sp_owner[] = ($row[$i++]);
            $this->sp_project[] = ($row[$i++]);
            $this->sp_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->sp_mem_email_work[] = ($row[$i++]);
            $this->sp_sr_subject[] = HtmlEntityDecodeNOD($row[$i++]);
        }
    }
    /**
     * results services
     * @global array $row
     * @global array $initrequest
     * @global int $rateAccuracy
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openServices($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $rateAccuracy, $strings;
        $this->connectClass();
        $sql = $initrequest['services'];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->serv_id = array();
        $this->serv_name = array();
        $this->serv_name_print = array();
        $this->serv_hourly_rate = array();
        $this->serv_hourly_rate_i = array();
        $this->serv_currency = array();
        $this->serv_locked = array();
        $this->serv_created = array();
        $this->serv_cuser = array();
        $this->serv_modified = array();
        $this->serv_muser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->serv_id[] = ($row[$i++]);
            $n = ($row[$i++]);
            $this->serv_name[] = $n;
            $this->serv_name_print[] = ((isset($strings['SVC__' . $n]))?$strings['SVC__' . $n]:$n);
            $val1 = ($row[$i++]);
            $rate1 = (is_numeric($val1))?round($val1, $rateAccuracy):'0';
            $this->serv_hourly_rate[] = $rate1;
            $val2 = ($row[$i++]);
            $rate2 = (is_numeric($val2))?round($val2, $rateAccuracy):'0';
            $this->serv_hourly_rate_i[] = $rate2;
            $this->serv_currency[] = trim($row[$i++]);
            $this->serv_locked[] = ($row[$i++]);
            $this->serv_created[] = ($row[$i++]);
            $this->serv_cuser[] = ($row[$i++]);
            $this->serv_modified[] = ($row[$i++]);
            $this->serv_muser[] = ($row[$i++]);
        }
    }
    /**
     * results services with hours total
     * @global array $row
     * @global array $initrequest
     * @global int $rateAccuracy
     * @global int $hourAccuracy
     * @global array $strings
     * @param string $querymore
     * @param int $datefrom
     * @param int $dateto
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openServices1($querymore, $datefrom, $dateto, $start = "", $rows = "")
    {
        global $row, $initrequest, $rateAccuracy, $hourAccuracy, $strings;
        $this->connectClass();
        $sql = str_replace('%DATETO%', $dateto, str_replace('%DATEFROM%', $datefrom, $initrequest['services1']));
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->serv_id = array();
        $this->serv_name = array();
        $this->serv_name_print = array();
        $this->serv_hourly_rate = array();
        $this->serv_hourly_rate_i = array();
        $this->serv_currency = array();
        $this->serv_created = array();
        $this->serv_cuser = array();
        $this->serv_modified = array();
        $this->serv_muser = array();
        $this->serv_total = array();

        while ($this->fetch()) {
            $i = 0;
            $this->serv_id[] = ($row[$i++]);
            $n = ($row[$i++]);
            $this->serv_name[] = $n;
            $this->serv_name_print[] = ((isset($strings['SVC__' . $n]))?$strings['SVC__' . $n]:$n);
            $val1 = ($row[$i++]);
            $this->serv_hourly_rate[] = (is_numeric($val1))?round($val1, $rateAccuracy):'0';
            $val2 = ($row[$i++]);
            $this->serv_hourly_rate_i[] = (is_numeric($val2))?round($val2, $rateAccuracy):'0';
            $this->serv_currency[] = trim($row[$i++]);
            $this->serv_created[] = ($row[$i++]);
            $this->serv_cuser[] = ($row[$i++]);
            $this->serv_modified[] = ($row[$i++]);
            $this->serv_muser[] = ($row[$i++]);
            $thours = ($row[$i++]);
            $whours = ($row[$i++]);
            $this->serv_total[] = round(((is_numeric($thours))?floatval($thours):0) + ((is_numeric($whours))?floatval($whours):0), $hourAccuracy);
        }
    }
    /**
     * results material issue
     * @global array $row
     * @global array $initrequest
     * @global int $quantityAccuracy
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openMaterialIssue($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $quantityAccuracy, $strings;
        $this->connectClass();
        $sql = $initrequest['material_issue'];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->iss_id = array();
        $this->iss_project = array();
        $this->iss_task = array();
        $this->iss_owner = array();
        $this->iss_material = array();
        $this->iss_date = array();
        $this->iss_quantity = array();
        $this->iss_created = array();
        $this->iss_cuser = array();
        $this->iss_modified = array();
        $this->iss_muser = array();
        $this->iss_mat_name = array();
        $this->iss_mat_name_print = array();
        $this->iss_mat_unit = array();
        $this->iss_mem_name = array();

        while ($this->fetch()) {
            $i = 0;
            $this->iss_id[] = ($row[$i++]);
            $this->iss_project[] = ($row[$i++]);
            $this->iss_task[] = ($row[$i++]);
            $this->iss_owner[] = ($row[$i++]);
            $this->iss_material[] = ($row[$i++]);
            $this->iss_date[] = ($row[$i++]);
            $q = ($row[$i++]);
            $qty = (is_numeric($q))?round($q, $quantityAccuracy):'0';
            $this->iss_quantity[] = $qty;
            $this->iss_created[] = ($row[$i++]);
            $this->iss_cuser[] = ($row[$i++]);
            $this->iss_modified[] = ($row[$i++]);
            $this->iss_muser[] = ($row[$i++]);
            $matn = ($row[$i++]);
            $this->iss_mat_name[] = $matn;
            $this->iss_mat_name_print[] = ((isset($strings['MAT__' . $matn]))?$strings['MAT__' . $matn]:$matn);
            $this->iss_mat_unit[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->iss_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
        }
    }
    /**
     * results materials
     * @global array $row
     * @global array $initrequest
     * @global int $rateAccuracy
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openMaterials($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $rateAccuracy, $strings;
        $this->connectClass();
        $sql = $initrequest['materials'];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->mat_id = array();
        $this->mat_name = array();         // name
        $this->mat_name_print = array();   // name print
        $this->mat_unit = array();         // unit
        $this->mat_currency = array();     // currency
        $this->mat_costrate = array();     // cost rate
        $this->mat_locked = array();       // locked
        $this->mat_created = array();
        $this->mat_cuser = array();
        $this->mat_modified = array();
        $this->mat_muser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->mat_id[] = ($row[$i++]);
            $n = ($row[$i++]);
            $this->mat_name[] = $n;
            $this->mat_name_print[] = ((isset($strings['MAT__' . $n]))?$strings['MAT__' . $n]:$n);
            $this->mat_unit[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mat_currency[] = trim($row[$i++]);
            $val = ($row[$i++]);
            $costrate = (is_numeric($val))?round($val, $rateAccuracy):'0';
            $this->mat_costrate[] = $costrate;
            $this->mat_locked[] = ($row[$i++]);
            $this->mat_created[] = ($row[$i++]);
            $this->mat_cuser[] = ($row[$i++]);
            $this->mat_modified[] = ($row[$i++]);
            $this->mat_muser[] = ($row[$i++]);
        }
    }
    /**
     * results meetings
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openMeetings($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["meetings"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->mee_id = array();
        $this->mee_project = array();
        $this->mee_priority = array();
        $this->mee_status = array();
        $this->mee_owner = array();
        $this->mee_name = array();
        $this->mee_agenda = array();
        $this->mee_location = array();
        $this->mee_minutes = array();
        $this->mee_duration = array();
        $this->mee_start_time = array();
        $this->mee_reminder = array();
        $this->mee_reminder_time1 = array();
        $this->mee_reminder_time2 = array();
        $this->mee_confirmed = array();
        $this->mee_allreplied = array();
        $this->mee_created = array();
        $this->mee_cuser = array();
        $this->mee_modified = array();
        $this->mee_muser = array();
        $this->mee_pro_name = array();
        $this->mee_pro_organization = array();
        $this->mee_owner_name = array();
        $this->mee_owner_login = array();
        $this->mee_owner_organization = array();
        $this->mee_owner_email = array();
        $this->mee_owner_language = array();
        $this->mee_owner_profil = array();
        $this->mee_owner_timezone = array();

        while ($this->fetch()) {
            $i = 0;
            $this->mee_id[] = ($row[$i++]);
            $this->mee_project[] = ($row[$i++]);
            $this->mee_priority[] = ($row[$i++]);
            $this->mee_status[] = ($row[$i++]);
            $this->mee_owner[] = ($row[$i++]);
            $this->mee_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mee_agenda[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mee_location[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mee_minutes[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mee_duration[] = ($row[$i++]);
            $this->mee_start_time[] = ($row[$i++]);
            $this->mee_reminder[] = ($row[$i++]);
            $this->mee_reminder_time1[] = ($row[$i++]);
            $this->mee_reminder_time2[] = ($row[$i++]);
            $this->mee_confirmed[] = ($row[$i++]);
            $this->mee_allreplied[] = ($row[$i++]);
            $this->mee_created[] = ($row[$i++]);
            $this->mee_cuser[] = ($row[$i++]);
            $this->mee_modified[] = ($row[$i++]);
            $this->mee_muser[] = ($row[$i++]);
            $this->mee_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mee_pro_organization[] = ($row[$i++]);
            $this->mee_owner_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mee_owner_login[] = ($row[$i++]);
            $this->mee_owner_organization[] = ($row[$i++]);
            $this->mee_owner_email[] = ($row[$i++]);
            $this->mee_owner_language[] = ($row[$i++]);
            $this->mee_owner_profil[] = ($row[$i++]);
            $this->mee_owner_timezone[] = ($row[$i++]);
        }
    }
    /**
     * results attendees
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openAttendees($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["attendees"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->att_meeting = array();
        $this->att_member = array();
        $this->att_attended = array();
        $this->att_authorized = array();
        $this->att_required = array();
        $this->att_schedule_string = array();
        $this->att_string_validto = array();
        $this->att_mem_login = array();
        $this->att_mem_name = array();
        $this->att_mem_email_work = array();
        $this->att_mem_language = array();
        $this->att_mem_title = array();
        $this->att_mem_phone_work = array();
        $this->att_mem_profil = array();
        $this->att_mem_password = array();
        $this->att_mem_organization = array();
        $this->att_mem_location = array();
        $this->att_mee_project = array();
        $this->att_mee_name = array();
        $this->att_mee_agenda = array();
        $this->att_mee_location = array();
        $this->att_mee_priority = array();
        $this->att_mee_status = array();
        $this->att_mee_start_time = array();
        $this->att_mee_duration = array();
        $this->att_org_name = array();
        $this->att_pro_name = array();
        $this->att_pro_priority = array();
        $this->att_pro_status = array();
        $this->att_pro_published = array();
        $this->att_pro_organization = array();
        $this->att_pro_owner = array();
        $this->att_org2_name = array();
        $this->att_mem2_login = array();
        $this->att_mem2_email_work = array();
        $this->att_log_connected = array();
        $this->att_loc_timezone = array();

        while ($this->fetch()) {
            $i = 0;
            $this->att_meeting[] = ($row[$i++]);
            $this->att_member[] = ($row[$i++]);
            $this->att_attended[] = ($row[$i++]);
            $this->att_authorized[] = ($row[$i++]);
            $this->att_required[] = ($row[$i++]);
            $this->att_schedule_string[] = ($row[$i++]);
            $this->att_string_validto[] = ($row[$i++]);
            $this->att_mem_login[] = ($row[$i++]);
            $this->att_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->att_mem_email_work[] = ($row[$i++]);
            $this->att_mem_language[] = ($row[$i++]);
            $this->att_mem_title[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->att_mem_phone_work[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->att_mem_profil[] = ($row[$i++]);
            $this->att_mem_password[] = ($row[$i++]);
            $this->att_mem_organization[] = ($row[$i++]);
            $this->att_mem_location[] = ($row[$i++]);
            $this->att_mee_project[] = ($row[$i++]);
            $this->att_mee_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->att_mee_agenda[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->att_mee_location[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->att_mee_priority[] = ($row[$i++]);
            $this->att_mee_status[] = ($row[$i++]);
            $this->att_mee_start_time[] = ($row[$i++]);
            $this->att_mee_duration[] = ($row[$i++]);
            $this->att_org_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->att_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->att_pro_priority[] = ($row[$i++]);
            $this->att_pro_status[] = ($row[$i++]);
            $this->att_pro_published[] = ($row[$i++]);
            $this->att_pro_organization[] = ($row[$i++]);
            $this->att_pro_owner[] = ($row[$i++]);
            $this->att_org2_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->att_mem2_login[] = ($row[$i++]);
            $this->att_mem2_email_work[] = ($row[$i++]);
            $this->att_log_connected[] = ($row[$i++]);
            $this->att_loc_timezone[] = ($row[$i++]);
        }
    }
    /**
     * results meetings_available
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openMeetingAvailable($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["meetings_available"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->mav_meeting = array();
        $this->mav_member = array();
        $this->mav_schedule = array();
        $this->mav_msc_start_time = array();
        $this->mav_msc_canceled = array();

        while ($this->fetch()) {
            $i = 0;
            $this->mav_meeting[] = ($row[$i++]);
            $this->mav_member[] = ($row[$i++]);
            $this->mav_schedule[] = ($row[$i++]);
            $this->mav_msc_start_time[] = ($row[$i++]);
            $this->mav_msc_canceled[] = ($row[$i++]);
        }
    }
    /**
     * results meetings_schedule
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openMeetingSchedule($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["meetings_schedule"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->msc_id = array();
        $this->msc_meeting = array();
        $this->msc_start_time = array();
        $this->msc_canceled = array();

        while ($this->fetch()) {
            $i = 0;
            $this->msc_id[] = ($row[$i++]);
            $this->msc_meeting[] = ($row[$i++]);
            $this->msc_start_time[] = ($row[$i++]);
            $this->msc_canceled[] = ($row[$i++]);
        }
    }
    /**
     * results meetings_time
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openMeetingTime($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy;
        $this->connectClass();
        $sql = $initrequest["meetings_time"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->mti_id = array();
        $this->mti_project = array();
        $this->mti_meeting = array();
        $this->mti_owner = array();
        $this->mti_date = array();
        $this->mti_hours = array();
        $this->mti_comments = array();
        $this->mti_created = array();
        $this->mti_cuser = array();
        $this->mti_modified = array();
        $this->mti_muser = array();
        $this->mti_mem_name = array();
        $this->mti_mee_name = array();
        $this->mti_pro_organization = array();
        $this->mti_pro_name = array();
        $this->mti_pro_type = array();
        $this->mti_org_name = array();

        while ($this->fetch()) {
            $i = 0;
            $this->mti_id[] = ($row[$i++]);
            $this->mti_project[] = ($row[$i++]);
            $this->mti_meeting[] = ($row[$i++]);
            $this->mti_owner[] = ($row[$i++]);
            $this->mti_date[] = ($row[$i++]);
            $hours0 = ($row[$i++]);
            $hours = (is_numeric($hours0))?round($hours0, $hourAccuracy):'0';
            $this->mti_hours[] = $hours;
            $this->mti_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mti_created[] = ($row[$i++]);
            $this->mti_cuser[] = ($row[$i++]);
            $this->mti_modified[] = ($row[$i++]);
            $this->mti_muser[] = ($row[$i++]);
            $this->mti_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mti_mee_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mti_pro_organization[] = ($row[$i++]);
            $this->mti_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->mti_pro_type[] = ($row[$i++]);
            $this->mti_org_name[] = HtmlEntityDecodeNOD($row[$i++]);
        }
    }
    /**
     * results workcalendars
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openWorkCalendars($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["workcalendars"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->wca_id = array();     // The unique id of workcalendar
        $this->wca_name = array();        // The name of workcalendar
        $this->wca_description = array(); // The description of workcalendar
        $this->wca_created = array();
        $this->wca_cuser = array();
        $this->wca_modified = array();
        $this->wca_muser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->wca_id[] = ($row[$i++]);     // The unique id of workcalendar
            $this->wca_name[] = HtmlEntityDecodeNOD($row[$i++]);        // The name of workcalendar
            $this->wca_description[] = HtmlEntityDecodeNOD($row[$i++]); // The description of workcalendar
            $this->wca_created[] = ($row[$i++]);
            $this->wca_cuser[] = ($row[$i++]);
            $this->wca_modified[] = ($row[$i++]);
            $this->wca_muser[] = ($row[$i++]);
        }
    }
    /**
     * results workcalendars_weekday
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openWorkCalendarsWeekday($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy;
        $this->connectClass();
        $sql = $initrequest["workcalendars_weekday"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->wcw_id = array();     // The unique id of workcalendar weekday
        $this->wcw_workcalendar = array();   // The unique id of workcalendar
        $this->wcw_year = array();   // The year of workcalendar weekday
        $this->wcw_day_type = array();   // The day type of workcalendar weekday
        $this->wcw_hours = array();        // The hours of workcalendar weekday
        $this->wcw_start_time = array(); // The start time of workcalendar weekday
        $this->wcw_end_time = array();   // The end time of workcalendar weekday
        $this->wcw_created = array();
        $this->wcw_cuser = array();
        $this->wcw_modified = array();
        $this->wcw_muser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->wcw_id[] = ($row[$i++]);     // The unique id of workcalendar weekday
            $this->wcw_workcalendar[] = ($row[$i++]);   // The unique id of workcalendar
            $this->wcw_year[] = ($row[$i++]);   // The year of workcalendar weekday
            $this->wcw_day_type[] = ($row[$i++]);   // The day type of workcalendar weekday
            $hours0 = ($row[$i++]);
            $hours = (is_numeric($hours0))?round($hours0, $hourAccuracy):'0';
            $this->wcw_hours[] = $hours;        // The hours of workcalendar weekday
            $this->wcw_start_time[] = ($row[$i++]); // The start time of workcalendar weekday
            $this->wcw_end_time[] = ($row[$i++]);   // The end time of workcalendar weekday
            $this->wcw_created[] = ($row[$i++]);
            $this->wcw_cuser[] = ($row[$i++]);
            $this->wcw_modified[] = ($row[$i++]);
            $this->wcw_muser[] = ($row[$i++]);
        }
    }
    /**
     * results workcalendars_detail
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openWorkCalendarsDetail($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy;
        $this->connectClass();
        $sql = $initrequest["workcalendars_detail"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->wcd_id = array();     // The unique id of workcalendar detail
        $this->wcd_workcalendar = array();   // The unique id of workcalendar
        $this->wcd_year = array();   // The year of workcalendar detail
        $this->wcd_date = array();   // The date of workcalendar detail
        $this->wcd_type = array();   // The day type of workcalendar detail
        $this->wcd_hours = array();        // The hours of workcalendar detail
        $this->wcd_comments = array();    // The remarks of workcalendar detail
        $this->wcd_created = array();
        $this->wcd_cuser = array();
        $this->wcd_modified = array();
        $this->wcd_muser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->wcd_id[] = ($row[$i++]);     // The unique id of workcalendar detail
            $this->wcd_workcalendar[] = ($row[$i++]);   // The unique id of workcalendar
            $this->wcd_year[] = ($row[$i++]);   // The year of workcalendar detail
            $this->wcd_date[] = ($row[$i++]);   // The date of workcalendar detail
            $this->wcd_type[] = ($row[$i++]);   // The day type of workcalendar detail
            $hours0 = ($row[$i++]);
            $hours = (is_numeric($hours0))?round($hours0, $hourAccuracy):'0';
            $this->wcd_hours[] = $hours;        // The hours of workcalendar detail
            $this->wcd_comments[] = HtmlEntityDecodeNOD($row[$i++]);    // The remarks of workcalendar detail
            $this->wcd_created[] = ($row[$i++]);
            $this->wcd_cuser[] = ($row[$i++]);
            $this->wcd_modified[] = ($row[$i++]);
            $this->wcd_muser[] = ($row[$i++]);
        }
    }
    /**
     * results leaves
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openLeaves($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy;
        $this->connectClass();
        $sql = $initrequest["leaves"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->lea_id = array();     // The unique id of leave
        $this->lea_owner = array();  // The owner of leave
        $this->lea_year = array();   // The year of leave
        $this->lea_type = array();   // The type of leave
        $this->lea_hours = array();    // The hours of leave
        $this->lea_due_date = array();   // The due date of leave
        $this->lea_comments = array();    // The remarks of leave
        $this->lea_created = array();    // The create timestamp of leave
        $this->lea_cuser = array();      // The create user id of leave
        $this->lea_modified = array();   // The modify timestamp of leave
        $this->lea_muser = array();      // The modify user id of leave
        $this->lea_mem_login = array();  // The login name of owner
        $this->lea_mem_name = array();    // The fullname of owner
        $this->lea_mem_title = array();   // The title of owner
        $this->lea_mem_department = array();   // The department of owner
        $this->lea_mem_email_work = array();   // The work email of owner
        $this->lea_mem_extension_picture = array();
        $this->lea_mem_gender = array();

        while ($this->fetch()) {
            $i = 0;
            $this->lea_id[] = ($row[$i++]);     // The unique id of leave
            $this->lea_owner[] = ($row[$i++]);  // The owner of leave
            $this->lea_year[] = ($row[$i++]);   // The year of leave
            $this->lea_type[] = ($row[$i++]);   // The type of leave
            $hours0 = ($row[$i++]);              // The hours of leave
            $hours = (is_numeric($hours0))?round($hours0, $hourAccuracy):'0';
            $this->lea_hours[] = $hours;
            $this->lea_due_date[] = ($row[$i++]);   // The due date of leave
            $this->lea_comments[] = HtmlEntityDecodeNOD($row[$i++]);    // The remarks of leave
            $this->lea_created[] = ($row[$i++]);    // The create timestamp of leave
            $this->lea_cuser[] = ($row[$i++]);      // The create user id of leave
            $this->lea_modified[] = ($row[$i++]);   // The modify timestamp of leave
            $this->lea_muser[] = ($row[$i++]);      // The modify user id of leave
            $this->lea_mem_login[] = ($row[$i++]);  // The login name of owner
            $this->lea_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);    // The fullname of owner
            $this->lea_mem_title[] = HtmlEntityDecodeNOD($row[$i++]);   // The title of owner
            $this->lea_mem_department[] = ($row[$i++]); // The department of owner
            $this->lea_mem_email_work[] = ($row[$i++]); // The work email of owner
            $this->lea_mem_extension_picture[] = ($row[$i++]);
            $this->lea_mem_gender[] = ($row[$i++]);
        }
    }
    /**
     * results leave_requests
     * @global array $row
     * @global array $initrequest
     * @global int $hourAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openLeaveRequests($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $hourAccuracy;
        $this->connectClass();
        $sql = $initrequest["leave_requests"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->lea_id = array();     // The unique id of leave request
        $this->lea_owner = array();  // The owner of leave request
        $this->lea_type = array();   // The type of leave request
        $this->lea_date_start = array(); // The start date of leave request detail
        $this->lea_date_end = array();   // The end date of leave request detail
        $this->lea_time_start = array(); // The start time of leave request detail
        $this->lea_time_end = array();   // The end time of leave request detail
        $this->lea_hours_total = array();  // The total hours of leave request
        $this->lea_hours_start = array();  // The hours on start of leave request
        $this->lea_hours_end = array();    // The hours on end of leave request
        $this->lea_status = array(); // The approval status of leave request
        $this->lea_comments = array();    // The remarks of leave request
        $this->lea_created = array();
        $this->lea_cuser = array();
        $this->lea_modified = array();
        $this->lea_muser = array();
        $this->lea_mem_name = array();    // The name of owner
        $this->lea_mem_manager = array();    // The manager of owner
        $this->lea_mem_login = array();      // The login name of owner

        while ($this->fetch()) {
            $i = 0;
            $this->lea_id[] = ($row[$i++]);     // The unique id of leave request
            $this->lea_owner[] = ($row[$i++]);  // The owner of leave request
            $this->lea_type[] = ($row[$i++]);   // The type of leave request
            $this->lea_date_start[] = ($row[$i++]); // The start date of leave request detail
            $this->lea_date_end[] = ($row[$i++]);   // The end date of leave request detail
            $this->lea_time_start[] = ($row[$i++]); // The start time of leave request detail
            $this->lea_time_end[] = ($row[$i++]);   // The end time of leave request detail
            $hours0 = ($row[$i++]);
            $hours1 = (is_numeric($hours0))?round($hours0, $hourAccuracy):'0';
            $this->lea_hours_total[] = $hours1;  // The total hours of leave request
            $hours2 = ($row[$i++]);
            $hours3 = (is_numeric($hours2))?round($hours2, $hourAccuracy):'0';
            $this->lea_hours_start[] = $hours3;  // The hours on start of leave request
            $hours4 = ($row[$i++]);
            $hours5 = (is_numeric($hours4))?round($hours4, $hourAccuracy):'0';
            $this->lea_hours_end[] = $hours5;    // The hours on end of leave request
            $this->lea_status[] = ($row[$i++]); // The approval status of leave request
            $this->lea_comments[] = HtmlEntityDecodeNOD($row[$i++]);    // The remarks of leave request
            $this->lea_created[] = ($row[$i++]);
            $this->lea_cuser[] = ($row[$i++]);
            $this->lea_modified[] = ($row[$i++]);
            $this->lea_muser[] = ($row[$i++]);
            $this->lea_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);    // The name of owner
            $this->lea_mem_manager[] = ($row[$i++]);    // The manager of owner
            $this->lea_mem_login[] = ($row[$i++]);      // The login name of owner
        }
    }
    /**
     * results strings
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openStrings($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest['strings'];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->str_string_key = array();
        $this->str_language = array();
        $this->str_string_val = array();

        while ($this->fetch()) {
            $i = 0;
            $this->str_string_key[] = ($row[$i++]);
            $this->str_language[] = ($row[$i++]);
            $this->str_string_val[] = HtmlEntityDecodeNOD($row[$i++]);
        }
    }
    /**
     * get member time of day
     * @global string $tablePrefix
     * @global array $row
     * @global int $hourAccuracy
     * @param int $id member id
     * @param int $date1
     */
    function getMemberTimeOfDay($id, $date1)
    {
        global $tablePrefix, $row, $hourAccuracy;
        $rc = 0;
        $this->connectClass();
        $sql = "SELECT SUM(A.hours) FROM (";
        $sql .= "SELECT SUM(hours) AS hours FROM " . $tablePrefix . "tasks_time WHERE owner='$id' AND date='$date1'";
        $sql .= " UNION ALL ";
        $sql .= "SELECT SUM(hours) AS hours FROM " . $tablePrefix . "meetings_time WHERE owner='$id' AND date='$date1'";
        $sql .= " UNION ALL ";
        $sql .= "SELECT SUM(hours) AS hours FROM " . $tablePrefix . "work_hours WHERE owner='$id' AND date='$date1'";
        $sql .= ") A";
        $this->query($sql);

        while ($this->fetch()) {
            if (is_numeric($row[0])) {
                $rc += floatval($row[0]);
            }
        }

        $rc1 = round($rc, $hourAccuracy);
        return $rc1;
    }
    /**
     * get member time of days
     * @global string $tablePrefix
     * @global array $row
     * @global int $hourAccuracy
     * @param int $id member id
     * @param int $date_start
     * @param int $date_end
     */
    function getMemberTimeOfDays($id, $date_start, $date_end)
    {
        global $tablePrefix, $row, $hourAccuracy;
        $this->mem_hours = array();
        $this->connectClass();
        $sql = "SELECT A.date,SUM(A.hours) FROM (";
        $sql .= "SELECT date,hours FROM " . $tablePrefix . "tasks_time WHERE owner='$id' AND date>='$date_start' AND date<='$date_end'";
        $sql .= " UNION ALL ";
        $sql .= "SELECT date,hours FROM " . $tablePrefix . "meetings_time WHERE owner='$id' AND date>='$date_start' AND date<='$date_end'";
        $sql .= " UNION ALL ";
        $sql .= "SELECT date,hours FROM " . $tablePrefix . "work_hours WHERE owner='$id' AND date>='$date_start' AND date<='$date_end'";
        $sql .= ") A GROUP BY A.date";
        $this->query($sql);

        while ($this->fetch()) {
            $date = ($row[0]);
            $hours = ($row[1]);

            if (is_numeric($hours)) {
                $idx = date('Ymd', $date);
                $this->mem_hours[$idx] = round(floatval($hours), $hourAccuracy);
            }
        }
    }
    /**
     * get member time of a specific period
     * @global string $tablePrefix
     * @global array $row
     * @global int $hourAccuracy
     * @param int $id member id
     * @param int $date_start
     * @param int $date_end
     */
    function getMemberTimeOfPeriod($id, $date_start, $date_end)
    {
        global $tablePrefix, $row, $hourAccuracy;
        $rc = 0;
        $this->connectClass();
        $sql = "SELECT SUM(A.hours) FROM (";
        $sql .= "SELECT SUM(hours) AS hours FROM " . $tablePrefix . "tasks_time WHERE owner='$id' AND date>='$date_start' AND date<='$date_end'";
        $sql .= " UNION ALL ";
        $sql .= "SELECT SUM(hours) AS hours FROM " . $tablePrefix . "meetings_time WHERE owner='$id' AND date>='$date_start' AND date<='$date_end'";
        $sql .= " UNION ALL ";
        $sql .= "SELECT SUM(hours) AS hours FROM " . $tablePrefix . "work_hours WHERE owner='$id' AND date>='$date_start' AND date<='$date_end'";
        $sql .= ") A";
        $this->query($sql);

        while ($this->fetch()) {
            if (is_numeric($row[0])) {
                $rc += floatval($row[0]);
            }
        }

        $rc1 = round($rc, $hourAccuracy);
        return $rc1;
    }
    /**
     * get member billable time of a specific period
     * @global string $tablePrefix
     * @global array $row
     * @global int $hourAccuracy
     * @param int $id member id
     * @param int $date_start
     * @param int $date_end
     */
    function getMemberBillableTimeOfPeriod($id, $date_start, $date_end)
    {
        global $tablePrefix, $row, $hourAccuracy;
        $rc = 0;
        $this->connectClass();
        $sql = "SELECT SUM(A.hours) FROM (";
        $sql .= "SELECT SUM(hours) AS hours FROM " . $tablePrefix . "tasks_time WHERE owner='$id' AND date>='$date_start' AND date<='$date_end' AND billing='" . enumBoolean::bTrue . "'";
        $sql .= " UNION ALL ";
        $sql .= "SELECT SUM(hours) AS hours FROM " . $tablePrefix . "work_hours WHERE owner='$id' AND date>='$date_start' AND date<='$date_end' AND billing='" . enumBoolean::bTrue . "'";
        $sql .= ") A";
        $this->query($sql);

        while ($this->fetch()) {
            if (is_numeric($row[0])) {
                $rc += floatval($row[0]);
            }
        }

        $rc1 = round($rc, $hourAccuracy);
        return $rc1;
    }
    /**
     * get member leave time of month
     * @global string $tablePrefix
     * @global array $row
     * @global int $hourAccuracy
     * @param int $id member id
     * @param string $month1
     */
    function getMemberLeaveTimeOfMonth($id, $month1)
    {
        global $tablePrefix, $row, $hourAccuracy;
        $rc = 0;
        $this->connectClass();
        $sql = 'SELECT SUM(hours) FROM ' . $tablePrefix . "work_hours WHERE owner='$id' AND date LIKE '$month1%' AND work IN ('" . enumLeaveType::lvAnnual . "','" . enumLeaveType::lvSick . "','" . enumLeaveType::lvAbsence . "','" . enumLeaveType::lvBankHoliday . "','" . enumLeaveType::lvMourning . "','" . enumLeaveType::lvHoneyMoon . "','" . enumLeaveType::lvMaternity . "')";
        $this->query($sql);

        if ($this->fetch()) {
            $rc = floatval($row[0]);
        }

        $rc1 = round($rc, $hourAccuracy);
        return $rc1;
    }
    /**
     * get task time
     * @global string $tablePrefix
     * @global array $row
     * @global int $hourAccuracy
     * @param int $id task id
     */
    function getTaskTime($id)
    {
        global $tablePrefix, $row, $hourAccuracy;
        $this->connectClass();
        $sql = 'SELECT task_group FROM ' . $tablePrefix . "tasks WHERE id=$id";
        $this->query($sql);
        $val = $this->fetch();
        $rc = 0;
        $stack = array();

        if (!$val) {
            return 0;
        } else if ($val[0] == '1') {
            $sql = 'SELECT SUM(hours) FROM ' . $tablePrefix . "tasks_time WHERE task='$id'";
            $this->query($sql);
            $val = $this->fetch();

            if (!$val) {
                $rc = 0;
            } else {
                $rc0 = ($val[0]);
                $rc = (is_numeric($rc0))?round($rc0, $hourAccuracy):'0';
            }

            return $rc;
        } else {
            $stack[] = $id;
            $rc = 0;
        }

        while (count($stack)>0) {
            $id = array_pop($stack);
            $sql = 'SELECT id,task_group FROM ' . $tablePrefix . "tasks WHERE parent_task='$id'";
            $this->query($sql);
            $listIds = array();
            $listTaskGroups = array();

            while ($this->fetch()) {
                $listIds[] = ($row[0]);
                $listTaskGroups[] = ($row[1]);
            }

            for ($i=0; $i<count($listTaskGroups); $i++) {
                if ($listTaskGroups[$i]=='1') {
                    $sql = 'SELECT SUM(hours) FROM ' . $tablePrefix . "tasks_time WHERE task=" . $listIds[$i];
                    $this->query($sql);

                    if ($this->fetch()) {
                        if (is_numeric($row[0])) {
                            $rc += floatval($row[0]);
                        }
                    }
                } else {
                    array_push($stack,$listIds[$i]);
                }
            }
        }

        $rc1 = (is_numeric($rc))?round($rc, $hourAccuracy):'0';
        return $rc1;
    }
    /**
     * get project actual time
     * @global string $tablePrefix
     * @global array $row
     * @global int $hourAccuracy
     * @param int $id project id
     */
    function getProjectTime($id)
    {
        global $tablePrefix, $row, $hourAccuracy;
        $rc = 0;
        $this->connectClass();
        $sql = "SELECT SUM(A.hours) FROM (";
        $sql .= "SELECT SUM(tim.hours) AS hours FROM " . $tablePrefix . "tasks_time tim, " . $tablePrefix . "tasks tas WHERE tas.project='$id' AND tas.id=tim.task";
        $sql .= " UNION ALL ";
        $sql .= "SELECT SUM(mti.hours) AS hours FROM " . $tablePrefix . "meetings_time mti, " . $tablePrefix . "meetings mee WHERE mee.project='$id' AND mee.id=mti.meeting";
        $sql .= " UNION ALL ";
        $sql .= "SELECT SUM(wkh.hours) AS hours FROM " . $tablePrefix . "work_hours wkh WHERE wkh.project='$id'";
        $sql .= ") A";
        $this->query($sql);

        while ($this->fetch()) {
            if (is_numeric($row[0])) {
                $rc += floatval($row[0]);
            }
        }

        $rc1 = round($rc, $hourAccuracy);
        return $rc1;
    }
    /**
     * results hierarchy of tasks
     * @param string $querymore
     * @param string $sortingmore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openHierarchyOfTasks($querymore, $sortingmore = "", $start = "", $rows = "")
    {
        $rowCurr = 0;
        $stack = array();
        $stack[] = array('level' => '0', 'row' => '0', 'parent' => '0', 'wbs' => '');
        $this->tas_id = array();
        $this->tas_project = array();
        $this->tas_priority = array();
        $this->tas_status = array();
        $this->tas_owner = array();
        $this->tas_assigned_to = array();
        $this->tas_name = array();
        $this->tas_description = array();
        $this->tas_start_date = array();
        $this->tas_due_date = array();
        $this->tas_estimated_time = array();
        $this->tas_actual_time = array();
        $this->tas_comments = array();
        $this->tas_completion = array();
        $this->tas_created = array();
        $this->tas_modified = array();
        $this->tas_assigned = array();
        $this->tas_published = array();
        $this->tas_parent_phase = array();
        $this->tas_complete_date = array();
        $this->tas_service = array();
        $this->tas_fixed_duration = array();
        $this->tas_milestone = array();
        $this->tas_type = array();
        $this->tas_task_group = array();
        $this->tas_level = array();
        $this->tas_wbs = array();
        $this->tas_parent_task = array();
        $this->tas_subtask = array();
        $this->tas_support_request = array();
        $this->tas_mem2_name = array();
        $this->tas_mem2_login = array();
        $this->tas_mem2_email_work = array();
        $this->tas_mem2_profil = array();
        $this->tas_pro_name = array();
        $this->tas_org_id = array();
        $this->tas_sr_subject = array();

        if ($start == "") {
            $rowStart = "0";
        } else {
            $rowStart = $start;
        }

        if ($rows == "") {
            $rowEnd = -1;
        } else {
            $rowEnd = $rowStart + $rows;
        }

        while (count($stack) > 0) {
            $info = array_pop($stack);
            $level = $info['level'];
            $row = $info['row'];
            $parent = $info['parent'];
            $wbs = $info['wbs'];
            $tmpquery = $querymore . " AND tas.level='$level' AND tas.parent_task='$parent' " . $sortingmore;
            $listTask = new request();
            $listTask->openTasks($tmpquery, $row, "1");
            $comptListTask = count($listTask->tas_id);

            if ($comptListTask >= '1') {
                $info['level'] = $level;
                $info['row'] = $row + 1;
                $info['parent'] =  $parent;
                $info['wbs'] = $wbs;
                array_push($stack, $info);

                if ($level > 0) {
                    $wbs .= '.';
                }

                $wbs .= $info['row'];

                if ($rowCurr >= $rowStart) {
                    $this->tas_id[] = $listTask->tas_id[0];
                    $this->tas_project[] = $listTask->tas_project[0];
                    $this->tas_priority[] = $listTask->tas_priority[0];
                    $this->tas_status[] = $listTask->tas_status[0];
                    $this->tas_owner[] = $listTask->tas_owner[0];
                    $this->tas_assigned_to[] = $listTask->tas_assigned_to[0];
                    $this->tas_name[] = $listTask->tas_name[0];
                    $this->tas_description[] = $listTask->tas_description[0];
                    $this->tas_start_date[] = $listTask->tas_start_date[0];
                    $this->tas_due_date[] = $listTask->tas_due_date[0];
                    $this->tas_estimated_time[] = $listTask->tas_estimated_time[0];
                    $this->tas_actual_time[] = $listTask->tas_actual_time[0];
                    $this->tas_comments[] = $listTask->tas_comments[0];
                    $this->tas_completion[] = $listTask->tas_completion[0];
                    $this->tas_created[] = $listTask->tas_created[0];
                    $this->tas_modified[] = $listTask->tas_modified[0];
                    $this->tas_assigned[] = $listTask->tas_assigned[0];
                    $this->tas_published[] = $listTask->tas_published[0];
                    $this->tas_parent_phase[] = $listTask->tas_parent_phase[0];
                    $this->tas_complete_date[] = $listTask->tas_complete_date[0];
                    $this->tas_service[] = $listTask->tas_service[0];
                    $this->tas_fixed_duration[] = $listTask->tas_fixed_duration[0];
                    $this->tas_milestone[] = $listTask->tas_milestone[0];
                    $this->tas_type[] = $listTask->tas_type[0];
                    $this->tas_task_group[] = $listTask->tas_task_group[0];
                    $this->tas_level[] = $listTask->tas_level[0];
                    $this->tas_wbs[] = $wbs;
                    $this->tas_parent_task[] = $listTask->tas_parent_task[0];
                    $this->tas_subtask[] = $listTask->tas_subtask[0];
                    $this->tas_support_request[] = $listTask->tas_support_request[0];
                    $this->tas_mem2_name[] = $listTask->tas_mem2_name[0];
                    $this->tas_mem2_login[] = $listTask->tas_mem2_login[0];
                    $this->tas_mem2_email_work[] = $listTask->tas_mem2_email_work[0];
                    $this->tas_mem2_profil[] = $listTask->tas_mem2_profil[0];
                    $this->tas_pro_name[] = $listTask->tas_pro_name[0];
                    $this->tas_org_id[] = $listTask->tas_org_id[0];
                    $this->tas_sr_subject[] = $listTask->tas_sr_subject[0];
                }

                $rowCurr++;

                if ($listTask->tas_task_group[0] == '0') {
                    $info['level'] = $level + 1;
                    $info['row'] = 0;
                    $info['parent'] = $listTask->tas_id[0];
                    $info['wbs'] = $wbs;
                    array_push($stack, $info);
                }

                if ($rowEnd >= 0 && $rowCurr >= $rowEnd) {
                    break;
                }
            }
        }
    }
    /**
     * results project permissions
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openProjectPermissions($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["project_permissions"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->prp_id = array();
        $this->prp_project = array();
        $this->prp_profil = array();
        $this->prp_view_project = array();
        $this->prp_create_customer_service_site = array();
        $this->prp_copy_project = array();
        $this->prp_import_project = array();
        $this->prp_export_project = array();
        $this->prp_modify_project_properties = array();
        $this->prp_delete_project = array();
        $this->prp_view_project_budget = array();
        $this->prp_view_project_cost = array();
        $this->prp_view_phase = array();
        $this->prp_modify_phase_properties = array();
        $this->prp_view_task = array();
        $this->prp_create_task = array();
        $this->prp_copy_task = array();
        $this->prp_modify_task_status = array();
        $this->prp_log_task_hours = array();
        $this->prp_material_issue = array();
        $this->prp_arrange_task_resource = array();
        $this->prp_modify_task_properties = array();
        $this->prp_edit_task_relationships = array();
        $this->prp_delete_task = array();
        $this->prp_configure_task_security = array();
        $this->prp_publish_task = array();
        $this->prp_view_milestone = array();
        $this->prp_create_milestone = array();
        $this->prp_modify_milestone_properties = array();
        $this->prp_delete_milestone = array();
        $this->prp_configure_milestone_security = array();
        $this->prp_publish_milestone = array();
        $this->prp_view_meeting = array();
        $this->prp_create_meeting = array();
        $this->prp_copy_meeting = array();
        $this->prp_modify_meeting_status = array();
        $this->prp_log_meeting_hours = array();
        $this->prp_arrange_meeting_resource = array();
        $this->prp_modify_meeting_properties = array();
        $this->prp_delete_meeting = array();
        $this->prp_configure_meeting_security = array();
        $this->prp_view_support_request = array();
        $this->prp_add_support_response = array();
        $this->prp_assign_support_request = array();
        $this->prp_close_support_request = array();
        $this->prp_delete_support_request = array();
        $this->prp_view_discussion = array();
        $this->prp_add_discussion_topic = array();
        $this->prp_post_reply = array();
        $this->prp_close_discussion_topic = array();
        $this->prp_publish_discussion_topic = array();
        $this->prp_delete_discussion_topic = array();
        $this->prp_view_team = array();
        $this->prp_send_message = array();
        $this->prp_add_team_member = array();
        $this->prp_publish_team_member = array();
        $this->prp_modify_team_member_properties = array();
        $this->prp_delete_team_member = array();
        $this->prp_view_file = array();
        $this->prp_add_file = array();
        $this->prp_update_file = array();
        $this->prp_publish_file = array();
        $this->prp_delete_file = array();
        $this->prp_view_note = array();
        $this->prp_add_note = array();
        $this->prp_modify_note_properties = array();
        $this->prp_delete_note = array();
        $this->prp_publish_note = array();
        $this->prp_view_calendar = array();
        $this->prp_add_calendar_event = array();
        $this->prp_modify_calendar_event = array();
        $this->prp_delete_calendar_event = array();
        $this->prp_view_role = array();
        $this->prp_configure_role_security = array();
        $this->prp_view_expense = array();
        $this->prp_create_expense = array();
        $this->prp_modify_expense_properties = array();
        $this->prp_delete_expense = array();

        while ($this->fetch()) {
            $i = 0;
            $this->prp_id[] = ($row[$i++]);
            $this->prp_project[] = ($row[$i++]);
            $this->prp_profil[] = ($row[$i++]);
            $this->prp_view_project[] = ($row[$i++]);
            $this->prp_create_customer_service_site[] = ($row[$i++]);
            $this->prp_copy_project[] = ($row[$i++]);
            $this->prp_import_project[] = ($row[$i++]);
            $this->prp_export_project[] = ($row[$i++]);
            $this->prp_modify_project_properties[] = ($row[$i++]);
            $this->prp_delete_project[] = ($row[$i++]);
            $this->prp_view_project_budget[] = ($row[$i++]);
            $this->prp_view_project_cost[] = ($row[$i++]);
            $this->prp_view_phase[] = ($row[$i++]);
            $this->prp_modify_phase_properties[] = ($row[$i++]);
            $this->prp_view_task[] = ($row[$i++]);
            $this->prp_create_task[] = ($row[$i++]);
            $this->prp_copy_task[] = ($row[$i++]);
            $this->prp_modify_task_status[] = ($row[$i++]);
            $this->prp_log_task_hours[] = ($row[$i++]);
            $this->prp_material_issue[] = ($row[$i++]);
            $this->prp_arrange_task_resource[] = ($row[$i++]);
            $this->prp_modify_task_properties[] = ($row[$i++]);
            $this->prp_edit_task_relationships[] = ($row[$i++]);
            $this->prp_delete_task[] = ($row[$i++]);
            $this->prp_configure_task_security[] = ($row[$i++]);
            $this->prp_publish_task[] = ($row[$i++]);
            $this->prp_view_milestone[] = ($row[$i++]);
            $this->prp_create_milestone[] = ($row[$i++]);
            $this->prp_modify_milestone_properties[] = ($row[$i++]);
            $this->prp_delete_milestone[] = ($row[$i++]);
            $this->prp_configure_milestone_security[] = ($row[$i++]);
            $this->prp_publish_milestone[] = ($row[$i++]);
            $this->prp_view_meeting[] = ($row[$i++]);
            $this->prp_create_meeting[] = ($row[$i++]);
            $this->prp_copy_meeting[] = ($row[$i++]);
            $this->prp_modify_meeting_status[] = ($row[$i++]);
            $this->prp_log_meeting_hours[] = ($row[$i++]);
            $this->prp_arrange_meeting_resource[] = ($row[$i++]);
            $this->prp_modify_meeting_properties[] = ($row[$i++]);
            $this->prp_delete_meeting[] = ($row[$i++]);
            $this->prp_configure_meeting_security[] = ($row[$i++]);
            $this->prp_view_support_request[] = ($row[$i++]);
            $this->prp_add_support_response[] = ($row[$i++]);
            $this->prp_assign_support_request[] = ($row[$i++]);
            $this->prp_close_support_request[] = ($row[$i++]);
            $this->prp_delete_support_request[] = ($row[$i++]);
            $this->prp_view_discussion[] = ($row[$i++]);
            $this->prp_add_discussion_topic[] = ($row[$i++]);
            $this->prp_post_reply[] = ($row[$i++]);
            $this->prp_close_discussion_topic[] = ($row[$i++]);
            $this->prp_publish_discussion_topic[] = ($row[$i++]);
            $this->prp_delete_discussion_topic[] = ($row[$i++]);
            $this->prp_view_team[] = ($row[$i++]);
            $this->prp_send_message[] = ($row[$i++]);
            $this->prp_add_team_member[] = ($row[$i++]);
            $this->prp_publish_team_member[] = ($row[$i++]);
            $this->prp_modify_team_member_properties[] = ($row[$i++]);
            $this->prp_delete_team_member[] = ($row[$i++]);
            $this->prp_view_file[] = ($row[$i++]);
            $this->prp_add_file[] = ($row[$i++]);
            $this->prp_update_file[] = ($row[$i++]);
            $this->prp_publish_file[] = ($row[$i++]);
            $this->prp_delete_file[] = ($row[$i++]);
            $this->prp_view_note[] = ($row[$i++]);
            $this->prp_add_note[] = ($row[$i++]);
            $this->prp_modify_note_properties[] = ($row[$i++]);
            $this->prp_delete_note[] = ($row[$i++]);
            $this->prp_publish_note[] = ($row[$i++]);
            $this->prp_view_calendar[] = ($row[$i++]);
            $this->prp_add_calendar_event[] = ($row[$i++]);
            $this->prp_modify_calendar_event[] = ($row[$i++]);
            $this->prp_delete_calendar_event[] = ($row[$i++]);
            $this->prp_view_role[] = ($row[$i++]);
            $this->prp_configure_role_security[] = ($row[$i++]);
            $this->prp_view_expense[] = ($row[$i++]);
            $this->prp_create_expense[] = ($row[$i++]);
            $this->prp_modify_expense_properties[] = ($row[$i++]);
            $this->prp_delete_expense[] = ($row[$i++]);
        }
    }
    /**
     * results claim_type
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openClaimType($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["claim_type"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->clt_id = array();           // claim type id
        $this->clt_name = array();         // claim type name
        $this->clt_name_print = array();   // claim type name print
        $this->clt_locked = array();       // claim type locked
        $this->clt_created = array();      // create timestamp of claim type
        $this->clt_cuser = array();        // create user id of claim type
        $this->clt_modified = array();     // modify timestamp of claim type
        $this->clt_muser = array();        // modify user id of claim type

        while ($this->fetch()) {
            $i = 0;
            $this->clt_id[] = ($row[$i++]);
            $n = ($row[$i++]);
            $this->clt_name[] = $n;
            $this->clt_name_print[] = ((isset($strings['CLT__' . $n]))?$strings['CLT__' . $n]:$n);
            $this->clt_locked[] = ($row[$i++]);
            $this->clt_created[] = ($row[$i++]);
            $this->clt_cuser[] = ($row[$i++]);
            $this->clt_modified[] = ($row[$i++]);
            $this->clt_muser[] = ($row[$i++]);
        }
    }
    /**
     * results expense_type
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openExpenseType($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["expense_type"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->ext_id = array();           // expense type id
        $this->ext_name = array();         // expense type name
        $this->ext_name_print = array();   // expense type name print
        $this->ext_claimtype = array();    // claim type id of expense type
        $this->ext_locked = array();       // expense type locked
        $this->ext_created = array();      // create timestamp of expense type
        $this->ext_cuser = array();        // create user id of expense type
        $this->ext_modified = array();     // modify timestamp of expense type
        $this->ext_muser = array();        // modify user id of expense type
        $this->ext_clt_name = array();     // claim type name
        $this->ext_clt_name_print = array();   // claim type name print

        while ($this->fetch()) {
            $i = 0;
            $this->ext_id[] = ($row[$i++]);
            $n = ($row[$i++]);
            $this->ext_name[] = $n;
            $this->ext_name_print[] = ((isset($strings['EXT__' . $n]))?$strings['EXT__' . $n]:$n);
            $this->ext_claimtype[] = ($row[$i++]);
            $this->ext_locked[] = ($row[$i++]);
            $this->ext_created[] = ($row[$i++]);
            $this->ext_cuser[] = ($row[$i++]);
            $this->ext_modified[] = ($row[$i++]);
            $this->ext_muser[] = ($row[$i++]);
            $m = ($row[$i++]);
            $this->ext_clt_name[] = $m;
            $this->ext_clt_name_print[] = (isset($strings['CLT__' . $m])?$strings['CLT__' . $m]:$m);
        }
    }
    /**
     * results expenses
     * @global array $row
     * @global array $initrequest
     * @global int $costAccuracy
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openExpenses($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $costAccuracy, $strings;
        $this->connectClass();
        $sql = $initrequest["expenses"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->exp_id = array();
        $this->exp_project = array();
        $this->exp_status = array();
        $this->exp_status_approval = array();
        $this->exp_printed = array();
        $this->exp_owner = array();                // the id of owner
        $this->exp_description = array();          // description
        $this->exp_docdate = array();              // expense date
        $this->exp_billable = array();             // billable expense
        $this->exp_claimtype = array();            // the id of claim type
        $this->exp_expensetype = array();          // the id of expense type
        $this->exp_amount = array();               // the amount of expense
        $this->exp_currency = array();             // expense currency
        $this->exp_recurring = array();            // recurring expense template
        $this->exp_recurring_start = array();      // recurring start date (unix timestamp)
        $this->exp_recurring_finish = array();     // recurring finish date (unix timestamp)
        $this->exp_recurring_next = array();       // recurring next date (unix timestamp)
        $this->exp_recurring_type = array();       // recurring type
        $this->exp_recurring_frequency = array();  // recurring frequency
        $this->exp_recurring_enabled = array();    // recurring expense template enabled
        $this->exp_created = array();
        $this->exp_cuser = array();
        $this->exp_modified = array();
        $this->exp_muser = array();
        $this->exp_mem_name = array();
        $this->exp_mem_login = array();
        $this->exp_mem_email_work = array();
        $this->exp_pro_name = array();
        $this->exp_org_id = array();
        $this->exp_org_name = array();
        $this->exp_clt_name = array();
        $this->exp_clt_name_print = array();
        $this->exp_ext_name = array();
        $this->exp_ext_name_print = array();

        while ($this->fetch()) {
            $i = 0;
            $this->exp_id[] = ($row[$i++]);
            $this->exp_project[] = ($row[$i++]);
            $this->exp_status[] = ($row[$i++]);
            $this->exp_status_approval[] = ($row[$i++]);
            $this->exp_printed[] = ($row[$i++]);
            $this->exp_owner[] = ($row[$i++]);
            $this->exp_description[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->exp_docdate[] = ($row[$i++]);
            $this->exp_billable[] = ($row[$i++]);
            $this->exp_claimtype[] = ($row[$i++]);
            $this->exp_expensetype[] = ($row[$i++]);
            $amt = ($row[$i++]);
            $amount = (is_numeric($amt))?round($amt, $costAccuracy):'0';
            $this->exp_amount[] = $amount;
            $this->exp_currency[] = trim($row[$i++]);
            $this->exp_recurring[] = ($row[$i++]);            // recurring expense template
            $this->exp_recurring_start[] = ($row[$i++]);      // recurring start date (unix timestamp)
            $this->exp_recurring_finish[] = ($row[$i++]);     // recurring finish date (unix timestamp)
            $this->exp_recurring_next[] = ($row[$i++]);       // recurring next date (unix timestamp)
            $this->exp_recurring_type[] = ($row[$i++]);       // recurring type
            $this->exp_recurring_frequency[] = ($row[$i++]);  // recurring frequency
            $this->exp_recurring_enabled[] = ($row[$i++]);    // recurring expense template enabled
            $this->exp_created[] = ($row[$i++]);
            $this->exp_cuser[] = ($row[$i++]);
            $this->exp_modified[] = ($row[$i++]);
            $this->exp_muser[] = ($row[$i++]);
            $this->exp_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->exp_mem_login[] = ($row[$i++]);
            $this->exp_mem_email_work[] = ($row[$i++]);
            $this->exp_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->exp_org_id[] = ($row[$i++]);
            $this->exp_org_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $clt = ($row[$i++]);
            $this->exp_clt_name[] = $clt;
            $this->exp_clt_name_print[] = ((isset($strings['CLT__' . $clt]))?$strings['CLT__' . $clt]:$clt);
            $ext = ($row[$i++]);
            $this->exp_ext_name[] = $ext;
            $this->exp_ext_name_print[] = ((isset($strings['EXT__' . $ext]))?$strings['EXT__' . $ext]:$ext);
        }
    }
    /**
     * results confirmation levels
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openConfirmationLevels($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["confirmation_levels"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->con_id = array();
        $this->con_name = array();
        $this->con_comments = array();
        $this->con_max_requirements = array();

        while ($this->fetch()) {
            $i = 0;
            $this->con_id[] = ($row[$i++]);
            $this->con_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->con_max_requirements[] = ($row[$i++]);
        }
    }
    /**
     * results confirmation levels - detail
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openConfirmationLevelsDetail($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["confirmation_levels_detail"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->cld_confirmation_level = array();
        $this->cld_authorizer_type = array();
        $this->cld_authorizer = array();
        $this->cld_required = array();
        $this->cld_con_name = array();
        $this->cld_con_comments = array();
        $this->cld_con_max_requirements = array();

        while ($this->fetch()) {
            $i = 0;
            $this->cld_confirmation_level[] = ($row[$i++]);
            $this->cld_authorizer_type[] = ($row[$i++]);
            $this->cld_authorizer[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->cld_required[] = ($row[$i++]);
            $this->cld_con_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->cld_con_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->cld_con_max_requirements[] = ($row[$i++]);
        }
    }
    /**
     * results approvals
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openApprovals($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["approvals"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->app_id = array();
        $this->app_name = array();
        $this->app_doctype = array();
        $this->app_conditions = array();
        $this->app_active = array();
        $this->app_comments = array();
        $this->app_userquery = array();

        while ($this->fetch()) {
            $i = 0;
            $this->app_id[] = ($row[$i++]);
            $this->app_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->app_doctype[] = ($row[$i++]);
            $this->app_conditions[] = ($row[$i++]);
            $this->app_active[] = ($row[$i++]);
            $this->app_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->app_userquery[] = HtmlEntityDecodeNOD($row[$i++]);
        }
    }
    /**
     * results approvals1
     * @global array $row
     * @global array $initrequest
     * @param int $producer
     * @param mixed $doctype
     */
    function openApprovals1($producer, $doctype)
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql0 = $initrequest["approvals1"];
        $sql1 = str_replace('%producer%', $producer, $sql0);
        $sql = str_replace('%doctype%', $doctype, $sql1);
        $this->query($sql);
        $this->app_id = array();
        $this->app_conditions = array();
        $this->app_userquery = array();

        while ($this->fetch()) {
            $i = 0;
            $this->app_id[] = ($row[$i++]);
            $this->app_conditions[] = ($row[$i++]);
            $this->app_userquery[] = HtmlEntityDecodeNOD($row[$i++]);
        }
    }
    /**
     * results approvals producers
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openApprovalsProducers($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["approvals_producers"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->apd_approval = array();
        $this->apd_producer_type = array();
        $this->apd_producer = array();
        $this->apd_exclude = array();
        $this->apd_producer_name = array();
        $this->apd_app_name = array();
        $this->apd_app_doctype = array();
        $this->apd_app_conditions = array();
        $this->apd_app_active = array();

        while ($this->fetch()) {
            $i = 0;
            $this->apd_approval[] = ($row[$i++]);
            $this->apd_producer_type[] = ($row[$i++]);
            $this->apd_producer[] = ($row[$i++]);
            $this->apd_exclude[] = ($row[$i++]);
            $this->apd_producer_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->apd_app_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->apd_app_doctype[] = ($row[$i++]);
            $this->apd_app_conditions[] = ($row[$i++]);
            $this->apd_app_active[] = ($row[$i++]);
        }
    }
    /**
     * results approvals stages
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openApprovalsStages($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["approvals_stages"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->aps_approval = array();
        $this->aps_confirmation_level = array();
        $this->aps_sortid = array();
        $this->aps_con_name = array();
        $this->aps_con_max_requirements = array();

        while ($this->fetch()) {
            $i = 0;
            $this->aps_approval[] = ($row[$i++]);
            $this->aps_confirmation_level[] = ($row[$i++]);
            $this->aps_sortid[] = ($row[$i++]);
            $this->aps_con_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->aps_con_max_requirements[] = ($row[$i++]);
        }
    }
    /**
     * results approvals terms
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openApprovalsTerms($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["approvals_terms"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->apt_id = array();
        $this->apt_approval = array();
        $this->apt_fieldname = array();
        $this->apt_ratio = array();
        $this->apt_value = array();
        $this->apt_compare_fields = array();

        while ($this->fetch()) {
            $i = 0;
            $this->apt_id[] = ($row[$i++]);
            $this->apt_approval[] = ($row[$i++]);
            $fldnam = ($row[$i++]);
            $this->apt_fieldname[] = $fldnam;
            $this->apt_ratio[] = ($row[$i++]);
            $value = ($row[$i++]);
            $compare_fields = ($row[$i++]);

            if ($compare_fields == 'Y') {
                $this->apt_value[] = $value;
            } else {
                $this->apt_value[] = HtmlEntityDecodeNOD($value);
            }

            $this->apt_compare_fields[] = $compare_fields;
        }
    }
    /**
     * results document approval authorizers
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openDocumentsApprovalAuthorizers($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["documents_approval_authorizers"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->daa_document_approval = array();
        $this->daa_confirmation_level = array();
        $this->daa_authorizer = array();
        $this->daa_required = array();
        $this->daa_stage = array();
        $this->daa_status = array();
        $this->daa_approve_string = array();
        $this->daa_not_approve_string = array();
        $this->daa_string_validto = array();
        $this->daa_comments = array();
        $this->daa_created = array();
        $this->daa_cuser = array();
        $this->daa_modified = array();
        $this->daa_muser = array();
        $this->daa_dap_approval = array();
        $this->daa_dap_owner = array();
        $this->daa_dap_doctype = array();
        $this->daa_dap_current_stage = array();
        $this->daa_dap_status = array();
        $this->daa_dap_canceled = array();
        $this->daa_dap_closed = array();
        $this->daa_dap_comments = array();
        $this->daa_dap_created = array();
        $this->daa_mem_name = array();
        $this->daa_mem_email_work = array();
        $this->daa_mem_language = array();
        $this->daa_mem2_name = array();
        $this->daa_mem2_extension_picture = array();
        $this->daa_mem2_gender = array();
        $this->daa_loc_timezone = array();

        while ($this->fetch()) {
            $i = 0;
            $this->daa_document_approval[] = ($row[$i++]);
            $this->daa_confirmation_level[] = ($row[$i++]);
            $this->daa_authorizer[] = ($row[$i++]);
            $this->daa_required[] = ($row[$i++]);
            $this->daa_stage[] = ($row[$i++]);
            $this->daa_status[] = ($row[$i++]);
            $this->daa_approve_string[] = ($row[$i++]);
            $this->daa_not_approve_string[] = ($row[$i++]);
            $this->daa_string_validto[] = ($row[$i++]);
            $this->daa_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->daa_created[] = ($row[$i++]);
            $this->daa_cuser[] = ($row[$i++]);
            $this->daa_modified[] = ($row[$i++]);
            $this->daa_muser[] = ($row[$i++]);
            $this->daa_dap_approval[] = ($row[$i++]);
            $this->daa_dap_owner[] = ($row[$i++]);
            $this->daa_dap_doctype[] = ($row[$i++]);
            $this->daa_dap_current_stage[] = ($row[$i++]);
            $this->daa_dap_status[] = ($row[$i++]);
            $this->daa_dap_canceled[] = ($row[$i++]);
            $this->daa_dap_closed[] = ($row[$i++]);
            $this->daa_dap_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->daa_dap_created[] = ($row[$i++]);
            $this->daa_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->daa_mem_email_work[] = ($row[$i++]);
            $this->daa_mem_language[] = ($row[$i++]);
            $this->daa_mem2_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->daa_mem2_extension_picture[] = ($row[$i++]);
            $this->daa_mem2_gender[] = ($row[$i++]);
            $this->daa_loc_timezone[] = ($row[$i++]);
        }
    }
    /**
     * results documents approval
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openDocumentsApproval($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["documents_approval"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->dap_id = array();
        $this->dap_approval = array();
        $this->dap_owner = array();
        $this->dap_docid = array();
        $this->dap_doctype = array();
        $this->dap_docdate = array();
        $this->dap_current_stage = array();
        $this->dap_status = array();
        $this->dap_canceled = array();
        $this->dap_closed = array();
        $this->dap_comments = array();
        $this->dap_userquery = array();
        $this->dap_created = array();
        $this->dap_cuser = array();
        $this->dap_modified = array();
        $this->dap_muser = array();
        $this->dap_mem_name = array();
        $this->dap_mem_email_work = array();
        $this->dap_aps_confirmation_level = array();
        $this->dap_con_name = array();
        $this->dap_con_max_requirements = array();

        while ($this->fetch()) {
            $i = 0;
            $this->dap_id[] = ($row[$i++]);
            $this->dap_approval[] = ($row[$i++]);
            $this->dap_owner[] = ($row[$i++]);
            $this->dap_docid[] = ($row[$i++]);
            $this->dap_doctype[] = ($row[$i++]);
            $this->dap_docdate[] = ($row[$i++]);
            $this->dap_current_stage[] = ($row[$i++]);
            $this->dap_status[] = ($row[$i++]);
            $this->dap_canceled[] = ($row[$i++]);
            $this->dap_closed[] = ($row[$i++]);
            $this->dap_comments[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->dap_userquery[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->dap_created[] = ($row[$i++]);
            $this->dap_cuser[] = ($row[$i++]);
            $this->dap_modified[] = ($row[$i++]);
            $this->dap_muser[] = ($row[$i++]);
            $this->dap_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->dap_mem_email_work[] = ($row[$i++]);
            $this->dap_aps_confirmation_level[] = ($row[$i++]);
            $this->dap_con_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->dap_con_max_requirements[] = ($row[$i++]);
        }
    }
    /**
     * results periods
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openPeriods($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["periods"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->per_id = array();
        $this->per_fyear = array();
        $this->per_serial_no = array();
        $this->per_date_start = array();
        $this->per_date_end = array();
        $this->per_locked = array();
        $this->per_created = array();
        $this->per_cuser = array();
        $this->per_modified = array();
        $this->per_muser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->per_id[] = ($row[$i++]);
            $this->per_fyear[] = ($row[$i++]);
            $this->per_serial_no[] = ($row[$i++]);
            $this->per_date_start[] = ($row[$i++]);
            $this->per_date_end[] = ($row[$i++]);
            $this->per_locked[] = ($row[$i++]);
            $this->per_created[] = ($row[$i++]);
            $this->per_cuser[] = ($row[$i++]);
            $this->per_modified[] = ($row[$i++]);
            $this->per_muser[] = ($row[$i++]);
        }
    }
    /**
     * results currency exchange rates
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openCurrencyRates($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["currency_rates"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->cur_currency_from = array();
        $this->cur_currency_to = array();
        $this->cur_reference_date = array();
        $this->cur_exchange_rate = array();
        $this->cur_created = array();
        $this->cur_cuser = array();
        $this->cur_modified = array();
        $this->cur_muser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->cur_currency_from[] = trim($row[$i++]);
            $this->cur_currency_to[] = trim($row[$i++]);
            $this->cur_reference_date[] = ($row[$i++]);
            $this->cur_exchange_rate[] = ($row[$i++]);
            $this->cur_created[] = ($row[$i++]);
            $this->cur_cuser[] = ($row[$i++]);
            $this->cur_modified[] = ($row[$i++]);
            $this->cur_muser[] = ($row[$i++]);
        }
    }
    /**
     * results project folder size
     * @global array $row
     * @global string $tablePrefix
     * @global string $db_cast_int
     * @param int $id project id
     */
    function openProjectFolderSize($id)
    {
        global $row, $tablePrefix, $db_cast_int;
        $this->connectClass();
        $sql = "SELECT SUM(CAST(fil.size AS $db_cast_int)) FROM (
SELECT f01.size FROM " . $tablePrefix . "files f01
WHERE f01.doc_type='" . enumFileRelatedDocumentType::dtProject . "' AND f01.doc_id='$id' AND f01.dir='" . enumBoolean::bFalse . "'
UNION ALL
SELECT f02.size FROM " . $tablePrefix . "files f02
INNER JOIN " . $tablePrefix . "phases pha ON pha.id=f02.doc_id
WHERE f02.doc_type='" . enumFileRelatedDocumentType::dtPhase . "' AND f02.dir='" . enumBoolean::bFalse . "' AND pha.project='$id'
UNION ALL
SELECT f03.size FROM " . $tablePrefix . "files f03
INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=f03.doc_id
WHERE f03.doc_type='" . enumFileRelatedDocumentType::dtTask . "' AND f03.dir='" . enumBoolean::bFalse . "' AND tas.project='$id'
UNION ALL
SELECT f04.size FROM " . $tablePrefix . "files f04
INNER JOIN " . $tablePrefix . "meetings mee ON mee.id=f04.doc_id
WHERE f04.doc_type='" . enumFileRelatedDocumentType::dtMeeting . "' AND f04.dir='" . enumBoolean::bFalse . "' AND mee.project='$id'
UNION ALL
SELECT f05.size FROM " . $tablePrefix . "files f05
INNER JOIN " . $tablePrefix . "posts pos ON pos.id=f05.doc_id
INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic
WHERE f05.doc_type='" . enumFileRelatedDocumentType::dtDiscussion . "' AND f05.dir='" . enumBoolean::bFalse . "' AND topic.project='$id'
UNION ALL
SELECT f06.size FROM " . $tablePrefix . "files f06
INNER JOIN " . $tablePrefix . "notes note ON note.id=f06.doc_id
WHERE f06.doc_type='" . enumFileRelatedDocumentType::dtNote . "' AND f06.dir='" . enumBoolean::bFalse . "' AND note.project='$id'
UNION ALL
SELECT f07.size FROM " . $tablePrefix . "files f07
INNER JOIN " . $tablePrefix . "expenses exp ON exp.id=f07.doc_id
WHERE f07.doc_type='" . enumFileRelatedDocumentType::dtExpense . "' AND f07.dir='" . enumBoolean::bFalse . "' AND exp.project='$id'
UNION ALL
SELECT f08.size FROM " . $tablePrefix . "files f08
INNER JOIN " . $tablePrefix . "support_requests req ON req.id=f08.doc_id
WHERE f08.doc_type='" . enumFileRelatedDocumentType::dtSupportRequest . "' AND f08.dir='" . enumBoolean::bFalse . "' AND req.project='$id'
UNION ALL
SELECT f09.size FROM " . $tablePrefix . "files f09
INNER JOIN " . $tablePrefix . "support_posts pos ON pos.id=f09.doc_id
INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id
WHERE f09.doc_type='" . enumFileRelatedDocumentType::dtSupportPost . "' AND f09.dir='" . enumBoolean::bFalse . "' AND req.project='$id'
) fil";
        $this->query($sql);

        if ($this->fetch()) {
            $this->project_folder_size = ($row[0]);
        } else {
            $this->project_folder_size = 0;
        }
    }
    /**
     * results tables definitions
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTablesDefinitions($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["tables_def"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->tdf_id = array();
        $this->tdf_tablename = array();        // table name
        $this->tdf_sysdef = array();           // system-defined table
        $this->tdf_cfenabled = array();        // custom fields enabled
        $this->tdf_searchable = array();       // searchable table
        $this->tdf_printable = array();        // printable table
        $this->tdf_mainmenu = array();         // create main menu item
        $this->tdf_keyfields = array();
        $this->tdf_formfields = array();       // Field(s) Shown in the Form List
        $this->tdf_dispfields = array();       // Field(s) Shown in Search Results
        $this->tdf_dispstyle = array();        // Display Style
        $this->tdf_listfields = array();       // Field(s) Shown in the Choose List
        $this->tdf_primfields = array();       // Primary Search Fields
        $this->tdf_fathertable = array();
        $this->tdf_linkedfield = array();
        $this->tdf_approvalenabled = array();  // enable approvals
        $this->tdf_publishenabled = array();   // enable publish
        $this->tdf_javascript = array();       // javascript file path
        $this->tdf_projectrelated = array();   // project-related table
        $this->tdf_history = array();          // history table exists
        $this->tdf_viewurl = array();          // custom view url
        $this->tdf_created = array();          // creation timestamp
        $this->tdf_cuser = array();            // creation user id
        $this->tdf_modified = array();         // last modification timestamp
        $this->tdf_muser = array();            // last modification user id
        $this->tdf_dbtablename = array();

        while ($this->fetch()) {
            $i = 0;
            $this->tdf_id[] = ($row[$i++]);
            $tblnam = ($row[$i++]);
            $this->tdf_tablename[] = $tblnam;               // table name
            $sysdef = ($row[$i++]);
            $this->tdf_sysdef[] = $sysdef;                  // system-defined table
            $this->tdf_cfenabled[] = ($row[$i++]);          // custom fields enabled
            $this->tdf_searchable[] = ($row[$i++]);         // searchable table
            $this->tdf_printable[] = ($row[$i++]);          // printable table
            $this->tdf_mainmenu[] = ($row[$i++]);           // create main menu item
            $this->tdf_keyfields[] = ($row[$i++]);
            $this->tdf_formfields[] = ($row[$i++]);         // Field(s) Shown in the Form List
            $this->tdf_dispfields[] = ($row[$i++]);         // Field(s) Shown in Search Results
            $this->tdf_dispstyle[] = ($row[$i++]);          // Display Style
            $this->tdf_listfields[] = ($row[$i++]);         // Field(s) Shown in the Choose List
            $this->tdf_primfields[] = ($row[$i++]);         // Primary Search Fields
            $this->tdf_fathertable[] = ($row[$i++]);
            $this->tdf_linkedfield[] = ($row[$i++]);
            $this->tdf_approvalenabled[] = ($row[$i++]);    // enable approvals
            $this->tdf_publishenabled[] = ($row[$i++]);     // enable publish
            $this->tdf_javascript[] = HtmlEntityDecodeNOD($row[$i++]);  // javascript file path
            $this->tdf_projectrelated[] = ($row[$i++]);     // project-related table
            $this->tdf_history[] = ($row[$i++]);            // history table exists
            $this->tdf_viewurl[] = HtmlEntityDecodeNOD($row[$i++]); // custom view url
            $this->tdf_created[] = ($row[$i++]);            // creation timestamp
            $this->tdf_cuser[] = ($row[$i++]);              // creation user id
            $this->tdf_modified[] = ($row[$i++]);           // last modification timestamp
            $this->tdf_muser[] = ($row[$i++]);              // last modification user id

            if ($sysdef == 'Y') {
                $this->tdf_dbtablename[] = $tblnam;
            } else {
                $this->tdf_dbtablename[] = preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam);
            }
        }
    }
    /**
     * results fields definitions
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openFieldsDefinitions($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["fields_def"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->fdf_tablename = array();        // table name
        $this->fdf_fieldname = array();        // field name
        $this->fdf_fielddesc = array();        // field description
        $this->fdf_fieldtype = array();        // field type
        $this->fdf_length = array();           // field length
        $this->fdf_default_value = array();    // default value
        $this->fdf_required = array();         // mandatory field
        $this->fdf_unique_field = array();     // create unique index on this field
        $this->fdf_create_index = array();     // create index on this field
        $this->fdf_sysdef = array();           // system defined field
        $this->fdf_published = array();        // publish
        $this->fdf_linkedtable = array();      // linked table name
        $this->fdf_disporder = array();        // field display order
        $this->fdf_tdf_sysdef = array();       // system defined table
        $this->fdf_tdf_fathertable = array();  // parent table name
        $this->fdf_tdf_history = array();      // history table exists
        $this->fdf_tdf_viewurl = array();      // custom view url
        $this->fdf_dbfieldname = array();      // database field name
        $this->fdf_dbtablename = array();      // database table name
        $this->fdf_dblinkedtable = array();    // database linked table name

        while ($this->fetch()) {
            $i = 0;
            $tblnam = ($row[$i++]);
            $fldnam = ($row[$i++]);
            $this->fdf_tablename[] = $tblnam;
            $this->fdf_fieldname[] = $fldnam;
            $this->fdf_fielddesc[] = fieldNameString($tblnam, $fldnam);
            $this->fdf_fieldtype[] = ($row[$i++]);
            $this->fdf_length[] = ($row[$i++]);
            $this->fdf_default_value[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fdf_required[] = ($row[$i++]);
            $this->fdf_unique_field[] = ($row[$i++]);
            $this->fdf_create_index[] = ($row[$i++]);
            $sysdef = ($row[$i++]);
            $this->fdf_sysdef[] = $sysdef;
            $this->fdf_published[] = ($row[$i++]);
            $lnktbl = ($row[$i++]);
            $this->fdf_linkedtable[] = $lnktbl;
            $this->fdf_disporder[] = ($row[$i++]);
            $tdf_sysdef = ($row[$i++]);
            $this->fdf_tdf_sysdef[] = $tdf_sysdef;
            $this->fdf_tdf_fathertable[] = ($row[$i++]);
            $this->fdf_tdf_history[] = ($row[$i++]);
            $this->fdf_tdf_viewurl[] = HtmlEntityDecodeNOD($row[$i++]);
            $tdf1_sysdef = ($row[$i++]);

            if ($sysdef == 'Y') {
                $this->fdf_dbfieldname[] = $fldnam;
            } else {
                $this->fdf_dbfieldname[] = 'U_' . $fldnam;
            }

            if ($tdf_sysdef == 'Y') {
                $this->fdf_dbtablename[] = $tblnam;
            } else {
                $this->fdf_dbtablename[] = preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam);
            }

            if ($tdf1_sysdef == 'Y') {
                $this->fdf_dblinkedtable[] = $lnktbl;
            } else {
                $this->fdf_dblinkedtable[] = preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $lnktbl);
            }
        }
    }
    /**
     * results fields values definitions
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openFieldsValuesDefinitions($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["fields_valdef"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->fvd_id = array();
        $this->fvd_tablename = array();
        $this->fvd_fieldname = array();
        $this->fvd_fieldvalue = array();
        $this->fvd_fieldvalue_desc = array();
        $this->fvd_sysdef = array();

        while ($this->fetch()) {
            $i = 0;
            $this->fvd_id[] = ($row[$i++]);
            $tblnam = ($row[$i++]);
            $fldnam = ($row[$i++]);
            $fldval = HtmlEntityDecodeNOD($row[$i++]);
            $this->fvd_tablename[] = $tblnam;
            $this->fvd_fieldname[] = $fldnam;
            $this->fvd_fieldvalue[] = $fldval;
            $this->fvd_fieldvalue_desc[] = fieldValidValueString($tblnam, $fldnam, $fldval);
            $this->fvd_sysdef[] = ($row[$i++]);
        }
    }
    /**
     * results field_filters
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openFieldFilters($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["field_filters"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->fft_member = array();
        $this->fft_tablename = array();
        $this->fft_dbfieldname = array();
        $this->fft_pattern_begin = array();
        $this->fft_pattern_mid = array();
        $this->fft_pattern_end = array();
        $this->fft_tdf_sysdef = array();

        while ($this->fetch()) {
            $i = 0;
            $this->fft_member[] = ($row[$i++]);
            $this->fft_tablename[] = ($row[$i++]);
            $this->fft_dbfieldname[] = ($row[$i++]);
            $this->fft_pattern_begin[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fft_pattern_mid[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fft_pattern_end[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->fft_tdf_sysdef[] = ($row[$i++]);
        }
    }
    /**
     * results locations
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openLocations($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["locations"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->loc_id = array();           // location id
        $this->loc_name = array();         // location name
        $this->loc_timezone = array();     // location timezone
        $this->loc_language = array();     // location default language
        $this->loc_locked = array();       // location locked
        $this->loc_created = array();      // location creation timestamp
        $this->loc_cuser = array();        // location creation user id
        $this->loc_modified = array();     // location last modification timestamp
        $this->loc_muser = array();        // location last modification user id
        $this->loc_name_print = array();   // location name print

        while ($this->fetch()) {
            $i = 0;
            $this->loc_id[] = ($row[$i++]);         // location id
            $nam = ($row[$i++]);
            $this->loc_name[] = $nam;               // location name
            $this->loc_timezone[] = ($row[$i++]);   // location timezone
            $this->loc_language[] = ($row[$i++]);   // location default language
            $this->loc_locked[] = ($row[$i++]);     // location locked
            $this->loc_created[] = ($row[$i++]);    // location creation timestamp
            $this->loc_cuser[] = ($row[$i++]);      // location creation user id
            $this->loc_modified[] = ($row[$i++]);   // location last modification timestamp
            $this->loc_muser[] = ($row[$i++]);      // location last modification user id
            $this->loc_name_print[] = ((isset($strings['LOC__' . $nam]))?$strings['LOC__' . $nam]:$nam);    // location name print
        }
    }
    /**
     * results equipment_category
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openEquipmentCategory($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["equipment_category"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->eqc_id = array();                   // equipment category id
        $this->eqc_name = array();                 // equipment category name
        $this->eqc_name_print = array();           // equipment category name print
        $this->eqc_locked = array();               // equipment category locked

        while ($this->fetch()) {
            $i = 0;
            $this->eqc_id[] = ($row[$i++]);                 // equipment category id
            $nam = ($row[$i++]);
            $this->eqc_name[] = $nam;                       // equipment category name
            $this->eqc_name_print[] = ((isset($strings['EQC__' . $nam]))?$strings['EQC__' . $nam]:$nam);    // equipment category name print
            $this->eqc_locked[] = ($row[$i++]);             // equipment category locked
        }
    }
    /**
     * results equipment_type
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openEquipmentType($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["equipment_type"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->eqt_id = array();                   // equipment type id
        $this->eqt_name = array();                 // equipment type name
        $this->eqt_name_print = array();           // equipment type name print
        $this->eqt_locked = array();               // equipment type locked

        while ($this->fetch()) {
            $i = 0;
            $this->eqt_id[] = ($row[$i++]);                 // equipment type id
            $nam = ($row[$i++]);
            $this->eqt_name[] = $nam;                       // equipment type name
            $this->eqt_name_print[] = ((isset($strings['EQT__' . $nam]))?$strings['EQT__' . $nam]:$nam);    // equipment type name print
            $this->eqt_locked[] = ($row[$i++]);             // equipment type locked
        }
    }
    /**
     * results equipments
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @global int $costAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openEquipments($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings, $costAccuracy;
        $this->connectClass();
        $sql = $initrequest["equipments"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->equ_id = array();                   // equipment internal id
        $this->equ_equipment_id = array();         // equipment id
        $this->equ_equipment_category = array();   // equipment category
        $this->equ_equipment_type = array();       // equipment type
        $this->equ_name = array();                 // equipment name
        $this->equ_name_print = array();           // equipment name print
        $this->equ_owner = array();                // equipment owner id
        $this->equ_location = array();             // equipment location id
        $this->equ_status = array();               // equipment status
        $this->equ_manufacturer = array();         // equipment manufacturer
        $this->equ_model = array();                // equipment model
        $this->equ_serial_number = array();        // equipment serial number
        $this->equ_purchase_date = array();        // equipment purchase date timestamp
        $this->equ_warranty = array();             // equipment warranty
        $this->equ_cost_price = array();           // equipment purchase price
        $this->equ_cost_currency = array();        // equipment purchase currency
        $this->equ_sell_price = array();           // equipment sell price
        $this->equ_sell_currency = array();        // equipment sell currency
        $this->equ_photo = array();                // file path of equipment photo
        $this->equ_locked = array();               // equipment locked
        $this->equ_created = array();              // equipment creation timestamp
        $this->equ_cuser = array();                // equipment creation user id
        $this->equ_modified = array();             // equipment last modification timestamp
        $this->equ_muser = array();                // equipment last modification user id
        $this->equ_eqc_name = array();             // equipment category name
        $this->equ_eqc_name_print = array();       // equipment category name print
        $this->equ_eqt_name = array();             // equipment type name
        $this->equ_eqt_name_print = array();       // equipment type name print
        $this->equ_mem_login = array();            // login name of equipment owner
        $this->equ_mem_name = array();             // full name of equipment owner
        $this->equ_mem_email_work = array();       // work email of equipment owner
        $this->equ_loc_name = array();             // equipment location name
        $this->equ_loc_name_print = array();       // equipment location name print

        while ($this->fetch()) {
            $i = 0;
            $this->equ_id[] = ($row[$i++]);                 // equipment internal id
            $this->equ_equipment_id[] = ($row[$i++]);       // equipment id
            $this->equ_equipment_category[] = ($row[$i++]); // equipment category
            $this->equ_equipment_type[] = ($row[$i++]);     // equipment type
            $n = ($row[$i++]);
            $this->equ_name[] = $n;                         // equipment name
            $this->equ_name_print[] = ((isset($strings['EQU__' . $n]))?$strings['EQU__' . $n]:$n);  // equipment name print
            $this->equ_owner[] = ($row[$i++]);              // equipment owner id
            $this->equ_location[] = ($row[$i++]);           // equipment location id
            $this->equ_status[] = ($row[$i++]);             // equipment status
            $this->equ_manufacturer[] = HtmlEntityDecodeNOD($row[$i++]);    // equipment manufacturer
            $this->equ_model[] = HtmlEntityDecodeNOD($row[$i++]);           // equipment model
            $this->equ_serial_number[] = HtmlEntityDecodeNOD($row[$i++]);   // equipment serial number
            $this->equ_purchase_date[] = ($row[$i++]);      // equipment purchase date timestamp
            $this->equ_warranty[] = HtmlEntityDecodeNOD($row[$i++]);        // equipment warranty
            $price0 = ($row[$i++]);
            $cost_price = (is_numeric($price0))?round($price0, $costAccuracy):'0';
            $this->equ_cost_price[] = $cost_price;          // equipment purchase price
            $this->equ_cost_currency[] = ($row[$i++]);      // equipment purchase currency
            $price1 = ($row[$i++]);
            $sell_price = (is_numeric($price1))?round($price1, $costAccuracy):'0';
            $this->equ_sell_price[] = $sell_price;          // equipment sell price
            $this->equ_sell_currency[] = ($row[$i++]);      // equipment sell currency
            $this->equ_photo[] = ($row[$i++]);              // file path of equipment photo
            $this->equ_locked[] = ($row[$i++]);             // equipment locked
            $this->equ_created[] = ($row[$i++]);            // equipment creation timestamp
            $this->equ_cuser[] = ($row[$i++]);              // equipment creation user id
            $this->equ_modified[] = ($row[$i++]);           // equipment last modification timestamp
            $this->equ_muser[] = ($row[$i++]);              // equipment last modification user id
            $eqc_nam = ($row[$i++]);
            $this->equ_eqc_name[] = $eqc_nam;               // equipment category name
            $this->equ_eqc_name_print[] = ((isset($strings['EQC__' . $eqc_nam]))?$strings['EQC__' . $eqc_nam]:$eqc_nam);  // equipment category name print
            $eqt_nam = ($row[$i++]);
            $this->equ_eqt_name[] = $eqt_nam;               // equipment type name
            $this->equ_eqt_name_print[] = ((isset($strings['EQT__' . $eqt_nam]))?$strings['EQT__' . $eqt_nam]:$eqt_nam);  // equipment type name print
            $this->equ_mem_login[] = ($row[$i++]);          // login name of equipment owner
            $this->equ_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);        // full name of equipment owner
            $this->equ_mem_email_work[] = ($row[$i++]);     // work email of equipment owner
            $loc_nam = ($row[$i++]);
            $this->equ_loc_name[] = $loc_nam;               // equipment location name
            $this->equ_loc_name_print[] = ((isset($strings['LOC__' . $eqt_nam]))?$strings['LOC__' . $eqt_nam]:$eqt_nam);  // equipment location name print
        }
    }
    /**
     * results hour_type
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openHourType($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["hour_type"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->hrt_id = array();                   // hour type id
        $this->hrt_name_print = array();           // hour type name print
        $this->hrt_sysdef = array();               // system-defined hour type
        $this->hrt_locked = array();               // hour type locked
        $this->hrt_service = array();              // hour type default service
        $this->hrt_created = array();              // hour type creation timestamp
        $this->hrt_cuser = array();                // hour type creation user id
        $this->hrt_modified = array();             // hour type last modification timestamp
        $this->hrt_muser = array();                // hour type last modification user id
        $this->hrt_serv_name_print = array();      // hour type default service name print

        while ($this->fetch()) {
            $i = 0;
            $hrtid = ($row[$i++]);
            $this->hrt_id[] = $hrtid;               // hour type id
            $this->hrt_name_print[] = ((isset($strings['HRT__' . $hrtid]))?$strings['HRT__' . $hrtid]:$hrtid);  // hour type name print
            $this->hrt_sysdef[] = ($row[$i++]);     // system-defined hour type
            $this->hrt_locked[] = ($row[$i++]);     // hour type locked
            $this->hrt_service[] = ($row[$i++]);    // hour type default service
            $this->hrt_created[] = ($row[$i++]);    // hour type creation timestamp
            $this->hrt_cuser[] = ($row[$i++]);      // hour type creation user id
            $this->hrt_modified[] = ($row[$i++]);   // hour type last modification timestamp
            $this->hrt_muser[] = ($row[$i++]);      // hour type last modification user id
            $n = ($row[$i++]);                      // hour type default service name
            $this->hrt_serv_name_print[] = ((isset($strings['SVC__' . $n]))?$strings['SVC__' . $n]:$n); // hour type default service name print
        }
    }
    /**
     * results hour_code
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openHourCode($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["hour_code"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->hrc_id = array();                   // hour code id
        $this->hrc_name_print = array();           // hour code name print
        $this->hrc_hourtype = array();             // hour type of this hour code
        $this->hrc_sysdef = array();               // system-defined hour code
        $this->hrc_locked = array();               // hour code locked
        $this->hrc_service = array();              // hour code default service
        $this->hrc_created = array();              // hour code creation timestamp
        $this->hrc_cuser = array();                // hour code creation user id
        $this->hrc_modified = array();             // hour code last modification timestamp
        $this->hrc_muser = array();                // hour code last modification user id
        $this->hrc_hrt_name_print = array();       // hour type name print
        $this->hrc_serv_name_print = array();      // hour code default service name print

        while ($this->fetch()) {
            $i = 0;
            $hrcid = ($row[$i++]);
            $this->hrc_id[] = $hrcid;               // hour code id
            $this->hrc_name_print[] = ((isset($strings['HRC__' . $hrcid]))?$strings['HRC__' . $hrcid]:$hrcid);  // hour code name print
            $hrtid = ($row[$i++]);
            $this->hrc_hourtype[] = $hrtid;         // hour type of this hour code
            $this->hrc_sysdef[] = ($row[$i++]);     // system-defined hour code
            $this->hrc_locked[] = ($row[$i++]);     // hour code locked
            $this->hrc_service[] = ($row[$i++]);    // hour code default service
            $this->hrc_created[] = ($row[$i++]);    // hour code creation timestamp
            $this->hrc_cuser[] = ($row[$i++]);      // hour code creation user id
            $this->hrc_modified[] = ($row[$i++]);   // hour code last modification timestamp
            $this->hrc_muser[] = ($row[$i++]);      // hour code last modification user id
            $this->hrc_hrt_name_print[] = ((isset($strings['HRT__' . $hrtid]))?$strings['HRT__' . $hrtid]:$hrtid);  // hour type name print
            $n = ($row[$i++]);                      // hour code default service name
            $this->hrc_serv_name_print[] = ((isset($strings['SVC__' . $n]))?$strings['SVC__' . $n]:$n); // hour code default service name print
        }
    }
    /**
     * results flextime_adjustment
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openFlextimeAdjustment($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["flextime_adjustment"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->fta_id = array();               // id
        $this->fta_owner = array();            // owner id
        $this->fta_refdate = array();          // reference date
        $this->fta_hours = array();            // hours
        $this->fta_comments = array();         // comments
        $this->fta_created = array();          // creation timestamp
        $this->fta_cuser = array();            // creation user id
        $this->fta_modified = array();         // last modification timestamp
        $this->fta_muser = array();            // last modification user id
        $this->fta_mem_name = array();         // owner user name

        while ($this->fetch()) {
            $i = 0;
            $this->fta_id[] = ($row[$i++]);         // id
            $this->fta_owner[] = ($row[$i++]);      // owner id
            $this->fta_refdate[] = ($row[$i++]);    // reference date
            $this->fta_hours[] = ($row[$i++]);      // hours
            $this->fta_comments[] = HtmlEntityDecodeNOD($row[$i++]);    // comments
            $this->fta_created[] = ($row[$i++]);    // creation timestamp
            $this->fta_cuser[] = ($row[$i++]);      // creation user id
            $this->fta_modified[] = ($row[$i++]);   // last modification timestamp
            $this->fta_muser[] = ($row[$i++]);      // last modification user id
            $this->fta_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);    // owner user name
        }
    }
    /**
     * results payment_methods
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openPaymentMethods($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["payment_methods"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->pym_id = array();                   // internal id
        $this->pym_name = array();                 // payment method name
        $this->pym_locked = array();               // payment method locked
        $this->pym_created = array();              // creation timestamp
        $this->pym_cuser = array();                // creation user id
        $this->pym_modified = array();             // last modification timestamp
        $this->pym_muser = array();                // last modification user id
        $this->pym_name_print = array();           // payment method name print

        while ($this->fetch()) {
            $i = 0;
            $this->pym_id[] = ($row[$i++]);         // internal id
            $nam = ($row[$i++]);
            $this->pym_name[] = $nam;               // payment method name
            $this->pym_locked[] = ($row[$i++]);     // payment method locked
            $this->pym_created[] = ($row[$i++]);    // creation timestamp
            $this->pym_cuser[] = ($row[$i++]);      // creation user id
            $this->pym_modified[] = ($row[$i++]);   // last modification timestamp
            $this->pym_muser[] = ($row[$i++]);      // last modification user id
            $this->pym_name_print[] = (isset($strings['PYM__' . $nam])?$strings['PYM__' . $nam]:$nam);  // payment method name print
        }
    }
    /**
     * results payment_terms
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openPaymentTerms($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["payment_terms"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->pyt_id = array();                   // internal id
        $this->pyt_name = array();                 // payment terms name
        $this->pyt_start_from = array();           // start from
        $this->pyt_extra_months = array();         // number of additional months
        $this->pyt_extra_days = array();           // number of additional days
        $this->pyt_locked = array();               // payment terms locked
        $this->pyt_created = array();              // creation timestamp
        $this->pyt_cuser = array();                // creation user id
        $this->pyt_modified = array();             // last modification timestamp
        $this->pyt_muser = array();                // last modification user id
        $this->pyt_name_print = array();           // payment terms name print

        while ($this->fetch()) {
            $i = 0;
            $this->pyt_id[] = ($row[$i++]);         // internal id
            $nam = ($row[$i++]);
            $this->pyt_name[] = $nam;               // payment terms name
            $this->pyt_start_from[] = ($row[$i++]); // start from
            $this->pyt_extra_months[] = ($row[$i++]);   // number of additional months
            $this->pyt_extra_days[] = ($row[$i++]); // number of additional days
            $this->pyt_locked[] = ($row[$i++]);     // payment terms locked
            $this->pyt_created[] = ($row[$i++]);    // creation timestamp
            $this->pyt_cuser[] = ($row[$i++]);      // creation user id
            $this->pyt_modified[] = ($row[$i++]);   // last modification timestamp
            $this->pyt_muser[] = ($row[$i++]);      // last modification user id
            $this->pyt_name_print[] = (isset($strings['PYT__' . $nam])?$strings['PYT__' . $nam]:$nam);  // payment terms name print
        }
    }
    /**
     * results invoices
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openInvoices($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["invoices"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->inv_id = array();                   // internal id
        $this->inv_invoice_no = array();           // invoice number
        $this->inv_organization = array();         // client id
        $this->inv_owner = array();                // owner id
        $this->inv_status = array();               // status
        $this->inv_status_approval = array();      // approval status
        $this->inv_printed = array();              // printed
        $this->inv_doc_date = array();             // document date
        $this->inv_due_date = array();             // due date
        $this->inv_payment_terms = array();        // payment terms id
        $this->inv_payment_method = array();       // payment method id
        $this->inv_currency = array();             // currency
        $this->inv_before_discount = array();      // value before discount
        $this->inv_discount_percent = array();     // discount percentage
        $this->inv_discount_sum = array();         // discount
        $this->inv_freight = array();              // freight
        $this->inv_tax_sum = array();              // tax
        $this->inv_amount = array();               // invoice total
        $this->inv_paid = array();                 // amount paid
        $this->inv_due = array();                  // amount due
        $this->inv_notes = array();                // notes
        $this->inv_bill_to = array();              // bill to
        $this->inv_ship_to = array();              // ship to
        $this->inv_recurring = array();            // recurring invoice template
        $this->inv_recurring_start = array();      // recurring start date (unix timestamp)
        $this->inv_recurring_finish = array();     // recurring finish date (unix timestamp)
        $this->inv_recurring_next = array();       // recurring next date (unix timestamp)
        $this->inv_recurring_type = array();       // recurring type
        $this->inv_recurring_frequency = array();  // recurring frequency
        $this->inv_recurring_enabled = array();    // recurring invoice template enabled
        $this->inv_tax_group = array();            // tax group
        $this->inv_tax_group2 = array();           // tax group 2
        $this->inv_tax_group3 = array();           // tax group 3
        $this->inv_created = array();              // creation timestamp
        $this->inv_cuser = array();                // creation user id
        $this->inv_modified = array();             // last modification timestamp
        $this->inv_muser = array();                // last modification user id
        $this->inv_mem_name = array();             // owner user name
        $this->inv_org_name = array();             // organization name
        $this->inv_org_workcalendar = array();     // organization workcalendar id
        $this->inv_pyt_name_print = array();       // payment terms name print
        $this->inv_pyt_start_from = array();       // payment terms - start from
        $this->inv_pyt_extra_months = array();     // payment terms - number of additional months
        $this->inv_pyt_extra_days = array();       // payment terms - number of additional days
        $this->inv_pym_name_print = array();       // payment method name print

        while ($this->fetch()) {
            $i = 0;
            $this->inv_id[] = ($row[$i++]);                     // internal id
            $this->inv_invoice_no[] = ($row[$i++]);             // invoice number
            $this->inv_organization[] = ($row[$i++]);           // client id
            $this->inv_owner[] = ($row[$i++]);                  // owner id
            $this->inv_status[] = ($row[$i++]);                 // status
            $this->inv_status_approval[] = ($row[$i++]);        // approval status
            $this->inv_printed[] = ($row[$i++]);                // printed
            $this->inv_doc_date[] = ($row[$i++]);               // document date
            $this->inv_due_date[] = ($row[$i++]);               // due date
            $this->inv_payment_terms[] = ($row[$i++]);          // payment terms id
            $this->inv_payment_method[] = ($row[$i++]);         // payment method id
            $this->inv_currency[] = ($row[$i++]);               // currency
            $this->inv_before_discount[] = DbValueDecode(enumFieldType::ftTotals, $row[$i++]);    // value before discount
            $this->inv_discount_percent[] = DbValueDecode(enumFieldType::ftPercentage, $row[$i++]);  // discount percentage
            $this->inv_discount_sum[] = DbValueDecode(enumFieldType::ftTotals, $row[$i++]);       // discount
            $this->inv_freight[] = DbValueDecode(enumFieldType::ftTotals, $row[$i++]);            // freight
            $this->inv_tax_sum[] = DbValueDecode(enumFieldType::ftTotals, $row[$i++]);            // tax
            $amt = DbValueDecode(enumFieldType::ftTotals, $row[$i++]);
            $paid = DbValueDecode(enumFieldType::ftTotals, $row[$i++]);
            $due = ($paid>=$amt)?0:($amt-$paid);
            $this->inv_amount[] = $amt;                         // invoice total
            $this->inv_paid[] = $paid;                          // amount paid
            $this->inv_due[] = $due;                            // amount due
            $this->inv_notes[] = HtmlEntityDecodeNOD($row[$i++]); // notes
            $this->inv_bill_to[] = HtmlEntityDecodeNOD($row[$i++]); // notes
            $this->inv_ship_to[] = HtmlEntityDecodeNOD($row[$i++]); // notes
            $this->inv_recurring[] = ($row[$i++]);              // recurring invoice template
            $this->inv_recurring_start[] = ($row[$i++]);        // recurring start date (unix timestamp)
            $this->inv_recurring_finish[] = ($row[$i++]);       // recurring finish date (unix timestamp)
            $this->inv_recurring_next[] = ($row[$i++]);         // recurring next date (unix timestamp)
            $this->inv_recurring_type[] = ($row[$i++]);         // recurring type
            $this->inv_recurring_frequency[] = ($row[$i++]);    // recurring frequency
            $this->inv_recurring_enabled[] = ($row[$i++]);      // recurring invoice template enabled
            $this->inv_tax_group[] = ($row[$i++]);              // tax group
            $this->inv_tax_group2[] = ($row[$i++]);             // tax group 2
            $this->inv_tax_group3[] = ($row[$i++]);             // tax group 3
            $this->inv_created[] = ($row[$i++]);                // creation timestamp
            $this->inv_cuser[] = ($row[$i++]);                  // creation user id
            $this->inv_modified[] = ($row[$i++]);               // last modification timestamp
            $this->inv_muser[] = ($row[$i++]);                  // last modification user id
            $this->inv_org_name[] = HtmlEntityDecodeNOD($row[$i++]);    // ogranization name
            $this->inv_org_workcalendar[] = ($row[$i++]);       // organization workcalendar id
            $pyt_name = ($row[$i++]);                           // payment terms name
            $this->inv_pyt_name_print[] = (isset($strings['PYT__' . $pyt_name])?$strings['PYT__' . $pyt_name]:$pyt_name);    // payment terms name print
            $this->inv_pyt_start_from[] = ($row[$i++]);         // payment terms - start from
            $this->inv_pyt_extra_months[] = ($row[$i++]);       // payment terms - number of additional months
            $this->inv_pyt_extra_days[] = ($row[$i++]);         // payment terms - number of additional days
            $pym_name = ($row[$i++]);                           // payment method name
            $this->inv_pym_name_print[] = (isset($strings['PYM__' . $pym_name])?$strings['PYM__' . $pym_name]:$pym_name);    // payment method name print
        }
    }
    /**
     * results invoice_rows
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openInvoiceRows($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["invoice_rows"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->in1_id = array();
        $this->in1_invoice = array();                      // invoice id
        $this->in1_description = array();                  // row description
        $this->in1_project = array();                      // project id
        $this->in1_quantity = array();                     // quantity
        $this->in1_price = array();                        // price
        $this->in1_unit = array();                         // unit
        $this->in1_discount_percent = array();             // discount % per row
        $this->in1_discount_sum = array();                 // total discount
        $this->in1_tax_code = array();                     // tax code list
        $this->in1_tax_rate = array();                     // tax rate list
        $this->in1_tax_sum = array();                      // total tax list
        $this->in1_line_total = array();                   // row total
        $this->in1_created = array();                      // creation timestamp
        $this->in1_cuser = array();                        // creation user id
        $this->in1_modified = array();                     // last modification timestamp
        $this->in1_muser = array();                        // last modification user id
        $this->in1_pro_name = array();                     // project name
        $this->in1_txc_name_print = array();               // tax code name print list

        while ($this->fetch()) {
            $i = 0;
            $this->in1_id[] = ($row[$i++]);
            $this->in1_invoice[] = ($row[$i++]);        // invoice id
            $this->in1_description[] = HtmlEntityDecodeNOD($row[$i++]); // row description
            $this->in1_project[] = ($row[$i++]);        // project id
            $this->in1_quantity[] = DbValueDecode(enumFieldType::ftQuantity, $row[$i++]); // quantity
            $this->in1_price[] = DbValueDecode(enumFieldType::ftRate, $row[$i++]);        // price
            $this->in1_unit[] = HtmlEntityDecodeNOD($row[$i++]);    // unit
            $this->in1_discount_percent[] = DbValueDecode(enumFieldType::ftPercentage, $row[$i++]);  // discount % per row
            $this->in1_discount_sum[] = DbValueDecode(enumFieldType::ftTotals, $row[$i++]);       // total discount
            $listTaxC = array();
            $listTaxR = array();
            $listTaxS = array();

            for ($j=0; $j<3; $j++) {
                $listTaxC[] = ($row[$i++]);
                $r = ($row[$i++]);
                $listTaxR[] = (($r=='')?'0':DbValueDecode(enumFieldType::ftPercentage, $r));
                $listTaxS[] = DbValueDecode(enumFieldType::ftTotals, $row[$i++]);
            }

            $this->in1_tax_code[] = $listTaxC;          // tax code list
            $this->in1_tax_rate[] = $listTaxR;          // tax rate list
            $this->in1_tax_sum[] = $listTaxS;           // total tax list
            $this->in1_line_total[] = DbValueDecode(enumFieldType::ftTotals, $row[$i++]); // row total
            $this->in1_created[] = ($row[$i++]);        // creation timestamp
            $this->in1_cuser[] = ($row[$i++]);          // creation user id
            $this->in1_modified[] = ($row[$i++]);       // last modification timestamp
            $this->in1_muser[] = ($row[$i++]);          // last modification user id
            $this->in1_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);    // project name
            $listTaxN = array();

            for ($j=0; $j<3; $j++) {
                $nam = ($row[$i++]);
                $listTaxN[] = (isset($strings['TXC__' . $nam])?$strings['TXC__' . $nam]:$nam);     // tax code name print
            }

            $this->in1_txc_name_print[] = $listTaxN;    // tax code name print list
        }
    }
    /**
     * results tax_groups
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTaxGroups($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["tax_groups"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->txg_id = array();           // tax group internal id
        $this->txg_name = array();         // tax group name
        $this->txg_locked = array();       // tax group locked
        $this->txg_created = array();      // creation timestamp
        $this->txg_cuser = array();        // creation user id
        $this->txg_modified = array();     // last modification timestamp
        $this->txg_muser = array();        // last modification user id
        $this->txg_name_print = array();   // tax group name print

        while ($this->fetch()) {
            $i = 0;
            $this->txg_id[] = ($row[$i++]);         // tax group internal id
            $nam = ($row[$i++]);
            $this->txg_name[] = $nam;               // tax group name
            $this->txg_locked[] = ($row[$i++]);     // tax group locked
            $this->txg_created[] = ($row[$i++]);    // creation timestamp
            $this->txg_cuser[] = ($row[$i++]);      // creation user id
            $this->txg_modified[] = ($row[$i++]);   // modification timestamp
            $this->txg_muser[] = ($row[$i++]);      // modification user id
            $this->txg_name_print[] = (isset($strings['TXG__' . $nam])?$strings['TXG__' . $nam]:$nam);  // tax group name print
        }
    }
    /**
     * results tax_codes
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @global int $rateAccuracy
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTaxCodes($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings, $rateAccuracy;
        $this->connectClass();
        $sql = $initrequest["tax_codes"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->txc_id = array();           // tax code internal id
        $this->txc_tax_group = array();    // tax group internal id
        $this->txc_name = array();         // tax code name
        $this->txc_rate = array();         // tax rate
        $this->txc_created = array();      // creation timestamp
        $this->txc_cuser = array();        // creation user id
        $this->txc_modified = array();     // last modification timestamp
        $this->txc_muser = array();        // last modification user id
        $this->txc_txg_name = array();     // tax group name
        $this->txc_name_print = array();   // tax code name print
        $this->txc_txg_name_print = array();   // tax group name print

        while ($this->fetch()) {
            $i = 0;
            $this->txc_id[] = ($row[$i++]);         // tax code internal id
            $this->txc_tax_group[] = ($row[$i++]);  // tax group internal id
            $nam = ($row[$i++]);
            $this->txc_name[] = $nam;               // tax code name
            $r = round($row[$i++], $rateAccuracy);
            $this->txc_rate[] = $r;                 // tax rate
            $this->txc_created[] = ($row[$i++]);    // creation timestamp
            $this->txc_cuser[] = ($row[$i++]);      // creation user id
            $this->txc_modified[] = ($row[$i++]);   // modification timestamp
            $this->txc_muser[] = ($row[$i++]);      // modification user id
            $nam1 = ($row[$i++]);
            $this->txc_txg_name[] = $nam1;          // tax group name
            $this->txc_name_print[] = (isset($strings['TXC__' . $nam])?$strings['TXC__' . $nam]:$nam);  // tax code name print
            $this->txc_txg_name_print[] = (isset($strings['TXG__' . $nam1])?$strings['TXG__' . $nam1]:$nam1);    // tax group name print
        }
    }
    /**
     * results payments
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openPayments($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["payments"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->pay_id = array();
        $this->pay_invoice = array();          // invoice id
        $this->pay_currency = array();         // payment currency
        $this->pay_amount = array();           // payment amount
        $this->pay_doc_date = array();         // payment date
        $this->pay_payment_method = array();   // payment method
        $this->pay_notes = array();            // payment notes
        $this->pay_printed = array();          // printed
        $this->pay_created = array();          // creation timestamp
        $this->pay_cuser = array();            // creation user id
        $this->pay_modified = array();         // last modification timestamp
        $this->pay_muser = array();            // last modification user id
        $this->pay_inv_invoice_no = array();   // invoice number
        $this->pay_inv_organization = array(); // client id
        $this->pay_pym_name_print = array();   // payment method name print

        while ($this->fetch()) {
            $i = 0;
            $this->pay_id[] = ($row[$i++]);
            $this->pay_invoice[] = ($row[$i++]);    // invoice id
            $this->pay_currency[] = ($row[$i++]);   // payment currency
            $this->pay_amount[] = DbValueDecode(enumFieldType::ftTotals, $row[$i++]); // payment amount
            $this->pay_doc_date[] = ($row[$i++]);   // payment date
            $pym = ($row[$i++]);
            $this->pay_payment_method[] = $pym;     // payment method
            $this->pay_notes[] = HtmlEntityDecodeNOD($row[$i++]);   // payment notes
            $this->pay_printed[] = ($row[$i++]);    // printed
            $this->pay_created[] = ($row[$i++]);    // creation timestamp
            $this->pay_cuser[] = ($row[$i++]);      // creation user id
            $this->pay_modified[] = ($row[$i++]);   // last modification timestamp
            $this->pay_muser[] = ($row[$i++]);      // last modification user id
            $this->pay_inv_invoice_no[] = ($row[$i++]); // invoice number
            $this->pay_inv_organization[] = ($row[$i++]);   // client id
            $nam = ($row[$i++]);
            $this->pay_pym_name_print[] = (isset($strings['PYM__' . $nam])?$strings['PYM__' . $nam]:$nam); // payment method name print
        }
    }
    /**
     * results print_layouts
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openPrintLayouts($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["print_layouts"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->plt_id = array();
        $this->plt_doc_type = array();
        $this->plt_doc_type_ex = array();
        $this->plt_description = array();
        $this->plt_path = array();
        $this->plt_start_page = array();
        $this->plt_defaults = array();
        $this->plt_created = array();
        $this->plt_cuser = array();
        $this->plt_modified = array();
        $this->plt_muser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->plt_id[] = ($row[$i++]);
            $this->plt_doc_type[] = ($row[$i++]);
            $this->plt_doc_type_ex[] = ($row[$i++]);
            $this->plt_description[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->plt_path[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->plt_start_page[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->plt_defaults[] = ($row[$i++]);
            $this->plt_created[] = ($row[$i++]);
            $this->plt_cuser[] = ($row[$i++]);
            $this->plt_modified[] = ($row[$i++]);
            $this->plt_muser[] = ($row[$i++]);
        }
    }
    /**
     * results ui_settings
     * @global array $row
     * @global array $initrequest
     * @param strings $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openUISettings($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["ui_settings"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->uis_member = array();       // user id
        $this->uis_uitype = array();       // ui type
        $this->uis_uiid = array();         // ui id
        $this->uis_uisettings = array();   // ui settings

        while ($this->fetch()) {
            $i = 0;
            $this->uis_member[] = ($row[$i++]);
            $this->uis_uitype[] = ($row[$i++]);
            $this->uis_uiid[] = ($row[$i++]);
            $this->uis_uisettings[] = ($row[$i++]);
        }
    }
    /**
     *
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openUserProfiles($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["user_profiles"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->upf_id = array();           // user profile id
        $this->upf_name = array();         // user profile name
        $this->upf_department = array();   // default department
        $this->upf_location = array();     // default location
        $this->upf_language = array();     // default language
        $this->upf_date_format = array();  // default date format
        $this->upf_time_format = array();  // default time format
        $this->upf_workcalendar = array();     // default workcalendar
        $this->upf_enable_flextime = array();  // enable flextime by default
        $this->upf_readonly = array();     // readonly
        $this->upf_sysdef = array();       // system definied profile
        $this->upf_locked = array();       // locked
        $this->upf_created = array();      // creation timestamp
        $this->upf_cuser = array();        // creation user id
        $this->upf_modified = array();     // last modification timestamp
        $this->upf_muser = array();        // last modification user id
        $this->upf_name_print = array();   // user profile name print
        $this->upf_dep_name = array();     // default department name
        $this->upf_dep_name_print = array();   // default department name print
        $this->upf_loc_name = array();     // default location name
        $this->upf_loc_name_print = array();   // default location name print
        $this->upf_wca_name = array();     // default workcalendar name
        $this->upf_loc_timezone = array(); // default location timezone

        while ($this->fetch()) {
            $i = 0;
            $this->upf_id[] = ($row[$i++]);
            $nam = ($row[$i++]);
            $this->upf_name[] = $nam;
            $this->upf_department[] = ($row[$i++]);   // default department
            $this->upf_location[] = ($row[$i++]);     // default location
            $this->upf_language[] = ($row[$i++]);     // default language
            $this->upf_date_format[] = ($row[$i++]);  // default date format
            $this->upf_time_format[] = ($row[$i++]);  // default time format
            $this->upf_workcalendar[] = ($row[$i++]);     // default workcalendar
            $this->upf_enable_flextime[] = ($row[$i++]);  // enable flextime by default
            $this->upf_readonly[] = ($row[$i++]);
            $this->upf_sysdef[] = ($row[$i++]);
            $this->upf_locked[] = ($row[$i++]);
            $this->upf_created[] = ($row[$i++]);
            $this->upf_cuser[] = ($row[$i++]);
            $this->upf_modified[] = ($row[$i++]);
            $this->upf_muser[] = ($row[$i++]);
            $this->upf_name_print[] = ((isset($strings['UPF__' . $nam]))?$strings['UPF__' . $nam]:$nam);
            $namD = ($row[$i++]);
            $this->upf_dep_name[] = $namD;
            $this->upf_dep_name_print[] = ((isset($strings['DEP__' . $namD]))?$strings['DEP__' . $namD]:$namD);
            $namL = ($row[$i++]);
            $this->upf_loc_name[] = $namL;
            $this->upf_loc_name_print[] = ((isset($strings['LOC__' . $namL]))?$strings['LOC__' . $namL]:$namL);
            $this->upf_wca_name[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->upf_loc_timezone[] = ($row[$i++]);
        }
    }
    /**
     * results user_profiles_detail
     * @global array $row
     * @global array $initrequest
     * @global array $SW_Permissions
     * @global string $tablePrefix
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openUserProfilesDetail($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $SW_Permissions, $tablePrefix;
        $this->connectClass();
        // setup inactive extension list
        $sql0 = "SELECT name FROM " . $tablePrefix . "extensions WHERE active='" . enumBoolean::bFalse . "'";
        $this->query($sql0);
        $this->inactive_func = array();

        while ($this->fetch()) {
            $this->inactive_func[] = '#' . ($row[0]);
        }

        $this->connectClass();
        $sql = $initrequest["user_profiles_detail"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->upd_user_profile = array();
        $this->upd_function_name = array();
        $this->upd_access_level = array();
        $this->upd_granted = array();

        while ($this->fetch()) {
            $i = 0;
            $user_profile = ($row[$i++]);
            $function_name = ($row[$i++]);
            $access_level = ($row[$i++]);
            $granted = ($row[$i++]);
            $SW_Permissions[$function_name][$access_level][$user_profile] = (($granted=='1') && (!in_array($function_name, $this->inactive_func)));
            $this->upd_user_profile[] = $user_profile;
            $this->upd_function_name[] = $function_name;
            $this->upd_access_level[] = $access_level;
            $this->upd_granted[] = ($granted=='1');
        }
    }
    /**
     * results timeclock
     * @global array $row
     * @global array $initrequest
     * @global array $strings
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openTimeClock($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["timeclock"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->tck_id = array();       // timeclock internal id
        $this->tck_owner = array();    // owner id
        $this->tck_finish = array();   // timeclock entry has been checkout
        $this->tck_project = array();  // project id
        $this->tck_task = array();     // task id
        $this->tck_meeting = array();  // meeting id
        $this->tck_work = array();     // hour code
        $this->tck_clockin = array();  // clock-in timestamp
        $this->tck_clockout = array(); // clock-out timestamp
        $this->tck_hours = array();    // log hours
        $this->tck_comments = array(); // remarks
        $this->tck_billing = array();  // bill to client
        $this->tck_service = array();  // service id
        $this->tck_mem_name = array(); // owner name
        $this->tck_pro_name = array(); // project name
        $this->tck_tas_name = array(); // task name
        $this->tck_mee_name = array(); // meeting name
        $this->tck_hrc_name_print = array();   // hour code name print
        $this->tck_hrt_name_print = array();   // hour type name print

        while ($this->fetch()) {
            $i = 0;
            $this->tck_id[] = ($row[$i++]);         // timeclock internal id
            $this->tck_owner[] = ($row[$i++]);      // owner id
            $this->tck_finish[] = ($row[$i++]);     // timeclock entry has been checkout
            $this->tck_project[] = ($row[$i++]);    // project id
            $this->tck_task[] = ($row[$i++]);       // task id
            $this->tck_meeting[] = ($row[$i++]);    // meeting id
            $this->tck_work[] = ($row[$i++]);       // hour code
            $this->tck_clockin[] = ($row[$i++]);    // clock-in timestamp
            $this->tck_clockout[] = ($row[$i++]);   // clock-out timestamp
            $this->tck_hours[] = ($row[$i++]);      // log hours
            $this->tck_comments[] = HtmlEntityDecodeNOD($row[$i++]);    // remarks
            $this->tck_billing[] = ($row[$i++]);    // bill to client
            $this->tck_service[] = ($row[$i++]);    // service id
            $this->tck_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);    // owner name
            $this->tck_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);    // project name
            $this->tck_tas_name[] = HtmlEntityDecodeNOD($row[$i++]);    // task name
            $this->tck_mee_name[] = HtmlEntityDecodeNOD($row[$i++]);    // meeting name
            $hrcid = ($row[$i++]);
            $this->tck_hrc_name_print[] = ((isset($strings['HRC__' . $hrcid]))?$strings['HRC__' . $hrcid]:'');  // hour code name print
            $hrtid = ($row[$i++]);
            $this->tck_hrt_name_print[] = ((isset($strings['HRT__' . $hrtid]))?$strings['HRT__' . $hrtid]:'');  // hour type name print
        }
    }
    /**
     * results bookmarks
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openBookmarks($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest;
        $this->connectClass();
        $sql = $initrequest["bookmarks"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->boo_title = array();
        $this->boo_url = array();
        $this->boo_created = array();
        $this->boo_cuser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->boo_title[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->boo_url[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->boo_created[] = ($row[$i++]);
            $this->boo_cuser[] = ($row[$i++]);
        }
    }
    /**
     * results extensions
     * @global array $row
     * @global array $initrequest
     * @param string $querymore
     * @param int $start offset of the first row to return (0-based)
     * @param int $rows maximum number of rows to return
     */
    function openExtensions($querymore, $start = "", $rows = "")
    {
        global $row, $initrequest, $strings;
        $this->connectClass();
        $sql = $initrequest["extensions"];
        $sql .= ' ' . $querymore;
        $sql .= $this->limitSqlCmd($start, $rows);
        $this->query($sql);
        $this->ext_id = array();
        $this->ext_name = array();
        $this->ext_title = array();
        $this->ext_description = array();
        $this->ext_version = array();
        $this->ext_active = array();
        $this->ext_created = array();
        $this->ext_cuser = array();
        $this->ext_modified = array();
        $this->ext_muser = array();

        while ($this->fetch()) {
            $i = 0;
            $this->ext_id[] = ($row[$i++]);
            $n = ($row[$i++]);
            $this->ext_name[] = $n;
            $this->ext_title[] = ((isset($strings['EXT__' . $n]))?$strings['EXT__' . $n]:$n);
            $this->ext_description[] = HtmlEntityDecodeNOD($row[$i++]);
            $this->ext_version[] = ($row[$i++]);
            $this->ext_active[] = ($row[$i++]);
            $this->ext_created[] = ($row[$i++]);
            $this->ext_cuser[] = ($row[$i++]);
            $this->ext_modified[] = ($row[$i++]);
            $this->ext_muser[] = ($row[$i++]);
        }
    }
}
