<?php // $Revision: 1.36 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: admin.php,v 1.36 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();                                  // start of breadcrumbs
$blockPage->itemBreadcrumbs(lang_strings('administration'));    // current page
$blockPage->closeBreadcrumbs();                                 // end of breadcrumbs

/**
 * accounting
 */
ob_start();     // Turn on output buffering
$i2 = 0;
$block2 = new block();
$block2->headingToggle(lang_strings('accounting'), !($toggle_focus=='accounting'));
$block2->openContent();
// Currency Exchange Rates
if ($SW_Permissions['Currency Rate']['Read'][$profilSession]) {
    $i2++;
    $block2->contentRow('', $blockPage->buildLink('../administration/viewcurrencyrates.php', lang_strings('exchange_rates'), 'in'));
}

if ($SW_Permissions['Accounting']['Read'][$profilSession]) {
    // Claim Type
    $i2++;
    $block2->contentRow('', $blockPage->buildLink('../expenses/claim_type.php', lang_strings('claim_type'), 'in'));
    // Expense Type
    $i2++;
    $block2->contentRow('', $blockPage->buildLink('../expenses/expense_type.php', lang_strings('expense_type'), 'in'));
    // Payment Method
    $i2++;
    $block2->contentRow('', $blockPage->buildLink('../administration/payment_method.php', lang_strings('payment_method'), 'in'));
    // Payment Terms
    $i2++;
    $block2->contentRow('', $blockPage->buildLink('../administration/payment_terms.php', lang_strings('payment_terms'), 'in'));
}
// Service Management
if ($SW_Permissions['Service']['Read'][$profilSession]) {
    $i2++;
    $block2->contentRow('', $blockPage->buildLink('../services/listservices.php', lang_strings('service_management'), 'in'));
}

if ($SW_Permissions['Accounting']['Read'][$profilSession]) {
    // Tax Code
    $i2++;
    $block2->contentRow('', $blockPage->buildLink('../invoices/tax_code.php', lang_strings('tax_code'), 'in'));
    // Tax Group
    $i2++;
    $block2->contentRow('', $blockPage->buildLink('../invoices/tax_group.php', lang_strings('tax_group'), 'in'));
}

$block2->closeContent();
$block2->closeToggle();

if ($i2 > 0) {
    ob_end_flush();     // Flush (send) the output buffer and turn off output buffering
} else {
    ob_end_clean();     // Clean (erase) the output buffer and turn off output buffering
}


/**
 * company organization
 */
ob_start();     // Turn on output buffering
$i1 = 0;
$block1 = new block();
$block1->headingToggle(lang_strings('company_organization'), !($toggle_focus=='company'));
$block1->openContent();
// Company Detail
if ($SW_Permissions['Company Detail']['Read'][$profilSession]) {
    $i1++;
    $block1->contentRow('', $blockPage->buildLink('../administration/mycompany.php', lang_strings('company_details'), 'in'));
}
// Departments
if ($SW_Permissions['User']['Read'][$profilSession]) {
    $i1++;
    $block1->contentRow('', $blockPage->buildLink('../administration/departments.php', lang_strings('departments'), 'in'));
}
// User Management
if ($SW_Permissions['User']['Read'][$profilSession]) {
    $i1++;
    $block1->contentRow('', $blockPage->buildLink('../users/listusers.php', lang_strings('user_management'), 'in'));
}
// Locations
if ($SW_Permissions['Locations']['Read'][$profilSession]) {
    $i1++;
    $block1->contentRow('', $blockPage->buildLink('../administration/locations.php', lang_strings('locations'), 'in'));
}
// Leave Management
if ($enableTimesheet == 'true') {
    if ($SW_Permissions['Leave']['Read'][$profilSession]) {
        $i1++;
        $block1->contentRow('', $blockPage->buildLink('../leaves/listleaves.php', lang_strings('leave_management'), 'in'));
    }
}

$block1->closeContent();
$block1->closeToggle();

if ($i1 > 0) {
    ob_end_flush();     // Flush (send) the output buffer and turn off output buffering
} else {
    ob_end_clean();     // Clean (erase) the output buffer and turn off output buffering
}


/**
 * form templates & custom fields
 */
ob_start();     // Turn on output buffering
$i3 = 0;
$block3 = new block();
$block3->headingToggle(lang_strings('formtemplate_customfield'), !($toggle_focus=='custom'));
$block3->openContent();
// Custom Fields
if ($SW_Permissions['Custom Fields']['Read'][$profilSession]) {
    $i3++;
    $block3->contentRow('', $blockPage->buildLink('../customfields/listcustomfields.php', lang_strings('custom_fields'), 'in'));
}
// Form Templates
if ($SW_Permissions['Form Template']['Read'][$profilSession]) {
    $i3++;
    $block3->contentRow('', $blockPage->buildLink('../forms/listformtemplates.php', lang_strings('form_templates'), 'in'));
}

$block3->closeContent();
$block3->closeToggle();

if ($i3 > 0) {
    ob_end_flush();     // Flush (send) the output buffer and turn off output buffering
} else {
    ob_end_clean();     // Clean (erase) the output buffer and turn off output buffering
}


/**
 * language support
 */
ob_start();     // Turn on output buffering
$i4 = 0;
$block4 = new block();
$block4->headingToggle(lang_strings('language_support'), !($toggle_focus=='language'));
$block4->openContent();
// Text Customization
if ($SW_Permissions['TextCustomization']['Admin'][$profilSession]) {
    $i4++;
    $block4->contentRow('', $blockPage->buildLink('../administration/updatestrings.php', lang_strings('text_customization'), 'in'));
}

$block4->closeContent();
$block4->closeToggle();

if ($i4 > 0) {
    ob_end_flush();     // Flush (send) the output buffer and turn off output buffering
} else {
    ob_end_clean();     // Clean (erase) the output buffer and turn off output buffering
}


/**
 * print layout
 */
if ($SW_Permissions['Print Layout']['Admin'][$profilSession]) {
    $block401 = new block();
    $block401->headingToggle(lang_strings('print_layout'), !($toggle_focus=='layout'));
    $block401->openContent();
    $block401->contentRow('', $blockPage->buildLink('../administration/print_layout.php?doc_type=' . enumFileRelatedDocumentType::dtInvoice, lang_strings('invoices'), 'in'));     // invoice print layout
    $block401->contentRow('', $blockPage->buildLink('../administration/print_layout.php?doc_type=' . enumFileRelatedDocumentType::dtPayment, lang_strings('payments'), 'in'));     // payment print layout
    $block401->contentRow('', $blockPage->buildLink('../administration/print_layout.php?doc_type=' . enumFileRelatedDocumentType::dtExpense, lang_strings('expenses'), 'in'));     // expense print layout
    $querymore = " WHERE tdf.sysdef='N' AND tdf.printable='Y' ORDER BY tdf.tablename";
    $listTableDefinitions = new request();
    $listTableDefinitions->openTablesDefinitions($querymore);
    $comptListTableDefinitions = count($listTableDefinitions->tdf_id);

    for ($i=0; $i<$comptListTableDefinitions; $i++) {
        $tblnam = $listTableDefinitions->tdf_tablename[$i];
        $tbldispnam = tableNameString($tblnam) . ' (' . lang_strings('form_template') . ')';
        $block401->contentRow('', $blockPage->buildLink('../administration/print_layout.php?doc_type=' . enumFileRelatedDocumentType::dtForm . '&doc_type_ex=' . $tblnam, $tbldispnam, 'in'));     // form template print layout
    }

    $block401->closeContent();
    $block401->closeToggle();
}


/**
 * system configuration & settings
 */
ob_start();     // Turn on output buffering
$i5 = 0;
$block5 = new block();
$block5->headingToggle(lang_strings('system_configuration'), !($toggle_focus=='system'));
$block5->openContent();
if ($SW_Permissions['System Settings']['Read'][$profilSession]) {
// System Settings
    $i5++;
    $block5->contentRow('', $blockPage->buildLink('../administration/updatesettings.php', lang_strings('edit_settings'), 'in'));
// Hour Code
    $i5++;
    $block5->contentRow('', $blockPage->buildLink('../timesheet/hour_code.php', lang_strings('hour_code'), 'in'));
}
// Extension Management
if ($SW_Permissions['Extension']['Admin'][$profilSession]) {
    $i5++;
    $block5->contentRow('', $blockPage->buildLink('../extensions/listextensions.php', lang_strings('extension_management'), 'in'));
}
// Periods
if ($SW_Permissions['Period']['Read'][$profilSession]) {
    $i5++;
    $block5->contentRow('', $blockPage->buildLink('../administration/listperiods.php', lang_strings('periods'), 'in'));
}
// Phase Sets
if ($SW_Permissions['Phase Set']['Read'][$profilSession]) {
    $i5++;
    $block5->contentRow('', $blockPage->buildLink('../administration/phasesets.php', lang_strings('phase_sets'), 'in'));
}
// System Information
if ($SW_Permissions['System Settings']['Read'][$profilSession]) {
    $i5++;
    $block5->contentRow('', $blockPage->buildLink('../administration/systeminfo.php', lang_strings('system_information'), 'in'));
}
// User Profiles
if ($SW_Permissions['Profile']['Admin'][$profilSession]) {
    $i5++;
    $block5->contentRow('', $blockPage->buildLink('../userprofiles/listuserprofiles.php', lang_strings('user_profiles'), 'in'));
}
// Workcalendar Management
if ($SW_Permissions['Work Calendar']['Read'][$profilSession]) {
    $i5++;
    $block5->contentRow('', $blockPage->buildLink('../workcalendars/listworkcalendars.php', lang_strings('workcalendar_management'), 'in'));
}
// Check webTareas Version
if ($updateChecker == 'true' && $installationType == 'online' && $idSession == '1') {
    $i5++;
    $block5->contentRow('', updatechecker($version));
}

$block5->closeContent();
$block5->closeToggle();

if ($i5 > 0) {
    ob_end_flush();     // Flush (send) the output buffer and turn off output buffering
} else {
    ob_end_clean();     // Clean (erase) the output buffer and turn off output buffering
}


/**
 * system log & security
 */
ob_start();     // Turn on output buffering
$i6 = 0;
$block6 = new block();
$block6->headingToggle(lang_strings('systemlog_security'), !($toggle_focus=='log'));
$block6->openContent();
// Deny IP
if ($SW_Permissions['Deny IP']['Read'][$profilSession]) {
    $i6++;
    $block6->contentRow('', $blockPage->buildLink('../administration/listdenyips.php', lang_strings('deny_ips'), 'in'));
}
// System Log
if ($SW_Permissions['System Log']['Read'][$profilSession]) {
    $i6++;
    $block6->contentRow('', $blockPage->buildLink('../administration/listlogs.php', lang_strings('logs'), 'in'));
}

$block6->closeContent();
$block6->closeToggle();

if ($i6 > 0) {
    ob_end_flush();     // Flush (send) the output buffer and turn off output buffering
} else {
    ob_end_clean();     // Clean (erase) the output buffer and turn off output buffering
}


/**
 * utilities
 */
ob_start();     // Turn on output buffering
$i7 = 0;
$block7 = new block();
$block7->headingToggle(lang_strings('utilities'), !($toggle_focus=='utility'));
$block7->openContent();
// Equipment Management
if ($enableEquipment == 'true' && $SW_Permissions['Equipment']['Read'][$profilSession]) {
    $i7++;
    $block7->contentRow('', $blockPage->buildLink('../equipments/listequipments.php', lang_strings('equipment_management'), 'in'));
}
// Material Management
if ($enableMaterial == 'true' && $SW_Permissions['Material']['Read'][$profilSession]) {
    $i7++;
    $block7->contentRow('', $blockPage->buildLink('../materials/listmaterials.php', lang_strings('material_management'), 'in'));
}

$block7->closeContent();
$block7->closeToggle();

if ($i7 > 0) {
    ob_end_flush();     // Flush (send) the output buffer and turn off output buffering
} else {
    ob_end_clean();     // Clean (erase) the output buffer and turn off output buffering
}


/**
 * workflow
 */
ob_start();     // Turn on output buffering
$i8 = 0;
$block8 = new block();
$block8->headingToggle(lang_strings('workflow'), !($toggle_focus=='workflow'));
$block8->openContent();
// Approval Procedures
if ($SW_Permissions['Approval Procedure']['Read'][$profilSession]) {
    $i8++;
    $block8->contentRow('', $blockPage->buildLink('../approvals/approvalprocedures.php', lang_strings('approval_procedures'), 'in'));
}

$block8->closeContent();
$block8->closeToggle();

if ($i8 > 0) {
    ob_end_flush();     // Flush (send) the output buffer and turn off output buffering
} else {
    ob_end_clean();     // Clean (erase) the output buffer and turn off output buffering
}


$blockPage->openContent();

// Remove the installation directory and its contents!!
if ($idSession == '1') {
    if (is_dir('../installation')) {
        $blockPage->contentRow('<h2>' . $strings['attention'] . ' : ' . $strings['install_erase'] . '</h2>');
    }
}

$blockPage->closeContent();
require_once('../includes/footer.php');
