<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: departments.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');         // department id
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'list';              // form mode - list, add, edit, delete
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";               // array of department id

if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'departments' && $_SESSION['SOURCE'] == '') {
    $nam = $_SESSION['PARAMS']['nam'];                  // department name
    $desc = $_SESSION['PARAMS']['desc'];                // department name print
    $loc = $_SESSION['PARAMS']['loc'];                  // default location
    $l = $_SESSION['PARAMS']['l'];                      // locked
    $_SESSION['TARGET'] = '';
    $icp = 'true';
} else {
    $nam = AddSlashesNOD(isset($_POST['nam'])?$_POST['nam']:'');    // department name
    $desc = isset($_POST['desc'])?$_POST['desc']:'';                // department name print
    $loc = isset($_POST['loc'])?$_POST['loc']:'';                   // default location
    $l = isset($_POST['l'])?$_POST['l']:'';                         // locked (input value)
    $icp = '';
}

if ($loc == '') {
    $loc = '0';
}

$lk = DbValueEncode(enumFieldType::ftBoolean, $l);                            // locked (db value)
$error = '';
$nam_highlight = false;

/**
 * Permission check
 */
if ($mode == 'list') {
    if (!$SW_Permissions['User']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['User']['Write'][$profilSession]) {
        header("Location: ../administration/departments.php?mode=list&msg=permissiondenied" . $urlBornes);
        exit;
    }
}

if ($id != '') {
    if ($mode == 'delete') {
        // check if departments in used
        $tmpquery = "SELECT department FROM " . $tablePrefix . "members WHERE department IN ($ids) UNION ALL SELECT department FROM " . $tablePrefix . "user_profiles WHERE department IN ($ids)";

        if (compt($tmpquery) > 0) {
            header("Location: ../administration/departments.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }

        $querymore = " WHERE dep.id IN ($ids)"; // check if departments exist
        $listDepartments = new request();
        $listDepartments->openDepartments($querymore);
        $comptListDepartments = count($listDepartments->dep_id);

        if ($comptListDepartments == '0') {
            header("Location: ../administration/departments.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE dep.id='$id'"; // check if this department exists
        $departmentDetail = new request();
        $departmentDetail->openDepartments($querymore);
        $comptDepartmentDetail = count($departmentDetail->dep_id);

        if ($comptDepartmentDetail == '0') {
            header("Location: ../administration/departments.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add' || $action == 'edit') {
    $querymore = " WHERE dep.organization='1' AND dep.name='$nam'"; // check if department name duplicated

    if ($action == 'edit') {
        $querymore .= " AND dep.id<>'$id'";
    }

    $departmentTest = new request();
    $departmentTest->openDepartments($querymore);

    if (count($departmentTest->dep_id) > 0) {
        $error = lang_strings("department_already_exists");
        $bodyCommand = "onLoad=\"document.depForm.nam.focus();\"";
        $nam_highlight = true;
    }
} else if ($action == 'new') {
    // store all user input values in session variables
    $params = array();
    $params['nam'] = $nam;
    $params['desc'] = $desc;
    $params['l'] = $l;
    $_SESSION['PARAMS'] = $params;
    $_SESSION['SOURCE'] = 'departments';
    $_SESSION['LOCATION'] = '../administration/departments.php?id=' . $id . '&mode=' . $mode;
    /**
     * Add New Location
     */
    $_SESSION['TARGET'] = 'locations';
    header("Location: ../administration/locations.php?mode=add");
    exit;
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') { // add new department
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "departments (organization,name,location,locked,created,cuser) VALUES ('1','$nam','$loc','$lk','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('departments');
            copy2HistoryTable($requestAct, 'departments', $num, 'A');
            updateString($requestAct, 'DEP__' . $nam, $desc);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'departments') {
                $_SESSION['PARAMS']['dep'] = $num;

                if ($loc != '0') {
                    $_SESSION['PARAMS']['loc'] = $loc;
                }

                $_SESSION['TARGET'] = $_SESSION['SOURCE'];
                $_SESSION['SOURCE'] = '';
                header("Location: " . $_SESSION['LOCATION']);
            } else {
                header("Location: ../administration/departments.php?mode=list&msg=add");
            }

            exit;
        }
    } else if ($action == 'edit') { // edit department
        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "departments SET name='$nam',location='$loc',locked='$lk',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'departments', $id, 'U');
            updateString($requestAct, 'DEP__' . $nam, $desc);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../administration/departments.php?mode=list&msg=update" . $urlBornes);
            exit;
        }
    } else if ($action == 'delete') {   // delete department(s)
        try {
            $requestAct->startTransaction();
            copy2HistoryTable($requestAct, 'departments', $ids, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "departments WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
            // delete departments calendars
            $tmpsql = "DELETE FROM " . $tablePrefix . "calendars WHERE target='" . enumCalendarTarget::tDepartment . "' AND target_id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
            // delete departments calendar events
            $tmpsql = "DELETE FROM " . $tablePrefix . "calendar_events WHERE target='" . enumCalendarTarget::tDepartment . "' AND target_id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../administration/departments.php?mode=list&msg=delete" . $urlBornes);
            exit;
        }
    }
}

/**
 * get location valid values
 */
$querymore = " WHERE loc.locked='" . enumBoolean::bFalse . "'";

if ($id != '') {
    $querymore .= " OR loc.id='" . $departmentDetail->dep_location[0] . "'";
}

$querymore .= " ORDER BY loc.name";
$listLocations = new request();
$listLocations->openLocations($querymore);
$comptListLocations = count($listLocations->loc_id);
$locVV = array();
$locVV['0'] = '';

for ($i=0; $i<$comptListLocations; $i++) {
    $locVV[$listLocations->loc_id[$i]] = $listLocations->loc_name_print[$i];
}

if ($SW_Permissions['Locations']['Edit'][$profilSession]) {
    $locVV['-1'] = $strings['add_new_location'];
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=company", lang_strings("administration"), 'in'));

if ($mode == 'list') {  // department list
    $blockPage->itemBreadcrumbs(lang_strings("departments"));
} else if ($mode == 'add') {    // add new department
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/departments.php?", lang_strings("departments"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_department"));
} else if ($mode == 'edit') {   // edit department
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/departments.php?" . $urlBornes, lang_strings("departments"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_department"));
} else if ($mode == 'delete') { // delete department(s)
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/departments.php?" . $urlBornes, lang_strings("departments"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_departments"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = "dep";
$block1->openForm("../administration/departments.php?id=$id&mode=$mode" . $urlBornes . "#" . $block1->form . "Anchor");

if ($mode == 'list') {  // department list
    logURL($strings['departments'], "../administration/departments.php?id=$id&mode=$mode");
    $block1->heading(lang_strings("departments"));
    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '12';
    $block1->sorting('departments', (isset($sortingUser['departments'])?$sortingUser['departments']:''), 'dep.name ASC', $sortingFields = array(0 => 'dep.name', 1 => 'none', 2 => 'none', 3 => 'dep.locked'));
    $querymore = " ORDER BY " . $block1->sortingValue;
    $block1->recordsTotal = compt($initrequest['departments'] . ' ' . $querymore);
    $listDepartments = new request();
    $listDepartments->openDepartments($querymore, $block1->borne, $block1->rowsLimit);
    $comptListDepartments = count($listDepartments->dep_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftAlphaNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name_print'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['location'];
    $columns[2]->field_type = enumFieldType::ftNumeric;
    $columns[2]->linked_table = 'locations';
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['locked'];
    $columns[3]->field_type = enumFieldType::ftBoolean;
    $opt[enumCardviewOption::oObject] = 'departments';
    $opt[enumCardviewOption::oTableName] = 'departments';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oExtraParameters] = 'borne1=' . $block1->borne;

    if ($SW_Permissions['User']['Write'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../administration/departments.php?mode=add';
    }

    $block1->openCardView($opt);

    for ($i=0; $i<$comptListDepartments; $i++) {
        $content = array(
            $listDepartments->dep_name[$i],
            $listDepartments->dep_name_print[$i],
            $listDepartments->dep_location[$i],
            $listDepartments->dep_locked[$i]
        );
        $block1->itemCardView($listDepartments->dep_id[$i], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "id=$id&mode=$mode");
    $block1->closeFormResults();
} else if ($mode == 'add') {    // add new department
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_department"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name"), 'nam', enumFieldType::ftAlphaNumeric, 'Y', '155', $nam, '', '', $nam_highlight, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("name_print"), 'desc', enumFieldType::ftText, 'Y', '65535', $desc, '', '', false, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("location") . $block1->printHelp('setup_locdefault'), 'loc', enumFieldType::ftNumeric, 'N', '8', $loc, $locVV, '', false, '', 'onchange="locationChanged()"');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {   // edit department
    if ($error == '' && $icp == '') {
        $nam = $departmentDetail->dep_name[0];
        $desc = $departmentDetail->dep_name_print[0];
        $loc = $departmentDetail->dep_location[0];
        $lk = $departmentDetail->dep_locked[0];
    }

    echo '<input type="hidden" name="action" value="edit">';
    $block1->heading(lang_strings("edit_department") . " : " . $departmentDetail->dep_name[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name"), 'nam', enumFieldType::ftAlphaNumeric, 'Y', '155', $nam, '', '', $nam_highlight, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("name_print"), 'desc', enumFieldType::ftText, 'Y', '65535', $desc, '', '', false, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("location") . $block1->printHelp('setup_locdefault'), 'loc', enumFieldType::ftNumeric, 'N', '8', $loc, $locVV, '', false, '', 'onchange="locationChanged()"');
    setupInputHTML($block1, lang_strings("locked"), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') { // delete department(s)
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_departments"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListDepartments; $i++) {
        $block1->contentRow('#' . $listDepartments->dep_id[$i], $listDepartments->dep_name[$i] . ' (' . $listDepartments->dep_name_print[$i] . ')');
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

?>
<script type="text/javascript">
    function nameChanged() {
        var np = document.getElementById('desc').value;

        if (np === '') {
            var n = document.getElementById('nam').value;
            document.getElementById('desc').value = n;
        }
    }

    function locationChanged()
    {
        var x = document.getElementById('loc').selectedIndex;
        var y = document.getElementById('loc').options[x].value;

        if (y === '-1') {
            document.depForm.action.value = 'new';
            document.depForm.submit();
        }
    }
</script>
<?php
require_once("../includes/footer.php");
