<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exporttranslation.php,v 1.6 2013/02/01 02:25:46 luiswang Exp $
 * 
 * Copyright (c) 2018 by the webTareas developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * functions
 */
function which_crlf()
{
    $the_crlf = "\n"; 
    // The 'WEBTAREAS_USR_OS' constant is defined in "../includes/defines.lib.php"
    // Win case
    if (WEBTAREAS_USR_OS == 'Win') {
        $the_crlf = "\r\n";
    }
    // Mac case
    else if (WEBTAREAS_USR_OS == 'Mac') {
        $the_crlf = "\r";
    }
    // Others
    else {
        $the_crlf = "\n";
    }

    return $the_crlf;
}

@set_time_limit(600);
$crlf = which_crlf();
$filename = 'lang_' . $languageSession . '.php';
$dump_buffer = '<?php' . $crlf;
$dump_buffer .= '/* vim: set expandtab ts=4 sw=4 sts=4: */' . $crlf;
$dump_buffer .= '/**' . $crlf;
$dump_buffer .= ' * Copyright (c) ' . date('Y') . ' by the webTareas developers' . $crlf;
$dump_buffer .= ' *' . $crlf;
$dump_buffer .= ' * This program is free software; you can redistribute it and/or modify' . $crlf;
$dump_buffer .= ' * it under the terms of the GNU General Public License as published by' . $crlf;
$dump_buffer .= ' * the Free Software Foundation; either version 2 of the License, or' . $crlf;
$dump_buffer .= ' * (at your option) any later version.' . $crlf;
$dump_buffer .= ' */' . $crlf . $crlf;
ksort($strings);

foreach ($strings as $key => $val) {
    $dump_buffer .= "\$strings['" . $key . "'] = '" . str_replace("'", '&#39;', $val) . "';" . $crlf;
}

$dump_buffer .= $crlf . '?>';
$mime_type = 'text/plain';
// Send headers
header('Content-Type: ' . $mime_type);
$content_disp = (WEBTAREAS_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '"');
header('Pragma: no-cache');
header('Expires: 0');
echo $dump_buffer;
