<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: importdenyips.php,v 1.8 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Deny IP']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Fields check
 */
if ($action == 'import') {
    if ($_FILES['upload']['name'] == '') {
        $error = lang_strings("no_file");
    } else if ($_FILES['upload']['size'] == '0') {
        $error = lang_strings('exceed_size');
    }
}

/**
 * Actions
 */
if ($action == "import" && $error == "") {
    /**
     * get file content
     */
    $content = file_get_contents($_FILES['upload']['tmp_name']);

    /**
     * get ip addresses
     */
    $pattern = '/^([a-zA-Z]+:\s*)(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})$/m';
    $matches = null;
    preg_match_all($pattern, $content, $matches);

    /**
     * import ip addresses
     */
    if (is_array($matches) && is_array($matches[2])) {
        foreach ($matches[2] as $ip) {
            // check ip address blocked already
            $tmpquery = "SELECT ipaddr FROM " . $tablePrefix . "denyips WHERE ipaddr='$ip'";

            if (compt($tmpquery) == 0) {
                // add deny ip address
                $tmpsql = "INSERT INTO " . $tablePrefix . "denyips (ipaddr,reason,created,cuser) VALUES ('$ip','file.upload','" . time() . "','1')";
                connectSql($tmpsql);
            }
        }
    }

    header("Location: ../administration/listdenyips.php?msg=add");
    exit;
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/listdenyips.php?", lang_strings("deny_ips"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("import"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "imD";
$block1->openForm("../administration/importdenyips.php?#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="import">';
$block1->heading(lang_strings("import"));
$block1->openContent();
$block1->contentRow("*&nbsp;" . lang_strings("upload"), "<input name=\"upload\" type=\"FILE\">");
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["import"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
