<?php // $Revision: 1.2 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listdenyips.php,v 1.2 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$action = isset($_GET['action'])?$_GET['action']:'';
$idI = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = '';
$error = '';

/**
 * Permission check
 */
if ($action == '') {
    if (!$SW_Permissions['Deny IP']['Read'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} else {
    if (!$SW_Permissions['Deny IP']['Admin'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = 'DELETE FROM ' . $tablePrefix . "denyips WHERE ipaddr='$idI'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
        $msg = 'delete';
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php?toggle_focus=log', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('deny_ips'));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
logURL($strings['deny_ips'], '../administration/listdenyips.php');
$block1 = new block();
$block1->form = 'ldI';
$block1->openForm('../administration/listdenyips.php?#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('deny_ips'));

if ($SW_Permissions['Deny IP']['Admin'][$profilSession]) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(1, 'remove', $strings['delete']);
    $block1->paletteIcon(2, 'import', $strings['import']);
    $block1->closePaletteIcon();
}

$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '20';
$block1->sorting('denyips', (isset($sortingUser['denyips'])?$sortingUser['denyips']:''), 'den.ipaddr ASC', $sortingFields = array(0 => 'den.ipaddr', 1 => 'den.reason', 2 => 'den.created', 3 => 'mem.name'));
$tmpquery = "SELECT den.ipaddr,den.reason,den.created,den.cuser,mem.name FROM " . $tablePrefix . "denyips den LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=den.cuser ORDER BY " . $block1->sortingValue;
$block1->recordsTotal = compt($tmpquery);
$listDenyIPs = new request();
$listDenyIPs->connectClass();
$tmpquery .= $listDenyIPs->limitSqlCmd($block1->borne, $block1->rowsLimit);
$listDenyIPs->query($tmpquery);
$listDenyIPs->ipaddr = array();

while ($listDenyIPs->fetch()) {
    $listDenyIPs->ipaddr[] = ($row[0]);
    $listDenyIPs->reason[] = ($row[1]);
    $listDenyIPs->created[] = ($row[2]);
    $listDenyIPs->cuser[] = ($row[3]);
    $listDenyIPs->mem_name[] = HtmlEntityDecodeNOD($row[4]);
}

$comptListDenyIPs = count($listDenyIPs->ipaddr);

if ($comptListDenyIPs > 0) {
    $labels = array(lang_strings('ip'), lang_strings('reason'), lang_strings('created'), lang_strings('created_by'));
    $block1->openResults();
    $block1->labels($labels, 'false', 'false');

    for ($i=0; $i<$comptListDenyIPs; $i++) {
        $block1->openRow($listDenyIPs->ipaddr[$i]);
        $block1->cellRow($listDenyIPs->ipaddr[$i]);
        $block1->cellRow($listDenyIPs->reason[$i]);
        $block1->cellRow(createDate($listDenyIPs->created[$i], 'both', true));
        $block1->cellRow($blockPage->buildLink($listDenyIPs->cuser[$i], '', 'message'));
        $block1->closeRow();
    }

    $block1->closeResults();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "");
} else {
    $block1->noresults();
}

$block1->closeFormResults();

if ($SW_Permissions['Deny IP']['Admin'][$profilSession]) {
    $block1->openPaletteScript();
    $block1->paletteScript(1, 'remove', '../administration/listdenyips.php?action=delete', 'false,true,true', $strings['delete']);
    $block1->paletteScript(2, 'import', '../administration/importdenyips.php?', 'true,false,false', $strings['import']);
    $block1->closePaletteScript($comptListDenyIPs, $listDenyIPs->ipaddr);
}

require_once('../includes/footer.php');
