<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listlogs.php,v 1.16 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$action = isset($_POST['action'])?$_POST['action']:'';
$error = '';

/**
 * Permission check
 */
if ($action == '') {
    if (!$SW_Permissions['System Log']['Read'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} else {
    if (!$SW_Permissions['System Log']['Admin'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $dateunix = date('U');
        $tmpsql = "UPDATE " . $tablePrefix . "logs SET compt=1 WHERE CAST(connected AS $db_cast_int)>$dateunix-5*60";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = 'DELETE FROM ' . $tablePrefix . "logs WHERE connected IS NULL OR CAST(connected AS $db_cast_int)<=$dateunix-5*60";
        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php?toggle_focus=log', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('logs'));
$blockPage->closeBreadcrumbs();
logURL($strings['logs'], '../administration/listlogs.php');
$block1 = new block();
$block1->form = 'adminD';
$block1->openForm('../administration/listlogs.php?#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('logs'));
$querymore = ' ORDER BY last_visite DESC';
$listLogs = new request();
$listLogs->openLogs($querymore);
$comptListLogs = count($listLogs->log_id);
echo "<input name=\"action\" type=\"hidden\" value=\"delete\">";
$dateunix = date("U");
$labels = array(lang_strings('user_name'), lang_strings('ip'), lang_strings('session'), lang_strings('compteur'), lang_strings('last_visit'), lang_strings('connected'));
$block1->openResults(false);
$block1->labels($labels, false, $sorting = false, $sortingOff = array(0 => '4', 1 => 'DESC'));

for ($i=0; $i<$comptListLogs; $i++) {
    $block1->openRow();
    $block1->cellRow($listLogs->log_login[$i]);
    $block1->cellRow($listLogs->log_ip[$i]);
    $block1->cellRow($listLogs->log_session[$i]);
    $block1->cellRow($listLogs->log_compt[$i]);
    $block1->cellRow(createDate($listLogs->log_last_visite[$i], 'both'));

    if ($listLogs->log_mem_organization[$i] != '1') {
        $z = ' (' . lang_strings('client_on_customer_service_site') . ')';
    } else {
        $z = '';
    }

    if ($listLogs->log_connected[$i] > $dateunix-5*60) {
        $block1->cellRow(lang_strings('yes') . $z);
    } else {
        $block1->cellRow(lang_strings('no'));
    }

    $block1->closeRow();
}

$block1->closeResults();

if ($SW_Permissions['System Log']['Admin'][$profilSession]) {
    echo "<div class=\"clear\"><input type=\"SUBMIT\" value=\"" . $strings["delete"] . "\"></div>";
}

$block1->closeForm();
require_once('../includes/footer.php');
