<?php // $Revision: 1.11 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listperiods.php,v 1.11 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Permission check
 */
if (!$SW_Permissions['Period']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (!$SW_Permissions['Period']['Edit'][$profilSession]) {
    $disabled = "disabled";
} else {
    $disabled = '';
}

/**
 * Variables init
 */
$fyear = isset($_GET['fyear'])?$_GET['fyear']:date('Y');
$locked = isset($_POST['locked'])?$_POST['locked']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$prevYear = intval($fyear) - 1;
$thisYear = date('Y');
$nextYear = intval($fyear) + 1;
$msg = '';

/**
 * Initial periods data
 */
$error = initialPeriodsOfYear($fyear);

/**
 * Load data
 */
$querymore = " WHERE per.fyear='$fyear' ORDER BY per.serial_no";
$listPeriods = new request();
$listPeriods->openPeriods($querymore);
$comptListPeriods = count($listPeriods->per_id);

/**
 * Actions
 */
if ($action == 'update' && is_array($locked) && $error == '') {
    $chgCount = 0;
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        for ($i=0; $i<$comptListPeriods; $i++) {
            $k = array_key_exists($listPeriods->per_serial_no[$i], $locked);

            if (($k && $listPeriods->per_locked[$i] == 'N') || (!$k && $listPeriods->per_locked[$i] == 'Y')) {
                $tmpsql = "UPDATE " . $tablePrefix . "periods SET locked='" . (($listPeriods->per_locked[$i]=='N')?'Y':'N') . "',modified='" . time() . "',muser='$idSession' WHERE fyear='$fyear' AND serial_no='" . $listPeriods->per_serial_no[$i] . "'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $chgCount++;
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '' && $chgCount > 0) {
        $msg = 'update';
        // reload data
        $querymore = " WHERE per.fyear='$fyear' ORDER BY per.serial_no";
        $listPeriods = new request();
        $listPeriods->openPeriods($querymore);
        $comptListPeriods = count($listPeriods->per_id);
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php?toggle_focus=system', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/listperiods.php?fyear=$thisYear", lang_strings('periods'), 'in'));
$blockPage->closeBreadcrumbs();
$title = $strings['periods'] . ' : ' . $fyear;
logURL($title, '../administration/listperiods.php?fyear=' . $fyear);
$block1 = new block();
$block1->form = 'lsP';
$block1->openForm('../administration/listperiods.php?fyear=' . $fyear . '#' . $block1->form . 'Anchor');
$block1->heading('<div class="right"><a href="../administration/listperiods.php?fyear=' . $nextYear . '"><div class="solid-ball">&gt;</div></a></div><div class="left"><a href="../administration/listperiods.php?fyear=' . $prevYear . '"><div class="solid-ball">&lt;</div></a></div><div class="screen-center">' . lang_strings('periods') . ' ' . $fyear . '</div>');
$block1->openContent(true);

if ($periodUnit == 'month') {
    for ($i=0; $i<$comptListPeriods; $i++) {
        $checked1 = ($listPeriods->per_locked[$i]=='Y')?'checked':'';
        $block1->contentRow('<input type="checkbox" name="locked[' . $listPeriods->per_serial_no[$i] . ']" value="Y" ' . $checked1 . ' ' . $disabled . '> ' . lang_strings('locked'), $monthNameArray[$listPeriods->per_serial_no[$i]] . '&nbsp;' . $fyear . '&nbsp;&nbsp;' . createDate($listPeriods->per_date_start[$i],'date',false,true) . '&nbsp;~&nbsp;' . createDate($listPeriods->per_date_end[$i],'date',false,true));
    }
} else {
    for ($i=0; $i<$comptListPeriods; $i++) {
        $checked1 = ($listPeriods->per_locked[$i]=='Y')?'checked':'';
        $block1->contentRow('<input type="checkbox" name="locked[' . $listPeriods->per_serial_no[$i] . ']" value="Y" ' . $checked1 . ' ' . $disabled . '> ' . lang_strings('locked'), lang_strings('week') . '&nbsp;' . $listPeriods->per_serial_no[$i] . '&nbsp;' . $fyear . '&nbsp;&nbsp;' . createDate($listPeriods->per_date_start[$i],'date',false,true) . '&nbsp;~&nbsp;' . createDate($listPeriods->per_date_end[$i],'date',false,true));
    }
}

if ($disabled == '') {
    echo '<input type="hidden" name="action" value="update">';
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings["update"] . '">');
}

$block1->closeContent();
$block1->closeForm();
require_once('../includes/footer.php');
