<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: locations.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'list';
$nam = AddSlashesNOD(isset($_POST['nam'])?$_POST['nam']:'');    // name
$desc = isset($_POST['desc'])?$_POST['desc']:'';                // name print
$tz = AddSlashesNOD(isset($_POST['tz'])?$_POST['tz']:'');       // timezone
$la = isset($_POST['la'])?$_POST['la']:$langDefault;            // language
$l = isset($_POST['l'])?$_POST['l']:'';                         // locked
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$lk = DbValueEncode(enumFieldType::ftBoolean, $l);
$error = '';
$nam_highlight = false;

/**
 * Permission check
 */
if ($mode == 'list') {
    if (!$SW_Permissions['Locations']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Locations']['Edit'][$profilSession]) {
        header("Location: ../administration/locations.php?mode=list&msg=permissiondenied" . $urlBornes);
        exit;
    }
}

if ($id != '') {
    if ($mode == 'delete') {
        // check if location in used
        $tmpquery = "SELECT location FROM " . $tablePrefix . "members WHERE location IN ($ids) UNION ALL SELECT location FROM " . $tablePrefix . "departments WHERE location IN ($ids) UNION ALL SELECT location FROM " . $tablePrefix . "user_profiles WHERE location IN ($ids)";

        if (compt($tmpquery) > 0) {
            header("Location: ../administration/locations.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }

        $querymore = " WHERE loc.id IN ($ids)";
        $listLocations = new request();
        $listLocations->openLocations($querymore);
        $comptListLocations = count($listLocations->loc_id);

        if ($comptListLocations == '0') {
            header("Location: ../administration/locations.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE loc.id='$id'";
        $locationDetail = new request();
        $locationDetail->openLocations($querymore);
        $comptLocationDetail = count($locationDetail->loc_id);

        if ($comptLocationDetail == '0') {
            header("Location: ../administration/locations.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add') {
    $querymore = " WHERE loc.name='$nam'";
    $locationTest = new request();
    $locationTest->openLocations($querymore);

    if (count($locationTest->loc_id) > 0) {
        $error = lang_strings("location_already_exists");
        $bodyCommand = "onLoad=\"document.locForm.nam.focus();\"";
        $nam_highlight = true;
    }
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "locations (name,timezone,language,locked,created,cuser) VALUES ('$nam','$tz','$la','$lk','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('locations');
            copy2HistoryTable($requestAct, 'locations', $num, 'A');
            updateString($requestAct, 'LOC__' . $nam, $desc);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'locations') {
                $_SESSION['PARAMS']['loc'] = $num;
                $_SESSION['PARAMS']['la'] = $la;
                $_SESSION['TARGET'] = $_SESSION['SOURCE'];
                $_SESSION['SOURCE'] = '';
                header("Location: " . $_SESSION['LOCATION']);
            } else {
                header("Location: ../administration/locations.php?mode=list&msg=add");
            }

            exit;
        }
    } else if ($action == 'edit') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "locations SET timezone='$tz',language='$la',locked='$lk',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'locations', $id, 'U');
            updateString($requestAct, 'LOC__' . $nam, $desc);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../administration/locations.php?mode=list&msg=update" . $urlBornes);
            exit;
        }
    } else if ($action == 'delete') {
        try {
            $requestAct->startTransaction();
            copy2HistoryTable($requestAct, 'locations', $ids, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "locations WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../administration/locations.php?mode=list&msg=delete" . $urlBornes);
            exit;
        }
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=company", lang_strings("administration"), 'in'));

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings("locations"));
} else if ($mode == 'add') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/locations.php?", lang_strings("locations"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_location"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/locations.php?" . (isset($borne1)?'borne1=' . $borne1:''), lang_strings("locations"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_location"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/locations.php?" . (isset($borne1)?'borne1=' . $borne1:''), lang_strings("locations"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_locations"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = "loc";
$block1->openForm("../administration/locations.php?id=$id&mode=$mode" . $urlBornes . "#" . $block1->form . "Anchor");

if ($mode == 'list') {
    logURL($strings['locations'], "../administration/locations.php?id=$id&mode=$mode");
    $block1->heading(lang_strings("locations"));
    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '12';
    $block1->sorting('locations', (isset($sortingUser['locations'])?$sortingUser['locations']:''), 'loc.name ASC', $sortingFields = array(0 => 'loc.name', 1 => 'none', 2 => 'loc.timezone', 3 => 'loc.language', 4 => 'loc.locked'));
    $querymore = " ORDER BY $block1->sortingValue";
    $block1->recordsTotal = compt($initrequest['locations'] . ' ' . $querymore);
    $listLocations = new request();
    $listLocations->openLocations($querymore, $block1->borne, $block1->rowsLimit);
    $comptListLocations = count($listLocations->loc_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftAlphaNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name_print'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['timezone'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['language'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['locked'];
    $columns[4]->field_type = enumFieldType::ftBoolean;
    $opt[enumCardviewOption::oObject] = 'locations';
    $opt[enumCardviewOption::oTableName] = 'locations';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oExtraParameters] = 'borne1=' . $block1->borne;

    if ($SW_Permissions['Locations']['Edit'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../administration/locations.php?mode=add';
    }

    $block1->openCardView($opt);

    for ($i=0; $i<$comptListLocations; $i++) {
        $content = array(
            $listLocations->loc_name[$i],
            $listLocations->loc_name_print[$i],
            $timezoneTable[$listLocations->loc_timezone[$i]],
            $langValue[$listLocations->loc_language[$i]],
            $listLocations->loc_locked[$i]
        );
        $block1->itemCardView($listLocations->loc_id[$i], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "id=$id&mode=$mode");
    $block1->closeFormResults();
} else if ($mode == 'add') {
    if ($error == '') {
        $tz = $defaultTimezone;
    }

    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_location"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name"), 'nam', enumFieldType::ftAlphaNumeric, 'Y', '155', $nam, '', '', $nam_highlight, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("name_print"), 'desc', enumFieldType::ftText, 'Y', '65535', $desc, '', '', false, '', 'onblur="nameChanged()"');
    $tzSel = '<select name="tz">';

    foreach ($timezoneTable as $val => $desc) {
        if ($val == $tz) {
            $tzSel .= '<option value="' . $val . '" selected>' . $desc . '</option>';
        } else {
            $tzSel .= '<option value="' . $val . '">' . $desc . '</option>';
        }
    }

    $tzSel .= '</select>';
    $block1->contentRow("* " . lang_strings('timezone'), $tzSel);
    // build language drop list
    array_multisort($langValue, SORT_ASC, SORT_STRING);
    $selectLanguage = '<select name="la">';

    foreach ($langValue as $key => $value) {
        if (file_exists('../languages/lang_' . $key . '.php')) {
            if ($key == $la) {
                $selectLanguage .= '<option value="' . $key . '" selected>' . $value . '</option>';
            } else {
                $selectLanguage .= '<option value="' . $key . '">' . $value . '</option>';
            }
        }
    }

    $selectLanguage .= '</select>';
    $block1->contentRow('* ' . lang_strings('language') . $blockPage->printHelp('setup_langdefault'), $selectLanguage);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    if ($error == '') {
        $nam = $locationDetail->loc_name[0];
        $desc = $locationDetail->loc_name_print[0];
        $tz = $locationDetail->loc_timezone[0];
        $la = $locationDetail->loc_language[0];
        $lk = $locationDetail->loc_locked[0];
    }

    echo '<input type="hidden" name="action" value="edit">';
    echo '<input type="hidden" name="nam" value="' . $nam . '">';
    $block1->heading(lang_strings("edit_location") . " : " . $locationDetail->loc_name[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name_print"), 'desc', enumFieldType::ftText, 'Y', '65535', $desc);
    $tzSel = '<select name="tz">';

    foreach ($timezoneTable as $val => $desc) {
        if ($val == $tz) {
            $tzSel .= '<option value="' . $val . '" selected>' . $desc . '</option>';
        } else {
            $tzSel .= '<option value="' . $val . '">' . $desc . '</option>';
        }
    }

    $tzSel .= '</select>';
    $block1->contentRow("* " . lang_strings('timezone'), $tzSel);
    // build language drop list
    array_multisort($langValue, SORT_ASC, SORT_STRING);
    $selectLanguage = '<select name="la">';

    foreach ($langValue as $key => $value) {
        if (file_exists('../languages/lang_' . $key . '.php')) {
            if ($key == $la) {
                $selectLanguage .= '<option value="' . $key . '" selected>' . $value . '</option>';
            } else {
                $selectLanguage .= '<option value="' . $key . '">' . $value . '</option>';
            }
        }
    }

    $selectLanguage .= '</select>';
    $block1->contentRow('* ' . lang_strings('language') . $blockPage->printHelp('setup_langdefault'), $selectLanguage);
    setupInputHTML($block1, lang_strings('locked'), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_locations"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListLocations; $i++) {
        $block1->contentRow('#' . $listLocations->loc_id[$i], $listLocations->loc_name[$i] . ' (' . $listLocations->loc_name_print[$i] . ')');
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

?>
<script type="text/javascript">
    function nameChanged() {
        var np = document.getElementById('desc').value;

        if (np === '') {
            var n = document.getElementById('nam').value;
            document.getElementById('desc').value = n;
        }
    }
</script>
<?php
require_once("../includes/footer.php");
