<?php // $Revision: 1.28 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: mycompany.php,v 1.28 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.myCForm.cn.focus();"';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$att1 = isset($_POST['atttmp1'])?$_POST['atttmp1']:'';
$cn = isset($_POST['cn'])?$_POST['cn']:'';
$add = isset($_POST['add'])?$_POST['add']:'';
$wp = isset($_POST['wp'])?$_POST['wp']:'';
$fa = isset($_POST['fa'])?$_POST['fa']:'';
$url = isset($_POST['url'])?$_POST['url']:'';
$email = isset($_POST['email'])?$_POST['email']:'';
$wc = isset($_POST['wc'])?$_POST['wc']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$logoDel = isset($_POST['logoDel'])?$_POST['logoDel']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Company Detail']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * get company detail
 */
$querymore1 = " WHERE org.id='1'";
$companyDetail = new request();
$companyDetail->openOrganizations($querymore1);
$extensionOld = $companyDetail->org_extension_logo[0];

/**
 * Actions
 */
if ($action == 'update') {
    $cn = HtmlEntitiesNOD($cn);
    $add = HtmlEntitiesNOD($add);
    $wp = HtmlEntitiesNOD($wp);
    $fa = HtmlEntitiesNOD($fa);
    $url = HtmlEntitiesNOD($url);
    $c = HtmlEntitiesNOD($c);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($logoDel == 'on') {
            $tmpsql = 'UPDATE ' . $tablePrefix . "organizations SET extension_logo='' WHERE id='1'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            if (fileExists('Logos/1.' . $extensionOld)) {
                deleteFile('Logos/1.' . $extensionOld);
            }
        }

        if ($att1 != '' && file_exists($att1)) {
            $attnam = $_POST['attnam1'];
            $extension = strtolower(substr(strrchr($attnam, '.'), 1));
            uploadFile('Logos', $att1, '1.' . $extension);
            $tmpsql = 'UPDATE ' . $tablePrefix . "organizations SET extension_logo='$extension' WHERE id='1'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $tmpsql = 'UPDATE ' . $tablePrefix . "organizations SET name='$cn',address='$add',phone='$wp',fax='$fa',url='$url',email='$email',workcalendar='$wc',comments='$c',modified='" . time() . "',muser='$idSession' WHERE id='1'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'organizations', '1', 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../administration/admin.php?msg=update&toggle_focus=company');
        exit;
    }
}
/**
 * get workcalendar list
 */
$querymore0 = " ORDER BY wca.name";
$listWorkCalendars = new request();
$listWorkCalendars->openWorkCalendars($querymore0);
$comptListWorkCalendars = count($listWorkCalendars->wca_id);
$wcVV = array();

for ($i=0; $i<$comptListWorkCalendars; $i++) {
    $wcVV[$listWorkCalendars->wca_id[$i]] = $listWorkCalendars->wca_name[$i];
}

/**
 * Load data
 */
if ($error == '') {
    $cn = $companyDetail->org_name[0];
    $add = $companyDetail->org_address[0];
    $wp = $companyDetail->org_phone[0];
    $fa = $companyDetail->org_fax[0];
    $url = $companyDetail->org_url[0];
    $email = $companyDetail->org_email[0];
    $wc = $companyDetail->org_workcalendar[0];
    $c = $companyDetail->org_comments[0];
}

$pathLogo = getLogo('1', $extensionOld);

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php?toggle_focus=company', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('company_details'));
$blockPage->closeBreadcrumbs();
logURL($strings['company_details'], "../administration/mycompany.php");
$block1 = new block();
$block1->form = "myC";
$block1->openForm("../administration/mycompany.php?#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="update">';
$block1->heading(lang_strings('company_details'));
$block1->openContent(true);
$block1->contentTitle(lang_strings('company_info'));

if ($SW_Permissions['Company Detail']['Edit'][$profilSession]) {
    setupInputHTML($block1, lang_strings('name'), 'cn', enumFieldType::ftText, 'Y', '255', $cn);
    setupInputHTML($block1, lang_strings('address'), 'add', enumFieldType::ftMemo, 'N', '0', $add);
    setupInputHTML($block1, lang_strings('phone'), 'wp', enumFieldType::ftText, 'N', '255', $wp);
    setupInputHTML($block1, lang_strings('fax'), 'fa', enumFieldType::ftText, 'N', '255', $fa);
    setupInputHTML($block1, lang_strings('url'), 'url', enumFieldType::ftUrl, 'N', '0', $url);
    setupInputHTML($block1, lang_strings('email'), 'email', enumFieldType::ftEmail, 'N', '0', $email);
    setupInputHTML($block1, lang_strings('workcalendar'), 'wc', enumFieldType::ftNumeric, 'Y', '11', $wc, $wcVV);
    setupInputHTML($block1, lang_strings('comments'), 'c', enumFieldType::ftMemo, 'N', '0', $c);
    $block1->contentRow(lang_strings('logo') . $blockPage->printHelp('mycompany_logo'), setupUploadFileHTML('1', 'image/*'));

    if ($pathLogo != '') {
        $block1->contentRow('', setupPhotoBox($pathLogo, '1.' . $extensionOld) . '<input name="logoDel" type="checkbox" value="on"> ' . lang_strings('delete'));
    }

    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
} else {
    $block1->contentRow(lang_strings('name'), $cn);
    $block1->contentRow(lang_strings('address'), $add);
    $block1->contentRow(lang_strings('phone'), $wp);
    $block1->contentRow(lang_strings('fax'), $fa);
    $block1->contentRow(lang_strings('url'), $url);
    $block1->contentRow(lang_strings('email'), $email);
    $k = array_search($wc, $listWorkCalendars->wca_id);
    $block1->contentRow(lang_strings('workcalendar'), $listWorkCalendars->wca_name[$k]);
    $block1->contentRow(lang_strings('comments'), $c);

    if ($pathLogo != '') {
        $block1->contentRow(lang_strings('logo'), '<img src="' . $pathLogo . '" border="0" alt="' . $companyDetail->org_name[0] . '">');
    }
}

$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once('../includes/footer.php');
