<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: payment_method.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'list';
$n = AddSlashesNOD(isset($_POST['n'])?$_POST['n']:'');
$np = isset($_POST['np'])?$_POST['np']:'';
$l = isset($_POST['l'])?$_POST['l']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$lk = DbValueEncode(enumFieldType::ftBoolean, $l);
$error = '';
$n_highlight = false;

/**
 * Permission check
 */
if ($mode == 'list') {
    if (!$SW_Permissions['Accounting']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Accounting']['Edit'][$profilSession]) {
        header("Location: ../administration/payment_method.php?mode=list&msg=permissiondenied" . $urlBornes);
        exit;
    }
}

if ($id != '') {
    if ($mode == 'delete') {
        $tmpquery = "SELECT id FROM " . $tablePrefix . "organizations WHERE payment_method IN ($ids) UNION ALL SELECT id FROM " . $tablePrefix . "invoices WHERE payment_method IN ($ids) UNION ALL SELECT id FROM " . $tablePrefix . "payments WHERE payment_method IN ($ids)";

        if (compt($tmpquery) > 0) {
            header("Location: ../administration/payment_method.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }

        $querymore = " WHERE pym.id IN ($ids)";
        $listPaymentMethods = new request();
        $listPaymentMethods->openPaymentMethods($querymore);
        $comptListPaymentMethods = count($listPaymentMethods->pym_id);

        if ($comptListPaymentMethods == '0') {
            header("Location: ../administration/payment_method.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE pym.id='$id'";
        $paymentMethodDetail = new request();
        $paymentMethodDetail->openPaymentMethods($querymore);
        $comptPaymentMethodDetail = count($paymentMethodDetail->pym_id);

        if ($comptPaymentMethodDetail == '0') {
            header("Location: ../administration/payment_method.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add') {
    $querymore = " WHERE pym.name='$n'";
    $paymentMethodTest = new request();
    $paymentMethodTest->openPaymentMethods($querymore);

    if (count($paymentMethodTest->pym_id) > 0) {
        $error = lang_strings("payment_method_already_exists");
        $bodyCommand = "onLoad=\"document.pymForm.n.focus();\"";
        $n_highlight = true;
    }
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "payment_methods (name,locked,created,cuser) VALUES ('$n','$lk','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('payment_methods');
            copy2HistoryTable($requestAct, 'payment_methods', $num, 'A');
            updateString($requestAct, 'PYM__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../administration/payment_method.php?mode=list&msg=add");
            exit;
        }
    } else if ($action == 'edit') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "payment_methods SET locked='$lk',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'payment_methods', $id, 'U');
            updateString($requestAct, 'PYM__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../administration/payment_method.php?mode=list&msg=update" . $urlBornes);
            exit;
        }
    } else if ($action == 'delete') {
        try {
            $requestAct->startTransaction();
            copy2HistoryTable($requestAct, 'payment_methods', $ids, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "payment_methods WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../administration/payment_method.php?mode=list&msg=delete" . $urlBornes);
            exit;
        }
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=accounting", lang_strings("administration"), 'in'));

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings("payment_method"));
} else if ($mode == 'add') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/payment_method.php?", lang_strings("payment_method"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_payment_method"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/payment_method.php?" . $urlBornes, lang_strings("payment_method"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_payment_method"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/payment_method.php?" . $urlBornes, lang_strings("payment_method"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_payment_methods"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = "pym";
$block1->openForm("../administration/payment_method.php?id=$id&mode=$mode" . $urlBornes . "#" . $block1->form . "Anchor");

if ($mode == 'list') {
    logURL($strings['payment_method'], "../administration/payment_method.php?id=$id&mode=$mode");
    $block1->heading(lang_strings("payment_method"));
    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '12';
    $block1->sorting('payment_method', (isset($sortingUser['payment_method'])?$sortingUser['payment_method']:''), 'pym.name ASC', $sortingFields = array(0 => 'pym.name', 1 => 'none', 2 => 'pym.locked'));
    $querymore = " ORDER BY " . $block1->sortingValue;
    $block1->recordsTotal = compt($initrequest['payment_methods'] . ' ' . $querymore);
    $listPaymentMethods = new request();
    $listPaymentMethods->openPaymentMethods($querymore, $block1->borne, $block1->rowsLimit);
    $comptListPaymentMethods = count($listPaymentMethods->pym_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftAlphaNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name_print'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['locked'];
    $columns[2]->field_type = enumFieldType::ftBoolean;
    $opt[enumCardviewOption::oObject] = 'payment_method';
    $opt[enumCardviewOption::oTableName] = 'payment_methods';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oExtraParameters] = 'borne1=' . $block1->borne;

    if ($SW_Permissions['Accounting']['Edit'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../administration/payment_method.php?mode=add';
    }

    $block1->openCardView($opt);

    for ($i=0; $i<$comptListPaymentMethods; $i++) {
        $content = array(
            $listPaymentMethods->pym_name[$i],
            $listPaymentMethods->pym_name_print[$i],
            $listPaymentMethods->pym_locked[$i]
        );
        $block1->itemCardView($listPaymentMethods->pym_id[$i], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "id=$id&mode=$mode");
    $block1->closeFormResults();
} else if ($mode == 'add') {
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_payment_method"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name"), 'n', enumFieldType::ftAlphaNumeric, 'Y', '155', $n, '', '', $n_highlight, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np, '', '', false, '', 'onblur="nameChanged()"');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    if ($error == '') {
        $n = $paymentMethodDetail->pym_name[0];
        $np = $paymentMethodDetail->pym_name_print[0];
        $lk = $paymentMethodDetail->pym_locked[0];
    }

    echo '<input type="hidden" name="action" value="edit">';
    echo '<input type="hidden" name="n" value="' . $n . '">';
    $block1->heading(lang_strings("edit_payment_method") . " : " . $paymentMethodDetail->pym_name[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np);
    setupInputHTML($block1, lang_strings("locked"), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_payment_methods"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListPaymentMethods; $i++) {
        $block1->contentRow('#' . $listPaymentMethods->pym_id[$i], $listPaymentMethods->pym_name[$i] . ' (' . $listPaymentMethods->pym_name_print[$i] . ')');
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

?>
<script type="text/javascript">
    function nameChanged() {
        var np = document.getElementById('np').value;

        if (np === '') {
            var n = document.getElementById('n').value;
            document.getElementById('np').value = n;
        }
    }
</script>
<?php
require_once("../includes/footer.php");
