<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: phasesets.php,v 1.9 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * TODO: Default task type
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'list';
$nam = isset($_POST['nam'])?$_POST['nam']:'';
$desc = isset($_POST['desc'])?$_POST['desc']:'';
$num = isset($_POST['num'])?$_POST['num']:'0';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$error = '';
$nam_highlight = false;

for ($i=0; $i<$num; $i++) {
    $pha[$i] = isset($_POST['pha' . $i])?$_POST['pha' . $i]:'';
}

/**
 * Permission check
 */
if ($mode == 'list') {
    if (!$SW_Permissions['Phase Set']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Phase Set']['Edit'][$profilSession]) {
        header("Location: ../administration/phasesets.php?mode=list&msg=permissiondenied" . $urlBornes);
        exit;
    }
}

if ($id != '') {
    if ($mode == 'delete') {
        if (strstr($id, '**')) {
            $id = "'" . str_replace('**',"','",$id) . "'";
        }

        $tmpquery = "SELECT * FROM " . $tablePrefix . "projects WHERE phase_set IN ($id)";

        if (compt($tmpquery) > 0) {
            header("Location: ../administration/phasesets.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }

        $querymore = " WHERE phs.id IN ($id)";
        $listPhaseSets = new request();
        $listPhaseSets->openPhaseSets($querymore);
        $comptListPhaseSets = count($listPhaseSets->phs_id);

        if ($comptListPhaseSets == '0') {
            header("Location: ../administration/phasesets.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE phs.id='$id'";
        $phaseSetDetail = new request();
        $phaseSetDetail->openPhaseSets($querymore);
        $comptPhaseSetDetail = count($phaseSetDetail->phs_id);

        if ($comptPhaseSetDetail == '0') {
            header("Location: ../administration/phasesets.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }

        if ($action == 'edit') {
            if ($phaseSetDetail->project_num[0] != 0 && $phaseSetDetail->phs_phase_num[0] != $num) {
                header("Location: ../administration/phasesets.php?mode=list&msg=permissiondenied" . $urlBornes);
                exit;
            }
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add') {
    $querymore = " WHERE phs.name='$nam'";
    $phaseSetTest = new request();
    $phaseSetTest->openPhaseSets($querymore);

    if (count($phaseSetTest->phs_id) > 0) {
        $error = lang_strings("phaseset_already_exists");
        $bodyCommand = "onLoad=\"document.phsForm.nam.focus();\"";
        $nam_highlight = true;
    }
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($action == 'add') {
            $tmpsql = "INSERT INTO " . $tablePrefix . "phase_sets (name,phase_num,created,cuser) VALUES ('$nam','$num','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            updateString($requestAct, 'PHS__' . $nam, $desc);

            for ($i=0,$j=1; $i<$num; $i++,$j++) {
                updateString($requestAct, 'PHS__' . $nam . '_' . $j, $pha[$i]);
            }
        } else if ($action == 'edit') {
            $tmpsql = "UPDATE " . $tablePrefix . "phase_sets SET phase_num='$num',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            updateString($requestAct, 'PHS__' . $nam, $desc);

            for ($i=0,$j=1; $i<$num; $i++,$j++) {
                updateString($requestAct, 'PHS__' . $nam . '_' . $j, $pha[$i]);
            }
        } else if ($action == 'delete') {
            $tmpsql = "DELETE FROM " . $tablePrefix . "phase_sets WHERE id IN ($id)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($action == 'add') {
            header("Location: ../administration/phasesets.php?mode=list&msg=add");
            exit;
        } else if ($action == 'edit') {
            header("Location: ../administration/phasesets.php?mode=list&msg=update" . $urlBornes);
            exit;
        } else if ($action == 'delete') {
            header("Location: ../administration/phasesets.php?mode=list&msg=delete" . $urlBornes);
            exit;
        }
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings("phase_sets"));
} else if ($mode == 'add') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/phasesets.php?", lang_strings("phase_sets"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_phaseset"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/phasesets.php?" . $urlBornes, lang_strings("phase_sets"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_phaseset"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/phasesets.php?" . $urlBornes, lang_strings("phase_sets"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_phasesets"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "phs";

if ($mode == 'list') {
    logURL($strings['phase_sets'], "../administration/phasesets.php?id=$id&mode=$mode");
    $block1->openForm("../administration/phasesets.php?id=$id&mode=$mode#" . $block1->form . "Anchor");
    $block1->heading(lang_strings("phase_sets"));
    $blockPage->bornesNumber = '1';
    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '12';
    $block1->sorting('phase_sets', (isset($sortingUser['phase_sets'])?$sortingUser['phase_sets']:''), 'phs.name ASC', $sortingFields = array(0 => 'phs.name', 1 => 'none', 2 => 'none'));
    $querymore = " ORDER BY $block1->sortingValue";
    $block1->recordsTotal = compt($initrequest['phase_sets'] . ' ' . $querymore);
    $listPhaseSets = new request();
    $listPhaseSets->openPhaseSets($querymore, $block1->borne, $block1->rowsLimit);
    $comptListPhaseSets = count($listPhaseSets->phs_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftAlphaNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['description'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['phases'];
    $columns[2]->field_type = enumFieldType::ftText;
    $opt[enumCardviewOption::oObject] = 'phase_sets';
    $opt[enumCardviewOption::oTableName] = 'phase_sets';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oExtraParameters] = 'borne1=' . $block1->borne;

    if ($SW_Permissions['Phase Set']['Edit'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../administration/phasesets.php?mode=add';
    }

    $block1->openCardView($opt);

    for ($i=0; $i<$comptListPhaseSets; $i++) {
        $phases = array();

        for ($j=1; $j<=$listPhaseSets->phs_phase_num[$i]; $j++) {
            $phases[] = $strings['PHS__' . $listPhaseSets->phs_name[$i] . '_' . $j];
        }

        $content = array(
            $listPhaseSets->phs_name[$i],
            $listPhaseSets->phs_description[$i],
            implode(' , ', $phases)
        );
        $block1->itemCardView($listPhaseSets->phs_id[$i], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "id=$id&mode=$mode");
    $block1->closeFormResults();
} else if ($mode == 'add') {
    $block1->openForm("../administration/phasesets.php?id=$id&mode=$mode#" . $block1->form . "Anchor", "return checkform(this, '0');");
    echo '<input type="hidden" name="action" value="add">';
    echo '<input type="hidden" name="num" value="0">';
    $block1->heading(lang_strings("add_phaseset"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name"), 'nam', enumFieldType::ftAlphaNumeric, 'Y', '155', $nam, '', '', $nam_highlight);
    setupInputHTML($block1, lang_strings("description"), 'desc', enumFieldType::ftText, 'Y', '65535', $desc);
    $block1->contentRow(lang_strings("phases"), $blockPage->buildLink("javascript:morep();", lang_strings("more_phase"), 'in') . '<br><div  class="valuelist"><table id="phases"></table></div>');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    $block1->openForm("../administration/phasesets.php?id=$id&mode=$mode" . $urlBornes . "#" . $block1->form . "Anchor", "return checkform(this, '1');");
    if ($error == '') {
        $nam = $phaseSetDetail->phs_name[0];
        $desc = $phaseSetDetail->phs_description[0];
        $num = $phaseSetDetail->phs_phase_num[0];

        for ($i=1; $i<=$num; $i++) {
            $pha[] = $strings['PHS__' . $nam . '_' . $i];
        }
    }

    echo '<input type="hidden" name="action" value="edit">';
    echo '<input type="hidden" name="nam" value="' . $nam . '">';
    echo '<input type="hidden" name="num" value="' . $num . '">';
    $block1->heading(lang_strings("edit_phaseset") . " : " . $phaseSetDetail->phs_name[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("description"), 'desc', enumFieldType::ftText, 'Y', '65535', $desc);
    $phases = '<br><div class="valuelist"><table id="phases">';

    for ($i=0; $i<$num; $i++) {
        $phases .= '<tr><td><input type="text" name="pha' . $i . '" value="' . $pha[$i] . '">';

        if ($phaseSetDetail->project_num[0]==0) {
            $phases .= '<a href="javascript:delp(' . $i . ');" class="delete-link">&#8722;</a></td>';
        }

        $phases .= '</td></tr>';
    }

    $phases .= '</table></div>';
    $block1->contentRow(lang_strings("phases"), (($phaseSetDetail->project_num[0]==0)?$blockPage->buildLink("javascript:morep();", lang_strings("more_phase"), 'in'):'') . $phases);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    $block1->openForm("../administration/phasesets.php?id=$id&mode=$mode" . $urlBornes . "#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_phasesets"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListPhaseSets; $i++) {
        $block1->contentRow('#' . $listPhaseSets->phs_id[$i], $listPhaseSets->phs_name[$i]);
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

?>
<script type="text/javascript">
function morep() {
    var num = document.phsForm.num;
    var v = Number(num.value);
    var x = '';
    x = x + '<tr><td><input type="text" name="pha' + num.value + '" value="">';
    x = x + '<a href="javascript:delp(' + num.value + ');" class="delete-link">&#8722;</a></td></tr>';
    $("#phases").append(x);
    num.value = String(v + 1);
}

function delp(idx) {
    var num = document.phsForm.num;
    var v = Number(num.value);

    if (v === 1) {
        $("#phases").html('');
        v = 0;
    } else {
        var phaa = new Array();

        for (var i=0; i<v; i++) {
            if (Number(i) === Number(idx)) {
                continue;
            }

            var pha = document.phsForm.elements["pha" + String(i)];
            phaa.push(pha.value);
        }

        v = v - 1;
        var x = '';

        for (var i=0; i<v; i++) {
            x = x + '<tr><td><input type="text" name="pha' + String(i) + '" value="' + phaa[i] + '">';
            x = x + '<a href="javascript:delp(' + String(i) + ');" class="delete-link">&#8722;</a></td></tr>';
        }

        $("#phases").html(x);
    }

    num.value = String(v);
}

function checkform(theObj, chg) {
    var res = __default_checkformdata(theObj);

    if (!res) {
        return false;
    }

    var v = Number(theObj.num.value);

    if (v !== 0) {
        var phaa1 = new Array();

        for (var i=0; i<v; i++) {
            var x = theObj.elements['pha' + String(i)];
            var y = x.className;

            if ((x.value === '') || (phaa1.indexOf(x.value) !== -1)) {
                if (y === '') {
                    x.className = 'highlight';
                }

                x.focus();
                return false;
            } else {
                phaa1.push(x.value);

                if (y !== '') {
                    x.className = '';
                }
            }
        }
    }

    return true;
}
</script>
<?php
require_once("../includes/footer.php");
