<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: print_layout.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$doc_type = AddSlashesNOD(isset($_GET['doc_type'])?$_GET['doc_type']:'');
$doc_type_ex = AddSlashesNOD(isset($_GET['doc_type_ex'])?$_GET['doc_type_ex']:'');
$mode = isset($_GET['mode'])?$_GET['mode']:'list';
$desc = AddSlashesNOD(isset($_POST['desc'])?$_POST['desc']:'');
$sp = isset($_POST['sp'])?$_POST['sp']:'';
$dft = isset($_POST['dft'])?$_POST['dft']:'';
$atttmp = isset($_POST['atttmp1'])?$_POST['atttmp1']:'';
$attnam = isset($_POST['attnam1'])?$_POST['attnam1']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Print Layout']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($id != '') {
    if ($mode == 'delete') {
        $querymore = " WHERE plt.id IN ($ids)";
        $listPrintLayouts = new request();
        $listPrintLayouts->openPrintLayouts($querymore);
        $comptListPrintLayouts = count($listPrintLayouts->plt_id);

        if ($comptListPrintLayouts == '0') {
            header("Location: ../administration/print_layout.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }

        if (in_array(enumBoolean::bTrue, $listPrintLayouts->plt_defaults)) {
            header("Location: ../administration/print_layout.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }
    } else if ($mode == 'edit' || $mode == 'save') {
        $querymore = " WHERE plt.id='$id'";
        $printLayoutDetail = new request();
        $printLayoutDetail->openPrintLayouts($querymore);
        $comptPrintLayoutDetail = count($printLayoutDetail->plt_id);

        if ($comptPrintLayoutDetail == '0') {
            header("Location: ../administration/print_layout.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }
    }
}

/**
 * Download print layout
 */
if ($mode == 'save') {
    if ($mkdirMethod == 'FTP') {
        $path = tempnam(preg_replace_callback('#/+#', function ($matches) { return '/'; }, $basedir . '/files'), 'tmp');
        $ftp = ftp_connect(FTPSERVER);
        ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
        $rc = @ftp_get($ftp, $zipfile, preg_replace_callback('#/+#', function ($matches) { return '/'; }, $ftpRoot . "/PrintLayouts/" . $printLayoutDetail->plt_path[0]), FTP_BINARY);
        ftp_quit($ftp);
    } else {
        $path = preg_replace_callback('#/+#', function ($matches) { return '/'; }, $basedir . '/files/PrintLayouts/' . $printLayoutDetail->plt_path[0]);
    }

    // MIMETypes should be handled using PHP mime.magic once it's out
    require_once('../includes/mimetypes.php');
    // figure out mimetype, should be done using PHP mime.magic once it's out
    $mimetype = $mimetypes['zip'];
    header('Content-Length: ' . filesize($path));
    header('Content-Type: ' . $mimetype);
    header("Content-Disposition: attachment; filename=" . basename($printLayoutDetail->plt_path[0]));
    // write file as response
    readfile($path);
    exit;
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $desc = HtmlEntitiesNOD($desc);
    $sp = HtmlEntitiesNOD($sp);
    $dft = DbValueEncode(enumFieldType::ftBoolean, $dft);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "print_layouts (doc_type,doc_type_ex,description,path,start_page,defaults,created,cuser) VALUES ('$doc_type', '$doc_type_ex', '$desc','','$sp','$dft','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('print_layouts');

            if ($dft == enumBoolean::bTrue) {
                $querymore = " WHERE plt.id<>'$num' AND plt.doc_type='$doc_type' AND plt.doc_type_ex='$doc_type_ex' AND plt.defaults='" . enumBoolean::bTrue . "'";
                $printLayoutTest = clone $requestAct;
                $printLayoutTest->openPrintLayouts($querymore);

                if (count($printLayoutTest->plt_id) > 0) {
                    $tmpsql = "UPDATE " . $tablePrefix . "print_layouts SET defaults='" . enumBoolean::bFalse . "',modified='" . time() . "',muser='$idSession' WHERE plt.id<>'$num' AND plt.doc_type='$doc_type' AND plt.doc_type_ex='$doc_type_ex' AND plt.defaults='" . enumBoolean::bTrue . "'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }

            $extension = strtolower(substr(strrchr($attnam, ".") , 1));
            $extension_len = strlen($extension) + 1;
            $filename_len = strlen($attnam);
            $filename_prefix = substr($attnam, 0, $filename_len - $extension_len);
            $realname = uploadFile('/PrintLayouts', $atttmp, $filename_prefix . '--' . $num . '.' . $extension);
            $tmpsql = "UPDATE " . $tablePrefix . "print_layouts SET path='$realname' WHERE id='$num'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../administration/print_layout.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex&mode=list&msg=add");
            exit;
        }
    } else if ($action == 'edit') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "print_layouts SET description='$desc',start_page='$sp',defaults='$dft',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            if ($dft == enumBoolean::bTrue) {
                $querymore = " WHERE plt.id<>'$id' AND plt.doc_type='$doc_type' AND plt.doc_type_ex='$doc_type_ex' AND plt.defaults='" . enumBoolean::bTrue . "'";
                $printLayoutTest = clone $requestAct;
                $printLayoutTest->openPrintLayouts($querymore);

                if (count($printLayoutTest->plt_id) > 0) {
                    $tmpsql = "UPDATE " . $tablePrefix . "print_layouts SET defaults='" . enumBoolean::bFalse . "',modified='" . time() . "',muser='$idSession' WHERE id<>'$id' AND doc_type='$doc_type' AND doc_type_ex='$doc_type_ex' AND defaults='" . enumBoolean::bTrue . "'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }

            if ($atttmp != '') {
                deleteFile('PrintLayouts/' . $printLayoutDetail->plt_path[0]);
                $extension = strtolower(substr(strrchr($attnam, ".") , 1));
                $extension_len = strlen($extension) + 1;
                $filename_len = strlen($attnam);
                $filename_prefix = substr($attnam, 0, $filename_len - $extension_len);
                $realname = uploadFile('/PrintLayouts', $atttmp, $filename_prefix . '--' . $id . '.' . $extension);
                $tmpsql = "UPDATE " . $tablePrefix . "print_layouts SET path='$realname' WHERE id='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../administration/print_layout.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex&mode=list&msg=update" . $urlBornes);
            exit;
        }
    } else if ($action == 'delete') {
        try {
            $requestAct->startTransaction();

            for ($i=0; $i<$comptListPrintLayouts; $i++) {
                deleteFile('PrintLayouts/' . $listPrintLayouts->plt_path[$i]);
            }

            $tmpsql = "DELETE FROM " . $tablePrefix . "print_layouts WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../administration/print_layout.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex&mode=list&msg=delete" . $urlBornes);
            exit;
        }
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=layout", lang_strings("administration"), 'in'));

if ($doc_type == enumFileRelatedDocumentType::dtForm) {
    $docTypeName = tableNameString($doc_type_ex) . ' (' . lang_strings('form_template') . ')';
} else {
    $docTypeName = $fileDocType[$doc_type];
}

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings("print_layout") . ' : ' . $docTypeName);
} else if ($mode == 'add') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/print_layout.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex", lang_strings("print_layout") . ' : ' . $docTypeName, 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_print_layout"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/print_layout.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex" . $urlBornes, lang_strings("print_layout") . ' : ' . $docTypeName, 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_print_layout"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/print_layout.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex" . $urlBornes, lang_strings("print_layout") . ' : ' . $docTypeName, 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_print_layouts"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = "pym";

if ($mode == 'add' || $mode == 'edit') {
    echo '<script type="text/javascript" src="../javascript/print_layout' . $scriptMinimized . '.js"></script>';
    $block1->openForm("../administration/print_layout.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex&id=$id&mode=$mode" . $urlBornes . "#" . $block1->form . "Anchor", 'return checkformdata(this)');
} else {
    $block1->openForm("../administration/print_layout.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex&id=$id&mode=$mode" . $urlBornes . "#" . $block1->form . "Anchor");
}

if ($mode == 'list') {
    $title = $strings['print_layout'] . ' : ' . $docTypeName;
    logURL($title, "../administration/print_layout.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex&id=$id&mode=$mode");
    $block1->heading(lang_strings("print_layout") . ' : ' . $docTypeName);
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, 'add', $strings['add']);
    $block1->paletteIcon(1, 'remove', $strings['delete']);
    $block1->paletteIcon(3, 'edit', $strings['edit']);
    $block1->closePaletteIcon();
    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '20';
    $block1->sorting('print_layout', (isset($sortingUser['print_layout'])?$sortingUser['print_layout']:''), 'plt.description ASC', $sortingFields = array(0 => 'plt.description', 1 => 'plt.defaults'));
    $querymore = " WHERE plt.doc_type='$doc_type' AND plt.doc_type_ex='$doc_type_ex' ORDER BY " . $block1->sortingValue;
    $block1->recordsTotal = compt($initrequest['print_layouts'] . ' ' . $querymore);
    $listPrintLayouts = new request();
    $listPrintLayouts->openPrintLayouts($querymore, $block1->borne, $block1->rowsLimit);
    $comptListPrintLayouts = count($listPrintLayouts->plt_id);

    if ($comptListPrintLayouts > 0) {
        $labels = array(lang_strings('description'), lang_strings('default'), '');
        $block1->openResults();
        $block1->labels($labels, 'false');

        for ($i=0; $i<$comptListPrintLayouts; $i++) {
            $block1->openRow($listPrintLayouts->plt_id[$i]);
            $block1->cellRow(strip_tags($listPrintLayouts->plt_description[$i]));
            $block1->cellRow(DbValueDecode(enumFieldType::ftBoolean, $listPrintLayouts->plt_defaults[$i]));
            $block1->cellRow($block1->buildLink('../administration/print_layout.php?mode=save&id=' . $listPrintLayouts->plt_id[$i], lang_strings('save'), 'out'));
            $block1->closeRow();
        }

        $block1->closeResults();
        $block1->bornesFooter("1", $blockPage->bornesNumber, "doc_type=$doc_type&doc_type_ex=$doc_type_ex&id=$id&mode=$mode");
    } else {
        $block1->noresults();
    }

    $block1->closeFormResults();
    $block1->openPaletteScript();
    $block1->paletteScript(0, 'add', '../administration/print_layout.php?doc_type=' . $doc_type . '&doc_type_ex=' . $doc_type_ex . '&mode=add', 'true,false,false', $strings['add']);
    $block1->paletteScript(1, 'remove', '../administration/print_layout.php?doc_type=' . $doc_type . '&doc_type_ex=' . $doc_type_ex . '&mode=delete&borne1=' . $block1->borne, 'false,true,true', $strings['delete']);
    $block1->paletteScript(3, 'edit', '../administration/print_layout.php?doc_type=' . $doc_type . '&doc_type_ex=' . $doc_type_ex . '&mode=edit&borne1=' . $block1->borne, 'false,true,false', $strings['edit']);
    $block1->closePaletteScript($comptListPrintLayouts, $listPrintLayouts->plt_id);
} else if ($mode == 'add') {
    echo '<input type="hidden" id="action" name="action" value="add">';
    $block1->heading(lang_strings("add_print_layout"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("description"), 'desc', enumFieldType::ftMemo, 'Y', '0', $desc);
    $block1->contentRow("*&nbsp;" . lang_strings("upload"), setupUploadFileHTML('1', '.zip', true));
    setupInputHTML($block1, lang_strings('start_page') . $block1->printHelp('start_page_help'), 'sp', enumFieldType::ftText, 'Y', '255', 'index.html');
    setupInputHTML($block1, lang_strings('default'), 'dft', enumFieldType::ftBoolean, 'N', '1', '0');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    if ($error == '') {
        $desc = $printLayoutDetail->plt_description[0];
        $sp = $printLayoutDetail->plt_start_page[0];
    }

    echo '<input type="hidden" id="action" name="action" value="edit">';
    echo '<input type="hidden" id="pltid" value="' . $id . '">';
    $block1->heading(lang_strings("edit_print_layout") . " : " . $printLayoutDetail->plt_name[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("description"), 'desc', enumFieldType::ftMemo, 'Y', '0', $desc);
    $block1->contentRow(lang_strings("upload"), setupUploadFileHTML('1', '.zip'));
    $block1->contentRow('', $printLayoutDetail->plt_path[0]);
    setupInputHTML($block1, lang_strings('start_page') . $block1->printHelp('start_page_help'), 'sp', enumFieldType::ftText, 'Y', '255', $sp, '', '', $sp_highlight);

    if ($printLayoutDetail->plt_defaults[0] == enumBoolean::bFalse) {
        setupInputHTML($block1, lang_strings('default'), 'dft', enumFieldType::ftBoolean, 'N', '1', '0');
    }

    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_print_layouts"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListPrintLayouts; $i++) {
        $block1->contentRow('#' . $listPrintLayouts->plt_id[$i], $listPrintLayouts->plt_description[$i]);
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

require_once("../includes/footer.php");
