<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: print_layout_serv.php,v 1.3 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

// check if the request is an AJAX request
if (!is_ajax()) {
    exit;
}

/**
 * check zip file
 * @global array $strings
 * @param string $zipfile
 * @param string $sp
 */
function checkZipFile($zipfile, $sp)
{
    global $strings;
    $error = '';
    $zip = new ZipArchive();
    $res = $zip->open($zipfile);

    if ($res === true) {
        if ($zip->locateName($sp) === FALSE) {
            $error = ($strings['start_page_not_found']=='')?'start_page_not_found':$strings['start_page_not_found'];
        }
        
        $zip->close();
    } else {
        switch ($res) {
            case ZipArchive::ER_INCONS:
                $error = ($strings['zip__ER_INCONS']=='')?'zip__ER_INCONS':$strings['zip__ER_INCONS'];
                break;
            case ZipArchive::ER_INVAL:
                $error = ($strings['zip__ER_INVAL']=='')?'zip__ER_INVAL':$strings['zip__ER_INVAL'];
                break;
            case ZipArchive::ER_MEMORY:
                $error = ($strings['zip__ER_MEMORY']=='')?'zip__ER_MEMORY':$strings['zip__ER_MEMORY'];
                break;
            case ZipArchive::ER_NOZIP:
                $error = ($strings['zip__ER_NOZIP']=='')?'zip__ER_NOZIP':$strings['zip__ER_NOZIP'];
                break;
            case ZipArchive::ER_OPEN:
                $error = ($strings['zip__ER_OPEN']=='')?'zip__ER_OPEN':$strings['zip__ER_OPEN'];
                break;
            case ZipArchive::ER_READ:
                $error = ($strings['zip__ER_READ']=='')?'zip__ER_READ':$strings['zip__ER_READ'];
                break;
            case ZipArchive::ER_SEEK:
                $error = ($strings['zip__ER_SEEK']=='')?'zip__ER_SEEK':$strings['zip__ER_SEEK'];
                break;
            default:
                $error = 'unknown error';
        }
    }
    
    return $error;
}

/**
 * Variables init
 */
$action = AddSlashesNOD(isset($_POST['action'])?$_POST['action']:'');   // action

if ($action == '') {
    exit;
}

switch ($action) {
    case 'newzip':
        $zipfile = isset($_POST['zipfile'])?$_POST['zipfile']:'';   // zip file
        $sp = isset($_POST['sp'])?$_POST['sp']:'';     // start page
        /**
         * check zip file
         */
        $error = checkZipFile($zipfile, $sp);
        header("content-type:application/json");
        echo json_encode(array(
            'result' => (($error=='')?'ok':'error'),
            'error' => $error
        ));
        break;
    case 'oldzip':
        $id = AddSlashesNOD(isset($_POST['id'])?$_POST['id']:'');      // print layout id
        $sp = isset($_POST['sp'])?$_POST['sp']:'';      // start page
        /**
         * open print layout
         */
        $querymore = " WHERE plt.id='$id'";
        $printLayoutDetail = new request();
        $printLayoutDetail->openPrintLayouts($querymore);
        
        if ($sp != $printLayoutDetail->plt_path[0]) {
            /**
             * check new start page in zip file
             */
            if ($mkdirMethod == 'FTP') {
                $zipfile = tempnam(preg_replace_callback('#/+#', function ($matches) { return '/'; }, $basedir . '/files'), 'tmp');
                $ftp = ftp_connect(FTPSERVER);
                ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
                $rc = @ftp_get($ftp, $zipfile, preg_replace_callback('#/+#', function ($matches) { return '/'; }, $ftpRoot . "/PrintLayouts/" . $printLayoutDetail->plt_path[0]), FTP_BINARY);
                ftp_quit($ftp);
            } else {
                $zipfile = preg_replace_callback('#/+#', function ($matches) { return '/'; }, $basedir . '/files/PrintLayouts/' . $printLayoutDetail->plt_path[0]);
            }

            $error = checkZipFile($zipfile, $sp);

            if ($mkdirMethod == 'FTP') {
                unlink($zipfile);
            }
        } else {
            $error = '';
        }

        header("content-type:application/json");
        echo json_encode(array(
            'result' => (($error=='')?'ok':'error'),
            'error' => $error
        ));
        break;
}
