<?php // $Revision: 1.31 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: updatesettings.php,v 1.31 2013/02/19 14:15:27 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
require_once('../includes/library.php');

/**
 * generate decimal place selection html
 * @param object $block1
 * @param string $title
 * @param string $name
 * @param string $val
 */
function setupDecimalPlaceSelectionHtml($block1, $title, $name, $val)
{
    $selHtml = '<select name="' . $name . '">';

    for ($i=0; $i<=6; $i++) {
        if ($i == $val) {
            $selHtml .= '<option value="' . $i . '" selected>' . $i . '</option>';
        } else {
            $selHtml .= '<option value="' . $i . '">' . $i . '</option>';
        }
    }

    $selHtml .= '</select>';
    $block1->contentRow($title, $selHtml);
}

/**
 * Permission check
 */
if (!$SW_Permissions['System Settings']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Variables init
 */
$installationTypeNew = isset($_POST['installationTypeNew'])?$_POST['installationTypeNew']:$installationType;
$dbtype = DBTYPE;
$dbserver = DBSERVER;
$dblogin = DBLOGIN;
$dbpassword = DBPASSWORD;
$dbname = DBNAME;
$notificationMethodNew = isset($_POST['notificationMethodNew'])?$_POST['notificationMethodNew']:$notificationMethod;
$smtpserverNew = isset($_POST['smtpserverNew'])?$_POST['smtpserverNew']:SMTPSERVER;
$smtpportNew = isset($_POST['smtpportNew'])?$_POST['smtpportNew']:SMTPPORT;
$smtpsecureNew = isset($_POST['smtpsecureNew'])?$_POST['smtpsecureNew']:SMTPSECURE;
$smtploginNew = isset($_POST['smtploginNew'])?$_POST['smtploginNew']:SMTPLOGIN;
$smtppasswordNew = isset($_POST['smtppasswordNew'])?$_POST['smtppasswordNew']:SMTPPASSWORD;
$mkdirMethodNew = isset($_POST['mkdirMethodNew'])?$_POST['mkdirMethodNew']:$mkdirMethod;
$ftpserverNew = isset($_POST['ftpserverNew'])?$_POST['ftpserverNew']:FTPSERVER;
$ftploginNew = isset($_POST['ftploginNew'])?$_POST['ftploginNew']:FTPLOGIN;
$ftppasswordNew = isset($_POST['ftppasswordNew'])?$_POST['ftppasswordNew']:FTPPASSWORD;
$ftpRootNew = isset($_POST['ftpRootNew'])?$_POST['ftpRootNew']:$ftpRoot;
$gmtTimezoneNew = isset($_POST['gmtTimezoneNew'])?$_POST['gmtTimezoneNew']:$gmtTimezone;
$defaultTimezoneNew = isset($_POST['defaultTimezoneNew'])?$_POST['defaultTimezoneNew']:$defaultTimezone;
$langDefaultNew = isset($_POST['langDefaultNew'])?$_POST['langDefaultNew']:$langDefault;
$defaultCurrencyNew = isset($_POST['defaultCurrencyNew'])?$_POST['defaultCurrencyNew']:$defaultCurrency;
$defaultCostMethodNew = isset($_POST['defaultCostMethodNew'])?$_POST['defaultCostMethodNew']:$defaultCostMethod;
$autoCreateDirNew = isset($_POST['autoCreateDirNew'])?$_POST['autoCreateDirNew']:$autoCreateDir;
$currencyOnRightNew = isset($_POST['currencyOnRightNew'])?$_POST['currencyOnRightNew']:$currencyOnRight;
$maxFileSizeNew = isset($_POST['maxFileSizeNew'])?$_POST['maxFileSizeNew']:$maxFileSize;
$rootNew = isset($_POST['rootNew'])?$_POST['rootNew']:$root;
$updateCheckerNew = isset($_POST['updateCheckerNew'])?$_POST['updateCheckerNew']:$updateChecker;
$notificationsNew = isset($_POST['notificationsNew'])?$_POST['notificationsNew']:$notifications;
$footerDevNew = isset($_POST['footerDevNew'])?$_POST['footerDevNew']:$footerDev;
$projectsFilterNew = isset($_POST['projectsFilterNew'])?$_POST['projectsFilterNew']:$projectsFilter;
$enableOnlineTextCustomizationNew = isset($_POST['enableOnlineTextCustomizationNew'])?$_POST['enableOnlineTextCustomizationNew']:$enableOnlineTextCustomization;
$siteOffNew = isset($_POST['siteOffNew'])?$_POST['siteOffNew']:$siteOff;
$contactNameFormatNew = isset($_POST['contactNameFormatNew'])?$_POST['contactNameFormatNew']:$contactNameFormat;
$hourAccuracyNew = isset($_POST['hourAccuracyNew'])?$_POST['hourAccuracyNew']:$hourAccuracy;
$quantityAccuracyNew = isset($_POST['quantityAccuracyNew'])?$_POST['quantityAccuracyNew']:$quantityAccuracy;
$measureAccuracyNew = isset($_POST['measureAccuracyNew'])?$_POST['measureAccuracyNew']:$measureAccuracy;
$rateAccuracyNew = isset($_POST['rateAccuracyNew'])?$_POST['rateAccuracyNew']:$rateAccuracy;
$costAccuracyNew = isset($_POST['costAccuracyNew'])?$_POST['costAccuracyNew']:$costAccuracy;
$percentAccuracyNew = isset($_POST['percentAccuracyNew'])?$_POST['percentAccuracyNew']:$percentAccuracy;
$decimalPointNew = isset($_POST['decimalPointNew'])?$_POST['decimalPointNew']:$decimalPoint;
$thousandsSeparatorNew = isset($_POST['thousandsSeparatorNew'])?$_POST['thousandsSeparatorNew']:$thousandsSeparator;
$dateFormatNew = isset($_POST['dateFormatNew'])?$_POST['dateFormatNew']:$dateFormat;
$timeFormatNew = isset($_POST['timeFormatNew'])?$_POST['timeFormatNew']:$timeFormat;
$autoLockPeriodNew = isset($_POST['autoLockPeriodNew'])?$_POST['autoLockPeriodNew']:$autoLockPeriod;
$lockThresholdNew = isset($_POST['lockThresholdNew'])?$_POST['lockThresholdNew']:$lockThreshold;
$banThresholdNew = isset($_POST['banThresholdNew'])?$_POST['banThresholdNew']:$banThreshold;
$detectHijackNew = isset($_POST['detectHijackNew'])?$_POST['detectHijackNew']:$detectHijack;
$useLDAPNew = isset($_POST['useLDAPNew'])?$_POST['useLDAPNew']:$useLDAP;
$ldapserverNew = isset($_POST['ldapserverNew'])?$_POST['ldapserverNew']:$configLDAP['ldapserver'];
$ldapversionNew = isset($_POST['ldapversionNew'])?$_POST['ldapversionNew']:$configLDAP['ldapversion'];
$basednNew = isset($_POST['basednNew'])?$_POST['basednNew']:$configLDAP['basedn'];
$ldapuserNew = isset($_POST['ldapuserNew'])?$_POST['ldapuserNew']:$configLDAP['userdn'];
$ldappasswordNew = isset($_POST['ldappasswordNew'])?$_POST['ldappasswordNew']:$configLDAP['password'];
$devModeNew = isset($_POST['devModeNew'])?$_POST['devModeNew']:$devMode;
$action = AddSlashesNOD(isset($_GET['action'])?$_GET['action']:'');
$error = '';
$msg = '';
if ($defaultTheme == '') $defaultTheme = THEME;
if ($defaultPalette == '') $defaultPalette = PALETTE;

/**
 * Actions
 */
if ($action == 'generate') {
    if ($siteOff == 'true') {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "DELETE FROM " . $tablePrefix . "sessions WHERE id<>'" . session_id() . "'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "UPDATE " . $tablePrefix . "logs SET connected=NULL WHERE login<>'" . $_SESSION['loginSession'] . "'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    }

    if ($installationTypeNew == 'offline') {
        $updateCheckerNew = 'false';
    }

    if (substr($rootNew, -1) == '/') {
        $rootNew = substr($rootNew, 0, -1);
    }

    if (substr($ftpRootNew, -1) == '/') {
        $ftpRootNew = substr($ftpRootNew, 0, -1);
    }

    if (!$SW_Permissions['TextCustomization']['Admin'][$profilSession]) {
        $enableOnlineTextCustomizationNew = 'false';
    }

    if ($fileManagement == 'true') {
        $maxFileSizeNew = strtoupper($maxFileSizeNew);
        $g = strtok($maxFileSizeNew, 'G');
        $m = strtok($maxFileSizeNew, 'M');
        $k = strtok($maxFileSizeNew, 'K');

        if ($g !== false && is_numeric($g)) {
            $maxFileSizeNew = $g * 1024 * 1024 * 1024;
        } else if ($m !== false && is_numeric($m)) {
            $maxFileSizeNew = $m * 1024 * 1024;
        } else if ($k !== false && is_numeric($k)) {
            $maxFileSizeNew = $k * 1024;
        } else if (!is_numeric($maxFileSizeNew)) {
            $maxFileSizeNew = '2097152';
        }
    } else {
        $maxFileSizeNew = '0';
    }

    $content = <<<STAMP
<?php
/* vim: set expandtab ts=4 sw=4 sts=4: */
/***************************************************************************
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * webTareas Settings file
 ***************************************************************************/
#Path by root: ../includes/settings.php

# installation type
\$installationType = '$installationTypeNew'; // select 'offline' or 'online'

# database parameters
define('DBTYPE','$dbtype');
define('DBSERVER','$dbserver');
define('DBLOGIN','$dblogin');
define('DBPASSWORD','$dbpassword');
define('DBNAME','$dbname');

# notification method
\$notificationMethod = '$notificationMethodNew'; // select 'mail' or 'smtp'

# smtp parameters (only if \$notificationMethod == 'smtp')
define('SMTPSERVER','$smtpserverNew');
define('SMTPPORT','$smtpportNew');
define('SMTPSECURE','$smtpsecureNew');
define('SMTPLOGIN','$smtploginNew');
define('SMTPPASSWORD','$smtppasswordNew');

# create folder method
\$mkdirMethod = '$mkdirMethodNew'; // select 'FTP' or 'PHP'

# ftp parameters (only if \$mkdirMethod == 'FTP')
define('FTPSERVER','$ftpserverNew');
define('FTPLOGIN','$ftploginNew');
define('FTPPASSWORD','$ftppasswordNew');

# App root according to ftp account (only if \$mkdirMethod == 'FTP')
\$ftpRoot = '$ftpRootNew'; // no slash at the end

# Enable GMT Timezone
\$gmtTimezone = '$gmtTimezoneNew';

# default timezone
\$defaultTimezone = '$defaultTimezoneNew';

# language choice
\$langDefault = '$langDefaultNew';

# Default currency
\$defaultCurrency = '$defaultCurrencyNew';
\$currencyOnRight = '$currencyOnRightNew';

# https related parameters
\$pathToOpenssl = '$pathToOpenssl';

# The [en|de]cryption key unique to your site, used for session validity checks
\$cryptKey = '$cryptKey';

# login method, set to 'CRYPT' in order CVS authentication to work (if CVS support is enabled)
\$loginMethod = '$loginMethod'; // select 'MD5', 'CRYPT', or 'PLAIN'

# enable LDAP
\$useLDAP = '$useLDAPNew';
\$configLDAP['ldapserver'] = '$ldapserverNew';
\$configLDAP['ldapversion'] = '$ldapversionNew';
\$configLDAP['basedn'] = '$basednNew';
\$configLDAP['userdn'] = '$ldapuserNew';
\$configLDAP['password'] = '$ldappasswordNew';

# htaccess parameters
\$htaccessAuth = '$htaccessAuth';
\$fullPath = '$fullPath'; // no slash at the end

# file management parameters
\$fileManagement = '$fileManagement';
\$maxFileSize = $maxFileSizeNew; // bytes limit for upload
\$root = '$rootNew'; // no slash at the end

# Base directory of the webTareas installation, needs trailing slash
\$basedir = '$basedir';

# security issue to disallow php files upload
\$allowPhp = '$allowPhp';

# project site creation
\$sitePublish = '$sitePublish';

# enable timesheet
\$enableTimesheet = '$enableTimesheet';

# enable flextime
\$enableFlextime = '$enableFlextime';

# enable equipment management
\$enableEquipment = '$enableEquipment';

# enable material management
\$enableMaterial = '$enableMaterial';

# default project cost method
\$defaultCostMethod = '$defaultCostMethodNew';

# auto create project folder
\$autoCreateDir = '$autoCreateDirNew';

# unit of period  --- DO NOT MODIFY THIS VALUE
\$periodUnit = '$periodUnit';

# rule for determining the first week of the year  --- DO NOT MODIFY THIS VALUE
\$weekRule = '$weekRule';

# the day of the week  --- DO NOT MODIFY THIS VALUE
\$firstDayOfWeek = '$firstDayOfWeek';

# auto lock period
\$autoLockPeriod = '$autoLockPeriodNew';

# enable update checker
\$updateChecker = '$updateCheckerNew';

# e-mail notifications
\$notifications = '$notificationsNew';

# show peer review area
\$peerReview = '$peerReview';

# table prefix
\$tablePrefix = '$tablePrefix';

# App version
\$version = '$version';

# Gantt graphs
\$activeJpgraph = '$activeJpgraph';

# developement options in footer
\$footerDev = '$footerDevNew';

# filter to see only logged user projects (in team / owner)
\$projectsFilter = '$projectsFilterNew';

# Enable help center support requests, values 'true' or 'false'
\$enableHelpSupport = '$enableHelpSupport';

# Return email address given for clients to respond too.
\$supportEmail = '$supportEmail';

# filter to see both key & value of text array (online text customization)
\$enableOnlineTextCustomization = '$enableOnlineTextCustomizationNew';

# Html entity charset
\$htmlEntityCharset = '$htmlEntityCharset';

# Turn your site off
\$siteOff = '$siteOffNew';

# Turn development mode on
\$devMode = '$devModeNew';

# Contact Name Format
\$contactNameFormat = "$contactNameFormatNew";

# Decimal Places (0..6)
\$hourAccuracy = '$hourAccuracyNew';
\$quantityAccuracy = '$quantityAccuracyNew';
\$measureAccuracy = '$measureAccuracyNew';
\$rateAccuracy = '$rateAccuracyNew';
\$costAccuracy = '$costAccuracyNew';
\$percentAccuracy = '$percentAccuracyNew';

# Separator for the decimal point
\$decimalPoint = "$decimalPointNew";

# Thousands separator
\$thousandsSeparator = "$thousandsSeparatorNew";

# Date/Time Format
\$dateFormat = "$dateFormatNew";
\$timeFormat = "$timeFormatNew";

# Approval String Life Time
\$approvalStringLifeTime = '$approvalStringLifeTime';

# html header parameters
\$setTitle = '$setTitle';
\$setDescription = '$setDescription';
\$setKeywords = '$setKeywords';

# Account Lockout Threshold
\$lockThreshold = "$lockThresholdNew";

# IP Banned Threshold
\$banThreshold = "$banThresholdNew";

# Detect Hijack Activities
\$detectHijack = "$detectHijackNew";

# default theme
\$defaultTheme = "$defaultTheme";

# default menu palette
\$defaultPalette = "$defaultPalette";
?>
STAMP;

    if (!@fopen('../includes/settings.php', 'wb+')) {
        $msg = 'settingsNotwritable';
    } else {
        $fp = @fopen('../includes/settings.php', 'wb+');
        $fw = @fwrite($fp, $content);

        if (!$fw) {
            $msg = 'settingsNotwritable';
            fclose($fp);
        } else {
            fclose($fp);
            header('Location: ../administration/admin.php?msg=update&toggle_focus=system');
            exit;
        }
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php?toggle_focus=system', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('edit_settings'));
$blockPage->closeBreadcrumbs();
logURL($strings['edit_settings'], '../administration/updatesettings.php');
$block1 = new block();
$block1->heading(lang_strings('edit_settings'));
$block1->openContent(true);
$block1->contentTitle('General');
$block1->form = 'settings';
$block1->openForm('../administration/updatesettings.php?action=generate');
$safemodeTest = ini_get("safe_mode");

if ($safemodeTest == '1') {
    $safemode = 'on';
} else {
    $safemode = 'off';
}

$notificationsTest = function_exists('mail');

if ($notificationsTest == 'true') {
    $mail = 'on';
} else {
    $mail = 'off';
}

if ($SW_Permissions['System Settings']['Edit'][$profilSession]) {
    $block1->contentRow('Installation type', '<ul><li><input type="radio" name="installationTypeNew" value="offline" ' . (($installationTypeNew=='offline')?'checked':'') . '>Offline (firewall/intranet, no update checker)</li><li><input type="radio" name="installationTypeNew" value="online" ' . (($installationTypeNew=='online')?'checked':'') . '> Online</li></ul>');
    $block1->contentRow('Update checker', '<ul><li><input type="radio" name="updateCheckerNew" value="false" ' . (($updateCheckerNew=='false')?'checked':'') . '> False</li><li><input type="radio" name="updateCheckerNew" value="true" ' . (($updateCheckerNew=='true')?'checked':'') . '> True</li></ul>');
    $contentMkdirMethod = '
<ol>
    <li>
        <input type="radio" name="mkdirMethodNew" value="PHP" ' . (($mkdirMethodNew=='PHP')?'checked':'') . '> PHP
    </li><li>
        <input type="radio" name="mkdirMethodNew" value="FTP" ' . (($mkdirMethodNew=='FTP')?'checked':'') . '> FTP
    </li><li>
        <label for="ftpserverNew">Ftp server : </label><input value="' . $ftpserverNew . '" style="width: 200px" id="ftpserverNew" name="ftpserverNew" maxlength="100" type="text">
    </li><li>
        <label for="ftploginNew">Ftp login : </label><input value="' . $ftploginNew . '" style="width: 200px" id="ftploginNew" name="ftploginNew" maxlength="100" type="text">
    </li><li>
        <label for="ftppasswordNew">Ftp password : </label><input value="' . $ftppasswordNew . '" style="width: 200px" id="ftppasswordNew" name="ftppasswordNew" maxlength="100" type="password">
    </li><li>
        <label for="ftpRootNew">Ftp root : </label><input value="' . $ftpRootNew . '" style="width: 200px" id="ftpRootNew" name="ftpRootNew" maxlength="100" type="text">
    </li><li>
        [Safe-mode ' . $safemode . ']
    </li>
</ol>
';
    $block1->contentRow('Create folder method' . $blockPage->printHelp('setup_mkdirMethod'), $contentMkdirMethod);
    $contentNotificationMethod = '
<ol>
    <li>
        <input type="radio" name="notificationMethodNew" value="mail" ' . (($notificationMethodNew=='mail')?'checked':'') . '> PHP mail function
    </li><li>
        <input type="radio" name="notificationMethodNew" value="smtp" ' . (($notificationMethodNew=='smtp')?'checked':'') . '> SMTP
    </li><li>
        <label for="smtpserverNew">Smtp server : </label><input value="' . $smtpserverNew . '" style="width: 200px" id="smtpserverNew" name="smtpserverNew" maxlength="100" type="text">
    </li><li>
        <label for="smtpportNew">Smtp port : </label><input value="' . $smtpportNew . '" style="width: 200px" id="smtpportNew" name="smtpportNew" maxlength="3" type="text">
    </li><li>
        <label for="smtpsecureNew">Smtp connection prefix : </label><select style="width: 200px" id="smtpsecureNew" name="smtpsecureNew"><option value="" ' . (($smtpsecureNew=='')?'selected':'') . '></option><option value="ssl" ' . (($smtpsecureNew=='ssl')?'selected':'') . '>ssl</option><option value="tls" ' . (($smtpsecureNew=='tls')?'selected':'') . '>tls</option></select>
    </li><li>
        <label for="smtploginNew">Smtp login : </label><input value="' . $smtploginNew . '" style="width: 200px" id="smtploginNew" name="smtploginNew" maxlength="100" type="text">
    </li><li>
        <label for="smtppasswordNew">Smtp password : </label><input value="' . $smtppasswordNew . '" style="width: 200px" id="smtppasswordNew" name="smtppasswordNew" maxlength="100" type="password">
    </li>
</ol>
';
    $block1->contentRow('Notification method' . $blockPage->printHelp('setup_notificationMethod'), $contentNotificationMethod);
    $block1->contentRow('Notifications' . $blockPage->printHelp('setup_notifications'), '<ul><li><input type="radio" name="notificationsNew" value="false" ' . (($notificationsNew=='false')?'checked':'') . '> False</li><li><input type="radio" name="notificationsNew" value="true" ' . (($notificationsNew=='true')?'checked':'') . '> True</li></ul><div class="clear">[Mail ' . $mail . ']</div>');
    // build default language drop list
    array_multisort($langValue, SORT_ASC, SORT_STRING);
    $selectLanguage = '<select name="langDefaultNew">';

    foreach ($langValue as $key => $value) {
        if (file_exists('../languages/lang_' . $key . '.php')) {
            if ($langDefaultNew == $key) {
                $selectLanguage .= '<option value="' . $key . '" selected>' . $value . '</option>';
            } else {
                $selectLanguage .= '<option value="' . $key . '">' . $value . '</option>';
            }
        }
    }

    $selectLanguage .= '</select>';
    $block1->contentRow('* Default language' . $blockPage->printHelp('setup_langdefault'), $selectLanguage);
    $helpStr = '<table>';
    $currencyStr = '<select name="defaultCurrencyNew">';

    foreach ($CurrencyMatrix['active'] as $currCode) {
        $currName = $CurrencyMatrix['name'][$currCode];
        $helpStr .= '<tr><th>' . $currCode . '</th><td>' . $currName . '</td></tr>';
        $currencyStr .= '<option value="' . $currCode . '"';

        if ($currCode == $defaultCurrencyNew) {
            $currencyStr .= ' selected';
        }

        $currencyStr .= '>' . $currCode . '</option>';
    }

    $currencyStr .= '</select>';
    $helpStr .= '</table>';
    $block1->contentRow("Default currency " . $blockPage->printHelp($helpStr, true), $currencyStr);
    $block1->contentRow(lang_strings('default_cost_method') . $blockPage->printHelp('setup_costmethoddefault'), '<ol><li>
<input type="radio" name="defaultCostMethodNew" value="1"' . (($defaultCostMethodNew=='1')?' checked':'') . '>' . fieldValidValueString('projects', 'cost_method', '1') . '</li><li>
<input type="radio" name="defaultCostMethodNew" value="2"' . (($defaultCostMethodNew=='2')?' checked':'') . '>' . fieldValidValueString('projects', 'cost_method', '2') . '</li><li>
<input type="radio" name="defaultCostMethodNew" value="3"' . (($defaultCostMethodNew=='3')?' checked':'') . '>' . fieldValidValueString('projects', 'cost_method', '3') . '</li></ol>');
    $block1->contentRow(lang_strings('auto_create_folder') . $blockPage->printHelp('setup_createfolder'), '<ul><li>
<input type="radio" name="autoCreateDirNew" value="true"' . (($autoCreateDirNew=='true')?' checked':'') . '> ' . lang_strings('yes') . '</li><li>
<input type="radio" name="autoCreateDirNew" value="false"' . (($autoCreateDirNew!='true')?' checked':'') . '> ' . lang_strings("no") . '</li></ul>');
    $block1->contentRow('* Root', '<input value="' . $rootNew . '" style="width: 200px" name="rootNew" maxlength="100" type="text">');

    if ($fileManagement == 'true') {
        $block1->contentRow('* Max file size', '<input value="' . str_replace(array(' ','B'), '', convertSize($maxFileSizeNew)) . '" style="width: 200px" name="maxFileSizeNew" maxlength="100" type="text">');
    } else {
        echo '<input type="hidden" name="maxFileSizeNew" value="0">';
    }

    $autoLockStr = '<select name="autoLockPeriodNew">';

    foreach (array('0', '1', '2', '3', '5', '7', '14', '21', '28') as $d) {
        if ($d == $autoLockPeriodNew) {
            $autoLockStr .= '<option value="' . $d . '" selected>' . $d . '</option>';
        } else {
            $autoLockStr .= '<option value="' . $d . '">' . $d . '</option>';
        }
    }

    $autoLockStr .= '</select>';
    $block1->contentRow('Auto Lock Period' . $blockPage->printHelp('setup_autolockperiod'), $autoLockStr);
    $block1->contentTitle("LDAP Integration");
    $block1->contentRow("Enable LDAP Integration", "<input type=\"radio\" name=\"useLDAPNew\" value=\"true\"" . (($useLDAPNew == "true")?' checked':'') . "> True&nbsp;&nbsp;<input type=\"radio\" name=\"useLDAPNew\" value=\"false\"" . (($useLDAPNew == "true")?'':' checked') . "> False");
    $block1->contentRow("URL to LDAP server", "<input size=\"44\" value=\"$ldapserverNew\" style=\"width: 200px\" name=\"ldapserverNew\" maxlength=\"100\" type=\"text\">");
    $block1->contentRow("LDAP protocol version", "<input type=\"radio\" name=\"ldapversionNew\" value=\"2\"" . (($ldapversionNew == "2")?' checked':'') . "> 2&nbsp;&nbsp;<input type=\"radio\" name=\"ldapversionNew\" value=\"3\"" . (($ldapversionNew == "2")?'':' checked') . "> 3");
    $block1->contentRow("Base DN", "<input size=\"44\" value=\"$basednNew\" style=\"width: 200px\" name=\"basednNew\" maxlength=\"255\" type=\"text\">");
    $block1->contentRow("User DN", "<input size=\"44\" value=\"$ldapuserNew\" style=\"width: 200px\" name=\"ldapuserNew\" maxlength=\"255\" type=\"text\">");
    $block1->contentRow("Password", "<input size=\"44\" value=\"$ldappasswordNew\" style=\"width: 200px\" name=\"ldappasswordNew\" maxlength=\"100\" type=\"password\">");
    $block1->contentTitle('Display');
    $contactNameFormatSel = '<select name="contactNameFormatNew">';

    foreach ($contactNameFormats as $key => $val) {
        if ($contactNameFormatNew == $key) {
            $contactNameFormatSel .= '<option value="' . $key . '" selected>' . $val . '</option>';
        } else {
            $contactNameFormatSel .= '<option value="' . $key . '">' . $val . '</option>';
        }
    }

    $contactNameFormatSel .= '</select>';
    $block1->contentRow($strings['contact_name_format'], $contactNameFormatSel);
    setupDecimalPlaceSelectionHtml($block1, "Decimal Place for Log Hours", "hourAccuracyNew", $hourAccuracyNew);
    setupDecimalPlaceSelectionHtml($block1, "Decimal Place for Quantity", "quantityAccuracyNew", $quantityAccuracyNew);
    setupDecimalPlaceSelectionHtml($block1, "Decimal Place for Measure", "measureAccuracyNew", $measureAccuracyNew);
    setupDecimalPlaceSelectionHtml($block1, "Decimal Place for Service Rate/Price", "rateAccuracyNew", $rateAccuracyNew);
    setupDecimalPlaceSelectionHtml($block1, "Decimal Place Project Cost/Expense/for Totals", "costAccuracyNew", $costAccuracyNew);
    setupDecimalPlaceSelectionHtml($block1, "Decimal Place for Percentage", "percentAccuracyNew", $percentAccuracyNew);
    $block1->contentRow('Separator for the decimal point', '<input type="text" name="decimalPointNew" value="' . $decimalPointNew . '" size="2" maxlength="2">');
    $block1->contentRow('Thousands separator', '<input type="text" name="thousandsSeparatorNew" value="' . $thousandsSeparatorNew . '" size="2" maxlength="2">');
    $dateFormatSel = '<select name="dateFormatNew">';

    foreach ($dateFormats as $key => $val) {
        if ($key == $dateFormatNew) {
            $dateFormatSel .= '<option value="' . $key . '" selected>' . $val . '</option>';
        } else {
            $dateFormatSel .= '<option value="' . $key . '">' . $val . '</option>';
        }
    }

    $dateFormatSel .= '</select>';
    $block1->contentRow("Default Date Format", $dateFormatSel);
    $timeFormatSel = '<select name="timeFormatNew">';

    foreach ($timeFormats as $i) {
        if ($i == $timeFormatNew) {
            $timeFormatSel .= '<option value="' . $i . '" selected>' . $i . '</option>';
        } else {
            $timeFormatSel .= '<option value="' . $i . '">' . $i . '</option>';
        }
    }

    $timeFormatSel .= '</select>';
    $block1->contentRow("Default Time Format", $timeFormatSel);
    $block1->contentRow('Enable GMT Timezone', '<ul><li><input type="radio" name="gmtTimezoneNew" value="false" ' . (($gmtTimezoneNew=='false')?'checked':'') . '> False</li><li><input type="radio" name="gmtTimezoneNew" value="true" ' . (($gmtTimezoneNew=='true')?'checked':'') . '> True</li></ul>');
    $defaultTimezoneSel = '<select name="defaultTimezoneNew">';

    foreach ($timezoneTable as $val => $desc) {
        if ($val == $defaultTimezoneNew) {
            $defaultTimezoneSel .= '<option value="' . $val . '" selected>' . $desc . '</option>';
        } else {
            $defaultTimezoneSel .= '<option value="' . $val . '">' . $desc . '</option>';
        }
    }

    $defaultTimezoneSel .= '</select>';
    $block1->contentRow('Default Timezone', $defaultTimezoneSel);
    $block1->contentRow("Display Currency on the Right", '<ul><li><input type="radio" name="currencyOnRightNew" value="false" ' . (($currencyOnRightNew=='false')?'checked':'') . '> False</li><li><input type="radio" name="currencyOnRightNew" value="true" ' . (($currencyOnRightNew=='true')?'checked':'') . '> True</li></ul>');
    $block1->contentTitle('Options');
    $block1->contentRow('Projects filter' . $blockPage->printHelp('setup_projectsfilter'), '<ul><li><input type="radio" name="projectsFilterNew" value="false" ' . (($projectsFilterNew=='false')?'checked':'') . '> False</li><li><input type="radio" name="projectsFilterNew" value="true" ' . (($projectsFilterNew=='true')?'checked':'') . '> True</li></ul>');
    $block1->contentTitle('Security');
    $lockThresholdSel = '<select name="lockThresholdNew">';
    $lockThresholdOpts = array('0', '3', '5', '10');

    foreach ($lockThresholdOpts as $i) {
        $desc = ($i==0)?'Never':$i;
        $lockThresholdSel .= '<option value="' . $i . '"' . ((strval($lockThresholdNew) == strval($i))?' selected':'') . '>' . $desc . '</option>';
    }

    $lockThresholdSel .= '</select>';
    $block1->contentRow('Account Lockout Threshold', $lockThresholdSel);
    $banThresholdSel = '<select name="banThresholdNew">';
    $banThresholdOpts = array('0', '15', '25', '50');

    foreach ($banThresholdOpts as $i) {
        $desc = ($i==0)?'Never':$i;
        $banThresholdSel .= '<option value="' . $i . '"' . ((strval($banThresholdNew) == strval($i))?' selected':'') . '>' . $desc . '</option>';
    }

    $banThresholdSel .= '</select>';
    $block1->contentRow("IP Banned Threshold " . $blockPage->printHelp("setup_banThreshold"), $banThresholdSel);
    $block1->contentRow('Detect Suspicious Sign-In', '<ul><li><input type="radio" name="detectHijackNew" value="on"' . (($detectHijackNew=='on')?' checked':'') . '> On</li><li><input type="radio" name="detectHijackNew" value=""' . (($detectHijackNew=='')?' checked':'') . '> Off</li></ul>');
    $block1->contentTitle('Advanced');
    $block1->contentRow('Extended footer (dev)', '<ul><li><input type="radio" name="footerDevNew" value="false" ' . (($footerDevNew!='true')?'checked':'') . '> False</li><li><input type="radio" name="footerDevNew" value="true" ' . (($footerDevNew=='true')?'checked':'') . '> True</li></ul>');

    if ($SW_Permissions['TextCustomization']['Admin'][$profilSession]) {
        $block1->contentRow('Online text customization mode','<ul><li><input type="radio" name="enableOnlineTextCustomizationNew" value="false" '.(($enableOnlineTextCustomizationNew!='true')?'checked':'').'> Off</li><li><input type="radio" name="enableOnlineTextCustomizationNew" value="true" '. (($enableOnlineTextCustomizationNew=='true')?'checked':'') .'> On</li></ul>');
    } else {
        echo '<input type="hidden" name="enableOnlineTextCustomizationNew" value="' . $enableOnlineTextCustomizationNew . '">';
        $block1->contentRow('Online text customization mode', ($enableOnlineTextCustomizationNew=='true'?"True":"False"));
    }

    $block1->contentRow('Turn your site off ?','<ul><li><input type="radio" name="siteOffNew" value="false" '. (($siteOffNew!='true')?'checked':'') .'> No</li><li><input type="radio" name="siteOffNew" value="true" '. (($siteOffNew=='true')?'checked':'') .'> Yes</li></ul>');
    $block1->contentRow('Turn development mode on ?','<ul><li><input type="radio" name="devModeNew" value="false" '. (($devModeNew!='true')?'checked':'') .'> No</li><li><input type="radio" name="devModeNew" value="true" '. (($devModeNew=='true')?'checked':'') .'> Yes</li></ul>');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
} else {
    $block1->contentRow('Installation type', ($installationType == 'offline'?"Offline (firewall/intranet, no update checker)":"Online"));
    $block1->contentRow('Update checker', ($updateChecker=='true'?"True":"False"));
    $block1->contentRow('Create folder method' . $blockPage->printHelp('setup_mkdirMethod'), $mkdirMethod);
    $block1->contentRow('Notification method' . $blockPage->printHelp('setup_notificationMethod'), $notificationMethod);
    $block1->contentRow('Notifications' . $blockPage->printHelp('setup_notifications'), ($notifications=='true'?"True":"False"));
    $block1->contentRow('Default language' . $blockPage->printHelp('setup_langdefault'), $langDefault);
    $block1->contentRow('Default currency' . $blockPage->printHelp($helpStr, true), $defaultCurrency);
    $block1->contentRow(lang_strings('default_cost_method') . $blockPage->printHelp('setup_costmethoddefault'), fieldValidValueString('projects', 'cost_method', $defaultCostMethod));
    $block1->contentRow(lang_strings('auto_create_folder') . $blockPage->printHelp('setup_createfolder'), (($autoCreateDir=='true')?lang_strings('yes'):lang_strings('no')));
    $block1->contentRow('Root', $root);

    if ($fileManagement == 'true') {
        $block1->contentRow('Max file size', $maxFileSize . "&nbsp;" . $byteUnits[0]);
    }

    $block1->contentRow('Auto Lock Period' . $blockPage->printHelp('setup_autolockperiod'), $autoLockPeriod);
    $block1->contentTitle('Display');
    $block1->contentRow("Decimal Place for Log Hours", $hourAccuracy);
    $block1->contentRow("Decimal Place for Quantity", $quantityAccuracy);
    $block1->contentRow("Decimal Place for Measure", $measureAccuracy);
    $block1->contentRow("Decimal Place for Service Rate/Price", $rateAccuracy);
    $block1->contentRow("Decimal Place for Project Cost/Expense/Totals", $costAccuracy);
    $block1->contentRow("Decimal Place for Percentage", $percentAccuracy);
    $block1->contentRow('Separator for the decimal point', $decimalPoint);
    $block1->contentRow('Thousands separator', $thousandsSeparator);
    $block1->contentRow("Default Date Format", $dateFormats[$dateFormat]);
    $block1->contentRow("Default Time Format", $timeFormat);
    $block1->contentRow('Enable GMT Timezone', ($gmtTimezone=='true'?"True":"False"));
    $block1->contentRow('Default Timezone', $timezoneTable[$defaultTimezone]);
    $block1->contentRow("Display Currency on the Right", ($currencyOnRight=="true"?"True":"False"));
    $block1->contentTitle('Options');
    $block1->contentRow('Projects filter' . $blockPage->printHelp('setup_projectsfilter'), ($projectsFilter=='true'?"True":"False"));
    $block1->contentTitle('Advanced');
    $block1->contentRow('Extended footer (dev)', ($footerDev=='true'?"True":"False"));
    $block1->contentRow('Online text customization mode', ($enableOnlineTextCustomization=='true'?"True":"False"));
    $block1->contentRow('Turn your site off ?', ($siteOff=='true'?"True":"False"));
    $block1->contentRow('Turn development mode on ?', ($devMode=='true'?"True":"False"));
}

$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once('../includes/footer.php');
