<?php // $Revision: 1.15 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: updatestrings.php,v 1.15 2013/02/01 02:25:47 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
$bodyCommand = 'onLoad="document.udSForm.sv.focus();"';

/**
 * Variables init
 */
$string_key = AddSlashesNOD(isset($_GET['string_key'])?$_GET['string_key']:'');    // The key of string
$list = isset($_GET['list'])?$_GET['list']:'';                      // The beginning letter of strings
$sv = isset($_POST['sv'])?$_POST['sv']:'';                          // The key list of strings
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$del = isset($_GET['del'])?$_GET['del']:'';                         // Delete text customization
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$patt = strtolower(AddSlashesNOD(isset($_REQUEST['patt'])?$_REQUEST['patt']:''));   // pattern for strings
$error = '';
$new_string = false;

if ($action == 'search' && $patt == '') {
    $action = '';
}

if ($patt == '') {
    if ($list == '') {
        $list = 'A';
    }
} else {
    $list = '';
}

/**
 * Permission check
 */
if (!$SW_Permissions['TextCustomization']['Admin'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($action != '' && $string_key == '' && $sv == '') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Actions
 */
if ($action != '') {
    if ($string_key == '') {    // customize all strings with the same beginning letter
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();

            foreach ($sv as $key) {
                $val0 = $_POST['sv' . $key];
                $tmpquery = " WHERE str.string_key='$key' AND language='$lang'";
                $stringsDetail = clone $requestAct;
                $stringsDetail->openStrings($tmpquery);
                $comptStringsDetail = count($stringsDetail->str_string_key);
                $val = HtmlEntitiesNOD($val0);

                if ($comptStringsDetail == '0') {
                    $tmpsql = "INSERT INTO " . $tablePrefix . "strings (string_key,language,string_val) VALUES ('$key','$lang','$val')";
                } else {
                    $tmpsql = 'UPDATE ' . $tablePrefix . "strings SET string_val='$val' WHERE string_key='$key' AND language='$lang'";
                }

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header('Location: ../administration/updatestrings.php?list=' . $list . '&patt=' . $patt . '&msg=update');
            exit;
        }
    } else {                    // customize single string
        $sv = HtmlEntitiesNOD($sv);
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();

            if ($action == 'update') {          // add a text customization
                $tmpsql = 'UPDATE ' . $tablePrefix . "strings SET string_val='$sv' WHERE string_key='$string_key' AND language='$lang'";
            } else if ($action == 'add') {      // update a text customization
                $tmpsql = 'INSERT INTO ' . $tablePrefix . "strings (string_key,language,string_val) VALUES ('$string_key','$lang','$sv')";
            }

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if ($action == 'update') {          // add a text customization
                header('Location: ../administration/updatestrings.php?msg=update&string_key=' . $string_key);
            } else if ($action == 'add') {      // update a text customization
                header('Location: ../administration/updatestrings.php?msg=add&string_key=' . $string_key);
            }

            exit;
        }
    }
}

if ($del == 'true') {   // Delete text customization
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($string_key == '') {
            $old_strings = $strings;    // backup strings
            unset($strings);
            require('../languages/lang_' . $lang . '.php');     // reload original strings

            foreach ($strings as $k => $v) {
                $tmpsql = "DELETE FROM " . $tablePrefix . "strings WHERE language='$lang' AND string_key='$k'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        } else {
            $tmpsql = "DELETE FROM " . $tablePrefix . "strings WHERE language='$lang' AND string_key='$string_key'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../administration/updatestrings.php?msg=delete&string_key=' . $string_key);
        exit;
    }
}

/**
 * Prepare data
 */
if ($error == '') {
    if ($string_key != '') {
        $querymore = " WHERE str.string_key='$string_key' AND str.language='$lang'";
        $stringsDetail = new request();
        $stringsDetail->openStrings($querymore);
        $comptStringsDetail = count($stringsDetail->str_string_key);

        if ($comptStringsDetail == 0) {
            $new_string = true;
            $string_val = $strings[$string_key];
        } else {
            $string_val = $stringsDetail->str_string_val[0];
        }
    } else if ($patt != '') {
        $s2 = array();
        $patt1 = '/' . $patt . '/i';

        foreach ($strings as $key => $val) {
            if (preg_match($patt1, $key) || preg_match($patt1, $val)) {
                $s2[$key] = $val;
            }
        }
    } else {
        $s2 = array();

        foreach ($strings as $key => $val) {
            $a = strtoupper(substr($key, 0, 1));

            if ($a == $list) {
                $s2[$key] = $val;
            }
        }
    }
}

$tmpquery = "SELECT * FROM " . $tablePrefix . "strings WHERE language='$lang'";
$compt1 = compt($tmpquery);

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php?toggle_focus=language', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('text_customization'));
$blockPage->closeBreadcrumbs();

if ($string_key == '') {
    $s1 = array();

    foreach ($strings as $key => $val) {
        $a = strtoupper(substr($key, 0, 1));

        if (!in_array($a, $s1)) {
            $s1[] = $a;
        }
    }

    sort($s1);
    ksort($s2);
    $links = "&nbsp;&nbsp;&nbsp;&nbsp;[";

    foreach ($s1 as $a) {
        if ($list == $a) {
            $links .= "&nbsp;$a&nbsp;|";
        } else {
            $links .= "&nbsp;" . $blockPage->buildLink('../administration/updatestrings.php?list=' . $a, $a, 'in') . "&nbsp;|";
        }
    }

    $links = substr($links, 0, -1) . ']';
}

if ($patt == '' || ($patt != '' && count($s2) > 0)) {
    $block1 = new block();
    $block1->form = "udS";
    $block1->openForm("../administration/updatestrings.php?string_key=$string_key&list=$list#" . $block1->form . "Anchor");

    if ($new_string) {
        echo '<input type="hidden" name="action" value="add">';
    } else {
        echo '<input type="hidden" name="action" value="update">';
    }

    $block1->openContent();
    setupInputHTML($block1, '<input type="button" value="' . $strings['search'] . '" onclick="searchText();">', 'patt', enumFieldType::ftText, 'N', 255, $patt);
    $block1->closeContent();
    $block1->heading($strings['text_customization'] . $links);

    if ($compt1 != '0') {
        $block1->openPaletteIcon();

        if (!$new_string || $string_key == '') {
            $block1->paletteIcon(1, "remove", $strings["delete"]);
        }

        $block1->paletteIcon(2, "export", $strings["export"]);
        $block1->closePaletteIcon();
    }

    $block1->openContent();

    if ($string_key == '') {
        $block1->contentTitle($strings['text_customization']);
        $i = 0;

        foreach ($s2 as $key => $val) {
            echo '<input type="hidden" name="sv[' . $i++ . ']" value="' . $key . '">';
            setupInputHTML($block1, $key, 'sv' . $key, enumFieldType::ftText, 'Y', '65535', str_replace('"', '&quot;', $val));
        }
    } else {
        $block1->contentTitle($strings['text_customization'] . " - $string_key");
        setupInputHTML($block1, $strings["description"], 'sv', enumFieldType::ftText, 'Y', '65535', str_replace('"', '&quot;', $string_val));
    }

    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();

    if ($compt1 != '0') {
        $block1->openPaletteScript();

        if (!$new_string || $string_key == '') {
            $block1->paletteScript(1, "remove", "../administration/updatestrings.php?string_key=$string_key&del=true", "true,true,true", $strings["delete"]);
        }

        $block1->paletteScript(2, "export", "../administration/exporttranslation.php", "true,true,true", $strings["export"]);
        $block1->closePaletteScript("", "");
    }

    $block1->closeForm();
} else if ($patt != '' && count($s2) == 0) {
    $block1 = new block();
    $block1->form = "udS";
    $block1->openForm("../administration/updatestrings.php?string_key=$string_key&list=$list#" . $block1->form . "Anchor");
    $block1->openContent();
    setupInputHTML($block1, '<input type="button" value="' . $strings['search'] . '" onclick="searchText();">', 'patt', enumFieldType::ftText, 'N', 255, $patt);
    $block1->closeContent();
    $block1->heading($strings['text_customization'] . $links);
    $block1->noresults();
    $block1->closeForm();
}

?>
<script type="text/javascript">
function searchText(){
    var x = document.udSForm.action;
    x.value = '';
    document.udSForm.submit();
}
</script>
<?php
require_once('../includes/footer.php');
