<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewcurrencyrates.php,v 1.13 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$thisMonth = date("Y-m");
$action = isset($_POST['action'])?$_POST['action']:'';
$currency_from = AddSlashesNOD(isset($_REQUEST['currency_from'])?$_REQUEST['currency_from']:$defaultCurrency);
$month = isset($_GET['month'])?$_GET['month']:$thisMonth;
$prevMonth = date('Y-m', mktime(0, 0, 0, intval(substr($month, 5, 2)) - 1, 1, intval(substr($month, 0, 4))));
$nextMonth = date('Y-m', mktime(0, 0, 0, intval(substr($month, 5, 2)) + 1, 1, intval(substr($month, 0, 4))));
$rates = isset($_POST['rates'])?$_POST['rates']:'';
$msg = '';
$error = '';

/**
 * Permission check
 */
if ($action == 'update') {
    if (!$SW_Permissions['Currency Rate']['Edit'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} else {
    if (!$SW_Permissions['Currency Rate']['Read'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'update') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        foreach ($rates as $refdate => $ratesCurr) {
            foreach ($ratesCurr as $curr => $rate) {
                if (is_numeric($rate) && floatval($rate)>0) {
                    $tmpquery = " WHERE cur.currency_from='$currency_from' AND cur.currency_to='$curr' AND cur.reference_date='$refdate'";
                    $currencyRateDetail = clone $requestAct;
                    $currencyRateDetail->openCurrencyRates($tmpquery);
                    $comptCurrencyRateDetail = count($currencyRateDetail->cur_currency_from);
                    $exchange_rate = round(floatval($rate), 5);

                    if ($comptCurrencyRateDetail == '0') {
                        $tmpsql = "INSERT INTO " . $tablePrefix . "currency_rates (currency_from,currency_to,reference_date,exchange_rate,created,cuser) VALUES ('$currency_from','$curr','$refdate','$exchange_rate','" . time() . "','$idSession')";
                    } else {
                        $tmpsql = "UPDATE " . $tablePrefix . "currency_rates SET exchange_rate='$exchange_rate',modified='" . time() . "',muser='$idSession' WHERE currency_from='$currency_from' AND currency_to='$curr' AND reference_date='$refdate'";
                    }

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        $msg = 'update';
    }
}

/**
 * Load data
 */
if ($error == '') {
    unset($rates);
    $sts = mktime(0,0,0,intval(substr($month,5,2)),1,intval(substr($month,0,4)));
    $ets = mktime(0,0,0,intval(substr($month,5,2))+1,0,intval(substr($month,0,4)));
    $querymore = " WHERE cur.currency_from='$currency_from' AND cur.currency_to IN ('" . implode("','", $CurrencyMatrix['active']) . "') AND cur.reference_date>='$sts' AND cur.reference_date<='$ets' ORDER BY cur.currency_to,cur.reference_date";
    $listCurrencyRates = new request();
    $listCurrencyRates->openCurrencyRates($querymore);
    $comptListCurrencyRates = count($listCurrencyRates->cur_currency_from);

    foreach ($CurrencyMatrix['active'] as $key) {
        if ($key == $currency_from) {
            continue;
        }

        for ($d=$sts; $d<=$ets; $d=mktime(0,0,0,intval(date('m',$d)),intval(date('d',$d))+1,intval(date('Y',$d)))) {
            $rates[$d][$key] = '';
        }
    }

    for ($i=0; $i<$comptListCurrencyRates; $i++) {
        $rates[$listCurrencyRates->cur_reference_date[$i]][$listCurrencyRates->cur_currency_to[$i]] = $listCurrencyRates->cur_exchange_rate[$i];
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php?toggle_focus=accounting', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/viewcurrencyrates.php?currency_from=' . $currency_from, lang_strings('exchange_rates'), 'in'));
$blockPage->closeBreadcrumbs();
$title = $strings['exchange_rates'] . ' : ' . $currency_from . ' ' . $month;
logURL($title, "../administration/viewcurrencyrates.php?month=$month&currency_from=$currency_from");
$block1 = new block();
$block1->form = "cuR";
$block1->openForm("../administration/viewcurrencyrates.php?month=$month#" . $block1->form . "Anchor");
$helpStr = '<table>';
$currSel = "<select name=\"currency_from\" onchange=\"currency_changed()\">";

foreach ($CurrencyMatrix['active'] as $key) {
    $val = $CurrencyMatrix['name'][$key];
    $helpStr .= '<tr><th>' . $key . '</th><td>' . $val . '</td></tr>';

    if ($key == $currency_from) {
        $currSel .= '<option value="' . $key . '" selected>' . $key . '</option>';
    } else {
        $currSel .= '<option value="' . $key . '">' . $key . '</option>';
    }
}

$helpStr .= '</table>';
$currSel .= "</select>";
$block1->heading('<div class="right"><a href="../administration/viewcurrencyrates.php?currency_from=' . $currency_from . '&amp;month=' . $nextMonth . '"><div class="solid-ball">&gt;</div></a></div><div class="left"><a href="../administration/viewcurrencyrates.php?currency_from=' . $currency_from . '&amp;month=' . $prevMonth . '"><div class="solid-ball">&lt;</div></a></div><div class="screen-center">' . lang_strings('exchange_rates') . ' ' . $month . ' ' . $currSel . '</div>');
echo $blockPage->printHelp($helpStr, true, 'left');
$labels = array('&nbsp;');

foreach ($CurrencyMatrix['active'] as $key) {
    if ($key != $currency_from) {
        $labels[] = $key;
    }
}

$block1->openResults(false);
$block1->labels($labels, 'false', 'false');

foreach ($rates as $refdate => $ratesCurr) {
    $block1->openRow();
    $block1->cellRow(date('j', $refdate));

    if ($SW_Permissions['Currency Rate']['Edit'][$profilSession]) {
        foreach ($ratesCurr as $curr => $rate) {
            $block1->cellRow('<input type="text" name="rates[' . $refdate . '][' . $curr . ']" value="' . $rate . '" maxlength="19">');
        }
    } else {
        foreach ($ratesCurr as $curr => $rate) {
            $block1->cellRow($rate);
        }
    }

    $block1->closeRow();
}

$block1->labels($labels, 'false', 'false');
$block1->closeResults();

if ($SW_Permissions['Currency Rate']['Edit'][$profilSession]) {
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
    $block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
}

$block1->closeFormResults();
?>
<script type="text/javascript">
function currency_changed(){
    var x = document.cuRForm.action;
    x.value = '';
    document.cuRForm.submit();
}
</script>
<?php
require_once('../includes/footer.php');
