<?php // $Revision: 1.19 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: adddocument.php,v 1.19 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

if ($producer == '' || $doctype == '' || !defined('INNER_ADDDOCUMENT')) {
    exit;
}

$listApprovals1 = clone $requestAct;
$listApprovals1->openApprovals1($producer, $doctype);
$comptListApprovals1 = count($listApprovals1->app_id);

for ($ife=0; $ife<$comptListApprovals1; $ife++) {
    $approval = $listApprovals1->app_id[$ife];
    $userquery = $listApprovals1->app_userquery[$ife];
    // get the table definition of the approval document type
    $querymore = " WHERE tdf.tablename='$doctype'";
    $tableDefinitionDetail = clone $requestAct;
    $tableDefinitionDetail->openTablesDefinitions($querymore);

    if (count($tableDefinitionDetail->tdf_id) == 0) {
        exit;
    }

    if ($listApprovals1->app_conditions[$ife] == 'Y') {
        // get approval criteria list
        $querymore1 = " WHERE apt.approval='$approval'";
        $listApprovalTerms = clone $requestAct;
        $listApprovalTerms->openApprovalsTerms($querymore1);
        $comptListApprovalTerms = count($listApprovalTerms->apt_approval);
        // get field definition list of the approval document type
        $querymore2 = " WHERE fdf.tablename='$doctype'";
        $listFieldsDefinitions = clone $requestAct;
        $listFieldsDefinitions->openFieldsDefinitions($querymore2);
        $comptListFieldsDefinitions0 = count($listFieldsDefinitions->fdf_tablename);
        // initial linked table information list
        $lktblinfo = array();
        // initial the table alias index of all fields
        $fieldtblA = array();

        // get field definition list for linked tables
        for ($jfe=0,$lfe=1; $jfe<$comptListFieldsDefinitions0; $jfe++) {
            $fieldtblA[$listFieldsDefinitions->fdf_fieldname[$jfe]] = 'f0';
            $listFieldsDefinitions->fdf_dbfieldname[$jfe] = 'f0.' . $listFieldsDefinitions->fdf_dbfieldname[$jfe];

            if ($listFieldsDefinitions->fdf_linkedtable[$jfe] == '') {
                continue;
            }

            $querymore = " WHERE fdf.tablename='" . $listFieldsDefinitions->fdf_linkedtable[$jfe] . "' ORDER BY fdf.sysdef DESC,fdf.fieldname";
            $listFieldsDefinitionsLT = clone $requestAct;
            $listFieldsDefinitionsLT->openFieldsDefinitions($querymore);
            $comptListFieldsDefinitionsLT = count($listFieldsDefinitionsLT->fdf_tablename);

            if ($comptListFieldsDefinitionsLT != '0') {
                $alias = 'f' . $lfe++;
                $lktblinfo[$alias] = array(
                    'dbtablename' => $listFieldsDefinitionsLT->fdf_dbtablename[0],
                    'dbfieldname' => $listFieldsDefinitions->fdf_dbfieldname[$jfe]
                );

                for ($kfe=0; $kfe<$comptListFieldsDefinitionsLT; $kfe++) {
                    $fldnam = $listFieldsDefinitions->fdf_fieldname[$jfe] . '.' . $listFieldsDefinitionsLT->fdf_fieldname[$kfe];
                    $fieldtblA[$fldnam] = $alias;
                    $listFieldsDefinitions->fdf_tablename[] = $listFieldsDefinitionsLT->fdf_tablename[$kfe];
                    $listFieldsDefinitions->fdf_fieldname[] = $fldnam;
                    $listFieldsDefinitions->fdf_dbfieldname[] = $alias . "." . $listFieldsDefinitionsLT->fdf_dbfieldname[$kfe];
                }
            }
        }
        // re-caculate size of field definition list
        $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);
        $tmpquery = "SELECT f0.id FROM " . $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0] . " f0 ";

        foreach ($lktblinfo as $alias => $infos) {
            $tmpquery .= "LEFT OUTER JOIN " . $tablePrefix . $infos['dbtablename'] . " " . $alias . " ON " . $alias . ".id=" . $infos['dbfieldname'] . " ";
        }

        $tmpquery .= "WHERE f0.id='$num'";

        for ($jfe=0; $jfe<$comptListApprovalTerms; $jfe++) {
            $fldnam = $listApprovalTerms->apt_fieldname[$jfe];
            $kfe = array_search($fldnam, $listFieldsDefinitions->fdf_fieldname);
            $subquery = $listFieldsDefinitions->fdf_dbfieldname[$kfe];

            switch ($listApprovalTerms->apt_ratio[$jfe]) {
                case enumRatio::rGreaterThan:
                    $subquery .= ">";
                    break;
                case enumRatio::rGreaterOrEqual:
                    $subquery .= ">=";
                    break;
                case enumRatio::rLessThan:
                    $subquery .= "<";
                    break;
                case enumRatio::rLessOrEqual:
                    $subquery .= "<=";
                    break;
                case enumRatio::rEqual:
                    $subquery .= "=";
                    break;
                case enumRatio::rNotEqual:
                    $subquery .= "<>";
                    break;
                case enumRatio::rInRange:
                    $subquery .= " IN ";
                    break;
                case enumRatio::rNotInRange:
                    $subquery .= " NOT IN ";
                    break;
                case enumRatio::rContains:
                case enumRatio::rBeginWith:
                case enumRatio::rEndWith:
                    $subquery .= " LIKE ";
                    break;
            }

            if ($listApprovalTerms->apt_compare_fields[$jfe] == 'N') {
                $k1 = array_search($listApprovalTerms->apt_fieldname[$jfe], $listFieldsDefinitions->fdf_fieldname);
                $v = $listApprovalTerms->apt_value[$jfe];

                if ($listFieldsDefinitions->fdf_fieldtype[$k1]==enumFieldType::ftText || $listFieldsDefinitions->fdf_fieldtype[$k1]==enumFieldType::ftMemo) {
                    $v = HtmlEntitiesNOD($v);
                }

                if (($listApprovalTerms->apt_ratio[$jfe] == enumRatio::rInRange) || ($listApprovalTerms->apt_ratio[$jfe] == enumRatio::rNotInRange)) {
                    $va = explode(',', $v);
                    $subquery .= "('" . implode("','", $va) . "')";
                } else if ($listApprovalTerms->apt_ratio[$jfe] == enumRatio::rContains) {
                    $subquery .= "'%" . $v . "%'";
                } else if ($listApprovalTerms->apt_ratio[$jfe] == enumRatio::rBeginWith) {
                    $subquery .= "'" . $v . "%'";
                } else if ($listApprovalTerms->apt_ratio[$jfe] == enumRatio::rEndWith) {
                    $subquery .= "'%" . $v . "'";
                } else {
                    $subquery .= "'$v'";

                    if ($v=='' && $listApprovalTerms->apt_ratio[$jfe] == enumRatio::rEqual) {
                        list($f,$v) = split('=', $subquery);
                        $subquery = "($f='' OR $f IS NULL)";
                    }
                }
            } else {
                $k1 = array_search($listApprovalTerms->apt_value[$jfe], $listFieldsDefinitions->fdf_fieldname);
                $subquery .= $listFieldsDefinitions->fdf_dbfieldname[$k1];

                if ($listApprovalTerms->apt_ratio[$jfe] == enumRatio::rEqual) {
                    list($f1, $f2) = split('=', $subquery);
                    $subquery = "(($f1=$f2) OR ($f1 IS NULL AND $f2 IS NULL) OR ($f1='' AND $f2 IS NULL) OR ($f1 IS NULL AND $f2=''))";
                }
            }

            $tmpquery .= " AND $subquery";
        }

        $requestAct->query($tmpquery);

        if ($requestAct->rowCount() > 0) {
            $status = enumFileStatus::stNeedsApproval;
        }
    } elseif ($listApprovals1->app_conditions[$ife] == 'Q') {
        $tmpquery = prepareUserQuery($userquery, $num);

        if ($requestAct->query($tmpquery) !== FALSE) {
            if ($requestAct->rowCount() > 0) {
                $status = enumFileStatus::stNeedsApproval;
            }
        }
    } else {
        $status = enumFileStatus::stNeedsApproval;
    }

    if ($status==enumFileStatus::stNeedsApproval) {
        switch ($doctype) {
            case "files":
                $tmpquery = "SELECT (
CASE doc_type
    WHEN " . enumFileRelatedDocumentType::dtProject . " THEN doc_id
    WHEN " . enumFileRelatedDocumentType::dtPhase . " THEN (SELECT pha.project FROM " . $tablePrefix . "phases pha WHERE pha.id=doc_id)
    WHEN " . enumFileRelatedDocumentType::dtTask . " THEN (SELECT tas.project FROM " . $tablePrefix . "tasks tas WHERE tas.id=doc_id)
    WHEN " . enumFileRelatedDocumentType::dtMeeting . " THEN (SELECT mee.project FROM " . $tablePrefix . "meetings mee WHERE mee.id=doc_id)
    WHEN " . enumFileRelatedDocumentType::dtDiscussion . " THEN (SELECT topic.project FROM " . $tablePrefix . "posts pos INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic WHERE pos.id=doc_id)
    WHEN " . enumFileRelatedDocumentType::dtNote . " THEN (SELECT note.project FROM " . $tablePrefix . "notes note WHERE note.id=doc_id)
    WHEN " . enumFileRelatedDocumentType::dtExpense . " THEN (SELECT exp.project FROM " . $tablePrefix . "expenses exp WHERE exp.id=doc_id)
    WHEN " . enumFileRelatedDocumentType::dtSupportRequest . " THEN (SELECT req.project FROM " . $tablePrefix . "support_requests req WHERE req.id=doc_id)
    WHEN " . enumFileRelatedDocumentType::dtSupportPost . " THEN (SELECT req.project FROM " . $tablePrefix . "support_posts pos INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id WHERE pos.id=doc_id)
    ELSE '-1' END) AS project,comments FROM " . $tablePrefix . "files WHERE id='$num'";
                break;
            case "timesheet":
                $tmpquery = "SELECT '-1' AS project,comments FROM " . $tablePrefix . "timesheet WHERE id='$num'";
                break;
            case "leave_requests":
                $tmpquery = "SELECT '-1' AS project,comments FROM " . $tablePrefix . "leave_requests WHERE id='$num'";
                break;
            case "expenses":
                $tmpquery = "SELECT project,description FROM " . $tablePrefix . "expenses WHERE id='$num'";
                break;
            case "projects":
                $tmpquery = "SELECT id,description FROM " . $tablePrefix . "projects WHERE id='$num'";
                break;
           default:
                $tmpquery = "SELECT '-1' AS project,'' FROM " . $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0] . " WHERE id='$num'";
        }

        $request1 = clone $requestAct;
        $request1->query($tmpquery);

        if ($request1->fetch()) {
            $project = ($row[0]);
            $comments = ($row[1]);
        } else {
            $status = enumFileStatus::stNoApprovalsNeeded;
            $comments = '';
        }

        if ($project == '-1' || $project == '0') {
            $querymore = " WHERE tea.member='$producer' AND pro.status IN ('" . enumProjectStatus::stInitiation . "','" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "')";
            $listTeams = clone $requestAct;
            $listTeams->openTeams($querymore);
            $comptListTeams = count($listTeams->tea_project);

            if ($comptListTeams == '0') {
                $projects = "''";
            } else {
                $projects = "'" . implode("','", $listTeams->tea_project) . "'";
            }
        }

        if ($status == enumFileStatus::stNeedsApproval) {
            $need_more_approvals = true;
            $current_stage = '0';
            $querymore = " WHERE mem.id='$producer'";
            $producerDetail = clone $requestAct;
            $producerDetail->openMembers($querymore);

            while ($need_more_approvals) {
                $need_more_approvals = false;
                $querymore1 = " WHERE aps.approval='$approval' AND aps.sortid>='$current_stage' ORDER BY aps.sortid";
                $listApprovalStages = clone $requestAct;
                $listApprovalStages->openApprovalsStages($querymore1);
                $comptListApprovalStages = count($listApprovalStages->aps_approval);
                $confirmation_level = $listApprovalStages->aps_confirmation_level[0];
                $querymore2 = " WHERE cld.confirmation_level='$confirmation_level'";
                $listConfirmationLevelsDetail = clone $requestAct;
                $listConfirmationLevelsDetail->openConfirmationLevelsDetail($querymore2);
                $comptListConfirmationLevelsDetail = count($listConfirmationLevelsDetail->cld_confirmation_level);
                $authorizers = array();
                $authorizersApproved = array();

                for ($jfe=0; $jfe<$comptListConfirmationLevelsDetail; $jfe++) {
                    switch ($listConfirmationLevelsDetail->cld_authorizer_type[$jfe]) {
                        case enumAuthorizerType::atUser:
                            $querymore = " WHERE mem.id='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "' AND mem.active='" . enumBoolean::bTrue . "'";
                            $memberDetail = clone $requestAct;
                            $memberDetail->openMembers($querymore);
                            $comptMemberDetail = count($memberDetail->mem_id);

                            if ($comptMemberDetail != '0') {
                                if (!in_array($listConfirmationLevelsDetail->cld_authorizer[$jfe], $authorizers)) {
                                    $authorizers[] = $listConfirmationLevelsDetail->cld_authorizer[$jfe];
                                }

                                if ($listConfirmationLevelsDetail->cld_authorizer[$jfe]==$producer && !in_array($listConfirmationLevelsDetail->cld_authorizer[$jfe], $authorizersApproved)) {
                                    $authorizersApproved[] = $listConfirmationLevelsDetail->cld_authorizer[$jfe];
                                }
                            }

                            break;
                        case enumAuthorizerType::atProfile:
                            $querymore = " WHERE mem.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "' AND mem.active='" . enumBoolean::bTrue . "'";
                            $listMembers = clone $requestAct;
                            $listMembers->openMembers($querymore);
                            $comptListMembers = count($listMembers->mem_id);

                            for ($kfe=0; $kfe<$comptListMembers; $kfe++) {
                                if (!in_array($listMembers->mem_id[$kfe], $authorizers)) {
                                    $authorizers[] = $listMembers->mem_id[$kfe];
                                }

                                if ($listMembers->mem_id[$kfe]==$producer && !in_array($listMembers->mem_id[$kfe], $authorizersApproved)) {
                                    $authorizersApproved[] = $listMembers->mem_id[$kfe];
                                }
                            }

                            break;
                        case enumAuthorizerType::atDepartmentTitle:
                            $querymore = " WHERE mem.organization='" . $producerDetail->mem_organization[0] . "' AND mem.department='" . $producerDetail->mem_department[0] . "' AND mem.title='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "' AND mem.active='" . enumBoolean::bTrue . "'";
                            $listMembers = clone $requestAct;
                            $listMembers->openMembers($querymore);
                            $comptListMembers = count($listMembers->mem_id);

                            for ($kfe=0; $kfe<$comptListMembers; $kfe++) {
                                if (!in_array($listMembers->mem_id[$kfe], $authorizers)) {
                                    $authorizers[] = $listMembers->mem_id[$kfe];
                                }

                                if ($listMembers->mem_id[$kfe]==$producer && !in_array($listMembers->mem_id[$kfe], $authorizersApproved)) {
                                    $authorizersApproved[] = $listMembers->mem_id[$kfe];
                                }
                            }

                            break;
                        case enumAuthorizerType::atOrganizationTitle:
                            $querymore = " WHERE mem.organization='" . $producerDetail->mem_organization[0] . "' AND mem.title='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "' AND mem.active='" . enumBoolean::bTrue . "'";
                            $listMembers = clone $requestAct;
                            $listMembers->openMembers($querymore);
                            $comptListMembers = count($listMembers->mem_id);

                            for ($kfe=0; $kfe<$comptListMembers; $kfe++) {
                                if (!in_array($listMembers->mem_id[$kfe], $authorizers)) {
                                    $authorizers[] = $listMembers->mem_id[$kfe];
                                }

                                if ($listMembers->mem_id[$kfe]==$producer && !in_array($listMembers->mem_id[$kfe], $authorizersApproved)) {
                                    $authorizersApproved[] = $listMembers->mem_id[$kfe];
                                }
                            }

                            break;
                        case enumAuthorizerType::atRole:
                            if ($project == '-1' || $project == '0') {
                                $querymore = " WHERE tea.project IN ($projects) AND tea.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "'";
                            } else {
                                $querymore = " WHERE tea.project='$project' AND tea.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "'";
                            }

                            $querymore .= " AND mem.active='" . enumBoolean::bTrue . "'";
                            $listTeams = clone $requestAct;
                            $listTeams->openTeams($querymore);
                            $comptListTeams = count($listTeams->tea_project);

                            for ($kfe=0; $kfe<$comptListTeams; $kfe++) {
                                if (!in_array($listTeams->tea_member[$kfe], $authorizers)) {
                                    $authorizers[] = $listTeams->tea_member[$kfe];
                                }

                                if ($listTeams->tea_member[$kfe]==$producer && !in_array($listTeams->tea_member[$kfe], $authorizersApproved)) {
                                    $authorizersApproved[] = $listTeams->tea_member[$kfe];
                                }
                            }

                            break;
                    }
                }

                if (count($authorizers) == 0) {
                    $status = enumFileStatus::stNotApproved;

                    if ($doctype == 'projects') {
                        $tmpsql = "UPDATE " . $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0] . " SET status_next=status,status_approval='$status',modified='" . time() . "',muser='$idSession' WHERE id='$num'";
                    } else if ($doctype == 'expenses' || $doctype == 'invoices') {
                        $tmpsql = "UPDATE " . $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0] . " SET status='" . enumDocumentStatus::stDraft . "',status_approval='$status',modified='" . time() . "',muser='$idSession' WHERE id='$num'";
                    } else {
                        $tmpsql = "UPDATE " . $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0] . " SET status='$status',modified='" . time() . "',muser='$idSession' WHERE id='$num'";
                    }

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                } else if (($listApprovalStages->aps_con_max_requirements[0] != '0' && count($authorizersApproved) >= $listApprovalStages->aps_con_max_requirements[0]) || ($listApprovalStages->aps_con_max_requirements[0] == '0' && count($authorizersApproved) == count($authorizers))) {
                    if ($comptListApprovalStages == '1') {
                        $status = enumFileStatus::stNoApprovalsNeeded;
                    } else {
                        $need_more_approvals = true;
                        $current_stage = $listApprovalStages->aps_sortid[1];
                    }
                } else {
                    $status = enumFileStatus::stNeedsApproval;

                    if ($doctype == 'projects') {
                        $tmpsql = "UPDATE " . $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0] . " SET status_approval='$status',modified='" . time() . "',muser='$idSession' WHERE id='$num'";
                    } else if ($doctype == 'expenses' || $doctype == 'invoices') {
                        $tmpsql = "UPDATE " . $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0] . " SET status='" . enumDocumentStatus::stDraft . "',status_approval='$status',modified='" . time() . "',muser='$idSession' WHERE id='$num'";
                    } else {
                        $tmpsql = "UPDATE " . $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0] . " SET status='$status',modified='" . time() . "',muser='$idSession' WHERE id='$num'";
                    }

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }
        }

        if ($status==enumFileStatus::stNeedsApproval) {
            $tmpsql = "INSERT INTO " . $tablePrefix . "documents_approval (approval,owner,docid,doctype,docdate,current_stage,status,canceled,closed,comments,userquery,created,cuser) VALUES ('$approval','$producer','$num','$doctype','" . time() . "','$current_stage','" . enumApprovalStatus::stPending . "','N','N','$comments','" . HtmlEntitiesNOD($userquery) . "','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $document_approval = $requestAct->newId('documents_approval');

            if ($listApprovals1->app_conditions[$ife] == 'Y') {
                for ($jfe=0; $jfe<$comptListApprovalTerms; $jfe++) {
                    $tmpsql = "INSERT INTO " . $tablePrefix . "documents_approval_terms (document_approval,fieldname,ratio,value,compare_fields) VALUES ('$document_approval','" . $listApprovalTerms->apt_fieldname[$jfe] . "','" . $listApprovalTerms->apt_ratio[$jfe] . "','" . HtmlEntitiesNOD($listApprovalTerms->apt_value[$jfe]) . "','" . $listApprovalTerms->apt_compare_fields[$jfe] . "')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }

            $authorizers = array();

            for ($jfe=0; $jfe<$comptListConfirmationLevelsDetail; $jfe++) {
                switch ($listConfirmationLevelsDetail->cld_authorizer_type[$jfe]) {
                    case enumAuthorizerType::atUser:
                        if ($listConfirmationLevelsDetail->cld_authorizer[$jfe] != $producer) {
                            $querymore = " WHERE mem.id='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "' AND mem.active='" . enumBoolean::bTrue . "'";
                            $memberDetail = clone $requestAct;
                            $memberDetail->openMembers($querymore);
                            $comptMemberDetail = count($memberDetail->mem_id);

                            if ($comptMemberDetail != '0') {
                                if (!in_array($listConfirmationLevelsDetail->cld_authorizer[$jfe], $authorizers)) {
                                    $approve_string = get_rand_id(32);
                                    $not_approve_string = get_rand_id(32);
                                    $string_validto = time() + $approvalStringLifeTime;
                                    $tmpsql = "INSERT INTO " . $tablePrefix . "documents_approval_authorizers (document_approval,confirmation_level,authorizer,required,stage,status,approve_string,not_approve_string,string_validto,created,cuser) VALUES ('$document_approval','$confirmation_level','" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "','" . $listConfirmationLevelsDetail->cld_required[$jfe] . "','$current_stage','" . enumApprovalStatus::stPending . "','$approve_string','$not_approve_string','$string_validto','" . time() . "','$idSession')";

                                    if ($requestAct->query($tmpsql) === false) {
                                        throw new Exception($tmpsql);
                                    }

                                    $authorizers[] = $listConfirmationLevelsDetail->cld_authorizer[$jfe];
                                }
                            }
                        }

                        break;
                    case enumAuthorizerType::atProfile:
                        $querymore = " WHERE mem.id<>'$producer' AND mem.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "' AND mem.active='" . enumBoolean::bTrue . "'";
                        $listMembers = clone $requestAct;
                        $listMembers->openMembers($querymore);
                        $comptListMembers = count($listMembers->mem_id);

                        for ($kfe=0; $kfe<$comptListMembers; $kfe++) {
                            if (!in_array($listMembers->mem_id[$kfe], $authorizers)) {
                                $approve_string = get_rand_id(32);
                                $not_approve_string = get_rand_id(32);
                                $string_validto = time() + $approvalStringLifeTime;
                                $tmpsql = "INSERT INTO " . $tablePrefix . "documents_approval_authorizers (document_approval,confirmation_level,authorizer,required,stage,status,approve_string,not_approve_string,string_validto,created,cuser) VALUES ('$document_approval','$confirmation_level','" . $listMembers->mem_id[$kfe] . "','" . $listConfirmationLevelsDetail->cld_required[$jfe] . "','$current_stage','" . enumApprovalStatus::stPending . "','$approve_string','$not_approve_string',$string_validto,'" . time() . "','$idSession')";

                                if ($requestAct->query($tmpsql) === false) {
                                    throw new Exception($tmpsql);
                                }

                                $authorizers[] = $listMembers->mem_id[$kfe];
                            }
                        }

                        break;
                    case enumAuthorizerType::atDepartmentTitle:
                        $querymore = " WHERE mem.id<>'$producer' AND mem.organization='" . $producerDetail->mem_organization[0] . "' AND mem.department='" . $producerDetail->mem_department[0] . "' AND mem.title='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "' AND mem.active='" . enumBoolean::bTrue . "'";
                        $listMembers = clone $requestAct;
                        $listMembers->openMembers($querymore);
                        $comptListMembers = count($listMembers->mem_id);

                        for ($kfe=0; $kfe<$comptListMembers; $kfe++) {
                            if (!in_array($listMembers->mem_id[$kfe], $authorizers)) {
                                $approve_string = get_rand_id(32);
                                $not_approve_string = get_rand_id(32);
                                $string_validto = time() + $approvalStringLifeTime;
                                $tmpsql = "INSERT INTO " . $tablePrefix . "documents_approval_authorizers (document_approval,confirmation_level,authorizer,required,stage,status,approve_string,not_approve_string,string_validto,created,cuser) VALUES ('$document_approval','$confirmation_level','" . $listMembers->mem_id[$kfe] . "','" . $listConfirmationLevelsDetail->cld_required[$jfe] . "','$current_stage','" . enumApprovalStatus::stPending . "','$approve_string','$not_approve_string',$string_validto,'" . time() . "','$idSession')";

                                if ($requestAct->query($tmpsql) === false) {
                                    throw new Exception($tmpsql);
                                }

                                $authorizers[] = $listMembers->mem_id[$kfe];
                            }
                        }

                        break;
                    case enumAuthorizerType::atOrganizationTitle:
                        $querymore = " WHERE mem.id<>'$producer' AND mem.organization='" . $producerDetail->mem_organization[0] . "' AND mem.title='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "' AND mem.active='" . enumBoolean::bTrue . "'";
                        $listMembers = clone $requestAct;
                        $listMembers->openMembers($querymore);
                        $comptListMembers = count($listMembers->mem_id);

                        for ($kfe=0; $kfe<$comptListMembers; $kfe++) {
                            if (!in_array($listMembers->mem_id[$kfe], $authorizers)) {
                                $approve_string = get_rand_id(32);
                                $not_approve_string = get_rand_id(32);
                                $string_validto = time() + $approvalStringLifeTime;
                                $tmpsql = "INSERT INTO " . $tablePrefix . "documents_approval_authorizers (document_approval,confirmation_level,authorizer,required,stage,status,approve_string,not_approve_string,string_validto,created,cuser) VALUES ('$document_approval','$confirmation_level','" . $listMembers->mem_id[$kfe] . "','" . $listConfirmationLevelsDetail->cld_required[$jfe] . "','$current_stage','" . enumApprovalStatus::stPending . "','$approve_string','$not_approve_string',$string_validto,'" . time() . "','$idSession')";

                                if ($requestAct->query($tmpsql) === false) {
                                    throw new Exception($tmpsql);
                                }

                                $authorizers[] = $listMembers->mem_id[$kfe];
                            }
                        }

                        break;
                    case enumAuthorizerType::atRole:
                        if ($project == '-1' || $project == '0') {
                            $querymore = " WHERE tea.project IN ($projects) AND tea.member<>'$producer' AND tea.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "'";
                        } else {
                            $querymore = " WHERE tea.project='$project' AND tea.member<>'$producer' AND tea.profil='" . $listConfirmationLevelsDetail->cld_authorizer[$jfe] . "'";
                        }

                        $querymore .= " AND mem.active='" . enumBoolean::bTrue . "'";
                        $listTeams = clone $requestAct;
                        $listTeams->openTeams($querymore);
                        $comptListTeams = count($listTeams->tea_project);

                        for ($kfe=0; $kfe<$comptListTeams; $kfe++) {
                            if (!in_array($listTeams->tea_member[$kfe], $authorizers)) {
                                $approve_string = get_rand_id(32);
                                $not_approve_string = get_rand_id(32);
                                $string_validto = time() + $approvalStringLifeTime;
                                $tmpsql = "INSERT INTO " . $tablePrefix . "documents_approval_authorizers (document_approval,confirmation_level,authorizer,required,stage,status,approve_string,not_approve_string,string_validto,created,cuser) VALUES ('$document_approval','$confirmation_level','" . $listTeams->tea_member[$kfe] . "','" . $listConfirmationLevelsDetail->cld_required[$jfe] . "','$current_stage','" . enumApprovalStatus::stPending . "','$approve_string','$not_approve_string',$string_validto,'" . time() . "','$idSession')";

                                if ($requestAct->query($tmpsql) === false) {
                                    throw new Exception($tmpsql);
                                }

                                $authorizers[] = $listTeams->tea_member[$kfe];
                            }
                        }

                        break;
                }
            }

            if (!defined('INNER_NOTI_DOCUMENTADDED')) {
                define('INNER_NOTI_DOCUMENTADDED', 1);
            }

            require("../approvals/noti_documentadded.php");
        }
    }
}
