<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteapprovalstages.php,v 1.7 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$ids = str_replace('**', ',', $id);
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = "SELECT aps.confirmation_level FROM " . $tablePrefix . "approvals_stages aps WHERE aps.confirmation_level IN ($ids)";

if (compt($tmpquery) != '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = 'DELETE FROM ' . $tablePrefix . "confirmation_levels WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = 'DELETE FROM ' . $tablePrefix . "confirmation_levels_detail WHERE confirmation_level IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../approvals/listapprovalstages.php?msg=delete' . $urlBornes);
        exit;
    }
}

/**
 * Prepare data
 */
$tmpquery = " WHERE con.id IN ($ids)";
$listConfirmationLevels = new request();
$listConfirmationLevels->openConfirmationLevels($tmpquery);
$comptListConfirmationLevels = count($listConfirmationLevels->con_id);

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=workflow", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/listapprovalstages.php?" . $urlBornes, lang_strings("approval_stages"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('delete_approval_stages'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'dCl';
$block1->openForm("../approvals/deleteapprovalstages.php?id=$id" . $urlBornes);
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings('delete_approval_stages'));
$block1->openContent();
$block1->contentTitle(lang_strings('delete_following'));

for ($i=0; $i<$comptListConfirmationLevels; $i++) {
    $block1->contentRow('#' . $listConfirmationLevels->con_id[$i], $listConfirmationLevels->con_name[$i]);
}

$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
require_once('../includes/footer.php');
