<?php // $Revision: 1.15 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editapprovalstage.php,v 1.15 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
$bodyCommand = 'onLoad="document.eClForm.nm.focus();"';

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$nm = isset($_POST['nm'])?$_POST['nm']:'';
$cm = isset($_POST['cm'])?$_POST['cm']:'';
$max = isset($_POST['max'])?$_POST['max']:'0';
$au = isset($_POST['au'])?$_POST['au']:'';
$aut = isset($_POST['aut'])?$_POST['aut']:'';
$aur = isset($_POST['aur'])?$_POST['aur']:'';
$idx = isset($_POST['idx'])?$_POST['idx']:'';
$error = '';
$nm_highlight = false;
$max_highlight = false;
$maxN = 0;

if (is_array($aur)) {
    for ($i=0; $i<count($aur); $i++) {
        $aur[$i] = DbValueEncode(enumFieldType::ftBoolean, $aur[$i]);

        if ($aur[$i] == enumBoolean::bTrue) {
            $maxN++;
        }
    }
}

if ($max < $maxN) {
    $max = $maxN;
}
/**
 * Permission check
 */
if ($id == '') {
    if (!$SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $tmpquery = " WHERE cld.confirmation_level=$id";
    $listConfirmationLevelsDetail = new request();
    $listConfirmationLevelsDetail->openConfirmationLevelsDetail($tmpquery);
    $comptListConfirmationLevelsDetail = count($listConfirmationLevelsDetail->cld_confirmation_level);

    if ($comptListConfirmationLevelsDetail == "0") {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
}

/**
 * Check fields
 */
if ($action == 'add' || $action == 'update') {

    if (is_array($au)) {
        $auX = array();
        $autX = array();
        $aurX = array();

        for ($i=0; $i<count($au); $i++) {
            if ($au[$i] == '' || $aut[$i] == '') {
                continue;
            }

            $auI = array_search($au[$i], $auX);
            $autI = array_search($aut[$i], $autX);

            if ($auI !== false && $autI !== false && $auI === $autI) {
                $error = lang_strings('auth_already_exist') . '(' . $au[$i] . ')';
                $bodyCommand = 'onLoad="document.eClForm.au[' . $i . '].focus();"';
            }

            $auX[] = $au[$i];
            $autX[] = $aut[$i];
            $aurX[] = $aur[$i];
        }

        $cnt = count($auX);
    } else {
        $cnt = '0';
    }

    if ($error == '') {
        if ($nm == '') {
            $error = lang_strings('name') . ' ' . lang_strings('error_required');
            $bodyCommand = 'onLoad="document.eClForm.nm.focus();"';
            $nm_highlight = true;
        } else if ($max == '') {
            $error = lang_strings('no_of_approvals_required') . ' ' . lang_strings('error_required');
            $bodyCommand = 'onLoad="document.eClForm.max.focus();"';
            $max_highlight = true;
        } else if (!is_numeric($max)) {
            $error = lang_strings('no_of_approvals_required') . ' ' . lang_strings('error_numerical');
            $bodyCommand = 'onLoad="document.eClForm.max.focus();"';
            $max_highlight = true;
        } else if (intval($max) < 0) {
            $error = lang_strings('zero_auth_no');
            $bodyCommand = 'onLoad="document.eClForm.max.focus();"';
            $max_highlight = true;
        } else if (intval($max) > intval($cnt)) {
            $error = lang_strings('auth_no_lower_min');
            $bodyCommand = 'onLoad="document.eClForm.max.focus();"';
            $max_highlight = true;
        }
    }
}

/**
 * Actions
 */
if ($error == '' && ($action == 'add' || $action == 'update')) {
    $nm = HtmlEntitiesNOD($nm);
    $cm = HtmlEntitiesNOD($cm);

    if ($action == 'add') {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "confirmation_levels (name,comments,max_requirements) VALUES ('$nm','$cm','$max')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('confirmation_levels');

            for ($i=0; $i<$cnt; $i++) {
                $tmpsql = "INSERT INTO " . $tablePrefix . "confirmation_levels_detail(confirmation_level,authorizer_type,authorizer,required) VALUES ('$num'," . $autX[$i] . ",'" . HtmlEntitiesNOD($auX[$i]) . "','" . $aurX[$i] . "')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../approvals/viewapprovalstage.php?id=$num&msg=add");
            exit;
        }
    } else if ($action == 'update') {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "DELETE FROM " . $tablePrefix . "confirmation_levels_detail WHERE confirmation_level='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "UPDATE " . $tablePrefix . "confirmation_levels SET name='$nm',comments='$cm',max_requirements='$max' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            for ($i=0; $i<$cnt; $i++) {
                $tmpsql = "INSERT INTO " . $tablePrefix . "confirmation_levels_detail(confirmation_level,authorizer_type,authorizer) VALUES ('$id'," . $autX[$i] . ",'" . HtmlEntitiesNOD($auX[$i]) . "','" . $aurX[$i] . "')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../approvals/viewapprovalstage.php?id=$id&msg=update" . $urlBornes);
            exit;
        }
    }
}

/**
 * Set value in form
 */
if ($error == '') {
    if ($action == '') {
        unset($au,$aut,$aur);

        if ($id != '') {
            $nm = $listConfirmationLevelsDetail->cld_con_name[0];
            $cm = $listConfirmationLevelsDetail->cld_con_comments[0];
            $max = $listConfirmationLevelsDetail->cld_con_max_requirements[0];

            for ($i=0; $i<$comptListConfirmationLevelsDetail; $i++) {
                $au[] = $listConfirmationLevelsDetail->cld_authorizer[$i];
                $aut[] = $listConfirmationLevelsDetail->cld_authorizer_type[$i];
                $aur[] = $listConfirmationLevelsDetail->cld_required[$i];
            }
        } else {
            $nm = '';
            $cm = '';
            $max = '1';
            $au[] = $idSession;
            $aut[] = enumAuthorizerType::atUser;
            $aur[] = enumBoolean::bTrue;
        }
    } else if ($action == 'addrow') {
        $cnt = is_array($au)?count($au):'0';
        $au[] = '';
        $aut[] = ($cnt=='0')?enumAuthorizerType::atUser:$aut[$cnt-1];
        $aur[] = enumBoolean::bTrue;
        $max++;
    } else if ($action == 'delrow') {
        $auX = $au;
        $autX = $aut;
        $aurX = $aur;
        unset($au,$aut,$aur);
        $max = 0;

        for ($i=0; $i<count($auX); $i++) {
            if ($i != $idx) {
                $au[] = $auX[$i];
                $aut[] = $autX[$i];
                $aur[] = $aurX[$i];

                if ($aurX[$i] == enumBoolean::bTrue) {
                    $max++;
                }
            }
        }
    }

    $cnt = count($au);
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=workflow", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/listapprovalstages.php?" . $urlBornes, lang_strings("approval_stages"), 'in'));

if ($id == '') {
    $blockPage->itemBreadcrumbs(lang_strings('add_approval_stage'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../approvals/viewapprovalstage.php?id=' . $id . $urlBornes, $listConfirmationLevelsDetail->cld_con_name[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings('edit_approval_stage'));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "eCl";

if ($id == '') {
    $block1->openForm("../approvals/editapprovalstage.php?#" . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
} else {
    $block1->openForm("../approvals/editapprovalstage.php?id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
}

if ($id == '') {
    $block1->heading(lang_strings('add_approval_stage'));
} else {
    $block1->heading(lang_strings('edit_approval_stage') . ' : ' . $listConfirmationLevelsDetail->cld_con_name[0]);
}

$block1->openContent();
$block1->contentTitle(lang_strings('info'));
echo '<input type="hidden" name="idx" value="">';
$block1->contentRow('* ' . lang_strings('name') . $block1->printHelp("approval_stage_name_help"), '<input size="24"' . (($nm_highlight)?' class="highlight"':'') . ' type="text" name="nm" value="' . str_replace('"', '&quot;', $nm) . '" maxlength="30">');
setupInputHTML($block1, lang_strings('description') . $block1->printHelp("approval_stage_description_help"), 'cm', enumFieldType::ftMemo, 'Y', '0', $cm);
$block1->contentRow('* ' . lang_strings('no_of_approvals_required') . $block1->printHelp("approval_stage_num_help"), '<input size="24"' . (($max_highlight)?' class="highlight"':'') . ' type="text" name="max" value="' . $max . '" maxlength="30">');
$block1->contentTitle(lang_strings("authorizers"));
$querymore1 = " WHERE mem.organization='1' AND mem.active='" . enumBoolean::bTrue . "' ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore1);
$comptListMembers = count($listMembers->mem_id);
$querymore2 = "SELECT DISTINCT mem.title FROM " . $tablePrefix . "members mem WHERE mem.organization='1' AND mem.active='" . enumBoolean::bTrue . "' ORDER BY mem.title";
$listTitles = new request();
$listTitles->connectClass();
$listTitles->query($querymore2);
$listTitles->title = array();

while ($listTitles->fetch()) {
    $listTitles->title[] = HtmlEntityDecodeNOD($row[0]);
}

$listTitles->close();
$comptListTitles = count($listTitles->title);
$authLst = '';

for ($i=0; $i<$cnt; $i++) {
    $authLst .= '<div class="clear"><div class="float-left"><select name="aut[' . $i . ']" onchange="reloadForm(\'reload\',0);">';

    foreach ($authorizerType as $key => $val) {
        if ($aut[$i] == $key) {
            $authLst .= '<option value="' . $key . '" selected>' . $val . '</option>';
        } else {
            $authLst .= '<option value="' . $key . '">' . $val . '</option>';
        }
    }

    $authLst .= '</select></div><div class="float-left"><select name="au[' . $i . ']">';

    switch ($aut[$i]) {
        case enumAuthorizerType::atUser:
            for ($j=0; $j<$comptListMembers; $j++) {
                if ($listMembers->mem_id[$j] == $au[$i]) {
                    $authLst .= '<option value="' . $listMembers->mem_id[$j] . '" selected>' . $listMembers->mem_name[$j] . '</option>';
                } else {
                    $authLst .= '<option value="' . $listMembers->mem_id[$j] . '">' . $listMembers->mem_name[$j] . '</option>';
                }
            }

            break;
        case enumAuthorizerType::atProfile:
            $querymore = " ORDER BY upf.name";
            $listUserProfiles = new request();
            $listUserProfiles->openUserProfiles($querymore);
            $comptListUserProfiles = count($listUserProfiles->upf_id);

            for ($j=0; $j<$comptListUserProfiles; $j++) {
                if ($listUserProfiles->upf_id[$j] == $au[$i]) {
                    $authLst .= '<option value="' . $listUserProfiles->upf_id[$j] . '" selected>' . $listUserProfiles->upf_name_print[$j] . '</option>';
                } else {
                    $authLst .= '<option value="' . $listUserProfiles->upf_id[$j] . '">' . $listUserProfiles->upf_name_print[$j] . '</option>';
                }
            }

            break;
        case enumAuthorizerType::atDepartmentTitle:
        case enumAuthorizerType::atOrganizationTitle:
            for ($j=0; $j<$comptListTitles; $j++) {
                if ($listTitles->title[$j] == $au[$i]) {
                    $authLst .= '<option value="' . $listTitles->title[$j] . '" selected>' . $listTitles->title[$j] . '</option>';
                } else {
                    $authLst .= '<option value="' . $listTitles->title[$j] . '">' . $listTitles->title[$j] . '</option>';
                }
            }

            break;
        case enumAuthorizerType::atRole:
            foreach ($projectRoles as $key => $val) {
                if ($key != enumProjectProfile::ppGuest) {
                    if ($key == $au[$i]) {
                        $authLst .= '<option value="' . $key . '" selected>' . $val . '</option>';
                    } else {
                        $authLst .= '<option value="' . $key . '">' . $val . '</option>';
                    }
                }
            }

            break;
        default:
            $authLst .= '<option value=""></option>';
    }

    $authLst .= '</select></div><div class="float-left">&nbsp;<input type="checkbox" name="aur[' . $i . ']" value="Y" ' . (($aur[$i]==enumBoolean::bTrue)?'checked':'') . '>' . $strings['required'] . '&nbsp;</div><div class="float-left"><a href="javascript:reloadForm(\'delrow\',' . $i . ');">X</a></div></div>';
}

$authLst .= '<div class="clear"><a href="javascript:reloadForm(\'addrow\',0);">' . $strings['more_row'] . '</a></div>';
$block1->contentRow($block1->printHelp("approval_stage_authorizers_help"), $authLst);
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
function reloadForm(a,b){
    var x = document.eClForm.action;
    var y = document.eClForm.idx;
    x.value = a;
    y.value = b;
    document.eClForm.submit();
}
</script>
<?php
require_once('../includes/footer.php');
