<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportapprovaltemplates.php,v 1.5 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id0 = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$ids = explode('**', $id0);
$id = implode(',', $ids);
$querymore0 = " WHERE app.id IN ($id)";
$listApprovals = new request();
$listApprovals->openApprovals($querymore0);
$comptListApprovals = count($listApprovals->app_id);

if ($comptListApprovals != count($ids)) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Prepare data
 */
// approval stages
$tmpquery = "SELECT aps.confirmation_level FROM " . $tablePrefix . "approvals_stages aps WHERE aps.approval IN ($id) GROUP BY aps.confirmation_level";
$listApprovalStages = new request();
$listApprovalStages->connectClass();
$listApprovalStages->query($tmpquery);
$listApprovalStages->confirmation_level = array();

while ($listApprovalStages->fetch()) {
    $listApprovalStages->confirmation_level[] = ($row[0]);
}

$listApprovalStages->close();
// confirmation levels
$consId = implode(',', $listApprovalStages->confirmation_level);
$querymore = " WHERE con.id IN ($consId)";
$listConfirmationLevels = new request();
$listConfirmationLevels->openConfirmationLevels($querymore);
$comptListConfirmationLevels = count($listConfirmationLevels->con_id);
// create XML document
$doc = new DOMDocument('1.0', 'UTF-8');
$doc->formatOutput = true;
// The collection of approval procedures.
$approvals = $doc->createElement("approval_procedures");
$doc->appendChild($approvals);

for ($i=0; $i<$comptListConfirmationLevels; $i++) {
    $stage = $doc->createElement("approval_stage");
    $stage->appendChild($doc->createElement("name", $listConfirmationLevels->con_name[$i]));    // The name of approval stage
    $stage->appendChild($doc->createElement("comments", $listConfirmationLevels->con_comments[$i]));    // The description of approval stage
    $stage->appendChild($doc->createElement("max_requirements", $listConfirmationLevels->con_max_requirements[$i])); // No. of Approvals Required
    // The collection of authorizers.
    $authorizers = $doc->createElement("authorizers");
    // authorizer list
    $querymore = " WHERE cld.confirmation_level='" . $listConfirmationLevels->con_id[$i] . "'";
    $listConfirmationLevelsDetail = new request();
    $listConfirmationLevelsDetail->openConfirmationLevelsDetail($querymore);
    $comptListConfirmationLevelsDetail = count($listConfirmationLevelsDetail->cld_confirmation_level);

    for ($j=0; $j<$comptListConfirmationLevelsDetail; $j++) {
        $authorizer = $doc->createElement("authorizer");
        $authorizer->appendChild($doc->createElement("type", $listConfirmationLevelsDetail->cld_authorizer_type[$j]));  // The type of authorizer

        if ($listConfirmationLevelsDetail->cld_authorizer_type[$j] == enumAuthorizerType::atUser) {    // user
            // get user login name
            $querymore = " WHERE mem.id='" . $listConfirmationLevelsDetail->cld_authorizer[$j] . "'";
            $memberDetail = new request();
            $memberDetail->openMembers($querymore);
            $authorizer->appendChild($doc->createElement("id", $memberDetail->mem_login[0]));   // The login name of user
        } else {    // user profile, title and project role
            $authorizer->appendChild($doc->createElement("id", $listConfirmationLevelsDetail->cld_authorizer[$j]));
        }

        $authorizer->appendChild($doc->createElement("required", $listConfirmationLevelsDetail->cld_required[$j]));
        $authorizers->appendChild($authorizer);
    }

    $stage->appendChild($authorizers);
    $approvals->appendChild($stage);
}

for ($i=0; $i<$comptListApprovals; $i++) {
    $approval = $doc->createElement("approval_procedure");
    $approval->appendChild($doc->createElement("name", $listApprovals->app_name[$i]));  // The name of approval procedure
    $approval->appendChild($doc->createElement("doctype", $listApprovals->app_doctype[$i]));    // The document type of approval procedure
    $approval->appendChild($doc->createElement("comments", $listApprovals->app_comments[$i]));  // The description of approval procedure
    $approval->appendChild($doc->createElement("conditions", $listApprovals->app_conditions[$i]));  // whether conditions to launch approval procedure

    if ($listApprovals->app_conditions[$i] == 'Y') {
        // The collection of conditions to launch approval procedure
        $terms = $doc->createElement("terms");
        $querymore = " WHERE apt.approval='" . $listApprovals->app_id[$i] . "'";
        $listApprovalTerms = new request();
        $listApprovalTerms->openApprovalsTerms($querymore);
        $comptListApprovalTerms = count($listApprovalTerms->apt_id);

        for ($j=0; $j<$comptListApprovalTerms; $j++) {
            $term = $doc->createElement("term");
            $term->appendChild($doc->createElement("fieldname", $listApprovalTerms->apt_fieldname[$j]));    // The name of field
            $term->appendChild($doc->createElement("ratio", $listApprovalTerms->apt_ratio[$j]));    // comparison operator
            $term->appendChild($doc->createElement("value", $listApprovalTerms->apt_value[$j]));    // The value of field or the name of another field
            $term->appendChild($doc->createElement("compare_fields", $listApprovalTerms->apt_compare_fields[$j]));  // whether comparison of two fields
            $terms->appendChild($term);
        }

        $approval->appendChild($terms);
    } elseif ($listApprovals->app_conditions[$i] == 'Q') {
        $approval->appendChild($doc->createElement("userquery", HtmlEntitiesNOD($listApprovals->app_userquery[$i])));   // user query to launch approval procedure
    }

    $originators = $doc->createElement("originators");  // The collection of approval procedure originators
    $querymore = " WHERE apd.approval='" . $listApprovals->app_id[$i] . "' ORDER BY apd.exclude";
    $listApprovalProducers = new request();
    $listApprovalProducers->openApprovalsProducers($querymore);
    $comptListApprovalProducers = count($listApprovalProducers->apd_approval);

    for ($j=0; $j<$comptListApprovalProducers; $j++) {
        $originator = $doc->createElement("originator");
        $originator->appendChild($doc->createElement("type", $listApprovalProducers->apd_producer_type[$j]));   // The type of originator

        switch ($listApprovalProducers->apd_producer_type[$j]) {
            case enumProducerType::ptUser:
                // get user login name
                $querymore = " WHERE mem.id='" . $listApprovalProducers->apd_producer[$j] . "'";
                $memberDetail = new request();
                $memberDetail->openMembers($querymore);
                $originator->appendChild($doc->createElement("id", $memberDetail->mem_name[0]));    // The login name of user
                break;
            case enumProducerType::ptProfile:
                $originator->appendChild($doc->createElement("id", $listApprovalProducers->apd_producer[$j]));  // The unique id of profile
                break;
            case enumProducerType::ptDepartment:
                // get department name
                $querymore = " WHERE dep.id='" . $listApprovalProducers->apd_producer[$j] . "'";
                $departmentDetail = new request();
                $departmentDetail->openDepartments($querymore);
                $originator->appendChild($doc->createElement("id", $departmentDetail->dep_name_print[0]));    // The name print of department
                break;
            case enumProducerType::ptTeam:
                // get project name
                $querymore = " WHERE pro.id='" . $listApprovalProducers->apd_producer[$j] . "'";
                $projectDetail = new request();
                $projectDetail->openProjects($querymore);
                $originator->appendChild($doc->createElement("id", $projectDetail->pro_name[0]));    // The name of project
                break;
        }

        $originator->appendChild($doc->createElement("exclude", $listApprovalProducers->apd_exclude[$j]));  // whether excluding this originator
        $originators->appendChild($originator);
    }

    $approval->appendChild($originators);
    $stages = $doc->createElement("stages");    // The collection of stages
    $querymore = " WHERE aps.approval='" . $listApprovals->app_id[$i] . "'";
    $listApprovalStages = new request();
    $listApprovalStages->openApprovalsStages($querymore);
    $comptListApprovalStages = count($listApprovalStages->aps_approval);

    for ($j=0; $j<$comptListApprovalStages; $j++) {
        $stage = $doc->createElement("stage");
        $stage->appendChild($doc->createElement("name", $listApprovalStages->aps_con_name[$j]));    // The name of stage
        $stage->appendChild($doc->createElement("sortid", $listApprovalStages->aps_sortid[$j]));    // The order of stage
        $stages->appendChild($stage);
    }

    $approval->appendChild($stages);
    $approvals->appendChild($approval);
}

$dump = $doc->saveXML();    // Dumps the internal XML tree back into a string
$size = strlen($dump);
$name = (($comptListApprovals=='1')?$listApprovals->app_name[0]:'approval_procedures') . '.xml';

/**
 * Output
 */
header('Content-Length: ' . $size);
header('Content-Type: text/xml');
header("Content-Disposition: attachment; filename=$name");
echo $dump;
