<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: importapprovaltemplates.php,v 1.8 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = isset($_POST['action'])?$_POST['action']:'';
$act = isset($_POST['act'])?$_POST['act']:'';
$atttmp = isset($_POST['atttmp1'])?$_POST['atttmp1']:'';
$attnam = isset($_POST['attnam1'])?$_POST['attnam1']:'';
$error = '';

if ($act != 'Y') {
    $act = 'N';
}

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Actions
 */
if ($action == "import") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $doc = new DOMDocument();

        if ($doc->load($atttmp) === false) {
            $error = str_replace('%FILE%', $attnam, $strings['load_file_fail']);
        }

        // The mapping table of approval stages name <-> id
        $approval_stages = array();
        // The collection of approval stages
        $stages = $doc->getElementsByTagName("approval_stage");

        if ($stages->length > 0) {
            foreach ($stages as $stage) {
                $elements = $stage->getElementsByTagName("name");   // The name of approval stage
                $nm = $elements->item(0)->nodeValue;
                // check if the approval stage already exists
                $querymore = " WHERE UPPER(con.name)='" . strtoupper(HtmlEntitiesNOD($nm)) . "'";
                $confirmationLevelDetail = clone $requestAct;
                $confirmationLevelDetail->openConfirmationLevels($querymore);
                $comptConfirmationLevelDetail = count($confirmationLevelDetail->con_id);

                if ($comptConfirmationLevelDetail == '0') { // new approval stage
                    $elements1 = $stage->getElementsByTagName("comments");   // The description of approval stage
                    $cm = HtmlEntitiesNOD($elements1->item(0)->nodeValue);
                    $elements2 = $stage->getElementsByTagName("max_requirements");   // No. of Approvals Required
                    $max = $elements2->item(0)->nodeValue;
                    $tmpsql = "INSERT INTO " . $tablePrefix . "confirmation_levels (name,comments,max_requirements) VALUES ('" . HtmlEntitiesNOD($nm) . "','$cm','$max')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num = $requestAct->newId('confirmation_levels');
                    $approval_stages[$nm] = $num;
                    // The collection of authorizers
                    $authorizers = $stage->getElementsByTagName("authorizers");

                    foreach ($authorizers as $authorizer) {
                        $elements3 = $authorizer->getElementsByTagName("type");  // The type of authorizer
                        $aut = $elements3->item(0)->nodeValue;
                        $elements4 = $authorizer->getElementsByTagName("id");    // The id of authorizer
                        $au = $elements4->item(0)->nodeValue;
                        $elements5 = $authorizer->getElementsByTagName("required");

                        if ($elements5->length == 0) {
                            $aur = enumBoolean::bFalse;
                        } else {
                            $aur = $elements5->item(0)->nodeValue;
                        }

                        if ($aut == enumAuthorizerType::atUser) {  // get the unique id of user
                            $nm = strtoupper(HtmlEntitiesNOD($au));
                            $querymore = " WHERE (UPPER(mem.login)='$nm' OR UPPER(mem.name)='$nm') AND mem.active='" . enumBoolean::bTrue . "'";
                            $memberDetail = clone $requestAct;
                            $memberDetail->openMembers($querymore);
                            $au = $memberDetail->mem_id[0];
                        }

                        $tmpsql = "INSERT INTO " . $tablePrefix . "confirmation_levels_detail (confirmation_level,authorizer_type,authorizer,required) VALUES ('$num','$aut','" . HtmlEntitiesNOD($au) . "','$aur')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                } else {    // approval stage already exists
                    $approval_stages[$nm] = $confirmationLevelDetail->con_id[0];
                }
            }
        }

        // The collection of approval procedures
        $approvals = $doc->getElementsByTagName("approval_procedure");

        if ($approvals->length > 0) {
            foreach ($approvals as $approval) {
                $elements = $approval->getElementsByTagName("name");    // The name of approval procedure
                $nm = $elements->item(0)->nodeValue;
                // check if the approval procedure exists
                $tmpquery = "SELECT id FROM " . $tablePrefix . "approvals WHERE UPPER(name)='" . strtoupper(HtmlEntitiesNOD($nm)) . "'";
                $requestAct->query($tmpquery);

                if ($requestAct->rowCount() == '0') {  // new approval procedure
                    $elements1 = $approval->getElementsByTagName("doctype"); // The document type of approval procedure
                    $dt = $elements1->item(0)->nodeValue;
                    $elements2 = $approval->getElementsByTagName("comments");    // The description of approval procedure
                    $cm = $elements2->item(0)->nodeValue;
                    $elements3 = $approval->getElementsByTagName("conditions");  // whether conditions to launch approval procedure
                    $cd = $elements3->item(0)->nodeValue;
                    $elements31 = $approval->getElementsByTagName("userquery");  // user query to launch approval procedure
                    $uq = $elements31->item(0)->nodeValue;
                    $tmpsql = "INSERT INTO " . $tablePrefix . "approvals (name,doctype,conditions,active,comments,userquery) VALUES ('" . HtmlEntitiesNOD($nm) . "','$dt','$cd','$act','" . HtmlEntitiesNOD($cm) . "','" . HtmlEntitiesNOD($uq) . "')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num = $requestAct->newId('approvals');    // The unique id of new approval procedure

                    if ($cd == 'Y') {
                        // The collection of conditions to launch approval procedure
                        $terms = $approval->getElementsByTagName("term");

                        foreach ($terms as $term) {
                            $elements4 = $term->getElementsByTagName("fieldname");   // The name of field
                            $fn = $elements4->item(0)->nodeValue;
                            $elements5 = $term->getElementsByTagName("ratio");   // comparison operator
                            $r = $elements5->item(0)->nodeValue;
                            $elements6 = $term->getElementsByTagName("value");   // The value of field or the name of another field
                            $v = $elements6->item(0)->nodeValue;
                            $elements7 = $term->getElementsByTagName("compare_fields");  // whether comparison of two fields
                            $cf = $elements7->item(0)->nodeValue;
                            $tmpsql = "INSERT INTO " . $tablePrefix . "approvals_terms(approval,fieldname,ratio,value,compare_fields) VALUES ('$num','$fn','$r','" . HtmlEntitiesNOD($v) . "','$cf')";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }
                        }
                    }

                    // The collection of approval procedure originators
                    $originators = $approval->getElementsByTagName("originator");

                    foreach ($originators as $originator) {
                        $elements1 = $originator->getElementsByTagName("type");  // The type of originator
                        $pdt = $elements1->item(0)->nodeValue;
                        $elements2 = $originator->getElementsByTagName("id");    // The id of originator
                        $pd = $elements2->item(0)->nodeValue;
                        $skip = false;

                        switch ($pdt) {
                            case enumProducerType::ptUser:
                                // check if user exist
                                $nm = strtoupper(HtmlEntitiesNOD($pd));
                                $querymore = " WHERE (UPPER(mem.login)='$nm' OR UPPER(mem.name)='$nm') AND mem.active='" . enumBoolean::bTrue . "'";
                                $memberDetail = clone $requestAct;
                                $memberDetail->openMembers($querymore);
                                $comptMemberDetail = count($memberDetail->mem_id);

                                if ($comptMemberDetail == '0') {
                                    $skip = true;
                                    continue;
                                }

                                $pd = $memberDetail->mem_id[0];
                                break;
                            case enumProducerType::ptDepartment:
                                // check if department exist
                                $nm = strtoupper(HtmlEntitiesNOD($pd));
                                $querymore = " WHERE UPPER(dep.name)='$nm'";
                                $departmentDetail = clone $requestAct;
                                $departmentDetail->openDepartments($querymore);
                                $comptDepartmentDetail = count($departmentDetail->dep_id);

                                if ($comptDepartmentDetail == '0') {
                                    $skip = true;
                                    continue;
                                }

                                $pd = $departmentDetail->dep_id[0];
                                break;
                            case enumProducerType::ptTeam:
                                // check if project exist
                                $nm = strtoupper(HtmlEntitiesNOD($pd));
                                $querymore = " WHERE UPPER(pro.name)='$nm'";
                                $projectDetail = clone $requestAct;
                                $projectDetail->openDepartments($querymore);
                                $comptProjectDetail = count($projectDetail->pro_id);

                                if ($comptProjectDetail == '0') {
                                    $skip = true;
                                    continue;
                                }

                                $pd = $projectDetail->pro_id[0];
                                break;
                        }

                        if ($skip === true) {
                            continue;
                        }

                        $elements = $originator->getElementsByTagName("exclude");   // whether excluding this originator
                        $ex = $elements->item(0)->nodeValue;
                        $tmpsql = "INSERT INTO " . $tablePrefix . "approvals_producers(approval,producer_type,producer,exclude) VALUES ('$num','$pdt','$pd','$ex')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }

                    // The collection of stages
                    $stages = $approval->getElementsByTagName("stage");

                    foreach ($stages as $stage) {
                        $elements1 = $stage->getElementsByTagName("name");   // The name of stage
                        $nm = $elements1->item(0)->nodeValue;
                        $elements2 = $stage->getElementsByTagName("sortid"); // The order of stage
                        $sortid = $elements2->item(0)->nodeValue;
                        $st = isset($approval_stages[$nm])?$approval_stages[$nm]:'0';
                        $tmpsql = "INSERT INTO " . $tablePrefix . "approvals_stages(approval,confirmation_level,sortid) VALUES ('$num','$st','$sortid')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                }
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../approvals/listapprovaltemplates.php?msg=add");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=workflow", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/listapprovaltemplates.php?", lang_strings("approval_templates"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("import_approval_templates"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "imA";
$block1->openForm("../approvals/importapprovaltemplates.php?#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="import">';
$block1->heading(lang_strings("import_approval_templates"));
$block1->openContent();
$block1->contentRow(lang_strings("active_immediately"), '<input type="checkbox" name="act" value="Y">');
$block1->contentRow("*&nbsp;" . lang_strings("upload"), setupUploadFileHTML('1', '.xml', true));
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["import"] . "\">");
$block1->closeContent();
$block1->note(lang_strings('importapproval_help'));
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
