<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listapprovalstages.php,v 1.6 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=workflow", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("approval_stages"));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
logURL($strings['approval_stages'], '../approvals/listapprovalstages.php');
$block1 = new block();
$block1->form = 'apS';
$block1->openForm('../approvals/listapprovalstages.php?#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('approval_stages'));
$block1->openPaletteIcon();

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteIcon(0, 'add', $strings['add']);
}

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteIcon(1, 'remove', $strings['delete']);
}

$block1->paletteIcon(2, 'info', $strings['view']);

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteIcon(3, 'edit', $strings['edit']);
}

$block1->closePaletteIcon();
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '20';
$block1->sorting('confirmation_levels', (isset($sortingUser['confirmation_levels'])?$sortingUser['confirmation_levels']:''), 'con.name ASC', $sortingFields = array(0 => 'con.name', 1 => 'con.comments', 2 => 'con.max_requirements'));
$block1->recordsTotal = compt($initrequest['confirmation_levels']);
$tmpquery = " ORDER BY " . $block1->sortingValue;
$listConfirmationLevels = new request();
$listConfirmationLevels->openConfirmationLevels($tmpquery, $block1->borne, $block1->rowsLimit);
$comptListConfirmationLevels = count($listConfirmationLevels->con_id);

if ($comptListConfirmationLevels > 0) {
    $labels = array(lang_strings('name'), lang_strings('description'), lang_strings('no_of_approvals_required'));
    $block1->openResults();
    $block1->labels($labels, 'false');

    for ($i=0; $i<$comptListConfirmationLevels; $i++) {
        $block1->openRow($listConfirmationLevels->con_id[$i]);
        $block1->cellRow($blockPage->buildLink("../approvals/viewapprovalstage.php?id=" . $listConfirmationLevels->con_id[$i] . $urlBornes, $listConfirmationLevels->con_name[$i], 'in'));
        $comm = strip_tags($listConfirmationLevels->con_comments[$i]);
        $block1->cellRow($comm);
        $block1->cellRow($listConfirmationLevels->con_max_requirements[$i]);
        $block1->closeRow();
    }

    $block1->closeResults();
    $block1->bornesFooter("1", $blockPage->bornesNumber);
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteScript(0, 'add', '../approvals/editapprovalstage.php?', 'true,false,false', $strings['add']);
}

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteScript(1, 'remove', '../approvals/deleteapprovalstages.php?' . $urlBornes, 'false,true,true', $strings['delete']);
}

$block1->paletteScript(2, 'info', '../approvals/viewapprovalstage.php?' . $urlBornes, 'false,true,false', $strings['view']);

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteScript(3, 'edit', '../approvals/editapprovalstage.php?' . $urlBornes, 'false,true,false', $strings['edit']);
}

$block1->closePaletteScript($comptListConfirmationLevels, $listConfirmationLevels->con_id);
require_once('../includes/footer.php');
