<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listapprovaltemplates.php,v 1.7 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=workflow", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("approval_templates"));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
logURL($strings['approval_templates'], '../approvals/listapprovaltemplates.php');
$block1 = new block();
$block1->form = 'apT';
$block1->openForm('../approvals/listapprovaltemplates.php?#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('approval_templates'));
$block1->openPaletteIcon();

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteIcon(0, 'add', $strings['add']);
}

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteIcon(1, 'remove', $strings['delete']);
}

$block1->paletteIcon(2, 'info', $strings['view']);

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteIcon(3, 'edit', $strings['edit']);
}

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteIcon(4, 'import', $strings['import']);
}

$block1->paletteIcon(5, 'export', $strings['export']);
$block1->closePaletteIcon();
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '20';
$block1->sorting('approvals', (isset($sortingUser['approvals'])?$sortingUser['approvals']:''), 'app.name ASC', $sortingFields = array(0 => 'app.name', 1 => 'app.comments', 2 => 'app.active'));
$block1->recordsTotal = compt($initrequest['approvals']);
$tmpquery = " ORDER BY " . $block1->sortingValue;
$listApprovals = new request();
$listApprovals->openApprovals($tmpquery, $block1->borne, $block1->rowsLimit);
$comptListApprovals = count($listApprovals->app_id);

if ($comptListApprovals != '0') {
    $labels = array(lang_strings('name'), lang_strings('description'), lang_strings('active_str'));
    $block1->openResults();
    $block1->labels($labels, 'false');

    for ($i=0; $i<$comptListApprovals; $i++) {
        $block1->openRow($listApprovals->app_id[$i]);
        $block1->cellRow($blockPage->buildLink("../approvals/viewapprovaltemplate.php?id=" . $listApprovals->app_id[$i] . $urlBornes, $listApprovals->app_name[$i], 'in'));
        $comm = strip_tags($listApprovals->app_comments[$i]);
        $block1->cellRow($comm);
        $active = ($listApprovals->app_active[$i]=='Y')?lang_strings('yes'):lang_strings('no');
        $block1->cellRow($active);
        $block1->closeRow();
    }

    $block1->closeResults();
    $block1->bornesFooter("1", $blockPage->bornesNumber);
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteScript(0, 'add', '../approvals/editapprovaltemplate.php?', 'true,false,false', $strings['add']);
}

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteScript(1, 'remove', '../approvals/deleteapprovaltemplates.php?' . $urlBornes, 'false,true,true', $strings['delete']);
}

$block1->paletteScript(2, 'info', '../approvals/viewapprovaltemplate.php?' . $urlBornes, 'false,true,false', $strings['view']);

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteScript(3, 'edit', '../approvals/editapprovaltemplate.php?' . $urlBornes, 'false,true,false', $strings['edit']);
}

if ($SW_Permissions['Approval Procedure']['Write'][$profilSession]) {
    $block1->paletteScript(4, 'import', '../approvals/importapprovaltemplates.php?', 'true,false,false', $strings['import']);
}

$block1->paletteScript(5, 'export', '../approvals/exportapprovaltemplates.php?', 'false,true,true', $strings['export']);
$block1->closePaletteScript($comptListApprovals, $listApprovals->app_id);
require_once('../includes/footer.php');
