<?php // $Revision: 1.20 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: noti_documentadded.php,v 1.20 2013/01/18 09:50:37 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

if ($document_approval == '' || !defined('INNER_NOTI_DOCUMENTADDED')) {
    return;
}

// get approval authorizers
$notiid = 'documentadded';
$querymore2 = " WHERE daa.document_approval='$document_approval' AND daa.confirmation_level='$confirmation_level' AND NOT EXISTS (SELECT noti.member FROM " . $tablePrefix . "notifications noti WHERE noti.member=daa.authorizer AND noti.notiid='$notiid' AND noti.block='" . enumBoolean::bTrue . "') ORDER BY mem.language";
$listDocumentsApprovalAuthorizers = clone $requestAct;
$listDocumentsApprovalAuthorizers->openDocumentsApprovalAuthorizers($querymore2);
$comptListDocumentsApprovalAuthorizers = count($listDocumentsApprovalAuthorizers->daa_document_approval);

if ($comptListDocumentsApprovalAuthorizers == 0) {
    return;
}

// get document definition
$querymore3 = " WHERE tdf.tablename='$doctype'";
$tableDefinitionDetail = clone $requestAct;
$tableDefinitionDetail->openTablesDefinitions($querymore3);
// backup timezone session
$timezoneBackup = $timezoneSession;
// check if email address of receipt is empty
$querymore1 = " WHERE dap.id='$document_approval'";
$documentsApprovalDetail = clone $requestAct;
$documentsApprovalDetail->openDocumentsApproval($querymore1);
unset($att_id, $att_name, $att_path);

// send approval adding notifications
for ($ie0=0,$lastTimezone='',$lastLanguage=''; $ie0<$comptListDocumentsApprovalAuthorizers; $ie0++) {
    // change timezone
    if ($listDocumentsApprovalAuthorizers->daa_loc_timezone[$ie0] == '') {
        $timezoneSession = $defaultTimezone;
    } else {
        $timezoneSession = $listDocumentsApprovalAuthorizers->daa_loc_timezone[$ie0];
    }
    // change language
    if (selectLanguage($listDocumentsApprovalAuthorizers->daa_mem_language[$ie0])) {
        // currency matrix
        require('../includes/currency.inc.php');
        // load array definitions
        require('../includes/arrays.lib.php');
    }

    if (($timezoneSession != $lastTimezone) || ($listDocumentsApprovalAuthorizers->daa_mem_language[$ie0] != $lastLanguage)) {
        // get document details
        switch ($doctype) {
            case 'files':   // file
                $querymore = " WHERE fil.id='$num'";
                $fileDetail = clone $requestAct;
                $fileDetail->openFiles($querymore);
                $att_id[] = $num;
                $att_name[] = $fileDetail->fil_name[0];
                $path = $fileDetail->fil_fullname[0];
                $mail_priority = 3;

                if ($mkdirMethod == 'FTP') {
                    $tmpfname = tempnam ("../files", "FOO");
                    $ftp = ftp_connect(FTPSERVER);
                    ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
                    ftp_get($ftp, $tmpfname, $ftpRoot . "/" . $path, FTP_BINARY);
                    ftp_quit($ftp);
                    $att_path[] = $tmpfname;
                } else {
                    $att_path[] = "../files/" . $path;
                }

                break;
            case 'timesheet':   // timesheet
                $querymore = " WHERE tim.id='$num'";
                $timesheetDetail = clone $requestAct;
                $timesheetDetail->openTimesheet($querymore);
                $mail_priority = 3;
                $generate_mail_attach = 'Y';
                $S_org = 'ALL';
                $S_prj = 'ALL';
                $S_dep = 'ALL';
                $S_mem = $documentsApprovalDetail->dap_owner[0];
                $S_date1 = createDate($timesheetDetail->tim_per_date_start[0], 'date', false, true);
                $S_date2 = createDate($timesheetDetail->tim_per_date_end[0], 'date', false, true);
                $billingSelection = 'ALL';
                include('../reports/exporthours.php');
                $att_id[] = '';
                $att_name[] = $attfname;
                $att_path[] = $tmpfname;
                break;
            case 'leave_requests':  // leave request
                $querymore = " WHERE lea.id='$num'";
                $leaveRequestDetail = clone $requestAct;
                $leaveRequestDetail->openLeaveRequests($querymore);
                $mail_priority = 3;
                $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtLeaveRequest . "' AND fil.doc_id='$num' AND fil.vc_parent=0";
                $listFiles = clone $requestAct;
                $listFiles->openFiles($querymore);
                $comptListFiles = count($listFiles->fil_id);

                for ($ie0=0; $ie0<$comptListFiles; $ie0++) {
                    $att_id[] = $listFiles->fil_id[$ie0];
                    $att_name[] = $listFiles->fil_name[$ie0];

                    if ($mkdirMethod == 'FTP') {
                        $tmpfname = tempnam ("../files", "FOO");
                        $ftp = ftp_connect(FTPSERVER);
                        ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
                        ftp_get($ftp, $tmpfname, $ftpRoot . "/" . $listFiles->fil_fullname[$ie0], FTP_BINARY);
                        ftp_quit($ftp);
                        $att_path[] = $tmpfname;
                    } else {
                        $att_path[] = "../files/" . $listFiles->fil_fullname[$ie0];
                    }
                }

                break;
            case 'expenses':    // expense
                $querymore = " WHERE exp.id='$num'";
                $expenseDetail = clone $requestAct;
                $expenseDetail->openExpenses($querymore);
                $bill_client = ($expenseDetail->exp_billable[0]==enumBoolean::bTrue)?$strings['yes']:$strings['no'];
                $mail_priority = 3;
                $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtExpense . "' AND fil.doc_id='$num' AND fil.vc_parent=0";
                $listFiles = clone $requestAct;
                $listFiles->openFiles($querymore);
                $comptListFiles = count($listFiles->fil_id);

                for ($ie0=0; $ie0<$comptListFiles; $ie0++) {
                    $att_id[] = $listFiles->fil_id[$ie0];
                    $att_name[] = $listFiles->fil_name[$ie0];

                    if ($mkdirMethod == 'FTP') {
                        $tmpfname = tempnam ("../files", "FOO");
                        $ftp = ftp_connect(FTPSERVER);
                        ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
                        ftp_get($ftp, $tmpfname, $ftpRoot . "/" . $listFiles->fil_fullname[$ie0], FTP_BINARY);
                        ftp_quit($ftp);
                        $att_path[] = $tmpfname;
                    } else {
                        $att_path[] = "../files/" . $listFiles->fil_fullname[$ie0];
                    }
                }

                break;
            case 'invoices':    // invoice
                $querymore = " WHERE inv.id='$num'";
                $invoiceDetail = clone $requestAct;
                $invoiceDetail->openInvoices($querymore);
                $mail_priority = 3;
                $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtInvoice . "' AND fil.doc_id='$num' AND fil.vc_parent=0";
                $listFiles = clone $requestAct;
                $listFiles->openFiles($querymore);
                $comptListFiles = count($listFiles->fil_id);

                for ($ie0=0; $ie0<$comptListFiles; $ie0++) {
                    $att_id[] = $listFiles->fil_id[$ie0];
                    $att_name[] = $listFiles->fil_name[$ie0];

                    if ($mkdirMethod == 'FTP') {
                        $tmpfname = tempnam ("../files", "FOO");
                        $ftp = ftp_connect(FTPSERVER);
                        ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
                        ftp_get($ftp, $tmpfname, $ftpRoot . "/" . $listFiles->fil_fullname[$ie0], FTP_BINARY);
                        ftp_quit($ftp);
                        $att_path[] = $tmpfname;
                    } else {
                        $att_path[] = "../files/" . $listFiles->fil_fullname[$ie0];
                    }
                }

                break;
            case 'projects':    // project
                $querymore1 = " WHERE pro.id='$num'";
                $projectDetail = clone $requestAct;
                $projectDetail->openProjects($querymore1);
                $mail_priority = ($projectDetail->pro_priority[0] == enumPriority::prNone)?3:(6 - intval($projectDetail->pro_priority[0]));
                $querymore2 = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtProject . "' AND fil.doc_id='$num' AND fil.vc_parent='0'";
                $listFiles = clone $requestAct;
                $listFiles->openFiles($querymore2);
                $comptListFiles = count($listFiles->fil_id);

                for ($ie0=0; $ie0<$comptListFiles; $ie0++) {
                    $att_id[] = $listFiles->fil_id[$ie0];
                    $att_name[] = $listFiles->fil_name[$ie0];

                    if ($mkdirMethod == 'FTP') {
                        $tmpfname = tempnam ("../files", "FOO");
                        $ftp = ftp_connect(FTPSERVER);
                        ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
                        ftp_get($ftp, $tmpfname, $ftpRoot . "/" . $listFiles->fil_fullname[$ie0], FTP_BINARY);
                        ftp_quit($ftp);
                        $att_path[] = $tmpfname;
                    } else {
                        $att_path[] = "../files/" . $listFiles->fil_fullname[$ie0];
                    }
                }

                // get Project Budget
                $querymore3 = " WHERE pjb.project='$num'";
                $listProjectBudget = clone $requestAct;
                $listProjectBudget->openProjectsBudget($querymore3);
                $comptListProjectBudget = count($listProjectBudget->pjb_project);

                if ($projectDetail->pro_currency[0] == '') {
                    $currency_display = $defaultCurrency;
                } else {
                    $currency_display = $projectDetail->pro_currency[0];
                }

                if ($comptListProjectBudget == '0') {
                    $project_budget = '';
                } else {
                    if ($projectDetail->pro_currency[0] == '') {
                        $currSets = array();

                        foreach ($listProjectBudget->pjb_currency as $curr) {
                            if ($curr != $defaultCurrency && !in_array($curr, $currSets)) {
                                $currSets[] = $curr;
                            }
                        }

                        $currStr = "'" . implode("','", $currSets) . "'";
                        $querymore = " WHERE cur.currency_to='$defaultCurrency' AND cur.currency_from IN ($currStr) AND cur.reference_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d'))+1,intval(date('Y'))) . "'";
                        $listCurrencyRates = clone $requestAct;
                        $listCurrencyRates->openCurrencyRates($querymore);
                        $comptListCurrencyRates = count($listCurrencyRates->cur_currency_from);

                        if ($comptListCurrencyRates != count($currSets)) {
                            $project_budget = '';
                        } else {
                            $project_budget = 0;

                            for ($ie0=0; $ie0<$comptListProjectBudget; $ie0++) {
                                if ($listProjectBudget->pjb_currency[$ie0] == $defaultCurrency) {
                                    $amount = $listProjectBudget->pjb_amount[$ie0];
                                } else {
                                    $idx = array_search($listProjectBudget->pjb_currency[$ie0], $listCurrencyRates->cur_currency_from);
                                    $rate = $listCurrencyRates->cur_exchange_rate[$idx];
                                    $amount = round($listProjectBudget->pjb_amount[$ie0] * $rate, $costAccuracy);
                                }

                                $project_budget += $amount;
                            }
                        }
                    } else {
                        $project_budget = 0;

                        for ($ie0=0; $ie0<$comptListProjectBudget; $ie0++) {
                            $project_budget += $listProjectBudget->pjb_amount[$ie0];
                        }
                    }
                }

                break;
            default:    // form
                $querymore = " WHERE f.id='$num'";
                $formDetail = clone $requestAct;
                $formDetail->openForms($doctype, $querymore);
                $mail_priority = 3;
                $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtForm . "' AND fil.doc_type_ex='$doctype' AND fil.doc_id='$num' AND fil.vc_parent=0";
                $listFiles = clone $requestAct;
                $listFiles->openFiles($querymore);
                $comptListFiles = count($listFiles->fil_id);

                for ($ie0=0; $ie0<$comptListFiles; $ie0++) {
                    $att_id[] = $listFiles->fil_id[$ie0];
                    $att_name[] = $listFiles->fil_name[$ie0];

                    if ($mkdirMethod == 'FTP') {
                        $tmpfname = tempnam ("../files", "FOO");
                        $ftp = ftp_connect(FTPSERVER);
                        ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
                        ftp_get($ftp, $tmpfname, $ftpRoot . "/" . $listFiles->fil_fullname[$ie0], FTP_BINARY);
                        ftp_quit($ftp);
                        $att_path[] = $tmpfname;
                    } else {
                        $att_path[] = "../files/" . $listFiles->fil_fullname[$ie0];
                    }
                }
        }

        // get approval record for document and its approval history
        $querymore = " WHERE dap.docid='$num' AND dap.doctype='$doctype' ORDER BY dap.id";
        $listDocumentsApproval = clone $requestAct;
        $listDocumentsApproval->openDocumentsApproval($querymore);
        $comptListDocumentsApproval = count($listDocumentsApproval->dap_id);
        $replaces = array();

        for ($ke0=0,$ah=''; $ke0<$comptListDocumentsApproval; $ke0++,$ah.='<br>') {
            $x = count($replaces);
            $replaces[] = $listDocumentsApproval->dap_created[$ke0];

            if ($ke0 == 0) {
                $ah .= '<i>' . str_replace('%TIME%', '%TIME' . $x . '%', $strings['submit_at']) . '</i>';
            } else {
                $ah .= '<i>' . str_replace('%TIME%', '%TIME' . $x . '%', $strings['resubmit_at']) . '</i>';
            }

            $querymore = " WHERE daa.document_approval='" . $listDocumentsApproval->dap_id[$ke0] . "' AND daa.status<>'" . enumApprovalStatus::stPending . "' ORDER BY daa.created,daa.modified";
            $listDocumentsApprovalAuthorizer = clone $requestAct;
            $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($querymore);
            $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

            for ($je0=0; $je0<$comptListDocumentsApprovalAuthorizer; $je0++) {
                $ahd = '';

                if ($listDocumentsApprovalAuthorizer->daa_status[$je0] == enumApprovalStatus::stApproved) {
                    $ahd = $strings['approval_history_approved'];
                } else if ($listDocumentsApprovalAuthorizer->daa_status[$je0] == enumApprovalStatus::stNotApproved) {
                    $ahd = $strings['approval_history_rejected'];
                }

                if ($ahd != '') {
                    $ahd1 = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$je0], $ahd);
                    $x = count($replaces);
                    $replaces[] = $listDocumentsApprovalAuthorizer->daa_modified[$je0];
                    $ahd = str_replace('%TIME%', '%TIME' . $x . '%', $ahd1);
                    $ah .= '<br><i>' . $ahd  . '</i>';

                    if ($listDocumentsApprovalAuthorizer->daa_comments[$je0] != '') {
                        $ah .= '<br>' . $listDocumentsApprovalAuthorizer->daa_comments[$je0];
                    }
                }
            }
        }

        $doctypename = tableNameString($doctype) . (($tableDefinitionDetail->tdf_sysdef[0] == 'Y')?'':' (' . $strings['form'] . ')');
        $lastTimezone = $timezoneSession;
        $lastLanguage = $listDocumentsApprovalAuthorizers->daa_mem_language[$ie0];
    }

    $mail = new notification();
    $mail->getUserinfo($producer, "from");
    $mail->getUserinfo($listDocumentsApprovalAuthorizers->daa_authorizer[$ie0], "to");
    $mail->partSubject = $strings["noti_documentadded1"];
    $mail->partMessage = $strings["noti_documentadded2"];
    $mail->openBody();
    $mail->openContent();
    $mail->contentTitle($strings["details"]);
    $mail->contentRow($strings["owner"], $documentsApprovalDetail->dap_mem_name[0]);

    if ($documentsApprovalDetail->dap_comments[0] != '') {
        $mail->contentRow($strings["comments"], $documentsApprovalDetail->dap_comments[0]);
    }

    $mail->contentRow($strings["type"], $doctypename);

    switch ($doctype) {
        case 'files':   // file
            $mail->contentRow($strings["name"], $fileDetail->fil_name[0]);
            $mail->contentRow($strings["vc_version"], $fileDetail->fil_vc_version[0]);
            $mail->contentRow($strings["modify_last_time"], createDate($fileDetail->fil_modified[0], 'both'));
            $mail->contentRow($strings["size"], $fileDetail->fil_size[0]);
            break;
        case 'timesheet':   // timesheet
            $mail->contentRow($strings["period"], createDate($timesheetDetail->tim_per_date_start[0],'date',false,true) . '&nbsp;~&nbsp;' . createDate($timesheetDetail->tim_per_date_end[0],'date',false,true));
            $mail->contentRow($strings["standard"], $timesheetDetail->tim_standard_hours[0]);
            $mail->contentRow($strings["actual"], $timesheetDetail->tim_actual_hours[0]);
            $mail->contentRow($strings["overtime"], $timesheetDetail->tim_overtime_hours[0]);
            $mail->contentRow($strings["billable"], $timesheetDetail->tim_billable_hours[0]);
            break;
        case 'leave_requests':  // leave request
            $mail->contentRow($strings["type"], $strings['HRC__' . $leaveRequestDetail->lea_type[0]]);
            $mail->contentRow($strings["date_start"], createDate($leaveRequestDetail->lea_date_start[0], 'date', false, true));
            $mail->contentRow($strings['time_start'], DbValueDecode(enumFieldType::ftTime, $leaveRequestDetail->lea_time_start[0]));
            $mail->contentRow($strings["date_end"], createDate($leaveRequestDetail->lea_date_end[0], 'date', false, true));
            $mail->contentRow($strings['time_end'], DbValueDecode(enumFieldType::ftTime, $leaveRequestDetail->lea_time_end[0]));
            $mail->contentRow($strings["total"], NumberFormatNOD($leaveRequestDetail->lea_hours_total[0], $hourAccuracy, false) . ' ' . $strings['hours']);
            break;
        case 'expenses':    // expense
            if ($expenseDetail->exp_project[0] != '0') {
                $mail->contentRow($strings["project"], $expenseDetail->exp_pro_name[0]);
            }

            $mail->contentRow($strings["date"], createDate($expenseDetail->exp_docdate[0],'date',false,true));
            $mail->contentRow($strings["claim_type"], $expenseDetail->exp_clt_name_print[0]);
            $mail->contentRow($strings["expense_type"], $expenseDetail->exp_ext_name_print[0]);
            $mail->contentRow($strings["bill_client"], $bill_client);
            $mail->contentRow($strings["amount"], CurrencyFormatNOD($expenseDetail->exp_amount[0], $expenseDetail->exp_currency[0], $costAccuracy));
            break;
        case 'invoices':    // invoice
            $mail->contentRow($strings["invoice_no"], $invoiceDetail->inv_invoice_no[0]);
            $mail->contentRow($strings["client"], $invoiceDetail->inv_org_name[0]);
            $mail->contentRow($strings['date'], createDate($invoiceDetail->inv_doc_date[0], 'date', false, true));
            $mail->contentRow($strings['due_date'], createDate($invoiceDetail->inv_due_date[0], 'date', false, true));
            $mail->contentRow($strings['payment_terms'], $invoiceDetail->inv_pyt_name_print[0]);
            $mail->contentRow($strings['payment_method'], $invoiceDetail->inv_pym_name_print[0]);
            $mail->contentRow($strings['subtotal'], CurrencyFormatNOD($invoiceDetail->inv_before_discount[0], $invoiceDetail->inv_currency[0], $costAccuracy));
            $mail->contentRow($strings['discount'], CurrencyFormatNOD($invoiceDetail->inv_discount_sum[0], $invoiceDetail->inv_currency[0], $costAccuracy) . ' (' . $invoiceDetail->inv_discount_percent[0] . '%)');
            $mail->contentRow($strings['tax'], CurrencyFormatNOD($invoiceDetail->inv_tax_sum[0], $invoiceDetail->inv_currency[0], $costAccuracy));
            $mail->contentRow($strings['shipping'], CurrencyFormatNOD($invoiceDetail->inv_freight[0], $invoiceDetail->inv_currency[0], $costAccuracy));
            $mail->contentRow($strings['total'], CurrencyFormatNOD($invoiceDetail->inv_amount[0], $invoiceDetail->inv_currency[0], $costAccuracy));
            break;
        case 'projects':    // project
            $mail->contentRow($strings["name"], $projectDetail->pro_name[0]);
            $mail->contentRow($strings["priority"], $priority[$projectDetail->pro_priority[0]]);
            $mail->contentRow($strings["description"], $projectDetail->pro_description[0]);
            $mail->contentRow($strings["organization"], $projectDetail->pro_org_name[0]);
            $mail->contentRow($strings["type"], $projectType[$projectDetail->pro_type[0]]);

            if ($project_budget != '') {
                if ($currencyOnRight == 'true') {
                    $mail->contentRow($strings["budget"], $project_budget . ' ' . $currency_display);
                } else {
                    $mail->contentRow($strings["budget"], $currency_display . ' ' . $project_budget);
                }
            }

            break;
        default:    // form
            $mail->contentRow($strings['description'], HtmlEntityDecodeNOD($formDetail->rows[0]['description']));
    }

    for ($je0=0; $je0<count($att_name); $je0++) {
        $mail->AddAnAttach($att_path[$je0], $att_name[$je0], $att_id[$je0]);
    }

    $mail->contentTitle($strings["approval_history"]);

    for ($x=0; $x<count($replaces); $x++) {
        $ah = str_replace('%TIME' . $x . '%', createDate($replaces[$x], 'both'), $ah);
    }

    $mail->contentRow('', $ah);
    $mail->closeContent();

    // setup approve & reject links
    switch ($doctype) {
        case 'files':   // file
            $mail->note("$root/linkedcontent/approvefile.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_approve_string[$ie0], $strings['to_approve_document']);
            $mail->note("$root/linkedcontent/rejectfile.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_not_approve_string[$ie0], $strings['to_reject_document']);
            break;
        case 'timesheet':   // timesheet
            $mail->note("$root/timesheet/approvetimesheet.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_approve_string[$ie0], $strings['to_approve_document']);
            $mail->note("$root/timesheet/rejecttimesheet.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_not_approve_string[$ie0], $strings['to_reject_document']);
            break;
        case 'leave_requests':  // leave request
            $mail->note("$root/leaves/approveleaverequest.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_approve_string[$ie0], $strings['to_approve_document']);
            $mail->note("$root/leaves/rejectleaverequest.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_not_approve_string[$ie0], $strings['to_reject_document']);
            break;
        case 'expenses':    // expense
            $mail->note("$root/expenses/approveexpense.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_approve_string[$ie0], $strings['to_approve_document']);
            $mail->note("$root/expenses/rejectexpense.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_not_approve_string[$ie0], $strings['to_reject_document']);
            break;
        case 'invoices':    // invoice
            $mail->note("$root/invoices/approveinvoice.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_approve_string[$ie0], $strings['to_approve_document']);
            $mail->note("$root/invoices/rejectinvoice.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_not_approve_string[$ie0], $strings['to_reject_document']);
            break;
        case 'projects':    // project
            $mail->note("$root/projects/approveproject.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_approve_string[$ie0], $strings['to_approve_document']);
            $mail->note("$root/projects/rejectproject.php?id=$num&doc=$document_approval&auth=" . $listDocumentsApprovalAuthorizers->daa_not_approve_string[$ie0], $strings['to_reject_document']);
            break;
        default:    // form
            $mail->note("$root/forms/approveform.php?id=$num&doc=$document_approval&doctype=$doctype&auth=" . $listDocumentsApprovalAuthorizers->daa_approve_string[$ie0], $strings['to_approve_document']);
            $mail->note("$root/forms/rejectform.php?id=$num&doc=$document_approval&doctype=$doctype&auth=" . $listDocumentsApprovalAuthorizers->daa_not_approve_string[$ie0], $strings['to_reject_document']);
    }

    $mail->note("$root/general/login.php?url=general/home.php");
    $mail->closeBody($notiid);
    $subject = $mail->partSubject . ' ' . $doctypename;
    $mail->Subject = $subject;
    $mail->Priority = $mail_priority;
    $mail->SendItOut($requestAct);
}

// restore timezone session
$timezoneSession = $timezoneBackup;
// restore language
if (selectLanguage($languageSession)) {
    // currency matrix
    require('../includes/currency.inc.php');
    // load array definitions
    require('../includes/arrays.lib.php');
}
