<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewapprovalstage.php,v 1.9 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = " WHERE cld.confirmation_level='$id'";
$listConfirmationLevelsDetail = new request();
$listConfirmationLevelsDetail->openConfirmationLevelsDetail($tmpquery);
$comptListConfirmationLevelsDetail = count($listConfirmationLevelsDetail->cld_confirmation_level);

if ($comptListConfirmationLevelsDetail == "0") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=workflow", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/listapprovalstages.php?" . $urlBornes, lang_strings("approval_stages"), 'in'));
$blockPage->itemBreadcrumbs($listConfirmationLevelsDetail->cld_con_name[0]);
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'vCl';
$block1->openForm('../approvals/viewapprovalstage.php?id=' . $id . $urlBornes . '#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('approval_stage') . ' : ' . $listConfirmationLevelsDetail->cld_con_name[0]);
$block1->openPaletteIcon();

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteIcon(0, 'remove', $strings['delete']);
}

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, 'edit', $strings['edit']);
}

$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings('info'));
$block1->contentRow(lang_strings('name'), $listConfirmationLevelsDetail->cld_con_name[0]);
$block1->contentRow(lang_strings('description'), $listConfirmationLevelsDetail->cld_con_comments[0]);
$block1->contentRow(lang_strings('no_of_approvals_required'), $listConfirmationLevelsDetail->cld_con_max_requirements[0]);
$block1->contentTitle(lang_strings('authorizers'));

for ($i=0; $i<$comptListConfirmationLevelsDetail; $i++) {
    $skip = false;

    switch ($listConfirmationLevelsDetail->cld_authorizer_type[$i]) {
        case enumAuthorizerType::atUser:
            $tmpquery = " WHERE mem.id=" . $listConfirmationLevelsDetail->cld_authorizer[$i];
            $memberDetail = new request($tmpquery);
            $memberDetail->openMembers($tmpquery);
            $authorizer = $block1->buildLink("../users/viewuser.php?id=" . $memberDetail->mem_id[0], $memberDetail->mem_name[0], 'in');
            break;
        case enumAuthorizerType::atProfile:
            $querymore = " WHERE upf.id='" . $listConfirmationLevelsDetail->cld_authorizer[$i] . "'";
            $userProfileDetail = new request();
            $userProfileDetail->openUserProfiles($querymore);
            $authorizer = $userProfileDetail->upf_name_print[0];
            break;
        case enumAuthorizerType::atDepartmentTitle:
        case enumAuthorizerType::atOrganizationTitle:
            $authorizer = $listConfirmationLevelsDetail->cld_authorizer[$i];
            break;
        case enumAuthorizerType::atRole:
            $authorizer = $projectRoles[$listConfirmationLevelsDetail->cld_authorizer[$i]];
            break;
        default:
            $skip = true;
            continue;
    }

    if ($skip === false) {
        $block1->contentRow((($listConfirmationLevelsDetail->cld_required[$i]==enumBoolean::bTrue)?'* ':'') . $authorizerType[$listConfirmationLevelsDetail->cld_authorizer_type[$i]], $authorizer . (($listConfirmationLevelsDetail->cld_required[$i]==enumBoolean::bTrue)?' (' . lang_strings('required') . ')':''));
    }
}

$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$block1->openPaletteScript();

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteScript(0, 'remove', '../approvals/deleteapprovalstages.php?id=' . $id . $urlBornes, 'true,true,false', $strings['delete']);
}

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteScript(1, 'edit', '../approvals/editapprovalstage.php?id=' . $id . $urlBornes, 'true,true,false', $strings['edit']);
}

$block1->closePaletteScript('', '');
require_once('../includes/footer.php');
