<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewapprovaltemplate.php,v 1.13 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Approval Procedure']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

// open approval template
$querymore = " WHERE app.id='$id'";
$approvalDetail = new request();
$approvalDetail->openApprovals($querymore);
$comptApprovalDetail = count($approvalDetail->app_id);

if ($comptApprovalDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Prepare data
 */
// get approval producer list
$querymore = " WHERE apd.approval='$id' ORDER BY apd.exclude";
$listApprovalProducers = new request();
$listApprovalProducers->openApprovalsProducers($querymore);
$comptListApprovalProducers = count($listApprovalProducers->apd_approval);
// get approval criteria list
$querymore = " WHERE apt.approval='$id'";
$listApprovalTerms = new request();
$listApprovalTerms->openApprovalsTerms($querymore);
$comptListApprovalTerms = count($listApprovalTerms->apt_id);
// get approval stage list
$querymore = " WHERE aps.approval='$id' ORDER BY aps.sortid";
$listApprovalStages = new request();
$listApprovalStages->openApprovalsStages($querymore);
$comptListApprovalStages = count($listApprovalStages->aps_approval);
// get table definition of the approval document type
$querymore = " WHERE tdf.tablename='" . $approvalDetail->app_doctype[0] . "'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore);
// setup the display name of the approval document type
$docnam = tableNameString($tableDefinitionDetail->tdf_tablename[0]);
if ($tableDefinitionDetail->tdf_sysdef[0] == 'N')
    $docnam .= ' (' . lang_strings('form') . ')';
// get field definition list of the approval document type
$querymore = " WHERE fdf.tablename='" . $tableDefinitionDetail->tdf_tablename[0] . "'";
$listFieldsDefinitions = new request();
$listFieldsDefinitions->openFieldsDefinitions($querymore);
$comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);
// get field definition list for linked tables
for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
    if ($listFieldsDefinitions->fdf_linkedtable[$i] == '')
        continue;
    $querymore = " WHERE fdf.tablename='" . $listFieldsDefinitions->fdf_linkedtable[$i] . "' ORDER BY fdf.sysdef DESC,fdf.fieldname";
    $listFieldsDefinitionsLT = new request();
    $listFieldsDefinitionsLT->openFieldsDefinitions($querymore);
    $comptListFieldsDefinitionsLT = count($listFieldsDefinitionsLT->fdf_tablename);

    for ($j=0; $j<$comptListFieldsDefinitionsLT; $j++) {
        $listFieldsDefinitions->fdf_tablename[] = $listFieldsDefinitionsLT->fdf_tablename[$j];
        $listFieldsDefinitions->fdf_fieldname[] = $listFieldsDefinitions->fdf_fieldname[$i] . '.' . $listFieldsDefinitionsLT->fdf_fieldname[$j];
        $listFieldsDefinitions->fdf_fielddesc[] = $listFieldsDefinitions->fdf_fielddesc[$i] . '.' . $listFieldsDefinitionsLT->fdf_fielddesc[$j];
    }
}
// re-caculate size of field definition list
$comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=workflow", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/approvalprocedures.php?", lang_strings("approval_procedures"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../approvals/listapprovaltemplates.php?" . $urlBornes, lang_strings("approval_templates"), 'in'));
$blockPage->itemBreadcrumbs($approvalDetail->app_name[0]);
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "vAp";
$block1->openForm('../approvals/viewapprovaltemplate.php?id=' . $id . $urlBornes . '#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('approval_template') . ' : ' . $approvalDetail->app_name[0]);
$block1->openPaletteIcon();

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteIcon(0, 'remove', $strings['delete']);
}

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, 'edit', $strings['edit']);
}

$block1->paletteIcon(2, 'export', $strings['export']);
$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings('info'));
$block1->contentRow(lang_strings('name'), $approvalDetail->app_name[0]);
$block1->contentRow(lang_strings('description'), $approvalDetail->app_comments[0]);
$block1->contentRow(lang_strings('document'), $docnam);
$block1->contentRow(lang_strings("active_str"), (($approvalDetail->app_active[0] == 'Y')?lang_strings("yes"):lang_strings("no")));
$block1->contentTitle(lang_strings('launch_approval'));

if ($approvalDetail->app_conditions[0] == 'Y') {
    $block1->contentRow(lang_strings("when_following"));

    for ($i=0, $c=''; $i<$comptListApprovalTerms; $i++, $c=$strings['op_and']) {
        $k1 = array_search($listApprovalTerms->apt_fieldname[$i], $listFieldsDefinitions->fdf_fieldname);

        if ($listApprovalTerms->apt_compare_fields[$i] == 'Y') {
            $k2 = array_search($listApprovalTerms->apt_value[$i], $listFieldsDefinitions->fdf_fieldname);
            $block1->contentRow($c, $listFieldsDefinitions->fdf_fielddesc[$k1] . ' ' . $ratioArray[$listApprovalTerms->apt_ratio[$i]] . ' ' . $listFieldsDefinitions->fdf_fielddesc[$k2] . '(' . lang_strings('compare_fields') . ')', "false", "");
        } else {
            if (preg_match('/\./', $listApprovalTerms->apt_fieldname[$i])) {
                list($srcfld, $fldnam) = preg_split('/\./', $listApprovalTerms->apt_fieldname[$i]);
                $querymore = " LEFT OUTER JOIN " . $tablePrefix . "fields_def fdf1 ON fdf1.linkedtable=fvd.tablename WHERE fdf1.tablename='" . $tableDefinitionDetail->tdf_tablename[0] . "' AND fdf1.fieldname='$srcfld' AND fvd.fieldname='$fldnam'";
            } else {
                $querymore = " WHERE fvd.tablename='" . $tableDefinitionDetail->tdf_tablename[0] . "' AND fvd.fieldname='" . $listApprovalTerms->apt_fieldname[$i] . "'";
            }

            $listFieldsValuesDefinitions = new request();
            $listFieldsValuesDefinitions->openFieldsValuesDefinitions($querymore);
            $comptListFieldsValuesDefinitions = count($listFieldsValuesDefinitions->fvd_tablename);

            if ($comptListFieldsValuesDefinitions != '0') {
                $vla = explode(',', $listApprovalTerms->apt_value[$i]);
                unset($vl);

                foreach ($vla as $v) {
                    $k2 = array_search($v, $listFieldsValuesDefinitions->fvd_fieldvalue);
                    $vl[] = $listFieldsValuesDefinitions->fvd_fieldvalue_desc[$k2];
                }

                $value = implode(',', $vl);
            } else {
                $value = $listApprovalTerms->apt_value[$i];
            }

            $block1->contentRow($c, $listFieldsDefinitions->fdf_fielddesc[$k1] . ' ' . $ratioArray[$listApprovalTerms->apt_ratio[$i]] . ' ' . $value, "false", "");
        }
    }
} elseif ($approvalDetail->app_conditions[0] == 'Q') {
    $block1->contentRow(lang_strings("when_query_met"), $approvalDetail->app_userquery[0]);
} else {
    $block1->contentRow(lang_strings("always"));
}

$block1->closeContent();
$block1->openContent();
$block1->contentTitle(lang_strings("originators"));

for ($i=0, $c=''; $i<$comptListApprovalProducers; $i++, $c=$strings['op_or']) {
    $rval = $producerType[$listApprovalProducers->apd_producer_type[$i]] . '&nbsp;';

    switch ($listApprovalProducers->apd_producer_type[$i]) {
        case enumProducerType::ptUser:
            $rval .= $block1->buildLink('../users/viewuser.php?id=' . $listApprovalProducers->apd_producer[$i], $listApprovalProducers->apd_producer_name[$i], 'in');
            break;
        case enumProducerType::ptProfile:
            $querymore = " WHERE upf.id='" . $listApprovalProducers->apd_producer[$i] . "'";
            $userProfileDetail = new request();
            $userProfileDetail->openUserProfiles($querymore);
            $rval .= $userProfileDetail->upf_name_print[0];
            break;
        case enumProducerType::ptDepartment:
            $rval .= $listApprovalProducers->apd_producer_name[$i];
            break;
        case enumProducerType::ptTeam:
            $rval .= $block1->buildLink('../projects/viewproject.php?id=' . $listApprovalProducers->apd_producer[$i], $listApprovalProducers->apd_producer_name[$i], 'in');
            break;
    }

    if ($listApprovalProducers->apd_exclude[$i] == 'Y') {
        $block1->contentRow(lang_strings('exclude'), $rval, "false", "");
    } else {
        $block1->contentRow($c, $rval, "false", "");
    }
}

$block1->closeContent();
$block1->openContent();
$block1->contentTitle(lang_strings("stages"));

for ($i=0; $i<$comptListApprovalStages; $i++) {
    $block1->contentRow($i+1, $block1->buildLink('../approvals/viewapprovalstage.php?id=' . $listApprovalStages->aps_confirmation_level[$i], $listApprovalStages->aps_con_name[$i], 'in'));
}

$block1->closeContent();
$block1->closeForm();
$block1->openPaletteScript();

if ($SW_Permissions['Approval Procedure']['Admin'][$profilSession]) {
    $block1->paletteScript(0, 'remove', '../approvals/deleteapprovaltemplates.php?id=' . $id . $urlBornes, 'true,true,false', $strings['delete']);
}

if ($SW_Permissions['Approval Procedure']['Edit'][$profilSession]) {
    $block1->paletteScript(1, 'edit', '../approvals/editapprovaltemplate.php?id=' . $id . $urlBornes, 'true,true,false', $strings['edit']);
}

$block1->paletteScript(2, 'export', '../approvals/exportapprovaltemplates.php?id=' . $id, 'true,true,true', $strings['export']);
$block1->closePaletteScript('', '');
require_once('../includes/footer.php');
