<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewdocument.php,v 1.16 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
$querymore0 = " WHERE daa.document_approval='$id' AND daa.authorizer='$idSession' AND daa.stage=dap.current_stage AND dap.closed='N' ORDER BY dap.created";
$documentsApprovalAuthorizerDetail = new request();
$documentsApprovalAuthorizerDetail->openDocumentsApprovalAuthorizers($querymore0);
$comptDocumentsApprovalAuthorizerDetail = count($documentsApprovalAuthorizerDetail->daa_document_approval);

if ($comptDocumentsApprovalAuthorizerDetail == "1") {
    if ($documentsApprovalAuthorizerDetail->daa_dap_canceled[0] == 'Y') {
        header("Location: ../general/home.php?msg=docCanceled");
        exit;
    } else {
        $querymore1 = " WHERE dap.id='$id'";
        $documentsApprovalDetail = new request();
        $documentsApprovalDetail->openDocumentsApproval($querymore1);
        $doctype = $documentsApprovalDetail->dap_doctype[0];
        $num = $documentsApprovalDetail->dap_docid[0];
        $querymore2 = " WHERE tdf.tablename='$doctype'";
        $tableDefinitionDetail = new request();
        $tableDefinitionDetail->openTablesDefinitions($querymore2);
        $doctypename = tableNameString($doctype) . (($tableDefinitionDetail->tdf_sysdef[0] == 'Y')?'':' (' . lang_strings('form') . ')');
    }
} else {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Actions
 */
if ($action == 'approve') {
    switch ($doctype) {
        case 'files':
            header("Location: ../linkedcontent/approvefile.php?id=$num&doc=$id");
            exit;
        case 'timesheet':
            header("Location: ../timesheet/approvetimesheet.php?id=$num&doc=$id");
            exit;
        case 'leave_requests':
            header("Location: ../leaves/approveleaverequest.php?id=$num&doc=$id");
            exit;
        case 'expenses':
            header("Location: ../expenses/approveexpense.php?id=$num&doc=$id");
            exit;
        case 'invoices':
            header("Location: ../invoices/approveinvoice.php?id=$num&doc=$id");
            exit;
        case 'projects':
            header("Location: ../projects/approveproject.php?id=$num&doc=$id");
            exit;
        default:
            header("Location: ../forms/approveform.php?id=$num&doc=$id&doctype=$doctype");
    }
} else if ($action == 'reject') {
    switch ($doctype) {
        case 'files':
            header("Location: ../linkedcontent/rejectfile.php?id=$num&doc=$id");
            exit;
        case 'timesheet':
            header("Location: ../timesheet/rejecttimesheet.php?id=$num&doc=$id");
            exit;
        case 'leave_requests':
            header("Location: ../leaves/rejectleaverequest.php?id=$num&doc=$id");
            exit;
        case 'expenses':
            header("Location: ../expenses/rejectexpense.php?id=$num&doc=$id");
            exit;
        case 'invoices':
            header("Location: ../invoices/rejectinvoice.php?id=$num&doc=$id");
            exit;
        case 'projects':
            header("Location: ../projects/rejectproject.php?id=$num&doc=$id");
            exit;
        default:
            header("Location: ../forms/rejectform.php?id=$num&doc=$id&doctype=$doctype");
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../general/home.php', lang_strings('home'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('view_document'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'vDo';
$block1->openForm('../approvals/viewdocument.php?id=' . $id . '#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('view_document'));
$block1->openContent();
echo '<input type="hidden" id="action" name="action" value="">';
$block1->contentTitle(lang_strings('info'));
$block1->contentRow(lang_strings("owner"), $blockPage->buildLink($documentsApprovalDetail->dap_owner[0], '', 'message'));

if ($documentsApprovalDetail->dap_comments[0] != '') {
    $block1->contentRow(lang_strings("comments"), $documentsApprovalDetail->dap_comments[0]);
}

$block1->contentRow(lang_strings("status"), $statusDocumentApproval[$documentsApprovalAuthorizerDetail->daa_status[0]]);

if ($documentsApprovalAuthorizerDetail->daa_modified[0] != '0') {
    $block1->contentRow(lang_strings('modify_last_time'), createDate($documentsApprovalAuthorizerDetail->daa_modified[0], 'both'));
}

$block1->contentRow(lang_strings("type"), $doctypename);
$block1->contentTitle(lang_strings('details'));

switch ($doctype) {
    case 'files':
        $querymore = " WHERE fil.id='$num'";
        $fileDetail = new request();
        $fileDetail->openFiles($querymore);
        $viewLink = '&nbsp;&nbsp;' . $blockPage->buildLink('../linkedcontent/viewfile.php?id=' . $num . '&amp;doc_id=' . $fileDetail->fil_parent[0], lang_strings("view"), 'in');
        $block1->contentRow(lang_strings("name"), $fileDetail->fil_name[0] . $viewLink);
        $block1->contentRow(lang_strings("vc_version"), $fileDetail->fil_vc_version[0]);
        $block1->contentRow(lang_strings("ifc_last_date"), $fileDetail->fil_date[0]);
        $block1->contentRow(lang_strings("size"), $fileDetail->fil_size[0]);
        setupCustomFieldsHTML($block1, 'files', $num);
        break;
    case 'timesheet':
        $querymore = " WHERE tim.id='$num'";
        $timesheetDetail = new request();
        $timesheetDetail->openTimesheet($querymore);
        $_SESSION['TARGET'] = 'hours';
        $params = array();
        $params['S_ORGSEL'] = 'ALL';
        $params['S_PRJSEL'] = 'ALL';
        $params['S_DEPSEL'] = 'ALL';
        $params['S_ATSEL'] = $documentsApprovalDetail->dap_owner[0];
        $params['S_DATE1'] = $timesheetDetail->tim_per_date_start[0];
        $params['S_DATE2'] = $timesheetDetail->tim_per_date_end[0];
        $params['S_BILLING'] = 'ALL';
        $_SESSION['PARAMS'] = $params;
        $viewLink = '&nbsp;&nbsp;' . $blockPage->buildLink('../reports/hours.php?pis=true', lang_strings("view"), 'in');
        $block1->contentRow(lang_strings("period"), createDate($timesheetDetail->tim_per_date_start[0], 'date', false, true) . '&nbsp;~&nbsp;' . createDate($timesheetDetail->tim_per_date_end[0], 'date', false, true) . $viewLink);
        $block1->contentRow(lang_strings("standard"), $timesheetDetail->tim_standard_hours[0]);
        $block1->contentRow(lang_strings("actual"), $timesheetDetail->tim_actual_hours[0]);
        $block1->contentRow(lang_strings("overtime"), $timesheetDetail->tim_overtime_hours[0]);
        $block1->contentRow(lang_strings("billable"), $timesheetDetail->tim_billable_hours[0]);
        break;
    case 'leave_requests':
        $querymore = " WHERE lea.id='$num'";
        $leaveRequestDetail = new request();
        $leaveRequestDetail->openLeaveRequests($querymore);
        $viewLink = '&nbsp;&nbsp;' . $blockPage->buildLink('../leaves/viewleaverequest.php?id=' . $num, lang_strings("view"), 'in');
        $block1->contentRow(lang_strings("type"), $strings['HRC__' . $leaveRequestDetail->lea_type[0]]);
        $block1->contentRow($strings["date_start"], createDate($leaveRequestDetail->lea_date_start[0], 'date', false, true));
        $block1->contentRow($strings['time_start'], DbValueDecode(enumFieldType::ftTime, $leaveRequestDetail->lea_time_start[0]));
        $block1->contentRow($strings["date_end"], createDate($leaveRequestDetail->lea_date_end[0], 'date', false, true));
        $block1->contentRow($strings['time_end'], DbValueDecode(enumFieldType::ftTime, $leaveRequestDetail->lea_time_end[0]));
        $block1->contentRow($strings["total"], NumberFormatNOD($leaveRequestDetail->lea_hours_total[0], $hourAccuracy, false) . ' ' . $strings['hours'] . $viewLink);
        setupCustomFieldsHTML($block1, 'leave_requests', $num);
        break;
    case 'expenses':
        $querymore = " WHERE exp.id='$num'";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($querymore);
        $viewLink = '&nbsp;&nbsp;' . $blockPage->buildLink('../expenses/viewexpense.php?id=' . $num, lang_strings("view"), 'in');
        $bill_client = ($expenseDetail->exp_billable[0]==enumBoolean::bTrue)?lang_strings('yes'):lang_strings('no');

        if ($expenseDetail->exp_project[0] != '0') {
            $block1->contentRow(lang_strings("project"), $expenseDetail->exp_pro_name[0]);
        }

        $block1->contentRow(lang_strings("claim_type"), $expenseDetail->exp_clt_name_print[0]);
        $block1->contentRow(lang_strings("expense_type"), $expenseDetail->exp_ext_name_print[0]);
        $block1->contentRow(lang_strings("bill_client"), $bill_client);
        $block1->contentRow(lang_strings("amount"), CurrencyFormatNOD($expenseDetail->exp_amount[0], $expenseDetail->exp_currency[0], $costAccuracy) . $viewLink);
        setupCustomFieldsHTML($block1, 'expenses', $num);
        break;
    case 'invoices':    // invoice
        $querymore = " WHERE inv.id='$num'";
        $invoiceDetail = new request();
        $invoiceDetail->openInvoices($querymore);
        $block1->contentRow(lang_strings('invoice_no'), $invoiceDetail->inv_invoice_no[0]);
        $block1->contentRow(lang_strings('client'), $invoiceDetail->inv_org_name[0]);
        $block1->contentRow(lang_strings('date'), createDate($invoiceDetail->inv_doc_date[0], 'date', false, true));
        $block1->contentRow(lang_strings('due_date'), createDate($invoiceDetail->inv_due_date[0], 'date', false, true));
        $block1->contentRow(lang_strings('payment_terms'), $invoiceDetail->inv_pyt_name_print[0]);
        $block1->contentRow(lang_strings('payment_method'), $invoiceDetail->inv_pym_name_print[0]);
        setupCustomFieldsHTML($block1, 'invoices', $num);
        $block1->contentRow(lang_strings('subtotal'), CurrencyFormatNOD($invoiceDetail->inv_before_discount[0], $invoiceDetail->inv_currency[0], $costAccuracy));
        $block1->contentRow(lang_strings('discount'), CurrencyFormatNOD($invoiceDetail->inv_discount_sum[0], $invoiceDetail->inv_currency[0], $costAccuracy) . ' (' . $invoiceDetail->inv_discount_percent[0] . '%)');
        $block1->contentRow(lang_strings('tax'), CurrencyFormatNOD($invoiceDetail->inv_tax_sum[0], $invoiceDetail->inv_currency[0], $costAccuracy));
        $block1->contentRow(lang_strings('shipping'), CurrencyFormatNOD($invoiceDetail->inv_freight[0], $invoiceDetail->inv_currency[0], $costAccuracy));
        $block1->contentRow(lang_strings('total'), CurrencyFormatNOD($invoiceDetail->inv_amount[0], $invoiceDetail->inv_currency[0], $costAccuracy));
        break;
    case 'projects':
        $querymore1 = " WHERE pro.id='$num'";
        $projectDetail = new request();
        $projectDetail->openProjects($querymore1);
        // get Project Budget
        $querymore2 = " WHERE pjb.project='$num'";
        $listProjectBudget = new request();
        $listProjectBudget->openProjectsBudget($querymore2);
        $comptListProjectBudget = count($listProjectBudget->pjb_project);

        if ($projectDetail->pro_currency[0] == '') {
            $currency_display = $defaultCurrency;
        } else {
            $currency_display = $projectDetail->pro_currency[0];
        }

        if ($comptListProjectBudget == '0') {
            $project_budget = '';
        } else {
            if ($projectDetail->pro_currency[0] == '') {
                $currSets = array();

                foreach ($listProjectBudget->pjb_currency as $curr) {
                    if ($curr != $defaultCurrency && !in_array($curr, $currSets)) {
                        $currSets[] = $curr;
                    }
                }

                $currStr = "'" . implode("','", $currSets) . "'";
                $querymore = " WHERE cur.currency_to='$defaultCurrency' AND cur.currency_from IN ($currStr) cur.reference_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d'))+1,intval(date('Y'))) . "'";
                $listCurrencyRates = new request();
                $listCurrencyRates->openCurrencyRates($querymore);
                $comptListCurrencyRates = count($listCurrencyRates->cur_currency_from);

                if ($comptListCurrencyRates != count($currSets)) {
                    $project_budget = '';
                } else {
                    $project_budget = 0;

                    for ($i=0; $i<$comptListProjectBudget; $i++) {
                        if ($listProjectBudget->pjb_currency[$i] == $defaultCurrency) {
                            $amount = $listProjectBudget->pjb_amount[$i];
                        } else {
                            $idx = array_search($listProjectBudget->pjb_currency[$i], $listCurrencyRates->cur_currency_from);
                            $rate = $listCurrencyRates->cur_exchange_rate[$idx];
                            $amount = round($listProjectBudget->pjb_amount[$i] * $rate, $costAccuracy);
                        }

                        $project_budget += $amount;
                    }
                }
            } else {
                $project_budget = 0;

                for ($i=0; $i<$comptListProjectBudget; $i++) {
                    $project_budget += $listProjectBudget->pjb_amount[$i];
                }
            }
        }

        $block1->contentRow(lang_strings("name"), $projectDetail->pro_name[0]);
        $block1->contentRow(lang_strings("priority"), $priority[$projectDetail->pro_priority[0]]);
        $block1->contentRow(lang_strings("description"), $projectDetail->pro_description[0]);
        $block1->contentRow(lang_strings("organization"), $projectDetail->pro_org_name[0]);
        $block1->contentRow(lang_strings("type"), $projectType[$projectDetail->pro_type[0]]);

        if ($project_budget != '') {
            if ($currencyOnRight == 'true') {
                $block1->contentRow(lang_strings("budget"), $project_budget . ' ' . $currency_display);
            } else {
                $block1->contentRow(lang_strings("budget"), $currency_display . ' ' . $project_budget);
            }
        }

        setupCustomFieldsHTML($block1, 'projects', $num);
        break;
    default:
        $querymore = " WHERE f.id='$num'";
        $formDetail = new request();
        $formDetail->openForms($doctype, $querymore);
        $block1->contentRow(lang_strings('id'), $num . ' ' . $blockPage->buildLink('../forms/viewform.php?tblnam=' . $doctype . '&id=' . $num, lang_strings("view"), 'in'));
        setupCustomFieldsHTML($block1, $doctype, $num);
}

$block1->contentTitle(lang_strings("approval_history"));
$querymore = " WHERE dap.docid='$num' AND dap.doctype='$doctype' ORDER BY dap.id";
$listDocumentsApproval = new request();
$listDocumentsApproval->openDocumentsApproval($querymore);
$comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

for ($i=0,$ah=''; $i<$comptListDocumentsApproval; $i++,$ah.='<br>') {
    if ($i == 0) {
        $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['submit_at']) . '</i>';
    } else {
        $ah .= '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['resubmit_at']) . '</i>';
    }

    $querymore = " WHERE daa.document_approval='" . $listDocumentsApproval->dap_id[$i] . "' AND daa.status<>'" . enumApprovalStatus::stPending . "' ORDER BY daa.created,daa.modified";
    $listDocumentsApprovalAuthorizer = new request();
    $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($querymore);
    $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

    for ($j=0; $j<$comptListDocumentsApprovalAuthorizer; $j++) {
        $ahd = '';

        if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stApproved) {
            $ahd = $strings['approval_history_approved'];
        } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stNotApproved) {
            $ahd = $strings['approval_history_rejected'];
        }

        if ($ahd != '') {
            $ahd0 = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
            $ahd = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j], 'both'), $ahd0);
            $ah .= '<br><i>' . $ahd  . '</i>';

            if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                $ah .= '<br>' . $listDocumentsApprovalAuthorizer->daa_comments[$j];
            }
        }
    }
}

$block1->contentRow('', $ah);
$block1->contentRow('', '
<input type="SUBMIT" value="' . $strings['approve'] . '" onclick="document.getElementById(\'action\').value=\'approve\';">&nbsp;&nbsp;
<input type="SUBMIT" value="' . $strings['reject'] . '" onclick="document.getElementById(\'action\').value=\'reject\';">
');
$block1->closeContent();
$block1->closeForm();
require_once('../includes/footer.php');
