<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletecalendarevents.php,v 1.9 2013/01/29 08:46:20 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$dateCalend = isset($_REQUEST['dateCalend'])?$_REQUEST['dateCalend']:$dateToday;
$view = isset($_GET['view'])?$_GET['view']:'week';
$year = intval(date('Y', $dateCalend));
$month = intval(date('n', $dateCalend));
$day = intval(date('j', $dateCalend));
$monthName = $monthNameArray[$month];

/**
 * Permission check
 */
if (!$SW_Permissions['Calendar']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$ids = "'" . str_replace("**", "','", $id) . "'";
$querymore1 = " WHERE cae.id IN ($ids)";
$listCalendarEvents1 = new request();
$listCalendarEvents1->openCalendarEvents($querymore1);
$comptListCalendarEvents1 = count($listCalendarEvents1->cae_id);

if ($comptListCalendarEvents1 == 0) {
    header('Location: ../calendar/viewcalendar.php?view=' . $view . '&dateCalend=' . $dateCalend . '&msg=permissiondenied');
    exit;
}

$querymore2 = " WHERE cae.id IN ($ids) AND cae.cuser='$idSession'";
$listCalendarEvents2 = new request();
$listCalendarEvents2->openCalendarEvents($querymore2);
$comptListCalendarEvents2 = count($listCalendarEvents2->cae_id);

if ($comptListCalendarEvents2!=$comptListCalendarEvents1 && !$SW_Permissions['Calendar']['Admin'][$profilSession]) {
    header('Location: ../calendar/viewcalendar.php?view=' . $view . '&dateCalend=' . $dateCalend . '&msg=permissiondenied');
    exit;
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "DELETE FROM " . $tablePrefix . "calendar_events WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../calendar/viewcalendar.php?view=' . $view . '&dateCalend=' . $dateCalend . '&msg=delete');
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?", lang_strings("calendar"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=month&dateCalend=$dateCalend", "$monthName $year", 'in'));

if ($view != 'month') {
    $w = date('N', $dateCalend);
    $dateFrom = mktime(0, 0, 0, $month, $day+1-$w, $year);
    $dateTo = mktime(0, 0, 0, $month, $day+7-$w, $year);
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=week&dateCalend=$dateCalend", createDate($dateFrom, 'date', false, true) . ' ~ ' . createDate($dateTo, 'date', false, true), 'in'));

    if ($view == 'day') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=day&dateCalend=$dateCalend", $dayShortNameArray[date('N', $dateCalend)] . ' ' . createDate($dateCalend, 'date', false, true), 'in'));
    }
}

$blockPage->itemBreadcrumbs(lang_strings("delete"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "dCe";
$block1->openForm("../calendar/deletecalendarevents.php?view=$view&dateCalend=$dateCalend&id=$id");
echo '<input type="hidden" name="action" value="delete">';
$block1->heading(lang_strings("delete"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListCalendarEvents1; $i++) {
    $block1->contentRow($listCalendarEvents1->cae_id[$i], createDate($listCalendarEvents1->cae_time_start[$i]) . ' ' . $listCalendarEvents1->cae_subject[$i]);
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");

