<?php // $Revision: 1.14 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editcalendarevent.php,v 1.14 2013/01/29 08:46:20 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.caEForm.subject.focus();"';
$dateToday = mktime(0, 0, 0, intval(date('n')), intval(date('j')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$view = isset($_GET['view'])?$_GET['view']:'week';
$dateCalend = AddSlashesNOD(isset($_REQUEST['dateCalend'])?$_REQUEST['dateCalend']:$dateToday);
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$cal = isset($_POST['cal'])?$_POST['cal']:'';
$subject = isset($_POST['subject'])?$_POST['subject']:'';
$description = isset($_POST['description'])?$_POST['description']:'';
$cdI = isset($_POST['cdI'])?$_POST['cdI']:'';
$tsi = isset($_POST['time_start'])?$_POST['time_start']:'';
$tei = isset($_POST['time_end'])?$_POST['time_end']:'';
$time_start = date2Timestamp($cdI, $tsi, true);
$time_end = date2Timestamp($cdI, $tei, true);
$rep = isset($_POST['rep'])?$_POST['rep']:'';
$repe = isset($_POST['repe'])?$_POST['repe']:'';
$ends = isset($_POST['ends'])?$_POST['ends']:'';
$repcnt = isset($_POST['repcnt'])?$_POST['repcnt']:'';
$endonI = isset($_POST['endonI'])?$_POST['endonI']:'';
$reminder1 = isset($_POST['reminder1'])?$_POST['reminder1']:"0";
$reminder2 = isset($_POST['reminder2'])?$_POST['reminder2']:"0";
$year = intval(date('Y', $dateCalend));
$month = intval(date('n', $dateCalend));
$day = intval(date('j', $dateCalend));
$monthName = $monthNameArray[$month];
$error = '';

if ($gmtTimezone == 'true') {  // GMT Timezone Enabled
    $serverTZ = date('Z');        // Timezone offset in seconds.
    $hoursTZ = ($timezoneSession=='')?0:floor(floatval($timezoneSession));            // The hours of timezone
    $minutesTZ = ($timezoneSession=='')?0:((floatval($timezoneSession)-$hoursTZ)*60);   // The minutes of timezone
} else {
    $serverTZ = 0;
    $hoursTZ = 0;
    $minutesTZ = 0;
}

/**
 * Permission check
 */
if (!$SW_Permissions['Calendar']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore1 = " WHERE cal.owner='$idSession' ORDER BY cal.target";
$listCalendars = new request();
$listCalendars->openCalendars($querymore1);
$comptListCalendars = count($listCalendars->cal_owner);

if ($id != "") {
    $querymore2 = " WHERE cae.id='$id'";
    $calendarEventDetail = new request();
    $calendarEventDetail->openCalendarEvents($querymore2);
    $comptCalendarEventDetail = count($calendarEventDetail->cae_id);

    if ($comptCalendarEventDetail == "0") {
        header('Location: ../calendar/viewcalendar.php?view=' . $view . '&dateCalend=' . $dateCalend . '&msg=permissiondenied');
        exit;
    } elseif ($calendarEventDetail->cae_cuser[0] != $idSession && !$SW_Permissions['Calendar']['Admin'][$profilSession]) {
        header('Location: ../calendar/viewcalendar.php?view=' . $view . '&dateCalend=' . $dateCalend . '&msg=permissiondenied');
        exit;
    }
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    if ($reminder1 == 0) {
        $reminder1 = $reminder2;
        $reminder2 = 0;
    } else if ($reminder1 == $reminder2) {
        $reminder2 = 0;
    }

    list($target, $target_id) = explode(":", $cal);
    $subject = HtmlEntitiesNOD($subject);
    $description = HtmlEntitiesNOD($description);

    if ($action == "update") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "calendar_events SET target='$target',target_id='$target_id',subject='$subject',description='$description',time_start='$time_start',time_end='$time_end',reminder_time1='$reminder1',reminder_time2='$reminder2',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../calendar/viewcalendar.php?view=$view&dateCalend=$dateCalend&msg=update");
            exit;
        }
    } else if ($action == "add") {
        if ($rep != '' && $ends == '2') {
            $endon = date2Timestamp($endonI, $tsi, true);
        }

        switch ($rep) {
            case 'd':
                if ($ends == '1') {
                    for ($i=0,$d=0; $i<$repcnt; $i++, $d+=$repe) {
                        $tsA[] = mktime(date('H',$time_start),date('i',$time_start),date('s',$time_start),date('n',$time_start),date('j',$time_start)+$d,date('Y',$time_start));
                        $teA[] = mktime(date('H',$time_end),date('i',$time_end),date('s',$time_end),date('n',$time_end),date('j',$time_end)+$d,date('Y',$time_end));
                    }
                } else {
                    $date1 = $time_start;
                    $date2 = $time_end;

                    while ($date1 <= $endon) {
                        $tsA[] = $date1;
                        $teA[] = $date2;
                        $date1 = mktime(date('H',$date1),date('i',$date1),date('s',$date1),date('n',$date1),date('j',$date1)+$repe,date('Y',$date1));
                        $date2 = mktime(date('H',$date2),date('i',$date2),date('s',$date2),date('n',$date2),date('j',$date2)+$repe,date('Y',$date2));
                    }
                }
                break;
            case 'w':
                if ($ends == '1') {
                    for ($i=0,$d=0; $i<$repcnt; $i++, $d+=(7*$repe)) {
                        $tsA[] = mktime(date('H',$time_start),date('i',$time_start),date('s',$time_start),date('n',$time_start),date('j',$time_start)+$d,date('Y',$time_start));
                        $teA[] = mktime(date('H',$time_end),date('i',$time_end),date('s',$time_end),date('n',$time_end),date('j',$time_end)+$d,date('Y',$time_end));
                    }
                } else {
                    $date1 = $time_start;
                    $date2 = $time_end;

                    while ($date1 <= $endon) {
                        $tsA[] = $date1;
                        $teA[] = $date2;
                        $date1 = mktime(date('H',$date1),date('i',$date1),date('s',$date1),date('n',$date1),date('j',$date1)+(7*$repe),date('Y',$date1));
                        $date2 = mktime(date('H',$date2),date('i',$date2),date('s',$date2),date('n',$date2),date('j',$date2)+(7*$repe),date('Y',$date2));
                    }
                }
                break;
            case 'm':
                if ($ends == '1') {
                    for ($i=0,$n=0; $i<$repcnt; $i++, $n+=$repe) {
                        $tsA[] = mktime(date('H',$time_start),date('i',$time_start),date('s',$time_start),date('n',$time_start)+$n,date('j',$time_start),date('Y',$time_start));
                        $teA[] = mktime(date('H',$time_end),date('i',$time_end),date('s',$time_end),date('n',$time_end)+$n,date('j',$time_end),date('Y',$time_end));
                    }
                } else {
                    $date1 = $time_start;
                    $date2 = $time_end;

                    while ($date1 <= $endon) {
                        $tsA[] = $date1;
                        $teA[] = $date2;
                        $date1 = mktime(date('H',$date1),date('i',$date1),date('s',$date1),date('n',$date1)+$repe,date('j',$date1),date('Y',$date1));
                        $date2 = mktime(date('H',$date2),date('i',$date2),date('s',$date2),date('n',$date2)+$repe,date('j',$date2),date('Y',$date2));
                    }
                }
                break;
            case 'y':
                if ($ends == '1') {
                    for ($i=0,$y=0; $i<$repcnt; $i++, $y+=$repe) {
                        $tsA[] = mktime(date('H',$time_start),date('i',$time_start),date('s',$time_start),date('n',$time_start),date('j',$time_start),date('Y',$time_start)+$y);
                        $teA[] = mktime(date('H',$time_end),date('i',$time_end),date('s',$time_end),date('n',$time_end),date('j',$time_end),date('Y',$time_end)+$y);
                    }
                } else {
                    $date1 = $time_start;
                    $date2 = $time_end;

                    while ($date1 <= $endon) {
                        $tsA[] = $date1;
                        $teA[] = $date2;
                        $date1 = mktime(date('H',$date1),date('i',$date1),date('s',$date1),date('n',$date1),date('j',$date1),date('Y',$date1)+$repe);
                        $date2 = mktime(date('H',$date2),date('i',$date2),date('s',$date2),date('n',$date2),date('j',$date2),date('Y',$date2)+$repe);
                    }
                }
                break;
            default:
                $tsA[] = $time_start;
                $teA[] = $time_end;
        }

        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();

            for ($i=0; $i<count($tsA); $i++) {
                $tmpsql = "INSERT INTO " . $tablePrefix . "calendar_events (target,target_id,subject,description,time_start,time_end,reminder_time1,reminder_time2,created,cuser) VALUES ('$target','$target_id','$subject','$description','" . $tsA[$i] . "','" . $teA[$i] . "','$reminder1','$reminder2','" . time() . "','$idSession')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../calendar/viewcalendar.php?view=$view&dateCalend=$dateCalend&msg=add");
            exit;
        }
    }
}

/**
 * Prepare data
 */
$calVV = array();

for ($i=0; $i<$comptListCalendars; $i++) {
    $k = $listCalendars->cal_target[$i] . ':' . $listCalendars->cal_target_id[$i];
    $calVV[$k] = $listCalendars->cal_target_name[$i];
}

if ($error == '') {
    if ($id != "") {
        $cal = $calendarEventDetail->cae_target[0] . ':' . $calendarEventDetail->cae_target_id[0];
        $subject = $calendarEventDetail->cae_subject[0];
        $description = $calendarEventDetail->cae_description[0];
        $ts = $calendarEventDetail->cae_time_start[0];
        $te = $calendarEventDetail->cae_time_end[0];
        $time_start = mktime(date('H',$ts)+$hoursTZ,date('i',$ts)+$minutesTZ,date('s',$ts)+$serverTZ,date('n',$ts),date('j',$ts),date('Y',$ts));
        $time_end = mktime(date('H',$te)+$hoursTZ,date('i',$te)+$minutesTZ,date('s',$te)+$serverTZ,date('n',$te),date('j',$te),date('Y',$te));
        $reminder1 = $calendarEventDetail->cae_reminder_time1[0];
        $reminder2 = $calendarEventDetail->cae_reminder_time2[0];
    } else {
        reset($calVV);
        $cal = key($calVV);
        $subject = "";
        $description = "";
        $shortname = "";
        $time_start = mktime(date('H')+$hoursTZ+1,$minutesTZ,$serverTZ,$month,$day,$year);
        $time_end = mktime(date('H')+$hoursTZ+2,$minutesTZ,$serverTZ,$month,$day,$year);
        $reminder1 = "0";
        $reminder2 = "0";
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
echo '<script type="text/javascript" src="../javascript/editcalendarevent' . $scriptMinimized . '.js"></script>';
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?", lang_strings("calendar"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=month&dateCalend=$dateCalend", "$monthName $year", 'in'));

if ($view != 'month') {
    $w = date('N', $dateCalend);
    $dateFrom = mktime(0, 0, 0, $month, $day+1-$w, $year);
    $dateTo = mktime(0, 0, 0, $month, $day+7-$w, $year);
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=week&dateCalend=$dateCalend", createDate($dateFrom, 'date', false, true) . ' ~ ' . createDate($dateTo, 'date', false, true), 'in'));

    if ($view == 'day') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=day&dateCalend=$dateCalend", $dayShortNameArray[date('N', $dateCalend)] . ' ' . createDate($dateCalend, 'date', false, true), 'in'));
    }
}

if ($id != "") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendarevent.php?id=$id&amp;view=$view&amp;dateCalend=$dateCalend", $calendarEventDetail->cae_subject[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("modify_calendar_event"));
} else {
    $blockPage->itemBreadcrumbs(lang_strings("add_calendar_event"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "caE";
$block1->openForm("../calendar/editcalendarevent.php?id=$id&amp;dateCalend=$dateCalend&amp;view=$view#" . $block1->form . "Anchor");

if ($id != "") {
    echo '<input type="hidden" name="action" value="update">';
} else {
    echo '<input type="hidden" name="action" value="add">';
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));
setupInputHTML($block1, lang_strings('calendar'), 'cal', enumFieldType::ftText, 'Y', 254, $cal, $calVV);
setupInputHTML($block1, lang_strings('subject'), 'subject', enumFieldType::ftText, 'Y', 255, $subject);
setupInputHTML($block1, lang_strings('description'), 'description', enumFieldType::ftMemo, 'N', '0', $description);
setupInputHTML($block1, lang_strings('date'), 'cdI', enumFieldType::ftDate, 'Y', '0', $time_start);
$time_start_str = (($time_start=='0')?'':date('Hi', $time_start));
setupInputHTML($block1, lang_strings("time_start"), 'time_start', enumFieldType::ftTime, 'Y', '0', $time_start_str);
$time_end_str = (($time_end=='0')?'':date('Hi', $time_end));
setupInputHTML($block1, lang_strings("time_end"), 'time_end', enumFieldType::ftTime, 'Y', '0', $time_end_str);

if ($id == '') {
    echo '<input type="hidden" id="repeve_d" value="' . $strings['days'] . '">';
    echo '<input type="hidden" id="repeve_w" value="' . $strings['weeks'] . '">';
    echo '<input type="hidden" id="repeve_m" value="' . $strings['months'] . '">';
    echo '<input type="hidden" id="repeve_y" value="' . $strings['years'] . '">';
    $repVV = array('' => '--', 'd' => $strings['repeat_daily'], 'w' => $strings['repeat_weekly'], 'm' => $strings['repeat_monthly'], 'y' => $strings['repeat_yearly']);
    setupInputHTML($block1, lang_strings('repeats'), 'rep', enumFieldType::ftAlphaNumeric, 'N', '1', '', $repVV);
    echo '<div id="repcnt" style="margin:0;padding:0">';
    $repeSel = '<select id="repe" name="repe">';

    for ($k=1; $k<31; $k++) {
        $repeSel .= '<option value="' . $k . '"' . (($k==1)?' selected':'') . '>' . $k . '</option>';
    }

    $repeSel .= '</select>';
    $block1->contentRow(lang_strings('repeat_every'), $repeSel . '<div id="repetxt" style="display: inline-block"></div>');
    $repcSel = '<select name="repcnt">';

    for ($k=1; $k<52; $k++) {
        $repcSel .= '<option value="' . $k . '"' . (($k==1)?' selected':'') . '>' . $k . '</option>';
    }

    $repcSel .= '</select>';
    $block1->contentRow(lang_strings('repeat_ends'), '<div><input type="radio" id="ends1" name="ends" value="1" checked>' . sprintf($strings['repeat_ends_occurrences'], $repcSel) . '</div><div><input type="radio" id="ends2" name="ends" value="2">' . lang_strings('repeat_ends_on') . ' <input accept="date" type="text" id="endonI" name="endonI" value=""><strong id="endonIS"></strong></div>');
    echo '</div>';
} else {
    echo '<input type="hidden" id="rep" name="rep" value="">';
}

$remSel = '<select name="reminder1">';

foreach ($reminderTimeArray as $key => $value) {
    if ($key == $reminder1) {
        $remSel .= "<option value=\"$key\" selected>$value</option>";
    } else {
        $remSel .= "<option value=\"$key\">$value</option>";
    }
}

$remSel .= '</select> ' . lang_strings("calendar_reminder_time2") . ' <select name="reminder2">';

foreach ($reminderTimeArray as $key => $value) {
    if ($key == $reminder2) {
        $remSel .= "<option value=\"$key\" selected>$value</option>";
    } else {
        $remSel .= "<option value=\"$key\">$value</option>";
    }
}

$remSel .= "</select> " . lang_strings("calendar_reminder_time3");
$block1->contentRow(lang_strings("calendar_reminder_time1"), $remSel);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
