<?php // $Revision: 1.48 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewcalendar.php,v 1.48 2013/02/09 06:37:06 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$view = AddSlashesNOD(isset($_GET['view'])?$_GET['view']:'week');
$action = AddSlashesNOD(isset($_REQUEST['action'])?$_REQUEST['action']:'');
$target = AddSlashesNOD(isset($_GET['target'])?$_GET['target']:'');
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$cal = AddSlashesNOD(isset($_POST['cal'])?$_POST['cal']:'');
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$dateCalend = AddSlashesNOD(isset($_GET['dateCalend'])?$_GET['dateCalend']:$dateToday);
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$year = intval(date('Y', $dateCalend));
$month = intval(date('n', $dateCalend));
$day = intval(date('j', $dateCalend));
$monthName = $monthNameArray[$month];

if (!in_array($view, array('month', 'week', 'day'))) {
    $view = 'week';
}

if ($gmtTimezone == 'true') {  // GMT Timezone Enabled
    $serverTZ = date('Z');        // Timezone offset in seconds.
    $hoursTZ = ($timezoneSession=='')?0:floor(floatval($timezoneSession));            // The hours of timezone
    $minutesTZ = ($timezoneSession=='')?0:((floatval($timezoneSession)-$hoursTZ)*60);   // The minutes of timezone
} else {
    $serverTZ = 0;
    $hoursTZ = 0;
    $minutesTZ = 0;
}

if ($view == 'month') {
    $sw = date('N', mktime(0, 0, 0, $month, 1, $year));
    $dateFrom = mktime(0, 0, 0, $month, 2-$sw, $year);
    $ew = date('N', mktime(0, 0, 0, $month+1, 0, $year));
    $dateTo = mktime(0, 0, 0, $month+1, 7-$ew, $year);
} elseif ($view == 'week') {
    $w = date('N', $dateCalend);
    $dateFrom = mktime(0, 0, 0, $month, $day+1-$w, $year);
    $dateTo = mktime(0, 0, 0, $month, $day+7-$w, $year);
} else {
    $dateFrom = $dateCalend;
    $dateTo = $dateCalend;
}

/**
 * Permission check
 */
if (!$SW_Permissions['Calendar']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore1 = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore1);
$querymore2 = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.date>='" . mktime(0-$hoursTZ, 0-$minutesTZ, 0-$serverTZ, date('n', $dateFrom), date('j', $dateFrom), date('Y', $dateFrom)) . "' AND wcd.date<'" . mktime(0-$hoursTZ, 0-$minutesTZ, 0-$serverTZ, date('n', $dateTo), date('j', $dateTo)+1, date('Y', $dateTo)) . "'";
$listWorkCalendarDetail = new request();
$listWorkCalendarDetail->openWorkCalendarsDetail($querymore2);
$comptListWorkCalendarDetail = count($listWorkCalendarDetail->wcd_id);

if ($comptListWorkCalendarDetail == '0') {
    header("Location: ../general/home.php?msg=noWorkCalendar");
    exit;
}

/**
 * Actions
 */
if ($action == 'delete' && $target != '' && $id != '' && is_numeric($target) && is_numeric($id)) {
    $tmpsql = "DELETE FROM " . $tablePrefix . "calendars WHERE owner='$idSession' AND target='$target' AND target_id='$id'";
    connectSql($tmpsql);
} elseif ($action == 'add' && $cal != '') {
    list($target, $target_id) = explode(":", $cal);

    if (in_array($target, array(enumCalendarTarget::tUser, enumCalendarTarget::tOrganization, enumCalendarTarget::tDepartment, enumCalendarTarget::tProject, enumCalendarTarget::tUserProfile)) && is_numeric($target_id)) {
        $tmpsql = "INSERT INTO " . $tablePrefix . "calendars (owner,target,target_id) VALUES ('$idSession','$target','$target_id')";
        connectSql($tmpsql);
    }
}

/**
 * Prepare data
 */
$querymore3 = " WHERE cal.owner='$idSession' ORDER BY cal.target";
$listCalendars = new request();
$listCalendars->openCalendars($querymore3);
$comptListCalendars = count($listCalendars->cal_owner);
$bgcolors = array();
$targets = array();

for ($i=0; $i<$comptListCalendars; $i++) {
    $k = $listCalendars->cal_target[$i] . ':' . $listCalendars->cal_target_id[$i];
    $bgcolors[$k] = $i;
    $targets[] = "(cae.target='" . $listCalendars->cal_target[$i] . "' AND cae.target_id='" . $listCalendars->cal_target_id[$i] . "')";
}

if ($view != 'day') {
    $listCalendarEvents = new request();
    $date1 = $dateFrom;
    $max = 1;

    while ($date1 <= $dateTo) {
        $date2 = mktime(0, 0, 0, intval(date('n', $date1)), intval(date('j', $date1))+1, intval(date('Y', $date1)));
        $querymore4 = " WHERE cae.time_start>='" . mktime(0-$hoursTZ, 0-$minutesTZ, 0-$serverTZ, date('n', $date1), date('j', $date1), date('Y', $date1)) . "' AND cae.time_start<'" . mktime(0-$hoursTZ, 0-$minutesTZ, 0-$serverTZ, date('n', $date2), date('j', $date2), date('Y', $date2)) . "' AND (" . implode(" OR ", $targets) . ") ORDER BY cae.time_start,cae.target,cae.target_id";
        $listCalendarEvents->openCalendarEvents($querymore4);
        $comptListCalendarEvents = count($listCalendarEvents->cae_id);
        $events = array();

        for ($i=0; $i<$comptListCalendarEvents; $i++) {
            $events[] = array('id' => $listCalendarEvents->cae_id[$i], 'target' => $listCalendarEvents->cae_target[$i], 'target_id' => $listCalendarEvents->cae_target_id[$i], 'subject' => $listCalendarEvents->cae_subject[$i]);
        }

        if ($comptListCalendarEvents > $max) {
            $max = $comptListCalendarEvents;
        }

        $listCalendarEvents->data[$date1] = $events;
        $date1 = $date2;
    }
}

/**
 * get available calendars
 */
$availableCalendars = array();
// organization calendar
$k = enumCalendarTarget::tOrganization . ':' . $orgSession;

if (!array_key_exists($k, $bgcolors)) {
    $querymore5 = " WHERE org.id='$orgSession'";
    $mycompanyDetail = new request();
    $mycompanyDetail->openOrganizations($querymore5);
    $availableCalendars[$k] = $mycompanyDetail->org_name[0];
}

// department calendar
$querymore6 = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore6);

if ($memberDetail->mem_dep_name_print[0] != '') {
    $k = enumCalendarTarget::tDepartment . ':' . $memberDetail->mem_department[0];

    if (!array_key_exists($k, $bgcolors)) {
        $availableCalendars[$k] = $memberDetail->mem_dep_name_print[0];
    }
}

// project calendars
$querymore7 = " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=pro.id LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE (pro.status='" . enumProjectStatus::stPlanning . "' OR pro.status='" . enumProjectStatus::stOpen . "') AND tea.member=$idSession AND prp.view_project='" . enumBoolean::bTrue . "' ORDER BY pro.name ASC";
$listProjects = new request();
$listProjects->openProjects($querymore7);
$comptListProjects = count($listProjects->pro_id);

for ($i=0; $i<$comptListProjects; $i++) {
    $k = enumCalendarTarget::tProject . ':' . $listProjects->pro_id[$i];

    if (!array_key_exists($k, $bgcolors)) {
        $availableCalendars[$k] = $listProjects->pro_name[$i];
    }
}

// user profile(group) calendar
$k = enumCalendarTarget::tUserProfile . ':' . $profilSession;

if (!array_key_exists($k, $bgcolors)) {
    $querymore8 = " WHERE upf.id='$profilSession'";
    $userProfileDetail = new request();
    $userProfileDetail->openUserProfiles($querymore8);
    $availableCalendars[$k] = $userProfileDetail->upf_name_print[0];
}

/**
 * Html
 */
$extra_head_content = '<link rel="stylesheet" href="' . verSource('calendar/stylesheet' . $scriptMinimized . '.css') . '" type="text/css">';
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?", lang_strings("calendar"), 'in'));

if ($view == 'month') {
    $title = "$monthName $year";
} elseif ($view == 'week') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=month&dateCalend=$dateCalend", "$monthName $year", 'in'));
    $title = createDate($dateFrom, 'date', false, true) . ' ~ ' . createDate($dateTo, 'date', false, true);
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=month&dateCalend=$dateCalend", "$monthName $year", 'in'));
    $w = date('N', $dateCalend);
    $dateFromB = mktime(0, 0, 0, $month, $day+1-$w, $year);
    $dateToB = mktime(0, 0, 0, $month, $day+7-$w, $year);
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=week&dateCalend=$dateCalend", createDate($dateFromB, 'date', false, true) . ' ~ ' . createDate($dateToB, 'date', false, true), 'in'));
    $title = $dayShortNameArray[date('N', $dateCalend)] . ' ' . createDate($dateCalend, 'date', false, true);
}

$blockPage->itemBreadcrumbs($title);
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = 1;
logURL($title, "../calendar/viewcalendar.php?view=$view&dateCalend=$dateCalend");
$block1 = new block();
$block1->openViewOptions();

if ($view == 'month') {
    $block1->itemViewOptions($block1->buildLink('../calendar/viewcalendar.php?view=' . $view . '&dateCalend=' . mktime(0, 0, 0, $month-1, 1, $year), '<', 'in'));
    $block1->itemViewOptions($block1->buildLink('../calendar/viewcalendar.php?view=' . $view, $strings['today'], 'in'));
    $block1->itemViewOptions($block1->buildLink('../calendar/viewcalendar.php?view=' . $view . '&dateCalend=' . mktime(0, 0, 0, $month+1, 1, $year), '>', 'in'));
} elseif ($view == 'week') {
    $block1->itemViewOptions($block1->buildLink('../calendar/viewcalendar.php?view=' . $view . '&dateCalend=' . mktime(0, 0, 0, $month, $day-7, $year), '<', 'in'));
    $block1->itemViewOptions($block1->buildLink('../calendar/viewcalendar.php?view=' . $view, $strings['today'], 'in'));
    $block1->itemViewOptions($block1->buildLink('../calendar/viewcalendar.php?view=' . $view . '&dateCalend=' . mktime(0, 0, 0, $month, $day+7, $year), '>', 'in'));
} else {
    $block1->itemViewOptions($block1->buildLink('../calendar/viewcalendar.php?view=' . $view . '&dateCalend=' . mktime(0, 0, 0, $month, $day-1, $year), '<', 'in'));
    $block1->itemViewOptions($block1->buildLink('../calendar/viewcalendar.php?view=' . $view, $strings['today'], 'in'));
    $block1->itemViewOptions($block1->buildLink('../calendar/viewcalendar.php?view=' . $view . '&dateCalend=' . mktime(0, 0, 0, $month, $day+1, $year), '>', 'in'));
}

$block1->closeViewOptions();
$block1->form = "chC";
$block1->openForm("../calendar/viewcalendar.php?view=$view&dateCalend=$dateCalend#" . $block1->form . "Anchor");
$c = '<ul class="calendar-colors">';

for ($i=0; $i<$comptListCalendars; $i++) {
    $c .= '<li data-target="x" class="calendar-bgcolor-' . $i . '"><div>' . $listCalendars->cal_target_name[$i] . '</div>';

    if ($i > 0) {
        $c .= '<div><a href="../calendar/viewcalendar.php?dateCalend=' . $dateCalend . '&view=' . $view . '&action=delete&target=' . $listCalendars->cal_target[$i] . '&id=' . $listCalendars->cal_target_id[$i] . '">X</a></div>';
    }

    $c .= '</li>';
}

if (count($availableCalendars) > 0) {
    reset($availableCalendars);
    $cal = key($availableCalendars);
    $calSel = '<select name="cal">';

    foreach ($availableCalendars as $k => $v) {
        $calSel .= '<option value="' . $k . '"' . (($k==$cal)?' selected':'') . '>' . $v . '</option>';
    }

    $calSel .= '</select>';
    $c .= '<li>' . $calSel . '<input type="hidden" name="action" value="add"><input type="SUBMIT" value="+"></li>';
}

$c .= '</ul>';
echo $c;
$block1->closeForm();
$block2 = new block();
$block2->form = "lsC";
$block2->openForm("../calendar/viewcalendar.php?view=$view&dateCalend=$dateCalend#" . $block2->form . "Anchor");
$columns = array();

if ($view == 'month') {
    $columns[0] = new cardviewColumn();
    $columns[0]->title = '';
    $columns[0]->field_type = enumFieldType::ftText;

    for ($i=1; $i<=7; $i++) {
        $columns[$i] = new cardviewColumn();
        $columns[$i]->title = '';
        $columns[$i]->field_type = enumFieldType::ftText;
    }
} elseif ($view == 'week') {
    $columns[0] = new cardviewColumn();
    $columns[0]->title = '';
    $columns[0]->field_type = enumFieldType::ftText;

    for ($i=1; $i<=$max; $i++) {
        $columns[$i] = new cardviewColumn();
        $columns[$i]->title = '';
        $columns[$i]->field_type = enumFieldType::ftText;
    }
} else {
    $block2->borne = $blockPage->returnBorne('1');
    $block2->rowsLimit = '12';
    $block2->sorting("calendar", isset($sortingUser['calendar'])?$sortingUser['calendar']:'', "cae.time_start ASC", $sortingFields = array(0 => "cae.target_id", 1 => "cae.subject", 2 => "cae.time_start", 3 => "cae.time_end"));
    $listCalendarEvents = new request();
    $date1 = $dateFrom;
    $date2 = mktime(0, 0, 0, intval(date('n', $date1)), intval(date('j', $date1))+1, intval(date('Y', $date1)));
    $querymore4 = " WHERE cae.time_start>='" . mktime(0-$hoursTZ, 0-$minutesTZ, 0-$serverTZ, date('n', $date1), date('j', $date1), date('Y', $date1)) . "' AND cae.time_start<'" . mktime(0-$hoursTZ, 0-$minutesTZ, 0-$serverTZ, date('n', $date2), date('j', $date2), date('Y', $date2)) . "' AND (" . implode(" OR ", $targets) . ") ORDER BY " . $block2->sortingValue;
    $block2->recordsTotal = compt($initrequest['calendar_events'] . ' ' . $querymore4);
    $listCalendarEvents->openCalendarEvents($querymore4, $block2->borne, $block2->rowsLimit);
    $comptListCalendarEvents = count($listCalendarEvents->cae_id);
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['calendar'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['subject'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['time_start'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['time_end'];
    $columns[3]->field_type = enumFieldType::ftText;
    $opt[enumCardviewOption::oObject] = 'calendar_events';
    $opt[enumCardviewOption::oTableName] = 'calendar_events';
}

$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oMultipleSelection] = ($view == 'day');
$opt[enumCardviewOption::oExtraParameters] = "view=$view&dateCalend=$dateCalend";
$opt[enumCardviewOption::oTrimTrailEmptyCol] = ($view == 'week');
$opt[enumCardviewOption::oAddUrl] = '../calendar/editcalendarevent.php?view=' . $view . '&dateCalend=' . $dateCalend;
$block2->openCardView($opt);

if ($view == 'month') {
    $date1 = $dateFrom;

    while ($date1 <= $dateTo) {
        $date2 = mktime(0, 0, 0, intval(date('n', $date1)), intval(date('j', $date1))+6, intval(date('Y', $date1)));
        $content = array();
        $content[] = '<a href="../calendar/viewcalendar.php?dateCalend=' . $date1 . '&view=week">' . createDate($date1, 'date', false, true) . ' ~ ' . createDate($date2, 'date', false, true) . '</a>';

        for ($i=0; $i<7; $i++) {
            $date2 = mktime(0, 0, 0, intval(date('n', $date1)), intval(date('j', $date1))+$i, intval(date('Y', $date1)));
            $c = '<ul class="calendar-events"><li><div>' . $dayShortNameArray[date('N', $date2)] . '</div><div>' . date('j', $date2) . '</div></li>';

            if (count($listCalendarEvents->data[$date2])>0) {
                $event = $listCalendarEvents->data[$date2][0];
                $k = $event['target'] . ':' . $event['target_id'];
                $bgcolor = (isset($bgcolors[$k])?$bgcolors[$k]:'0');
                $c .= '<li class="calendar-bgcolor-' . $bgcolor . '"><a href="../calendar/viewcalendarevent.php?view=' . $view . '&dateCalend=' . $dateCalend . '&id=' . $event['id'] . '">' . $event['subject'] . '</a></li>';

                if (count($listCalendarEvents->data[$date2])>1) {
                    $c .= '<li><a href="../calendar/viewcalendar.php?view=day&dateCalend=' . $date2 . '">...</a></li>';
                }
            }

            $c .= '</ul>';
            $content[] = $c;
        }

        $block2->itemCardView($date1, $content);
        $date1 = mktime(0, 0, 0, intval(date('n', $date1)), intval(date('j', $date1))+7, intval(date('Y', $date1)));
    }
} elseif ($view == 'week') {
    $date1 = $dateFrom;

    while ($date1 <= $dateTo) {
        $content = array();
        $content[] = '<a href="../calendar/viewcalendar.php?view=day&dateCalend=' . $date1 . '">' . $dayShortNameArray[date('N', $date1)] . ' ' . createDate($date1, 'date', false, true) . '</a>';

        if (count($listCalendarEvents->data[$date1])>0) {
            foreach ($listCalendarEvents->data[$date1] as $event) {
                $k = $event['target'] . ':' . $event['target_id'];
                $bgcolor = (isset($bgcolors[$k])?$bgcolors[$k]:'0');
                $content[] = '<div class="calendar-subject calendar-bgcolor-' . $bgcolor . '"><a href="../calendar/viewcalendarevent.php?view=' . $view . '&dateCalend=' . $dateCalend . '&id=' . $event['id'] . '">' . $event['subject'] . '</a></div>';
            }
        }

        $block2->itemCardView($date1, $content);
        $date1 = mktime(0, 0, 0, intval(date('n', $date1)), intval(date('j', $date1))+1, intval(date('Y', $date1)));
    }
} else {
    for ($i=0; $i<$comptListCalendarEvents; $i++) {
        $k = $listCalendarEvents->cae_target[$i] . ':' . $listCalendarEvents->cae_target_id[$i];
        $bgcolor = (isset($bgcolors[$k])?$bgcolors[$k]:'0');
        $content = array(
            '<div class="calendar-bgcolor-' . $bgcolor . '">' . $listCalendarEvents->cae_target_name[$i] . '</div>',
            $listCalendarEvents->cae_subject[$i],
            createDate($listCalendarEvents->cae_time_start[$i], 'time'),
            createDate($listCalendarEvents->cae_time_end[$i], 'time')
        );
        $block2->itemCardView($listCalendarEvents->cae_id[$i], $content);
    }
}

$block2->closeCardView();

if ($view == 'day') {
    $block2->bornesFooter("1", $blockPage->bornesNumber, "view=day&dateCalend=$dateCalend");
}

$block2->closeFormResults();
require_once("../includes/footer.php");
