<?php // $Revision: 1.10 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewcalendarevent.php,v 1.10 2013/01/29 08:46:20 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_REQUEST['id'])?$_REQUEST['id']:'');
$dateCalend = isset($_REQUEST['dateCalend'])?$_REQUEST['dateCalend']:$dateToday;
$view = isset($_GET['view'])?$_GET['view']:'week';
$year = intval(date('Y', $dateCalend));
$month = intval(date('n', $dateCalend));
$day = intval(date('j', $dateCalend));
$monthName = $monthNameArray[$month];

/**
 * Permission check
 */
if (!$SW_Permissions['Calendar']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Prepare data
 */
$querymore2 = " WHERE cae.id='$id'";
$calendarEventDetail = new request();
$calendarEventDetail->openCalendarEvents($querymore2);
$comptCalendarEventDetail = count($calendarEventDetail->cae_id);

if ($comptCalendarEventDetail == 0) {
    header('Location: ../calendar/viewcalendar.php');
    exit;
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?", lang_strings("calendar"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=month&dateCalend=$dateCalend", "$monthName $year", 'in'));

if ($view != 'month') {
    $w = date('N', $dateCalend);
    $dateFrom = mktime(0, 0, 0, $month, $day+1-$w, $year);
    $dateTo = mktime(0, 0, 0, $month, $day+7-$w, $year);
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=week&dateCalend=$dateCalend", createDate($dateFrom, 'date', false, true) . ' ~ ' . createDate($dateTo, 'date', false, true), 'in'));

    if ($view == 'day') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../calendar/viewcalendar.php?view=day&dateCalend=$dateCalend", $dayShortNameArray[date('N', $dateCalend)] . ' ' . createDate($dateCalend, 'date', false, true), 'in'));
    }
}

$blockPage->itemBreadcrumbs($calendarEventDetail->cae_subject[0]);
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "ceV";
$block1->openForm("../calendar/viewcalendarevent.php?view=$view&amp;dateCalend=$dateCalend&amp;id=$id#" . $block1->form . "Anchor");
$block1->openPaletteIcon();
$block1->paletteIcon(0, "remove", $strings["delete"]);
$block1->paletteIcon(1, "edit", $strings["edit"]);
$block1->paletteIcon(2, "export", $strings["export"]);
$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow(lang_strings("subject"), $calendarEventDetail->cae_subject[0]);
$block1->contentRow(lang_strings("description"), $calendarEventDetail->cae_description[0]);
$block1->contentRow(lang_strings("date"), createDate($calendarEventDetail->cae_time_start[0],'date'));
$block1->contentRow(lang_strings("time_start"), createDate($calendarEventDetail->cae_time_start[0],'time'));
$block1->contentRow(lang_strings("time_end"), createDate($calendarEventDetail->cae_time_end[0],'time'));

if ($calendarEventDetail->cae_reminder_time1[0] != '0') {
    $reminderContent = $reminderTimeArray[$calendarEventDetail->cae_reminder_time1[0]] . ' ';

    if ($calendarEventDetail->cae_reminder_time2[0] != '0') {
        $reminderContent .= lang_strings("calendar_reminder_time2") . ' ' . $reminderTimeArray[$calendarEventDetail->cae_reminder_time2[0]] . ' ';
    }

    $reminderContent .= lang_strings("calendar_reminder_time3");
    $block1->contentRow(lang_strings("calendar_reminder_time1"), $reminderContent);
}

$block1->closeContent();
$block1->closeForm();
$block1->openPaletteScript();
$block1->paletteScript(0, "remove", "../calendar/deletecalendarevents.php?id=$id&view=$view&dateCalend=$dateCalend", "true,true,true", $strings["delete"]);
$block1->paletteScript(1, "edit", "../calendar/editcalendarevent.php?id=$id&view=$view&dateCalend=$dateCalend", "true,true,true", $strings["edit"]);
$block1->paletteScript(2, "export", "../calendar/exportcalendars.php?id=$id", "true,true,true", $strings["export"]);
$block1->closePaletteScript("", "");
require_once("../includes/footer.php");
