<?php // $Revision: 1.14 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteclients.php,v 1.14 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$ids = "'" . str_replace('**', "','", $id) . "'";
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
$querymore1 = " WHERE org.id IN ($ids) ORDER BY org.name";
$listOrganizations = new request();
$listOrganizations->openOrganizations($querymore1);
$comptListOrganizations = count($listOrganizations->org_id);

if ($comptListOrganizations == '0') {
    header("Location: ../clients/listclients.php?msg=blankClient");
    exit;
}

$tmpquery = "SELECT id FROM " . $tablePrefix . "contacts WHERE organization IN ($ids) "
    . "UNION ALL SELECT id FROM " . $tablePrefix . "departments WHERE organization IN ($ids) "
    . "UNION ALL SELECT id FROM " . $tablePrefix . "invoices WHERE organization IN ($ids) "
    . "UNION ALL SELECT id FROM " . $tablePrefix . "members WHERE organization IN ($ids) "
    . "UNION ALL SELECT id FROM " . $tablePrefix . "projects WHERE organization IN ($ids) ";
$querymore2 = " WHERE fdf.sysdef='N' AND fdf.linkedtable='organizations'";
$listFieldsDefinitions = new request();
$listFieldsDefinitions->openFieldsDefinitions($querymore2);
$comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
    $tmpquery .= "UNION ALL SELECT id FROM " . $tablePrefix . $listFieldsDefinitions->fdf_dbtablename[$i] . " WHERE " . $listFieldsDefinitions->fdf_dbfieldname[$i] . " IN ($ids) ";
}

if (compt($tmpquery) > 0) {
    header("Location: ../clients/listclients.php?msg=clientInUse" . $urlBornes);
    exit;
}

if (!$SW_Permissions['Client']['Edit'][$profilSession]) {
    for ($i=0; $i<$comptListOrganizations; $i++) {
        if ($listOrganizations->org_owner[$i] != $idSession) {
            header("Location: ../clients/listclients.php?msg=permissiondenied" . $urlBornes);
            exit;
        }
    }
}

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'organizations', $ids, 'D');
        $tmpsql = 'DELETE FROM ' . $tablePrefix . "organizations WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "DELETE FROM " . $tablePrefix . "organizations_form WHERE organization IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        for ($i=0; $i<$comptListOrganizations; $i++) {
            $logo = 'Logos/' . $listOrganizations->org_id[$i] . '.' . $listOrganizations->org_extension_logo[$i];

            if (fileExists($logo)) {
                deleteFile($logo);
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../clients/listclients.php?msg=delete' . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../clients/listclients.php?' . $urlBornes, lang_strings('clients'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('delete_organizations'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'saP';
$block1->openForm("../clients/deleteclients.php?id=$id" . $urlBornes);
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings('delete_organizations'));
$block1->openContent();
$block1->contentTitle(lang_strings('delete_following'));

for ($i=0; $i<$comptListOrganizations; $i++) {
    $block1->contentRow('#' . $listOrganizations->org_id[$i], $listOrganizations->org_name[$i]);
}

$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
$block1->note(lang_strings('delete_organizations_note'));
require_once('../includes/footer.php');
