<?php // $Revision: 1.36 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editclient.php,v 1.36 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$cpy = isset($_GET['cpy'])?$_GET['cpy']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$logoDel = isset($_POST['logoDel'])?$_POST['logoDel']:'';
$cn = isset($_POST['cn'])?$_POST['cn']:'';
$add = isset($_POST['add'])?$_POST['add']:'';
$zip = isset($_POST['zip'])?$_POST['zip']:'';
$ct = isset($_POST['ct'])?$_POST['ct']:'';
$cou = isset($_POST['cou'])?$_POST['cou']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$ssc = isset($_POST['ssc'])?$_POST['ssc']:'';
$wp = isset($_POST['wp'])?$_POST['wp']:'';
$fa = isset($_POST['fa'])?$_POST['fa']:'';
$url = isset($_POST['url'])?$_POST['url']:'';
$email = isset($_POST['email'])?$_POST['email']:'';
$cown = isset($_POST['cown'])?$_POST['cown']:'';
$curr = isset($_POST['curr'])?$_POST['curr']:'';
$wc = isset($_POST['wc'])?$_POST['wc']:'1';
$pym = isset($_POST['pym'])?$_POST['pym']:'';
$pyt = isset($_POST['pyt'])?$_POST['pyt']:'';
$l = isset($_POST['l'])?$_POST['l']:'';
$att1 = isset($_POST['atttmp1'])?$_POST['atttmp1']:'';
$bodyCommand = 'onLoad="document.edCForm.cn.focus();"';
$cn_highlight = false;
$lk = DbValueEncode(enumFieldType::ftBoolean, $l);
$error = '';

/**
 * Permission check
 */
if ($id != '') {
    // test exists selected client organization, redirect to list if not
    $querymore = " WHERE org.id='$id'";
    $clientDetail = new request();
    $clientDetail->openOrganizations($querymore);
    $comptClientDetail = count($clientDetail->org_id);

    if ($comptClientDetail == '0') {
        header('Location: ../clients/listclients.php?msg=blankClient' . $urlBornes);
        exit;
    }

    if ($cpy != 'true') {
        if (!$SW_Permissions['Client']['Edit'][$profilSession] && $clientDetail->org_owner[0] != $idSession) {
            header("Location: ../general/home.php?msg=permissiondenied");
            exit;
        }
    } else {
        if (!$SW_Permissions['Client']['Write'][$profilSession]) {
            header("Location: ../general/home.php?msg=permissiondenied");
            exit;
        }
    }
} else {
    if (!$SW_Permissions['Client']['Write'][$profilSession]) {
        header("Location: ../general/home.php?msg=permissiondenied");
        exit;
    }
}

/**
 * Check fields
 */
if ($action != '') {
    $cn = HtmlEntitiesNOD($cn);

    try {
        // test if there is a client with the same name
        if ($action == 'add') {
            $querymore = " WHERE org.name='$cn'";
        } else {
            $querymore = " WHERE org.id<>'$id' AND org.name='$cn'";
        }

        $existsClient = new request();
        $existsClient->openOrganizations($querymore);
        $comptExistsClient = count($existsClient->org_id);

        if ($comptExistsClient != '0') {
            $cn_highlight = true;
            throw new Exception(lang_strings('organization_already_exists'));
        }

        $error = checkCustomFields('organizations', $id);
    } catch (Exception $e) {
        $error = $e->getMessage();
    }
}

/**
 * Actions
 */
if ($action != '' && $error == '') {
    $add = HtmlEntitiesNOD($add);
    $zip = HtmlEntitiesNOD($zip);
    $ct = HtmlEntitiesNOD($ct);
    $cou = HtmlEntitiesNOD($cou);
    $wp = HtmlEntitiesNOD($wp);
    $fa = HtmlEntitiesNOD($fa);
    $c = HtmlEntitiesNOD($c);
    $ssc = HtmlEntitiesNOD($ssc);

    if ($pym == '') {
        $pym = '0';
    }

    if ($pyt == '') {
        $pyt = '0';
    }

    if ($action == 'update') { // case update client organization
        $extensionOld = $clientDetail->org_extension_logo[0];
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();

            if ($logoDel == 'on') {
                $tmpsql = 'UPDATE ' . $tablePrefix . "organizations SET extension_logo='' WHERE id='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                if (fileExists('Logos/' . $id . '.' . $extensionOld)) {
                    deleteFile('Logos/' . $id . '.' . $extensionOld);
                }
            }

            if ($att1 != '' && file_exists($att1)) {
                $attnam = $_POST['attnam1'];
                $extension = strtolower(substr(strrchr($attnam, '.'), 1));
                uploadFile('Logos', $att1, $id . '.' . $extension);
                $tmpsql = 'UPDATE ' . $tablePrefix . "organizations SET extension_logo='$extension' WHERE id='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $cfsql = setupCustomFieldsUpdateSQL('organizations', $id);  // Generate custom fields update sql
            $tmpsql = 'UPDATE ' . $tablePrefix . "organizations SET name='$cn',address='$add',zip_code='$zip',city='$ct',country='$cou',phone='$wp',fax='$fa',url='$url',email='$email',comments='$c',sscomments='$ssc',owner=$cown,currency='$curr',workcalendar='$wc',payment_method='$pym',payment_terms='$pyt',locked='$lk',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'organizations', $id, 'U');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../clients/viewclient.php?id=$id&msg=update" . $urlBornes);
            exit;
        }
    } else if ($action == 'add') { // case add client organization
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsqls = setupCustomFieldsInsertSQL('organizations');  // Generate custom fields insert sql
            // insert into organizations and redirect to new client organization detail (last id)
            $tmpsql = "INSERT INTO " . $tablePrefix . "organizations (name,address,zip_code,city,country,phone,fax,url,email,comments,sscomments,owner,currency,workcalendar,payment_method,payment_terms,locked,created,cuser" . $cfsqls[0] . ") VALUES ('$cn','$add','$zip','$ct','$cou','$wp','$fa','$url','$email','$c','$ssc','$cown','$curr','$wc','$pym','$pyt','$lk','" . time() . "','$idSession'" . $cfsqls[1] . ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('organizations');
            $cfsql = setupCustomMediaFieldsUpdateSQL('organizations', $num);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "organizations SET $cfsql WHERE id='$num'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            if ($att1 != '' && file_exists($att1)) {
                $attnam = $_POST['attnam1'];
                $extension = strtolower(substr(strrchr($attnam, '.'), 1));
                uploadFile('Logos', $att1, $num . '.' . $extension);
                $tmpsql = 'UPDATE ' . $tablePrefix . "organizations SET extension_logo='$extension' WHERE id='$num'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            copy2HistoryTable($requestAct, 'organizations', $num, 'A');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'editclient') {
                $_SESSION['PARAMS']['clod'] = $num;
                $_SESSION['TARGET'] = $_SESSION['SOURCE'];
                $_SESSION['SOURCE'] = '';
                header("Location: " . $_SESSION['LOCATION']);
            } else {
                header("Location: ../clients/viewclient.php?id=$num&msg=add");
            }

            exit;
        }
    }
}
/**
 * get workcalendar list
 */
$querymore = " ORDER BY wca.name";
$listWorkCalendars = new request();
$listWorkCalendars->openWorkCalendars($querymore);
$comptListWorkCalendars = count($listWorkCalendars->wca_id);
$wcVV = array();

for ($i=0; $i<$comptListWorkCalendars; $i++) {
    $wcVV[$listWorkCalendars->wca_id[$i]] = $listWorkCalendars->wca_name[$i];
}
/**
 * get payment terms list
 */
$querymore2 = " WHERE pyt.locked='" . enumBoolean::bFalse . "' ORDER BY pyt.name";
$listPaymentTerms = new request();
$listPaymentTerms->openPaymentTerms($querymore2);
$comptListPaymentTerms = count($listPaymentTerms->pyt_id);
$pytVV = array();

for ($i=0; $i<$comptListPaymentTerms; $i++) {
    $pytVV[$listPaymentTerms->pyt_id[$i]] = $listPaymentTerms->pyt_name_print[$i];
}

/**
 * get payment method list
 */
$querymore3 = " WHERE pym.locked='" . enumBoolean::bFalse . "' ORDER BY pym.name";
$listPaymentMethods = new request();
$listPaymentMethods->openPaymentMethods($querymore3);
$comptListPaymentMethods = count($listPaymentMethods->pym_id);
$pymVV = array();

for ($i=0; $i<$comptListPaymentMethods; $i++) {
    $pymVV[$listPaymentMethods->pym_id[$i]] = $listPaymentMethods->pym_name_print[$i];
}
/**
 * Form variables init
 */
if ($error == '') {
    // set value in form
    if ($id != '') {
        $cown = $clientDetail->org_owner[0];
        $cn = $clientDetail->org_name[0];
        $add = $clientDetail->org_address[0];
        $zip = $clientDetail->org_zip_code[0];
        $ct = $clientDetail->org_city[0];
        $cou = $clientDetail->org_country[0];
        $wp = $clientDetail->org_phone[0];
        $fa = $clientDetail->org_fax[0];
        $url = $clientDetail->org_url[0];
        $email = $clientDetail->org_email[0];
        $c = $clientDetail->org_comments[0];
        $ssc = $clientDetail->org_sscomments[0];
        $curr = $clientDetail->org_currency[0];
        $wc = $clientDetail->org_workcalendar[0];
        $pym = $clientDetail->org_payment_method[0];
        $pyt = $clientDetail->org_payment_terms[0];
        $lk = $clientDetail->org_locked[0];
    } else {
        $cown = $idSession;
        $cn = '';
        $add = '';
        $zip = '';
        $ct = '';
        $cou = '';
        $wp = '';
        $fa = '';
        $url = '';
        $email = '';
        $c = '';
        $ssc = '';
        $curr = '';
        $wc = '1';
        $pym = $listPaymentMethods->pym_id[0];
        $pyt = $listPaymentTerms->pyt_id[0];
    }
}

if ($id == '' || $cpy == 'true') {
    $pathLogo = '';
} else {
    $pathLogo = getLogo($id, $clientDetail->org_extension_logo[0]);
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../clients/listclients.php?' . $urlBornes, lang_strings('clients'), 'in'));

if ($id == '' || $cpy == 'true') {
    $blockPage->itemBreadcrumbs(lang_strings('add_organization'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../clients/viewclient.php?id=' . $clientDetail->org_id[0] . $urlBornes, $clientDetail->org_name[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings('edit_organization'));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "edC";

if ($id == '' || $cpy == 'true') {
    $block1->openForm('../clients/editclient.php#' . $block1->form . 'Anchor');
    $block1->heading(lang_strings('add_organization'));
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
} else {
    $block1->openForm("../clients/editclient.php?id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
    $block1->heading(lang_strings('edit_organization') . ' : ' . $clientDetail->org_name[0]);
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
}

$block1->openContent(true);
$block1->contentTitle(lang_strings('details'));

if ($SW_Permissions['Client']['Admin'][$profilSession]) {
    $querymore1 = " WHERE upd.function_name='Client' AND access_level='Write'";
    $listUserProfilesDetail = new request();
    $listUserProfilesDetail->openUserProfilesDetail($querymore1);
    $selectOwner = '<select name="cown">';
    $querymore2 = " WHERE mem.profil IN ('" . implode("','", $listUserProfilesDetail->upd_user_profile) . "') AND mem.active='" . enumBoolean::bTrue . "' ORDER BY mem.name";
    $clientOwner = new request();
    $clientOwner->openMembers($querymore2);
    $comptClientOwner = count($clientOwner->mem_id);

    for ($i=0; $i<$comptClientOwner; $i++) {
        if ($cown == $clientOwner->mem_id[$i]) {
            $selectOwner .= '<option value="' . $clientOwner->mem_id[$i] . '" selected>' . $clientOwner->mem_name[$i] . '</option>';
        } else {
            $selectOwner .= '<option value="' . $clientOwner->mem_id[$i] . '">' . $clientOwner->mem_name[$i] . '</option>';
        }
    }

    $selectOwner .= '</select>';
    $block1->contentRow(lang_strings('owner'), $selectOwner);
} else {
    echo "<input type=\"hidden\" name=\"cown\" value=\"$idSession\">";
}

setupInputHTML($block1, lang_strings('name'), 'cn', enumFieldType::ftText, 'Y', '255', $cn, '', '', $cn_highlight);
setupInputHTML($block1, lang_strings('address'), 'add', enumFieldType::ftMemo, 'N', '0', $add);
setupInputHTML($block1, lang_strings('zip_code'), 'zip', enumFieldType::ftText, 'N', '36', $zip);
setupInputHTML($block1, lang_strings('city'), 'ct', enumFieldType::ftText, 'N', '255', $ct);
setupInputHTML($block1, lang_strings('country'), 'cou', enumFieldType::ftText, 'N', '255', $cou);
setupInputHTML($block1, lang_strings('phone'), 'wp', enumFieldType::ftText, 'N', '255', $wp);
setupInputHTML($block1, lang_strings('fax'), 'fa', enumFieldType::ftText, 'N', '255', $fa);
setupInputHTML($block1, lang_strings('url'), 'url', enumFieldType::ftUrl, 'N', '255', $url);
setupInputHTML($block1, lang_strings('email'), 'email', enumFieldType::ftEmail, 'N', '255', $email);
$helpStr = '<table>';
$currSel = '<select name="curr"><option value="">' . $strings['CRC'] . '</option>';

foreach ($CurrencyMatrix['active'] as $key) {
    $val = $CurrencyMatrix['name'][$key];
    $helpStr .= '<tr><th>' . $key . '</th><td>' . $val . '</td></tr>';

    if ($curr == $key) {
        $currSel .= '<option value="' . $key . '" selected>' . $key . '</option>';
    } else {
        $currSel .= '<option value="' . $key . '">' . $key . '</option>';
    }
}

$currSel .= '</select>';
$helpStr .= '</table>';
$block1->contentRow(lang_strings('currency') . $blockPage->printHelp($helpStr, true), $currSel);
setupInputHTML($block1, lang_strings('workcalendar'), 'wc', enumFieldType::ftNumeric, 'N', '11', $wc, $wcVV);
setupInputHTML($block1, lang_strings('payment_method') . $blockPage->printHelp('preferred_payment_method_help'), 'pym', enumFieldType::ftNumeric, 'N', '11', $pym, $pymVV);
setupInputHTML($block1, lang_strings('payment_terms') . $blockPage->printHelp('preferred_payment_terms_help'), 'pyt', enumFieldType::ftNumeric, 'N', '11', $pyt, $pytVV);
setupInputHTML($block1, lang_strings('comments'), 'c', enumFieldType::ftMemo, 'N', '0', $c);
setupInputHTML($block1, lang_strings('sscomments'), 'ssc', enumFieldType::ftMemo, 'N', '0', $ssc);
$block1->contentRow(lang_strings('logo'), setupUploadFileHTML('1', 'image/*'));

if ($id != '' && $cpy != 'true') {
    if ($pathLogo != '') {
        $block1->contentRow('', setupPhotoBox($pathLogo, $id . '.' . $clientDetail->org_extension_logo[0]) . '<input name="logoDel" type="checkbox" value="on"> ' . lang_strings('delete'));
    }

    setupInputHTML($block1, lang_strings('locked'), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
}

setupCustomFieldsInputHTML($block1, 'organizations', $id);
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once('../includes/footer.php');
