<?php // $Revision: 1.19 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listclients.php,v 1.19 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$view = isset($_GET['view'])?$_GET['view']:'this_year';

/**
 * Permission check
 */
if (!$SW_Permissions['Client']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings('clients'));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = 'clientList';
$block1->openForm('../clients/listclients.php#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('organizations'));
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '12';
$block1->sorting('organizations', (isset($sortingUser['organizations'])?$sortingUser['organizations']:''), 'org.name ASC', $sortingFields = array(0 => 'org.name', 1 => 'num_open', 2 => 'num_complete', 3 => 'org.phone', 4 => 'org.fax', 5 => 'org.url'));

if ($SW_Permissions['Client']['Admin'][$profilSession]) {
    $querymore = " WHERE org.id<>'1' ORDER BY " . $block1->sortingValue;
} else {
    $querymore = " WHERE org.id<>'1' AND ((org.owner='$idSession') OR (EXISTS (SELECT * FROM " . $tablePrefix . "teams tea LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=tea.project WHERE tea.member=$idSession AND pro.organization=org.id))) ORDER BY " . $block1->sortingValue;
}

$block1->recordsTotal = compt($initrequest['organizations'] . ' ' . $querymore);
$listOrganizations = new request();

switch ($view) {
    case 'this_year':
        $datefrom = mktime(0, 0, 0, 1, 1, intval(date('Y')));
        $dateto = mktime(0, 0, 0, 12, 31, intval(date('Y')));
        break;
    case 'recent_month':
        $datefrom = mktime(0, 0, 0, intval(date('n'))-1, intval(date('j'))+1, intval(date('Y')));
        $dateto = mktime(0, 0, 0, intval(date('n')), intval(date('j')), intval(date('Y')));
        break;
    case 'recent_quarter':
        $datefrom = mktime(0, 0, 0, intval(date('n'))-3, intval(date('j'))+1, intval(date('Y')));
        $dateto = mktime(0, 0, 0, intval(date('n')), intval(date('j')), intval(date('Y')));
        break;
    case 'recent_year':
        $datefrom = mktime(0, 0, 0, intval(date('n')), intval(date('j'))+1, intval(date('Y'))-1);
        $dateto = mktime(0, 0, 0, intval(date('n')), intval(date('j')), intval(date('Y')));
        break;
}

$listOrganizations->openOrganizations2($querymore, $datefrom, $dateto, $block1->borne, $block1->rowsLimit);
$comptListOrganizations = count($listOrganizations->org_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['name'];
$columns[0]->field_type = enumFieldType::ftAlphaNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['open'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[1]->tooltip = $strings['num_open_project'];
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['completed'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[2]->tooltip = $strings['num_completed_project'];
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['phone'];
$columns[3]->field_type = enumFieldType::ftText;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['fax'];
$columns[4]->field_type = enumFieldType::ftText;
$columns[5] = new cardviewColumn();
$columns[5]->title = $strings['url'];
$columns[5]->field_type = enumFieldType::ftUrl;
$opt[enumCardviewOption::oObject] = 'clients';
$opt[enumCardviewOption::oTableName] = 'organizations';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;
$opt[enumCardviewOption::oExtraParameters] = 'borne1=' . $block1->borne;

if ($SW_Permissions['Client']['Write'][$profilSession]) {
    $opt[enumCardviewOption::oAddUrl] = '../clients/editclient.php?';
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListOrganizations; $i++) {
    $content = array(
        $listOrganizations->org_name[$i],
        (($listOrganizations->org_num_open[$i] == '0')?'0':$block1->buildLink('../projects/listprojects.php?client=' . $listOrganizations->org_id[$i] . '&cstatus=open&cnum=' . $listOrganizations->org_num_open[$i], $listOrganizations->org_num_open[$i], 'out')),
        (($listOrganizations->org_num_complete[$i] == '0')?'0':$block1->buildLink('../projects/listprojects.php?client=' . $listOrganizations->org_id[$i] . '&cview=' . $view . '&datefrom=' . $datefrom . '&dateto=' . $dateto . '&cstatus=completed&cnum=' . $listOrganizations->org_num_complete[$i], $listOrganizations->org_num_complete[$i], 'in')),
        $listOrganizations->org_phone[$i],
        $listOrganizations->org_fax[$i],
        $listOrganizations->org_url[$i]
    );
    $block1->itemCardView($listOrganizations->org_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter("1", $blockPage->bornesNumber);

if ($comptListOrganizations > 0) {
    $linkStr = '';

    foreach (array('this_year','recent_month','recent_quarter','recent_year') as $val) {
        if ($linkStr != '') {
            $linkStr .= "&nbsp;|&nbsp;";
        }

        if ($val == $view) {
            $linkStr .= lang_strings($val);
        } else {
            $linkStr .= $blockPage->buildLink('../clients/listclients.php?view=' . $val, lang_strings($val), 'in');
        }
    }

    $block1->note($linkStr);
}

$block1->closeFormResults();
require_once('../includes/footer.php');
