<?php // $Revision: 1.36 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewclient.php,v 1.36 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

if ($toggle_focus == '') {
    $toggle_focus = 'client';
}

/**
 * Permission check
 */
if (!$SW_Permissions['Client']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($SW_Permissions['Client']['Admin'][$profilSession]) {
    $querymore = " WHERE org.id='$id'";
} else {
    $querymore = " WHERE org.owner='$idSession' AND org.id='$id'";
    $clientDetail = new request();
    $clientDetail->openOrganizations($querymore);
    $comptClientDetail = count($clientDetail->org_id);

    if ($comptClientDetail == "0") {
        $querymore1 = " WHERE tea.member='$idSession' AND org2.id='$id'";
        $memberTest = new request();
        $memberTest->openTeams($querymore1);
        $comptMemberTest = count($memberTest->tea_project);

        if ($comptMemberTest == "0") {
            header('Location: ../clients/listclients.php?msg=permissiondenied' . $urlBornes);
            exit;
        }

        $querymore = " WHERE org.id='$id'";
    }
}

$clientDetail = new request();
$clientDetail->openOrganizations($querymore);
$comptClientDetail = count($clientDetail->org_id);

if ($comptClientDetail == '0') {
    header('Location: ../clients/listclients.php?msg=blankClient' . $urlBornes);
    exit;
}

$pathLogo = getLogo($id, $clientDetail->org_extension_logo[0]);

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../clients/listclients.php?' . $urlBornes, lang_strings('clients'), 'in'));
$blockPage->itemBreadcrumbs($clientDetail->org_name[0]);
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '5';     // 1st for listclients
$title = $strings['client'] . ' : ' . $clientDetail->org_name[0];
logURL($title, "../clients/viewclient.php?id=$id");
$block1 = new block();
$block1->form = 'ecD';
$block1->openForm("../clients/viewclient.php?id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
$block1->headingToggle($strings['client'], !($toggle_focus=='client'));
$block1->openPaletteIcon();

if ($SW_Permissions['Client']['Write'][$profilSession]) {
    $block1->paletteIcon(4, 'copy', $strings['copy']);
}

if ($SW_Permissions['Client']['Edit'][$profilSession]) {
    $block1->paletteIcon(0, 'remove', $strings['delete']);
    $block1->paletteIcon(1, 'edit', $strings['edit']);
}

$block1->paletteIcon(99, 'search', 'organizations');
$block1->closePaletteIcon();
$block1->openContent(true);
$block1->contentRow(lang_strings('name'), $clientDetail->org_name[0]);
$block1->contentRow(lang_strings('address'), $clientDetail->org_address[0]);
$block1->contentRow(lang_strings('zip_code'), $clientDetail->org_zip_code[0]);
$block1->contentRow(lang_strings('city'), $clientDetail->org_city[0]);
$block1->contentRow(lang_strings('country'), $clientDetail->org_country[0]);
$block1->contentRow(lang_strings('phone'), $clientDetail->org_phone[0]);
$block1->contentRow(lang_strings('fax'), $clientDetail->org_fax[0]);
$block1->contentRow(lang_strings('url'), $block1->buildLink($clientDetail->org_url[0], $clientDetail->org_url[0], 'out'));
$block1->contentRow(lang_strings('email'), $block1->buildLink($clientDetail->org_email[0], $clientDetail->org_email[0], 'mail'));

if ($clientDetail->org_currency[0] == '') {
    $block1->contentRow(lang_strings('currency'), lang_strings('CRC'));
} else {
    $helpStr = $CurrencyMatrix['name'][$clientDetail->org_currency[0]];
    $block1->contentRow(lang_strings('currency') . '&nbsp;' . $block1->printHelp($helpStr, true), $clientDetail->org_currency[0]);
}

$block1->contentRow(lang_strings('workcalendar'), $block1->buildLink('../workcalendars/viewworkcalendar.php?id=' . $clientDetail->org_workcalendar[0], $clientDetail->org_wca_name[0], 'in'));
$block1->contentRow(lang_strings('payment_method') . $block1->printHelp('preferred_payment_method_help'), $clientDetail->org_pym_name_print[0]);
$block1->contentRow(lang_strings('payment_terms') . $block1->printHelp('preferred_payment_terms_help'), $clientDetail->org_pyt_name_print[0]);
$block1->contentRow(lang_strings('comments'), $clientDetail->org_comments[0]);
$block1->contentRow(lang_strings('sscomments'), $clientDetail->org_sscomments[0]);
$block1->contentRow(lang_strings('owner'), $block1->buildLink($clientDetail->org_mem_id[0], '', 'message'));
$block1->contentRow(lang_strings('created'), createDate($clientDetail->org_created[0],'both'));

if ($pathLogo != '') {
    $block1->contentRow(lang_strings('logo'), setupPhotoBox($pathLogo, $id . '.' . $clientDetail->org_extension_logo[0]));
}

$block1->contentRow(lang_strings('locked'), DbValueDecode(enumFieldType::ftBoolean, $clientDetail->org_locked[0]));
setupCustomFieldsHTML($block1, 'organizations', $id);
$block1->closeContent();
$block1->closeToggle();
$block1->closeForm();
$block1->openPaletteScript();

if ($SW_Permissions['Client']['Write'][$profilSession]) {
    $block1->paletteScript(4, 'copy', '../clients/editclient.php?id=' . $clientDetail->org_id[0] . '&cpy=true', 'true,true,true', $strings['copy']);
}

if ($SW_Permissions['Client']['Edit'][$profilSession]) {
    $block1->paletteScript(0, 'remove', '../clients/deleteclients.php?id=' . $clientDetail->org_id[0] . $urlBornes, 'true,true,true', $strings['delete']);
    $block1->paletteScript(1, 'edit', '../clients/editclient.php?id=' . $clientDetail->org_id[0] . $urlBornes, 'true,true,true', $strings['edit']);
}

$block1->paletteScript(99, 'search', 'organizations');
$block1->closePaletteScript('', '');
// Client Projects
$block2 = new block();
$block2->form = 'clPr';
$block2->openForm("../clients/viewclient.php?id=" . $clientDetail->org_id[0] . "#" . $block2->form . 'Anchor');
$block2->headingToggle(lang_strings('client_projects'), !($toggle_focus=='project'));
$block2->borne = $blockPage->returnBorne('2');
$block2->rowsLimit = '12';
$sortingFields2 = array(0 => 'pro.id', 1 => 'pro.name', 2 => 'pro.priority', 3 => 'pro.status', 4 => 'mem.name');
$block2->sorting('organization_projects', (isset($sortingUser['organization_projects'])?$sortingUser['organization_projects']:''), 'pro.name ASC', $sortingFields2);

if ($projectsFilter == 'true' && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    $querymore = " LEFT OUTER JOIN " . $tablePrefix . "teams teams ON teams.project=pro.id ";
    $querymore .= " WHERE pro.organization='" . $clientDetail->org_id[0] . "' AND teams.member='" . $idSession . "' ORDER BY " . $block2->sortingValue;
} else {
    $querymore = " WHERE pro.organization='" . $clientDetail->org_id[0] . "' ORDER BY " . $block2->sortingValue;
}

$block2->recordsTotal = compt($initrequest['projects'] . $querymore);
$listProjects = new request();
$listProjects->openProjects($querymore, $block2->borne, $block2->rowsLimit);
$comptListProjects = count($listProjects->pro_id);
$columns2 = array();
$columns2[0] = new cardviewColumn();
$columns2[0]->title = $strings['id'];
$columns2[0]->field_type = enumFieldType::ftNumeric;
$columns2[1] = new cardviewColumn();
$columns2[1]->title = $strings['name'];
$columns2[1]->field_type = enumFieldType::ftText;
$columns2[2] = new cardviewColumn();
$columns2[2]->title = $strings['priority'];
$columns2[2]->field_type = enumFieldType::ftText;
$columns2[3] = new cardviewColumn();
$columns2[3]->title = $strings['status'];
$columns2[3]->field_type = enumFieldType::ftText;
$columns2[4] = new cardviewColumn();
$columns2[4]->title = $strings['owner'];
$columns2[4]->field_type = enumFieldType::ftNumeric;
$columns2[4]->linked_table = 'members';
$opt2 = array();
$opt2[enumCardviewOption::oObject] = 'projects';
$opt2[enumCardviewOption::oTableName] = 'projects';
$opt2[enumCardviewOption::oColumns] = $columns2;
$opt2[enumCardviewOption::oSearch] = true;
$opt2[enumCardviewOption::oMultipleSelection] = false;

if ($SW_Permissions['Project']['Write'][$profilSession]) {
    $opt2[enumCardviewOption::oAddUrl] = '../projects/editproject.php?organization=' . $clientDetail->org_id[0];
}

$block2->openCardView($opt2);

for ($i=0; $i<$comptListProjects; $i++) {
    $idStatus = $listProjects->pro_status[$i];
    $idPriority = $listProjects->pro_priority[$i];
    $content = array(
        $listProjects->pro_id[$i],
        $listProjects->pro_name[$i],
        $priority[$idPriority],
        $statusProject[$idStatus],
        $listProjects->pro_owner[$i]
    );
    $block2->itemCardView($listProjects->pro_id[$i], $content);
}

$block2->closeCardView();
$block2->bornesFooter("2", $blockPage->bornesNumber, "id=" . $clientDetail->org_id[0] . "&toggle_focus=project");
$block2->closeToggle();
$block2->closeFormResults();

if ($sitePublish == 'true') {
    // Client Users
    $block3 = new block();
    $block3->form = 'clU';
    $block3->openForm("../clients/viewclient.php?id=" . $clientDetail->org_id[0] . $urlBornes . "#" . $block3->form . 'Anchor');
    $block3->headingToggle(lang_strings('client_users'), !($toggle_focus=='user'));
    $block3->borne = $blockPage->returnBorne('3');
    $block3->rowsLimit = '12';
    $sortingFields3 = array("none", "mem.name", "mem.title", "mem.department", "mem.email_work", "mem.phone_work");
    $block3->sorting('organization_users', (isset($sortingUser['organization_users'])?$sortingUser['organization_users']:''), 'mem.name ASC', $sortingFields3);
    $querymore = " WHERE mem.organization='$id' ORDER BY " . $block3->sortingValue;
    $block3->recordsTotal = compt($initrequest['members'] . $querymore);
    $listMembers = new request();
    $listMembers->openMembers($querymore, $block3->borne, $block3->rowsLimit);
    $comptListMembers = count($listMembers->mem_id);
    $columns3 = array();
    $columns3[0] = new cardviewColumn();
    $columns3[0]->field_type = enumFieldType::ftAvatar;
    $columns3[1] = new cardviewColumn();
    $columns3[1]->title = $strings['full_name'];
    $columns3[1]->field_type = enumFieldType::ftText;
    $columns3[2] = new cardviewColumn();
    $columns3[2]->title = $strings['title'];
    $columns3[2]->field_type = enumFieldType::ftText;
    $columns3[3] = new cardviewColumn();
    $columns3[3]->title = $strings['department'];
    $columns3[3]->field_type = enumFieldType::ftNumeric;
    $columns3[3]->linked_table = 'departments';
    $columns3[4] = new cardviewColumn();
    $columns3[4]->title = $strings['email'];
    $columns3[4]->field_type = enumFieldType::ftEmail;
    $columns3[5] = new cardviewColumn();
    $columns3[5]->title = $strings['phone'];
    $columns3[5]->field_type = enumFieldType::ftText;
    $opt3 = array();
    $opt3[enumCardviewOption::oObject] = 'client_users';
    $opt3[enumCardviewOption::oTableName] = 'members';
    $opt3[enumCardviewOption::oColumns] = $columns3;
    $opt3[enumCardviewOption::oSearch] = true;
    $opt3[enumCardviewOption::oExtraParameters] = 'organization=' . $clientDetail->org_id[0] . $urlBornes . '&borne3=' . $block3->borne;

    if ($SW_Permissions['Client']['Write'][$profilSession]) {
        $opt3[enumCardviewOption::oAddUrl] = '../users/addclientuser.php?organization=' . $clientDetail->org_id[0] . $urlBornes;
    }

    $block3->openCardView($opt3);

    for ($i=0; $i<$comptListMembers; $i++) {
        $content = array(
            implode(',',
                array(
                    $listMembers->mem_id[$i],
                    $listMembers->mem_extension_picture[$i],
                    $listMembers->mem_gender[$i])),
            $listMembers->mem_name[$i],
            $listMembers->mem_title[$i],
            $listMembers->mem_department[$i],
            $listMembers->mem_email_work[$i],
            $listMembers->mem_phone_work[$i]
        );
        $block3->itemCardView($listMembers->mem_id[$i], $content);
    }

    $block3->closeCardView();
    $block3->bornesFooter("3", $blockPage->bornesNumber, "id=" . $clientDetail->org_id[0] . "&toggle_focus=user" . $urlBornes);
    $block3->closeToggle();
    $block3->closeFormResults();
    // Client Extensions
    $block4 = new block();
    $block4->form = 'clE';
    $block4->openForm("../clients/viewclient.php?id=" . $clientDetail->org_id[0] . $urlBornes . "#" . $block4->form . 'Anchor');
    $block4->headingToggle(lang_strings('client_extensions'), !($toggle_focus=='extension'));
    $block4->borne = $blockPage->returnBorne('4');
    $block4->rowsLimit = '12';
    $sortingFields4 = array(0 => 'ext.name', 1 => 'none');
    $block4->sorting('client_extensions', (isset($sortingUser['client_extensions'])?$sortingUser['client_extensions']:''), 'ext.name ASC', $sortingFields4);
    $querymore = " WHERE oge.organization='$id' ORDER BY " . $block4->sortingValue;
    $block4->recordsTotal = compt($initrequest['organizations_extension'] . $querymore);
    $listOrganizationExtensions = new request();
    $listOrganizationExtensions->openOrganizationExtensions($querymore, $block4->borne, $block4->rowsLimit);
    $comptListOrganizationExtensions = count($listOrganizationExtensions->oge_organization);
    $columns4 = array();
    $columns4[0] = new cardviewColumn();
    $columns4[0]->title = $strings['name'];
    $columns4[0]->field_type = enumFieldType::ftText;
    $columns4[1] = new cardviewColumn();
    $columns4[1]->title = $strings['title'];
    $columns4[1]->field_type = enumFieldType::ftText;
    $opt4 = array();
    $opt4[enumCardviewOption::oObject] = 'client_extensions';
    $opt4[enumCardviewOption::oTableName] = 'organizations_extension';
    $opt4[enumCardviewOption::oColumns] = $columns4;
    $opt4[enumCardviewOption::oExtraParameters] = 'organization=' . $clientDetail->org_id[0] . $urlBornes . '&borne4=' . $block4->borne;

    if ($SW_Permissions['Client']['Write'][$profilSession]) {
        $opt4[enumCardviewOption::oAddUrl] = '../extensions/editclientextensions.php?organization=' . $clientDetail->org_id[0] . $urlBornes;
    }

    $block4->openCardView($opt4);

    for ($i=0; $i<$comptListOrganizationExtensions; $i++) {
        $content = array(
            $listOrganizationExtensions->oge_ext_name[$i],
            $listOrganizationExtensions->oge_ext_title[$i]
        );
        $item_id = $listOrganizationExtensions->oge_organization[$i] . ':' . $listOrganizationExtensions->oge_extension[$i];
        $block4->itemCardView($item_id, $content);
    }

    $block4->closeCardView();
    $block4->bornesFooter("4", $blockPage->bornesNumber, "id=" . $clientDetail->org_id[0] . "&toggle_focus=extension" . $urlBornes);
    $block4->closeToggle();
    $block4->closeFormResults();
    // Client Forms
    $block5 = new block();
    $block5->form = 'clF';
    $block5->openForm("../clients/viewclient.php?id=" . $clientDetail->org_id[0] . $urlBornes . "#" . $block5->form . 'Anchor');
    $block5->headingToggle(lang_strings('client_form_templates'), !($toggle_focus=='form'));
    $block5->borne = $blockPage->returnBorne('5');
    $block5->rowsLimit = '12';
    $sortingFields5 = array(0 => 'ogf.tablename', 1 => 'none', 2 => 'ogf.addenabled', 3 => 'ogf.modenabled');
    $block5->sorting('client_forms', (isset($sortingUser['client_forms'])?$sortingUser['client_forms']:''), 'ogf.tablename ASC', $sortingFields5);
    $querymore = " WHERE ogf.organization='$id' ORDER BY " . $block5->sortingValue;
    $block5->recordsTotal = compt($initrequest['organizations_form'] . $querymore);
    $listOrganizationForms = new request();
    $listOrganizationForms->openOrganizationForms($querymore, $block5->borne, $block5->rowsLimit);
    $comptListOrganizationForms = count($listOrganizationForms->ogf_id);
    $columns5 = array();
    $columns5[0] = new cardviewColumn();
    $columns5[0]->title = $strings['name'];
    $columns5[0]->field_type = enumFieldType::ftText;
    $columns5[1] = new cardviewColumn();
    $columns5[1]->title = $strings['description'];
    $columns5[1]->field_type = enumFieldType::ftText;
    $columns5[2] = new cardviewColumn();
    $columns5[2]->title = $strings['add_permitted'];
    $columns5[2]->field_type = enumFieldType::ftText;
    $columns5[3] = new cardviewColumn();
    $columns5[3]->title = $strings['modify_permitted'];
    $columns5[3]->field_type = enumFieldType::ftText;
    $opt5 = array();
    $opt5[enumCardviewOption::oObject] = 'client_forms';
    $opt5[enumCardviewOption::oTableName] = 'organizations_form';
    $opt5[enumCardviewOption::oColumns] = $columns5;
    $opt5[enumCardviewOption::oExtraParameters] = 'organization=' . $clientDetail->org_id[0] . $urlBornes . '&borne5=' . $block5->borne;

    if ($SW_Permissions['Client']['Write'][$profilSession]) {
        $opt5[enumCardviewOption::oAddUrl] = '../forms/addclientforms.php?organization=' . $clientDetail->org_id[0] . $urlBornes;
    }

    $block5->openCardView($opt5);

    for ($i=0; $i<$comptListOrganizationForms; $i++) {
        $content = array(
            $blockPage->buildLink('../forms/viewformtemplate.php?id=' . $listOrganizationForms->ogf_tablename[$i], $listOrganizationForms->ogf_tablename[$i], 'out'),
            tableNameString($listOrganizationForms->ogf_tablename[$i]),
            ($listOrganizationForms->ogf_addenabled[$i]=='Y')?lang_strings('yes'):lang_strings('no'),
            ($listOrganizationForms->ogf_modenabled[$i]=='Y')?lang_strings('yes'):lang_strings('no')
        );
        $block5->itemCardView($listOrganizationForms->ogf_id[$i], $content);
    }

    $block5->closeCardView();
    $block5->bornesFooter("5", $blockPage->bornesNumber, "id=" . $clientDetail->org_id[0] . "&toggle_focus=form" . $urlBornes);
    $block5->closeToggle();
    $block5->closeFormResults();
}

require_once('../includes/footer.php');
