<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletecontacts.php,v 1.16 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = "'" . str_replace('**', "','", $id) . "'";

/**
 * Permission check
 */
if (!$SW_Permissions['Contact']['Edit'][$profilSession]) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

$querymore = " WHERE con.id IN ($ids) ORDER BY con.last_name";
$listContacts = new request();
$listContacts->openContacts($querymore);
$comptListContacts = count($listContacts->con_id);

if ($comptListContacts == '0') {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'contacts', $ids, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "contacts WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../contacts/listcontacts.php?msg=delete" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../contacts/listcontacts.php?" . $urlBornes, lang_strings("contacts"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_contacts"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "dtC";
$block1->openForm("../contacts/deletecontacts.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">\n";
$block1->heading(lang_strings("delete_contacts"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i< $comptListContacts; $i++) {
    $fn = $listContacts->con_formatted_name[$i];
    $block1->contentRow("", $blockPage->buildLink("../contacts/viewcontact.php?id=" . $listContacts->con_id[$i], $fn, 'in'));
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
