<?php // $Revision: 1.12 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: importcontacts.php,v 1.12 2013/02/09 06:36:54 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
// Create client organization when importing the first contact of this client organization
$addorg0 = isset($_POST['addorg'])?$_POST['addorg']:'';
// Action for duplicate records
$dupact = isset($_POST['dupact'])?$_POST['dupact']:'';
// Do Not Call
$dnc0 = isset($_POST['dnc'])?$_POST['dnc']:'';
// Share contacts
$sha0 = isset($_POST['sha'])?$_POST['sha']:'';
$addorg = DbValueEncode(enumFieldType::ftBoolean, $addorg0);           // Create Client Organizations
$dnc = DbValueEncode(enumFieldType::ftBoolean, $dnc0);                 // Do Not Call
$sha = DbValueEncode(enumFieldType::ftBoolean, $sha0);                 // Shared
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Contact']['Edit'][$profilSession]) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

/**
 * Fields check
 */
if ($action == "import") {
    try {
        if ($_FILES['upload']['name'] == '') {  // check file name
            throw new Exception(lang_strings("no_file"));
        } else if ($_FILES['upload']['size'] == '0') {  // check file size
            throw new Exception(lang_strings('exceed_size'));
        } else {
            $lines = file($_FILES['upload']['tmp_name']);

            if (!$lines) {
                $msg = str_replace('%FILE%', $_FILES['upload']['name'], $strings['load_file_fail']);
                throw new Exception($msg);
            }
        }
    } catch (Exception $e) {
        $error = $e->getMessage();
    }
}

/**
 * Load client organization names
 */
$querymore = " WHERE org.id<>'1' AND org.locked='" . enumBoolean::bFalse . "' ORDER BY org.name";
$listClients = new request();
$listClients->openOrganizations($querymore);
$comptListClients = count($listClients->org_id);

for ($i=0; $i<$comptListClients; $i++) {
    $listClients->org_name[$i] = strtoupper($listClients->org_name[$i]);
}
/**
 * Load contacts
 */
$listContacts = new request();
$listContacts->openContacts('');
$comptListContacts = count($listContacts->con_id);
$listContacts->contactKey = array();

for ($i=0; $i<$comptListContacts; $i++) {
    $listContacts->contactKey[$i] = strtoupper($listContacts->con_salutation[$i]) . '**' . strtoupper($listContacts->con_first_name[$i]) . '**' . strtoupper($listContacts->con_last_name[$i]);
}

/**
 * Actions
 */
if ($action == "import" && $error == '') {
    require_once("../includes/vcard.php");
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $card = new VCard();

        while ($card->parse($lines)) {  // Parses a set of cards from one or more lines
            /**
             * A structured representation of the name of the person
             */
            $property = $card->getProperty('N');
            $ln = '';                       // Last Name (Required)

            if ($property) {
                $n = $property->getComponents();
                // Family Names (also known as surnames), Given Names, Additional Names, Honorific Prefixes, and Honorific Suffixes
                if ($n[0]) {
                    $ln = $n[0];
                }
            }

            if ($ln != '') {
                $fn = ($n[1])?$n[1]:'';     // First Name
                $sal = ($n[3])?$n[3]:'';    // Salutation
                /**
                 * Specifies the job title
                 */
                $property = $card->getProperty('TITLE');
                $tit = '';                  // Title

                if ($property) {
                    $tit = $property->value;
                }
                /**
                 * The name and optionally the unit(s) of the organization associated with the vCard object
                 */
                $property = $card->getProperty('ORG');
                $org = '';                  // Client Organization Name
                $dep = '';                  // Department

                if ($property) {
                    $n = $property->getComponents();
                    $org = ($n[0])?$n[0]:'';
                    $dep = ($n[1])?$n[1]:'';
                }
                /**
                 * The address for electronic mail communication with the vCard object
                 */
                $properties = $card->getProperties('EMAIL');
                $ew = '';                   // Work E-Mail
                $eh = '';                   // Home E-Mail
                $eo = '';                   // Other E-Mail
                $ems = array();

                if ($properties) {
                    foreach ($properties as $property) {
                        $types = $property->params['TYPE'];

                        if ($types) {
                            if (in_array('WORK', $types)) {
                                $ew = $property->value;
                            } else if (in_array('HOME', $types)) {
                                $eh = $property->value;
                            } else {
                                $ems[] = $property->value;
                            }
                        } else {
                            $ems[] = $property->value;
                        }
                    }

                    if (count($ems) > 0) {
                        foreach ($ems as $val) {
                            if ($ew == '') {
                                $ew = $val;
                            } else if ($eh == '') {
                                $eh = $val;
                            } else if ($eo == '') {
                                $eo = $val;
                            } else {
                                break;
                            }
                        }
                    }
                }
                /**
                 * The canonical number string for a telephone number for telephony communication with the vCard object
                 */
                $properties = $card->getProperties('TEL');
                $pw = '';                   // Work Phone
                $ph = '';                   // Home Phone
                $po = '';                   // Other Phone
                $mob = '';                  // Mobile
                $fax = '';                  // Fax
                $tels = array();

                if ($properties) {
                    foreach ($properties as $property) {
                        $types = $property->params['TYPE'];

                        if ($types) {
                            if (in_array('WORK', $types)) {
                                $pw = $property->value;
                            } else if (in_array('HOME', $types)) {
                                $ph = $property->value;
                            } else if (in_array('CELL', $types)) {
                                $mob = $property->value;
                            } else if (in_array('FAX', $types)) {
                                $fax = $property->value;
                            } else {
                                $tels[] = $property->value;
                            }
                        } else {
                            $tels[] = $property->value;
                        }
                    }

                    if (count($tels) > 0) {
                        foreach ($tels as $val) {
                            if ($pw == '') {
                                $pw = $val;
                            } else if ($ph == '') {
                                $ph = $val;
                            } else if ($po == '') {
                                $po = $val;
                            } else {
                                break;
                            }
                        }
                    }
                }
                /**
                 * A structured representation of the physical delivery address for the vCard object
                 */
                $properties = $card->getProperties('ADR');
                $ad1 = false;
                $adds = '';                 // Address Street
                $addc = '';                 // Address City
                $addst = '';                // Address State
                $addp = '';                 // Address PostalCode
                $addco = '';                // Address Country
                $ad2 = false;
                $aadds = '';                // Other Address Street
                $aaddc = '';                // Other Address City
                $aaddst = '';               // Other Address State
                $aaddp = '';                // Other Address PostalCode
                $aaddco = '';               // Other Address Country
                $adrs = array();

                if ($properties) {
                    foreach ($properties as $property) {
                        $types = $property->params['TYPE'];
                        $pref = 100;

                        if ($types) {
                            if (in_array('WORK', $types)) {
                                $pref = 1;
                            } else if (in_array('HOME', $types)) {
                                $pref = 2;
                            }
                        }

                        $adrs[$pref][] = $property;
                    }

                    ksort($adrs, SORT_NUMERIC);

                    foreach ($adrs as $adra) {
                        foreach ($adra as $property) {
                            $n = $property->getComponents();
                            $nn = array();

                            for ($i=0; $i<3; $i++) {
                                if ($n[$i]) {
                                    $nn[] = $n[$i];
                                }
                            }

                            if (!$ad1) {
                                $ad1 = true;
                                $adds = implode(' ', $nn);
                                $addc = $n[3];
                                $addst = $n[4];
                                $addp = $n[5];
                                $addco = $n[6];
                            } else if (!$ad2) {
                                $ad2 = true;
                                $aadds = implode(' ', $nn);
                                $aaddc = $n[3];
                                $aaddst = $n[4];
                                $aaddp = $n[5];
                                $aaddco = $n[6];
                            } else {
                                break;
                            }
                        }
                    }
                }
                /**
                 * Date of birth of the individual associated with the vCard
                 */
                $property = $card->getProperty('BDAY');
                $bir = 0;                   // Birthdate

                if ($property) {
                    $val = $property->value;

                    if (is_numeric($val) && strlen($val) == 8) {    // import YYYYMMDD only
                        $bir = mktime(0, 0, 0, intval(substr($val, 4, 2)), intval(substr($val, 6, 2)), intval(substr($val, 0, 4)));
                    }
                }
                /**
                 * Specifies supplemental information or a comment that is associated with the vCard
                 */
                $property = $card->getProperty('NOTE');
                $desc = '';                 // Description

                if ($property) {
                    $desc = $property->value;
                }
                /**
                 * Specifies client organization id
                 */
                if ($org == '') {
                    $clod = '1';            // No client organization specified
                } else {
                    if ($comptListClients == 0) {
                        $k = false;         // New client organization
                    } else {
                        $k = array_search(strtoupper($org), $listClients->org_name);    // Existing client organization
                    }

                    if ($k === false) {
                        if ($addorg) {      // add new client organization
                            /**
                             * Convert all applicable characters to HTML entities
                             */
                            $org1 = HtmlEntitiesNOD($org);      // name
                            $adds1 = HtmlEntitiesNOD($adds);    // address
                            $addp1 = HtmlEntitiesNOD($addp);    // zip code
                            $addc1 = HtmlEntitiesNOD($addc);    // city
                            $addco1 = HtmlEntitiesNOD($addco);  // country
                            $pw1 = HtmlEntitiesNOD($pw);        // phone
                            $fax1 = HtmlEntitiesNOD($fax);      // fax
                            $tmpsql = "INSERT INTO " . $tablePrefix . "organizations (name,address,zip_code,city,country,phone,fax,url,email,comments,owner,currency,workcalendar,created,cuser) VALUES ('$org1','$adds1','$addp1','$addc1','$addco1','$pw1','$fax1','','$ew','','$idSession','','1','" . time() . "','$idSession')";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }

                            $clod = $requestAct->newId('organizations');    // New client organization specified
                            $listClients->org_id[] = $clod;
                            $listClients->org_name[] = $org;
                            copy2HistoryTable($requestAct, 'organizations', $clod, 'A');
                        } else {
                            $clod = '1';    // No client organization specified
                        }
                    } else {
                        $clod = $listClients->org_id[$k];   // Existing client organization specified
                    }
                }
                /**
                 * Check duplicate record
                 */
                if ($comptListContacts > 0) {
                    $salU = strtoupper($sal);           // Salutation in upper case
                    $fnU = strtoupper($fn);             // First Name in upper case
                    $lnU = strtoupper($ln);             // Last Name in upper case
                    $contactKey = $salU . '**' . $fnU . '**' . $lnU;
                    $k1 = array_search($contactKey, $listContacts->contactKey);

                    if ($k1 !== false) {
                        $id = $listContacts->con_id[$k1];
                        $dup = true;
                    } else {
                        $dup = false;
                    }
                } else {
                    $dup = false;
                }
                /**
                 * Convert all applicable characters to HTML entities
                 */
                $sal1 = HtmlEntitiesNOD($sal);       // Salutation
                $fn1 = HtmlEntitiesNOD($fn);         // First Name
                $ln1 = HtmlEntitiesNOD($ln);         // Last Name
                $tit1 = HtmlEntitiesNOD($tit);       // Title
                $dep1 = HtmlEntitiesNOD($dep);       // Department
                $pw1 = HtmlEntitiesNOD($pw);         // Work Phone
                $ph1 = HtmlEntitiesNOD($ph);         // Home Phone
                $po1 = HtmlEntitiesNOD($po);         // Other Phone
                $mob1 = HtmlEntitiesNOD($mob);       // Mobile
                $fax1 = HtmlEntitiesNOD($fax);       // Fax
                $adds1 = HtmlEntitiesNOD($adds);     // Address Street
                $addc1 = HtmlEntitiesNOD($addc);     // Address City
                $addst1 = HtmlEntitiesNOD($addst);   // Address State
                $addco1 = HtmlEntitiesNOD($addco);   // Address Country
                $aadds1 = HtmlEntitiesNOD($aadds);   // Other Address Street
                $aaddc1 = HtmlEntitiesNOD($aaddc);   // Other Address City
                $aaddst1 = HtmlEntitiesNOD($aaddst); // Other Address State
                $aaddco1 = HtmlEntitiesNOD($aaddco); // Other Address Country
                $desc1 = HtmlEntitiesNOD($desc);     // Description

                if (!$dup || $dupact=='c') {        // Add new contact
                    $tmpsql = "INSERT INTO " . $tablePrefix . "contacts (salutation,first_name,last_name,title,organization,department,do_not_call,email_work,email_home,email_other,phone_work,phone_home,phone_other,mobile,fax,address_street,address_city,address_state,address_postalcode,address_country,alt_address_street,alt_address_city,alt_address_state,alt_address_postalcode,alt_address_country,assistant,assistant_phone,description,shared,member,created,cuser) VALUES ('$sal1','$fn1','$ln1','$tit1','$clod','$dep1','$dnc','$ew','$eh','$eo','$pw1','$ph1','$po1','$mob1','$fax1','$adds1','$addc1','$addst1','$addp','$addco1','$aadds1','$aaddc1','$aaddst1','$aaddp','$aaddco1','','','$desc1','$sha','0','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num = $requestAct->newId('contacts');
                    $listContacts->con_id[] = $num;
                    $listContacts->con_salutation[] = $salU;
                    $listContacts->con_first_name[] = $fnU;
                    $listContacts->con_last_name[] = $lnU;
                    copy2HistoryTable($requestAct, 'contacts', $num, 'A');
                } else if ($dup && $dupact=='o') {  // Overwrite existing contact
                    $tmpsql = 'UPDATE ' . $tablePrefix . "contacts SET salutation='$sal1',first_name='$fn1',last_name='$ln1',title='$tit1',organization='$clod',department='$dep1',do_not_call='$dnc',email_work='$ew',email_home='$eh',email_other='$eo',phone_work='$pw1',phone_home='$ph1',phone_other='$po1',mobile='$mob1',fax='$fax1',address_street='$adds1',address_city='$addc1',address_state='$addst1',address_postalcode='$addp',address_country='$addco1',alt_address_street='$aadds1',alt_address_city='$aaddc1',alt_address_state='$aaddst1',alt_address_postalcode='$aaddp',alt_address_country='$aaddco1',description='$desc1',shared='$sha',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    copy2HistoryTable($requestAct, 'contacts', $id, 'U');
                }
            }

            $card = new VCard();
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../contacts/listcontacts.php?msg=add");
        exit;
    }
}

/**
 * Form variables init
 */
if ($error == '') {
    $addorg = enumBoolean::bFalse;
    $dnc = enumBoolean::bFalse;
    $sha = enumBoolean::bTrue;
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../contacts/listcontacts.php', lang_strings('contacts'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("import_contacts"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "imC";
$block1->openForm("../contacts/importcontacts.php?#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="import">';
$block1->heading(lang_strings("import_contacts"));
$block1->openContent();
$block1->contentRow("*&nbsp;" . lang_strings("upload"), "<input name=\"upload\" type=\"FILE\">");

if ($SW_Permissions['Client']['Write'][$profilSession]) {
    $helpStr = $strings['create_organization_help'];
    setupInputHTML($block1, lang_strings('create_organization') . '&nbsp;' . $blockPage->printHelp($helpStr, true), 'addorg', enumFieldType::ftBoolean, 'N', '1', $addorg);
} else {
    echo '<input type="hidden" name="addorg" value="">';
}

setupInputHTML($block1, lang_strings('do_not_call'), 'dnc', enumFieldType::ftBoolean, 'N', '1', $dnc);
setupInputHTML($block1, lang_strings('shared'), 'sha', enumFieldType::ftBoolean, 'N', '1', $sha);
$dupactOpt = '<input type="radio" name="dupact" value=""' . (($dupact=='')?' checked':'') . '> ' . lang_strings('skip') . '<br>'
    . '<input type="radio" name="dupact" value="o"' . (($dupact=='o')?' checked':'') . '> ' . lang_strings('overwrite') . '<br>'
    . '<input type="radio" name="dupact" value="c"' . (($dupact=='c')?' checked':'') . '> ' . lang_strings('clone');
$block1->contentRow(lang_strings('duplicate_records'), $dupactOpt);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["import"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
