<?php // $Revision: 1.19 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listcontacts.php,v 1.19 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$groupby = isset($_GET['groupby'])?$_GET['groupby']:'';     // grouping method
$view = isset($_GET['view'])?$_GET['view']:'';              // group view

if ($groupby == '') {
    $groupby = 'firstname';
}

/**
 * Permission check
 */
if (!$SW_Permissions['Contact']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Grouping
 */
$querymore = " WHERE ((con.shared<>'" . enumBoolean::bTrue . "' AND con.cuser='$idSession') OR con.shared='" . enumBoolean::bTrue . "')";
$listContacts0 = new request();
$letters = array();

switch ($groupby) {
    case 'firstname':      // Group by the first letter of First Name
        $querymore .= " ORDER BY con.first_name";
        $listContacts0->openContacts($querymore);
        $comptListContacts = count($listContacts0->con_id);

        for ($i=0; ($i<$comptListContacts && count($letters)<30); $i++) {
            if ($listContacts0->con_first_name[$i] == '') {
                $fl = 'empty';
            } else {
                $fl = mb_substr($listContacts0->con_first_name[$i], 0, 1, 'UTF-8');

                if (is_numeric($fl)) {
                    $fl = 'numeric';
                } else {
                    $fl = strtoupper($fl);
                }
            }

            if (!in_array($fl, $letters)) {
                $letters[] = $fl;
            }
        }

        if ($i<$comptListContacts) {
            $letters[] = 'others';
        }

        break;
    case 'lastname':                // Group by the first letter of Last Name
        $querymore .= " ORDER BY con.last_name";
        $listContacts0->openContacts($querymore);
        $comptListContacts = count($listContacts0->con_id);

        for ($i=0; ($i<$comptListContacts && count($letters)<30); $i++) {
            $fl = mb_substr($listContacts0->con_last_name[$i], 0, 1, 'UTF-8');

            if (is_numeric($fl)) {
                $fl = 'numeric';
            } else {
                $fl = strtoupper($fl);
            }

            if (!in_array($fl, $letters)) {
                $letters[] = $fl;
            }
        }

        if ($i<$comptListContacts) {
            $letters[] = 'others';
        }

        break;
    case 'title':           // Group by the first letter of Title
        $querymore .= " ORDER BY con.title";
        $listContacts0->openContacts($querymore);
        $comptListContacts = count($listContacts0->con_id);

        for ($i=0; ($i<$comptListContacts && count($letters)<30); $i++) {
            if ($listContacts0->con_title[$i] == '') {
                $fl = 'empty';
            } else {
                $fl = mb_substr($listContacts0->con_title[$i], 0, 1, 'UTF-8');

                if (is_numeric($fl)) {
                    $fl = 'numeric';
                } else {
                    $fl = strtoupper($fl);
                }
            }

            if (!in_array($fl, $letters)) {
                $letters[] = $fl;
            }
        }

        if ($i<$comptListContacts) {
            $letters[] = 'others';
        }

        break;
    case 'organization':    // Group by the first letter of Organization
        $querymore .= " ORDER BY org.name";
        $listContacts0->openContacts($querymore);
        $comptListContacts = count($listContacts0->con_id);

        for ($i=0; ($i<$comptListContacts && count($letters)<30); $i++) {
            if ($listContacts0->con_organization[$i] == '1') {
                $fl = 'none';
            } else {
                $fl = mb_substr($listContacts0->con_org_name[$i], 0, 1, 'UTF-8');

                if (is_numeric($fl)) {
                    $fl = 'numeric';
                } else {
                    $fl = strtoupper($fl);
                }
            }

            if (!in_array($fl, $letters)) {
                $letters[] = $fl;
            }
        }

        if ($i<$comptListContacts) {
            $letters[] = 'others';
        }

        break;
}

/**
 * Generate numeric sql
 *
 * @param string $fieldName
 * @return string
 */
function numericSQL($fieldName) {
    $sql = "($fieldName LIKE '0%'";

    for ($i=1; $i<10; $i++) {
        $sql .= " OR $fieldName LIKE '" . $i . "%'";
    }

    $sql .= ")";
    return $sql;
}

/**
 * Generate single letter sql
 *
 * @param string $fieldName
 * @param string $fl
 * @return string
 */
function singleSQL($fieldName, $fl) {
    $fll = strtolower($fl);

    if ($fll == $fl) {
        $sql = "$fieldName LIKE '" . HtmlEntitiesNOD($fl) . "%'";
    } else {
        $sql = "($fieldName LIKE '" . HtmlEntitiesNOD($fl) . "%' OR $fieldName LIKE '" . HtmlEntitiesNOD($fll) . "%')";
    }

    return $sql;
}

/**
 * Generate others sql
 *
 * @param string $fieldName
 * @param array $la
 * @return string
 */
function othersSQL($fieldName, $la) {
    $sql = "NOT ($fieldName='' OR $fieldName LIKE '0%'";

    for ($i=1; $i<10; $i++) {
        $sql .= " OR $fieldName LIKE '" . $i . "%'";
    }

    foreach ($la as $fl) {
        if ($fl != 'none' && $fl != 'empty' && $fl != 'numeric' && $fl != 'others') {
            $sql .= " OR " . singleSQL($fieldName, $fl);
        }
    }

    $sql .= ")";
    return $sql;
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings('contacts'));
$blockPage->itemBreadcrumbs($strings['groupby_' . $groupby]);
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$title = $strings['contacts'] . ' : ' . $strings['groupby_' . $groupby];
logURL($title, '../contacts/listcontacts.php?groupby=' . $groupby);
$block1 = new block();
$block1->openHeading(lang_strings('contacts'));
$block1->openViewOptions();

foreach (array('firstname', 'lastname', 'title', 'organization') as $g) {
    if ($g != $groupby) {
        $block1->itemViewOptions($block1->buildLink('../contacts/listcontacts.php?groupby=' . $g, $strings['groupby_' . $g], 'in'));
    } else if (count($letters) > 1) {
        if ($view == '') {
            $view = $letters[0];
        }

        foreach ($letters as $fl) {
            if ($fl == $view) {
                continue;
            }

            if ($fl=='others' || $fl=='none' || $fl=='empty') {
                $block1->itemViewOptions($block1->buildLink('../contacts/listcontacts.php?groupby=' . $groupby . '&amp;view=' . $fl, $strings['groupby_' . $g] . ' - ' . $strings[$fl], 'in'));
            } else if ($fl == 'numeric') {
                $block1->itemViewOptions($block1->buildLink('../contacts/listcontacts.php?groupby=' . $groupby . '&amp;view=' . $fl, $strings['groupby_' . $g] . ' - ' . '123', 'in'));
            } else {
                $fle = HtmlEntitiesNOD($fl);
                $block1->itemViewOptions($block1->buildLink('../contacts/listcontacts.php?groupby=' . $groupby . '&amp;view=' . $fle, $strings['groupby_' . $g] . ' - ' . $fl, 'in'));
            }
        }
    }
}

$block1->closeViewOptions();
$block1->closeHeading();
$block1->form = 'ctL';
$block1->openForm('../contacts/listcontacts.php?groupby=' . $groupby . '&amp;view=' . $view . $urlBornes . '#' . $block1->form . 'Anchor');
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '12';
$block1->sorting('contacts', (isset($sortingUser['contacts'])?$sortingUser['contacts']:''), 'con.last_name ASC', $sortingFields = array(0 => 'con.first_name', 1 => 'con.last_name', 2 => 'con.title', 3 => 'org.name', 4 => 'none', 5 => 'none'));
$querymore = " WHERE ((con.shared<>'" . enumBoolean::bTrue . "' AND con.cuser='$idSession') OR con.shared='" . enumBoolean::bTrue . "')";

if (count($letters) > 1) {
    switch ($groupby) {
        case 'firstname':       // Group by the first letter of First Name
            if ($view == 'empty') {
                $querymore .= " AND con.first_name=''";
            } else if ($view == 'numeric') {
                $querymore .= " AND " . numericSQL("con.first_name");
            } else if ($view == 'others') {
                $querymore .= " AND " . othersSQL("con.first_name", $letters);
            } else {
                $querymore .= " AND " . singleSQL("con.first_name", $view);
            }

            break;
        case 'lastname':        // Group by the first letter of Last Name
            if ($view == 'numeric') {
                $querymore .= " AND " . numericSQL("con.last_name");
            } else if ($view == 'others') {
                $querymore .= " AND " . othersSQL("con.last_name", $letters);
            } else {
                $querymore .= " AND " . singleSQL("con.last_name", $view);
            }

            break;
        case 'title':           // Group by the first letter of Title
            if ($view == 'empty') {
                $querymore .= " AND con.title=''";
            } else if ($view == 'numeric') {
                $querymore .= " AND " . numericSQL("con.title");
            } else if ($view == 'others') {
                $querymore .= " AND " . othersSQL("con.title", $letters);
            } else {
                $querymore .= " AND " . singleSQL("con.title", $view);
            }

            break;
        case 'organization':    // Group by the first letter of Organization
            if ($view == 'none') {
                $querymore .= " AND con.organization='1'";
            } else if ($view == 'numeric') {
                $querymore .= " AND con.organization<>'1' AND " . numericSQL("org.name");
            } else if ($view == 'others') {
                $querymore .= " AND con.organization<>'1' AND " . othersSQL("org.name", $letters);
            } else {
                $querymore .= " AND con.organization<>'1' AND " . singleSQL("org.name", $view);
            }

            break;
    }
}

$block1->recordsTotal = compt($initrequest['contacts'] . ' ' . $querymore);
$querymore .= " ORDER BY " . $block1->sortingValue;
$listContacts = new request();
$listContacts->openContacts($querymore, $block1->borne, $block1->rowsLimit);
$comptListContacts = count($listContacts->con_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['first_name'];
$columns[0]->field_type = enumFieldType::ftText;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['last_name'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['title'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['organization'];
$columns[3]->field_type = enumFieldType::ftNumeric;
$columns[3]->linked_table = 'organizations';
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['work_email'];
$columns[4]->field_type = enumFieldType::ftEmail;
$columns[5] = new cardviewColumn();
$columns[5]->title = $strings['work_phone'];
$columns[5]->field_type = enumFieldType::ftText;
$opt[enumCardviewOption::oObject] = 'contacts';
$opt[enumCardviewOption::oTableName] = 'contacts';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;
$opt[enumCardviewOption::oExtraParameters] = 'borne1=' . $block1->borne;

if ($SW_Permissions['Contact']['Edit'][$profilSession]) {
    $opt[enumCardviewOption::oAddUrl] = '../contacts/editcontact.php?';
    $opt[enumCardviewOption::oImportUrl] = '../contacts/importcontacts.php?';
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListContacts; $i++) {
    $content = array(
        $listContacts->con_first_name[$i],
        $listContacts->con_last_name[$i],
        $listContacts->con_title[$i],
        (($listContacts->con_organization[$i]=='1')?'0':$listContacts->con_organization[$i]),
        $listContacts->con_email_work[$i],
        (($listContacts->con_do_not_call[$i]==enumBoolean::bTrue)?'***' . strtoupper($strings['do_not_call']):$listContacts->con_phone_work[$i])
    );
    $block1->itemCardView($listContacts->con_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter("1", $blockPage->bornesNumber, "groupby=$groupby&amp;view=$view");
$block1->closeFormResults();
require_once('../includes/footer.php');
