<?php // $Revision: 1.36 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewcontact.php,v 1.36 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
$querymore = " WHERE con.id='$id'";
$contactDetail = new request();
$contactDetail->openContacts($querymore);
$comptContactDetail = count($contactDetail->con_id);

if ($comptContactDetail == '0') {
    header('Location: ../contacts/listcontacts.php?msg=blankContact' . $urlBornes);
    exit;
}

if (!$SW_Permissions['Contact']['Read'][$profilSession] && $contactDetail->con_muser[0] != $idSession) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

/**
 * Generate contact address
 *
 * @param string $adda
 * @return string
 */
function contactAddress($adda) {
    $addr = '';

    foreach ($adda as $x) {
        if ($x != '') {
            if ($addr != '') {
                $addr .= ' ';
            }

            $addr .= $x;
        }
    }

    return $addr;
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../contacts/listcontacts.php?' . $urlBornes, lang_strings('contacts'), 'in'));
$fn = $contactDetail->con_formatted_name[0];
$blockPage->itemBreadcrumbs($fn);
$blockPage->closeBreadcrumbs();
$title = $strings['contact'] . ' : ' . $fn;
logURL($title, "../contacts/viewcontact.php?id=$id");
$block1 = new block();
$block1->form = "vwC";
$block1->openForm("../contacts/viewcontact.php?id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');

if ($contactDetail->con_do_not_call[0] == enumBoolean::bTrue) {
    $block1->heading(lang_strings('contact') . ' : ' . $fn . ' ***' . strtoupper($strings['do_not_call']));
} else {
    $block1->heading(lang_strings('contact') . ' : ' . $fn);
}

$block1->openPaletteIcon();

if ($SW_Permissions['Contact']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, 'remove', $strings['delete']);
    $block1->paletteIcon(3, 'edit', $strings['edit']);
}

$block1->paletteIcon(5, 'export', $strings['export']);

if ($SW_Permissions['Client']['Write'][$profilSession] && $contactDetail->con_organization[0] != '1' && $contactDetail->con_member[0] == '0') {
    $block1->paletteIcon(6, 'copy', $strings['copy_to_clientuser']);
}

$block1->paletteIcon(99, 'search', 'contacts');
$block1->closePaletteIcon();
$block1->openContent(true);
$block1->contentTitle(lang_strings('details'));
$block1->contentRow(lang_strings('name'), $fn);
$block1->contentRow(lang_strings('title'), $contactDetail->con_title[0]);

if ($contactDetail->con_organization[0] == '1') {
    $block1->contentRow(lang_strings('organization'), lang_strings('none'));
} else {
    $block1->contentRow(lang_strings('organization'), $contactDetail->con_org_name[0]);
}

$block1->contentRow(lang_strings('department'), $contactDetail->con_department[0]);

if ($contactDetail->con_email_work[0] == '') {
    $block1->contentRow(lang_strings('work_email'), '');
} else {
    $block1->contentRow(lang_strings('work_email'), $blockPage->buildLink($contactDetail->con_email_work[0], $contactDetail->con_email_work[0], 'mail'));
}

if ($contactDetail->con_email_home[0] == '') {
    $block1->contentRow(lang_strings("home_email"), '');
} else {
    $block1->contentRow(lang_strings("home_email"), $blockPage->buildLink($contactDetail->con_email_home[0], $contactDetail->con_email_home[0], 'mail'));
}

if ($contactDetail->con_email_other[0] == '') {
    $block1->contentRow(lang_strings("other_email"), '');
} else {
    $block1->contentRow(lang_strings("other_email"), $blockPage->buildLink($contactDetail->con_email_other[0], $contactDetail->con_email_other[0], 'mail'));
}

$block1->contentRow(lang_strings("work_phone"), $contactDetail->con_phone_work[0]);
$block1->contentRow(lang_strings("home_phone"), $contactDetail->con_phone_home[0]);
$block1->contentRow(lang_strings("other_phone"), $contactDetail->con_phone_other[0]);
$block1->contentRow(lang_strings("mobile_phone"), $contactDetail->con_mobile[0]);
$block1->contentRow(lang_strings("fax"), $contactDetail->con_fax[0]);
$block1->contentRow(lang_strings('assistant'), $contactDetail->con_assistant[0]);
$block1->contentRow(lang_strings('assistant_phone'), $contactDetail->con_assistant_phone[0]);
$block1->contentRow(lang_strings('birthdate'), createDate($contactDetail->con_birthdate[0],'date',false,true));
$block1->contentRow(lang_strings("description"), $contactDetail->con_description[0]);
$shared = ($contactDetail->con_shared[0]==enumBoolean::bTrue)?$strings['yes']:$strings['no'];
$block1->contentRow(lang_strings('shared'), $shared);
setupCustomFieldsHTML($block1, 'contacts', $id);
$block1->contentTitle(lang_strings('address'));
$adda1 = array($contactDetail->con_address_street[0], $contactDetail->con_address_city[0], $contactDetail->con_address_state[0], $contactDetail->con_address_postalcode[0], $contactDetail->con_address_country[0]);
$addr1 = contactAddress($adda1);
$block1->contentRow(lang_strings('primary_address'), $addr1);
$adda2 = array($contactDetail->con_alt_address_street[0], $contactDetail->con_alt_address_city[0], $contactDetail->con_alt_address_state[0], $contactDetail->con_alt_address_postalcode[0], $contactDetail->con_alt_address_country[0]);
$addr2 = contactAddress($adda2);
$block1->contentRow(lang_strings('other_address'), $addr2);
$block1->closeContent();
$block1->closeForm();
$block1->openPaletteScript();

if ($SW_Permissions['Contact']['Edit'][$profilSession]) {
    $block1->paletteScript(1, 'remove', '../contacts/deletecontacts.php?id=' . $id . $urlBornes, 'true,true,true', $strings['delete']);
    $block1->paletteScript(3, 'edit', '../contacts/editcontact.php?id=' . $id . $urlBornes, 'true,true,false', $strings['edit']);
}

$block1->paletteScript(5, 'export', '../contacts/exportcontacts.php?id=' . $id, 'true,true,true', $strings['export']);

if ($SW_Permissions['Client']['Write'][$profilSession] && $contactDetail->con_organization[0] != '1' && $contactDetail->con_member[0] == '0') {
    $block1->paletteScript(6, 'copy', '../users/addclientuser.php?cpy2=true&id=' . $id, 'true,true,false', $strings['copy_to_clientuser']);
}

$block1->paletteScript(99, 'search', 'contacts');
$block1->closePaletteScript('', '');
require_once('../includes/footer.php');
