<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletecustomfields.php,v 1.7 2013/01/29 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = isset($_POST['action'])?$_POST['action']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'';
$tbldispnam = tableNameString($mode);

if (substr($mode,0,1)=='@') {
    $tbldispnam .= ' (' . lang_strings('form_template') . ')';
}

/**
 * Permission check
 */
if (!$SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$multi = strstr($id, "**");

if ($multi != "") {
    $ids = preg_split('/\*\*/', $id);
    $querymore0 = '';

    foreach ($ids as $token) {
        if ($querymore0 != '') {
            $querymore0 = $querymore0 . ' OR ';
        }

        list($table_name, $field_name) = preg_split('/\|/', $token, 2);
        $querymore0 .= "(fdf.tablename='$table_name' AND fdf.fieldname='$field_name')";
    }

    $querymore1 = " WHERE fdf.sysdef='Y' AND ($querymore0)";
} else {
    list($table_name, $field_name) = preg_split('/\|/', $id, 2);
    $querymore1 = " WHERE fdf.sysdef='Y' AND fdf.tablename='$table_name' AND fdf.fieldname='$field_name'";
}

$listFieldsDefinitions = new request();
$listFieldsDefinitions->openFieldsDefinitions($querymore1);
$comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

if ($comptListFieldsDefinitions > 0) {
    header('Location: ../customfields/listcustomfields.php?mode=' . $mode . '&msg=permissiondenied');
    exit;
}

/**
 * Actions
 */
if ($action == "delete") {
    $ids = preg_split('/\*\*/', $id);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tbls = array();

        foreach ($ids as $token) {
            list($table_name, $field_name) = preg_split('/\|/', $token, 2);
            $tmpsql = "DELETE FROM " . $tablePrefix . "fields_def WHERE tablename='$table_name' AND fieldname='$field_name'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "DELETE FROM " . $tablePrefix . "fields_valdef WHERE tablename='$table_name' AND fieldname='$field_name'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
            // delete user field filters
            $tmpsql = "DELETE FROM " . $tablePrefix . "field_filters WHERE tablename='$table_name' AND dbfieldname='U_$field_name'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            if (preg_match('/@/', $table_name) == 0) {
                $dbtblnam = $tablePrefix . $table_name;
            } else {
                $dbtblnam = $tablePrefix . preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $table_name);
            }

            // delete field in the database
            $tmpsql = "ALTER TABLE $dbtblnam DROP U_$field_name";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $querymore1 = " WHERE tdf.tablename='$table_name' AND tdf.history='Y'";
            $tableDefinitionDetail = clone $requestAct;
            $tableDefinitionDetail->openTablesDefinitions($querymore1);

            if (count($tableDefinitionDetail->tdf_tablename) > 0) {
                // delete history field in the database
                $tmpsql = "ALTER TABLE " . $dbtblnam . "_hist DROP U_$field_name";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            if (!in_array($table_name, $tbls)) {
                $tbls[] = $table_name;
            }
        }

        foreach ($tbls as $tblnam) {
            $querymore1 = " WHERE tdf.tablename='$tblnam'";
            $tableDefinitionDetail = clone $requestAct;
            $tableDefinitionDetail->openTablesDefinitions($querymore1);
            $querymore2 = " WHERE fdf.tablename='$tblnam' ORDER BY fdf.disporder";
            $listFieldsDefinitions = new request();
            $listFieldsDefinitions->openFieldsDefinitions($querymore2);
            $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

            if ($tableDefinitionDetail->tdf_formfields[0] != '') {
                $formfields = explode('+', $tableDefinitionDetail->tdf_formfields[0]);
                $fields = array();

                for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
                    if (in_array($listFieldsDefinitions->fdf_dbfieldname[$i], $formfields)) {
                        $fields[] = $listFieldsDefinitions->fdf_dbfieldname[$i];
                    }
                }

                foreach ($reservedDbFields as $dbfldnam => $flddesc) {
                    if (in_array($dbfldnam, $formfields)) {
                        $fields[] = $dbfldnam;
                    }
                }

                if (($key = array_search('id', $fields)) !== false) {
                    unset($fields[$key]);
                    array_unshift($fields, 'id');
                }

                $newformfields = implode('+', $fields);

                if ($newformfields != $tableDefinitionDetail->tdf_formfields[0]) {
                    $tmpsql = "UPDATE " . $tablePrefix . "tables_def SET formfields='$newformfields' WHERE tablename='$tblnam'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }

            if ($tableDefinitionDetail->tdf_listfields[0] != '') {
                $listfields = explode('+', $tableDefinitionDetail->tdf_listfields[0]);
                $fields = array();

                for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
                    if (in_array($listFieldsDefinitions->fdf_dbfieldname[$i], $listfields)) {
                        $fields[] = $listFieldsDefinitions->fdf_dbfieldname[$i];
                    }
                }

                foreach ($reservedDbFields as $dbfldnam => $flddesc) {
                    if (in_array($dbfldnam, $listfields)) {
                        $fields[] = $dbfldnam;
                    }
                }

                if (($key = array_search('id', $fields)) !== false) {
                    unset($fields[$key]);
                    array_unshift($fields, 'id');
                }

                $newlistfields = implode('+', $fields);

                if ($newlistfields != $tableDefinitionDetail->tdf_listfields[0]) {
                    $tmpsql = "UPDATE " . $tablePrefix . "tables_def SET listfields='$newlistfields' WHERE tablename='$tblnam'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../customfields/listcustomfields.php?mode=$mode&msg=delete");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=custom", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/listformtemplates.php?", lang_strings('form_templates'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/viewformtemplate.php?id=$mode", $tbldispnam, 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../customfields/listcustomfields.php?mode=$mode", lang_strings('custom_fields'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_custom_fields"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "cfD";
$block1->openForm("../customfields/deletecustomfields.php?mode=$mode&id=$id");
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings("deletecustomfields"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));
$ids = preg_split('/\*\*/', $id);

foreach ($ids as $token) {
    list($table_name, $field_name) = preg_split('/\|/', $token, 2);
    $block1->contentRow('', $field_name . " - " . fieldNameString($table_name, $field_name));
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
