<?php // $Revision: 1.20 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editcustomfield.php,v 1.20 2013/02/03 15:14:28 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$mode = AddSlashesNOD(isset($_GET['mode'])?$_GET['mode']:'');   // operation mode (table name)
$tbldispnam = tableNameString($mode);                           // table display name

if (substr($mode,0,1)=='@') {
    $tbldispnam .= ' (' . lang_strings('form_template') . ')';
}

$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$tblnam = $mode;
$fldnam0 = isset($_POST['fldnam'])?$_POST['fldnam']:'';     // field name
$fldnam = strtolower($fldnam0);                             // case-insensitive
$flddes = isset($_POST['flddes'])?$_POST['flddes']:'';      // field description
$fldtyp = isset($_POST['fldtyp'])?$_POST['fldtyp']:'';      // field type
$len = isset($_POST['len'])?$_POST['len']:'0';              // field length
$defval = isset($_POST['defval'])?$_POST['defval']:'';      // default value
$fldfmt = isset($_POST['fldfmt'])?$_POST['fldfmt']:'';      // field format (serial only)
$req0 = isset($_POST['req'])?$_POST['req']:'N';             // required field
$req = ($req0=='Y' || $fldtyp==enumFieldType::ftSerial)?'Y':'N';
$lkt = isset($_POST['lkt'])?$_POST['lkt']:'';               // linked table
$uni0 = isset($_POST['uni'])?$_POST['uni']:'N';             // unique field
$uni = ($uni0=='Y' || $fldtyp==enumFieldType::ftSerial)?'Y':'N';
$idx0 = isset($_POST['idx'])?$_POST['idx']:'N';             // create index
$idx = ($idx0=='Y' || $uni=='Y')?'Y':'N';
$pub0 = isset($_POST['pub'])?$_POST['pub']:'';              // publish
$pub = ($pub0==enumPublished::pbYes || $req=='Y')?enumPublished::pbYes:enumPublished::pbNo;
$vvc = isset($_POST['vvc'])?$_POST['vvc']:'0';              // valid value counter

if ($vvc != '0') {
    for ($i=0; $i<$vvc; $i++) {
        $valsa[] = $_POST['valsa' . $i];                    // valid value
        $dessa[] = $_POST['dessa' . $i];                    // valid value description
    }
}

if ($id != '') {
    $oldfldtyp = isset($_POST['oldfldtyp'])?$_POST['oldfldtyp']:''; // old field type
    $oldlen = isset($_POST['oldlen'])?$_POST['oldlen']:'0';         // old field length
    $oldreq = isset($_POST['oldreq'])?$_POST['oldreq']:'N';         // old required field flag
    $olddefval = isset($_POST['olddefval'])?$_POST['olddefval']:''; // old default value
    $oldfldfmt = isset($_POST['oldfldfmt'])?$_POST['oldfldfmt']:''; // old serial format
    $olduni = isset($_POST['olduni'])?$_POST['olduni']:'N';         // old unique field flag
    $oldidx = isset($_POST['oldidx'])?$_POST['oldidx']:'N';         // old create index flag
    $oldvals = isset($_POST['oldvals'])?$_POST['oldvals']:'';       // old valid values
}

$error = '';

/**
 * Permission check
 */
if ($id != '') {
    list($tblnam, $fldnam) = preg_split('/\|/', $id);
    $querymore1 = " WHERE fdf.tablename='$tblnam' AND fdf.fieldname='$fldnam'";
    $fieldDefinitionDetail = new request();
    $fieldDefinitionDetail->openFieldsDefinitions($querymore1);
    $comptFieldDefinitionDetail = count($fieldDefinitionDetail->fdf_tablename);

    if ($comptFieldDefinitionDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    $querymore = " WHERE fvd.tablename='$tblnam' AND fvd.fieldname='$fldnam' ORDER BY fvd.fieldvalue";
    $listFieldsValuesDefinitions = new request();
    $listFieldsValuesDefinitions->openFieldsValuesDefinitions($querymore);
    $comptListFieldsValuesDefinitions = count($listFieldsValuesDefinitions->fvd_tablename);
}

if (!$SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore2 = " WHERE tdf.tablename='$mode'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore2);

if (count($tableDefinitionDetail->tdf_tablename) <= 0) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Fields check
 */
if ($action != '') {
    if ($id == '') {    // check if there is a field with the same name in the table
        $querymore = " WHERE fdf.tablename='$tblnam' AND fdf.fieldname='$fldnam'";
        $listFieldsDefinitions = new request();
        $listFieldsDefinitions->openFieldsDefinitions($querymore);
        $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

        if ($comptListFieldsDefinitions != '0') {
            $error = lang_strings('fieldname_already_exists');
            $bodyCommand = "onLoad=\"var x=document.cfEForm.fldnam;x.setAttribute('class','highlight');x.focus();\"";
        }
    } else if ($olduni != $uni && $uni == 'Y') {    // check if duplicate entry exist for unique field
        // determine tablename
        if (preg_match('/@/', $tblnam) == 0) {
            $dbtblnam = $tablePrefix . $tblnam;
        } else {
            $dbtblnam = $tablePrefix . preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam);
        }

        // find duplicate entry
        $tmpquery = "SELECT T0.cnt FROM (SELECT COUNT(id) AS cnt FROM $dbtblnam GROUP BY U_$fldnam) T0 WHERE T0.cnt>1";
        $duplicateCheck = new request();
        $duplicateCheck->connectClass();
        $duplicateCheck->query($tmpquery);

        if ($duplicateCheck->fetch()) {
            $dup = true;
        } else {
            $dup = false;
        }

        $duplicateCheck->close();

        if ($dup) {
            $error = lang_strings('duplicate_entry_found');
        }
    }

    if ($error == '' && $fldtyp == enumFieldType::ftSerial) { // serial field check
        // determine tablename
        if (preg_match('/@/', $tblnam) == 0) {
            $dbtblnam = $tablePrefix . $tblnam;
        } else {
            $dbtblnam = $tablePrefix . preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam);
        }

        // it's impossible to change field type, field length or serial format if the table is not empty
        if ($id == '' || $oldfldtyp != $fldtyp || intval($oldlen) != intval($len) || $oldfldfmt != $fldfmt) {
            $tmpquery = "SELECT id FROM $dbtblnam";
            $cnt = compt($tmpquery);

            if ($cnt != '0') {
                $error = lang_strings('entry_found_error');
            }
        }
    }

    if ($error == '' && $idx == 'Y' && DBTYPE == 'MySQL' && intval($len) > 160 && ($fldtyp == enumFieldType::ftText || $fldtyp == enumFieldType::ftNumeric || $fldtyp == enumFieldType::ftAlphaNumeric || $fldtyp == enumFieldType::ftSerial)) {
        $error = lang_strings('value_deviate');
    }
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    // Convert all applicable characters to HTML entities
    $defval = HtmlEntitiesNOD($defval);
    // store serial format in the field 'default_value'
    if ($fldtyp == enumFieldType::ftSerial) {
        $defval = $fldfmt;
    }

    if (preg_match('/@/', $tblnam) == 0) {
        $dbtblnam = $tablePrefix . $tblnam;
    } else {
        $dbtblnam = $tablePrefix . preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam);
    }

    // case update field definition entry
    if ($action == "update") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();    // this transaction not work in MySQL because some implicit commits

            if ($fieldDefinitionDetail->fdf_sysdef[0] != 'Y') {
                $tmpsql = "UPDATE " . $tablePrefix . "fields_def SET fieldtype='$fldtyp',length='" . intval($len) . "',default_value='$defval',required='$req',unique_field='$uni',create_index='$idx',published='$pub',linkedtable='$lkt' WHERE tablename='$tblnam' AND fieldname='$fldnam'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                // field type changed or field length truncated
                if ($fldtyp != $fieldDefinitionDetail->fdf_fieldtype[0] || intval($len) < intval($fieldDefinitionDetail->fdf_length[0])) {
                    // delete user field filters
                    $tmpsql = "DELETE FROM " . $tablePrefix . "field_filters WHERE tablename='$tblnam' AND dbfieldname='U_$fldnam'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    if ($oldidx == 'Y') {
                        $tmpsql = setup_drop_index_sql($dbtblnam, $fldnam); // delete index

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                    // delete field in the database
                    $tmpsql1 = "ALTER TABLE $dbtblnam DROP U_$fldnam";

                    if ($requestAct->query($tmpsql1) === false) {
                        throw new Exception($tmpsql1);
                    }
                    // add field in the database
                    $tmpsql = "ALTER TABLE $dbtblnam ADD U_$fldnam";

                    if ($fldtyp == enumFieldType::ftText) {
                        $tmpsql .= ' ' . str_replace('%length%', intval($len)*4, $fieldDataType[$fldtyp]);
                    } else if ($fldtyp == enumFieldType::ftNumeric || $fldtyp == enumFieldType::ftAlphaNumeric || $fldtyp == enumFieldType::ftSerial) {
                        $tmpsql .= ' ' . str_replace('%length%', intval($len), $fieldDataType[$fldtyp]);
                    } else {
                        $tmpsql .= ' ' . $fieldDataType[$fldtyp];
                    }

                    // required field
                    if ($req == 'Y') {
                        $tmpsql .= ' NOT NULL';
                    }

                    if ($defval != '') {
                        switch ($fldtyp) {
                            case enumFieldType::ftText:
                            case enumFieldType::ftMemo:
                                $tmpsql .= " DEFAULT '" . HtmlEntitiesNOD($defval) . "'";
                                break;
                            case enumFieldType::ftAlphaNumeric:
                            case enumFieldType::ftNumeric:
                            case enumFieldType::ftTime:
                            case enumFieldType::ftEmail:
                            case enumFieldType::ftUrl:
                                $tmpsql .= " DEFAULT '$defval'";
                                break;
                            case enumFieldType::ftDate:
                                if (preg_match('/^(\d{4})(0\d|10|11|12)([0-2]\d|30|31)$/', $defval, $oa)) {
                                    $tmpsql .= " DEFAULT '" . mktime(0,0,0,intval($oa[2]),intval($oa[3]),intval($oa[1])) . "'";
                                }

                                break;
                            case enumFieldType::ftHours:
                            case enumFieldType::ftQuantity:
                            case enumFieldType::ftMeasure:
                            case enumFieldType::ftRate:
                            case enumFieldType::ftTotals:
                            case enumFieldType::ftPercentage:
                                $tmpsql .= " DEFAULT $defval";
                                break;
                            case enumFieldType::ftBoolean:
                                $tmpsql .= " DEFAULT '" . (($defval=='1')?enumBoolean::bTrue:enumBoolean::bFalse) . "'";
                                break;
                        }
                    }

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    if ($tableDefinitionDetail->tdf_history[0] == 'Y') {
                        // delete history field in the database
                        $tmpsql1 = "ALTER TABLE " . $dbtblnam . "_hist DROP U_$fldnam";

                        if ($requestAct->query($tmpsql1) === false) {
                            throw new Exception($tmpsql1);
                        }
                        // add history field in the database
                        $tmpsql = "ALTER TABLE " . $dbtblnam . "_hist ADD U_$fldnam";

                        if ($fldtyp == enumFieldType::ftText) {
                            $tmpsql .= ' ' . str_replace('%length%', intval($len)*4, $fieldDataType[$fldtyp]);
                        } else if ($fldtyp == enumFieldType::ftNumeric || $fldtyp == enumFieldType::ftAlphaNumeric || $fldtyp == enumFieldType::ftSerial) {
                            $tmpsql .= ' ' . str_replace('%length%', intval($len), $fieldDataType[$fldtyp]);
                        } else {
                            $tmpsql .= ' ' . $fieldDataType[$fldtyp];
                        }

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }

                    // create index
                    if ($idx == 'Y') {
                        $tmpsql = "CREATE " . (($uni=='Y')?'UNIQUE':'') . " INDEX idxu" . $dbtblnam . $fldnam . " ON $dbtblnam (U_$fldnam)";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                } else {
                    $tmpsqls = setup_change_column_sql($dbtblnam, $fldnam, $fldtyp, $fldlens=array($fieldDefinitionDetail->fdf_length[0], intval($len)), $fldreqs=array($fieldDefinitionDetail->fdf_required[0], $req), $defvals=array($fieldDefinitionDetail->fdf_default_value[0], $defval));

                    foreach ($tmpsqls as $tmpsql) {
                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }

                    if ($oldidx == 'Y' && ($uni != $olduni || $idx != $oldidx)) {
                        $tmpsql = setup_drop_index_sql($dbtblnam, $fldnam); // delete index

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }

                    if ($idx == 'Y' && ($uni != $olduni || $idx != $oldidx)) {
                        $tmpsql = "CREATE " . (($uni=='Y')?'UNIQUE':'') . " INDEX idxu" . $dbtblnam . $fldnam . " ON $dbtblnam (U_$fldnam)";    // create index

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                }
            }

            // remove old valid values
            for ($i=0; $i<$comptListFieldsValuesDefinitions; $i++) {
                if (($vvc > 0) && (!in_array($listFieldsValuesDefinitions->fvd_fieldvalue[$i], $valsa))) {
                    $tmpsql = "DELETE FROM " . $tablePrefix . "fields_valdef WHERE tablename='$tblnam' AND fieldname='$fldnam' AND fieldvalue='" . HtmlEntitiesNOD($listFieldsValuesDefinitions->fvd_fieldvalue[$i]) . "'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }

            // add new valid values
            if ($vvc > 0) {
                foreach ($valsa as $val) {
                    $fv = HtmlEntitiesNOD($val);

                    if (!in_array($fv, $listFieldsValuesDefinitions->fvd_fieldvalue)) {
                        $tmpsql = "INSERT INTO " . $tablePrefix . "fields_valdef (tablename,fieldname,fieldvalue,sysdef) VALUES ('$tblnam','$fldnam','$fv','N')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                }
            }

            // update valid value description
            for ($i=0; $i<$vvc; $i++) {
                updateString($requestAct, "VV__" . $tblnam . "_" . $fldnam . "_" . $valsa[$i], $dessa[$i]);
            }

            // update field description
            if ($flddes != fieldNameString($tblnam, $fldnam)) {
                updateString($requestAct, "FIE__" . $tblnam . "_" . $fldnam, $flddes);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);      // this transaction not work in MySQL because some implicit commits
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../customfields/viewcustomfield.php?mode=$mode&id=$tblnam|$fldnam&msg=update");
            exit;
        }
    }
    // case add field definition entry
    if ($action == "add") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();        // this transaction not work in MySQL because some implicit commits
            $tmpquery = "SELECT MAX(disporder) FROM " . $tablePrefix . "fields_def WHERE tablename='$tblnam'";
            $requestAct->query($tmpquery);
            $disporder = '0';

            if ($requestAct->fetch()) {
                $disporder = intval($row[0]) + 1;
            }

            $tmpsql = "INSERT INTO " . $tablePrefix . "fields_def (tablename,fieldname,fieldtype,length,default_value,required,unique_field,create_index,sysdef,published,linkedtable,disporder) VALUES ('$tblnam','$fldnam','$fldtyp','" . intval($len) . "','$defval','$req','$uni','$idx','N','$pub','$lkt','$disporder')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            // add field in the database
            $tmpsql = "ALTER TABLE $dbtblnam ADD U_$fldnam";

            if ($fldtyp == enumFieldType::ftText) {
                $tmpsql .= ' ' . str_replace('%length%', intval($len)*4, $fieldDataType[$fldtyp]);
            } else if ($fldtyp == enumFieldType::ftNumeric || $fldtyp == enumFieldType::ftAlphaNumeric || $fldtyp == enumFieldType::ftSerial) {
                $tmpsql .= ' ' . str_replace('%length%', intval($len), $fieldDataType[$fldtyp]);
            } else {
                $tmpsql .= ' ' . $fieldDataType[$fldtyp];
            }

            // required field
            if ($req == 'Y') {
                $tmpsql .= ' NOT NULL';
            }

            // default value
            if ($defval != '') {
                switch ($fldtyp) {
                    case enumFieldType::ftText:
                    case enumFieldType::ftMemo:
                        $tmpsql .= " DEFAULT '" . HtmlEntitiesNOD($defval) . "'";
                        break;
                    case enumFieldType::ftAlphaNumeric:
                    case enumFieldType::ftNumeric:
                    case enumFieldType::ftTime:
                    case enumFieldType::ftEmail:
                    case enumFieldType::ftUrl:
                        $tmpsql .= " DEFAULT '$defval'";
                        break;
                    case enumFieldType::ftDate:
                        if (preg_match('/^(\d{4})(0\d|10|11|12)([0-2]\d|30|31)$/', $defval, $oa)) {
                            $tmpsql .= " DEFAULT '" . mktime(0,0,0,intval($oa[2]),intval($oa[3]),intval($oa[1])) . "'";
                        }

                        break;
                    case enumFieldType::ftHours:
                    case enumFieldType::ftQuantity:
                    case enumFieldType::ftMeasure:
                    case enumFieldType::ftRate:
                    case enumFieldType::ftTotals:
                    case enumFieldType::ftPercentage:
                        $tmpsql .= " DEFAULT $defval";
                        break;
                    case enumFieldType::ftBoolean:
                        $tmpsql .= " DEFAULT '" . (($defval=='1')?enumBoolean::bTrue:enumBoolean::bFalse) . "'";
                        break;
                }
            }

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            // add history field in the database
            if ($tableDefinitionDetail->tdf_history[0] == 'Y') {
                $tmpsql = "ALTER TABLE " . $dbtblnam . "_hist ADD U_$fldnam";

                if ($fldtyp == enumFieldType::ftText) {
                    $tmpsql .= ' ' . str_replace('%length%', intval($len)*4, $fieldDataType[$fldtyp]);
                } else if ($fldtyp == enumFieldType::ftNumeric || $fldtyp == enumFieldType::ftAlphaNumeric || $fldtyp == enumFieldType::ftSerial) {
                    $tmpsql .= ' ' . str_replace('%length%', intval($len), $fieldDataType[$fldtyp]);
                } else {
                    $tmpsql .= ' ' . $fieldDataType[$fldtyp];
                }

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            // create index
            if ($idx == 'Y') {
                $tmpsql = "CREATE " . (($uni=='Y')?'UNIQUE':'') . " INDEX idxu" . $dbtblnam . $fldnam . " ON $dbtblnam (U_$fldnam)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            // add valid values
            for ($i=0; $i<$vvc; $i++) {
                $fv = HtmlEntitiesNOD($valsa[$i]);
                $tmpsql = "INSERT INTO " . $tablePrefix . "fields_valdef (tablename,fieldname,fieldvalue,sysdef) VALUES ('$tblnam','$fldnam','$fv','N')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                // update valid values description
                updateString($requestAct, "VV__" . $tblnam . "_" . $fldnam . "_" . $valsa[$i], $dessa[$i]);
            }

            // update field description
            if ($flddes != fieldNameString($tblnam, $fldnam)) {
                updateString($requestAct, "FIE__" . $tblnam . "_" . $fldnam, $flddes);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);      // this transaction not work in MySQL because some implicit commits
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../customfields/listcustomfields.php?mode=$mode&msg=add");
            exit;
        }
    }
}

/**
 * Set value in form
 */
if ($error == '') {
    if ($id != '') {
        $tblnam = $fieldDefinitionDetail->fdf_tablename[0];
        $fldnam = $fieldDefinitionDetail->fdf_fieldname[0];
        $flddes = fieldNameString($tblnam, $fldnam);
        $fldtyp = $fieldDefinitionDetail->fdf_fieldtype[0];
        $len = ($fldtyp==enumFieldType::ftText || $fldtyp==enumFieldType::ftAlphaNumeric || $fldtyp==enumFieldType::ftNumeric || $fldtyp==enumFieldType::ftSerial)?$fieldDefinitionDetail->fdf_length[0]:'';
        $req = $fieldDefinitionDetail->fdf_required[0];
        $defval = $fieldDefinitionDetail->fdf_default_value[0];
        $fldfmt = $fieldDefinitionDetail->fdf_default_value[0];
        $lkt = $fieldDefinitionDetail->fdf_linkedtable[0];
        $uni = $fieldDefinitionDetail->fdf_unique_field[0];
        $idx = $fieldDefinitionDetail->fdf_create_index[0];
        $sys = $fieldDefinitionDetail->fdf_sysdef[0];
        $pub = $fieldDefinitionDetail->fdf_published[0];
        $fathertbl = $fieldDefinitionDetail->fdf_tdf_fathertable[0];
        $vvc = count($listFieldsValuesDefinitions->fvd_id);

        if ($vvc == '0') {
            $valsa = array();
            $dessa = array();
            $syssa = array();
        } else {
            $valsa = $listFieldsValuesDefinitions->fvd_fieldvalue;
            $dessa = $listFieldsValuesDefinitions->fvd_fieldvalue_desc;
            $syssa = $listFieldsValuesDefinitions->fvd_sysdef;
        }

        if ($sys != 'Y') {
            $bodyCommand = 'onLoad="document.cfEForm.flddes.focus();"';
        }
    } else {
        $tblnam = $mode;
        $fldnam = '';
        $flddes = '';
        $fldtyp = enumFieldType::ftText;
        $len = '50';
        $req = 'N';
        $defval = '';
        $fldfmt = '';
        $lkt = '';
        $uni = 'N';
        $idx = 'N';
        $sys = 'N';
        $pub = enumPublished::pbNo;
        $fathertbl = $tableDefinitionDetail->tdf_fathertable[0];
        $vvc = '0';
        $valsa = array();
        $dessa = array();
        $syssa = array();
        $bodyCommand = 'onLoad="document.cfEForm.fldnam.focus();"';
    }
}

$flddispnam = ($flddes=='')?$fldnam:$flddes;
$lenreadonly = ($fldtyp==enumFieldType::ftText || $fldtyp==enumFieldType::ftAlphaNumeric || $fldtyp==enumFieldType::ftNumeric)?'':'readonly';
$reqchecked = ($req=='Y')?'checked':'';
$defvalreadonly = ($fldtyp==enumFieldType::ftImage || $fldtyp==enumFieldType::ftAudio || $fldtyp==enumFieldType::ftVideo || $fldtyp==enumFieldType::ftSerial)?'readonly':'';
$fldfmtreadonly = ($fldtyp==enumFieldType::ftSerial)?'':'readonly';
$lktdisabled = ($fldtyp==enumFieldType::ftNumeric && $vvc == '0')?'':'disabled';
$unidisabled = ($uni=='N')?'disabled':'';
$idxdisabled = ($req=='N')?'disabled':'';
$unichecked = ($uni=='Y')?'checked':'';
$idxchecked = ($idx=='Y')?'checked':'';
$pubchecked = ($pub==enumPublished::pbYes)?'checked':'';

/**
 * Prepare data
 */
$querymore = " WHERE tdf.tablename<>'$tblnam' AND tdf.keyfields='id' AND ((tdf.listfields<>'' AND tdf.sysdef='Y') OR tdf.sysdef='N') AND tdf.fathertable='' ORDER BY tdf.sysdef DESC,tdf.tablename";
$listTablesDefinitions = new request();
$listTablesDefinitions->openTablesDefinitions($querymore);
$comptListTablesDefinitions = count($listTablesDefinitions->tdf_id);

/**
 * Html
 */
require_once("../includes/header.php");
echo '<script type="text/javascript" src="../javascript/editcustomfield' . $scriptMinimized . '.js"></script>';
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=custom", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/listformtemplates.php?", lang_strings('form_templates'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/viewformtemplate.php?id=$mode", $tbldispnam, 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../customfields/listcustomfields.php?mode=$mode", lang_strings('custom_fields'), 'in'));

if ($id == "") {
    $blockPage->itemBreadcrumbs(lang_strings("add_custom_field"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../customfields/viewcustomfield.php?mode=$mode&id=$id", $flddispnam, 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_custom_field"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "cfE";

if ($id == "") {
    $block1->openForm("../customfields/editcustomfield.php?mode=$mode#" . $block1->form . "Anchor", "return checkform(this, '0');");
    echo '<input type="hidden" name="action" value="add">';
} else {
    $block1->openForm("../customfields/editcustomfield.php?mode=$mode&id=$id#" . $block1->form . "Anchor", "return checkform(this, '1');");
    echo '<input type="hidden" name="action" value="update">';
}

if ($id == "") {
    $block1->heading(lang_strings("add_custom_field"));
} else {
    $block1->heading(lang_strings("edit_custom_field") . " : " . $flddispnam);
    echo '<input type="hidden" name="oldfldtyp" value="' . $fieldDefinitionDetail->fdf_fieldtype[0] . '">';
    echo '<input type="hidden" name="oldlen" value="' . $fieldDefinitionDetail->fdf_length[0] . '">';
    echo '<input type="hidden" name="oldreq" value="' . $fieldDefinitionDetail->fdf_required[0] . '">';
    echo '<input type="hidden" name="olddefval" value="' . $fieldDefinitionDetail->fdf_default_value[0] . '">';
    echo '<input type="hidden" name="oldfldfmt" value="' . $fieldDefinitionDetail->fdf_default_value[0] . '">';
    echo '<input type="hidden" name="olduni" value="' . $fieldDefinitionDetail->fdf_unique_field[0] . '">';
    echo '<input type="hidden" name="oldidx" value="' . $fieldDefinitionDetail->fdf_create_index[0] . '">';
    echo '<input type="hidden" name="oldvals" value="' . ((is_array($listFieldsValuesDefinitions->fvd_fieldvalue))?implode('***', $listFieldsValuesDefinitions->fvd_fieldvalue):'') . '">';
}

echo '<input type="hidden" name="dbtype" value="' . DBTYPE . '">';
echo '<input type="hidden" name="fdt" value="' . (($fathertbl=='' && $tblnam!='files')?'N':'Y') . '">';
echo '<input type="hidden" name="vvc" value="' . $vvc . '">';
echo '<input type="hidden" name="valstr" value="' . $strings['value'] . '">';
echo '<input type="hidden" name="desstr" value="' . $strings['description'] . '">';
echo '<input type="hidden" name="constr" value="' . $strings['confirm_datalost'] . '">';
echo '<input type="hidden" name="lenestr" value="' . $strings['invalid_length'] . '">';
echo '<input type="hidden" name="invnam" value="' . $strings['invalid_field_name'] . '">';
echo '<input type="hidden" id="format' . enumFieldType::ftText . '" value="">';
echo '<input type="hidden" id="format' . enumFieldType::ftAlphaNumeric . '" value="">';
echo '<input type="hidden" id="format' . enumFieldType::ftNumeric . '" value="">';
echo '<input type="hidden" id="format' . enumFieldType::ftMemo . '" value="">';
echo '<input type="hidden" id="format' . enumFieldType::ftDate . '" value="&quot;YYYYMMDD&quot; (ie 18790314), &quot;+n&quot; (ie +0), &quot;-n&quot; (ie -3)", &quot;+NyNmNwNd&quot; (ie +1y6m, -12w, +15d)>';
echo '<input type="hidden" id="format' . enumFieldType::ftTime . '" value="&quot;HHMM&quot; (ie 2359)">';
echo '<input type="hidden" id="format' . enumFieldType::ftHours . '" value="' . $hourAccuracy . ' ' . $strings['decimal_places'] . '">';
echo '<input type="hidden" id="format' . enumFieldType::ftQuantity . '" value="' . $quantityAccuracy . ' ' . $strings['decimal_places'] . '">';
echo '<input type="hidden" id="format' . enumFieldType::ftMeasure . '" value="' . $measureAccuracy . ' ' . $strings['decimal_places'] . '">';
echo '<input type="hidden" id="format' . enumFieldType::ftRate . '" value="' . $rateAccuracy . ' ' . $strings['decimal_places'] . '">';
echo '<input type="hidden" id="format' . enumFieldType::ftTotals . '" value="' . $costAccuracy . ' ' . $strings['decimal_places'] . '">';
echo '<input type="hidden" id="format' . enumFieldType::ftImage . '" value="">';
echo '<input type="hidden" id="format' . enumFieldType::ftAudio . '" value="">';
echo '<input type="hidden" id="format' . enumFieldType::ftVideo . '" value="">';
echo '<input type="hidden" id="format' . enumFieldType::ftBoolean . '" value="0 - ' . $strings['no'] . ', 1 - ' . $strings['yes'] . '">';
echo '<input type="hidden" id="format' . enumFieldType::ftEmail . '" value="">';
echo '<input type="hidden" id="format' . enumFieldType::ftUrl . '" value="">';
echo '<input type="hidden" id="format' . enumFieldType::ftSerial . '" value="">';
echo '<input type="hidden" id="format' . enumFieldType::ftPercentage . '" value="' . $percentAccuracy . ' ' . $strings['decimal_places'] . '">';
echo '<input type="hidden" id="format' . enumFieldType::ftPassword . '" value="">';
$block1->openContent();
$block1->contentTitle(lang_strings("info"));

if ($id == "") {
    setupInputHTML($block1, lang_strings("field"), 'fldnam', enumFieldType::ftAlphaNumeric, 'Y', '32', $fldnam);
    setupInputHTML($block1, lang_strings("description"), 'flddes', enumFieldType::ftText, 'Y', '255', $flddes);
} else {
    if ($sys == 'Y') {
        $block1->contentRow(lang_strings("field"), fieldNameString($tblnam, $fldnam));
        echo '<input type="hidden" name="flddes" value="' . $flddes . '">';
    } else {
        $block1->contentRow(lang_strings("field"), $fldnam);
        setupInputHTML($block1, lang_strings("description"), 'flddes', enumFieldType::ftText, 'Y', '255', $flddes);
    }
}

$block1->contentTitle(lang_strings("details"));

if ($sys == 'Y') {
    echo '<input type="hidden" name="fldtyp" value="' . $fldtyp . '">';
    echo '<input type="hidden" name="len" value="' . $len . '">';
    echo '<input type="hidden" name="req" value="' . $req . '">';
    echo '<input type="hidden" name="defval" value="' . $defval . '">';
    echo '<input type="hidden" name="fldfmt" value="' . $fldfmt . '">';
    echo '<input type="hidden" name="uni" value= "' . $uni . '">';
    echo '<input type="hidden" name="idx" value="' . $idx . '">';
    $block1->contentRow(lang_strings("fieldtype"), $fieldTypeArray[strval($fldtyp)]);

    if ($lenreadonly == '') {
        $block1->contentRow(lang_strings("length"), $len);
    }

    $block1->contentRow(lang_strings("required"), '<input value="Y" name="req" type="checkbox" ' . $reqchecked . ' disabled>');
    $block1->contentRow(lang_strings("defaultvalue"), $defval);
    $block1->contentRow(lang_strings("validvalues"), $blockPage->buildLink("javascript:morevv();", lang_strings("more_vv"), 'in'));
} else {
    $fldtypSel = '<select name="fldtyp" onchange="fldtyp_change(1)">';

    foreach ($fieldTypeArray as $val => $desc) {
        if ($fathertbl != '' && ($val == enumFieldType::ftImage || $val == enumFieldType::ftAudio || $val == enumFieldType::ftVideo || $val == enumFieldType::ftSerial)) {
            continue;
        }

        if (strval($val) == strval($fldtyp)) {
            $fldtypSel .= '<option value="' . $val . '" selected>' . $desc . '</option>';
        } else {
            $fldtypSel .= '<option value="' . $val . '">' . $desc . '</option>';
        }
    }

    $fldtypSel .= '</select>';
    $block1->contentRow(lang_strings("fieldtype"), $fldtypSel);
    setupInputHTML($block1, lang_strings("length"), 'len', enumFieldType::ftNumeric, 'N', '32', $len);
    $block1->contentRow(lang_strings("required"), '<input value="Y" name="req" type="checkbox" ' . $reqchecked . ' onchange="req_change()">');
    $block1->contentRow(lang_strings("defaultvalue"), '<input value="' . $defval . '" name="defval" type="TEXT" ' . $defvalreadonly . '>&nbsp;<dfn></dfn>');
    $fldfmtSel = '<select name="fldfmt" ' . $fldfmtreadonly . '>';

    foreach ($serialFormat as $val => $desc) {
        if ($val == $fldfmt) {
            $fldfmtSel .= '<option value="' . $val . '" selected>' . $desc . '</option>';
        } else {
            $fldfmtSel .= '<option value="' . $val . '">' . $desc . '</option>';
        }
    }

    $fldfmtSel .= '</select>';
    $block1->contentRow(lang_strings('serial_format'), $fldfmtSel);
    $block1->contentRow(lang_strings("validvalues"), $blockPage->buildLink("javascript:morevv();", lang_strings("more_vv"), 'in'));
}

$vv = '<div class="valuelist"><table id="vv">';

if ($vvc != '0') {
    $vv .= '<tr><td>' . $strings['value'] . '</td><td>' . $strings['description'] .'</td><td>&nbsp</td></tr>';

    for ($i=0; $i<$vvc; $i++) {
        $vv .= '<tr><td><input type="text" name="valsa' . $i . '" value="' . $valsa[$i] . '"';

        if ($syssa[$i] == 'Y') {
            $vv .= ' readonly';
        }

        $vv .= '></td><td><input type="text" name="dessa' . $i . '" value="' . $dessa[$i] . '"></td>';
        $vv .= '<input type="hidden" name="syssa' . $i . '" value="' . $syssa[$i] . '">';

        if ($syssa[$i] == 'Y') {
            $vv .= '<td>&nbsp;</td></tr>';
        } else {
            $vv .= '<td><a href="javascript:delvv(' . $i . ');" class="delete-link">&#8722;</a></td></tr>';
        }
    }
}

$vv .= '</table></div>';
$block1->contentRow('', $vv);

if ($sys == 'Y') {
    if ($lkt == '') {
        $lktdispnam = lang_strings('none');
    } else {
        $lktdispnam = tableNameString($lkt);

        if (substr($lkt,0,1)=='@') {
            $lktdispnam .= ' (' . lang_strings('form_template') . ')';
        }
    }

    $block1->contentRow(lang_strings('linked_table'), $lktdispnam);
    $block1->contentRow(lang_strings("uniquefield"), '<input value="Y" name="uni" type="checkbox" ' . $unichecked . ' disabled>');
    $block1->contentRow(lang_strings("createindex"), '<input value="Y" name="idx" type="checkbox" ' . $idxchecked . ' disabled>');

    if ($sitePublish == 'true') {
        $block1->contentRow(lang_strings("published"), '<input value="' . enumPublished::pbYes . '" name="pub" type="checkbox" ' . $pubchecked . ' disabled>');
    } else {
        echo '<input type="hidden" name="pub" value="' . enumPublished::pbNo . '">';
    }
} else {
    $lktSel = '<select name="lkt" ' . $lktdisabled . '><option value="" ' . (($lkt=='')?'selected':'') . '>' . $strings['none'] . '</option>';

    for ($i=0; $i<$comptListTablesDefinitions; $i++) {
        $lktdispnam = tableNameString($listTablesDefinitions->tdf_tablename[$i]);

        if (substr($listTablesDefinitions->tdf_tablename[$i],0,1)=='@') {
            $lktdispnam .= ' (' . lang_strings('form_template') . ')';
        }

        $lktSel .= '<option value="' . $listTablesDefinitions->tdf_tablename[$i] . '" ' . (($lkt==$listTablesDefinitions->tdf_tablename[$i])?'selected':'') . '>' . $lktdispnam . '</option>';
    }

    $lktSel .= '</select>';
    $block1->contentRow(lang_strings('linked_table'), $lktSel);
    $block1->contentRow(lang_strings("uniquefield"), '<input value="Y" name="uni" type="checkbox" ' . $unichecked . ' ' . $unidisabled . ' onchange="uni_change()">');
    $block1->contentRow(lang_strings("createindex"), '<input value="Y" name="idx" type="checkbox" ' . $idxchecked . ' ' . $idxdisabled . '>');

    if ($sitePublish == 'true') {
        $block1->contentRow(lang_strings("published"), '<input value="' . enumPublished::pbYes . '" name="pub" type="checkbox" ' . $pubchecked . '>');
    } else {
        echo '<input type="hidden" name="pub" value="' . enumPublished::pbNo . '">';
    }
}

$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
