<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportcustomfields.php,v 1.4 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$mode = AddSlashesNOD(isset($_GET['mode'])?$_GET['mode']:'');

/**
 * Permission check
 */
if (!$SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$ids = explode('**', $id);
$condA = array();

foreach ($ids as $x) {
    list($tblnam, $fldnam) = preg_split('/\|/', $x);
    $condA[] = "(fdf.tablename='$tblnam' AND fdf.fieldname='$fldnam')";
}

$querymore = " WHERE " . implode(" OR ", $condA) . " ORDER BY fdf.tablename,fdf.disporder";
$listFieldsDefinitions = new request();
$listFieldsDefinitions->openFieldsDefinitions($querymore);
$comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

if ($comptListFieldsDefinitions != count($ids)) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Prepare data
 */
$doc = exportCustomFields($listFieldsDefinitions); // create XML document
$dump = $doc->saveXML();    // Dumps the internal XML tree back into a string
$size = strlen($dump);
$name = 'custom_fields_' . preg_replace_callback('/@/', function ($matches) { return 'FORM_'; }, $tblnam) . '.xml';

/**
 * Output
 */
header('Content-Length: ' . $size);
header('Content-Type: text/xml');
header("Content-Disposition: attachment; filename=$name");
echo $dump;
