<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: importcustomfields.php,v 1.9 2013/02/03 15:14:27 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$mode = AddSlashesNOD(isset($_GET['mode'])?$_GET['mode']:'');
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Actions
 */
if ($action == "import") {
    try {
        if ($_FILES['upload']['name'] == '') {  // check file name
            throw new Exception(lang_strings("no_file"));
        } else if ($_FILES['upload']['size'] == '0') {  // check file size
            throw new Exception(lang_strings('exceed_size'));
        } else {
            $doc = new DOMDocument();

            if ($doc->load($_FILES['upload']['tmp_name']) === false) {   // check if file exists
                throw new Exception(str_replace('%FILE%', $_FILES['upload']['name'], $strings['load_file_fail']));
            }
        }
    } catch (Exception $e) {
        $error = $e->getMessage();
    }
}

if ($action == "import" && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        importCustomFields($doc);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../customfields/listcustomfields.php?mode=$mode&msg=add");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=custom", lang_strings("administration"), 'in'));
$tbldispnam = tableNameString($mode);

if (substr($mode,0,1)=='@') {
    $tbldispnam .= ' (' . lang_strings('form_template') . ')';
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/listformtemplates.php?", lang_strings('form_templates'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/viewformtemplate.php?id=$mode", $tbldispnam, 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../customfields/listcustomfields.php?mode=$mode", lang_strings("custom_fields"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("import_customfields"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "imF";
$block1->openForm("../customfields/importcustomfields.php?mode=$mode#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="import">';
$block1->heading(lang_strings("import_customfields"));
$block1->openContent();
$block1->contentRow("*&nbsp;" . lang_strings("upload"), "<input name=\"upload\" type=\"FILE\">");
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["import"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
