<?php // $Revision: 1.12 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listcustomfields.php,v 1.12 2013/01/29 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSite = isset($_GET['addToSite'])?$_GET['addToSite']:'';
$removeToSite = isset($_GET['removeToSite'])?$_GET['removeToSite']:'';
$mode = AddSlashesNOD(isset($_GET['mode'])?$_GET['mode']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$error = '';

/**
 * Permission check
 */
if ($action != '') {
    if (!$SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
        header('Location: ../administration/admin.php?msg=permissiondenied&toggle_focus=custom');
        exit;
    }

    if ($action == 'publish') {
        $multi = strstr($id, "**");

        if ($multi != "") {
            $ids = preg_split('/\*\*/', $id);
            $querymore = '';

            foreach ($ids as $token) {
                if ($querymore != '') {
                    $querymore .= ' OR ';
                }

                list($table_name, $field_name) = preg_split('/\|/', $token, 2);
                $querymore .= "(fdf.tablename='$table_name' AND fdf.fieldname='$field_name')";
            }

            if ($removeToSite == "true") {
                $querymore = " WHERE (fdf.sysdef='Y' OR fdf.required='Y') AND ($querymore)";
            } else {
                $querymore = " WHERE fdf.sysdef='Y' AND ($querymore)";
            }
        } else {
            list($table_name, $field_name) = preg_split('/\|/', $id, 2);

            if ($removeToSite == "true") {
                $querymore = " WHERE (fdf.sysdef='Y' OR fdf.required='Y') AND fdf.tablename='$table_name' AND fdf.fieldname='$field_name'";
            } else {
                $querymore = " WHERE fdf.sysdef='Y' AND fdf.tablename='$table_name' AND fdf.fieldname='$field_name'";
            }
        }

        $listFieldsDefinitions = new request();
        $listFieldsDefinitions->openFieldsDefinitions($querymore);
        $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

        if ($comptListFieldsDefinitions > 0) {
            header('Location: ../administration/admin.php?msg=permissiondenied&toggle_focus=custom');
            exit;
        }
    }
} else {
    if (!$SW_Permissions['Custom Fields']['Read'][$profilSession]) {
        header('Location: ../administration/admin.php?msg=permissiondenied&toggle_focus=custom');
        exit;
    }
}

/**
 * update form fields & list fields display order
 */
function UpdateFormListOrders($requestAct, $tblnam)
{
    global $reservedDbFields, $tablePrefix;
    $querymore1 = " WHERE tdf.tablename='$tblnam'";
    $tableDefinitionDetail = clone $requestAct;
    $tableDefinitionDetail->openTablesDefinitions($querymore1);
    $querymore2 = " WHERE fdf.tablename='$tblnam' ORDER BY fdf.disporder";
    $listFieldsDefinitions = clone $requestAct;
    $listFieldsDefinitions->openFieldsDefinitions($querymore2);
    $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

    if ($tableDefinitionDetail->tdf_formfields[0] != '') {
        $formfields = explode('+', $tableDefinitionDetail->tdf_formfields[0]);
        $fields = array();

        for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
            if (in_array($listFieldsDefinitions->fdf_dbfieldname[$i], $formfields)) {
                $fields[] = $listFieldsDefinitions->fdf_dbfieldname[$i];
            }
        }

        foreach ($reservedDbFields as $dbfldnam => $flddesc) {
            if (in_array($dbfldnam, $formfields)) {
                $fields[] = $dbfldnam;
            }
        }

        if (($key = array_search('id', $fields)) !== false) {
            unset($fields[$key]);
            array_unshift($fields, 'id');
        }

        $newformfields = implode('+', $fields);

        if ($newformfields != $tableDefinitionDetail->tdf_formfields[0]) {
            $tmpsql = "UPDATE " . $tablePrefix . "tables_def SET formfields='$newformfields' WHERE tablename='$tblnam'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }
    }

    if ($tableDefinitionDetail->tdf_listfields[0] != '') {
        $listfields = explode('+', $tableDefinitionDetail->tdf_listfields[0]);
        $fields = array();

        for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
            if (in_array($listFieldsDefinitions->fdf_dbfieldname[$i], $listfields)) {
                $fields[] = $listFieldsDefinitions->fdf_dbfieldname[$i];
            }
        }

        foreach ($reservedDbFields as $dbfldnam => $flddesc) {
            if (in_array($dbfldnam, $listfields)) {
                $fields[] = $dbfldnam;
            }
        }

        if (($key = array_search('id', $fields)) !== false) {
            unset($fields[$key]);
            array_unshift($fields, 'id');
        }

        $newlistfields = implode('+', $fields);

        if ($newlistfields != $tableDefinitionDetail->tdf_listfields[0]) {
            $tmpsql = "UPDATE " . $tablePrefix . "tables_def SET listfields='$newlistfields' WHERE tablename='$tblnam'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }
    }
}

/**
 * Actions
 */
if ($action == "publish") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($addToSite == "true") {
            $multi = strstr($id, "**");

            if ($multi != "") {
                $ids = preg_split('/\*\*/', $id);

                foreach ($ids as $token) {
                    if ($tmpsql != '') {
                        $tmpsql = $tmpsql . ' OR ';
                    }

                    list($table_name, $field_name) = preg_split('/\|/', $token, 2);
                    $tmpsql .= "(tablename='$table_name' AND fieldname='$field_name')";
                }

                $tmpsql = "UPDATE " . $tablePrefix . "fields_def SET published='" . enumPublished::pbYes . "' WHERE $tmpsql";
            } else {
                list($table_name, $field_name) = preg_split('/\|/', $id, 2);
                $tmpsql = "UPDATE " . $tablePrefix . "fields_def SET published='" . enumPublished::pbYes . "' WHERE tablename='$table_name' AND fieldname='$field_name'";
            }

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = "addToSite";
        } else if ($removeToSite == "true") {
            $multi = strstr($id, "**");

            if ($multi != "") {
                $ids = preg_split('/\*\*/', $id);

                foreach ($ids as $token) {
                    if ($tmpsql != '') {
                        $tmpsql = $tmpsql . ' OR ';
                    }

                    list($table_name, $field_name) = preg_split('/\|/', $token, 2);
                    $tmpsql .= "(tablename='$table_name' AND fieldname='$field_name')";
                }

                $tmpsql = "UPDATE " . $tablePrefix . "fields_def SET published='" . enumPublished::pbNo . "' WHERE $tmpsql";
            } else {
                list($table_name, $field_name) = preg_split('/\|/', $id, 2);
                $tmpsql = "UPDATE " . $tablePrefix . "fields_def SET published='" . enumPublished::pbNo . "' WHERE tablename='$table_name' AND fieldname='$field_name'";
            }

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = "removeToSite";
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
} else if ($action == 'moveUp') {
    list($tblnam, $fldnam) = preg_split('/\|/', $id, 2);
    $querymore = " WHERE fdf.tablename='$tblnam' AND fdf.fieldname='$fldnam'";
    $fieldDefinitionDetail = new request();
    $fieldDefinitionDetail->openFieldsDefinitions($querymore);
    $thisfld = $fieldDefinitionDetail->fdf_disporder[0];
    $prevfld = intval($thisfld) - 1;
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "UPDATE " . $tablePrefix . "fields_def SET disporder='$thisfld' WHERE tablename='$tblnam' AND disporder='$prevfld'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "UPDATE " . $tablePrefix . "fields_def SET disporder='$prevfld' WHERE tablename='$tblnam' AND fieldname='$fldnam'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        UpdateFormListOrders($requestAct, $tblnam);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
} else if ($action == 'moveDown') {
    list($tblnam, $fldnam) = preg_split('/\|/', $id, 2);
    $querymore = " WHERE fdf.tablename='$tblnam' AND fdf.fieldname='$fldnam'";
    $fieldDefinitionDetail = new request();
    $fieldDefinitionDetail->openFieldsDefinitions($querymore);
    $thisfld = $fieldDefinitionDetail->fdf_disporder[0];
    $nextfld = intval($thisfld) + 1;
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "UPDATE " . $tablePrefix . "fields_def SET disporder='$thisfld' WHERE tablename='$tblnam' AND disporder='$nextfld'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "UPDATE " . $tablePrefix . "fields_def SET disporder='$nextfld' WHERE tablename='$tblnam' AND fieldname='$fldnam'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        UpdateFormListOrders($requestAct, $tblnam);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=custom", lang_strings("administration"), 'in'));

if ($mode == '') {
    $blockPage->itemBreadcrumbs(lang_strings("custom_fields"));
} else {
    $tbldispnam = tableNameString($mode);

    if (substr($mode,0,1)=='@') {
        $tbldispnam .= ' (' . lang_strings('form_template') . ')';
    }

    $blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/listformtemplates.php?", lang_strings('form_templates'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/viewformtemplate.php?id=$mode", $tbldispnam, 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("custom_fields"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "lcf";
$block1->openForm("../customfields/listcustomfields.php?mode=$mode#" . $block1->form . "Anchor");

if ($mode == '') {
    $block1->heading(lang_strings("choose_table"));
    $block1->openContent();
    $querymore = " WHERE tdf.cfenabled='Y' ORDER BY tdf.sysdef DESC,tdf.tablename";
    $listTablesDefinitions = new request();
    $listTablesDefinitions->openTablesDefinitions($querymore);
    $comptListTablesDefinitions = count($listTablesDefinitions->tdf_tablename);

    for ($i=0; $i<$comptListTablesDefinitions; $i++) {
        $tbldispnam = tableNameString($listTablesDefinitions->tdf_tablename[$i]);

        if ($listTablesDefinitions->tdf_sysdef[$i] == 'N') {
            $tbldispnam .= ' (' . lang_strings('form_template') . ')';
        }

        $block1->contentRow('', $blockPage->buildLink("../customfields/listcustomfields.php?mode=" . $listTablesDefinitions->tdf_tablename[$i], $tbldispnam, 'in'));
    }

    $block1->closeContent();
} else {
    $block1->heading(lang_strings("custom_fields"));
    $block1->openPaletteIcon();

    if ($SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
        $block1->paletteIcon(0, "add", $strings["add"]);
        $block1->paletteIcon(1, "remove", $strings["delete"]);

        if ($sitePublish == "true") {
            $block1->paletteIcon(3, "add_projectsite", $strings["add_customer_service_site"]);
            $block1->paletteIcon(4, "remove_projectsite", $strings["remove_customer_service_site"]);
        }
    }

    $block1->paletteIcon(5, "info", $strings["view"]);

    if ($SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
        $block1->paletteIcon(6, "edit", $strings["edit"]);
        $block1->paletteIcon(7, 'import', $strings['import']);
        $block1->paletteIcon(8, 'export', $strings['export']);
    }

    $block1->closePaletteIcon();
    $querymore = " WHERE fdf.tablename='$mode' AND fdf.sysdef<>'Y' ORDER BY fdf.disporder";
    $listFieldsDefinitions = new request();
    $listFieldsDefinitions->openFieldsDefinitions($querymore);
    $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);
    $listFieldsDefinitions->fdf_id = array();

    if ($comptListFieldsDefinitions > 0) {
        $labels = array("", "", lang_strings("name"), lang_strings("description"), lang_strings("fieldtype"), lang_strings("length"), lang_strings('required'), lang_strings("published"));
        $block1->openResults();
        $block1->labels($labels, "true", "false");

        for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
            $listFieldsDefinitions->fdf_id[$i] = $listFieldsDefinitions->fdf_tablename[$i] . '|' . $listFieldsDefinitions->fdf_fieldname[$i];
            $block1->openRow($listFieldsDefinitions->fdf_id[$i]);

            if ($i == 0) {
                $block1->cellRow('');
            } else {
                $block1->cellRow($blockPage->buildLink("../customfields/listcustomfields.php?mode=$mode&action=moveUp&id=" . $listFieldsDefinitions->fdf_id[$i], '&xutri;', 'in'));
            }

            if (($i+1) == $comptListFieldsDefinitions) {
                $block1->cellRow('');
            } else {
                $block1->cellRow($blockPage->buildLink("../customfields/listcustomfields.php?mode=$mode&action=moveDown&id=" . $listFieldsDefinitions->fdf_id[$i], '&xdtri;', 'in'));
            }

            $block1->cellRow($blockPage->buildLink("../customfields/viewcustomfield.php?mode=$mode&id=" . $listFieldsDefinitions->fdf_id[$i], $listFieldsDefinitions->fdf_fieldname[$i], 'in'));
            $block1->cellRow($blockPage->buildLink("../customfields/viewcustomfield.php?mode=$mode&id=" . $listFieldsDefinitions->fdf_id[$i], fieldNameString($listFieldsDefinitions->fdf_tablename[$i], $listFieldsDefinitions->fdf_fieldname[$i]), 'in'));
            $block1->cellRow($fieldTypeArray[$listFieldsDefinitions->fdf_fieldtype[$i]]);

            if ($listFieldsDefinitions->fdf_fieldtype[$i] == enumFieldType::ftText || $listFieldsDefinitions->fdf_fieldtype[$i] == enumFieldType::ftAlphaNumeric || $listFieldsDefinitions->fdf_fieldtype[$i] == enumFieldType::ftNumeric || $listFieldsDefinitions->fdf_fieldtype[$i] == enumFieldType::ftSerial) {
                $block1->cellRow($listFieldsDefinitions->fdf_length[$i]);
            } else {
                $block1->cellRow('');
            }

            $block1->cellRow(($listFieldsDefinitions->fdf_required[$i]=='Y')?lang_strings('yes'):lang_strings('no'));

            if ($sitePublish == "true") {
                $idPublish = $listFieldsDefinitions->fdf_published[$i];
                $block1->cellRow($statusPublish[$idPublish]);
            }

            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }

    $block1->closeFormResults();
    $block1->openPaletteScript();

    if ($SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
        $block1->paletteScript(0, "add", "../customfields/editcustomfield.php?mode=$mode", "true,false,false", $strings["add"]);
        $block1->paletteScript(1, "remove", "../customfields/deletecustomfields.php?mode=$mode", "false,true,true", $strings["delete"]);

        if ($sitePublish == "true") {
            $block1->paletteScript(3, "add_projectsite", "../customfields/listcustomfields.php?mode=$mode&addToSite=true&action=publish", "false,true,true", $strings["add_customer_service_site"]);
            $block1->paletteScript(4, "remove_projectsite", "../customfields/listcustomfields.php?mode=$mode&removeToSite=true&action=publish", "false,true,true", $strings["remove_customer_service_site"]);
        }
    }

    $block1->paletteScript(5, "info", "../customfields/viewcustomfield.php?mode=$mode", "false,true,false", $strings["view"]);

    if ($SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
        $block1->paletteScript(6, "edit", "../customfields/editcustomfield.php?mode=$mode", "false,true,false", $strings["edit"]);
        $block1->paletteScript(7, 'import', "../customfields/importcustomfields.php?mode=$mode", 'true,false,false', $strings['import']);
        $block1->paletteScript(8, 'export', "../customfields/exportcustomfields.php?mode=$mode", 'false,true,true', $strings['export']);
    }

    $block1->closePaletteScript($comptListFieldsDefinitions, $listFieldsDefinitions->fdf_id);
}

require_once("../includes/footer.php");
