<?php // $Revision: 1.11 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewcustomfield.php,v 1.11 2013/01/29 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$mode = AddSlashesNOD(isset($_GET['mode'])?$_GET['mode']:'');
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSite = isset($_GET['addToSite'])?$_GET['addToSite']:'';
$removeToSite = isset($_GET['removeToSite'])?$_GET['removeToSite']:'';
$tbldispnam = tableNameString($mode);

if (substr($mode,0,1)=='@') {
    $tbldispnam .= ' (' . lang_strings('form_template') . ')';
}

/**
 * Permission check
 */
if ($action == '') {
    if (!$SW_Permissions['Custom Fields']['Read'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} else {
    if (!$SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

list($tblnam, $fldnam) = preg_split('/\|/', $id);
$querymore = " WHERE fdf.tablename='$tblnam' AND fdf.fieldname='$fldnam'";
$fieldDefinitionDetail = new request();
$fieldDefinitionDetail->openFieldsDefinitions($querymore);
$comptFieldDefinitionDetail = count($fieldDefinitionDetail->fdf_tablename);

if ($comptFieldDefinitionDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$flddispnam = fieldNameString($tblnam, $fldnam);
$sys = $fieldDefinitionDetail->fdf_sysdef[0];
$idPublish = $fieldDefinitionDetail->fdf_published[0];

if ($sys == 'Y' && $action == 'publish') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Actions
 */
if ($action == 'publish') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($addToSite == 'true') {
            $tmpsql = "UPDATE " . $tablePrefix . "fields_def SET published='" . enumPublished::pbYes . "' WHERE tablename='$tblnam' AND fieldname='$fldnam'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $idPublish = enumPublished::pbYes;
            $msg = "addToSite";
        } else if ($removeToSite == 'true') {
            $tmpsql = "UPDATE " . $tablePrefix . "fields_def SET published='" . enumPublished::pbNo . "' WHERE tablename='$tblnam' AND fieldname='$fldnam'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $idPublish = enumPublished::pbNo;
            $msg = "removeToSite";
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
}

/**
 * Prepare data
 */
$tblnam = $fieldDefinitionDetail->fdf_tablename[0];
$fldnam = $fieldDefinitionDetail->fdf_fieldname[0];
$fldtyp = $fieldDefinitionDetail->fdf_fieldtype[0];
$len = ($fldtyp==enumFieldType::ftText || $fldtyp==enumFieldType::ftAlphaNumeric || $fldtyp==enumFieldType::ftNumeric || $fldtyp==enumFieldType::ftSerial)?$fieldDefinitionDetail->fdf_length[0]:'';
$req = $fieldDefinitionDetail->fdf_required[0];
$lkt = $fieldDefinitionDetail->fdf_linkedtable[0];
$uni = $fieldDefinitionDetail->fdf_unique_field[0];
$defval = $fieldDefinitionDetail->fdf_default_value[0];
$idx = $fieldDefinitionDetail->fdf_create_index[0];
$sys = $fieldDefinitionDetail->fdf_sysdef[0];
$querymore = " WHERE fvd.tablename='$tblnam' AND fvd.fieldname='$fldnam' ORDER BY fvd.fieldvalue";
$listFieldsValuesDefinitions = new request();
$listFieldsValuesDefinitions->openFieldsValuesDefinitions($querymore);
$comptListFieldsValuesDefinitions = count($listFieldsValuesDefinitions->fvd_tablename);

if ($lkt == '') {
    $lktdispnam = lang_strings('none');
} else {
    $lktdispnam = tableNameString($lkt);

    if (substr($lkt,0,1)=='@') {
        $lktdispnam .= ' (' . lang_strings('form_template') . ')';
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=custom", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/listformtemplates.php?", lang_strings('form_templates'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/viewformtemplate.php?id=$mode", $tbldispnam, 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../customfields/listcustomfields.php?mode=$mode", lang_strings('custom_fields'), 'in'));
$blockPage->itemBreadcrumbs($flddispnam);
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "cfV";
$block1->openForm("../customfields/viewcustomfield.php?mode=$mode&id=$id#" . $block1->form . "Anchor");
$block1->heading(lang_strings("custom_field") . ' : ' . $flddispnam);

if ($SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
    $block1->openPaletteIcon();

    if ($sys != 'Y') {
        $block1->paletteIcon(1, "remove", $strings["delete"]);

        if ($sitePublish == "true") {
            $block1->paletteIcon(3, "add_projectsite", $strings["add_customer_service_site"]);
            $block1->paletteIcon(4, "remove_projectsite", $strings["remove_customer_service_site"]);
        }
    }

    $block1->paletteIcon(6, "edit", $strings["edit"]);
    $block1->closePaletteIcon();
}

$block1->openContent();
$block1->contentTitle(lang_strings("info"));

if (substr($mode,0,1)=='@') {
    $block1->contentRow(lang_strings("table"), $blockPage->buildLink("../forms/viewformtemplate.php?id=" . $mode, $tbldispnam, 'in'));
} else {
    $block1->contentRow(lang_strings("table"), $tbldispnam);
}

$block1->contentRow(lang_strings("name"), $fldnam);
$block1->contentRow(lang_strings("description"), fieldNameString($tblnam, $fldnam));
$block1->contentTitle(lang_strings("details"));
$block1->contentRow(lang_strings("fieldtype"), $fieldTypeArray[strval($fldtyp)]);

if ($len != '') {
    $block1->contentRow(lang_strings("length"), $len);
}

$block1->contentRow(lang_strings("required"), (($req=='Y')?lang_strings('yes'):lang_strings('no')));

if ($fldtyp == enumFieldType::ftSerial) {
    $block1->contentRow(lang_strings("serial_format"), $serialFormat[$defval]);
} else {
    $block1->contentRow(lang_strings("defaultvalue"), $defval);
}

if ($comptListFieldsValuesDefinitions > 0) {
    $block1->contentRow(lang_strings("validvalues"), '');
    $vv = '<table><tr><th>' . lang_strings('value') . '</th><th>' . lang_strings('description') . '</th></tr>';

    for ($i=0; $i<$comptListFieldsValuesDefinitions; $i++) {
        $vv .= '<tr><td>' . $listFieldsValuesDefinitions->fvd_fieldvalue[$i] . '</td><td>' . $listFieldsValuesDefinitions->fvd_fieldvalue_desc[$i] . '</td></tr>';
    }

    $vv .= '</table>';
    $block1->contentRow('', $vv);
}

$block1->contentRow(lang_strings('linked_table'), $lktdispnam);
$block1->contentRow(lang_strings("uniquefield"), (($uni=='Y')?lang_strings('yes'):lang_strings('no')));
$block1->contentRow(lang_strings("createindex"), (($idx=='Y')?lang_strings('yes'):lang_strings('no')));
$block1->contentRow(lang_strings("system_defined"), (($sys=='Y')?lang_strings('yes'):lang_strings('no')));

if ($sitePublish == "true") {
    $block1->contentRow(lang_strings("published"), $statusPublish[$idPublish]);
}

$block1->closeContent();
$block1->closeForm();

if ($SW_Permissions['Custom Fields']['Edit'][$profilSession]) {
    $block1->openPaletteScript();

    if ($sys != 'Y') {
        $block1->paletteScript(1, "remove", "../customfields/deletecustomfields.php?mode=$mode&id=$tblnam|$fldnam", "true,true,true", $strings["delete"]);

        if ($sitePublish == "true") {
            $block1->paletteScript(3, "add_projectsite", "../customfields/viewcustomfield.php?mode=$mode&id=$tblnam|$fldnam&addToSite=true&action=publish", "true,true,true", $strings["add_customer_service_site"]);
            $block1->paletteScript(4, "remove_projectsite", "../customfields/viewcustomfield.php?mode=$mode&id=$tblnam|$fldnam&removeToSite=true&action=publish", "true,true,true", $strings["remove_customer_service_site"]);
        }
    }

    $block1->paletteScript(6, "edit", "../customfields/editcustomfield.php?mode=$mode&id=$tblnam|$fldnam", "true,true,true", $strings["edit"]);
    $block1->closePaletteScript('', '');
}

require_once("../includes/footer.php");
