<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editequipment.php,v 1.5 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
$bodyCommand = "onLoad=\"document.eqEForm.eid.focus();\"";

/**
 * Variables init
 */
$eid_highlight = false;
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));  // The timestamp of today
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$cpy = isset($_GET['cpy'])?$_GET['cpy']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$error = '';

if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'editequipment' && $_SESSION['SOURCE'] == '') {
    $eid = $_SESSION['PARAMS']['eid'];                  // equipment id
    $ec = $_SESSION['PARAMS']['ec'];                    // equipment category id
    $et = $_SESSION['PARAMS']['et'];                    // equipment type id
    $n = $_SESSION['PARAMS']['n'];                      // name
    $np = $_SESSION['PARAMS']['np'];                    // name print
    $ow = $_SESSION['PARAMS']['ow'];                    // owner id
    $loc = $_SESSION['PARAMS']['loc'];                  // location id
    $st = $_SESSION['PARAMS']['st'];                    // status
    $ma = $_SESSION['PARAMS']['ma'];                    // manufacturer
    $mo = $_SESSION['PARAMS']['mo'];                    // model
    $sn = $_SESSION['PARAMS']['sn'];                    // serial number
    $pd = $_SESSION['PARAMS']['pd'];                    // purchase date
    $wa = $_SESSION['PARAMS']['wa'];                    // warranty
    $cp = $_SESSION['PARAMS']['cp'];                    // cost price
    $cc = $_SESSION['PARAMS']['cc'];                    // cost currency
    $sp = $_SESSION['PARAMS']['sp'];                    // sell price
    $sc = $_SESSION['PARAMS']['sc'];                    // sell currency
    $l = $_SESSION['PARAMS']['l'];                      // locked
    $imgdel = $_SESSION['PARAMS']['imgdel'];            // delete photo
    $_SESSION['TARGET'] = '';
    $icp = 'true';
} else {
    $eid = isset($_POST['eid'])?$_POST['eid']:'';       // equipment id
    $ec = isset($_POST['ec'])?$_POST['ec']:'';          // equipment category id
    $et = isset($_POST['et'])?$_POST['et']:'';          // equipment type id
    $n = isset($_POST['n'])?$_POST['n']:'';             // name
    $np = isset($_POST['np'])?$_POST['np']:'';          // name print
    $ow = isset($_POST['ow'])?$_POST['ow']:'';          // owner id
    $loc = isset($_POST['loc'])?$_POST['loc']:'';       // location id
    $st = isset($_POST['st'])?$_POST['st']:'';          // status
    $ma = isset($_POST['ma'])?$_POST['ma']:'';          // manufacturer
    $mo = isset($_POST['mo'])?$_POST['mo']:'';          // model
    $sn = isset($_POST['sn'])?$_POST['sn']:'';          // serial number
    $pdI = isset($_POST['pdI'])?$_POST['pdI']:'';       // display field of purchase date
    $pd = ($pdI=='')?0:date2Timestamp($pdI);            // purchase date
    $wa = isset($_POST['wa'])?$_POST['wa']:'';          // warranty
    $cp = isset($_POST['cp'])?$_POST['cp']:'';          // cost price
    $cc = isset($_POST['cc'])?$_POST['cc']:$defaultCurrency;    // cost currency
    $sp = isset($_POST['sp'])?$_POST['sp']:'';          // sell price
    $sc = isset($_POST['sc'])?$_POST['sc']:'';          // sell currency
    $l = isset($_POST['l'])?$_POST['l']:'';             // locked
    $imgidx = isset($_POST['Idxphoto'])?$_POST['Idxphoto']:'';
    $imgtmp = isset($_POST['atttmp' . $imgidx])?$_POST['atttmp' . $imgidx]:'';
    $imgdel = isset($_POST['Delphoto'])?$_POST['Delphoto']:'';
    $icp = '';

    if ($imgdel == 'on' || $imgtmp == '') {
        $photo = '';
    } else {
        $photo = uploadImage('equipments', $id, 'photo', $imgtmp);
    }
}

$lk = DbValueEncode(enumFieldType::ftBoolean, $l);

/**
 * Permission check
 */
if ($enableEquipment != 'true') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($id != "") {
    if ($cpy != 'true') {
        if (!$SW_Permissions['Equipment']['Edit'][$profilSession]) {
            header("Location: ../general/permissiondenied.php");
            exit;
        }
    } else {
        if (!$SW_Permissions['Equipment']['Write'][$profilSession]) {
            header("Location: ../general/permissiondenied.php");
            exit;
        }
    }

    $querymore = " WHERE equ.id='$id'";
    $detailEquipment = new request();
    $detailEquipment->openEquipments($querymore);
    $comptDetailEquipment = count($detailEquipment->equ_id);

    if ($comptDetailEquipment == '0') {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Equipment']['Write'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
}

if ($action == 'new') {
    // store all user input values in session variables
    $params = array();
    $params['eid'] = $eid;
    $params['ec'] = $ec;
    $params['et'] = $et;
    $params['n'] = $n;
    $params['np'] = $np;
    $params['ow'] = $ow;
    $params['loc'] = $loc;
    $params['st'] = $st;
    $params['ma'] = $ma;
    $params['mo'] = $mo;
    $params['sn'] = $sn;
    $params['pd'] = $pd;
    $params['wa'] = $wa;
    $params['cp'] = $cp;
    $params['cc'] = $cc;
    $params['sp'] = $sp;
    $params['sc'] = $sc;
    $params['l'] = $l;
    $params['imgdel'] = $imgdel;
    $_SESSION['PARAMS'] = $params;
    $_SESSION['SOURCE'] = 'editequipment';
    $_SESSION['LOCATION'] = '../equipments/editequipment.php?id=' . $id;

    /**
     * Add New Equipment Category
     */
    if ($ec == '-1') {
        $_SESSION['TARGET'] = 'equipment_category';
        header("Location: ../equipments/equipment_category.php?mode=add");
        exit;
    }

    /**
     * Add New Equipment Type
     */
    if ($et == '-1') {
        $_SESSION['TARGET'] = 'equipment_type';
        header("Location: ../equipments/equipment_type.php?mode=add");
        exit;
    }

    /**
     * Add New Location
     */
    if ($loc == '-1') {
        $_SESSION['TARGET'] = 'locations';
        header("Location: ../administration/locations.php?mode=add");
        exit;
    }
}

/**
 * Check fields
 */
if ($action == 'add' || $action == 'update') {
    if ($error == '') {
        $error = checkCustomFields('equipments', $id);
    }
}

/**
 * Actions
 */
if ($error == '' && ($action == "add" || $action == "update")) {
    $cp = round($cp, $costAccuracy);
    $sp = round($sp, $costAccuracy);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == "update") {
        try {
            $requestAct->startTransaction();
            $cfsql = setupCustomFieldsUpdateSQL('equipments', $id);  // Generate custom fields update sql
            $tmpsql = "UPDATE " . $tablePrefix . "equipments SET equipment_id='$eid',equipment_category='$ec',equipment_type='$et',name='$n',owner='$ow',location='$loc',status='$st',manufacturer='$ma',model='$mo',serial_number='$sn',purchase_date='$pd',warranty='$wa',cost_currency='$cc',cost_price='$cp',sell_currency='$sc',sell_price='$sp',photo='$photo',locked='$lk',modified='" . time() . "',muser='$idSession'$cfsql WHERE id=$id";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'equipments', $id, 'U');
            updateString($requestAct, 'EQU__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../equipments/listequipments.php?msg=update" . $urlBornes);
            exit;
        }
    } else if ($action == "add") {
        try {
            $requestAct->startTransaction();
            $cfsqls = setupCustomFieldsInsertSQL('equipments');  // Generate custom fields insert sql
            $tmpsql = "INSERT INTO " . $tablePrefix . "equipments (equipment_id,equipment_category,equipment_type,name,owner,location,status,manufacturer,model,serial_number,purchase_date,warranty,cost_currency,cost_price,sell_currency,sell_price,photo,locked,created,cuser" . $cfsqls[0] . ") VALUES ('$eid','$ec','$et','$n','$ow','$loc','$st','$ma','$mo','$sn','$pd','$wa','$cc','$cp','$sc','$sp','$photo','$lk','" . time() . "','$idSession'" . $cfsqls[1] . ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('equipments');
            $cfsql = setupCustomMediaFieldsUpdateSQL('equipments', $num);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "equipments SET $cfsql WHERE id='$num'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            copy2HistoryTable($requestAct, 'equipments', $num, 'A');
            updateString($requestAct, 'EQU__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../equipments/listequipments.php?msg=add");
            exit;
        }
    }
}

/**
 * Form variables init
 */
if ($error == '' && $icp != 'true') {
    if ($id != '') {
        $eid = $detailEquipment->equ_equipment_id[0];       // equipment id
        $ec = $detailEquipment->equ_equipment_category[0];  // equipment category id
        $et = $detailEquipment->equ_equipment_type[0];      // equipment type id
        $n = $detailEquipment->equ_name[0];                 // name
        $np = $detailEquipment->equ_name_print[0];          // name print
        $ow = $detailEquipment->equ_owner[0];               // owner id
        $loc = $detailEquipment->equ_location[0];           // location id
        $st = $detailEquipment->equ_status[0];              // status
        $ma = $detailEquipment->equ_manufacturer[0];        // manufacturer
        $mo = $detailEquipment->equ_model[0];               // model
        $sn = $detailEquipment->equ_serial_number[0];       // serial number
        $pd = $detailEquipment->equ_purchase_date[0];       // purchase date
        $wa = $detailEquipment->equ_warranty[0];            // warranty
        $cp = $detailEquipment->equ_cost_price[0];          // cost price
        $cc = $detailEquipment->equ_cost_currency[0];       // cost currency
        $sp = $detailEquipment->equ_sell_price[0];          // sell price
        $sc = $detailEquipment->equ_sell_currency[0];       // sell currency
        $pho = ($cpy=='true')?'':$detailEquipment->equ_photo[0];    // photo
        $lk = $detailEquipment->equ_locked[0];              // locked
    } else {
        $ec = '';
        $et = '';
        $ow = $idSession;                                   // owner id
        $loc = '0';                                         // location id
        $st = enumEquipmentStatus::stAvailable;                                // status
        $pd = $dateToday;                                   // purchase date
        $cp = '0';                                          // cost price
        $cc = $defaultCurrency;                             // cost currency
        $sp = '0';                                          // sell price
        $sc = $defaultCurrency;                             // sell currency
        $lk = enumBoolean::bFalse;                                      // locked
        $pho = '';
    }
}
/**
 * get equipment category valid values
 */
$querymore1 = " WHERE eqc.locked='" . enumBoolean::bFalse . "'";

if ($ec != '') {
    $querymore1 .= " OR eqc.id='$ec'";
}

$querymore1 .= " ORDER BY eqc.name";
$listEquipmentCategory = new request();
$listEquipmentCategory->openEquipmentCategory($querymore1);
$comptListEquipmentCategory = count($listEquipmentCategory->eqc_id);
$ecVV = array();
$ecVV['0'] = '';

for ($i=0; $i<$comptListEquipmentCategory; $i++) {
    $ecVV[$listEquipmentCategory->eqc_id[$i]] = $listEquipmentCategory->eqc_name_print[$i];
}

$ecVV['-1'] = $strings['add_new_equipment_category'];
/**
 * get equipment type valid values
 */
$querymore2 = " WHERE eqt.locked='" . enumBoolean::bFalse . "'";

if ($et != '') {
    $querymore2 .= " OR eqt.id='$et'";
}

$querymore2 .= " ORDER BY eqt.name";
$listEquipmentType = new request();
$listEquipmentType->openEquipmentType($querymore2);
$comptListEquipmentType = count($listEquipmentType->eqt_id);
$etVV = array();
$etVV['0'] = '';

for ($i=0; $i<$comptListEquipmentType; $i++) {
    $etVV[$listEquipmentType->eqt_id[$i]] = $listEquipmentType->eqt_name_print[$i];
}

$etVV['-1'] = $strings['add_new_equipment_type'];
/**
 * get owner valid values
 */
$querymore3 = " WHERE mem.organization='1' AND mem.active='" . enumBoolean::bTrue . "' ORDER BY mem.name";
$listOwners = new request();
$listOwners->openMembers($querymore3);
$comptListOwners = count($listOwners->mem_id);
$owVV = array();

for ($i=0; $i<$comptListOwners; $i++) {
    $owVV[$listOwners->mem_id[$i]] = $listOwners->mem_name[$i];
}
/**
 * get location valid values
 */
$querymore4 = " WHERE loc.locked='" . enumBoolean::bFalse . "' OR loc.id='$loc' ORDER BY loc.name";
$listLocations = new request();
$listLocations->openLocations($querymore4);
$comptListLocations = count($listLocations->loc_id);
$locVV = array();
$locVV['0'] = '';

for ($i=0; $i<$comptListLocations; $i++) {
    $locVV[$listLocations->loc_id[$i]] = $listLocations->loc_name_print[$i];
}

$locVV['-1'] = $strings['add_new_location'];
/**
 * get currency valid values
 */
$currHelp = '<table>';
$currVV = array();

foreach ($CurrencyMatrix['active'] as $currCode) {
    $currHelp .= '<tr><th>' . $currCode . '</th><td>' . $CurrencyMatrix['name'][$currCode] . '</td></tr>';
    $currVV[$currCode] = $currCode;
}

$currHelp .= '</table>';
/**
 * get equipment status valid values
 */
$stVV = array();
$stVV[enumEquipmentStatus::stAvailable] = $equipmentStatusNames[enumEquipmentStatus::stAvailable];
$stVV[enumEquipmentStatus::stBroken] = $equipmentStatusNames[enumEquipmentStatus::stBroken];
$stVV[enumEquipmentStatus::stSold] = $equipmentStatusNames[enumEquipmentStatus::stSold];

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=utility", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../equipments/listequipments.php?" . $urlBornes, lang_strings("equipment_management"), 'in'));

if ($id == "" || $cpy == 'true') {
    $blockPage->itemBreadcrumbs(lang_strings("add_equipment"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../equipments/viewequipment.php?id=$id" . $urlBornes, $detailEquipment->equ_equipment_id[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_equipment"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "eqE";

if ($id == "" || $cpy == 'true') {
    $block1->openForm("../equipments/editequipment.php?#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_equipment"));
} else {
    $block1->openForm("../equipments/editequipment.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="update">';
    $block1->heading(lang_strings("edit_equipment") . " : " . $detailEquipment->equ_equipment_id[0]);
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));
setupInputHTML($block1, lang_strings("equipment_id"), 'eid', enumFieldType::ftAlphaNumeric, 'Y', '155', $eid, '', '', $eid_highlight);
setupInputHTML($block1, lang_strings("equipment_category"), 'ec', enumFieldType::ftNumeric, 'N', '8', $ec, $ecVV, '', false, '', 'onchange="categoryChanged()"');
setupInputHTML($block1, lang_strings("equipment_type"), 'et', enumFieldType::ftNumeric, 'N', '8', $et, $etVV, '', false, '', 'onchange="typeChanged()"');
setupInputHTML($block1, lang_strings("name"), 'n', enumFieldType::ftAlphaNumeric, 'Y', '155', $n, '', '', false, '', 'onblur="nameChanged()"');
setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np, '', '', false, '', 'onblur="nameChanged()"');
setupInputHTML($block1, lang_strings('owner'), 'ow', enumFieldType::ftNumeric, 'Y', '8', $ow, $owVV);
setupInputHTML($block1, lang_strings('location'), 'loc', enumFieldType::ftNumeric, 'N', '8', $loc, $locVV, '', false, '', 'onchange="locationChanged()"');
setupInputHTML($block1, lang_strings('status'), 'st', enumFieldType::ftAlphaNumeric, 'Y', '1', $st, $stVV);
setupInputHTML($block1, lang_strings('manufacturer'), 'ma', enumFieldType::ftText, 'N', '255', $ma);
setupInputHTML($block1, lang_strings('model'), 'mo', enumFieldType::ftText, 'N', '255', $mo);
setupInputHTML($block1, lang_strings('serial_number'), 'sn', enumFieldType::ftAlphaNumeric, 'N', '155', $sn);
setupInputHTML($block1, lang_strings('purchase_date'), 'pdI', enumFieldType::ftDate, 'N', '0', $pd);
setupInputHTML($block1, lang_strings('warranty'), 'wa', enumFieldType::ftText, 'N', '255', $wa);
setupInputHTML($block1, lang_strings('cost_currency') . ' ' . $blockPage->printHelp($currHelp, true), 'cc', enumFieldType::ftAlphaNumeric, 'Y', '3', $cc, $currVV);
setupInputHTML($block1, lang_strings('cost_price'), 'cp', enumFieldType::ftTotals, 'N', '', $cp);
setupInputHTML($block1, lang_strings('sell_currency') . ' ' . $blockPage->printHelp($currHelp, true), 'sc', enumFieldType::ftAlphaNumeric, 'Y', '3', $sc, $currVV);
setupInputHTML($block1, lang_strings('sell_price'), 'sp', enumFieldType::ftTotals, 'N', '', $sp);
setupInputHTML($block1, lang_strings('photo'), 'photo', enumFieldType::ftImage, 'N', '', $pho);

if ($id != '' && $cpy != 'true') {
    setupInputHTML($block1, lang_strings('locked'), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
}

setupCustomFieldsInputHTML($block1, 'equipments', $id);
$block1->contentRow('', '<input type="submit" name="Save" value="' . $strings["save"] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
    function categoryChanged() {
        var x = document.getElementById('ec').selectedIndex;
        var y = document.getElementById('ec').options[x].value;

        if (y === '-1') {
            document.eqEForm.action.value = 'new';
            document.eqEForm.submit();
        }
    }

    function typeChanged() {
        var x = document.getElementById('et').selectedIndex;
        var y = document.getElementById('et').options[x].value;

        if (y === '-1') {
            document.eqEForm.action.value = 'new';
            document.eqEForm.submit();
        }
    }

    function locationChanged() {
        var x = document.getElementById('loc').selectedIndex;
        var y = document.getElementById('loc').options[x].value;

        if (y === '-1') {
            document.eqEForm.action.value = 'new';
            document.eqEForm.submit();
        }
    }

    function nameChanged() {
        var np = document.getElementById('np').value;

        if (np === '') {
            var n = document.getElementById('n').value;
            document.getElementById('np').value = n;
        }
    }
</script>
<?php
require_once("../includes/footer.php");
