<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: equipment_category.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'list';
$n = AddSlashesNOD(isset($_POST['n'])?$_POST['n']:'');      // name
$np = isset($_POST['np'])?$_POST['np']:'';                  // name print
$l = isset($_POST['l'])?$_POST['l']:'';                     // locked
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$lk = DbValueEncode(enumFieldType::ftBoolean, $l);
$n_highlight = false;
$error = '';

/**
 * Permission check
 */
if ($enableEquipment != 'true') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($mode == 'list') {
    if (!$SW_Permissions['Equipment']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Equipment']['Edit'][$profilSession]) {
        header("Location: ../equipments/equipment_category.php?mode=list&msg=permissiondenied");
        exit;
    }
}

if ($id != '') {
    if ($mode == 'delete') {
        $tmpquery = "SELECT * FROM " . $tablePrefix . "equipments WHERE equipment_category IN ($ids)";

        if (compt($tmpquery) > 0) {
            header("Location: ../equipments/equipment_category.php?mode=list&msg=permissiondenied");
            exit;
        }

        $querymore = " WHERE eqc.id IN ($ids)";
        $listEquipmentCategory = new request();
        $listEquipmentCategory->openEquipmentCategory($querymore);
        $comptListEquipmentCategory = count($listEquipmentCategory->eqc_id);

        if ($comptListEquipmentCategory == '0') {
            header("Location: ../equipments/equipment_category.php?mode=list&msg=permissiondenied");
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE eqc.id='$id'";
        $equipmentCategoryDetail = new request();
        $equipmentCategoryDetail->openEquipmentCategory($querymore);
        $comptEquipmentCategory = count($equipmentCategoryDetail->eqc_id);

        if ($comptEquipmentCategory == '0') {
            header("Location: ../equipments/equipment_category.php?mode=list&msg=permissiondenied");
            exit;
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add') {
    $querymore = " WHERE eqc.name='$n'";
    $equipmentCategoryTest = new request();
    $equipmentCategoryTest->openEquipmentCategory($querymore);

    if (count($equipmentCategoryTest->eqc_id) > 0) {
        $error = lang_strings("equipment_category_already_exists");
        $bodyCommand = "onLoad=\"document.eqcForm.n.focus();\"";
        $n_highlight = true;
    }
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "equipment_category (name,locked,created,cuser) VALUES ('$n','$lk','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('equipment_category');
            copy2HistoryTable($requestAct, 'equipment_category', $num, 'A');
            updateString($requestAct, 'EQC__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'equipment_category') {
                $_SESSION['PARAMS']['ec'] = $num;
                $_SESSION['TARGET'] = $_SESSION['SOURCE'];
                $_SESSION['SOURCE'] = '';
                header("Location: " . $_SESSION['LOCATION']);
            } else {
                header("Location: ../equipments/equipment_category.php?mode=list&msg=add");
            }

            exit;
        }
    } else if ($action == 'edit') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "equipment_category SET locked='$lk',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'equipment_category', $id, 'U');
            updateString($requestAct, 'EQC__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../equipments/equipment_category.php?mode=list&msg=update");
            exit;
        }
    } else if ($action == 'delete') {
        try {
            $requestAct->startTransaction();
            copy2HistoryTable($requestAct, 'equipment_category', $ids, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "equipment_category WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../equipments/equipment_category.php?mode=list&msg=delete");
            exit;
        }
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=utility", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../equipments/listequipments.php?", lang_strings("equipment_management"), 'in'));

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings("equipment_category"));
} else if ($mode == 'add') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../equipments/equipment_category.php?", lang_strings("equipment_category"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_equipment_category"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../equipments/equipment_category.php?", lang_strings("equipment_category"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_equipment_category"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../equipments/equipment_category.php?", lang_strings("equipment_category"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_equipment_categories"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = "eqc";
$block1->openForm("../equipments/equipment_category.php?id=$id&mode=$mode#" . $block1->form . "Anchor");

if ($mode == 'list') {
    logURL($strings['equipment_category'], "../equipments/equipment_category.php?id=$id&mode=$mode");
    $block1->heading(lang_strings("equipment_category"));

    if ($SW_Permissions['Equipment']['Edit'][$profilSession]) {
        $block1->openPaletteIcon();
        $block1->paletteIcon(0, 'add', $strings['add']);
        $block1->paletteIcon(1, 'remove', $strings['delete']);
        $block1->paletteIcon(3, 'edit', $strings['edit']);
        $block1->closePaletteIcon();
    }

    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '20';
    $block1->sorting('equipment_category', (isset($sortingUser['equipment_category'])?$sortingUser['equipment_category']:''), 'eqc.name ASC', $sortingFields = array(0 => 'eqc.name', 1 => 'none', 2 => 'eqc.locked'));
    $querymore = " ORDER BY $block1->sortingValue";
    $block1->recordsTotal = compt($initrequest['equipment_category'] . ' ' . $querymore);
    $listEquipmentCategory = new request();
    $listEquipmentCategory->openEquipmentCategory($querymore, $block1->borne, $block1->rowsLimit);
    $comptListEquipmentCategory = count($listEquipmentCategory->eqc_id);

    if ($comptListEquipmentCategory > 0) {
        $labels = array(lang_strings('name'), lang_strings('name_print'), lang_strings('locked'));
        $block1->openResults();
        $block1->labels($labels, 'false');

        for ($i=0; $i<$comptListEquipmentCategory; $i++) {
            $block1->openRow($listEquipmentCategory->eqc_id[$i]);
            $block1->cellRow($listEquipmentCategory->eqc_name[$i]);
            $block1->cellRow($listEquipmentCategory->eqc_name_print[$i]);
            $block1->cellRow(DbValueDecode(enumFieldType::ftBoolean, $listEquipmentCategory->eqc_locked[$i]));
            $block1->closeRow();
        }

        $block1->closeResults();
        $block1->bornesFooter("1", $blockPage->bornesNumber, "id=$id&mode=$mode");
    } else {
        $block1->noresults();
    }

    $block1->closeFormResults();

    if ($SW_Permissions['Equipment']['Edit'][$profilSession]) {
        $block1->openPaletteScript();
        $block1->paletteScript(0, 'add', '../equipments/equipment_category.php?mode=add', 'true,false,false', $strings['add']);
        $block1->paletteScript(1, 'remove', '../equipments/equipment_category.php?mode=delete', 'false,true,true', $strings['delete']);
        $block1->paletteScript(3, 'edit', '../equipments/equipment_category.php?mode=edit', 'false,true,false', $strings['edit']);
        $block1->closePaletteScript($comptListEquipmentCategory, $listEquipmentCategory->eqc_id);
    }
} else if ($mode == 'add') {
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_equipment_category"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name"), 'n', enumFieldType::ftAlphaNumeric, 'Y', '155', $n, '', '', $n_highlight, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np, '', '', false, '', 'onblur="nameChanged()"');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    if ($error == '') {
        $n = $equipmentCategoryDetail->eqc_name[0];
        $np = $equipmentCategoryDetail->eqc_name_print[0];
        $lk = $equipmentCategoryDetail->eqc_locked[0];
    }

    echo '<input type="hidden" name="action" value="edit">';
    echo '<input type="hidden" name="n" value="' . $n . '">';
    $block1->heading(lang_strings("edit_equipment_category") . " : " . $equipmentCategoryDetail->eqc_name[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np);
    setupInputHTML($block1, lang_strings('locked'), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_equipment_categories"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListEquipmentCategory; $i++) {
        $block1->contentRow('#' . $listEquipmentCategory->eqc_id[$i], $listEquipmentCategory->eqc_name[$i] . ' (' . $listEquipmentCategory->eqc_name_print[$i] . ')');
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

?>
<script type="text/javascript">
    function nameChanged() {
        var np = document.getElementById('np').value;

        if (np === '') {
            var n = document.getElementById('n').value;
            document.getElementById('np').value = n;
        }
    }
</script>
<?php
require_once("../includes/footer.php");
