<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listequipments.php,v 1.3 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if ($enableEquipment != 'true' || !$SW_Permissions['Equipment']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=utility", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("equipment_management"));
$blockPage->closeBreadcrumbs();
logURL($strings['equipment_management'], "../equipments/listequipments.php");
$block1 = new block();
$block1->form = "eqL";
$block1->openForm("../equipments/listequipments.php?" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("equipment_management"));
$blockPage->bornesNumber = '1';
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '12';
$block1->sorting('equipments', (isset($sortingUser['equipments'])?$sortingUser['equipments']:''), "equ.equipment_id ASC", $sortingFields = array(0 => 'equ.equipment_id', 1 => 'eqc.name', 2 => 'eqt.name', 3 => 'equ.name', 4 => 'none', 5 => 'equ.locked'));
$querymore = " ORDER BY " . $block1->sortingValue;
$block1->recordsTotal = compt($initrequest['equipments'] . ' ' . $querymore);
$listEquipments = new request();
$listEquipments->openEquipments($querymore, $block1->borne, $block1->rowsLimit);
$comptListEquipments = count($listEquipments->equ_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['equipment_id'];
$columns[0]->field_type = enumFieldType::ftAlphaNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['equipment_category'];
$columns[1]->field_type = enumFieldType::ftNumeric;
$columns[1]->linked_table = 'equipment_category';
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['equipment_type'];
$columns[2]->field_type = enumFieldType::ftNumeric;
$columns[2]->linked_table = 'equipment_type';
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['name'];
$columns[3]->field_type = enumFieldType::ftAlphaNumeric;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['name_print'];
$columns[4]->field_type = enumFieldType::ftText;
$columns[5] = new cardviewColumn();
$columns[5]->title = $strings['locked'];
$columns[5]->field_type = enumFieldType::ftBoolean;
$opt[enumCardviewOption::oObject] = 'equipments';
$opt[enumCardviewOption::oTableName] = 'equipments';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;
$opt[enumCardviewOption::oExtraParameters] = 'borne1=' . $block1->borne;

if ($SW_Permissions['Equipment']['Write'][$profilSession]) {
    $opt[enumCardviewOption::oAddUrl] = '../equipments/editequipment.php?';
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListEquipments; $i++) {
    $content = array(
        $listEquipments->equ_equipment_id[$i],
        $listEquipments->equ_equipment_category[$i],
        $listEquipments->equ_equipment_type[$i],
        $listEquipments->equ_name[$i],
        $listEquipments->equ_name_print[$i],
        $listEquipments->equ_locked[$i]
    );
    $block1->itemCardView($listEquipments->equ_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter("1", $blockPage->bornesNumber);
$block1->closeFormResults();
require_once("../includes/footer.php");
