<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewequipment.php,v 1.4 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');

/**
 * Permission check
 */
if ($enableEquipment != 'true' || !$SW_Permissions['Equipment']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore = " WHERE equ.id='$id'";
$detailEquipment = new request();
$detailEquipment->openEquipments($querymore);
$comptDetailEquipment = count($detailEquipment->equ_id);

if ($comptDetailEquipment == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=utility", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../equipments/listequipments.php?" . $urlBornes, lang_strings("equipment_management"), 'in'));
$blockPage->itemBreadcrumbs($detailEquipment->equ_equipment_id[0]);
$blockPage->closeBreadcrumbs();
$title = $strings['equipment'] . ' : ' . $detailEquipment->equ_equipment_id[0];
logURL($title, "../equipments/viewequipment.php?id=$id");
$block1 = new block();
$block1->form = "eqV";
$block1->openForm("../equipments/viewequipment.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("equipment"));
$block1->openPaletteIcon();

if ($SW_Permissions['Equipment']['Write'][$profilSession]) {
    $block1->paletteIcon(2, 'copy', $strings['copy']);
}

if ($SW_Permissions['Equipment']['Admin'][$profilSession]) {
    $block1->paletteIcon(0, "remove", $strings["delete"]);
}

if ($SW_Permissions['Equipment']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, "edit", $strings["edit"]);
}

$block1->paletteIcon(99, 'search', 'equipments');
$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow(lang_strings("equipment_id"), $detailEquipment->equ_equipment_id[0]);
$block1->contentRow(lang_strings("equipment_category"), $detailEquipment->equ_eqc_name_print[0]);
$block1->contentRow(lang_strings("equipment_type"), $detailEquipment->equ_eqt_name_print[0]);
$block1->contentRow(lang_strings("name"), $detailEquipment->equ_name[0]);
$block1->contentRow(lang_strings("name_print"), $detailEquipment->equ_name_print[0]);
$block1->contentRow(lang_strings("owner"), $blockPage->buildLink($detailEquipment->equ_owner[0], '', 'message'));
$block1->contentRow(lang_strings("location"), $detailEquipment->equ_loc_name_print[0]);
$st = equipmentStatus($id);
$block1->contentRow(lang_strings("status"), $equipmentStatusNames[$st]);
$block1->contentRow(lang_strings("manufacturer"), $detailEquipment->equ_manufacturer[0]);
$block1->contentRow(lang_strings("model"), $detailEquipment->equ_model[0]);
$block1->contentRow(lang_strings("serial_number"), $detailEquipment->equ_serial_number[0]);
$block1->contentRow(lang_strings("purchase_date"), createDate($detailEquipment->equ_purchase_date[0], 'date', false, true));
$block1->contentRow(lang_strings("warranty"), $detailEquipment->equ_warranty[0]);

if ($currencyOnRight == 'true') {
    $block1->contentRow(lang_strings("cost_price"), NumberFormatNOD($detailEquipment->equ_cost_price[0], $costAccuracy, false) . " " . $detailEquipment->equ_cost_currency[0]);
} else {
    $block1->contentRow(lang_strings("cost_price"), $detailEquipment->equ_cost_currency[0] . " " . NumberFormatNOD($detailEquipment->equ_cost_price[0], $costAccuracy, false));
}

if ($st == enumEquipmentStatus::stSold) {
    if ($currencyOnRight == 'true') {
        $block1->contentRow(lang_strings("sell_price"), NumberFormatNOD($detailEquipment->equ_sell_price[0], $costAccuracy, false) . " " . $detailEquipment->equ_sell_currency[0]);
    } else {
        $block1->contentRow(lang_strings("sell_price"), $detailEquipment->equ_sell_currency[0] . " " . NumberFormatNOD($detailEquipment->equ_sell_price[0], $costAccuracy, false));
    }
}

if ($detailEquipment->equ_photo[0] != '') {
    $block1->contentRow(lang_strings('photo'), setupImageHTML($detailEquipment->equ_photo[0]));
}

$block1->contentRow(lang_strings('locked'), DbValueDecode(enumFieldType::ftBoolean, $detailEquipment->equ_locked[0]));
setupCustomFieldsHTML($block1, 'equipments', $id);
$block1->closeContent();
$block1->closeForm();
$block1->openPaletteScript();

if ($SW_Permissions['Equipment']['Write'][$profilSession]) {
    $block1->paletteScript(2, "copy", "../equipments/editequipment.php?id=$id&cpy=true", "true,true,true", $strings["copy"]);
}

if ($SW_Permissions['Equipment']['Admin'][$profilSession]) {
    $block1->paletteScript(0, "remove", "../equipments/deleteequipments.php?id=$id" . $urlBornes, "true,true,true", $strings["delete"]);
}

if ($SW_Permissions['Equipment']['Edit'][$profilSession]) {
    $block1->paletteScript(1, "edit", "../equipments/editequipment.php?id=$id" . $urlBornes, "true,true,true", $strings["edit"]);
}

$block1->paletteScript(99, 'search', 'equipments');
$block1->closePaletteScript("", "");
require_once("../includes/footer.php");
