<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: claim_type.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'list';
$n = AddSlashesNOD(isset($_POST['n'])?$_POST['n']:'');
$np = isset($_POST['np'])?$_POST['np']:'';
$l = isset($_POST['l'])?$_POST['l']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$lk = DbValueEncode(enumFieldType::ftBoolean, $l);
$error = '';
$n_highlight = false;

/**
 * Permission check
 */
if ($mode == 'list') {
    if (!$SW_Permissions['Accounting']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Accounting']['Edit'][$profilSession]) {
        header("Location: ../expenses/claim_type.php?mode=list&msg=permissiondenied" . $urlBornes);
        exit;
    }
}

if ($id != '') {
    if ($mode == 'delete') {
        $tmpquery = "SELECT id FROM " . $tablePrefix . "expenses WHERE claimtype IN ($ids) UNION ALL SELECT id FROM " . $tablePrefix . "expense_type WHERE claimtype IN ($ids)";

        if (compt($tmpquery) > 0) {
            header("Location: ../expenses/claim_type.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }

        $querymore = " WHERE clt.id IN ($ids)";
        $listClaimType = new request();
        $listClaimType->openClaimType($querymore);
        $comptListClaimType = count($listClaimType->clt_id);

        if ($comptListClaimType == '0') {
            header("Location: ../expenses/claim_type.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE clt.id='$id'";
        $claimTypeDetail = new request();
        $claimTypeDetail->openClaimType($querymore);
        $comptClaimTypeDetail = count($claimTypeDetail->clt_id);

        if ($comptClaimTypeDetail == '0') {
            header("Location: ../expenses/claim_type.php?mode=list&msg=permissiondenied" . $urlBornes);
            exit;
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add') {
    $querymore = " WHERE clt.name='$n'";
    $claimTypeTest = new request();
    $claimTypeTest->openClaimType($querymore);

    if (count($claimTypeTest->clt_id) > 0) {
        $error = lang_strings("claim_type_already_exists");
        $bodyCommand = "onLoad=\"document.cltForm.n.focus();\"";
        $n_highlight = true;
    }
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "claim_type (name,locked,created,cuser) VALUES ('$n','$lk','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('claim_type');
            copy2HistoryTable($requestAct, 'claim_type', $num, 'A');
            updateString($requestAct, 'CLT__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'claim_type') {
                $_SESSION['PARAMS']['ct'] = $num;
                $_SESSION['TARGET'] = $_SESSION['SOURCE'];
                $_SESSION['SOURCE'] = '';
                header("Location: " . $_SESSION['LOCATION']);
            } else {
                header("Location: ../expenses/claim_type.php?mode=list&msg=add" . $urlBornes);
            }

            exit;
        }
    } else if ($action == 'edit') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "claim_type SET locked='$lk',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'claim_type', $id, 'U');
            updateString($requestAct, 'CLT__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../expenses/claim_type.php?mode=list&msg=update" . $urlBornes);
            exit;
        }
    } else if ($action == 'delete') {
        try {
            $requestAct->startTransaction();
            copy2HistoryTable($requestAct, 'claim_type', $ids, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "claim_type WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../expenses/claim_type.php?mode=list&msg=delete" . $urlBornes);
            exit;
        }
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=accounting", lang_strings("administration"), 'in'));

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings("claim_type"));
} else if ($mode == 'add') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/claim_type.php?" . $urlBornes, lang_strings("claim_type"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_claim_type"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/claim_type.php?" . $urlBornes, lang_strings("claim_type"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_claim_type"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/claim_type.php?" . $urlBornes, lang_strings("claim_type"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_claim_types"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '4';     // 1st for listprojects, 2nd for viewprojectaccounting, and 3rd for listexpenses
$block1 = new block();
$block1->form = "clt";
$block1->openForm("../expenses/claim_type.php?id=$id&mode=$mode" . $urlBornes . "#" . $block1->form . "Anchor");

if ($mode == 'list') {
    logURL($strings['claim_type'], "../expenses/claim_type.php?id=$id&mode=$mode");
    $block1->heading(lang_strings("claim_type"));
    $block1->borne = $blockPage->returnBorne('4');
    $block1->rowsLimit = '12';
    $block1->sorting('claim_type', (isset($sortingUser['claim_type'])?$sortingUser['claim_type']:''), 'clt.name ASC', $sortingFields = array(0 => 'clt.name', 1 => 'none', 2 => 'clt.locked'));
    $querymore = " ORDER BY " . $block1->sortingValue;
    $block1->recordsTotal = compt($initrequest['claim_type'] . ' ' . $querymore);
    $listClaimType = new request();
    $listClaimType->openClaimType($querymore, $block1->borne, $block1->rowsLimit);
    $comptListClaimType = count($listClaimType->clt_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftAlphaNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name_print'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['locked'];
    $columns[2]->field_type = enumFieldType::ftBoolean;
    $opt[enumCardviewOption::oObject] = 'claim_type';
    $opt[enumCardviewOption::oTableName] = 'claim_type';
    $opt[enumCardviewOption::oColumns] = $columns;

    if ($SW_Permissions['Accounting']['Edit'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../expenses/claim_type.php?mode=add' . $urlBornes;
    }

    $block1->openCardView($opt);

    for ($i=0; $i<$comptListClaimType; $i++) {
        $content = array(
            $listClaimType->clt_name[$i],
            $listClaimType->clt_name_print[$i],
            $listClaimType->clt_locked[$i]
        );
        $block1->itemCardView($listClaimType->clt_id[$i], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter("4", $blockPage->bornesNumber, "id=$id&mode=$mode" . $urlBornes);
    $block1->closeFormResults();
} else if ($mode == 'add') {
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_claim_type"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name"), 'n', enumFieldType::ftAlphaNumeric, 'Y', '155', $n, '', '', $n_highlight, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np, '', '', false, '', 'onblur="nameChanged()"');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    if ($error == '') {
        $n = $claimTypeDetail->clt_name[0];
        $np = $claimTypeDetail->clt_name_print[0];
        $lk = $claimTypeDetail->clt_locked[0];
    }

    echo '<input type="hidden" name="action" value="edit">';
    echo '<input type="hidden" name="n" value="' . $n . '">';
    $block1->heading(lang_strings("edit_claim_type") . " : " . $claimTypeDetail->clt_name[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np);
    setupInputHTML($block1, lang_strings("locked"), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_claim_types"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListClaimType; $i++) {
        $block1->contentRow('#' . $listClaimType->clt_id[$i], $listClaimType->clt_name[$i] . ' (' . $listClaimType->clt_name_print[$i] . ')');
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

?>
<script type="text/javascript">
    function nameChanged() {
        var np = document.getElementById('np').value;

        if (np === '') {
            var n = document.getElementById('n').value;
            document.getElementById('np').value = n;
        }
    }
</script>
<?php
require_once("../includes/footer.php");
