<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteexpenses.php,v 1.16 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$ids = str_replace('**', ',', $id);
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if ($project == '0') {
    if (!$SW_Permissions['Expense']['Admin'][$profilSession]) {
        header('Location: ../expenses/listexpenses.php?msg=permissiondenied' . $urlBornes);
        exit;
    }
} else {
    $querymore1 = " WHERE pro.id='$project'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore1);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../projects/viewprojectaccounting.php?id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }

    $querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore2);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore3);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($permissionDetail->prp_delete_expense[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewprojectaccounting.php?id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }
}

$querymore4 = " WHERE exp.id IN ($ids) AND exp.project='$project'";
$listExpenses = new request();
$listExpenses->openExpenses($querymore4);
$comptListExpenses = count($listExpenses->exp_id);

if ($comptListExpenses != count(explode("**", $id))) {
    header('Location: ../expenses/listexpenses.php?project=' . $project . '&msg=permissiondenied' . $urlBornes);
    exit;
}

for ($i=0; $i<$comptListExpenses; $i++) {
    if ($listExpenses->exp_owner[$i] != $idSession) {
        header('Location: ../expenses/listexpenses.php?project=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }

    if (periodLocked($listExpenses->exp_docdate[$i])) {     // check if period locked
        header('Location: ../expenses/listexpenses.php?project=' . $project . '&msg=periodLocked' . $urlBornes);
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'expenses', $ids, 'D');
        $tmpsql = 'DELETE FROM ' . $tablePrefix . "expenses WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "UPDATE " . $tablePrefix . "documents_approval SET canceled='Y',modified='" . time() . "' WHERE docid IN ($ids) AND doctype='expenses'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtExpense . "' AND fil.doc_id IN ($ids)";
        deleteAttachFiles($requestAct, $querymore);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../expenses/listexpenses.php?project=' . $project . '&msg=delete' . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '0') {
    $blockPage->itemBreadcrumbs(lang_strings("accounting"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $project . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewprojectaccounting.php?id=" . $project . $urlBornes, lang_strings('project_accounting'), 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $project . $urlBornes, lang_strings("expenses"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('delete_expenses'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'dEx';
$block1->openForm("../expenses/deleteexpenses.php?project=$project&id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings('delete_expenses'));
$block1->openContent();
$block1->contentTitle(lang_strings('delete_following'));

for ($i=0; $i<$comptListExpenses; $i++) {
    $block1->contentRow('#' . $listExpenses->exp_id[$i], $listExpenses->exp_ext_name_print[$i] . " " . CurrencyFormatNOD($listExpenses->exp_amount[$i], $listExpenses->exp_currency[$i], $costAccuracy));
}

$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
require_once('../includes/footer.php');
