<?php // $Revision: 1.32 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editexpense.php,v 1.32 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.eExForm.de.focus();"';
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');        // The unique id of expense
$recurring = AddSlashesNOD(isset($_GET['recurring'])?$_GET['recurring']:'');    // recurring expense mode
$cpy = isset($_GET['cpy'])?$_GET['cpy']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$dd_highlight = false;
$error = '';
$upload_dir = '1';

if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'editexpense' && $_SESSION['SOURCE'] == '') {
    $project = $_SESSION['PARAMS']['project'];          // The project of expense
    $dd = $_SESSION['PARAMS']['dd'];                    // The timestamp of expense date
    $de = $_SESSION['PARAMS']['de'];                    // The description of expense
    $ct = $_SESSION['PARAMS']['ct'];                    // The claim type of expense
    $et = $_SESSION['PARAMS']['et'];                    // The expense type of expense
    $bi = $_SESSION['PARAMS']['bi'];                    // bill to client?
    $am = $_SESSION['PARAMS']['am'];                    // The amount of expense
    $cu = $_SESSION['PARAMS']['cu'];                    // The currency of expense
    $rsd = $_SESSION['PARAMS']['rsd'];                  // recurring start date
    $rfd = $_SESSION['PARAMS']['rfd'];                  // recurring finish date
    $rty = $_SESSION['PARAMS']['rty'];                  // recurring type
    $rfq = $_SESSION['PARAMS']['rfq'];                  // recurring frequency
    $re = $_SESSION['PARAMS']['re'];                    // enable recurring
    $_SESSION['TARGET'] = '';
    $icp = 'true';
} else {
    $project = AddSlashesNOD(isset($_REQUEST['project'])?$_REQUEST['project']:'0');    // The project of expense
    $ddI = isset($_POST['ddI'])?$_POST['ddI']:'';   // The input value of expense date
    $dd = ($ddI=='')?$dateToday:date2Timestamp($ddI);   // The timestamp of expense date
    $de = isset($_POST['de'])?$_POST['de']:'';      // The description of expense
    $ct = isset($_POST['ct'])?$_POST['ct']:'';      // The claim type of expense
    $et = isset($_POST['et'])?$_POST['et']:'';      // The expense type of expense
    $bi = isset($_POST['bi'])?$_POST['bi']:'';      // bill to client?
    $am = isset($_POST['am'])?$_POST['am']:'';      // The amount of expense
    $cu = isset($_POST['cu'])?$_POST['cu']:'';      // The currency of expense
    $rsdI = isset($_POST['rsdI'])?$_POST['rsdI']:'';    // input value of recurring start date
    $rsd = ($rsdI=='')?$dateToday:date2Timestamp($rsdI);    // timestamp of recurring start date
    $rfdI = isset($_POST['rfdI'])?$_POST['rfdI']:'';    // input value of recurring finish date
    $rfd = ($rfdI=='')?$dateToday:date2Timestamp($rfdI);    // timestamp of recurring finish date
    $rty = isset($_POST['rty'])?$_POST['rty']:'';       // recurring type
    $rfq = isset($_POST['rfq'])?$_POST['rfq']:'';       // recurring frequency
    $r = isset($_POST['re'])?$_POST['re']:'';           // enable recurring
    $re = DbValueEncode(enumFieldType::ftBoolean, $r);
    $icp = '';
}

if ($project == '') {
    $project = '0';
}

/**
 * Permission check
 */
if ($project == '0') {
    if ($id == '') {
        if (!$SW_Permissions['Expense']['Write'][$profilSession]) {
            header('Location: ../expenses/listexpenses.php?msg=permissiondenied' . $urlBornes);
            exit;
        }
    } else {
        if ($cpy != 'true') {
            if (!$SW_Permissions['Expense']['Edit'][$profilSession]) {
                header('Location: ../expenses/viewexpense.php?id=' . $id . '&msg=permissiondenied' . $urlBornes);
                exit;
            }
        } else {
            if (!$SW_Permissions['Expense']['Write'][$profilSession]) {
                header('Location: ../expenses/listexpenses.php?msg=permissiondenied' . $urlBornes);
                exit;
            }
        }

        $querymore4 = " WHERE exp.id='$id'";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($querymore4);
        $comptExpenseDetail = count($expenseDetail->exp_id);

        if ($comptExpenseDetail == 0 || $expenseDetail->exp_owner[0] != $idSession) {
            header('Location: ../expenses/listexpenses.php?msg=permissiondenied' . $urlBornes);
            exit;
        }

        if ($expenseDetail->exp_recurring[0] == enumBoolean::bTrue) {
            $recurring = 'true';
        }

        if ($recurring != 'true' && $cpy != 'true') {
            if ($expenseDetail->exp_status_approval[0] == enumFileStatus::stNeedsApproval) {
                header('Location: ../expenses/listexpenses.php?msg=permissiondenied' . $urlBornes);
                exit;
            }

            if (periodLocked($expenseDetail->exp_docdate[0])) {     // check if period locked
                header('Location: ../expenses/listexpenses.php?msg=periodLocked' . $urlBornes);
                exit;
            }
        }
    }
} else {
    $querymore1 = " WHERE pro.id='$project'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore1);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../projects/viewprojectaccounting.php?id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }

    $upload_dir = $projectDetail->pro_upload_dir[0];
    $querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore2);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore3);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($id == '') {
        if ($permissionDetail->prp_create_expense[0] != enumBoolean::bTrue) {
            header('Location: ../projects/viewprojectaccounting.php?id=' . $project . '&msg=permissiondenied' . $urlBornes);
            exit;
        }
    } else {
        $querymore4 = " WHERE exp.id='$id'";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($querymore4);
        $comptExpenseDetail = count($expenseDetail->exp_id);

        if ($comptExpenseDetail == 0 || $expenseDetail->exp_owner[0] != $idSession) {
            header('Location: ../projects/viewprojectaccounting.php?id=' . $project . '&msg=permissiondenied' . $urlBornes);
            exit;
        }

        if ($expenseDetail->exp_recurring[0] == enumBoolean::bTrue) {
            $recurring = 'true';
        }

        if ($recurring != 'true' && $cpy != 'true') {
            if (($expenseDetail->exp_status_approval[0] == enumFileStatus::stNeedsApproval) || ($permissionDetail->prp_modify_expense_properties[0] != enumBoolean::bTrue)) {
                header('Location: ../projects/viewprojectaccounting.php?id=' . $project . '&msg=permissiondenied' . $urlBornes);
                exit;
            }

            if (periodLocked($expenseDetail->exp_docdate[0])) {     // check if period locked
                header('Location: ../projects/viewprojectaccounting.php?id=' . $project . '&msg=periodLocked' . $urlBornes);
                exit;
            }
        } else if ($permissionDetail->prp_create_expense[0] != enumBoolean::bTrue) {
            header('Location: ../projects/viewprojectaccounting.php?id=' . $project . '&msg=permissiondenied' . $urlBornes);
            exit;
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add' || $action == 'update') {
    if (periodLocked($dd)) {
        $error = lang_strings('period') . ' ' . createDate($period_date_start,'date',false,true) . ' ~ ' . createDate($period_date_end,'date',false,true) . ' ' . lang_strings('locked');
        $bodyCommand = 'onLoad="document.eExForm.ddI.focus();"';
        $dd_highlight = true;
    } else {
        $error = checkCustomFields('expenses', $id);
    }
} else if ($action == 'new') {
    // store all user input values in session variables
    $params = array();
    $params['project'] = $project;
    $params['dd'] = $dd;
    $params['de'] = $de;
    $params['ct'] = $ct;
    $params['et'] = $et;
    $params['bi'] = $bi;
    $params['am'] = $am;
    $params['cu'] = $cu;
    $params['rsd'] = $rsd;
    $params['rfd'] = $rfd;
    $params['rty'] = $rty;
    $params['rfq'] = $rfq;
    $params['re'] = $re;
    $_SESSION['PARAMS'] = $params;
    $_SESSION['SOURCE'] = 'editexpense';
    $_SESSION['LOCATION'] = "../expenses/editexpense.php?project=$project&id=$id";
    /**
     * Add New Claim Type
     */
    if ($ct == '-1') {
        $_SESSION['TARGET'] = 'claim_type';
        header("Location: ../expenses/claim_type.php?mode=add");
        exit;
    }
    /**
     * Add New Expense Type
     */
    if ($et == '-1') {
        $_SESSION['TARGET'] = 'expense_type';
        header("Location: ../expenses/expense_type.php?mode=add");
        exit;
    }
}

/**
 * Actions
 */
if ($error == '' && ($action == 'add' || $action == 'update')) {
    $de = HtmlEntitiesNOD($de);
    $bi = ($bi=='Y')?enumBoolean::bTrue:enumBoolean::bFalse;
    $am = round($am, $costAccuracy);

    if ($action == 'add') {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsqls = setupCustomFieldsInsertSQL('expenses');  // Generate custom fields insert sql

            if ($recurring == 'true') {
                if ($re == enumBoolean::bFalse) {
                    $rnd = 0;
                } else {
                    $rnd = nextRecurringDate($rsd, $rfd, $rty, $rfq);
                    $re = ($rnd==0)?enumBoolean::bFalse:$re;
                }

                $tmpsql = "INSERT INTO " . $tablePrefix . "expenses (project,status,status_approval,owner,description,docdate,billable,claimtype,expensetype,amount,currency,recurring,recurring_start,recurring_finish,recurring_next,recurring_type,recurring_frequency,recurring_enabled,created,cuser" . $cfsqls[0] . ") VALUES ('$project','" . enumDocumentStatus::stDraft. "','" . enumFileStatus::stNoApprovalsNeeded . "','$idSession','$de','0','$bi','$ct','$et','$am','$cu','" . enumBoolean::bTrue . "','$rsd','$rfd','$rnd','$rty','$rfq','$re','" . time() . "','$idSession'" . $cfsqls[1] . ")";
            } else {
                $tmpsql = "INSERT INTO " . $tablePrefix . "expenses (project,status,status_approval,owner,description,docdate,billable,claimtype,expensetype,amount,currency,recurring,created,cuser" . $cfsqls[0] . ") VALUES ('$project','" . enumDocumentStatus::stOpen. "','" . enumFileStatus::stNoApprovalsNeeded . "','$idSession','$de','$dd','$bi','$ct','$et','$am','$cu','" . enumBoolean::bFalse . "','" . time() . "','$idSession'" . $cfsqls[1] . ")";
            }

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $sendto = $requestAct->newId('expenses');
            $cfsql = setupCustomMediaFieldsUpdateSQL('expenses', $sendto);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "expenses SET $cfsql WHERE id='$sendto'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            if ($recurring != 'true') {
                $status = enumFileStatus::stNoApprovalsNeeded;
                $num = $sendto;
                $producer = $idSession;
                $doctype = 'expenses';

                if (!defined('INNER_ADDDOCUMENT')) {
                    define('INNER_ADDDOCUMENT', 1);
                }

                require('../approvals/adddocument.php');
                $querymore = " WHERE fil.id='$upload_dir'";
                $folderDetail = clone $requestAct;
                $folderDetail->openFiles($querymore);
                $path = $folderDetail->fil_fullname[0];
                uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtExpense, $sendto, $status, $upload_dir, $path);
            }

            copy2HistoryTable($requestAct, 'expenses', $sendto, 'A');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../expenses/viewexpense.php?project=$project&id=$sendto&msg=add". $urlBornes);
            exit;
        }
    } else if ($action == 'update') {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsql = setupCustomFieldsUpdateSQL('expenses', $id);  // Generate custom fields update sql

            if ($recurring == 'true') {
                if ($re == enumBoolean::bFalse) {
                    $rnd = 0;
                } else {
                    $rnd = nextRecurringDate($rsd, $rfd, $rty, $rfq);
                    $re = ($rnd==0)?enumBoolean::bFalse:$re;
                }

                $tmpsql = "UPDATE " . $tablePrefix . "expenses SET owner='$idSession',description='$de',billable='$bi',claimtype='$ct',expensetype='$et',amount='$am',currency='$cu',recurring_start='$rsd',recurring_finish='$rfd',recurring_next='$rnd',recurring_type='$rty',recurring_frequency='$rfq',recurring_enabled='$re',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";
            } else {
                $tmpsql = "UPDATE " . $tablePrefix . "expenses SET status='" . enumDocumentStatus::stOpen . "',status_approval='" . enumFileStatus::stNoApprovalsNeeded . "',owner='$idSession',description='$de',docdate='$dd',billable='$bi',claimtype='$ct',expensetype='$et',amount='$am',currency='$cu',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";
            }

           if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
           }

           if ($recurring != 'true') {
                $status = enumFileStatus::stNoApprovalsNeeded;
                $producer = $idSession;
                $num = $id;
                $doctype = 'expenses';
                require_once('../approvals/updatedocument.php');
                $querymore5 = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtExpense . "' AND fil.doc_id='$id'";
                $listFiles = clone $requestAct;
                $listFiles->openFiles($querymore5);

                if (count($listFiles->fil_id) > 0) {
                    $tmpsql = 'UPDATE ' . $tablePrefix . "files SET status='$status' WHERE doc_type='" . enumFileRelatedDocumentType::dtExpense . "' AND doc_id='$id'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }

                $querymore = " WHERE fil.id='$upload_dir'";
                $folderDetail = clone $requestAct;
                $folderDetail->openFiles($querymore);
                $path = $folderDetail->fil_fullname[0];
                uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtExpense, $id, $status, $upload_dir, $path);
           }

           copy2HistoryTable($requestAct, 'expenses', $id, 'U');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../expenses/viewexpense.php?project=$project&id=$id&msg=update" . $urlBornes);
            exit;
        }
    }
}

/**
 * Set value in form
 */
if ($error == '' && $icp != 'true') {
    if ($id != '') {
        $dd = $expenseDetail->exp_docdate[0];
        $de = $expenseDetail->exp_description[0];
        $ct = $expenseDetail->exp_claimtype[0];
        $et = $expenseDetail->exp_expensetype[0];
        $bi = $expenseDetail->exp_billable[0];
        $cu = $expenseDetail->exp_currency[0];
        $am = $expenseDetail->exp_amount[0];
        $rsd = $expenseDetail->exp_recurring_start[0];      // recurring start date
        $rfd = $expenseDetail->exp_recurring_finish[0];     // recurring finish date
        $rty = $expenseDetail->exp_recurring_type[0];       // recurring type
        $rfq = $expenseDetail->exp_recurring_frequency[0];  // recurring frequency
        $re = $expenseDetail->exp_recurring_enabled[0];     // enable recurring
    } else {
        $dd = $dateToday;
        $de = '';
        $tmpquery = "SELECT claimtype,expensetype,COUNT(id) AS X FROM " . $tablePrefix . "expenses WHERE owner='$idSession' GROUP BY claimtype,expensetype ORDER BY X DESC";
        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery);

        if ($request1->fetch()) {
            $ct = ($row[0]);
            $et = ($row[1]);
        } else {
            $ct = '';
            $et = '';
        }

        $request1->close();
        $bi = enumBoolean::bFalse;
        $cu = ($project == '0' || $projectDetail->pro_currency[0] == '')?$defaultCurrency:$projectDetail->pro_currency[0];
        $am = 0;
        $re = enumBoolean::bTrue;                           // enable recurring
    }
}

if ($project != '0' && $projectDetail->pro_currency[0] != '') {
    $cuDisabled = 'disabled';
} else {
    $cuDisabled = '';
}

/**
 * get claim type valid vlaues
 */
$querymore6 = " WHERE clt.locked='" . enumBoolean::bFalse . "'";

if ($ct != '') {
    $querymore6 .= " OR clt.id='$ct'";
}

$querymore6 .= " ORDER BY clt.name";
$listClaimType = new request();
$listClaimType->openClaimType($querymore6);
$comptListClaimType = count($listClaimType->clt_id);
$ctVV = array();
$ctVV[''] = '';

for ($i=0; $i<$comptListClaimType; $i++) {
    $ctVV[$listClaimType->clt_id[$i]] = $listClaimType->clt_name_print[$i];
}

if ($SW_Permissions['Accounting']['Edit'][$profilSession]) {
    $ctVV['-1'] = $strings['add_new_claim_type'];
}

/**
 * get expense type valid values
 */
$querymore7 = " WHERE ext.locked='" . enumBoolean::bFalse . "'";

if ($et != '') {
    $querymore7 .= " OR ext.id='$et'";
}

$querymore7 .= " ORDER BY ext.name";
$listExpenseType = new request();
$listExpenseType->openExpenseType($querymore7);
$comptListExpenseType = count($listExpenseType->ext_id);

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '0') {
    $blockPage->itemBreadcrumbs(lang_strings("accounting"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $project . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewprojectaccounting.php?id=" . $project . $urlBornes, lang_strings('project_accounting'), 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $project . $urlBornes, lang_strings("expenses"), 'in'));

if ($id == '' || $cpy == 'true') {
    if ($recurring == 'true') {
        $blockPage->itemBreadcrumbs(lang_strings('add_recurring_expense'));
    } else {
        $blockPage->itemBreadcrumbs(lang_strings('add_expense'));
    }
} else {
    if ($recurring == 'true') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink('../expenses/viewexpense.php?id=' . $id . $urlBornes, lang_strings('recurring_expense') . ' #' . $id, 'in'));
        $blockPage->itemBreadcrumbs(lang_strings('edit_recurring_expense'));
    } else {
        $blockPage->itemBreadcrumbs($blockPage->buildLink('../expenses/viewexpense.php?id=' . $id . $urlBornes, '#' . $id, 'in'));
        $blockPage->itemBreadcrumbs(lang_strings('edit_expense'));
    }
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "eEx";

if ($id == '' || $cpy == 'true') {
    $block1->openForm("../expenses/editexpense.php?recurring=$recurring&project=$project" . $urlBornes . "#" . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">";

    if ($recurring == 'true') {
        $block1->heading(lang_strings('add_recurring_expense'));
    } else {
        $block1->heading(lang_strings('add_expense'));
    }
} else {
    $block1->openForm("../expenses/editexpense.php?recurring=$recurring&project=$project&id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">";

    if ($recurring == 'true') {
        $block1->heading(lang_strings('edit_recurring_expense') . ' : #' . $id);
    } else {
        $block1->heading(lang_strings('edit_expense') . ' : #' . $id);
    }
}

$block1->openContent();

if ($project != '0') {
    $block1->contentTitle(lang_strings("info"));
    $block1->contentRow(lang_strings('organization'), $block1->buildLink('../clients/viewclient.php?id=' . $projectDetail->pro_ogranization[0], $projectDetail->pro_org_name[0], 'in'));
    $block1->contentRow(lang_strings('project'), $block1->buildLink('../projects/viewproject.php?id=' . $project . $urlBornes, $projectDetail->pro_name[0], 'in'));
}

$block1->contentTitle(lang_strings("details"));

if ($recurring == 'true') {
    echo '<input type="hidden" id="ddI" name="ddI" value="">';
} else {
    setupInputHTML($block1, lang_strings('date'), 'ddI', enumFieldType::ftDate, 'Y', '0', $dd, '', '', $dd_highlight);
}

setupInputHTML($block1, lang_strings('description'), 'de', enumFieldType::ftMemo, 'Y', '0', $de);
setupInputHTML($block1, lang_strings("claim_type"), 'ct', enumFieldType::ftNumeric, 'Y', '8', $ct, $ctVV, '', false, '', 'onchange="claimTypeChanged()"');

for ($i=0; $i<$comptListExpenseType; $i++) {
    echo '<input type="hidden" id="eti' . $i . '" value="' . $listExpenseType->ext_id[$i] . '"/>';
    echo '<input type="hidden" id="etn' . $i . '" value="' . htmlspecialchars($listExpenseType->ext_name_print[$i]) . '"/>';
    echo '<input type="hidden" id="etc' . $i . '" value="' . $listExpenseType->ext_claimtype[$i] . '"/>';
}

if ($SW_Permissions['Accounting']['Edit'][$profilSession]) {
    echo '<input type="hidden" id="eti' . $i . '" value="-1"/>';
    echo '<input type="hidden" id="etn' . $i . '" value="' . $strings['add_new_expense_type'] . '"/>';
    echo '<input type="hidden" id="etc' . $i . '" value=""/>';
    $i++;
}

echo '<input type="hidden" id="etnum" value="' . $i . '"/>';
echo '<input type="hidden" id="etid" value="' . $et . '"/>';
setupInputHTML($block1, lang_strings("expense_type"), 'et', enumFieldType::ftNumeric, 'Y', '8', $et, array(0=>''), '', false, '', 'onchange="expenseTypeChanged()"');

if ($project != '0') {
    setupInputHTML($block1, lang_strings('bill_client'), 'bi', enumFieldType::ftBoolean, 'N', '0', $bi);
} else {
    echo '<input type="hidden" name="bi" value="N">';
}

if ($cuDisabled == '') {
    setupCurrencyInputHTML($block1, lang_strings('amount'), 'cu', $cu, 'am', $am, 'Y', $costAccuracy);
} else {
    $block1->contentRow(lang_strings('currency'), $cu);
    echo '<input type="hidden" name="cu" value="' . $projectDetail->pro_currency[0] . '"/>';
    setupInputHTML($block1, lang_strings('amount'), 'am', array(enumFieldType::ftTotals, enumFieldOption::foPositiveNumber), 'Y', '0', $am);
}

setupCustomFieldsInputHTML($block1, 'expenses', $id);

if ($recurring == 'true') {
    $rtyVV = array('D' => $strings['VV__expenses_recurring_type_D'], 'W' => $strings['VV__expenses_recurring_type_W'], 'M' => $strings['VV__expenses_recurring_type_M']);
    setupInputHTML($block1, lang_strings('recurring_start'), 'rsdI', enumFieldType::ftDate, 'Y', '8', $rsd);
    setupInputHTML($block1, lang_strings('recurring_finish'), 'rfdI', enumFieldType::ftDate, 'Y', '8', $rfd);
    setupInputHTML($block1, lang_strings('recurring_type'), 'rty', enumFieldType::ftAlphaNumeric, 'N', '1', $rty, $rtyVV);
    setupInputHTML($block1, lang_strings('recurring_frequency'), 'rfq', array(enumFieldType::ftNumeric, enumFieldOption::foPositiveNumber), 'Y', '11', $rfq);
    setupInputHTML($block1, lang_strings('recurring_enabled'), 're', enumFieldType::ftBoolean, 'N', '1', $re);
}

$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();

if ($recurring != 'true' && $fileManagement == 'true' && ($project=='0' || $permissionDetail->prp_add_file[0] == enumBoolean::bTrue)) {
    setupAttachFilesHTML(($sitePublish=='true'));
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
function claimTypeChanged()
{
    var x = document.getElementById('ct').selectedIndex;
    var y = document.getElementById('ct').options[x].value;

    if (y === '-1') {
        document.eExForm.action.value = 'new';
        document.eExForm.submit();
    } else {
        var et = document.getElementById('et');
        var y1 = document.getElementById('etid');
        et.innerHTML = '<option value=""></option>';
        var z = document.getElementById('etnum').value;
        var w = parseInt(z);

        for (i=0; i<w; i++) {
            var etc = document.getElementById('etc' + String(i)).value;

            if (etc === y || etc === '') {
                var u = document.getElementById('etn' + String(i)).value;
                var v = document.getElementById('eti' + String(i)).value;
                var opt = document.createElement("option");
                opt.textContent = u;
                opt.value = v;
                et.appendChild(opt);
            }
        }

        for (i=0; i<et.options.length; i++) {
            if (et.options[i].value === y1.value) {
                et.selectedIndex = i;
                y1.value = '';
                break;
            }
        }
    }
}

function expenseTypeChanged()
{
    var x = document.getElementById('et').selectedIndex;
    var y = document.getElementById('et').options[x].value;

    if (y === '-1') {
        document.eExForm.action.value = 'new';
        document.eExForm.submit();
    }
}

claimTypeChanged();
</script>
<?php
require_once('../includes/footer.php');
