<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: expense_type.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'list';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$error = '';

if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'expense_type' && $_SESSION['SOURCE'] == '') {
    $n = $_SESSION['PARAMS']['n'];                      // name
    $np = $_SESSION['PARAMS']['np'];                    // name print
    $clt = $_SESSION['PARAMS']['ct'];                   // claim type
    $l = $_SESSION['PARAMS']['l'];                      // locked
    $_SESSION['TARGET'] = '';
    $icp = 'true';
} else {
    $n = AddSlashesNOD(isset($_POST['n'])?$_POST['n']:'');  // name
    $np = isset($_POST['np'])?$_POST['np']:'';              // name print
    $clt = isset($_POST['clt'])?$_POST['clt']:'';           // claim type
    $l = isset($_POST['l'])?$_POST['l']:'';                 // locked
}

$lk = DbValueEncode(enumFieldType::ftBoolean, $l);
$n_highlight = false;

/**
 * Permission check
 */
if ($mode == 'list') {
    if (!$SW_Permissions['Accounting']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Accounting']['Edit'][$profilSession]) {
        header("Location: ../expenses/expense_type.php?mode=list&msg=permissiondenied");
        exit;
    }
}

if ($id != '') {
    if ($mode == 'delete') {
        $tmpquery = "SELECT * FROM " . $tablePrefix . "expenses WHERE expensetype IN ($ids)";

        if (compt($tmpquery) > 0) {
            header("Location: ../expenses/expense_type.php?mode=list&msg=permissiondenied");
            exit;
        }

        $querymore = " WHERE ext.id IN ($ids)";
        $listExpenseType = new request();
        $listExpenseType->openExpenseType($querymore);
        $comptListExpenseType = count($listExpenseType->ext_id);

        if ($comptListExpenseType == '0') {
            header("Location: ../expenses/expense_type.php?mode=list&msg=permissiondenied");
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE ext.id='$id'";
        $expenseTypeDetail = new request();
        $expenseTypeDetail->openExpenseType($querymore);
        $comptExpenseTypeDetail = count($expenseTypeDetail->ext_id);

        if ($comptExpenseTypeDetail == '0') {
            header("Location: ../expenses/expense_type.php?mode=list&msg=permissiondenied");
            exit;
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add') {
    $querymore = " WHERE ext.name='$n'";
    $expenseTypeTest = new request();
    $expenseTypeTest->openExpenseType($querymore);

    if (count($expenseTypeTest->ext_id) > 0) {
        $error = lang_strings("expense_type_already_exists");
        $bodyCommand = "onLoad=\"document.extForm.n.focus();\"";
        $n_highlight = true;
    }
} else if ($action == 'new') {
    // store all user input values in session variables
    $params = array();
    $params['n'] = $n;
    $params['np'] = $np;
    $params['l'] = $l;
    $_SESSION['PARAMS'] = $params;
    $_SESSION['SOURCE'] = 'expense_type';
    $_SESSION['LOCATION'] = '../expenses/expense_type.php?id=' . $id . '&mode=' . $mode;
    /**
     * Add New Claim Type
     */
    $_SESSION['TARGET'] = 'claim_type';
    header("Location: ../expenses/claim_type.php?mode=add");
    exit;
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "expense_type (name,claimtype,locked,created,cuser) VALUES ('$n','$clt','$lk','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('expense_type');
            copy2HistoryTable($requestAct, 'expense_type', $num, 'A');
            updateString($requestAct, 'EXT__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'expense_type') {
                $_SESSION['PARAMS']['et'] = $num;
                $_SESSION['PARAMS']['ct'] = $clt;
                $_SESSION['TARGET'] = $_SESSION['SOURCE'];
                $_SESSION['SOURCE'] = '';
                header("Location: " . $_SESSION['LOCATION']);
            } else {
                header("Location: ../expenses/expense_type.php?mode=list&msg=add");
            }

            exit;
        }
    } else if ($action == 'edit') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "expense_type SET claimtype='$clt',locked='$lk',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'expense_type', $id, 'U');
            updateString($requestAct, 'EXT__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../expenses/expense_type.php?mode=list&msg=update");
            exit;
        }
    } else if ($action == 'delete') {
        try {
            $requestAct->startTransaction();
            copy2HistoryTable($requestAct, 'expense_type', $ids, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "expense_type WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../expenses/expense_type.php?mode=list&msg=delete");
            exit;
        }
    }
}

/**
 * get claim type valid values
 */
$querymore = " WHERE clt.locked='" . enumBoolean::bFalse . "'";

if ($id != '') {
    $querymore .= " OR clt.id='" . $expenseTypeDetail->ext_claimtype[0] . "'";
}

$querymore .= " ORDER BY clt.name";
$listClaimType = new request();
$listClaimType->openClaimType($querymore);
$comptListClaimType = count($listClaimType->clt_id);
$cltVV = array();
$cltVV[''] = '';

for ($i=0; $i<$comptListClaimType; $i++) {
    $cltVV[$listClaimType->clt_id[$i]] = $listClaimType->clt_name_print[$i];
}

$cltVV['-1'] = $strings['add_new_claim_type'];

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=accounting", lang_strings("administration"), 'in'));

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings("expense_type"));
} else if ($mode == 'add') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/expense_type.php?", lang_strings("expense_type"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_expense_type"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/expense_type.php?", lang_strings("expense_type"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_expense_type"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/expense_type.php?", lang_strings("expense_type"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_expense_types"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = "ext";
$block1->openForm("../expenses/expense_type.php?id=$id&mode=$mode#" . $block1->form . "Anchor");

if ($mode == 'list') {
    logURL($strings['expense_type'], "../expenses/expense_type.php?id=$id&mode=$mode");
    $block1->heading(lang_strings("expense_type"));
    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '12';
    $block1->sorting('expense_type', (isset($sortingUser['expense_type'])?$sortingUser['expense_type']:''), 'ext.name ASC', $sortingFields = array(0 => 'ext.name', 1 => 'none', 2 => 'clt.name', 3 => 'ext.locked'));
    $querymore = " ORDER BY " . $block1->sortingValue;
    $block1->recordsTotal = compt($initrequest['expense_type'] . ' ' . $querymore);
    $listExpenseType = new request();
    $listExpenseType->openExpenseType($querymore, $block1->borne, $block1->rowsLimit);
    $comptListExpenseType = count($listExpenseType->ext_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftAlphaNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name_print'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['claim_type'];
    $columns[2]->field_type = enumFieldType::ftNumeric;
    $columns[2]->linked_table = 'claim_type';
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['locked'];
    $columns[3]->field_type = enumFieldType::ftBoolean;
    $opt[enumCardviewOption::oObject] = 'expense_type';
    $opt[enumCardviewOption::oTableName] = 'expense_type';
    $opt[enumCardviewOption::oColumns] = $columns;

    if ($SW_Permissions['Accounting']['Edit'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../expenses/expense_type.php?mode=add';
    }

    $block1->openCardView($opt);

    for ($i=0; $i<$comptListExpenseType; $i++) {
        $content = array(
            $listExpenseType->ext_name[$i],
            $listExpenseType->ext_name_print[$i],
            $listExpenseType->ext_claimtype[$i],
            $listExpenseType->ext_locked[$i]
        );
        $block1->itemCardView($listExpenseType->ext_id[$i], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "id=$id&mode=$mode");
    $block1->closeFormResults();
} else if ($mode == 'add') {
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_expense_type"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name"), 'n', enumFieldType::ftAlphaNumeric, 'Y', '155', $n, '', '', $n_highlight, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np, '', '', false, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("claim_type"), 'clt', enumFieldType::ftNumeric, 'Y', '8', $clt, $cltVV, '', false, '', 'onchange="claimTypeChanged()"');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    if ($error == '') {
        $n = $expenseTypeDetail->ext_name[0];
        $np = $expenseTypeDetail->ext_name_print[0];
        $clt = $expenseTypeDetail->ext_claimtype[0];
        $lk = $expenseTypeDetail->ext_locked[0];
    }

    echo '<input type="hidden" name="action" value="edit">';
    echo '<input type="hidden" name="n" value="' . $n . '">';
    $block1->heading(lang_strings("edit_expense_type") . " : " . $expenseTypeDetail->ext_name[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np);
    setupInputHTML($block1, lang_strings("claim_type"), 'clt', enumFieldType::ftNumeric, 'Y', '8', $clt, $cltVV, '', false, '', 'onchange="claimTypeChanged()"');
    setupInputHTML($block1, lang_strings('locked'), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_expense_types"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListExpenseType; $i++) {
        $block1->contentRow('#' . $listExpenseType->ext_id[$i], $listExpenseType->ext_name[$i] . ' (' . $listExpenseType->ext_name_print[$i] . ')');
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

?>
<script type="text/javascript">
    function nameChanged() {
        var np = document.getElementById('np').value;

        if (np === '') {
            var n = document.getElementById('n').value;
            document.getElementById('np').value = n;
        }
    }

    function claimTypeChanged()
    {
        var x = document.getElementById('clt').selectedIndex;
        var y = document.getElementById('clt').options[x].value;

        if (y === '-1') {
            document.extForm.action.value = 'new';
            document.extForm.submit();
        }
    }
</script>
<?php
require_once("../includes/footer.php");
