<?php // $Revision: 1.14 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listexpenses.php,v 1.14 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$show = isset($_GET['show'])?$_GET['show']:'';
$recurring = ($show=='recurring')?'true':'';

if ($project == '') {
    $project = '0';
}

if ($show == '') {
    $show = "open";
}

/**
 * Permission check
 */
if ($project == '0') {
    if (!$SW_Permissions['Expense']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    $querymore1 = " WHERE pro.id='$project'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore1);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    $querymore2 = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore2);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore3 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore3 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore3);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($permissionDetail->prp_view_expense[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '0') {
    $blockPage->itemBreadcrumbs(lang_strings("accounting"));
    $blockPage->itemBreadcrumbs(lang_strings("expenses"));

    switch ($show) {
        case 'all':
            $blockPage->itemBreadcrumbs(lang_strings('all'));
            $title = $strings['expenses'] . ' : ' . $strings['all'];
            break;
        case 'draft':
            $blockPage->itemBreadcrumbs($statusAccountDoc[enumDocumentStatus::stDraft]);
            $title = $strings['expenses'] . ' : ' . $statusAccountDoc[enumDocumentStatus::stDraft];
            break;
        case 'open':
            $blockPage->itemBreadcrumbs($statusAccountDoc[enumDocumentStatus::stOpen]);
            $title = $strings['expenses'] . ' : ' . $statusAccountDoc[enumDocumentStatus::stOpen];
            break;
        case 'closed':
            $blockPage->itemBreadcrumbs($statusAccountDoc[enumDocumentStatus::stClosed]);
            $title = $strings['expenses'] . ' : ' . $statusAccountDoc[enumDocumentStatus::stClosed];
            break;
        case 'recurring':
            $blockPage->itemBreadcrumbs(lang_strings('recurring'));
            $title = $strings['expenses'] . ' : ' . $strings['recurring'];
            break;
    }
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewprojectaccounting.php?id=" . $project . $urlBornes, lang_strings('project_accounting'), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("expenses"));
    $title = $strings['expenses'] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '3';     // 1st for listprojects, 2nd for viewprojectaccounting
logURL($title, '../expenses/listexpenses.php?show=' . $show . '&project=' . $project);
$block1 = new block();
$block1->openHeading(lang_strings('expenses'));

if ($project == '0') {
    $block1->openViewOptions();

    foreach (array(array('all', lang_strings('all')),array('draft', $statusAccountDoc[enumDocumentStatus::stDraft]),array('open', $statusAccountDoc[enumDocumentStatus::stOpen]),array('closed', $statusAccountDoc[enumDocumentStatus::stClosed]),array('recurring', lang_strings('recurring'))) as $x) {
        if ($show != $x[0]) {
            $block1->itemViewOptions($block1->buildLink('../expenses/listexpenses.php?show=' . $x[0], $x[1], 'in'));
        }
    }

    $block1->closeViewOptions();
}

$block1->closeHeading();
$block1->form = 'exL';

if ($project == '0') {
    $block1->openForm('../expenses/listexpenses.php?show=' . $show . '&project=' . $project . '#' . $block1->form . 'Anchor');
} else {
    $block1->openForm('../expenses/listexpenses.php?show=' . $show . '&project=' . $project . $urlBornes . '#' . $block1->form . 'Anchor');
}

$block1->borne = $blockPage->returnBorne('3');
$block1->rowsLimit = '12';
$block1->sorting('expense', (isset($sortingUser['expense'])?$sortingUser['expense']:''), 'exp.docdate ASC', $sortingFields = array(0 => 'exp.docdate', 1 => 'mem.name', 2 => 'exp.status', 3 => 'exp.expensetype', 4 => 'exp.billable', 5 => 'exp.currency', 6 => 'exp.amount'));
$querymore = " WHERE exp.project='$project'";

if ($project == '0') {
    $querymore .= " AND exp.owner='$idSession'";
}

switch ($show) {
    case 'draft':
        $querymore .= " AND exp.status='" . enumDocumentStatus::stDraft . "' AND exp.recurring='" . enumBoolean::bFalse . "'";
        break;
    case 'open':
        $querymore .= " AND exp.status='" . enumDocumentStatus::stOpen . "' AND exp.recurring='" . enumBoolean::bFalse . "'";
        break;
    case 'recurring':
        $querymore .= " AND exp.status='" . enumDocumentStatus::stDraft . "' AND exp.recurring='" . enumBoolean::bTrue . "'";
        break;
}

$querymore .= " ORDER BY " . $block1->sortingValue;
$block1->recordsTotal = compt($initrequest['expenses'] . ' ' . $querymore);
$listExpenses = new request();
$listExpenses->openExpenses($querymore, $block1->borne, $block1->rowsLimit);
$comptListExpenses = count($listExpenses->exp_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['date'];
$columns[0]->field_type = enumFieldType::ftText;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['owner'];
$columns[1]->field_type = enumFieldType::ftNumeric;
$columns[1]->linked_table = 'members';
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['status'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['expense_type'];
$columns[3]->field_type = enumFieldType::ftNumeric;
$columns[3]->linked_table = 'expense_type';
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['bill_client'];
$columns[4]->field_type = enumFieldType::ftBoolean;
$columns[5] = new cardviewColumn();
$columns[5]->title = $strings['currency'];
$columns[5]->field_type = enumFieldType::ftText;
$columns[6] = new cardviewColumn();
$columns[6]->title = $strings['amount'];
$columns[6]->field_type = enumFieldType::ftTotals;
$opt[enumCardviewOption::oTableName] = 'expenses';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oObject] = 'expenses';

if ($project == '0') {
    $opt[enumCardviewOption::oExtraParameters] = 'show=' . $show . '&recurring=' . $recurring . '&project=' . $project . '&borne3=' . $block1->borne;
    
    if ($SW_Permissions['Expense']['Write'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../expenses/editexpense.php?recurring=' . $recurring . '&project=0';
    }
} else {
    $opt[enumCardviewOption::oExtraParameters] = 'show=' . $show . '&recurring=' . $recurring . '&project=' . $project . $urlBornes . '&borne3=' . $block1->borne;
    
    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_create_expense[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = '../expenses/editexpense.php?project=' . $project . $urlBornes;
        }
    }
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListExpenses; $i++) {
    $content = array(
        createDate($listExpenses->exp_docdate[$i],'date',false,true),
        $listExpenses->exp_owner[$i],
        $statusAccountDoc[$listExpenses->exp_status[$i]],
        $listExpenses->exp_expensetype[$i],
        $listExpenses->exp_billable[$i],
        $listExpenses->exp_currency[$i],
        $listExpenses->exp_amount[$i]
    );
    $block1->itemCardView($listExpenses->exp_id[$i], $content);
}

$block1->closeCardView();

if ($project == '0') {
    $block1->bornesFooter("3", $blockPage->bornesNumber, "project=$project&show=$show&recurring=$recurring");
} else {
    $block1->bornesFooter("3", $blockPage->bornesNumber, "project=$project&show=$show&recurring=$recurring" . $urlBornes);    
}

$block1->closeFormResults();
require_once('../includes/footer.php');
