<?php // $Revision: 1.21 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewexpense.php,v 1.21 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
$querymore0 = " WHERE exp.id='$id'";
$expenseDetail = new request();
$expenseDetail->openExpenses($querymore0);
$comptExpenseDetail = count($expenseDetail->exp_id);

if ($comptExpenseDetail <= 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$project = $expenseDetail->exp_project[0];

if ($project == '0') {
    if (!$SW_Permissions['Expense']['Read'][$profilSession]) {
        header('Location: ../expenses/listexpenses.php?msg=permissiondenied' . $urlBornes);
        exit;
    }

    if ($expenseDetail->exp_owner[0] != $idSession) {
        header('Location: ../expenses/listexpenses.php?msg=permissiondenied' . $urlBornes);
        exit;
    }
} else {
    $querymore = " WHERE pro.id='$project'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    $querymore = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($permissionDetail->prp_view_expense[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }

    if ($action == 'publish') {
        if ($permissionDetail->prp_publish_file[0] != enumBoolean::bTrue) {
            header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied' . $urlBornes);
            exit;
        }
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '0') {
    $blockPage->itemBreadcrumbs(lang_strings("accounting"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $project . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewprojectaccounting.php?id=" . $project . $urlBornes, lang_strings('project_accounting'), 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $project . $urlBornes, lang_strings("expenses"), 'in'));

if ($expenseDetail->exp_recurring[0] != enumBoolean::bTrue) {
    $blockPage->itemBreadcrumbs('#' . $id);
    $title = $strings['expense'] . ' : #' . $id;
} else {
    $blockPage->itemBreadcrumbs('#' . $id);
    $title = $strings['recurring_expense'] . ' : #' . $id;
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '4';
logURL($title, '../expenses/viewexpense.php?id=' . $id);
$block1 = new block();
$block1->form = 'vEx';
$block1->openForm('../expenses/viewexpense.php?id=' . $id . $urlBornes . '#' . $block1->form . 'Anchor');

if ($expenseDetail->exp_recurring[0] != enumBoolean::bTrue) {
    $block1->headingToggle($strings['expense'], !($toggle_focus==''));
} else {
    $block1->headingToggle($strings['recurring_expense'], !($toggle_focus==''));
}

$block1->openPaletteIcon();

if ($project == '0') {
    if ($SW_Permissions['Expense']['Write'][$profilSession]) {
        $block1->paletteIcon(4, 'copy', $strings['copy']);
    }

    if ($SW_Permissions['Expense']['Admin'][$profilSession]) {
        $block1->paletteIcon(0, 'remove', $strings['delete']);
    }

    if ($SW_Permissions['Expense']['Edit'][$profilSession]) {
        $block1->paletteIcon(1, 'edit', $strings['edit']);
    }
} else {
    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval && $expenseDetail->exp_status_approval[0] != enumFileStatus::stNeedsApproval && !periodLocked($expenseDetail->exp_docdate[0])) {
        if ($permissionDetail->prp_create_expense[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(4, 'copy', $strings['copy']);
        }

        if ($permissionDetail->prp_delete_expense[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(0, 'remove', $strings['delete']);
        }

        if ($permissionDetail->prp_modify_expense_properties[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(1, 'edit', $strings['edit']);
        }
    }
}

$block1->paletteIcon(5, 'print', $strings['print']);
$block1->closePaletteIcon();
$block1->openContent();

if ($expenseDetail->exp_recurring[0] != enumBoolean::bTrue) {
    $block1->contentRow(lang_strings('date'), createDate($expenseDetail->exp_docdate[0],'date',false,true));
}

$block1->contentRow(lang_strings('owner'), $blockPage->buildLink($expenseDetail->exp_owner[0], '', 'message'));
$block1->contentRow(lang_strings('description'), $expenseDetail->exp_description[0]);
$block1->contentRow(lang_strings("claim_type"), $expenseDetail->exp_clt_name_print[0]);
$block1->contentRow(lang_strings("expense_type"), $expenseDetail->exp_ext_name_print[0]);
$bill_client = ($expenseDetail->exp_billable[0]==enumBoolean::bTrue)?$strings['yes']:$strings['no'];
$block1->contentRow(lang_strings('bill_client'), $bill_client);
$block1->contentRow(lang_strings('amount') . '&nbsp;' . $blockPage->printHelp($CurrencyMatrix['name'][$expenseDetail->exp_currency[0]], true), CurrencyFormatNOD($expenseDetail->exp_amount[0], $expenseDetail->exp_currency[0], $costAccuracy));

if ($expenseDetail->exp_recurring[0] != enumBoolean::bTrue) {
    $block1->contentRow(lang_strings('status'), $statusAccountDoc[$expenseDetail->exp_status[0]]);
}

setupCustomFieldsHTML($block1, 'expenses', $id);

if ($expenseDetail->exp_recurring[0] == enumBoolean::bTrue) {
    $block1->contentRow(lang_strings('recurring_start'), createDate($expenseDetail->exp_recurring_start[0], 'date', false, true));
    $block1->contentRow(lang_strings('recurring_finish'), createDate($expenseDetail->exp_recurring_finish[0], 'date', false, true));
    $block1->contentRow(lang_strings('recurring_type'), $strings['VV__expenses_recurring_type_' . $expenseDetail->exp_recurring_type[0]]);
    $block1->contentRow(lang_strings('recurring_frequency'), $expenseDetail->exp_recurring_frequency[0]);
    $block1->contentRow(lang_strings('recurring_enabled'), DbValueDecode(enumFieldType::ftBoolean, $expenseDetail->exp_recurring_enabled[0]));

    if ($expenseDetail->exp_recurring_enabled[0] == enumBoolean::bTrue) {
        $block1->contentRow(lang_strings('recurring_next'), createDate($expenseDetail->exp_recurring_next[0], 'date', false, true));
    }
}

$block1->closeContent();
$block1->closeToggle();

if ($expenseDetail->exp_recurring[0] != enumBoolean::bTrue && $expenseDetail->exp_status_approval[0] != enumFileStatus::stNoApprovalsNeeded) {
    $block1->headingToggle(lang_strings("approval_history"));
    $block1->openContent();
    $querymore = " WHERE dap.docid='$id' AND dap.doctype='expenses' ORDER BY dap.id";
    $listDocumentsApproval = new request();
    $listDocumentsApproval->openDocumentsApproval($querymore);
    $comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

    for ($i=0; $i<$comptListDocumentsApproval; $i++) {
        if ($i == 0) {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['submit_at']) . '</i>';
        } else {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['resubmit_at']) . '</i>';
        }

        $querymore = " WHERE daa.document_approval='" . $listDocumentsApproval->dap_id[$i] . "' AND daa.status<>'" . enumApprovalStatus::stPending . "' ORDER BY daa.created,daa.modified";
        $listDocumentsApprovalAuthorizer = new request();
        $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($querymore);
        $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

        for ($j=0,$right = ''; $j<$comptListDocumentsApprovalAuthorizer; $j++,$right.='<br>') {
            $ahd = '';

            if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stApproved) {
                $ahd = $strings['approval_history_approved'];
            } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stNotApproved) {
                $ahd = $strings['approval_history_rejected'];
            }

            if ($ahd != '') {
                $ahd0 = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
                $ahd1 = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j], 'both'), $ahd0);
                $right .= '<i>' . $ahd1  . '</i>';

                if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                    $right .= '<br>' . $listDocumentsApprovalAuthorizer->daa_comments[$j];
                }
            }
        }

        $block1->contentRow($left, $right);
    }

    $block1->closeContent();
    $block1->closeToggle();
}

$block1->closeForm();
$block1->openPaletteScript();

if ($project == '0') {
    if ($SW_Permissions['Expense']['Write'][$profilSession]) {
        $block1->paletteScript(4, 'copy', '../expenses/editexpense.php?cpy=true&project=' . $project . '&id=' . $id, 'true,true,true', $strings['copy']);
    }

    if ($SW_Permissions['Expense']['Admin'][$profilSession]) {
        $block1->paletteScript(0, 'remove', '../expenses/deleteexpenses.php?project=' . $project . '&id=' . $id . $urlBornes, 'true,true,true', $strings['delete']);
    }

    if ($SW_Permissions['Expense']['Edit'][$profilSession]) {
        $block1->paletteScript(1, 'edit', '../expenses/editexpense.php?project=' . $project . '&id=' . $id . $urlBornes, 'true,true,true', $strings['edit']);
    }
} else {
    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval && $status != enumFileStatus::stNeedsApproval && !periodLocked($expenseDetail->exp_docdate[0])) {
        if ($permissionDetail->prp_create_expense[0] == enumBoolean::bTrue) {
            $block1->paletteScript(4, 'copy', '../expenses/editexpense.php?cpy=true&project=' . $project . '&id=' . $id . $urlBornes, 'true,true,true', $strings['copy']);
        }

        if ($permissionDetail->prp_delete_expense[0] == enumBoolean::bTrue) {
            $block1->paletteScript(0, 'remove', '../expenses/deleteexpenses.php?project=' . $project . '&id=' . $id . $urlBornes, 'true,true,true', $strings['delete']);
        }

        if ($permissionDetail->prp_modify_expense_properties[0] == enumBoolean::bTrue) {
            $block1->paletteScript(1, 'edit', '../expenses/editexpense.php?project=' . $project . '&id=' . $id . $urlBornes, 'true,true,true', $strings['edit']);
        }
    }
}

$block1->paletteScript(5, "print", "../expenses/printexpenses.php?project=$project&id=$id" . $urlBornes, "true,true,true", $strings["print"]);
$block1->closePaletteScript('', '');

if (($fileManagement == "true") && ($expenseDetail->exp_recurring[0] != enumBoolean::bTrue) && (($project == '0' && $SW_Permissions['File']['Read'][$profilSession]) || ($project != '0' && ($SW_Permissions['Project']['Admin'][$profilSession] || $permissionDetail->prp_view_file[0] == enumBoolean::bTrue)))) {
    $block2 = new block();
    $block2->form = "exF";
    $block2->openForm("../expenses/viewexpense.php?id=$id" . $urlBornes . "#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings("linked_content"), !($toggle_focus=='linked_content'));
    $block2->borne = $blockPage->returnBorne('4');
    $block2->rowsLimit = 12;
    $block2->sorting("expense_files", (isset($sortingUser['expense_files'])?$sortingUser['expense_files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status'));
    $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtExpense . "' AND fil.doc_id='$id' AND fil.vc_parent='0' ORDER BY " . $block2->sortingValue;
    $recordsTotal = compt($initrequest['files'] . $querymore);
    $block2->recordsTotal = $recordsTotal;
    $listFiles = new request();
    $listFiles->openFiles($querymore, $block2->borne, $block2->rowsLimit);
    $comptListFiles = count($listFiles->fil_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['owner'];
    $columns[1]->field_type = enumFieldType::ftAvatar;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['created'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['approval_tracking'];
    $columns[3]->field_type = enumFieldType::ftText;
    $opt[enumCardviewOption::oTableName] = 'files';
    $opt[enumCardviewOption::oObject] = 'files';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] = "doc_type=" . enumFileRelatedDocumentType::dtExpense . "&doc_id=$id" . $urlBornes . '&borne4=' . $block2->borne;

    if ($project == '0') {
        if ($SW_Permissions['File']['Write'][$profilSession]) {
            $opt[enumCardviewOption::oAddUrl] = "../linkedcontent/addfile.php?doc_type=" . enumFileRelatedDocumentType::dtExpense . "&doc_id=$id" . $urlBornes;
        }
    } else {
        if ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = "../linkedcontent/addfile.php?doc_type=" . enumFileRelatedDocumentType::dtExpense . "&doc_id=$id" . $urlBornes;
        }
    }

    $block2->openCardView($opt);

    for ($i=0; $i<$comptListFiles; $i++) {
        $idStatus = $listFiles->fil_status[$i];
        $content = array(
            $listFiles->fil_name[$i],
            implode(',',
                array(
                    $listFiles->fil_owner[$i],
                    $listFiles->fil_mem_extension_picture[$i],
                    $listFiles->fil_mem_gender[$i])),
            createDate($listFiles->fil_created[$i],'both'),
            $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . enumFileRelatedDocumentType::dtExpense . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i] . $urlBornes, $statusFile[$idStatus], 'in')
        );
        $block2->itemCardView($listFiles->fil_id[$i], $content);
    }

    $block2->closeCardView();
    $block2->bornesFooter("4", $blockPage->bornesNumber, "id=$id&toggle_focus=linked_content" . $urlBornes);
    $block2->closeToggle();
    $block2->closeFormResults();
}

require_once('../includes/footer.php');
