<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addextension.php,v 1.9 2013/02/03 15:14:27 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
$bodyCommand = "onLoad=\"document.extAForm.nam.focus();\"";

/**
 * Variables init
 */
$action = isset($_POST['action'])?$_POST['action']:'';
$nam = isset($_POST['nam'])?$_POST['nam']:'';           // extension name
$tit = isset($_POST['tit'])?$_POST['tit']:'';           // extension title for mainmenu
$des = isset($_POST['des'])?$_POST['des']:'';           // extension description
$ver = isset($_POST['ver'])?$_POST['ver']:'';           // extension version
$act0 = isset($_POST['act'])?$_POST['act']:'';          // Determine whether an active extension
$act = (($act0=='Y')?enumBoolean::bTrue:enumBoolean::bFalse);
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Extension']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Actions
 */
if ($action == "add" && $error == '') {
    // replace quotes by html code
    $des = HtmlEntitiesNOD($des);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "INSERT INTO " . $tablePrefix . "extensions (name,description,version,active,created,cuser) VALUES ('$nam','$des','$ver','$act','" . time() . "','$idSession')";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        if (($num = $requestAct->newId("extensions")) === false) {
            throw new Exception('Unable to get new id of extension');
        }

        copy2HistoryTable($requestAct, 'extensions', $num, 'A');
        updateString($requestAct, 'EXT__' . $nam, $tit);
        // full control by default for all user profiles
        $listUserProfiles = clone $requestAct;
        $listUserProfiles->openUserProfiles('');
        $comptListUserProfiles = count($listUserProfiles->upf_id);

        for ($i=0; $i<$comptListUserProfiles; $i++) {
            foreach (array('Read','Write','Edit','Admin') as $p) {
                $tmpsql = "INSERT INTO " . $tablePrefix . "user_profiles_detail (user_profile,function_name,access_level,granted) VALUES ('" . $listUserProfiles->upf_id[$i] . "','#$nam','$p','" . enumBoolean::bTrue . "')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        if (mkdir($basedir . 'extensions/' . $nam, 0755)) {
            $content = file_get_contents($basedir . 'extensions/index.php.template');
            $content1 = str_replace(array('%name%', '%title%'), array($nam, $tit), $content);
            file_put_contents($basedir . 'extensions/' . $nam . '/index.php', $content1);
            mkdir($basedir . 'extensions/' . $nam . '/languages', 0755);
            $content2 = file_get_contents($basedir . 'extensions/lang_xx.php.template');
            $content3 = str_replace(array('%name%', '%title%'), array($nam, $tit), $content2);
            file_put_contents($basedir . 'extensions/' . $nam . '/languages/lang_' . $lang . '.php', $content3);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } else {
            $error = 'Failed to create folders';
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../extensions/listextensions.php?show=all&msg=add");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
echo '<script type="text/javascript" src="../javascript/addextension' . $scriptMinimized . '.js"></script>';
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../extensions/listextensions.php?", lang_strings('extension_management'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_extension"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "extA";
$block1->openForm("../extensions/addextension.php?#" . $block1->form . "Anchor", 'return checkFormData(this);');
echo '<input type="hidden" name="action" value="add">';
$block1->heading(lang_strings("add_extension"));
$block1->openContent();
setupInputHTML($block1, lang_strings('name'), 'nam', enumFieldType::ftAlphaNumeric, 'Y', 255, $nam);
setupInputHTML($block1, lang_strings('title'), 'tit', enumFieldType::ftText, 'Y', 255, $tit);
setupInputHTML($block1, lang_strings('description'), 'des', enumFieldType::ftMemo, 'N', 0, $des);
setupInputHTML($block1, lang_strings('version'), 'ver', array(enumFieldType::ftText, enumFieldOption::foVersionNumber), 'N', '255', $ver);
setupInputHTML($block1, lang_strings('status_active'), 'act', enumFieldType::ftBoolean, 'N', 1, $act);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
