<?php // $Revision: 1.20 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteextensions.php,v 1.20 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = "'" . str_replace('**', "','", $id) . "'";
$ida = explode('**', $id);

/**
 * Permission check
 */
if (!$SW_Permissions['Extension']['Admin'][$profilSession]) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

// check if extensions exist
$querymore = " WHERE ext.id IN ($ids) ORDER BY ext.name";
$listExtensions = new request();
$listExtensions->openExtensions($querymore);
$comptListExtensions = count($listExtensions->ext_id);

if ($comptListExtensions != count($ida)) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

/**
 * delete recursively a tree
 */
function delTree($dir)
{
    $files = array_diff(scandir($dir), array('.','..'));

    foreach ($files as $file) {
        (is_dir("$dir/$file")) ? delTree("$dir/$file") : unlink("$dir/$file");
    }

    return rmdir($dir);
}

/**
 * Action
 */
if ($action == "delete") {
    $namA = $listExtensions->ext_name;
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'extensions', $ids, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "extensions WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        foreach ($namA as $name) {
            $tmpsql = "DELETE FROM " . $tablePrefix . "user_profiles_detail WHERE function_name='#$name'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "DELETE FROM " . $tablePrefix . "strings WHERE string_key='EXT__" . $name . "'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            delTree($basedir . 'extensions/' . $name);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../extensions/listextensions.php?msg=delete" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../extensions/listextensions.php?" . $urlBornes, lang_strings("extension_management"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_extensions"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "extD";
$block1->openForm("../extensions/deleteextensions.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="delete">';
$block1->heading(lang_strings("delete_extensions"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListExtensions; $i++) {
    $block1->contentRow('#' . $listExtensions->ext_id[$i], $listExtensions->ext_name[$i]);
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
