<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editclientextensions.php,v 1.6 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
$bodyCommand = "onLoad=\"document.cuAForm.un.focus();\"";

/**
 * Variables init
 */
$organization = AddSlashesNOD(isset($_GET['organization'])?$_GET['organization']:'');
$action = isset($_POST['action'])?$_POST['action']:'';
$perm = isset($_POST['perm'])?$_POST['perm']:'';    // access level mapping table
$vals = isset($_POST['vals'])?$_POST['vals']:'';    // permission list
$error = '';
unset($updA);

/**
 * Permission check
 */
if (!$SW_Permissions['Client']['Write'][$profilSession]) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

if (!is_numeric($organization)) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

/**
 * check client detail
 */
$querymore1 = " WHERE org.id='$organization'";
$clientDetail = new request();
$clientDetail->openOrganizations($querymore1);
$comptClientDetail = count($clientDetail->org_id);

if ($comptClientDetail == '0') {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

/**
 * get extension list
 */
$querymore2 = " ORDER BY ext.name";
$listExtensions = new request();
$listExtensions->openExtensions($querymore2);
$comptListExtensions = count($listExtensions->ext_name);

if ($comptListExtensions == '0') {
    header("Location: ../clients/viewclient.php?id=$organization&msg=permissiondenied&toggle_focus=extension" . $urlBornes);
    exit;
}

/**
 * Check fields
 */
if ($action != '') {
    for ($i=0; $i<count($perm); $i++) {
        list($func, $p) = explode("|", $perm[$i]);
        $valA[$func][$p] = (($vals[$i]=='Y')?enumBoolean::bTrue:enumBoolean::bFalse);
        $updA[$func][$p] = (($vals[$i]=='Y')?' checked':'');
    }
}

/**
 * Actions
 */
if ($action == 'update') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "DELETE FROM " . $tablePrefix . "organizations_extension WHERE organization=$organization";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        foreach ($valA as $func => $pa) {
            $perm_read = $pa['Read'];
            $perm_write = $pa['Write'];
            $perm_edit = $pa['Edit'];
            $perm_admin = $pa['Admin'];
            $k = array_search($func, $listExtensions->ext_name);

            if ($k !== false && $perm_read == enumBoolean::bTrue) {
                $ext = $listExtensions->ext_id[$k];
                $tmpsql = "INSERT INTO " . $tablePrefix . "organizations_extension (organization,extension,perm_read,perm_write,perm_edit,perm_admin,created,cuser) VALUES ('$organization','$ext','$perm_read','$perm_write','$perm_edit','$perm_admin','" . time() . "','$idSession')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../clients/viewclient.php?id=$organization&msg=update&toggle_focus=extension" . $urlBornes);
        exit;
    }
}

/**
 * prepare data
 */
/**
 * get client extension list
 */
$querymore4 = " WHERE oge.organization='$organization' ORDER BY ext.name";
$listOrganizationExtensions = new request();
$listOrganizationExtensions->openOrganizationExtensions($querymore4);
$comptListOrganizationExtensions = count($listOrganizationExtensions->oge_organization);

if ($error == '') {
    for ($i=0; $i<$comptListExtensions; $i++) {
        $func = $listExtensions->ext_name[$i];
        $k = array_search($listExtensions->ext_name[$i], $listOrganizationExtensions->oge_ext_name);

        if ($k === false) {
            foreach (array('Read','Write','Edit','Admin') as $p) {
                $updA[$func][$p] = '';
            }
        } else {
            $updA[$func]['Read'] = ($listOrganizationExtensions->oge_perm_read[$k]== enumBoolean::bTrue)?' checked':'';
            $updA[$func]['Write'] = ($listOrganizationExtensions->oge_perm_write[$k]== enumBoolean::bTrue)?' checked':'';
            $updA[$func]['Edit'] = ($listOrganizationExtensions->oge_perm_edit[$k]== enumBoolean::bTrue)?' checked':'';
            $updA[$func]['Admin'] = ($listOrganizationExtensions->oge_perm_admin[$k]== enumBoolean::bTrue)?' checked':'';
        }
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
echo '<script type="text/javascript" src="../javascript/editclientextensions' . $scriptMinimized . '.js"></script>';
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../clients/listclients.php?" . $urlBornes, lang_strings("clients"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../clients/viewclient.php?toggle_focus=extension&id=" . $clientDetail->org_id[0] . $urlBornes, $clientDetail->org_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_client_extension"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "eCe";
$block1->openForm("../extensions/editclientextensions.php?organization=$organization" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" id="action" name="action" value="update">';
$block1->heading(lang_strings("edit_client_extension"));

for ($i=0; $i<$comptListExtensions; $i++) {
    $func = $listExtensions->ext_name[$i];
    $pi = 0;

    foreach (array('Read','Write','Edit','Admin') as $p) {
        echo '<input type="hidden" name="perm[' . $pi . ']" value="' . $func . '|' . $p . '">';
        $permA[$func][$p] = $pi++;
    }
}

$labels = array('', $strings["read"], $strings["write"], $strings["edit"], $strings['admin']);
$block1->openResults();
$block1->labels($labels, 'false', 'false', '', true);

for ($i=0; $i<$comptListExtensions; $i++) {
    $func = $listExtensions->ext_name[$i];
    $block1->openRow('', true);
    $block1->cellRow($block1->buildLink("javascript:funcChkAll('" . $func . "');", $listExtensions->ext_title[$i], 'in'));  // function name

    foreach (array('Read','Write','Edit','Admin') as $p) {
        $block1->cellRow('<input type="checkbox" name="vals[' . $permA[$func][$p] . ']" value="Y"' . $updA[$func][$p] . ' data-func="' . $func . '" data-level="' . $p . '">');
    }

    $block1->closeRow();
}

$block1->openRow('', true);
$block1->cellRow('&nbsp;');

foreach (array('Read' => $strings["read"], 'Write' => $strings["write"], 'Edit' => $strings["edit"], 'Admin' => $strings['admin']) as $level => $title) {
    $block1->cellRow($block1->buildLink("javascript:levelChkAll('" . $level . "');", $title, 'in'));
}

$block1->closeRow();
$block1->closeResults();
$block1->openContent();
$block1->contentRow('', '<input type="submit" name="Save" value="' . $strings["save"] . '">');
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
