<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editextension.php,v 1.4 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$tit = isset($_POST['tit'])?$_POST['tit']:'';           // extension title for mainmenu
$des = isset($_POST['des'])?$_POST['des']:'';           // extension description
$ver = isset($_POST['ver'])?$_POST['ver']:'';           // extension version
$act0 = isset($_POST['act'])?$_POST['act']:'';          // Determine whether an active extension
$act = (($act0=='Y')?enumBoolean::bTrue:enumBoolean::bFalse);
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Extension']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore = " WHERE ext.id='$id'";
$extensionDetail = new request();
$extensionDetail->openExtensions($querymore);
$comptExtensionDetail = count($extensionDetail->ext_id);

if ($comptExtensionDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
} else {
    $nam = $extensionDetail->ext_name[0];
}

/**
 * Actions
 */
if ($action == "update" && $error == '') {
    // replace quotes by html code
    $des = HtmlEntitiesNOD($des);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "UPDATE " . $tablePrefix . "extensions SET description='$des',version='$ver',active='$act',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'extensions', $id, 'U');
        updateString($requestAct, 'EXT__' . $nam, $tit);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../extensions/listextensions.php?show=all&msg=update" . $urlBornes);
        exit;
    }
}

if ($error == '') {
    $tit = $extensionDetail->ext_title[0];
    $des = $extensionDetail->ext_description[0];
    $ver = $extensionDetail->ext_version[0];
    $act = $extensionDetail->ext_active[0];
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../extensions/listextensions.php?" . $urlBornes, lang_strings("extension_management"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../extensions/viewextension.php?id=$id" . $urlBornes, $nam, 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_extension"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "extU";
$block1->openForm("../extensions/editextension.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" id="action" name="action" value="update">';
$block1->heading(lang_strings("edit_extension") . ' : ' . $nam);
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
setupInputHTML($block1, lang_strings('title'), 'tit', enumFieldType::ftText, 'Y', 255, $tit);
setupInputHTML($block1, lang_strings('description'), 'des', enumFieldType::ftMemo, 'N', 0, $des);
setupInputHTML($block1, lang_strings('version'), 'ver', array(enumFieldType::ftText, enumFieldOption::foVersionNumber), 'N', '255', $ver);
setupInputHTML($block1, lang_strings('status_active'), 'act', enumFieldType::ftBoolean, 'N', 1, $act);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
