<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportextension.php,v 1.4 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$action = isset($_POST['action'])?$_POST['action']:'';
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$ped = isset($_POST['ped'])?$_POST['ped']:'';
$exd = isset($_POST['exd'])?$_POST['exd']:'';
$ftd = isset($_POST['ftd'])?$_POST['ftd']:'';
$cfd = isset($_POST['cfd'])?$_POST['cfd']:'';
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Extension']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore = " WHERE ext.id='$id'";
$extensionDetail = new request();
$extensionDetail->openExtensions($querymore);
$comptExtensionDetail = count($extensionDetail->ext_id);

if ($comptExtensionDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
} else {
    $nam = $extensionDetail->ext_name[0];
    $ver = $extensionDetail->ext_version[0];
}

/**
 * Actions
 */
if ($action == "export" && $error == '') {
    // create ZIP file archive
    $zip = new ZipArchive();
    $tmpfname = tempnam(str_replace('//', '/', $basedir . '/files'), 'tmp');
    $zip->open($tmpfname, ZipArchive::OVERWRITE);
    // create extension definition XML document
    $doc1 = new DOMDocument('1.0', 'UTF-8');
    $doc1->formatOutput = true;
    $extension = $doc1->createElement("extension");
    $doc1->appendChild($extension);
    $extension->appendChild($doc1->createElement('name', $nam));                                         // extension name
    $extension->appendChild($doc1->createElement('title', $extensionDetail->ext_title[0]));              // extension title for mainmenu
    $extension->appendChild($doc1->createElement('description', $extensionDetail->ext_description[0]));  // extension description
    $extension->appendChild($doc1->createElement('version', $extensionDetail->ext_version[0]));          // extension version
    unset($dependencies);

    if (is_array($ped) && count($ped) > 0) {
        $dependencies = $doc1->createElement("dependencies");

        foreach ($ped as $ext) {
            $dependency = $doc1->createElement("dependency");
            $dependency->appendChild($doc1->createElement("type", "php_extension"));    // dependency type
            $dependency->appendChild($doc1->createElement("name", $ext));               // extension name
            $dependencies->appendChild($dependency);
        }
    }

    if (is_array($exd) && count($exd) > 0) {
        $exdS = "'" . implode("','", $exd) . "'";
        $querymore = " WHERE ext.name IN ($exdS)";
        $listExtensions = new request();
        $listExtensions->openExtensions($querymore);
        $comptListExtensions = count($listExtensions->ext_id);

        if ($comptListExtensions > 0) {
            if (!isset($dependencies)) {
                $dependencies = $doc1->createElement("dependencies");
            }

            for ($i=0; $i<$comptListExtensions; $i++) {
                $dependency = $doc1->createElement("dependency");
                $dependency->appendChild($doc1->createElement("type", "webtareas_extension"));            // dependency type
                $dependency->appendChild($doc1->createElement("name", $listExtensions->ext_name[$i]));    // extension name
                $dependencies->appendChild($dependency);
            }
        }
    }

    if (isset($dependencies)) {
        $extension->appendChild($dependencies);
    }

    // add extension definition XML document to ZIP file archive
    $zip->addFromString('extension.xml', $doc1->saveXML());
    // save extension definition XML document to __definition_documents__ folder
    $doc1->save($basedir . 'extensions/__definition_documents__/' . $nam . '.extension.xml');

    if (is_array($ftd) && count($ftd) > 0) {
        $ftdS = "'" . implode("','", $ftd) . "'";
        // export child custom form templates & custom form templates linked to fields along with selected custom form templates
        $querymore = " WHERE tdf.sysdef='N' AND (tdf.tablename IN ($ftdS) OR tdf.fathertable IN ($ftdS) OR tdf.tablename IN (SELECT fdf.linkedtable FROM " . $tablePrefix . "fields_def fdf INNER JOIN " . $tablePrefix . "tables_def tdf1 ON tdf1.tablename=fdf.tablename INNER JOIN " . $tablePrefix . "tables_def tdf2 ON tdf2.tablename=fdf.linkedtable WHERE tdf1.sysdef='N' AND tdf2.sysdef='N' AND (tdf1.tablename IN ($ftdS) OR tdf1.fathertable IN ($ftdS))) OR tdf.fathertable IN (SELECT fdf.linkedtable FROM " . $tablePrefix . "fields_def fdf INNER JOIN " . $tablePrefix . "tables_def tdf1 ON tdf1.tablename=fdf.tablename INNER JOIN " . $tablePrefix . "tables_def tdf2 ON tdf2.tablename=fdf.linkedtable WHERE tdf1.sysdef='N' AND tdf2.sysdef='N' AND (tdf1.tablename IN ($ftdS) OR tdf1.fathertable IN ($ftdS)))";

        if (is_array($cfd) && count($cfd) > 0) {
            $conditions = array();

            foreach ($cfd as $x) {
                list($tblnam, $fldnam) = split(':', $x);
                $conditions[] = "(fdf.tablename='$tblnam' AND fdf.fieldname='$fldnam')";
            }

            $querymore .= " OR tdf.tablename IN (SELECT fdf.linkedtable FROM " . $tablePrefix . "fields_def fdf INNER JOIN " . $tablePrefix . "tables_def tdf1 ON tdf1.tablename=fdf.tablename INNER JOIN " . $tablePrefix . "tables_def tdf2 ON tdf2.tablename=fdf.linkedtable WHERE tdf1.sysdef='N' AND tdf2.sysdef='N' AND (" . implode(" OR ", $conditions) . ")) OR tdf.fathertable IN (SELECT fdf.linkedtable FROM " . $tablePrefix . "fields_def fdf INNER JOIN " . $tablePrefix . "tables_def tdf1 ON tdf1.tablename=fdf.tablename INNER JOIN " . $tablePrefix . "tables_def tdf2 ON tdf2.tablename=fdf.linkedtable WHERE tdf1.sysdef='N' AND tdf2.sysdef='N' AND (" . implode(" OR ", $conditions) . "))";
        }

        $querymore .= ")";
        $listTablesDefinitions = new request();
        $listTablesDefinitions->openTablesDefinitions($querymore);
        $comptListTablesDefinitions = count($listTablesDefinitions->tdf_tablename);

        if ($comptListTablesDefinitions > 0) {
            $doc2 = exportFormTemplates($listTablesDefinitions);
            // add form template definition XML document to ZIP file archive
            $zip->addFromString('form_templates.xml', $doc2->saveXML());
            // save form template definition XML document to __definition_documents__ folder
            $doc2->save($basedir . 'extensions/__definition_documents__/' . $nam . '.form_templates.xml');
        }
    }

    if (is_array($cfd) && count($cfd) > 0) {
        $conditions = array();

        foreach ($cfd as $x) {
            list($tblnam, $fldnam) = split(':', $x);
            $conditions[] = "(fdf.tablename='$tblnam' AND fdf.fieldname='$fldnam')";
        }

        $querymore = " WHERE " . implode(" OR ", $conditions);
        $listFieldsDefinitions = new request();
        $listFieldsDefinitions->openFieldsDefinitions($querymore);
        $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

        if ($comptListFieldsDefinitions > 0) {
            $doc3 = exportCustomFields($listFieldsDefinitions);
            // add custom field definition XML document to ZIP file archive
            $zip->addFromString('custom_fields.xml', $doc3->saveXML());
            // save custom field definition XML document to __definition_documents__ folder
            $doc3->save($basedir . 'extensions/__definition_documents__/' . $nam . '.custom_fields.xml');
        }
    }

    $zip->addEmptyDir($nam . '/');
    $source = $basedir . 'extensions/' . $nam;
    $files = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($source), RecursiveIteratorIterator::SELF_FIRST);

    foreach ($files as $file) {
        $file = str_replace('\\', '/', $file);
        // Ignore "." and ".." folders
        if (in_array(substr($file, strrpos($file, '/')+1), array('.', '..'))) {
            continue;
        }

        $localname = $nam . '/' . str_replace($source . '/', '', $file);

        if (is_dir($file)) {
            $zip->addEmptyDir($localname . '/');
        } elseif (is_file($file)) {
            $zip->addFile($file, $localname);
        }
    }

    $zip->close();
    // MIMETypes should be handled using PHP mime.magic once it's out
    require_once('../includes/mimetypes.php');
    $mimetype = $mimetypes['zip'];
    header('Content-Length: ' . filesize($tmpfname));
    header('Content-Type: ' . $mimetype);
    header("Content-Disposition: attachment; filename=" . $nam . (($ver=='')?'':'-v'.$ver) . ".zip");
    // write file as response
    readfile($tmpfname);
    // delete temp file
    unlink($tmpfname);
    exit;
}

/**
 * get table definitions
 */
$querymore4 = " WHERE tdf.sysdef='N' ORDER BY tdf.tablename";
$listTablesDefinitions = new request();
$listTablesDefinitions->openTablesDefinitions($querymore4);
$comptListTablesDefinitions = count($listTablesDefinitions->tdf_tablename);

/**
 * get field definitions (system tables)
 */
$querymore5 = " WHERE fdf.sysdef='N' AND tdf.sysdef='Y' ORDER BY fdf.tablename,fdf.fieldname";
$listFieldsDefinitions = new request();
$listFieldsDefinitions->openFieldsDefinitions($querymore5);
$comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

/**
 * get extensions
 */
$querymore6 = " WHERE ext.id<>'$id' ORDER BY ext.name";
$listExtensions = new request();
$listExtensions->openExtensions($querymore6);
$comptListExtensions = count($listExtensions->ext_id);

/**
 * load extension definition XML document
 */
$file1 = $basedir . 'extensions/__definition_documents__/' . $nam . '.extension.xml';
$extDependencies = array();

if (file_exists($file1)) {
    $doc1 = new DOMDocument();
    $doc1->load($file1);
    $dependencies = $doc1->getElementsByTagName('dependency');

    if ($dependencies->length > 0) {
        foreach ($dependencies as $dependency) {
            $elements = $dependency->getElementsByTagName('type');
            $deptyp = $elements->item(0)->nodeValue;
            $elements = $dependency->getElementsByTagName('name');
            $depnam = $elements->item(0)->nodeValue;
            $extDependencies[$deptyp][$depnam] = enumBoolean::bTrue;
        }
    }
}

/**
 * load form template definition XML document
 */
$file2 = $basedir . 'extensions/__definition_documents__/' . $nam . '.form_templates.xml';
$formTemplates = array();

if (file_exists($file2)) {
    $doc2 = new DOMDocument();
    $doc2->load($file2);
    // The collection of form templates
    $form_templates = $doc2->getElementsByTagName("form_template");

    if ($form_templates->length > 0) {
        foreach ($form_templates as $form_template) {
            $elements = $form_template->getElementsByTagName("name");   // The name of form template
            $tblnam = $elements->item(0)->nodeValue;
            $formTemplates[$tblnam] = enumBoolean::bTrue;
        }
    }
}

/**
 * custom field definition XML document
 */
$file3 = $basedir . 'extensions/__definition_documents__/' . $nam . '.custom_fields.xml';
$customFields = array();

if (file_exists($file3)) {
    $doc3 = new DOMDocument();
    $doc3->load($file3);
    // The collection of custom fields
    $custom_fields = $doc3->getElementsByTagName('custom_field');

    if ($custom_fields->length > 0) {
        foreach ($custom_fields as $custom_field) {
            $elements = $custom_field->getElementsByTagName("table");   // The name of system table
            $tblnam = $elements->item(0)->nodeValue;
            $elements = $custom_field->getElementsByTagName("name");    // The name of custom field
            $fldnam = $elements->item(0)->nodeValue;
            $customFields[$tblnam][$fldnam] = enumBoolean::bTrue;
        }
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../extensions/listextensions.php?", lang_strings("extension_management"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../extensions/viewextension.php?id=$id", $nam, 'in'));
$blockPage->itemBreadcrumbs(lang_strings("export_extension"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "expU";
$block1->openForm("../extensions/exportextension.php?id=$id#" . $block1->form . "Anchor");
echo '<input type="hidden" id="action" name="action" value="export">';
$block1->heading(lang_strings("export_extension") . ' : ' . $nam);
$block1->openContent();
$block1->contentTitle($strings['required'] . ' PHP ' . $strings['extension']);
$content1 = '';

foreach (get_loaded_extensions() as $ext) {
    $content1 .= '<div style="float:left;margin-right:40px;margin-bottom:16px;"><input type="checkbox" name="ped[]" value="' . $ext . '"' . ((isset($extDependencies['php_extension'][$ext]))?' checked':'') . '>' . $ext . '</div>';
}

$block1->contentRow($content1);

if ($comptListExtensions > 0) {
    $block1->contentTitle($strings['required'] . ' webTareas ' . $strings['extension']);
    $content2 = '';

    for ($i=0; $i<$comptListExtensions; $i++) {
        $content2 .= '<div style="float:left;margin-right:40px;margin-bottom:16px;"><input type="checkbox" name="exd[]" value="' . $listExtensions->ext_name[$i] . '"' . ((isset($extDependencies['webtareas_extension'][$listExtensions->ext_name[$i]]))?' checked':'') . '>' . $listExtensions->ext_title[$i] . '</div>';
    }

    $block1->contentRow($content2);
}

if ($comptListTablesDefinitions > 0) {
    $block1->contentTitle($strings['required'] . ' ' . $strings['form_template']);
    $content3 = '';

    for ($i=0; $i<$comptListTablesDefinitions; $i++) {
        $tblnam = $listTablesDefinitions->tdf_tablename[$i];
        $content3 .= '<div style="float:left;margin-right:40px;margin-bottom:16px;"><input type="checkbox" name="ftd[]" value="' . $tblnam . '"' . ((isset($formTemplates[$tblnam]))?' checked':'') . '>' . tableNameString($tblnam) . '</div>';
    }

    $block1->contentRow($content3);
}

if ($comptListFieldsDefinitions > 0) {
    $block1->contentTitle($strings['required'] . ' ' . $strings['custom_field']);
    $content4 = '';

    for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
        $tblnam = $listFieldsDefinitions->fdf_tablename[$i];
        $fldnam = $listFieldsDefinitions->fdf_fieldname[$i];
        $content4 .= '<div style="float:left;margin-right:40px;margin-bottom:16px;"><input type="checkbox" name="cfd[]" value="' . $tblnam . ':' . $fldnam . '"' . ((isset($customFields[$tblnam][$fldnam]))?' checked':'') . '>' . fieldNameString($tblnam, $fldnam) . ' (' . tableNameString($tblnam) . ')' . '</div>';
    }

    $block1->contentRow($content4);
}

$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["export"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
