<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: importextension.php,v 1.9 2013/02/03 15:14:27 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = isset($_POST['action'])?$_POST['action']:'';
$act0 = isset($_POST['act'])?$_POST['act']:'';          // Determine whether an active extension
$atttmp = isset($_POST['atttmp1'])?$_POST['atttmp1']:'';
$attnam = isset($_POST['attnam1'])?$_POST['attnam1']:'';
$pre = isset($_POST['pre'])?$_POST['pre']:'S';
$act = (($act0=='Y')?enumBoolean::bTrue:enumBoolean::bFalse);
$error = '';
$extension = '';
$formtemplates = '';
$customfields = '';
$ext_id = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Extension']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * check data
 */
if ($action == "import") {
    try {
        $zip = new ZipArchive();

        if ($zip->open($atttmp) !== true) {   // check if file exists
            throw new Exception(str_replace('%FILE%', $attnam, $strings['load_file_fail']));
        }

        for ($i=0; $i<$zip->numFiles; $i++) {
            $x = $zip->getNameIndex($i);

            if ($x == 'extension.xml') {
                $extension = $i;
            } elseif ($x == 'form_templates.xml') {
                $formtemplates = $i;
            } elseif ($x == 'custom_fields.xml') {
                $customfields = $i;
            }
        }

        if ($extension === '') {
            throw new Exception($strings['invalid_fileformat']);
        }

        $doc1 = new DOMDocument();

        if ($doc1->loadXML($zip->getFromIndex($extension)) === false) {
            throw new Exception($strings['invalid_fileformat']);
        }

        $names = $doc1->getElementsByTagName('name');
        $titles = $doc1->getElementsByTagName('title');

        if ($names->length == 0 || $titles->length == 0) {
            throw new Exception($strings['invalid_fileformat']);
        } elseif ($names->item(0)->nodeValue == '' || $titles->item(0)->nodeValue == '') {
            throw new Exception($strings['invalid_fileformat']);
        }

        $nam = $names->item(0)->nodeValue;      // extension name

        if ($nam == '__definition_documents__') {
            throw new Exception($strings['no_permissions']);
        }

        $querymore1 = " WHERE ext.name='$nam'";
        $existExtension = new request();
        $existExtension->openExtensions($querymore1);

        if (count($existExtension->ext_id) > 0) {
            $ext_id = $existExtension->ext_id[0];

            if ($pre == 'S') {
                throw new Exception($strings['duplicate_entry_found']);
            }
        }

        // check dependencies
        $dependencies = $doc1->getElementsByTagName('dependency');

        if ($dependencies->length > 0) {
            foreach ($dependencies as $dependency) {
                $deptyp = $dependency->getElementsByTagName('type');
                $depnam = $dependency->getElementsByTagName('name');

                if ($deptyp->length > 0 && $depnam->length > 0) {
                    switch ($deptyp->item(0)->nodeValue) {
                        case 'php_extension':
                            $extnam = $depnam->item(0)->nodeValue;

                            if (!extension_loaded($extnam)) {
                                throw new Exception('PHP ' . $strings['extension'] . ' ' . $extnam . ' ' . $strings['error_required']);
                            }

                            break;
                        case 'webtareas_extension':
                            $extnam = $depnam->item(0)->nodeValue;
                            $querymore1 = " WHERE ext.name='$extnam'";
                            $existExtension = new request();
                            $existExtension->openExtensions($querymore1);

                            if (count($existExtension->ext_name) == '0') {
                                throw new Exception('webTareas ' . $strings['extension'] . ' ' . $extnam . ' ' . $strings['error_required']);
                            }

                            break;
                    }
                }
            }
        }

        if ($formtemplates !== '') {
            $doc2 = new DOMDocument();

            if ($doc2->loadXML($zip->getFromIndex($formtemplates)) === false) {
                throw new Exception($strings['invalid_fileformat']);
            }
        }

        if ($customfields !== '') {
            $doc3 = new DOMDocument();

            if ($doc3->loadXML($zip->getFromIndex($customfields)) === false) {
                throw new Exception($strings['invalid_fileformat']);
            }
        }

        $tit = $titles->item(0)->nodeValue;     // extension title
        $des = '';
        $ver = '';
        $desA = $doc1->getElementsByTagName('description');
        $verA = $doc1->getElementsByTagName('version');

        if ($desA->length > 0) {
            $des = $desA->item(0)->nodeValue;
        }

        if ($verA->length > 0) {
            $ver = $verA->item(0)->nodeValue;
        }
    } catch (Exception $e) {
        $error = $e->getMessage();
    }
}

/**
 * delete recursively a tree
 */
function delTree($dir)
{
    $files = array_diff(scandir($dir), array('.','..'));

    foreach ($files as $file) {
        (is_dir("$dir/$file")) ? delTree("$dir/$file") : unlink("$dir/$file");
    }

    return rmdir($dir);
}

/**
 * Actions
 */
if ($action == "import" && $error == '') {
    // replace quotes by html code
    $des = HtmlEntitiesNOD($des);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($formtemplates !== '') {
            importFormTemplates($doc2);
        }

        if ($customfields !== '') {
            importCustomFields($doc3);
        }

        if ($ext_id === '') {
            $tmpsql = "INSERT INTO " . $tablePrefix . "extensions (name,description,version,active,created,cuser) VALUES ('$nam','$des','$ver','$act','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            if (($num = $requestAct->newId("extensions")) === false) {
                throw new Exception('Unable to get new id of extension');
            }

            copy2HistoryTable($requestAct, 'extensions', $num, 'A');
        } else {
            $tmpsql = "UPDATE " . $tablePrefix . "extensions SET description='$des',version='$ver',active='$act',modified='" . time() . "',muser='$idSession' WHERE id='$ext_id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'extensions', $ext_id, 'U');
        }

        updateString($requestAct, 'EXT__' . $nam, $tit);

        if ($ext_id === '') {
            // full control by default for all user profiles
            $listUserProfiles = clone $requestAct;
            $listUserProfiles->openUserProfiles('');
            $comptListUserProfiles = count($listUserProfiles->upf_id);

            for ($i=0; $i<$comptListUserProfiles; $i++) {
                foreach (array('Read','Write','Edit','Admin') as $p) {
                    $tmpsql = "INSERT INTO " . $tablePrefix . "user_profiles_detail (user_profile,function_name,access_level,granted) VALUES ('" . $listUserProfiles->upf_id[$i] . "','#$nam','$p','" . enumBoolean::bTrue . "')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }
        } elseif ($pre == 'R') {
            // remove previous installation first
            delTree($basedir . 'extensions/' . $nam);
        }

        for ($i=0; $i<$zip->numFiles; $i++) {
            if ($i === $extension || $i === $formtemplates || $i === $customfields) {
                continue;
            }

            $zip->extractTo($basedir . 'extensions/', $zip->getNameIndex($i));
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
        // save extension definition XML document to __definition_documents__ folder
        $doc1->save($basedir . 'extensions/__definition_documents__/' . $nam . '.extension.xml');
        // save form template definition XML document to __definition_documents__ folder
        if ($formtemplates !== '') {
            $doc2->save($basedir . 'extensions/__definition_documents__/' . $nam . '.form_templates.xml');
        }
        // save custom field definition XML document to __definition_documents__ folder
        if ($customfields !== '') {
            $doc3->save($basedir . 'extensions/__definition_documents__/' . $nam . '.custom_fields.xml');
        }
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../extensions/listextensions.php?show=all&msg=add");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../extensions/listextensions.php?", lang_strings('extension_management'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("import_extension"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "imE";
$block1->openForm("../extensions/importextension.php?#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="import">';
$block1->heading(lang_strings("import_extension"));
$block1->openContent();
$block1->contentRow("*&nbsp;" . lang_strings("upload"), setupUploadFileHTML('1', '.zip', true));
setupInputHTML($block1, lang_strings('previous_exists'), 'pre', enumFieldType::ftAlphaNumeric, 'Y', 1, $pre, array('S'=>$strings['stop_import'], 'O'=>$strings['overwrite'], 'R'=>$strings['remove_previous_first']));
setupInputHTML($block1, lang_strings('active_immediately'), 'act', enumFieldType::ftBoolean, 'N', 1, $act);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["import"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
