<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listextensions.php,v 1.16 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$show = isset($_GET['show'])?$_GET['show']:'';

if ($show != 'all' && $show != 'inactive') {
    $show = 'active';
}

/**
 * Permission check
 */
if (!$SW_Permissions['Extension']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("extension_management"));

switch ($show) {
    case 'active':      // show active extensions only
        $blockPage->itemBreadcrumbs(lang_strings('status_active'));
        $title = $strings['extension_management'] . ' : ' . $strings['status_active'];
        break;
    case 'inactive':    // show inactive extensions only
        $blockPage->itemBreadcrumbs(lang_strings('status_inactive'));
        $title = $strings['extension_management'] . ' : ' . $strings['status_inactive'];
        break;
    default:            // show all extensions
        $blockPage->itemBreadcrumbs(lang_strings('all'));
        $title = $strings['extension_management'] . ' : ' . $strings['all'];
}

$blockPage->closeBreadcrumbs();
logURL($title, "../extensions/listextensions.php?show=$show");
$block1 = new block();
$block1->openHeading(lang_strings("extension_management"));
$block1->openViewOptions();

foreach (array('all' => lang_strings('all'), 'active' => lang_strings('status_active'), 'inactive' => lang_strings('status_inactive')) as $s => $desc) {
    if ($s != $show) {
        $block1->itemViewOptions($block1->buildLink('../extensions/listextensions.php?show=' . $s, $desc, 'in'));
    }
}

$block1->closeViewOptions();
$block1->closeHeading();
$block1->form = "modList";
$block1->openForm("../extensions/listextensions.php?show=$show#" . $block1->form . "Anchor");
$blockPage->bornesNumber = '1';
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '12';
$sortingFields = array("ext.name", "ext.version", "ext.active");
$block1->sorting("extensions", (isset($sortingUser['extensions'])?$sortingUser['extensions']:''), "ext.name ASC", $sortingFields);

switch ($show) {
    case 'active':
        $querymore = " WHERE ext.active='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
        break;
    case 'inactive':
        $querymore = " WHERE ext.active<>'" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
        break;
    default:
        $querymore = " ORDER BY " . $block1->sortingValue;
}

$block1->recordsTotal = compt($initrequest['extensions'] . ' ' . $querymore);
$listExtensions = new request();
$listExtensions->openExtensions($querymore, $block1->borne, $block1->rowsLimit);
$comptListExtensions = count($listExtensions->ext_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['name'];
$columns[0]->field_type = enumFieldType::ftAlphaNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['version'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['active_str'];
$columns[2]->field_type = enumFieldType::ftText;
$opt[enumCardviewOption::oObject] = 'extensions';
$opt[enumCardviewOption::oTableName] = 'extensions';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oAddUrl] = '../extensions/addextension.php?';
$opt[enumCardviewOption::oImportUrl] = '../extensions/importextension.php?';
$opt[enumCardviewOption::oExtraParameters] = '&borne1=' . $block1->borne;
$block1->openCardView($opt);

for ($i=0; $i<$comptListExtensions; $i++) {
    $content = array(
        $listExtensions->ext_name[$i],
        $listExtensions->ext_version[$i],
        ($listExtensions->ext_active[$i]== enumBoolean::bTrue)?$strings['yes']:$strings['no']
    );
    $block1->itemCardView($listExtensions->ext_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter("1", $blockPage->bornesNumber);
$block1->closeFormResults();
require_once("../includes/footer.php");
