<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: copyformtemplate.php,v 1.4 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$tblnam0 = isset($_POST['tblnam'])?$_POST['tblnam']:'';      // The name of new form template
$tblnam = strtolower($tblnam0);
$tbldes = isset($_POST['tbldes'])?$_POST['tbldes']:'';      // The description of new form template
$ctbls = isset($_POST['ctbls'])?$_POST['ctbls']:'';         // The unique id list of child form templates need to be copied
$ae0 = isset($_POST['ae'])?$_POST['ae']:'N';                 // The approval flag of new form template
$pe0 = isset($_POST['pe'])?$_POST['pe']:'N';                 // The publish flag of new form template
$pre0 = isset($_POST['pre'])?$_POST['pre']:'N';
$mm0 = isset($_POST['mm'])?$_POST['mm']:'N';
$his0 = isset($_POST['his'])?$_POST['his']:'N';
$ae = ($ae0=='')?'N':$ae0;
$pe = ($pe0=='')?'N':$pe0;
$pre = ($pre0=='')?'N':$pre0;
$mm = ($mm0=='')?'N':$mm0;
$his = ($his0=='')?'N':$his0;
$tbldispnam = tableNameString($id);

/**
 * Permission check
 */
$querymore1 = " WHERE tdf.tablename='$id'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore1);
$comptTableDefinitionDetail = count($tableDefinitionDetail->tdf_tablename);

if ($comptTableDefinitionDetail == '0') {   // check if form template exists
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($tableDefinitionDetail->tdf_sysdef[0] == 'Y') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (!$SW_Permissions['Form Template']['Edit'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Find the next id (postfix) for tablename
 */
function nextNum($tblnam) {
    $num = 0;
    $querymore = " WHERE tdf.tablename LIKE '" . $tblnam . "%'";
    $listTableDefinitions = new request();
    $listTableDefinitions->openTablesDefinitions($querymore);
    $comptListTableDefinitions = count($listTableDefinitions->tdf_id);

    if ($comptListTableDefinitions > 0) {
        foreach ($listTableDefinitions->tdf_tablename as $i0) {
            $i = str_replace($tblnam, '', $i0);

            if ($i !== '' && is_numeric($i) && intval($i) > $num) {
                $num = intval($i);
            }
        }
    }

    return ($num + 1);
}

/**
 * Copy form template
 *
 * @global string $tablePrefix
 * @global array $strings
 * @global string $db_mediumint_auto
 * @global string $db_mediumint
 * @global string $db_char1default0
 * @global string $db_char1
 * @global string $db_timestamp
 * @global string $db_create_table_postfix
 * @global array $fieldDataType
 * @global integer $idSession
 * @param class $requestAct Transaction object
 * @param string $id
 * @param string $tblnam
 * @param string $tbldes
 * @param string $ftbl
 * @param string $ae
 * @param string $pe
 * @param string $pre
 * @param string $mm
 * @param string $his
 * @throws Exception
 */
function copyFormTemplate($requestAct, $id, $tblnam, $tbldes, $ftbl, $ae, $pe, $pre, $mm, $his) {
    global $tablePrefix, $strings, $db_mediumint_auto, $db_mediumint, $db_char1default0, $db_char1, $db_timestamp, $db_create_table_postfix, $fieldDataType, $idSession;
    /**
     * copy form template definition
     */
    $tmpsql = "INSERT INTO " . $tablePrefix . "tables_def (tablename,sysdef,cfenabled,searchable,printable,mainmenu,keyfields,formfields,dispfields,dispstyle,listfields,primfields,fathertable,linkedfield,approvalenabled,publishenabled,history,created,cuser) SELECT '@$tblnam','N','Y',searchable,'$pre','$mm',keyfields,formfields,dispfields,dispstyle,listfields,primfields,'$ftbl','','$ae','$pe','$his','" . time() . "','$idSession' FROM " . $tablePrefix . "tables_def WHERE tablename='$id'";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }

    if ($tbldes != $strings['TBL__@' . $tblnam]) {
        updateString($requestAct, "TBL__@" . $tblnam, $tbldes);
    }
    /**
     * create new form template
     */
    $dbtblnam = $tablePrefix . "FORM_" . $tblnam;
    $tmpsql = "CREATE TABLE " . $dbtblnam . " (id $db_mediumint_auto" . (($ftbl=="")?"":",pid $db_mediumint") . ",status $db_mediumint,printed $db_char1default0,project $db_mediumint" . (($pe=='Y')?",published $db_char1":"") . ",created $db_timestamp,cuser $db_mediumint,modified $db_timestamp,muser $db_mediumint,PRIMARY KEY (id)) $db_create_table_postfix";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }

    if ($ftbl != '') {
        $tmpsql = "CREATE INDEX idxu" . $dbtblnam . "pid ON $dbtblnam (pid)";   // create index

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
    }

    if ($his == 'Y') {
        // create history log table
        $tmpsql = "CREATE TABLE " . $dbtblnam . "_hist (hid $db_mediumint_auto,action $db_char1,id $db_mediumint" . (($ftbl=="")?"":",pid $db_mediumint") . ",status $db_mediumint,printed $db_char1default0,project $db_mediumint" . (($pe=='Y')?",published $db_char1":"") . ",created $db_timestamp,cuser $db_mediumint,modified $db_timestamp,muser $db_mediumint,PRIMARY KEY (hid)) $db_create_table_postfix";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
        // create index
        $tmpsql = "CREATE INDEX idxu" . $dbtblnam . "_histid ON " . $dbtblnam . "_hist (id)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
    }
    /**
     * copy custom field definitions
     */
    $querymore2 = " WHERE fdf.tablename='$id'";
    $listFieldsDefinitions = clone $requestAct;
    $listFieldsDefinitions->openFieldsDefinitions($querymore2);
    $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

    if ($comptListFieldsDefinitions > 0) {
        $tmpsql = "INSERT INTO " . $tablePrefix . "fields_def (tablename,fieldname,fieldtype,length,default_value,required,unique_field,create_index,sysdef,published,linkedtable,disporder) SELECT '@$tblnam',fieldname,fieldtype,length,default_value,required,unique_field,create_index,sysdef,published,linkedtable,disporder FROM " . $tablePrefix . "fields_def WHERE tablename='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
            $fldnam = $listFieldsDefinitions->fdf_fieldname[$i];
            $flddes = $listFieldsDefinitions->fdf_fielddesc[$i];
            $fldtyp = $listFieldsDefinitions->fdf_fieldtype[$i];
            $len = $listFieldsDefinitions->fdf_length[$i];
            $req = $listFieldsDefinitions->fdf_required[$i];
            $defval = $listFieldsDefinitions->fdf_default_value[$i];
            $idx = $listFieldsDefinitions->fdf_create_index[$i];
            $uni = $listFieldsDefinitions->fdf_unique_field[$i];
            $tmpsql = "ALTER TABLE $dbtblnam ADD U_$fldnam";

            if ($fldtyp == enumFieldType::ftText) {
                $tmpsql .= ' ' . str_replace('%length%', intval($len)*4, $fieldDataType[$fldtyp]);
            } else if ($fldtyp == enumFieldType::ftNumeric || $fldtyp == enumFieldType::ftAlphaNumeric || $fldtyp == enumFieldType::ftSerial) {
                $tmpsql .= ' ' . str_replace('%length%', $len, $fieldDataType[$fldtyp]);
            } else {
                $tmpsql .= ' ' . $fieldDataType[$fldtyp];
            }

            // required field
            if ($req == 'Y') {
                $tmpsql .= ' NOT NULL';
            }

            // default value
            if ($defval != '') {
                switch ($fldtyp) {
                    case enumFieldType::ftText:
                    case enumFieldType::ftMemo:
                    case enumFieldType::ftAlphaNumeric:
                    case enumFieldType::ftNumeric:
                    case enumFieldType::ftTime:
                    case enumFieldType::ftEmail:
                    case enumFieldType::ftUrl:
                        $tmpsql .= " DEFAULT '$defval'";
                        break;
                    case enumFieldType::ftDate:
                        if (!preg_match('/^(\+|\-)\d+$/', $defval)) {
                            $tmpsql .= " DEFAULT '" . mktime(0,0,0,intval(substr($defval,4,2)),intval(substr($defval,6,2)),intval(substr($defval,0,4))) . "'";
                        }

                        break;
                    case enumFieldType::ftHours:
                    case enumFieldType::ftQuantity:
                    case enumFieldType::ftMeasure:
                    case enumFieldType::ftRate:
                    case enumFieldType::ftTotals:
                    case enumFieldType::ftPercentage:
                        $tmpsql .= " DEFAULT $defval";
                        break;
                    case enumFieldType::ftBoolean:
                        $tmpsql .= " DEFAULT '" . enumBoolean::bTrue . "'";
                        break;
                }
            }

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            // add history field in the database
            if ($his == 'Y') {
                $tmpsql = "ALTER TABLE " . $dbtblnam . "_hist ADD U_$fldnam";

                if ($fldtyp == enumFieldType::ftText) {
                    $tmpsql .= ' ' . str_replace('%length%', intval($len)*4, $fieldDataType[$fldtyp]);
                } else if ($fldtyp == enumFieldType::ftNumeric || $fldtyp == enumFieldType::ftAlphaNumeric || $fldtyp == enumFieldType::ftSerial) {
                    $tmpsql .= ' ' . str_replace('%length%', $len, $fieldDataType[$fldtyp]);
                } else {
                    $tmpsql .= ' ' . $fieldDataType[$fldtyp];
                }

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            // create index
            if ($idx == 'Y') {
                $tmpsql = "CREATE " . (($uni=='Y')?'UNIQUE':'') . " INDEX idxu$fldnam ON $dbtblnam (U_$fldnam)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            // update field description
            if ($flddes != fieldNameString($tblnam, $fldnam)) {
                updateString($requestAct, "FIE__" . $tblnam . "_" . $fldnam, $flddes);
            }
        }
    }

    /**
     * copy custom field valid values
     */
    $querymore3 = " WHERE fvd.tablename='$id'";
    $listFieldsValuesDefinitions = clone $requestAct;
    $listFieldsValuesDefinitions->openFieldsValuesDefinitions($querymore3);
    $comptListFieldsValuesDefinitions = count($listFieldsValuesDefinitions->fvd_tablename);

    if ($comptListFieldsValuesDefinitions > 0) {
        $tmpsql = "INSERT INTO " . $tablePrefix . "fields_valdef (tablename,fieldname,fieldvalue,sysdef) SELECT '@$tblnam',fieldname,fieldvalue,sysdef FROM " . $tablePrefix . "fields_valdef WHERE tablename='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        for ($i=0; $i<$comptListFieldsValuesDefinitions; $i++) {
            $tmpsql = "INSERT INTO " . $tablePrefix . "strings (string_key,language,string_val) SELECT 'VV__@" . $tblnam . "_" . $listFieldsValuesDefinitions->fvd_fieldname[$i] . "_" . $listFieldsValuesDefinitions->fvd_fieldvalue[$i] . "',language,string_val FROM " . $tablePrefix . "strings WHERE string_key='VV__" . $listFieldsValuesDefinitions->fvd_tablename[$i] . "_" . $listFieldsValuesDefinitions->fvd_fieldname[$i] . "_" . $listFieldsValuesDefinitions->fvd_fieldvalue[$i] . "'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }
    }
    /**
     * create index on pid if new form template has parent form template
     */
    if ($ftbl != '') {
        $tmpsql = "CREATE INDEX idxu" . $dbtblnam . "pid ON $dbtblnam (pid)";   // create index

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
    }
}

/**
 * Fetch data
 */
$querymore5 = " WHERE tdf.fathertable='$id'";
$listChildTables = new request();
$listChildTables->openTablesDefinitions($querymore5);
$comptListChildTables = count($listChildTables->tdf_id);
$ctblna = array();      // The name list of child form templates
$ctblda = array();      // The description list of child form templates
$ctblpa = array();      // The publish flag list of child form templates

for ($i=0; $i<$comptListChildTables; $i++) {
    $tdfid = $listChildTables->tdf_id[$i];
    $num = nextNum($listChildTables->tdf_tablename[$i]);
    $ctblna[$tdfid] = isset($_POST['ctbln' . $tdfid])?$_POST['ctbln' . $tdfid]:str_replace('@', '', $listChildTables->tdf_tablename[$i]) . $num;
    $ctblda[$tdfid] = isset($_POST['ctbld' . $tdfid])?$_POST['ctbld' . $tdfid]:tableNameString($listChildTables->tdf_tablename[$i]) . $num;
    $ctblpa[$tdfid] = isset($_POST['ctblp' . $tdfid])?(($_POST['ctblp' . $tdfid]=='Y')?'Y':'N'):$listChildTables->tdf_publishenabled[$i];
}

/**
 * Fields check
 */
if ($action == 'copy') {
    $requestCheck = new request();
    $requestCheck->connectClass();

    try {
        $tmpquery = "SELECT tdf.id FROM " . $tablePrefix . "tables_def tdf WHERE tdf.tablename='@$tblnam'";
        $requestCheck->query($tmpquery);

        if ($requestCheck->rowCount() > 0) {
            $bodyCommand = "onLoad=\"var x=document.ftCForm.tblnam;x.setAttribute('class','highlight');x.focus();\"";
            throw new Exception(lang_strings('formname_already_exists'));
        }

        if ($ctbls !== '') {     // some child form templates need to be copied
            foreach ($ctbls as $ctbl) {
                $ctbln = $ctblna[$ctbl];    // The name of new child form template
                $tmpquery = "SELECT tdf.id FROM " . $tablePrefix . "tables_def tdf WHERE tdf.tablename='@$ctbln'";
                $requestCheck->query($tmpquery);

                if ($requestCheck->rowCount() > 0) {
                    $bodyCommand = "onLoad=\"var x=document.ftCForm.ctbln" . $ctbl . ";x.setAttribute('class','highlight');x.focus();\"";
                    throw new Exception(lang_strings('formname_already_exists'));
                }
            }
        }
    } catch (Exception $e) {
        $error = $e->getMessage();
    }

    $requestCheck->close();
}

/**
 * Actions
 */
if ($error == '' && $action == 'copy') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copyFormTemplate($requestAct, $id, $tblnam, $tbldes, '', $ae, $pe, $pre, $mm, $his);
        $id = '@' . $tblnam;

        if ($ctbls !== '') {     // some child form templates need to be copied
            foreach ($ctbls as $ctbl) {
                $k = array_search($ctbl, $listChildTables->tdf_id);
                copyFormTemplate($requestAct, $listChildTables->tdf_tablename[$k], $ctblna[$ctbl], $ctblda[$ctbl], $id, 'N', $ctblpa[$ctbl], 'N', 'N', $his);
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../forms/viewformtemplate.php?id=$id&msg=add");
        exit;
    }
}

/**
 * Set value in form
 */
if ($error == '') {
    $num = nextNum($id);
    $tblnam = str_replace('@', '', $id) . $num;
    $tbldes = $tbldispnam . $num;
    $ae = $tableDefinitionDetail->tdf_approvalenabled[0];
    $pe = $tableDefinitionDetail->tdf_publishenabled[0];
    $pre = $tableDefinitionDetail->tdf_printable[0];
    $mm = $tableDefinitionDetail->tdf_mainmenu[0];
    $his = $tableDefinitionDetail->tdf_history[0];

    if ($comptListChildTables > 0) {
        $ctbls = $listChildTables->tdf_id;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=custom", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/listformtemplates.php?", lang_strings('form_templates'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/viewformtemplate.php?id=$id", $tbldispnam, 'in'));
$blockPage->itemBreadcrumbs(lang_strings("copy_form_template"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "ftC";
$block1->openForm("../forms/copyformtemplate.php?id=$id#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="copy">';
$block1->heading(lang_strings("copy_form_template") . " : " . $tbldispnam);
$block1->openContent();
setupInputHTML($block1, lang_strings("name"), 'tblnam', enumFieldType::ftAlphaNumeric, 'Y', '31', $tblnam);
setupInputHTML($block1, lang_strings("description"), 'tbldes', enumFieldType::ftText, 'Y', '255', $tbldes);
$block1->contentRow(lang_strings('enable_approvals'), '<input type="checkbox" name="ae" value="Y" ' . (($ae=='Y')?'checked':'') . '>');

if ($sitePublish == 'true') {
    $block1->contentRow(lang_strings('enable_publish'), '<input type="checkbox" id="pe" name="pe" value="Y" ' . (($pe=='Y')?'checked':'') . '>');
} else {
    echo '<input type="hidden" name="pe" value="N">';
}


$block1->contentRow(lang_strings('printable'), '<input type="checkbox" name="pre" value="Y" ' . (($pre=='Y')?'checked':'') . '>');
$block1->contentRow(lang_strings('createmainmenuitem'), '<input type="checkbox" name="mm" value="Y" ' . (($mm=='Y')?'checked':'') . '>');
$block1->contentRow(lang_strings('history_log'), '<input type="checkbox" name="his" value="Y" ' . (($his=='Y')?'checked':'') . '>');

if ($comptListChildTables > 0) {
    $block1->contentRow(lang_strings('include_following_form_templates'), "&nbsp;");
    $rval = '<table><tr><th></th><th>* ' . lang_strings('name') . '</th><th>* ' . lang_strings('description') . '</th><th>' . lang_strings('enable_publish') . '</th></tr>';

    for ($i=0; $i<$comptListChildTables; $i++) {
        $tdfid = $listChildTables->tdf_id[$i];
        $rval .= '<tr><td><input type="checkbox" name="ctbls[]" value="' . $tdfid . '"';

        if ($ctbls !== '' && in_array($tdfid, $ctbls)) {
            $rval .= ' checked';
        }

        $rval .= '></td>';
        $rval .= '<td><input type="input" id="ctbln' . $tdfid . '" name="ctbln' . $tdfid . '" value="' . $ctblna[$tdfid] . '"  maxlength="31"><strong id="ctbln' . $tdfid . 'S"></strong></td>';
        $__default_requireda[] = 'ctbln' . $tdfid;
        $__default_reqtypea[] = enumFieldType::ftAlphaNumeric;
        $__default_alphanuma[] = 'ctbln' . $tdfid;
        $rval .= '<td><input type="input" id="ctbld' . $tdfid . '" name="ctbld' . $tdfid . '" value="' . $ctblda[$tdfid] . '"  maxlength="255"><strong id="ctbld' . $tdfid . 'S"></strong></td>';
        $__default_requireda[] = 'ctbld' . $tdfid;
        $__default_reqtypea[] = enumFieldType::ftText;
        $rval .= '<td><input type="checkbox" name="ctblp' . $tdfid . '" value="Y"';

        if ($ctblpa[$tdfid] == 'Y') {
            $rval .= ' checked';
        }

        $rval .= '></td>';
        $rval .= '</tr>';
    }

    $rval .= '</table>';
    $block1->contentRow("&nbsp;", $rval, "false", "");
}

$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
