<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteclientforms.php,v 1.5 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$organization = AddSlashesNOD(isset($_GET['organization'])?$_GET['organization']:'');
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";

/**
 * Permission check
 */
if (!$SW_Permissions['Client']['Edit'][$profilSession] || $id == '') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore1 = " WHERE org.id='$organization'";
$clientDetail = new request();
$clientDetail->openOrganizations($querymore1);
$comptClientDetail = count($clientDetail->org_id);

if ($comptClientDetail == '0') {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

/**
 * Prepare data
 */
$querymore2 = " WHERE ogf.id IN ($ids)";
$listOrganizationForms = new request();
$listOrganizationForms->openOrganizationForms($querymore2);
$comptListOrganizationForms = count($listOrganizationForms->ogf_id);

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "DELETE FROM " . $tablePrefix . "organizations_form WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../clients/viewclient.php?id=' . $organization . '&msg=delete' . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../clients/listclients.php?" . $urlBornes, lang_strings("clients"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../clients/viewclient.php?id=" . $clientDetail->org_id[0] . $urlBornes, $clientDetail->org_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings('delete_client_form_templates'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'dEx';
$block1->openForm("../forms/deleteclientforms.php?organization=$organization&id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings('delete_client_form_templates'));
$block1->openContent();
$block1->contentTitle(lang_strings('delete_following'));

for ($i=0; $i<$comptListOrganizationForms; $i++) {
    $block1->contentRow('', $listOrganizationForms->ogf_tablename[$i] . ' - ' . tableNameString($listOrganizationForms->ogf_tablename[$i]));
}

$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
require_once('../includes/footer.php');
