<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteforms.php,v 1.7 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$tblnam = AddSlashesNOD(isset($_GET['tblnam'])?$_GET['tblnam']:'');
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$ids = str_replace('**', ',', $id);
$tbldispnam = tableNameString($tblnam);
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$proid = $project;
$error = '';

/**
 * Permission check
 */
$querymore1 = " WHERE tdf.tablename='$tblnam'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore1);
$comptTableDefinitionDetail = count($tableDefinitionDetail->tdf_tablename);

if ($comptTableDefinitionDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (!$SW_Permissions[$tblnam]['Admin'][$profilSession]) {
    header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . '&msg=permissiondenied' . $urlBornes);
    exit;
}

$querymore2 = " WHERE f.id IN ($ids) AND f.status='" . enumFileStatus::stNeedsApproval . "'";
$listForms = new request();
$listForms->openForms($tblnam, $querymore2);

if ($listForms->row_count != '0') {
    header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . '&msg=permissiondenied' . $urlBornes);
    exit;
}

if ($project == '') {
    $dbtblnam = $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0];
    $tmpquery = "SELECT project FROM $dbtblnam WHERE id IN ($ids)";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $request1->project = array();

    while ($request1->fetch()) {
        $request1->project[] = ($row[0]);
    }

    $request1->close();

    if (count($request1->project) > 1) {
        header('Location: ../general/permissiondenied.php');
        exit;
    } else {
        $proid = $request1->project[0];
    }
}

if ($proid != '0') {
    // check if the project exists
    $querymore3 = " WHERE pro.id='$proid'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore3);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }

    // check if the user is a team member of this project
    $querymore4 = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore4);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore5 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore5 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    // load project permission matrix and check the users permission
    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore5);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($permissionDetail->prp_delete_file[0] != enumBoolean::bTrue) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $dbtblnam = $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0];

        if ($tableDefinitionDetail->tdf_history[0] == 'Y') {
            copy2HistoryTable($requestAct, $tblnam, $ids, 'D');
        }

        $tmpsql = 'DELETE FROM ' . $dbtblnam . ' WHERE id IN (' . $ids . ')';

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $querymore6 = " WHERE tdf.fathertable='$tblnam'";
        $listChildTables = new request();
        $listChildTables->openTablesDefinitions($querymore6);
        $comptListChildTables = count($listChildTables->tdf_id);

        for ($i=0; $i<$comptListChildTables; $i++) {
            $dbtblnam = $tablePrefix . $listChildTables->tdf_dbtablename[$i];
            $tmpquery2 = "SELECT id FROM " . $dbtblnam . " WHERE pid IN ($ids)";
            $request2 = clone $requestAct;
            $request2->query($tmpquery2);
            $request2->rowid = array();

            while ($request2->fetch()) {
                $request2->rowid[] = ($row[0]);
            }

            if (count($request2->rowid) > 0) {
                $ids2 = implode(',', $request2->rowid);

                if ($listChildTables->tdf_history[$i] == 'Y') {
                    copy2HistoryTable($requestAct, $listChildTables->tdf_tablename[$i], $ids2, 'D');
                }

                $tmpsql = 'DELETE FROM ' . $dbtblnam . ' WHERE id IN (' . $ids2 . ')';

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        $tmpsql = "UPDATE " . $tablePrefix . "documents_approval SET canceled='Y',modified='" . time() . "' WHERE docid IN ($ids) AND doctype='" . $tableDefinitionDetail->tdf_id[0] . "'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . '&msg=delete' . $urlBornes);
        exit;
    }
}

/**
 * Prepare data
 */
$querymore7 = " WHERE f.id IN ($ids)";
$listForms = new request();
$listForms->openForms($tblnam, $querymore7);

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '') {
    $blockPage->itemBreadcrumbs(lang_strings('forms'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . $urlBornes, $tbldispnam, 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php?' . $urlBornes, lang_strings('projects'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . $urlBornes, lang_strings('form') . ' : ' . $tbldispnam, 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings('delete_forms'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'dfM';
$block1->openForm("../forms/deleteforms.php?tblnam=$tblnam&project=$project&id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings('delete_forms'));
$block1->openContent();
$block1->contentTitle(lang_strings('delete_following'));

for ($listForms->row_index=0; $listForms->row_index<$listForms->row_count; $listForms->row_index++) {
    $block1->contentRow('', HtmlEntityDecodeNOD($listForms->rows[$listForms->row_index]['description']));
}

$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
require_once('../includes/footer.php');
