<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteformtemplates.php,v 1.8 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Form Template']['Edit'][$profilSession] || $id == '') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$ida = explode("**", $id);
$ids = "('" . implode("','", $ida) . "')";
// system tables CANNOT be deleted
$querymore1 = " WHERE tdf.tablename IN $ids AND tdf.sysdef='Y'";
$listTableDefinitions1 = new request();
$listTableDefinitions1->openTablesDefinitions($querymore1);
$comptListTableDefinitions1 = count($listTableDefinitions1->tdf_tablename);

if ($comptListTableDefinitions1 > 0) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// tables with child tables need delete together
$querymore2 = " WHERE tdf.fathertable IN $ids AND tdf.tablename NOT IN $ids";
$listTableDefinitions2 = new request();
$listTableDefinitions2->openTablesDefinitions($querymore2);
$comptListTableDefinitions2 = count($listTableDefinitions2->tdf_tablename);

if ($comptListTableDefinitions2 > 0) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// table cannot be deleted if there is a filed linked to it
$querymore3 = " WHERE fdf.linkedtable IN $ids";
$listFieldsDefinitions = new request();
$listFieldsDefinitions->openFieldsDefinitions($querymore3);
$comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

if ($comptListFieldsDefinitions != '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// table cannot be deleted if there is an approval procedure based to it
$querymore4 = " WHERE app.doctype IN $ids";
$listApprovals = new request();
$listApprovals->openApprovals($querymore4);
$comptListApprovals = count($listApprovals->app_id);

if ($comptListApprovals != '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// table cannot be deleted if there is a document approval for this form template
$querymore5 = " WHERE dap.doctype IN $ids";
$listDocumentsApprovals = new request();
$listDocumentsApprovals->openDocumentsApproval($querymore5);
$comptListDocumentsApprovals = count($listDocumentsApprovals->dap_id);

if ($comptListDocumentsApprovals != '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// table cannot be delete if there is a project using it
$querymore6 = " WHERE pfm.tablename IN $ids";
$listProjectForms = new request();
$listProjectForms->openProjectsForm($querymore6);
$comptListProjectForms = count($listProjectForms->pfm_project);

if ($comptListProjectForms != '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Prepare data
 */
$querymore7 = " WHERE tdf.tablename IN $ids";
$listTableDefinitions = new request();
$listTableDefinitions->openTablesDefinitions($querymore7);
$comptListTableDefinitions = count($listTableDefinitions->tdf_tablename);

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        // delete table definitions
        $tmpsql = "DELETE FROM " . $tablePrefix . "tables_def WHERE tablename IN $ids";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
        // delete field definitions
        $tmpsql = "DELETE FROM " . $tablePrefix . "fields_def WHERE tablename IN $ids";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
        // delete field validvalue definitions
        $tmpsql = "DELETE FROM " . $tablePrefix . "fields_valdef WHERE tablename IN $ids";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
        // delete field filters
        $tmpsql = "DELETE FROM " . $tablePrefix . "field_filters WHERE tablename IN $ids";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tableList = array();

        for ($i=0; $i<$comptListTableDefinitions; $i++) {
            $tableList[] = $tablePrefix . $listTableDefinitions->tdf_dbtablename[$i];

            if ($listTableDefinitions->tdf_history[$i] == 'Y') {
                $tableList[] = $tablePrefix . $listTableDefinitions->tdf_dbtablename[$i] . '_hist';
            }
        }

        $tmpsql = "DROP TABLE IF EXISTS " . implode(',', $tableList);

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        foreach ($ida as $tblnam) {
            $tmpsql = "DELETE FROM " . $tablePrefix . "user_profiles_detail WHERE function_name='" . $tblnam . "'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "DELETE FROM " . $tablePrefix . "strings WHERE string_key='TBL__" . $tblnam . "'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "DELETE FROM " . $tablePrefix . "strings WHERE string_key LIKE 'FIE__" . $tblnam . "_%'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "DELETE FROM " . $tablePrefix . "strings WHERE string_key LIKE 'VV__" . $tblnam . "_%'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../forms/listformtemplates.php?msg=delete' . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=custom", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/listformtemplates.php?" . $urlBornes, lang_strings('form_templates'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('delete_form_templates'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'dEx';
$block1->openForm("../forms/deleteformtemplates.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings('delete_form_templates'));
$block1->openContent();
$block1->contentTitle(lang_strings('delete_following'));

for ($i=0; $i<$comptListTableDefinitions; $i++) {
    $block1->contentRow('', $listTableDefinitions->tdf_tablename[$i] . ' - ' . lang_strings('TBL__' . $listTableDefinitions->tdf_tablename[$i]));
}

$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
require_once('../includes/footer.php');
