<?php // $Revision: 1.17 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editform.php,v 1.17 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$tblnam = AddSlashesNOD(isset($_GET['tblnam'])?$_GET['tblnam']:'');
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$tbldispnam = tableNameString($tblnam);
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$cpy = isset($_GET['cpy'])?$_GET['cpy']:'';
$proid = $project;
$error = '';

/**
 * Permission check
 */
$querymore = " WHERE tdf.tablename='$tblnam'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore);
$comptTableDefinitionDetail = count($tableDefinitionDetail->tdf_tablename);

if ($comptTableDefinitionDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($id != '') {
    if (!$SW_Permissions[$tblnam]['Edit'][$profilSession]) {
        header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }

    $querymore = " WHERE f.id='$id'";
    $formDetail = new request();
    $formDetail->openForms($tblnam, $querymore);

    if ($formDetail->row_count == '0') {
        header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }

    $proid = $formDetail->rows[0]['project'];
} else {
    if (!$SW_Permissions[$tblnam]['Write'][$profilSession]) {
        header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }
}

if ($proid != '' && $proid != '0') {
    // check if the project exists
    $querymore = " WHERE pro.id='$proid'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }

    // check if the user is a team member of this project
    $querymore = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    // load project permission matrix and check the users permission
    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($id != '' && $cpy != 'true') {
        if ($permissionDetail->prp_add_file[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else {
        if ($permissionDetail->prp_update_file[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    }
}

$tmpquery = "SELECT fdf.tablename FROM " . $tablePrefix . "fields_def fdf WHERE fdf.tablename='$tblnam' AND fdf.sysdef='N'";
$comptCF = compt($tmpquery);

/**
 * Check fields
 */
if ($action == 'add' || $action == 'update') {
    $error = checkCustomFields($tblnam, $id, '0', false, ($cpy=='true'));
}

/**
 * Actions
 */
if ($error == '') {
    if ($action == 'add' || ($action == 'update' && $cpy == 'true')) {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsqls = setupCustomFieldsInsertSQL($tblnam);  // Generate custom fields insert sql
            $dbtblnam = $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0];
            $pro = (($project=='')?'0':$project);
            $status = enumFileStatus::stNoApprovalsNeeded;
            $tmpsql = "INSERT INTO $dbtblnam (status,project,created,cuser" . $cfsqls[0];

            if ($tableDefinitionDetail->tdf_publishenabled[0] == 'Y') {
                $tmpsql .= ",published";
            }

            $tmpsql .= ") VALUES ('$status','$pro','" . time() . "','$idSession'" . $cfsqls[1];

            if ($tableDefinitionDetail->tdf_publishenabled[0] == 'Y') {
                $tmpsql .= ",'" . enumPublished::pbNo . "'";
            }

            $tmpsql .= ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $sendto = $requestAct->newId($tblnam);
            $cfsql = setupCustomMediaFieldsUpdateSQL($tblnam, $sendto);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE $dbtblnam SET $cfsql WHERE id='$sendto'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            updateFormDetails($requestAct, $sendto, $pro);
            $num = $sendto;
            $producer = $idSession;
            $doctype = $tblnam;

            if (!defined('INNER_ADDDOCUMENT')) {
                define('INNER_ADDDOCUMENT', 1);
            }

            require('../approvals/adddocument.php');
            $querymore = " WHERE fil.id='1'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtForm, $sendto, $status, '1', $path, $tblnam);

            if ($tableDefinitionDetail->tdf_history[0] == 'Y') {
                copy2HistoryTable($requestAct, $tblnam, $num, 'A');
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if ($project == '-1') {
                $project = '';
            }

            header("Location: ../forms/viewform.php?tblnam=$tblnam&project=$project&id=$num&msg=add" . $urlBornes);
            exit;
        }
    } else if ($action == 'update') {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsql = setupCustomFieldsUpdateSQL($tblnam, $id);  // Generate custom fields update sql
            $dbtblnam = $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0];
            $status = enumFileStatus::stNoApprovalsNeeded;
            $tmpsql = "UPDATE $dbtblnam SET status='$status',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            updateFormDetails($requestAct, $id, $formDetail->rows[0]['project']);
            $num = $id;
            $producer = $idSession;
            $doctype = $tblnam;
            require('../approvals/updatedocument.php');
            $querymore5 = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtForm . "' AND fil.doc_type_ex='$tblnam' AND fil.doc_id='$id'";
            $listFiles = clone $requestAct;
            $listFiles->openFiles($querymore5);

            if (count($listFiles->fil_id) > 0) {
                $tmpsql = 'UPDATE ' . $tablePrefix . "files SET status='$status' WHERE doc_type='" . enumFileRelatedDocumentType::dtForm . "' AND doc_type_ex='$tblnam' AND doc_id='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $querymore = " WHERE fil.id='1'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtForm, $id, $status, '1', $path, $tblnam);

            if ($tableDefinitionDetail->tdf_history[0] == 'Y') {
                copy2HistoryTable($requestAct, $tblnam, $id, 'U');
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if ($project == '-1') {
                $project = '';
            }

            header("Location: ../forms/viewform.php?tblnam=$tblnam&project=$project&id=$num&msg=update" . $urlBornes);
            exit;
        }
    }
}

/**
 * Form initial
 */
if ($error == '') {
    if ($comptCF > 0) {
        $querymore = " WHERE fdf.tablename='$tblnam' AND fdf.fieldtype NOT IN ('" . enumFieldType::ftDate . "','" . enumFieldType::ftImage . "','" . enumFieldType::ftAudio . "','" . enumFieldType::ftVideo . "','" . enumFieldType::ftSerial . "') AND fdf.sysdef='N' ORDER BY fdf.disporder";
        $firstCustomField = new request();
        $firstCustomField->openFieldsDefinitions($querymore, '0', '1');

        if (count($firstCustomField->fdf_tablename) > 0) {
            $bodyCommand = 'onLoad="document.edFForm.U0' . $firstCustomField->fdf_fieldname[0] . '.focus();"';
        }
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');

if ($tableDefinitionDetail->tdf_javascript[0] != '') {
    includeJavaScript($tableDefinitionDetail->tdf_javascript[0], $tableDefinitionDetail->tdf_modified[0]);
}

$blockPage = new block();
$blockPage->openBreadcrumbs();  // start of breadcrumbs

if ($project == '') {
    $blockPage->itemBreadcrumbs(lang_strings('forms'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . $urlBornes, $tbldispnam, 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php?' . $urlBornes, lang_strings('projects'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . $urlBornes, lang_strings('form') . ' : ' . $tbldispnam, 'in'));
}

if ($id == '') {
    $blockPage->itemBreadcrumbs(lang_strings('add_form'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/viewform.php?tblnam=' . $tblnam . '&project=' . $project . '&id=' . $id . $urlBornes, HtmlEntityDecodeNOD($formDetail->rows[0]['description']), 'in'));

    if ($cpy == 'true') {
        $blockPage->itemBreadcrumbs(lang_strings('copy_form'));
    } else {
        $blockPage->itemBreadcrumbs(lang_strings('edit_form'));
    }
}

$blockPage->closeBreadcrumbs(); // end of breadcrumbs
$block1 = new block();
$block1->form = "edF";
$block1->openForm("../forms/editform.php?tblnam=$tblnam&project=$project&id=$id&cpy=$cpy" . $urlBornes . "#" . $block1->form . 'Anchor');

if ($id == '') {
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
    $block1->heading(lang_strings('add_form'));
} else {
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">";

    if ($cpy == 'true') {
        $block1->heading(lang_strings('copy_form') . ' : ' . HtmlEntityDecodeNOD($formDetail->rows[0]['description']));
    } else {
        $block1->heading(lang_strings('edit_form') . ' : ' . HtmlEntityDecodeNOD($formDetail->rows[0]['description']));
    }
}

if ($id != '' && $cpy != 'true') {
    $block1->openContent();
    $block1->contentTitle(lang_strings("info"));
    $block1->contentRow(lang_strings("id"), $formDetail->rows[0]['id']);

    if ($proid != '' && $proid != '0') {
        $block1->contentRow(lang_strings('project'), $blockPage->buildLink('../projects/viewproject.php?id=' . $proid . $urlBornes, $projectDetail->pro_name[0], 'in'));
    }

    if ($tableDefinitionDetail->tdf_approvalenabled[0]=='Y') {
        $block1->contentRow(lang_strings("status"), $statusFile[$formDetail->rows[0]['status']]);
    }

    $block1->contentRow(lang_strings("created"), createDate($formDetail->rows[0]['created'], 'both'));
    $block1->contentRow(lang_strings("created_by"), $blockPage->buildLink($formDetail->rows[0]['cuser'], '', 'message'));

    if ($formDetail->rows[0]['muser'] != '0') {
        $block1->contentRow(lang_strings("modified"), createDate($formDetail->rows[0]['modified'], 'both'));
        $block1->contentRow(lang_strings("modified_by"), $blockPage->buildLink($formDetail->rows[0]['muser'], '', 'message'));
    }

    if ($sitePublish=='true' && $tableDefinitionDetail->tdf_publishenabled[0]=='Y') {
        $block1->contentRow(lang_strings('published'), (($formDetail->rows[0]['published']==enumPublished::pbYes)?lang_strings('yes'):lang_strings('no')));
    }

    $block1->closeContent();
}

if ($comptCF > 0) {
    if ($comptCF < 10) {
        $block1->openContent();
    } else {
        $block1->openContent(true);
    }

    $block1->contentTitle(lang_strings("details"));
    setupCustomFieldsInputHTML($block1, $tblnam, $id, '0', false, ($cpy=='true'));
    $block1->closeContent();
}

setupFormDetailsInputHTML($tblnam, $id, false, $cpy);
$block1->openContent();
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();

if ($fileManagement == 'true') {
    setupAttachFilesHTML(($sitePublish=='true'));
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
function reloadForm(){
    var x = document.eExForm.action;
    x.value = 'reload';
    document.eExForm.submit();
}

function change_project(theObj)
{
    var proId = theObj.value;
    var newOrg = document.getElementById('orgName' + proId);
    document.getElementById('orgName').innerHTML = newOrg.value;
}
</script>
<?php
require_once('../includes/footer.php');
