<?php // $Revision: 1.17 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editformtemplate.php,v 1.17 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$tblnam0 = isset($_POST['tblnam'])?$_POST['tblnam']:$id;
$tblnam = strtolower($tblnam0);
$tbldes = isset($_POST['tbldes'])?$_POST['tbldes']:'';
$ftbl = isset($_POST['ftbl'])?$_POST['ftbl']:'';
$ae0 = isset($_POST['ae'])?$_POST['ae']:'N';
$pe0 = isset($_POST['pe'])?$_POST['pe']:'N';
$pre0 = isset($_POST['pre'])?$_POST['pre']:'N';
$mm0 = isset($_POST['mm'])?$_POST['mm']:'N';
$his0 = isset($_POST['his'])?$_POST['his']:'N';
$vu = isset($_POST['vu'])?$_POST['vu']:'';
$searchable = ($ftbl=='')?'Y':'N';
$ae = ($ae0=='')?'N':$ae0;
$pe = ($pe0=='')?'N':$pe0;
$pre = ($pre0=='')?'N':$pre0;
$mm = ($mm0=='')?'N':$mm0;
$his = ($his0=='')?'N':$his0;
$tbldispnam = tableNameString($tblnam);
$dispfields = isset($_POST['dispfields'])?$_POST['dispfields']:'';
$dispstyle = isset($_POST['dispstyle'])?$_POST['dispstyle']:'';
$formfields = isset($_POST['formfields'])?$_POST['formfields']:'';
$listfields = isset($_POST['listfields'])?$_POST['listfields']:'';
$primfields = isset($_POST['primfields'])?$_POST['primfields']:'';
$atttmp1 = isset($_POST['atttmp1'])?$_POST['atttmp1']:'';
$deljs = isset($_POST['deljs'])?$_POST['deljs']:'';
$error = '';

/**
 * Permission check
 */
if ($id != '') {
    $querymore = " WHERE tdf.tablename='$id'";
    $tableDefinitionDetail = new request();
    $tableDefinitionDetail->openTablesDefinitions($querymore);
    $comptTableDefinitionDetail = count($tableDefinitionDetail->tdf_tablename);

    if ($comptTableDefinitionDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    if ($action == "update" && $ftbl != $tableDefinitionDetail->tdf_fathertable[0]) {   // parent table changed
        if ($tableDefinitionDetail->tdf_fathertable[0] != '') {     // check if parent table empty
            $formDetail = new request();
            $formDetail->openForms($tableDefinitionDetail->tdf_fathertable[0], '');

            if ($formDetail->row_count != '0') {
                header('Location: ../general/permissiondenied.php');
                exit;
            }
        }
    }
}

if (!$SW_Permissions['Form Template']['Edit'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Fields check
 */
if ($action != '') {
    if ($id == '') {
        $querymore = " WHERE tdf.tablename='@$tblnam'";
        $listTableDefinitions = new request();
        $listTableDefinitions->openTablesDefinitions($querymore);
        $comptListTableDefinitions = count($listTableDefinitions->tdf_tablename);

        if ($comptListTableDefinitions > 0) {
            $error = lang_strings('formname_already_exists');
            $bodyCommand = "onLoad=\"var x=document.ftEForm.tblnam;x.setAttribute('class','highlight');x.focus();\"";
        }
    } else {
        if ($deljs == 'on') {
            $js = '';
        } else if ($atttmp1 == '') {
            $js = $tableDefinitionDetail->tdf_javascript[0];
        } else {
            $js = str_replace('@', 'form', $id) . '.js';
            uploadFile('JavaScript', $atttmp1, $js);
        }

        $js = HtmlEntitiesNOD($js);
    }
}

/**
 * Prepare data
 */
if ($id != '') {
    $querymore = " WHERE fdf.tablename='$id' AND fdf.fieldtype NOT IN ('" . enumFieldType::ftImage . "','" . enumFieldType::ftAudio . "','" . enumFieldType::ftVideo . "') ORDER BY fdf.disporder";
    $listFieldsDefinitions = new request();
    $listFieldsDefinitions->openFieldsDefinitions($querymore);
    $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);
    $querymore = " WHERE fdf.tablename='$id' AND fdf.fieldtype IN ('" . enumFieldType::ftText . "','" . enumFieldType::ftMemo . "','" . enumFieldType::ftAlphaNumeric . "','" . enumFieldType::ftEmail . "','" . enumFieldType::ftUrl . "','" . enumFieldType::ftSerial . "') ORDER BY fdf.disporder";
    $listTextFieldsDefinitions = new request();
    $listTextFieldsDefinitions->openFieldsDefinitions($querymore);
    $comptListTextFieldsDefinitions = count($listTextFieldsDefinitions->fdf_tablename);

    if ($action == '') {
        $dispstyle = $tableDefinitionDetail->tdf_dispstyle[0];
    } else {
        if ($dispstyle == '') {
            $dispstyle = enumDisplayStyle::dsMultipleColumnsWithoutTitle;
        }
    }
}

/**
 * Field filters for Print Enabled/Approval Enabled/Publish Enabled & Re-Order
 * @param array $fields
 * @param string $pre print enabled
 * @param string $ae approval enabled
 * @param string $pe publish enabled
 * @return array
 */
function fieldFiltersReorder($fields, $pre, $ae, $pe) {
    if ($pre != 'Y') {
        if (($key = array_search('printed', $fields)) !== false) {
            unset($fields[$key]);
        }
    }
    if ($ae != 'Y') {
        if (($key = array_search('status', $fields)) !== false) {
            unset($fields[$key]);
        }
    }
    if ($pe != 'Y') {
        if (($key = array_search('published', $fields)) !== false) {
            unset($fields[$key]);
        }
    }

    if (($key = array_search('id', $fields)) !== false) {
        unset($fields[$key]);
        array_unshift($fields, 'id');
    }

    return $fields;
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    // check if father table has history log table
    if ($ftbl != '' && ($id == '' || ($id != '' && $tableDefinitionDetail->tdf_sysdef[0] == 'N'))) {
        $querymore1 = " WHERE tdf.tablename='$ftbl'";
        $tableDefinitionDetail1 = new request();
        $tableDefinitionDetail1->openTablesDefinitions($querymore1);
        $his = $tableDefinitionDetail1->tdf_history[0];
    }

    // case update form template (custom table) entry
    if ($action == "update") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $skipHis = false;   // no history log file action needed
            $requestAct->startTransaction();
            $dbtblnam = $tablePrefix . str_replace('@', 'FORM_', $id);
            $tmpsql = "UPDATE " . $tablePrefix . "tables_def SET fathertable='$ftbl',searchable='$searchable',printable='$pre',mainmenu='$mm',approvalenabled='$ae',publishenabled='$pe',javascript='$js',dispstyle='$dispstyle',history='$his',modified='" . time() . "',muser='$idSession' WHERE tablename='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            if ($tableDefinitionDetail->tdf_sysdef[0] == 'N') {
                if ($his == 'Y' && $tableDefinitionDetail->tdf_history[0] == 'N') {
                    $skipHis = true;
                    // create history log table
                    $tmpsql = "CREATE TABLE " . $dbtblnam . "_hist (hid $db_mediumint_auto,action $db_char1,id $db_mediumint" . (($ftbl=="")?"":",pid $db_mediumint") . ",status $db_mediumint,printed $db_char1default0,project $db_mediumint" . (($pe=='Y')?",published $db_char1":"") . ",created $db_timestamp,cuser $db_mediumint,modified $db_timestamp,muser $db_mediumint,PRIMARY KEY (hid)) $db_create_table_postfix";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                    // create index
                    $tmpsql = "CREATE INDEX idxu" . $dbtblnam . "_histid ON " . $dbtblnam . "_hist (id)";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                } elseif ($his == 'N' && $tableDefinitionDetail->tdf_history[0] == 'Y') {
                    $skipHis = true;
                    $tmpsql = setup_drop_index_sql($dbtblnam . '_hist', 'id');   // delete index

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                    // drop history log table
                    $tmpsql = "DROP TABLE IF EXISTS " . $dbtblnam . "_hist";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }

            if ($ftbl != $tableDefinitionDetail->tdf_fathertable[0]) {
                if ($ftbl == "") {
                    $tmpsql = setup_drop_index_sql($dbtblnam, 'pid');   // delete index

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $tmpsql = "ALTER TABLE " . $dbtblnam . " DROP COLUMN pid";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    if ($skipHis == false && $his == 'Y') {
                        $tmpsql = setup_drop_index_sql($dbtblnam . '_hist', 'pid');   // delete index

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $tmpsql = "ALTER TABLE " . $dbtblnam . "_hist DROP COLUMN pid";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                } else if ($tableDefinitionDetail->tdf_fathertable[0] == '') {
                    $tmpsql = "ALTER TABLE " . $dbtblnam . " ADD COLUMN pid $db_mediumint";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $tmpsql = "CREATE INDEX idxu" . $dbtblnam . "pid ON $dbtblnam (pid)";   // create index

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    if ($skipHis == false && $his == 'Y') {
                        $tmpsql = "ALTER TABLE " . $dbtblnam . "_hist ADD COLUMN pid $db_mediumint";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                }
            }

            if ($tableDefinitionDetail->tdf_sysdef[0] == 'N' && $pe != $tableDefinitionDetail->tdf_publishenabled[0]) {
                if ($pe == 'Y') {
                    $tmpsql = "ALTER TABLE " . $dbtblnam . " ADD COLUMN published $db_char1";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    if ($skipHis == false && $his == 'Y') {
                        $tmpsql = "ALTER TABLE " . $dbtblnam . "_hist ADD COLUMN published $db_char1";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                } else {
                    $tmpsql = "ALTER TABLE " . $dbtblnam . " DROP COLUMN published";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    if ($skipHis == false && $his == 'Y') {
                        $tmpsql = "ALTER TABLE " . $dbtblnam . "_hist DROP COLUMN published";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                }
            }

            if ($ftbl == '') {
                if (is_array($dispfields)) {
                    $dispfieldsStr = implode('+', $dispfields);
                } else {
                    $dispfieldsStr = $dispfields;
                }

                if (is_array($formfields)) {
                    $formfields = fieldFiltersReorder($formfields, $pre, $ae, $pe);
                    $formfieldsStr = implode('+', $formfields);
                } else {
                    $formfieldsStr = $formfields;
                }

                if (is_array($listfields)) {
                    $listfields = fieldFiltersReorder($listfields, $pre, $ae, $pe);
                    $listfieldsStr = implode('+', $listfields);
                } else {
                    $listfieldsStr = $listfields;
                }

                if (is_array($primfields)) {
                    $primfieldsStr = implode('+', $primfields);
                } else {
                    $primfieldsStr = $primfields;
                }
            } else {
                $formfieldsStr = '';
                $listfieldsStr = '';
                $dispfieldsStr = '';
                $primfieldsStr = '';
            }

            $upda = array();

            if ($tableDefinitionDetail->tdf_formfields[0] != $formfieldsStr) {
                $upda[] = "formfields='$formfieldsStr'";
            }

            if ($tableDefinitionDetail->tdf_listfields[0] != $listfieldsStr) {
                $upda[] = "listfields='$listfieldsStr'";
            }

            if ($tableDefinitionDetail->tdf_dispfields[0] != $dispfieldsStr) {
                $upda[] = "dispfields='$dispfieldsStr'";
            }

            if ($tableDefinitionDetail->tdf_primfields[0] != $primfieldsStr) {
                $upda[] = "primfields='$primfieldsStr'";
            }

            if (count($upda) > 0) {
                $tmpsql = "UPDATE " . $tablePrefix . "tables_def SET " . implode(',', $upda) . " WHERE tablename='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            if ($tbldes != $strings['TBL__' . $id]) {
                updateString($requestAct, "TBL__" . $id, $tbldes);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../forms/viewformtemplate.php?id=$id&msg=update" . $urlBornes);
            exit;
        }
    }
    // case add form template (custom table) entry
    if ($action == "add") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "tables_def (tablename,sysdef,cfenabled,searchable,printable,mainmenu,keyfields,formfields,dispfields,dispstyle,primfields,fathertable,linkedfield,approvalenabled,publishenabled,history,created,cuser) VALUES ('@$tblnam','N','Y','$searchable','$pre','$mm','id','','','" . enumDisplayStyle::dsMultipleColumnsWithoutTitle . "','','$ftbl','','$ae','$pe','$his','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $dbtblnam = $tablePrefix . 'FORM_' . $tblnam;
            $tmpsql = "CREATE TABLE $dbtblnam (id $db_mediumint_auto" . (($ftbl=="")?"":",pid $db_mediumint") . ",status $db_mediumint,printed $db_char1default0,project $db_mediumint" . (($pe=='Y')?",published $db_char1":"") . ",created $db_timestamp,cuser $db_mediumint,modified $db_timestamp,muser $db_mediumint,PRIMARY KEY (id)) $db_create_table_postfix";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            if (!isset($strings['TBL__@' . $tblnam]) || $tbldes != $strings['TBL__@' . $tblnam]) {
                updateString($requestAct, "TBL__@" . $tblnam, $tbldes);
            }

            if ($ftbl != '') {
                $tmpsql = "CREATE INDEX idxu" . $dbtblnam . "pid ON $dbtblnam (pid)";   // create index

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            if ($his == 'Y') {
                // create history log table
                $tmpsql = "CREATE TABLE " . $dbtblnam . "_hist (hid $db_mediumint_auto,action $db_char1,id $db_mediumint" . (($ftbl=="")?"":",pid $db_mediumint") . ",status $db_mediumint,printed $db_char1default0,project $db_mediumint" . (($pe=='Y')?",published $db_char1":"") . ",created $db_timestamp,cuser $db_mediumint,modified $db_timestamp,muser $db_mediumint,PRIMARY KEY (hid)) $db_create_table_postfix";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
                // create index
                $tmpsql = "CREATE INDEX idxu" . $dbtblnam . "_histid ON " . $dbtblnam . "_hist (id)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
            // full control by default for all user profiles
            $listUserProfiles = clone $requestAct;
            $listUserProfiles->openUserProfiles('');
            $comptListUserProfiles = count($listUserProfiles->upf_id);

            for ($i=0; $i<$comptListUserProfiles; $i++) {
                foreach (array('Read','Write','Edit','Admin') as $p) {
                    $tmpsql = "INSERT INTO " . $tablePrefix . "user_profiles_detail (user_profile,function_name,access_level,granted) VALUES ('" . $listUserProfiles->upf_id[$i] . "','@$tblnam','$p','" . enumBoolean::bTrue . "')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }

            $id = '@' . $tblnam;
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../forms/viewformtemplate.php?id=$id&msg=add");
            exit;
        }
    }
}

/**
 * Fetch data
 */
if ($id != '') {
    $tmpquery = "SELECT * FROM " . $tablePrefix . "tables_def WHERE fathertable='$id'";
    $childTables = compt($tmpquery);
    $tmpquery = "SELECT fdf.* FROM " . $tablePrefix . "fields_def fdf WHERE fdf.tablename='$id' AND fdf.fieldtype IN ('" . enumFieldType::ftImage . "','" . enumFieldType::ftAudio . "','" . enumFieldType::ftVideo . "')";
    $mediaFieldNum = compt($tmpquery);
} else {
    $childTables = 0;
    $mediaFieldNum = 0;
}

if ($childTables == '0' && $mediaFieldNum == '0') {
    $querymore = " WHERE tdf.sysdef='N' AND (tdf.fathertable IS NULL OR tdf.fathertable='')";

    if ($id != '') {
        $querymore .= " AND tdf.tablename<>'$id'";
    }

    $listTableDefinitions = new request();
    $listTableDefinitions->openTablesDefinitions($querymore);
    $comptListTableDefinitions = count($listTableDefinitions->tdf_tablename);
} else {
    $comptListTableDefinitions = 0;
}

/**
 * Set value in form
 */
if ($error == '') {
    if ($id != '') {
        $ftbl = $tableDefinitionDetail->tdf_fathertable[0];
        $ae = $tableDefinitionDetail->tdf_approvalenabled[0];
        $pe = $tableDefinitionDetail->tdf_publishenabled[0];
        $pre = $tableDefinitionDetail->tdf_printable[0];
        $mm = $tableDefinitionDetail->tdf_mainmenu[0];
        $his = $tableDefinitionDetail->tdf_history[0];
        $vu = $tableDefinitionDetail->tdf_viewurl[0];
        $dispstyle = $tableDefinitionDetail->tdf_dispstyle[0];

        if ($tableDefinitionDetail->tdf_dispfields[0] == '') {
            $dispfields = array();
        } else {
            $dispfields = explode('+', $tableDefinitionDetail->tdf_dispfields[0]);
        }

        if ($tableDefinitionDetail->tdf_formfields[0] == '') {
            $formfields = array();
        } else {
            $formfields = explode('+', $tableDefinitionDetail->tdf_formfields[0]);
        }

        if ($tableDefinitionDetail->tdf_listfields[0] == '') {
            $listfields = array();
        } else {
            $listfields = explode('+', $tableDefinitionDetail->tdf_listfields[0]);
        }

        if ($tableDefinitionDetail->tdf_primfields[0] == '') {
            $primfields = array();
        } else {
            $primfields = explode('+', $tableDefinitionDetail->tdf_primfields[0]);
        }

        $tbldes = $strings['TBL__' . $tblnam];
        $bodyCommand = 'onLoad="document.ftEForm.tbldes.focus();"';
    } else {
        $ftbl = '';
        $ae = 'N';
        $pe = 'N';
        $pre = 'N';
        $mm = 'N';
        $his = 'N';
        $vu = '';
        $tbldes = '';
        $bodyCommand = 'onLoad="document.ftEForm.tblnam.focus();"';
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=custom", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/listformtemplates.php?" . $urlBornes, lang_strings('form_templates'), 'in'));

if ($id == "") {
    $blockPage->itemBreadcrumbs(lang_strings("add_form_template"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/viewformtemplate.php?id=$id" . $urlBornes, $tbldispnam, 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_form_template"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "ftE";
$block1->openForm("../forms/editformtemplate.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");

if ($id == "") {
    echo '<input type="hidden" name="action" value="add">';
} else {
    echo '<input type="hidden" name="action" value="update">';
}

if ($id == "") {
    $block1->heading(lang_strings("add_form_template"));
} else {
    $block1->heading(lang_strings("edit_form_template") . " : " . $tbldispnam);
}

$block1->openContent();

if ($id == "") {
    setupInputHTML($block1, lang_strings("name"), 'tblnam', enumFieldType::ftAlphaNumeric, 'Y', '31', $tblnam);
} else {
    $block1->contentRow(lang_strings("name"), $tblnam);
}

if (($id == '' || $tableDefinitionDetail->tdf_sysdef[0] == 'N') && $comptListTableDefinitions > 0) {
    $ftblContent = '<select id="ftbl" name="ftbl" onchange="ftblChanged();"><option value="" ' . (($ftbl=='')?'selected':'') . '></option>';

    for ($i=0; $i<$comptListTableDefinitions; $i++) {
        $fdispnam = ($strings['TBL__' . $listTableDefinitions->tdf_tablename[$i]]=='')?$listTableDefinitions->tdf_tablename[$i]:$strings['TBL__' . $listTableDefinitions->tdf_tablename[$i]];
        $ftblContent .= '<option value="' . $listTableDefinitions->tdf_tablename[$i] . '" ' . (($ftbl==$listTableDefinitions->tdf_tablename[$i])?'selected':'') . '>' . $fdispnam . '</option>';
    }

    $ftblContent .= '</select>';
    $block1->contentRow(lang_strings('parent_form_template'), $ftblContent);
} else {
    echo '<input type="hidden" id="ftbl" name="ftbl" value="">';
}

setupInputHTML($block1, lang_strings("description"), 'tbldes', enumFieldType::ftText, 'Y', '255', $tbldes);

if ($id == '' || $tableDefinitionDetail->tdf_sysdef[0] == 'N') {
    $block1->contentRow(lang_strings('enable_approvals'), '<input type="checkbox" name="ae" value="Y" ' . (($ae=='Y')?'checked':'') . '>');

    if ($sitePublish == 'true') {
        $block1->contentRow(lang_strings('enable_publish'), '<input type="checkbox" id="pe" name="pe" value="Y" ' . (($pe=='Y')?'checked':'') . '>');
    } else {
        echo '<input type="hidden" name="pe" value="N">';
    }

    $block1->contentRow(lang_strings('printable'), '<input type="checkbox" name="pre" value="Y" ' . (($pre=='Y')?'checked':'') . '>');
    $block1->contentRow(lang_strings('createmainmenuitem'), '<input type="checkbox" name="mm" value="Y" ' . (($mm=='Y')?'checked':'') . '>');
    $block1->contentRow(lang_strings('history_log'), '<input type="checkbox" name="his" value="Y" ' . (($his=='Y')?'checked':'') . '>');
    setupInputHTML($block1, lang_strings("view_url"), 'vu', enumFieldType::ftText, 'N', '255', $vu, '', '', false, '', 'onchange="parseViewURL();"');
} else {
    echo '<input type="hidden" name="ae" value="' . $tableDefinitionDetail->tdf_approvalenabled[0] . '">';
    echo '<input type="hidden" name="pe" value="' . $tableDefinitionDetail->tdf_publishenabled[0] . '">';
    echo '<input type="hidden" name="pre" value="' . $tableDefinitionDetail->tdf_printable[0] . '">';
    echo '<input type="hidden" name="mm" value="' . $tableDefinitionDetail->tdf_mainmenu[0] . '">';
    echo '<input type="hidden" name="his" value="' . $tableDefinitionDetail->tdf_history[0] . '">';
    echo '<input type="hidden" name="vu" value="' . $tableDefinitionDetail->tdf_viewurl[0] . '">';
}

if ($id != '') {
    if ($tableDefinitionDetail->tdf_searchable[0] == 'Y') {
        $dispfieldsSel = '<select name="dispfields[]" data-root="x" multiple>';

        for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
            $dispfieldsSel .= '<option value="' . $listFieldsDefinitions->fdf_dbfieldname[$i] . '"' . ((in_array($listFieldsDefinitions->fdf_dbfieldname[$i], $dispfields))?' selected':'') . '>' . fieldNameString($id, $listFieldsDefinitions->fdf_fieldname[$i]) . '</option>';
        }

        $dispfieldsSel .= '</select>';
        $block1->contentRow(lang_strings("display_fields"), $dispfieldsSel);
        $dispstyleSel = '<select name="dispstyle" data-root="x">';

        foreach ($fieldsDisplayStyle as $k => $v) {
            $dispstyleSel .= '<option value="' . $k . '"' . (($dispstyle==$k)?' selected':'') . '>' . $v . '</option>';
        }

        $dispstyleSel .= '</select>';
        $block1->contentRow(lang_strings("display_style"), $dispstyleSel);
    } else {
        echo '<input type="hidden" name="dispfields" value="">';
        echo '<input type="hidden" name="dispstyle" value="' . enumDisplayStyle::dsMultipleRowsWithTitle . '">';
    }

    if ($tableDefinitionDetail->tdf_sysdef[0] == 'N') {
        $formfieldsSel = '<select name="formfields[]" data-root="x" multiple>';

        for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
            $formfieldsSel .= '<option value="' . $listFieldsDefinitions->fdf_dbfieldname[$i] . '"' . ((in_array($listFieldsDefinitions->fdf_dbfieldname[$i], $formfields))?' selected':'') . '>' . fieldNameString($id, $listFieldsDefinitions->fdf_fieldname[$i]) . '</option>';
        }

        foreach ($reservedDbFields as $k => $d) {
            $formfieldsSel .= '<option value="' . $k . '"' . ((in_array($k, $formfields))?' selected':'') . '>' . $d . '</option>';
        }

        $formfieldsSel .= '</select>';
        $block1->contentRow(lang_strings('form_fields'), $formfieldsSel);
    } else {
        echo '<input type="hidden" name="formfields" value="">';
    }

    $listfieldsSel = '<select name="listfields[]" data-root="x" multiple>';

    for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
        $listfieldsSel .= '<option value="' . $listFieldsDefinitions->fdf_dbfieldname[$i] . '"' . ((in_array($listFieldsDefinitions->fdf_dbfieldname[$i], $listfields))?' selected':'') . '>' . fieldNameString($id, $listFieldsDefinitions->fdf_fieldname[$i]) . '</option>';
    }

    foreach ($reservedDbFields as $k => $d) {
        $listfieldsSel .= '<option value="' . $k . '"' . ((in_array($k, $listfields))?' selected':'') . '>' . $d . '</option>';
    }

    $listfieldsSel .= '</select>';
    $block1->contentRow(lang_strings('list_fields'), $listfieldsSel);

    if ($tableDefinitionDetail->tdf_sysdef[0] == 'N' && $tableDefinitionDetail->tdf_searchable[0] == 'Y' && $comptListTextFieldsDefinitions > 0) {
        $primfieldsSel = '<select name="primfields[]" data-root="x" multiple>';

        for ($i=0; $i<$comptListTextFieldsDefinitions; $i++) {
            $primfieldsSel .= '<option value="' . $listTextFieldsDefinitions->fdf_dbfieldname[$i] . '"' . ((in_array($listTextFieldsDefinitions->fdf_dbfieldname[$i], $primfields))?' selected':'') . '>' . fieldNameString($id, $listTextFieldsDefinitions->fdf_fieldname[$i]) . '</option>';
        }

        $primfieldsSel .= '</select>';
        $block1->contentRow(lang_strings("primary_search_fields"), $primfieldsSel);
    } else {
        echo '<input type="hidden" name="primfields" value="">';
    }

    if ($tableDefinitionDetail->tdf_sysdef[0] == 'N') {
        $fcs = setupUploadFileHTML('1', ".js");

        if ($tableDefinitionDetail->tdf_javascript[0] != '') {
            $fcs .= '<br><input type="checkbox" name="deljs" value="on">' . lang_strings('delete');
            $fcs .= '<br>' . $tableDefinitionDetail->tdf_javascript[0];
        }

        $block1->contentRow(lang_strings('form_control_script'), $fcs);
    }
}

$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
ftblChanged();

function ftblChanged() {
    var x = $("#ftbl").val();

    if (x === '') {
        $("[data-root='x']").each(function () {$(this).parentsUntil('.contentRow').show();});
    } else {
        $("[data-root='x']").each(function () {$(this).parentsUntil('.contentRow').hide();});
    }
}

function parseViewURL() {
    var u = $('#vu').val();
    var p = /(extensions\/.+\.php)/;
    var r = u.match(p);

    if (r === null) {
        $('#vu').val('');
    } else {
        $('#vu').val(r[0]);
    }
}
</script>
<?php
require_once("../includes/footer.php");
