<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: importformtemplates.php,v 1.9 2013/02/03 15:14:27 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = isset($_POST['action'])?$_POST['action']:'';
$atttmp = isset($_POST['atttmp1'])?$_POST['atttmp1']:'';
$attnam = isset($_POST['attnam1'])?$_POST['attnam1']:'';
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Form Template']['Edit'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Actions
 */
if ($action == "import") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $doc = new DOMDocument();

        if ($doc->load($atttmp) === false) {   // check if file exists
            throw new Exception(str_replace('%FILE%', $attnam, $strings['load_file_fail']));
        }

        importFormTemplates($doc);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../forms/listformtemplates.php?msg=add");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=custom", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/listformtemplates.php?", lang_strings('form_templates'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("import_formtemplates"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "imF";
$block1->openForm("../forms/importformtemplates.php?#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="import">';
$block1->heading(lang_strings("import_formtemplates"));
$block1->openContent();
$block1->contentRow("*&nbsp;" . lang_strings("upload"), setupUploadFileHTML('1', '.xml', true));
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["import"] . "\">");
$block1->closeContent();
$block1->note(lang_strings('importformtemplates_help'));
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
