<?php // $Revision: 1.18 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listforms.php,v 1.18 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$tblnam = AddSlashesNOD(isset($_GET['tblnam'])?$_GET['tblnam']:'');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';

if ($sitePublish == 'true') {
    $action = isset($_GET['action'])?$_GET['action']:'';
    $addToSite = isset($_GET['addToSite'])?$_GET['addToSite']:'';
    $removeToSite = isset($_GET['removeToSite'])?$_GET['removeToSite']:'';
}

$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$ids = "'" . str_replace("**", "','", $id) . "'";
$proid = $project;

/**
 * Prepare data
 */
$querymore = " WHERE tdf.tablename='$tblnam' AND tdf.sysdef='N' AND tdf.mainmenu='Y' AND tdf.fathertable=''";
$listTablesDefinitions = new request();
$listTablesDefinitions->openTablesDefinitions($querymore);
$comptListTablesDefinitions = count($listTablesDefinitions->tdf_tablename);

/**
 * Permission check
 */
if ($comptListTablesDefinitions == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (!$SW_Permissions[$tblnam]['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($action == 'publish' && $project == '') {
    $dbtblnam = $tablePrefix . $listTablesDefinitions->tdf_dbtablename[0];
    $tmpquery = "SELECT project FROM $dbtblnam WHERE id IN ($ids)";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $request1->project = array();

    while ($request1->fetch()) {
        $request1->project[] = ($row[0]);
    }

    $request1->close();

    if (count($request1->project) > 1) {
        header('Location: ../general/permissiondenied.php');
        exit;
    } else {
        $proid = $request1->project[0];
    }
}

if ($proid != '' && $proid != '0') {
    // check if the project exists
    $querymore = " WHERE pro.id='$proid'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject');
        exit;
    }

    // check if the user is a team member of this project
    $querymore = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    // load project permission matrix and check the users permission
    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($permissionDetail->prp_view_project[0] != enumBoolean::bTrue) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    if ($action == 'publish') {
        if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . '&msg=permissiondenied');
            exit;
        }

        if ($permissionDetail->prp_publish_file[0] != enumBoolean::bTrue) {
            header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . '&msg=permissiondenied');
            exit;
        }
    }
}

/**
 * Actions
 */
if ($action == "publish") {
    $dbtblnam = $tablePrefix . $listTablesDefinitions->tdf_dbtablename[0];
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($addToSite == "true") {
            $tmpsql = "UPDATE $dbtblnam SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids) AND published<>'" . enumPublished::pbYes ."'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = "addToSite";
        } else if ($removeToSite == "true") {
            $tmpsql = "UPDATE $dbtblnam SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids) AND published<>'" . enumPublished::pbNo ."'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = "removeToSite";
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '') {
    $blockPage->itemBreadcrumbs(lang_strings('forms'));
    $blockPage->itemBreadcrumbs(tableNameString($tblnam));
    $title = $strings['forms'] . ' ' . tableNameString($tblnam);
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php' . $urlBornes, lang_strings('projects'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings('form') . ' : ' . tableNameString($tblnam));
    $title = $strings['forms'] . ' ' . tableNameString($tblnam) . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '2';     // 1st for listprojects
logURL($title, '../forms/listforms.php?tblnam=' . $tblnam . '&form=' . $listTablesDefinitions->tdf_tablename[0] . '&project=' . $project);
$formfields = $listTablesDefinitions->tdf_formfields[0];

if ($formfields == '') {
    $blockPage->note(lang_strings('form') . ' ' . tableNameString($listTablesDefinitions->tdf_tablename[0]) . ' has no field(s) shown in the form list. ' . $blockPage->buildLink('../forms/editformtemplate.php?id=' . $tblnam, 'Please choose field(s) shown in the form list first', 'in'));
} else {
    $block1 = new block();
    $block1->form = 'lsF' . $listTablesDefinitions->tdf_id[0];
    $block1->openForm('../forms/listforms.php?tblnam=' . $tblnam . '&amp;form=' . $listTablesDefinitions->tdf_tablename[0] . '&amp;project=' . $project . $urlBornes . '#' . $block1->form . 'Anchor');
    $block1->heading(lang_strings('form') . ' : ' . tableNameString($listTablesDefinitions->tdf_tablename[0]));
    $block1->borne = $blockPage->returnBorne('2');
    $block1->rowsLimit = 12;
    $formfielda = explode('+', $formfields);
    $sortingFields = array();

    foreach ($formfielda as $f) {
        switch ($f) {
            case 'cuser':
                $sortingFields[] = 'c.name';
                break;
            case 'muser':
                $sortingFields[] = 'm.name';
                break;
            default:
                $sortingFields[] = 'f.' . $f;
        }
    }

    $sortRef = $listTablesDefinitions->tdf_tablename[0];
    $block1->sorting($sortRef, (isset($sortingUser[$sortRef])?$sortingUser[$sortRef]:''), 'f.created DESC', $sortingFields);
    $sf = str_replace(array('ASC', 'DESC', ' '), '', $block1->sortingValue);

    if (!in_array($sf, $sortingFields)) {
        $block1->sortingValue = 'f.created DESC';
    }

    if ($project == '') {
        $querymore = " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=f.project AND tea.member='$idSession' LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=f.project AND prp.profil=tea.profil WHERE (f.project='0' OR (f.project<>'0' AND prp.view_file='" . enumBoolean::bTrue . "')) ORDER BY " . $block1->sortingValue;
    } else {
        $querymore = " WHERE f.project='$project' ORDER BY " . $block1->sortingValue;
    }

    $listForms = new request();
    $block1->recordsTotal = compt("SELECT f.* FROM $tablePrefix" . $listTablesDefinitions->tdf_dbtablename[0] . " f " . $querymore);
    $listForms->openForms2($listTablesDefinitions->tdf_tablename[0], $querymore, $block1->borne, $block1->rowsLimit);
    $tblnamL = $listTablesDefinitions->tdf_tablename[0];
    // fields definitions
    $querymore1 = " WHERE fdf.tablename='$tblnamL'";
    $listFieldsDefinitions = new request();
    $listFieldsDefinitions->openFieldsDefinitions($querymore1);
    $columns = array();
    $cc = 0;

    foreach ($formfielda as $dbfldnam) {
        $col = new cardviewColumn();

        if (array_key_exists($dbfldnam, $reservedDbFields)) {
            $col->title = $reservedDbFields[$dbfldnam];

            if (is_array($reservedDbFieldsDef['validvalues'][$dbfldnam])) {
                $col->field_type = enumFieldType::ftText;
            } else {
                $col->field_type = $reservedDbFieldsDef['type'][$dbfldnam];
            }

            if (isset($reservedDbFieldsDef['linked_table'][$dbfldnam])) {
                $col->linked_table = $reservedDbFieldsDef['linked_table'][$dbfldnam];
            }
        } else {
            $key = array_search($dbfldnam, $listFieldsDefinitions->fdf_dbfieldname);
            $col->title = fieldNameString($tblnamL, $listFieldsDefinitions->fdf_fieldname[$key]);
            $querymore = " WHERE fvd.tablename='$tblnam' AND fvd.fieldname='" . $listFieldsDefinitions->fdf_fieldname[$key] . "' ORDER BY fvd.fieldvalue";
            $listFieldsValuesDefinitions = new request();
            $listFieldsValuesDefinitions->openFieldsValuesDefinitions($querymore);
            $comptListFieldsValuesDefinitions = count($listFieldsValuesDefinitions->fvd_id);

            if ($comptListFieldsValuesDefinitions > 0) {
                for ($i=0; $i<$comptListFieldsValuesDefinitions; $i++) {
                    $listFieldsDefinitions->fdf_validvalues[$key][$listFieldsValuesDefinitions->fvd_fieldvalue[$i]] = $listFieldsValuesDefinitions->fvd_fieldvalue_desc[$i];
                }
            } else {
                $listFieldsDefinitions->fdf_validvalues[$key] = '';
            }

            if (is_array($listFieldsDefinitions->fdf_validvalues[$key])) {
                $col->field_type = enumFieldType::ftText;
            } else {
                $col->field_type = $listFieldsDefinitions->fdf_fieldtype[$key];
            }
        }

        $columns[$cc++] = $col;
    }

    if ($project == '') {
        $opt[enumCardviewOption::oObject] = 'forms';
    } else {
        $opt[enumCardviewOption::oObject] = 'project_forms';
    }

    $opt[enumCardviewOption::oTableName] = $tblnam;
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oExtraParameters] = $urlBornes . '&borne2=' . $block1->borne;

    if ($listTablesDefinitions->tdf_searchable[0] == 'Y') {
        $opt[enumCardviewOption::oSearch] = true;
    }

    if ($project == '') {
        if ($SW_Permissions[$tblnam]['Write'][$profilSession]) {
            $opt[enumCardviewOption::oAddUrl] = '../forms/editform.php?tblnam=' . $listTablesDefinitions->tdf_tablename[0];
        }
    } else {
        if ($project != '' && $projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
            $opt[enumCardviewOption::oAddUrl] = '../forms/editform.php?tblnam=' . $listTablesDefinitions->tdf_tablename[0] . '&project=' . $project . $urlBornes;
        }
    }

    $block1->openCardView($opt);

    for ($listForms->row_index=0; $listForms->row_index<$listForms->row_count; $listForms->row_index++) {
        $content = array();

        foreach ($formfielda as $dbfldnam) {
            if (array_key_exists($dbfldnam, $reservedDbFields)) {
                if (is_array($reservedDbFieldsDef['validvalues'][$dbfldnam])) {
                    $fldtyp = $reservedDbFieldsDef['type'][$dbfldnam];
                    $fldvv = $reservedDbFieldsDef['validvalues'][$dbfldnam];
                    $content[] = DbValueDecode($fldtyp, $listForms->rows[$listForms->row_index][$dbfldnam], $fldvv);
                } else {
                    $content[] = $listForms->rows[$listForms->row_index][$dbfldnam];
                }
            } else {
                $key = array_search($dbfldnam, $listFieldsDefinitions->fdf_dbfieldname);

                if (is_array($listFieldsDefinitions->fdf_validvalues[$key])) {
                    $fldtyp = $listFieldsDefinitions->fdf_fieldtype[$key];
                    $fldvv = $listFieldsDefinitions->fdf_validvalues[$key];
                    $content[] = DbValueDecode($fldtyp, $listForms->rows[$listForms->row_index][$dbfldnam], $fldvv);
                } else {
                    $content[] = $listForms->rows[$listForms->row_index][$dbfldnam];
                }
            }
        }

        $block1->itemCardView($listForms->rows[$listForms->row_index]['id'], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter("2", $blockPage->bornesNumber, 'tblnam=' . $listTablesDefinitions->tdf_tablename[0] . '&project=' . $project);
    $block1->closeFormResults();
}

require_once('../includes/footer.php');
