<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listformtemplates.php,v 1.7 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$show = isset($_GET['show'])?$_GET['show']:'';

if ($show != 'all' && $show != 'system') {
    $show = 'custom';
}

/**
 * Permission check
 */
if (!$SW_Permissions['Form Template']['Read'][$profilSession]) {
    header('Location: ../administration/admin.php?msg=permissiondenied&toggle_focus=custom');
    exit;
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=custom", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("form_templates"));

switch ($show) {
    case 'custom':      // show custom form templates only
        $blockPage->itemBreadcrumbs(lang_strings('custom_form'));
        $title = $strings['form_templates'] . ' : ' . $strings['custom_form'];
        break;
    case 'system':      // show system tables only
        $blockPage->itemBreadcrumbs(lang_strings('system_table'));
        $title = $strings['form_templates'] . ' : ' . $strings['system_table'];
        break;
    default:            // show all extensions
        $blockPage->itemBreadcrumbs(lang_strings('all'));
        $title = $strings['form_templates'] . ' : ' . $strings['all'];
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
logURL($title, '../forms/listformtemplates.php?show=' . $show);
$block1 = new block();
$block1->openHeading(lang_strings('form_templates'));
$block1->openViewOptions();

foreach (array('all' => lang_strings('all'), 'custom' => lang_strings('custom_form'), 'system' => lang_strings('system_table')) as $s => $desc) {
    if ($s != $show) {
        $block1->itemViewOptions($block1->buildLink('../forms/listformtemplates.php?show=' . $s, $desc, 'in'));
    }
}

$block1->closeViewOptions();
$block1->closeHeading();
$block1->form = 'ftL';
$block1->openForm('../forms/listformtemplates.php?show=' . $show . '#' . $block1->form . 'Anchor');
$block1->openPaletteIcon();

if ($SW_Permissions['Form Template']['Edit'][$profilSession]) {
    $block1->paletteIcon(0, 'add', $strings['add']);
    $block1->paletteIcon(1, 'remove', $strings['delete']);
    $block1->paletteIcon(2, 'copy', $strings['copy']);
}

$block1->paletteIcon(3, 'info', $strings['view']);

if ($SW_Permissions['Form Template']['Edit'][$profilSession]) {
    $block1->paletteIcon(4, 'edit', $strings['edit']);
    $block1->paletteIcon(5, 'import', $strings['import']);
    $block1->paletteIcon(6, 'export', $strings['export']);
}

$block1->closePaletteIcon();
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '20';
$block1->sorting('form_template', (isset($sortingUser['form_template'])?$sortingUser['form_template']:''), 'tdf.tablename ASC', $sortingFields = array(0 => 'tdf.tablename', 1 => 'tdf.fathertable', 2 => 'none', 3 => 'tdf.approvalenabled', 4 => 'tdf.sysdef', 5 => 'tdf.publishenabled'));
$querymore = " WHERE tdf.cfenabled='Y' ";

if ($show == 'custom') {
    $querymore .= "AND tdf.sysdef='N' ";
} elseif ($show == 'system') {
    $querymore .= "AND tdf.sysdef='Y' ";
}

$querymore .= "ORDER BY " . $block1->sortingValue;
$block1->recordsTotal = compt($initrequest['tables_def'] . ' ' . $querymore);
$listTableDefinitions = new request();
$listTableDefinitions->openTablesDefinitions($querymore, $block1->borne, $block1->rowsLimit);
$comptListTableDefinitions = count($listTableDefinitions->tdf_tablename);

if ($comptListTableDefinitions > 0) {
    $labels = array(lang_strings('name'), lang_strings('parent_form_template'), lang_strings('description'), lang_strings('enable_approvals'), lang_strings('system_table'), lang_strings('enable_publish'));
    $block1->openResults();
    $block1->labels($labels, 'true');

    for ($i=0; $i<$comptListTableDefinitions; $i++) {
        $block1->openRow($listTableDefinitions->tdf_tablename[$i]);
        $block1->cellRow($blockPage->buildLink("../forms/viewformtemplate.php?id=" . $listTableDefinitions->tdf_tablename[$i], $listTableDefinitions->tdf_tablename[$i], 'in'));

        if ($listTableDefinitions->tdf_fathertable[$i] == '') {
            $block1->cellRow('&nbsp;');
        } else {
            $block1->cellRow($blockPage->buildLink("../forms/viewformtemplate.php?id=" . $listTableDefinitions->tdf_fathertable[$i], $listTableDefinitions->tdf_fathertable[$i], 'in'));
        }

        $block1->cellRow(tableNameString($listTableDefinitions->tdf_tablename[$i]));
        $block1->cellRow(($listTableDefinitions->tdf_approvalenabled[$i]=='Y')?lang_strings('yes'):lang_strings('no'));
        $block1->cellRow(($listTableDefinitions->tdf_sysdef[$i]=='Y')?lang_strings('yes'):lang_strings('no'));

        if ($sitePublish == 'true') {
            $block1->cellRow(($listTableDefinitions->tdf_publishenabled[$i]=='Y')?lang_strings('yes'):lang_strings('no'));
        }

        $block1->closeRow();
    }

    $block1->closeResults();
    $block1->bornesFooter("1", $blockPage->bornesNumber);
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($SW_Permissions['Form Template']['Edit'][$profilSession]) {
    $block1->paletteScript(0, 'add', '../forms/editformtemplate.php?', 'true,false,false', $strings['add']);
    $block1->paletteScript(1, 'remove', '../forms/deleteformtemplates.php?borne1=' . $block1->borne, 'false,true,true', $strings['delete']);
    $block1->paletteScript(2, 'copy', '../forms/copyformtemplate.php?', 'false,true,false', $strings['copy']);
}

$block1->paletteScript(3, 'info', '../forms/viewformtemplate.php?borne1=' . $block1->borne, 'false,true,false', $strings['view']);

if ($SW_Permissions['Form Template']['Edit'][$profilSession]) {
    $block1->paletteScript(4, 'edit', '../forms/editformtemplate.php?borne1=' . $block1->borne, 'false,true,false', $strings['edit']);
    $block1->paletteScript(5, 'import', '../forms/importformtemplates.php?', 'true,false,false', $strings['import']);
    $block1->paletteScript(6, 'export', '../forms/exportformtemplates.php?', 'false,true,true', $strings['export']);
}

$block1->closePaletteScript($comptListTableDefinitions, $listTableDefinitions->tdf_tablename);
require_once('../includes/footer.php');
