<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: updateclientform.php,v 1.7 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$organization = AddSlashesNOD(isset($_GET['organization'])?$_GET['organization']:'');
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$ae0 = isset($_POST['ae'])?$_POST['ae']:'';
$me0 = isset($_POST['me'])?$_POST['me']:'';
$ae = (($ae0=='Y')?'Y':'N');
$me = (($me0=='Y')?'Y':'N');
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Client']['Edit'][$profilSession]) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

if (!is_numeric($organization)) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

$querymore1 = " WHERE org.id='$organization'";
$clientDetail = new request();
$clientDetail->openOrganizations($querymore1);
$comptClientDetail = count($clientDetail->org_id);
$querymore2 = " WHERE ogf.id='$id'";
$organizationFormDetail = new request();
$organizationFormDetail->openOrganizationForms($querymore2);
$comptOrganizationFormDetail = count($organizationFormDetail->ogf_id);

if ($comptClientDetail == '0' || $comptOrganizationFormDetail == '0') {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

$tbldispnam = tableNameString($organizationFormDetail->ogf_tablename[0]);

/**
 * Actions
 */
if ($action == 'update') {
    if ($ae != $organizationFormDetail->ogf_addenabled[0] || $me != $organizationFormDetail->ogf_modenabled[0]) {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "organizations_form SET ";

            if ($ae != $organizationFormDetail->ogf_addenabled[0]) {
                $tmpsql .= "addenabled='$ae',";
            }

            if ($me != $organizationFormDetail->ogf_modenabled[0]) {
                $tmpsql .= "modenabled='$me',";
            }

            $tmpsql .= "modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    }

    if ($error == '') {
        header("Location: ../clients/viewclient.php?id=$organization&msg=update&toggle_focus=form" . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../clients/listclients.php?" . $urlBornes, lang_strings("clients"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../clients/viewclient.php?toggle_focus=form&id=" . $clientDetail->org_id[0] . $urlBornes, $clientDetail->org_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_client_form_template") . ' : ' . $tbldispnam);
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "ucF";
$block1->openForm("../forms/updateclientform.php?organization=$organization&amp;id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="update">';
$block1->heading(lang_strings("edit_client_form_template") . ' : ' . $tbldispnam);
$block1->openContent();
$block1->contentRow(lang_strings('add_permitted') . $block1->printHelp('add_permitted_help'), '<input type="checkbox" name="ae" value="Y"' . (($organizationFormDetail->ogf_addenabled[0]=='Y')?' checked':'') . '>', 'false', '');
$block1->contentRow(lang_strings('modify_permitted') . $block1->printHelp('modify_permitted_help'), '<input type="checkbox" name="me" value="Y"' . (($organizationFormDetail->ogf_modenabled[0]=='Y')?' checked':'') . '>', 'false', '');
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["update"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
