<?php // $Revision: 1.15 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewform.php,v 1.15 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$tblnam = AddSlashesNOD(isset($_GET['tblnam'])?$_GET['tblnam']:'');
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$formid = AddSlashesNOD(isset($_GET['formid'])?$_GET['formid']:'');
$tbldispnam = tableNameString($tblnam);
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';

if ($sitePublish == 'true') {
    $action = isset($_GET['action'])?$_GET['action']:'';
    $addToSite = isset($_GET['addToSite'])?$_GET['addToSite']:'';
    $removeToSite = isset($_GET['removeToSite'])?$_GET['removeToSite']:'';
    $addToSiteFile = isset($_GET['addToSiteFile'])?$_GET['addToSiteFile']:'';
    $removeToSiteFile = isset($_GET['removeToSiteFile'])?$_GET['removeToSiteFile']:'';
}

/**
 * Permission check
 */
$querymore = " WHERE tdf.tablename='$tblnam'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore);
$comptTableDefinitionDetail = count($tableDefinitionDetail->tdf_tablename);

if ($comptTableDefinitionDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (!$SW_Permissions[$tblnam]['Read'][$profilSession]) {
    header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . '&msg=permissiondenied' . $urlBornes);
    exit;
}

if ($action == 'publish' && ($addToSiteFile =='true' || $removeToSiteFile == 'true')) {
    $querymore = " WHERE f.id='$formid'";
} else {
    $querymore = " WHERE f.id='$id'";
}

if ($project != '') {
    $querymore .= " AND f.project='$project'";
}

$formDetail = new request();
$formDetail->openForms($tblnam, $querymore);

if ($formDetail->row_count == '0') {
    header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project='. $project . '&msg=permissiondenied' . $urlBornes);
    exit;
} else {
    $proid = $formDetail->rows[0]['project'];
}

if ($proid != '0') {
    // check if the project exists
    $querymore = " WHERE pro.id='$proid'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    // check if the user is a team member of this project
    $querymore = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    // load project permission matrix and check the users permission
    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($permissionDetail->prp_view_file[0] != enumBoolean::bTrue) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    if ($action == 'publish') {
        if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $proid . '&msg=permissiondenied' . $urlBornes);
            exit;
        }

        if ($permissionDetail->prp_publish_file[0] != enumBoolean::bTrue) {
            header('Location: ../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $proid . '&msg=permissiondenied' . $urlBornes);
            exit;
        }
    }
}

$tmpquery = "SELECT fdf.tablename FROM " . $tablePrefix . "fields_def fdf WHERE fdf.tablename='$tblnam' AND fdf.sysdef='N'";
$comptCF = compt($tmpquery);

/**
 * Actions
 */
if ($action == "publish") {
    $dbtblnam = $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0];
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($addToSite == "true") {
            $tmpsql = "UPDATE $dbtblnam SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id='$id' AND published<>'" . enumPublished::pbYes ."'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = "addToSite";
        } else if ($removeToSite == "true") {
            $tmpsql = "UPDATE $dbtblnam SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id='$id' AND published<>'" . enumPublished::pbNo ."'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = "removeToSite";
        } else {
            $ids = "'" . str_replace("**", "','", $id) . "'";

            if ($addToSiteFile == 'true') {
                $tmpsql = "UPDATE " . $tablePrefix . "files SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $msg = "addToSite";
            } else if ($removeToSiteFile == 'true') {
                $tmpsql = "UPDATE " . $tablePrefix . "files SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $msg = "removeToSite";
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($addToSite == 'true' || $removeToSite == 'true') {
            // reload data
            $querymore = " WHERE f.id='$id'";
            $formDetail = new request();
            $formDetail->openForms($tblnam, $querymore);
        } else {
            $id = $formid;
        }
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '') {
    $blockPage->itemBreadcrumbs(lang_strings('forms'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . $urlBornes, $tbldispnam, 'in'));
    $title = $strings['form'] . ' ' . $tbldispnam;
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php?' . $urlBornes, lang_strings('projects'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $project . $urlBornes, lang_strings('form') . ' : ' . $tbldispnam, 'in'));
    $title = $strings['form'] . ' ' . $tbldispnam . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
}

$blockPage->itemBreadcrumbs(HtmlEntityDecodeNOD($formDetail->rows[0]['description']));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '3';     // 1st for listprojects, 2nd for listforms
$title .= ' : ' . HtmlEntityDecodeNOD($formDetail->rows[0]['description']);
logURL($title, "../forms/viewform.php?tblnam=$tblnam&project=$project&id=$id");
$block1 = new block();
$block1->form = "fmV";
$block1->openForm("../forms/viewform.php?tblnam=$tblnam&project=$project&id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->headingToggle($tbldispnam, !($toggle_focus==''));
$block1->openPaletteIcon();

if ($proid == '0') {
    if ($SW_Permissions[$tblnam]['Admin'][$profilSession]) {
        $block1->paletteIcon(1, "remove", $strings["delete"]);
    }

    if ($SW_Permissions[$tblnam]['Write'][$profilSession]) {
        $block1->paletteIcon(2, "copy", $strings["copy"]);
    }

    if ($SW_Permissions[$tblnam]['Edit'][$profilSession]) {
        $block1->paletteIcon(3, "edit", $strings["edit"]);

        if ($sitePublish == 'true' && $tableDefinitionDetail->tdf_publishenabled[0] == 'Y') {
            $block1->paletteIcon(4, "add_projectsite", $strings["add_customer_service_site"]);
            $block1->paletteIcon(5, "remove_projectsite", $strings["remove_customer_service_site"]);
        }
    }
} else {
    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_delete_file[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(1, "remove", $strings["delete"]);
        }

        if ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(2, "copy", $strings["copy"]);
        }

        if ($permissionDetail->prp_update_file[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(3, "edit", $strings["edit"]);
        }

        if ($sitePublish == 'true' && $tableDefinitionDetail->tdf_publishenabled[0] == 'Y') {
            if ($permissionDetail->prp_publish_file[0] == enumBoolean::bTrue) {
                $block1->paletteIcon(4, "add_projectsite", $strings["add_customer_service_site"]);
                $block1->paletteIcon(5, "remove_projectsite", $strings["remove_customer_service_site"]);
            }
        }
    }
}

if ($tableDefinitionDetail->tdf_printable[0] == 'Y') {
    $block1->paletteIcon(8, "print", $strings["print"]);
}

$block1->paletteIcon(6, "email", $strings["email"]);
$block1->paletteIcon(99, 'search', $tblnam);
$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("id"), $formDetail->rows[0]['id']);

if ($proid != '0') {
    $block1->contentRow(lang_strings('project'), $blockPage->buildLink('../projects/viewproject.php?id=' . $proid . $urlBornes, $projectDetail->pro_name[0], 'in'));
}

if ($tableDefinitionDetail->tdf_approvalenabled[0] == 'Y') {
    $block1->contentRow(lang_strings("status"), $statusFile[$formDetail->rows[0]['status']]);
}

$block1->contentRow(lang_strings("created"), createDate($formDetail->rows[0]['created'], 'both'));
$block1->contentRow(lang_strings("created_by"), $blockPage->buildLink($formDetail->rows[0]['cuser'], '', 'message'));

if ($formDetail->rows[0]['muser'] != '0') {
    $block1->contentRow(lang_strings("modified"), createDate($formDetail->rows[0]['modified'], 'both'));
    $block1->contentRow(lang_strings("modified_by"), $blockPage->buildLink($formDetail->rows[0]['muser'], '', 'message'));
}

if ($sitePublish=='true' && $tableDefinitionDetail->tdf_publishenabled[0]=='Y') {
    $block1->contentRow(lang_strings('published'), (($formDetail->rows[0]['published']==enumPublished::pbYes)?lang_strings('yes'):lang_strings('no')));
}

$block1->closeContent();

if ($comptCF > 0) {
    if ($comptCF < 10) {
        $block1->openContent();
    } else {
        $block1->openContent(true);
    }

    $block1->contentTitle(lang_strings("details"));
    setupCustomFieldsHTML($block1, $tblnam, $id);
    $block1->closeContent();
}

$block1->closeToggle();

if ($tableDefinitionDetail->tdf_approvalenabled[0] == 'Y') {
    $block1->headingToggle(lang_strings("approval_history"));
    $block1->openContent();
    $querymore = " WHERE dap.docid='$id' AND dap.doctype='$tblnam' ORDER BY dap.id";
    $listDocumentsApproval = new request();
    $listDocumentsApproval->openDocumentsApproval($querymore);
    $comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

    for ($i=0; $i<$comptListDocumentsApproval; $i++) {
        if ($i == 0) {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['submit_at']) . '</i>';
        } else {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['resubmit_at']) . '</i>';
        }

        $querymore = " WHERE daa.document_approval='" . $listDocumentsApproval->dap_id[$i] . "' AND daa.status<>'" . enumApprovalStatus::stPending . "' ORDER BY daa.created,daa.modified";
        $listDocumentsApprovalAuthorizer = new request();
        $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($querymore);
        $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

        for ($j=0,$right = ''; $j<$comptListDocumentsApprovalAuthorizer; $j++,$right.='<br>') {
            $ahd = '';

            if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stApproved) {
                $ahd = $strings['approval_history_approved'];
            } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stNotApproved) {
                $ahd = $strings['approval_history_rejected'];
            }

            if ($ahd != '') {
                $ahd0 = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
                $ahd1 = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j], 'both'), $ahd0);
                $right .= '<i>' . $ahd1  . '</i>';

                if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                    $right .= '<br>' . $listDocumentsApprovalAuthorizer->daa_comments[$j];
                }
            }
        }

        $block1->contentRow($left, $right);
    }

    $block1->closeContent();
    $block1->closeToggle();
}

$block1->closeForm();
$block1->openPaletteScript();

if ($proid == '0') {
    if ($SW_Permissions[$tblnam]['Admin'][$profilSession]) {
        $block1->paletteScript(1, "remove", "../forms/deleteforms.php?tblnam=$tblnam&project=$project&id=$id" . $urlBornes, "true,true,true", $strings["delete"]);
    }

    if ($SW_Permissions[$tblnam]['Write'][$profilSession]) {
        $block1->paletteScript(2, "copy", "../forms/editform.php?cpy=true&tblnam=$tblnam&project=$project&id=$id", "true,true,true", $strings["copy"]);
    }

    if ($SW_Permissions[$tblnam]['Edit'][$profilSession]) {
        $block1->paletteScript(3, "edit", "../forms/editform.php?tblnam=$tblnam&project=$project&id=$id" . $urlBornes, "true,true,true", $strings["edit"]);

        if ($sitePublish == 'true' && $tableDefinitionDetail->tdf_publishenabled[0] == 'Y') {
            $block1->paletteScript(4, "add_projectsite", "../forms/viewform.php?addToSite=true&tblnam=$tblnam&project=$project&action=publish&id=$id" . $urlBornes, "true,true,true", $strings["add_customer_service_site"]);
            $block1->paletteScript(5, "remove_projectsite", "../forms/viewform.php?removeToSite=true&tblnam=$tblnam&project=$project&action=publish&id=$id" . $urlBornes, "true,true,true", $strings["remove_customer_service_site"]);
        }
    }
} else {
    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_delete_file[0] == enumBoolean::bTrue) {
            $block1->paletteScript(1, "remove", "../forms/deleteforms.php?tblnam=$tblnam&project=$project&id=$id" . $urlBornes, "true,true,true", $strings["delete"]);
        }

        if ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue) {
            $block1->paletteScript(2, "copy", "../forms/editform.php?cpy=true&tblnam=$tblnam&project=$project&id=$id" . $urlBornes, "true,true,true", $strings["copy"]);
        }

        if ($permissionDetail->prp_update_file[0] == enumBoolean::bTrue) {
            $block1->paletteScript(3, "edit", "../forms/editform.php?tblnam=$tblnam&project=$project&id=$id" . $urlBornes, "true,true,true", $strings["edit"]);
        }

        if ($sitePublish == 'true' && $tableDefinitionDetail->tdf_publishenabled[0] == 'Y') {
            if ($permissionDetail->prp_publish_file[0] == enumBoolean::bTrue) {
                $block1->paletteScript(4, "add_projectsite", "../forms/viewform.php?addToSite=true&tblnam=$tblnam&project=$project&action=publish&id=$id" . $urlBornes, "true,true,true", $strings["add_customer_service_site"]);
                $block1->paletteScript(5, "remove_projectsite", "../forms/viewform.php?removeToSite=true&tblnam=$tblnam&project=$project&action=publish&id=$id" . $urlBornes, "true,true,true", $strings["remove_customer_service_site"]);
            }
        }
    }
}

if ($tableDefinitionDetail->tdf_printable[0] == 'Y') {
    $block1->paletteScript(8, "print", "../forms/printforms.php?tblnam=$tblnam&project=$project&id=$id" . $urlBornes, "true,true,true", $strings["print"]);
}

$block1->paletteScript(6, "email", "../forms/emailforms.php?tblnam=$tblnam&project=$project&id=$id" . $urlBornes, "true,true,true", $strings["email"]);
$block1->paletteScript(99, 'search', $tblnam);
$block1->closePaletteScript('', '');
setupFormDetailsHTML($block1, $tblnam, $id, false, false, "../forms/viewform.php?tblnam=$tblnam&project=$project&id=$id" . $urlBornes . "#");

if ($fileManagement == "true") {
    $block2 = new block();
    $block2->form = "fmF";
    $block2->openForm("../forms/viewform.php?tblnam=$tblnam&project=$project&id=$id" . $urlBornes . "#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings("linked_content"), !($toggle_focus=='linked_content'));
    $block2->borne = $blockPage->returnBorne('3');
    $block2->rowsLimit = 12;

    if ($sitePublish == 'true') {
        $block2->sorting("form_files", (isset($sortingUser['form_files'])?$sortingUser['form_files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status', 4 => 'fil.published'));
    } else {
        $block2->sorting("form_files", (isset($sortingUser['form_files'])?$sortingUser['form_files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status'));
    }

    $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtForm . "' AND fil.doc_type_ex='$tblnam' AND fil.doc_id='$id' AND fil.vc_parent='0' ORDER BY " . $block2->sortingValue;
    $recordsTotal = compt($initrequest['files'] . $querymore);
    $block2->recordsTotal = $recordsTotal;
    $listFiles = new request();
    $listFiles->openFiles($querymore, $block2->borne, $block2->rowsLimit);
    $comptListFiles = count($listFiles->fil_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['owner'];
    $columns[1]->field_type = enumFieldType::ftAvatar;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['created'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['approval_tracking'];
    $columns[3]->field_type = enumFieldType::ftText;

    if ($sitePublish == 'true') {
        $columns[4] = new cardviewColumn();
        $columns[4]->title = $strings['published'];
        $columns[4]->field_type = enumFieldType::ftText;
    }

    $opt[enumCardviewOption::oTableName] = 'files';
    $opt[enumCardviewOption::oObject] = 'files';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] = "doc_type=" . enumFileRelatedDocumentType::dtForm . "&doc_type_ex=$tblnam&doc_id=$id" . $urlBornes;

    if ($proid == '0') {
        if ($SW_Permissions['File']['Write'][$profilSession]) {
            $opt[enumCardviewOption::oAddUrl] = "../linkedcontent/addfile.php?doc_type=" . enumFileRelatedDocumentType::dtForm . "&doc_type_ex=$tblnam&doc_id=$id" . $urlBornes;
        }
    } else {
        if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
            if ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue) {
                $opt[enumCardviewOption::oAddUrl] = "../linkedcontent/addfile.php?doc_type=" . enumFileRelatedDocumentType::dtForm . "&doc_type_ex=$tblnam&doc_id=$id" . $urlBornes;
            }
        }
    }

    $block2->openCardView($opt);

    for ($i=0; $i<$comptListFiles; $i++) {
        $idStatus = $listFiles->fil_status[$i];
        $idPublish = $listFiles->fil_published[$i];
        $content = array(
            $listFiles->fil_name[$i],
            implode(',',
                array(
                    $listFiles->fil_owner[$i],
                    $listFiles->fil_mem_extension_picture[$i],
                    $listFiles->fil_mem_gender[$i])),
            createDate($listFiles->fil_created[$i],'both'),
            $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . enumFileRelatedDocumentType::dtForm . '&doc_type_ex=' . $tblnam . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i] . $urlBornes, $statusFile[$idStatus], 'in')
        );

        if ($sitePublish == 'true') {
            $content[] = $statusPublish[$idPublish];
        }

        $block2->itemCardView($listFiles->fil_id[$i], $content);
    }

    $block2->closeCardView();
    $block2->bornesFooter("3", $blockPage->bornesNumber, "tblnam=$tblnam&project=$project&id=$id&toggle_focus=linked_content");
    $block2->closeToggle();
    $block2->closeFormResults();
}

require_once("../includes/footer.php");
