<?php // $Revision: 1.12 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewformtemplate.php,v 1.12 2013/01/29 08:46:11 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = isset($_POST['action'])?$_POST['action']:'';
$tbldispnam = tableNameString($id);
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if ($action == '') {
    if (!$SW_Permissions['Form Template']['Read'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} else {
    if (!$SW_Permissions['Form Template']['Edit'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

$querymore0 = " WHERE tdf.tablename='$id'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore0);
$comptTableDefinitionDetail = count($tableDefinitionDetail->tdf_tablename);

if ($comptTableDefinitionDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
} else if ($tableDefinitionDetail->tdf_cfenabled[0] != 'Y') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Prepare data
 */
$querymore = " WHERE fdf.tablename='$id' ORDER BY fdf.disporder";
$listFieldsDefinitions = new request();
$listFieldsDefinitions->openFieldsDefinitions($querymore);
$comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=custom", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../forms/listformtemplates.php?", lang_strings('form_templates'), 'in'));
$blockPage->itemBreadcrumbs($tbldispnam);
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "ftV";
$block1->openForm("../forms/viewformtemplate.php?id=$id#" . $block1->form . "Anchor");
$block1->heading(lang_strings("form_template") . ' : ' . $tbldispnam);

if ($SW_Permissions['Form Template']['Edit'][$profilSession]) {
    $block1->openPaletteIcon();

    if ($tableDefinitionDetail->tdf_sysdef[0] == 'N') {
        $block1->paletteIcon(1, "remove", $strings["delete"]);
        $block1->paletteIcon(2, "copy", $strings["copy"]);
    }

    $block1->paletteIcon(6, "edit", $strings["edit"]);
    $block1->paletteIcon(5, "export", $strings["export"]);
    $block1->closePaletteIcon();
}

$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("name"), $id);

if ($tableDefinitionDetail->tdf_fathertable[0] != '') {
    $block1->contentRow(lang_strings("parent_form_template"), $blockPage->buildLink("../forms/viewformtemplate.php?id=" . $tableDefinitionDetail->tdf_fathertable[0], $tableDefinitionDetail->tdf_fathertable[0], 'in'));
}

$block1->contentRow(lang_strings("description"), $tbldispnam);

if ($tableDefinitionDetail->tdf_sysdef[0] == 'N') {
    if ($tableDefinitionDetail->tdf_fathertable[0] == '') {
        $block1->contentRow(lang_strings("enable_approvals"), ($tableDefinitionDetail->tdf_approvalenabled[0]=='Y')?lang_strings('yes'):lang_strings('no'));
    }

    $block1->contentRow(lang_strings("enable_publish"), ($tableDefinitionDetail->tdf_publishenabled[0]=='Y')?lang_strings('yes'):lang_strings('no'));

    if ($tableDefinitionDetail->tdf_fathertable[0] == '') {
        $block1->contentRow(lang_strings("printable"), ($tableDefinitionDetail->tdf_printable[0]=='Y')?lang_strings('yes'):lang_strings('no'));
        $block1->contentRow(lang_strings("createmainmenuitem"), ($tableDefinitionDetail->tdf_mainmenu[0]=='Y')?lang_strings('yes'):lang_strings('no'));
    }

    $block1->contentRow(lang_strings('history_log'), ($tableDefinitionDetail->tdf_history[0]=='Y')?lang_strings('yes'):lang_strings('no'));
    $block1->contentRow(lang_strings('view_url'), $tableDefinitionDetail->tdf_viewurl[0]);
}

if ($tableDefinitionDetail->tdf_searchable[0] == 'Y') {
    if ($tableDefinitionDetail->tdf_dispfields[0] == '') {
        $block1->contentRow(lang_strings('display_fields'), lang_strings('none'));
    } else {
        $dispfields = explode('+', $tableDefinitionDetail->tdf_dispfields[0]);
        $dispdescs = array();

        foreach ($dispfields as $dispfield) {
            $key = array_search($dispfield, $listFieldsDefinitions->fdf_dbfieldname);
            $dispdescs[] = fieldNameString($id, $listFieldsDefinitions->fdf_fieldname[$key]);
        }

        $block1->contentRow(lang_strings('display_fields'), implode(',', $dispdescs));
    }

    $block1->contentRow(lang_strings('display_style'), $fieldsDisplayStyle[$tableDefinitionDetail->tdf_dispstyle[0]]);
}

if ($tableDefinitionDetail->tdf_fathertable[0] == '') {
    if ($tableDefinitionDetail->tdf_sysdef[0] == 'N') {
        if ($tableDefinitionDetail->tdf_formfields[0] == '') {
            $block1->contentRow(lang_strings('form_fields'), lang_strings('none'));
        } else {
            $formfields = explode('+', $tableDefinitionDetail->tdf_formfields[0]);
            $formdescs = array();

            foreach ($formfields as $formfield) {
                if (array_key_exists($formfield, $reservedDbFields)) {
                    $formdescs[] = $reservedDbFields[$formfield];
                } else {
                    $key = array_search($formfield, $listFieldsDefinitions->fdf_dbfieldname);
                    $formdescs[] = fieldNameString($id, $listFieldsDefinitions->fdf_fieldname[$key]);
                }
            }

            $block1->contentRow(lang_strings('form_fields'), implode(',', $formdescs));
        }
    }

    if ($tableDefinitionDetail->tdf_listfields[0] == '') {
        $block1->contentRow(lang_strings('list_fields'), lang_strings('none'));
    } else {
        $listfields = explode('+', $tableDefinitionDetail->tdf_listfields[0]);
        $listdescs = array();

        foreach ($listfields as $listfield) {
            if (array_key_exists($listfield, $reservedDbFields)) {
                $listdescs[] = $reservedDbFields[$listfield];
            } else {
                $key = array_search($listfield, $listFieldsDefinitions->fdf_dbfieldname);
                $listdescs[] = fieldNameString($id, $listFieldsDefinitions->fdf_fieldname[$key]);
            }
        }

        $block1->contentRow(lang_strings('list_fields'), implode(',', $listdescs));
    }
}

if ($tableDefinitionDetail->tdf_searchable[0] == 'Y') {
    if ($tableDefinitionDetail->tdf_primfields[0] == '') {
        $block1->contentRow(lang_strings('primary_search_fields'), lang_strings('none'));
    } else {
        $primfields = explode('+', $tableDefinitionDetail->tdf_primfields[0]);
        $primdescs = array();

        foreach ($primfields as $primfield) {
            $key = array_search($primfield, $listFieldsDefinitions->fdf_dbfieldname);
            $primdescs[] = fieldNameString($id, $listFieldsDefinitions->fdf_fieldname[$key]);
        }

        $block1->contentRow(lang_strings('primary_search_fields'), implode(',', $primdescs));
    }
}

if ($tableDefinitionDetail->tdf_sysdef[0] == 'N') {
    $block1->contentRow(lang_strings('form_control_script'), $tableDefinitionDetail->tdf_javascript[0]);
}

$block1->contentRow('', $blockPage->buildLink("../customfields/listcustomfields.php?mode=$id", lang_strings("custom_fields"), 'in'));
$block1->closeContent();
$block1->closeForm();

if ($SW_Permissions['Form Template']['Edit'][$profilSession]) {
    $block1->openPaletteScript();

    if ($tableDefinitionDetail->tdf_sysdef[0] == 'N') {
        $block1->paletteScript(1, "remove", "../forms/deleteformtemplates.php?id=$id", "true,true,true", $strings["delete"]);
        $block1->paletteScript(2, "copy", "../forms/copyformtemplate.php?id=$id", "true,true,true", $strings["copy"]);
    }

    $block1->paletteScript(6, "edit", "../forms/editformtemplate.php?id=$id", "true,true,true", $strings["edit"]);
    $block1->paletteScript(5, "export", "../forms/exportformtemplates.php?id=$id", "true,true,true", $strings["export"]);
    $block1->closePaletteScript('', '');
}

require_once("../includes/footer.php");
