<?php // $Revision: 1.10 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: error.php,v 1.10 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
// get configuration settings
require_once('../includes/settings.php');
require_once('../includes/defines.lib.php');
// request data class
require_once('../includes/initrequests.php');
require_once('../includes/request.class-dbspec.php');
require_once('../includes/request.class.php');
// database-specific library
require_once('../includes/library-dbspec.php');
// languages array
require_once('../languages/languages.inc.php');
// first load the default language file
if (@file_exists('../languages/lang_' . $langDefault . '.php'))
    require_once('../languages/lang_' . $langDefault . '.php');
// then load the english language file
if (@file_exists('../languages/lang_en.php'))
    require_once('../languages/lang_en.php');
// load array definitions
require_once('../includes/arrays.lib.php');

/**
 * HTML
 */
echo '<!DOCTYPE HTML>
<html>
<head>
<meta http-equiv="cache-control" content="no-cache,no-store">
<meta http-equiv="expires" content="0">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>webTareas : Error</title>
</head>
<body>
<h2>webTareas : Error</h2>';

switch ($_GET['type']) {
    case 'dbserver':
        echo '<h3>' . DBTYPE . ' Error</h3>' . $strings['error_server'];
        break;
    case 'phpversion':
        echo '<h3>PHP Version Error</h3>' . $strings['error_phpversion'];
        break;
    case 'denyip':
        echo '<h3>IP Banned Error</h3>' . $strings['error_denyip'];
        break;
}

echo '
</body>
</html>
';
?>
