<?php // $Revision: 1.41 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: home.php,v 1.41 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$dateFilter = mktime(0,0,0,intval(date('m'))-1,intval(date('d')),intval(date('Y')));
$id = AddSlashesNOD(isset($_REQUEST['id'])?$_REQUEST['id']:'');
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$num = isset($_GET['num'])?$_GET['num']:'';
$error = isset($_GET['error'])?$_GET['error']:'';

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings('home'));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '5';
/**
 * My Projects
 */
if ($SW_Permissions['Project']['Read'][$profilSession]) {
    $block1 = new block();
    $block1->form = "wbP";
    $block1->openForm('../general/home.php#' . $block1->form . 'Anchor');
    $block1->headingToggle(lang_strings("my_projects"), !($toggle_focus=='my_projects'));
    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = 12;
    $block1->sorting("home_projects", (isset($sortingUser['home_projects'])?$sortingUser['home_projects']:''), "pro.name ASC", $sortingFields = array(0 => "pro.id", 1 => "pro.name", 2 => "pro.priority", 3 => "org2.name", 4 => "pro.status", 5 => "mem2.name"));
    $querymore = " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member='$idSession' AND pro.status IN ('" . enumProjectStatus::stInitiation . "','" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "') AND prp.view_project='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
    $recordsTotal = compt($initrequest['teams'] . $querymore);
    $block1->recordsTotal = $recordsTotal;
    $listProjects = new request();
    $listProjects->openTeams($querymore, $block1->borne, $block1->rowsLimit);
    $comptListProjects = count($listProjects->tea_project);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['id'];
    $columns[0]->field_type = enumFieldType::ftNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['priority'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['status'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['owner'];
    $columns[4]->field_type = enumFieldType::ftNumeric;
    $columns[4]->linked_table = 'members';
    $opt = array();
    $opt[enumCardviewOption::oObject] = 'projects';
    $opt[enumCardviewOption::oTableName] = 'projects';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oMultipleSelection] = false;

    if ($SW_Permissions['Project']['Write'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../projects/editproject.php';
    }

    $block1->openCardView($opt);

    for ($i=0; $i<$comptListProjects; $i++) {
        $idStatus = $listProjects->tea_pro_status[$i];
        $idPriority = $listProjects->tea_pro_priority[$i];
        $content = array(
            $listProjects->tea_pro_id[$i],
            $listProjects->tea_pro_name[$i],
            $priority[$idPriority],
            $statusProject[$idStatus],
            $listProjects->tea_pro_owner[$i]
        );
        $block1->itemCardView($listProjects->tea_pro_id[$i], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter(1, $blockPage->bornesNumber, "toggle_focus=my_projects");
    $block1->closeToggle();
    $block1->closeFormResults();
}

/**
 * My Tasks
 */
if ($SW_Permissions['Project']['Read'][$profilSession]) {
    $block2 = new block();
    $block2->form = "xwbT";
    $block2->openForm("../general/home.php#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings("my_tasks"), !($toggle_focus=='my_tasks'));
    $block2->borne = $blockPage->returnBorne('2');
    $block2->rowsLimit = 12;
    $block2->sorting("home_tasks", (isset($sortingUser['home_tasks'])?$sortingUser['home_tasks']:''), "tas.name ASC", $sortingFields = array(0 => "tas.id", 1 => "tas.name", 2 => "tas.priority", 3 => "tas.due_date", 4 => "tas.owner", 5 => "pro.name"));
    $querymore = " WHERE EXISTS (SELECT res.task FROM " . $tablePrefix . "tasks_resource res WHERE res.task=tas.id AND res.type='" . enumResourceType::rtUser . "' AND res.resource='$idSession') AND tas.status IN ('" . enumStatus::stClientCompleted . "','" . enumStatus::stNotStarted . "','" . enumStatus::stOpen . "') ORDER BY $block2->sortingValue";
    $recordsTotal = compt($initrequest['tasks'] . $querymore);
    $block2->recordsTotal = $recordsTotal;
    $listTasks = new request();
    $listTasks->openTasks($querymore, $block2->borne, $block2->rowsLimit);
    $comptListTasks = count($listTasks->tas_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['id'];
    $columns[0]->field_type = enumFieldType::ftNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['priority'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['due_date'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['assigned_by'];
    $columns[4]->field_type = enumFieldType::ftAvatar;
    $columns[5] = new cardviewColumn();
    $columns[5]->title = $strings['project'];
    $columns[5]->field_type = enumFieldType::ftNumeric;
    $columns[5]->linked_table = 'projects';
    $opt = array();
    $opt[enumCardviewOption::oObject] = 'tasks';
    $opt[enumCardviewOption::oTableName] = 'tasks';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $block2->openCardView($opt);

    for ($i = 0;$i < $comptListTasks;$i++) {
        $idPriority = $listTasks->tas_priority[$i];

        if ($listTasks->tas_due_date[$i] == "0")  {
            $duedate = '--';
        } else if (date('Ymd', $listTasks->tas_due_date[$i]) <= date('Ymd') && $listTasks->tas_completion[$i] != "10") {
            $duedate = '<div class="overdue">' . createDate($listTasks->tas_due_date[$i],'date',false,true) . '</div>';
        } else {
            $duedate = createDate($listTasks->tas_due_date[$i],'date',false,true);
        }

        $content = array(
            $listTasks->tas_id[$i],
            $listTasks->tas_name[$i],
            $priority[$idPriority],
            $duedate,
            implode(',',
                array(
                    $listTasks->tas_owner[$i],
                    $listTasks->tas_mem2_extension_picture[$i],
                    $listTasks->tas_mem2_gender[$i])),
            $listTasks->tas_project[$i]
        );
        $block2->itemCardView($listTasks->tas_id[$i], $content);
    }

    $block2->closeCardView();
    $block2->bornesFooter(2, $blockPage->bornesNumber, "toggle_focus=my_tasks");
    $block2->closeToggle();
    $block2->closeFormResults();
}

/**
 * My Meetings
 */
if ($SW_Permissions['Meeting']['Read'][$profilSession]) {
    $block3 = new block();
    $block3->form = "Met";
    $block3->openForm("../general/home.php#" . $block3->form . "Anchor");
    $block3->headingToggle(lang_strings("my_meetings"), !($toggle_focus=='my_meetings'));
    $block3->borne = $blockPage->returnBorne('3');
    $block3->rowsLimit = 12;
    $block3->sorting("home_meetings", (isset($sortingUser['home_meetings'])?$sortingUser['home_meetings']:''), "mee.start_time ASC", $sortingFields = array(0 => 'mee.id', 1 => 'mee.name', 2 => 'mee.priority', 3 => 'mee.status', 4 => 'mee.start_time', 5 => 'mee.duration'));
    $querymore = " WHERE EXISTS (SELECT att.meeting FROM " . $tablePrefix . "attendees att WHERE att.meeting=mee.id AND att.member='$idSession' AND (mee.status IN ('" . enumMeetingStatus::stScheduling . "','" . enumMeetingStatus::stScheduled . "') OR (mee.status IN ('" . enumMeetingStatus::stCompleted . "','" . enumMeetingStatus::stOpen . "') AND att.attended='" . enumBoolean::bTrue . "'))) ORDER BY " . $block3->sortingValue;
    $recordsTotal = compt($initrequest['meetings'] . $querymore);
    $block3->recordsTotal = $recordsTotal;
    $listMeetings= new request();
    $listMeetings->openMeetings($querymore, $block3->borne, $block3->rowsLimit);
    $comptListMeetings= count($listMeetings->mee_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['id'];
    $columns[0]->field_type = enumFieldType::ftNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['meeting'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['priority'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['status'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['start_time'];
    $columns[4]->field_type = enumFieldType::ftText;
    $columns[5] = new cardviewColumn();
    $columns[5]->title = $strings['duration'];
    $columns[5]->field_type = enumFieldType::ftText;
    $opt = array();
    $opt[enumCardviewOption::oObject] = 'meetings';
    $opt[enumCardviewOption::oTableName] = 'meetings';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;

    if ($SW_Permissions['Meeting']['Write'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../meetings/editmeeting.php';
    }

    $block3->openCardView($opt);

    for ($i=0; $i<$comptListMeetings; $i++) {
        $idStatus = $listMeetings->mee_status[$i];
        $idPriority = $listMeetings->mee_priority[$i];

        if ($idStatus == enumMeetingStatus::stCompleted || $idStatus == enumMeetingStatus::stCanceled) {
            $mee_name = '<del>' . $listMeetings->mee_name[$i] . '</del>';
        } else {
            $mee_name = $listMeetings->mee_name[$i];
        }

        if ($idStatus == enumMeetingStatus::stScheduling) {
            $start_time = '--';
        } else {
            if ($listMeetings->mee_start_time[$i] <= time() && $idStatus != enumMeetingStatus::stCompleted && $idStatus != enumMeetingStatus::stCanceled) {
                $start_time = "<b>" . createDate($listMeetings->mee_start_time[$i], 'both') . "</b>";
            } else {
                $start_time = createDate($listMeetings->mee_start_time[$i], 'both');
            }
        }

        $content = array(
            $listMeetings->mee_id[$i] . (($listMeetings->mee_reminder[$i] == '1')?' <img src="../themes/' . THEME . '/bell.gif">':''),
            $mee_name,
            $priority[$idPriority],
            $statusMeeting[$idStatus],
            $start_time,
            sprintf("%.1f %s", $listMeetings->mee_duration[$i], lang_strings("hours"))
        );
        $block3->itemCardView($listMeetings->mee_id[$i], $content);
    }

    $block3->closeCardView();
    $block3->bornesFooter(3, $blockPage->bornesNumber, "toggle_focus=my_meetings");
    $block3->closeToggle();
    $block3->closeFormResults();
}

/**
 * My Support Requests
 */
if ($SW_Permissions['Project']['Read'][$profilSession]) {
    $block4 = new block();
    $block4->form = 'msr';
    $block4->openForm('../general/home.php#' . $block4->form . 'Anchor');
    $block4->headingToggle(lang_strings('my_support_requests'), !($toggle_focus=='my_support_requests'));
    $block4->borne = $blockPage->returnBorne('4');
    $block4->rowsLimit = 12;
    $block4->sorting("home_supports", (isset($sortingUser['home_supports'])?$sortingUser['home_supports']:''), "sr.priority DESC", $sortingFields = array(0 => 'sr.id', 1 => 'sr.subject', 2 => 'sr.status', 3 => 'sr.priority', 4 => 'sr.owner', 5 => 'pro.name'));
    $querymore = " WHERE (sr.owner='$idSession' OR sr.assigned_to='$idSession' OR EXISTS (SELECT id FROM " . $tablePrefix . "support_posts WHERE request_id=sr.id AND owner='$idSession')) AND sr.status<>'" . enumRequestStatus::stCompleted . "' ORDER BY " . $block4->sortingValue;
    $recordsTotal = compt($initrequest['support_requests'] . $querymore);
    $block4->recordsTotal = $recordsTotal;
    $listSupportRequests = new request();
    $listSupportRequests->openSupportRequests($querymore, $block4->borne, $block4->rowsLimit);
    $comptListSupportRequests = count($listSupportRequests->sr_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['id'];
    $columns[0]->field_type = enumFieldType::ftNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['subject'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['status'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['priority'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['owner'];
    $columns[4]->field_type = enumFieldType::ftAvatar;
    $columns[5] = new cardviewColumn();
    $columns[5]->title = $strings['project'];
    $columns[5]->field_type = enumFieldType::ftNumeric;
    $columns[5]->linked_table = 'projects';
    $opt = array();
    $opt[enumCardviewOption::oObject] = 'support_requests';
    $opt[enumCardviewOption::oTableName] = 'support_requests';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oMultipleSelection] = false;
    $block4->openCardView($opt);

    for ($i=0; $i<$comptListSupportRequests; $i++) {
        $content = array(
            $listSupportRequests->sr_id[$i],
            $listSupportRequests->sr_subject[$i],
            $requestStatus[$listSupportRequests->sr_status[$i]],
            $priority[$listSupportRequests->sr_priority[$i]],
            implode(',',
                array(
                    $listSupportRequests->sr_owner[$i],
                    $listSupportRequests->sr_mem_extension_picture[$i],
                    $listSupportRequests->sr_mem_gender[$i])),
            $listSupportRequests->sr_project[$i]
        );
        $block4->itemCardView($listSupportRequests->sr_id[$i], $content);
    }

    $block4->closeCardView();
    $block4->bornesFooter(4, $blockPage->bornesNumber, "toggle_focus=my_support_requests");
    $block4->closeToggle();
    $block4->closeFormResults();
}

/**
 * My Approval List
 */
if (compt($initrequest["approvals"] . " WHERE app.active='Y'") > 0) {
    $block5 = new block();
    $block5->form = 'app';
    $block5->openForm('../general/home.php#' . $block5->form . 'Anchor');
    $block5->headingToggle(lang_strings('approvals_my'), !($toggle_focus=='my_approvals'));
    $block5->borne = $blockPage->returnBorne('5');
    $block5->rowsLimit = 12;
    $block5->sorting("my_approvals", (isset($sortingUser['my_approvals'])?$sortingUser['my_approvals']:''), "", $sortingFields = array(0 => 'none', 1 => 'none', 2 => 'none', 3 => 'none'));
    $querymore = " WHERE daa.authorizer='$idSession' AND dap.canceled='N' AND daa.stage=dap.current_stage AND dap.closed='N' ORDER BY dap.created";
    $recordsTotal = compt($initrequest['documents_approval_authorizers'] . $querymore);
    $block5->recordsTotal = $recordsTotal;
    $listDocumentsApprovalAuthorizers = new request();
    $listDocumentsApprovalAuthorizers->openDocumentsApprovalAuthorizers($querymore);
    $comptListDocumentsApprovalAuthorizers = count($listDocumentsApprovalAuthorizers->daa_document_approval);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['type'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['originator'];
    $columns[1]->field_type = enumFieldType::ftAvatar;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['comments'];
    $columns[2]->field_type = enumFieldType::ftMemo;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['created'];
    $columns[3]->field_type = enumFieldType::ftText;
    $opt = array();
    $opt[enumCardviewOption::oObject] = 'documents_approval';
    $opt[enumCardviewOption::oTableName] = 'documents_approval';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oMultipleSelection] = false;
    $block5->openCardView($opt);

    for ($i=0; $i<$comptListDocumentsApprovalAuthorizers; $i++) {
        $content = array(
            tableNameString($listDocumentsApprovalAuthorizers->daa_dap_doctype[$i]),
            implode(',',
                array(
                    $listDocumentsApprovalAuthorizers->daa_dap_owner[$i],
                    $listDocumentsApprovalAuthorizers->daa_mem2_extension_picture[$i],
                    $listDocumentsApprovalAuthorizers->daa_mem2_gender[$i])),
            $listDocumentsApprovalAuthorizers->daa_dap_comments[$i],
            createDate($listDocumentsApprovalAuthorizers->daa_dap_created[$i],'both')
        );
        $block5->itemCardView($listDocumentsApprovalAuthorizers->daa_document_approval[$i], $content);
    }

    $block5->closeCardView();
    $block5->bornesFooter(5, $blockPage->bornesNumber, "toggle_focus=my_approvals");
    $block5->closeToggle();
    $block5->closeFormResults();
}

require_once("../includes/footer.php");
