<?php // $Revision: 1.21 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: login.php,v 1.21 2013/02/19 14:15:27 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = false;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$url = isset($_REQUEST['url'])?$_REQUEST['url']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$logout = isset($_GET['logout'])?$_GET['logout']:'';
$sessionGet = isset($_GET['session'])?$_GET['session']:'';
$loginForm = AddSlashesNOD(isset($_POST['loginForm'])?$_POST['loginForm']:'');
$passwordForm = isset($_POST['passwordForm'])?$_POST['passwordForm']:'';
$rememberForm = isset($_POST['rememberForm'])?$_POST['rememberForm']:'';
$tz = isset($_POST['tz'])?$_POST['tz']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$start_page = '';
$error = '';
$match = false;

/**
 * Logout
 */
if (($logout == 'true') and (isset($_SESSION['loginSession']))) {
    // update the logs table before logout
    $tmpsql = "UPDATE " . $tablePrefix . "logs SET connected=NULL WHERE login='" . $_SESSION['loginSession'] . "'";
    connectSql($tmpsql);
    // delete the authentication cookies
    setcookie('webTareasAuthCookie', '', time()-86400, $cookiePath['path'].'/');
    // handle the session
    $_SESSION = array(); // unset all session varables
    session_unset();
    // then destroy the session
    if ($enableUserDefinedSaveHandler) {
        _sess_destroy( session_id() );
    } else {
        session_destroy();
    }

    // redirection to login page with logout message
    header('Location: ../general/login.php?msg=logout');
    exit;
}

if (!defined('auth')) {
    $auth = '';
}

/**
 * Login
 */
if ($action == 'login') {
    if ($loginForm == '') {
        $error = $strings['login_username'];
    } else if ($passwordForm == '') {
        $error = $strings['login_password'];
    } else {
        $auth = 'on';

        if ($rememberForm == 'on') {
            $storePwd = get_password($passwordForm);
            $cookie_value = base64_encode(serialize(array('loginForm' => $loginForm, 'storePwd' => $storePwd, 'loginToken' => md5($loginForm . $cryptKey))));
            setcookie('webTareasAuthCookie', $cookie_value, time()+31536000, $cookiePath['path'].'/');
        } else {
            setcookie('webTareasAuthCookie', '', time()-3600, $cookiePath['path'].'/');
        }
    }
}

// get cookie params
if (isset($_COOKIE['webTareasAuthCookie'])) {
    $authCookie = unserialize(base64_decode($_COOKIE['webTareasAuthCookie']));
    $loginCookie = $authCookie['loginForm'];
    $passwordCookie = $authCookie['storePwd'];
    $tokenCookie = $authCookie['loginToken'];

    if ((isset($loginCookie)) && ($loginCookie != '') && ($passwordCookie != '') && ($tokenCookie != '')) {
        $auth = 'on';
    }
}

if ($auth == 'on') {
    if ((isset($loginCookie)) && ($loginCookie != '') && ($passwordCookie != '') && ($tokenCookie != '')) {
        $loginUser = wtAuthentication($loginCookie, $passwordCookie, $tz, $tokenCookie);
    } else {
        $loginS = strip_tags($loginForm);
        $passwordS = strip_tags($passwordForm);
        $loginUser = wtAuthentication($loginS, $passwordS, $tz);
    }

    if ($loginUser !== null) {
        if ($loginUser->mem_organization[0] != '1') {  // login as a client user
            if ($url != '') {
                // redirect for external link to internal page
                header('Location: ../' . $url . '&updateProject=true');
            } else {
                // redirect to home page
                header('Location: ../service_site/home.php');
            }
        } else {
            if ($url != '') {
                // validate external link
                $matches = array();

                if ((preg_match('/(.+\.php)/', $url, $matches)!==1) || (!file_exists('../' . $matches[1]))) {
                    $url = '';
                }
            }

            if ($url === '') {
                // validate start page
                $matches = array();

                if ((preg_match('/(.+\.php)/', $loginUser->mem_start_page[0], $matches)===1) && (file_exists('../' . $matches[1]))) {
                    $start_page = $loginUser->mem_start_page[0];
                }
            }

            if ($url != '') {
                // redirect for external link to internal page
                header('Location: ../' . $url);
            } else if ($comptRegisterLog == '0' && $loginUser->mem_id[0] != '1') {
                // redirect to password changing page
                header('Location: ../preferences/updatepassword.php');
            } else if ($start_page != '') {
                // redirect to selected start page
                header('Location: ../' . $start_page);
            } else if ($loginUser->mem_id[0] == '1') {
                // redirect to admin page
                header('Location: ../administration/admin.php');
            } else {
                // redirect to home page
                header('Location: ../general/home.php');
            }
        }

        exit;
    } else {
        setcookie('webTareasAuthCookie', '', time()-3600, $cookiePath['path'].'/');
    }
}

if (($sessionGet == 'false') and ($url == '')) {
    $error = $strings['session_false'];
}

if ($logout == 'true') {
    $msg = 'logout';
}

$notLogged = true;
$bodyCommand = 'onLoad="document.loginForm.loginForm.focus();"';
require_once('../includes/header.php');
$blockPage = new block();
$block1 = new block();
$block1->form = 'login';
$block1->openLoginForm($_SERVER['REQUEST_URI']);
echo '<input type="hidden" name="action" value="login">';

if ($url != '') {
    echo '<input value="' . $url . '" type="hidden" name="url">';
    echo '<input value="0" type="hidden" id="tz" name="tz">';
}

echo '<input id="loginForm" name="loginForm" type="text" placeholder="' . $strings['user_name'] . '"/>
      <input id="passwordForm" name="passwordForm" type="password" placeholder="' . $strings['password'] . '"/>
      <input class="submit-button" type="submit" name="loginSubmit" value="' . $strings['login'] . '">';

if ($siteOff == 'true') {
    $block1->heading($strings['siteoff']);
}

echo '<p class="message">' . $blockPage->buildLink('../general/sendpassword.php', $strings['forgot_pwd'], 'in') . '</p>';
$block1->closeLoginForm();
?>
<script>
    $(document).ready(function() {
        var offset = new Date().getTimezoneOffset();
        var val = 0 - offset / 60;
        $('#tz').val(val);
    });
</script>
<?php
require_once('../includes/footer.php');
