<?php // $Revision: 1.18 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: search.php,v 1.18 2013/01/29 08:46:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$bodyCommand = "onLoad=\"document.searchForm.searchfor.focus()\"";
$searchfor = urlencode(isset($_REQUEST['searchfor'])?$_REQUEST['searchfor']:'');
$searchtype = isset($_GET['searchtype'])?$_GET['searchtype']:'';
$searchonly = isset($_REQUEST['searchonly'])?$_REQUEST['searchonly']:'';
$nosearch = isset($_GET['nosearch'])?$_GET['nosearch']:'';
$moreresults = isset($_GET['moreresults'])?$_GET['moreresults']:'';
$advsubmit = isset($_POST['advsubmit'])?$_POST['advsubmit']:'';
$error ='';
$tmpquery = '';
$skip = false;
$searchfor_highlight = false;

if ($searchtype == '') {
    $searchtype = 'advance';
}

/**
 *  Load definitions of the searchable tables
 */
$querymore = " WHERE tdf.searchable='Y'";
$tables2Hide = array();

if ($enableEquipment != 'true' || !$SW_Permissions['Equipment']['Read'][$profilSession]) {
    $tables2Hide[] = 'equipments';
}

if (!$SW_Permissions['Expense']['Read'][$profilSession] && !$SW_Permissions['Project']['Read'][$profilSession] && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    $tables2Hide[] = 'expenses';
}

if ($fileManagement != 'true') {
    $tables2Hide[] = 'files';
}

if (!$SW_Permissions['Invoice']['Read'][$profilSession]) {
    $tables2Hide[] = 'invoices';
}

if ($enableMaterial != 'true' || !$SW_Permissions['Material']['Read'][$profilSession]) {
    $tables2Hide[] = 'materials';
}

if (!$SW_Permissions['User']['Read'][$profilSession]) {
    $tables2Hide[] = 'members';
}

if (!$SW_Permissions['Client']['Read'][$profilSession]) {
    $tables2Hide[] = 'organizations';
}

if (!$SW_Permissions['Payment']['Read'][$profilSession]) {
    $tables2Hide[] = 'payments';
}

if (!$SW_Permissions['Project']['Read'][$profilSession] && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    $tables2Hide[] = 'projects';
    $tables2Hide[] = 'notes';
    $tables2Hide[] = 'posts';
    $tables2Hide[] = 'support_posts';
    $tables2Hide[] = 'support_requests';
    $tables2Hide[] = 'tasks';
    $tables2Hide[] = 'topics';
}

if (count($tables2Hide) > 0) {
    $querymore .= " AND tdf.tablename NOT IN ('" . implode("','", $tables2Hide) . "')";
}

$listTablesDefinitions = new request();
$listTablesDefinitions->openTablesDefinitions($querymore);
$comptListTablesDefinitions = count($listTablesDefinitions->tdf_tablename);

/**
 * Check fields
 */
if (strlen($searchfor) < 2) {        // Keywords must has at least 2 char length
    $error = lang_strings("keywords_too_short");
    $bodyCommand = "onLoad=\"document.searchForm.searchfor.focus()\"";
    $searchfor_highlight = true;
} else {
    if ($searchtype == 'advance') {
        if ($advsubmit == 'true') {
            $nosearch = '';
            $searchonly = '';
            $noA = array();
            $onA = array();

            for ($i=0; $i<$comptListTablesDefinitions; $i++) {
                $tblnam = $listTablesDefinitions->tdf_tablename[$i];
                $tblnamX = preg_replace_callback('/@/', function ($matches) { return 'X40'; }, $tblnam);
                ${$tblnamX} = isset($_POST[$tblnamX])?$_POST[$tblnamX]:'';

                if (${$tblnamX} != 'Y') {
                    $noA[] = $tblnam;
                } else {
                    $onA[] = $tblnam;
                }
            }

            if (count($noA) == $comptListTablesDefinitions) {
                $skip = true;
            } else if (count($noA) > count($onA)) {
                $searchonly = implode('**', $onA);
            } else {
                $nosearch = implode('**', $noA);
            }
        } else if ($nosearch == '' && $searchonly == '') {
            for ($i=0; $i<$comptListTablesDefinitions; $i++) {
                $tblnam = $listTablesDefinitions->tdf_tablename[$i];
                $tblnamX = preg_replace_callback('/@/', function ($matches) { return 'X40'; }, $tblnam);
                ${$tblnamX} = 'Y';
            }

            $skip = true;
        } else {
            for ($i=0; $i<$comptListTablesDefinitions; $i++) {
                $tblnam = $listTablesDefinitions->tdf_tablename[$i];
                $tblnamX = preg_replace_callback('/@/', function ($matches) { return 'X40'; }, $tblnam);
                ${$tblnamX} = '';

                if ($nosearch != '') {
                    if (preg_match('/'.$tblnam.'/', $nosearch) == 0) {
                        ${$tblnamX} = 'Y';
                    }
                } else if ($searchonly != '') {
                    if (preg_match('/'.$tblnam.'/', $searchonly) == 1) {
                        ${$tblnamX} = 'Y';
                    }
                }
            }
        }
    }
}

/**
 * Actions
 */
if ($error == '' && !$skip) {
    // case Insensitive
    $searchfori = strtolower(urldecode(str_replace(array('--', '({', '/*'), array('', '', ''), $searchfor)));
    // parse the search expression
    $pattern1 = '/("[^"]*"|\'[^\']*\'|(\w+))\s*=\s*("[^"]*"|\'[^\']*\'|\S*)|("[^"]*"|\'[^\']*\'|\S+)/';
    preg_match_all($pattern1, $searchfori, $matches1);
    $matches2 = array();
    $keywordArray = array();
    // eliminate redundant keywords
    for ($i=0; $i<count($matches1[0]); $i++) {
        $match = $matches1[0][$i];

        if (!in_array($match, $matches2)) {
            array_push($matches2, $match);
            $val = '';
            // get value
            for ($j=count($matches1)-1; $j>1; $j--) {
                if ($matches1[$j][$i] != '') {
                    $val = str_replace('"', '', str_replace("'", '', $matches1[$j][$i]));
                    break;
                }
            }

            if ($matches1[1][$i] != '') {
                // name/value pair
                $nam = str_replace('"', '', str_replace("'", '', $matches1[1][$i]));
                $fv = array($nam, $val);
                array_push($keywordArray, array($fv));
            } else {
                // single value
                array_push($keywordArray, array($val));
            }
        }
    }

    $keywordNum = count($keywordArray);
    // search single or multiple keywords
    for ($i=($keywordNum-1); $i>0; $i--) {
        $num = count($keywordArray);

        for ($j=($num-$i); $j<$num; $j++) {
            $org = $keywordArray[$j];
            $f = $org[0];
            $k = 0;

            while ($keywordArray[$k][0] != $f) {
                $keywordArray[] = array_merge($keywordArray[$k++], $org);
            }
        }
    }

    /*
     * Build search sql
     */
    $querymore = " WHERE tdf.searchable='Y'";

    if (count($tables2Hide) > 0) {
        $querymore .= " AND tdf.tablename NOT IN ('" . implode("','", $tables2Hide) . "')";
    }

    $listTablesDefinitions = new request();
    $listTablesDefinitions->openTablesDefinitions($querymore);
    $comptListTablesDefinitions = count($listTablesDefinitions->tdf_tablename);
    $querySetArray = array();

    foreach ($keywordArray as $keywords) {
        for ($i=0; $i<$comptListTablesDefinitions; $i++) {
            $tblnam = $listTablesDefinitions->tdf_tablename[$i];
            $dbtblnam = $listTablesDefinitions->tdf_dbtablename[$i];

            if ($nosearch != '') {
                if (preg_match('/'.$tblnam.'/', $nosearch) == 1) {
                    continue;
                }
            } else if ($searchonly != '') {
                if (preg_match('/'.$tblnam.'/', $searchonly) == 0) {
                    continue;
                }
            }

            $querymore = " WHERE fdf.tablename='$tblnam'";
            $listFieldsDefinitions = new request();
            $listFieldsDefinitions->openFieldsDefinitions($querymore);
            $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

            if (!is_array($listFieldsDefinitions->fdf_dbfieldname)) {
                $listFieldsDefinitions->fdf_dbfieldname = array();
            }

            $subquerySetArray = array();
            $querySetArrayC = array();

            foreach ($keywords as $keyword) {
                if (is_array($keyword)) {
                    // search for the specified field description/name
                    $subqueryArray = array();

                    if (($keyword[0] == strtolower($strings['id'])) || ($keyword[0] == 'id')) {
                        $val = (is_numeric($keyword[1])?$keyword[1]:'0');
                        $subqueryArray[] = "P.id='$val'";
                    } else {
                        for ($j=0; $j<$comptListFieldsDefinitions; $j++) {
                            if (($keyword[0] == strtolower($listFieldsDefinitions->fdf_fielddesc[$j])) || ($keyword[0] == strtolower($listFieldsDefinitions->fdf_fieldname[$j]))) {
                                switch ($listFieldsDefinitions->fdf_fieldtype[$j]) {
                                    case enumFieldType::ftAlphaNumeric:
                                    case enumFieldType::ftEmail:
                                    case enumFieldType::ftMemo:
                                    case enumFieldType::ftText:
                                    case enumFieldType::ftUrl:
                                        $val = DbValueEncode($listFieldsDefinitions->fdf_fieldtype[$j], $keyword[1]);
                                        $subqueryArray[] = "LOWER(P." . $listFieldsDefinitions->fdf_dbfieldname[$j] . ")='$val'";
                                        break;
                                    case enumFieldType::ftDate:
                                    case enumFieldType::ftTimestamp:
                                        $val1 = date2Timestamp($keyword[1], '', true);
                                        $val2 = $val1 + 86400;
                                        $subqueryArray[] = "(P." . $listFieldsDefinitions->fdf_dbfieldname[$j] . ">='$val1' AND P." . $listFieldsDefinitions->fdf_dbfieldname[$j] . "<'$val2')";
                                        break;
                                    default:
                                        $val = DbValueEncode($listFieldsDefinitions->fdf_fieldtype[$j], $keyword[1]);
                                        $subqueryArray[] = "P." . $listFieldsDefinitions->fdf_dbfieldname[$j] . "='$val'";
                                }

                                break;
                            }
                        }
                    }
                } else {
                    // search for the primary search fields
                    $primFields = explode('+', $listTablesDefinitions->tdf_primfields[$i]);
                    $subqueryArray = array();

                    foreach ($primFields as $fldnam) {
                        $key = array_search($fldnam, $listFieldsDefinitions->fdf_dbfieldname);

                        if ($key !== false) {
                            $subqueryArray[] = "LOWER(P.$fldnam) LIKE '%" . HtmlEntitiesNOD($keyword) . "%'";
                        }
                    }

                    // search for the other text-based fields
                    if (preg_match('/more/', $moreresults) == 1) {
                        for ($j=0; $j<$comptListFieldsDefinitions; $j++) {
                            if (in_array($listFieldsDefinitions->fdf_dbfieldname[$j], $primFields)) {
                                continue;   // skip primary search fields
                            }

                            $fldtyp = $listFieldsDefinitions->fdf_fieldtype[$j];

                            if ($fldtyp == enumFieldType::ftText || $fldtyp == enumFieldType::ftMemo || $fldtyp == enumFieldType::ftAlphaNumeric || $fldtyp == enumFieldType::ftEmail || $fldtyp == enumFieldType::ftUrl || $fldtyp == enumFieldType::ftSerial) {
                                $subqueryArray[] = "LOWER(P." . $listFieldsDefinitions->fdf_dbfieldname[$j] . ") LIKE '%" . HtmlEntitiesNOD($keyword) . "%'";
                            }
                        }
                    }
                }

                if (count($subqueryArray) > 0) {
                    $subquerySetArray[] = '(' . implode(" OR ", $subqueryArray) . ')';
                }
            }

            if (count($subquerySetArray) == 0) {
                continue;   // no primary search fields or text-based fields to search
            }

            if (preg_match('/more/', $moreresults) == 1) {
                // search in form details
                $querymore1 = " WHERE tdf.fathertable='$tblnam'";
                $listChildTables = new request();
                $listChildTables->openTablesDefinitions($querymore1);
                $comptListChildTables = count($listChildTables->tdf_id);

                for ($k=0; $k<$comptListChildTables; $k++) {
                    $querymore = " WHERE fdf.tablename='" . $listChildTables->tdf_tablename[$k] . "'";
                    $listFieldsDefinitions = new request();
                    $listFieldsDefinitions->openFieldsDefinitions($querymore);
                    $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);
                    $subquerySetArrayC = array();
                    $alias = 'C' . $k;

                    // search for the other text-based fields
                    foreach ($keywords as $keyword) {
                        if (is_array($keyword)) {
                            continue;
                        }

                        $subqueryArrayC = array();

                        for ($j=0; $j<$comptListFieldsDefinitions; $j++) {
                            $fldtyp = $listFieldsDefinitions->fdf_fieldtype[$j];

                            if ($fldtyp == enumFieldType::ftText || $fldtyp == enumFieldType::ftMemo || $fldtyp == enumFieldType::ftAlphaNumeric || $fldtyp == enumFieldType::ftEmail || $fldtyp == enumFieldType::ftUrl || $fldtyp == enumFieldType::ftSerial) {
                                $subqueryArrayC[] = "LOWER($alias." . $listFieldsDefinitions->fdf_dbfieldname[$j] . ") LIKE '%" . HtmlEntitiesNOD($keyword) . "%'";
                            }
                        }

                        if (count($subqueryArrayC) > 0) {
                            $subquerySetArrayC[] = '(' . implode(" OR ", $subqueryArrayC) . ')';
                        }
                    }

                    if (count($subquerySetArrayC) == 0) {
                        continue;   // no primary search fields or text-based fields to search
                    }

                    if ($listChildTables->tdf_sysdef[$k] == 'Y') {
                        $lkfd = $listChildTables->tdf_linkedfield[$k];
                    } else {
                        $lkfd = 'pid';
                    }

                    $querySetArrayC[] = "EXISTS (SELECT $alias.id FROM " . $tablePrefix . $listChildTables->tdf_dbtablename[$k] . " $alias WHERE $alias.$lkfd=P.id AND " . implode(" AND ", $subquerySetArrayC) . ")";
                }
            }

            $tmpquery0 = "SELECT CAST('$tblnam' AS $db_cast_str(155)) AS tblnam, P." . $listTablesDefinitions->tdf_keyfields[$i] . " AS id,CAST('" . count($keywords) . "' AS $db_cast_int) as weight FROM " . $tablePrefix . $dbtblnam . " P";

            if ($listTablesDefinitions->tdf_sysdef[$i] != 'Y') {
                $tmpquery0 .= " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=P.project AND tea.member='$idSession'";
                $tmpquery0 .= " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=P.project AND prp.profil=tea.profil";
            } else if ($listTablesDefinitions->tdf_projectrelated[$i] == 'Y') {
                switch ($tblnam) {
                    case 'posts':
                        $tmpquery0 .= " INNER JOIN " . $tablePrefix . "topics P0 ON P0.id=P.topic";
                        $tmpquery0 .= " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=P0.project AND tea.member='$idSession'";
                        $tmpquery0 .= " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=P0.project AND prp.profil=tea.profil";
                        break;
                    case 'projects':
                        $tmpquery0 .= " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=P.id AND tea.member='$idSession'";
                        $tmpquery0 .= " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=P.id AND prp.profil=tea.profil";
                        break;
                    default:
                        $tmpquery0 .= " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=P.project AND tea.member='$idSession'";
                        $tmpquery0 .= " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=P.project AND prp.profil=tea.profil";
                }
            }

            $tmpquery0 .= " WHERE ((" . implode(" AND ", $subquerySetArray) . ")";

            if (count($querySetArrayC) > 0) {
                $tmpquery0 .= " OR " . implode(" OR ", $querySetArrayC);
            }

            $tmpquery0 .= ")";

            if ($listTablesDefinitions->tdf_sysdef[$i] != 'Y') {
                $tmpquery0 .= " AND ((P.project='0') OR (P.project<>'0' AND prp.view_project='" . enumBoolean::bTrue . "'))";
            } else if ($listTablesDefinitions->tdf_projectrelated[$i] == 'Y') {
                switch ($tblnam) {
                    case 'expenses':
                        $tmpquery0 .= " AND ((P.project='0' AND P.owner='$idSession') OR (P.project<>'0' AND prp.view_expense='" . enumBoolean::bTrue . "'))";
                        break;
                    case 'files':
                        $tmpquery0 .= " AND ((P.project='0') OR (P.project<>'0' AND prp.view_file='" . enumBoolean::bTrue . "'))";
                        break;
                    case 'meetings':
                        $tmpquery0 .= " AND ((P.project='0') OR (P.project<>'0' AND prp.view_meeting='" . enumBoolean::bTrue . "'))";
                        break;
                    case 'notes':
                        $tmpquery0 .= " AND prp.view_note='" . enumBoolean::bTrue . "'";
                        break;
                    case 'posts':
                    case 'topics':
                        $tmpquery0 .= " AND prp.view_discussion='" . enumBoolean::bTrue . "'";
                        break;
                    case 'projects':
                        $tmpquery0 .= " AND prp.view_project='" . enumBoolean::bTrue . "'";
                        break;
                    case 'support_posts':
                    case 'support_requests':
                        $tmpquery0 .= " AND prp.view_support_request='" . enumBoolean::bTrue . "'";
                        break;
                    case 'tasks':
                        $tmpquery0 .= " AND prp.view_task='" . enumBoolean::bTrue . "'";
                        break;
                }
            }

            $querySetArray[] = $tmpquery0;
        }
    }

    if (count($querySetArray) > 0) {
        // join all the sub-query into one big query
        $tmpquery = "SELECT T1.tblnam,T1.id,T1.weight FROM (SELECT T0.tblnam,T0.id,MAX(T0.weight) AS weight FROM (" . implode(" UNION ALL ", $querySetArray) . ") T0 GROUP BY T0.tblnam,T0.id) T1 ORDER BY T1.weight DESC,T1.tblnam";
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings("search"));

if ($searchtype == 'advance') {
    $blockPage->itemBreadcrumbs(lang_strings('advance_search'));
} else {
    $blockPage->itemBreadcrumbs(lang_strings('simple_search'));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "search";
$block1->openForm("../general/search.php?searchtype=$searchtype&searchfor=$searchfor&nosearch=$nosearch&searchonly=$searchonly");

if ($searchtype == 'advance') {
    $block1->heading($block1->buildLink('../general/search.php?searchtype=simple&amp;searchfor=' . $searchfor, lang_strings('simple_search'), 'in') . ' | ' . lang_strings("advance_search"));
} else {
    $block1->heading(lang_strings("simple_search") . ' | ' . $block1->buildLink('../general/search.php?searchtype=advance&amp;searchfor=' . $searchfor . "&amp;nosearch=$nosearch&amp;searchonly=$searchonly", lang_strings("advance_search"), 'in'));
}

$block1->openContent();
$block1->contentTitle(lang_strings("search_options"));
setupInputHTML($block1, lang_strings('enter_keywords'), 'searchfor', enumFieldType::ftText, 'Y', 255, urldecode($searchfor), '', '', $searchfor_highlight);

if ($searchtype == 'advance') {
    echo '<input type="hidden" name="advsubmit" value="true">';
    echo "<input type=\"hidden\" name=\"chkbox_slt\" value=\"$chkbox_slt\">";
    $block1->contentRow('', '<input type="checkbox" id="cb" onchange="togglecheckboxes()"> ' . $strings["select_deselect"]);
    $chkContent = '';

    for ($i=0; $i<$comptListTablesDefinitions; $i++) {
        $tblnam = $listTablesDefinitions->tdf_tablename[$i];
        $tblnamX = preg_replace_callback('/@/', function ($matches) { return 'X40'; }, $tblnam);

        if (($i%4) == 0) {
            if ($chkContent != '') {
                $chkContent .= '</tr>';
            }

            $chkContent .= '<tr>';
        }

        $chkContent .= '<td><input type="checkbox" name="' . $tblnamX . '" value="Y"';

        if (${$tblnamX} == 'Y') {
            $chkContent .= ' checked';
        }

        $chkContent .= '>' . lang_strings('TBL__' . $tblnam) . '</td>';
    }

    $chkContent = '<table>' . $chkContent . '</tr></table>';
    $block1->contentRow("", $chkContent, "false", "&nbsp;");
}

$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["search"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();

if ($tmpquery != '') {
    $block2 = new block();
    $block2->heading(lang_strings("search_results"));
    $block2->openContent();
    $block2->contentTitle(lang_strings("results_for_keywords") . " : <b>" . urldecode($searchfor) . "</b>");
    $comptTotal = compt($tmpquery);     // num. of search results

    if ($comptTotal == "1") {
        $block2->contentRow($comptTotal . ' ' . lang_strings("match"));
    } else  {
        $block2->contentRow($comptTotal . ' ' . lang_strings("matches"));
    }

    if ($comptTotal == "0") {           // no search results found
        $block2->contentRow(lang_strings("no_results_search"));
    }

    if ($moreresults == '') {
        $block2->contentRow("<a href=\"../general/search.php?searchtype=$searchtype&searchfor=$searchfor&nosearch=$nosearch&searchonly=$searchonly&moreresults=more\">" . lang_strings('more_results') . "</a>");
    } else {
        $block2->contentRow("<a href=\"../general/search.php?searchtype=$searchtype&searchfor=$searchfor&nosearch=$nosearch&searchonly=$searchonly&moreresults=\">" . lang_strings('less_results') . "</a>");
    }

    $block2->closeContent();

    if ($comptTotal > 0) {
        $blockPage->bornesNumber = '1';
        $block3 = new block();
        $block3->form = "sRes";
        $block3->openForm("../general/search.php?searchtype=$searchtype&searchfor=$searchfor&nosearch=$nosearch&searchonly=$searchonly&moreresults=$moreresults#" . $block3->form . "Anchor");
        $block3->borne = $blockPage->returnBorne("1");
        $block3->rowsLimit = "20";
        $block3->recordsTotal = $comptTotal;
        $results = new request();
        $results->connectClass();
        $results->query($tmpquery, $block3->borne, $block3->rowsLimit);
        $results->id = array();

        while ($results->fetch()) {
            $results->tablename[] = ($row[0]);
            $results->id[] = ($row[1]);
            $results->weight[] = ($row[2]);
        }

        $results->close();
        $comptResults = count($results->id);
        $labels = array('', lang_strings("document"), lang_strings("id"), lang_strings("description"), lang_strings("accuracy"));
        $block3->openResults(false);
        $block3->labels($labels, 'false', 'false');

        for ($i=0; $i<$comptResults; $i++) {
            $block3->openRow();
            $tblnam = $results->tablename[$i];
            $id = $results->id[$i];

            switch ($tblnam) {
                case 'contacts':
                    $block3->cellRow($blockPage->buildLink('../contacts/viewcontact.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'equipments':
                    $block3->cellRow($blockPage->buildLink('../equipments/viewequipment.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'expenses':
                    $block3->cellRow($blockPage->buildLink('../expenses/viewexpense.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'files':
                    $block3->cellRow($blockPage->buildLink('../linkedcontent/viewfile.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'invoices':
                    $block3->cellRow($blockPage->buildLink('../invoices/viewinvoice.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'materials':
                    $block3->cellRow($blockPage->buildLink('../materials/viewmaterial.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'meetings':
                    $block3->cellRow($blockPage->buildLink('../meetings/viewmeeting.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'members':
                    $block3->cellRow($blockPage->buildLink('../users/viewuser.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'notes':
                    $block3->cellRow($blockPage->buildLink('../notes/viewnote.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'organizations':
                    $block3->cellRow($blockPage->buildLink('../clients/viewclient.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'payments':
                    $block3->cellRow($blockPage->buildLink('../payments/viewpayment.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'posts':
                    $querymore = " WHERE pos.id='$id'";
                    $postDetail = new request();
                    $postDetail->openPosts($querymore);
                    $block3->cellRow($blockPage->buildLink('../topics/viewtopic.php?id=' . $postDetail->pos_topic[0], lang_strings("view"), 'out'));
                    break;
                case 'projects':
                    $block3->cellRow($blockPage->buildLink('../projects/viewproject.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'support_posts':
                    $querymore = " WHERE sp.id='$id'";
                    $spDetail = new request();
                    $spDetail->openSupportPosts($querymore);
                    $block3->cellRow($blockPage->buildLink('../support/viewrequest.php?id=' . $spDetail->sp_request_id[0], lang_strings("view"), 'out'));
                    break;
                case 'support_requests':
                    $block3->cellRow($blockPage->buildLink('../support/viewrequest.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'tasks':
                    $block3->cellRow($blockPage->buildLink('../tasks/viewtask.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                case 'topics':
                    $block3->cellRow($blockPage->buildLink('../topics/viewtopic.php?id=' . $id, lang_strings("view"), 'out'));
                    break;
                default:
                    $block3->cellRow($blockPage->buildLink('../forms/viewform.php?tblnam=' . $tblnam . '&id=' . $id, lang_strings("view"), 'out'));
            }

            $document = lang_strings('TBL__' . $tblnam);

            if (preg_match('/@/', $tblnam)==1) {
                $document .= ' (' . lang_strings('form') . ')';
            }

            $block3->cellRow($document);
            $block3->cellRow($id);
            $block3->cellRow(setupDocDesc($tblnam, $id));
            $accuracy = intval($results->weight[$i] * 100 / $keywordNum);
            $block3->cellRow($accuracy . '%');
            $block3->closeRow();
        }

        $block3->closeResults();
        $block3->bornesFooter("1", $blockPage->bornesNumber, "searchtype=$searchtype&amp;searchfor=$searchfor&amp;nosearch=$nosearch&amp;searchonly=$searchonly&amp;moreresults=$moreresults");
        $block3->closeFormResults();
    }
}

?>
<script type="text/javascript">
function togglecheckboxes() {
    var cb = $('#cb');
    $(':checkbox').each(function() {
        if (this.id !== 'cb') {
            $(this).prop("checked", cb.prop('checked'));
        }
    });
}
</script>
<?php
require_once("../includes/footer.php");
