<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: timeclock.php,v 1.5 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ISSUE: non-block when periods locked
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$typ = isset($_POST['typ'])?$_POST['typ']:'';
$prj = isset($_POST['prj'])?$_POST['prj']:'';
$tas = isset($_POST['tas'])?$_POST['tas']:'';
$mee = isset($_POST['mee'])?$_POST['mee']:'';
$wt = isset($_POST['wt'])?$_POST['wt']:'';
$wk = isset($_POST['wk'])?$_POST['wk']:'';
$ooy = isset($_POST['ooy'])?$_POST['ooy']:'Y';
$serv = isset($_POST['serv'])?$_POST['serv']:'';
$dt = isset($_POST['dt'])?$_POST['dt']:'';
$cancel = isset($_POST['cancel'])?$_POST['cancel']:'';
$error = '';

/**
 * Permission check
 */
$querymore0 = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore0);

if ($memberDetail->mem_enable_timeclock[0] != enumBoolean::bTrue) {
    header('Location: ../general/home.php?msg=permissiondenied');
    exit;
}

$querymore1 = " WHERE tck.owner='$idSession' AND tck.finish='" . enumBoolean::bFalse . "'";
$listTimeClock = new request();
$listTimeClock->openTimeClock($querymore1);
$comptListTimeClock = count($listTimeClock->tck_id);

if (($action == 'clockin' && $comptListTimeClock > 0) || ($action == 'clockout' && $comptListTimeClock <= 0)) {
    $action = '';
}

if ($comptListTimeClock > 0) {
    $prj = $listTimeClock->tck_project[0];
    $tas = $listTimeClock->tck_task[0];
    $mee = $listTimeClock->tck_meeting[0];
    $wk = $listTimeClock->tck_work[0];
    $bf = $listTimeClock->tck_billing[0];
    $serv = $listTimeClock->tck_service[0];
}

/**
 * Fields check
 */
if ($action == 'clockout') {
    if (!is_array($dt) && $cancel != 'true') {
        header('Location: ../general/home.php?msg=permissiondenied');
        exit;
    }
}

/**
 * Actions
 */
if ($error == '') {
    if ($action == 'clockin') {
        if ($prj == '') {
            $prj = '0';
        }

        if ($tas == '') {
            $tas = '0';
        }

        if ($mee == '') {
            $mee = '0';
        }

        if ($wk == '') {
            $wk = '0';
        }

        if ($serv == '') {
            $serv = '0';
        }

        $bf = (($serv=='0')?enumBoolean::bFalse:enumBoolean::bTrue);
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "timeclock (owner,project,task,meeting,work,clockin,billing,service) VALUES ('$idSession','$prj','$tas','$mee','$wk','" . time() . "','$bf','$serv')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            $_SESSION['etcgoSession'] = enumBoolean::bTrue;
            header("Location: ../general/home.php?msg=requestProcessed");
            exit;
        }
    } else if ($action == 'clockout') {
        $hrTtl = 0;
        $comm1 = HtmlEntitiesNOD($comm);
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();

            if ($cancel == 'true') {
                $comm1 = '';
            } else {
                foreach ($dt as $d) {
                    $ts = date2Timestamp($d, '', false, true);
                    $hr = $_POST['d' . $d];

                    if ($hr != '' && $hr > 0) {
                        $hours = round($hr, $hourAccuracy);
                        $hrTtl += $hours;

                        if ($tas != '0') {
                            $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_time (project,task,owner,date,hours,comments,billing,service,created,cuser) VALUES ('$prj','$tas','$idSession','$ts','$hours','$comm1','$bf','$serv','" . time() . "','$idSession')";
                        } else if ($mee != '0') {
                            $tmpsql = "INSERT INTO " . $tablePrefix . "meetings_time (project,meeting,owner,date,hours,comments,created,cuser) VALUES ('$prj','$mee','$idSession','$ts','$hours','$comm1','" . time() . "','$idSession')";
                        } else {
                            $tmpsql = "INSERT INTO " . $tablePrefix . "work_hours (project,work,owner,date,hours,comments,billing,service,created,cuser) VALUES ('$prj','$wk','$idSession','$ts','$hours','$comm1','$bf','$serv','" . time() . "','$idSession')";
                        }

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                        // check if log hours > 24 in each day
                        $tmpquery = "SELECT B.hours FROM (SELECT SUM(A.hours) AS hours FROM (SELECT tim.hours FROM " . $tablePrefix . "tasks_time tim WHERE tim.owner='$idSession' AND tim.date='$ts' UNION ALL SELECT mti.hours FROM " . $tablePrefix . "meetings_time mti WHERE mti.owner='$idSession' AND mti.date='$ts' UNION ALL SELECT wkh.hours FROM " . $tablePrefix . "work_hours wkh WHERE wkh.owner='$idSession' AND wkh.date='$ts') A) B WHERE B.hours>24";
                        $requestAct->query($tmpquery);

                        if ($requestAct->rowCount() > 0) {
                            while ($requestAct->fetch()) {
                                $idx = date('Ymd', $row[0]);
                                $errorDays[] = $idx;
                            }

                            $error = lang_strings('worked_hours') . '&nbsp;' . lang_strings('error_hours');
                            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
                            break;
                        }
                    }
                }
            }

            if ($error == '') {
                $tmpsql = "UPDATE " . $tablePrefix . "timeclock SET finish='" . enumBoolean::bTrue . "',clockout='" . time() . "',hours='$hrTtl',comments='$comm1' WHERE id='" . $listTimeClock->tck_id[0] . "'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $requestAct->endTransaction(enumTransactionEndType::etCommit);
            }
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            $_SESSION['etcgoSession'] = enumBoolean::bFalse;
            header("Location: ../general/home.php?msg=requestProcessed");
            exit;
        }
    }
}
/**
 * Set form data
 */
if ($comptListTimeClock > 0) {  // clock-out
    if ($prj != '0') {
        $querymore = " WHERE pro.id='" . $prj . "'";
        $projectDetail = new request();
        $projectDetail->openProjects($querymore);
    }

    if ($tas != '0') {
        $typ = 'task';
        $querymore = " WHERE tas.id='" . $tas . "'";
        $taskDetail = new request();
        $taskDetail->openTasks($querymore);
    } else if ($mee != '0') {
        $typ = 'meet';
        $querymore = " WHERE mee.id='" . $mee . "'";
        $meetingDetail = new request();
        $meetingDetail->openMeetings($querymore);
    } else {
        $typ = 'work';
        $querymore = " WHERE hrc.id='" . $wk . "'";
        $hourCodeDetail = new request();
        $hourCodeDetail->openHourCode($querymore);
    }

    if ($bf == enumBoolean::bTrue) {
        $querymore = " WHERE serv.id='" . $serv . "'";
        $serviceDetail = new request();
        $serviceDetail->openServices($querymore);
    }
} else {                        // clock-in
    $typVV = array('task' => $strings['task'], 'meet' => $strings['meeting'], 'work' => $strings['others']);

    if ($typ == '') {
        $b1 = mktime(intval(date('H'))-1, date('i'), 0, date('n'), date('j'), date('Y'));
        $a1 = mktime(intval(date('H'))+1, date('i'), 0, date('n'), date('j'), date('Y'));
        $querymore2 = " WHERE att.member='$idSession' AND mee.status IN ('" . enumMeetingStatus::stScheduled . "','" . enumMeetingStatus::stOpen . "') AND mee.start_time<=$a1 AND (mee.start_time+mee.duration)>=$b1 ORDER BY mee.start_time";
        $listAttendees = new request();
        $listAttendees->openAttendees($querymore2);

        if (count($listAttendees->att_meeting) > 0) {
            $typ = 'meet';
            $mee = $listAttendees->att_meeting[0];
            $prj = $listAttendees->att_mee_project[0];
        }

        if ($typ == '') {
            $today = mktime(0, 0, 0, date('n'), date('j'), date('Y'));
            $querymore3 = " AND res.resource='$idSession' AND tas.status IN ('" . enumStatus::stNotStarted . "','" . enumStatus::stOpen . "') AND tas.start_date<='$today' AND tas.due_date>='$today' ORDER BY tas.start_date";
            $listTaskHumanResources = new request();
            $listTaskHumanResources->openTaskHumanResource($querymore3);

            if (count($listTaskHumanResources->res_id) > 0) {
                $typ = 'task';
                $tas = $listTaskHumanResources->res_task[0];
                $prj = $listTaskHumanResources->res_tas_project[0];
            }
        }

        if ($typ == '') {
            $typ = 'work';
            $prj = '';
            $wt = '';
            $wk = '';
        }
    }

    if ($typ == 'work') {
        $querymore6 = " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member='$idSession' AND prp.log_task_hours='" . enumBoolean::bTrue . "'";
        $listProjects0 = new request();
        $listProjects0->openTeams($querymore6);
        $comptListProjects0 = count($listProjects0->tea_project);

        if ($ooy == 'Y') {
            $querymore6 .= " AND pro.status='" . enumProjectStatus::stOpen . "'";
        }

        $querymore6 .= " ORDER BY pro.name";
        $listProjects = new request();
        $listProjects->openTeams($querymore6);
        $comptListProjects = count($listProjects->tea_project);

        if ($wt == '') {
            if ($comptListProjects0 == '0') {
                $wt = enumHourType::htLeave;
            } else {
                $wt = enumHourType::htProject;
            }
        }

        if ($serv == '') {
            $serv = "0";
        }

        if ($wt != enumHourType::htProject) {
            $serv = "0";
            $svcDisabled = true;
        }

        if ($prj == '') {
            if ($wt == enumHourType::htProject) {
                $prj = $listProjects->tea_project[0];
            } else {
                $prj = '0';
            }
        }

        if ($wk == '') {
            $querymore = " WHERE hrc.hourtype='$wt' AND hrc.locked='" . enumBoolean::bFalse . "' ORDER BY hrc.id";
            $defaultHourCode = new request();
            $defaultHourCode->openHourCode($querymore, 0 , 1);

            if (count($defaultHourCode->hrc_id) > 0) {
                $wk = $defaultHourCode->hrc_id[0];
            }
        }
    } else if ($typ == 'task') {
        $querymore = " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member='$idSession' AND prp.log_task_hours='" . enumBoolean::bTrue . "'";

        if ($ooy == 'Y') {
            $querymore .= " AND pro.status='" . enumProjectStatus::stOpen . "' ORDER BY pro.name";
        } else {
            $querymore .= " ORDER BY pro.name";
        }

        $listProjects = new request();
        $listProjects->openTeams($querymore);
        $comptListProjects = count($listProjects->tea_project);

        if ($prj == '' && $comptListProjects > 0) {
            $prj = $listProjects->tea_project[0];
        }

        if ($prj != '') {
            $querymore1 = " WHERE pro.id='$prj'";
            $projectDetail = new request();
            $projectDetail->openProjects($querymore1);
            $querymore2 = " AND res.resource='$idSession' AND tas.project='$prj' ORDER BY tas.name";
            $listTasks = new request();
            $listTasks->openTaskHumanResource($querymore2);
            $comptListTasks = count($listTasks->res_id);
            $querymore = " WHERE tea.project='$prj' AND tea.member='$idSession'";
            $memberDetail = new request();
            $memberDetail->openTeams($querymore);
        } else {
            $comptListTasks = 0;
        }

        if ($tas == '' && $comptListTasks > 0) {
            $tas = $listTasks->res_task[0];
        } else if ($tas != '' && $comptListTasks == 0) {
            $tas = '';
        }

        if ($tas != '') {
            $querymore = " WHERE tas.id='$tas'";
            $taskDetail = new request();
            $taskDetail->openTasks($querymore);
        } else {
            $saveDisabled = 'disabled';
        }
    } else {
        $querymore = " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member='$idSession' AND prp.log_meeting_hours='" . enumBoolean::bTrue . "'";

        if ($ooy == 'Y') {
            $querymore .= " AND pro.status='" . enumProjectStatus::stOpen . "' ORDER BY pro.name";
        } else {
            $querymore .= " ORDER BY pro.name";
        }

        $listProjects = new request();
        $listProjects->openTeams($querymore);
        $comptListProjects = count($listProjects->tea_project);

        if ($prj != '0' && $id == '') {
            if ($comptListProjects == '0') {
                $prj = '0';
            } else if (!in_array($prj, $listProjects->tea_project)) {
                $prj = '0';
            }
        }

        if ($prj != '0') {
            $querymore = " WHERE pro.id='$prj'";
            $projectDetail = new request();
            $projectDetail->openProjects($querymore);
        }

        $querymore = " WHERE mee.project='$prj' AND att.member='$idSession' AND mee.status IN ('" . enumMeetingStatus::stOpen . "','" . enumMeetingStatus::stScheduled . "') ORDER BY mee.name";
        $listMeeAttendees = new request();
        $listMeeAttendees->openAttendees($querymore);
        $comptListMeeAttendees = count($listMeeAttendees->att_meeting);

        if ($mee == '' && $comptListMeeAttendees > 0) {
            $mee = $listMeeAttendees->att_meeting[0];
        } else if ($mee != '' && $comptListMeeAttendees == 0) {
            $mee = '';
        }

        if ($mee != '') {
            $querymore = " WHERE mee.id='$mee'";
            $meetingDetail = new request();
            $meetingDetail->openMeetings($querymore);
            $st = $meetingDetail->mee_start_time[0];
            $du = $meetingDetail->mee_duration[0];
            $dat = mktime(0,0,0,intval(date('n',$st)),intval(date('j',$st)),intval(date('Y',$st)));
        } else {
            $st = '';
            $du = '';
            $dat = '';
            $saveDisabled = 'disabled';
        }

        if ($ooy == 'Y') {
            $openonlyChecked = 'checked';
        }
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
echo '<script type="text/javascript" src="../javascript/timeclock' . $scriptMinimized . '.js"></script>';
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../general/home.php', lang_strings("home"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('timeclock'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "tck";
$block1->openForm("../general/timeclock.php?#" . $block1->form . "Anchor");

if ($comptListTimeClock > 0) {
    echo '<input type="hidden" name="action" value="clockout">';
    $block1->heading(lang_strings('clockout'));
} else {
    echo '<input type="hidden" name="action" value="clockin">';
    $block1->heading(lang_strings('clockin'));
}

$block1->openContent();

if ($comptListTimeClock > 0) {
    if ($typ == 'task') {
        $block1->contentRow(lang_strings('project'), $taskDetail->tas_pro_name[0]);
        $block1->contentRow(lang_strings('task'), $taskDetail->tas_name[0]);

        if ($bf == enumBoolean::bTrue) {
            $block1->contentRow(lang_strings('service'), $serviceDetail->serv_name_print[0]);
        }
    } else if ($typ == 'mee') {
        if ($prj != '0') {
            $block1->contentRow(lang_strings('project'), $meetingDetail->mee_pro_name[0]);
        }

        $block1->contentRow(lang_strings('meeting'), $meetingDetail->mee_name[0]);
    } else {
        $block1->contentRow(lang_strings("hourtype"), $hourCodeDetail->hrc_hrt_name_print[0]);

        if ($prj != '0') {
            $block1->contentRow(lang_strings('project'), $projectDetail->pro_name[0]);
        }

        $block1->contentRow(lang_strings("hourcode"), $hourCodeDetail->hrc_name_print[0]);

        if ($bf == enumBoolean::bTrue) {
            $block1->contentRow(lang_strings('service'), $serviceDetail->serv_name_print[0]);
        }
    }

    $tsNow = time();
    $tsIn = $listTimeClock->tck_clockin[0];
    $block1->contentRow(lang_strings('clockin'), createDate($tsIn, 'both'));
    $block1->contentRow(lang_strings('clockout'), createDate($tsNow, 'both'));
    $today = createDate($tsNow, 'date', false, false, true);
    $dt = createDate($tsIn, 'date', false, false, true);

    while ($dt <= $today) {
        $ts1 = date2Timestamp($dt, '24:00', true, true);
        echo '<input type="hidden" name="dt[]" value="' .$dt . '">';

        if ($dt == $today) {
            $s = $tsNow - $tsIn;
        } else {
            $s = $ts1 - $tsIn;
        }

        $val = round($s / 3600, $hourAccuracy);
        setupInputHTML($block1, createDate($tsIn, 'date'), 'd' . $dt, enumFieldType::ftHours, 'N', '19', $val);
        $tsIn = $ts1;
        $dt = createDate($tsIn, 'date', false, false, true);
    }
    // comments
    setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
    echo '<input type="hidden" name="cancel" value="">';
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings["save"] . '"> <input type="button" value="' . $strings['cancel'] . '" onclick="dropHours()">');
} else {
    setupInputHTML($block1, lang_strings('type'), 'typ', enumFieldType::ftAlphaNumeric, 'Y', '4', $typ, $typVV, '', false, '', 'onchange="changeOptions()"');

    if ($typ == 'work') {
        // work type
        $querymore8 = " WHERE hrt.locked='" . enumBoolean::bFalse . "' ORDER BY hrt.id";
        $listHourType = new request();
        $listHourType->openHourType($querymore8);
        $comptListHourType = count($listHourType->hrt_id);
        $worktypeSel = "<select name=\"wt\" onchange=\"changeOptions()\">";

        for ($i=0; $i<$comptListHourType; $i++) {
            if ($comptListProjects0 > 0 || $listHourType->hrt_id[$i] != enumHourType::htProject) {
                $worktypeSel .= '<option value="' . $listHourType->hrt_id[$i] . '"' . (($wt == $listHourType->hrt_id[$i])?" selected":"") . '>' . $listHourType->hrt_name_print[$i] . '</option>';
            }
        }

        $worktypeSel .= "</select>";
        $block1->contentRow('* ' . lang_strings("hourtype"), $worktypeSel);

        if ($wt == enumHourType::htProject) {
            // project
            $projectSel = "<select name=\"prj\" onchange=\"changeOptions()\">";

            for ($i=0; $i<$comptListProjects; $i++) {
                $projectSel .= "<option value=\"" . $listProjects->tea_project[$i] . "\"" . (($prj == $listProjects->tea_project[$i])?" selected":"") . ">" . $listProjects->tea_pro_name[$i] . "</option>";
            }

            $projectSel .= '</select>&nbsp;&nbsp;<input type="checkbox" name="openonly" value="Y" onchange="changeOpenOnly(this)" ' . (($ooy=='Y')?' checked':'') . '><input type="hidden" name="ooy" value="' . $ooy . '">' . lang_strings('ongoing_project_only');
            $block1->contentRow('* ' . lang_strings("project"), $projectSel);
        } else {
            echo "<input type=\"hidden\" name=\"prj\" value=\"0\">";
        }

        // work code
        $querymore9 = " WHERE hrc.hourtype='$wt' AND hrc.locked='" . enumBoolean::bFalse . "' ORDER BY hrc.id";
        $listHourCode = new request();
        $listHourCode->openHourCode($querymore9);
        $comptListHourCode = count($listHourCode->hrc_id);
        $workcodeSel = "<select name=\"wk\">";

        for ($i=0; $i<$comptListHourCode; $i++) {
            $workcodeSel .= '<option value="' . $listHourCode->hrc_id[$i] . '"' . (($wk == $listHourCode->hrc_id[$i])?" selected":"") . '>' . $listHourCode->hrc_id[$i] . ' - ' . $listHourCode->hrc_name_print[$i] . '</option>';
        }

        $workcodeSel .= "</select>";
        $block1->contentRow('* ' . lang_strings("hourcode"), $workcodeSel);

        if ($wt == enumHourType::htProject) {
            $querymore = " WHERE serv.locked='" . enumBoolean::bFalse . "'";

            if ($prj != '') {
                $querymore1 = " WHERE pro.id='$prj'";
                $projectDetail = new request();
                $projectDetail->openProjects($querymore1);
                $comptProjectDetail = count($projectDetail->pro_id);

                if ($comptProjectDetail != '0' && $projectDetail->pro_currency[0] != '') {
                    $querymore .= " AND serv.currency='" . $projectDetail->pro_currency[0] . "'";
                }
            }

            $querymore .= " ORDER BY serv.name";
            $listServices = new request();
            $listServices->openServices($querymore);
            $comptListServices = count($listServices->serv_id);
            $serviceSel = "<select name=\"serv\"><option value=\"0\">" . lang_strings("none") . "</option>";

            for ($i=0; $i<$comptListServices; $i++) {
                $serviceSel .= "<option value='" . $listServices->serv_id[$i] . "'" . (($listServices->serv_id[$i] == $serv)?' selected':'') . ">" . $listServices->serv_name_print[$i] . '</option>';
            }

            $serviceSel .= "</select>";
            $block1->contentRow(lang_strings("service"), $serviceSel);
        } else {
            echo "<input type=\"hidden\" name=\"serv\" value=\"0\">";
        }
    } else if ($typ == 'task') {
        // project
        $projectSel = "<select name=\"prj\" onchange=\"changeOptions()\">";

        for ($i=0; $i<$comptListProjects; $i++) {
            if ($prj == $listProjects->tea_project[$i]) {
                $projectSel .= "<option value=\"" . $listProjects->tea_project[$i] . "\" selected>" . $listProjects->tea_pro_name[$i] . "</option>";
            } else {
                $projectSel .= "<option value=\"" . $listProjects->tea_project[$i] . "\">" . $listProjects->tea_pro_name[$i] . "</option>";
            }
        }

        $projectSel .= '</select>&nbsp;&nbsp;<input type="checkbox" name="openonly" value="Y" onchange="changeOpenOnly(this)"' . (($ooy=='Y')?' checked':'') . '><input type="hidden" name="ooy" value="' . $ooy . '">' . lang_strings('ongoing_project_only');
        $block1->contentRow('* ' . lang_strings("project"), $projectSel);

        // task
        $taskSel = "<select name=\"tas\" onchange=\"changeOptions()\">";

        for ($i=0; $i<$comptListTasks; $i++) {
            if ($tas == $listTasks->res_task[$i]) {
                $taskSel .= "<option value=\"" . $listTasks->res_task[$i] . "\" selected>" . $listTasks->res_tas_name[$i] . "</option>";
            } else {
                $taskSel .= "<option value=\"" . $listTasks->res_task[$i] . "\">" . $listTasks->res_tas_name[$i] . "</option>";
            }
        }

        $taskSel .= "</select>";
        $block1->contentRow('* ' . lang_strings("task"), $taskSel);
        $servSel = "<select name=\"serv\">";

        if ($taskDetail->tas_service[0] != '' && $taskDetail->tas_service[0] != '0') {
            $querymore = " WHERE serv.id='" . $taskDetail->tas_service[0] . "'";
            $serviceDetail = new request();
            $serviceDetail->openServices($querymore);

            if ($taskDetail->tas_service[0] == $serv) {
                $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
            } else {
                $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
            }
        } else if ($memberDetail->tea_service[0] != '' && $memberDetail->tea_service[0] != '0') {
            $querymore = " WHERE serv.id='" . $memberDetail->tea_service[0] . "'";
            $serviceDetail = new request();
            $serviceDetail->openServices($querymore);

            if ($memberDetail->tea_service[0] == $serv) {
                $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
            } else {
                $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
            }
        }

        if ($serv == '0') {
            $servSel .= "<option value='0' selected>" . $strings["none"] . "</option>";
        } else {
            $servSel .= "<option value='0'>" . $strings["none"] . "</option>";
        }

        $servSel .= "</select>";
        $block1->contentRow(lang_strings("service"), $servSel);
    } else {
        // project
        $projectSel = '<select name="prj" onchange="changeOptions()"><option value="0"';

        if ($prj == '0') {
            $projectSel .= ' selected';
        }

        $projectSel .= '></option>';

        for ($i=0; $i<$comptListProjects; $i++) {
            $projectSel .= "<option value=\"" . $listProjects->tea_project[$i] . "\"";

            if ($prj == $listProjects->tea_project[$i]) {
                $projectSel .= " selected";
            }

            $projectSel .= ">" . $listProjects->tea_pro_name[$i] . "</option>";
        }

        $projectSel .= '</select>&nbsp;&nbsp;<input type="checkbox" name="openonly" value="Y" onchange="changeOpenOnly(this)" ' . $openonlyChecked . '><input type="hidden" name="ooy" value="' . $ooy . '">' . lang_strings('ongoing_project_only');
        $block1->contentRow('* ' . lang_strings("project"), $projectSel);
        // meeting
        $meetingSel = "<select name=\"mee\" onchange=\"changeOptions()\">";

        for ($i=0; $i<$comptListMeeAttendees; $i++) {
            $meetingSel .= "<option value=\"" . $listMeeAttendees->att_meeting[$i] . "\" ";

            if ($mee == $listMeeAttendees->att_meeting[$i]) {
                $meetingSel .= "selected";
            }

            $meetingSel .= ">" . $listMeeAttendees->att_mee_name[$i] . "</option>";
        }

        $meetingSel .= "</select>";
        $block1->contentRow('* ' . lang_strings("meeting"), $meetingSel);

        if ($st != '') {
            $block1->contentRow(lang_strings("start_time"), createDate($st, 'both'));
            $block1->contentRow(lang_strings("duration"), NumberFormatNOD($du, $hourAccuracy, false));
        }
    }

    $block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\" $saveDisabled>");
}

$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script>
function dropHours()
{
    var x=document.tckForm;
    x.cancel.value = "true";
    document.tckForm.submit();
}
function changeOptions()
{
    var x=document.tckForm;
    x.action.value="";
    document.tckForm.submit();
}
function changeOpenOnly(theObj)
{
    if (theObj.checked === true) {
        document.tckForm.ooy.value = 'Y';
    } else {
        document.tckForm.ooy.value = 'N';
    }

    document.tckForm.action.value="";
    document.tckForm.submit();
}
</script>
<?php
require_once("../includes/footer.php");
