<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewnotification.php,v 1.5 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');    // Message ID
$error = '';

/**
 * Permission check
 */
if ($id == '') {
    exit;
}

$querymore0 = " WHERE mes.id='$id' AND mes.to_id='$idSession' AND mes.message_type='S'";
$messageDetail = new request();
$messageDetail->openMessages($querymore0);

if (count($messageDetail->mes_id) == 0) {
    exit;
}

/**
 * Mark message as read
 */
if ($messageDetail->mes_seen[0] == 'N') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "UPDATE " . $tablePrefix . "messages SET seen='Y' WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
}

/**
 * newer messages & older messages
 */
$querymore1 = " WHERE mes.to_id='$idSession' AND mes.message_type='S' AND mes.archived='N' AND mes.id>'$id' ORDER BY mes.seen,mes.created DESC";
$newerMessages = new request();
$newerMessages->openMessages($querymore1);
$querymore2 = " WHERE mes.to_id='$idSession' AND mes.message_type='S' AND mes.archived='N' AND mes.id<'$id' ORDER BY mes.seen,mes.created DESC";
$olderMessages = new request();
$olderMessages->openMessages($querymore2);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../general/newnotifications.php', lang_strings("my_notifications"), 'in'));
$blockPage->itemBreadcrumbs($messageDetail->mes_subject[0]);
$blockPage->closeBreadcrumbs();
echo '<div class="footerCell clear"><ul><li>';

if (count($newerMessages->mes_id) > 0) {
    echo $blockPage->buildLink('../general/viewnotification.php?id=' . $newerMessages->mes_id[0], '<div class="pageNumber">&laquo;</div>', 'in') . '</li><li>';
    echo $blockPage->buildLink('../general/viewnotification.php?id=' . $newerMessages->mes_id[count($newerMessages->mes_id)-1], '<div class="pageNumber">&lsaquo;</div>', 'in') . '</li><li>';
} else {
    echo '<div class="pageNumber-gray">&laquo;</div></li><li><div class="pageNumber-gray">&lsaquo;</div></li><li>';
}

if (count($olderMessages->mes_id) > 0) {
    echo $blockPage->buildLink('../general/viewnotification.php?id=' . $olderMessages->mes_id[0], '<div class="pageNumber">&rsaquo;</div>', 'in') . '</li><li>';
    echo $blockPage->buildLink('../general/viewnotification.php?id=' . $olderMessages->mes_id[count($olderMessages->mes_id)-1], '<div class="pageNumber">&raquo;</div>', 'in');
} else {
    echo '<div class="pageNumber-gray">&rsaquo;</div></li><li><div class="pageNumber-gray">&raquo;</div>';
}

echo '</li></ul></div>
<h2>' . $messageDetail->mes_subject[0] . '</h2>
<h3>' . $strings['from'] . ' : ' . $messageDetail->mes_mem_name[0] . '</h3>
' . $messageDetail->mes_message[0];
require_once("../includes/footer.php");
