<?php // $Revision: 1.28 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: arrays.lib.php,v 1.28 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * DEFINES ARRAYS
 */
// Options for auto logout
$autoLogoutOptions = array(
    0 => $strings['disabled'],              // auto logout disabled
    300 => '5 ' . $strings['minutes'],      // auto logout after 5 minutes idle
    600 => '10 ' . $strings['minutes'],     // auto logout after 10 minutes idle
    900 => '15 ' . $strings['minutes'],     // auto logout after 15 minutes idle
    1800 => '30 ' . $strings['minutes'],    // auto logout after 30 minutes idle
    2700 => '45 ' . $strings['minutes'],    // auto logout after 45 minutes idle
    3600 => '60 ' . $strings['minutes']     // auto logout after 1 hour idle
    );
// Options for the start page after login
$startPageOptions = array(
    'general/home.php' => $strings['home_page'],                            // home
    'timesheet/viewtimesheet.php' => $strings['timesheet'],                 // timesheet
    'calendar/viewcalendar.php' => $strings['calendar'],                    // calendar
    'reports/listreports.php?cat=1' => $strings['reports'],                 // custom report list
    'linkedcontent/listfiles.php?doc_type=0&id=0' => $strings['documents'], // document list
    'contacts/listcontacts.php' => $strings['contacts'],                    // contact list
    'clients/listclients.php' => $strings['organizations'],                 // client organization list
    'invoices/listinvoices.php' => $strings['invoices'],                    // invoice list
    'payments/listpayments.php' => $strings['payments'],                    // payment list
    'expenses/listexpenses.php' => $strings['expenses'],                    // expense list
    'administration/admin.php' => $strings['administration']                // administration
    );
// file size unit
$byteUnits = array(
    $strings['bytes'],
    $strings['kb'],
    $strings['mb'],
    $strings['gb']
    );
$dayNameArray = array(
    0 => $strings['sunday'],
    1 => $strings['monday'],
    2 => $strings['tuesday'],
    3 => $strings['wednesday'],
    4 => $strings['thursday'],
    5 => $strings['friday'],
    6 => $strings['saturday'],
    7 => $strings['sunday']
    );
$dayShortNameArray = array(
    0 => $strings['sun'],
    1 => $strings['mon'],
    2 => $strings['tue'],
    3 => $strings['wed'],
    4 => $strings['thu'],
    5 => $strings['fri'],
    6 => $strings['sat'],
    7 => $strings['sun']
    );
$monthNameArray = array(
    1 => $strings['january'],
    2 => $strings['february'],
    3 => $strings['march'],
    4 => $strings['april'],
    5 => $strings['may_'],
    6 => $strings['june'],
    7 => $strings['july'],
    8 => $strings['august'],
    9 => $strings['september'],
    10 => $strings['october'],
    11 => $strings['november'],
    12 => $strings['december']
    );
$monthShortNameArray = array(
    1 => $strings['jan'],
    2 => $strings['feb'],
    3 => $strings['mar'],
    4 => $strings['apr'],
    5 => $strings['may'],
    6 => $strings['jun'],
    7 => $strings['jul'],
    8 => $strings['aug'],
    9 => $strings['sep'],
    10 => $strings['oct'],
    11 => $strings['nov'],
    12 => $strings['dec']
    );
$status = array(
    enumStatus::stClientCompleted => $strings['client_completed'],
    enumStatus::stCompleted => $strings['completed'],
    enumStatus::stNotStarted => $strings['not_started'],
    enumStatus::stOpen => $strings['open'],
    enumStatus::stSuspended => $strings['suspended']
    );
$statusTeamTask = array(
    enumStatus::stNotStarted => $strings['not_started'],
    enumStatus::stOpen => $strings['open'],
    enumStatus::stCompleted => $strings['completed'],
    enumStatus::stSuspended => $strings['suspended']
    );
$statusClientTask = array(
    enumStatus::stOpen => $strings['open'],
    enumStatus::stClientCompleted => $strings['client_completed']
    );
$statusProject = array(
    enumProjectStatus::stInitiation => $strings['initiation'],
    enumProjectStatus::stCanceled => $strings['canceled'],
    enumProjectStatus::stPlanning => $strings['planning'],
    enumProjectStatus::stOpen => $strings['open'],
    enumProjectStatus::stCompleted => $strings['completed'],
    enumProjectStatus::stSuspended => $strings['suspended']
    );
$statusMeeting = array(
    enumMeetingStatus::stScheduling => $strings['scheduling'],
    enumMeetingStatus::stScheduled => $strings['scheduled'],
    enumMeetingStatus::stOpen => $strings['open'],
    enumMeetingStatus::stCompleted => $strings['completed'],
    enumMeetingStatus::stCanceled => $strings['canceled']
    );
$priority = array(
    enumPriority::prNone => $strings['none'],
    enumPriority::prVeryLow => $strings['very_low'],
    enumPriority::prLow => $strings['low'],
    enumPriority::prMedium => $strings['medium'],
    enumPriority::prHigh => $strings['high'],
    enumPriority::prVeryHigh => $strings['very_high']
    );
$statusTopic = array(
    0 => $strings['closed'],
    1 => $strings['open']
    );
$statusTopicBis = array(
    0 => $strings['yes'],
    1 => $strings['no']
    );
$statusPublish = array(
    enumPublished::pbYes => $strings['yes'],
    enumPublished::pbNo => $strings['no']
    );
$statusFile = array(
    enumFileStatus::stApproved => $strings['approved'],
    enumFileStatus::stApprovedWithChanges => $strings['approved_with_changes'],
    enumFileStatus::stNeedsApproval => $strings['needs_approval'],
    enumFileStatus::stNoApprovalsNeeded => $strings['no_approvals_needed'],
    enumFileStatus::stNotApproved => $strings['not_approved']
    );
$phaseStatus = array(
    enumPhaseStatus::stNotStarted => $strings['not_started'],
    enumPhaseStatus::stOpen => $strings['open'],
    enumPhaseStatus::stCompleted => $strings['completed'],
    enumPhaseStatus::stSuspended => $strings['suspended']
    );
$requestStatus = array(
    enumRequestStatus::stNew => $strings['new'],
    enumRequestStatus::stOpen => $strings['open'],
    enumRequestStatus::stCompleted => $strings['completed']
    );
$projectType = array(
    enumProjectType::tyInternal => $strings['internal_project'],
    enumProjectType::tyExternal => $strings['external_project']
    );
$dayHourArray = array(
    0 => "0",
    1 => "8",
    2 => "8",
    3 => "8",
    4 => "8",
    5 => "8",
    6 => "0",
    7 => "0"
    );
$taskPredecessorTypes = array(
    "FS" => $strings['finish_to_start'],
    "FF" => $strings['finish_to_finish'],
    "SF" => $strings['start_to_finish'],
    "SS" => $strings['start_to_start']
    );
$reminderTimeArray = array(
    "0"     => "--",
    "5"     => "5 " . $strings['minutes'],
    "15"    => "15 " . $strings['minutes'],
    "30"    => "30 " . $strings['minutes'],
    "60"    => "1 " . $strings['hour'],
    "120"   => "2 " . $strings['hours'],
    "180"   => "3 " . $strings['hours'],
    "360"   => "6 " . $strings['hours'],
    "720"   => "12 " . $strings['hours'],
    "1440"  => "1 " . $strings['day'],
    "2880"  => "2 " . $strings['days'],
    "4320"  => "3 " . $strings['days'],
    "5760"  => "4 " . $strings['days'],
    "7200"  => "5 " . $strings['days'],
    "8640"  => "6 " . $strings['days'],
    "10080" => "1 " . $strings['week'],
    "11520" => "8 " . $strings['days'],
    "12960" => "9 " . $strings['days'],
    "14400" => "10 " . $strings['days'],
    "15840" => "11 " . $strings['days'],
    "17280" => "12 " . $strings['days'],
    "18720" => "13 " . $strings['days'],
    "20160" => "2 " . $strings['weeks']
    );
$milestoneis = array(
    enumMilestone::msYes => $strings['yes'],
    enumMilestone::msNo => $strings['no']
    );
$leaveCodeArray = array(
    enumLeaveType::lvAnnual,
    enumLeaveType::lvSick,
    enumLeaveType::lvAbsence,
    enumLeaveType::lvBankHoliday,
    enumLeaveType::lvMourning,
    enumLeaveType::lvHoneyMoon,
    enumLeaveType::lvMaternity
    );
$limitedLeaveCodeArray = array(
    enumLeaveType::lvAnnual,
    enumLeaveType::lvSick,
    enumLeaveType::lvAbsence
    );
$dayType = array(
    enumDayType::dtWeekend => $strings['weekend'],
    enumDayType::dtStatutoryHoliday => $strings['statutory_holiday'],
    enumDayType::dtMakeupHoliday => $strings['makeup_holiday'],
    enumDayType::dtWorkday => $strings['workday']
    );
$dayTypeClass = array(
    enumDayType::dtWeekend => 'weekend',
    enumDayType::dtStatutoryHoliday => 'statutoryHoliday',
    enumDayType::dtMakeupHoliday => 'makeupHoliday',
    enumDayType::dtWorkday => 'workday'
    );
$billingFlag = array(
    enumBoolean::bTrue => $strings['billable'],
    enumBoolean::bFalse => $strings['non_billable']
    );
$sortingArray = array(
    enumSortingOrder::oAscending => $strings['ascending'],
    enumSortingOrder::oDescending => $strings['descending']
    );
$permissionLevels = array(
    enumPermissionLevel::plRestrictedExceptLeader => $strings['restricted_leader'],
    enumPermissionLevel::plRestricted => $strings['restricted'],
    enumPermissionLevel::plNoLimitsExceptObserver => $strings['nolimits_observer'],
    enumPermissionLevel::plCustom => $strings['custom']
    );
$projectRoles = array(
    enumProjectProfile::ppLeader => $strings['project_leader'],
    enumProjectProfile::ppCoLeader => $strings['project_coleader'],
    enumProjectProfile::ppMember => $strings['project_member'],
    enumProjectProfile::ppObserver => $strings['project_observer'],
    enumProjectProfile::ppGuest => $strings['project_guest']
    );
$rolePermissionMatrix = array(
    'Project' => array(
        $strings['project'],
        array(
            'view_project' => $strings['view_project'],
            'create_customer_service_site' => $strings['create_customerservicesite'],
            'copy_project' => $strings['copy_project'],
            'import_project' => $strings['import_project'],
            'export_project' => $strings['export_project'],
            'modify_project_properties' => $strings['modify_project_properties'],
            'delete_project' => $strings['delete_project']
            ),
        array(
            'Read',
            'Write',
            'Write',
            'Write',
            'Write',
            'Edit',
            'Admin'
            )
        ),
    'Project Cost' => array(
        $strings['project_cost'],
        array(
            'view_project_budget' => $strings['view_project_budget'],
            'view_project_cost' => $strings['view_project_cost']
            ),
        array(
            'Read',
            'Read'
            )
        ),
    'Phase' => array(
        $strings['phase'],
        array(
            'view_phase' => $strings['view_phase'],
            'modify_phase_properties' => $strings['modify_phase_properties']
            ),
        array(
            'Read',
            'Edit'
            )
        ),
    'Task' => array(
        $strings['task'],
        array(
            'view_task' => $strings['view_task'],
            'create_task' => $strings['create_task'],
            'copy_task' => $strings['copy_task'],
            'modify_task_status' => $strings['modify_task_status'],
            'log_task_hours' => $strings["loghours"],
            'material_issue' => $strings['material_issue'],
            'arrange_task_resource' => $strings['arrange_task_resource'],
            'modify_task_properties' => $strings['modify_task_properties'],
            'edit_task_relationships' => $strings['edit_task_relationships'],
            'delete_task' => $strings['delete_task'],
            'configure_task_security' => $strings['configure_task_security'],
            'publish_task' => $strings['publish_task']
            ),
        array(
            'Read',
            'Write',
            'Write',
            'Write',
            'Write',
            'Write',
            'Edit',
            'Edit',
            'Edit',
            'Admin',
            'Admin',
            'Admin'
            )
        ),
    'Milestone' => array(
        $strings['milestone'],
        array(
            'view_milestone' => $strings['view_milestone'],
            'create_milestone' => $strings['create_milestone'],
            'modify_milestone_properties' => $strings['modify_milestone_properties'],
            'delete_milestone' => $strings['delete_milestone'],
            'configure_milestone_security' => $strings['configure_milestone_security'],
            'publish_milestone' => $strings['publish_milestone']
            ),
        array(
            'Read',
            'Write',
            'Edit',
            'Admin',
            'Admin',
            'Admin'
            )
        ),
    'Meeting' => array(
        $strings['meeting'],
        array(
            'view_meeting' => $strings['view_meeting'],
            'create_meeting' => $strings['create_meeting'],
            'copy_meeting' => $strings['copy_meeting'],
            'modify_meeting_status' => $strings['modify_meeting_status'],
            'log_meeting_hours' => $strings["loghours"],
            'arrange_meeting_resource' => $strings['arrange_meeting_resource'],
            'modify_meeting_properties' => $strings['modify_meeting_properties'],
            'delete_meeting' => $strings['delete_meeting'],
            'configure_meeting_security' => $strings['configure_meeting_security']
            ),
        array(
            'Read',
            'Write',
            'Write',
            'Write',
            'Write',
            'Edit',
            'Edit',
            'Admin',
            'Admin'
            )
        ),
    'Support' => array(
        $strings['support'],
        array(
            'view_support_request' => $strings['view_support_request'],
            'add_support_response' => $strings['add_support_response'],
            'assign_support_request' => $strings['assign_support_request'],
            'close_support_request' => $strings['close_support_request'],
            'delete_support_request' => $strings['delete_support_request']
            ),
        array(
            'Read',
            'Write',
            'Edit',
            'Edit',
            'Admin'
            )
        ),
    'Discussion' => array(
        $strings['discussion'] . '/' . $strings['bulletin_board'],
        array(
            'view_discussion' => $strings['view_discussion'],
            'add_discussion_topic' => $strings['add_discussion_topic'],
            'post_reply' => $strings['post_reply'],
            'close_discussion_topic' => $strings['close_discussion_topic'],
            'publish_discussion_topic' => $strings['publish_discussion_topic'],
            'delete_discussion_topic' => $strings['delete_discussion_topic']
            ),
        array(
            'Read',
            'Write',
            'Write',
            'Edit',
            'Edit',
            'Admin'
            )
        ),
    'Team' => array(
        $strings['team'],
        array(
            'view_team' => $strings['view_team'],
            'send_message' => $strings['send_message'],
            'add_team_member' => $strings['add_team_member'],
            'publish_team_member' => $strings['publish_team_member'],
            'modify_team_member_properties' => $strings['modify_team_member_properties'],
            'delete_team_member' => $strings['delete_team_member']
            ),
        array(
            'Read',
            'Read',
            'Write',
            'Edit',
            'Edit',
            'Admin'
            )
        ),
    'File' => array(
        $strings['files'],
        array(
            'view_file' => $strings['view_file'],
            'add_file' => $strings['add_file'],
            'update_file' => $strings['update_file'],
            'publish_file' => $strings['publish_file'],
            'delete_file' => $strings['delete_file']
            ),
        array(
            'Read',
            'Write',
            'Write',
            'Edit',
            'Admin'
            )
        ),
    'Note' => array(
        $strings['note'],
        array(
            'view_note' => $strings['view_note'],
            'add_note' => $strings['add_note'],
            'modify_note_properties' => $strings['modify_note_properties'],
            'delete_note' => $strings['delete_note1'],
            'publish_note' => $strings['publish_note']
            ),
        array(
            'Read',
            'Write',
            'Edit',
            'Admin',
            'Admin'
            )
        ),
    'Calendar' => array(
        $strings['calendar'],
        array(
            'view_calendar' => $strings['view_calendar'],
            'add_calendar_event' => $strings['add_calendar_event'],
            'modify_calendar_event' => $strings['modify_calendar_event'],
            'delete_calendar_event' => $strings['delete_calendar_event']
            ),
        array(
            'Read',
            'Write',
            'Edit',
            'Admin'
            )
        ),
    'Role' => array(
        $strings['role'],
        array(
            'view_role' => $strings['view_role'],
            'configure_role_security' => $strings['configure_role_security']
            ),
        array(
            'Read',
            'Admin'
            )
        ),
    'Expense' => array(
        $strings['expense'],
        array(
            'view_expense' => $strings['view_expense'],
            'create_expense' => $strings['create_expense'],
            'modify_expense_properties' => $strings['modify_expense_properties'],
            'delete_expense' => $strings['delete_expense']
            ),
        array(
            'Read',
            'Write',
            'Edit',
            'Admin'
            )
        )
    );
$leaveType = array(
    enumLeaveType::lvAnnual => $strings['HRC__10100'],
    enumLeaveType::lvSick => $strings['HRC__10101'],
    enumLeaveType::lvAbsence => $strings['HRC__10102'],
    enumLeaveType::lvBankHoliday => $strings['HRC__10103'],
    enumLeaveType::lvMourning => $strings['HRC__10104'],
    enumLeaveType::lvHoneyMoon => $strings['HRC__10105'],
    enumLeaveType::lvMaternity => $strings['HRC__10106']
    );
$authorizerType = array(
    enumAuthorizerType::atUser => $strings['user'],
    enumAuthorizerType::atProfile => $strings['profile'],
    enumAuthorizerType::atDepartmentTitle => $strings['dep_title'],
    enumAuthorizerType::atOrganizationTitle => $strings['org_title'],
    enumAuthorizerType::atRole => $strings['role']
    );
$producerType = array(
    enumProducerType::ptUser => $strings['user'],
    enumProducerType::ptProfile => $strings['profile'],
    enumProducerType::ptDepartment => $strings['department'],
    enumProducerType::ptTeam => $strings['project_team']
    );
$ratioArray = array(
    enumRatio::rGreaterThan => $strings['greater_than'],
    enumRatio::rGreaterOrEqual => $strings['greater_or_equal'],
    enumRatio::rLessThan => $strings['less_than'],
    enumRatio::rLessOrEqual => $strings['less_or_equal'],
    enumRatio::rEqual => $strings['equal'],
    enumRatio::rNotEqual => $strings['not_equal'],
    enumRatio::rInRange => $strings['in_range'],
    enumRatio::rNotInRange => $strings['not_in_range'],
    enumRatio::rContains => $strings['contains'],
    enumRatio::rBeginWith => $strings['begin_with'],
    enumRatio::rEndWith => $strings['end_with']
    );
$sqlOparators = array(
    enumRatio::rGreaterThan => '>',
    enumRatio::rGreaterOrEqual => '>=',
    enumRatio::rLessThan => '<',
    enumRatio::rLessOrEqual => '<=',
    enumRatio::rEqual => '=',
    enumRatio::rNotEqual => '<>'
    );
$statusDocumentApproval = array(
    enumApprovalStatus::stPending => $strings['pending'],
    enumApprovalStatus::stApproved => $strings['approved'],
    enumApprovalStatus::stNotApproved => $strings['not_approved']
    );
$fileDocType = array(
    '0' => '',
    enumFileRelatedDocumentType::dtProject => $strings['project'],
    enumFileRelatedDocumentType::dtPhase => $strings['phase'],
    enumFileRelatedDocumentType::dtTask => $strings['task'],
    enumFileRelatedDocumentType::dtMeeting => $strings['meeting'],
    enumFileRelatedDocumentType::dtDiscussion => $strings['discussion'],
    enumFileRelatedDocumentType::dtNote => $strings['note'],
    enumFileRelatedDocumentType::dtExpense => $strings['expense'],
    enumFileRelatedDocumentType::dtSupportRequest => $strings['support_request'],
    enumFileRelatedDocumentType::dtSupportPost => $strings['support_post'],
    enumFileRelatedDocumentType::dtLeaveRequest => $strings['leave_request'],
    enumFileRelatedDocumentType::dtInvoice => $strings['invoice'],
    enumFileRelatedDocumentType::dtPayment => $strings['payment']
    );
$fieldTypeArray = array(
    enumFieldType::ftText => $strings['text'],
    enumFieldType::ftAlphaNumeric => $strings['alphanum'],
    enumFieldType::ftNumeric => $strings['numeric'],
    enumFieldType::ftMemo => $strings['memo'],
    enumFieldType::ftDate => $strings['date'],
    enumFieldType::ftTime => $strings['time'],
    enumFieldType::ftHours => $strings['hours'],
    enumFieldType::ftQuantity => $strings['quantity'],
    enumFieldType::ftMeasure => $strings['measure'],
    enumFieldType::ftRate => $strings['rate'],
    enumFieldType::ftTotals => $strings['totals'],
    enumFieldType::ftImage => $strings['image'],
    enumFieldType::ftBoolean => $strings['boolean'],
    enumFieldType::ftEmail => $strings['email'],
    enumFieldType::ftUrl => $strings['url'],
    enumFieldType::ftSerial => $strings['serial'],
    enumFieldType::ftPercentage => $strings['percentage'],
    enumFieldType::ftAudio => $strings['audio'],
    enumFieldType::ftVideo => $strings['video'],
    enumFieldType::ftPassword => $strings['password']
    );
$fieldDataType = array(
    enumFieldType::ftText => 'varchar(%length%)',
    enumFieldType::ftAlphaNumeric => 'varchar(%length%)',
    enumFieldType::ftNumeric => 'varchar(%length%)',
    enumFieldType::ftMemo => 'text',
    enumFieldType::ftDate => $db_timestamp,
    enumFieldType::ftTime => 'char(4)',
    enumFieldType::ftHours => 'decimal(19,6)',
    enumFieldType::ftQuantity => 'decimal(19,6)',
    enumFieldType::ftMeasure => 'decimal(19,6)',
    enumFieldType::ftRate => 'decimal(19,6)',
    enumFieldType::ftTotals => 'decimal(19,6)',
    enumFieldType::ftImage => 'varchar(1024)',
    enumFieldType::ftBoolean => 'char(1)',
    enumFieldType::ftEmail => 'varchar(255)',
    enumFieldType::ftUrl => 'varchar(1024)',
    enumFieldType::ftSerial => 'varchar(%length%)',
    enumFieldType::ftTimestamp => $db_timestamp,
    enumFieldType::ftPercentage => 'decimal(19,6)',
    enumFieldType::ftAudio => 'varchar(1024)',
    enumFieldType::ftVideo => 'varchar(1024)',
    enumFieldType::ftPassword => 'varchar(1024)'
    );
$serialFormat = array(
    '1' => $strings['serial_format_1'],
    '2' => $strings['serial_format_2'],
    '3' => $strings['serial_format_3'],
    '4' => $strings['serial_format_4'],
    '5' => $strings['serial_format_5']
    );
$timezoneTable = array(
    "-12" => $strings["GMT -12:00"],
    "-11" => $strings["GMT -11:00"],
    "-10" => $strings["GMT -10:00"],
    "-9" => $strings["GMT -9:00"],
    "-8" => $strings["GMT -8:00"],
    "-7" => $strings["GMT -7:00"],
    "-6" => $strings["GMT -6:00"],
    "-5" => $strings["GMT -5:00"],
    "-4" => $strings["GMT -4:00"],
    "-3.5" => $strings["GMT -3:30"],
    "-3" => $strings["GMT -3:00"],
    "-2" => $strings["GMT -2:00"],
    "-1" => $strings["GMT -1:00"],
    "0" => $strings["GMT"],
    "1" => $strings["GMT +1:00"],
    "2" => $strings["GMT +2:00"],
    "3" => $strings["GMT +3:00"],
    "3.5" => $strings["GMT +3:30"],
    "4" => $strings["GMT +4:00"],
    "4.5" => $strings["GMT +4:30"],
    "5" => $strings["GMT +5:00"],
    "5.5" => $strings["GMT +5:30"],
    "6" => $strings["GMT +6:00"],
    "7" => $strings["GMT +7:00"],
    "8" => $strings["GMT +8:00"],
    "9" => $strings["GMT +9:00"],
    "9.5" => $strings["GMT +9:30"],
    "10" => $strings["GMT +10:00"],
    "11" => $strings["GMT +11:00"],
    "12" => $strings["GMT +12:00"]
    );
$timezoneTableSimple = array(
    "-12" => "GMT -12:00",
    "-11" => "GMT -11:00",
    "-10" => "GMT -10:00",
    "-9" => "GMT -9:00",
    "-8" => "GMT -8:00",
    "-7" => "GMT -7:00",
    "-6" => "GMT -6:00",
    "-5" => "GMT -5:00",
    "-4" => "GMT -4:00",
    "-3.5" => "GMT -3:30",
    "-3" => "GMT -3:00",
    "-2" => "GMT -2:00",
    "-1" => "GMT -1:00",
    "0" => "GMT",
    "1" => "GMT +1:00",
    "2" => "GMT +2:00",
    "3" => "GMT +3:00",
    "3.5" => "GMT +3:30",
    "4" => "GMT +4:00",
    "4.5" => "GMT +4:30",
    "5" => "GMT +5:00",
    "5.5" => "GMT +5:30",
    "6" => "GMT +6:00",
    "7" => "GMT +7:00",
    "8" => "GMT +8:00",
    "9" => "GMT +9:00",
    "9.5" => "GMT +9:30",
    "10" => "GMT +10:00",
    "11" => "GMT +11:00",
    "12" => "GMT +12:00"
    );
// Options for date format
$dateFormats = array(
    'Y-m-d|yy-mm-dd|Y-m'=>'YYYY-MM-DD Ex: 2010-01-09',
    'd-m-Y|dd-mm-yy|m-Y'=>'DD-MM-YYYY Ex: 09-01-2010',
    'd-m-y|dd-mm-y|m-y'=>'DD-MM-YY   Ex: 09-01-10',
    'd/m/Y|dd/mm/yy|m/Y'=>'DD/MM/YYYY Ex: 09/01/2010',
    'd/m/y|dd/mm/y|m/y'=>'DD/MM/YY   Ex: 09/01/10',
    'j/n/Y|d/m/yy|n/Y'=>'D/M/YYYY   Ex: 9/1/2010',
    'j/n/y|d/m/y|n/y'=>'D/M/YY     Ex: 9/1/10',
    'm/d/Y|mm/dd/yy|m/Y'=>'MM/DD/YYYY Ex: 01/09/2010',
    'm/d/y|mm/dd/y|m/y'=>'MM/DD/YY   Ex: 01/09/10',
    'j.m.Y|d.mm.yy|m.Y'=>'D.MM.YYYY  Ex: 9.01.2010',
    'j.n.Y|d.m.yy|n.Y'=>'D.M.YYYY   Ex: 9.1.2010',
    'd.m.Y|dd.mm.yy|m.Y'=>'DD.MM.YYYY Ex: 09.01.2010',
    'd.m.y|dd.mm.y|m.y'=>'DD.MM.YY   Ex: 09.01.2010',
    'j.n.y|d.m.y|n.y'=>'D.M.YY     Ex: 9.1.10',
    'Y.m.d|yy.mm.dd|Y.m'=>'YYYY.MM.DD Ex: 2010.01.09',
    'd m Y|dd mm yy|m Y'=>'DD MM YYYY Ex: 09 01 2010',
    'd m y|dd mm y|m y'=>'DD MM YY   Ex: 09 01 10');
$timeFormats = array('12H', '24H');
// Options for field displaying style
$fieldsDisplayStyle = array(
    enumDisplayStyle::dsMultipleRowsWithTitle => $strings["multirows_with_title"],               // multiple rows with title
    enumDisplayStyle::dsMultipleRowsWithoutTitle => $strings["multirows_without_title"],         // multiple rows without title
    enumDisplayStyle::dsMultipleColumnsWithTitle => $strings["multicolumns_with_title"],         // multiple columns with title
    enumDisplayStyle::dsMultipleColumnsWithoutTitle => $strings["multicolumns_without_title"]);  // multiple columns without title
// Options for file exporting format
$exportFormats = array(
    'csv' => array(     // Comma Separated Values (CSV) file format
        'File-Extension' => 'csv',
        'Content-Type' => 'text/x-csv',
        'PHPExcel-Writer-Type' => 'Csv'
    ),
    'xls' => array(     // Microsoft Excel file format
        'File-Extension' => 'xls',
        'Content-Type' => 'application/vnd.ms-excel',
        'PHPExcel-Writer-Type' => 'Xls'
    ),
    'xlsx' => array(    // Excel Microsoft Office Open XML Format
        'File-Extension' => 'xlsx',
        'Content-Type' => 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
        'PHPExcel-Writer-Type' => 'Xlsx'
    ),
    'ods' => array(    // Open Document Format
        'File-Extension' => 'ods',
        'Content-Type' => 'application/vnd.oasis.opendocument.spreadsheet',
        'PHPExcel-Writer-Type' => 'Ods'
    )
);
// Options for contact name format
$contactNameFormats = array(
    "first_name,' ',last_name" => $strings['first_name'] . ' ' . $strings['last_name'],
    "last_name,', ',first_name" => $strings['last_name'] . ', ' . $strings['first_name'],
    "last_name,' ',first_name" => $strings['last_name'] . ' ' . $strings['first_name'],
    "last_name,first_name" => $strings['last_name'] . $strings['first_name'],
    "salutaion,' ',first_name" => $strings['salutation'] . ' ' . $strings['first_name'],
    "salutation,' ',first_name,' ',last_name" => $strings['salutation'] . ' ' . $strings['first_name'] . ' ' . $strings['last_name'],
    "last_name,first_name,salutation" => $strings['last_name'] . $strings['first_name'] . $strings['salutation']
);
// Options for contact salutation
$contactSalutations = array(
    $strings['CS0'],$strings['CS1'],$strings['CS2'],$strings['CS3'],$strings['CS4'],
    $strings['CS5'],$strings['CS6'],$strings['CS7'],$strings['CS8'],$strings['CS9']
);
// The print names for equipment status
$equipmentStatusNames = array(
    enumEquipmentStatus::stAvailable => $strings['VV__equipments_status_0'],
    enumEquipmentStatus::stOccupied => $strings['VV__equipments_status_1'],
    enumEquipmentStatus::stBroken => $strings['VV__equipments_status_2'],
    enumEquipmentStatus::stSold => $strings['VV__equipments_status_3']
);
// Supported sql functions
$sqlFunctions = array(
    'avg' => $strings['sql_avg'],
    'count' => $strings['sql_count'],
    'max' => $strings['sql_max'],
    'min' => $strings['sql_min'],
    'sum' => $strings['sql_sum']
);
// Payment terms start from
$paymentTermsStartFrom = array(
    '' => '',
    'Y' => $strings['month_start'],
    'H' => $strings['half_month'],
    'E' => $strings['month_end']
);
// Accounting document status
$statusAccountDoc = array(
    enumDocumentStatus::stDraft => $strings['status_draft'],
    enumDocumentStatus::stOpen => $strings['status_open'],
    enumDocumentStatus::stClosed => $strings['status_closed']
);
$functionsName = array(
    'Profile' => $strings['user_profiles'],
    'User' => $strings['users'],
    'System Log' => $strings['system_log'],
    'System Settings' => $strings['system_configuration'],
    'Deny IP' => $strings['deny_ips'],
    'Service' => $strings['service_management'],
    'Material' => $strings['material_management'],
    'Equipment' => $strings['equipment_management'],
    'Company Detail' => $strings['company_details'],
    'Period' => $strings['periods'],
    'Work Calendar' => $strings['workcalendar_management'],
    'Leave' => $strings['leave_management'],
    'Leave Request' => $strings['leave_requests'],
    'Client' => $strings['clients'],
    'Contact' => $strings['contacts'],
    'Project' => $strings['projects'],
    'Meeting' => $strings['meetings'],
    'Approval Procedure' => $strings['approval_procedures'],
    'TextCustomization' => $strings['text_customization'],
    'File' => $strings['files'],
    'Currency Rate' => $strings['exchange_rates'],
    'Custom Fields' => $strings['custom_fields'],
    'Form Template' => $strings['form_templates'],
    'Locations' => $strings['locations'],
    'Phase Set' => $strings['phase_sets'],
    'Report' => $strings['reports'],
    'Accounting' => $strings['accounting'],
    'Invoice' => $strings['invoices'],
    'Payment' => $strings['payments'],
    'Expense' => $strings['expenses'],
    'Calendar' => $strings['calendar'],
    'Extension' => $strings['extension_management'],
    'Print Layout' => $strings['print_layout']
);
$functionsACL = array(
    'Profile' => array(
        'Admin'
    ),
    'User' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'System Log' => array(
        'Read',
        'Admin'
    ),
    'System Settings' => array(
        'Read',
        'Edit'
    ),
    'Deny IP' => array(
        'Read',
        'Admin'
    ),
    'Service' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Material' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Equipment' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Company Detail' => array(
        'Read',
        'Edit'
    ),
    'Period' => array(
        'Read',
        'Edit'
    ),
    'Work Calendar' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Leave' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Leave Request' => array(
        'Edit',
        'Admin'
    ),
    'Client' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Contact' => array(
        'Read',
        'Edit'
    ),
    'Project' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Meeting' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Approval Procedure' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'TextCustomization' => array(
        'Admin'
    ),
    'File' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Currency Rate' => array(
        'Read',
        'Edit'
    ),
    'Custom Fields' => array(
        'Read',
        'Edit'
    ),
    'Form Template' => array(
        'Read',
        'Edit'
    ),
    'Locations' => array(
        'Read',
        'Edit'
    ),
    'Phase Set' => array(
        'Read',
        'Edit'
    ),
    'Report' => array(
        'Read',
        'Edit'
    ),
    'Accounting' => array(
        'Read',
        'Edit'
    ),
    'Invoice' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Payment' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Expense' => array(
        'Read',
        'Write',
        'Edit',
        'Admin'
    ),
    'Calendar' => array(
        'Read',
        'Admin'
    ),
    'Extension' => array(
        'Admin'
    ),
    'Print Layout' => array(
        'Admin'
    )
);
$reservedDbFields = array(
    'id' => $strings['id'],
    'status' => $strings['status'],
    'printed' => $strings['printed'],
    'published' => $strings['published'],
    'created' => $strings['created'],
    'cuser' => $strings['created_by'],
    'modified' => $strings['modified'],
    'muser' => $strings['modified_by']
);
$reservedDbFieldsDef = array(
    'type' => array(
        'id' => enumFieldType::ftNumeric,
        'status' => enumFieldType::ftAlphaNumeric,
        'printed' => enumFieldType::ftAlphaNumeric,
        'published' => enumFieldType::ftAlphaNumeric,
        'created' => enumFieldType::ftTimestamp,
        'cuser' => enumFieldType::ftNumeric,
        'modified' => enumFieldType::ftTimestamp,
        'muser' => enumFieldType::ftNumeric
    ),
    'length' => array(
        'id' => 11,
        'status' => 1,
        'printed' => 1,
        'published' => 1,
        'created' => 11,
        'cuser' => 11,
        'modified' => 11,
        'muser' => 11
    ),
    'validvalues' => array(
        'id' => '',
        'status' => $statusFile,
        'printed' => array('N' => $strings['no'], 'Y' => $strings['yes']),
        'published' => array('N' => $strings['no'], 'Y' => $strings['yes']),
        'created' => '',
        'cuser' => '',
        'modified' => '',
        'muser' => ''
    ),
    'linked_table' => array(
        'cuser' => 'members',
        'muser' => 'members'
    )
);
$genderArray = array(
    'F' => $strings['female'],
    'M' => $strings['male']
);
$messageTypes = array(
    'S' => $strings['notification'],
    'P' => $strings['chat'],
    'M' => $strings['meeting']
);