<?php // $Revision: 1.0 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: expenses.php,v 1.0 2016/09/01 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
function item_viewable()
{
    global $listExpenses, $comptListExpenses, $SW_Permissions, $idSession, $profilSession, $permissionDetail;

    for ($i=0; $i<$comptListExpenses; $i++) {
        if ($listExpenses->exp_project[$i] == '0') {
            if ($listExpenses->exp_owner[$i] != $idSession) {
                return false;
            }

            if (!$SW_Permissions['Expense']['Read'][$profilSession]) {
                return false;
            }
        } else {
            if (!isset($permissionDetail[$i]->prp_view_expense[0]) || $permissionDetail[$i]->prp_view_expense[0] != enumBoolean::bTrue) {
                return false;
            }
        }
    }

    return true;
}

function item_printable()
{
    global $listExpenses, $comptListExpenses;

    for ($i=0; $i<$comptListExpenses; $i++) {
        if ($listExpenses->exp_recurring[$i] == enumBoolean::bTrue) {
            return false;
        }
    }

    return true;
}

function item_editable()
{
    global $listExpenses, $SW_Permissions, $idSession, $profilSession, $projectDetail, $permissionDetail;

    if ($listExpenses->exp_project[0] == '0') {
        if ($listExpenses->exp_owner[0] != $idSession) {
            return false;
        }

        if (!$SW_Permissions['Expense']['Edit'][$profilSession]) {
            return false;
        }

        if ($listExpenses->exp_recurring[0] != enumBoolean::bTrue) {
            if ($listExpenses->exp_status_approval[0] == enumFileStatus::stNeedsApproval) {
                return false;
            }

            if (periodLocked($listExpenses->exp_docdate[0])) {     // check if period locked
                return false;
            }
        }
    } else {
        if ($projectDetail[0]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[0]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[0]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[0]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            return false;
        }

        if ($listExpenses->exp_recurring[0] != enumBoolean::bTrue) {
            if ($listExpenses->exp_owner[0] != $idSession) {
                return false;
            }

            if ($listExpenses->exp_status_approval[0] == enumFileStatus::stNeedsApproval) {
                return false;
            }

            if (periodLocked($listExpenses->exp_docdate[0])) {     // check if period locked
                return false;
            }
        } elseif ($permissionDetail[0]->prp_create_expense[0] != enumBoolean::bTrue) {
            return false;
        }
    }

    return true;
}

function item_removable()
{
    global $listExpenses, $comptListExpenses, $SW_Permissions, $idSession, $profilSession, $projectDetail, $permissionDetail;

    for ($i=0; $i<$comptListExpenses; $i++) {
        if ($listExpenses->exp_recurring[$i] != enumBoolean::bTrue) {
            if ($listExpenses->exp_owner[$i] != $idSession) {
                return false;
            }

            if (periodLocked($listExpenses->exp_docdate[$i])) {     // check if period locked
                return false;
            }
        }

        if ($listExpenses->exp_project[$i] == '0') {
            if (!$SW_Permissions['Expense']['Admin'][$profilSession]) {
                return false;
            }
        } else {
            if ($projectDetail[$i]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[$i]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
                return false;
            }

            if ($permissionDetail[$i]->prp_delete_expense[0] != enumBoolean::bTrue) {
                return false;
            }
        }
    }

    return true;
}

function item_duplicable()
{
    global $listExpenses, $SW_Permissions, $idSession, $profilSession, $projectDetail, $permissionDetail;

    if ($listExpenses->exp_owner[0] != $idSession) {
        return false;
    }

    if ($listExpenses->exp_project[0] == '0') {
        if (!$SW_Permissions['Expense']['Write'][$profilSession]) {
            return false;
        }
    } else {
        if ($projectDetail[0]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[0]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[0]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[0]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            return false;
        }

        if ($permissionDetail[0]->prp_create_expense[0] != enumBoolean::bTrue) {
            return false;
        }
    }

    return true;
}

function printlayout_available()
{
    $querymore1 = " WHERE plt.doc_type='" . enumFileRelatedDocumentType::dtExpense . "' ORDER BY plt.description";
    $listPrintLayouts = new request();
    $listPrintLayouts->openPrintLayouts($querymore1);
    $comptListPrintLayouts = count($listPrintLayouts->plt_id);
    return ($comptListPrintLayouts>0);
}

$ids = "'" . str_replace("**", "','", $id) . "'";
$ida = explode('**', $id);
$querymore = " WHERE exp.id IN ($ids)";
$listExpenses = new request();
$listExpenses->openExpenses($querymore);
$comptListExpenses = count($listExpenses->exp_id);

if ($comptListExpenses === 0 || $comptListExpenses !== count($ida)) {
    return;
}

for ($i=0; $i<$comptListExpenses; $i++) {
    if ($listExpenses->exp_project[$i] != '0') {
        $querymore1 = " WHERE pro.id='" . $listExpenses->exp_project[$i] . "'";
        $projectDetail[$i] = new request();
        $projectDetail[$i]->openProjects($querymore1);
        $querymore2 = " WHERE tea.project='" . $listExpenses->exp_project[$i] . "' AND tea.member='$idSession'";
        $memberDetail = new request();
        $memberDetail->openTeams($querymore2);
        $comptMemberDetail = count($memberDetail->tea_project);

        if ($comptMemberDetail == 0) {
            $querymore3 = " WHERE prp.project='" . $listExpenses->exp_project[$i] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
        } else {
            $querymore3 = " WHERE prp.project='" . $listExpenses->exp_project[$i] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
        }

        $permissionDetail[$i] = new request();
        $permissionDetail[$i]->openProjectPermissions($querymore3);
    }
}

if ($default_action=='Y' && preg_match('/\*\*/', $id)==0 && item_viewable()) {
    $url = $path_prefix . 'expenses/viewexpense.php?project=' . $project . '&id=' . $id . $urlBornes;
} else {
    if (preg_match('/\*\*/', $id)==0 && item_viewable()) {
        $content .= '<a href="' . $path_prefix . 'expenses/viewexpense.php?project=' . $project . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_info_norm.png') . '">';
        $content .= '<label>' . $strings['view'] . '</label>';
        $content .= '</a>';
    }

    if (item_viewable() && printlayout_available() && item_printable()) {
        $content .= '<a href="' . $path_prefix . 'expenses/printexpenses.php?project=' . $project . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_print_norm.png') . '">';
        $content .= '<label>' . $strings['print'] . '</label>';
        $content .= '</a>';
    }

    if (preg_match('/\*\*/', $id)==0 && item_editable()) {
        $content .= '<a href="' . $path_prefix . 'expenses/editexpense.php?project=' . $project . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_edit_norm.png') . '">';
        $content .= '<label>' . $strings['edit'] . '</label>';
        $content .= '</a>';
    }

    if (item_removable()) {
        $content .= '<a href="' . $path_prefix . 'expenses/deleteexpenses.php?project=' . $project . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_remove_norm.png') . '">';
        $content .= '<label>' . $strings['delete'] . '</label>';
        $content .= '</a>';
    }

    if (preg_match('/\*\*/', $id)==0 && item_duplicable()) {
        $content .= '<a href="' . $path_prefix . 'expenses/editexpense.php?cpy=true&recurring=' . $recurring . '&project=' . $project . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_copy_norm.png') . '">';
        $content .= '<label>' . $strings['copy'] . '</label>';
        $content .= '</a>';
    }
}
