<?php // $Revision: 1.0 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: files.php,v 1.0 2016/09/01 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
if ($fileManagement != 'true') {
    return;
}

$ids = "'" . str_replace("**", "','", $id) . "'";
$ida = explode('**', $id);
$querymore = " WHERE fil.id IN ($ids) ORDER BY fil.name";
$listFiles = new request();
$listFiles->openFiles($querymore);
$comptListFiles = count($listFiles->fil_id);

if ($comptListFiles === 0 || $comptListFiles !== count($ida)) {
    return;
}

for ($i=0; $i<$comptListFiles; $i++) {
    switch ($listFiles->fil_doc_type[$i]) {
        case enumFileRelatedDocumentType::dtProject:
            $tmpquery = "SELECT id FROM " . $tablePrefix . "projects WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtPhase:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "phases WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtTask:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "tasks WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtMeeting:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "meetings WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtDiscussion:
            $tmpquery = "SELECT topic.project FROM " . $tablePrefix . "posts pos INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic WHERE pos.id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtNote:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "notes WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtExpense:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "expenses WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtSupportRequest:
            $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_requests req WHERE req.id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtSupportPost:
            $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_posts pos INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id WHERE pos.id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        default:
            $tmpquery = '';
    }

    if ($tmpquery === '') {
        $permissionDetail[$i] = null;
    } else {
        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery);

        if ($request1->fetch()) {
            $project = ($row[0]);
        } else {
            $project = '0';
        }

        $request1->close();
        $querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
        $memberDetail = new request();
        $memberDetail->openTeams($querymore2);
        $comptMemberDetail = count($memberDetail->tea_project);

        if ($comptMemberDetail == 0) {
            $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
        } else {
            $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
        }

        $permissionDetail[$i] = new request();
        $permissionDetail[$i]->openProjectPermissions($querymore3);
    }
}

function item_editable()
{
    global $comptListFiles, $SW_Permissions, $profilSession, $permissionDetail;

    for ($i=0; $i<$comptListFiles; $i++) {
        if ($permissionDetail[$i] === null) {
            if (!$SW_Permissions['File']['Edit'][$profilSession]) {
                return false;
            }
        } else {
            if (!isset($permissionDetail[$i]->prp_update_file[0]) || $permissionDetail[$i]->prp_update_file[0]!==enumBoolean::bTrue) {
                return false;
            }
        }
    }

    return true;
}

function item_removable()
{
    global $comptListFiles, $SW_Permissions, $profilSession, $permissionDetail;

    for ($i=0; $i<$comptListFiles; $i++) {
        if ($permissionDetail[$i] === null) {
            if (!$SW_Permissions['File']['Admin'][$profilSession]) {
                return false;
            }
        } else {
            if (!isset($permissionDetail[$i]->prp_delete_file[0]) || $permissionDetail[$i]->prp_delete_file[0]!==enumBoolean::bTrue) {
                return false;
            }
        }
    }

    return true;
}

function item_add_projectsite()
{
    global $sitePublish, $listFiles, $comptListFiles, $permissionDetail;

    if ($sitePublish != "true") {
        return false;
    }

    if (!in_array(strval(enumPublished::pbNo), $listFiles->fil_published)) {
        return false;
    }

    for ($i=0; $i<$comptListFiles; $i++) {
        if ($permissionDetail[$i] === null) {
            return false;
        } else {
            if (!isset($permissionDetail[$i]->prp_publish_file[0]) || $permissionDetail[$i]->prp_publish_file[0]!==enumBoolean::bTrue) {
                return false;
            }
        }
    }

    return true;
}

function item_remove_projectsite()
{
    global $sitePublish, $listFiles, $comptListFiles, $permissionDetail;

    if ($sitePublish != "true") {
        return false;
    }

    if (!in_array(strval(enumPublished::pbYes), $listFiles->fil_published)) {
        return false;
    }

    for ($i=0; $i<$comptListFiles; $i++) {
        if ($permissionDetail[$i] === null) {
            return false;
        } else {
            if (!isset($permissionDetail[$i]->prp_publish_file[0]) || $permissionDetail[$i]->prp_publish_file[0]!==enumBoolean::bTrue) {
                return false;
            }
        }
    }

    return true;
}

if ($default_action=='Y' && preg_match('/\*\*/', $id) == 0) {
    $newurl = $root . '/linkedcontent/accessfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&mode=view&id=' . $id . $urlBornes;
} else {
    if (preg_match('/\*\*/', $id) == 0) {
        $content = '<a href="' . $path_prefix . 'linkedcontent/accessfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&mode=view&id=' . $id . $urlBornes . '" target="_blank">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_open.png') . '">';
        $content .= '<label>' . $strings['view'] . '</label>';
        $content .= '</a>';
        $content .= '<a href="' . $path_prefix . 'linkedcontent/accessfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&mode=download&id=' . $id . $urlBornes . '" target="_blank">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_download.png') . '">';
        $content .= '<label>' . $strings['save'] . '</label>';
        $content .= '</a>';
        $content .= '<a href="' . $path_prefix . 'linkedcontent/viewfile.php?doc_type=' . $doc_type . (($doc_type==enumFileRelatedDocumentType::dtForm)?'&doc_type_ex=' . $doc_type_ex:'') . '&doc_id=' . $doc_id . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_info.png') . '">';
        $content .= '<label>' . $strings['info'] . '</label>';
        $content .= '</a>';
    } else {
        $content = '<a href="' . $path_prefix . 'linkedcontent/accessfiles.php?folders=false&id=' . $id . $urlBornes . '" target="_blank">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_export_norm.png') . '">';
        $content .= '<label>' . $strings['export'] . '</label>';
        $content .= '</a>';
    }

    if (item_editable()) {
        if (preg_match('/\*\*/', $id) == 0) {
            $content .= '<a href="' . $path_prefix . 'linkedcontent/editfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&id=' . $id . $urlBornes . '">';
            $content .= '<img src="' . verSource('themes/' . THEME . '/btn_edit_norm.png') . '">';
            $content .= '<label>' . $strings['edit'] . '</label>';
            $content .= '</a>';
        }

        $content .= '<a href="' . $path_prefix . 'linkedcontent/movefiles.php?cpy=true&parent=' . $doc_id . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_copy_norm.png') . '">';
        $content .= '<label>' . $strings['copy'] . '</label>';
        $content .= '</a>';
        $content .= '<a href="' . $path_prefix . 'linkedcontent/movefiles.php?parent=' . $doc_id . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_move_norm.png') . '">';
        $content .= '<label>' . $strings['move'] . '</label>';
        $content .= '</a>';
    }

    if (item_removable()) {
        $content .= '<a href="' . $path_prefix . 'linkedcontent/deletefiles.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_remove_norm.png') . '">';
        $content .= '<label>' . $strings['delete'] . '</label>';
        $content .= '</a>';
    }

    if (item_add_projectsite()) {
        $content .= '<a href="' . $path_prefix . 'linkedcontent/listfiles.php?addToSiteFile=true&doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&action=publish&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_add_projectsite_norm.png') . '">';
        $content .= '<label>' . $strings['add_customer_service_site'] . '</label>';
        $content .= '</a>';
    }

    if (item_remove_projectsite()) {
        $content .= '<a href="' . $path_prefix . 'linkedcontent/listfiles.php?removeToSiteFile=true&doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&action=publish&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_remove_projectsite_norm.png') . '">';
        $content .= '<label>' . $strings['remove_customer_service_site'] . '</label>';
        $content .= '</a>';
    }
}
