<?php // $Revision: 1.0 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: invoices.php,v 1.0 2016/09/01 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
function item_printable()
{
    global $comptListInvoices, $listInvoices;
    $querymore1 = " WHERE plt.doc_type='" . enumFileRelatedDocumentType::dtInvoice . "' ORDER BY plt.description";
    $listPrintLayouts = new request();
    $listPrintLayouts->openPrintLayouts($querymore1);
    $comptListPrintLayouts = count($listPrintLayouts->plt_id);

    if ($comptListPrintLayouts <= 0) {
        return false;
    }

    for ($i=0; $i<$comptListInvoices; $i++) {
        if ($listInvoices->inv_recurring[$i] == enumBoolean::bTrue) {
            return false;
        }
    }

    return true;
}

function item_editable()
{
    global $listInvoices, $SW_Permissions, $profilSession;

    if (($listInvoices->inv_status_approval[0] == enumFileStatus::stNeedsApproval) || (!$SW_Permissions['Invoice']['Edit'][$profilSession]) || ($listInvoices->inv_paid[0] > 0)) {
        return false;
    }

    if ($listInvoices->inv_recurring[0] !== enumBoolean::bTrue) {
        if (periodLocked($listInvoices->inv_doc_date[0])) {     // check if period locked
            return false;
        }
    }

    return true;
}

function item_removable()
{
    global $SW_Permissions, $profilSession, $comptListInvoices, $listInvoices;

    if (!$SW_Permissions['Invoice']['Admin'][$profilSession]) {
        return false;
    }

    for ($i=0; $i<$comptListInvoices; $i++) {
        if (periodLocked($listInvoices->inv_doc_date[$i])) {     // check if period locked
            return false;
        }

        if ($listInvoices->inv_paid[$i] > 0) {
            return false;
        }
    }
}

$ids = "'" . str_replace("**", "','", $id) . "'";
$ida = explode('**', $id);
$querymore = " WHERE inv.id IN ($ids)";
$listInvoices = new request();
$listInvoices->openInvoices($querymore);
$comptListInvoices = count($listInvoices->inv_id);

if ($comptListInvoices === 0 || $comptListInvoices !== count($ida)) {
    return;
}

if ($default_action=='Y' && $SW_Permissions['Invoice']['Read'][$profilSession] && preg_match('/\*\*/', $id)==0) {
    $url = $path_prefix . 'invoices/viewinvoice.php?id=' . $id . $urlBornes;
} else {
    if ($SW_Permissions['Invoice']['Read'][$profilSession]) {
        if (preg_match('/\*\*/', $id)==0) {
            $content .= '<a href="' . $path_prefix . 'invoices/viewinvoice.php?id=' . $id . $urlBornes . '">';
            $content .= '<img src="' . verSource('themes/' . THEME . '/btn_info_norm.png') . '">';
            $content .= '<label>' . $strings['view'] . '</label>';
            $content .= '</a>';
        }

        if (item_printable()) {
            $content .= '<a href="' . $path_prefix . 'invoices/printinvoices.php?id=' . $id . $urlBornes . '">';
            $content .= '<img src="' . verSource('themes/' . THEME . '/btn_print_norm.png') . '">';
            $content .= '<label>' . $strings['print'] . '</label>';
            $content .= '</a>';
        }
    }

    if (preg_match('/\*\*/', $id)==0 && item_editable()) {
        $content .= '<a href="' . $path_prefix . 'invoices/editinvoice.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_edit_norm.png') . '">';
        $content .= '<label>' . $strings['edit'] . '</label>';
        $content .= '</a>';
    }

    if (item_removable()) {
        $content .= '<a href="' . $path_prefix . 'invoices/deleteinvoices.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_remove_norm.png') . '">';
        $content .= '<label>' . $strings['delete'] . '</label>';
        $content .= '</a>';
    }

    if (preg_match('/\*\*/', $id)==0 && $SW_Permissions['Invoice']['Write'][$profilSession]) {
        $content .= '<a href="' . $path_prefix . 'invoices/editinvoice.php?cpy=true&recurring=' . $recurring . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_copy_norm.png') . '">';
        $content .= '<label>' . $strings['copy'] . '</label>';
        $content .= '</a>';
    }
}
