<?php // $Revision: 1.0 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: meetings.php,v 1.0 2016/09/01 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
function item_viewable()
{
    global $listMeetings, $idSession, $SW_Permissions, $profilSession, $permissionDetail;

    if ($listMeetings->mee_owner[0] != $idSession) {
        if ($listMeetings->mee_project[0] == '0') {
            if (!$SW_Permissions['Meeting']['Read'][$profilSession]) {
                return false;
            }
        } else {
            if (!$SW_Permissions['Project']['Admin'][$profilSession] && (!isset($permissionDetail[0]->prp_view_meeting[0]) || $permissionDetail[0]->prp_view_meeting[0] != enumBoolean::bTrue)) {
                return false;
            }
        }
    }

    return true;
}

function item_editable()
{
    global $listMeetings, $idSession, $SW_Permissions, $profilSession, $permissionDetail;

    if ($listMeetings->mee_owner[0] != $idSession) {
        if ($listMeetings->mee_project[0] == '0') {
            if (!$SW_Permissions['Meeting']['Edit'][$profilSession]) {
                return false;
            }
        } else {
            if ($permissionDetail[0]->prp_modify_meeting_status[0] != enumBoolean::bTrue && $permissionDetail[0]->prp_modify_meeting_properties[0] != enumBoolean::bTrue) {
                return false;
            }
        }
    }

    return true;
}

function item_removable()
{
    global $comptListMeetings, $listMeetings, $idSession, $SW_Permissions, $profilSession, $permissionDetail;

    for ($i=0; $i<$comptListMeetings; $i++) {
        if ($listMeetings->mee_owner[$i] != $idSession) {
            if ($listMeetings->mee_project[$i] == '0') {
                if (!$SW_Permissions['Meeting']['Admin'][$profilSession]) {
                    return false;
                }
            } else {
                if ($permissionDetail[$i]->prp_delete_meeting[0] != enumBoolean::bTrue) {
                    return false;
                }
            }
        }
    }

    return true;
}

function item_duplicable()
{
    global $listMeetings, $idSession, $SW_Permissions, $profilSession, $permissionDetail;

    if ($listMeetings->mee_project[0] == '0') {
        if (!$SW_Permissions['Meeting']['Write'][$profilSession]) {
            return false;
        }
    } else {
        if ($permissionDetail[0]->prp_copy_meeting[0] != enumBoolean::bTrue && $listMeetings->mee_owner[0] != $idSession) {
            return false;
        }
    }

    return true;
}

function item_logtime()
{
    global $id, $listMeetings, $idSession, $SW_Permissions, $profilSession, $projectDetail, $permissionDetail;

    if ($listMeetings->mee_status[0] == enumMeetingStatus::stScheduling || $listMeetings->mee_status[0] == enumMeetingStatus::stCanceled) {
        return false;
    }

    $querymore1 = " WHERE att.meeting='$id'";
    $listAttendees = new request();
    $listAttendees->openAttendees($querymore1);
    $comptListAttendees = count($listAttendees->att_meeting);

    if (array_search($idSession, $listAttendees->att_member) === FALSE) {
        return false;
    }

    if ($listMeetings->mee_project[0] == '0') {
        if (!$SW_Permissions['Meeting']['Write'][$profilSession]) {
            return false;
        }
    } else {
        if ($projectDetail[0]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[0]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[0]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[0]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            return false;
        }

        if ($permissionDetail[0]->prp_log_meeting_hours[0] != enumBoolean::bTrue) {
            return false;
        }
    }

    return true;
}

$ids = "'" . str_replace("**", "','", $id) . "'";
$ida = explode('**', $id);
$querymore = " WHERE mee.id IN ($ids) ORDER BY mee.name";
$listMeetings = new request();
$listMeetings->openMeetings($querymore);
$comptListMeetings = count($listMeetings->mee_id);

if ($comptListMeetings === 0 || $comptListMeetings !== count($ida)) {
    return;
}

for ($i=0; $i<$comptListMeetings; $i++) {
    if ($listMeetings->mee_project[$i] != '0') {
        $querymore1 = " WHERE pro.id='" . $listMeetings->mee_project[$i] . "'";
        $projectDetail[$i] = new request();
        $projectDetail[$i]->openProjects($querymore1);
        $querymore2 = " WHERE tea.project='" . $listMeetings->mee_project[$i] . "' AND tea.member='$idSession'";
        $memberDetail = new request();
        $memberDetail->openTeams($querymore2);
        $comptMemberDetail = count($memberDetail->tea_project);

        if ($comptMemberDetail == 0) {
            $querymore3 = " WHERE prp.project='" . $listMeetings->mee_project[$i] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
        } else {
            $querymore3 = " WHERE prp.project='" . $listMeetings->mee_project[$i] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
        }

        $permissionDetail[$i] = new request();
        $permissionDetail[$i]->openProjectPermissions($querymore3);
    } else {
        $projectDetail[$i] = null;
        $permissionDetail[$i] = null;
    }
}

if ($default_action=='Y' && preg_match('/\*\*/', $id)==0 && item_viewable()) {
    $url = $path_prefix . 'meetings/viewmeeting.php?id=' . $id . $urlBornes;
} else {
    if (preg_match('/\*\*/', $id)==0 && item_viewable()) {
        $content .= '<a href="' . $path_prefix . 'meetings/viewmeeting.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_info_norm.png') . '">';
        $content .= '<label>' . $strings['view'] . '</label>';
        $content .= '</a>';

        if ($listMeetings->mee_status[0] != enumMeetingStatus::stScheduling && $listMeetings->mee_status[0] != enumMeetingStatus::stCanceled) {
            $content .= '<a href="' . $path_prefix . 'meetings/viewmeeting.php?action=chat&id=' . $id . $urlBornes . '">';
            $content .= '<img src="' . verSource('themes/' . THEME . '/btn_chat_norm.png') . '">';
            $content .= '<label>' . $strings['chatroom'] . '</label>';
            $content .= '</a>';
        }
    }

    if (preg_match('/\*\*/', $id)==0 && item_editable()) {
        $content .= '<a href="' . $path_prefix . 'meetings/editmeeting.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_edit_norm.png') . '">';
        $content .= '<label>' . $strings['edit'] . '</label>';
        $content .= '</a>';
    }

    if (item_removable()) {
        $content .= '<a href="' . $path_prefix . 'meetings/deletemeetings.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_remove_norm.png') . '">';
        $content .= '<label>' . $strings['delete'] . '</label>';
        $content .= '</a>';
    }

    if (preg_match('/\*\*/', $id)==0 && item_duplicable()) {
        $content .= '<a href="' . $path_prefix . 'meetings/editmeeting.php?cpy=true&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_copy_norm.png') . '">';
        $content .= '<label>' . $strings['copy'] . '</label>';
        $content .= '</a>';
    }

    if (preg_match('/\*\*/', $id)==0 && item_logtime()) {
        $content .= '<a href="' . $path_prefix . 'meetings/addmeetingtime.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_timelog_norm.png') . '">';
        $content .= '<label>' . $strings['loghours'] . '</label>';
        $content .= '</a>';
    }
}
