<?php // $Revision: 1.0 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: payments.php,v 1.0 2016/09/01 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
function item_printable()
{
    $querymore1 = " WHERE plt.doc_type='" . enumFileRelatedDocumentType::dtPayment . "' ORDER BY plt.description";
    $listPrintLayouts = new request();
    $listPrintLayouts->openPrintLayouts($querymore1);
    $comptListPrintLayouts = count($listPrintLayouts->plt_id);

    if ($comptListPrintLayouts <= 0) {
        return false;
    }

    return true;
}

function item_editable()
{
    global $SW_Permissions, $profilSession, $listPayments;

    if (!$SW_Permissions['Payment']['Edit'][$profilSession]) {
        return false;
    }

    if (periodLocked($listPayments->pay_doc_date[0])) {     // check if period locked
        return false;
    }

    return true;
}

function item_removable()
{
    global $SW_Permissions, $profilSession, $comptListPayments, $listPayments;

    if (!$SW_Permissions['Payment']['Admin'][$profilSession]) {
        return false;
    }

    for ($i=0; $i<$comptListPayments; $i++) {
        if (periodLocked($listPayments->pay_doc_date[$i])) {     // check if period locked
            return false;
        }
    }

    return true;
}

$ids = "'" . str_replace("**", "','", $id) . "'";
$ida = explode('**', $id);
$querymore = " WHERE pay.id IN ($ids)";
$listPayments = new request();
$listPayments->openPayments($querymore);
$comptListPayments = count($listPayments->pay_id);

if ($comptListPayments === 0 || $comptListPayments !== count($ida)) {
    return;
}

if ($default_action=='Y' && $SW_Permissions['Payment']['Read'][$profilSession] && preg_match('/\*\*/', $id)==0) {
    $url = $path_prefix . 'payments/viewpayment.php?id=' . $id . $urlBornes;
} else {
    if ($SW_Permissions['Payment']['Read'][$profilSession]) {
        if (preg_match('/\*\*/', $id)==0) {
            $content .= '<a href="' . $path_prefix . 'payments/viewpayment.php?id=' . $id . $urlBornes . '">';
            $content .= '<img src="' . verSource('themes/' . THEME . '/btn_info_norm.png') . '">';
            $content .= '<label>' . $strings['view'] . '</label>';
            $content .= '</a>';
        }

        if (item_printable()) {
            $content .= '<a href="' . $path_prefix . 'payments/printpayments.php?id=' . $id . $urlBornes . '">';
            $content .= '<img src="' . verSource('themes/' . THEME . '/btn_print_norm.png') . '">';
            $content .= '<label>' . $strings['print'] . '</label>';
            $content .= '</a>';
        }
    }

    if (preg_match('/\*\*/', $id)==0 && item_editable()) {
        $content .= '<a href="' . $path_prefix . 'payments/editpayment.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_edit_norm.png') . '">';
        $content .= '<label>' . $strings['edit'] . '</label>';
        $content .= '</a>';
    }

    if (item_removable()) {
        $content .= '<a href="' . $path_prefix . 'payments/deletepayments.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_remove_norm.png') . '">';
        $content .= '<label>' . $strings['delete'] . '</label>';
        $content .= '</a>';
    }
}
