<?php // $Revision: 1.0 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: tasks.php,v 1.0 2016/09/01 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
function item_viewable() {
    global $SW_Permissions, $profilSession, $listTasks, $permissionDetail;

    if (!$SW_Permissions['Project']['Admin'][$profilSession]) {
        if ($listTasks->tas_milestone[0] == enumMilestone::msYes) {
            if (!isset($permissionDetail[0]->prp_view_milestone[0]) || $permissionDetail[0]->prp_view_milestone[0] != enumBoolean::bTrue) {
                return false;
            }
        } else {
            if (!isset($permissionDetail[0]->prp_view_task[0]) || $permissionDetail[0]->prp_view_task[0] != enumBoolean::bTrue) {
                return false;
            }
        }
    }

    return true;
}

function item_editable()
{
    global $projectDetail, $permissionDetail;

    if ($projectDetail[0]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[0]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[0]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[0]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        return false;
    }

    if ($permissionDetail[0]->prp_modify_task_status[0] != enumBoolean::bTrue && $permissionDetail[0]->prp_modify_task_properties[0] != enumBoolean::bTrue) {
        return false;
    }

    return true;
}

function item_removable()
{
    global $comptListTasks, $projectDetail, $permissionDetail;

    for ($i=0; $i<$comptListTasks; $i++) {
        if ($projectDetail[$i]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[$i]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            return false;
        }

        if ($permissionDetail[$i]->prp_delete_task[0] != enumBoolean::bTrue) {
            return false;
        }
    }

    return true;
}

function item_duplicable()
{
    global $projectDetail, $permissionDetail;

    if ($projectDetail[0]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[0]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[0]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[0]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        return false;
    }

    if ($permissionDetail[0]->prp_copy_task[0] != enumBoolean::bTrue) {
        return false;
    }

    return true;
}

function item_logtime()
{
    global $id, $idSession, $projectDetail, $permissionDetail;

    if ($projectDetail[0]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[0]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[0]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[0]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        return false;
    }

    $querymore2 = " AND res.task='$id' AND res.resource='$idSession'";
    $resourceUsage = new request();
    $resourceUsage->openTaskHumanResource($querymore2);
    $comptResourceUsage = count($resourceUsage->res_id);

    if ($comptResourceUsage == '0') {
        return false;
    }

    if ($permissionDetail[0]->prp_log_task_hours[0] != enumBoolean::bTrue) {
        return false;
    }

    return true;
}

function item_issuematerial()
{
    global $enableMaterial, $projectDetail, $permissionDetail, $id;

    if ($enableMaterial != 'true') {
        return false;
    }

    if ($projectDetail[0]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[0]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[0]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[0]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        return false;
    }

    if ($permissionDetail[0]->prp_material_issue[0] != enumBoolean::bTrue) {
        return false;
    }

    // get material resource list for task
    $querymore = " AND res.task='$id'";
    $listTaskResources = new request();
    $listTaskResources->openTaskMaterialResource($querymore);
    $comptListTaskResources = count($listTaskResources->res_id);

    if ($comptListTaskResources == '0') {
        return false;
    }

    return true;
}

function item_add_projectsite()
{
    global $sitePublish, $listTasks, $comptListTasks, $projectDetail, $permissionDetail;

    if ($sitePublish != "true") {
        return false;
    }

    if (!in_array(strval(enumPublished::pbNo), $listTasks->tas_published)) {
        return false;
    }

    for ($i=0; $i<$comptListTasks; $i++) {
        if ($projectDetail[$i]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[$i]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            return false;
        }

        if ($permissionDetail[$i]->prp_publish_task[0] != enumBoolean::bTrue || $projectDetail[$i]->pro_published[0] != enumPublished::pbYes) {
            return false;
        }
    }

    return true;
}

function item_remove_projectsite()
{
    global $sitePublish, $listTasks, $comptListTasks, $projectDetail, $permissionDetail;

    if ($sitePublish != "true") {
        return false;
    }

    if (!in_array(strval(enumPublished::pbYes), $listTasks->tas_published)) {
        return false;
    }

    for ($i=0; $i<$comptListTasks; $i++) {
        if ($projectDetail[$i]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[$i]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            return false;
        }

        if ($permissionDetail[$i]->prp_publish_task[0] != enumBoolean::bTrue || $projectDetail[$i]->pro_published[0] != enumPublished::pbYes) {
            return false;
        }
    }

    return true;
}

function item_addpredecessor()
{
    global $id, $listTasks, $projectDetail;

    if ($listTasks->tas_task_group[0] == enumTaskGroup::tgYes) {
        return false;
    } else if ($listTasks->tas_start_date[0] == '0' || $listTasks->tas_due_date[0] == '0') {
        return false;
    }

    $querymore4 = " WHERE tas.project='" . $listTasks->tas_project[0] . "' AND tas.id<>'$id'";

    if ($projectDetail[0]->pro_phase_set[0] != "0") {
        $querymore4 .= " AND tas.parent_phase='" . $listTasks->tas_parent_phase[0]. "'";
    }

    $listTasksP = new request();
    $listTasksP->openTasks($querymore4);
    $comptListTasksP = count($listTasksP->tas_id);
    $querymore5 = " WHERE (pre.task='$id' OR pre.predecessor='$id') AND tas.start_date<>'0' AND tas.due_date<>'0' AND tas2.start_date<>'0' AND tas2.due_date<>'0'";
    $listTasksL = new request();
    $listTasksL->openTaskPredecessor($querymore5);
    $comptListTasksL = count($listTasksL->pre_id);
    $prSets = array();

    for ($i=0; $i<$comptListTasksP; $i++) {
        for ($j=0; $j<$comptListTasksL; $j++) {
            if ($listTasksP->tas_id[$i] == $listTasksL->pre_task[$j] || $listTasksP->tas_id[$i] == $listTasksL->pre_predecessor[$j]) {
                break;
            }
        }

        if ($j != $comptListTasksL || $listTasksP->tas_task_group[$i] == enumTaskGroup::tgYes) {
            continue;
        }

        $prSets[$listTasksP->tas_id[$i]] = $listTasksP->tas_name[$i];
    }

    if (count($prSets) == 0) {
        return false;
    }

    return true;
}

function item_deletedependencies()
{
    global $id;
    $querymore4 = " WHERE pre.task='$id' OR pre.predecessor='$id'";
    $listDependencies = new request();
    $listDependencies->openTaskPredecessor($querymore4);
    $comptListDependencies = count($listDependencies->pre_id);
    return ($comptListDependencies>0);
}

function item_indentation()
{
    global $id, $listTasks;
    // check milestone
    if ($listTasks->tas_milestone[0] == enumMilestone::msYes) {
        return false;
    }

    // exclude related tasks
    $querymore8 = " WHERE pre.task='$id' OR pre.predecessor='$id'";
    $relatedTaskList = new request();
    $relatedTaskList->openTaskPredecessor($querymore8);
    $comptRelatedTaskList = count($relatedTaskList->pre_id);
    $relatedTasks = $id;

    for ($i=0; $i<$comptRelatedTaskList; $i++) {
        $relatedTasks .= ',';

        if ($relatedTaskList->pre_task[$i] == $id) {
            $relatedTasks .= $relatedTaskList->pre_predecessor[$i];
        } else {
            $relatedTasks .= $relatedTaskList->pre_task[$i];
        }
    }

    // check parent tasks available
    $querymore9 = " WHERE tas.id NOT IN ($relatedTasks) AND tas.project='" . $listTasks->tas_project[0] . "' AND tas.parent_phase='" . $listTasks->tas_parent_phase[0] . "' AND tas.milestone='" . enumMilestone::msNo . "' AND tas.level='" . $listTasks->tas_level[0] . "' AND tas.parent_task='" . $listTasks->tas_parent_task[0] . "'";
    $listTasksP = new request();
    $listTasksP->openTasks($querymore9);
    $comptListTasksP = count($listTasksP->tas_id);

    if ($comptListTasksP == 0) {
        return false;
    }

    return true;
}

function item_unindentation()
{
    global $listTasks;
    // check milestone
    if ($listTasks->tas_milestone[0] == enumMilestone::msYes) {
        return false;
    }

    // check parent task
    if ($listTasks->tas_parent_task[0] == '0') {
        return false;
    }

    return true;
}

function item_relationship()
{
    global $comptListTasks, $projectDetail, $permissionDetail;

    for ($i=0; $i<$comptListTasks; $i++) {
        if ($projectDetail[$i]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[$i]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            return false;
        }

        if ($permissionDetail[$i]->prp_edit_task_relationships[0] != enumBoolean::bTrue) {
            return false;
        }
    }

    return true;
}

$ids = "'" . str_replace("**", "','", $id) . "'";
$ida = explode('**', $id);
$querymore = " WHERE tas.id IN ($ids)";
$listTasks = new request();
$listTasks->openTasks($querymore);
$comptListTasks = count($listTasks->tas_id);
$taskgroups = array();

if ($comptListTasks === 0 || $comptListTasks !== count($ida)) {
    return;
}

for ($i=0; $i<$comptListTasks; $i++) {
    $querymore1 = " WHERE pro.id='" . $listTasks->tas_project[$i] . "'";
    $projectDetail[$i] = new request();
    $projectDetail[$i]->openProjects($querymore1);
    $querymore2 = " WHERE tea.project='" . $listTasks->tas_project[$i] . "' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore2);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore3 = " WHERE prp.project='" . $listTasks->tas_project[$i] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore3 = " WHERE prp.project='" . $listTasks->tas_project[$i] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail[$i] = new request();
    $permissionDetail[$i]->openProjectPermissions($querymore3);
    $groupkey = $listTasks->tas_project[$i] . '**' .$listTasks->tas_parent_phase[$i];
    
    if (!isset($taskgroups[$groupkey])) {
        $taskgroups[$groupkey] = $groupkey;
    }
}

if ($default_action=='Y' && preg_match('/\*\*/', $id)==0 && item_viewable()) {
    $url = $path_prefix . 'tasks/viewtask.php?id=' . $id . $urlBornes;
} else {
    if (preg_match('/\*\*/', $id)==0 && item_viewable()) {
        $content .= '<a href="' . $path_prefix . 'tasks/viewtask.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_info_norm.png') . '">';
        $content .= '<label>' . $strings['view'] . '</label>';
        $content .= '</a>';
    }

    if (preg_match('/\*\*/', $id)==0 && item_editable()) {
        $content .= '<a href="' . $path_prefix . 'tasks/edittask.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_edit_norm.png') . '">';
        $content .= '<label>' . $strings['edit'] . '</label>';
        $content .= '</a>';
    }

    if (item_removable()) {
        $content .= '<a href="' . $path_prefix . 'tasks/deletetasks.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_remove_norm.png') . '">';
        $content .= '<label>' . $strings['delete'] . '</label>';
        $content .= '</a>';
    }

    if (preg_match('/\*\*/', $id)==0 && item_duplicable()) {
        $content .= '<a href="' . $path_prefix . 'tasks/edittask.php?cpy=true&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_copy_norm.png') . '">';
        $content .= '<label>' . $strings['copy'] . '</label>';
        $content .= '</a>';
    }

    if (preg_match('/\*\*/', $id)==0 && item_logtime()) {
        $content .= '<a href="' . $path_prefix . 'tasks/addtasktime.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_timelog_norm.png') . '">';
        $content .= '<label>' . $strings['loghours'] . '</label>';
        $content .= '</a>';
    }

    if (preg_match('/\*\*/', $id)==0 && item_issuematerial()) {
        $content .= '<a href="' . $path_prefix . 'tasks/addmaterialissue.php?id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_material_norm.png') . '">';
        $content .= '<label>' . $strings['material_issue'] . '</label>';
        $content .= '</a>';
    }

    if (item_add_projectsite() && isset($org_url)) {
        $content .= '<a href="' . $path_prefix . $org_url . '&action=publish&addToSiteTask=true&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_add_projectsite_norm.png') . '">';
        $content .= '<label>' . $strings['add_customer_service_site'] . '</label>';
        $content .= '</a>';
    }

    if (item_remove_projectsite() && isset($org_url)) {
        $content .= '<a href="' . $path_prefix . $org_url . '&action=publish&removeToSiteTask=true&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_remove_projectsite_norm.png') . '">';
        $content .= '<label>' . $strings['remove_customer_service_site'] . '</label>';
        $content .= '</a>';
    }

    if (count($taskgroups)==1 && item_relationship()) {
        list($project, $phase_order) = explode("**", $groupkey);

        if (preg_match('/\*\*/', $id)==0) {
            if (item_addpredecessor()) {
                $content .= '<a href="' . $path_prefix . 'tasks/addpredecessor.php?project=' . $project . '&id=' . $id . $urlBornes . '">';
                $content .= '<img src="' . verSource('themes/' . THEME . '/btn_dependency_norm.png') . '">';
                $content .= '<label>' . $strings['add_predecessor'] . '</label>';
                $content .= '</a>';
            }

            if (item_deletedependencies()) {
                $content .= '<a href="' . $path_prefix . 'tasks/deletedependencies.php?project=' . $project . '&id=' . $id . $urlBornes . '">';
                $content .= '<img src="' . verSource('themes/' . THEME . '/btn_unlink_norm.png') . '">';
                $content .= '<label>' . $strings['delete_dependencies'] . '</label>';
                $content .= '</a>';
            }

            if (item_indentation()) {
                $content .= '<a href="' . $path_prefix . 'tasks/indentation.php?project=' . $project . '&phase=' . $phase_order . '&id=' . $id . $urlBornes . '">';
                $content .= '<img src="' . verSource('themes/' . THEME . '/btn_indentation_norm.png') . '">';
                $content .= '<label>' . $strings['indentation'] . '</label>';
                $content .= '</a>';
            }

            if (item_unindentation()) {
                $content .= '<a href="' . $path_prefix . 'tasks/unindentation.php?project=' . $project . '&phase=' . $phase_order . '&id=' . $id . $urlBornes . '">';
                $content .= '<img src="' . verSource('themes/' . THEME . '/btn_unindentation_norm.png') . '">';
                $content .= '<label>' . $strings['unindentation'] . '</label>';
                $content .= '</a>';
            }
        } else {
            $content .= '<a href="' . $path_prefix . 'tasks/edittask.php?action=taskgroup&project=' . $project . '&phase=' . $phase_order . '&id=' . $id . $urlBornes . '">';
            $content .= '<img src="' . verSource('themes/' . THEME . '/btn_add_taskgroup_norm.png') . '">';
            $content .= '<label>' . $strings['add_taskgroup'] . '</label>';
            $content .= '</a>';
        }
    }
}
