<?php // $Revision: 1.0 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: teams.php,v 1.0 2016/09/01 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
function item_editable()
{
    global $projectDetail, $permissionDetail;

    if ($projectDetail[0]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[0]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[0]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[0]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        return false;
    }

    if ($permissionDetail[0]->prp_modify_team_member_properties[0] != enumBoolean::bTrue) {
        return false;
    }

    return true;
}
function item_removable()
{
    global $comptListTeam, $projectDetail, $permissionDetail;

    for ($i=0; $i<$comptListTeam; $i++) {
        if ($projectDetail[$i]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[$i]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            return false;
        }

        if ($permissionDetail[$i]->prp_delete_team_member[0] != enumBoolean::bTrue) {
            return false;
        }
    }

    return true;
}

function item_add_projectsite()
{
    global $sitePublish, $listTeam, $comptListTeam, $projectDetail, $permissionDetail;

    if ($sitePublish != "true") {
        return false;
    }

    if (!in_array(strval(enumPublished::pbNo), $listTeam->tea_published)) {
        return false;
    }

    for ($i=0; $i<$comptListTeam; $i++) {
        if ($projectDetail[$i]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[$i]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            return false;
        }

        if ($permissionDetail[$i]->prp_publish_team_member[0] != enumBoolean::bTrue || $projectDetail[$i]->pro_published[0] != enumPublished::pbYes) {
            return false;
        }
    }

    return true;
}

function item_remove_projectsite()
{
    global $sitePublish, $listTeam, $comptListTeam, $projectDetail, $permissionDetail;

    if ($sitePublish != "true") {
        return false;
    }

    if (!in_array(strval(enumPublished::pbYes), $listTeam->tea_published)) {
        return false;
    }

    for ($i=0; $i<$comptListTeam; $i++) {
        if ($projectDetail[$i]->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail[$i]->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail[$i]->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            return false;
        }

        if ($permissionDetail[$i]->prp_publish_team_member[0] != enumBoolean::bTrue || $projectDetail[$i]->pro_published[0] != enumPublished::pbYes) {
            return false;
        }
    }

    return true;
}

function item_sendmessage()
{
    global $comptListTeam, $permissionDetail;

    for ($i=0; $i<$comptListTeam; $i++) {
        if ($permissionDetail[$i]->prp_send_message[0] != enumBoolean::bTrue) {
            return false;
        }
    }

    return true;
}

$ids = "'" . str_replace("**", "','", $id) . "'";
$ida = explode('**', $id);
$querymore = " WHERE tea.id IN ($ids)";
$listTeam = new request();
$listTeam->openTeams($querymore);
$comptListTeam = count($listTeam->tea_project);

if ($comptListTeam === 0 || $comptListTeam !== count($ida)) {
    return;
}

for ($i=0; $i<$comptListTeam; $i++) {
    $querymore1 = " WHERE pro.id='" . $listTeam->tea_project[$i] . "'";
    $projectDetail[$i] = new request();
    $projectDetail[$i]->openProjects($querymore1);
    $querymore2 = " WHERE tea.project='" . $listTeam->tea_project[$i] . "' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore2);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore3 = " WHERE prp.project='" . $listTeam->tea_project[$i] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore3 = " WHERE prp.project='" . $listTeam->tea_project[$i] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail[$i] = new request();
    $permissionDetail[$i]->openProjectPermissions($querymore3);
}

if ($default_action=='Y' && preg_match('/\*\*/', $id)==0 && ($SW_Permissions['Project']['Admin'][$profilSession] || $permissionDetail[0]->prp_view_team[0]==enumBoolean::bTrue)) {
    $url = $path_prefix . 'teams/viewuser.php?project=' . $project . '&id=' . $id . $urlBornes;
} else {
    if (preg_match('/\*\*/', $id)==0 && ($SW_Permissions['Project']['Admin'][$profilSession] || $permissionDetail[0]->prp_view_team[0]==enumBoolean::bTrue)) {
        $content .= '<a href="' . $path_prefix . 'teams/viewuser.php?project=' . $project . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_info_norm.png') . '">';
        $content .= '<label>' . $strings['view'] . '</label>';
        $content .= '</a>';
    }

    if (preg_match('/\*\*/', $id)==0 && item_editable()) {
        $content .= '<a href="' . $path_prefix . 'teams/updateusers.php?project=' . $project . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_edit_norm.png') . '">';
        $content .= '<label>' . $strings['edit'] . '</label>';
        $content .= '</a>';
    }

    if (item_removable()) {
        $content .= '<a href="' . $path_prefix . 'teams/deleteusers.php?project=' . $project . '&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_remove_norm.png') . '">';
        $content .= '<label>' . $strings['delete'] . '</label>';
        $content .= '</a>';
    }

    if (item_add_projectsite() && isset($org_url)) {
        $content .= '<a href="' . $path_prefix . $org_url . '&action=publish&addToSiteTeam=true&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_add_projectsite_norm.png') . '">';
        $content .= '<label>' . $strings['add_customer_service_site'] . '</label>';
        $content .= '</a>';
    }

    if (item_remove_projectsite() && isset($org_url)) {
        $content .= '<a href="' . $path_prefix . $org_url . '&action=publish&removeToSiteTeam=true&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_remove_projectsite_norm.png') . '">';
        $content .= '<label>' . $strings['remove_customer_service_site'] . '</label>';
        $content .= '</a>';
    }

    if (item_sendmessage()) {
        $content .= '<a href="' . $path_prefix . 'users/emailusers.php?project=' . $project . '&team=true&id=' . $id . $urlBornes . '">';
        $content .= '<img src="' . verSource('themes/' . THEME . '/btn_email_norm.png') . '">';
        $content .= '<label>' . $strings['email'] . '</label>';
        $content .= '</a>';
    }
}
