<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: chattab_serv.php,v 1.3 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
// check if the request is an AJAX request
if (!is_ajax()) {
    exit;
}

/**
 * Variables init
 */
$action = AddSlashesNOD(isset($_POST['action'])?$_POST['action']:'');   // action

if ($action == '') {
    exit;
}

/**
 * Generate message html
 * @param integer $id message id
 * @param string $avatar avatar file path
 * @param string $mem_name sender user name
 * @param integer $created message create timestamp
 * @param boolean $my is my message
 * @param string $message message content
 * @param string $extension_picture photo file extension
 * @param string $subject photo file name
 * @return string message html
 */
function setupMessageHtml($id, $avatar, $mem_name, $created, $my, $message, $extension_picture, $subject)
{
    $msg = '<div class="message"><div class="message-left"><img class="avatar" src="' . $avatar . '"></div>';
    $msg .= '<div class="message-right"><div class="message-info">';
    $msg .= '<div class="message-username">' . $mem_name . '</div>';
    $msg .= '<div class="message-timestamp">' . createDate($created, 'both') . '</div></div>';

    if ($message != '') {
        $msg .= '<div class="message-content ';
        $msg .= ($my)?'my-message':'others-message';
        $msg .= '">' . $message . '</div>';
    } elseif ($extension_picture != '') {
        $photosrc = getMsgPhoto($id, $extension_picture);

        if ($photosrc == '') {
            return '';
        } else {
            $msg .= setupPhotoBox($photosrc, $subject, $subject);
        }
    }

    $msg .= '</div></div>';
    return $msg;
}
/**
 * get online user list & avatar html content
 * @global integer $idSession
 * @global string $tablePrefix
 * @global array $row
 * @param string $chatType
 * @param integer $chatTo
 * @param string $online
 * @param string $onlineHtml
 * @param string $onlineOrg
 */
function getOnlineData($chatType, $chatTo, &$online, &$onlineHtml, $onlineOrg = '')
{
    global $idSession, $tablePrefix, $row;
    $min5ago = time() - 300;
    $tmpquery = '';
    $online = '';
    $onlineHtml = '';

    if ($chatType == 'P') {          // 1-1 chat
        $tmpquery .= "SELECT sess.member,mem.name,mem.gender,mem.extension_picture FROM " . $tablePrefix . "chat_sessions sess INNER JOIN " . $tablePrefix . "members mem ON mem.id=sess.member WHERE sess.chat_type='$chatType' AND sess.chat_to='$idSession' AND sess.last_access>'$min5ago' ORDER BY sess.member";
    } else if ($chatType == 'M') {   // meeting
        $tmpquery .= "SELECT sess.member,mem.name,mem.gender,mem.extension_picture FROM " . $tablePrefix . "chat_sessions sess INNER JOIN " . $tablePrefix . "members mem ON mem.id=sess.member WHERE sess.member<>'$idSession' AND sess.chat_type='$chatType' AND sess.chat_to='$chatTo' AND sess.last_access>'$min5ago' ORDER BY sess.member";
    }

    if ($tmpquery != '') {
        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery);
        $request1->member = array();
        $request1->name = array();
        $request1->gender = array();
        $request1->extension_picture = array();

        while ($request1->fetch()) {
            $request1->member[] = ($row[0]);
            $request1->name[] = HtmlEntityDecodeNOD($row[1]);
            $request1->gender[] = ($row[2]);
            $request1->extension_picture[] = ($row[3]);
        }

        if (count($request1->member) > 0) {
            $online = implode(',', $request1->member);

            if ($online != $onlineOrg) {
                for ($i=0; $i<count($request1->member); $i++) {
                    $avatar = getAvatar($request1->member[$i], $request1->extension_picture[$i], $request1->gender[$i]);
                    $onlineHtml .= '<div class="online-user"><img title="' . $request1->name[$i] . '" src="' . $avatar . '"></div>';
                }
            }
        }
    }
}

switch ($action) {
    case 'initial':     // load last 10 messages & all new messages
        $chatTo = AddSlashesNOD(isset($_POST['chatTo'])?$_POST['chatTo']:'0');          // user id or meeting id
        $chatType = AddSlashesNOD(isset($_POST['chatType'])?$_POST['chatType']:'P');    // message type
        $title = '';
        $content = '';
        $prev = '0';
        $firstId = '0';
        $msgCount = 0;

        if ($chatType == 'P') {          // 1-1 chat
            $toAvatar = getAvatar($idSession, $extSession, $genderSession);
            $querymore1 = " WHERE mem.id='$chatTo'";
            $memberDetail = new request();
            $memberDetail->openMembers($querymore1);

            if (count($memberDetail->mem_id) > 0) {
                $title = $memberDetail->mem_name[0];
                $fromAvatar = getAvatar($chatTo, $memberDetail->mem_extension_picture[0], $memberDetail->mem_gender[0]);
            }

            $requestAct = new request();
            $requestAct->connectClass();     // connect to database server

            try {
                $requestAct->startTransaction();
                // get first new messages
                $querymore2 = " WHERE mes.from_id='$chatTo' AND mes.to_id='$idSession' AND mes.message_type='P' AND mes.seen='N' ORDER BY mes.id";
                $firstNewMessage = clone $requestAct;
                $firstNewMessage->openMessages($querymore2, 0, 1);
                $newMsgFound = (count($firstNewMessage->mes_id) > 0);

                if ($newMsgFound) {
                    // load new messages
                    $mid = $firstNewMessage->mes_id[0];
                    $querymore3 = " WHERE mes.id>='$mid' AND mes.message_type='P' AND ((mes.from_id='$chatTo' AND mes.to_id='$idSession') OR (mes.from_id='$idSession' AND mes.to_id='$chatTo')) ORDER BY mes.id";
                    $listNewMessages = clone $requestAct;
                    $listNewMessages->openMessages($querymore3);
                    $comptListNewMessages = count($listNewMessages->mes_id);
                    $firstId = $listNewMessages->mes_id[0];
                    $prev = $listNewMessages->mes_id[$comptListNewMessages-1];

                    for ($i=0; $i<$comptListNewMessages; $i++) {
                        $msg = setupMessageHtml($listNewMessages->mes_id[$i], (($listNewMessages->mes_from_id[$i]==$idSession)?$toAvatar:$fromAvatar), $listNewMessages->mes_mem_name[$i], $listNewMessages->mes_created[$i], ($listNewMessages->mes_from_id[$i]==$idSession), $listNewMessages->mes_message[$i], $listNewMessages->mes_extension_picture[$i], $listNewMessages->mes_subject[$i]);

                        if ($msg != '') {
                            $content .= $msg;
                            $msgCount++;
                        }
                    }

                    $tmpsql = "UPDATE " . $tablePrefix . "messages SET seen='Y' WHERE from_id='$chatTo' AND to_id='$idSession' AND message_type='P' AND seen='N'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                } else {
                    $mid = '';
                }

                if ($msgCount < 10) {
                    $querymore4 = " WHERE mes.message_type='P' AND ((mes.from_id='$chatTo' AND mes.to_id='$idSession') OR (mes.from_id='$idSession' AND mes.to_id='$chatTo'))";

                    if ($mid !== '') {
                        $querymore4 .= " AND mes.id<'$mid'";
                    }

                    $querymore4 .= " ORDER BY mes.id DESC";     // fetch data in reversed order
                    $listSeenMessages = clone $requestAct;
                    $listSeenMessages->openMessages($querymore4, 0, (10 - $msgCount));
                    $comptListSeenMessages = count($listSeenMessages->mes_id);

                    if ($comptListSeenMessages > 0) {
                        $content1 = '';

                        if ($firstId == '0') {
                            $firstId = $listSeenMessages->mes_id[$comptListSeenMessages-1];
                        }

                        if ($prev == '0') {
                            $prev = $listSeenMessages->mes_id[0];
                        }

                        for ($i=$comptListSeenMessages-1; $i>=0; $i--) {
                            $msg = setupMessageHtml($listSeenMessages->mes_id[$i], (($listSeenMessages->mes_from_id[$i]==$idSession)?$toAvatar:$fromAvatar), $listSeenMessages->mes_mem_name[$i], $listSeenMessages->mes_created[$i], ($listSeenMessages->mes_from_id[$i]==$idSession), $listSeenMessages->mes_message[$i], $listSeenMessages->mes_extension_picture[$i], $listSeenMessages->mes_subject[$i]);

                            if ($msg != '') {
                                $content1 .= $msg;
                                $msgCount++;
                            }
                        }

                        if ($content1 != '') {
                            $content = $content1 . '<div class="message"><div class="line-behind"><h1>' . $strings['new_messages'] . '</h1></div></div>' . $content;
                        }
                    }
                }

                if ($newMsgFound) {
                    $requestAct->endTransaction(enumTransactionEndType::etCommit);
                } else {
                    $requestAct->endTransaction(enumTransactionEndType::etRollBack);
                }
            } catch (Exception $e) {
                $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
                error_log($e->getMessage());
                $requestAct->endTransaction(enumTransactionEndType::etRollBack);
                $content = '';
            }
        } else if ($chatType == 'M') {   // meeting
            $querymore1 = " WHERE mee.id='$chatTo'";
            $meetingDetail = new request();
            $meetingDetail->openMeetings($querymore1);

            if (count($meetingDetail->mee_id) > 0) {
                $title = $strings['meeting'] . ' : ' . $meetingDetail->mee_name[0];
            }

            // get users avatars
            $userAvatars = array();
            $tmpquery = "SELECT mes.from_id,mem.gender,mem.extension_picture FROM " . $tablePrefix . "messages mes INNER JOIN " . $tablePrefix . "members mem ON mem.id=mes.from_id WHERE mes.to_id='$chatTo' AND mes.message_type='M' GROUP BY mes.from_id,mem.gender,mem.extension_picture";
            $listUsers = new request();
            $listUsers->connectClass();
            $listUsers->query($tmpquery);

            while ($listUsers->fetch()) {
                $from_id = ($row[0]);
                $gender = ($row[1]);
                $ext = ($row[2]);
                $userAvatars[$from_id] = getAvatar($from_id, $ext, $gender);
            }

            $querymore2 = " WHERE mes.to_id='$chatTo' AND mes.message_type='M' ORDER BY mes.id DESC";
            $listMessages = new request();
            $listMessages->openMessages($querymore2, 0, 10);    // get last 10 messages in reversed order
            $comptListMessages = count($listMessages->mes_id);

            if ($comptListMessages > 0) {
                $firstId = $listMessages->mes_id[$comptListMessages-1];
                $prev = $listMessages->mes_id[0];

                for ($i=$comptListMessages-1; $i>=0; $i--) {
                    $msg = setupMessageHtml($listMessages->mes_id[$i], $userAvatars[$listMessages->mes_from_id[$i]], $listMessages->mes_mem_name[$i], $listMessages->mes_created[$i], ($listMessages->mes_from_id[$i]==$idSession), $listMessages->mes_message[$i], $listMessages->mes_extension_picture[$i], $listMessages->mes_subject[$i]);

                    if ($msg != '') {
                        $content .= $msg;
                        $msgCount++;
                    }
                }
            }
        }

        $online = '';
        $onlineHtml = '';
        getOnlineData($chatType, $chatTo, $online, $onlineHtml);
        updateChatSession($chatType, $chatTo);
        header("content-type:application/json");
        echo json_encode(array(
            'title' => $title,
            'content' => $content,
            'firstId' => $firstId,
            'prev' => $prev,
            'online' => $online,
            'onlineHtml' => $onlineHtml
        ));
        break;
    case 'history':     // load 10 older messages
        $chatTo = AddSlashesNOD(isset($_POST['chatTo'])?$_POST['chatTo']:'0');          // user id or meeting id
        $chatType = AddSlashesNOD(isset($_POST['chatType'])?$_POST['chatType']:'P');    // message type
        $chatFirst = AddSlashesNOD(isset($_POST['chatFirst'])?$_POST['chatFirst']:'0'); // first loaded message id
        $content = '';
        $firstId = $chatFirst;
        // get users avatars
        $userAvatars = array();

        if ($chatType == 'P') {          // 1-1 chat
            $userAvatars[$idSession] = getAvatar($idSession, $extSession, $genderSession);
            $querymore1 = " WHERE mem.id='$chatTo'";
            $memberDetail = new request();
            $memberDetail->openMembers($querymore1);

            if (count($memberDetail->mem_id) > 0) {
                $userAvatars[$chatTo] = getAvatar($chatTo, $memberDetail->mem_extension_picture[0], $memberDetail->mem_gender[0]);
            }
        } else if ($chatType == 'M') {   // meeting
            $tmpquery = "SELECT mes.from_id,mem.gender,mem.extension_picture FROM " . $tablePrefix . "messages mes INNER JOIN " . $tablePrefix . "members mem ON mem.id=mes.from_id WHERE mes.id<'$chatFirst' AND mes.to_id='$chatTo' AND mes.message_type='M' GROUP BY mes.from_id,mem.gender,mem.extension_picture";
            $listUsers = new request();
            $listUsers->connectClass();
            $listUsers->query($tmpquery);

            while ($listUsers->fetch()) {
                $from_id = ($row[0]);
                $gender = ($row[1]);
                $ext = ($row[2]);
                $userAvatars[$from_id] = getAvatar($from_id, $ext, $gender);
            }
        }

        // get 10 order messages
        if ($chatType == 'P') {          // 1-1 chat
            $querymore1 = " WHERE mes.id<'$chatFirst' AND ((mes.from_id='$idSession' AND mes.to_id='$chatTo') OR (mes.from_id='$chatTo' AND mes.to_id='$idSession')) AND mes.message_type='P' ORDER BY mes.id DESC";
        } else if ($chatType == 'M') {   // meeting
            $querymore1 = " WHERE mes.id<'$chatFirst' AND mes.to_id='$chatTo' AND mes.message_type='M' ORDER BY mes.id DESC";
        }

        $listMessages = new request();
        $listMessages->openMessages($querymore1, 0, 10);
        $comptListMessages = count($listMessages->mes_id);

        if ($comptListMessages > 0) {
            $firstId = $listMessages->mes_id[$comptListMessages-1];

            for ($i=$comptListMessages-1; $i>=0; $i--) {
                $msg = setupMessageHtml($listMessages->mes_id[$i], $userAvatars[$listMessages->mes_from_id[$i]], $listMessages->mes_mem_name[$i], $listMessages->mes_created[$i], ($listMessages->mes_from_id[$i]==$idSession), $listMessages->mes_message[$i], $listMessages->mes_extension_picture[$i], $listMessages->mes_subject[$i]);

                if ($msg != '') {
                    $content .= $msg;
                }
            }
        }

        header("content-type:application/json");
        echo json_encode(array(
            'content' => $content,
            'firstId' => $firstId
        ));
        break;
    case 'load':    // load new messages that added after last loading
        $chatTo = AddSlashesNOD(isset($_POST['chatTo'])?$_POST['chatTo']:'0');          // user id or meeting id
        $chatType = AddSlashesNOD(isset($_POST['chatType'])?$_POST['chatType']:'P');    // message type
        $chatPrev = AddSlashesNOD(isset($_POST['chatPrev'])?$_POST['chatPrev']:'0');    // last loaded message id
        $chatSess = AddSlashesNOD(isset($_POST['chatSess'])?$_POST['chatSess']:'0');    // update chat session
        $chatOnline = AddSlashesNOD(isset($_POST['chatOnline'])?$_POST['chatOnline']:'');   // online user list
        $content = '';
        $prev = $chatPrev;

        if ($chatType == 'P') {          // 1-1 chat
            $querymore1 = " WHERE mem.id='$chatTo'";
            $memberDetail = new request();
            $memberDetail->openMembers($querymore1);

            if (count($memberDetail->mem_id) > 0) {
                $title = $memberDetail->mem_name[0];
                $fromAvatar = getAvatar($chatTo, $memberDetail->mem_extension_picture[0], $memberDetail->mem_gender[0]);
            }

            $requestAct = new request();
            $requestAct->connectClass();     // connect to database server

            try {
                $requestAct->startTransaction();
                // get new messages
                $querymore2 = " WHERE mes.from_id='$chatTo' AND mes.to_id='$idSession' AND mes.message_type='P' AND (mes.seen='N' OR mes.id>'$chatPrev') ORDER BY mes.id";
                $listNewMessages = clone $requestAct;
                $listNewMessages->openMessages($querymore2);
                $comptListNewMessages = count($listNewMessages->mes_id);
                $newMsgFound = ($comptListNewMessages > 0);

                if ($newMsgFound) {
                    $prev = $listNewMessages->mes_id[$comptListNewMessages-1];

                    for ($i=0; $i<$comptListNewMessages; $i++) {
                        $msg = setupMessageHtml($listNewMessages->mes_id[$i], $fromAvatar, $listNewMessages->mes_mem_name[$i], $listNewMessages->mes_created[$i], false, $listNewMessages->mes_message[$i], $listNewMessages->mes_extension_picture[$i], $listNewMessages->mes_subject[$i]);

                        if ($msg != '') {
                            $content .= $msg;
                        }
                    }

                    $tmpsql = "UPDATE " . $tablePrefix . "messages SET seen='Y' WHERE from_id='$chatTo' AND to_id='$idSession' AND message_type='P' AND seen='N'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $requestAct->endTransaction(enumTransactionEndType::etCommit);
                } else {
                    $requestAct->endTransaction(enumTransactionEndType::etRollBack);
                }
            } catch (Exception $e) {
                $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
                error_log($e->getMessage());
                $requestAct->endTransaction(enumTransactionEndType::etRollBack);
                $content = '';
            }
        } else if ($chatType == 'M') {   // meeting
            // get users avatars
            $userAvatars = array();
            $tmpquery = "SELECT mes.from_id,mem.gender,mem.extension_picture FROM " . $tablePrefix . "messages mes INNER JOIN " . $tablePrefix . "members mem ON mem.id=mes.from_id WHERE mes.id>'$chatPrev' AND mes.from_id<>'$idSession' AND mes.to_id='$chatTo' AND mes.message_type='M' GROUP BY mes.from_id,mem.gender,mem.extension_picture";
            $listUsers = new request();
            $listUsers->connectClass();
            $listUsers->query($tmpquery);

            while ($listUsers->fetch()) {
                $from_id = ($row[0]);
                $gender = ($row[1]);
                $ext = ($row[2]);
                $userAvatars[$from_id] = getAvatar($from_id, $ext, $gender);
            }

            // get new messages
            $querymore1 = " WHERE mes.id>'$chatPrev' AND mes.from_id<>'$idSession' AND mes.to_id='$chatTo' AND mes.message_type='M' ORDER BY mes.id";
            $listNewMessages = new request();
            $listNewMessages->openMessages($querymore1);
            $comptListNewMessages = count($listNewMessages->mes_id);

            if ($comptListNewMessages > 0) {
                $prev = $listNewMessages->mes_id[$comptListNewMessages-1];

                for ($i=0; $i<$comptListNewMessages; $i++) {
                    $msg = setupMessageHtml($listNewMessages->mes_id[$i], $userAvatars[$listNewMessages->mes_from_id[$i]], $listNewMessages->mes_mem_name[$i], $listNewMessages->mes_created[$i], false, $listNewMessages->mes_message[$i], $listNewMessages->mes_extension_picture[$i], $listNewMessages->mes_subject[$i]);

                    if ($msg != '') {
                        $content .= $msg;
                    }
                }
            }
        }

        if ($chatSess == '1') {
            updateChatSession($chatType, $chatTo);
        }

        $online = '';
        $onlineHtml = '';
        getOnlineData($chatType, $chatTo, $online, $onlineHtml, $chatOnline);
        header("content-type:application/json");
        echo json_encode(array(
            'content' => $content,
            'prev' => $prev,
            'online' => $online,
            'onlineHtml' => $onlineHtml
        ));
        break;
    case 'sendMessage':     // send a messages
        $chatTo = AddSlashesNOD(isset($_POST['chatTo'])?$_POST['chatTo']:'0');          // user id or meeting id
        $chatType = AddSlashesNOD(isset($_POST['chatType'])?$_POST['chatType']:'P');    // message type
        $msg = AddSlashesNOD(isset($_POST['message'])?$_POST['message']:'');            // message
        $content = '';
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $message = nl2br($msg);
            $created = time();
            $tmpsql = "INSERT INTO " . $tablePrefix . "messages (from_id,to_id,message_type,message,extension_picture,subject,seen,archived,created) VALUES ('$idSession','$chatTo','$chatType','" . HtmlEntitiesNOD($message) . "','','','N','N','$created')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('messages');
            $fromAvatar = getAvatar($idSession, $extSession, $genderSession);
            $content .= setupMessageHtml($num, $fromAvatar, $nameSession, $created, true, $message, '', '');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
            $content = '';
        }

        header("content-type:application/json");
        echo json_encode(array(
            'content' => $content
        ));
        break;
    case 'sendPhotos':      // send photos
        $chatTo = AddSlashesNOD(isset($_POST['chatTo'])?$_POST['chatTo']:'0');          // user id or meeting id
        $chatType = AddSlashesNOD(isset($_POST['chatType'])?$_POST['chatType']:'P');    // message type
        $content = '';
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $fromAvatar = getAvatar($idSession, $extSession, $genderSession);

            foreach ($_FILES as $file1) {
                $subject = $file1['name'];
                $extension = strtolower(substr(strrchr($subject, '.'), 1));
                $created = time();
                $tmpsql = "INSERT INTO " . $tablePrefix . "messages (from_id,to_id,message_type,message,extension_picture,subject,seen,archived,created) VALUES ('$idSession','$chatTo','$chatType','','$extension','" . HtmlEntitiesNOD($subject) . "','N','N','$created')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $num = $requestAct->newId('messages');
                uploadFile('Messages', $file1['tmp_name'], $num . '.' . $extension);
                $content .= setupMessageHtml($num, $fromAvatar, $nameSession, $created, true, '', $extension, $subject);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
            $content = '';
        }

        header("content-type:application/json");
        echo json_encode(array(
            'content' => $content
        ));
        break;
    case 'unread':
        // get unread message count
        $tmpquery1 = "SELECT id FROM " . $tablePrefix . "messages WHERE to_id='$idSession' AND message_type<>'M' AND seen='N'";
        $unread = compt($tmpquery1);

        if ($unread > 0) {
            $title = '(' . $unread . ') ' . $setTitle;
        } else {
            $title = $setTitle;
        }

        header("content-type:application/json");
        echo json_encode(array(
            'unread' => $unread,
            'title' => $title
        ));
        break;
    case 'leave':
        clearChatSession();
        break;
}
