<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: chooselist.php,v 1.5 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$tblnam = AddSlashesNOD(isset($_GET['TBLNAM'])?$_GET['TBLNAM']:'');     // table name
$elemid = (isset($_GET['ELEMID']))?$_GET['ELEMID']:'';                  // element ID
$msel = (isset($_GET['MSEL']))?$_GET['MSEL']:'';                        // multiple selection
$borne = AddSlashesNOD(isset($_GET['borne']))?$_GET['borne']:'0';       // limit query (start offset)
$tbldispnam = tableNameString($tblnam);

if (substr($tblnam,0,1)=='@') {
    $tbldispnam .= ' (' . lang_strings('form') . ')';
}

$inputtype = ($msel=='Y')?'checkbox':'radio';

/**
 * Permission check
 */
if ($elemid == '') {
    exit;
}

// table definition
$querymore0 = " WHERE tdf.tablename='$tblnam'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore0);

if (count($tableDefinitionDetail->tdf_tablename) === 0) {
    exit;
}
// check fields shown in choose list
if ($tableDefinitionDetail->tdf_listfields[0] == '') {
    exit;
}

/**
 * Prepare data
 */
// array for choose list fields
$listfields = explode('+', $tableDefinitionDetail->tdf_listfields[0]);
$key = array_search('id', $listfields);

if ($key !== FALSE) {
    unset($listfields[$key]);
}
// fields definitions
$querymore1 = " WHERE fdf.tablename='$tblnam'";
$listFieldsDefinitions = new request();
$listFieldsDefinitions->openFieldsDefinitions($querymore1);
// user field filters
$querymore2 = " WHERE fft.member='$idSession' AND fft.tablename='$tblnam' AND fft.dbfieldname IN ('id'" . ((count($listfields)==0)?'':",'" . implode("','", $listfields)) . "')";
$listFieldFilters = new request();
$listFieldFilters->openFieldFilters($querymore2);
$comptListFieldFilters = count($listFieldFilters->fft_member);
// prepare fetch data sql
$tmpquery = "SELECT id" . ((count($listfields)==0)?'':',' . implode(',', $listfields)) . " FROM $tablePrefix" . $tableDefinitionDetail->tdf_dbtablename[0];

if ($comptListFieldFilters > 0) {
    $conditions = array();

    for ($i=0; $i<$comptListFieldFilters; $i++) {
        $dbfldnam = $listFieldFilters->fft_dbfieldname[$i];

        if (array_key_exists($dbfldnam, $reservedDbFields)) {
            $fldtyp = $reservedDbFieldsDef['type'][$dbfldnam];

            if ($reservedDbFieldsDef['validvalues'][$dbfldnam] == '') {
                $comptListFieldsValuesDefinitions = 0;
            } else {
                $comptListFieldsValuesDefinitions = count($reservedDbFieldsDef['validvalues'][$dbfldnam]);
            }
        } else {
            $key = array_search($dbfldnam, $listFieldsDefinitions->fdf_dbfieldname);
            $fldnam = $listFieldsDefinitions->fdf_fieldname[$key];
            $fldtyp = $listFieldsDefinitions->fdf_fieldtype[$key];
            // field valid values definitions
            $querymore = " WHERE fvd.tablename='$tblnam' AND fvd.fieldname='$fldnam'";
            $listFieldsValuesDefinitions = new request();
            $listFieldsValuesDefinitions->openFieldsValuesDefinitions($querymore);
            $comptListFieldsValuesDefinitions = count($listFieldsValuesDefinitions->fvd_id);
        }

        switch ($fldtyp) {
            case enumFieldType::ftText:
            case enumFieldType::ftNumeric:
            case enumFieldType::ftMemo:
            case enumFieldType::ftEmail:
            case enumFieldType::ftUrl:
            case enumFieldType::ftAlphaNumeric:
            case enumFieldType::ftSerial:
                if ($comptListFieldsValuesDefinitions == '0') {
                    $x = '';

                    if ($listFieldFilters->fft_pattern_begin[$i] != '') {
                        $x = $listFieldFilters->fft_pattern_begin[$i] . '%';
                    }

                    if ($listFieldFilters->fft_pattern_mid[$i] != '') {
                        if ($x == '') {
                            $x = '%';
                        }

                        $x .= $listFieldFilters->fft_pattern_mid[$i] . '%';
                    }

                    if ($listFieldFilters->fft_pattern_end[$i] != '') {
                        if ($x == '') {
                            $x = '%';
                        }

                        $x .= $listFieldFilters->fft_pattern_end[$i];
                    }

                    $conditions[] = "$dbfldnam LIKE '$x'";
                } else {
                    $pma = preg_split("/\n\r/", $listFieldFilters->fft_pattern_mid[$i]);
                    $conditions[] = "$dbfldnam IN ('" . implode("','", $pma) . "')";
                }

                break;
            case enumFieldType::ftDate:
            case enumFieldType::ftTimestamp:
                if ($listFieldFilters->fft_pattern_mid[$i] != '') {
                    $st = $listFieldFilters->fft_pattern_mid[$i];
                    $et = mktime(0, 0, 0, date('n', $st), date('j', $st)+1, date('Y', $st));
                    $conditions[] = "$dbfldnam>='$st' AND $dbfldnam<'$et'";
                } else {
                    if ($listFieldFilters->fft_pattern_begin[$i] != '') {
                        $conditions[] = "$dbfldnam>='" . $listFieldFilters->fft_pattern_begin[$i] . "'";
                    }

                    if ($listFieldFilters->fft_pattern_end[$i] != '') {
                        $conditions[] = "$dbfldnam<='" . $listFieldFilters->fft_pattern_end[$i] . "'";
                    }
                }

                break;
            case enumFieldType::ftTime:
            case enumFieldType::ftHours:
            case enumFieldType::ftRate:
            case enumFieldType::ftTotals:
            case enumFieldType::ftQuantity:
            case enumFieldType::ftMeasure:
            case enumFieldType::ftPercentage:
                if ($listFieldFilters->fft_pattern_mid[$i] != '') {
                    $conditions[] = "$dbfldnam='" . $listFieldFilters->fft_pattern_mid[$i] . "'";
                } else {
                    if ($listFieldFilters->fft_pattern_begin[$i] != '') {
                        $conditions[] = "$dbfldnam>='" . $listFieldFilters->fft_pattern_begin[$i] . "'";
                    }

                    if ($listFieldFilters->fft_pattern_end[$i] != '') {
                        $conditions[] = "$dbfldnam<='" . $listFieldFilters->fft_pattern_end[$i] . "'";
                    }
                }

                break;
            case enumFieldType::ftBoolean:
                $conditions[] = "$dbfldnam='" . $listFieldFilters->fft_pattern_mid[$i] . "'";
                break;
        }
    }

    if (count($conditions) > 0) {
        $tmpquery .= " WHERE " . implode(" AND ", $conditions);
    }
}

$tmpquery .= " ORDER BY id";
$recordsTotal = compt($tmpquery);
$rowsLimit = 20;
$listResults = new request();
$listResults->connectClass();
$listResults->query($tmpquery, $borne, $rowsLimit);
$listResults->columns['id'] = array();

while ($listResults->fetch()) {
    $i = 0;
    $listResults->columns['id'][] = ($row[$i++]);

    foreach ($listfields as $dbfldnam) {
        $listResults->columns[$dbfldnam][] = ($row[$i++]);
    }
}

$comptListResults = count($listResults->columns['id']);
$listResults->close();
/**
 * Html
 */
echo '<!DOCTYPE HTML>
<html>
<head>
<meta http-equiv="cache-control" content="no-cache,no-store">
<meta http-equiv="expires" content="0">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>' . $tbldispnam . ' ' . $strings['list'] . '</title>
<script type="text/javascript" src="../javascript/jquery-1.11.1.min.js"></script>
<link rel="stylesheet" href="../themes/' . THEME . '/stylesheet.css" type="text/css">
</head>
<body>
<div id="wrapper">
<div class="heading">
<h1>' . $tbldispnam . ' ' . lang_strings('list') . '</h1>
</div>
<div class="listing"><table><thead><tr>';

if ($inputtype == "checkbox") {
    echo '<th><input type="checkbox" name="checkAllAuto" id="checkAllAuto" value="0" onclick="selectall();"></th>';
} else {
    echo '<th>&nbsp;</th>';
}

$titles = array();
$listfields1 = explode('+', $tableDefinitionDetail->tdf_listfields[0]);

foreach ($listfields1 as $dbfldnam) {
    if (array_key_exists($dbfldnam, $reservedDbFields)) {
        $flddesc = $reservedDbFields[$dbfldnam];
    } else {
        $key = array_search($dbfldnam, $listFieldsDefinitions->fdf_dbfieldname);
        $flddesc = fieldNameString($tblnam, $listFieldsDefinitions->fdf_fieldname[$key]);
    }

    $titles[$dbfldnam] = $flddesc;
    echo '<th>' . $flddesc . ' <img src="../themes/' . THEME . '/filter_';

    if ($comptListFieldFilters > 0) {
        if (array_search($dbfldnam, $listFieldFilters->fft_dbfieldname) !== false) {
            echo 'on';
        } else {
            echo 'off';
        }
    } else {
        echo 'off';
    }

    echo '.gif" alt="' . $strings['filter_field'] . '" onclick="window.open(\'../includes/editfieldfilters.php?TBLNAM=' . $tblnam . '&FLDNAM=' . $dbfldnam . '\',\'_blank\',\'location=no,menubar=no,status=no,toolbar=no,width=800,height=600\')"></th>';
}

echo '</tr></thead><tbody>';

for ($i=0; $i<$comptListResults; $i++) {
    $id = $listResults->columns['id'][$i];
    echo '<tr><td data-title=""><input type="' . $inputtype . '" value="' . $id . '" ';

    if ($inputtype == 'radio') {
        echo 'name="radiogrp1" ';
    } else {
        echo 'onclick="uncheckselall(this);"';
    }

    echo '></td>';

    foreach ($listfields1 as $dbfldnam) {
        if (array_key_exists($dbfldnam, $reservedDbFields)) {
            if ($reservedDbFieldsDef['validvalues'][$dbfldnam] == '') {
                switch ($dbfldnam) {
                    case 'created':
                    case 'modified':
                        $fieldValue = createDate($listResults->columns[$dbfldnam][$i], 'both');
                        break;
                    case 'cuser':
                    case 'muser':
                        if ($listResults->columns[$dbfldnam][$i] == '0') {
                            $fieldValue = '';
                        } else {
                            $querymore3 = " WHERE mem.id='" . $listResults->columns[$dbfldnam][$i] . "'";
                            $memberDetail = new request();
                            $memberDetail->openMembers($querymore3);
                            $fieldValue = $block->buildLink($listResults->columns[$dbfldnam][$i], '', 'message');
                        }
                        break;
                    default:
                        $fieldValue = $listResults->columns[$dbfldnam][$i];
                }
            } else {
                $fieldValue = $reservedDbFieldsDef['validvalues'][$dbfldnam][$listResults->columns[$dbfldnam][$i]];
            }
        } else {
            $key = array_search($dbfldnam, $listFieldsDefinitions->fdf_dbfieldname);
            $fieldValue = setupFieldHTML($block = new block(), $listResults->columns[$dbfldnam][$i], $listFieldsDefinitions->fdf_fieldtype[$key], $listFieldsDefinitions->fdf_linkedtable[$key], $tblnam, $listFieldsDefinitions->fdf_fieldname[$key], false, $tableDefinitionDetail->tdf_viewurl[0]);
        }

        echo '<td data-title="' . $titles[$dbfldnam] . '">' . $fieldValue . '</td>';
    }

    echo '</tr>';
}

echo '</tbody></table>';

if ($rowsLimit < $recordsTotal) {
    echo '<div class="footerCell clear"><ul>';
    $nbpages = ceil($recordsTotal / $rowsLimit);

    for ($i=1, $j="0"; $i<=$nbpages; $i++, $j+=$rowsLimit) {
        if ($borne == $j) {
            echo '<li><div class="pageNumber-highlight">' . $i . '</div></li>';
        } else {
            echo "<li><a href=\"" . $_SERVER['PHP_SELF'] . "?TBLNAM=$tblnam&amp;ELEMID=$elemid&amp;MSEL=$msel&amp;borne=$j\"><div class=\"pageNumber\">$i</div></a></li>";
        }
    }

    echo '</ul></div>';
}

echo '<hr>
<input type="button" id="choose" value="' . $strings['choose'] . '" onClick="choose();">
<input type="button" id="cancel" value="' . $strings['cancel'] . '" onClick="window.close();">
</div>';

echo '
<script type="text/javascript">
if (window.opener == null) {
    $(\'.listing\').html(\'\');
    $(\'#choose\').attr(\'disabled\', true);
}

if (!window.opener.document.getElementById(\'' . $elemid . '\'))
    window.close();
var x = window.opener.document.getElementById(\'' . $elemid . '\').value;

if (x != "") {
    if ($("INPUT[type=\'checkbox\']").length == 0) {
        $(\'input:radio\').each(
            function(index) {
                if ($(this).val() == x)
                    $(this).attr(\'checked\', true);
            }
        );
    } else {
        var y = x.split(",");
        $(\'input:checkbox\').each(
            function(index) {
                if ($.inArray($(this).val(), y) != -1)
                    $(this).attr(\'checked\', true);
            }
        );
    }
}

function choose() {
    var x = window.opener.document.getElementById(\'' . $elemid . '\');

    if ($("INPUT[type=\'checkbox\']").length == 0) {
        var v = $(\'input:radio:checked\').map(function () { return this.value; }).get()
        x.value = v;
    } else {
        var va = $(\'input:checkbox:checked\').map(function () { return this.value; }).get();

        if (va.length > 0) {
            var y = va.indexOf("0");
            if (y != -1)
                va.splice(y, 1);
        }
        if (va.length == 0) {
            x.value = "";
        } else {
            x.value = va.join();
        }
    }

    window.close();
}

function selectall() {
    $("INPUT[type=\'checkbox\']").attr(\'checked\', $(\'#checkAllAuto\').is(\':checked\'));
}

function uncheckselall(obj) {
    if (obj.checked == false && $(\'#checkAllAuto\').is(\':checked\')) {
        $(\'#checkAllAuto\').attr(\'checked\', false);
    }
}
</script>
</body>
</html>
';
