<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: currency.inc.php,v 1.5 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$CurrencyMatrix = array(
    'active' => array('USD','EUR','GBP','JPY','CAD','AUD','CNY','CHF'),
    'name' => array(
        'USD' => $strings["CRCUSD"],
        'EUR' => $strings["CRCEUR"],
        'JPY' => $strings["CRCJPY"],
        'CNY' => $strings["CRCCNY"],
        'RUB' => $strings["CRCRUB"],
        'INR' => $strings["CRCINR"],
        'GBP' => $strings["CRCGBP"],
        'PLN' => $strings["CRCPLN"],
        'CAD' => $strings["CRCCAD"],
        'CHF' => $strings["CRCCHF"],
        'BRL' => $strings["CRCBRL"],
        'MXN' => $strings["CRCMXN"],
        'AUD' => $strings["CRCAUD"],
        'THB' => $strings["CRCTHB"],
        'TWD' => $strings["CRCTWD"],
        'IDR' => $strings["CRCIDR"],
        'KRW' => $strings["CRCKRW"],
        'UAH' => $strings["CRCUAH"],
        'SAR' => $strings["CRCSAR"],
        'HKD' => $strings["CRCHKD"],
        'NZD' => $strings["CRCNZD"],
        'CLP' => $strings["CRCCLP"],
        'DKK' => $strings["CRCDKK"],
        'ALL' => $strings["CRCALL"],
        'AFN' => $strings["CRCAFN"],
        'ARS' => $strings["CRCARS"],
        'AWG' => $strings["CRCAWG"],
        'AZN' => $strings["CRCAZN"],
        'BSD' => $strings["CRCBSD"],
        'BBD' => $strings["CRCBBD"],
        'BYR' => $strings["CRCBYR"],
        'BZD' => $strings["CRCBZD"],
        'BMD' => $strings["CRCBMD"],
        'BOB' => $strings["CRCBOB"],
        'BAM' => $strings["CRCBAM"],
        'BWP' => $strings["CRCBWP"],
        'BGN' => $strings["CRCBGN"],
        'BND' => $strings["CRCBND"],
        'KHR' => $strings["CRCKHR"],
        'KYD' => $strings["CRCKYD"],
        'COP' => $strings["CRCCOP"],
        'CRC' => $strings["CRCCRC"],
        'HRK' => $strings["CRCHRK"],
        'CUP' => $strings["CRCCUP"],
        'CZK' => $strings["CRCCZK"],
        'DOP' => $strings["CRCDOP"],
        'XCD' => $strings["CRCXCD"],
        'EGP' => $strings["CRCEGP"],
        'SVC' => $strings["CRCSVC"],
        'EEK' => $strings["CRCEEK"],
        'FKP' => $strings["CRCFKP"],
        'FJD' => $strings["CRCFJD"],
        'GHC' => $strings["CRCGHC"],
        'GIP' => $strings["CRCGIP"],
        'GTQ' => $strings["CRCGTQ"],
        'GGP' => $strings["CRCGGP"],
        'GYD' => $strings["CRCGYD"],
        'HNL' => $strings["CRCHNL"],
        'HUF' => $strings["CRCHUF"],
        'ISK' => $strings["CRCISK"],
        'IRR' => $strings["CRCIRR"],
        'IMP' => $strings["CRCIMP"],
        'ILS' => $strings["CRCILS"],
        'JMD' => $strings["CRCJMD"],
        'JEP' => $strings["CRCJEP"],
        'KZT' => $strings["CRCKZT"],
        'KPW' => $strings["CRCKPW"],
        'KGS' => $strings["CRCKGS"],
        'LAK' => $strings["CRCLAK"],
        'LVL' => $strings["CRCLVL"],
        'LBP' => $strings["CRCLBP"],
        'LRD' => $strings["CRCLRD"],
        'LTL' => $strings["CRCLTL"],
        'MKD' => $strings["CRCMKD"],
        'MYR' => $strings["CRCMYR"],
        'MUR' => $strings["CRCMUR"],
        'MNT' => $strings["CRCMNT"],
        'MZN' => $strings["CRCMZN"],
        'NAD' => $strings["CRCNAD"],
        'NPR' => $strings["CRCNPR"],
        'ANG' => $strings["CRCANG"],
        'NIO' => $strings["CRCNIO"],
        'NGN' => $strings["CRCNGN"],
        'NOK' => $strings["CRCNOK"],
        'OMR' => $strings["CRCOMR"],
        'PKR' => $strings["CRCPKR"],
        'PAB' => $strings["CRCPAB"],
        'PYG' => $strings["CRCPYG"],
        'PEN' => $strings["CRCPEN"],
        'PHP' => $strings["CRCPHP"],
        'QAR' => $strings["CRCQAR"],
        'RON' => $strings["CRCRON"],
        'SHP' => $strings["CRCSHP"],
        'RSD' => $strings["CRCRSD"],
        'SCR' => $strings["CRCSCR"],
        'SGD' => $strings["CRCSGD"],
        'SBD' => $strings["CRCSBD"],
        'SOS' => $strings["CRCSOS"],
        'ZAR' => $strings["CRCZAR"],
        'LKR' => $strings["CRCLKR"],
        'SEK' => $strings["CRCSEK"],
        'SRD' => $strings["CRCSRD"],
        'SYP' => $strings["CRCSYP"],
        'TTD' => $strings["CRCTTD"],
        'TRY' => $strings["CRCTRY"],
        'TRL' => $strings["CRCTRL"],
        'TVD' => $strings["CRCTVD"],
        'UYU' => $strings["CRCUYU"],
        'UZS' => $strings["CRCUZS"],
        'VEF' => $strings["CRCVEF"],
        'VND' => $strings["CRCVND"],
        'YER' => $strings["CRCYER"],
        'ZWD' => $strings["CRCZWD"]
    ),
    'symbol' => array(
        'ALL' => '&#76;&#101;&#107;',
        'AFN' => '&#1547;',
        'ARS' => '&#36;',
        'AWG' => '&#402;',
        'AUD' => '&#36;',
        'AZN' => '&#1084;&#1072;&#1085;',
        'BSD' => '&#36;',
        'BBD' => '&#36;',
        'BYR' => '&#112;&#46;',
        'BZD' => '&#66;&#90;&#36;',
        'BMD' => '&#36;',
        'BOB' => '&#36;&#98;',
        'BAM' => '&#75;&#77;',
        'BWP' => '&#80;',
        'BGN' => '&#1083;&#1074;',
        'BRL' => '&#82;&#36;',
        'BND' => '&#36;',
        'KHR' => '&#6107;',
        'CAD' => '&#36;',
        'KYD' => '&#36;',
        'CLP' => '&#36;',
        'CNY' => '&#20803;',
        'COP' => '&#36;',
        'CRC' => '&#8353;',
        'HRK' => '&#107;&#110;',
        'CUP' => '&#8369;',
        'CZK' => '&#75;&#269;',
        'DKK' => '&#107;&#114;',
        'DOP' => '&#82;&#68;&#36;',
        'XCD' => '&#36;',
        'EGP' => '&#163;',
        'SVC' => '&#36;',
        'EEK' => '&#107;&#114;',
        'EUR' => '&#8364;',
        'FKP' => '&#163;',
        'FJD' => '&#36;',
        'GHC' => '&#162;',
        'GIP' => '&#163;',
        'GTQ' => '&#81;',
        'GGP' => '&#163;',
        'GYD' => '&#36;',
        'HNL' => '&#76;',
        'HKD' => '&#72;&#75;&#36;',
        'HUF' => '&#70;&#116;',
        'ISK' => '&#107;&#114;',
        'INR' => '&#8360;',
        'IDR' => '&#82;&#112;',
        'IRR' => '&#65020;',
        'IMP' => '&#163;',
        'ILS' => '&#8362;',
        'JMD' => '&#74;&#36;',
        'JPY' => '&#165;',
        'JEP' => '&#163;',
        'KZT' => '&#1083;&#1074;',
        'KPW' => '&#8361;',
        'KRW' => '&#8361;',
        'KGS' => '&#1083;&#1074;',
        'LAK' => '&#8365;',
        'LVL' => '&#76;&#115;',
        'LBP' => '&#163;',
        'LRD' => '&#36;',
        'LTL' => '&#76;&#116;',
        'MKD' => '&#1076;&#1077;&#1085;',
        'MYR' => '&#82;&#77;',
        'MUR' => '&#8360;',
        'MXN' => '&#36;',
        'MNT' => '&#8366;',
        'MZN' => '&#77;&#84;',
        'NAD' => '&#36;',
        'NPR' => '&#8360;',
        'ANG' => '&#402;',
        'NZD' => '&#36;',
        'NIO' => '&#67;&#36;',
        'NGN' => '&#8358;',
        'NOK' => '&#107;&#114;',
        'OMR' => '&#65020;',
        'PKR' => '&#8360;',
        'PAB' => '&#66;&#47;&#46;',
        'PYG' => '&#71;&#115;',
        'PEN' => '&#83;&#47;&#46;',
        'PHP' => '&#80;&#104;&#112;',
        'PLN' => '&#122;&#322;',
        'QAR' => '&#65020;',
        'RON' => '&#108;&#101;&#105;',
        'RUB' => '&#1088;&#1091;&#1073;',
        'SHP' => '&#163;',
        'SAR' => '&#65020;',
        'RSD' => '&#1044;&#1080;&#1085;&#46;',
        'SCR' => '&#8360;',
        'SGD' => '&#36;',
        'SBD' => '&#36;',
        'SOS' => '&#83;',
        'ZAR' => '&#82;',
        'LKR' => '&#8360;',
        'SEK' => '&#107;&#114;',
        'CHF' => '&#67;&#72;&#70;',
        'SRD' => '&#36;',
        'SYP' => '&#163;',
        'TWD' => '&#78;&#84;&#36;',
        'THB' => '&#3647;',
        'TTD' => '&#84;&#84;&#36;',
        'TRY' => '&#89;&#84;&#76;',
        'TRL' => '&#8356;',
        'TVD' => '&#36;',
        'UAH' => '&#8372;',
        'GBP' => '&#163;',
        'USD' => '&#36;',
        'UYU' => '&#36;&#85;',
        'UZS' => '&#1083;&#1074;',
        'VEF' => '&#66;&#115;',
        'VND' => '&#8363;',
        'YER' => '&#65020;',
        'ZWD' => '&#90;&#36;'
    )
);
