<?php // $Revision: 1.27 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: defines.lib.php,v 1.27 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * DEFINES VARIABLES & CONSTANTS
 * Overview:
 *    WEBTAREAS_USR_OS               (string) - the plateform (os) of the user
 *    WEBTAREAS_USR_BROWSER_AGENT    (string) - the browser of the user
 *    WEBTAREAS_USR_BROWSER_VER      (double) - the version of this browser
 */
// Determines platform (OS), browser and version of the user
// Based on a phpBuilder article:
//   see http://www.phpbuilder.net/columns/tim20000821.php
if (!defined('WEBTAREAS_USR_OS')) {
    // loic1 - 2001/25/11: use the new globals arrays defined with
    // php 4.1+
    if (!empty($_SERVER['HTTP_USER_AGENT'])) {
        $HTTP_USER_AGENT = $_SERVER['HTTP_USER_AGENT'];
    } else if (!empty($HTTP_SERVER_VARS['HTTP_USER_AGENT'])) {
        $HTTP_USER_AGENT = $HTTP_SERVER_VARS['HTTP_USER_AGENT'];
    }
    // 1. Platform
    if (strstr($HTTP_USER_AGENT, 'Win')) {
        define('WEBTAREAS_USR_OS', 'Win');
    } else if (strstr($HTTP_USER_AGENT, 'Mac')) {
        define('WEBTAREAS_USR_OS', 'Mac');
    } else if (strstr($HTTP_USER_AGENT, 'Linux')) {
        define('WEBTAREAS_USR_OS', 'Linux');
    } else if (strstr($HTTP_USER_AGENT, 'Unix')) {
        define('WEBTAREAS_USR_OS', 'Unix');
    } else if (strstr($HTTP_USER_AGENT, 'OS/2')) {
        define('WEBTAREAS_USR_OS', 'OS/2');
    } else {
        define('WEBTAREAS_USR_OS', 'Other');
    }
    // 2. browser and version
    if (preg_match('/MSIE ([0-9].[0-9]{1,2})/', $HTTP_USER_AGENT, $log_version)) {
        define('WEBTAREAS_USR_BROWSER_VER', $log_version[1]);
        define('WEBTAREAS_USR_BROWSER_AGENT', 'IE');
    } else if (preg_match('#Opera(/| )([0-9].[0-9]{1,2})#', $HTTP_USER_AGENT, $log_version)) {
        define('WEBTAREAS_USR_BROWSER_VER', $log_version[2]);
        define('WEBTAREAS_USR_BROWSER_AGENT', 'OPERA');
    } else if (preg_match('|OmniWeb/([0-9].[0-9]{1,2})|', $HTTP_USER_AGENT, $log_version)) {
        define('WEBTAREAS_USR_BROWSER_VER', $log_version[1]);
        define('WEBTAREAS_USR_BROWSER_AGENT', 'OMNIWEB');
    } else if (preg_match('|Mozilla/([0-9].[0-9]{1,2})|', $HTTP_USER_AGENT, $log_version)) {
        define('WEBTAREAS_USR_BROWSER_VER', $log_version[1]);
        define('WEBTAREAS_USR_BROWSER_AGENT', 'MOZILLA');
    } else if (preg_match('|Konqueror/([0-9].[0-9]{1,2})|', $HTTP_USER_AGENT, $log_version)) {
        define('WEBTAREAS_USR_BROWSER_VER', $log_version[1]);
        define('WEBTAREAS_USR_BROWSER_AGENT', 'KONQUEROR');
    } else {
        define('WEBTAREAS_USR_BROWSER_VER', 0);
        define('WEBTAREAS_USR_BROWSER_AGENT', 'OTHER');
    }
}

abstract class enumStatus {
    const stClientCompleted = '0';
    const stCompleted = '1';
    const stNotStarted = '2';
    const stOpen = '3';
    const stSuspended = '4';
}

abstract class enumProjectStatus {
    const stInitiation = '1';
    const stCanceled = '2';
    const stPlanning = '3';
    const stOpen = '4';
    const stCompleted = '5';
    const stSuspended = '6';
}

abstract class enumMeetingStatus {
    const stScheduling = '0';
    const stScheduled = '2';
    const stOpen = '3';
    const stCompleted = '1';
    const stCanceled = '4';
}

abstract class enumPriority {
    const prNone = '0';
    const prVeryLow = '1';
    const prLow = '2';
    const prMedium = '3';
    const prHigh = '4';
    const prVeryHigh = '5';
}

abstract class enumPublished {
    const pbYes = '0';
    const pbNo = '1';
}

abstract class enumAuthorized {
    const auYes = '0';
    const auNo = '1';
}

abstract class enumFileStatus {
    const stApproved = '0';
    const stApprovedWithChanges = '1';
    const stNeedsApproval = '2';
    const stNoApprovalsNeeded = '3';
    const stNotApproved = '4';
}

abstract class enumFileVersionControl {
    const vcPeerReview = '0';
    const vcVersionUpdate = '3';
}

abstract class enumPhaseStatus {
    const stNotStarted = '0';
    const stOpen = '1';
    const stCompleted = '2';
    const stSuspended = '3';
}

abstract class enumRequestStatus {
    const stNew = '0';
    const stOpen = '1';
    const stCompleted = '2';
}

abstract class enumProjectType {
    const tyInternal = '0';
    const tyExternal = '1';
}

abstract class enumFixedDuration {
    const fdYes = '0';
    const fdNo = '1';
}

abstract class enumMilestone {
    const msYes = '0';
    const msNo = '1';
}

abstract class enumTaskGroup {
    const tgYes = '0';
    const tgNo = '1';
}

abstract class enumDayType {
    const dtWeekend = '0';
    const dtStatutoryHoliday = '1';
    const dtMakeupHoliday = '2';
    const dtWorkday = '3';
}

abstract class enumLeaveType {
    const lvAnnual = 10100;
    const lvSick = 10101;
    const lvAbsence = 10102;
    const lvBankHoliday = 10103;
    const lvMourning = 10104;
    const lvHoneyMoon = 10105;
    const lvMaternity = 10106;
}

abstract class enumWorkType {
    const wtNonSpecificTask = '0';
    const wtSpecificTask = '1';
    const wtSpecificMeeting = '2';
    const wtFlextimeAdjustment = '3';
}

abstract class enumSortingOrder {
    const oAscending = '0';
    const oDescending = '1';
}

abstract class enumPermissionLevel {
    const plRestrictedExceptLeader = '1';
    const plRestricted = '2';
    const plNoLimitsExceptObserver = '3';
    const plCustom = '9';
}

abstract class enumProjectProfile {
    const ppLeader = '1';
    const ppCoLeader = '2';
    const ppMember = '3';
    const ppObserver = '4';
    const ppGuest = '5';
}

abstract class enumBoolean {
    const bTrue = '1';
    const bFalse = '0';
}

abstract class enumRatio {
    const rGreaterThan = '1';
    const rGreaterOrEqual = '2';
    const rLessThan = '3';
    const rLessOrEqual = '4';
    const rEqual = '5';
    const rNotEqual = '6';
    const rInRange = '7';
    const rNotInRange = '8';
    const rContains = '9';
    const rBeginWith = '10';
    const rEndWith = '11';
}

abstract class enumAuthorizerType {
    const atUser = '1';
    const atProfile = '2';
    const atDepartmentTitle = '3';
    const atOrganizationTitle = '4';
    const atRole = '5';
}

abstract class enumProducerType {
    const ptUser = '1';
    const ptProfile = '2';
    const ptDepartment = '3';
    const ptTeam = '4';
}

abstract class enumApprovalStatus {
    const stPending = '1';
    const stApproved = '2';
    const stNotApproved = '3';
}

abstract class enumFileRelatedDocumentType {
    const dtProject = '1';
    const dtPhase = '2';
    const dtTask = '3';
    const dtMeeting = '4';
    const dtDiscussion = '5';
    const dtNote = '6';
    const dtExpense = '7';
    const dtSupportRequest = '8';
    const dtSupportPost = '9';
    const dtLeaveRequest = '10';
    const dtInvoice = '11';
    const dtPayment = '12';
    const dtForm = '99';
}

abstract class enumCostType {
    const ctLabor = 'L';
    const ctMaterial = 'M';
    const ctEquipment = 'E';
}

abstract class enumFieldType {
    const ftText = '0';                 // text
    const ftNumeric = '1';              // numeric
    const ftMemo = '2';                 // memo
    const ftDate = '3';                 // date
    const ftTime = '4';                 // time
    const ftHours = '5';                // hours
    const ftRate = '6';                 // rate
    const ftTotals = '7';               // totals
    const ftImage = '8';                // image
    const ftBoolean = '9';              // boolean
    const ftEmail = 'E';                // e-mail
    const ftUrl = 'U';                  // url
    const ftAlphaNumeric = 'A';         // alpha-numeric
    const ftTimestamp = 'T';            // unix time stamp
    const ftQuantity = 'Q';             // quantity
    const ftMeasure = 'M';              // measure
    const ftSerial = 'S';               // serial number
    const ftPercentage = 'P';           // percentage
    const ftAudio = 'D';                // audio
    const ftVideo = 'V';                // video
    const ftPassword = 'W';             // password
    const ftAvatar = 'AV';              // user avatar (special type, not in db)
}

abstract class enumFieldOption {
    const foPositiveNumber = '1';
    const foNonNegativeNumber = '2';
    const foVersionNumber = '3';
}

abstract class enumDisplayStyle {
    const dsMultipleRowsWithTitle = '1';
    const dsMultipleRowsWithoutTitle = '2';
    const dsMultipleColumnsWithTitle = '3';
    const dsMultipleColumnsWithoutTitle = '4';
}

abstract class enumTransactionEndType {
    const etCommit = '1';
    const etRollBack = '0';
}

abstract class enumResourceType {
    const rtUser = 'U';                 // project member
    const rtEquipment = 'E';            // equipment
    const rtMaterial = 'M';             // material
}

abstract class enumEquipmentStatus {
    const stAvailable = '0';            // available
    const stOccupied = '1';             // occupied
    const stBroken = '2';               // broken
    const stSold = '3';                 // sold
}

abstract class enumHourType {
    const htProject = '1';
    const htLeave = '2';
}

abstract class enumDocumentStatus {
    const stDraft = '0';                // document draft
    const stOpen = '1';                 // open document
    const stClosed = '2';               // closed document
}

abstract class enumCardviewOption {
    const oObject = '1';                // cardview object (required)
    const oTableName = '2';             // table name (required)
    const oColumns = '3';               // column definition (required)
    const oAddUrl = '4';                // add url (optional, default '')
    const oMultipleSelection = '5';     // multi-selection (boolean, default true)
    const oSearch = '6';                // search button (boolean, default false)
    const oImportUrl = '7';             // import url (optional, default '')
    const oExtraParameters = '8';       // extra parameters (optional, format key1=val1&key2=val2..., default '')
    const oExtensionActionPath = '9';   // extension action file path (optional, default '')
    const oTrimTrailEmptyCol = 'A';     // remove trailing empty columns (optional, default false)
}

abstract class enumCalendarTarget {
    const tUser = '1';                  // user
    const tOrganization = '2';          // organization
    const tDepartment = '3';            // department
    const tProject = '4';               // project
    const tUserProfile = '5';           // user profile
}
