<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editfieldfilters.php,v 1.3 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$tblnam = AddSlashesNOD(isset($_GET['TBLNAM'])?$_GET['TBLNAM']:'');    // table name
$dbfldnam = AddSlashesNOD(isset($_GET['FLDNAM'])?$_GET['FLDNAM']:'');  // db field name
$action = isset($_POST['action'])?$_POST['action']:'';
$pb = isset($_POST['pb'])?$_POST['pb']:'';       // pattern begin
$pm = isset($_POST['pm'])?$_POST['pm']:'';       // pattern middle
$pe = isset($_POST['pe'])?$_POST['pe']:'';       // pattern end
$rg1 = isset($_POST['rg1'])?$_POST['rg1']:'';    // `equals to` or `in range`
$pmc = isset($_POST['pmc'])?$_POST['pmc']:'';    // num. of field valid values
$back2ChooseList = false;
$tbldispnam = tableNameString($tblnam);

if (substr($tblnam,0,1)=='@') {
    $tbldispnam .= ' (' . lang_strings('form') . ')';
}

/**
 * Permission check
 */
// table definition
$querymore0 = " WHERE tdf.tablename='$tblnam'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore0);

if (count($tableDefinitionDetail->tdf_tablename) == 0) {
    exit;
}

// field definitions
$querymore1 = " WHERE fdf.tablename='$tblnam'";
$listFieldsDefinitions = new request();
$listFieldsDefinitions->openFieldsDefinitions($querymore1);

if (count($listFieldsDefinitions->fdf_tablename) == 0) {
    exit;
}

if (array_key_exists($dbfldnam, $reservedDbFields)) {
    $fldtyp = $reservedDbFieldsDef['type'][$dbfldnam];
    $fldlen = $reservedDbFieldsDef['length'][$dbfldnam];
    $flddesc = $reservedDbFields[$dbfldnam];
    $fldvv = $reservedDbFieldsDef['validvalues'][$dbfldnam];
} else {
    $key = array_search($dbfldnam, $listFieldsDefinitions->fdf_dbfieldname);
    $fldnam = $listFieldsDefinitions->fdf_fieldname[$key];
    $fldtyp = $listFieldsDefinitions->fdf_fieldtype[$key];
    $fldlen = $listFieldsDefinitions->fdf_length[$key];
    $flddesc = fieldNameString($tblnam, $listFieldsDefinitions->fdf_fieldname[$key]);
    // field valid values definitions
    $querymore2 = " WHERE fvd.tablename='$tblnam' AND fvd.fieldname='$fldnam'";
    $listFieldsValuesDefinitions = new request();
    $listFieldsValuesDefinitions->openFieldsValuesDefinitions($querymore2);
    $comptListFieldsValuesDefinitions = count($listFieldsValuesDefinitions->fvd_id);

    if ($comptListFieldsValuesDefinitions == '0') {
        $fldvv = '';
    } else {
        $fldvv = array();

        for ($i=0; $i<$comptListFieldsValuesDefinitions; $i++) {
            $fldvv[$listFieldsValuesDefinitions->fvd_fieldvalue[$i]] = $listFieldsValuesDefinitions->fvd_fieldvalue_desc[$i];
        }
    }
}

/**
 * Action
 */
if ($action == 'update') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($pmc == '') {
            switch ($fldtyp) {
                case enumFieldType::ftText:
                case enumFieldType::ftNumeric:
                case enumFieldType::ftMemo:
                case enumFieldType::ftEmail:
                case enumFieldType::ftUrl:
                case enumFieldType::ftAlphaNumeric:
                case enumFieldType::ftSerial:
                    if ($pb == '' && $pm == '' && $pe == '') {
                        $tmpsql = "DELETE FROM " . $tablePrefix . "field_filters WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    } else {
                        $pb = DbValueEncode($fldtyp, $pb);
                        $pm = DbValueEncode($fldtyp, $pm);
                        $pe = DbValueEncode($fldtyp, $pe);
                        $tmpquery = "SELECT member FROM " . $tablePrefix . "field_filters WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";
                        $requestAct->query($tmpquery);

                        if ($requestAct->rowCount() == '0') {
                            $tmpsql = "INSERT INTO " . $tablePrefix . "field_filters (member,tablename,dbfieldname,pattern_begin,pattern_mid,pattern_end) VALUES ('$idSession','$tblnam','$dbfldnam','$pb','$pm','$pe')";
                        } else {
                            $tmpsql = "UPDATE " . $tablePrefix . "field_filters SET pattern_begin='$pb',pattern_mid='$pm',pattern_end='$pe' WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";
                        }

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }

                    break;
                case enumFieldType::ftHours:
                case enumFieldType::ftRate:
                case enumFieldType::ftTotals:
                case enumFieldType::ftQuantity:
                case enumFieldType::ftMeasure:
                case enumFieldType::ftDate:
                case enumFieldType::ftTimestamp:
                case enumFieldType::ftTime:
                case enumFieldType::ftPercentage:
                    if ($rg1 == enumRatio::rEqual) {
                        if ($pm == '') {
                            $tmpsql = "DELETE FROM " . $tablePrefix . "field_filters WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }
                        } else {
                            $pm = DbValueEncode($fldtyp, $pm);
                            $tmpquery = "SELECT member FROM " . $tablePrefix . "field_filters WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";
                            $requestAct->query($tmpquery);

                            if ($requestAct->rowCount() == '0') {
                                $tmpsql = "INSERT INTO " . $tablePrefix . "field_filters (member,tablename,dbfieldname,pattern_begin,pattern_mid,pattern_end) VALUES ('$idSession','$tblnam','$dbfldnam','','$pm','')";
                            } else {
                                $tmpsql = "UPDATE " . $tablePrefix . "field_filters SET pattern_begin='',pattern_mid='$pm',pattern_end='' WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";
                            }

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }
                        }
                    } else {
                        if ($pb == '' && $pe == '') {
                            $tmpsql = "DELETE FROM " . $tablePrefix . "field_filters WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }
                        } else {
                            $pb = DbValueEncode($fldtyp, $pb);
                            $pe = DbValueEncode($fldtyp, $pe);

                            if (($fldtyp == enumFieldType::ftDate || $fldtyp == enumFieldType::ftTimestamp) && $pb == '0') {
                                $pb = '';
                            }

                            if (($fldtyp == enumFieldType::ftDate || $fldtyp == enumFieldType::ftTimestamp) && $pe == '0') {
                                $pe = '';
                            } else {
                                $pe = mktime(0, 0, -1, date('n', $pe), date('j', $pe)+1, date('Y', $pe));
                            }

                            $tmpquery = "SELECT member FROM " . $tablePrefix . "field_filters WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";
                            $requestAct->query($tmpquery);

                            if ($requestAct->rowCount() == '0') {
                                $tmpsql = "INSERT INTO " . $tablePrefix . "field_filters (member,tablename,dbfieldname,pattern_begin,pattern_mid,pattern_end) VALUES ('$idSession','$tblnam','$dbfldnam','$pb','','$pe')";
                            } else {
                                $tmpsql = "UPDATE " . $tablePrefix . "field_filters SET pattern_begin='$pb',pattern_mid='',pattern_end='$pe' WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";
                            }

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }
                        }
                    }

                    break;
                case enumFieldType::ftBoolean:
                    if ($pm == '') {
                        $tmpsql = "DELETE FROM " . $tablePrefix . "field_filters WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    } else {
                        $tmpquery = "SELECT member FROM " . $tablePrefix . "field_filters WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";
                        $requestAct->query($tmpquery);

                        if ($requestAct->rowCount() == '0') {
                            $tmpsql = "INSERT INTO " . $tablePrefix . "field_filters (member,tablename,dbfieldname,pattern_begin,pattern_mid,pattern_end) VALUES ('$idSession','$tblnam','$dbfldnam','','$pm','')";
                        } else {
                            $tmpsql = "UPDATE " . $tablePrefix . "field_filters SET pattern_begin='',pattern_mid='$pm',pattern_end='' WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";
                        }

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }

                    break;
            }
        } else {
            $xa = array();

            for ($i=0; $i<$pmc; $i++) {
                $x = isset($_POST['pma' . $i])?$_POST['pma' . $i]:'';

                if ($x != '') {
                    $xa[] = $x;
                }
            }

            if (count($xa) == '0') {
                $tmpsql = "DELETE FROM " . $tablePrefix . "field_filters WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            } else {
                $pm = implode("\n\r", $xa);
                $tmpquery = "SELECT member FROM " . $tablePrefix . "field_filters WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";
                $requestAct->query($tmpquery);

                if ($requestAct->rowCount() == '0') {
                    $tmpsql = "INSERT INTO " . $tablePrefix . "field_filters (member,tablename,dbfieldname,pattern_begin,pattern_mid,pattern_end) VALUES ('$idSession','$tblnam','$dbfldnam','','$pm','')";
                } else {
                    $tmpsql = "UPDATE " . $tablePrefix . "field_filters SET pattern_begin='',pattern_mid='$pm',pattern_end='' WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";
                }

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        $back2ChooseList = true;
    }
} else if ($action == 'clear') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "DELETE FROM " . $tablePrefix . "field_filters WHERE member='$idSession' AND tablename='$tblnam' AND dbfieldname='$dbfldnam'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        $back2ChooseList = true;
    }
}

/**
 * Prepare data
 */
if ($error == '' && $action == '') {
    // user field filters
    $querymore = " WHERE fft.member='$idSession' AND fft.tablename='$tblnam' AND fft.dbfieldname='$dbfldnam'";
    $fieldFiltersDetail = new request();
    $fieldFiltersDetail->openFieldFilters($querymore);
    $comptFieldFiltersDetail = count($fieldFiltersDetail->fft_tablename);
    $pma = array();

    if ($comptFieldFiltersDetail > 0) {
        $pb = $fieldFiltersDetail->fft_pattern_begin[0];
        $pm = $fieldFiltersDetail->fft_pattern_mid[0];
        $pe = $fieldFiltersDetail->fft_pattern_end[0];
        $rg1 = (($pm=='')?enumRatio::rInRange:enumRatio::rEqual);

        if ($pm != '' && $fldvv != '' && count($fldvv) > 0) {
            $pma = preg_split("/\n\r/", $pm);
        }
    }
}

/**
 * Html
 */
echo '<!DOCTYPE HTML>
<html>
<head>
<meta http-equiv="cache-control" content="no-cache,no-store">
<meta http-equiv="expires" content="0">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>' . $strings['filter_field'] . '</title>
<script type="text/javascript" src="../javascript/general.js"></script>
<script type="text/JavaScript" src="../javascript/calendar.js"></script>
<script type="text/JavaScript" src="../javascript/lang/calendar-' . $lang . '.js"></script>
<script type="text/JavaScript" src="../javascript/calendar-setup.js"></script>
<script type="text/javascript" src="../javascript/jquery-1.11.1.min.js"></script>
<script type="text/javascript" src="../javascript/form-control.js"></script>
<link rel="stylesheet" href="../themes/' . THEME . '/stylesheet.css" type="text/css">
<link rel="stylesheet" href="../themes/' . THEME . '/calendar.css" type="text/css">
</head>
<body class="logged">';

if (isset($error) && $error !== '') {
    echo '<div id="wtMsgBox"><div class="errorMsg"><b>' . $strings['errors'] . '</b> ' . $error . '</div></div>';
}

echo '
<div id="wrapper">
';

if ($back2ChooseList) {
    echo '
<script type="text/javascript">
window.opener.location.reload(true);
window.close();
</script>
';
} else {
    $block1 = new block();
    $block1->form = "sff";
    $block1->openForm("../includes/editfieldfilters.php?TBLNAM=$tblnam&FLDNAM=$dbfldnam#" . $block1->form . 'Anchor');
    $block1->heading(lang_strings('filter_field') . ' : ' . $tbldispnam . ' . ' . $flddesc);
    echo '<input type="hidden" name="action" value="update">';
    $block1->openContent();

    if ($fldvv == '') {
        switch ($fldtyp) {
            case enumFieldType::ftText:
            case enumFieldType::ftNumeric:
            case enumFieldType::ftAlphaNumeric:
                setupInputHTML($block1, lang_strings('begin_with'), 'pb', $fldtyp, 'N', $fldlen,  $pb);
                setupInputHTML($block1, lang_strings('contains'), 'pm', $fldtyp, 'N', $fldlen,  $pm);
                setupInputHTML($block1, lang_strings('end_with'), 'pe', $fldtyp, 'N', $fldlen,  $pe);
                break;
            case enumFieldType::ftMemo:
            case enumFieldType::ftEmail:
            case enumFieldType::ftUrl:
                setupInputHTML($block1, lang_strings('begin_with'), 'pb', enumFieldType::ftText, 'N', '255',  $pb);
                setupInputHTML($block1, lang_strings('contains'), 'pm', enumFieldType::ftText, 'N', '255',  $pm);
                setupInputHTML($block1, lang_strings('end_with'), 'pe', enumFieldType::ftText, 'N', '255',  $pe);
                break;
            case enumFieldType::ftSerial:
                setupInputHTML($block1, lang_strings('begin_with'), 'pb', enumFieldType::ftNumeric, 'N', $fldlen,  $pb);
                setupInputHTML($block1, lang_strings('contains'), 'pm', enumFieldType::ftNumeric, 'N', $fldlen,  $pm);
                setupInputHTML($block1, lang_strings('end_with'), 'pe', enumFieldType::ftNumeric, 'N', $fldlen,  $pe);
                break;
            case enumFieldType::ftHours:
            case enumFieldType::ftRate:
            case enumFieldType::ftTotals:
            case enumFieldType::ftQuantity:
            case enumFieldType::ftMeasure:
            case enumFieldType::ftDate:
            case enumFieldType::ftTimestamp:
            case enumFieldType::ftTime:
            case enumFieldType::ftPercentage:
                echo '<tr><th colspan="2"><input type="radio" name="rg1" value="' . enumRatio::rEqual . '"' . (($rg1==enumRatio::rEqual)?' checked':'') . '>' . lang_strings('equal') . '</th></tr>';
                setupInputHTML($block1, '', 'pm', $fldtyp, 'N', '',  $pm);
                echo '<tr><th colspan="2">&nbsp;</th></tr>';
                echo '<tr><th colspan="2"><input type="radio" name="rg1" value="' . enumRatio::rInRange. '"' . (($rg1!=enumRatio::rEqual)?' checked':'') . '>' . lang_strings('in_range') . '</th></tr>';
                setupInputHTML($block1, lang_strings('from'), 'pb', $fldtyp, 'N', '',  $pb);
                setupInputHTML($block1, lang_strings('to'), 'pe', $fldtyp, 'N', '',  $pe);
                break;
            case enumFieldType::ftBoolean:
                echo '<tr><th colspan="2"><input type="radio" name="pm" value="' . enumBoolean::bTrue . '"' . (($pm==enumBoolean::bTrue)?' checked':'') . '>' . lang_strings('true') . '</th></tr>';
                echo '<tr><th colspan="2"><input type="radio" name="pm" value="' . enumBoolean::bFalse . '"' . (($pm!=enumBoolean::bTrue)?' checked':'') . '>' . lang_strings('false') . '</th></tr>';
                break;
        }
    } else {
        echo '<input type="hidden" name="pmc" value="' . count($fldvv) . '">';
        $i = 0;

        foreach ($fldvv as $val => $desc) {
            $block1->contentRow('<input type="checkbox" value="' . $val . '" name="pma' . $i . '"' . ((in_array($val, $pma))?' checked':'') . '>', $desc);
        }
    }

    $block1->contentRow('
    <input type="SUBMIT" value="' . $strings['save'] . '">
    <input type="button" id="cancel" value="' . $strings['cancel'] . '" onClick="window.close();">
' . (($comptFieldFiltersDetail=='0')?'':'<input type="button" id="clear" value="' . $strings['clear'] . '" onClick="document.sffForm.action.value=\'clear\';document.sffForm.submit();">')
    );
    $block1->closeContent();
    $block1->closeForm();

}

echo '
</body>
</html>
';
