<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: general_serv.php,v 1.3 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
// check if the request is an AJAX request
if (!is_ajax()) {
    exit;
}

/**
 * Variables init
 */
$action = AddSlashesNOD(isset($_POST['action'])?$_POST['action']:'');   // action

if ($action == '') {
    exit;
}

switch ($action) {
    case 'menu-palette-list':
        $path_prefix = AddSlashesNOD(isset($_POST['prefix'])?$_POST['prefix']:'');
        $content = '';
        $paletteDir = opendir('../themes/menu');

        while ($paletteFile = readdir($paletteDir)) {
            if (preg_match('/\.css$/i', $paletteFile) && !preg_match('/\.min\.css$/i', $paletteFile)) {
                preg_match('/(.+)\.css$/i', $paletteFile, $pa);
                $png = '../themes/menu/' . $pa[1] . '.png';

                if (file_exists($png)) {
                    $png = $path_prefix . 'themes/menu/' . $pa[1] . '.png';
                    $content .= '<li><img data-palette="' . $pa[1] . '" src="' . $png . '"></li>';
                }
            }
        }

        closedir($paletteDir);
        header("content-type:application/json");
        echo json_encode(array(
            'content' => $content
        ));
        break;
    case 'set-menu-palette':
        $href = '';
        $path_prefix = AddSlashesNOD(isset($_POST['prefix'])?$_POST['prefix']:'');
        $palette = AddSlashesNOD(isset($_POST['palette'])?$_POST['palette']:'');
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "members SET palette='$palette',modified='" . time() . "',muser='$idSession' WHERE id='$idSession'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $_SESSION['paletteSession'] = $palette;
            $href = verSource('themes/menu/' . $palette . $scriptMinimized . '.css');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
            $href = '';
        }

        header("content-type:application/json");
        echo json_encode(array(
            'href' => $href,
            'error' => $error
        ));
        break;
    case 'quicklinks':
        // get recently visited webpages
        $recentlyVisitTitle = array();
        $recentlyVisitURL = array();
        $tmpquery2 = "SELECT boo.title,boo.url FROM " . $tablePrefix . "bookmarks boo WHERE boo.cuser='$idSession' ORDER BY boo.created DESC";
        $request2 = new request();
        $request2->connectClass();
        $request2->query($tmpquery2);

        while ($request2->fetch() && count($recentlyVisitURL)<10) {
            $url = HtmlEntityDecodeNOD($row[1]);

            if (!in_array($url, $recentlyVisitURL)) {
                $recentlyVisitTitle[] = HtmlEntityDecodeNOD($row[0]);
                $recentlyVisitURL[] = $url;
            }
        }

        $request2->close();
        // get most visited webpages
        $mostVisitTitle = array();
        $mostVisitURL = array();
        $tmpquery3 = "SELECT t0.title,t0.url FROM (SELECT boo.title,boo.url,COUNT(boo.cuser) AS cnt1 FROM " . $tablePrefix . "bookmarks boo WHERE boo.cuser='$idSession' GROUP BY boo.title,boo.url) t0 ORDER BY t0.cnt1 DESC";
        $request3 = new request();
        $request3->connectClass();
        $request3->query($tmpquery3, 0, 10);

        while ($request3->fetch()) {
            $mostVisitTitle[] = HtmlEntityDecodeNOD($row[0]);
            $mostVisitURL[] = HtmlEntityDecodeNOD($row[1]);
        }

        $request3->close();
        $recentlyVisitCount = count($recentlyVisitURL)+count($mostVisitURL);
        $content = '<img src="' . verSource('themes/' . THEME . '/btn_quicklinks.png') . '">';

        if ($recentlyVisitCount > 0) {
            $content .= '<ul id="wtRecentlyVisit">';

            if (count($recentlyVisitURL) > 0) {
                $content .= '<li class="ql-title">' . $strings['recently_visit'] . '</li>';

                for ($i=0; $i<count($recentlyVisitURL); $i++) {
                    $content .= '<li class="ql-content"><a href="' . $recentlyVisitURL[$i] . '">' . $recentlyVisitTitle[$i] . '</a></li>';
                }
            }

            $content .= '</ul>';       // end of wtRecentlyVisit
            $content .= '<ul id="wtMostVisit">';

            if (count($mostVisitURL) > 0) {
                $content .= '<li class="ql-title">' . $strings['most_visit'] . '</li>';

                for ($i=0; $i<count($mostVisitURL); $i++) {
                    $content .= '<li class="ql-content"><a href="' . $mostVisitURL[$i] . '">' . $mostVisitTitle[$i] . '</a></li>';
                }
            }

            $content .= '</ul>';   // end of wtMostVisit
        }

        header("content-type:application/json");
        echo json_encode(array(
            'content' => $content
        ));
        break;
    case 'navigation-items':
        $path_prefix = AddSlashesNOD(isset($_POST['prefix'])?$_POST['prefix']:'');
        $content = '';

        if ($orgSession > 1) {
            // login as a client user
            if ($siteOff != 'true') {
                $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "service_site/home.php?" . '">' . $strings["home"] . '</a></li>';
                // client project
                $tmpquery4 = "SELECT tea.member FROM " . $tablePrefix . "teams tea INNER JOIN " . $tablePrefix . "projects pro ON pro.id=tea.project WHERE tea.member='$idSession' AND pro.status IN ('" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "') AND pro.published='" . enumPublished::pbYes . "'";

                if (compt($tmpquery4) > 0) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "service_site/myprojects.php?topPage=true" . '">' . $strings["my_projects"] . '</a></li>';
                }

                // client form list
                $querymore1 = " LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.organization=ogf.organization WHERE mem.id='$idSession' ORDER BY ogf.tablename";
                $listOrganizationForms = new request();
                $listOrganizationForms->openOrganizationForms($querymore1);

                if (count($listOrganizationForms->ogf_tablename) > 0) {
                    foreach ($listOrganizationForms->ogf_tablename as $tblnam) {
                        $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "service_site/myforms.php?updateDocument=true&tblnam=" . $tblnam . '">' . $strings['form'] . ' : ' . tableNameString($tblnam) . '</a></li>';
                    }
                }

                // Extensions
                $extItems = setupExtensionNavigationItems();

                foreach ($extItems as $x) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . $x['url'] . '">' . $x['label'] . '</a></li>';
                }
            }
        } else {
            if ($siteOff != 'true') {
                // Home Page
                $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "general/home.php?" . '">' . $strings["home"] . '</a></li>';
                // Projects
                if ($SW_Permissions['Project']['Read'][$profilSession]) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "projects/listprojects.php?" . '">' . $strings["projects"] . '</a></li>';
                }
                // Documents
                if (($fileManagement == 'true') && ($SW_Permissions['File']['Read'][$profilSession])) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "linkedcontent/listfiles.php?doc_type=0&id=0" . '">' . $strings["documents"] . '</a></li>';
                }
                // Forms
                $formItems = setupFormNavigationItems();

                foreach ($formItems as $x) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . $x['url'] . '">' . $x['label'] . '</a></li>';
                }
                // Extensions
                $extItems = setupExtensionNavigationItems();

                foreach ($extItems as $x) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . $x['url'] . '">' . $x['label'] . '</a></li>';
                }
                // Invoices
                if ($SW_Permissions['Invoice']['Read'][$profilSession]) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "invoices/listinvoices.php" . '">' . $strings["invoices"] . '</a></li>';
                }
                // Payments
                if ($SW_Permissions['Payment']['Read'][$profilSession]) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "payments/listpayments.php" . '">' . $strings["payments"] . '</a></li>';
                }
                // Expenses
                if ($SW_Permissions['Expense']['Read'][$profilSession]) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "expenses/listexpenses.php" . '">' . $strings["expenses"] . '</a></li>';
                }
                // Reports
                if ($SW_Permissions['Report']['Read'][$profilSession]) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . 'reports/listreports.php?cat=1' . '">' . $strings['reports'] . '</a></li>';
                }
                // Contacts
                if ($SW_Permissions['Contact']['Read'][$profilSession]) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "contacts/listcontacts.php?" . '">' . $strings["contacts"] . '</a></li>';
                }
                // Timesheet
                if ($enableTimesheet == 'true') {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "timesheet/viewtimesheet.php?" . '">' . $strings["timesheet"] . '</a></li>';
                }
                // Calendar
                if ($SW_Permissions['Calendar']['Read'][$profilSession]) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "calendar/viewcalendar.php?" . '">' . $strings["calendar"] . '</a></li>';
                }
                // Clients
                if ($SW_Permissions['Client']['Read'][$profilSession]) {
                    $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "clients/listclients.php?" . '">' . $strings["clients"] . '</a></li>';
                }
            }

            if (showAdminMainMenu()) {
                // Administration
                $content .= '<li class="menu-scheme"><a href="' . $path_prefix . "administration/admin.php?" . '">' . $strings["admin"] . '</a></li>';
            }
        }

        if ($installationType == 'online') {
            $content .= '<li><script async src="//pagead2.googlesyndication.com/pagead/js/adsbygoogle.js"></script>
<!-- nav-ads -->
<ins class="adsbygoogle"
     style="display:inline-block;width:320px;height:100px"
     data-ad-client="ca-pub-4132962408335037"
     data-ad-slot="1327508529"></ins>
<script>
(adsbygoogle = window.adsbygoogle || []).push({});
</script></li>';
        }

        header("content-type:application/json");
        echo json_encode(array(
            'content' => $content
        ));
        break;
    case 'file-actions':
        $path_prefix = isset($_POST['prefix'])?$_POST['prefix']:'';   // path prefix
        $params = isset($_POST['params'])?$_POST['params']:'';   // parameters
        $default_action = isset($_POST['defact'])?$_POST['defact']:'';
        list($doc_type, $doc_type_ex, $doc_id, $id, $idl, $info_icon) = explode(',', $params);
        $content = '';      // popup item actions
        $newurl = '';       // open new window

        if ($default_action == 'Y') {
            $newurl = $root . '/linkedcontent/accessfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&mode=view&id=' . $id;
        } else {
            $content = '<a href="' . $path_prefix . 'linkedcontent/accessfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&mode=view&id=' . $idl . '" target="_blank">';
            $content .= '<img src="' . verSource('themes/' . THEME . '/btn_open.png') . '">';
            $content .= '<label>' . $strings['view'] . '</label>';
            $content .= '</a>';
            $content .= '<a href="' . $path_prefix . 'linkedcontent/accessfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&mode=download&id=' . $idl . '" target="_blank">';
            $content .= '<img src="' . verSource('themes/' . THEME . '/btn_download.png') . '">';
            $content .= '<label>' . $strings['save'] . '</label>';
            $content .= '</a>';

            if ($info_icon == '1') {
                $content .= '<a href="' . $path_prefix . 'linkedcontent/viewfile.php?doc_type=' . $doc_type . '&doc_type_ex=' . $doc_type_ex . '&doc_id=' . $doc_id . '&id=' . $id . '">';
                $content .= '<img src="' . verSource('themes/' . THEME . '/btn_info.png') . '">';
                $content .= '<label>' . $strings['info'] . '</label>';
                $content .= '</a>';        // end of wtFileInfo
            }
        }

        header("content-type:application/json");
        echo json_encode(array(
            'content' => $content,
            'newurl' => $newurl
        ));
        break;
    case 'cardview-actions':
        $path_prefix = isset($_POST['prefix'])?$_POST['prefix']:''; // path prefix
        $object = isset($_POST['object'])?$_POST['object']:'';      // cardview object
        $tblnam = isset($_POST['tblnam'])?$_POST['tblnam']:'';      // table name
        $extra = isset($_POST['extra'])?$_POST['extra']:'';         // extra parameters
        $extpath = isset($_POST['extpath'])?$_POST['extpath']:'';   // extension action file path
        $id = isset($_POST['id'])?$_POST['id']:'';
        $default_action = isset($_POST['defact'])?$_POST['defact']:'';
        $content = '';      // popup item actions
        $url = '';          // redirect url
        $newurl = '';       // open new window
        $urlBornes = '';

        if ($extra != '') {
            foreach (explode('&', $extra) as $pair) {
                if (preg_match('/\S+=.*/', $pair)!=1) { continue; }
                list($key, $val) = explode('=', $pair);
                
                if (preg_match('/^borne/', $key)) {
                    $urlBornes .= '&' . $key . '=' . $val;
                } else {
                    $$key = urldecode($val);
                }
            }
        }

        if (@file_exists('../includes/cardview-actions/' . $object . '.php')) {
            require '../includes/cardview-actions/' . $object . '.php';
        } elseif ($extpath !== '') {
            $file1 = '../extensions/' . urldecode($extpath);

            if (@file_exists($file1)) {
                require $file1;
            }
        }

        header("content-type:application/json");
        echo json_encode(array(
            'content' => $content,
            'url' => $url,
            'newurl' => $newurl
        ));
        break;
}
