<?php // $Revision: 1.71 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: initrequests.php,v 1.71 2013/02/19 14:15:27 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$initrequest["contacts"] = "SELECT con.*,concat($contactNameFormat),org.name,mem.login,mem.name,mem.email_work,mem1.login,mem1.name,mem1.email_work "
    . "FROM " . $tablePrefix . "contacts con "
    . "LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=con.organization "
    . "LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=con.cuser "
    . "LEFT OUTER JOIN " . $tablePrefix . "members mem1 ON mem1.id=con.muser ";

$initrequest["sorting"] = "SELECT sor.*
FROM " . $tablePrefix . "sorting sor
";

$initrequest["services"] = "SELECT serv.id, serv.name, serv.hourly_rate, serv.hourly_rate_i, serv.currency, serv.locked, serv.created, serv.cuser, serv.modified, serv.muser
FROM " . $tablePrefix . "services serv
";

$initrequest["material_issue"] = "SELECT iss.id,iss.project,iss.task,iss.owner,iss.material,iss.date,iss.quantity,iss.created,iss.cuser,iss.modified,iss.muser,mat.name,mat.unit,mem.name
FROM " . $tablePrefix . "material_issue iss
LEFT OUTER JOIN " . $tablePrefix . "materials mat ON mat.id=iss.material
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=iss.owner
";

$initrequest["materials"] = "SELECT mat.id, mat.name, mat.unit, mat.currency, mat.costrate, mat.locked, mat.created, mat.cuser, mat.modified, mat.muser
FROM " . $tablePrefix . "materials mat
";

$initrequest["services1"] = "SELECT serv.id, serv.name, serv.hourly_rate, serv.hourly_rate_i, serv.currency, serv.created, serv.cuser, serv.modified, serv.muser,(SELECT SUM(tim.hours) FROM " . $tablePrefix . "tasks_time tim WHERE tim.date>='%DATEFROM%' AND tim.date<'%DATETO%' AND tim.service=serv.id) as thours,(SELECT SUM(wkh.hours) FROM " . $tablePrefix . "work_hours wkh WHERE wkh.date>='%DATEFROM%' AND wkh.date<'%DATETO%' AND wkh.service=serv.id) as whours
FROM " . $tablePrefix . "services serv
";

$initrequest["calendars"] = "SELECT cal.owner,cal.target,cal.target_id,(CASE cal.target WHEN '1' THEN mem.name WHEN '2' THEN org.name WHEN '3' THEN dep.name WHEN '4' THEN pro.name WHEN '5' THEN upf.name ELSE '' END) AS target_name
FROM " . $tablePrefix . "calendars cal
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = cal.target_id
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = cal.target_id
LEFT OUTER JOIN " . $tablePrefix . "departments dep ON dep.id = cal.target_id
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = cal.target_id
LEFT OUTER JOIN " . $tablePrefix . "user_profiles upf ON upf.id = cal.target_id
";

$initrequest["calendar_events"] = "SELECT cae.id,cae.target,cae.target_id,cae.subject,cae.description,cae.time_start,cae.time_end,cae.reminder_time1,cae.reminder_time2,cae.created,cae.cuser,cae.modified,cae.muser,(CASE cae.target WHEN '1' THEN mem.name WHEN '2' THEN org.name WHEN '3' THEN dep.name WHEN '4' THEN pro.name WHEN '5' THEN upf.name ELSE '' END) AS target_name,mem1.email_work,mem.language
FROM " . $tablePrefix . "calendar_events cae
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = cae.target_id
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = cae.target_id
LEFT OUTER JOIN " . $tablePrefix . "departments dep ON dep.id = cae.target_id
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = cae.target_id
LEFT OUTER JOIN " . $tablePrefix . "user_profiles upf ON upf.id = cae.target_id
LEFT OUTER JOIN " . $tablePrefix . "members mem1 ON mem1.id = cae.cuser
";

$initrequest["notes"] = "SELECT note.id, note.project, note.owner, note.topic, note.subject, note.description, note.date, note.published, mem.id, mem.login, mem.name, mem.email_work, mem.extension_picture, mem.gender, tea.published
FROM " . $tablePrefix . "notes note
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = note.owner
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = note.project
LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project = note.project AND tea.member = note.owner
";

$initrequest["logs"] = "SELECT log.id, log.login, log.password, log.ip, log.session, log.compt, log.last_visite, log.connected, mem.organization
FROM " . $tablePrefix . "logs log
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.login = log.login
";

$initrequest["notifications"] = "SELECT noti.member,noti.notiid,noti.block,noti.block_string,noti.string_validto,mem.login,mem.name,mem.email_work,mem.organization,mem.profil,mem.language,loc.timezone
FROM " . $tablePrefix . "notifications noti
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = noti.member
LEFT OUTER JOIN " . $tablePrefix . "locations loc ON loc.id = mem.location
";

$initrequest["members"] = "SELECT mem.id,mem.organization,mem.department,mem.login,mem.password,mem.name,mem.title,mem.email_work,mem.email_home,mem.phone_work,mem.phone_home,mem.mobile,mem.fax,mem.comments,mem.profil,mem.language,mem.logout_time,mem.start_page,mem.location,loc.timezone,mem.date_format,mem.time_format,mem.manager,mem.deputy,mem.theme,mem.palette,mem.gender,mem.extension_picture,mem.active,mem.workcalendar,mem.enable_flextime,mem.begin_flextime,mem.initial_flexibalance,mem.invalid_logon,mem.export_format,mem.ldap_cn,mem.enable_timeclock,mem.created,mem.cuser,mem.modified,mem.muser,org.name,log.connected,mem2.id,mem2.login,mem2.name,mem2.email_work,mem2.deputy,mem3.login,mem3.name,mem3.email_work,dep.name,loc.name,loc.timezone,wca.name,upf.name
FROM " . $tablePrefix . "members mem
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = mem.organization
LEFT OUTER JOIN " . $tablePrefix . "logs log ON log.login = mem.login
LEFT OUTER JOIN " . $tablePrefix . "members mem2 ON mem2.id = mem.manager
LEFT OUTER JOIN " . $tablePrefix . "members mem3 ON mem3.id = mem.deputy
LEFT OUTER JOIN " . $tablePrefix . "departments dep ON dep.id = mem.department
LEFT OUTER JOIN " . $tablePrefix . "locations loc ON loc.id = mem.location
LEFT OUTER JOIN " . $tablePrefix . "workcalendars wca ON wca.id = mem.workcalendar
LEFT OUTER JOIN " . $tablePrefix . "user_profiles upf ON upf.id = mem.profil
";

$initrequest["messages"] = "SELECT mes.id,mes.from_id,mes.to_id,mes.message_type,mes.message,mes.extension_picture,mes.subject,mes.seen,mes.archived,mes.created,mem.name,mem.extension_picture,log.connected,mem2.name,mem2.extension_picture,log2.connected,mee.name,mee.status,mee.agenda
FROM " . $tablePrefix . "messages mes
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = mes.from_id
LEFT OUTER JOIN " . $tablePrefix . "logs log ON log.login = mem.login
LEFT OUTER JOIN " . $tablePrefix . "members mem2 ON mem2.id = mes.to_id
LEFT OUTER JOIN " . $tablePrefix . "logs log2 ON log2.login = mem2.login
LEFT OUTER JOIN " . $tablePrefix . "meetings mee ON mee.id = mes.to_id
";

$initrequest["departments"] = "SELECT dep.id,dep.organization,dep.name,dep.location,dep.locked,dep.created,dep.cuser,dep.modified,dep.muser,org.name,loc.name,loc.timezone,loc.language
FROM " . $tablePrefix . "departments dep
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=dep.organization
LEFT OUTER JOIN " . $tablePrefix . "locations loc ON loc.id=dep.location
";

$initrequest["projects"] = "SELECT pro.id, pro.organization, pro.owner, pro.priority, pro.status, pro.status_next, pro.status_approval, pro.open_date, pro.complete_date, pro.name, pro.description, pro.published, pro.phase_set, pro.type, pro.upload_dir, pro.currency, pro.permission_set, pro.cost_method, pro.workcalendar, pro.created, pro.cuser, pro.modified, pro.muser, org.id, org.name, mem.id, mem.login, mem.name, mem.email_work, loc.timezone, phs.name, wca.name
FROM " . $tablePrefix . "projects pro
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = pro.organization
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = pro.owner
LEFT OUTER JOIN " . $tablePrefix . "locations loc ON loc.id = mem.location
LEFT OUTER JOIN " . $tablePrefix . "phase_sets phs ON phs.id = pro.phase_set
LEFT OUTER JOIN " . $tablePrefix . "workcalendars wca ON wca.id = pro.workcalendar
";

$initrequest["projects_budget"] = "SELECT pjb.id,pjb.project,pjb.costtype,pjb.currency,pjb.amount,pjb.created,pjb.cuser,pjb.modified,pjb.muser
FROM " . $tablePrefix . "projects_budget pjb
";

$initrequest["projects_form"] = "SELECT pfm.project,pfm.tablename,pfm.publishenabled,pfm.created,pfm.cuser,pfm.modified,pfm.muser
FROM " . $tablePrefix . "projects_form pfm
";

$initrequest["files"] = "SELECT fil.id, fil.owner, fil.doc_type, fil.doc_type_ex, fil.doc_id, fil.name, fil.size, fil.extension, fil.comments, fil.published, fil.status, fil.vc_status, fil.vc_version, fil.vc_parent, fil.dir, fil.parent, fil.fullname, fil.project, fil.created, fil.cuser, fil.modified, fil.muser, mem.login, mem.name, mem.email_work, mem.extension_picture, mem.gender
FROM " . $tablePrefix . "files fil
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = fil.owner
";

$initrequest["files_view"] = "SELECT fil.id, fil.owner, fil.doc_type, fil.doc_type_ex, fil.doc_id, fil.name, fil.size, fil.extension, fil.comments, fil.published, fil.status, fil.vc_status, fil.vc_version, fil.vc_parent, fil.dir, fil.parent, fil.fullname, fil.created, fil.cuser, fil.modified, fil.muser, mem.login, mem.name, mem.email_work
FROM (
SELECT f00.id, f00.owner, f00.doc_type, f00.doc_type_ex, f00.doc_id, f00.name, f00.size, f00.extension, f00.comments, f00.published, f00.status, f00.vc_status, f00.vc_version, f00.vc_parent, f00.dir, f00.parent, f00.fullname, f00.created, f00.cuser, f00.modified, f00.muser
FROM " . $tablePrefix . "files f00
WHERE f00.doc_type NOT IN ('" . enumFileRelatedDocumentType::dtProject . "','" . enumFileRelatedDocumentType::dtPhase . "','" . enumFileRelatedDocumentType::dtTask . "','" . enumFileRelatedDocumentType::dtMeeting . "','" . enumFileRelatedDocumentType::dtDiscussion . "','" . enumFileRelatedDocumentType::dtNote . "','" . enumFileRelatedDocumentType::dtExpense . "','" . enumFileRelatedDocumentType::dtSupportRequest . "','" . enumFileRelatedDocumentType::dtSupportPost . "') AND f00.dir='" . enumBoolean::bFalse . "'
UNION
SELECT f01.id, f01.owner, f01.doc_type, f01.doc_type_ex, f01.doc_id, f01.name, f01.size, f01.extension, f01.comments, f01.published, f01.status, f01.vc_status, f01.vc_version, f01.vc_parent, f01.dir, f01.parent, f01.fullname, f01.created, f01.cuser, f01.modified, f01.muser
FROM " . $tablePrefix . "files f01
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=f01.doc_id AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f01.doc_type='" . enumFileRelatedDocumentType::dtProject . "' AND f01.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f02.id, f02.owner, f02.doc_type, f02.doc_type_ex, f02.doc_id, f02.name, f02.size, f02.extension, f02.comments, f02.published, f02.status, f02.vc_status, f02.vc_version, f02.vc_parent, f02.dir, f02.parent, f02.fullname, f02.created, f02.cuser, f02.modified, f02.muser
FROM " . $tablePrefix . "files f02
INNER JOIN " . $tablePrefix . "phases pha ON pha.id=f02.doc_id
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=pha.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f02.doc_type='" . enumFileRelatedDocumentType::dtPhase . "' AND f02.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f03.id, f03.owner, f03.doc_type, f03.doc_type_ex, f03.doc_id, f03.name, f03.size, f03.extension, f03.comments, f03.published, f03.status, f03.vc_status, f03.vc_version, f03.vc_parent, f03.dir, f03.parent, f03.fullname, f03.created, f03.cuser, f03.modified, f03.muser
FROM " . $tablePrefix . "files f03
INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=f03.doc_id
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=tas.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f03.doc_type='" . enumFileRelatedDocumentType::dtTask . "' AND f03.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f04.id, f04.owner, f04.doc_type, f04.doc_type_ex, f04.doc_id, f04.name, f04.size, f04.extension, f04.comments, f04.published, f04.status, f04.vc_status, f04.vc_version, f04.vc_parent, f04.dir, f04.parent, f04.fullname, f04.created, f04.cuser, f04.modified, f04.muser
FROM " . $tablePrefix . "files f04
INNER JOIN " . $tablePrefix . "meetings mee ON mee.id=f04.doc_id
LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=mee.project AND tea.member=%member%
LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f04.doc_type='" . enumFileRelatedDocumentType::dtMeeting . "' AND f04.dir='" . enumBoolean::bFalse . "' AND (prp.view_file='" . enumBoolean::bTrue . "' OR mee.project='0')
UNION
SELECT f05.id, f05.owner, f05.doc_type, f05.doc_type_ex, f05.doc_id, f05.name, f05.size, f05.extension, f05.comments, f05.published, f05.status, f05.vc_status, f05.vc_version, f05.vc_parent, f05.dir, f05.parent, f05.fullname, f05.created, f05.cuser, f05.modified, f05.muser
FROM " . $tablePrefix . "files f05
INNER JOIN " . $tablePrefix . "posts pos ON pos.id=f05.doc_id
INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=topic.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f05.doc_type='" . enumFileRelatedDocumentType::dtDiscussion . "' AND f05.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f06.id, f06.owner, f06.doc_type, f06.doc_type_ex, f06.doc_id, f06.name, f06.size, f06.extension, f06.comments, f06.published, f06.status, f06.vc_status, f06.vc_version, f06.vc_parent, f06.dir, f06.parent, f06.fullname, f06.created, f06.cuser, f06.modified, f06.muser
FROM " . $tablePrefix . "files f06
INNER JOIN " . $tablePrefix . "notes note ON note.id=f06.doc_id
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=note.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f06.doc_type='" . enumFileRelatedDocumentType::dtNote . "' AND f06.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f07.id, f07.owner, f07.doc_type, f07.doc_type_ex, f07.doc_id, f07.name, f07.size, f07.extension, f07.comments, f07.published, f07.status, f07.vc_status, f07.vc_version, f07.vc_parent, f07.dir, f07.parent, f07.fullname, f07.created, f07.cuser, f07.modified, f07.muser
FROM " . $tablePrefix . "files f07
INNER JOIN " . $tablePrefix . "expenses exp ON exp.id=f07.doc_id
LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=exp.project AND tea.member=%member%
LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f07.doc_type='" . enumFileRelatedDocumentType::dtExpense . "' AND f07.dir='" . enumBoolean::bFalse . "' AND (prp.view_file='" . enumBoolean::bTrue . "' OR exp.project='0')
UNION
SELECT f08.id, f08.owner, f08.doc_type, f08.doc_type_ex, f08.doc_id, f08.name, f08.size, f08.extension, f08.comments, f08.published, f08.status, f08.vc_status, f08.vc_version, f08.vc_parent, f08.dir, f08.parent, f08.fullname, f08.created, f08.cuser, f08.modified, f08.muser
FROM " . $tablePrefix . "files f08
INNER JOIN " . $tablePrefix . "support_requests req ON req.id=f08.doc_id
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=req.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f08.doc_type='" . enumFileRelatedDocumentType::dtSupportRequest . "' AND f08.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f09.id, f09.owner, f09.doc_type, f09.doc_type_ex, f09.doc_id, f09.name, f09.size, f09.extension, f09.comments, f09.published, f09.status, f09.vc_status, f09.vc_version, f09.vc_parent, f09.dir, f09.parent, f09.fullname, f09.created, f09.cuser, f09.modified, f09.muser
FROM " . $tablePrefix . "files f09
INNER JOIN " . $tablePrefix . "support_posts pos ON pos.id=f09.doc_id
INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=req.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f09.doc_type='" . enumFileRelatedDocumentType::dtSupportPost . "' AND f09.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
) fil
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = fil.owner
";

$initrequest["files_view_novc"] = "SELECT fvv.id, fvv.owner, fvv.doc_type, fvv.doc_type_ex, fvv.doc_id, fvv.name, fvv.size, fvv.extension, fvv.comments, fvv.published, fvv.status, fvv.vc_status, fvv.vc_version, fvv.vc_parent, fvv.dir, fvv.parent, fvv.fullname, fvv.created, fvv.cuser, fvv.modified, fvv.muser, mem.login, mem.name, mem.email_work
FROM " . $tablePrefix . "files fvv
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = fvv.owner
WHERE fvv.id IN (
SELECT DISTINCT (CASE WHEN fil.vc_parent=0 THEN fil.id ELSE fil.vc_parent END) AS id
FROM (
SELECT f00.id, f00.owner, f00.doc_type, f00.doc_type_ex, f00.doc_id, f00.name, f00.size, f00.extension, f00.comments, f00.published, f00.status, f00.vc_status, f00.vc_version, f00.vc_parent, f00.dir, f00.parent, f00.fullname, f00.created, f00.cuser, f00.modified, f00.muser
FROM " . $tablePrefix . "files f00
WHERE f00.doc_type NOT IN ('" . enumFileRelatedDocumentType::dtProject . "','" . enumFileRelatedDocumentType::dtPhase . "','" . enumFileRelatedDocumentType::dtTask . "','" . enumFileRelatedDocumentType::dtMeeting . "','" . enumFileRelatedDocumentType::dtDiscussion . "','" . enumFileRelatedDocumentType::dtNote . "','" . enumFileRelatedDocumentType::dtExpense . "','" . enumFileRelatedDocumentType::dtSupportRequest . "','" . enumFileRelatedDocumentType::dtSupportPost . "') AND f00.dir='" . enumBoolean::bFalse . "'
UNION
SELECT f01.id, f01.owner, f01.doc_type, f01.doc_type_ex, f01.doc_id, f01.name, f01.size, f01.extension, f01.comments, f01.published, f01.status, f01.vc_status, f01.vc_version, f01.vc_parent, f01.dir, f01.parent, f01.fullname, f01.created, f01.cuser, f01.modified, f01.muser
FROM " . $tablePrefix . "files f01
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=f01.doc_id AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f01.doc_type='" . enumFileRelatedDocumentType::dtProject . "' AND f01.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f02.id, f02.owner, f02.doc_type, f02.doc_type_ex, f02.doc_id, f02.name, f02.size, f02.extension, f02.comments, f02.published, f02.status, f02.vc_status, f02.vc_version, f02.vc_parent, f02.dir, f02.parent, f02.fullname, f02.created, f02.cuser, f02.modified, f02.muser
FROM " . $tablePrefix . "files f02
INNER JOIN " . $tablePrefix . "phases pha ON pha.id=f02.doc_id
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=pha.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f02.doc_type='" . enumFileRelatedDocumentType::dtPhase . "' AND f02.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f03.id, f03.owner, f03.doc_type, f03.doc_type_ex, f03.doc_id, f03.name, f03.size, f03.extension, f03.comments, f03.published, f03.status, f03.vc_status, f03.vc_version, f03.vc_parent, f03.dir, f03.parent, f03.fullname, f03.created, f03.cuser, f03.modified, f03.muser
FROM " . $tablePrefix . "files f03
INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=f03.doc_id
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=tas.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f03.doc_type='" . enumFileRelatedDocumentType::dtTask . "' AND f03.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f04.id, f04.owner, f04.doc_type, f04.doc_type_ex, f04.doc_id, f04.name, f04.size, f04.extension, f04.comments, f04.published, f04.status, f04.vc_status, f04.vc_version, f04.vc_parent, f04.dir, f04.parent, f04.fullname, f04.created, f04.cuser, f04.modified, f04.muser
FROM " . $tablePrefix . "files f04
INNER JOIN " . $tablePrefix . "meetings mee ON mee.id=f04.doc_id
LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=mee.project AND tea.member=%member%
LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f04.doc_type='" . enumFileRelatedDocumentType::dtMeeting . "' AND f04.dir='" . enumBoolean::bFalse . "' AND (prp.view_file='" . enumBoolean::bTrue . "' OR mee.project='0')
UNION
SELECT f05.id, f05.owner, f05.doc_type, f05.doc_type_ex, f05.doc_id, f05.name, f05.size, f05.extension, f05.comments, f05.published, f05.status, f05.vc_status, f05.vc_version, f05.vc_parent, f05.dir, f05.parent, f05.fullname, f05.created, f05.cuser, f05.modified, f05.muser
FROM " . $tablePrefix . "files f05
INNER JOIN " . $tablePrefix . "posts pos ON pos.id=f05.doc_id
INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=topic.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f05.doc_type='" . enumFileRelatedDocumentType::dtDiscussion . "' AND f05.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f06.id, f06.owner, f06.doc_type, f06.doc_type_ex, f06.doc_id, f06.name, f06.size, f06.extension, f06.comments, f06.published, f06.status, f06.vc_status, f06.vc_version, f06.vc_parent, f06.dir, f06.parent, f06.fullname, f06.created, f06.cuser, f06.modified, f06.muser
FROM " . $tablePrefix . "files f06
INNER JOIN " . $tablePrefix . "notes note ON note.id=f06.doc_id
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=note.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f06.doc_type='" . enumFileRelatedDocumentType::dtNote . "' AND f06.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f07.id, f07.owner, f07.doc_type, f07.doc_type_ex, f07.doc_id, f07.name, f07.size, f07.extension, f07.comments, f07.published, f07.status, f07.vc_status, f07.vc_version, f07.vc_parent, f07.dir, f07.parent, f07.fullname, f07.created, f07.cuser, f07.modified, f07.muser
FROM " . $tablePrefix . "files f07
INNER JOIN " . $tablePrefix . "expenses exp ON exp.id=f07.doc_id
LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=exp.project AND tea.member=%member%
LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f07.doc_type='" . enumFileRelatedDocumentType::dtExpense . "' AND f07.dir='" . enumBoolean::bFalse . "' AND (prp.view_file='" . enumBoolean::bTrue . "' OR exp.project='0')
UNION
SELECT f08.id, f08.owner, f08.doc_type, f08.doc_type_ex, f08.doc_id, f08.name, f08.size, f08.extension, f08.comments, f08.published, f08.status, f08.vc_status, f08.vc_version, f08.vc_parent, f08.dir, f08.parent, f08.fullname, f08.created, f08.cuser, f08.modified, f08.muser
FROM " . $tablePrefix . "files f08
INNER JOIN " . $tablePrefix . "support_requests req ON req.id=f08.doc_id
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=req.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f08.doc_type='" . enumFileRelatedDocumentType::dtSupportRequest . "' AND f08.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
UNION
SELECT f09.id, f09.owner, f09.doc_type, f09.doc_type_ex, f09.doc_id, f09.name, f09.size, f09.extension, f09.comments, f09.published, f09.status, f09.vc_status, f09.vc_version, f09.vc_parent, f09.dir, f09.parent, f09.fullname, f09.created, f09.cuser, f09.modified, f09.muser
FROM " . $tablePrefix . "files f09
INNER JOIN " . $tablePrefix . "support_posts pos ON pos.id=f09.doc_id
INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=req.project AND tea.member=%member%
INNER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil
WHERE f09.doc_type='" . enumFileRelatedDocumentType::dtSupportPost . "' AND f09.dir='" . enumBoolean::bFalse . "' AND prp.view_file='" . enumBoolean::bTrue . "'
) fil
%querymore%
)
%ordermore%
";

$initrequest["project_files"] = "SELECT fil.id, fil.owner, fil.doc_type, fil.doc_id, fil.name, fil.size, fil.extension, fil.comments, fil.published, fil.status, fil.vc_status, fil.vc_version, fil.vc_parent, fil.dir, fil.parent, fil.fullname, fil.created, fil.cuser, fil.modified, fil.muser, mem.login, mem.name, mem.email_work, mem.extension_picture, mem.gender
FROM (
SELECT f01.id, f01.owner, f01.doc_type, f01.doc_id, f01.name, f01.size, f01.extension, f01.comments, f01.published, f01.status, f01.vc_status, f01.vc_version, f01.vc_parent, f01.dir, f01.parent, f01.fullname, f01.created, f01.cuser, f01.modified, f01.muser
FROM " . $tablePrefix . "files f01
WHERE f01.doc_type='" . enumFileRelatedDocumentType::dtProject . "' AND f01.doc_id=%project% AND f01.dir='" . enumBoolean::bFalse . "'
UNION
SELECT f02.id, f02.owner, f02.doc_type, f02.doc_id, f02.name, f02.size, f02.extension, f02.comments, f02.published, f02.status, f02.vc_status, f02.vc_version, f02.vc_parent, f02.dir, f02.parent, f02.fullname, f02.created, f02.cuser, f02.modified, f02.muser
FROM " . $tablePrefix . "files f02
INNER JOIN " . $tablePrefix . "phases pha ON pha.id=f02.doc_id
WHERE f02.doc_type='" . enumFileRelatedDocumentType::dtPhase . "' AND f02.dir='" . enumBoolean::bFalse . "' AND pha.project=%project%
UNION
SELECT f03.id, f03.owner, f03.doc_type, f03.doc_id, f03.name, f03.size, f03.extension, f03.comments, f03.published, f03.status, f03.vc_status, f03.vc_version, f03.vc_parent, f03.dir, f03.parent, f03.fullname, f03.created, f03.cuser, f03.modified, f03.muser
FROM " . $tablePrefix . "files f03
INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=f03.doc_id
WHERE f03.doc_type='" . enumFileRelatedDocumentType::dtTask . "' AND f03.dir='" . enumBoolean::bFalse . "' AND tas.project=%project%
UNION
SELECT f04.id, f04.owner, f04.doc_type, f04.doc_id, f04.name, f04.size, f04.extension, f04.comments, f04.published, f04.status, f04.vc_status, f04.vc_version, f04.vc_parent, f04.dir, f04.parent, f04.fullname, f04.created, f04.cuser, f04.modified, f04.muser
FROM " . $tablePrefix . "files f04
INNER JOIN " . $tablePrefix . "meetings mee ON mee.id=f04.doc_id
WHERE f04.doc_type='" . enumFileRelatedDocumentType::dtMeeting . "' AND f04.dir='" . enumBoolean::bFalse . "' AND mee.project=%project%
UNION
SELECT f05.id, f05.owner, f05.doc_type, f05.doc_id, f05.name, f05.size, f05.extension, f05.comments, f05.published, f05.status, f05.vc_status, f05.vc_version, f05.vc_parent, f05.dir, f05.parent, f05.fullname, f05.created, f05.cuser, f05.modified, f05.muser
FROM " . $tablePrefix . "files f05
INNER JOIN " . $tablePrefix . "posts pos ON pos.id=f05.doc_id
INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic
WHERE f05.doc_type='" . enumFileRelatedDocumentType::dtDiscussion . "' AND f05.dir='" . enumBoolean::bFalse . "' AND topic.project=%project%
UNION
SELECT f06.id, f06.owner, f06.doc_type, f06.doc_id, f06.name, f06.size, f06.extension, f06.comments, f06.published, f06.status, f06.vc_status, f06.vc_version, f06.vc_parent, f06.dir, f06.parent, f06.fullname, f06.created, f06.cuser, f06.modified, f06.muser
FROM " . $tablePrefix . "files f06
INNER JOIN " . $tablePrefix . "notes note ON note.id=f06.doc_id
WHERE f06.doc_type='" . enumFileRelatedDocumentType::dtNote . "' AND f06.dir='" . enumBoolean::bFalse . "' AND note.project=%project%
UNION
SELECT f07.id, f07.owner, f07.doc_type, f07.doc_id, f07.name, f07.size, f07.extension, f07.comments, f07.published, f07.status, f07.vc_status, f07.vc_version, f07.vc_parent, f07.dir, f07.parent, f07.fullname, f07.created, f07.cuser, f07.modified, f07.muser
FROM " . $tablePrefix . "files f07
INNER JOIN " . $tablePrefix . "expenses exp ON exp.id=f07.doc_id
WHERE f07.doc_type='" . enumFileRelatedDocumentType::dtExpense . "' AND f07.dir='" . enumBoolean::bFalse . "' AND exp.project=%project%
UNION
SELECT f08.id, f08.owner, f08.doc_type, f08.doc_id, f08.name, f08.size, f08.extension, f08.comments, f08.published, f08.status, f08.vc_status, f08.vc_version, f08.vc_parent, f08.dir, f08.parent, f08.fullname, f08.created, f08.cuser, f08.modified, f08.muser
FROM " . $tablePrefix . "files f08
INNER JOIN " . $tablePrefix . "support_requests req ON req.id=f08.doc_id
WHERE f08.doc_type='" . enumFileRelatedDocumentType::dtSupportRequest . "' AND f08.dir='" . enumBoolean::bFalse . "' AND req.project=%project%
UNION
SELECT f09.id, f09.owner, f09.doc_type, f09.doc_id, f09.name, f09.size, f09.extension, f09.comments, f09.published, f09.status, f09.vc_status, f09.vc_version, f09.vc_parent, f09.dir, f09.parent, f09.fullname, f09.created, f09.cuser, f09.modified, f09.muser
FROM " . $tablePrefix . "files f09
INNER JOIN " . $tablePrefix . "support_posts pos ON pos.id=f09.doc_id
INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id
WHERE f09.doc_type='" . enumFileRelatedDocumentType::dtSupportPost . "' AND f09.dir='" . enumBoolean::bFalse . "' AND req.project=%project%
) fil
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = fil.owner
";

$initrequest["phase_files"] = "SELECT fil.id, fil.owner, fil.doc_type, fil.doc_id, fil.name, fil.size, fil.extension, fil.comments, fil.published, fil.status, fil.vc_status, fil.vc_version, fil.vc_parent, fil.dir, fil.parent, fil.fullname, fil.created, fil.cuser, fil.modified, fil.muser, mem.login, mem.name, mem.email_work
FROM (
SELECT f01.id, f01.owner, f01.doc_type, f01.doc_id, f01.name, f01.size, f01.extension, f01.comments, f01.published, f01.status, f01.vc_status, f01.vc_version, f01.vc_parent, f01.dir, f01.parent, f01.fullname, f01.created, f01.cuser, f01.modified, f01.muser
FROM " . $tablePrefix . "files f01
WHERE f01.doc_type='" . enumFileRelatedDocumentType::dtPhase . "' AND f01.doc_id=%phase% AND f01.dir='" . enumBoolean::bFalse . "'
UNION
SELECT f02.id, f02.owner, f02.doc_type, f02.doc_id, f02.name, f02.size, f02.extension, f02.comments, f02.published, f02.status, f02.vc_status, f02.vc_version, f02.vc_parent, f02.dir, f02.parent, f02.fullname, f02.created, f02.cuser, f02.modified, f02.muser
FROM " . $tablePrefix . "files f02
INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=f02.doc_id
INNER JOIN " . $tablePrefix . "phases pha ON pha.project=tas.project AND pha.order_num=tas.parent_phase
WHERE f02.doc_type='" . enumFileRelatedDocumentType::dtTask . "' AND f02.dir='" . enumBoolean::bFalse . "' AND pha.id=%phase%
) fil
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = fil.owner
";

$initrequest["organizations"] = "SELECT org.id,org.name,org.address,org.zip_code,org.city,org.country,org.phone,org.fax,org.url,org.email,org.comments,org.sscomments,org.extension_logo,org.owner,org.currency,org.workcalendar,org.payment_method,org.payment_terms,org.locked,org.created,org.cuser,org.modified,org.muser,mem.id,mem.login,mem.name,mem.email_work,wca.name,pym.name,pyt.name
FROM " . $tablePrefix . "organizations org
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = org.owner
LEFT OUTER JOIN " . $tablePrefix . "workcalendars wca ON wca.id=org.workcalendar
LEFT OUTER JOIN " . $tablePrefix . "payment_methods pym ON pym.id=org.payment_method
LEFT OUTER JOIN " . $tablePrefix . "payment_terms pyt ON pyt.id=org.payment_terms
";

$initrequest["organizations2"] = "SELECT org.id, org.name, org.address, org.zip_code, org.city, org.country, org.phone, org.fax, org.url, org.email, org.comments,org.sscomments, org.extension_logo, org.owner, org.currency, org.workcalendar,org.payment_terms, org.created, org.cuser, org.modified, org.muser, mem.id, mem.login, mem.name, mem.email_work, wca.name,
(SELECT COUNT(pro1.id) FROM " . $tablePrefix . "projects pro1 WHERE pro1.organization=org.id AND pro1.status='" . enumProjectStatus::stOpen . "') AS num_open,
(SELECT COUNT(pro2.id) FROM " . $tablePrefix . "projects pro2 WHERE pro2.organization=org.id AND pro2.status='" . enumProjectStatus::stCompleted . "' AND pro2.complete_date>='%DATEFROM%' AND pro2.complete_date<='%DATETO%') AS num_complete
FROM " . $tablePrefix . "organizations org
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = org.owner
LEFT OUTER JOIN " . $tablePrefix . "workcalendars wca ON wca.id=org.workcalendar
";

$initrequest["organizations_extension"] = "SELECT oge.organization,oge.extension,oge.perm_read,oge.perm_write,oge.perm_edit,oge.perm_admin,oge.created,oge.cuser,ext.name
FROM " . $tablePrefix . "organizations_extension oge
INNER JOIN " . $tablePrefix . "extensions ext ON ext.id=oge.extension
";

$initrequest["organizations_form"] = "SELECT ogf.id,ogf.organization,ogf.tablename,ogf.addenabled,ogf.modenabled,ogf.created,ogf.cuser,ogf.modified,ogf.muser
FROM " . $tablePrefix . "organizations_form ogf
";

$initrequest["topics"] = "SELECT topic.id, topic.project, topic.owner, topic.subject, topic.status, topic.last_post, topic.posts, topic.published, mem.id, mem.login, mem.name, mem.email_work, mem.extension_picture, mem.gender, pro.id, pro.name, mem2.login, mem2.email_work, mem2.name
FROM " . $tablePrefix . "topics topic
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = topic.owner
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = topic.project
LEFT OUTER JOIN " . $tablePrefix . "posts pos ON pos.topic = topic.id and pos.created = topic.last_post
LEFT OUTER JOIN " . $tablePrefix . "members mem2 ON mem2.id = pos.member
";

$initrequest["posts"] = "SELECT pos.id, pos.topic, pos.member, pos.created, pos.message, mem.id, mem.login, mem.name, mem.email_work, topic.subject
FROM " . $tablePrefix . "posts pos
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = pos.member
LEFT OUTER JOIN " . $tablePrefix . "topics topic ON topic.id = pos.topic
";

$initrequest["assignments"] = "SELECT ass.id, ass.task, ass.owner, ass.assigned_to, ass.comments, ass.assigned, mem1.id, mem1.login, mem1.name, mem1.email_work, mem2.id, mem2.login, mem2.name, mem2.email_work
FROM " . $tablePrefix . "assignments ass
LEFT OUTER JOIN " . $tablePrefix . "members mem1 ON mem1.id = ass.owner
LEFT OUTER JOIN " . $tablePrefix . "members mem2 ON mem2.id = ass.assigned_to
";

$initrequest['report_category'] = "SELECT repc.id,repc.name,repc.created,repc.cuser,repc.modified,repc.muser
FROM " . $tablePrefix . "report_category repc
";

$initrequest["reports"] = "SELECT rep.id,rep.category,rep.name,rep.url,rep.tablename,rep.sysdef,rep.userquery,rep.locked,rep.created,rep.cuser,rep.modified,rep.muser,repc.name,tdf.sysdef
FROM " . $tablePrefix . "reports rep
LEFT OUTER JOIN " . $tablePrefix . "report_category repc ON repc.id=rep.category
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdf ON tdf.tablename=rep.tablename
";

$initrequest['reports_rel_tables'] = "SELECT repl.id,repl.report,repl.tablename,repl.table_left,tdf.sysdef,
CASE WHEN repl.table_left='0' THEN rep.tablename ELSE repll.tablename END AS tablename_left,
CASE WHEN repl.table_left='0' THEN tdfp.sysdef ELSE tdfl.sysdef END AS sysdef_left
FROM " . $tablePrefix . "reports_rel_tables repl
INNER JOIN " . $tablePrefix . "reports rep ON rep.id=repl.report
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdf ON tdf.tablename=repl.tablename
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdfp ON tdfp.tablename=rep.tablename
LEFT OUTER JOIN " . $tablePrefix . "reports_rel_tables repll ON repll.id=repl.table_left
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdfl ON tdfl.tablename=repll.tablename
";

$initrequest['reports_rel_fields'] = "SELECT replf.id,replf.rel_table,repl.report,repl.tablename,repl.table_left,replf.field_left,replf.field_right,tdf.sysdef,
CASE WHEN repl.table_left='0' THEN rep.tablename ELSE repll.tablename END AS tablename_left,
CASE WHEN repl.table_left='0' THEN tdfp.sysdef ELSE tdfl.sysdef END AS sysdef_left,
CASE WHEN repl.table_left='0' THEN fdfp.sysdef ELSE fdfl.sysdef END AS sysdef_leftf,
CASE WHEN replf.field_right='id' THEN 'Y' ELSE fdfr.sysdef END AS sysdef_rightf,
CASE WHEN repl.table_left='0' THEN fdfp.fieldtype ELSE fdfl.fieldtype END AS fieldtype_left,
CASE WHEN repl.table_left='0' THEN fdfp.length ELSE fdfl.length END AS length_left,
CASE WHEN replf.field_right='id' THEN '1' ELSE fdfr.fieldtype END AS fieldtype_right,
CASE WHEN replf.field_right='id' THEN 8 ELSE fdfr.length END AS length_right
FROM " . $tablePrefix . "reports_rel_fields replf
INNER JOIN " . $tablePrefix . "reports_rel_tables repl ON repl.id=replf.rel_table
INNER JOIN " . $tablePrefix . "reports rep ON rep.id=repl.report
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdf ON tdf.tablename=repl.tablename
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdfp ON tdfp.tablename=rep.tablename
LEFT OUTER JOIN " . $tablePrefix . "reports_rel_tables repll ON repll.id=repl.table_left
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdfl ON tdfl.tablename=repll.tablename
LEFT OUTER JOIN " . $tablePrefix . "fields_def fdfl ON fdfl.tablename=repll.tablename AND fdfl.fieldname=replf.field_left
LEFT OUTER JOIN " . $tablePrefix . "fields_def fdfr ON fdfr.tablename=repl.tablename AND fdfr.fieldname=replf.field_right
LEFT OUTER JOIN " . $tablePrefix . "fields_def fdfp ON fdfp.tablename=rep.tablename AND fdfp.fieldname=replf.field_left
";

$initrequest['reports_criteria'] = "SELECT repr.id,repr.report,repr.rel_table,repr.fieldname,repr.fieldtype,repr.ratio,repr.value,repr.table_right,repr.compare_fields,repr.parameter,
CASE WHEN repr.rel_table='0' THEN rep.tablename ELSE repl.tablename END AS tablename,
CASE WHEN repr.rel_table='0' THEN tdfp.sysdef ELSE tdf.sysdef END AS sysdef_t,
CASE WHEN repr.rel_table='0' THEN fdfp.sysdef ELSE fdf.sysdef END AS sysdef_f,
CASE WHEN repr.rel_table='0' THEN fdfp.fieldtype ELSE fdf.fieldtype END AS fieldtype_l,
CASE WHEN repr.rel_table='0' THEN fdfp.length ELSE fdf.length END AS length_l,
CASE WHEN repr.rel_table='0' THEN fdfp.linkedtable ELSE fdf.linkedtable END AS linkedtable_l,
CASE WHEN repr.compare_fields='0' THEN '' ELSE CASE WHEN repr.table_right='0' THEN rep.tablename ELSE replr.tablename END END AS tablename_right,
CASE WHEN repr.compare_fields='0' THEN 'N' ELSE CASE WHEN repr.table_right='0' THEN tdfp.sysdef ELSE tdfr.sysdef END END AS sysdef_right,
CASE WHEN repr.compare_fields='0' THEN '' ELSE repr.value END AS field_right,
CASE WHEN repr.compare_fields='0' THEN 'N' ELSE CASE WHEN repr.table_right='0' THEN fdfpr.sysdef ELSE fdfr.sysdef END END AS sysdef_fieldr,
CASE WHEN repr.compare_fields='0' THEN '' ELSE CASE WHEN repr.table_right='0' THEN fdfpr.fieldtype ELSE fdfr.fieldtype END END AS fieldtype_r,
CASE WHEN repr.compare_fields='0' THEN 0 ELSE CASE WHEN repr.table_right='0' THEN fdfpr.length ELSE fdfr.length END END AS length_r
FROM " . $tablePrefix . "reports_criteria repr
INNER JOIN " . $tablePrefix . "reports rep ON rep.id=repr.report
LEFT OUTER JOIN " . $tablePrefix . "reports_rel_tables repl ON repl.id=repr.rel_table
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdf ON tdf.tablename=repl.tablename
LEFT OUTER JOIN " . $tablePrefix . "fields_def fdf ON fdf.tablename=repl.tablename AND fdf.fieldname=repr.fieldname
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdfp ON tdfp.tablename=rep.tablename
LEFT OUTER JOIN " . $tablePrefix . "fields_def fdfp ON fdfp.tablename=rep.tablename AND fdfp.fieldname=repr.fieldname
LEFT OUTER JOIN " . $tablePrefix . "reports_rel_tables replr ON replr.id=repr.table_right
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdfr ON tdfr.tablename=replr.tablename
LEFT OUTER JOIN " . $tablePrefix . "fields_def fdfr ON fdfr.tablename=replr.tablename AND fdfr.fieldname=repr.value
LEFT OUTER JOIN " . $tablePrefix . "fields_def fdfpr ON fdfpr.tablename=rep.tablename AND fdfpr.fieldname=repr.value
";

$initrequest['reports_output'] = "SELECT repo.id,repo.report,repo.rel_table,repo.fieldname,repo.fieldtype,repo.title,repo.disp_order,repo.sort_order,repo.sort_type,repo.field_group,repo.field_function,
CASE WHEN repo.rel_table='0' THEN rep.tablename ELSE repl.tablename END AS tablename,
CASE WHEN repo.rel_table='0' THEN fdfp.sysdef ELSE fdf.sysdef END AS sysdef_f,
CASE WHEN repo.rel_table='0' THEN fdfp.fieldtype ELSE fdf.fieldtype END AS fieldtype,
CASE WHEN repo.rel_table='0' THEN fdfp.length ELSE fdf.length END AS length
FROM " . $tablePrefix . "reports_output repo
INNER JOIN " . $tablePrefix . "reports rep ON rep.id=repo.report
LEFT OUTER JOIN " . $tablePrefix . "reports_rel_tables repl ON repl.id=repo.rel_table
LEFT OUTER JOIN " . $tablePrefix . "fields_def fdf ON fdf.tablename=repl.tablename AND fdf.fieldname=repo.fieldname
LEFT OUTER JOIN " . $tablePrefix . "fields_def fdfp ON fdfp.tablename=rep.tablename AND fdfp.fieldname=repo.fieldname
";

$initrequest["teams"] = "SELECT tea.id, tea.project, tea.member, tea.published, tea.authorized, tea.profil, tea.service, tea.comments, tea.created, tea.cuser, tea.modified, tea.muser, mem.id, mem.organization, mem.login, mem.name, mem.email_work, mem.language, mem.title, mem.phone_work, mem.profil, mem.password, mem.active, mem.extension_picture, mem.gender, org.name, pro.id, pro.organization, pro.name, pro.owner, pro.priority, pro.status, pro.published, org2.name, mem2.login, mem2.name, mem2.email_work, mem2.deputy, org2.id, log.connected, loc.timezone
FROM " . $tablePrefix . "teams tea
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = tea.member
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = tea.project
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = mem.organization
LEFT OUTER JOIN " . $tablePrefix . "organizations org2 ON org2.id = pro.organization
LEFT OUTER JOIN " . $tablePrefix . "members mem2 ON mem2.id = pro.owner
LEFT OUTER JOIN " . $tablePrefix . "logs log ON log.login = mem.login
LEFT OUTER JOIN " . $tablePrefix . "locations loc ON loc.id = mem.location
";

$initrequest["tasks"] = "SELECT tas.id, tas.project, tas.priority, tas.status, tas.owner, tas.assigned_to, tas.name, tas.description, tas.start_date, tas.due_date, tas.estimated_time, tas.actual_time, tas.comments, tas.completion, tas.assigned, tas.published, tas.parent_phase, tas.complete_date, tas.service, tas.fixed_duration, tas.milestone, tas.type, tas.task_group, tas.level, tas.parent_task, tas.subtask, tas.support_request, tas.created, tas.cuser, tas.modified, tas.muser, mem2.name, mem2.login, mem2.organization, mem2.email_work, mem2.profil, mem2.extension_picture, mem2.gender, pro.name, org.id, sr.subject, svc.name
FROM " . $tablePrefix . "tasks tas
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = tas.project
LEFT OUTER JOIN " . $tablePrefix . "members mem2 ON mem2.id = tas.owner
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = pro.organization
LEFT OUTER JOIN " . $tablePrefix . "support_requests sr ON sr.id = tas.support_request
LEFT OUTER JOIN " . $tablePrefix . "services svc ON svc.id = tas.service
";

$initrequest["tasks_predecessor"] = "SELECT pre.id,pre.task,pre.predecessor,pre.type,pre.lag,pre.created,pre.cuser,pre.modified,pre.muser,tas.project,tas.name,tas.start_date,tas.due_date,tas.estimated_time,tas.fixed_duration,tas.milestone,tas.level,tas.parent_task,tas2.name,tas2.start_date,tas2.due_date,tas2.estimated_time,tas2.fixed_duration,tas2.milestone,tas2.completion,tas2.assigned_to,mem2.login,mem2.email_work
FROM " . $tablePrefix . "tasks_predecessor pre
LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id = pre.task
LEFT OUTER JOIN " . $tablePrefix . "tasks tas2 ON tas2.id = pre.predecessor
LEFT OUTER JOIN " . $tablePrefix . "members mem2 ON mem2.id = tas2.assigned_to
";

$initrequest["tasks_resource"] = "SELECT res.id, res.task, res.resource, res.type, res.quantity, res.created, res.cuser, res.modified, res.muser, tas.project, tas.name, pro.name, org.id
FROM " . $tablePrefix . "tasks_resource res
LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id = res.task
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = tas.project
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = pro.organization
";

$initrequest["tasks_human_resource"] = "SELECT res.id, res.task, res.resource, res.created, res.cuser, res.modified, res.muser, tas.project, tas.name, mem.name, mem.login, mem.email_work, mem.phone_work, mem.organization, mem.profil, mem.language, mem.extension_picture, mem.gender, pro.name, org.id, tas.description, tas.status, tas.start_date, tas.due_date, tas.estimated_time, tas.completion, log.connected, loc.timezone
FROM " . $tablePrefix . "tasks_resource res
LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id = res.task
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = res.resource
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = tas.project
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = pro.organization
LEFT OUTER JOIN " . $tablePrefix . "logs log ON log.login = mem.login
LEFT OUTER JOIN " . $tablePrefix . "locations loc ON loc.id = mem.location
WHERE res.type='U'
";

$initrequest["tasks_material_resource"] = "SELECT res.id, res.task, res.resource, res.quantity, res.created, res.cuser, res.modified, res.muser, tas.project, tas.name, mat.name, mat.unit, mat.currency, mat.costrate, pro.name, org.id, tas.description, tas.status, tas.start_date, tas.due_date, tas.estimated_time, tas.completion
FROM " . $tablePrefix . "tasks_resource res
LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id = res.task
LEFT OUTER JOIN " . $tablePrefix . "materials mat ON mat.id = res.resource
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = tas.project
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = pro.organization
WHERE res.type='M'
";

$initrequest["tasks_equipment_resource"] = "SELECT res.id, res.task, res.resource, res.created, res.cuser, res.modified, res.muser, tas.project, tas.name, equ.equipment_id, equ.equipment_category, equ.equipment_type, eqc.name, eqt.name, equ.name, pro.name, org.id, tas.description, tas.status, tas.start_date, tas.due_date, tas.estimated_time, tas.completion
FROM " . $tablePrefix . "tasks_resource res
LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id = res.task
LEFT OUTER JOIN " . $tablePrefix . "equipments equ ON equ.id = res.resource
LEFT OUTER JOIN " . $tablePrefix . "equipment_category eqc ON eqc.id = equ.equipment_category
LEFT OUTER JOIN " . $tablePrefix . "equipment_type eqt ON eqt.id = equ.equipment_type
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = tas.project
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = pro.organization
WHERE res.type='E'
";

$initrequest["tasks_time"] = "SELECT tim.id,tim.project,tim.task,tim.owner,tim.date,tim.hours,tim.comments,tim.billing,tim.service,tim.created,tim.cuser,tim.modified,tim.muser,mem.name,pro.name,pro.type,org.name,svc.name,svc.hourly_rate,svc.hourly_rate_i,svc.currency,tas.name,tas.type,wcd.type,wcd.hours,wcd.comments,pro.organization
FROM " . $tablePrefix . "tasks_time tim
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = tim.owner
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = tim.project
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = pro.organization
LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id = tim.task
LEFT OUTER JOIN " . $tablePrefix . "workcalendars_detail wcd ON wcd.workcalendar = pro.workcalendar AND wcd.date = tim.date
LEFT OUTER JOIN " . $tablePrefix . "services svc ON svc.id = tim.service
";

$initrequest["work_hours"] = "SELECT wkh.id, wkh.project, wkh.work, wkh.owner, wkh.date, wkh.hours, wkh.comments, wkh.billing, wkh.service, wkh.baseref, wkh.created, wkh.cuser, wkh.modified, wkh.muser, mem.name, pro.name, pro.type, org.name, svc.name, svc.hourly_rate, svc.hourly_rate_i, svc.currency, wcd.type, wcd.hours, wcd.comments, pro.organization, hrc.hourtype
FROM " . $tablePrefix . "work_hours wkh
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = wkh.owner
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = wkh.project
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = pro.organization
LEFT OUTER JOIN " . $tablePrefix . "services svc ON svc.id = wkh.service
LEFT OUTER JOIN " . $tablePrefix . "workcalendars_detail wcd ON wcd.workcalendar = pro.workcalendar AND wcd.date = wkh.date
LEFT OUTER JOIN " . $tablePrefix . "hour_code hrc ON hrc.id=wkh.work
";

$initrequest["timesheet"] = "SELECT tim.id,tim.owner,tim.period,tim.standard_hours,tim.actual_hours,tim.billable_hours,tim.overtime_hours,tim.status,tim.comments,tim.created,tim.cuser,tim.modified,tim.muser,mem.name,mem.login,per.fyear,per.serial_no,per.date_start,per.date_end,per.locked
FROM " . $tablePrefix . "timesheet tim
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = tim.owner
LEFT OUTER JOIN " . $tablePrefix . "periods per ON per.id = tim.period
";

$initrequest["phase_sets"] = "SELECT phs.id, phs.name, phs.phase_num, phs.created, phs.cuser, phs.modified, phs.muser, (SELECT COUNT(pro.id) FROM " . $tablePrefix . "projects pro WHERE pro.phase_set=phs.id) AS project_num
FROM " . $tablePrefix . "phase_sets phs
";

$initrequest["phases"] = "SELECT pha.id, pha.project, pha.order_num, pha.status, pha.date_start, pha.date_end, pha.comments, phs.name
FROM " . $tablePrefix . "phases pha
INNER JOIN " . $tablePrefix . "phase_sets phs ON phs.id=pha.phase_set
";

$initrequest["phases2"] = "SELECT pha.* FROM (SELECT ph2.id, ph2.project, ph2.order_num, ph2.status, ph2.date_start, ph2.date_end, ph2.comments, phs.name,
(SELECT COUNT(tas1.id) FROM " . $tablePrefix . "tasks tas1 WHERE tas1.project=ph2.project AND tas1.parent_phase=ph2.order_num AND tas1.milestone<>'" . enumMilestone::msYes . "' AND tas1.level='0') AS total_tasks,
(SELECT COUNT(tas2.id) FROM " . $tablePrefix . "tasks tas2 WHERE tas2.project=ph2.project AND tas2.parent_phase=ph2.order_num AND tas2.status<>'" . enumStatus::stCompleted . "' AND tas2.milestone<>'" . enumMilestone::msYes . "' AND tas2.level='0') AS uncompleted_tasks,
(SELECT COUNT(tas3.id) FROM " . $tablePrefix . "tasks tas3 WHERE tas3.project=ph2.project AND tas3.parent_phase=ph2.order_num AND tas3.milestone='" . enumMilestone::msYes . "' AND tas3.level='0') AS milestones
FROM " . $tablePrefix . "phases ph2
INNER JOIN " . $tablePrefix . "phase_sets phs ON phs.id=ph2.phase_set) pha
";

$initrequest["updates"] = "SELECT upd.*, mem.id, mem.name, mem.login, mem.email_work
FROM " . $tablePrefix . "updates upd
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = upd.member
";

$initrequest["support_requests"] = "SELECT sr.id, sr.status, sr.owner, sr.reproducibility, sr.severity, sr.priority, sr.subject, sr.message, sr.date_open, sr.date_close, sr.project, sr.assigned_to, sr.resolution, sr.auto_close, sr.published, pro.name, mem.name, mem.email_work, mem.profil, mem.extension_picture, mem.gender, mem2.name, mem2.email_work, mem2.profil
FROM " . $tablePrefix . "support_requests sr
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = sr.project
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = sr.owner
LEFT OUTER JOIN " . $tablePrefix . "members mem2 ON mem2.id = sr.assigned_to
";

$initrequest["support_posts"] = "SELECT sp.id, sp.request_id, sp.message, sp.date, sp.owner, sp.project, mem.name, mem.email_work, sr.subject
FROM " . $tablePrefix . "support_posts sp
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = sp.owner
LEFT OUTER JOIN " . $tablePrefix . "support_requests sr ON sr.id = sp.request_id
";

$initrequest["meetings"] = "SELECT mee.id, mee.project, mee.priority, mee.status, mee.owner, mee.name, mee.agenda, mee.location, mee.minutes, mee.duration, mee.start_time, mee.reminder, mee.reminder_time1, mee.reminder_time2, mee.confirmed, mee.allreplied, mee.created, mee.cuser, mee.modified, mee.muser, pro.name, pro.organization, mem.name, mem.login, mem.organization, mem.email_work, mem.language, mem.profil, loc.timezone
FROM " . $tablePrefix . "meetings mee
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = mee.project
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = pro.organization
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = mee.owner
LEFT OUTER JOIN " . $tablePrefix . "locations loc ON loc.id = mem.location
";

$initrequest["attendees"] = "SELECT att.meeting,att.member,att.attended,att.authorized,att.required,att.schedule_string,att.string_validto,mem.login,mem.name,mem.email_work,mem.language,mem.title,mem.phone_work,mem.profil,mem.password,mem.organization,mem.location,mee.project,mee.name,mee.agenda,mee.location,mee.priority,mee.status,mee.start_time,mee.duration,org.name,pro.name,pro.priority,pro.status,pro.published,pro.organization,pro.owner,org2.name,mem2.login,mem2.email_work,log.connected,loc.timezone
FROM " . $tablePrefix . "attendees att
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = att.member
LEFT OUTER JOIN " . $tablePrefix . "meetings mee ON mee.id = att.meeting
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = mee.project
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = mem.organization
LEFT OUTER JOIN " . $tablePrefix . "organizations org2 ON org2.id = pro.organization
LEFT OUTER JOIN " . $tablePrefix . "members mem2 ON mem2.id = pro.owner
LEFT OUTER JOIN " . $tablePrefix . "logs log ON log.login = mem.login
LEFT OUTER JOIN " . $tablePrefix . "locations loc ON loc.id = mem.location
";

$initrequest["meetings_available"] = "SELECT mav.meeting,mav.member,mav.schedule,msc.start_time,msc.canceled
FROM " . $tablePrefix . "meetings_available mav
LEFT OUTER JOIN " . $tablePrefix . "meetings_schedule msc ON msc.id=mav.schedule
";

$initrequest["meetings_schedule"] = "SELECT msc.*
FROM " . $tablePrefix . "meetings_schedule msc
";

$initrequest["meetings_time"] = "SELECT mti.*, mem.name, mee.name, pro.organization, pro.name, pro.type, org.name
FROM " . $tablePrefix . "meetings_time mti
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = mti.owner
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id = mti.project
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id = pro.organization
LEFT OUTER JOIN " . $tablePrefix . "meetings mee ON mee.id = mti.meeting
";

$initrequest["workcalendars"] = "SELECT wca.id,wca.name,wca.description,wca.created,wca.cuser,wca.modified,wca.muser
FROM " . $tablePrefix . "workcalendars wca
";

$initrequest["workcalendars_weekday"] = "SELECT wcw.id,wcw.workcalendar,wcw.year,wcw.day_type,wcw.hours,wcw.start_time,wcw.end_time,wcw.created,wcw.cuser,wcw.modified,wcw.muser
FROM " . $tablePrefix . "workcalendars_weekday wcw
INNER JOIN " . $tablePrefix . "workcalendars wca ON wca.id=wcw.workcalendar
";

$initrequest["workcalendars_detail"] = "SELECT wcd.id,wcd.workcalendar,wcd.year,wcd.date,wcd.type,wcd.hours,wcd.comments,wcd.created,wcd.cuser,wcd.modified,wcd.muser
FROM " . $tablePrefix . "workcalendars_detail wcd
INNER JOIN " . $tablePrefix . "workcalendars wca ON wca.id=wcd.workcalendar
";

$initrequest["leaves"] = "SELECT lea.id,lea.owner,lea.year,lea.type,lea.hours,lea.due_date,lea.comments,lea.created,lea.cuser,lea.modified,lea.muser,mem.login,mem.name,mem.title,mem.department,mem.email_work,mem.extension_picture,mem.gender
FROM " . $tablePrefix . "leaves lea
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = lea.owner
";

$initrequest["leave_requests"] = "SELECT lea.id, lea.owner, lea.type, lea.date_start, lea.date_end, lea.time_start, lea.time_end, lea.hours_total, lea.hours_start, lea.hours_end, lea.status, lea.comments, lea.created, lea.cuser, lea.modified, lea.muser, mem.name, mem.manager, mem.login
FROM " . $tablePrefix . "leave_requests lea
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id = lea.owner
";

$initrequest["project_permissions"] = "SELECT prp.id,prp.project,prp.profil,prp.view_project,prp.create_customer_service_site,prp.copy_project,prp.import_project,prp.export_project,prp.modify_project_properties,prp.delete_project,prp.view_project_budget,prp.view_project_cost,prp.view_phase,prp.modify_phase_properties,prp.view_task,prp.create_task,prp.copy_task,prp.modify_task_status,prp.log_task_hours,prp.material_issue,prp.arrange_task_resource,prp.modify_task_properties,prp.edit_task_relationships,prp.delete_task,prp.configure_task_security,prp.publish_task,prp.view_milestone,prp.create_milestone,prp.modify_milestone_properties,prp.delete_milestone,prp.configure_milestone_security,prp.publish_milestone,prp.view_meeting,prp.create_meeting,prp.copy_meeting,prp.modify_meeting_status,prp.log_meeting_hours,prp.arrange_meeting_resource,prp.modify_meeting_properties,prp.delete_meeting,prp.configure_meeting_security,prp.view_support_request,prp.add_support_response,prp.assign_support_request,prp.close_support_request,prp.delete_support_request,prp.view_discussion,prp.add_discussion_topic,prp.post_reply,prp.close_discussion_topic,prp.publish_discussion_topic,prp.delete_discussion_topic,prp.view_team,prp.send_message,prp.add_team_member,prp.publish_team_member,prp.modify_team_member_properties,prp.delete_team_member,prp.view_file,prp.add_file,prp.update_file,prp.publish_file,prp.delete_file,prp.view_note,prp.add_note,prp.modify_note_properties,prp.delete_note,prp.publish_note,prp.view_calendar,prp.add_calendar_event,prp.modify_calendar_event,prp.delete_calendar_event,prp.view_role,prp.configure_role_security,prp.view_expense,prp.create_expense,prp.modify_expense_properties,prp.delete_expense,prp.created,prp.cuser,prp.modified,prp.muser
FROM " . $tablePrefix . "project_permissions prp
";

$initrequest["strings"] = "SELECT str.*
FROM " . $tablePrefix . "strings str
";

$initrequest["claim_type"] = "SELECT clt.id,clt.name,clt.locked,clt.created,clt.cuser,clt.modified,clt.muser
FROM " . $tablePrefix . "claim_type clt
";

$initrequest["expense_type"] = "SELECT ext.id,ext.name,ext.claimtype,ext.locked,ext.created,ext.cuser,ext.modified,ext.muser,clt.name
FROM " . $tablePrefix . "expense_type ext
LEFT OUTER JOIN " . $tablePrefix . "claim_type clt ON clt.id=ext.claimtype
";

$initrequest["expenses"] = "SELECT exp.id,exp.project,exp.status,exp.status_approval,exp.printed,exp.owner,exp.description,exp.docdate,exp.billable,exp.claimtype,exp.expensetype,exp.amount,exp.currency,exp.recurring,exp.recurring_start,exp.recurring_finish,exp.recurring_next,exp.recurring_type,exp.recurring_frequency,exp.recurring_enabled,exp.created,exp.cuser,exp.modified,exp.muser,mem.name,mem.login,mem.email_work,pro.name,org.id,org.name,clt.name,ext.name
FROM " . $tablePrefix . "expenses exp
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=exp.project
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=exp.owner
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization
LEFT OUTER JOIN " . $tablePrefix . "claim_type clt ON clt.id=exp.claimtype
LEFT OUTER JOIN " . $tablePrefix . "expense_type ext ON ext.id=exp.expensetype
";

$initrequest['confirmation_levels'] = "SELECT con.id,con.name,con.comments,con.max_requirements
FROM " . $tablePrefix . "confirmation_levels con
";

$initrequest['confirmation_levels_detail'] = "SELECT cld.confirmation_level,cld.authorizer_type,cld.authorizer,cld.required,con.name,con.comments,con.max_requirements
FROM " . $tablePrefix . "confirmation_levels_detail cld
INNER JOIN " . $tablePrefix . "confirmation_levels con ON con.id=cld.confirmation_level
";

$initrequest['approvals'] = "SELECT app.id,app.name,app.doctype,app.conditions,app.active,app.comments,app.userquery
FROM " . $tablePrefix . "approvals app
";

$initrequest['approvals_producers'] = "SELECT apd.*,app.name,app.doctype,app.conditions,app.active
FROM (
SELECT ap0.*, mem.name
FROM " . $tablePrefix . "approvals_producers ap0
INNER JOIN " . $tablePrefix . "members mem ON mem.id=ap0.producer
WHERE ap0.producer_type='" . enumProducerType::ptUser . "'
UNION ALL
SELECT ap1.*, '' as name
FROM " . $tablePrefix . "approvals_producers ap1
WHERE ap1.producer_type='" . enumProducerType::ptProfile . "'
UNION ALL
SELECT ap2.*, dep.name
FROM " . $tablePrefix . "approvals_producers ap2
INNER JOIN " . $tablePrefix . "departments dep ON dep.id=ap2.producer
WHERE ap2.producer_type='" . enumProducerType::ptDepartment . "'
UNION ALL
SELECT ap3.*, pro.name
FROM " . $tablePrefix . "approvals_producers ap3
INNER JOIN " . $tablePrefix . "projects pro ON pro.id=ap3.producer
WHERE ap3.producer_type='" . enumProducerType::ptTeam . "'
) apd
INNER JOIN " . $tablePrefix . "approvals app ON app.id=apd.approval
";

$initrequest['approvals1'] = "SELECT v1.approval, app.conditions, app.userquery
FROM (
SELECT v0.approval, count(v0.approval) AS appcnt, (SELECT count(*) FROM " . $tablePrefix . "approvals_producers apx WHERE apx.approval=v0.approval AND apx.exclude='N') AS incnt, (SELECT count(*) FROM " . $tablePrefix . "approvals_producers apx WHERE apx.approval=v0.approval AND apx.exclude<>'N') AS excnt
FROM (
SELECT ap0.approval
FROM " . $tablePrefix . "approvals_producers ap0
INNER JOIN " . $tablePrefix . "approvals app0 ON app0.id=ap0.approval
INNER JOIN " . $tablePrefix . "members mem ON mem.id=ap0.producer
WHERE ap0.producer_type='" . enumProducerType::ptUser . "' AND ap0.producer=%producer% AND ap0.exclude='N' AND app0.doctype='%doctype%' AND app0.active='Y'
UNION ALL
SELECT ap1.approval
FROM " . $tablePrefix . "approvals_producers ap1
INNER JOIN " . $tablePrefix . "approvals app1 ON app1.id=ap1.approval
LEFT OUTER JOIN " . $tablePrefix . "members mem ON CAST(mem.profil AS char(10))=CAST(ap1.producer AS char(10))
WHERE ap1.producer_type='" . enumProducerType::ptProfile . "' AND mem.id=%producer% AND ap1.exclude='N' AND app1.doctype='%doctype%' AND app1.active='Y'
UNION ALL
SELECT ap2.approval
FROM " . $tablePrefix . "approvals_producers ap2
INNER JOIN " . $tablePrefix . "approvals app2 ON app2.id=ap2.approval
INNER JOIN " . $tablePrefix . "departments dep ON dep.id=ap2.producer
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.department=dep.id
WHERE ap2.producer_type='" . enumProducerType::ptDepartment . "' AND mem.id=%producer% AND ap2.exclude='N' AND app2.doctype='%doctype%' AND app2.active='Y'
UNION ALL
SELECT ap3.approval
FROM " . $tablePrefix . "approvals_producers ap3
INNER JOIN " . $tablePrefix . "approvals app3 ON app3.id=ap3.approval
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=ap3.producer
WHERE ap3.producer_type='" . enumProducerType::ptTeam . "' AND tea.member=%producer% AND ap3.exclude='N' AND app3.doctype='%doctype%' AND app3.active='Y'
UNION ALL
SELECT ap10.approval
FROM " . $tablePrefix . "approvals_producers ap10
INNER JOIN " . $tablePrefix . "approvals app10 ON app10.id=ap10.approval
INNER JOIN " . $tablePrefix . "members mem ON mem.id=ap10.producer
WHERE ap10.producer_type='" . enumProducerType::ptUser . "' AND ap10.producer<>%producer% AND ap10.exclude='Y' AND app10.doctype='%doctype%' AND app10.active='Y'
UNION ALL
SELECT ap11.approval
FROM " . $tablePrefix . "approvals_producers ap11
INNER JOIN " . $tablePrefix . "approvals app11 ON app11.id=ap11.approval
LEFT OUTER JOIN " . $tablePrefix . "members mem ON CAST(mem.profil AS char(10))=CAST(ap11.producer AS char(10))
WHERE ap11.producer_type='" . enumProducerType::ptProfile . "' AND mem.id<>%producer% AND ap11.exclude='Y' AND app11.doctype='%doctype%' AND app11.active='Y'
UNION ALL
SELECT ap12.approval
FROM " . $tablePrefix . "approvals_producers ap12
INNER JOIN " . $tablePrefix . "approvals app12 ON app12.id=ap12.approval
INNER JOIN " . $tablePrefix . "departments dep ON dep.id=ap12.producer
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.department=dep.id
WHERE ap12.producer_type='" . enumProducerType::ptDepartment . "' AND mem.id<>%producer% AND ap12.exclude='Y' AND app12.doctype='%doctype%' AND app12.active='Y'
UNION ALL
SELECT ap13.approval
FROM " . $tablePrefix . "approvals_producers ap13
INNER JOIN " . $tablePrefix . "approvals app13 ON app13.id=ap13.approval
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=ap13.producer
WHERE ap13.producer_type='" . enumProducerType::ptTeam . "' AND tea.member<>%producer% AND ap13.exclude='Y' AND app13.doctype='%doctype%' AND app13.active='Y'
) v0
GROUP BY v0.approval
) v1
INNER JOIN " . $tablePrefix . "approvals app ON app.id=v1.approval
WHERE (v1.incnt=0 AND v1.appcnt=v1.excnt)
OR (v1.incnt>0 AND v1.appcnt>v1.excnt)
";

$initrequest['approvals_stages'] = "SELECT aps.*,con.name,con.max_requirements
FROM " . $tablePrefix . "approvals_stages aps
INNER JOIN " . $tablePrefix . "confirmation_levels con ON con.id=aps.confirmation_level
";

$initrequest['approvals_terms'] = "SELECT apt.id,apt.approval,apt.fieldname,apt.ratio,apt.value,apt.compare_fields
FROM " . $tablePrefix . "approvals_terms apt
";

$initrequest['documents_approval_authorizers'] = "SELECT daa.document_approval,daa.confirmation_level,daa.authorizer,daa.required,daa.stage,daa.status,daa.approve_string,daa.not_approve_string,daa.string_validto,daa.comments,daa.created,daa.cuser,daa.modified,daa.muser,dap.approval,dap.owner,dap.doctype,dap.current_stage,dap.status,dap.canceled,dap.closed,dap.comments,dap.created,mem.name,mem.email_work,mem.language,mem2.name,mem2.extension_picture,mem2.gender,loc.timezone
FROM " . $tablePrefix . "documents_approval_authorizers daa
INNER JOIN " . $tablePrefix . "documents_approval dap ON dap.id=daa.document_approval
INNER JOIN " . $tablePrefix . "members mem ON mem.id=daa.authorizer
INNER JOIN " . $tablePrefix . "members mem2 ON mem2.id=dap.owner
LEFT OUTER JOIN " . $tablePrefix . "locations loc ON loc.id=mem.location
";

$initrequest['documents_approval'] = "SELECT dap.id,dap.approval,dap.owner,dap.docid,dap.doctype,dap.docdate,dap.current_stage,dap.status,dap.canceled,dap.closed,dap.comments,dap.userquery,dap.created,dap.cuser,dap.modified,dap.muser,mem.name,mem.email_work,aps.confirmation_level,con.name,con.max_requirements
FROM " . $tablePrefix . "documents_approval dap
INNER JOIN " . $tablePrefix . "members mem ON mem.id=dap.owner
LEFT OUTER JOIN " . $tablePrefix . "approvals_stages aps ON aps.approval=dap.approval AND aps.sortid=dap.current_stage
LEFT OUTER JOIN " . $tablePrefix . "confirmation_levels con ON con.id=aps.confirmation_level
";

$initrequest['periods'] = "SELECT per.*
FROM " . $tablePrefix . "periods per
";

$initrequest['currency_rates'] = "SELECT cur.*
FROM " . $tablePrefix . "currency_rates cur
";

$initrequest['tables_def'] = "SELECT tdf.id,tdf.tablename,tdf.sysdef,tdf.cfenabled,tdf.searchable,tdf.printable,tdf.mainmenu,tdf.keyfields,tdf.formfields,tdf.dispfields,tdf.dispstyle,tdf.listfields,tdf.primfields,tdf.fathertable,tdf.linkedfield,tdf.approvalenabled,tdf.publishenabled,tdf.javascript,tdf.projectrelated,tdf.history,tdf.viewurl,tdf.created,tdf.cuser,tdf.modified,tdf.muser
FROM " . $tablePrefix . "tables_def tdf
";

$initrequest['fields_def'] = "SELECT fdf.tablename,fdf.fieldname,fdf.fieldtype,fdf.length,fdf.default_value,fdf.required,fdf.unique_field,fdf.create_index,fdf.sysdef,fdf.published,fdf.linkedtable,fdf.disporder,tdf.sysdef,tdf.fathertable,tdf.history,tdf.viewurl,tdf1.sysdef
FROM " . $tablePrefix . "fields_def fdf
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdf ON tdf.tablename=fdf.tablename
LEFT OUTER JOIN " . $tablePrefix . "tables_def tdf1 ON tdf1.tablename=fdf.linkedtable
";

$initrequest['fields_valdef'] = "SELECT fvd.*
FROM " . $tablePrefix . "fields_valdef fvd
";

$initrequest['locations'] = "SELECT loc.id,loc.name,loc.timezone,loc.language,loc.locked,loc.created,loc.cuser,loc.modified,loc.muser
FROM " . $tablePrefix . "locations loc
";

$initrequest['field_filters'] = "SELECT fft.member,fft.tablename,fft.dbfieldname,fft.pattern_begin,fft.pattern_mid,fft.pattern_end,tdf.sysdef
FROM " . $tablePrefix . "field_filters fft
INNER JOIN " . $tablePrefix . "tables_def tdf ON tdf.tablename=fft.tablename
";

$initrequest['equipment_category'] = "SELECT eqc.id, eqc.name,eqc.locked
FROM " . $tablePrefix . "equipment_category eqc
";

$initrequest['equipment_type'] = "SELECT eqt.id, eqt.name,eqt.locked
FROM " . $tablePrefix . "equipment_type eqt
";

$initrequest['equipments'] = "SELECT equ.id,equ.equipment_id,equ.equipment_category,equ.equipment_type,equ.name,equ.owner,equ.location,equ.status,equ.manufacturer,equ.model,equ.serial_number,equ.purchase_date,equ.warranty,equ.cost_price,equ.cost_currency,equ.sell_price,equ.sell_currency,equ.photo,equ.locked,equ.created,equ.cuser,equ.modified,equ.muser,eqc.name,eqt.name,mem.login,mem.name,mem.email_work,loc.name
FROM " . $tablePrefix . "equipments equ
LEFT OUTER JOIN " . $tablePrefix . "equipment_category eqc ON eqc.id=equ.equipment_category
LEFT OUTER JOIN " . $tablePrefix . "equipment_type eqt ON eqt.id=equ.equipment_type
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=equ.owner
LEFT OUTER JOIN " . $tablePrefix . "locations loc ON loc.id=equ.location
";

$initrequest['hour_type'] = "SELECT hrt.id,hrt.sysdef,hrt.locked,hrt.service,hrt.created,hrt.cuser,hrt.modified,hrt.muser,serv.name
FROM " . $tablePrefix . "hour_type hrt
LEFT OUTER JOIN " . $tablePrefix . "services serv ON serv.id=hrt.service
";

$initrequest['hour_code'] = "SELECT hrc.id,hrc.hourtype,hrc.sysdef,hrc.locked,hrc.service,hrc.created,hrc.cuser,hrc.modified,hrc.muser,serv.name
FROM " . $tablePrefix . "hour_code hrc
LEFT OUTER JOIN " . $tablePrefix . "services serv ON serv.id=hrc.service
";

$initrequest['flextime_adjustment'] = "SELECT fta.id,fta.owner,fta.refdate,fta.hours,fta.comments,fta.created,fta.cuser,fta.modified,fta.muser,mem.name
FROM " . $tablePrefix . "flextime_adjustment fta
INNER JOIN " . $tablePrefix . "members mem ON mem.id=fta.owner
";

$initrequest['payment_methods'] = "SELECT pym.id,pym.name,pym.locked,pym.created,pym.cuser,pym.modified,pym.muser
FROM " . $tablePrefix . "payment_methods pym
";

$initrequest['payment_terms'] = "SELECT pyt.id,pyt.name,pyt.start_from,pyt.extra_months,pyt.extra_days,pyt.locked,pyt.created,pyt.cuser,pyt.modified,pyt.muser
FROM " . $tablePrefix . "payment_terms pyt
";

$initrequest['invoices'] = "SELECT inv.id,inv.invoice_no,inv.organization,inv.owner,inv.status,inv.status_approval,inv.printed,inv.doc_date,inv.due_date,inv.payment_terms,inv.payment_method,inv.currency,inv.before_discount,inv.discount_percent,inv.discount_sum,inv.freight,inv.tax_sum,inv.amount,inv.paid,inv.notes,inv.bill_to,inv.ship_to,inv.recurring,inv.recurring_start,inv.recurring_finish,inv.recurring_next,inv.recurring_type,inv.recurring_frequency,inv.recurring_enabled,inv.tax_group,inv.tax_group2,inv.tax_group3,inv.created,inv.cuser,inv.modified,inv.muser,org.name,org.workcalendar,pyt.name,pyt.start_from,pyt.extra_months,pyt.extra_days,pym.name
FROM " . $tablePrefix . "invoices inv
LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=inv.organization
LEFT OUTER JOIN " . $tablePrefix . "payment_terms pyt ON pyt.id=inv.payment_terms
LEFT OUTER JOIN " . $tablePrefix . "payment_methods pym ON pym.id=inv.payment_method
";

$initrequest['invoice_rows'] = "SELECT in1.id,in1.invoice,in1.description,in1.project,in1.quantity,in1.price,in1.unit,in1.discount_percent,in1.discount_sum,in1.tax_code,txc.rate,in1.tax_sum,in1.tax_code2,txc2.rate,in1.tax_sum2,in1.tax_code3,txc3.rate,in1.tax_sum3,in1.line_total,in1.created,in1.cuser,in1.modified,in1.muser,pro.name,txc.name,txc2.name,txc3.name
FROM " . $tablePrefix . "invoice_rows in1
INNER JOIN " . $tablePrefix . "invoices inv ON inv.id=in1.invoice
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=in1.project
LEFT OUTER JOIN " . $tablePrefix . "tax_codes txc ON txc.id=tax_code
LEFT OUTER JOIN " . $tablePrefix . "tax_codes txc2 ON txc2.id=tax_code2
LEFT OUTER JOIN " . $tablePrefix . "tax_codes txc3 ON txc3.id=tax_code3
";

$initrequest['tax_groups'] = "SELECT txg.id,txg.name,txg.locked,txg.created,txg.cuser,txg.modified,txg.muser
FROM " . $tablePrefix . "tax_groups txg
";

$initrequest['tax_codes'] = "SELECT txc.id,txc.tax_group,txc.name,txc.rate,txc.created,txc.cuser,txc.modified,txc.muser,txg.name
FROM " . $tablePrefix . "tax_codes txc
INNER JOIN " . $tablePrefix . "tax_groups txg ON txg.id=txc.tax_group
";

$initrequest['payments'] = "SELECT pay.id,pay.invoice,pay.currency,pay.amount,pay.doc_date,pay.payment_method,pay.notes,pay.printed,pay.created,pay.cuser,pay.modified,pay.muser,inv.invoice_no,inv.organization,pym.name
FROM " . $tablePrefix . "payments pay
INNER JOIN " . $tablePrefix . "invoices inv ON inv.id=pay.invoice
LEFT OUTER JOIN " . $tablePrefix . "payment_methods pym ON pym.id=pay.payment_method
";

$initrequest['print_layouts'] = "SELECT plt.id,plt.doc_type,plt.doc_type_ex,plt.description,plt.path,plt.start_page,plt.defaults,plt.created,plt.cuser,plt.modified,plt.muser
FROM " . $tablePrefix . "print_layouts plt
";

$initrequest['timeclock'] = "SELECT tck.id,tck.owner,tck.finish,tck.project,tck.task,tck.meeting,tck.work,tck.clockin,tck.clockout,tck.hours,tck.comments,tck.billing,tck.service,mem.name,pro.name,tas.name,mee.name,hrc.id,hrc.hourtype
FROM " . $tablePrefix . "timeclock tck
LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=tck.owner
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=tck.project
LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id=tck.task
LEFT OUTER JOIN " . $tablePrefix . "meetings mee ON mee.id=tck.meeting
LEFT OUTER JOIN " . $tablePrefix . "hour_code hrc ON hrc.id=tck.work
";

$initrequest['ui_settings'] = "SELECT uis.member,uis.uitype,uis.uiid,uis.uisettings FROM " . $tablePrefix . "ui_settings uis";

$initrequest['user_profiles'] = "SELECT upf.id,upf.name,upf.department,upf.location,upf.language,upf.date_format,upf.time_format,upf.workcalendar,upf.enable_flextime,upf.readonly,upf.sysdef,upf.locked,upf.created,upf.cuser,upf.modified,upf.muser,dep.name,loc.name,wca.name,loc.timezone
FROM " . $tablePrefix . "user_profiles upf
LEFT OUTER JOIN " . $tablePrefix . "departments dep ON dep.id=upf.department
LEFT OUTER JOIN " . $tablePrefix . "locations loc ON loc.id=upf.location
LEFT OUTER JOIN " . $tablePrefix . "workcalendars wca ON wca.id=upf.workcalendar
";

$initrequest['user_profiles_detail'] = "SELECT upd.user_profile,upd.function_name,upd.access_level,upd.granted FROM " . $tablePrefix . "user_profiles_detail upd";

$initrequest['bookmarks'] = "SELECT boo.title,boo.url,boo.created,boo.cuser FROM " . $tablePrefix . "bookmarks boo";

$initrequest['extensions'] = "SELECT ext.id,ext.name,ext.description,ext.version,ext.active,ext.created,ext.cuser,ext.modified,ext.muser FROM " . $tablePrefix . "extensions ext";