<?php // $Revision: 1.22 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: notification.class.php,v 1.22 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

require $path_prefix . 'includes/phpmailer/PHPMailerAutoload.php';

class notification extends phpmailer {
    private $to_names       = array();
    private $all_rec_names  = array();
    private $att_urls       = array();
    private $msg_from       = 1;
    private $msg_users      = array();
    private $msg_cusers     = array();
    private $msg_body       = '';
    private $msg_altbody    = '';
    private $msg_message    = '';
    public $partMessage    = '';

    function notification()
    {
        global $strings, $notificationMethod, $setCharset, $path_prefix;
        $this->Mailer = $notificationMethod;
        $this->PluginDir = $path_prefix . 'includes/phpmailer/';
        $this->SMTPOptions["ssl"] = array("verify_peer"=>false,"verify_peer_name"=>false,"allow_self_signed"=>true);
        // Sets the CharSet of the message
        $this->CharSet = $setCharset;

        if ($this->Mailer == 'smtp') {
            $this->Host = SMTPSERVER;

            if (SMTPPORT != '') {
                $this->Port = SMTPPORT;
            }

            if (SMTPSECURE != '') {
                $this->SMTPSecure = SMTPSECURE;
            }

            if (SMTPLOGIN != '') {
                $this->SMTPAuth = true;
                $this->Username = SMTPLOGIN;
                $this->Password = SMTPPASSWORD;
            }
        }

        $this->footer = "--\n" . $strings['noti_foot1'] . "\n\n" . $strings['noti_foot2'];
    }

    function getUserinfo($idUser, $type)
    {
        global $strings;
        $querymore = " WHERE mem.id='$idUser'";
        $detailUser = new request();
        $detailUser->openMembers($querymore);

        if ($type == "from") {
            $this->msg_from = $idUser;
            $this->From = $detailUser->mem_email_work[0];
            $this->FromName = $detailUser->mem_name[0];
            $this->signature = $detailUser->mem_name[0] . "\n";

            if ($detailUser->mem_title[0] == '') {
                $this->signature .= $detailUser->mem_org_name[0] . "\n";
            } else {
                $this->signature .= $detailUser->mem_title[0] . ", " . $detailUser->mem_org_name[0] . "\n";
            }

            if ($detailUser->mem_phone_work[0] != "") {
                $this->signature .= $strings["work_phone"] . " : " . $detailUser->mem_phone_work[0] . "\n";
            }

            if ($detailUser->mem_mobile[0] != "") {
                $this->signature .= $strings["mobile_phone"] . " : " . $detailUser->mem_mobile[0] . "\n";
            }

            if ($detailUser->mem_fax[0] != "") {
                $this->signature .= $strings["fax"] . " : " . $detailUser->mem_fax[0] . "\n";
            }
        }

        if ($type == 'to') {
            $this->msg_users[] = $idUser;

            if ($detailUser->mem_organization[0] != '1') {
                $this->msg_cusers[] = $idUser;
            }

            if ($detailUser->mem_email_work[0] != '') {
                $this->all_rec_names[] = $detailUser->mem_name[0];
                $this->AddAddress($detailUser->mem_email_work[0], $detailUser->mem_name[0]);
                $this->to_names[] = $detailUser->mem_name[0];
            }
        }

        if ($type == 'cc') {
            $this->msg_users[] = $idUser;

            if ($detailUser->mem_organization[0] != '1') {
                $this->msg_cusers[] = $idUser;
            }

            if ($detailUser->mem_email_work[0] != '') {
                $this->all_rec_names[] = $detailUser->mem_name[0];

                if ($this->Mailer == 'smtp') {
                    $this->AddCC($detailUser->mem_email_work[0], $detailUser->mem_name[0]);
                } else {
                    $this->AddAddress($detailUser->mem_email_work[0], $detailUser->mem_name[0]);
                }
            }
        }

        if ($type == 'bcc') {
            $this->msg_users[] = $idUser;

            if ($detailUser->mem_organization[0] != '1') {
                $this->msg_cusers[] = $idUser;
            }

            if ($detailUser->mem_email_work[0] != '') {
                $this->all_rec_names[] = $detailUser->mem_name[0];

                if ($this->Mailer == 'smtp') {
                    $this->AddBCC($detailUser->mem_email_work[0], $detailUser->mem_name[0]);
                } else {
                    $this->AddAddress($detailUser->mem_email_work[0], $detailUser->mem_name[0]);
                }
            }
        }
    }

    function openBody()
    {
        global $strings;
        $this->msg_body = "<body>\n";
        $this->msg_altbody = "";
        $this->msg_message = "";

        if (count($this->to_names) > 0) {
            $this->msg_body .= $strings["dear"];
            $this->msg_altbody .= $strings["dear"];

            foreach ($this->to_names as $usr) {
                $this->msg_body .= " $usr,";
                $this->msg_altbody .= " $usr,";
            }

            $this->msg_body .= "<br><br>\n";
            $this->msg_altbody .= "\n\n";
        }

        $this->msg_body .= $this->partMessage . "<br><br>\n";
        $this->msg_altbody .= $this->partMessage . "\n\n";
        $this->msg_message .= $this->partMessage . "<br><br>\n";
    }

    function note($url, $name = '')
    {
        global $strings, $root;

        if ($name == '') {
            $name = $strings['noti_moreinfo'];
            $this->msg_body .= "<p>$name <a href=\"$url\">" . $strings["here"] . "</a></p>\n";
            $this->msg_altbody .= "\n$name\n$url\n\n";
            $this->msg_message .= "<p>$name <a href=\"" . str_replace(array("$root/general/login.php?url=","%3F","%26"), array("../","?","&"), $url) . "\">" . $strings["here"] . "</a></p>\n";
        } else {
            $this->msg_body .= "<p>$name <a href=\"$url\">" . $strings["here"] . "</a></p>\n";
            $this->msg_altbody .= "\n$name\n$url\n\n";
            $this->msg_message .= "<p>$name <a href=\"$url\">" . $strings["here"] . "</a></p>\n";
        }
    }

    function heading($title)
    {
        $this->msg_body .= "<b>" . $title . "</b><br>\n";
        $this->msg_altbody .= $title . "\n";
        $this->msg_message .= "<h4>" . $title . "</h4><br>\n";
    }

    function plainContent($msg)
    {
        $this->msg_body .= $msg . "<br>\n";
        $this->msg_altbody .= $msg . "\n";
        $this->msg_message .= $msg . "<br>\n";
    }

    /**
     * Start a table to display sheet/form
     *
     * @see block::contentRow()
     * @access public
     */
    function openContent()
    {
        $this->msg_body .= "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
        $this->msg_message .= "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
    }

    /**
     * Display a table line in sheet/form
     *
     * @param string $left Text in left cell
     * @param string $right Text in right cell
     * @param string $mid Text in left cell ending
     * @access public
     */
    function contentRow($left, $right, $mid = " :")
    {
        if ($left != "") {
            $this->msg_body .= "<tr><td valign=\"top\" align=\"right\" width=\"27%\">" . $left . $mid . "</td><td>&nbsp;" . $right . "</td></tr>\n";
            $this->msg_altbody .= sprintf("%40s : %s\n", $left, $right);
            $this->msg_message .= "<tr><td valign=\"top\" align=\"right\" width=\"27%\">" . $left . $mid . "</td><td>&nbsp;" . $right . "</td></tr>\n";
        } else {
            $this->msg_body .= "<tr><td valign=\"top\" align=\"right\" width=\"27%\">&nbsp;</td><td>&nbsp;" . $right . "</td></tr>\n";
            $this->msg_altbody .= sprintf("%40s   %s\n", "", $right);
            $this->msg_message .= "<tr><td valign=\"top\" align=\"right\" width=\"27%\">&nbsp;</td><td>&nbsp;" . $right . "</td></tr>\n";
        }
    }

    function contentTitle($title)
    {
        $this->msg_body .= "<tr><th colspan=\"2\" align=\"left\">" . $title . "</th></tr>\n";
        $this->msg_altbody .= $title . "\n";
        $this->msg_message .= "<tr><th colspan=\"2\" align=\"left\">" . $title . "</th></tr>\n";
    }

    function closeContent()
    {
        $this->msg_body .= "</table>\n<hr>\n";
        $this->msg_altbody .= "\n";
        $this->msg_message .= "</table>\n<hr>\n";
    }

    function closeBody($notificationID = '')
    {
        global $strings, $root, $tablePrefix;
        $this->msg_body .= "<br>\n" . $this->signature . "<br>\n" . $this->footer . " <a href=\"$root/\">" . $strings["here"] . "</a>\n";
        $this->msg_altbody .= "\n" . $this->signature . "\n" . $this->footer . "\n$root/";

        if (count($this->att_urls) == 1) {
            $this->msg_message .= "<br>\n" . $strings['attach_document'] . ' : ' . $this->att_urls[0] . "<br>\n";
        } else if (count($this->att_urls) > 1) {
            $this->msg_message .= "<br>\n" . $strings['attach_documents'] . ' : ' . implode(", ", $this->att_urls) . "<br>\n";
        }

        $this->msg_message .= "<br>\n" . $this->signature . "<br>\n";

        if (($notificationID !== '') && (count($this->msg_users) === 1)) {
            $querymore = " WHERE noti.member='" . $this->msg_users[0] . "' AND noti.notiid='$notificationID'";
            $notificationDetail = new request();
            $notificationDetail->openNotifications($querymore);

            if (count($notificationDetail->not_member) > 0) {
                if ($notificationDetail->not_string_validto[0] <= (time()+3600)) {  // due in 1 hour
                    $block_string = get_rand_id(32);
                    $string_validto = time() + 43200;   // 12 hours
                    $tmpsql = "UPDATE " . $tablePrefix . "notifications SET block_string='$block_string',string_validto='$string_validto' WHERE member='" . $this->msg_users[0] . "' AND notiid='$notificationID'";
                    connectSql($tmpsql);
                } else {
                    $block_string = $notificationDetail->not_block_string[0];
                    $string_validto = $notificationDetail->not_string_validto[0];
                }
            } else {
                $block_string = get_rand_id(32);
                $string_validto = time() + 43200;   // 12 hours
                $tmpsql = "INSERT INTO " . $tablePrefix . "notifications (member,notiid,block,block_string,string_validto) VALUES ('" . $this->msg_users[0] . "','$notificationID','" . enumBoolean::bFalse . "','$block_string','$string_validto')";
                connectSql($tmpsql);
            }

            $this->msg_body .= "<br>\n" . $strings['noti_foot3'] . " <a href=\"$root/preferences/unsubscribe.php?id=$notificationID&amp;member=" . $this->msg_users[0] . "&amp;auth=$block_string\">" . $strings['here'] . "</a> " . $strings['noti_foot4'] . " <a href=\"$root/general/login.php?url=preferences/updatenotifications.php\">" . $strings['here'] . "</a>\n";
        }

        $this->msg_body .= "</body>";
    }

    function openResults()
    {
        $this->msg_body .= "<table cellpadding=\"0\" cellspacing=\"0\" border=\"1\">\n";
        $this->msg_altbody .= "\n";
        $this->msg_message .= "<table cellpadding=\"0\" cellspacing=\"0\" border=\"1\">\n";
    }

    function closeResults()
    {
        $this->msg_body .= "</table>\n</hr>\n";
        $this->msg_altbody .= "\n";
        $this->msg_message .= "</table>\n</hr>\n";
    }

    function labels($labels) {
        $this->msg_body .= "<tr>";
        $this->msg_message .= "<tr>";

        foreach ($labels as $content) {
            $this->msg_body .= "<th>$content</th>";
            $this->msg_altbody .= $content . "\t";
            $this->msg_message .= "<th>$content</th>";
        }

        $this->msg_body .= "</tr>\n";
        $this->msg_altbody .= "\n";
        $this->msg_message .= "</tr>\n";
    }

    function noresults()
    {
        global $strings;
        $this->msg_body .= "<table cellspacing=\"0\" border=\"1\" cellpadding=\"2\">\n<tr><td colspan=\"4\">" . $strings["no_items"] . "</td></tr>\n</table>\n<hr>\n";
        $this->msg_altbody .= $strings["no_items"] . "\n";
        $this->msg_message .= "<table cellspacing=\"0\" border=\"1\" cellpadding=\"2\">\n<tr><td colspan=\"4\">" . $strings["no_items"] . "</td></tr>\n</table>\n<hr>\n";
    }

    function openRow()
    {
        $this->msg_body .= "<tr>";
        $this->msg_message .= "<tr>";
    }

    function cellRow($content = null)
    {
        $this->msg_body .= "<td>$content</td>";
        $this->msg_altbody .= $content . "\t";
        $this->msg_message .= "<td>$content</td>";
    }

    function closeRow()
    {
        $this->msg_body .= "</tr>\n";
        $this->msg_altbody .= "\n";
        $this->msg_message .= "</tr>\n";
    }

    /**
     * Add an attachment
     *
     * @global string $root
     * @param string $path Path to the attachment
     * @param string $name Overrides the attachment name
     * @param mixed $id The unique id of linked content
     */
    function AddAnAttach($path, $name, $id = '')
    {
        global $root;

        if ($id != '') {
            $querymore = " WHERE fil.id='$id'";
            $fileDetail = new request();
            $fileDetail->openFiles($querymore);

            if (count($fileDetail->fil_id) > 0) {
                if (count($this->msg_cusers) == count($this->msg_users)) {
                    $this->att_urls[] .= "<a href=\"$root/service_site/clientfiledetail.php?id=$id\">$name</a>\n";
                } else {
                    $this->att_urls[] .= "<a href=\"$root/linkedcontent/viewfile.php?doc_type=0&doc_id=" . $fileDetail->fil_parent[0] . "&id=$id\">$name</a>\n";
                }
            }
        }

        parent::AddAttachment($path, $name);
    }

    /**
     * Send notification out
     *
     * @global array $tablePrefix
     * @global string $notifications
     * @param class $requestAct Transaction object
     * @param string $method 'i' - internal message only, 'e' - email only, '' - both
     */
    function SendItOut($requestAct = null, $method = '')
    {
        global $tablePrefix, $notifications;

        if ($method != 'e') {
            foreach ($this->msg_users as $idUser) {
                $tmpsql = "INSERT INTO " . $tablePrefix . "messages (from_id,to_id,message_type,subject,message,seen,archived,created) VALUES ('" . $this->msg_from . "','$idUser','S','" . HtmlEntitiesNOD($this->Subject) . "','" . HtmlEntitiesNOD($this->msg_message) . "','N','N','" . time() . "')";

                if ($requestAct === null) {
                    connectSql($tmpsql);
                } else {
                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }
        }

        if ($notifications == "true" && count($this->all_rec_names) > 0 && $method != 'i') {
            $this->Body = $this->msg_body;
            $this->AltBody = $this->msg_altbody;
            parent::Send();
        }
    }
}
