<?php // $Revision: 1.14 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: permissions-matrix.php,v 1.14 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$administrationPermissions = array(
    'Profile' => array(
        'Admin' => true
    ),
    'User' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'System Log' => array(
        'Read' => true,
        'Admin' => true
    ),
    'System Settings' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Deny IP' => array(
        'Read' => true,
        'Admin' => true
    ),
    'Service' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Material' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Equipment' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Company Detail' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Period' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Work Calendar' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Leave' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Leave Request' => array(
        'Edit' => true,
        'Admin' => true
    ),
    'Client' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Contact' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Project' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Meeting' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Approval Procedure' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'TextCustomization' => array(
        'Admin' => true
    ),
    'File' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Currency Rate' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Custom Fields' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Form Template' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Locations' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Phase Set' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Report' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Accounting' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Invoice' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Payment' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Expense' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Print Layout' => array(
        'Admin' => true
    ),
    'Calendar' => array(
        'Read' => true,
        'Admin' => true
    ),
    'Extension' => array(
        'Admin' => true
    )
);

$managerPermissions = array(
    'Profile' => array(
        'Admin' => false
    ),
    'User' => array(
        'Read' => true,
        'Write' => false,
        'Edit' => false,
        'Admin' => false
    ),
    'System Log' => array(
        'Read' => false,
        'Admin' => false
    ),
    'System Settings' => array(
        'Read' => false,
        'Edit' => false
    ),
    'Deny IP' => array(
        'Read' => false,
        'Admin' => false
    ),
    'Service' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Material' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Equipment' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Company Detail' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Period' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Work Calendar' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Leave' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Leave Request' => array(
        'Edit' => true,
        'Admin' => true
    ),
    'Client' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Contact' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Project' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Meeting' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Approval Procedure' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'TextCustomization' => array(
        'Admin' => false
    ),
    'File' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Currency Rate' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Custom Fields' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Form Template' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Locations' => array(
        'Read' => true,
        'Edit' => false
    ),
    'Phase Set' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Report' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Accounting' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Invoice' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Payment' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Expense' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Print Layout' => array(
        'Admin' => true
    ),
    'Calendar' => array(
        'Read' => true,
        'Admin' => true
    ),
    'Extension' => array(
        'Admin' => false
    )
);

$userPermissions = array(
    'Profile' => array(
        'Admin' => false
    ),
    'User' => array(
        'Read' => false,
        'Write' => false,
        'Edit' => false,
        'Admin' => false
    ),
    'System Log' => array(
        'Read' => false,
        'Admin' => false
    ),
    'System Settings' => array(
        'Read' => false,
        'Edit' => false
    ),
    'Deny IP' => array(
        'Read' => false,
        'Admin' => false
    ),
    'Service' => array(
        'Read' => true,
        'Write' => false,
        'Edit' => false,
        'Admin' => false
    ),
    'Material' => array(
        'Read' => true,
        'Write' => false,
        'Edit' => false,
        'Admin' => false
    ),
    'Equipment' => array(
        'Read' => true,
        'Write' => false,
        'Edit' => false,
        'Admin' => false
    ),
    'Company Detail' => array(
        'Read' => true,
        'Edit' => false
    ),
    'Period' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Work Calendar' => array(
        'Read' => true,
        'Write' => false,
        'Edit' => false,
        'Admin' => false
    ),
    'Leave' => array(
        'Read' => false,
        'Write' => false,
        'Edit' => false,
        'Admin' => false
    ),
    'Leave Request' => array(
        'Edit' => false,
        'Admin' => false
    ),
    'Client' => array(
        'Read' => true,
        'Write' => false,
        'Edit' => false,
        'Admin' => false
    ),
    'Contact' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Project' => array(
        'Read' => true,
        'Write' => false,
        'Edit' => false,
        'Admin' => false
    ),
    'Meeting' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Approval Procedure' => array(
        'Read' => false,
        'Write' => false,
        'Edit' => false,
        'Admin' => false
    ),
    'TextCustomization' => array(
        'Admin' => false
    ),
    'File' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => true
    ),
    'Currency Rate' => array(
        'Read' => true,
        'Edit' => false
    ),
    'Custom Fields' => array(
        'Read' => true,
        'Edit' => false
    ),
    'Form Template' => array(
        'Read' => true,
        'Edit' => false
    ),
    'Locations' => array(
        'Read' => true,
        'Edit' => false
    ),
    'Phase Set' => array(
        'Read' => true,
        'Edit' => false
    ),
    'Report' => array(
        'Read' => true,
        'Edit' => true
    ),
    'Accounting' => array(
        'Read' => true,
        'Edit' => false
    ),
    'Invoice' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => false
    ),
    'Payment' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => false
    ),
    'Expense' => array(
        'Read' => true,
        'Write' => true,
        'Edit' => true,
        'Admin' => false
    ),
    'Print Layout' => array(
        'Admin' => true
    ),
    'Calendar' => array(
        'Read' => true,
        'Admin' => true
    ),
    'Extension' => array(
        'Admin' => false
    )
);