<?php // $Revision: 1.47 $
/* vim: set expandtab ts=4 sw=4 sts=4: */
/**
 * $Id: setup.php,v 1.47 2013/02/19 14:15:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

if (version_compare(phpversion(), "7", "<")) {
    die("php version " . phpversion() . " not support");
}

require_once('../languages/lang_en.php');
require_once('../includes/defines.lib.php');
$version = '2.0';
$step = isset($_REQUEST['step'])?$_REQUEST['step']:'1';
$dbTypList = array("pg","my");
$checkList = array(
    "/administration/systeminfo.php" => "File",
    "/installation/db_var.inc.php" => "File",
    "/installation/setup_db.php" => "File",
    "/includes/library-dbspec.php" => "File",
    "/includes/request.class-dbspec.php" => "File",
    "/includes/settings.php" => "File",
    "/includes/jpgraph" => "Directory",
    "/includes/phpmailer" => "Directory",
    "/extensions" => "Directory",
    "/files" => "Directory");
$defaultFolders = array(
    "Default" => "Default upload",
    "Images" => "Image",
    "Media" => "Media",
    "PrintLayouts" => "Print layout",
    "JavaScript" => "JavaScript",
    "Logos" => "Company logos",
    "Avatars" => "Avatars",
    "Messages" => "Message pictures"
);
$setCopyright = '<!-- Powered by webTareas v' . $version . ' -->';
$setCharset = 'utf-8';
$setTitle = "webTareas Web-Based Installer";
$setDescription = 'Groupware module. Manage web projects with team collaboration, users management, tasks and projects tracking, files approval tracking, project sites clients access, customer relationship management, instant messaging.';
$setKeywords = 'management, web, projects, tasks, organizations, reports, application, module, file management, project site, team collaboration, crm, CRM, cutomer relationship management, workflow, workgroup, timesheet, chat';
$lang = 'en';
$orgSession  = '';
$scriptMinimized = '';
$path_prefix = '';
$installationType = '';
$bodyCommand = '';
$clientHeader->org_extension_logo[0] = '';
$error = '';
define('THEME', 'camping');
define('PALETTE', 'bottle-in-fall');
$blank = "true";
$fileManagement = '';
$languageSession = $lang;
$dateformatSession  = "Y-m-d|yy-mm-dd|Y-m";
$timeformatSession = "24H";
$firstDayOfWeek = "1";
require_once("../includes/block.class.php");
require_once("../includes/header.php");
$block1 = new block();
$block1->heading($setTitle . ' - Step ' . $step);
$block1->form = "setup";
$block1->openForm("../installation/setup.php?#" . $block1->form . "Anchor");

switch ($step) {
    case "1":
        echo "<input type=\"hidden\" name=\"step\" value=\"2\">";
        $block1->openViewOptions();
        $block1->itemViewOptions($block1->buildLink('../installation/upgrade.php?', 'Upgrade an existing webTareas v1.12 installation', 'in'));
        $block1->closeViewOptions();
        $block1->heading("License Agreement");
        $copying = file_get_contents("../docs/copying.txt");
        echo '<textarea readonly class="mceNoEditor" style="width:600px;height:400px;">' . $copying . '</textarea>';
        $submitName = "I accept the terms in the License Agreement";
        break;
    case "2":
        $error = false;

        foreach ($checkList as $fileChk => $fileTyp) {
            if (is_writable(".." . $fileChk) == false) {
                $error = true;
                break;
            }
        }

        if ($error) {
            messageBox("In order for the package to work correctly, the following files must be writeable by the server. Please change the permission setting for these files. (i.e. 'chmod 666 file_name' and 'chmod 777 dir_name' on a UNIX/LINUX server, or check the properties of the file and make sure the read-only flag is not set on a Windows server)");
            echo "<input type=\"hidden\" name=\"step\" value=\"2\">";
            $submitName = "Reload";
        } else {
            echo "<input type=\"hidden\" name=\"step\" value=\"3\">";
            $submitName = "Settings";
        }

        $block1->heading("Check File Permissions");
        $block1->openContent();

        foreach($checkList as $fileChk => $fileTyp) {
            if (is_writable(".." . $fileChk)) {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "$fileTyp $fileChk is writable.", "false", "");
            } else {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>$fileTyp $fileChk is NOT writable.</b>", "false", "");
            }
        }

        if (!$error) {
            $block1->contentRow('', "No errors detected.");
        }

        break;
    case "3":
        $connexion = isset($_REQUEST['connexion'])?$_REQUEST['connexion']:'online';
        $action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
        $updatechecker = isset($_REQUEST['updatechecker'])?$_REQUEST['updatechecker']:'';
        $installationType = isset($_REQUEST['installationType'])?$_REQUEST['installationType']:'';
        $dbtype = isset($_REQUEST['dbtype'])?$_REQUEST['dbtype']:'my';
        $dbserver = isset($_REQUEST['dbserver'])?$_REQUEST['dbserver']:'';
        $dblogin = isset($_REQUEST['dblogin'])?$_REQUEST['dblogin']:'';
        $dbpasswd = isset($_REQUEST['dbpasswd'])?$_REQUEST['dbpasswd']:'';
        $dbname = isset($_REQUEST['dbname'])?$_REQUEST['dbname']:'';
        $tbprefix = isset($_REQUEST['tbprefix'])?$_REQUEST['tbprefix']:chr(rand(97,122)).chr(rand(65,90)).chr(rand(48,57));
        $mkdirMethod = isset($_REQUEST['mkdirMethod'])?$_REQUEST['mkdirMethod']:'';
        $notifications = isset($_REQUEST['notifications'])?$_REQUEST['notifications']:'';
        $notificationMethod = isset($_REQUEST['notificationMethod'])?$_REQUEST['notificationMethod']:'';
        $smtpserver = isset($_REQUEST['smtpserver'])?$_REQUEST['smtpserver']:'';
        $smtpport = isset($_REQUEST['smtpport'])?$_REQUEST['smtpport']:'';
        $smtpsecure = isset($_REQUEST['smtpsecure'])?$_REQUEST['smtpsecure']:'';
        $smtplogin = isset($_REQUEST['smtplogin'])?$_REQUEST['smtplogin']:'';
        $smtppassword = isset($_REQUEST['smtppassword'])?$_REQUEST['smtppassword']:'';
        $ftpserver = isset($_REQUEST['ftpserver'])?$_REQUEST['ftpserver']:'';
        $ftplogin = isset($_REQUEST['ftplogin'])?$_REQUEST['ftplogin']:'';
        $ftppassword = isset($_REQUEST['ftppassword'])?$_REQUEST['ftppassword']:'';
        $ftpRoot = isset($_REQUEST['ftpRoot'])?$_REQUEST['ftpRoot']:'';
        $langDefault = isset($_REQUEST['langDefault'])?$_REQUEST['langDefault']:'en';
        $root = isset($_REQUEST['root'])?$_REQUEST['root']:'';
        $loginMethod = isset($_REQUEST['loginMethod'])?$_REQUEST['loginMethod']:'';
        $adminLogin = isset($_REQUEST['adminLogin'])?$_REQUEST['adminLogin']:'';
        $adminPwd = isset($_REQUEST['adminPwd'])?$_REQUEST['adminPwd']:'';
        $adminPwa = isset($_REQUEST['adminPwa'])?$_REQUEST['adminPwa']:'';
        $adminMail = isset($_REQUEST['adminMail'])?$_REQUEST['adminMail']:'';
        $useLDAP = isset($_REQUEST['useLDAP'])?$_REQUEST['useLDAP']:'false';
        $ldapserver = isset($_REQUEST['ldapserver'])?$_REQUEST['ldapserver']:'ldap://localhost:389/';
        $ldapversion = isset($_REQUEST['ldapversion'])?$_REQUEST['ldapversion']:'3';
        $basedn = isset($_REQUEST['basedn'])?$_REQUEST['basedn']:'dc=example,dc=com';
        $ldapuser = isset($_REQUEST['ldapuser'])?$_REQUEST['ldapuser']:'';
        $ldappassword = isset($_REQUEST['ldappassword'])?$_REQUEST['ldappassword']:'';
        $sitePublish = isset($_REQUEST['sitePublish'])?$_REQUEST['sitePublish']:'true';
        $enableTimesheet = isset($_REQUEST['enableTimesheet'])?$_REQUEST['enableTimesheet']:'true';
        $enableFlextime = isset($_REQUEST['enableFlextime'])?$_REQUEST['enableFlextime']:'false';
        $enableEquipment = isset($_REQUEST['enableEquipment'])?$_REQUEST['enableEquipment']:'false';
        $enableMaterial = isset($_REQUEST['enableMaterial'])?$_REQUEST['enableMaterial']:'false';
        $autoCreateDir = isset($_REQUEST['autoCreateDir'])?$_REQUEST['autoCreateDir']:'';
        $periodUnit = isset($_REQUEST['periodUnit'])?$_REQUEST['periodUnit']:'week';
        $weekRule = isset($_REQUEST['weekRule'])?$_REQUEST['weekRule']:'2';
        $firstDayOfWeek = isset($_REQUEST['firstDayOfWeek'])?$_REQUEST['firstDayOfWeek']:'1';
        $autoLockPeriod = isset($_REQUEST['autoLockPeriod'])?$_REQUEST['autoLockPeriod']:'0';
        $defaultCurrency = isset($_REQUEST['defaultCurrency'])?$_REQUEST['defaultCurrency']:'USD';
        $defaultCostMethod = isset($_REQUEST['defaultCostMethod'])?$_REQUEST['defaultCostMethod']:'1';
        $currencyOnRight = isset($_REQUEST['currencyOnRight'])?$_REQUEST['currencyOnRight']:'';
        $hourAccuracy = isset($_REQUEST['hourAccuracy'])?$_REQUEST['hourAccuracy']:'1';
        $quantityAccuracy = isset($_REQUEST['quantityAccuracy'])?$_REQUEST['quantityAccuracy']:'0';
        $measureAccuracy = isset($_REQUEST['measureAccuracy'])?$_REQUEST['measureAccuracy']:'2';
        $rateAccuracy = isset($_REQUEST['rateAccuracy'])?$_REQUEST['rateAccuracy']:'2';
        $costAccuracy = isset($_REQUEST['costAccuracy'])?$_REQUEST['costAccuracy']:'2';
        $percentAccuracy = isset($_REQUEST['percentAccuracy'])?$_REQUEST['percentAccuracy']:'2';
        $decimalPoint = isset($_REQUEST['decimalPoint'])?$_REQUEST['decimalPoint']:'.';
        $thousandsSeparator = isset($_REQUEST['thousandsSeparator'])?$_REQUEST['thousandsSeparator']:',';
        $dateFormat = isset($_REQUEST['dateFormat'])?$_REQUEST['dateFormat']:'Y-m-d|%Y-%m-%d';
        $timeFormat = isset($_REQUEST['timeFormat'])?$_REQUEST['timeFormat']:'24H';
        $contactNameFormat = isset($_REQUEST['contactNameFormat'])?$_REQUEST['contactNameFormat']:"first_name,' ',last_name";
        $gmtTimezone = isset($_REQUEST['gmtTimezone'])?$_REQUEST['gmtTimezone']:'true';
        $defaultTimezone = isset($_REQUEST['defaultTimezone'])?$_REQUEST['defaultTimezone']:'0';
        $lockThreshold = isset($_REQUEST['lockThreshold'])?$_REQUEST['lockThreshold']:'0';
        $banThreshold = isset($_REQUEST['banThreshold'])?$_REQUEST['banThreshold']:'0';
        $detectHijack = isset($_REQUEST['detectHijack'])?$_REQUEST['detectHijack']:'';
        $cryptKey = get_crypt_key();
        $basedir = preg_replace_callback('/installation$/i', function ($matches) { return ''; }, str_replace('\\', '/', dirname(__FILE__)), 1);

        if (substr($root, -1) == "/") {
            $root = substr($root, 0, -1);
        }

        if (substr($ftpRoot, -1) == "/") {
            $ftpRoot = substr($ftpRoot, 0, -1);
        }

        if ($installationType == "offline") {
            $updatechecker = "false";
        }

        if ($action == "save") {
            if ($dbserver == '') {
                $error = 'Must be insert the database Server';
            } else if ($dblogin == '') {
                $error = 'Must be insert the database Login';
            } else if ($dbname == '') {
                $error = 'Must be insert the database Name';
            } else if ($tbprefix == '') {
                $error = 'Must be insert the Table prefix';
            } else if ($root == '') {
                $error = 'Must be insert the Root path';
            } else if ($adminLogin == '') {
                $error = 'Must be insert the Admin login name';
            } else if ($adminPwd == '') {
                $error = 'Must be insert the Admin password';
            } else if ($adminPwd != $adminPwa) {
                $error = 'The two passwords you entered did not match';
            } else if ($adminMail == '') {
                $error = 'Must be insert the Admin E-mail';
            }

            if ($error == '' && $useLDAP == 'true') {
                if ($ldapserver == '') {
                    $error = 'Must be insert the URL to LDAP server';
                } else if ($basedn == '') {
                    $error = 'Must be insert the Base DN';
                } else {
                    $ds = ldap_connect($ldapserver);

                    if ($ds === false) {
                        $error = 'Could not connect to ' . $ldapserver;
                    } else if ($ldapuser != '') {
                        $r = ldap_bind($ds, $ldapuser, $ldappassword);

                        if ($r === false) {
                            $error = 'Could not connect as ' . $ldapuser . '@' . $ldapserver;
                        }

                        ldap_close($ds);
                    }
                }
            }

            if ($error == '' && $mkdirMethod == 'FTP') {
                if ($ftpserver == '') {
                    $error = 'Must be insert the Ftp server';
                } else if ($ftplogin == '') {
                    $error = 'Must be insert the Ftp login';
                } else if ($ftppassword == '') {
                    $error = 'Must be insert the Ftp password';
                } else if ($ftpRoot == '') {
                    $error = 'Must be insert the Ftp root';
                } else {
                    $f = ftp_connect($ftpserver);

                    if ($f === false) {
                        $error = 'Could not connect to ' . $ftpserver;
                    } else {
                        if (ftp_login($f, $ftplogin, $ftppassword)) {
                            if (!ftp_chdir($f, $ftpRoot)) {
                                $error = 'Could not change ftp directory ' . $ftpRoot;
                            }
                        } else {
                            $error = 'Could not connect as ' . $ftplogin . '@' . $ftpserver;
                        }

                        ftp_close($f);
                    }
                }
            }
        }

        if ($error != '') {
            messageBox($error);
            $action = "";
        }

        if ($action != "save") {
            $block1->heading("Settings");
            $block1->openContent();
            /**
             * general section
             */
            $block1->contentTitle("General");

            if ($connexion == "offline") {
                echo "<input value=\"false\" name=\"updatechecker\" type=\"hidden\">";
            } else if (@join('', file("http://webtareas.sourceforge.net/version.txt"))) {
                echo "<input value=\"true\" name=\"updatechecker\" type=\"hidden\">";
            } else {
                echo "<input value=\"false\" name=\"updatechecker\" type=\"hidden\">";
            }
            // installation type - online, offline
            $block1->contentRow("* Installation type", "<ul><li><input type=\"radio\" name=\"installationType\" value=\"offline\"" . (($connexion == "offline")?' checked':'') . "> Offline (firewall/intranet, no update checker)</li><li><input type=\"radio\" name=\"installationType\" value=\"online\"" . (($connexion == "offline")?'':' checked') . "> Online</li></ul>");
            // database type - postgresql, mysql
            $block1->contentRow("* Database type", "<ul><li><input type=\"radio\" name=\"dbtype\" value=\"pg\"" . (($dbtype=='pg')?' checked':'') . "> PostgreSQL</li><li><input type=\"radio\" name=\"dbtype\" value=\"my\"" . (($dbtype=='my')?' checked':'') . "> MySQL</li></ul>");
            // database server name
            $block1->contentRow("* Database server", "<input size=\"44\" value=\"$dbserver\" name=\"dbserver\" maxlength=\"100\" type=\"text\">");
            // database login user id
            $block1->contentRow("* Database login", "<input size=\"44\" value=\"$dblogin\" name=\"dblogin\" maxlength=\"100\" type=\"text\">");
            // database password
            $block1->contentRow("Database password", "<input size=\"44\" value=\"$dbpasswd\" name=\"dbpasswd\" maxlength=\"100\" type=\"password\">");
            // database name
            $block1->contentRow("* Database name", "<input size=\"44\" value=\"$dbname\" name=\"dbname\" maxlength=\"100\" type=\"text\">");
            // table prefix
            $block1->contentRow("* Table prefix" . $block1->printHelp(addslashes($strings["setup_dbprefix"]), true), "<input size=\"44\" value=\"$tbprefix\" name=\"tbprefix\" maxlength=\"100\" type=\"text\">");
            $safemodeTest = ini_get("safe_mode");
            $mailTest = function_exists('mail');
            $mswinTest = substr(PHP_OS, 0, 3);
            // create folder method - php/ftp
            $block1->contentRow("* Create folder method" . $block1->printHelp(addslashes($strings["setup_mkdirMethod"]), true), "<ol><li><input type=\"radio\" name=\"mkdirMethod\" value=\"PHP\" " . (($safemodeTest!='1')?'checked':'') . "> PHP</li>"
                . "<li><input type=\"radio\" name=\"mkdirMethod\" value=\"FTP\" " . (($safemodeTest=='1')?'checked':'') . "> FTP [Safe-mode " . (($safemodeTest=='1')?'on':'off') . "]</li>"
                . "<li><div class=\"leftValue\">Ftp server</div><div class=\"rightValue\"><input value=\"$ftpserver\" name=\"ftpserver\" maxlength=\"100\" type=\"text\"></div></li>"
                . "<li><div class=\"leftValue\">Ftp login</div><div class=\"rightValue\"><input value=\"$ftplogin\" name=\"ftplogin\" maxlength=\"100\" type=\"text\"></div></li>"
                . "<li><div class=\"leftValue\">Ftp password</div><div class=\"rightValue\"><input value=\"$ftppassword\" name=\"ftppassword\" maxlength=\"100\" type=\"password\"></div></li>"
                . "<li><div class=\"leftValue\">Ftp root</div><div class=\"rightValue\"><input value=\"$ftpRoot\" name=\"ftpRoot\" maxlength=\"255\" type=\"text\"></div></li></ol>");
            // notifications - on, off
            $block1->contentRow("* Notifications" . $block1->printHelp(addslashes($strings["setup_notifications"]), true), "<ul><li><input type=\"radio\" name=\"notifications\" value=\"true\" checked> True [Mail " . (($mailTest)?'on':'off') . "]</li><li><input type=\"radio\" name=\"notifications\" value=\"false\"> False</li></ul>");
            // notification method - php mail/smtp
            $block1->contentRow("Notification method" . $block1->printHelp(addslashes($strings["setup_notificationMethod"]), true), "<ol><li><input type=\"radio\" name=\"notificationMethod\" value=\"mail\" " . (($mswinTest=='WIN')?'':'checked') . "> PHP mail function</li>"
                . "<li><input type=\"radio\" name=\"notificationMethod\" value=\"smtp\" " . (($mswinTest=='WIN')?'checked':'') . "> SMTP</li>"
                . "<li><div class=\"leftValue\">Smtp server</div><div class=\"rightValue\"><input value=\"\" name=\"smtpserver\" maxlength=\"100\" type=\"text\"></div></li>"
                . "<li><div class=\"leftValue\">Smtp port</div><div class=\"rightValue\"><input value=\"\" name=\"smtpport\" maxlength=\"3\" type=\"text\"></div></li>"
                . "<li><div class=\"leftValue\">Smtp connection prefix</div><div class=\"rightValue\"><select name=\"smtpsecure\"><option value=\"\"></option><option value=\"ssl\">ssl</option><option value=\"tls\">tls</option></select></div></li>"
                . "<li><div class=\"leftValue\">Smtp login</div><div class=\"rightValue\"><input value=\"\" name=\"smtplogin\" maxlength=\"100\" type=\"text\"></div></li>"
                . "<li><div class=\"leftValue\">Smtp password</div><div class=\"rightValue\"><input value=\"\" name=\"smtppassword\" maxlength=\"100\" type=\"password\"></div></li></ol>");
            // load language list
            require_once('../languages/languages.inc.php');
            // build lang drop list
            array_multisort($langValue, SORT_ASC, SORT_STRING);
            $selectLanguage = '<select name="langDefault">';

            foreach ($langValue as $key => $value) {
                if (file_exists('../languages/lang_' . $key . '.php')) {
                    $selectLanguage .= '<option value="' . $key . '"';

                    if ($key == $langDefault) {
                        $selectLanguage .= ' selected';
                    }

                    $selectLanguage .= '>' . $value . '</option>';
                }
            }

            $selectLanguage .= '</select>';
            // default language
            $block1->contentRow("* Default language" . $block1->printHelp(addslashes($strings["setup_langdefault"]), true), $selectLanguage);
            // load currency list
            require_once('../includes/currency.inc.php');
            // build currency drop list
            $currencyStr = '<select name="defaultCurrency">';
            $helpStr1 = '<table>';

            foreach ($CurrencyMatrix['active'] as $currCode) {
                $currName = $CurrencyMatrix['name'][$currCode];
                $helpStr1 .= '<tr><th>' . $currCode . '</th><td>' . $currName . '</td></tr>';
                $currencyStr .= '<option value="' . $currCode . '"';

                if ($currCode == $defaultCurrency) {
                    $currencyStr .= ' selected';
                }

                $currencyStr .= '>' . $currCode . '</option>';
            }

            $currencyStr .= '</select>';
            $helpStr1 .= '</table>';
            // default currency
            $block1->contentRow("* Default currency" . $block1->printHelp($helpStr1, true), $currencyStr);
            // enable client collaboration
            $block1->contentRow("Client Collaboration", "<ul><li><input type=\"radio\" name=\"sitePublish\" value=\"true\"" . (($sitePublish == "true")?' checked':'') . "> True</li><li><input type=\"radio\" name=\"sitePublish\" value=\"false\"" . (($sitePublish == "true")?'':' checked') . "> False</li></ul>");
            // enable timesheet
            $block1->contentRow("Enable Timesheet", "<ul><li><input type=\"radio\" name=\"enableTimesheet\" value=\"true\"" . (($enableTimesheet == "true")?' checked':'') . "> True</li><li><input type=\"radio\" name=\"enableTimesheet\" value=\"false\"" . (($enableTimesheet == "true")?'':' checked') . "> False</li></ul>");
            // enable flextime
            $block1->contentRow("Enable Flextime", "<ul><li><input type=\"radio\" name=\"enableFlextime\" value=\"true\"" . (($enableFlextime == "true")?' checked':'') . "> True</li><li><input type=\"radio\" name=\"enableFlextime\" value=\"false\"" . (($enableFlextime == "true")?'':' checked') . "> False</li></ul>");
            // enable equipment management
            $block1->contentRow("Enable Equipment Management", "<ul><li><input type=\"radio\" name=\"enableEquipment\" value=\"true\"" . (($enableEquipment == "true")?' checked':'') . "> True</li><li><input type=\"radio\" name=\"enableEquipment\" value=\"false\"" . (($enableEquipment == "true")?'':' checked') . "> False</li></ul>");
            // enable material management
            $block1->contentRow("Enable Material Management", "<ul><li><input type=\"radio\" name=\"enableMaterial\" value=\"true\"" . (($enableMaterial == "true")?' checked':'') . "> True</li><li><input type=\"radio\" name=\"enableMaterial\" value=\"false\"" . (($enableMaterial == "true")?'':' checked') . "> False</li></ul>");
            // default project cost method
            $block1->contentRow("Default Project Cost Method", '<ol><li>
<input type="radio" name="defaultCostMethod" value="1"' . (($defaultCostMethod=='1')?' checked':'') . '>Use the cost rate of member only</li><li>
<input type="radio" name="defaultCostMethod" value="2"' . (($defaultCostMethod=='2')?' checked':'') . '>Use the hourly rate of service first and use the cost rate of member if no service specified</li><li>
<input type="radio" name="defaultCostMethod" value="3"' . (($defaultCostMethod=='3')?' checked':'') . '>Use the hourly rate of service only</li></ol>');
            // auto create project folder
            $block1->contentRow("Auto Create Project Folder", "<ul><li><input type=\"radio\" name=\"autoCreateDir\" value=\"true\"" . (($autoCreateDir == "true")?' checked':'') . "> True</li><li><input type=\"radio\" name=\"autoCreateDir\" value=\"false\"" . (($autoCreateDir == "true")?'':' checked') . "> False</li></ul>");
            // hint for the first week of the year rule
            $helpStr2 = '<table><tr><th>First day</th><td>Indicates that the first week of the year starts on the first day of the year and ends before the following designated first day of the week</td></tr><tr><th>First full week</th><td>Indicates that the first week of the year begins on the first occurrence of the designated first day of the week on</td></tr><tr><th>First four day week</th><td>Indicates that the first week of the year is the first week with four or more days before the designated first day of the week.</td></tr></table>';
            // unit of period - month/week
            $block1->contentRow('Unit of Period', '
<ol>
    <li><input type="radio" name="periodUnit" value="month" ' . (($periodUnit == 'month')?'checked':'') . '> Month</li>
    <li><input type="radio" name="periodUnit" value="week" ' . (($periodUnit == 'month')?'':'checked') . '> Week</li>
    <li><div class="contentRow">
        <div class="leftValue">The first week of the year' . $block1->printHelp($helpStr2, true) . '</div>
        <div class="rightValue">
            <select name="weekRule">
                <option value="0"' . (($weekRule=='0')?' selected':'') . '>First day</option>
                <option value="1"' . (($weekRule=='1')?' selected':'') . '>First full week</option>
                <option value="2"' . (($weekRule=='2')?' selected':'') . '>First four day week</option>
            </select>
        </div>
    </div></li>
    <li><div class="contentRow">
        <div class="leftValue">The first day of the week</div>
        <div class="rightValue">
            <select name="firstDayOfWeek">
                <option value="1"' . (($firstDayOfWeek=='1')?' selected':'') . '>Monday</option>
                <option value="2"' . (($firstDayOfWeek=='2')?' selected':'') . '>Tuesday</option>
                <option value="3"' . (($firstDayOfWeek=='3')?' selected':'') . '>Wednesday</option>
                <option value="4"' . (($firstDayOfWeek=='4')?' selected':'') . '>Thursday</option>
                <option value="5"' . (($firstDayOfWeek=='5')?' selected':'') . '>Friday</option>
                <option value="6"' . (($firstDayOfWeek=='6')?' selected':'') . '>Saturday</option>
                <option value="7"' . (($firstDayOfWeek=='7')?' selected':'') . '>Sunday</option>
            </select>
        </div>
    </div></li>
</ol>');
            // build auto lock period drop list
            $autoLockStr = '<select name="autoLockPeriod">';

            foreach (array('0', '1', '2', '3', '5', '7', '14', '21', '28') as $d) {
                if ($d == $autoLockPeriod) {
                    $autoLockStr .= '<option value="' . $d . '" selected>' . $d . '</option>';
                } else {
                    $autoLockStr .= '<option value="' . $d . '">' . $d . '</option>';
                }
            }

            $autoLockStr .= '</select>';
            // auto lock period
            $block1->contentRow("Auto Lock Period". $block1->printHelp(addslashes($strings["setup_autolockperiod"]), true), $autoLockStr);
            // website url root
            $url = $_SERVER['SERVER_NAME'];

            if ($_SERVER['SERVER_PORT'] != 80 && $_SERVER['SERVER_PORT'] != 443) {
                $url .= ":" . $_SERVER['SERVER_PORT'];
            }

            if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == "on") {
                $protocol = "https://";
            } else {
                $protocol = "http://";
            }

            $root = $protocol . $url . dirname($_SERVER['PHP_SELF']);
            $root = str_replace("installation", "", $root);
            $block1->contentRow("* Root", "<input size=\"44\" value=\"$root\" style=\"width: 200px\" name=\"root\" maxlength=\"100\" type=\"text\">");
            // login method - plain, md5, crypt
            $block1->contentRow("* Login method" . $block1->printHelp(addslashes($strings["setup_loginmethod"]), true), "<ul><li><input type=\"radio\" name=\"loginMethod\" value=\"PLAIN\"> Plain</li><li><input type=\"radio\" name=\"loginMethod\" value=\"MD5\" checked> Md5</li><li><input type=\"radio\" name=\"loginMethod\" value=\"CRYPT\"> Crypt</li></ul>");
            // website administrator id
            $block1->contentRow("* Admin login", "<input size=\"44\" value=\"$adminLogin\" name=\"adminLogin\" maxlength=\"100\" type=\"text\">");
            // website administrator password
            $block1->contentRow("* Admin password", "<input size=\"44\" value=\"$adminPwd\" name=\"adminPwd\" maxlength=\"100\" type=\"password\">");
            // confirm password
            $block1->contentRow("* Confirm password", "<input size=\"44\" value=\"$adminPwa\" name=\"adminPwa\" maxlength=\"100\" type=\"password\">");
            // website administrator e-mail address
            $block1->contentRow("* Admin E-mail", "<input size=\"44\" value=\"$adminMail\" name=\"adminMail\" maxlength=\"255\" type=\"text\">");
            /**
             * ldap integration section
             */
            $block1->contentTitle("LDAP Integration");
            // enable ldap integration
            $block1->contentRow("Enable LDAP Integration", "<ul><li><input type=\"radio\" name=\"useLDAP\" value=\"true\"" . (($useLDAP == "true")?' checked':'') . "> True</li><li><input type=\"radio\" name=\"useLDAP\" value=\"false\"" . (($useLDAP == "true")?'':' checked') . "> False</li></ul>");
            // ldap server url
            $block1->contentRow("URL to LDAP server", "<input size=\"44\" value=\"$ldapserver\" name=\"ldapserver\" maxlength=\"100\" type=\"text\">");
            // ldap protocol version
            $block1->contentRow("LDAP protocol version", "<ul><li><input type=\"radio\" name=\"ldapversion\" value=\"2\"" . (($ldapversion == "2")?' checked':'') . "> 2</li><li><input type=\"radio\" name=\"ldapversion\" value=\"3\"" . (($ldapversion == "2")?'':' checked') . "> 3</li></ul>");
            // ldap base dn
            $block1->contentRow("Base DN", "<input size=\"44\" value=\"$basedn\" name=\"basedn\" maxlength=\"255\" type=\"text\">");
            // ldap user dn
            $block1->contentRow("User DN", "<input size=\"44\" value=\"$ldapuser\" name=\"ldapuser\" maxlength=\"255\" type=\"text\">");
            // ldap password
            $block1->contentRow("Password", "<input size=\"44\" value=\"$ldappassword\" name=\"ldappassword\" maxlength=\"100\" type=\"password\">");
            /**
             * display section
             */
            $block1->contentTitle("Display");
            $contactNameFormats = array(
                "first_name,' ',last_name" => 'First Name Last Name',
                "last_name,', ',first_name" => 'Last Name, First Name',
                "last_name,' ',first_name" => 'Last Name First Name',
                "last_name,first_name" => 'Last NameFirst Name',
                "salutaion,' ',first_name" => 'Salutation First Name',
                "salutation,' ',first_name,' ',last_name" => 'Salutation First Name Last Name',
                "last_name,first_name,salutation" => 'Last NameFirst NameSalutation'
            );
            $contactNameFormatSel = '<select name="contactNameFormat">';

            foreach ($contactNameFormats as $key => $val) {
                if ($contactNameFormat == $key) {
                    $contactNameFormatSel .= '<option value="' . $key . '" selected>' . $val . '</option>';
                } else {
                    $contactNameFormatSel .= '<option value="' . $key . '">' . $val . '</option>';
                }
            }

            $contactNameFormatSel .= '</select>';
            $block1->contentRow('Contact Name Format', $contactNameFormatSel);
            setupDecimalPlaceSelectionHtml($block1, "Decimal Place for Log Hours", "hourAccuracy", $hourAccuracy);
            setupDecimalPlaceSelectionHtml($block1, "Decimal Place for Quantity", "quantityAccuracy", $quantityAccuracy);
            setupDecimalPlaceSelectionHtml($block1, "Decimal Place for Measure", "measureAccuracy", $measureAccuracy);
            setupDecimalPlaceSelectionHtml($block1, "Decimal Place for Service Rate/Price", "rateAccuracy", $rateAccuracy);
            setupDecimalPlaceSelectionHtml($block1, "Decimal Place for Project Cost/Expense/Totals", "costAccuracy", $costAccuracy);
            setupDecimalPlaceSelectionHtml($block1, "Decimal Place for Percentage", "percentAccuracy", $percentAccuracy);
            $block1->contentRow('Separator for the decimal point', '<input type="text" name="decimalPoint" value="' . $decimalPoint . '" size="2" maxlength="2">');
            $block1->contentRow('Thousands separator', '<input type="text" name="thousandsSeparator" value="' . $thousandsSeparator . '" size="2" maxlength="2">');
            $dateFormatSel = '<select name="dateFormat">';
            $dateFormats = array(
                'Y-m-d|yy-mm-dd|Y-m'=>'YYYY-MM-DD Ex: 2010-01-09',
                'd-m-Y|dd-mm-yy|m-Y'=>'DD-MM-YYYY Ex: 09-01-2010',
                'd-m-y|dd-mm-y|m-y'=>'DD-MM-YY   Ex: 09-01-10',
                'd/m/Y|dd/mm/yy|m/Y'=>'DD/MM/YYYY Ex: 09/01/2010',
                'd/m/y|dd/mm/y|m/y'=>'DD/MM/YY   Ex: 09/01/10',
                'j/n/Y|d/m/yy|n/Y'=>'D/M/YYYY   Ex: 9/1/2010',
                'j/n/y|d/m/y|n/y'=>'D/M/YY     Ex: 9/1/10',
                'm/d/Y|mm/dd/yy|m/Y'=>'MM/DD/YYYY Ex: 01/09/2010',
                'm/d/y|mm/dd/y|m/y'=>'MM/DD/YY   Ex: 01/09/10',
                'j.m.Y|d.mm.yy|m.Y'=>'D.MM.YYYY  Ex: 9.01.2010',
                'j.n.Y|d.m.yy|n.Y'=>'D.M.YYYY   Ex: 9.1.2010',
                'd.m.Y|dd.mm.yy|m.Y'=>'DD.MM.YYYY Ex: 09.01.2010',
                'd.m.y|dd.mm.y|m.y'=>'DD.MM.YY   Ex: 09.01.2010',
                'j.n.y|d.m.y|n.y'=>'D.M.YY     Ex: 9.1.10',
                'Y.m.d|yy.mm.dd|Y.m'=>'YYYY.MM.DD Ex: 2010.01.09',
                'd m Y|dd mm yy|m Y'=>'DD MM YYYY Ex: 09 01 2010',
                'd m y|dd mm y|m y'=>'DD MM YY   Ex: 09 01 10');

            foreach ($dateFormats as $key => $val) {
                if ($key == $dateFormat) {
                    $dateFormatSel .= '<option value="' . $key . '" selected>' . $val . '</option>';
                } else {
                    $dateFormatSel .= '<option value="' . $key . '">' . $val . '</option>';
                }
            }

            $dateFormatSel .= '</select>';
            $block1->contentRow("Default Date Format", $dateFormatSel);
            $timeFormatSel = '<select name="timeFormat">';
            $timeFormats = array('12H', '24H');

            foreach ($timeFormats as $i) {
                if ($i == $timeFormat) {
                    $timeFormatSel .= '<option value="' . $i . '" selected>' . $i . '</option>';
                } else {
                    $timeFormatSel .= '<option value="' . $i . '">' . $i . '</option>';
                }
            }

            $timeFormatSel .= '</select>';
            $block1->contentRow("Default Time Format", $timeFormatSel);
            $block1->contentRow('Enable GMT Timezone', '<ul><li><input type="radio" name="gmtTimezone" value="true" ' . (($gmtTimezone == 'true')?'checked':'') . '> True</li><li><input type="radio" name="gmtTimezone" value="false" ' . (($gmtTimezone == 'true')?'':'checked') . '> False</li></ul>');
            $timezoneTable = array(
                "-12" => $strings["GMT -12:00"],
                "-11" => $strings["GMT -11:00"],
                "-10" => $strings["GMT -10:00"],
                "-9" => $strings["GMT -9:00"],
                "-8" => $strings["GMT -8:00"],
                "-7" => $strings["GMT -7:00"],
                "-6" => $strings["GMT -6:00"],
                "-5" => $strings["GMT -5:00"],
                "-4" => $strings["GMT -4:00"],
                "-3.5" => $strings["GMT -3:30"],
                "-3" => $strings["GMT -3:00"],
                "-2" => $strings["GMT -2:00"],
                "-1" => $strings["GMT -1:00"],
                "0" => $strings["GMT"],
                "1" => $strings["GMT +1:00"],
                "2" => $strings["GMT +2:00"],
                "3" => $strings["GMT +3:00"],
                "3.5" => $strings["GMT +3:30"],
                "4" => $strings["GMT +4:00"],
                "4.5" => $strings["GMT +4:30"],
                "5" => $strings["GMT +5:00"],
                "5.5" => $strings["GMT +5:30"],
                "6" => $strings["GMT +6:00"],
                "7" => $strings["GMT +7:00"],
                "8" => $strings["GMT +8:00"],
                "9" => $strings["GMT +9:00"],
                "9.5" => $strings["GMT +9:30"],
                "10" => $strings["GMT +10:00"],
                "11" => $strings["GMT +11:00"],
                "12" => $strings["GMT +12:00"]
                );
            $defaultTimezoneSel = '<select id="dtz" name="defaultTimezone">';

            foreach ($timezoneTable as $val => $desc) {
                if ($val == $defaultTimezone) {
                    $defaultTimezoneSel .= '<option value="' . $val . '" selected>' . $desc . '</option>';
                } else {
                    $defaultTimezoneSel .= '<option value="' . $val . '">' . $desc . '</option>';
                }
            }

            $defaultTimezoneSel .= '</select>';
?>
<script>
    $(document).ready(function() {
        var offset = new Date().getTimezoneOffset();
        var val = 0 - offset / 60;
        $('#dtz').val(val);
    });
</script>
<?php
            $block1->contentRow('Default Timezone', $defaultTimezoneSel);
            $block1->contentRow("Display Currency on the Right", "<ul><li><input type=\"radio\" name=\"currencyOnRight\" value=\"true\"" . (($currencyOnRight == "true")?' checked':'') . "> True</li><li><input type=\"radio\" name=\"currencyOnRight\" value=\"false\"" . (($currencyOnRight == "true")?'':' checked') . "> False</li></ul>");
            /**
             * security section
             */
            $block1->contentTitle('Security');
            $lockThresholdSel = '<select name="lockThreshold">';
            $lockThresholdOpts = array('0', '3', '5', '10');

            foreach ($lockThresholdOpts as $i) {
                $desc = ($i==0)?'Never':$i;
                $lockThresholdSel .= '<option value="' . $i . '"' . ((strval($lockThreshold) == strval($i))?' selected':'') . '>' . $desc . '</option>';
            }

            $lockThresholdSel .= '</select>';
            $block1->contentRow('Account Lockout Threshold', $lockThresholdSel);
            $banThresholdSel = '<select name="banThreshold">';
            $banThresholdOpts = array('0', '15', '25', '50');

            foreach ($banThresholdOpts as $i) {
                $desc = ($i==0)?'Never':$i;
                $banThresholdSel .= '<option value="' . $i . '"' . ((strval($banThreshold) == strval($i))?' selected':'') . '>' . $desc . '</option>';
            }

            $banThresholdSel .= '</select>';
            $block1->contentRow("IP Banned Threshold" . $block1->printHelp(addslashes($strings["setup_banThreshold"]), true), $banThresholdSel);
            $block1->contentRow('Detect Suspicious Sign-In', '<ul><li><input type="radio" name="detectHijack" value="on"' . (($detectHijack=='on')?' checked':'') . '> On</li><li><input type="radio" name="detectHijack" value=""' . (($detectHijack=='')?' checked':'') . '> Off</li></ul>');
            echo "<input type=\"hidden\" name=\"step\" value=\"3\">";
            echo "<input type=\"hidden\" name=\"action\" value=\"save\">";
            $submitName = "Save";
            break;
        }
    case "4":
        $error = false;
        $block1->heading("Save settings");
        $block1->openContent();
        $pathToOpenssl = '/usr/bin/openssl';
        $htaccessAuth = 'false';
        $fullPath = '/var/www/html/webtareas/files';
        $fileManagement = 'true';
        $allowPhp = 'false';
        $peerReview = 'true';
        $activeJpgraph = 'true';
        $footerDev = 'false';
        $projectsFilter = 'true';
        $enableHelpSupport = 'true';
        $supportEmail = $adminMail;
        $siteOff = 'false';
        $devMode = 'false';
        $upload_max_filesize = strtoupper((ini_get('upload_max_filesize')=='')?'2097152':ini_get('upload_max_filesize'));
        $m = strtok($upload_max_filesize, 'M');
        $k = strtok($upload_max_filesize, 'K');
        $dbtypename = (($dbtype=='pg')?'PostgreSQL':'MySQL');

        if ($m !== false && is_numeric($m)) {
            $upload_max_filesize = $m * 1048576;
        } else if ($k !== false && is_numeric($k)) {
            $upload_max_filesize = $k * 1024;
        } else if (!is_numeric($upload_max_filesize)) {
            $upload_max_filesize = '2097152';
        }

        foreach ($checkList as $fileChk => $fileTyp) {
            if ($fileTyp == "File" && $fileChk != "/includes/settings.php") {
                $content = file_get_contents(".." . $fileChk . "." . $dbtype);

                if (write_file($content, ".." . $fileChk)) {
                    $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "$fileTyp $fileChk copied.", "false", "");
                } else {
                    $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>$fileTyp $fileChk DID NOT copy.</b>", "false", "");
                    $error = true;
                }
            }
        }

        if (!$error) {
            $htmlEntityCharset = 'UTF-8';
            require_once('./setup_settings.php');

            if (write_file($content, "../includes/settings.php")) {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "File /includes/settings.php created.", "false", "");
            } else {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>File /includes/settings.php DID NOT create.</b>", "false", "");
                $error = true;
            }
        }

        if (!$error) {
            $dirCpy = "/includes/jpgraph-4.2.0";

            if (dircpy(".." . $dirCpy, "../includes/jpgraph")) {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "Files in /includes/jpgraph created.", "false", "");
            } else {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Files in /includes/jpgraph DID NOT create.</b>", "false", "");
                $error = true;
            }
        }

        if (!$error) {
            $dirCpy = "/includes/PHPMailer-5.2.19";

            if (dircpy(".." . $dirCpy, "../includes/phpmailer")) {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "Files in /includes/phpmailer created.", "false", "");
            } else {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Files in /includes/phpmailer DID NOT create.</b>", "false", "");
                $error = true;
            }
        }

        if (!$error) {
            $block1->contentRow('', "Configuration data has been saved successfully.");
            $submitName = "Create default folders";
            echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
            echo "<input type=\"hidden\" name=\"dbtype\" value=\"$dbtype\">";
            echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
            echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
            echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
            echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
            echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
            echo "<input type=\"hidden\" name=\"adminLogin\" value=\"$adminLogin\">";
            echo "<input type=\"hidden\" name=\"adminPwd\" value=\"$adminPwd\">";
            echo "<input type=\"hidden\" name=\"adminMail\" value=\"$adminMail\">";
            echo "<input type=\"hidden\" name=\"loginMethod\" value=\"$loginMethod\">";
            echo "<input type=\"hidden\" name=\"mkdirMethod\" value=\"$mkdirMethod\">";
            echo "<input type=\"hidden\" name=\"ftpserver\" value=\"$ftpserver\">";
            echo "<input type=\"hidden\" name=\"ftplogin\" value=\"$ftplogin\">";
            echo "<input type=\"hidden\" name=\"ftppassword\" value=\"$ftppassword\">";
            echo "<input type=\"hidden\" name=\"ftpRoot\" value=\"$ftpRoot\">";
            echo "<input type=\"hidden\" name=\"langDefault\" value=\"$langDefault\">";
            echo "<input type=\"hidden\" name=\"enableTimesheet\" value=\"$enableTimesheet\">";
            echo "<input type=\"hidden\" name=\"enableFlextime\" value=\"$enableFlextime\">";
            echo "<input type=\"hidden\" name=\"enableEquipment\" value=\"$enableEquipment\">";
            echo "<input type=\"hidden\" name=\"enableMaterial\" value=\"$enableMaterial\">";
            echo "<input type=\"hidden\" name=\"step\" value=\"5\">";
        } else {
            $submitName = "Restart from the beginning";
            echo "<input type=\"hidden\" name=\"step\" value=\"\">";
        }

        break;
    case "5":
        $root = $_REQUEST['root'];
        $dbtype = $_REQUEST['dbtype'];
        $dbserver = $_REQUEST['dbserver'];
        $dblogin = $_REQUEST['dblogin'];
        $dbpasswd = $_REQUEST['dbpasswd'];
        $dbname = $_REQUEST['dbname'];
        $tbprefix = $_REQUEST['tbprefix'];
        $adminLogin = $_REQUEST['adminLogin'];
        $adminPwd = $_REQUEST['adminPwd'];
        $adminMail = $_REQUEST['adminMail'];
        $loginMethod = $_REQUEST['loginMethod'];
        $mkdirMethod = $_REQUEST['mkdirMethod'];
        $ftpserver = $_REQUEST['ftpserver'];
        $ftplogin = $_REQUEST['ftplogin'];
        $ftppassword = $_REQUEST['ftppassword'];
        $ftpRoot = $_REQUEST['ftpRoot'];
        $langDefault = $_REQUEST['langDefault'];
        $enableTimesheet = $_REQUEST['enableTimesheet'];
        $enableFlextime = $_REQUEST['enableFlextime'];
        $enableEquipment = $_REQUEST['enableEquipment'];
        $enableMaterial = $_REQUEST['enableMaterial'];
        $block1->heading("Create default folders");
        $block1->openContent();

        if ($mkdirMethod == 'FTP') {
            $ftp = ftp_connect($ftpserver);

            if (!$ftp) {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Unable to connect to ftp server $ftpserver.</b>", "false", "");
                $error = true;
            } else {
                $login_result = ftp_login($ftp, $ftplogin, $ftppassword);

                if (!$login_result) {
                    $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Unable to log in to ftp server $ftpserver.</b>", "false", "");
                    $error = true;
                } else {
                    foreach ($defaultFolders as $k => $v) {
                        if (!@ftp_chdir($ftp, $ftpRoot . '/' . $k)) {
                            if (ftp_mkdir($ftp, $ftpRoot . '/' . $k)) {
                                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "$v folder created.", "false", "");
                            } else {
                                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>$v folder DID NOT create.</b>", "false", "");
                                $error = true;
                            }
                        }
                    }
                }

                ftp_close($ftp);
            }
        } else {
            foreach ($defaultFolders as $k => $v) {
                if (!is_dir('../files/' . $k)) {
                    if (!mkdir('../files/' . $k)) {
                        $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>$v folder DID NOT create.</b>", "false", "");
                        $error = true;
                    } else {
                        $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "$v folder created.", "false", "");
                    }
                }
            }
        }

        echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
        echo "<input type=\"hidden\" name=\"dbtype\" value=\"$dbtype\">";
        echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
        echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
        echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
        echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
        echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
        echo "<input type=\"hidden\" name=\"adminLogin\" value=\"$adminLogin\">";
        echo "<input type=\"hidden\" name=\"adminPwd\" value=\"$adminPwd\">";
        echo "<input type=\"hidden\" name=\"adminMail\" value=\"$adminMail\">";
        echo "<input type=\"hidden\" name=\"loginMethod\" value=\"$loginMethod\">";
        echo "<input type=\"hidden\" name=\"mkdirMethod\" value=\"$mkdirMethod\">";
        echo "<input type=\"hidden\" name=\"ftpserver\" value=\"$ftpserver\">";
        echo "<input type=\"hidden\" name=\"ftplogin\" value=\"$ftplogin\">";
        echo "<input type=\"hidden\" name=\"ftppassword\" value=\"$ftppassword\">";
        echo "<input type=\"hidden\" name=\"ftpRoot\" value=\"$ftpRoot\">";
        echo "<input type=\"hidden\" name=\"langDefault\" value=\"$langDefault\">";
        echo "<input type=\"hidden\" name=\"enableTimesheet\" value=\"$enableTimesheet\">";
        echo "<input type=\"hidden\" name=\"enableFlextime\" value=\"$enableFlextime\">";
        echo "<input type=\"hidden\" name=\"enableEquipment\" value=\"$enableEquipment\">";
        echo "<input type=\"hidden\" name=\"enableMaterial\" value=\"$enableMaterial\">";

        if (!$error) {
            $block1->contentRow('', "Default folders have been created successfully.");
            $submitName = "Check database";
            echo "<input type=\"hidden\" name=\"step\" value=\"6\">";
        } else {
            $block1->contentRow('', "Please check the create folder method configuration.");
            $submitName = "Reload";
            echo "<input type=\"hidden\" name=\"step\" value=\"3\">";
            require('../installation/settings.php');
            echo '<input type="hidden" name="connexion" value="' . $installationType . '">';
            echo '<input type="hidden" name="updatechecker" value="' . $updatechecker . '">';
            echo '<input type="hidden" name="installationType" value="' . $installationType . '">';
            echo '<input type="hidden" name="dbtype" value="' . $dbtype . '">';
            echo '<input type="hidden" name="notifications" value="' . $notifications . '">';
            echo '<input type="hidden" name="notificationMethod" value="' . $notificationMethod . '">';
            echo '<input type="hidden" name="smtpserver" value="' . SMTPSERVER . '">';
            echo '<input type="hidden" name="smtpport" value="' . SMTPPORT . '">';
            echo '<input type="hidden" name="smtpsecure" value="' . SMTPSECURE . '">';
            echo '<input type="hidden" name="smtplogin" value="' . SMTPLOGIN . '">';
            echo '<input type="hidden" name="smtppassword" value="' . SMTPPASSWORD . '">';
            echo '<input type="hidden" name="adminPwa" value="' . $adminPwd . '">';
            echo "<input type=\"hidden\" name=\"adminMail\" value=\"$adminMail\">";
            echo '<input type="hidden" name="sitePublish" value="' . $sitePublish . '">';
            echo '<input type="hidden" name="enableTimesheet" value="' . $enableTimesheet . '">';
            echo '<input type="hidden" name="enableFlextime" value="' . $enableFlextime . '">';
            echo '<input type="hidden" name="enableEquipment" value="' . $enableEquipment . '">';
            echo '<input type="hidden" name="enableMaterial" value="' . $enableMaterial. '">';
            echo '<input type="hidden" name="autoCreateDir" value="' . $autoCreateDir . '">';
            echo '<input type="hidden" name="periodUnit" value="' . $periodUnit . '">';
            echo '<input type="hidden" name="autoLockPeriod" value="' . $autoLockPeriod . '">';
            echo '<input type="hidden" name="defaultCurrency" value="' . $defaultCurrency . '">';
            echo '<input type="hidden" name="currencyOnRight" value="' . $currencyOnRight . '">';
            echo '<input type="hidden" name="hourAccuracy" value="' . $hourAccuracy . '">';
            echo '<input type="hidden" name="quantityAccuracy" value="' . $quantityAccuracy . '">';
            echo '<input type="hidden" name="measureAccuracy" value="' . $measureAccuracy . '">';
            echo '<input type="hidden" name="rateAccuracy" value="' . $rateAccuracy . '">';
            echo '<input type="hidden" name="costAccuracy" value="' . $costAccuracy . '">';
            echo '<input type="hidden" name="percentAccuracy" value="' . $percentAccuracy . '">';
            echo '<input type="hidden" name="decimalPoint" value="' . $decimalPoint . '">';
            echo '<input type="hidden" name="thousandsSeparator" value="' . $thousandsSeparator . '">';
            echo '<input type="hidden" name="dateFormat" value="' . $dateFormat . '">';
            echo '<input type="hidden" name="timeFormat" value="' . $timeFormat . '">';
            echo '<input type="hidden" name="gmtTimezone" value="' . $gmtTimezone . '">';
            echo '<input type="hidden" name="defaultTimezone" value="' . $defaultTimezone . '">';
        }

        break;
    case "6":
        $root = $_REQUEST['root'];
        $dbtype = $_REQUEST['dbtype'];
        $dbserver = $_REQUEST['dbserver'];
        $dblogin = $_REQUEST['dblogin'];
        $dbpasswd = $_REQUEST['dbpasswd'];
        $dbname = $_REQUEST['dbname'];
        $tbprefix = $_REQUEST['tbprefix'];
        $adminLogin = $_REQUEST['adminLogin'];
        $adminPwd = $_REQUEST['adminPwd'];
        $adminMail = $_REQUEST['adminMail'];
        $loginMethod = $_REQUEST['loginMethod'];
        $langDefault = $_REQUEST['langDefault'];
        $enableTimesheet = $_REQUEST['enableTimesheet'];
        $enableFlextime = $_REQUEST['enableFlextime'];
        $enableEquipment = $_REQUEST['enableEquipment'];
        $enableMaterial = $_REQUEST['enableMaterial'];
        $block1->heading("Check database");
        $block1->openContent();
        require_once("./setup_db.php");
        check_database();
        echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
        echo "<input type=\"hidden\" name=\"dbtype\" value=\"$dbtype\">";
        echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
        echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
        echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
        echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
        echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
        echo "<input type=\"hidden\" name=\"adminLogin\" value=\"$adminLogin\">";
        echo "<input type=\"hidden\" name=\"adminPwd\" value=\"$adminPwd\">";
        echo "<input type=\"hidden\" name=\"adminMail\" value=\"$adminMail\">";
        echo "<input type=\"hidden\" name=\"loginMethod\" value=\"$loginMethod\">";
        echo '<input type="hidden" name="langDefault" value="' . $langDefault . '">';
        echo "<input type=\"hidden\" name=\"enableTimesheet\" value=\"$enableTimesheet\">";
        echo "<input type=\"hidden\" name=\"enableFlextime\" value=\"$enableFlextime\">";
        echo "<input type=\"hidden\" name=\"enableEquipment\" value=\"$enableEquipment\">";
        echo "<input type=\"hidden\" name=\"enableMaterial\" value=\"$enableMaterial\">";

        if ($error) {
            $block1->contentRow('', "Please check the database server and its configuration.");
            $submitName = "Reload";
            echo "<input type=\"hidden\" name=\"step\" value=\"3\">";
            require('../installation/settings.php');
            echo '<input type="hidden" name="connexion" value="' . $installationType . '">';
            echo '<input type="hidden" name="updatechecker" value="' . $updatechecker . '">';
            echo '<input type="hidden" name="installationType" value="' . $installationType . '">';
            echo '<input type="hidden" name="dbtype" value="' . $dbtype . '">';
            echo '<input type="hidden" name="mkdirMethod" value="' . $mkdirMethod . '">';
            echo '<input type="hidden" name="notifications" value="' . $notifications . '">';
            echo '<input type="hidden" name="notificationMethod" value="' . $notificationMethod . '">';
            echo '<input type="hidden" name="smtpserver" value="' . SMTPSERVER . '">';
            echo '<input type="hidden" name="smtpport" value="' . SMTPPORT . '">';
            echo '<input type="hidden" name="smtpsecure" value="' . SMTPSECURE . '">';
            echo '<input type="hidden" name="smtplogin" value="' . SMTPLOGIN . '">';
            echo '<input type="hidden" name="smtppassword" value="' . SMTPPASSWORD . '">';
            echo '<input type="hidden" name="ftpserver" value="' . FTPSERVER . '">';
            echo '<input type="hidden" name="ftplogin" value="' . FTPLOGIN . '">';
            echo '<input type="hidden" name="ftppassword" value="' . FTPPASSWORD . '">';
            echo '<input type="hidden" name="ftpRoot" value="' . $ftpRoot . '">';
            echo '<input type="hidden" name="adminPwa" value="' . $adminPwd . '">';
            echo "<input type=\"hidden\" name=\"adminMail\" value=\"$adminMail\">";
            echo '<input type="hidden" name="sitePublish" value="' . $sitePublish . '">';
            echo '<input type="hidden" name="enableTimesheet" value="' . $enableTimesheet . '">';
            echo '<input type="hidden" name="enableFlextime" value="' . $enableFlextime . '">';
            echo '<input type="hidden" name="enableEquipment" value="' . $enableEquipment . '">';
            echo '<input type="hidden" name="enableMaterial" value="' . $enableMaterial. '">';
            echo '<input type="hidden" name="autoCreateDir" value="' . $autoCreateDir . '">';
            echo '<input type="hidden" name="periodUnit" value="' . $periodUnit . '">';
            echo '<input type="hidden" name="autoLockPeriod" value="' . $autoLockPeriod . '">';
            echo '<input type="hidden" name="defaultCurrency" value="' . $defaultCurrency . '">';
            echo '<input type="hidden" name="currencyOnRight" value="' . $currencyOnRight . '">';
            echo '<input type="hidden" name="hourAccuracy" value="' . $hourAccuracy . '">';
            echo '<input type="hidden" name="quantityAccuracy" value="' . $quantityAccuracy . '">';
            echo '<input type="hidden" name="measureAccuracy" value="' . $measureAccuracy . '">';
            echo '<input type="hidden" name="rateAccuracy" value="' . $rateAccuracy . '">';
            echo '<input type="hidden" name="costAccuracy" value="' . $costAccuracy . '">';
            echo '<input type="hidden" name="percentAccuracy" value="' . $percentAccuracy . '">';
            echo '<input type="hidden" name="decimalPoint" value="' . $decimalPoint . '">';
            echo '<input type="hidden" name="thousandsSeparator" value="' . $thousandsSeparator . '">';
            echo '<input type="hidden" name="dateFormat" value="' . $dateFormat . '">';
            echo '<input type="hidden" name="timeFormat" value="' . $timeFormat . '">';
            echo '<input type="hidden" name="gmtTimezone" value="' . $gmtTimezone . '">';
            echo '<input type="hidden" name="defaultTimezone" value="' . $defaultTimezone . '">';
        } else {
            $block1->contentRow("", "No errors detected.");
            $submitName = "Create tables";
            echo "<input type=\"hidden\" name=\"step\" value=\"7\">";
        }

        break;
    case "7":
        $root = $_REQUEST['root'];
        $dbtype = $_REQUEST['dbtype'];
        $dbserver = $_REQUEST['dbserver'];
        $dblogin = $_REQUEST['dblogin'];
        $dbpasswd = $_REQUEST['dbpasswd'];
        $dbname = $_REQUEST['dbname'];
        $tbprefix = $_REQUEST['tbprefix'];
        $adminLogin = $_REQUEST['adminLogin'];
        $adminPwdPlain = $_REQUEST['adminPwd'];
        $adminMail = $_REQUEST['adminMail'];
        $loginMethod = $_REQUEST['loginMethod'];
        $langDefault = $_REQUEST['langDefault'];
        $enableTimesheet = $_REQUEST['enableTimesheet'];
        $enableFlextime = $_REQUEST['enableFlextime'];
        $enableEquipment = $_REQUEST['enableEquipment'];
        $enableMaterial = $_REQUEST['enableMaterial'];
        $block1->heading("Create tables");
        $block1->openContent();
        $error = false;
        // crypt admin password
        $adminPwd = get_password($adminPwdPlain);
        require_once("../includes/defines.lib.php");
        require_once("./setup_db.php");
        set_time_limit(0);
        create_tables();

        if ($error) {
            $submitName = "Check database again";
            echo "<input type=\"hidden\" name=\"step\" value=\"6\">";
            echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
            echo "<input type=\"hidden\" name=\"dbtype\" value=\"$dbtype\">";
            echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
            echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
            echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
            echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
            echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
            echo "<input type=\"hidden\" name=\"adminLogin\" value=\"$adminLogin\">";
            echo "<input type=\"hidden\" name=\"adminPwd\" value=\"$adminPwdPlain\">";
            echo "<input type=\"hidden\" name=\"adminMail\" value=\"$adminMail\">";
            echo "<input type=\"hidden\" name=\"loginMethod\" value=\"$loginMethod\">";
            echo '<input type="hidden" name="langDefault" value="' . $langDefault . '">';
            echo "<input type=\"hidden\" name=\"enableTimesheet\" value=\"$enableTimesheet\">";
            echo "<input type=\"hidden\" name=\"enableFlextime\" value=\"$enableFlextime\">";
            echo "<input type=\"hidden\" name=\"enableEquipment\" value=\"$enableEquipment\">";
            echo "<input type=\"hidden\" name=\"enableMaterial\" value=\"$enableMaterial\">";
        } else {
            $block1->contentRow('', "Database tables created.");
            $submitName = "Finish";
            echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
            echo "<input type=\"hidden\" name=\"step\" value=\"8\">";
        }

        break;
    case "8":
        foreach ($dbTypList as $dbTyp) {
            foreach ($checkList as $fileChk => $fileTyp) {
                $pathName = ".." . $fileChk . "." . $dbTyp;

                if ($fileTyp == "File" && $fileChk != "/includes/settings.php" && file_exists($pathName)) {
                    @unlink($pathName);
                }
            }
        }

        rmdirr('../includes/jpgraph-4.2.0');
        rmdirr('../includes/PHPMailer-5.2.19');
        $root = $_REQUEST['root'];
        $block1->heading("Installation Complete");
        $block1->openContent();
        $block1->contentRow("Your site", $block1->buildLink($root, "Click HERE to see the home page of your site.", "in"));
        $block1->contentRow("Support", $block1->buildLink("http://webtareas.sourceforge.net", "Visit webTareas", "in"));
        break;
}

if ($step != "8") {
    $block1->contentRow('', "<input type=\"SUBMIT\" name=\"save\" value=\"$submitName\">");
}

$block1->closeContent();
$block1->closeForm();
$footerDev = false;
require_once("../includes/footer.php");

// Write file
function write_file($content, $dest)
{
    $fp = @fopen($dest, 'wb+');
    $fw = fwrite($fp, $content);
    fclose($fp);
    return $fw;
}

// Generates the unique [en|de]cryption key for your installation
function get_crypt_key()
{
  srand((double)microtime()*1000000);
  return(md5(uniqid(rand(),1)));
}

// return a password using the globally specified method
function get_password($newPassword)
{
    global $loginMethod;

    switch ($loginMethod) {
        case "MD5":
            return md5($newPassword);
        case "CRYPT":
            $salt = substr($newPassword, 0, 2);
            return crypt($newPassword, $salt);
        case "PLAIN":
            return $newPassword;
        default:
            return $newPassword;
    }
}

// copy a directory and all subdirectories and files (recursive)
// void dircpy( str 'source directory', str 'destination directory' [, bool 'overwrite existing files'] )
function dircpy($source, $dest, $overwrite = false) {
    $handle = opendir($source);

    if ($handle) { // if the folder exploration is sucsessful, continue
        while (false !== ($file = readdir($handle))) { // as long as storing the next file to $file is successful, continue
            if ($file != '.' && $file != '..') {
                $path = $source . '/' . $file;

                if (is_file($path)) {
                    if (!is_file($dest . '/' . $file) || $overwrite) {
                        if (!@copy($path, $dest . '/' . $file)) {
                            return false;
                        }
                    }
                } elseif (is_dir($path)) {
                    if (!is_dir($dest . '/' . $file)) {
                        mkdir($dest . '/' . $file); // make subdirectory before subdirectory is copied
                    }

                    dircpy($path, $dest . '/' . $file, $overwrite); //recurse!
                }
            }
       }

       closedir($handle);
    }

    return true;
} // end of dircpy()

/**
 * Delete a file, or a folder and its contents
 *
 * @author      Aidan Lister <aidan@php.net>
 * @version     1.0.2
 * @param       string   $dirname    Directory to delete
 * @return      bool     Returns TRUE on success, FALSE on failure
 */
function rmdirr($dirname)
{
    // Sanity check
    if (!file_exists($dirname)) {
        return false;
    }

    // Simple delete for a file
    if (is_file($dirname)) {
        usleep(10);
        return unlink($dirname);
    }

    // Loop through the folder
    $dir = dir($dirname);
    while (false !== $entry = $dir->read()) {
        // Skip pointers
        if ($entry == '.' || $entry == '..') {
            continue;
        }

        // Recurse
        rmdirr("$dirname/$entry");
    }

    // Clean up
    $dir->close();
    usleep(10);
    return rmdir($dirname);
}

/**
 * append file modification time to image path/url
 * @param string $path
 * @return string
 */
function verSource($path)
{
    $basedir = preg_replace_callback('/installation$/i', function ($matches) { return ''; }, str_replace('\\', '/', dirname(__FILE__)), 1);
    return '../' . $path . '?ver=' . filemtime($basedir . $path);
}

// dummy function to print language strings
function lang_strings($str)
{
    return $str;
}
/**
 * generate decimal place selection html
 * @param object $block1
 * @param string $title
 * @param string $name
 * @param string $val
 */
function setupDecimalPlaceSelectionHtml($block1, $title, $name, $val)
{
    $selHtml = '<select name="' . $name . '">';

    for ($i=0; $i<=6; $i++) {
        if ($i == $val) {
            $selHtml .= '<option value="' . $i . '" selected>' . $i . '</option>';
        } else {
            $selHtml .= '<option value="' . $i . '">' . $i . '</option>';
        }
    }

    $selHtml .= '</select>';
    $block1->contentRow($title, $selHtml);
}

function messageBox($error)
{
    global $strings;
    echo '<script>'
    . '$(document).ready(function() {'
        . '$("body").prepend("<div id=\'wtMsgBox\'><div class=\'errorMsg\'><b>' . $strings['errors'] . '</b> ' . $error . '</div></div>");'
        . 'setTimeout(function() { $("#wtMsgBox").fadeOut(); }, 15000);'
    . '});'
    . '</script>';
}
