<?php // $Revision: 1.30 $
/* vim: set expandtab ts=4 sw=4 sts=4: */
/**
 * $Id: upgrade.php,v 1.30 2013/02/19 14:15:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

if (version_compare(phpversion(), "7", "<")) {
    die("php version " . phpversion() . " not support");
}

require_once('../languages/lang_en.php');
require_once('../includes/defines.lib.php');
$versionNew = '2.0';
$step = isset($_REQUEST['step'])?$_REQUEST['step']:'1';
$dbTypList = array("pg","my");
$checkList = array(
    "/administration/systeminfo.php" => "File",
    "/installation/db_var.inc.php" => "File",
    "/installation/setup_db.php" => "File",
    "/installation/temp" => "Directory",
    "/includes/library-dbspec.php" => "File",
    "/includes/request.class-dbspec.php" => "File",
    "/includes/settings.php" => "File",
    "/includes/jpgraph" => "Directory",
    "/includes/phpmailer" => "Directory",
    "/extensions" => "Directory",
    "/files" => "Directory");
$defaultFolders = array(
    "Default" => "Default upload",
    "Images" => "Image",
    "Media" => "Media",
    "PrintLayouts" => "Print layout",
    "JavaScript" => "JavaScript",
    "Logos" => "Company Logos",
    "Avatars" => "Avatars",
    "Messages" => "Message pictures"
);
$setCopyright = '<!-- Powered by webTareas v' . $versionNew . ' -->';
$setCharset = 'utf-8';
$setTitle = "webTareas Web-Based Upgrade";
$setDescription = 'Groupware module. Manage web projects with team collaboration, users management, tasks and projects tracking, files approval tracking, service sites clients access, customer relationship management, instant messaging.';
$setKeywords = 'management, web, projects, tasks, organizations, reports, application, module, file management, project site, team collaboration, crm, CRM, cutomer relationship management, workflow, workgroup, timesheet, chat';
$lang = 'en';
$orgSession  = '';
$scriptMinimized = '';
$path_prefix = '';
$installationType = '';
$bodyCommand = '';
$clientHeader->org_extension_logo[0] = '';
$error = '';
define('THEME', 'camping');
define('PALETTE', 'bottle-in-fall');
$blank = "true";
$languageSession = $lang;
$dateformatSession  = "Y-m-d|yy-mm-dd|Y-m";
$timeformatSession = "24H";
$firstDayOfWeek = "1";
require_once("../includes/block.class.php");
require_once("../includes/header.php");
$block1 = new block();
$block1->heading($setTitle . ' - Step ' . $step);
$block1->form = "upgrade";
$block1->openForm("../installation/upgrade.php?#" . $block1->form . "Anchor");

switch ($step) {
    case "1":
        $block1->openViewOptions();
        $block1->itemViewOptions($block1->buildLink('../installation/setup.php?', 'Install a new webTareas', 'in'));
        $block1->closeViewOptions();
        $block1->heading("License Agreement");
        $copying = file_get_contents("../docs/copying.txt");
        echo '<textarea readonly class="mceNoEditor" style="width:600px;height:400px;">' . $copying . '</textarea>';
        echo "<input type=\"hidden\" name=\"step\" value=\"2\">";
        $submitName = "I accept the terms in the License Agreement";
        break;
    case "2":
        $error = false;

        foreach ($checkList as $fileChk => $fileTyp) {
            if (is_writable(".." . $fileChk) == false) {
                $error = true;
                break;
            }
        }

        if ($error) {
            messageBox("In order for the package to work correctly, the following files must be writeable by the server. Please change the permission setting for these files. (i.e. 'chmod 666 file_name' and 'chmod 777 dir_name' on a UNIX/LINUX server, or check the properties of the file and make sure the read-only flag is not set on a Windows server)");
            echo "<input type=\"hidden\" name=\"step\" value=\"2\">";
            $submitName = "Reload";
        } else {
            echo "<input type=\"hidden\" name=\"step\" value=\"3\">";
            echo '<input type="hidden" name="prevroot" value="/var/www/html/webtareas">';
            $submitName = "Check Previous Installation";
        }

        $block1->heading("Check File Permissions");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");

        foreach($checkList as $fileChk => $fileTyp) {
            if (is_writable(".." . $fileChk)) {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "$fileTyp $fileChk is writable.", "false", "");
            } else {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>$fileTyp $fileChk is NOT writable.</b>", "false", "");
            }
        }

        if (!$error) {
            $block1->contentRow("", "");
            $block1->contentRow("", "No errors detected.");
        }

        break;
    case "3":
        $action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
        $prevroot = isset($_REQUEST['prevroot'])?$_REQUEST['prevroot']:'';

        if ($action == "check") {
            if ($prevroot == '') {
                $error = 'Must be insert the Previous Installation Root.';
            } else if (!file_exists($prevroot)) {
                $error = $prevroot . " doesn't exist.";
            } else {
                $prevroot = str_replace('\\', '/', $prevroot);

                if (substr($prevroot, -1) == '/') {
                    $prevroot = substr($prevroot, 0, -1);
                }

                $prevsettings = $prevroot . '/includes/settings.php';

                if (!file_exists($prevsettings)) {
                    $error = $prevsettings . " doesn't exist.";
                } else {
                    require($prevsettings);
                    if ($version != '1.12') {
                        $error = "Upgrade from version $version is impossible.";
                    } else if ($siteOff != 'true') {
                        $error = "Please turn the previous installation web site off first.";
                    }
                }

                if ($error == '') {
                    // load previous settings
                    $connexion = $installationType;
                    $prevdbtype = DBTYPE;
                    $prevdbserver = DBSERVER;
                    $prevdblogin = DBLOGIN;
                    $prevdbpassword = DBPASSWORD;
                    $prevdbname = DBNAME;

                    if (DBTYPE == 'MySQL') {
                        $dbtype = 'my';
                        $prevdbtype = 'my';
                    } else {
                        $dbtype = 'pg';
                        $prevdbtype = 'pg';
                    }

                    if (SMTPSERVER != '') {
                        $smtpa = preg_split('#:(//|)#', SMTPSERVER);

                        if (count($smtpa) == 3) {
                            $smtpsecure = $smtpa[0];
                            $smtpserver = $smtpa[1];
                            $smtpport = $smtpa[2];
                        } else if (count($smtpa) == 2) {
                            if (is_numeric($smtpa[1])) {
                                $smtpserver = $smtpa[0];
                                $smtpport = $smtpa[1];
                            } else {
                                $smtpsecure = $smtpa[0];
                                $smtpserver = $smtpa[1];
                            }
                        } else {
                            $smtpserver = $smtpa[0];
                        }
                    } else {
                        $smtpsecure = '';
                        $smtpserver = '';
                        $smtpport = '';
                    }

                    $prevmdmethod = $mkdirMethod;
                    $prevftpserver = FTPSERVER;
                    $prevftplogin = FTPLOGIN;
                    $prevftppassword = FTPPASSWORD;
                    $prevftproot = $ftpRoot;
                    $prevtbprefix = $tablePrefix;
                    $prevlangDefault = (($langDefault=='')?'en':$langDefault);
                }
            }
        }

        if ($error != '') {
            messageBox($error);
            $action = "";
        }

        if ($action != "check") {
            $block1->heading("Check Previous Installation");
            $block1->openContent();
            $block1->contentTitle("&nbsp;");
            echo "<input type=\"hidden\" name=\"step\" value=\"3\">";
            echo "<input type=\"hidden\" name=\"action\" value=\"check\">";
            $block1->contentRow("* Previous Installation Root", "<input size=\"44\" value=\"$prevroot\" style=\"width: 200px\" name=\"prevroot\" maxlength=\"100\" type=\"text\">");
            $submitName = "Check";
            break;
        }
    case "4":
        $action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
        $prevroot = isset($_REQUEST['prevroot'])?$_REQUEST['prevroot']:$prevroot;
        $prevdbtype = isset($_REQUEST['prevdbtype'])?$_REQUEST['prevdbtype']:$prevdbtype;
        $prevdbserver = isset($_REQUEST['prevdbserver'])?$_REQUEST['prevdbserver']:$prevdbserver;
        $prevdbname = isset($_REQUEST['prevdbname'])?$_REQUEST['prevdbname']:$prevdbname;
        $prevdblogin = isset($_REQUEST['prevdblogin'])?$_REQUEST['prevdblogin']:$prevdblogin;
        $prevdbpassword = isset($_REQUEST['prevdbpassword'])?$_REQUEST['prevdbpassword']:$prevdbpassword;
        $prevmdmethod = isset($_REQUEST['prevmdmethod'])?$_REQUEST['prevmdmethod']:$prevmdmethod;
        $prevftpserver = isset($_REQUEST['prevftpserver'])?$_REQUEST['prevftpserver']:$prevftpserver;
        $prevftplogin = isset($_REQUEST['prevftplogin'])?$_REQUEST['prevftplogin']:$prevftplogin;
        $prevftppassword = isset($_REQUEST['prevftppassword'])?$_REQUEST['prevftppassword']:$prevftppassword;
        $prevftproot = isset($_REQUEST['prevftproot'])?$_REQUEST['prevftproot']:$prevftproot;
        $prevtbprefix = isset($_REQUEST['prevtbprefix'])?$_REQUEST['prevtbprefix']:$prevtbprefix;
        $prevlangDefault = isset($_REQUEST['prevlangDefault'])?$_REQUEST['prevlangDefault']:$prevlangDefault;
        $cryptKey = isset($_REQUEST['cryptKey'])?$_REQUEST['cryptKey']:$cryptKey;
        $loginMethod = isset($_REQUEST['loginMethod'])?$_REQUEST['loginMethod']:$loginMethod;
        $connexion = isset($_REQUEST['connexion'])?$_REQUEST['connexion']:$connexion;
        $updatechecker = isset($_REQUEST['updatechecker'])?$_REQUEST['updatechecker']:$updateChecker;
        $installationType = isset($_REQUEST['installationType'])?$_REQUEST['installationType']:$installationType;
        $dbtype = isset($_REQUEST['dbtype'])?$_REQUEST['dbtype']:$dbtype;
        $dbserver = isset($_REQUEST['dbserver'])?$_REQUEST['dbserver']:$prevdbserver;
        $dblogin = isset($_REQUEST['dblogin'])?$_REQUEST['dblogin']:$prevdblogin;
        $dbpasswd = isset($_REQUEST['dbpasswd'])?$_REQUEST['dbpasswd']:$prevdbpassword;
        $dbname = isset($_REQUEST['dbname'])?$_REQUEST['dbname']:$prevdbname;
        $tbprefix = isset($_REQUEST['tbprefix'])?$_REQUEST['tbprefix']:chr(rand(97,122)).chr(rand(65,90)).chr(rand(48,57));
        $mkdirMethod = isset($_REQUEST['mkdirMethod'])?$_REQUEST['mkdirMethod']:$prevmdmethod;
        $notifications = isset($_REQUEST['notifications'])?$_REQUEST['notifications']:$notifications;
        $notificationMethod = isset($_REQUEST['notificationMethod'])?$_REQUEST['notificationMethod']:$notificationMethod;
        $smtpserver = isset($_REQUEST['smtpserver'])?$_REQUEST['smtpserver']:$smtpserver;
        $smtpport = isset($_REQUEST['smtpport'])?$_REQUEST['smtpport']:$smtpport;
        $smtpsecure = isset($_REQUEST['smtpsecure'])?$_REQUEST['smtpsecure']:$smtpsecure;
        $smtplogin = isset($_REQUEST['smtplogin'])?$_REQUEST['smtplogin']:SMTPLOGIN;
        $smtppassword = isset($_REQUEST['smtppassword'])?$_REQUEST['smtppassword']:SMTPPASSWORD;
        $ftpserver = isset($_REQUEST['ftpserver'])?$_REQUEST['ftpserver']:FTPSERVER;
        $ftplogin = isset($_REQUEST['ftplogin'])?$_REQUEST['ftplogin']:FTPLOGIN;
        $ftppassword = isset($_REQUEST['ftppassword'])?$_REQUEST['ftppassword']:FTPPASSWORD;
        $ftpRoot = isset($_REQUEST['ftpRoot'])?$_REQUEST['ftpRoot']:$ftpRoot;
        $langDefault = isset($_REQUEST['langDefault'])?$_REQUEST['langDefault']:$prevlangDefault;
        $root = isset($_REQUEST['root'])?$_REQUEST['root']:'';
        $useLDAP = isset($_REQUEST['useLDAP'])?$_REQUEST['useLDAP']:$useLDAP;
        $ldapserver = isset($_REQUEST['ldapserver'])?$_REQUEST['ldapserver']:$configLDAP['ldapserver'];
        $ldapversion = isset($_REQUEST['ldapversion'])?$_REQUEST['ldapversion']:$configLDAP['ldapversion'];
        $basedn = isset($_REQUEST['basedn'])?$_REQUEST['basedn']:$configLDAP['basedn'];
        $ldapuser = isset($_REQUEST['ldapuser'])?$_REQUEST['ldapuser']:$configLDAP['userdn'];
        $ldappassword = isset($_REQUEST['ldappassword'])?$_REQUEST['ldappassword']:$configLDAP['password'];
        $sitePublish = isset($_REQUEST['sitePublish'])?$_REQUEST['sitePublish']:$sitePublish;
        $enableTimesheet = isset($_REQUEST['enableTimesheet'])?$_REQUEST['enableTimesheet']:$enableTimesheet;
        $enableFlextime = isset($_REQUEST['enableFlextime'])?$_REQUEST['enableFlextime']:'false';
        $enableEquipment = isset($_REQUEST['enableEquipment'])?$_REQUEST['enableEquipment']:$enableEquipment;
        $enableMaterial = isset($_REQUEST['enableMaterial'])?$_REQUEST['enableMaterial']:$enableMaterial;
        $autoCreateDir = isset($_REQUEST['autoCreateDir'])?$_REQUEST['autoCreateDir']:$autoCreateDir;
        $periodUnit = isset($_REQUEST['periodUnit'])?$_REQUEST['periodUnit']:$periodUnit;
        $weekRule = isset($_REQUEST['weekRule'])?$_REQUEST['weekRule']:$weekRule;
        $firstDayOfWeek = isset($_REQUEST['firstDayOfWeek'])?$_REQUEST['firstDayOfWeek']:$firstDayOfWeek;
        $autoLockPeriod = isset($_REQUEST['autoLockPeriod'])?$_REQUEST['autoLockPeriod']:$autoLockPeriod;
        $defaultCurrency = isset($_REQUEST['defaultCurrency'])?$_REQUEST['defaultCurrency']:$defaultCurrency;
        $defaultCostMethod = isset($_REQUEST['defaultCostMethod'])?$_REQUEST['defaultCostMethod']:$defaultCostMethod;
        $currencyOnRight = isset($_REQUEST['currencyOnRight'])?$_REQUEST['currencyOnRight']:$currencyOnRight;
        $hourAccuracy = isset($_REQUEST['hourAccuracy'])?$_REQUEST['hourAccuracy']:$hourAccuracy;
        $quantityAccuracy = isset($_REQUEST['quantityAccuracy'])?$_REQUEST['quantityAccuracy']:$quantityAccuracy;
        $measureAccuracy = isset($_REQUEST['measureAccuracy'])?$_REQUEST['measureAccuracy']:$measureAccuracy;
        $rateAccuracy = isset($_REQUEST['rateAccuracy'])?$_REQUEST['rateAccuracy']:$rateAccuracy;
        $costAccuracy = isset($_REQUEST['costAccuracy'])?$_REQUEST['costAccuracy']:$costAccuracy;
        $percentAccuracy = isset($_REQUEST['percentAccuracy'])?$_REQUEST['percentAccuracy']:$percentAccuracy;
        $decimalPoint = isset($_REQUEST['decimalPoint'])?$_REQUEST['decimalPoint']:$decimalPoint;
        $thousandsSeparator = isset($_REQUEST['thousandsSeparator'])?$_REQUEST['thousandsSeparator']:$thousandsSeparator;
        $dateFormat = isset($_REQUEST['dateFormat'])?$_REQUEST['dateFormat']:$dateFormat;
        $timeFormat = isset($_REQUEST['timeFormat'])?$_REQUEST['timeFormat']:$timeFormat;
        $contactNameFormat = isset($_REQUEST['contactNameFormat'])?$_REQUEST['contactNameFormat']:$contactNameFormat;
        $gmtTimezone = isset($_REQUEST['gmtTimezone'])?$_REQUEST['gmtTimezone']:$gmtTimezone;
        $defaultTimezone = isset($_REQUEST['defaultTimezone'])?$_REQUEST['defaultTimezone']:$defaultTimezone;
        $lockThreshold = isset($_REQUEST['lockThreshold'])?$_REQUEST['lockThreshold']:$lockThreshold;
        $banThreshold = isset($_REQUEST['banThreshold'])?$_REQUEST['banThreshold']:$banThreshold;
        $detectHijack = isset($_REQUEST['detectHijack'])?$_REQUEST['detectHijack']:$detectHijack;
        $pathToOpenssl = isset($_REQUEST['pathToOpenssl'])?$_REQUEST['pathToOpenssl']:$pathToOpenssl;
        $fileManagement = isset($_REQUEST['fileManagement'])?$_REQUEST['fileManagement']:$fileManagement;
        $allowPhp = isset($_REQUEST['allowPhp'])?$_REQUEST['allowPhp']:$allowPhp;
        $peerReview = isset($_REQUEST['peerReview'])?$_REQUEST['peerReview']:$peerReview;
        $activeJpgraph = isset($_REQUEST['activeJpgraph'])?$_REQUEST['activeJpgraph']:$activeJpgraph;
        $footerDev = isset($_REQUEST['footerDev'])?$_REQUEST['footerDev']:$footerDev;
        $projectsFilter = isset($_REQUEST['projectsFilter'])?$_REQUEST['projectsFilter']:$projectsFilter;
        $enableHelpSupport = isset($_REQUEST['enableHelpSupport'])?$_REQUEST['enableHelpSupport']:$enableHelpSupport;
        $supportEmail = isset($_REQUEST['supportEmail'])?$_REQUEST['supportEmail']:$supportEmail;
        $upload_max_filesize = isset($_REQUEST['upload_max_filesize'])?$_REQUEST['upload_max_filesize']:$maxFileSize;
        $basedir = preg_replace_callback('/installation$/i', function ($matches) { return ''; }, str_replace('\\', '/', dirname(__FILE__)), 1);

        if (substr($root, -1) == "/") {
            $root = substr($root, 0, -1);
        }

        if (substr($ftpRoot, -1) == "/") {
            $ftpRoot = substr($ftpRoot, 0, -1);
        }

        if ($installationType == "offline") {
            $updatechecker = "false";
        }

        if ($action == "save") {
            if ($dbserver == '') {
                $error = 'Must be insert the database Server';
            } else if ($dblogin == '') {
                $error = 'Must be insert the database Login';
            } else if ($dbname == '') {
                $error = 'Must be insert the database Name';
            } else if ($tbprefix == '') {
                $error = 'Must be insert the Table prefix';
            } else if ($root == '') {
                $error = 'Must be insert the Root path';
            }

            if ($error == '' && $useLDAP == 'true') {
                if ($ldapserver == '') {
                    $error = 'Must be insert the URL to LDAP server';
                } else if ($basedn == '') {
                    $error = 'Must be insert the Base DN';
                } else {
                    $ds = ldap_connect($ldapserver);

                    if ($ds === false) {
                        $error = 'Could not connect to ' . $ldapserver;
                    } else if ($ldapuser != '') {
                        $r = ldap_bind($ds, $ldapuser, $ldappassword);

                        if ($r === false) {
                            $error = 'Could not connect as ' . $ldapuser . '@' . $ldapserver;
                        }

                        ldap_close($ds);
                    }
                }
            }

            if ($error == '' && $mkdirMethod == 'FTP') {
                if ($ftpserver == '') {
                    $error = 'Must be insert the Ftp server';
                } else if ($ftplogin == '') {
                    $error = 'Must be insert the Ftp login';
                } else if ($ftppassword == '') {
                    $error = 'Must be insert the Ftp password';
                } else if ($ftpRoot == '') {
                    $error = 'Must be insert the Ftp root';
                } else {
                    $f = ftp_connect($ftpserver);

                    if ($f === false) {
                        $error = 'Could not connect to ' . $ftpserver;
                    } else {
                        if (ftp_login($f, $ftplogin, $ftppassword)) {
                            if (!ftp_chdir($f, $ftpRoot)) {
                                $error = 'Could not change ftp directory ' . $ftpRoot;
                            }
                        } else {
                            $error = 'Could not connect as ' . $ftplogin . '@' . $ftpserver;
                        }

                        ftp_close($f);
                    }
                }
            }
        }

        if ($error != '') {
            messageBox($error);
            $action = "";
        }

        if ($action != "save") {
            $block1->heading("Settings");
            $block1->openContent();
            $block1->contentTitle("General");
            echo '<input name="prevroot" value="' . $prevroot . '" type="hidden">';
            echo '<input name="prevdbtype" value="' . $prevdbtype . '" type="hidden">';
            echo '<input name="prevdbserver" value="' . $prevdbserver . '" type="hidden">';
            echo '<input name="prevdbname" value="' . $prevdbname . '" type="hidden">';
            echo '<input name="prevdblogin" value="' . $prevdblogin . '" type="hidden">';
            echo '<input name="prevdbpassword" value="' . $prevdbpassword . '" type="hidden">';
            echo '<input name="prevmdmethod" value="' . $prevmdmethod . '" type="hidden">';
            echo '<input name="prevftpserver" value="' . $prevftpserver . '" type="hidden">';
            echo '<input name="prevftplogin" value="' . $prevftplogin . '" type="hidden">';
            echo '<input name="prevftppassword" value="' . $prevftppassword . '" type="hidden">';
            echo '<input name="prevftproot" value="' . $prevftproot . '" type="hidden">';
            echo '<input name="prevtbprefix" value="' . $prevtbprefix . '" type="hidden">';
            echo '<input name="prevlangDefault" value="' . $prevlangDefault . '" type="hidden">';
            echo '<input name="cryptKey" value="' . $cryptKey . '" type="hidden">';
            echo '<input name="loginMethod" value="' . $loginMethod . '" type="hidden">';

            if ($connexion == "offline") {
                echo "<input value=\"false\" name=\"updatechecker\" type=\"hidden\">";
            } else if (@join('', file("http://webtareas.sourceforge.net/version.txt"))) {
                echo "<input value=\"true\" name=\"updatechecker\" type=\"hidden\">";
            } else {
                echo "<input value=\"false\" name=\"updatechecker\" type=\"hidden\">";
            }

            $block1->contentRow("* Installation type", "<ul><li><input type=\"radio\" name=\"connexion\" value=\"offline\"" . (($connexion == "offline")?' checked':'') . "> Offline (firewall/intranet, no update checker)</li><li><input type=\"radio\" name=\"connexion\" value=\"online\"" . (($connexion == "offline")?'':' checked') . "> Online</li></ul>");
            echo '<input name="dbtype" value="' . $dbtype . '" type="hidden">';
            $block1->contentRow("* Database server", "<input size=\"44\" value=\"$dbserver\" style=\"width: 200px\" name=\"dbserver\" maxlength=\"100\" type=\"text\">");
            $block1->contentRow("* Database login", "<input size=\"44\" value=\"$dblogin\" style=\"width: 200px\" name=\"dblogin\" maxlength=\"100\" type=\"text\">");
            $block1->contentRow("Database password", "<input size=\"44\" value=\"$dbpasswd\" style=\"width: 200px\" name=\"dbpasswd\" maxlength=\"100\" type=\"password\">");
            $block1->contentRow("* Database name", "<input size=\"44\" value=\"$dbname\" style=\"width: 200px\" name=\"dbname\" maxlength=\"100\" type=\"text\">");
            $block1->contentRow("* Table prefix" . $block1->printHelp(addslashes($strings["setup_dbprefix"]), true), "<input size=\"44\" value=\"$tbprefix\" style=\"width: 200px\" name=\"tbprefix\" maxlength=\"100\" type=\"text\">");
            $safemodeTest = ini_get("safe_mode");
            $block1->contentRow("* Create folder method" . $block1->printHelp(addslashes($strings["setup_mkdirMethod"]), true), "<ol><li><input type=\"radio\" name=\"mkdirMethod\" value=\"PHP\" " . (($safemodeTest!='1')?'checked':'') . "> PHP</li>"
                . "<li><input type=\"radio\" name=\"mkdirMethod\" value=\"FTP\" " . (($safemodeTest=='1')?'checked':'') . "> FTP [Safe-mode " . (($safemodeTest=='1')?'on':'off') . "]</li>"
                . "<li><div class=\"leftValue\">Ftp server</div><div class=\"rightValue\"><input value=\"$ftpserver\" style=\"width: 200px\" name=\"ftpserver\" maxlength=\"100\" type=\"text\"></div></li>"
                . "<li><div class=\"leftValue\">Ftp login</div><div class=\"rightValue\"><input value=\"$ftplogin\" style=\"width: 200px\" name=\"ftplogin\" maxlength=\"100\" type=\"text\"></div></li>"
                . "<li><div class=\"leftValue\">Ftp password</div><div class=\"rightValue\"><input value=\"$ftppassword\" style=\"width: 200px\" name=\"ftppassword\" maxlength=\"100\" type=\"password\"></div></li>"
                . "<li><div class=\"leftValue\">Ftp root</div><div class=\"rightValue\"><input value=\"$ftpRoot\" style=\"width: 200px\" name=\"ftpRoot\" maxlength=\"255\" type=\"text\"></div></li></ol>");
            echo '<input name="notifications" value="' . $notifications . '" type="hidden">';
            echo '<input name="notificationMethod" value="' . $notificationMethod . '" type="hidden">';
            echo '<input name="smtpserver" value="' . $smtpserver . '" type="hidden">';
            echo '<input name="smtpport" value="' . $smtpport . '" type="hidden">';
            echo '<input name="smtpsecure" value="' . $smtpsecure . '" type="hidden">';
            echo '<input name="smtplogin" value="' . $smtplogin . '" type="hidden">';
            echo '<input name="smtppassword" value="' . $smtppassword . '" type="hidden">';
            echo '<input name="langDefault" value="' . $langDefault . '" type="hidden">';
            echo '<input name="defaultCurrency" value="' . $defaultCurrency . '" type="hidden">';
            echo '<input name="sitePublish" value="' . $sitePublish . '" type="hidden">';
            echo '<input name="enableTimesheet" value="' . $enableTimesheet . '" type="hidden">';
            echo '<input name="enableFlextime" value="' . $enableFlextime . '" type="hidden">';
            echo '<input name="enableEquipment" value="' . $enableEquipment . '" type="hidden">';
            echo '<input name="enableMaterial" value="' . $enableMaterial . '" type="hidden">';
            echo '<input name="defaultCostMethod" value="' . $defaultCostMethod . '" type="hidden">';
            echo '<input name="autoCreateDir" value="' . $autoCreateDir . '" type="hidden">';
            echo '<input name="periodUnit" value="' . $periodUnit . '" type="hidden">';
            echo '<input name="weekRule" value="' . $weekRule . '" type="hidden">';
            echo '<input name="firstDayOfWeek" value="' . $firstDayOfWeek . '" type="hidden">';
            echo '<input name="autoLockPeriod" value="' . $autoLockPeriod . '" type="hidden">';
            $url = $_SERVER['SERVER_NAME'];

            if ($_SERVER['SERVER_PORT'] != 80 && $_SERVER['SERVER_PORT'] != 443) {
                $url .= ":" . $_SERVER['SERVER_PORT'];
            }

            if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == "on") {
                $protocol = "https://";
            } else {
                $protocol = "http://";
            }

            $root = $protocol . $url . dirname($_SERVER['PHP_SELF']);
            $root = str_replace("installation", "", $root);
            $block1->contentRow("* Root", "<input size=\"44\" value=\"$root\" style=\"width: 200px\" name=\"root\" maxlength=\"100\" type=\"text\">");
            echo '<input name="useLDAP" value="' . $useLDAP . '" type="hidden">';
            echo '<input name="ldapserver" value="' . $ldapserver . '" type="hidden">';
            echo '<input name="ldapversion" value="' . $ldapversion . '" type="hidden">';
            echo '<input name="basedn" value="' . $basedn . '" type="hidden">';
            echo '<input name="ldapuser" value="' . $ldapuser . '" type="hidden">';
            echo '<input name="ldappassword" value="' . $ldappassword . '" type="hidden">';
            /**
             * display section
             */
            //$block1->contentTitle("Display");
            echo '<input name="contactNameFormat" value="' . $contactNameFormat . '" type="hidden">';
            echo '<input name="hourAccuracy" value="' . $hourAccuracy . '" type="hidden">';
            echo '<input name="quantityAccuracy" value="' . $quantityAccuracy . '" type="hidden">';
            echo '<input name="measureAccuracy" value="' . $measureAccuracy . '" type="hidden">';
            echo '<input name="rateAccuracy" value="' . $rateAccuracy . '" type="hidden">';
            echo '<input name="costAccuracy" value="' . $costAccuracy . '" type="hidden">';
            echo '<input name="percentAccuracy" value="' . $percentAccuracy . '" type="hidden">';
            echo '<input name="decimalPoint" value="' . $decimalPoint . '" type="hidden">';
            echo '<input name="thousandsSeparator" value="' . $thousandsSeparator . '" type="hidden">';
            // convert dateFormat
            $dateFormats = array(
                'Y-m-d|yy-mm-dd|Y-m'=>'YYYY-MM-DD Ex: 2010-01-09',
                'd-m-Y|dd-mm-yy|m-Y'=>'DD-MM-YYYY Ex: 09-01-2010',
                'd-m-y|dd-mm-y|m-y'=>'DD-MM-YY   Ex: 09-01-10',
                'd/m/Y|dd/mm/yy|m/Y'=>'DD/MM/YYYY Ex: 09/01/2010',
                'd/m/y|dd/mm/y|m/y'=>'DD/MM/YY   Ex: 09/01/10',
                'j/n/Y|d/m/yy|n/Y'=>'D/M/YYYY   Ex: 9/1/2010',
                'j/n/y|d/m/y|n/y'=>'D/M/YY     Ex: 9/1/10',
                'm/d/Y|mm/dd/yy|m/Y'=>'MM/DD/YYYY Ex: 01/09/2010',
                'm/d/y|mm/dd/y|m/y'=>'MM/DD/YY   Ex: 01/09/10',
                'j.m.Y|d.mm.yy|m.Y'=>'D.MM.YYYY  Ex: 9.01.2010',
                'j.n.Y|d.m.yy|n.Y'=>'D.M.YYYY   Ex: 9.1.2010',
                'd.m.Y|dd.mm.yy|m.Y'=>'DD.MM.YYYY Ex: 09.01.2010',
                'd.m.y|dd.mm.y|m.y'=>'DD.MM.YY   Ex: 09.01.2010',
                'j.n.y|d.m.y|n.y'=>'D.M.YY     Ex: 9.1.10',
                'Y.m.d|yy.mm.dd|Y.m'=>'YYYY.MM.DD Ex: 2010.01.09',
                'd m Y|dd mm yy|m Y'=>'DD MM YYYY Ex: 09 01 2010',
                'd m y|dd mm y|m y'=>'DD MM YY   Ex: 09 01 10');
            foreach ($dateFormats as $key => $val) {
                if (substr($key, 0, 5) == substr($dateFormat, 0, 5)) {
                    $dateFormat = $key;
                    break;
                }
            }
            echo '<input name="dateFormat" value="' . $dateFormat . '" type="hidden">';
            echo '<input name="timeFormat" value="' . $timeFormat . '" type="hidden">';
            echo '<input name="gmtTimezone" value="' . $gmtTimezone . '" type="hidden">';
            echo '<input name="defaultTimezone" value="' . $defaultTimezone . '" type="hidden">';
            echo '<input name="currencyOnRight" value="' . $currencyOnRight . '" type="hidden">';
            echo '<input name="lockThreshold" value="' . $lockThreshold . '" type="hidden">';
            echo '<input name="banThreshold" value="' . $banThreshold . '" type="hidden">';
            echo '<input name="detectHijack" value="' . $detectHijack . '" type="hidden">';
            echo '<input name="pathToOpenssl" value="' . $pathToOpenssl . '" type="hidden">';
            echo '<input name="fileManagement" value="' . $fileManagement . '" type="hidden">';
            echo '<input name="allowPhp" value="' . $allowPhp . '" type="hidden">';
            echo '<input name="peerReview" value="' . $peerReview . '" type="hidden">';
            echo '<input name="activeJpgraph" value="' . $activeJpgraph . '" type="hidden">';
            echo '<input name="footerDev" value="' . $footerDev . '" type="hidden">';
            echo '<input name="projectsFilter" value="' . $projectsFilter . '" type="hidden">';
            echo '<input name="enableHelpSupport" value="' . $enableHelpSupport . '" type="hidden">';
            echo '<input name="supportEmail" value="' . $supportEmail . '" type="hidden">';
            echo '<input name="upload_max_filesize" value="' . $maxFileSize . '" type="hidden">';
            echo "<input type=\"hidden\" name=\"step\" value=\"4\">";
            echo "<input type=\"hidden\" name=\"action\" value=\"save\">";
            $submitName = "Save";
            break;
        }
    case "5":
        $error = false;
        $block1->heading("Save settings");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");
        $htaccessAuth = 'false';
        $fullPath = '/var/www/html/webtareas/files';
        $siteOff = 'false';
        $devMode = 'false';
        $version = $versionNew;
        $dbtypename = (($dbtype=='pg')?'PostgreSQL':'MySQL');

        foreach ($checkList as $fileChk => $fileTyp) {
            if ($fileTyp == "File" && $fileChk != "/includes/settings.php") {
                $content = file_get_contents(".." . $fileChk . "." . $dbtype);

                if (write_file($content, ".." . $fileChk)) {
                    $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "$fileTyp $fileChk copied.", "false", "");
                } else {
                    $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>$fileTyp $fileChk DID NOT copy.</b>", "false", "");
                    $error = true;
                }
            }
        }

        if (!$error) {  // create settings file
            $htmlEntityCharset = 'UTF-8';
            require_once('./setup_settings.php');

            if (write_file($content, "../includes/settings.php")) {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "File /includes/settings.php created.", "false", "");
            } else {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>File /includes/settings.php DID NOT create.</b>", "false", "");
                $error = true;
            }
        }

        if (!$error) {  // create jpgraph files
            $dirCpy = "/includes/jpgraph-4.2.0";

            if (dircpy(".." . $dirCpy, "../includes/jpgraph")) {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "Files in /includes/jpgraph created.", "false", "");
            } else {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Files in /includes/jpgraph DID NOT create.</b>", "false", "");
                $error = true;
            }
        }

        if (!$error) {  // copy old jpgraph settings to new jpgraph folder for references
            $prevsettings = $prevroot . '/includes/jpgraph/jpg-config.inc.php';

            if (file_exists($prevsettings)) {
                $content = file_get_contents($prevsettings);
                @write_file($content, '../includes/jpgraph/jpg-config.inc.php.prev');
            }
        }

        if (!$error) {  // create phpmailer files
            $dirCpy = "/includes/PHPMailer-5.2.19";

            if (dircpy(".." . $dirCpy, "../includes/phpmailer")) {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "Files in /includes/phpmailer created.", "false", "");
            } else {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Files in /includes/phpmailer DID NOT create.</b>", "false", "");
                $error = true;
            }
        }

        if (!$error) {
            $block1->contentRow("", "");
            $block1->contentRow("", "Configuration data has been saved successfully.");
            echo '<input type="hidden" name="prevroot" value="' . $prevroot . '">';
            echo '<input name="prevdbtype" value="' . $prevdbtype . '" type="hidden">';
            echo '<input name="prevdbserver" value="' . $prevdbserver . '" type="hidden">';
            echo '<input name="prevdbname" value="' . $prevdbname . '" type="hidden">';
            echo '<input name="prevdblogin" value="' . $prevdblogin . '" type="hidden">';
            echo '<input name="prevdbpassword" value="' . $prevdbpassword . '" type="hidden">';
            echo '<input name="prevmdmethod" value="' . $prevmdmethod . '" type="hidden">';
            echo '<input name="prevftpserver" value="' . $prevftpserver . '" type="hidden">';
            echo '<input name="prevftplogin" value="' . $prevftplogin . '" type="hidden">';
            echo '<input name="prevftppassword" value="' . $prevftppassword . '" type="hidden">';
            echo '<input name="prevftproot" value="' . $prevftproot . '" type="hidden">';
            echo '<input name="prevtbprefix" value="' . $prevtbprefix . '" type="hidden">';
            echo '<input name="prevlangDefault" value="' . $prevlangDefault . '" type="hidden">';
            echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
            echo "<input type=\"hidden\" name=\"dbtype\" value=\"$dbtype\">";
            echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
            echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
            echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
            echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
            echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
            echo "<input type=\"hidden\" name=\"loginMethod\" value=\"$loginMethod\">";
            echo "<input type=\"hidden\" name=\"mkdirMethod\" value=\"$mkdirMethod\">";
            echo "<input type=\"hidden\" name=\"ftpserver\" value=\"$ftpserver\">";
            echo "<input type=\"hidden\" name=\"ftplogin\" value=\"$ftplogin\">";
            echo "<input type=\"hidden\" name=\"ftppassword\" value=\"$ftppassword\">";
            echo "<input type=\"hidden\" name=\"ftpRoot\" value=\"$ftpRoot\">";
            echo "<input type=\"hidden\" name=\"langDefault\" value=\"$langDefault\">";
            echo "<input type=\"hidden\" name=\"enableTimesheet\" value=\"$enableTimesheet\">";
            echo "<input type=\"hidden\" name=\"enableFlextime\" value=\"$enableFlextime\">";
            echo "<input type=\"hidden\" name=\"enableEquipment\" value=\"$enableEquipment\">";
            echo "<input type=\"hidden\" name=\"enableMaterial\" value=\"$enableMaterial\">";
            $submitName = "Migrate linked contents & create default folders";
            echo "<input type=\"hidden\" name=\"step\" value=\"6\">";
        } else {
            $submitName = "Restart from the beginning";
            echo "<input type=\"hidden\" name=\"step\" value=\"\">";
        }

        break;
    case "6":
        $prevroot = $_REQUEST['prevroot'];
        $prevdbtype = $_REQUEST['prevdbtype'];
        $prevdbserver = $_REQUEST['prevdbserver'];
        $prevdbname = $_REQUEST['prevdbname'];
        $prevdblogin = $_REQUEST['prevdblogin'];
        $prevdbpassword = $_REQUEST['prevdbpassword'];
        $prevmdmethod = $_REQUEST['prevmdmethod'];
        $prevftpserver = $_REQUEST['prevftpserver'];
        $prevftplogin = $_REQUEST['prevftplogin'];
        $prevftppassword = $_REQUEST['prevftppassword'];
        $prevftproot = $_REQUEST['prevftproot'];
        $prevtbprefix = $_REQUEST['prevtbprefix'];
        $prevlangDefault = $_REQUEST['prevlangDefault'];
        $root = $_REQUEST['root'];
        $dbtype = $_REQUEST['dbtype'];
        $dbserver = $_REQUEST['dbserver'];
        $dblogin = $_REQUEST['dblogin'];
        $dbpasswd = $_REQUEST['dbpasswd'];
        $dbname = $_REQUEST['dbname'];
        $tbprefix = $_REQUEST['tbprefix'];
        $loginMethod = $_REQUEST['loginMethod'];
        $mkdirMethod = $_REQUEST['mkdirMethod'];
        $ftpserver = $_REQUEST['ftpserver'];
        $ftplogin = $_REQUEST['ftplogin'];
        $ftppassword = $_REQUEST['ftppassword'];
        $ftpRoot = $_REQUEST['ftpRoot'];
        $langDefault = $_REQUEST['langDefault'];
        $enableTimesheet = $_REQUEST['enableTimesheet'];
        $enableFlextime = $_REQUEST['enableFlextime'];
        $enableEquipment = $_REQUEST['enableEquipment'];
        $enableMaterial = $_REQUEST['enableMaterial'];
        $block1->heading("Migrate linked contents & create default folders");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");

        // extensions migration
        $handle = opendir($prevroot . '/extensions');

        if ($handle) { // if the folder exploration is sucsessful, continue
            while (false !== ($file = readdir($handle))) { // as long as storing the next file to $file is successful, continue
                if ($file != '.' && $file != '..') {
                    $path = $prevroot . '/extensions/' . $file;

                    if (is_dir($path)) {
                        if (!is_dir('../extensions/' . $file)) {
                            mkdir('../extensions/' . $file); // make subdirectory before subdirectory is copied
                        }

                        if (!dircpy($path, '../extensions/' . $file, true)) { //recurse!
                            closedir($handle);
                            return false;
                        }
                    }
                }
           }

           closedir($handle);
        }

        if ($mkdirMethod != $prevmdmethod || $mkdirMethod != 'FTP' || $ftpserver != $prevftpserver || $ftplogin != $prevftplogin || $ftppassword != $prevftppassword || $ftpRoot != $prevftproot) {
            if ($prevmdmethod == 'FTP') {   // download files from previous installation ftp root
                $ftp = ftp_connect($prevftpserver);

                if (!$ftp) {
                    $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Unable to connect to ftp server $prevftpserver.</b>", "false", "");
                    $error = true;
                } else {
                    $login_result = ftp_login($ftp, $prevftplogin, $prevftppassword);

                    if (!$login_result) {
                        $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Unable to log in to ftp server $prevftpserver.</b>", "false", "");
                        $error = true;
                    } else {
                        $contentsrc = str_replace('\\', '/', dirname(__FILE__)) . '/contentsrc';
                        mkdir($contentsrc);
                        $localroot = $contentsrc . '/';

                        if (!ftp_sync($ftp, $localroot, $prevftproot)) {
                            $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Unable to download linked contents from ftp server $prevftpserver.</b>", "false", "");
                            $error = true;
                        }
                    }

                    ftp_close($ftp);
                }
            } else {
                $contentsrc = $prevroot . '/files';
            }

            if (!$error) {
                if ($mkdirMethod == 'FTP') {
                    $ftp = ftp_connect($ftpserver);

                    if (!$ftp) {
                        $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Unable to connect to ftp server $ftpserver.</b>", "false", "");
                        $error = true;
                    } else {
                        $login_result = ftp_login($ftp, $ftplogin, $ftppassword);

                        if (!$login_result) {
                            $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Unable to log in to ftp server $ftpserver.</b>", "false", "");
                            $error = true;
                        } else {
                            foreach ($defaultFolders as $k => $v) {
                                if (!@ftp_chdir($ftp, $ftpRoot . '/' . $k)) {
                                    if (ftp_mkdir($ftp, $ftpRoot . '/' . $k)) {
                                        $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "$v folder created.", "false", "");
                                    } else {
                                        $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>$v folder DID NOT create.</b>", "false", "");
                                        $error = true;
                                    }
                                }
                            }

                            if (dirupload($ftp, $contentsrc, $ftpRoot)) {
                                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "Linked contents migrated.", "false", "");
                            } else {
                                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Unable to upload linked contents to ftp server $ftpserver.</b>", "false", "");
                                $error = true;
                            }
                        }
                    }

                    ftp_close($ftp);
                } else {
                    foreach ($defaultFolders as $k => $v) {
                        if (!is_dir('../files/' . $k)) {
                            if (!mkdir('../files/' . $k)) {
                                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>$v folder DID NOT create.</b>", "false", "");
                                $error = true;
                            } else {
                                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "$v folder created.", "false", "");
                            }
                        }
                    }

                    $contentdesc = preg_replace_callback('/installation$/i', function ($matches) { return ''; }, str_replace('\\', '/', dirname(__FILE__)), 1) . 'files';

                    if (dircpy($contentsrc, $contentdesc)) {
                        $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "Linked contents migrated.", "false", "");
                    } else {
                        $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Unable to migrate linked contents</b>", "false", "");
                        $error = true;
                    }
                }
            }
        } else if ($mkdirMethod == 'FTP' && $ftpserver == $prevftpserver && $ftplogin == $prevftplogin && $ftppassword == $prevftppassword && $ftpRoot == $prevftproot) {
            $ftp = ftp_connect($ftpserver);

            if (!$ftp) {
                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Unable to connect to ftp server $ftpserver.</b>", "false", "");
                $error = true;
            } else {
                $login_result = ftp_login($ftp, $ftplogin, $ftppassword);

                if (!$login_result) {
                    $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>Unable to log in to ftp server $ftpserver.</b>", "false", "");
                    $error = true;
                } else {
                    foreach ($defaultFolders as $k => $v) {
                        if (!@ftp_chdir($ftp, $ftpRoot . '/' . $k)) {
                            if (ftp_mkdir($ftp, $ftpRoot . '/' . $k)) {
                                $block1->contentRow("<img src=\"../themes/" . THEME . "/success.png\">", "$v folder created.", "false", "");
                            } else {
                                $block1->contentRow("<img src=\"../themes/" . THEME . "/error.png\">", "<b>$v folder DID NOT create.</b>", "false", "");
                                $error = true;
                            }
                        }
                    }
                }

                ftp_close($ftp);
            }
        }

        $block1->contentRow("", "");
        echo '<input type="hidden" name="prevroot" value="' . $prevroot . '">';
        echo '<input name="prevdbtype" value="' . $prevdbtype . '" type="hidden">';
        echo '<input name="prevdbserver" value="' . $prevdbserver . '" type="hidden">';
        echo '<input name="prevdbname" value="' . $prevdbname . '" type="hidden">';
        echo '<input name="prevdblogin" value="' . $prevdblogin . '" type="hidden">';
        echo '<input name="prevdbpassword" value="' . $prevdbpassword . '" type="hidden">';
        echo '<input name="prevmdmethod" value="' . $prevmdmethod . '" type="hidden">';
        echo '<input name="prevftpserver" value="' . $prevftpserver . '" type="hidden">';
        echo '<input name="prevftplogin" value="' . $prevftplogin . '" type="hidden">';
        echo '<input name="prevftppassword" value="' . $prevftppassword . '" type="hidden">';
        echo '<input name="prevftproot" value="' . $prevftproot . '" type="hidden">';
        echo '<input name="prevtbprefix" value="' . $prevtbprefix . '" type="hidden">';
        echo '<input name="prevlangDefault" value="' . $prevlangDefault . '" type="hidden">';
        echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
        echo "<input type=\"hidden\" name=\"dbtype\" value=\"$dbtype\">";
        echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
        echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
        echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
        echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
        echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
        echo "<input type=\"hidden\" name=\"loginMethod\" value=\"$loginMethod\">";
        echo "<input type=\"hidden\" name=\"mkdirMethod\" value=\"$mkdirMethod\">";
        echo "<input type=\"hidden\" name=\"ftpserver\" value=\"$ftpserver\">";
        echo "<input type=\"hidden\" name=\"ftplogin\" value=\"$ftplogin\">";
        echo "<input type=\"hidden\" name=\"ftppassword\" value=\"$ftppassword\">";
        echo "<input type=\"hidden\" name=\"ftpRoot\" value=\"$ftpRoot\">";
        echo "<input type=\"hidden\" name=\"langDefault\" value=\"$langDefault\">";
        echo "<input type=\"hidden\" name=\"enableTimesheet\" value=\"$enableTimesheet\">";
        echo "<input type=\"hidden\" name=\"enableFlextime\" value=\"$enableFlextime\">";
        echo "<input type=\"hidden\" name=\"enableEquipment\" value=\"$enableEquipment\">";
        echo "<input type=\"hidden\" name=\"enableMaterial\" value=\"$enableMaterial\">";

        if (!$error) {
            $block1->contentRow("", "");
            $block1->contentRow("", "Linked contents have been migrated & default folders have been created successfully.");
            $submitName = "Check database";
            echo "<input type=\"hidden\" name=\"step\" value=\"7\">";
        } else {
            $block1->contentRow("", "Please check the create folder method configuration.");
            $submitName = "Reload";
            echo "<input type=\"hidden\" name=\"step\" value=\"4\">";
            require('../includes/settings.php');
            echo '<input type="hidden" name="connexion" value="' . $installationType . '">';
            echo '<input type="hidden" name="updatechecker" value="' . $updatechecker . '">';
            echo '<input type="hidden" name="installationType" value="' . $installationType . '">';
            echo '<input type="hidden" name="dbtype" value="' . $dbtype . '">';
            echo '<input type="hidden" name="notifications" value="' . $notifications . '">';
            echo '<input type="hidden" name="notificationMethod" value="' . $notificationMethod . '">';
            echo '<input type="hidden" name="smtpserver" value="' . SMTPSERVER . '">';
            echo '<input type="hidden" name="smtpport" value="' . SMTPPORT . '">';
            echo '<input type="hidden" name="smtpsecure" value="' . SMTPSECURE . '">';
            echo '<input type="hidden" name="smtplogin" value="' . SMTPLOGIN . '">';
            echo '<input type="hidden" name="smtppassword" value="' . SMTPPASSWORD . '">';
            echo '<input type="hidden" name="adminPwa" value="' . $adminPwd . '">';
            echo "<input type=\"hidden\" name=\"adminMail\" value=\"$adminMail\">";
            echo '<input type="hidden" name="sitePublish" value="' . $sitePublish . '">';
            echo '<input type="hidden" name="enableTimesheet" value="' . $enableTimesheet . '">';
            echo '<input type="hidden" name="enableFlextime" value="' . $enableFlextime . '">';
            echo '<input type="hidden" name="enableEquipment" value="' . $enableEquipment . '">';
            echo '<input type="hidden" name="enableMaterial" value="' . $enableMaterial. '">';
            echo '<input type="hidden" name="autoCreateDir" value="' . $autoCreateDir . '">';
            echo '<input type="hidden" name="periodUnit" value="' . $periodUnit . '">';
            echo '<input type="hidden" name="autoLockPeriod" value="' . $autoLockPeriod . '">';
            echo '<input type="hidden" name="hourAccuracy" value="' . $hourAccuracy . '">';
            echo '<input type="hidden" name="quantityAccuracy" value="' . $quantityAccuracy . '">';
            echo '<input type="hidden" name="measureAccuracy" value="' . $measureAccuracy . '">';
            echo '<input type="hidden" name="rateAccuracy" value="' . $rateAccuracy . '">';
            echo '<input type="hidden" name="costAccuracy" value="' . $costAccuracy . '">';
            echo '<input type="hidden" name="percentAccuracy" value="' . $percentAccuracy . '">';
            echo '<input type="hidden" name="decimalPoint" value="' . $decimalPoint . '">';
            echo '<input type="hidden" name="thousandsSeparator" value="' . $thousandsSeparator . '">';
            echo '<input type="hidden" name="dateFormat" value="' . $dateFormat . '">';
            echo '<input type="hidden" name="timeFormat" value="' . $timeFormat . '">';
            echo '<input type="hidden" name="defaultTimezone" value="' . $defaultTimezone . '">';
        }

        break;
    case "7":
        $prevroot = $_REQUEST['prevroot'];
        $prevdbtype = $_REQUEST['prevdbtype'];
        $prevdbserver = $_REQUEST['prevdbserver'];
        $prevdbname = $_REQUEST['prevdbname'];
        $prevdblogin = $_REQUEST['prevdblogin'];
        $prevdbpassword = $_REQUEST['prevdbpassword'];
        $prevmdmethod = $_REQUEST['prevmdmethod'];
        $prevftpserver = $_REQUEST['prevftpserver'];
        $prevftplogin = $_REQUEST['prevftplogin'];
        $prevftppassword = $_REQUEST['prevftppassword'];
        $prevftproot = $_REQUEST['prevftproot'];
        $prevtbprefix = $_REQUEST['prevtbprefix'];
        $prevlangDefault = $_REQUEST['prevlangDefault'];
        $root = $_REQUEST['root'];
        $dbtype = $_REQUEST['dbtype'];
        $dbserver = $_REQUEST['dbserver'];
        $dblogin = $_REQUEST['dblogin'];
        $dbpasswd = $_REQUEST['dbpasswd'];
        $dbname = $_REQUEST['dbname'];
        $tbprefix = $_REQUEST['tbprefix'];
        $loginMethod = $_REQUEST['loginMethod'];
        $mkdirMethod = $_REQUEST['mkdirMethod'];
        $ftpserver = $_REQUEST['ftpserver'];
        $ftplogin = $_REQUEST['ftplogin'];
        $ftppassword = $_REQUEST['ftppassword'];
        $ftpRoot = $_REQUEST['ftpRoot'];
        $langDefault = $_REQUEST['langDefault'];
        $enableTimesheet = $_REQUEST['enableTimesheet'];
        $enableFlextime = $_REQUEST['enableFlextime'];
        $enableEquipment = $_REQUEST['enableEquipment'];
        $enableMaterial = $_REQUEST['enableMaterial'];
        $block1->heading("Check database");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");
        require_once("./upgrade_db.php");

        if ($prevdbtype == 'my') {  // check database connection for previous installation
            check_mysql($prevdbserver, $prevdblogin, $prevdbpassword, $prevdbname);
        } else {
            check_postgres($prevdbserver, $prevdblogin, $prevdbpassword, $prevdbname);
        }

        if ($dbtype == 'my') {  // check database connection for new installation
            check_mysql($dbserver, $dblogin, $dbpasswd, $dbname);
        } else {
            check_postgres($dbserver, $dblogin, $dbpasswd, $dbname);
        }

        $block1->contentRow("", "");
        echo '<input type="hidden" name="prevroot" value="' . $prevroot . '">';
        echo '<input name="prevdbtype" value="' . $prevdbtype . '" type="hidden">';
        echo '<input name="prevdbserver" value="' . $prevdbserver . '" type="hidden">';
        echo '<input name="prevdbname" value="' . $prevdbname . '" type="hidden">';
        echo '<input name="prevdblogin" value="' . $prevdblogin . '" type="hidden">';
        echo '<input name="prevdbpassword" value="' . $prevdbpassword . '" type="hidden">';
        echo '<input name="prevmdmethod" value="' . $prevmdmethod . '" type="hidden">';
        echo '<input name="prevftpserver" value="' . $prevftpserver . '" type="hidden">';
        echo '<input name="prevftplogin" value="' . $prevftplogin . '" type="hidden">';
        echo '<input name="prevftppassword" value="' . $prevftppassword . '" type="hidden">';
        echo '<input name="prevftproot" value="' . $prevftproot . '" type="hidden">';
        echo '<input name="prevtbprefix" value="' . $prevtbprefix . '" type="hidden">';
        echo '<input name="prevlangDefault" value="' . $prevlangDefault . '" type="hidden">';
        echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
        echo "<input type=\"hidden\" name=\"dbtype\" value=\"$dbtype\">";
        echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
        echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
        echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
        echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
        echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
        echo "<input type=\"hidden\" name=\"loginMethod\" value=\"$loginMethod\">";
        echo "<input type=\"hidden\" name=\"mkdirMethod\" value=\"$mkdirMethod\">";
        echo "<input type=\"hidden\" name=\"ftpserver\" value=\"$ftpserver\">";
        echo "<input type=\"hidden\" name=\"ftplogin\" value=\"$ftplogin\">";
        echo "<input type=\"hidden\" name=\"ftppassword\" value=\"$ftppassword\">";
        echo "<input type=\"hidden\" name=\"ftpRoot\" value=\"$ftpRoot\">";
        echo '<input type="hidden" name="langDefault" value="' . $langDefault . '">';
        echo "<input type=\"hidden\" name=\"enableTimesheet\" value=\"$enableTimesheet\">";
        echo "<input type=\"hidden\" name=\"enableFlextime\" value=\"$enableFlextime\">";
        echo "<input type=\"hidden\" name=\"enableEquipment\" value=\"$enableEquipment\">";
        echo "<input type=\"hidden\" name=\"enableMaterial\" value=\"$enableMaterial\">";

        if ($error) {
            $block1->contentRow("", "Please check the database server and its configuration.");
            $submitName = "Reload";
            echo "<input type=\"hidden\" name=\"step\" value=\"7\">";
            require('../includes/settings.php');
            echo '<input type="hidden" name="connexion" value="' . $installationType . '">';
            echo '<input type="hidden" name="updatechecker" value="' . $updatechecker . '">';
            echo '<input type="hidden" name="installationType" value="' . $installationType . '">';
            echo '<input type="hidden" name="dbtype" value="' . $dbtype . '">';
            echo '<input type="hidden" name="notifications" value="' . $notifications . '">';
            echo '<input type="hidden" name="notificationMethod" value="' . $notificationMethod . '">';
            echo '<input type="hidden" name="smtpserver" value="' . SMTPSERVER . '">';
            echo '<input type="hidden" name="smtpport" value="' . SMTPPORT . '">';
            echo '<input type="hidden" name="smtpsecure" value="' . SMTPSECURE . '">';
            echo '<input type="hidden" name="smtplogin" value="' . SMTPLOGIN . '">';
            echo '<input type="hidden" name="smtppassword" value="' . SMTPPASSWORD . '">';
            echo '<input type="hidden" name="adminPwa" value="' . $adminPwd . '">';
            echo "<input type=\"hidden\" name=\"adminMail\" value=\"$adminMail\">";
            echo '<input type="hidden" name="sitePublish" value="' . $sitePublish . '">';
            echo '<input type="hidden" name="enableTimesheet" value="' . $enableTimesheet . '">';
            echo '<input type="hidden" name="enableFlextime" value="' . $enableFlextime . '">';
            echo '<input type="hidden" name="enableEquipment" value="' . $enableEquipment . '">';
            echo '<input type="hidden" name="enableMaterial" value="' . $enableMaterial. '">';
            echo '<input type="hidden" name="autoCreateDir" value="' . $autoCreateDir . '">';
            echo '<input type="hidden" name="periodUnit" value="' . $periodUnit . '">';
            echo '<input type="hidden" name="autoLockPeriod" value="' . $autoLockPeriod . '">';
            echo '<input type="hidden" name="hourAccuracy" value="' . $hourAccuracy . '">';
            echo '<input type="hidden" name="quantityAccuracy" value="' . $quantityAccuracy . '">';
            echo '<input type="hidden" name="measureAccuracy" value="' . $measureAccuracy . '">';
            echo '<input type="hidden" name="rateAccuracy" value="' . $rateAccuracy . '">';
            echo '<input type="hidden" name="costAccuracy" value="' . $costAccuracy . '">';
            echo '<input type="hidden" name="percentAccuracy" value="' . $percentAccuracy . '">';
            echo '<input type="hidden" name="decimalPoint" value="' . $decimalPoint . '">';
            echo '<input type="hidden" name="thousandsSeparator" value="' . $thousandsSeparator . '">';
            echo '<input type="hidden" name="dateFormat" value="' . $dateFormat . '">';
            echo '<input type="hidden" name="timeFormat" value="' . $timeFormat . '">';
            echo '<input type="hidden" name="defaultTimezone" value="' . $defaultTimezone . '">';
        } else {
            $block1->contentRow("", "No errors detected.");
            $submitName = "Create tables";
            echo "<input type=\"hidden\" name=\"step\" value=\"8\">";
        }

        break;
    case "8":
        $prevroot = $_REQUEST['prevroot'];
        $prevdbtype = $_REQUEST['prevdbtype'];
        $prevdbserver = $_REQUEST['prevdbserver'];
        $prevdbname = $_REQUEST['prevdbname'];
        $prevdblogin = $_REQUEST['prevdblogin'];
        $prevdbpassword = $_REQUEST['prevdbpassword'];
        $prevmdmethod = $_REQUEST['prevmdmethod'];
        $prevftpserver = $_REQUEST['prevftpserver'];
        $prevftplogin = $_REQUEST['prevftplogin'];
        $prevftppassword = $_REQUEST['prevftppassword'];
        $prevftproot = $_REQUEST['prevftproot'];
        $prevtbprefix = $_REQUEST['prevtbprefix'];
        $prevlangDefault = $_REQUEST['prevlangDefault'];
        $root = $_REQUEST['root'];
        $dbtype = $_REQUEST['dbtype'];
        $dbserver = $_REQUEST['dbserver'];
        $dblogin = $_REQUEST['dblogin'];
        $dbpasswd = $_REQUEST['dbpasswd'];
        $dbname = $_REQUEST['dbname'];
        $tbprefix = $_REQUEST['tbprefix'];
        $loginMethod = $_REQUEST['loginMethod'];
        $mkdirMethod = $_REQUEST['mkdirMethod'];
        $ftpserver = $_REQUEST['ftpserver'];
        $ftplogin = $_REQUEST['ftplogin'];
        $ftppassword = $_REQUEST['ftppassword'];
        $ftpRoot = $_REQUEST['ftpRoot'];
        $langDefault = $_REQUEST['langDefault'];
        $enableTimesheet = $_REQUEST['enableTimesheet'];
        $enableFlextime = $_REQUEST['enableFlextime'];
        $enableEquipment = $_REQUEST['enableEquipment'];
        $enableMaterial = $_REQUEST['enableMaterial'];
        $block1->heading("Create tables");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");
        $error = false;
        $adminLogin = '';
        $adminPwd = '';
        $adminMail = '';
        require_once("../includes/defines.lib.php");
        require_once("./setup_db.php");
        set_time_limit(0);
        create_tables();
        echo '<input type="hidden" name="prevroot" value="' . $prevroot . '">';
        echo '<input name="prevdbtype" value="' . $prevdbtype . '" type="hidden">';
        echo '<input name="prevdbserver" value="' . $prevdbserver . '" type="hidden">';
        echo '<input name="prevdbname" value="' . $prevdbname . '" type="hidden">';
        echo '<input name="prevdblogin" value="' . $prevdblogin . '" type="hidden">';
        echo '<input name="prevdbpassword" value="' . $prevdbpassword . '" type="hidden">';
        echo '<input name="prevmdmethod" value="' . $prevmdmethod . '" type="hidden">';
        echo '<input name="prevftpserver" value="' . $prevftpserver . '" type="hidden">';
        echo '<input name="prevftplogin" value="' . $prevftplogin . '" type="hidden">';
        echo '<input name="prevftppassword" value="' . $prevftppassword . '" type="hidden">';
        echo '<input name="prevftproot" value="' . $prevftproot . '" type="hidden">';
        echo '<input name="prevtbprefix" value="' . $prevtbprefix . '" type="hidden">';
        echo '<input name="prevlangDefault" value="' . $prevlangDefault . '" type="hidden">';
        echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
        echo "<input type=\"hidden\" name=\"dbtype\" value=\"$dbtype\">";
        echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
        echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
        echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
        echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
        echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
        echo "<input type=\"hidden\" name=\"loginMethod\" value=\"$loginMethod\">";
        echo "<input type=\"hidden\" name=\"mkdirMethod\" value=\"$mkdirMethod\">";
        echo "<input type=\"hidden\" name=\"ftpserver\" value=\"$ftpserver\">";
        echo "<input type=\"hidden\" name=\"ftplogin\" value=\"$ftplogin\">";
        echo "<input type=\"hidden\" name=\"ftppassword\" value=\"$ftppassword\">";
        echo "<input type=\"hidden\" name=\"ftpRoot\" value=\"$ftpRoot\">";
        echo '<input type="hidden" name="langDefault" value="' . $langDefault . '">';
        echo "<input type=\"hidden\" name=\"enableTimesheet\" value=\"$enableTimesheet\">";
        echo "<input type=\"hidden\" name=\"enableFlextime\" value=\"$enableFlextime\">";
        echo "<input type=\"hidden\" name=\"enableEquipment\" value=\"$enableEquipment\">";
        echo "<input type=\"hidden\" name=\"enableMaterial\" value=\"$enableMaterial\">";

        if ($error) {
            $submitName = "Check database again";
            echo "<input type=\"hidden\" name=\"step\" value=\"7\">";
            require('../includes/settings.php');
            echo '<input type="hidden" name="connexion" value="' . $installationType . '">';
            echo '<input type="hidden" name="updatechecker" value="' . $updatechecker . '">';
            echo '<input type="hidden" name="installationType" value="' . $installationType . '">';
            echo '<input type="hidden" name="dbtype" value="' . $dbtype . '">';
            echo '<input type="hidden" name="notifications" value="' . $notifications . '">';
            echo '<input type="hidden" name="notificationMethod" value="' . $notificationMethod . '">';
            echo '<input type="hidden" name="smtpserver" value="' . SMTPSERVER . '">';
            echo '<input type="hidden" name="smtpport" value="' . SMTPPORT . '">';
            echo '<input type="hidden" name="smtpsecure" value="' . SMTPSECURE . '">';
            echo '<input type="hidden" name="smtplogin" value="' . SMTPLOGIN . '">';
            echo '<input type="hidden" name="smtppassword" value="' . SMTPPASSWORD . '">';
            echo '<input type="hidden" name="adminPwa" value="' . $adminPwd . '">';
            echo "<input type=\"hidden\" name=\"adminMail\" value=\"$adminMail\">";
            echo '<input type="hidden" name="sitePublish" value="' . $sitePublish . '">';
            echo '<input type="hidden" name="enableTimesheet" value="' . $enableTimesheet . '">';
            echo '<input type="hidden" name="enableFlextime" value="' . $enableFlextime . '">';
            echo '<input type="hidden" name="enableEquipment" value="' . $enableEquipment . '">';
            echo '<input type="hidden" name="enableMaterial" value="' . $enableMaterial. '">';
            echo '<input type="hidden" name="autoCreateDir" value="' . $autoCreateDir . '">';
            echo '<input type="hidden" name="periodUnit" value="' . $periodUnit . '">';
            echo '<input type="hidden" name="autoLockPeriod" value="' . $autoLockPeriod . '">';
            echo '<input type="hidden" name="hourAccuracy" value="' . $hourAccuracy . '">';
            echo '<input type="hidden" name="quantityAccuracy" value="' . $quantityAccuracy . '">';
            echo '<input type="hidden" name="measureAccuracy" value="' . $measureAccuracy . '">';
            echo '<input type="hidden" name="rateAccuracy" value="' . $rateAccuracy . '">';
            echo '<input type="hidden" name="costAccuracy" value="' . $costAccuracy . '">';
            echo '<input type="hidden" name="percentAccuracy" value="' . $percentAccuracy . '">';
            echo '<input type="hidden" name="decimalPoint" value="' . $decimalPoint . '">';
            echo '<input type="hidden" name="thousandsSeparator" value="' . $thousandsSeparator . '">';
            echo '<input type="hidden" name="dateFormat" value="' . $dateFormat . '">';
            echo '<input type="hidden" name="timeFormat" value="' . $timeFormat . '">';
            echo '<input type="hidden" name="defaultTimezone" value="' . $defaultTimezone . '">';
        } else {
            $block1->contentRow("", "");
            $block1->contentRow("", "Database tables created.");
            $submitName = "Data migration";
            echo "<input type=\"hidden\" name=\"step\" value=\"9\">";
        }

        break;
    case "9":
        $prevroot = $_REQUEST['prevroot'];
        $prevdbtype = $_REQUEST['prevdbtype'];
        $prevdbserver = $_REQUEST['prevdbserver'];
        $prevdbname = $_REQUEST['prevdbname'];
        $prevdblogin = $_REQUEST['prevdblogin'];
        $prevdbpassword = $_REQUEST['prevdbpassword'];
        $prevmdmethod = $_REQUEST['prevmdmethod'];
        $prevftpserver = $_REQUEST['prevftpserver'];
        $prevftplogin = $_REQUEST['prevftplogin'];
        $prevftppassword = $_REQUEST['prevftppassword'];
        $prevftproot = $_REQUEST['prevftproot'];
        $prevtbprefix = $_REQUEST['prevtbprefix'];
        $prevlangDefault = $_REQUEST['prevlangDefault'];
        $root = $_REQUEST['root'];
        $dbtype = $_REQUEST['dbtype'];
        $dbserver = $_REQUEST['dbserver'];
        $dblogin = $_REQUEST['dblogin'];
        $dbpasswd = $_REQUEST['dbpasswd'];
        $dbname = $_REQUEST['dbname'];
        $tbprefix = $_REQUEST['tbprefix'];
        $loginMethod = $_REQUEST['loginMethod'];
        $mkdirMethod = $_REQUEST['mkdirMethod'];
        $ftpserver = $_REQUEST['ftpserver'];
        $ftplogin = $_REQUEST['ftplogin'];
        $ftppassword = $_REQUEST['ftppassword'];
        $ftpRoot = $_REQUEST['ftpRoot'];
        $langDefault = $_REQUEST['langDefault'];
        $enableTimesheet = $_REQUEST['enableTimesheet'];
        $enableFlextime = $_REQUEST['enableFlextime'];
        $enableEquipment = $_REQUEST['enableEquipment'];
        $enableMaterial = $_REQUEST['enableMaterial'];
        $block1->heading("Data migration");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");
        $error = false;
        require_once("../includes/defines.lib.php");
        require_once("./upgrade_db.php");
        set_time_limit(0);

        if ($prevdbtype == 'my') {
            upgrade_database_my2my($prevdbserver, $prevdblogin, $prevdbpassword, $prevdbname, $prevtbprefix, $dbserver, $dblogin, $dbpasswd, $dbname, $tbprefix);
        } else {
            upgrade_database_pg2pg($prevdbserver, $prevdblogin, $prevdbpassword, $prevdbname, $prevtbprefix, $dbserver, $dblogin, $dbpasswd, $dbname, $tbprefix);
        }

        if ($error) {
            $submitName = "Check database again";
            echo '<input type="hidden" name="prevroot" value="' . $prevroot . '">';
            echo '<input name="prevdbtype" value="' . $prevdbtype . '" type="hidden">';
            echo '<input name="prevdbserver" value="' . $prevdbserver . '" type="hidden">';
            echo '<input name="prevdbname" value="' . $prevdbname . '" type="hidden">';
            echo '<input name="prevdblogin" value="' . $prevdblogin . '" type="hidden">';
            echo '<input name="prevdbpassword" value="' . $prevdbpassword . '" type="hidden">';
            echo '<input name="prevmdmethod" value="' . $prevmdmethod . '" type="hidden">';
            echo '<input name="prevftpserver" value="' . $prevftpserver . '" type="hidden">';
            echo '<input name="prevftplogin" value="' . $prevftplogin . '" type="hidden">';
            echo '<input name="prevftppassword" value="' . $prevftppassword . '" type="hidden">';
            echo '<input name="prevftproot" value="' . $prevftproot . '" type="hidden">';
            echo '<input name="prevtbprefix" value="' . $prevtbprefix . '" type="hidden">';
            echo '<input name="prevlangDefault" value="' . $prevlangDefault . '" type="hidden">';
            echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
            echo '<input name="dbtype" value="' . $dbtype . '" type="hidden">';
            echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
            echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
            echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
            echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
            echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
            echo "<input type=\"hidden\" name=\"step\" value=\"7\">";
            echo "<input type=\"hidden\" name=\"mkdirMethod\" value=\"$mkdirMethod\">";
            echo "<input type=\"hidden\" name=\"ftpserver\" value=\"$ftpserver\">";
            echo "<input type=\"hidden\" name=\"ftplogin\" value=\"$ftplogin\">";
            echo "<input type=\"hidden\" name=\"ftppassword\" value=\"$ftppassword\">";
            echo "<input type=\"hidden\" name=\"ftpRoot\" value=\"$ftpRoot\">";
        } else {
            $block1->contentRow("", "");
            $block1->contentRow("", "Data was migrated successfully.");
            $submitName = "Finish";
            echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
            echo "<input type=\"hidden\" name=\"step\" value=\"10\">";
        }

        break;
    case "10":
        foreach ($dbTypList as $dbTyp) {
            foreach ($checkList as $fileChk => $fileTyp) {
                $pathName = ".." . $fileChk . "." . $dbTyp;

                if ($fileTyp == "File" && $fileChk != "/includes/settings.php" && file_exists($pathName)) {
                    @unlink($pathName);
                }
            }
        }

        rmdirr('../includes/jpgraph-4.2.0');
        rmdirr('../includes/PHPMailer-5.2.19');
        $root = $_REQUEST['root'];
        $block1->heading("Upgrade Complete");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");
        $block1->contentRow("Your site", $block1->buildLink($root, "Click HERE to see the home page of your site.", "in"));
        $block1->contentRow("Support", $block1->buildLink("http://webtareas.sourceforge.net", "Visit webTareas", "in"));
        break;
}

if ($step != "10") {
    $block1->contentRow("", "<input type=\"SUBMIT\" name=\"save\" value=\"$submitName\">");
}

$block1->closeContent();
$block1->closeForm();
$footerDev = false;
$version = $versionNew;
require_once("../includes/footer.php");

/**
 * Convert all applicable characters to HTML entities
 *
 * @param string $string The input string
 * @return string
 */
function HtmlEntitiesNOD($string) {
    return htmlentities ($string, ENT_QUOTES, 'utf-8');
}
/**
 * Convert all HTML entities to their applicable characters
 *
 * @param string $string The input string
 * @return string
 */
function HtmlEntityDecodeNOD($string) {
    return html_entity_decode($string, ENT_QUOTES, 'utf-8');
}

// dummy function to print language strings
function lang_strings($str)
{
    return $str;
}

// Write file
function write_file($content, $dest)
{
    $fp = @fopen($dest, 'wb+');
    $fw = fwrite($fp, $content);
    fclose($fp);
    return $fw;
}

// ftp_sync - Copy directory and file structure
function ftp_sync($ftp, $localroot, $dir)
{
    set_time_limit(0);

    if ($dir != ".") {
        if (ftp_chdir($ftp, $dir) == false) {
            return false;
        }

        if (!(is_dir($localroot . $dir))) {
            mkdir($localroot . $dir);
        }

        chdir($localroot . $dir);
        $localroot = $localroot . $dir . '/';
    }

    $contents = ftp_nlist($ftp, ".");

    foreach ($contents as $file) {
        if ($file == '.' || $file == '..') {
            continue;
        }

        if (@ftp_chdir($ftp, $file)) {
            ftp_chdir($ftp, "..");

            if (!ftp_sync($ftp, $localroot, $file)) {
                return false;
            }
        } else {
            ftp_get($ftp, $file, $file, FTP_BINARY);
        }
    }

    ftp_chdir($ftp, "..");
    chdir("..");
    return true;
}

// copy a directory and all subdirectories and files (recursive)
// void dircpy( str 'source directory', str 'destination directory' [, bool 'overwrite existing files'] )
function dircpy($source, $dest, $overwrite = false){
    set_time_limit(0);
    $handle = opendir($source);

    if ($handle) { // if the folder exploration is sucsessful, continue
        while (false !== ($file = readdir($handle))) { // as long as storing the next file to $file is successful, continue
            if ($file != '.' && $file != '..') {
                $path = $source . '/' . $file;

                if (is_file($path)) {
                    if (!is_file($dest . '/' . $file) || $overwrite) {
                        if (!@copy($path, $dest . '/' . $file)) {
                            return false;
                        }
                    }
                } elseif (is_dir($path)) {
                    if (!is_dir($dest . '/' . $file)) {
                        mkdir($dest . '/' . $file); // make subdirectory before subdirectory is copied
                    }

                    if (!dircpy($path, $dest . '/' . $file, $overwrite)) { //recurse!
                        closedir($handle);
                        return false;
                    }
                }
            }
       }

       closedir($handle);
    }

    return true;
} // end of dircpy()

// upload a directory and all subdirectories and files via ftp (recursive)
function dirupload($ftp, $source, $dest){
    set_time_limit(0);
    $contents = ftp_nlist($ftp, ".");

    if (!in_array($dest, $contents)) {
        ftp_mkdir($ftp, $dest);
    }

    ftp_chdir($ftp, $dest);
    $handle = opendir($source);

    if ($handle) { // if the folder exploration is sucsessful, continue
        while (false !== ($file = readdir($handle))) { // as long as storing the next file to $file is successful, continue
            if ($file != '.' && $file != '..') {
                $path = $source . '/' . $file;
                $contents = ftp_nlist($ftp, ".");

                if (is_file($path)) {
                    if (!in_array($file, $contents)) {
                        @ftp_put($ftp, $file, $file,  FTP_BINARY);
                    }
                } elseif (is_dir($path)) {
                    if (!dirupload($ftp, $path, $file)) { //recurse!
                        closedir($handle);
                        return false;
                    }
                }
            }
       }

       closedir($handle);
    }

    return true;
} // end of dirupload()

/**
 * Delete a file, or a folder and its contents
 *
 * @author      Aidan Lister <aidan@php.net>
 * @version     1.0.2
 * @param       string   $dirname    Directory to delete
 * @return      bool     Returns TRUE on success, FALSE on failure
 */
function rmdirr($dirname)
{
    // Sanity check
    if (!file_exists($dirname)) {
        return false;
    }

    // Simple delete for a file
    if (is_file($dirname)) {
        usleep(10);
        return unlink($dirname);
    }

    // Loop through the folder
    $dir = dir($dirname);
    while (false !== $entry = $dir->read()) {
        // Skip pointers
        if ($entry == '.' || $entry == '..') {
            continue;
        }

        // Recurse
        rmdirr("$dirname/$entry");
    }

    // Clean up
    $dir->close();
    usleep(10);
    return rmdir($dirname);
}
/**
 * generate decimal place selection html
 * @param object $block1
 * @param string $title
 * @param string $name
 * @param string $val
 */
function setupDecimalPlaceSelectionHtml($block1, $title, $name, $val)
{
    $selHtml = '<select name="' . $name . '">';

    for ($i=0; $i<=6; $i++) {
        if ($i == $val) {
            $selHtml .= '<option value="' . $i . '" selected>' . $i . '</option>';
        } else {
            $selHtml .= '<option value="' . $i . '">' . $i . '</option>';
        }
    }

    $selHtml .= '</select>';
    $block1->contentRow($title, $selHtml);
}
/**
 * append file modification time to image path/url
 * @param string $path
 * @return string
 */
function verSource($path)
{
    return '../' . $path . '?ver=' . filemtime('../' . $path);
}

function messageBox($error)
{
    global $strings;
    echo '<script>'
    . '$(document).ready(function() {'
        . '$("body").prepend("<div id=\'wtMsgBox\'><div class=\'errorMsg\'><b>' . $strings['errors'] . '</b> ' . $error . '</div></div>");'
        . 'setTimeout(function() { $("#wtMsgBox").fadeOut(); }, 15000);'
    . '});'
    . '</script>';
}
