<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: approveinvoice.php,v 1.13 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Variables init
 */
$action = isset($_POST['action'])?$_POST['action']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$id0 = isset($_GET['id'])?$_GET['id']:'0';
$doc0 = isset($_GET['doc'])?$_GET['doc']:'0';
$auth0 = isset($_GET['auth'])?$_GET['auth']:'';

if ($auth0 == '') {
    $checkSession = true;
} else {
    $blank = 'true';
    $checkSession = false;
}

/**
 * Includes
 */
$extractImportVariables = 'false';
require_once("../includes/library.php");
$id = AddSlashesNOD($id0);
$doc = AddSlashesNOD($doc0);
$auth = AddSlashesNOD($auth0);

/**
 * Permission check
 */
if ($auth == '') {
    $querymore = " WHERE daa.document_approval='$doc' AND daa.authorizer='$idSession' AND dap.docid='$id' AND dap.doctype='invoices' AND dap.current_stage=daa.stage AND dap.closed='N'";
} else {
    $querymore = " WHERE daa.document_approval='$doc' AND daa.approve_string='$auth' AND daa.string_validto>=" . time() . " AND dap.docid='$id' AND dap.doctype='invoices' AND dap.current_stage=daa.stage AND dap.canceled='N' AND dap.closed='N'";
}

$documentsApprovalAuthorizerDetail = new request();
$documentsApprovalAuthorizerDetail->openDocumentsApprovalAuthorizers($querymore);
$comptDocumentsApprovalAuthorizerDetail = count($documentsApprovalAuthorizerDetail->daa_document_approval);

if ($comptDocumentsApprovalAuthorizerDetail == '0') {
    if ($auth == '') {
        header("Location: ../general/permissiondenied.php");
        exit;
    } else {
        header("Location: ../general/login.php?url=invoices/approveinvoice.php%3Fid=$id%26doc=$doc");
        exit;
    }
} else if ($documentsApprovalAuthorizerDetail->daa_dap_canceled[0] == 'Y') {
    header("Location: ../general/home.php?msg=docCanceled");
    exit;
}

$document_approval = $documentsApprovalAuthorizerDetail->daa_document_approval[0];
$confirmation_level = $documentsApprovalAuthorizerDetail->daa_confirmation_level[0];
$approval = $documentsApprovalAuthorizerDetail->daa_dap_approval[0];
$producer = $documentsApprovalAuthorizerDetail->daa_dap_owner[0];
$current_stage = $documentsApprovalAuthorizerDetail->daa_dap_current_stage[0];
$document_status = $documentsApprovalAuthorizerDetail->daa_dap_status[0];
$doctype = 'invoices';
$querymore = " WHERE inv.id='$id'";
$invoiceDetail = new request();
$invoiceDetail->openInvoices($querymore);

/**
 * Actions
 */
if ($action == 'approve') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($auth != '') {
            $idSession = $documentsApprovalAuthorizerDetail->daa_authorizer[0];
        }

        if (!defined('INNER_APPROVEDOCUMENT')) {
            define('INNER_APPROVEDOCUMENT', 1);
        }

        require_once("../approvals/approvedocument.php");

        if ($document_status == enumApprovalStatus::stApproved) {
            $tmpsql = "UPDATE " . $tablePrefix . "invoices SET status='" . enumDocumentStatus::stOpen . "',status_approval='" . enumFileStatus::stApproved . "',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $querymore5 = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtInvoice . "' AND fil.doc_id='$id'";
            $listFiles = clone $requestAct;
            $listFiles->openFiles($querymore5);

            if (count($listFiles->fil_id) > 0) {
                $tmpsql = 'UPDATE ' . $tablePrefix . "files SET status='" . enumFileStatus::stApproved . "' WHERE doc_type='" . enumFileRelatedDocumentType::dtInvoice . "' AND doc_id='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $ids = "'" . implode("','", $listFiles->fil_id) . "'";
            copy2HistoryTable($requestAct, 'files', $ids, 'U');
            $invno = newInvoiceNo($requestAct, $invoiceDetail->inv_doc_date[0], $id);
            $tmpsql = "UPDATE " . $tablePrefix . "invoices SET invoice_no='$invno' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        copy2HistoryTable($requestAct, 'invoices', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($auth == '') {
            header("Location: ../general/home.php?msg=approveInvoice");
            exit;
        } else {
            $msg = 'approveInvoice';
        }
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($auth == '') {
    $blockPage->itemBreadcrumbs(lang_strings("accounting"));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/listinvoices.php?" . $urlBornes, lang_strings("invoices"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../invoices/viewinvoice.php?id=' . $id . $urlBornes, $invoiceDetail->inv_invoice_no[0], 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings('approve_invoice'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'apI';

if ($auth == '') {
    $block1->openForm("../invoices/approveinvoice.php?id=$id&doc=$doc" . $urlBornes);
} else {
    $block1->openForm("../invoices/approveinvoice.php?id=$id&doc=$doc&auth=$auth");
}

$block1->heading(lang_strings("approve_invoice"));
$block1->openContent();
$block1->contentTitle(lang_strings("approve_following"));
$block1->contentRow(lang_strings('invoice_no'), $invoiceDetail->inv_invoice_no[0]);

if ($auth == '') {
    $block1->contentRow(lang_strings('client'), $block1->buildLink('../clients/viewclient.php?id=' . $invoiceDetail->inv_organization[0], $invoiceDetail->inv_org_name[0], 'in'));
} else {
    $block1->contentRow(lang_strings('client'), $invoiceDetail->inv_org_name[0]);
}

$block1->contentRow(lang_strings('date'), createDate($invoiceDetail->inv_doc_date[0], 'date', false, true));
$block1->contentRow(lang_strings('due_date'), createDate($invoiceDetail->inv_due_date[0], 'date', false, true));
$block1->contentRow(lang_strings('payment_terms'), $invoiceDetail->inv_pyt_name_print[0]);
$block1->contentRow(lang_strings('payment_method'), $invoiceDetail->inv_pym_name_print[0]);
$block1->contentRow(lang_strings('subtotal'), CurrencyFormatNOD($invoiceDetail->inv_before_discount[0], $invoiceDetail->inv_currency[0], $costAccuracy));
$block1->contentRow(lang_strings('discount'), CurrencyFormatNOD($invoiceDetail->inv_discount_sum[0], $invoiceDetail->inv_currency[0], $costAccuracy) . ' (' . $invoiceDetail->inv_discount_percent[0] . '%)');
$block1->contentRow(lang_strings('tax'), CurrencyFormatNOD($invoiceDetail->inv_tax_sum[0], $invoiceDetail->inv_currency[0], $costAccuracy));
$block1->contentRow(lang_strings('shipping'), CurrencyFormatNOD($invoiceDetail->inv_freight[0], $invoiceDetail->inv_currency[0], $costAccuracy));
$block1->contentRow(lang_strings('total'), CurrencyFormatNOD($invoiceDetail->inv_amount[0], $invoiceDetail->inv_currency[0], $costAccuracy));
setupCustomFieldsHTML($block1, 'invoices', $id);

if (!isset($msg) || $msg=='') {
    setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
    echo "<input type=\"hidden\" name=\"action\" value=\"approve\">";
    $block1->contentRow('', "<input type='submit' name='submit' value='" . $strings['submit'] . "'>");
}

$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
