<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteinvoices.php,v 1.16 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$ids = str_replace('**', ',', $id);
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Invoice']['Admin'][$profilSession]) {
    header('Location: ../invoices/listinvoices.php?msg=permissiondenied' . $urlBornes);
    exit;
}

$querymore1 = " WHERE inv.id IN ($ids)";
$listInvoices = new request();
$listInvoices->openInvoices($querymore1);
$comptListInvoices = count($listInvoices->inv_id);
// invoice not found
if ($comptListInvoices != count(explode("**", $id))) {
    header('Location: ../invoices/listinvoices.php?msg=permissiondenied' . $urlBornes);
    exit;
}

for ($i=0; $i<$comptListInvoices; $i++) {
    if (periodLocked($listInvoices->inv_doc_date[$i])) {     // check if period locked
        header('Location: ../invoices/listinvoices.php?msg=periodLocked' . $urlBornes);
        exit;
    }
}

$querymore2 = " WHERE pay.invoice IN ($ids)";
$listPayments = new request();
$listPayments->openPayments($querymore2);
// payments related to invoices
if (count($listPayments->pay_id) > 0) {
    header('Location: ../invoices/listinvoices.php?msg=permissiondenied' . $urlBornes);
    exit;
}

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'invoices', $ids, 'D');
        $tmpsql = 'DELETE FROM ' . $tablePrefix . "invoices WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $querymore3 = " WHERE in1.invoice IN ($ids)";
        $listInvoiceRows = clone $requestAct;
        $listInvoiceRows->openInvoiceRows($querymore3);

        if (count($listInvoiceRows->in1_id) > 0) {
            $ids1 = "'" . implode("','", $listInvoiceRows->in1_id) . "'";
            copy2HistoryTable($requestAct, 'invoice_rows', $ids1, 'D');
            $tmpsql = 'DELETE FROM ' . $tablePrefix . "invoice_rows WHERE id IN ($ids1)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $tmpsql = "UPDATE " . $tablePrefix . "documents_approval SET canceled='Y',modified='" . time() . "' WHERE docid IN ($ids) AND doctype='invoices'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtInvoice . "' AND fil.doc_id IN ($ids)";
        deleteAttachFiles($requestAct, $querymore);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../invoices/listinvoices.php?msg=delete' . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings("accounting"));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/listinvoices.php?" . $urlBornes, lang_strings("invoices"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('delete_invoices'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'dIv';
$block1->openForm("../invoices/deleteinvoices.php?id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings('delete_invoices'));
$block1->openContent();
$block1->contentTitle(lang_strings('delete_following'));

for ($i=0; $i<$comptListInvoices; $i++) {
    $block1->contentRow('#' . $listInvoices->inv_id[$i], $listInvoices->inv_invoice_no[$i]);
}

$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
require_once('../includes/footer.php');
