<?php // $Revision: 1.32 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editinvoice.php,v 1.32 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.eInForm.invno.focus();"';
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');        // The unique id of invoice
$recurring = AddSlashesNOD(isset($_GET['recurring'])?$_GET['recurring']:'');    // recurring invoice mode
$cpy = isset($_GET['cpy'])?$_GET['cpy']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$error = '';
$dt_highlight = false;

if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'editinvoice' && $_SESSION['SOURCE'] == '') {
    $invno = $_SESSION['PARAMS']['invno'];              // invoice number
    $clod = $_SESSION['PARAMS']['clod'];                // client id
    $dt = $_SESSION['PARAMS']['dt'];                    // The timestamp of invoice date
    $dd = $_SESSION['PARAMS']['dd'];                    // The timestamp of invoice due date
    $cu = $_SESSION['PARAMS']['cu'];                    // currency
    $pyt = $_SESSION['PARAMS']['pyt'];                  // payment terms
    $pym = $_SESSION['PARAMS']['pym'];                  // payment method
    $ship = $_SESSION['PARAMS']['ship'];                // freight
    $ship2 = $_SESSION['PARAMS']['ship2'];              // ship to
    $bill2 = $_SESSION['PARAMS']['bill2'];              // bill to
    $note = $_SESSION['PARAMS']['note'];                // note
    $rsd = $_SESSION['PARAMS']['rsd'];                  // recurring start date
    $rfd = $_SESSION['PARAMS']['rfd'];                  // recurring finish date
    $rty = $_SESSION['PARAMS']['rty'];                  // recurring type
    $rfq = $_SESSION['PARAMS']['rfq'];                  // recurring frequency
    $re = $_SESSION['PARAMS']['re'];                    // enable recurring
    $_SESSION['TARGET'] = '';
    $icp = 'true';
} else {
    $invno = isset($_POST['invno'])?$_POST['invno']:''; // invoice number
    $clod = isset($_POST['clod'])?$_POST['clod']:'';    // client id
    $dtI = isset($_POST['dtI'])?$_POST['dtI']:'';       // The input value of invoice date
    $dt = ($dtI=='')?$dateToday:date2Timestamp($dtI);   // The timestamp of invoice date
    $ddI = isset($_POST['ddI'])?$_POST['ddI']:'';       // The input value of invoice due date
    $dd = ($ddI=='')?$dateToday:date2Timestamp($ddI);   // The timestamp of invoice due date
    $cu = isset($_POST['cu'])?$_POST['cu']:'';          // currency
    $pyt = isset($_POST['pyt'])?$_POST['pyt']:'';       // payment terms
    $pym = isset($_POST['pym'])?$_POST['pym']:'';       // payment method
    $subttl = isset($_POST['subttl'])?$_POST['subttl']:'0';     // sub-total
    $dissum = isset($_POST['dissum'])?$_POST['dissum']:'0';     // discount value
    $disperc = isset($_POST['disperc'])?$_POST['disperc']:'0';  // discount percent
    $taxsum = isset($_POST['taxsum'])?$_POST['taxsum']:'0';     // tax value
    $ship = isset($_POST['ship'])?$_POST['ship']:'0';   // freight
    $ship2 = isset($_POST['ship2'])?$_POST['ship2']:''; // ship to
    $bill2 = isset($_POST['bill2'])?$_POST['bill2']:''; // bill to
    $amt = isset($_POST['amt'])?$_POST['amt']:'0';      // invoice total
    $note = isset($_POST['note'])?$_POST['note']:'';    // note
    $tg0 = isset($_POST['tg0'])?$_POST['tg0']:'0';      // tax group id
    $tg1 = isset($_POST['tg1'])?$_POST['tg1']:'0';      // tax group 2 id
    $tg2 = isset($_POST['tg2'])?$_POST['tg2']:'0';      // tax group 3 id
    $rsdI = isset($_POST['rsdI'])?$_POST['rsdI']:'';    // input value of recurring start date
    $rsd = ($rsdI=='')?$dateToday:date2Timestamp($rsdI);    // timestamp of recurring start date
    $rfdI = isset($_POST['rfdI'])?$_POST['rfdI']:'';    // input value of recurring finish date
    $rfd = ($rfdI=='')?$dateToday:date2Timestamp($rfdI);    // timestamp of recurring finish date
    $rty = isset($_POST['rty'])?$_POST['rty']:'';       // recurring type
    $rfq = isset($_POST['rfq'])?$_POST['rfq']:'';       // recurring frequency
    $r = isset($_POST['re'])?$_POST['re']:'';           // enable recurring
    $re = DbValueEncode(enumFieldType::ftBoolean, $r);
    $icp = '';
}
/**
 * float values check
 */
if ($subttl == '') {
    $subttl = '0';
}
if ($dissum == '') {
    $dissum = '0';
}
if ($disperc == '') {
    $disperc = '0';
}
if ($taxsum == '') {
    $taxsum = '0';
}
if ($ship == '') {
    $ship = '0';
}
if ($amt == '') {
    $amt = '0';
}
/**
 * Permission check
 */
if ($id == '') {
    if (!$SW_Permissions['Invoice']['Write'][$profilSession]) {
        header('Location: ../invoices/listinvoices.php?msg=permissiondenied' . $urlBornes);
        exit;
    }
} else {
    $querymore4 = " WHERE inv.id='$id'";
    $invoiceDetail = new request();
    $invoiceDetail->openInvoices($querymore4);
    $comptInvoiceDetail = count($invoiceDetail->inv_id);

    if ($comptInvoiceDetail == 0) {
        header('Location: ../invoices/listinvoices.php?msg=permissiondenied' . $urlBornes);
        exit;
    }

    if ($cpy != 'true') {
        if (($invoiceDetail->inv_status_approval[0] == enumFileStatus::stNeedsApproval) || (!$SW_Permissions['Invoice']['Edit'][$profilSession]) || ($invoiceDetail->inv_paid[0] > 0)) {
            header('Location: ../invoices/viewinvoice.php?id=' . $id . '&msg=permissiondenied' . $urlBornes);
            exit;
        }
    } else {
        if (!$SW_Permissions['Invoice']['Write'][$profilSession]) {
            header('Location: ../invoices/listinvoices.php?msg=permissiondenied' . $urlBornes);
            exit;
        }
    }

    if ($invoiceDetail->inv_recurring[0] == enumBoolean::bTrue) {
        $recurring = 'true';
    }

    if ($recurring != 'true' && $cpy != 'true') {
        if (periodLocked($invoiceDetail->inv_doc_date[0])) {     // check if period locked
            header('Location: ../invoices/listinvoices.php?msg=periodLocked' . $urlBornes);
            exit;
        }
    }
}

/**
 * get available clients
 */
$querymore0 = " WHERE org.id<>'1' AND org.locked='" . enumBoolean::bFalse . "'";

if (!$SW_Permissions['Client']['Admin'][$profilSession]) {
    $querymore0 .= " AND org.owner='$idSession'";
}

$querymore0 .= " ORDER BY org.name";
$listClients = new request();
$listClients->openOrganizations($querymore0);
$comptListClients = count($listClients->org_id);

if ($comptListClients == 0) {
    header('Location: ../invoices/listinvoices.php?msg=noAvailableClients' . $urlBornes);
    exit;
}

/**
 * Add New Client Organization
 */
if ($clod == "-1") {
    // store all user input values in session variables and redirect to add client page
    $_SESSION['TARGET'] = 'editclient';
    $_SESSION['SOURCE'] = 'editinvoice';
    $_SESSION['LOCATION'] = '../invoices/editinvoice.php';
    $params = array();
    $params['invno'] = $invno;
    $params['clod'] = $clod;
    $params['dt'] = $dt;
    $params['dd'] = $dd;
    $params['cu'] = $cu;
    $params['pyt'] = $pyt;
    $params['pym'] = $pym;
    $params['ship'] = $ship;
    $params['ship2'] = $ship2;
    $params['bill2'] = $bill2;
    $params['note'] = $note;
    $params['rsd'] = $rsd;
    $params['rfd'] = $rfd;
    $params['rty'] = $rty;
    $params['rfq'] = $rfq;
    $params['re'] = $re;
    $_SESSION['PARAMS'] = $params;
    header("Location: ../clients/editclient.php");
    exit;
}

/**
 * Fields check
 */
if ($action == 'add' || $action == 'update') {
    if ($recurring != 'true' && periodLocked($dt)) {
        $error = lang_strings('period') . ' ' . createDate($period_date_start,'date',false,true) . ' ~ ' . createDate($period_date_end,'date',false,true) . ' ' . lang_strings('locked');
        $bodyCommand = 'onLoad="document.eInForm.dtI.focus();"';
        $dt_highlight = true;
    } else {
        $error = checkCustomFields('invoices', $id);
    }
}

/**
 * Actions
 */
if ($error == '' && ($action == 'add' || $action == 'update')) {
    $note = HtmlEntitiesNOD($note);
    $bill2 = HtmlEntitiesNOD($bill2);
    $ship2 = HtmlEntitiesNOD($ship2);

    if ($action == 'add') {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsqls = setupCustomFieldsInsertSQL('invoices');  // Generate custom fields insert sql

            if ($recurring == 'true') {
                if ($re == enumBoolean::bFalse) {
                    $rnd = 0;
                } else {
                    $rnd = nextRecurringDate($rsd, $rfd, $rty, $rfq);
                    $re = ($rnd==0)?enumBoolean::bFalse:$re;
                }

                $tmpsql = "INSERT INTO " . $tablePrefix . "invoices (invoice_no,organization,owner,status,status_approval,doc_date,due_date,payment_terms,payment_method,currency,before_discount,discount_percent,discount_sum,freight,tax_sum,amount,paid,notes,bill_to,ship_to,recurring,recurring_start,recurring_finish,recurring_next,recurring_type,recurring_frequency,recurring_enabled,tax_group,tax_group2,tax_group3,created,cuser" . $cfsqls[0] . ") VALUES ('','$clod','$idSession','" . enumDocumentStatus::stDraft. "','" . enumFileStatus::stNoApprovalsNeeded . "','0','0','$pyt','$pym','$cu','$subttl','$disperc','$dissum','$ship','$taxsum','$amt','0','$note','$bill2','$ship2','" . enumBoolean::bTrue . "','$rsd','$rfd','$rnd','$rty','$rfq','$re','$tg0','$tg1','$tg2','" . time() . "','$idSession'" . $cfsqls[1] . ")";
            } else {
                $tmpsql = "INSERT INTO " . $tablePrefix . "invoices (invoice_no,organization,owner,status,status_approval,doc_date,due_date,payment_terms,payment_method,currency,before_discount,discount_percent,discount_sum,freight,tax_sum,amount,paid,notes,bill_to,ship_to,recurring,tax_group,tax_group2,tax_group3,created,cuser" . $cfsqls[0] . ") VALUES ('$invno','$clod','$idSession','" . enumDocumentStatus::stOpen. "','" . enumFileStatus::stNoApprovalsNeeded . "','$dt','$dd','$pyt','$pym','$cu','$subttl','$disperc','$dissum','$ship','$taxsum','$amt','0','$note','$bill2','$ship2','" . enumBoolean::bFalse . "','$tg0','$tg1','$tg2','" . time() . "','$idSession'" . $cfsqls[1] . ")";
            }

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $sendto = $requestAct->newId('invoices');   // get new invoice id
            $cfsql = setupCustomMediaFieldsUpdateSQL('invoices', $sendto);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "invoices SET $cfsql WHERE id='$sendto'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            // insert invoice rows
            $rowids = $_POST['tbl00rowids'];    // row element id list

            if ($rowids != '') {
                $rowidsA = preg_split('/,/', $rowids);

                foreach ($rowidsA as $rowid) {  // get each row inputs
                    $desc = HtmlEntitiesNOD($_POST[$rowid . 'f00']);    // description
                    $pr = $_POST[$rowid . 'pr'];    // project id
                    $qty = is_numeric($_POST[$rowid . 'f01'])?$_POST[$rowid . 'f01']:0;     // quantity
                    $unit = HtmlEntitiesNOD($_POST[$rowid . 'f02']);    // unit
                    $price = is_numeric($_POST[$rowid . 'f03'])?$_POST[$rowid . 'f03']:0;   // price
                    $dissum = is_numeric($_POST[$rowid . 'f04'])?$_POST[$rowid . 'f04']:0;  // discount
                    $disp = is_numeric($_POST[$rowid . 'f05'])?$_POST[$rowid . 'f05']:0;    // discount %
                    $ttl = is_numeric($_POST[$rowid . 'f06'])?$_POST[$rowid . 'f06']:0;     // line total
                    $taxc = (isset($_POST[$rowid . 'f07']) && $_POST[$rowid . 'f07'] != '')?$_POST[$rowid . 'f07']:'0';   // tax code
                    $taxs = (isset($_POST[$rowid . 'f08']) && is_numeric($_POST[$rowid . 'f08']))?$_POST[$rowid . 'f08']:0; // tax sum
                    $taxc2 = (isset($_POST[$rowid . 'f09']) && $_POST[$rowid . 'f09'] != '')?$_POST[$rowid . 'f09']:'0';   // tax code 2
                    $taxs2 = (isset($_POST[$rowid . 'f10']) && is_numeric($_POST[$rowid . 'f10']))?$_POST[$rowid . 'f10']:0; // tax sum 2
                    $taxc3 = (isset($_POST[$rowid . 'f11']) && $_POST[$rowid . 'f11'] != '')?$_POST[$rowid . 'f11']:'0';   // tax code 3
                    $taxs3 = (isset($_POST[$rowid . 'f12']) && is_numeric($_POST[$rowid . 'f12']))?$_POST[$rowid . 'f12']:0; // tax sum 3
                    $tmpsql = "INSERT INTO " . $tablePrefix . "invoice_rows (invoice,description,project,quantity,price,unit,discount_percent,discount_sum,tax_code,tax_sum,tax_code2,tax_sum2,tax_code3,tax_sum3,line_total,created,cuser) VALUES ('$sendto','$desc','$pr','$qty','$price','$unit','$disp','$dissum','$taxc','$taxs','$taxc2','$taxs2','$taxc3','$taxs3','$ttl','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num = $requestAct->newId('invoice_rows');  // get new invoice row id
                    copy2HistoryTable($requestAct, 'invoice_rows', $num, 'A');
                }
            }

            if ($recurring != 'true') {
                $status = enumFileStatus::stNoApprovalsNeeded;
                $num = $sendto;
                $producer = $idSession;
                $doctype = 'invoices';

                if (!defined('INNER_ADDDOCUMENT')) {
                    define('INNER_ADDDOCUMENT', 1);
                }

                require('../approvals/adddocument.php');
                // upload attachments
                $querymore = " WHERE fil.id='1'";
                $folderDetail = clone $requestAct;
                $folderDetail->openFiles($querymore);
                $path = $folderDetail->fil_fullname[0];
                uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtInvoice, $sendto, $status, '1', $path);
            }

            copy2HistoryTable($requestAct, 'invoices', $sendto, 'A');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../invoices/viewinvoice.php?id=$sendto&msg=add");
            exit;
        }
    } else if ($action == 'update') {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsql = setupCustomFieldsUpdateSQL('invoices', $id);  // Generate custom fields update sql

            if ($recurring == 'true') {
                if ($re == enumBoolean::bFalse) {
                    $rnd = 0;
                } else {
                    $rnd = nextRecurringDate($rsd, $rfd, $rty, $rfq);
                    $re = ($rnd==0)?enumBoolean::bFalse:$re;
                }

                $tmpsql = "UPDATE " . $tablePrefix . "invoices SET organization='$clod',payment_terms='$pyt',payment_method='$pym',currency='$cu',before_discount='$subttl',discount_percent='$disperc',discount_sum='$dissum',freight='$ship',tax_sum='$taxsum',amount='$amt',notes='$note',bill_to='$bill2',ship_to='$ship2',recurring_start='$rsd',recurring_finish='$rfd',recurring_next='$rnd',recurring_type='$rty',recurring_frequency='$rfq',recurring_enabled='$re',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";
            } else {
                $tmpsql = "UPDATE " . $tablePrefix . "invoices SET invoice_no='$invno',organization='$clod',status='" . enumDocumentStatus::stOpen . "',status_approval='" . enumFileStatus::stNoApprovalsNeeded . "',doc_date='$dt',due_date='$dd',payment_terms='$pyt',payment_method='$pym',currency='$cu',before_discount='$subttl',discount_percent='$disperc',discount_sum='$dissum',freight='$ship',tax_sum='$taxsum',amount='$amt',notes='$note',bill_to='$bill2',ship_to='$ship2',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";
            }

           if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
           }

           $del = $_POST['tbl00del'];  // old row id list to be deleted
            // delete old rows
            if ($del != '') {
                $delA = preg_split('/,/', str_replace('tbl00r', '', $del));

                foreach ($delA as $del) {
                    copy2HistoryTable($requestAct, 'invoice_rows', $del, 'D');
                    $tmpsql = "DELETE FROM " . $tablePrefix . "invoice_rows WHERE id='$del'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }
            // insert invoice rows
            $rowids = $_POST['tbl00rowids'];    // row element id list

            if ($rowids != '') {
                $rowidsA = preg_split('/,/', $rowids);

                foreach ($rowidsA as $rowid) {  // get each row inputs
                    $desc = HtmlEntitiesNOD($_POST[$rowid . 'f00']);    // description
                    $pr = $_POST[$rowid . 'pr'];    // project id
                    $qty = is_numeric($_POST[$rowid . 'f01'])?$_POST[$rowid . 'f01']:0;     // quantity
                    $unit = HtmlEntitiesNOD($_POST[$rowid . 'f02']);    // unit
                    $price = is_numeric($_POST[$rowid . 'f03'])?$_POST[$rowid . 'f03']:0;   // price
                    $dissum = is_numeric($_POST[$rowid . 'f04'])?$_POST[$rowid . 'f04']:0;  // discount
                    $disp = is_numeric($_POST[$rowid . 'f05'])?$_POST[$rowid . 'f05']:0;    // discount %
                    $ttl = is_numeric($_POST[$rowid . 'f06'])?$_POST[$rowid . 'f06']:0;     // line total
                    $taxc = (isset($_POST[$rowid . 'f07']) && $_POST[$rowid . 'f07'] != '')?$_POST[$rowid . 'f07']:'0';   // tax code
                    $taxs = (isset($_POST[$rowid . 'f08']) && is_numeric($_POST[$rowid . 'f08']))?$_POST[$rowid . 'f08']:0; // tax sum
                    $taxc2 = (isset($_POST[$rowid . 'f09']) && $_POST[$rowid . 'f09'] != '')?$_POST[$rowid . 'f09']:'0';   // tax code 2
                    $taxs2 = (isset($_POST[$rowid . 'f10']) && is_numeric($_POST[$rowid . 'f10']))?$_POST[$rowid . 'f10']:0; // tax sum 2
                    $taxc3 = (isset($_POST[$rowid . 'f11']) && $_POST[$rowid . 'f11'] != '')?$_POST[$rowid . 'f11']:'0';   // tax code 3
                    $taxs3 = (isset($_POST[$rowid . 'f12']) && is_numeric($_POST[$rowid . 'f12']))?$_POST[$rowid . 'f12']:0; // tax sum 3

                    if (preg_match('/^tbl00r.+n$/', $rowid)) {
                        // add new row
                        $tmpsql = "INSERT INTO " . $tablePrefix . "invoice_rows (invoice,description,project,quantity,price,unit,discount_percent,discount_sum,tax_code,tax_sum,tax_code2,tax_sum2,tax_code3,tax_sum3,line_total,created,cuser) VALUES ('$id','$desc','$pr','$qty','$price','$unit','$disp','$dissum','$taxc','$taxs','$taxc2','$taxs2','$taxc3','$taxs3','$ttl','" . time() . "','$idSession')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $num = $requestAct->newId('invoice_rows');  // get new invoice row id
                        copy2HistoryTable($requestAct, 'invoice_rows', $num, 'A');
                    } else {
                        // update old row
                        $rowid = str_replace('tbl00r', '', $rowid);
                        $tmpsql = "UPDATE " . $tablePrefix . "invoice_rows SET description='$desc',quantity='$qty',price='$price',unit='$unit',discount_percent='$disp',discount_sum='$dissum',tax_code='$taxc',tax_sum='$taxs',tax_code2='$taxc2',tax_sum2='$taxs2',tax_code3='$taxc3',tax_sum3='$taxs3',line_total='$ttl',modified='" . time() . "',muser='$idSession' WHERE id='$rowid'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        copy2HistoryTable($requestAct, 'invoice_rows', $rowid, 'U');
                    }
                }
            }

            if ($recurring != 'true') {
                $status = enumFileStatus::stNoApprovalsNeeded;
                $producer = $idSession;
                $num = $id;
                $doctype = 'invoices';
                require_once('../approvals/updatedocument.php');
                $querymore5 = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtInvoice . "' AND fil.doc_id='$id'";
                $listFiles = clone $requestAct;
                $listFiles->openFiles($querymore5);

                if (count($listFiles->fil_id) > 0) {
                    $tmpsql = 'UPDATE ' . $tablePrefix . "files SET status='$status' WHERE doc_type='" . enumFileRelatedDocumentType::dtInvoice . "' AND doc_id='$id'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }

                // upload attachments
                $querymore = " WHERE fil.id='1'";
                $folderDetail = clone $requestAct;
                $folderDetail->openFiles($querymore);
                $path = $folderDetail->fil_fullname[0];
                uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtInvoice, $id, $status, '1', $path);
            }

            copy2HistoryTable($requestAct, 'invoices', $id, 'U');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../invoices/viewinvoice.php?id=$id&msg=update" . $urlBornes);
            exit;
        }
    }
}

/**
 * get client organization list
 */
$clodVV = array();

for ($i=0; $i<$comptListClients; $i++) {
    $clodVV[$listClients->org_id[$i]] = $listClients->org_name[$i];
}

if ($SW_Permissions['Client']['Write'][$profilSession] && $id == '') {
    $clodVV['-1'] = $strings['add_new_client'];
}

/**
 * get payment method list
 */
$querymore1 = " WHERE pym.locked='" . enumBoolean::bFalse . "' ORDER BY pym.name";
$listPaymentMethods = new request();
$listPaymentMethods->openPaymentMethods($querymore1);
$comptListPaymentMethods = count($listPaymentMethods->pym_id);
$pymVV = array();

for ($i=0; $i<$comptListPaymentMethods; $i++) {
    $pymVV[$listPaymentMethods->pym_id[$i]] = $listPaymentMethods->pym_name_print[$i];
}
/**
 * get payment terms list
 */
$querymore2 = " WHERE pyt.locked='" . enumBoolean::bFalse . "' ORDER BY pyt.name";
$listPaymentTerms = new request();
$listPaymentTerms->openPaymentTerms($querymore2);
$comptListPaymentTerms = count($listPaymentTerms->pyt_id);
$pytVV = array();

for ($i=0; $i<$comptListPaymentTerms; $i++) {
    $pytVV[$listPaymentTerms->pyt_id[$i]] = $listPaymentTerms->pyt_name_print[$i];
}
/**
 * get active currency list & help hints
 */
$helpStr = '<table>';
$cuVV = array();

foreach ($CurrencyMatrix['active'] as $key) {
    $val = $CurrencyMatrix['name'][$key];
    $helpStr .= '<tr><th>' . $key . '</th><td>' . $val . '</td></tr>';
    $cuVV[$key] = $key;
}

$helpStr .= '</table>';
/**
 * get tax group list
 */
if ($id == '') {
    $querymore3 = " WHERE txg.locked='" . enumBoolean::bFalse . "' AND EXISTS (SELECT txc.id FROM " . $tablePrefix . "tax_codes txc WHERE txc.tax_group=txg.id) ORDER BY txg.name";
} else {
    $querymore3 = " WHERE txg.id IN ('" . $invoiceDetail->inv_tax_group[0] . "','" . $invoiceDetail->inv_tax_group2[0] . "','" . $invoiceDetail->inv_tax_group3[0] . "') ORDER BY txg.name";
}

$listTaxGroups = new request();
$listTaxGroups->openTaxGroups($querymore3);
$comptListTaxGroups = count($listTaxGroups->txg_id);
/**
 * get tax code list
 */
for ($i=0; $i<$comptListTaxGroups; $i++) {
    $querymore4 = " WHERE txc.tax_group='" . $listTaxGroups->txg_id[$i] . "' ORDER BY txc.rate";
    $listTaxCodes = new request();
    $listTaxCodes->openTaxCodes($querymore4);
    $listTaxGroups->tax_codes[$i] = $listTaxCodes;
}
/**
 * Set value in form
 */
if ($error == '' && $icp != 'true') {
    if ($id != '') {
        $invno = $invoiceDetail->inv_invoice_no[0];     // invoice number
        $clod = $invoiceDetail->inv_organization[0];    // client id
        $dt = $invoiceDetail->inv_doc_date[0];          // document date
        $dd = $invoiceDetail->inv_due_date[0];          // due date
        $cu = $invoiceDetail->inv_currency[0];          // currency
        $pym = $invoiceDetail->inv_payment_method[0];   // payment method
        $pyt = $invoiceDetail->inv_payment_terms[0];    // payment terms
        $ship = $invoiceDetail->inv_freight[0];         // freight
        $note = $invoiceDetail->inv_notes[0];           // notes
        $bill2 = $invoiceDetail->inv_bill_to[0];        // bill to
        $ship2 = $invoiceDetail->inv_ship_to[0];        // ship to
        $rsd = $invoiceDetail->inv_recurring_start[0];      // recurring start date
        $rfd = $invoiceDetail->inv_recurring_finish[0];     // recurring finish date
        $rty = $invoiceDetail->inv_recurring_type[0];       // recurring type
        $rfq = $invoiceDetail->inv_recurring_frequency[0];  // recurring frequency
        $re = $invoiceDetail->inv_recurring_enabled[0];     // enable recurring
    } else {
        $invno = '';                            // invoice number
        $clod = reset($clodVV);                 // client id
        $dt = $dateToday;                       // document date
        $dd = $dateToday;                       // due date
        $k = array_search($clod, $listClients->org_id);
        $cu = ($listClients->org_currency[$k] == '')?$defaultCurrency:$listClients->org_currency[$k];   // currency
        $pym = $listPaymentMethods->pym_id[0];  // payment method
        $pyt = $listPaymentTerms->pyt_id[0];    // payment terms
        $ship = '0';                            // freight
        $re = enumBoolean::bTrue;                           // enable recurring
    }
}

/**
 * Generate invoice detail row input html
 *
 * @global array $__default_requireda
 * @global array $__default_reqtypea
 * @global array $__default_floata
 * @global array $__default_pnuma
 * @global array $__default_nnnuma
 * @global object $listTaxGroups tax group/code definitions
 * @param array $titles Titles
 * @param array $rowData Row data
 * @param string $isNew New row
 * @param string $cpy Copy row
 * @return string
 */
function setupDetailRowInputHTML($titles, $rowData, $isNew = 'false', $cpy = '') {
    global $__default_requireda, $__default_reqtypea, $__default_floata, $__default_pnuma, $__default_nnnuma, $listTaxGroups;
    $newscripts = array();
    $strongs = '';
    $t = 0;
    $trid = 'tbl00r' . $rowData['id'];
    echo '<tr id="' . $trid . '"><td data-title=""><a href="javascript:delinvrow(\'tbl00\',\'' . $trid . '\',' . (($isNew=='true' || $cpy=='true')?'true':'false') . ');">X</a></td>';
    // description
    echo '<td data-title="' . $titles[$t++] . '"><input type="text" id="' . $trid . 'f00" name="' . $trid . 'f00" value="' . $rowData['desc'] . '" maxlength="255"></td>';
    $strongs .= '<strong id="' . $trid . 'f00S"></strong>';

    if ($isNew == 'true') {
        $newscripts[] = 'required=' . $trid . 'f00,' . enumFieldType::ftText;
    } else {
        $__default_requireda[] = $trid . 'f00';
        $__default_reqtypea[] = enumFieldType::ftText;
    }
    // project
    echo '<td id="' . $trid . 'pro" data-title="' . $titles[$t++] . '">';

    if ($rowData['pr'] != '0') {
        echo '<a href="../projects/viewproject.php?id=' . $rowData['pr'] . '" target="_blank">' . $rowData['prn'] . '</a>';
    } else {
        echo '&nbsp;';
    }

    echo '<input type="hidden" id="' . $trid . 'pr" name="' . $trid . 'pr" value="' . $rowData['pr'] . '"></td>';
    // quantity
    echo '<td data-title="' . $titles[$t++] . '"><input type="text" id="' . $trid . 'f01" name="' . $trid . 'f01" value="' . $rowData['qty'] . '" maxlength="30" onchange="qtyprcdispchg(\'' . $trid . '\')"></td>';
    $strongs .= '<strong id="' . $trid . 'f01S"></strong>';

    if ($isNew == 'true') {
        $newscripts[] = 'required=' . $trid . 'f01,' . enumFieldType::ftQuantity;
        $newscripts[] = 'float=' . $trid . 'f01';
        $newscripts[] = 'pnum=' . $trid . 'f01';
    } else {
        $__default_requireda[] = $trid . 'f01';
        $__default_reqtypea[] = enumFieldType::ftQuantity;
        $__default_floata[] = $trid . 'f01';
        $__default_pnuma[] = $trid . 'f01';
    }
    // unit
    echo '<td data-title="' . $titles[$t++] . '"><input type="text" id="' . $trid . 'f02" name="' . $trid . 'f02" value="' . $rowData['unit'] . '" maxlength="50"></td>';
    $strongs .= '<strong id="' . $trid . 'f02S"></strong>';
    // price
    echo '<td data-title="' . $titles[$t++] . '"><input type="text" id="' . $trid . 'f03" name="' . $trid . 'f03" value="' . $rowData['prc'] . '" maxlength="30" onchange="qtyprcdispchg(\'' . $trid . '\')"></td>';
    $strongs .= '<strong id="' . $trid . 'f03S"></strong>';

    if ($isNew == 'true') {
        $newscripts[] = 'required=' . $trid . 'f03,' . enumFieldType::ftRate;
        $newscripts[] = 'float=' . $trid . 'f03';
    } else {
        $__default_requireda[] = $trid . 'f03';
        $__default_reqtypea[] = enumFieldType::ftRate;
        $__default_floata[] = $trid . 'f03';
    }
    // discount sum
    echo '<td data-title="' . $titles[$t++] . '"><input type="text" id="' . $trid . 'f04" name="' . $trid . 'f04" value="' . $rowData['diss'] . '" maxlength="30" onchange="disschg(\'' . $trid . '\')"></td>';
    $strongs .= '<strong id="' . $trid . 'f04S"></strong>';

    if ($isNew == 'true') {
        $newscripts[] = 'float=' . $trid . 'f04';
    } else {
        $__default_floata[] = $trid . 'f04';
    }
    // discount %
    echo '<td data-title="' . $titles[$t++] . '"><input type="text" id="' . $trid . 'f05" name="' . $trid . 'f05" value="' . $rowData['disp'] . '" maxlength="10" onchange="qtyprcdispchg(\'' . $trid . '\')"></td>';
    $strongs .= '<strong id="' . $trid . 'f05S"></strong>';

    if ($isNew == 'true') {
        $newscripts[] = 'float=' . $trid . 'f05';
    } else {
        $__default_floata[] = $trid . 'f05';
    }
    // tax columns
    for ($i=0, $f=6; $i<count($listTaxGroups->txg_id); $i++) {
        // tax code
        $f++;
        echo '<td data-title="' . $titles[$t++] . '"><select id="' . $trid . 'f' . sprintf('%02d', $f) . '" name="' . $trid . 'f' . sprintf('%02d', $f) . '" onchange="taxcchg(\'' . $trid . '\',\'' . $i . '\',\'' . $f . '\')"><option value=""' . (($rowData['taxc' . $i]=='')?' selected':'') . '></option>';
        $listTaxCodes = $listTaxGroups->tax_codes[$i];

        for ($j=0; $j<count($listTaxCodes->txc_id); $j++) {
            echo '<option value="' . $listTaxCodes->txc_id[$j] . '"' . (($rowData['taxc' . $i]==$listTaxCodes->txc_id[$j])?' selected':'') . '>' . $listTaxCodes->txc_name_print[$j] . '</option>';
        }

        echo '</select><input type="hidden" id="' . $trid . 'rt' . $i . '" name="' . $trid . 'rt' . $i . '" value="' . $rowData['taxr' . $i] . '"></td>';
        $strongs .= '<strong id="' . $trid . 'f' . sprintf('%02d', $f) . 'S"></strong>';
        // tax sum
        $f++;
        echo '<td data-title="' . $titles[$t++] . '"><input type="text" id="' . $trid . 'f' . sprintf('%02d', $f) . '" name="' . $trid . 'f' . sprintf('%02d', $f) . '" value="' . $rowData['taxs' . $i] . '" maxlength="30" onchange="taxschg(\'' . $trid . '\')"></td>';
        $strongs .= '<strong id="' . $trid . 'f' . sprintf('%02d', $f) . 'S"></strong>';

        if ($isNew == 'true') {
            $newscripts[] = 'float=' . $trid . 'f' . sprintf('%02d', $f);
            $newscripts[] = 'nnnum=' . $trid . 'f' . sprintf('%02d', $f);
        } else {
            $__default_floata[] = $trid . 'f' . sprintf('%02d', $f);
            $__default_nnnuma[] = $trid . 'f' . sprintf('%02d', $f);
        }
    }
    // line total
    echo '<td data-title="' . $titles[$t++] . '"><input type="text" id="' . $trid . 'f06" name="' . $trid . 'f06" value="' . $rowData['ttl'] . '" maxlength="30" onchange="ttlchg(\'' . $trid . '\')"></td>';
    $strongs .= '<strong id="' . $trid . 'f06S"></strong>';

    if ($isNew == 'true') {
        $newscripts[] = 'required=' . $trid . 'f06,' . enumFieldType::ftTotals;
        $newscripts[] = 'float=' . $trid . 'f06';
    } else {
        $__default_requireda[] = $trid . 'f06';
        $__default_reqtypea[] = enumFieldType::ftTotals;
        $__default_floata[] = $trid . 'f06';
    }

    echo '<td>' . $strongs . '</td></tr>';
    return implode('++', $newscripts);
}

/**
 * HTML
 */
require_once('../includes/header.php');
echo '<script type="text/javascript" src="../javascript/editinvoice' . $scriptMinimized . '.js"></script>';
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings("accounting"));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/listinvoices.php?" . $urlBornes, lang_strings("invoices"), 'in'));

if ($id == '' || $cpy == 'true') {
    if ($recurring == 'true') {
        $blockPage->itemBreadcrumbs(lang_strings('add_recurring_invoice'));
    } else {
        $blockPage->itemBreadcrumbs(lang_strings('add_invoice'));
    }
} else {
    if ($recurring == 'true') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink('../invoices/viewinvoice.php?id=' . $id . $urlBornes, lang_strings('recurring_invoice') . ' #' . $id, 'in'));
        $blockPage->itemBreadcrumbs(lang_strings('edit_recurring_invoice'));
    } else {
        $blockPage->itemBreadcrumbs($blockPage->buildLink('../invoices/viewinvoice.php?id=' . $id . $urlBornes, $invoiceDetail->inv_invoice_no[0], 'in'));
        $blockPage->itemBreadcrumbs(lang_strings('edit_invoice'));
    }
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "eIn";

if ($id == '' || $cpy == 'true') {
    $block1->openForm("../invoices/editinvoice.php?recurring=$recurring" . $urlBornes . "#" . $block1->form . 'Anchor', 'return checkformdata(this)');
    echo '<input type="hidden" id="action" name="action" value="add">';

    if ($recurring == 'true') {
        $block1->heading(lang_strings('add_recurring_invoice'));
    } else {
        $block1->heading(lang_strings('add_invoice'));
    }
} else {
    $block1->openForm("../invoices/editinvoice.php?recurring=$recurring&id=$id" . $urlBornes . "#" . $block1->form . 'Anchor', 'return checkformdata(this)');
    echo '<input type="hidden" id="action" name="action" value="update">';

    if ($recurring == 'true') {
        $block1->heading(lang_strings('edit_recurring_invoice') . ' : #' . $invoiceDetail->inv_id[0]);
    } else {
        $block1->heading(lang_strings('edit_invoice') . ' : ' . $invoiceDetail->inv_invoice_no[0]);
    }
}

echo '<input type="hidden" id="invid" value="' . ($cpy=='true')?'':$id . '">';    // invoice id
echo '<input type="hidden" id="dfc" value="' . $defaultCurrency . '">'; // default currency
echo '<input type="hidden" id="cwc" vlaue="">';
echo '<input type="hidden" id="cu" name="cu" value="' . $cu . '">';
echo '<input type="hidden" id="duplicate_entry" value="' . $strings['duplicate_entry_found'] . '">';

for ($i=0; $i<3; $i++) {    // store tax groups id
    if ($i < $comptListTaxGroups) {
        echo '<input type="hidden" id="tg' . $i . '" name="tg' . $i . '" value="' . $listTaxGroups->txg_id[$i] . '">';
    } else {
        echo '<input type="hidden" id="tg' . $i . '" name="tg' . $i . '" value="0">';
    }
}

$block1->openContent();
$block1->contentTitle(lang_strings("info"));

if ($recurring == 'true') {
    echo '<input type="hidden" id="invno" name="invno" value="">';
} elseif ($id == '' || $cpy == 'true') {
    setupInputHTML($block1, lang_strings('invoice_no'), 'invno', enumFieldType::ftAlphaNumeric, 'Y', '32', $invno, '', '', false, '<a href="javascript:newinvno()">' . lang_strings('refresh') . '</a>');
} else {
    echo '<input type="hidden" id="invno" name="invno" value="' . $invno . '">';
    $block1->contentRow(lang_strings('invoice_no'), $invno);
}

setupInputHTML($block1, lang_strings('client'), 'clod', enumFieldType::ftNumeric, 'Y', '11', $clod, $clodVV, '', false, '', ' onchange="clodchg()"');

if ($recurring == 'true') {
    echo '<input type="hidden" id="dtI" name="dtI" value="">';
    echo '<input type="hidden" id="ddI" name="ddI" value="">';
} else {
    setupInputHTML($block1, lang_strings('date'), 'dtI', enumFieldType::ftDate, 'Y', '0', $dt, '', '', $dt_highlight, '', ' onchange="chgdd()"');
    setupInputHTML($block1, lang_strings('due_date'), 'ddI', enumFieldType::ftDate, 'Y', '0', $dd);
}

setupInputHTML($block1, lang_strings('currency') . $blockPage->printHelp($helpStr, true), 'cuS', enumFieldType::ftAlphaNumeric, 'Y', '3', $cu, $cuVV, '', false, '', ' onchange="cuchg()"');
setupInputHTML($block1, lang_strings('payment_terms'), 'pyt', enumFieldType::ftAlphaNumeric, 'N', '155', $pyt, $pytVV, '', false, '', ' onchange="chgdd()"');
setupInputHTML($block1, lang_strings('payment_method'), 'pym', enumFieldType::ftAlphaNumeric, 'N', '155', $pym, $pymVV);
setupCustomFieldsInputHTML($block1, 'invoices', $id);

if ($recurring == 'true') {
    $rtyVV = array('D' => $strings['VV__invoices_recurring_type_D'], 'W' => $strings['VV__invoices_recurring_type_W'], 'M' => $strings['VV__invoices_recurring_type_M']);
    setupInputHTML($block1, lang_strings('recurring_start'), 'rsdI', enumFieldType::ftDate, 'Y', '8', $rsd);
    setupInputHTML($block1, lang_strings('recurring_finish'), 'rfdI', enumFieldType::ftDate, 'Y', '8', $rfd);
    setupInputHTML($block1, lang_strings('recurring_type'), 'rty', enumFieldType::ftAlphaNumeric, 'N', '1', $rty, $rtyVV);
    setupInputHTML($block1, lang_strings('recurring_frequency'), 'rfq', array(enumFieldType::ftNumeric, enumFieldOption::foPositiveNumber), 'Y', '11', $rfq);
    setupInputHTML($block1, lang_strings('recurring_enabled'), 're', enumFieldType::ftBoolean, 'N', '1', $re);
}

$block1->contentTitle(lang_strings("details"));
echo '<input type="hidden" name="tblc" value="1">';
echo '<input type="hidden" id="tbl00nam" name="tbl00nam" value="invoice_rows">';
echo '<input type="hidden" id="tbl00fc" name="tbl00fc" value="' . (7 + $comptListTaxGroups) . '">'; // invoice row field count
echo '<input type="hidden" id="tbl00del" name="tbl00del" value="">';    // deleted row list
echo '<input type="hidden" id="taxgc" name="taxgc" value="' . $comptListTaxGroups . '">';   // tax group count
$headers = '<thead><tr><th>&nbsp;</th><th>' . lang_strings('description') . '</th><th>' . lang_strings('project') . '</th><th>' . lang_strings('quantity') . '</th><th>' . lang_strings('unit') . '</th><th>' . lang_strings('price') . '</th><th>' . lang_strings('discount') . '</th><th>%</th>';
$titles = array(lang_strings('description'), lang_strings('project'), lang_strings('quantity'), lang_strings('unit'), lang_strings('price'), lang_strings('discount'), '%');
$newRow = array('id' => '**n', 'desc' => '', 'pr' => 'x', 'prn' => '', 'qty' => '1', 'unit' => '', 'prc' => '', 'diss' => '', 'disp' => '', 'ttl' => '');

for ($i=0; $i<$comptListTaxGroups; $i++) {
    $headers .= '<th>' . $listTaxGroups->txg_name_print[$i] . '</th><th></th>';
    $titles[] = $listTaxGroups->txg_name_print[$i];
    $titles[] = '';
    $newRow['taxc' . $i] = '';
    $newRow['taxs' . $i] = '';
    $newRow['taxr' . $i] = '0';
    $listTaxCodes = $listTaxGroups->tax_codes[$i];

    for ($j=0; $j<count($listTaxCodes->txc_id); $j++) {
        $r = 'taxg' . $i . 'c' . $listTaxCodes->txc_id[$j];
        echo '<input type="hidden" id="' . $r . '" name="' . $r . '" value="' . $listTaxCodes->txc_rate[$j] . '">';
    }
}

$headers .= '<th>' . lang_strings('total') . '</th><th></th></tr></thead>';
$titles[] = lang_strings('total');
$orgIdx = 0;
$rowIdCollect = array();

if ($id != '') {
    $querymore5 = " WHERE in1.invoice='$id' ORDER BY in1.id";
    $listInvoiceRows = new request();
    $listInvoiceRows->openInvoiceRows($querymore5);
    $comptListInvoiceRows = count($listInvoiceRows->in1_id);
    $orgRows = array();

    for ($i=0; $i<$comptListInvoiceRows; $i++, $orgIdx++) {
        $rowIdCollect[] = 'tbl00r' . $listInvoiceRows->in1_id[$i];
        $orgRows[$orgIdx]['id'] = $listInvoiceRows->in1_id[$i];
        $orgRows[$orgIdx]['desc'] = $listInvoiceRows->in1_description[$i];
        $orgRows[$orgIdx]['pr'] = $listInvoiceRows->in1_project[$i];
        $orgRows[$orgIdx]['prn'] = $listInvoiceRows->in1_pro_name[$i];
        $orgRows[$orgIdx]['qty'] = $listInvoiceRows->in1_quantity[$i];
        $orgRows[$orgIdx]['unit'] = $listInvoiceRows->in1_unit[$i];
        $orgRows[$orgIdx]['prc'] = $listInvoiceRows->in1_price[$i];
        $orgRows[$orgIdx]['diss'] = $listInvoiceRows->in1_discount_sum[$i];
        $orgRows[$orgIdx]['disp'] = $listInvoiceRows->in1_discount_percent[$i];
        $orgRows[$orgIdx]['ttl'] = $listInvoiceRows->in1_line_total[$i];

        for ($j=0; $j<$comptListTaxGroups; $j++) {
            $orgRows[$orgIdx]['taxc' . $j] = $listInvoiceRows->in1_tax_code[$i][$j];
            $orgRows[$orgIdx]['taxs' . $j] = $listInvoiceRows->in1_tax_sum[$i][$j];
            $orgRows[$orgIdx]['taxr' . $j] = $listInvoiceRows->in1_tax_rate[$i][$j];
        }
    }
}

ob_start();
$newscripts = setupDetailRowInputHTML($titles, $newRow, 'true');
$newRowContent = ob_get_contents();
ob_end_clean();
echo '<input type="hidden" id="tbl00nrc" name="tbl00nrc" value="0">';
echo '<input type="hidden" id="tbl00newrow" value="' . htmlentities($newRowContent, ENT_QUOTES, $htmlEntityCharset) . '">';
echo '<input type="hidden" id="tbl00newscript" value="' . $newscripts . '">';
echo '<input type="hidden" id="tbl00rowids" name="tbl00rowids" value="' . implode(',', $rowIdCollect) . '">';
echo '<div class="listing"><table id="tbl00">' . $headers . '<tbody>';

if ($orgIdx > 0) {
    for ($j=0; $j<$orgIdx; $j++) {
        setupDetailRowInputHTML($titles, $orgRows[$j], 'false', $cpy);
    }
}

echo '</tbody></table></div>';
echo '<div class="listing"><table><tbody><tr><td><select id="rowType" name="rowType" onchange="rtchg()"><option value="">' . $strings['empty_row'] . '</option><option value="1">' . $strings['estimated_time'] . '</option><option value="2">' . $strings['actual_time'] . '</option><option value="3">' . $strings['expenses'] . '</option></select></td><td></td><td id="prot">' . $strings['project'] . ':</td><td id="pros"><select id="proId" name="proId"></select></td><td></td><td><a href="javascript:addinvrow()">' . $strings['more_row'] . '</a></td></tr></tbody></table></div>';
$block1->contentTitle(lang_strings('totals'));
$block1->contentRow(lang_strings('subtotal'), '<div id="subttlstr">0</div><input type="hidden" id="subttl" name="subttl" value="0">');
$block1->contentRow(lang_strings('discount'), '<div id="disstr">0 (0%)</div><input type="hidden" id="dissum" name="dissum" value="0"><input type="hidden" id="disperc" name="disperc" value="0">');
$block1->contentRow(lang_strings('tax'), '<div id="taxstr">0</div><input type="hidden" id="taxsum" name="taxsum" value="0">');
setupInputHTML($block1, lang_strings('shipping'), 'ship', enumFieldType::ftTotals, 'N', 19, $ship, '', '', false, '', 'onchange="updatetotals()"');
$block1->contentRow(lang_strings('total'), '<div id="ttlstr">0</div><input type="hidden" id="amt" name="amt" value="0">');
$block1->contentTitle(lang_strings('notes'));
setupInputHTML($block1, '', 'note', enumFieldType::ftMemo, 'N', 0, $note);
$block1->contentTitle(lang_strings('address'));
setupInputHTML($block1, lang_strings('bill_to'), 'bill2', enumFieldType::ftMemo, 'N', 0, $bill2);
setupInputHTML($block1, lang_strings('ship_to'), 'ship2', enumFieldType::ftMemo, 'N', 0, $ship2);
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();

if ($recurring != 'true' && $fileManagement == 'true' && $SW_Permissions['File']['Write'][$profilSession]) {
    setupAttachFilesHTML(false);
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once('../includes/footer.php');
