<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editinvoice_serv.php,v 1.3 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

// check if the request is an AJAX request
if (!is_ajax()) {
    exit;
}

/**
 * Variables init
 */
$action = AddSlashesNOD(isset($_POST['action'])?$_POST['action']:'');   // action

if ($action == '') {
    exit;
}

switch ($action) {
    case 'client':
        $id = AddSlashesNOD(isset($_POST['id'])?$_POST['id']:'');   // client id
        /**
         * get client information
         */
        $querymore = " WHERE org.id='$id'";
        $clientDetail = new request();
        $clientDetail->openOrganizations($querymore);
        $comptClientDetail = count($clientDetail->org_id);

        if ($comptClientDetail > 0) {
            header("content-type:application/json");
            echo json_encode(array(
                'currency' => $clientDetail->org_currency[0],
                'workcalendar' => $clientDetail->org_workcalendar[0],
                'payment_method' => $clientDetail->org_payment_method[0],
                'payment_terms' => $clientDetail->org_payment_terms[0],
                'address' => $clientDetail->org_address[0]
            ));
        }

        break;
    case 'duedate':
        $dtI = AddSlashesNOD(isset($_POST['dtI'])?$_POST['dtI']:'');    // The input value of date
        $wc = AddSlashesNOD(isset($_POST['wc'])?$_POST['wc']:'');       // workcalendar id
        $pyt = AddSlashesNOD(isset($_POST['pyt'])?$_POST['pyt']:'');    // payment terms
        $dt = date2Timestamp($dtI); // convert input date to unix timestamp
        /**
         * get payment terms definition
         */
        $querymore = " WHERE pyt.id='$pyt'";
        $paymentTermsDetail = new request();
        $paymentTermsDetail->openPaymentTerms($querymore);
        $comptPaymentTermsDetail = count($paymentTermsDetail->pyt_id);

        if ($comptPaymentTermsDetail == 0) {
            exit;
        }

        $m = intval($paymentTermsDetail->pyt_extra_months[0]);
        $n = intval($paymentTermsDetail->pyt_extra_days[0]);

        switch ($paymentTermsDetail->pyt_start_from[0]) {
            case 'Y':                               // month start
                $dd = mktime(0, 0, 0, intval(date('n', $dt))+1+$m, 1+$n, intval(date('Y', $dt)));
                break;
            case 'H':                               // half month
                $j = intval(date('j', $dt));

                if ($j < 15) {
                    $dd = mktime(0, 0, 0, intval(date('n', $dt))+$m, 15+$n, intval(date('Y', $dt)));
                } else {
                    $dd = mktime(0, 0, 0, intval(date('n', $dt))+1+$m, $n, intval(date('Y', $dt)));
                }

                break;
            case 'E':                               // month end
                $dd = mktime(0, 0, 0, intval(date('n', $dt))+1+$m, $n, intval(date('Y', $dt)));
                break;
            default:
                $dd = mktime(0, 0, 0, intval(date('n', $dt))+$m, intval(date('j', $dt))+$n, intval(date('Y', $dt)));
        }

        $querymore1 = " WHERE wcd.workcalendar='$wc' AND wcd.date>='$dd' AND wcd.hours>0 ORDER BY wcd.date";
        $listWorkCalendarDetail = new request();
        $listWorkCalendarDetail->openWorkCalendarsDetail($querymore1);
        $comptListWorkCalendarDetail = count($listWorkCalendarDetail->wcd_id);

        if ($comptListWorkCalendarDetail > 0) {
            $ddI = createDate($listWorkCalendarDetail->wcd_date[0], 'date', false, true);
            header("content-type:application/json");
            echo json_encode(array(
                'duedate' => $ddI
            ));
        }

        break;
    case 'projectlist':
        $id = AddSlashesNOD(isset($_POST['id'])?$_POST['id']:'');       // client id
        /**
         * get project list
         */
        if ($projectsFilter == 'true' && !$SW_Permissions['Project']['Admin'][$profilSession]) {
            $querymore = " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=pro.id LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.organization='$id' AND pro.status IN ('" . enumProjectStatus::stOpen . "','" . enumProjectStatus::stCompleted . "','" . enumProjectStatus::stSuspended . "') AND tea.member=" . $idSession . " AND prp.view_project='" . enumBoolean::bTrue . "'";
        } else {
            $querymore = " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=pro.id  WHERE pro.organization='$id' AND pro.status IN ('" . enumProjectStatus::stOpen . "','" . enumProjectStatus::stCompleted . "','" . enumProjectStatus::stSuspended . "') AND tea.member=" . $idSession;
        }

        $listProjects = new request();
        $listProjects->openProjects($querymore);
        $comptListProjects = count($listProjects->pro_id);
        $options = array();

        for ($i=0; $i<$comptListProjects; $i++) {
            $options[$listProjects->pro_id[$i]] = $listProjects->pro_name[$i];
        }

        header("content-type:application/json");
        echo json_encode(array(
            'options' => $options
        ));

        break;
    case 'estimated':
        $id = AddSlashesNOD(isset($_POST['id'])?$_POST['id']:'');       // project id
        $cu = AddSlashesNOD(isset($_POST['cu'])?$_POST['cu']:'');       // currency
        /**
         * get project information
         */
        $querymore = " WHERE pro.id='$id'";
        $projectDetail = new request();
        $projectDetail->openProjects($querymore);
        $lcm = $projectDetail->pro_cost_method[0];
        /**
         * get project estimated time
         */
        switch ($lcm) {
            case '1':   // Use the cost rate of member only
                $tmpquery = "SELECT svc.name,svc.hourly_rate,SUM(tas.estimated_time) FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=res.task INNER JOIN " . $tablePrefix . "teams tea ON tea.project=tas.project AND tea.member=res.resource INNER JOIN " . $tablePrefix . "services svc ON svc.id=tea.service WHERE res.type='" . enumResourceType::rtUser . "' AND svc.currency='$cu' GROUP BY svc.name,svc.hourly_rate";
                break;
            case '2':   // Use the hourly rate of service first and use the cost rate of member if no service specified
                $tmpquery = "SELECT t0.name,t0.hourly_rate,SUM(t0.estimated_time) FROM (SELECT svc.name,svc.hourly_rate,tas.estimated_time FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=res.task INNER JOIN " . $tablePrefix . "services svc ON svc.id=tas.service WHERE res.type='" . enumResourceType::rtUser . "' AND svc.currency='$cu' AND tas.service<>'0'
UNION ALL
SELECT svc.name,svc.hourly_rate,tas.estimated_time FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=res.task INNER JOIN " . $tablePrefix . "teams tea ON tea.project=tas.project AND tea.member=res.resource INNER JOIN " . $tablePrefix . "services svc ON svc.id=tea.service WHERE res.type='" . enumResourceType::rtUser . "' AND svc.currency='$cu' AND tas.service='0') t0 GROUP BY t0.name,t0.hourly_rate";
                break;
            case '3':   // Use the hourly rate of service only
                $tmpquery = "SELECT svc.name,svc.hourly_rate,SUM(tas.estimated_time) FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=res.task INNER JOIN " . $tablePrefix . "services svc ON svc.id=tas.service WHERE res.type='" . enumResourceType::rtUser . "' AND svc.currency='$cu' GROUP BY svc.name,svc.hourly_rate";
                break;
        }

        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery);
        $description = array();
        $quantity = array();
        $unit = array();
        $price = array();

        while ($request1->fetch()) {
            $nam = ($row[0]);
            $hrt = (is_numeric($row[1]))?floatval($row[1]):0;
            $etm = (is_numeric($row[2]))?floatval($row[2]):0;

            if ($etm > 0) {
                $description[] = $strings['SVC__' . $nam];
                $quantity[] = $etm;
                $unit[] = $strings['hour'];
                $price[] = $hrt;
            }
        }

        $request1->close();

        if (count($description) == 0) {
            $description[] = '';
            $quantity[] = 0;
            $unit[] = $strings['hour'];
            $price[] = 0;
        }

        header("content-type:application/json");
        echo json_encode(array(
            'description' => $description,
            'quantity' => $quantity,
            'unit' => $unit,
            'price' => $price
        ));
        break;
    case 'actual':
        $id = AddSlashesNOD(isset($_POST['id'])?$_POST['id']:'');       // project id
        $cu = AddSlashesNOD(isset($_POST['cu'])?$_POST['cu']:'');       // currency
        /**
         * get project actual time
         */
        if ($enableTimesheet == 'true') {
            $tmpquery = "SELECT t0.name,t0.hourly_rate,SUM(t0.hours) FROM (SELECT svc.name,svc.hourly_rate,wkh.hours FROM " . $tablePrefix . "work_hours wkh INNER JOIN " . $tablePrefix . "services svc ON svc.id=wkh.service WHERE wkh.project='$id' AND wkh.billing='" . enumBoolean::bTrue . "' AND svc.currency='$cu' AND EXISTS (SELECT * FROM " . $tablePrefix . "timesheet ts1 INNER JOIN " . $tablePrefix . "periods pe1 ON pe1.id=ts1.period WHERE ts1.owner=wkh.owner AND ts1.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND wkh.date>=pe1.date_start AND wkh.date<=pe1.date_end) UNION ALL SELECT svc.name,svc.hourly_rate,tim.hours FROM " . $tablePrefix . "tasks_time tim INNER JOIN " . $tablePrefix . "services svc ON svc.id=tim.service WHERE tim.project='$id' AND tim.billing='" . enumBoolean::bTrue . "' AND svc.currency='$cu' AND EXISTS (SELECT * FROM " . $tablePrefix . "timesheet ts2 INNER JOIN " . $tablePrefix . "periods pe2 ON pe2.id=ts2.period WHERE ts2.owner=tim.owner AND ts2.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND tim.date>=pe2.date_start AND tim.date<=pe2.date_end)) t0 GROUP BY t0.name,t0.hourly_rate";
        } else {
            $tmpquery = "SELECT t0.name,t0.hourly_rate,SUM(t0.hours) FROM (SELECT svc.name,svc.hourly_rate,wkh.hours FROM " . $tablePrefix . "work_hours wkh INNER JOIN " . $tablePrefix . "services svc ON svc.id=wkh.service WHERE wkh.project='$id' AND wkh.billing='" . enumBoolean::bTrue . "' AND svc.currency='$cu' UNION ALL SELECT svc.name,svc.hourly_rate,tim.hours FROM " . $tablePrefix . "tasks_time tim INNER JOIN " . $tablePrefix . "services svc ON svc.id=tim.service WHERE tim.project='$id' AND tim.billing='" . enumBoolean::bTrue . "' AND svc.currency='$cu') t0 GROUP BY t0.name,t0.hourly_rate";
        }

        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery);
        $description = array();
        $quantity = array();
        $unit = array();
        $price = array();

        while ($request1->fetch()) {
            $nam = ($row[0]);
            $hrt = (is_numeric($row[1]))?floatval($row[1]):0;
            $hr = (is_numeric($row[2]))?floatval($row[2]):0;

            if ($hr > 0) {
                $description[] = $strings['SVC__' . $nam];
                $quantity[] = $hr;
                $unit[] = $strings['hour'];
                $price[] = $hrt;
            }
        }

        $request1->close();

        if (count($description) == 0) {
            $description[] = '';
            $quantity[] = 0;
            $unit[] = $strings['hour'];
            $price[] = 0;
        }

        header("content-type:application/json");
        echo json_encode(array(
            'description' => $description,
            'quantity' => $quantity,
            'unit' => $unit,
            'price' => $price
        ));
        break;
    case 'expense':
        $id = AddSlashesNOD(isset($_POST['id'])?$_POST['id']:'');       // project id
        $cu = AddSlashesNOD(isset($_POST['cu'])?$_POST['cu']:'');       // currency
        /**
         * get project information
         */
        $querymore = " WHERE pro.id='$id'";
        $projectDetail = new request();
        $projectDetail->openProjects($querymore);
        /**
         * get project expenses
         */
        $tmpquery = "SELECT SUM(exp.amount) FROM " . $tablePrefix . "expenses exp WHERE exp.project='$id' AND exp.currency='$cu' AND exp.billable='" . enumBoolean::bTrue . "' AND exp.status<>'" . enumDocumentStatus::stDraft . "'";
        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery);
        $description = $projectDetail->pro_name[0];
        $price = 0;

        while ($request1->fetch()) {
            if (is_numeric($row[0])) {
                $price = floatval($row[0]);
            }
        }

        $request1->close();
        header("content-type:application/json");
        echo json_encode(array(
            'description' => $projectDetail->pro_name[0],
            'quantity' => 1,
            'price' => $price
        ));
        break;
    case 'checkinvno':
        $invid = AddSlashesNOD(isset($_POST['invid'])?$_POST['invid']:'');       // invoice id
        $invno = AddSlashesNOD(isset($_POST['invno'])?$_POST['invno']:'');       // invoice no
        $querymore = " WHERE inv.invoice_no='$invno' AND inv.status<>'" . enumDocumentStatus::stDraft . "' AND inv.recurring='" . enumBoolean::bFalse . "'";

        if ($invid != '') {
            $querymore .= " AND inv.id<>'$invid'";
        }

        $listInvoices = new request();
        $listInvoices->openInvoices($querymore);

        if (count($listInvoices->inv_id) == 0) {
            $result = 'ok';
        } else {
            $result = 'failed';
        }

        header("content-type:application/json");
        echo json_encode(array(
            'result' => $result
        ));
        break;
    case 'newinvno':
        $dtI = isset($_POST['date'])?$_POST['date']:'';     // The input value of invoice date
        $dt = ($dtI=='')?mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y'))):date2Timestamp($dtI);  // The timestamp of invoice date
        $requestAct = new request();
        $requestAct->connectClass();
        $invno = newInvoiceNo($requestAct, $dt);
        $requestAct->close();
        header("content-type:application/json");
        echo json_encode(array(
            'invno' => $invno
        ));
        break;
}
