<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listinvoices.php,v 1.3 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$show = isset($_GET['show'])?$_GET['show']:'';
$recurring = ($show=='recurring')?'true':'';

if ($show == '') {
    $show = "open";
}

/**
 * Permission check
 */
if (!$SW_Permissions['Invoice']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings("accounting"));
$blockPage->itemBreadcrumbs(lang_strings("invoices"));

switch ($show) {
    case 'all':
        $blockPage->itemBreadcrumbs(lang_strings('all'));
        $title = $strings['invoices'] . ' : ' . $strings['all'];
        break;
    case 'draft':
        $blockPage->itemBreadcrumbs($statusAccountDoc[enumDocumentStatus::stDraft]);
        $title = $strings['invoices'] . ' : ' . $statusAccountDoc[enumDocumentStatus::stDraft];
        break;
    case 'open':
        $blockPage->itemBreadcrumbs($statusAccountDoc[enumDocumentStatus::stOpen]);
        $title = $strings['invoices'] . ' : ' . $statusAccountDoc[enumDocumentStatus::stOpen];
        break;
    case 'closed':
        $blockPage->itemBreadcrumbs($statusAccountDoc[enumDocumentStatus::stClosed]);
        $title = $strings['invoices'] . ' : ' . $statusAccountDoc[enumDocumentStatus::stClosed];
        break;
    case 'recurring':
        $blockPage->itemBreadcrumbs(lang_strings('recurring'));
        $title = $strings['invoices'] . ' : ' . $strings['recurring'];
        break;
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
logURL($title, "../invoices/listinvoices.php?show=$show");
$block1 = new block();
$block1->openHeading(lang_strings('invoices'));
$block1->openViewOptions();

foreach (array(array('all', lang_strings('all')),array('draft', $statusAccountDoc[enumDocumentStatus::stDraft]),array('open', $statusAccountDoc[enumDocumentStatus::stOpen]),array('closed', $statusAccountDoc[enumDocumentStatus::stClosed]),array('recurring', lang_strings('recurring'))) as $x) {
    if ($show != $x[0]) {
        $block1->itemViewOptions($block1->buildLink('../invoices/listinvoices.php?show=' . $x[0], $x[1], 'in'));
    }
}

$block1->closeViewOptions();
$block1->closeHeading();
$block1->form = "inL";
$block1->openForm("../invoices/listinvoices.php?show=$show#" . $block1->form . "Anchor");
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '12';
$block1->sorting('invoices', (isset($sortingUser['invoices'])?$sortingUser['invoices']:''), "inv.invoice_no ASC", $sortingFields = array(0 => 'inv.invoice_no', 1 => 'inv.doc_date', 2 => 'org.name', 3 => 'inv.status', 4 => 'inv.amount', 5 => 'inv.paid'));

switch ($show) {
    case 'draft':
        $querymore = " WHERE inv.status='" . enumDocumentStatus::stDraft . "' AND inv.recurring='" . enumBoolean::bFalse . "'";
        break;
    case 'open':
        $querymore = " WHERE inv.status='" . enumDocumentStatus::stOpen . "' AND inv.recurring='" . enumBoolean::bFalse . "'";
        break;
    case 'closed':
        $querymore = " WHERE inv.status='" . enumDocumentStatus::stClosed . "' AND inv.recurring='" . enumBoolean::bFalse . "'";
        break;
    case 'recurring':
        $querymore = " WHERE inv.status='" . enumDocumentStatus::stDraft . "' AND inv.recurring='" . enumBoolean::bTrue . "'";
        break;
    default:
        $querymore = '';
}

$querymore .= " ORDER BY " . $block1->sortingValue;
$block1->recordsTotal = compt($initrequest['invoices'] . ' ' . $querymore);
$listInvoices = new request();
$listInvoices->openInvoices($querymore, $block1->borne, $block1->rowsLimit);
$comptListInvoices = count($listInvoices->inv_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['invoice_no'];
$columns[0]->field_type = enumFieldType::ftAlphaNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['date'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['client'];
$columns[2]->field_type = enumFieldType::ftNumeric;
$columns[2]->linked_table = 'organizations';
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['status'];
$columns[3]->field_type = enumFieldType::ftText;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['total'];
$columns[4]->field_type = enumFieldType::ftText;
$columns[5] = new cardviewColumn();
$columns[5]->title = $strings['invoice_due'];
$columns[5]->field_type = enumFieldType::ftText;
$opt[enumCardviewOption::oObject] = 'invoices';
$opt[enumCardviewOption::oTableName] = 'invoices';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oExtraParameters] = 'show=' . $show . '&recurring=' . $recurring . '&borne1=' . $block1->borne;

if ($SW_Permissions['Invoice']['Write'][$profilSession]) {
    $opt[enumCardviewOption::oAddUrl] = '../invoices/editinvoice.php?recurring=' . $recurring;
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListInvoices; $i++) {
    $content = array(
        $listInvoices->inv_invoice_no[$i],
        createDate($listInvoices->inv_doc_date[$i], 'date', false, true),
        $listInvoices->inv_organization[$i],
        $statusAccountDoc[$listInvoices->inv_status[$i]],
        CurrencyFormatNOD($listInvoices->inv_amount[$i], $listInvoices->inv_currency[$i], $costAccuracy),
        CurrencyFormatNOD($listInvoices->inv_due[$i], $listInvoices->inv_currency[$i], $costAccuracy)
    );
    $block1->itemCardView($listInvoices->inv_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter("1", $blockPage->bornesNumber, "show=$show&recurring=$recurring");
$block1->closeFormResults();
require_once("../includes/footer.php");
