<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: tax_code.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'list';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$error = '';

if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'tax_code' && $_SESSION['SOURCE'] == '') {
    $n = $_SESSION['PARAMS']['n'];                  // name
    $np = $_SESSION['PARAMS']['np'];                // name print
    $tg = $_SESSION['PARAMS']['tg'];                // tax group
    $r = $_SESSION['PARAMS']['r'];                  // rate
    $_SESSION['TARGET'] = '';
    $icp = 'true';
} else {
    $n = AddSlashesNOD(isset($_POST['n'])?$_POST['n']:'');  // name
    $np = isset($_POST['np'])?$_POST['np']:'';      // name print
    $tg = isset($_POST['tg'])?$_POST['tg']:'';      // tax group
    $r = isset($_POST['r'])?$_POST['r']:'0';        // rate
}

$rt = round($r, $rateAccuracy);
$n_highlight = false;

/**
 * Permission check
 */
if ($mode == 'list') {
    if (!$SW_Permissions['Accounting']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Accounting']['Edit'][$profilSession]) {
        header("Location: ../invoices/tax_code.php?mode=list&msg=permissiondenied");
        exit;
    }
}

if ($id != '') {
    if ($mode == 'delete') {
        $tmpquery = "SELECT id FROM " . $tablePrefix . "invoice_rows WHERE tax_code IN ($ids) UNION ALL SELECT id FROM " . $tablePrefix . "invoice_rows WHERE tax_code2 IN ($ids) UNION ALL SELECT id FROM " . $tablePrefix . "invoice_rows WHERE tax_code3 IN ($ids)";

        if (compt($tmpquery) > 0) {
            header("Location: ../invoices/tax_code.php?mode=list&msg=permissiondenied");
            exit;
        }

        $querymore = " WHERE txc.id IN ($ids)";
        $listTaxCodes = new request();
        $listTaxCodes->openTaxCodes($querymore);
        $comptListTaxCodes = count($listTaxCodes->txc_id);

        if ($comptListTaxCodes == '0') {
            header("Location: ../invoices/tax_code.php?mode=list&msg=permissiondenied");
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE txc.id='$id'";
        $taxCodeDetail = new request();
        $taxCodeDetail->openTaxCodes($querymore);
        $comptTaxCodeDetail = count($taxCodeDetail->txc_id);

        if ($comptTaxCodeDetail == '0') {
            header("Location: ../invoices/tax_code.php?mode=list&msg=permissiondenied");
            exit;
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add') {
    $querymore = " WHERE txc.name='$n'";
    $taxCodeTest = new request();
    $taxCodeTest->openTaxCodes($querymore);

    if (count($taxCodeTest->txc_id) > 0) {
        $error = lang_strings("tax_code_already_exists");
        $bodyCommand = "onLoad=\"document.txcForm.n.focus();\"";
        $n_highlight = true;
    }
} else if ($action == 'new') {
    // store all user input values in session variables
    $params = array();
    $params['n'] = $n;
    $params['np'] = $np;
    $params['r'] = $r;
    $_SESSION['PARAMS'] = $params;
    $_SESSION['SOURCE'] = 'tax_code';
    $_SESSION['LOCATION'] = '../invoices/tax_code.php?id=' . $id . '&mode=' . $mode;
    /**
     * Add New Tax Group
     */
    $_SESSION['TARGET'] = 'tax_group';
    header("Location: ../invoices/tax_group.php?mode=add");
    exit;
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "tax_codes (name,tax_group,rate,created,cuser) VALUES ('$n','$tg','$rt','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('tax_codes');
            updateString($requestAct, 'TXC__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../invoices/tax_code.php?mode=list&msg=add");
            exit;
        }
    } else if ($action == 'edit') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "tax_codes SET tax_group='$tg',rate='$rt',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            updateString($requestAct, 'TXC__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../invoices/tax_code.php?mode=list&msg=update");
            exit;
        }
    } else if ($action == 'delete') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "DELETE FROM " . $tablePrefix . "tax_codes WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../invoices/tax_code.php?mode=list&msg=delete");
            exit;
        }
    }
}

/**
 * get tax group valid values
 */
$querymore = " ORDER BY txg.name";
$listTaxGroups = new request();
$listTaxGroups->openTaxGroups($querymore);
$comptListTaxGroups = count($listTaxGroups->txg_id);
$tgVV = array();
$tgVV[''] = '';

for ($i=0; $i<$comptListTaxGroups; $i++) {
    $tgVV[$listTaxGroups->txg_id[$i]] = $listTaxGroups->txg_name_print[$i];
}

$tgVV['-1'] = $strings['add_new_tax_group'];

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=accounting", lang_strings("administration"), 'in'));

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings("tax_code"));
} else if ($mode == 'add') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/tax_code.php?", lang_strings("tax_code"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_tax_code"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/tax_code.php?", lang_strings("tax_code"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_tax_code"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/tax_code.php?", lang_strings("tax_code"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_tax_codes"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = "txc";
$block1->openForm("../invoices/tax_code.php?id=$id&mode=$mode#" . $block1->form . "Anchor");

if ($mode == 'list') {
    logURL($strings['tax_code'], "../invoices/tax_code.php?id=$id&mode=$mode");
    $block1->heading(lang_strings("tax_code"));
    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '12';
    $block1->sorting('tax_code', (isset($sortingUser['tax_code'])?$sortingUser['tax_code']:''), 'txg.name ASC', $sortingFields = array(0 => 'txc.name', 1 => 'none', 2 => 'txg.name', 3 => 'txc.rate'));
    $querymore = " ORDER BY " . $block1->sortingValue;
    $block1->recordsTotal = compt($initrequest['tax_codes'] . ' ' . $querymore);
    $listTaxCodes = new request();
    $listTaxCodes->openTaxCodes($querymore, $block1->borne, $block1->rowsLimit);
    $comptListTaxCodes = count($listTaxCodes->txc_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftAlphaNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name_print'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['tax_group'];
    $columns[2]->field_type = enumFieldType::ftNumeric;
    $columns[2]->linked_table = 'tax_groups';
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['tax_rate'];
    $columns[3]->field_type = enumFieldType::ftRate;
    $opt[enumCardviewOption::oObject] = 'tax_codes';
    $opt[enumCardviewOption::oTableName] = 'tax_codes';
    $opt[enumCardviewOption::oColumns] = $columns;

    if ($SW_Permissions['Accounting']['Edit'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../invoices/tax_code.php?mode=add';
    }

    $block1->openCardView($opt);

    for ($i=0; $i<$comptListTaxCodes; $i++) {
        $content = array(
            $listTaxCodes->txc_name[$i],
            $listTaxCodes->txc_name_print[$i],
            $listTaxCodes->txc_tax_group[$i],
            $listTaxCodes->txc_rate[$i]
        );
        $block1->itemCardView($listTaxCodes->txc_id[$i], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "id=$id&mode=$mode");
    $block1->closeFormResults();
} else if ($mode == 'add') {
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_tax_code"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name"), 'n', enumFieldType::ftAlphaNumeric, 'Y', '155', $n, '', '', $n_highlight, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np, '', '', false, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("tax_group"), 'tg', enumFieldType::ftNumeric, 'Y', '8', $tg, $tgVV, '', false, '', 'onchange="taxGroupChanged()"');
    setupInputHTML($block1, lang_strings('tax_rate'), 'r', enumFieldType::ftRate, 'Y', '19', $r);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    if ($error == '') {
        $n = $taxCodeDetail->txc_name[0];
        $np = $taxCodeDetail->txc_name_print[0];
        $tg = $taxCodeDetail->txc_tax_group[0];
        $r = $taxCodeDetail->txc_rate[0];
    }

    echo '<input type="hidden" name="action" value="edit">';
    echo '<input type="hidden" name="n" value="' . $n . '">';
    $block1->heading(lang_strings("edit_tax_code") . " : " . $taxCodeDetail->txc_name[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np);
    setupInputHTML($block1, lang_strings("tax_group"), 'tg', enumFieldType::ftNumeric, 'Y', '8', $tg, $tgVV, '', false, '', 'onchange="taxGroupChanged()"');
    setupInputHTML($block1, lang_strings('tax_rate'), 'r', enumFieldType::ftRate, 'Y', '19', $r);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_tax_codes"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListTaxCodes; $i++) {
        $block1->contentRow('#' . $listTaxCodes->txc_id[$i], $listTaxCodes->txc_name[$i] . ' (' . $listTaxCodes->txc_name_print[$i] . ')');
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

?>
<script type="text/javascript">
    function nameChanged() {
        var np = document.getElementById('np').value;

        if (np === '') {
            var n = document.getElementById('n').value;
            document.getElementById('np').value = n;
        }
    }

    function taxGroupChanged()
    {
        var x = document.getElementById('tg').selectedIndex;
        var y = document.getElementById('tg').options[x].value;

        if (y === '-1') {
            document.txcForm.action.value = 'new';
            document.txcForm.submit();
        }
    }
</script>
<?php
require_once("../includes/footer.php");
