<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: tax_group.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');     // tax group id
$msg = isset($_GET['msg'])?$_GET['msg']:'';                 // message id
$mode = isset($_GET['mode'])?$_GET['mode']:'list';          // form mode
$n = AddSlashesNOD(isset($_POST['n'])?$_POST['n']:'');      // tax group name
$np = isset($_POST['np'])?$_POST['np']:'';                  // tax group name print
$l = isset($_POST['l'])?$_POST['l']:'';                     // tax group locked
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$lk = DbValueEncode(enumFieldType::ftBoolean, $l);
$error = '';
$n_highlight = false;

/**
 * Permission check
 */
if ($mode == 'list') {      // tax group list
    if (!$SW_Permissions['Accounting']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {        // add new tax group/edit a existing tax group/delete tax groups
    if (!$SW_Permissions['Accounting']['Edit'][$profilSession]) {
        header("Location: ../expenses/tax_group.php?mode=list&msg=permissiondenied");
        exit;
    }
}

if ($id != '') {
    if ($mode == 'delete') {
        $tmpquery = "SELECT id FROM " . $tablePrefix . "tax_codes WHERE tax_group IN ($ids)";
        // unable to delete tax groups (in-used)
        if (compt($tmpquery) > 0) {
            header("Location: ../invoices/tax_group.php?mode=list&msg=permissiondenied");
            exit;
        }

        $querymore = " WHERE txg.id IN ($ids)";
        $listTaxGroups = new request();
        $listTaxGroups->openTaxGroups($querymore);
        $comptListTaxGroups = count($listTaxGroups->txg_id);
        // tax groups not found
        if ($comptListTaxGroups == '0') {
            header("Location: ../invoices/tax_group.php?mode=list&msg=permissiondenied");
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE txg.id='$id'";
        $taxGroupDetail = new request();
        $taxGroupDetail->openTaxGroups($querymore);
        $comptTaxGroupDetail = count($taxGroupDetail->txg_id);
        // tax group not found
        if ($comptTaxGroupDetail == '0') {
            header("Location: ../expenses/tax_group.php?mode=list&msg=permissiondenied");
            exit;
        }
    }
}
/**
 * Count actived tax groups
 */
if ($mode != 'list') {
    $querymore1 = " WHERE txg.locked='" . enumBoolean::bFalse . "'";
    $listActTaxGroups = new request();
    $listActTaxGroups->openTaxGroups($querymore1);
    $comptListActTaxGroups = count($listActTaxGroups->txg_id);
}
/**
 * Fields check
 */
if ($action == 'add') {
    $querymore = " WHERE txg.name='$n'";
    $taxGroupTest = new request();
    $taxGroupTest->openTaxGroups($querymore);

    if (count($taxGroupTest->txg_id) > 0) {
        $error = lang_strings("tax_group_already_exists");
        $bodyCommand = "onLoad=\"document.txgForm.n.focus();\"";
        $n_highlight = true;
    }
    // 3 actived tax groups maximum
    if ($comptListActTaxGroups >= 3) {
        $lk = enumBoolean::bTrue;
    }
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "tax_groups (name,locked,created,cuser) VALUES ('$n','$lk','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('tax_groups');
            updateString($requestAct, 'TXG__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'tax_group') {
                $_SESSION['PARAMS']['tg'] = $num;
                $_SESSION['TARGET'] = $_SESSION['SOURCE'];
                $_SESSION['SOURCE'] = '';
                header("Location: " . $_SESSION['LOCATION']);
            } else {
                header("Location: ../invoices/tax_group.php?mode=list&msg=add");
            }

            exit;
        }
    } else if ($action == 'edit') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "tax_groups SET locked='$lk',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            updateString($requestAct, 'TXG__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../invoices/tax_group.php?mode=list&msg=update");
            exit;
        }
    } else if ($action == 'delete') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "DELETE FROM " . $tablePrefix . "tax_groups WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../invoices/tax_group.php?mode=list&msg=delete");
            exit;
        }
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=accounting", lang_strings("administration"), 'in'));

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings("tax_group"));
} else if ($mode == 'add') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/tax_group.php?", lang_strings("tax_group"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_tax_group"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/tax_group.php?", lang_strings("tax_group"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_tax_group"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/tax_group.php?", lang_strings("tax_group"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_tax_groups"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = "txg";
$block1->openForm("../invoices/tax_group.php?id=$id&mode=$mode#" . $block1->form . "Anchor");

if ($mode == 'list') {
    logURL($strings['tax_group'], "../invoices/tax_group.php?id=$id&mode=$mode");
    $block1->heading(lang_strings("tax_group"));
    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '12';
    $block1->sorting('tax_group', (isset($sortingUser['tax_group'])?$sortingUser['tax_group']:''), 'txg.name ASC', $sortingFields = array(0 => 'txg.name', 1 => 'none', 2 => 'txg.locked'));
    $querymore = " ORDER BY " . $block1->sortingValue;
    $block1->recordsTotal = compt($initrequest['tax_groups'] . ' ' . $querymore);
    $listTaxGroups = new request();
    $listTaxGroups->openTaxGroups($querymore, $block1->borne, $block1->rowsLimit);
    $comptListTaxGroups = count($listTaxGroups->txg_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftAlphaNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name_print'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['locked'];
    $columns[2]->field_type = enumFieldType::ftBoolean;
    $opt[enumCardviewOption::oObject] = 'tax_groups';
    $opt[enumCardviewOption::oTableName] = 'tax_groups';
    $opt[enumCardviewOption::oColumns] = $columns;

    if ($SW_Permissions['Accounting']['Edit'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../invoices/tax_group.php?mode=add';
    }

    $block1->openCardView($opt);

    for ($i=0; $i<$comptListTaxGroups; $i++) {
        $content = array(
            $listTaxGroups->txg_name[$i],
            $listTaxGroups->txg_name_print[$i],
            $listTaxGroups->txg_locked[$i]
        );
        $block1->itemCardView($listTaxGroups->txg_id[$i], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "id=$id&mode=$mode");
    $block1->closeFormResults();
} else if ($mode == 'add') {
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_tax_group"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name"), 'n', enumFieldType::ftAlphaNumeric, 'Y', '155', $n, '', '', $n_highlight, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np, '', '', false, '', 'onblur="nameChanged()"');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    if ($error == '') {
        $n = $taxGroupDetail->txg_name[0];
        $np = $taxGroupDetail->txg_name_print[0];
        $lk = $taxGroupDetail->txg_locked[0];
    }

    echo '<input type="hidden" name="action" value="edit">';
    echo '<input type="hidden" name="n" value="' . $n . '">';
    $block1->heading(lang_strings("edit_tax_group") . " : " . $taxGroupDetail->txg_name[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np);

    if ($lk == enumBoolean::bTrue && $comptListActTaxGroups >= 3) {
        $block1->contentRow(lang_strings('locked'), lang_strings('yes'));
        echo '<input type="hidden" name="l" value="Y">';
    } else {
        setupInputHTML($block1, lang_strings("locked"), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
    }

    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_tax_groups"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListTaxGroups; $i++) {
        $block1->contentRow('#' . $listTaxGroups->txg_id[$i], $listTaxGroups->txg_name[$i] . ' (' . $listTaxGroups->txg_name_print[$i] . ')');
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

?>
<script type="text/javascript">
    function nameChanged() {
        var np = document.getElementById('np').value;

        if (np === '') {
            var n = document.getElementById('n').value;
            document.getElementById('np').value = n;
        }
    }
</script>
<?php
require_once("../includes/footer.php");
