<?php // $Revision: 1.21 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewinvoice.php,v 1.21 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$recurring = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Invoice']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore = " WHERE inv.id='$id'";
$invoiceDetail = new request();
$invoiceDetail->openInvoices($querymore);

if (count($invoiceDetail->inv_id) == 0) {
    header('Location: ../invoices/listinvoices.php?msg=permissiondenied' . $urlBornes);
    exit;
}
/**
 * get active currency list & help hints
 */
$helpStr = '<table>';

foreach ($CurrencyMatrix['active'] as $key) {
    $val = $CurrencyMatrix['name'][$key];
    $helpStr .= '<tr><th>' . $key . '</th><td>' . $val . '</td></tr>';
}

$helpStr .= '</table>';
/**
 * get invoice rows
 */
$querymore1 = " WHERE in1.invoice='$id' ORDER BY in1.id";
$listInvoiceRows = new request();
$listInvoiceRows->openInvoiceRows($querymore1);
$comptListInvoiceRows = count($listInvoiceRows->in1_id);
/**
 * get tax group list
 */
$querymore2 = " WHERE txg.id IN ('" . $invoiceDetail->inv_tax_group[0] . "','" . $invoiceDetail->inv_tax_group2[0] . "','" . $invoiceDetail->inv_tax_group3[0] . "') ORDER BY txg.name";
$listTaxGroups = new request();
$listTaxGroups->openTaxGroups($querymore2);
$comptListTaxGroups = count($listTaxGroups->txg_id);
/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings("accounting"));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/listinvoices.php?" . $urlBornes, lang_strings("invoices"), 'in'));

if ($invoiceDetail->inv_recurring[0] != enumBoolean::bTrue) {
    $blockPage->itemBreadcrumbs($invoiceDetail->inv_invoice_no[0]);
    $title = $strings['invoice'] . ' : ' . $invoiceDetail->inv_invoice_no[0];
} else {
    $blockPage->itemBreadcrumbs('#' . $id);
    $title = $strings['recurring_invoice'] . ' : #' . $id;
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '3';     // 1st for listinvoices
logURL($title, '../invoices/viewinvoice.php?id=' . $id);
$block1 = new block();
$block1->form = 'vIv';
$block1->openForm('../invoices/viewinvoice.php?id=' . $id . $urlBornes . '#' . $block1->form . 'Anchor');

if ($invoiceDetail->inv_recurring[0] != enumBoolean::bTrue) {
    $block1->headingToggle(lang_strings('invoice'), !($toggle_focus==''));
} else {
    $block1->headingToggle(lang_strings('recurring_invoice'), !($toggle_focus==''));
}

$block1->openPaletteIcon();

if ($SW_Permissions['Invoice']['Write'][$profilSession]) {
    $block1->paletteIcon(5, "copy", $strings["copy"]);
}

if (!periodLocked($invoiceDetail->inv_doc_date[0]) && $invoiceDetail->inv_paid[0] == 0) {
    if ($SW_Permissions['Invoice']['Admin'][$profilSession]) {
        $block1->paletteIcon(0, 'remove', $strings['delete']);
    }

    if ($SW_Permissions['Invoice']['Edit'][$profilSession]) {
        $block1->paletteIcon(1, 'edit', $strings['edit']);
    }
}

if ($invoiceDetail->inv_recurring[0] != enumBoolean::bTrue) {
    $block1->paletteIcon(2, 'print', $strings['print']);
}

$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings('info'));

if ($invoiceDetail->inv_recurring[0] != enumBoolean::bTrue) {
    $block1->contentRow(lang_strings('invoice_no'), $invoiceDetail->inv_invoice_no[0]);
    $block1->contentRow(lang_strings('status'), $statusAccountDoc[$invoiceDetail->inv_status[0]]);
    $block1->contentRow(lang_strings('printed'), DbValueDecode(enumFieldType::ftBoolean, $invoiceDetail->inv_printed[0]));
}

$block1->contentRow(lang_strings('client'), $block1->buildLink('../clients/viewclient.php?id=' . $invoiceDetail->inv_organization[0], $invoiceDetail->inv_org_name[0], 'in'));

if ($invoiceDetail->inv_recurring[0] != enumBoolean::bTrue) {
    $block1->contentRow(lang_strings('date'), createDate($invoiceDetail->inv_doc_date[0], 'date', false, true));
    $block1->contentRow(lang_strings('due_date'), createDate($invoiceDetail->inv_due_date[0], 'date', false, true));
}

$block1->contentRow(lang_strings('currency') . $block1->printHelp($helpStr, true), $invoiceDetail->inv_currency[0]);
$block1->contentRow(lang_strings('payment_terms'), $invoiceDetail->inv_pyt_name_print[0]);
$block1->contentRow(lang_strings('payment_method'), $invoiceDetail->inv_pym_name_print[0]);
setupCustomFieldsHTML($block1, 'invoices', $id);

if ($invoiceDetail->inv_recurring[0] == enumBoolean::bTrue) {
    $block1->contentRow(lang_strings('recurring_start'), createDate($invoiceDetail->inv_recurring_start[0], 'date', false, true));
    $block1->contentRow(lang_strings('recurring_finish'), createDate($invoiceDetail->inv_recurring_finish[0], 'date', false, true));
    $block1->contentRow(lang_strings('recurring_type'), $strings['VV__invoices_recurring_type_' . $invoiceDetail->inv_recurring_type[0]]);
    $block1->contentRow(lang_strings('recurring_frequency'), $invoiceDetail->inv_recurring_frequency[0]);
    $block1->contentRow(lang_strings('recurring_enabled'), DbValueDecode(enumFieldType::ftBoolean, $invoiceDetail->inv_recurring_enabled[0]));

    if ($invoiceDetail->inv_recurring_enabled[0] == enumBoolean::bTrue) {
        $block1->contentRow(lang_strings('recurring_next'), createDate($invoiceDetail->inv_recurring_next[0], 'date', false, true));
    }
}

$block1->contentTitle(lang_strings("details"));

if ($comptListInvoiceRows > 0) {
    $labels = array(lang_strings("description"), lang_strings("project"), lang_strings("quantity"), lang_strings("unit"), lang_strings('price'), lang_strings('discount'), '%');

    for ($i=0; $i<$comptListTaxGroups; $i++) {
        $labels[] = $listTaxGroups->txg_name_print[$i];
        $labels[] = '';
    }

    $labels[] = lang_strings('total');
    $block1->openResults(false);
    $block1->labels($labels, "false", "false");

    for ($i=0; $i<$comptListInvoiceRows; $i++) {
        $block1->openRow();
        $block1->cellRow($listInvoiceRows->in1_description[$i]);
        $block1->cellRow($block1->buildLink('../projects/viewproject.php?id=' . $listInvoiceRows->in1_project[$i], $listInvoiceRows->in1_pro_name[$i], 'in'));
        $block1->cellRow($listInvoiceRows->in1_quantity[$i]);
        $block1->cellRow($listInvoiceRows->in1_unit[$i]);
        $block1->cellRow($listInvoiceRows->in1_price[$i]);
        $block1->cellRow($listInvoiceRows->in1_discount_sum[$i]);
        $block1->cellRow($listInvoiceRows->in1_discount_percent[$i]);

        for ($j=0; $j<$comptListTaxGroups; $j++) {
            $block1->cellRow($listInvoiceRows->in1_txc_name_print[$i][$j]);
            $block1->cellRow($listInvoiceRows->in1_tax_sum[$i][$j]);
        }

        $block1->cellRow($listInvoiceRows->in1_line_total[$i]);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->contentTitle(lang_strings('totals'));
$block1->contentRow(lang_strings('subtotal'), $invoiceDetail->inv_before_discount[0]);
$block1->contentRow(lang_strings('discount'), $invoiceDetail->inv_discount_sum[0] . ' (' . $invoiceDetail->inv_discount_percent[0] . '%)');
$block1->contentRow(lang_strings('tax'), $invoiceDetail->inv_tax_sum[0]);
$block1->contentRow(lang_strings('shipping'), $invoiceDetail->inv_freight[0]);
$block1->contentRow(lang_strings('total'), $invoiceDetail->inv_amount[0]);

if ($invoiceDetail->inv_recurring[0] != enumBoolean::bTrue) {
    $block1->contentRow(lang_strings('paid'), $invoiceDetail->inv_paid[0]);
    $block1->contentRow(lang_strings('invoice_due'), $invoiceDetail->inv_due[0]);
    $recurring = 'true';
}

$block1->contentTitle(lang_strings('notes'));
$block1->contentRow('', $invoiceDetail->inv_notes[0]);
$block1->contentTitle(lang_strings('address'));
$block1->contentRow(lang_strings('bill_to'), $invoiceDetail->inv_bill_to[0]);
$block1->contentRow(lang_strings('ship_to'), $invoiceDetail->inv_ship_to[0]);
$block1->closeContent();

if ($invoiceDetail->inv_recurring[0] != enumBoolean::bTrue) {
    $block1->closeToggle();
}

$block1->closeForm();
$block1->openPaletteScript();

if ($SW_Permissions['Invoice']['Write'][$profilSession]) {
    $block1->paletteScript(5, "copy", "../invoices/editinvoice.php?id=$id&cpy=true&recurring=$recurring" . $urlBornes, "true,true,true", $strings["copy"]);
}

if (!periodLocked($invoiceDetail->inv_doc_date[0]) && $invoiceDetail->inv_paid[0] == 0) {
    if ($SW_Permissions['Invoice']['Admin'][$profilSession]) {
        $block1->paletteScript(0, 'remove', '../invoices/deleteinvoices.php?id=' . $id . $urlBornes, 'true,true,true', $strings['delete']);
    }

    if ($SW_Permissions['Invoice']['Edit'][$profilSession]) {
        $block1->paletteScript(1, 'edit', '../invoices/editinvoice.php?id=' . $id . $urlBornes, 'true,true,true', $strings['edit']);
    }
}

if ($invoiceDetail->inv_recurring[0] != enumBoolean::bTrue) {
    $block1->paletteScript(2, 'print', '../invoices/printinvoices.php?id=' . $id . $urlBornes, 'true,true,true', $strings['print']);
}

$block1->closePaletteScript('', '');

if ($invoiceDetail->inv_recurring[0] != enumBoolean::bTrue && $invoiceDetail->inv_status_approval[0] != enumFileStatus::stNoApprovalsNeeded) {
    $block1->headingToggle(lang_strings("approval_history"));
    $block1->openContent();
    $querymore = " WHERE dap.docid='$id' AND dap.doctype='invoices' ORDER BY dap.id";
    $listDocumentsApproval = new request();
    $listDocumentsApproval->openDocumentsApproval($querymore);
    $comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

    for ($i=0; $i<$comptListDocumentsApproval; $i++) {
        if ($i == 0) {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['submit_at']) . '</i>';
        } else {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['resubmit_at']) . '</i>';
        }

        $querymore = " WHERE daa.document_approval='" . $listDocumentsApproval->dap_id[$i] . "' AND daa.status<>'" . enumApprovalStatus::stPending . "' ORDER BY daa.created,daa.modified";
        $listDocumentsApprovalAuthorizer = new request();
        $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($querymore);
        $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

        for ($j=0,$right = ''; $j<$comptListDocumentsApprovalAuthorizer; $j++,$right.='<br>') {
            $ahd = '';

            if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stApproved) {
                $ahd = $strings['approval_history_approved'];
            } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stNotApproved) {
                $ahd = $strings['approval_history_rejected'];
            }

            if ($ahd != '') {
                $ahd0 = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
                $ahd1 = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j], 'both'), $ahd0);
                $right .= '<i>' . $ahd1  . '</i>';

                if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                    $right .= '<br>' . $listDocumentsApprovalAuthorizer->daa_comments[$j];
                }
            }
        }

        $block1->contentRow($left, $right);
    }

    $block1->closeContent();
    $block1->closeToggle();
}

if ($invoiceDetail->inv_status[0] != enumDocumentStatus::stDraft && $SW_Permissions['Payment']['Read'][$profilSession]) {
    $block2 = new block();
    $block2->form = "ivP";
    $block2->openForm("../invoices/viewinvoice.php?id=$id" . $urlBornes . "#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings("payments"), !($toggle_focus=='payments'));
    $block2->borne = $blockPage->returnBorne('2');
    $block2->rowsLimit = 12;
    $block2->sorting("invoice_payments", isset($sortingUser['invoice_payments'])?$sortingUser['invoice_payments']:'', 'pay.doc_date DESC', $sortingFields = array(0 => 'pay.id', 1 => 'pay.doc_date', 2 => 'pay.amount', 3 => 'pay.payment_method'));
    $querymore = " WHERE pay.invoice='$id' ORDER BY " . $block2->sortingValue;
    $recordsTotal = compt($initrequest['payments'] . $querymore);
    $block2->recordsTotal = $recordsTotal;
    $listPayments = new request();
    $listPayments->openPayments($querymore, $block2->borne, $block2->rowsLimit);
    $comptListPayments = count($listPayments->pay_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['id'];
    $columns[0]->field_type = enumFieldType::ftNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['date'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['total'];
    $columns[2]->field_type = enumFieldType::ftTotals;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['payment_method'];
    $columns[3]->field_type = enumFieldType::ftText;
    $opt = array();
    $opt[enumCardviewOption::oObject] = 'payments';
    $opt[enumCardviewOption::oTableName] = 'payments';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oExtraParameters] = $urlBornes . '&borne2=' . $block2->borne;

    if ($SW_Permissions['Payment']['Write'][$profilSession] && $invoiceDetail->inv_status[0] == enumDocumentStatus::stOpen) {
        $opt[enumCardviewOption::oAddUrl] = '../payments/editpayment.php?inv=' . $id . $urlBornes;
    }

    $block2->openCardView($opt);

    for ($i=0; $i<$comptListPayments; $i++) {
        $content = array(
            $listPayments->pay_id[$i],
            createDate($listPayments->pay_doc_date[$i], 'date', false, true),
            $listPayments->pay_amount[$i],
            $listPayments->pay_pym_name_print[$i]
        );
        $block2->itemCardView($listPayments->pay_id[$i], $content);
    }

    $block2->closeCardView();
    $block2->bornesFooter(2, $blockPage->bornesNumber, "toggle_focus=payments" . $urlBornes);
    $block2->closeToggle();
    $block2->closeForm();
}

if ($fileManagement == "true" && $invoiceDetail->inv_recurring[0] != enumBoolean::bTrue) {
    $block3 = new block();
    $block3->form = "ivF";
    $block3->openForm("../invoices/viewinvoice.php?id=$id" . $urlBornes . "#" . $block3->form . "Anchor");
    $block3->headingToggle(lang_strings("linked_content"), !($toggle_focus=='linked_content'));
    $block3->borne = $blockPage->returnBorne('3');
    $block3->rowsLimit = 12;
    $block3->sorting("invoice_files", isset($sortingUser['invoice_files'])?$sortingUser['invoice_files']:'', 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status'));
    $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtInvoice . "' AND fil.doc_id='$id' AND fil.vc_parent='0' ORDER BY " . $block3->sortingValue;
    $recordsTotal = compt($initrequest['files'] . $querymore);
    $block3->recordsTotal = $recordsTotal;
    $listFiles = new request();
    $listFiles->openFiles($querymore, $block3->borne, $block3->rowsLimit);
    $comptListFiles = count($listFiles->fil_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['owner'];
    $columns[1]->field_type = enumFieldType::ftAvatar;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['created'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['approval_tracking'];
    $columns[3]->field_type = enumFieldType::ftText;
    $opt[enumCardviewOption::oTableName] = 'files';
    $opt[enumCardviewOption::oObject] = 'files';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] = "doc_type=" . enumFileRelatedDocumentType::dtInvoice . "&doc_id=$id" . $urlBornes . '&borne3=' . $block3->borne;

    if ($SW_Permissions['Invoice']['Edit'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = "../linkedcontent/addfile.php?doc_type=" . enumFileRelatedDocumentType::dtInvoice . "&doc_id=$id" . $urlBornes;
    }

    $block3->openCardView($opt);

    for ($i=0; $i<$comptListFiles; $i++) {
        $idStatus = $listFiles->fil_status[$i];
        $content = array(
            $listFiles->fil_name[$i],
            implode(',',
                array(
                    $listFiles->fil_owner[$i],
                    $listFiles->fil_mem_extension_picture[$i],
                    $listFiles->fil_mem_gender[$i])),
            createDate($listFiles->fil_created[$i],'both'),
            $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . enumFileRelatedDocumentType::dtInvoice . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i] . $urlBornes, $statusFile[$idStatus], 'in')
        );
        $block3->itemCardView($listFiles->fil_id[$i], $content);
    }

    $block3->closeCardView();
    $block3->bornesFooter("3", $blockPage->bornesNumber, "id=$id&toggle_focus=linked_content" . $urlBornes);
    $block3->closeToggle();
    $block3->closeFormResults();
}

require_once('../includes/footer.php');
