/* $Revision: 1.0 $
 *
 * $Id: editcalendarevent.js,v 1.6 2013/01/29 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
$(document).ready(function() {
    if ($('#repcnt').length) {
        $('#repcnt').hide();
    }
    $('#rep').change(function() {
        var x = $('#rep').val();

        if (x == '') {
            $('#repcnt').hide();
        } else {
            $('#repcnt').show();
            $('#repetxt').html($('#repeve_'+x).val());
        }
    });
});
/**
 * check form data
 *
 * @param theObj Form object
 * @returns {boolean}
 */
function checkFormData(theObj)
{
    var res = __default_checkformdata(theObj);

    if (res) {
        var cdi = $('#cdI').val();
        var tsi = $('#time_start').val();
        var tei = $('#time_end').val();
        var rep = $('#rep').val();
        var ends = '';
        var eoi = '';

        if (rep != '') {
            ends = ($('#ends2').is(':checked'))?'2':'1';
            eoi = $('#endonI').val();
        }

        $.ajax({url: '../calendar/editcalendarevent_serv.php',
            async: false,
            timeout: 30000,
            type: 'post',
            data: {
                'action': 'checkFormData',
                'cdI': cdi,
                'time_start': tsi,
                'time_end': tei,
                'rep': rep,
                'ends': ends,
                'endonI': eoi
            },
            success: function(json) {
                var te = json.time_end;
                $('#time_endS').html(te);

                if (te === '') {
                    $('#time_end').attr('class', '');
                } else {
                    res = false;
                    $('#time_end').attr('class', 'highlight');
                }

                if (rep != '') {
                    var eo = json.endon;
                    $('#endonIS').html(eo);

                    if (eo === '') {
                        $('#endonI').attr('class', '');
                    } else {
                        res = false;
                        $('#endonI').attr('class', 'highlight');
                    }
                }
            },
            error: function(xhr, desc, err) {
                console.log(xhr);
                console.log("Details: " + desc + "\nError:" + err);
                res = false;
            }
        });
    }

    return res;
}
