/* $Revision: 1.0 $
 *
 * $Id: addextension.js,v 1.6 2013/01/29 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$(document).ready(function() {
    fldtyp_change(0);
});
/**
 * field type changed
 */
function fldtyp_change(mode)
{
    var dbtype = document.cfEForm.dbtype.value;
    var fldtyp = document.cfEForm.fldtyp.value;
    var len = document.cfEForm.len;
    var req = document.cfEForm.req;
    var defval = document.cfEForm.defval;
    var fldfmt = document.cfEForm.fldfmt;
    var vvc = document.cfEForm.vvc;
    var lkt = document.cfEForm.lkt;
    var uni = document.cfEForm.uni;
    var idx = document.cfEForm.idx;
    var pub = document.cfEForm.pub;
    var act = document.cfEForm.action;
    var f = document.getElementById("format" + fldtyp);
    $("dfn").html(f.value);
    $("#lenS").html('');

    // turn highlight off for length & default value
    len.className = '';
    defval.className = '';

    // field length only for text, alpha-numeric, numeric & serial
    if (fldtyp == '0' || fldtyp == '1' || fldtyp == 'A' || fldtyp == 'S') {
        len.readOnly = false;
        // field default length
        if (mode == 1 || act == 'add') {
            switch (fldtyp) {
                case '0':   // text
                case 'A':   // alpha-numeric
                    len.value = '50';
                    break;
                case '1':   // numeric
                case 'S':   // serial
                    len.value = '11';
                    break;
            }
        }
    } else {
        len.readOnly = true;
        len.value = '';
        len.className = 'dim';
    }

    // field valid value only for text, alpha-numeric & numeric
    if (fldtyp != '0' && fldtyp != '1' && fldtyp != 'A') {
        vvc.value = '0';
        $("#vv").html('');
    }

    // memo, image, serial & password cannot have a default value
    if (fldtyp == '2' || fldtyp == '8' || fldtyp == 'S' || fldtyp == 'W') {
        defval.readOnly = true;
        defval.value = '';
        defval.className = 'dim';
    } else {
        defval.readOnly = false;
    }

    if (fldtyp == 'S') {
        // serial is always required
        req.disabled = true;
        req.checked = true;
        // serial format only for a serial
        fldfmt.disabled = false;
        // required field always be published
        if (pub.type == 'checkbox') {
            pub.disabled = true;
            pub.checked = true;
        }
    } else {
        req.disabled = false;
        fldfmt.disabled = true;

        if (pub.type == 'checkbox') {
            pub.disabled = false;
        }
    }

    // only numeric & no valid values can have a linked table
    if (fldtyp == '1' && vvc.value == '0') {
        lkt.disabled = false;
    } else {
        lkt.disabled = true;
        lkt.selectedIndex = 0;
    }

    if (fldtyp == '2' || fldtyp == '8' || fldtyp == '9' || fldtyp == 'W' || (dbtype == 'MySQL' && (fldtyp == 'E' || fldtyp == 'U'))) {
        // memo, image, boolean & password cannot create an index
        // email & url cannot create an index neither if database type is MySQL
        idx.disabled = true;
        idx.checked = false;
        // memo, image, boolean & password cannot be an unique field
        // email & url cannot be an unique field neither if database type is MySQL
        uni.disabled = true;
        uni.checked = false;
    } else if (fldtyp == 'S') {
        // always create an index for serial
        idx.disabled = true;
        idx.checked = true;
        // serial is always an unique field
        uni.disabled = true;
        uni.checked = true;
    } else {
        req_change();
    }
}

/**
 * required field flag changed
 */
function req_change()
{
    var fldtyp = document.cfEForm.fldtyp.value;
    var fdt = document.cfEForm.fdt.value;
    var req = document.cfEForm.req;
    var uni = document.cfEForm.uni;
    var idx = document.cfEForm.idx;
    var pub = document.cfEForm.pub;

    if (req.checked && fldtyp != '2' && fldtyp != '8' && fldtyp != '9' && fldtyp != 'W') {
        if (fdt == 'Y') {
            // form detail field cannot be an unique field
            uni.disabled = true;
            uni.checked = false;
            // active create index
            idx.disabled = false;
        } else {
            uni.disabled = false;
            uni_change();
        }
    } else {
        // non-required field, memo, image, boolean & password cannot create an index
        idx.disabled = true;
        idx.checked = false;
        // non-required field, memo, image, boolean & password cannot be an unique field
        uni.disabled = true;
        uni.checked = false;
    }

    // required field always be published
    if (pub.type == 'checkbox') {
        if (req.checked) {
            pub.disabled = true;
            pub.checked = true;
        } else {
            pub.disabled = false;
        }
    }
}

/**
 * unique field flag changed
 */
function uni_change()
{
    var uni = document.cfEForm.uni;
    var idx = document.cfEForm.idx;

    if (uni.checked) {
        idx.disabled = true;
        idx.checked = true;
    } else {
        idx.disabled = false;
    }
}

/**
 * add a valid value
 */
function morevv()
{
    var fldtyp = document.cfEForm.fldtyp.value;
    // field valid value only for text, alpha-numeric & numeric
    if (fldtyp != '0' && fldtyp != '1' && fldtyp != 'A') {
        return;
    }

    var vvc = document.cfEForm.vvc;
    var v = Number(vvc.value);
    var x = '';

    if (v == 0) {
        var valstr = document.cfEForm.valstr.value;
        var desstr = document.cfEForm.desstr.value;
        x = '<tr><th>' + valstr + '</th><th>' + desstr + '</th><th>&nbsp;</th></tr>';
    }

    x = x + '<tr><td><input type="text" name="valsa' + vvc.value + '" value=""></td>';
    x = x + '<td><input type="text" name="dessa' + vvc.value + '" value=""></td>';
    x = x + '<input type="hidden" name="syssa' + vvc.value + '" value="N">';
    x = x + '<td><a href="javascript:delvv(' + vvc.value + ');" class="delete-link">&#8722;</a></td></tr>';
    $("#vv").append(x);
    vvc.value = String(v + 1);
    // field with valid values cannot have a linked table
    var lkt = document.cfEForm.lkt;
    lkt.disabled = true;
    lkt.selectedIndex = 0;
}

/**
 * delete a valid value
 */
function delvv(idx)
{
    var vvc = document.cfEForm.vvc;
    var v = Number(vvc.value);

    if (v == 1) {
        $("#vv").html('');
        v = 0;
        var fldtyp = document.cfEForm.fldtyp.value;

        // only numeric & no valid values can have a linked table
        if (fldtyp == '1') {
            var lkt = document.cfEForm.lkt;
            lkt.disabled = false;
        }
    } else {
        var valsa = new Array();
        var dessa = new Array();
        var syssa = new Array();

        for (var i=0; i<v; i++) {
            if (Number(i) === Number(idx)) {
                continue;
            }

            var vals = document.cfEForm.elements["valsa" + String(i)];
            var dess = document.cfEForm.elements["dessa" + String(i)];
            var syss = document.cfEForm.elements["syssa" + String(i)];
            valsa.push(vals.value);
            dessa.push(dess.value);
            syssa.push(syss.value);
        }

        v = v - 1;
        var valstr = document.cfEForm.valstr.value;
        var desstr = document.cfEForm.desstr.value;
        var x = '<tr><th>' + valstr + '</th><th>' + desstr + '</th><th>&nbsp;</th></tr>';

        for (var i=0; i<v; i++) {
            x = x + '<tr><td><input type="text" name="valsa' + String(i) + '" value="' + valsa[i] + '" ';

            if (syssa[i] == 'Y') {
                x = x + 'readonly';
            }

            x = x + '></td><td><input type="text" name="dessa' + String(i) + '" value="' + dessa[i] + '"></td>';
            x = x + '<input type="hidden" name="syssa' + String(i) + '" value="' + syssa[i] + '">';

            if (syssa[i] == 'Y') {
                x = x + '<td>&nbsp;</td></tr>';
            } else {
                x = x + '<td><a href="javascript:delvv(' + String(i) + ');" class="delete-link">&#8722;</a></td></tr>';
            }
        }

        $("#vv").html(x);
    }

    vvc.value = String(v);
}

/**
 * check form data
 */
function checkform(theObj, chg)
{
    var res = __default_checkformdata(theObj);

    if (!res) {
        return false;
    }

    var fldtyp = theObj.fldtyp.value;
    var len = theObj.len.value;
    var maxlen = 255;

    if (chg == '0') {
        // check field name
        var fldnam = theObj.fldnam;
        var patt0 = /^[a-z0-9]+$/i;

        if (!fldnam.value.match(patt0)) {
            $("#fldnamS").html(' ' + theObj.invnam.value);
            fldnam.className = 'highlight';
            fldnam.focus();
            return false;
        }
    }

    // check field length (for text, alpha-numeric & numeric)
    switch (fldtyp) {
        case '0':
        case '1':
        case 'A':
            var x = theObj.len;

            if (len == '') {
                var requirede = document.getElementById('__default_requirede');
                $("#lenS").html(' ' + requirede.value);
                x.className = 'highlight';
                x.focus();
                return false;
            } else {
                maxlen = Number(len);

                if (maxlen < 1 || maxlen > 255) {
                    var le = theObj.lenestr;
                    $("#lenS").html(' ' + le.value);
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }
            }

            break;
        case 'S':
            var x = theObj.len;

            if (len == '') {
                var requirede = document.getElementById('__default_requirede');
                $("#lenS").html(' ' + requirede.value);
                x.className = 'highlight';
                x.focus();
                return false;
            } else {
                maxlen = Number(len);
                var fldfmt = theObj.fldfmt.value;
                var minlen = 1;

                switch (fldfmt) {
                    case '1':
                        minlen = 5;
                        break;
                    case '2':
                        minlen = 6;
                        break;
                    case '3':
                    case '4':
                        minlen = 7;
                        break;
                    case '5':
                        minlen = 9;
                        break;
                }

                if (maxlen < minlen || maxlen > 255) {
                    var le = theObj.lenestr.value;
                    var le1 = le.replace('1-255', minlen.toString() + '-255');
                    $("#lenS").html(' ' + le1);
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }
            }

            break;
        default:
            var x = theObj.len;
            x.value = '';
    }

    // check default value
    var x = theObj.defval;

    if (x.value != '') {
        switch (fldtyp) {
            case '0':   // text
                if (x.value.length > maxlen) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }

                break;
            case 'A':   // alpha-numeric
                var patt1 = /^[a-z0-9]+$/i;

                if (!x.value.match(patt1) || x.value.length > maxlen) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }

                break;
            case '1':   // numeric
                var patt1 = /\D/g;

                if (x.value.match(patt1) || x.value.length > maxlen) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }

                break;
            case '3':   // date
                var patt1 = /^(((\d{4})(0\d|10|11|12)([0-2]\d|30|31))|((\+|\-)(\d+))|((\+|\-)(\d+y|)(\d+m|)(\d+w|)(\d+d|)))$/;
                var patt2 = /^(\+|\-)$/;

                if (!x.value.match(patt1) || x.value.match(patt2)) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }

                break;
            case '4':   // time
                var patt1 = /^([01]\d|2[0-3])[0-5]\d$/;

                if (!x.value.match(patt1)) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }

                break;
            case '5':   // hours
            case 'Q':   // quantity
            case 'M':   // measure
            case '6':   // rate
            case '7':   // total
                if (!isFinite(x.value)) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }

                break;
            case 'P':   // percentage
                if (!isFinite(x.value)) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }

                var f = parseFloat(x.value);

                if (f < 0) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }

                break;
            case '9':   // boolean
                var patt1 = /^[01]$/;

                if (!x.value.match(patt1)) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }

                break;
            case 'E':   // email
                var patt1 = /^\s*[\w\-\+_]+(\.[\w\-\+_]+)*\@[\w\-\+_]+\.[\w\-\+_]+(\.[\w\-\+_]+)*\s*$/;

                if (!x.value.match(patt1)) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }

                break;
            case 'U':   // url
                var patt1 = /^(?:([A-Za-z]+):)?(\/{0,3})([0-9.\-A-Za-z]+)(?::(\d+))?(?:\/([^?#]*))?(?:\?([^#]*))?(?:#(.*))?$/;

                if (!x.value.match(patt1)) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                }

                break;
        }
    }

    // check field valid value
    if (fldtyp == '0' || fldtyp == '1' || fldtyp == 'A') {
        var v = Number(theObj.vvc.value);

        if (v != 0) {
            var maxlen = Number(theObj.len.value);
            var valsae = theObj.elements["valsa[]"];
            var valsae1 = new Array();

            for (var i=0; i<valsae.length; i++) {
                var x = valsae[i]
                var patt1 = /\D/g;
                var patt2 = /^[a-z0-9]+$/i;

                if ((x.value.length > maxlen) || (fldtyp == '1' && (x.value == '' || x.value.match(patt1))) || (fldtyp == 'A' && (x.value == '' || !x.value.match(patt2))) || (valsae1.indexOf(x.value) != -1)) {
                    x.className = 'highlight';
                    x.focus();
                    return false;
                } else {
                    valsae1.push(x.value);
                    x.className = '';
                }
            }
        }
    }

    // check if field type changed
    if (chg == '0') {
        return true;
    }

    var oldfldtyp = theObj.oldfldtyp.value;
    var oldlen = theObj.oldlen.value;
    var confirmit = false;

    if (fldtyp == oldfldtyp) {
        var patt1 = /\D/g;

        if (!oldlen.match(patt1) && !len.match(patt1)) {
            if (Number(len) < Number(oldlen))
                confirmit = true;
        }
    } else {
        confirmit = true;
    }

    if (confirmit) {
        var constr = theObj.constr.value;
        return confirm(constr);
    } else {
        return true;
    }
}
