/* $Revision: 1.0 $
 *
 * $Id: editinvoice.js,v 1.6 2013/01/29 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
$(document).ready(function() {
    if ($('#action').val() === 'add') {
        clodchg();
        newinvno();
    } else {
        var x = $('#clod').val();   // client id
        // get project list
        $.ajax({url: '../invoices/editinvoice_serv.php',
            type: 'post',
            data: {'action': 'projectlist', 'id': x},
            success: function(json) {
                $('#proId option').remove();
                $.each(json.options, function(idx) {
                    $('#proId').append($("<option></option>")
                            .attr('value',idx)
                            .text(json.options[idx]));
                });
            }
        });
        updatetotals();
    }
    rtchg();
});
/**
 * get new invoice number
 * @returns {undefined}
 */
function newinvno()
{
    var x = $('#dtI').val();    // invoice date
    $.ajax({url: '../invoices/editinvoice_serv.php',
        type: 'post',
        data: {'action': 'newinvno', 'date': x},
        success: function(json) {
            $('#invno').val(json.invno);
        }
    });
}
/**
 * client changed
 * @returns {undefined}
 */
function clodchg()
{
    var x = $('#clod').val();   // client id

    if (x === '-1') {           // add new client
        document.eInForm.action.value = '';
        document.eInForm.submit();
    } else {
        // get client information
        $.ajax({url: '../invoices/editinvoice_serv.php',
            type: 'post',
            data: {'action': 'client', 'id': x},
            success: function(json) {
                var y = json.currency;

                if (y === '') {     // multi-currency client
                    var z = $('#dfc').val();    // system default currency
                    $('#cu').val(z);
                    $('#cuS').val(z);
                    $('#cuS').prop('disabled', false);
                } else {
                    $('#cu').val(y);
                    $('#cuS').val(y);
                    $('#cuS').prop('disabled', true);
                }

                $('#cwc').val(json.workcalendar);   // client workcalendar
                $('#pym').val(json.payment_method); // payment method
                $('#pyt').val(json.payment_terms);  // payment terms
                var bill2 = tinyMCE.getInstanceById('bill2');   // bill to
                bill2.setContent(json.address);
                var ship2 = tinyMCE.getInstanceById('ship2');   // ship to
                ship2.setContent(json.address);
                chgdd();
            }
        });
        // get project list
        $.ajax({url: '../invoices/editinvoice_serv.php',
            type: 'post',
            data: {'action': 'projectlist', 'id': x},
            success: function(json) {
                $('#proId option').remove();
                $.each(json.options, function(idx) {
                    $('#proId').append($("<option></option>")
                            .attr('value',idx)
                            .text(json.options[idx]));
                });
            }
        });
        // delete all project-specified rows
        var rowids = $('#tbl00rowids').val();   // row id collection
        var rowidsa = rowids.split(',');
        $.each(rowidsa, function(idx, trid) {
            var isnew = (trid.match(/n$/) !== null);
            var pr = $('#' + trid + 'pr').val();
            if (pr !== '' && pr !== '0') {
                delRow('tbl00', trid, isnew);
            }
        });
        updatetotals();
    }
}
/**
 * currency changed
 * @returns {undefined}
 */
function cuchg()
{
    var z = $('#cuS').val();
    $('#cu').val(z);
    var rowids = $('#tbl00rowids').val();   // row id collection
    var rowidsa = rowids.split(',');
    // delete all rows
    $.each(rowidsa, function(idx, trid) {
        var isnew = (trid.match(/n$/) !== null);
        delRow('tbl00', trid, isnew);
    });
    updatetotals();
}
/**
 * get new due date
 * @returns {undefined}
 */
function chgdd()
{
    var x = $('#dtI').val();
    var y = $('#cwc').val();
    var z = $('#pyt').val();
    $.ajax({url: '../invoices/editinvoice_serv.php',
        type: 'post',
        data: {'action': 'duedate', 'dtI': x, 'wc': y, 'pyt': z},
        success: function(json) {
            var w = json.duedate;
            $('#ddI').val(w);
        }
    });
}
/**
 * new invoice row type changed
 * @returns {undefined}
 */
function rtchg()
{
    var x = $('#rowType').val();

    if (x === '') { // empty row
        $('#prot').hide();
        $('#pros').hide();
    } else {
        $('#prot').show();
        $('#pros').show();
    }
}
/**
 * delete invoice row
 * @param {string} tblid
 * @param {string} trid
 * @param {boolean} isnew
 * @returns {undefined}
 */
function delinvrow(tblid,trid,isnew)
{
    delRow(tblid,trid,isnew);
    updatetotals();
}
/**
 * add new invoice row
 * @returns {undefined}
 */
function addinvrow()
{
    var x = $('#rowType').val();

    if (x === '') { // empty row
        var r = addRow('tbl00');
        var pro = $('#' + r + 'pro');
        var pr = $('#' + r + 'pr');
        pro.children('a').remove();
        pr.val('0');
    } else {
        var cu = $('#cu').val();
        var prs = $('#proId').val();
        if (prs === '' || prs === '0') {
            return;     // do nothing if no project selected
        }
        var prn = $('#proId option:selected').text();

        if (x === '1') { // project estimated time
            $.ajax({url: '../invoices/editinvoice_serv.php',
                type: 'post',
                data: {'action': 'estimated', 'id': prs, 'cu': cu},
                success: function(json) {
                    $.each(json.description, function(i, desc) {
                        var r = addRow('tbl00');
                        $('#' + r + 'f00').val(desc);    // description
                        var pro = $('#' + r + 'pro');   // project
                        var pr = $('#' + r + 'pr');
                        pro.children('a').html(prn);
                        pro.children('a').attr("href", "../projects/viewproject.php?id=" + prs);
                        pr.val(prs);
                        $('#' + r + 'f01').val(json.quantity[i]);    // quantity
                        $('#' + r + 'f02').val(json.unit[i]);        // unit
                        $('#' + r + 'f03').val(json.price[i]);       // price
                        qtyprcdispchg(r);
                    });
                }
            });
        } else if (x === '2') { // project actual time
            $.ajax({url: '../invoices/editinvoice_serv.php',
                type: 'post',
                data: {'action': 'actual', 'id': prs, 'cu': cu},
                success: function(json) {
                    $.each(json.description, function(i, desc) {
                        var r = addRow('tbl00');
                        $('#' + r + 'f00').val(desc);    // description
                        var pro = $('#' + r + 'pro');   // project
                        var pr = $('#' + r + 'pr');
                        pro.children('a').html(prn);
                        pro.children('a').attr("href", "../projects/viewproject.php?id=" + prs);
                        pr.val(prs);
                        $('#' + r + 'f01').val(json.quantity[i]);    // quantity
                        $('#' + r + 'f02').val(json.unit[i]);        // unit
                        $('#' + r + 'f03').val(json.price[i]);       // price
                        qtyprcdispchg(r);
                    });
                }
            });
        } else {    // project expenses
            $.ajax({url: '../invoices/editinvoice_serv.php',
                type: 'post',
                data: {'action': 'expense', 'id': prs, 'cu': cu},
                success: function(json) {
                    var r = addRow('tbl00');
                    $('#' + r + 'f00').val(json.description);   // description
                    var pro = $('#' + r + 'pro');   // project
                    var pr = $('#' + r + 'pr');
                    pro.children('a').html(prn);
                    pro.children('a').attr("href", "../projects/viewproject.php?id=" + prs);
                    pr.val(prs);
                    $('#' + r + 'f01').val(json.quantity);      // quantity
                    $('#' + r + 'f03').val(json.price);         // price
                    qtyprcdispchg(r);
                }
            });
        }
    }
}
/**
 * quantity/price/discount(%) changed
 * @param {String} trid
 * @returns {undefined}
 */
function qtyprcdispchg(trid)
{
    var qtys = $('#' + trid + 'f01').val(); // quantity
    var prcs = $('#' + trid + 'f03').val(); // price
    var disps = $('#' + trid + 'f05').val();    // discount %
    var taxgc = $('#taxgc').val();  // tax group count
    var qty = 0;
    var prc = 0;
    var disp = 0;

    if (qtys !== '' && isFinite(qtys)) {
        qty = parseFloat(qtys);
        qty = qty_round(qty);
    }
    if (prcs !== '' && isFinite(prcs)) {
        prc = parseFloat(prcs);
        prc = rate_round(prc);
    }
    if (disps !== '' && isFinite(disps)) {
        disp = parseFloat(disps);
        disp = percent_round(disp);
    }

    var ttl = cost_round(qty * prc);
    var diss = cost_round(ttl * disp / 100);
    $('#' + trid + 'f04').val(diss.toString());    // discount sum
    var taxs = 0;   // tax sum

    for (var i=0; i<taxgc; i++) {
        var rts = $('#' + trid + 'rt' + i.toString()).val();
        var rt = parseFloat(rts);
        var ta = cost_round(ttl * rt /100);
        var j = 8 + 2 * i;
        var k = j.toString();
        if (k.length === 1)
            k = '0' + k;
        $('#' + trid + 'f' + k).val(ta.toString());
        taxs += ta;
    }

    var f06 = ttl + taxs - diss;
    $('#' + trid + 'f06').val(f06.toString());    // line total
    updatetotals();
}
/**
 * discount sum changed
 * @param {String} trid
 * @returns {undefined}
 */
function disschg(trid)
{
    var qtys = $('#' + trid + 'f01').val();     // quantity
    var prcs = $('#' + trid + 'f03').val();     // price
    var disss = $('#' + trid + 'f04').val();    // discount sum
    var taxgc = $('#taxgc').val();  // tax group count
    var qty = 0;
    var prc = 0;
    var diss = 0;

    if (qtys !== '' && isFinite(qtys)) {
        qty = parseFloat(qtys);
        qty = qty_round(qty);
    }
    if (prcs !== '' && isFinite(prcs)) {
        prc = parseFloat(prcs);
        prc = rate_round(prc);
    }
    if (disss !== '' && isFinite(disss)) {
        diss = parseFloat(disss);
        diss = percent_round(diss);
    }

    var ttl = cost_round(qty * prc);
    var disp = percent_round(diss * 100 / ttl);
    $('#' + trid + 'f05').val(disp.toString());    // discount %
    var taxs = 0;   // tax sum

    for (var i=0; i<taxgc; i++) {
        var j = 8 + 2 * i;
        var k = j.toString();
        if (k.length === 1)
            k = '0' + k;
        var ta = $('#' + trid + 'f' + k).val();
        if (ta !== '' && isFinite(ta))
            taxs += parseFloat(ta);
    }

    var f06 = ttl + taxs - diss;
    $('#' + trid + 'f06').val(f06.toString());    // line total
    updatetotals();
}
/**
 * tax code changed
 * @param {String} trid
 * @param {String} i
 * @param {String} f
 * @returns {undefined}
 */
function taxcchg(trid, i, f)
{
    var qtys = $('#' + trid + 'f01').val();     // quantity
    var prcs = $('#' + trid + 'f03').val();     // price
    var ff = parseInt(f) + 1;
    if (f.length === 1)
        f = '0' + f;
    var c = $('#' + trid + 'f' + f).val();      // tax code
    var r = $('#taxg' + i + 'c' + c).val();     // tax rate
    $('#' + trid + 'rt' + i).val(r.toString());
    var qty = 0;
    var prc = 0;

    if (qtys !== '' && isFinite(qtys)) {
        qty = parseFloat(qtys);
        qty = qty_round(qty);
    }
    if (prcs !== '' && isFinite(prcs)) {
        prc = parseFloat(prcs);
        prc = rate_round(prc);
    }

    var ttl = cost_round(qty * prc);
    var ta = cost_round(ttl * r /100);
    f = ff.toString();
    if (f.length === 1)
        f = '0' + f;
    $('#' + trid + 'f' + f).val(ta.toString()); // tax sum
    taxschg(trid);
}
/**
 * tax sum changed
 * @param {String} trid
 * @returns {undefined}
 */
function taxschg(trid)
{
    var qtys = $('#' + trid + 'f01').val();     // quantity
    var prcs = $('#' + trid + 'f03').val();     // price
    var disss = $('#' + trid + 'f04').val();    // discount sum
    var taxgc = $('#taxgc').val();  // tax group count
    var qty = 0;
    var prc = 0;
    var diss = 0;

    if (qtys !== '' && isFinite(qtys)) {
        qty = parseFloat(qtys);
        qty = qty_round(qty);
    }
    if (prcs !== '' && isFinite(prcs)) {
        prc = parseFloat(prcs);
        prc = rate_round(prc);
    }
    if (disss !== '' && isFinite(disss)) {
        diss = parseFloat(disss);
        diss = percent_round(diss);
    }

    var ttl = cost_round(qty * prc);
    var taxs = 0;   // tax sum

    for (var i=0; i<taxgc; i++) {
        var j = 8 + 2 * i;
        var k = j.toString();
        if (k.length === 1)
            k = '0' + k;
        var ta = $('#' + trid + 'f' + k).val();
        if (ta !== '' && isFinite(ta))
            taxs += parseFloat(ta);
    }

    var f06 = ttl + taxs - diss;
    $('#' + trid + 'f06').val(f06.toString());    // line total
    updatetotals();
}
/**
 * line total changed
 * @param {string} trid
 */
function ttlchg(trid)
{
    var qtys = $('#' + trid + 'f01').val();     // quantity
    var prcs = $('#' + trid + 'f03').val();     // price
    var lttls = $('#' + trid + 'f06').val();    // line total
    var taxgc = $('#taxgc').val();      // tax group count
    var qty = 0;
    var prc = 0;
    var lttl = 0;

    if (qtys !== '' && isFinite(qtys)) {
        qty = parseFloat(qtys);
        qty = qty_round(qty);
    }
    if (prcs !== '' && isFinite(prcs)) {
        prc = parseFloat(prcs);
        prc = rate_round(prc);
    }
    if (lttls !== '' && isFinite(lttls)) {
        lttl = parseFloat(lttls);
        lttl = cost_round(lttl);
    }

    var ttl = cost_round(qty * prc);
    var taxs = 0;   // tax sum

    for (var i=0; i<taxgc; i++) {
        var j = 8 + 2 * i;
        var k = j.toString();
        if (k.length === 1)
            k = '0' + k;
        var ta = $('#' + trid + 'f' + k).val();
        if (ta !== '' && isFinite(ta))
            taxs += parseFloat(ta);
    }

    var diss = cost_round(ttl + taxs - lttl);
    $('#' + trid + 'f04').val(diss.toString());    // discount sum
    var disp = percent_round(diss * 100 / ttl);
    $('#' + trid + 'f05').val(disp.toString());    // discount %
    updatetotals();
}
/**
 * update invoice total
 */
function updatetotals()
{
    var taxgc = $('#taxgc').val();          // tax group count
    var rowids = $('#tbl00rowids').val();   // row id collection
    var rowidsa = rowids.split(',');
    var dissum = 0;
    var taxsum = 0;
    var total = 0;
    $.each(rowidsa, function(idx, trid) {
        var lttls = $('#' + trid + 'f06').val();    // line total
        var disss = $('#' + trid + 'f04').val();    // discount sum
        if (lttls !== '' && isFinite(lttls))
            total += parseFloat(lttls);
        if (disss !== '' && isFinite(disss))
            dissum += parseFloat(disss);

        for (var i=0; i<taxgc; i++) {
            var j = 8 + 2 * i;
            var k = j.toString();
            if (k.length === 1)
                k = '0' + k;
            var ta = $('#' + trid + 'f' + k).val();
            if (ta !== '' && isFinite(ta))
                taxsum += parseFloat(ta);
        }
    });
    var subttl = total + dissum - taxsum;
    var disp = 0;
    if (dissum > 0 && subttl > 0)
        disp = percent_round(dissum * 100 / subttl);
    $('#subttlstr').html(subttl.toString());    // display sub-total
    $('#subttl').val(subttl.toString());        // sub-total value
    $('#disstr').html(dissum.toString() + ' (' + disp.toString() + '%)');   // display discount
    $('#dissum').val(dissum.toString());        // discount value
    $('#disperc').val(disp.toString());         // discount percent
    $('#taxstr').html(taxsum.toString());       // display tax
    $('#taxsum').val(taxsum.toString());        // tax value
    var ships = $('#ship').val();               // freight
    var ship = 0;
    if (ships !== '' && isFinite(ships)) {
        ship = parseFloat(ships);
        ship = cost_round(ship);
    }
    var amt = cost_round(total+ship);
    $('#ttlstr').html(amt.toString()); // display invoice total
    $('#amt').val(amt.toString());     // invoice total
}
/**
 * check form data
 *
 * @param theObj Form object
 * @returns {boolean}
 */
function checkformdata(theObj)
{
    var invid = $('#invid').val();      // invoice id
    var invno = $('#invno').val();      // invoice number
    var act = $('#action').val();       // action
    var res = '';

    if (act === 'add') {
        $.ajax({url: '../invoices/editinvoice_serv.php',
            type: 'post',
            async: false,
            timeout: 30000,
            data: {'action': 'checkinvno', 'invid': invid, 'invno': invno},
            success: function(json) {
                res = json.result;
                if (res === 'ok') {
                    $('#invno').attr('class', '');
                    $('#invnoS').html('');
                } else {
                    $('#invno').attr('class', 'highlight');
                    var d = $('#duplicate_entry').val();
                    $('#invnoS').html(d);
                }
            },
            error: function(xhr, desc, err) {
                console.log(xhr);
                console.log("Details: " + desc + "\nError:" + err);
            }
        });
    } else {
        res = 'ok';
    }

    if (res !== 'ok')
        return false;
    return __default_checkformdata(theObj);
}
