/* $Revision: 1.0 $
 *
 * $Id: editleaverequest.js,v 1.6 2013/01/29 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
$(document).ready(function() {
    dateStartChanged();
    dateEndChanged();
    updateTotals();
    getAvailableHours();
});
/**
 * check form data
 * 
 * @param theObj Form object
 * @returns {boolean}
 */
function checkFormData(theObj)
{
    var res = true;
    var a = $('#applicant').val();      // applicant user id
    var t = $('#ty').val();             // leave request type
    var ds = $('#dateStartI').val();    // start date
    var ts = $('#time_start').val();    // start time
    var hs = $('#hours_start').val();   // hours on start
    var de = $('#dateEndI').val();      // end date
    var te = $('#time_end').val();      // end time
    var he = $('#hours_end').val();     // hours on end
    $.ajax({url: '../leaves/editleaverequest_serv.php',
        async: false,
        timeout: 30000,
        type: 'post',
        data: {
            'action': 'checkFormData', 
            'applicant': a, 
            'type': t,
            'dateStartI': ds, 
            'timeStart': ts, 
            'hoursStart': hs, 
            'dateEndI': de, 
            'timeEnd': te, 
            'hoursEnd': he
        },
        success: function(json) {
            var dso = json.dateStart;
            var tso = json.timeStart;
            var hso = json.hoursStart;
            var deo = json.dateEnd;
            var teo = json.timeEnd;
            var heo = json.hoursEnd;
            var to = json.total;
            $('#dateStartIS').html(dso);
            $('#time_startS').html(tso);
            $('#hours_startS').html(hso);
            $('#dateEndIS').html(deo);
            $('#time_endS').html(teo);
            $('#hours_endS').html(heo);
            $('#totalS').html(to);
            
            if (dso === '') {
                $('#dateStartI').attr('class', '');
            } else {
                res = false;
                $('#dateStartI').attr('class', 'highlight');
            }
            
            if (tso === '') {
                $('#time_start').attr('class', '');
            } else {
                res = false;
                $('#time_start').attr('class', 'highlight');
            }
            
            if (hso === '') {
                $('#hours_start').attr('class', '');
            } else {
                res = false;
                $('#hours_start').attr('class', 'highlight');
            }
            
            if (deo === '') {
                $('#dateEndI').attr('class', '');
            } else {
                res = false;
                $('#dateEndI').attr('class', 'highlight');
            }
            
            if (teo === '') {
                $('#time_end').attr('class', '');
            } else {
                res = false;
                $('#time_end').attr('class', 'highlight');
            }
            
            if (heo === '') {
                $('#hours_end').attr('class', '');
            } else {
                res = false;
                $('#hours_end').attr('class', 'highlight');
            }
            
            if (to !== '') {
                res = false;
            }
        },
        error: function(xhr, desc, err) {
            console.log(xhr);
            console.log("Details: " + desc + "\nError:" + err);
            res = false;
        }
    });

    if (res) {
        return __default_checkformdata(theObj);
    } else {
        return false;
    }
}
/**
 * get available hours for the specified leave type
 */
function getAvailableHours()
{
    var a = $('#applicant').val();  // applicant user id
    var t = $('#ty').val();         // leave request type
    var e = $('#dateEndI').val();   // end date
    $.ajax({url: '../leaves/editleaverequest_serv.php',
        type: 'post',
        data: {'action': 'availableHours', 'applicant': a, 'type': t, 'end': e},
        success: function(json) {
            var av = json.available;
            $('#available').html(av);
        }
    });
}
/**
 * get standard work hours, start time & end time of start date
 */
function dateStartChanged()
{
    var a = $('#applicant').val();  // applicant user id
    var x = $('#dateStartI').val(); // start date
    $.ajax({url: '../leaves/editleaverequest_serv.php',
        type: 'post',
        data: {'action': 'workcalendarInfo', 'applicant': a, 'date': x},
        success: function(json) {
            var h = json.hourInfo;
            var t = json.timeInfo;
            $('#time_startS + i').html(t);
            $('#hours_startS + i').html(h);
            updateTotals();
        }
    });
}
/**
 * get standard work hours, start time & end time of end date
 */
function dateEndChanged()
{
    var a = $('#applicant').val();  // applicant user id
    var x = $('#dateEndI').val();   // end date
    $.ajax({url: '../leaves/editleaverequest_serv.php',
        type: 'post',
        data: {'action': 'workcalendarInfo', 'applicant': a, 'date': x},
        success: function(json) {
            var h = json.hourInfo;
            var t = json.timeInfo;
            $('#time_endS + i').html(t);
            $('#hours_endS + i').html(h);
            updateTotals();
        }
    });
}
/**
 * hours on start date changed
 */
function hoursStartChanged()
{
    var ds = $('#dateStartI').val();    // start date
    var hs = $('#hours_start').val();   // hours on start
    var de = $('#dateEndI').val();      // end date
    
    if (ds === de) {
        $('#hours_end').val(hs);        // hours on end
    }
    
    updateTotals();
}
/**
 * hours on end date changed
 */
function hoursEndChanged()
{
    var ds = $('#dateStartI').val();    // start date
    var de = $('#dateEndI').val();      // end date
    var he = $('#hours_end').val();     // hours on end
    
    if (ds === de) {
        $('#hours_start').val(he);      // hours on start
    }
    
    updateTotals();
}
/**
 * update day details & total hours
 */
function updateTotals()
{
    var a = $('#applicant').val();      // applicant user id
    var t = $('#ty').val();             // leave request type
    var ds = $('#dateStartI').val();    // start date
    var ts = $('#time_start').val();    // start time
    var hs = $('#hours_start').val();   // hours on start
    var de = $('#dateEndI').val();      // end date
    var te = $('#time_end').val();      // end time
    var he = $('#hours_end').val();     // hours on end
    $.ajax({url: '../leaves/editleaverequest_serv.php',
        type: 'post',
        data: {
            'action': 'summary', 
            'applicant': a,
            'type': t,
            'dateStartI': ds, 
            'timeStart': ts, 
            'hoursStart': hs, 
            'dateEndI': de, 
            'timeEnd': te, 
            'hoursEnd': he
        },
        success: function(json) {
            var d = json.dayDetails;
            var t = json.total;
            $('#dayDetails').html(d);
            $('#total').html(t);
        }
    });
}