/* $Revision: 1.0 $
 *
 * $Id: editmeetingtime.js,v 1.6 2013/01/29 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
$(document).ready(function() {
    getMeetingInfo();
});
/**
 * get meeting list
 */
function getMeetingList() {
    var p = $('#prj').val();                // project id
    var s = $('#dateStartPeriod').val();    // period start date
    var e = $('#dateEndPeriod').val();      // period end date
    $.ajax({url: '../timesheet/editmeetingtime_serv.php',
        type: 'post',
        data: {'action': 'meetingList', 'project': p, 'dateStart': s, 'dateEnd': e},
        success: function(json) {
            $('#mee option').remove();
            $.each(json.options, function(idx) {
                $('#mee').append($("<option></option>")
                        .attr('value',idx)
                        .text(json.options[idx]));
            });
            $('#mee').val(json.meeting);
            $('#startTime').html(json.startTime);
            $('#duration').html(json.duration);
            
            if ($('#hours').val() === '' && json.duration !== '') {
                $('#hours').val(json.duration);
            }
        }
    });
}
/**
 * get meeting start time & duration
 */
function getMeetingInfo() {
    var m = $('#mee').val();     // meeting id
    $.ajax({url: '../timesheet/editmeetingtime_serv.php',
        type: 'post',
        data: {'action': 'meetingInfo', 'meeting': m},
        success: function(json) {
            $('#startTime').html(json.startTime);
            $('#duration').html(json.duration);
            
            if ($('#hours').val() === '' && json.duration !== '') {
                $('#hours').val(json.duration);
            }
        }
    });
}
/**
 * check form data
 * 
 * @param theObj Form object
 * @returns {boolean}
 */
function checkFormData(theObj) {
    var res = true;
    var h = $('#hours').val();      // hours
    $.ajax({url: '../timesheet/editmeetingtime_serv.php',
        async: false,
        timeout: 30000,
        type: 'post',
        data: {
            'action': 'checkFormData', 
            'hours': h
        },
        success: function(json) {
            var e = json.error;
            $('#hoursS').html(' ' + e);
            
            if (e === '') {
                $('#hours').attr('class', '');
            } else {
                res = false;
                $('#hours').attr('class', 'highlight');
            }
        },
        error: function(xhr, desc, err) {
            console.log(xhr);
            console.log("Details: " + desc + "\nError:" + err);
            res = false;
        }
    });

    if (res) {
        return __default_checkformdata(theObj);
    } else {
        return false;
    }
}