/* $Revision: 1.0 $
 *
 * $Id: edituser.js,v 1.6 2013/01/29 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
$(document).ready(function() {
    locationChanged();
});
function fullNameChanged() {
    var f = $('#fn').val();
    $('#cn').val('cn=' + f);
}
function userProfileChanged() {
    var u = $('#perm').val();
    // get user profile default values
    $.ajax({url: '../users/edituser_serv.php',
        type: 'post',
        data: {'action': 'userProfileDefaults', 'userProfile': u},
        success: function(json) {
            if (json.department !== '0') {
                $('#dep').val(json.department);
            }
            if (json.location !== '0') {
                $('#loc').val(json.location);
                $('#tz').html(json.timezone);
            }
            if (json.language !== '') {
                $('#la').val(json.language);
            }
            if (json.dateFormat !== '') {
                $('#dtft').val(json.dateFormat);
            }
            if (json.timeFormat !== '') {
                $('#tmft').val(json.timeFormat);
            }
            if (json.workcalendar !== '0') {
                $('#wc').val(json.workcalendar);
            }
            if (($('#eft').length) && (json.enableFlextime === '1')) {
                $('#eft').prop('checked', true);
            }
        }
    });
}
function departmentChanged() {
    var d = $('#dep').val();
    
    if (d === '-1') {
        $('#action').val('');
        $("form[name='uAEForm']").submit();
    } else if (d !== '0') {
        $.ajax({url: '../users/edituser_serv.php',
            type: 'post',
            data: {'action': 'departmentDefaults', 'department': d},
            success: function(json) {
                if (json.location !== '0') {
                    $('#loc').val(json.location);
                    $('#tz').html(json.timezone);
                }
                if (json.language !== '') {
                    $('#la').val(json.language);
                }
            }
        });
    }
}
function locationChanged() {
    var l = $('#loc').val();
    
    if (l === '-1') {
        $('#action').val('');
        $("form[name='uAEForm']").submit();
    } else {
        $.ajax({url: '../users/edituser_serv.php',
            type: 'post',
            data: {'action': 'locationDefaults', 'location': l},
            success: function(json) {
                $('#tz').html(json.timezone);
                
                if (json.language !== '') {
                    $('#la').val(json.language);
                }
            }
        });
    }
}
function passwordChanged() {
    var strength = document.getElementById('strength');
    var strongRegex = new RegExp("^(?=.{8,})(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])(?=.*\\W).*$", "g");
    var mediumRegex = new RegExp("^(?=.{7,})(((?=.*[A-Z])(?=.*[a-z]))|((?=.*[A-Z])(?=.*[0-9]))|((?=.*[a-z])(?=.*[0-9]))).*$", "g");
    var enoughRegex = new RegExp("(?=.{6,}).*", "g");
    var pwd = document.getElementById("pw");
    var pass1 = document.getElementById("pass1");

    if (pwd.value.length === 0) {
        // new password empty
        var y = document.getElementById('action');
        
        if (y.value === 'add') {
            var x = document.getElementById('txt0');
            strength.innerHTML = x.value;
            pass1.value = '';
        } else {
            strength.innerHTML = '';
            pass1.value = 'Y';
        }
    } else if (!enoughRegex.test(pwd.value)) {
        // new password length too short
        var x = document.getElementById('txt1');
        strength.innerHTML = x.value;
        pass1.value = '';
    } else if (strongRegex.test(pwd.value)) {
        // new password strength passed
        var x = document.getElementById('txt4');
        strength.innerHTML = '<span style="color:green">' + x.value + '</span>';
        pass1.value = 'Y';
    } else if (mediumRegex.test(pwd.value)) {
        // new password strength medium
        var x = document.getElementById('txt3');
        strength.innerHTML = '<span style="color:orange">' + x.value + '</span>';
        pass1.value = 'Y';
    } else {
        // new password strength weak
        var x = document.getElementById('txt2');
        strength.innerHTML = '<span style="color:red">' + x.value + '</span>';
        pass1.value = '';
    }
}
function confirmChanged() {
    var npw = document.getElementById("pw");
    var pwa = document.getElementById("pwa");
    var match = document.getElementById("match");
    var pass2 = document.getElementById("pass2");
    
    if (npw.value === pwa.value) {
        match.innerHTML = '';
        pass2.value = 'Y';
    } else {
        var x = document.getElementById('txt5');
        match.innerHTML = x.value;
        pass2.value = '';
    }
}
function saveClicked() {
    var pass1 = document.getElementById("pass1");
    var pass2 = document.getElementById("pass2");
    
    if (pass1.value === 'Y' && pass2.value === 'Y') {
        return true;
    } else {
        return false;
    }
}
