/* $Revision: 1.6 $
 *
 * $Id: form-control.js,v 1.6 2013/01/29 08:46:24 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/*
 * Add a new row to form details
 *
 * @param string tblid Table id
 */
function addRow(tblid) {
    var x = $('#' + tblid + 'newrow').val();
    var y = $('#' + tblid + 'newscript').val();
    var z = $('#' + tblid + 'nrc').val();
    // add row id into row id collection string
    var rowids = $('#' + tblid + 'rowids').val();
    
    if (rowids !== '') {
        rowids = rowids + ',';
    }
    
    // new row id
    var rowid = tblid + 'r' + z + 'n';
    rowids = rowids + rowid;
    $('#' + tblid + 'rowids').val(rowids);
    // prepare new row html content & javascript
    x = x.replace(/\*\*/g, z);
    y = y.replace(/\*\*/g, z);
    // insert new row html content
    $('#' + tblid).append(x);
    // update default fields check variables
    var w = y.split('++');

    for (var v=0; v<w.length; v++) {
        var u = w[v].split('=');

        switch (u[0]) {
            case 'required':    // required field
                var t = u[1].split(',');
                var r = $('#' + '__default_requiredl').val();
                var s = $('#' + '__default_reqtypel').val();

                if (r !== '') {
                    r = r + ',';
                    s = s + ',';
                }

                r = r + t[0];
                s = s + t[1];
                $('#' + '__default_requiredl').val(r);
                $('#' + '__default_reqtypel').val(s);
                break;
            case 'alphanum':    // alpha-numeric field
                var r = $('#' + '__default_alphanuml').val();
                
                if (r != '') {
                    r = r + ',';
                }
                
                r = r + u[1];
                $('#' + '__default_alphanuml').val(r);
                break;
            case 'numeric':     // numeric field
                var r = $('#' + '__default_numericl').val();
                
                if (r != '') {
                    r = r + ',';
                }
                
                r = r + u[1];
                $('#' + '__default_numericl').val(r);
                break;
            case 'time':        // time field
                var r = $('#' + '__default_timel').val();
                
                if (r != '') {
                    r = r + ',';
                }
                
                r = r + u[1];
                $('#' + '__default_timel').val(r);
                break;
            case 'float':       // float field
                var r = $('#' + '__default_floatl').val();
                
                if (r != '') {
                    r = r + ',';
                }
                
                r = r + u[1];
                $('#' + '__default_floatl').val(r);
                break;
            case 'email':       // email field
                var r = $('#' + '__default_emaill').val();
                
                if (r != '') {
                    r = r + ',';
                }
                
                r = r + u[1];
                $('#' + '__default_emaill').val(r);
                break;
            case 'url':         // url field
                var r = $('#' + '__default_urll').val();
                
                if (r != '') {
                    r = r + ',';
                }
                
                r = r + u[1];
                $('#' + '__default_urll').val(r);
                break;
            case 'pnum':        // positive number field
                var r = $('#' + '__default_pnuml').val();
                
                if (r != '') {
                    r = r + ',';
                }
                
                r = r + u[1];
                $('#' + '__default_pnuml').val(r);
                break;
            case 'nnnum':        // non-negative number field
                var r = $('#' + '__default_nnnuml').val();
                
                if (r != '') {
                    r = r + ',';
                }
                
                r = r + u[1];
                $('#' + '__default_nnnuml').val(r);
                break;
        }
    }

    var i = parseInt(z) + 1;
    $('#' + tblid + 'nrc').val(i);
    return rowid;
}

/*
 * Delete a row from form details
 *
 * @param string tblid Table id
 * @param string trid Table row id
 * @param boolean isnew New row
 */
function delRow(tblid,trid,isnew) {
    if (!isnew) {
        // delete a old row
        var delval = $('#' + tblid + 'del').val();
        if (delval != '')
            delval = delval + ',';
        delval = delval + trid;
        $('#' + tblid + 'del').val(delval);
    }

    // remove row id from row id collection string
    var rowids = $('#' + tblid + 'rowids').val();
    var rowidsa = rowids.split(',');
    var w1 = $.inArray(trid, rowidsa);
    rowidsa.splice(w1, 1);

    if (rowidsa.length == 0) {
        $('#' + tblid + 'rowids').val('');
    } else {
        $('#' + tblid + 'rowids').val(rowidsa.join());
    }

    // update default fields check variables
    var x = document.getElementById(tblid + 'fc');
    var y = parseInt(x.value);
    var requiredl = document.getElementById('__default_requiredl');
    var reqtypel = document.getElementById('__default_reqtypel');
    var alphanuml = document.getElementById('__default_alphanuml');
    var numericl = document.getElementById('__default_numericl');
    var floatl = document.getElementById('__default_floatl');
    var timel = document.getElementById('__default_timel');
    var emaill = document.getElementById('__default_emaill');
    var urll = document.getElementById('__default_urll');
    var pnuml = document.getElementById('__default_pnuml');
    var nnnuml = document.getElementById('__default_nnnuml');
    var requirea = new Array();
    var reqtypea = new Array();
    var alphanuma = new Array();
    var numerica = new Array();
    var floata = new Array();
    var timea = new Array();
    var emaila = new Array();
    var urla = new Array();
    var pnuma = new Array();
    var nnnuma = new Array();

    if (requiredl != null && requiredl.value != '') {
        requirea = requiredl.value.split(',');
        reqtypea = reqtypel.value.split(',');
    }

    if (alphanuml != null && alphanuml.value != '') {
        alphanuma = alphanuml.value.split(',');
    }
    
    if (numericl != null && numericl.value != '') {
        numerica = numericl.value.split(',');
    }
    
    if (floatl != null && floatl.value != '') {
        floata = floatl.value.split(',');
    }
    
    if (timel != null && timel.value != '') {
        timea = timel.value.split(',');
    }
    
    if (emaill != null && emaill.value != '') {
        emaila = emaill.value.split(',');
    }
    
    if (urll != null && urll.value != '') {
        urla = urll.value.split(',');
    }
    
    if (pnuml != null && pnuml.value != '') {
        pnuma = pnuml.value.split(',');
    }
    
    if (nnnuml != null && nnnuml.value != '') {
        nnnuma = nnnuml.value.split(',');
    }

    for (var i=0; i<y; i++) {
        var j = '' + i;
        
        if (j.length == 1) {
            j = '0' + j;
        }
        
        var z = trid + 'f' + j;
        var w =$.inArray(z, requirea);

        if (w > -1) {
            requirea.splice(w, 1);
            reqtypea.splice(w, 1);
        }

        w = $.inArray(z, alphanuma);
        
        if (w > -1) {
            alphanuma.splice(w, 1);
        }
        
        w = $.inArray(z, numerica);
        
        if (w > -1) {
            numerica.splice(w, 1);
        }
        
        w = $.inArray(z, floata);
        
        if (w > -1) {
            floata.splice(w, 1);
        }
        
        w = $.inArray(z, timea);
        
        if (w > -1) {
            timea.splice(w, 1);
        }
        
        w = $.inArray(z, emaila);
        
        if (w > -1) {
            emaila.splice(w, 1);
        }
        
        w = $.inArray(z, urla);
        
        if (w > -1) {
            urla.splice(w, 1);
        }
        
        w = $.inArray(z, pnuma);
        
        if (w > -1) {
            pnuma.splice(w, 1);
        }
        
        w = $.inArray(z, nnnuma);
        
        if (w > -1) {
            nnnuma.splice(w, 1);
        }
    }

    if (requiredl != null) {
        if (requirea.length == 0) {
            requiredl.value = '';
            reqtypel.value = '';
        } else {
            requiredl.value = requirea.join();
            reqtypel.value = reqtypea.join();
        }
    }

    if (alphanuml != null) {
        if (alphanuma.length == 0) {
            alphanuml.value = '';
        } else {
            alphanuml.value = alphanuma.join();
        }
    }

    if (numericl != null) {
        if (numerica.length == 0) {
            numericl.value = '';
        } else {
            numericl.value = numerica.join();
        }
    }

    if (floatl != null) {
        if (floata.length == 0) {
            floatl.value = '';
        } else {
            floatl.value = floata.join();
        }
    }

    if (timel != null) {
        if (timea.length == 0) {
            timel.value = '';
        } else {
            timel.value = timea.join();
        }
    }

    if (emaill != null) {
        if (emaila.length == 0) {
            emaill.value = '';
        } else {
            emaill.value = emaila.join();
        }
    }

    if (urll != null) {
        if (urla.length == 0) {
            urll.value = '';
        } else {
            urll.value = urla.join();
        }
    }
    
    if (pnuml != null) {
        if (pnuma.length == 0) {
            pnuml.value = '';
        } else {
            pnuml.value = pnuma.join();
        }
    }
    
    if (nnnuml != null) {
        if (nnnuma.length == 0) {
            nnnuml.value = '';
        } else {
            nnnuml.value = nnnuma.join();
        }
    }

    // remove this row
    $('#' + trid).remove();
}

/*
 * Default required fields check function
 *
 * @param object theObj Form object
 */
function __default_checkrequired(theObj) {
    var requiredl = document.getElementById('__default_requiredl');
    var reqtypel = document.getElementById('__default_reqtypel');
    var res = true;

    if (requiredl !== null && requiredl.value !== '') {
        var requirede = document.getElementById('__default_requirede');
        var requirea = requiredl.value.split(',');
        var reqtypea = reqtypel.value.split(',');

        for (var i=0; i<requirea.length; i++) {
            if (reqtypea[i] === '8') {   // image
                var x = document.getElementById('Idx' + requirea[i]);
                var y = document.getElementById('atttmp' + x.value);
                var w = document.getElementById(requirea[i] + 'S');

                if (y.value === '') {
                    w.innerHTML = ' ' + requirede.value;
                    res = false;
                } else {
                    w.innerHTML = '';
                }
            } else {
                var x = document.getElementById(requirea[i]);
                
                if (x === null || x.form.name !== theObj.name) {
                    continue;
                }
                
                var y = x.className;
                var w = document.getElementById(requirea[i] + 'S');

                if (x.value === '') {
                    w.innerHTML = ' ' + requirede.value;

                    if (y === '') {
                        x.className = 'highlight';
                    }

                    if (res) {
                        x.focus();
                    }

                    res = false;
                } else {
                    w.innerHTML = '';

                    if (y !== '') {
                        x.className = '';
                    }
                }
            }
        }
    }

    return res;
}

/*
 * Default alpha-numeric fields check function
 *
 * @param object theObj Form object
 */
function __default_checkalphanum(theObj) {
    var alphanuml = document.getElementById('__default_alphanuml');
    var res = true;

    if (alphanuml != null && alphanuml.value != '') {
        var alphanume = document.getElementById('__default_alphanume');
        var alphanuma = alphanuml.value.split(',');

        for (var i=0; i<alphanuma.length; i++) {
            var x = document.getElementById(alphanuma[i]);
            
            if (x == null || x.form.name != theObj.name) {
                continue;
            }
            
            var y = x.className;
            var w = document.getElementById(alphanuma[i] + 'S');
            var patt1 = /^[a-z0-9_\-\.]+$/i;

            if (x.value !== '' && !x.value.match(patt1)) {
                w.innerHTML = ' ' + alphanume.value;
                
                if (y === '') {
                    x.className = 'highlight';
                }
                
                if (res) {
                    x.focus();
                }
                
                res = false;
            } else {
                w.innerHTML = '';
                
                if (y !== '') {
                    x.className = '';
                }
            }
        }
    }

    return res;
}

/*
 * Default numeric fields check function
 *
 * @param object theObj Form object
 */
function __default_checknumeric(theObj) {
    var numericl = document.getElementById('__default_numericl');
    var res = true;

    if (numericl != null && numericl.value != '') {
        var numerice = document.getElementById('__default_numerice');
        var numerica = numericl.value.split(',');

        for (var i=0; i<numerica.length; i++) {
            var x = document.getElementById(numerica[i]);
            
            if (x == null || x.form.name != theObj.name) {
                continue;
            }
            
            var y = x.className;
            var w = document.getElementById(numerica[i] + 'S');
            var patt1 = /\D/g;

            if (x.value != '' && x.value.match(patt1)) {
                w.innerHTML = ' ' + numerice.value;
                
                if (y === '') {
                    x.className = 'highlight';
                }
                
                if (res) {
                    x.focus();
                }
                
                res = false;
            } else {
                w.innerHTML = '';
                
                if (y !== '') {
                    x.className = '';
                }
            }
        }
    }

    return res;
}

/*
 * Default float fields check function
 *
 * @param object theObj Form object
 */
function __default_checkfloat(theObj) {
    var floatl = document.getElementById('__default_floatl');
    var res = true;

    if (floatl != null && floatl.value != '') {
        var floate = document.getElementById('__default_floate');
        var floata = floatl.value.split(',');

        for (var i=0; i<floata.length; i++) {
            var x = document.getElementById(floata[i]);
            
            if (x == null || x.form.name != theObj.name) {
                continue;
            }
            
            var y = x.className;
            var w = document.getElementById(floata[i] + 'S');

            if (x.value != '' && !isFinite(x.value)) {
                w.innerHTML = ' ' + floate.value;
                
                if (y === '') {
                    x.className = 'highlight';
                }
                
                if (res) {
                    x.focus();
                }
                
                res = false;
            } else {
                w.innerHTML = '';
                
                if (y !== '') {
                    x.className = '';
                }
            }
        }
    }

    return res;
}

/*
 * Default time fields check function
 *
 * @param object theObj Form object
 */
function __default_checktime(theObj) {
    var timel = document.getElementById('__default_timel');
    var res = true;

    if (timel != null && timel.value != '') {
        var timee = document.getElementById('__default_timee');
        var timef = document.getElementById('__default_timef');
        var timea = timel.value.split(',');

        for (var i=0; i<timea.length; i++) {
            var x = document.getElementById(timea[i]);
            
            if (x == null || x.form.name != theObj.name) {
                continue;
            }
            
            var y = x.className;
            var w = document.getElementById(timea[i] + 'S');
            var patt1;

            if (timef.value === '24H') {
                patt1 = /^([01]?[0-9]|2[0-3]):[0-5][0-9]$/;
            } else {
                patt1 = /^((AM|PM)(\s|)|)(0?[1-9]|1[012]):[0-5][0-9]$/i;;
            }

            if (x.value !== '' && !x.value.match(patt1)) {
                w.innerHTML = ' ' + timee.value;
                
                if (y === '') {
                    x.className = 'highlight';
                }
                
                if (res) {
                    x.focus();
                }
                
                res = false;
            } else {
                w.innerHTML = '';
                
                if (y !== '') {
                    x.className = '';
                }
            }
        }
    }

    return res;
}

/*
 * Default mail fields check function
 *
 * @param object theObj Form object
 */
function __default_checkemail(theObj) {
    var emaill = document.getElementById('__default_emaill');
    var res = true;

    if (emaill !== null && emaill.value !== '') {
        var emaile = document.getElementById('__default_emaile');
        var emaila = emaill.value.split(',');

        for (var i=0; i<emaila.length; i++) {
            var x = document.getElementById(emaila[i]);
            
            if (x === null || x.form.name !== theObj.name) {
                continue;
            }
            
            var y = x.className;
            var w = document.getElementById(emaila[i] + 'S');
            var patt1 = /^\s*[\w\-\+_]+(\.[\w\-\+_]+)*\@[\w\-\+_]+\.[\w\-\+_]+(\.[\w\-\+_]+)*\s*$/;

            if (x.value !== '' && !x.value.match(patt1)) {
                w.innerHTML = ' ' + emaile.value;
                
                if (y === '') {
                    x.className = 'highlight';
                }
                
                if (res) {
                    x.focus();
                }
                
                res = false;
            } else {
                w.innerHTML = '';
                
                if (y !== '') {
                    x.className = '';
                }
            }
        }
    }

    return res;
}

/*
 * Default url fields check function
 *
 * @param object theObj Form object
 */
function __default_checkurl(theObj) {
    var urll = document.getElementById('__default_urll');
    var res = true;

    if (urll !== null && urll.value !== '') {
        var urle = document.getElementById('__default_urle');
        var urla = urll.value.split(',');

        for (var i=0; i<urla.length; i++) {
            var x = document.getElementById(urla[i]);
            
            if (x === null || x.form.name !== theObj.name) {
                continue;
            }
            
            var y = x.className;
            var w = document.getElementById(urla[i] + 'S');
            var patt1 = /^(?:([A-Za-z]+):)?(\/{0,3})([0-9.\-A-Za-z]+)(?::(\d+))?(?:\/([^?#]*))?(?:\?([^#]*))?(?:#(.*))?$/;

            if (x.value !== '' && !x.value.match(patt1)) {
                w.innerHTML = ' ' + urle.value;
                
                if (y === '') {
                    x.className = 'highlight';
                }
                
                if (res) {
                    x.focus();
                }
                
                res = false;
            } else {
                w.innerHTML = '';
                
                if (y !== '') {
                    x.className = '';
                }
            }
        }
    }

    return res;
}

/*
 * Default positive numeric fields check function
 *
 * @param object theObj Form object
 */
function __default_checkpnum(theObj) {
    var pnuml = document.getElementById('__default_pnuml');
    var res = true;

    if (pnuml !== null && pnuml.value !== '') {
        var pnume = document.getElementById('__default_pnume');
        var pnuma = pnuml.value.split(',');

        for (var i=0; i<pnuma.length; i++) {
            var x = document.getElementById(pnuma[i]);
            
            if (x === null || x.form.name !== theObj.name) {
                continue;
            }
            
            var y = x.className;
            var w = document.getElementById(pnuma[i] + 'S');

            if (x.value !== '' && (!isFinite(x.value) || parseFloat(x.value) <= 0)) {
                w.innerHTML = ' ' + pnume.value;
                
                if (y === '') {
                    x.className = 'highlight';
                }
                
                if (res) {
                    x.focus();
                }
                
                res = false;
            } else {
                w.innerHTML = '';
                
                if (y !== '') {
                    x.className = '';
                }
            }
        }
    }

    return res;
}

/*
 * Default non-negative numeric fields check function
 *
 * @param object theObj Form object
 */
function __default_checknnnum(theObj) {
    var nnnuml = document.getElementById('__default_nnnuml');
    var res = true;

    if (nnnuml !== null && nnnuml.value !== '') {
        var nnnume = document.getElementById('__default_nnnume');
        var nnnuma = nnnuml.value.split(',');

        for (var i=0; i<nnnuma.length; i++) {
            var x = document.getElementById(nnnuma[i]);
            
            if (x === null || x.form.name !== theObj.name) {
                continue;
            }
            
            var y = x.className;
            var w = document.getElementById(nnnuma[i] + 'S');

            if (x.value !== '' && (!isFinite(x.value) || parseFloat(x.value) < 0)) {
                w.innerHTML = ' ' + nnnume.value;
                
                if (y === '') {
                    x.className = 'highlight';
                }
                
                if (res) {
                    x.focus();
                }
                
                res = false;
            } else {
                w.innerHTML = '';
                
                if (y !== '') {
                    x.className = '';
                }
            }
        }
    }

    return res;
}


/*
 * Default version number fields check function
 *
 * @param object theObj Form object
 */
function __default_checkvernum(theObj) {
    var vernuml = document.getElementById('__default_vernuml');
    var res = true;

    if (vernuml !== null && vernuml.value !== '') {
        var vernume = document.getElementById('__default_vernume');
        var vernuma = vernuml.value.split(',');

        for (var i=0; i<vernuma.length; i++) {
            var x = document.getElementById(vernuma[i]);
            
            if (x === null || x.form.name !== theObj.name) {
                continue;
            }
            
            var y = x.className;
            var w = document.getElementById(vernuma[i] + 'S');
            var patt1 = /^(\d+\.)?(\d+)$/;

            if (x.value !== '' && !x.value.match(patt1)) {
                w.innerHTML = ' ' + vernume.value;
                
                if (y === '') {
                    x.className = 'highlight';
                }
                
                if (res) {
                    x.focus();
                }
                
                res = false;
            } else {
                w.innerHTML = '';
                
                if (y !== '') {
                    x.className = '';
                }
            }
        }
    }

    return res;
}

/*
 * Default form data check function
 *
 * @param object theObj Form object
 */
function __default_checkformdata(theObj) {
    var res = true;
    
    if (typeof __default_checkrequired==='function') {
        res = __default_checkrequired(theObj);
    }
    
    if (res && typeof __default_checkalphanum==='function') {
        res = __default_checkalphanum(theObj);
    }
    
    if (res && typeof __default_checknumeric==='function') {
        res = __default_checknumeric(theObj);
    }
    
    if (res && typeof __default_checkfloat==='function') {
        res = __default_checkfloat(theObj);
    }
    
    if (res && typeof __default_checktime==='function') {
        res = __default_checktime(theObj);
    }
    
    if (res && typeof __default_checkemail==='function') {
        res = __default_checkemail(theObj);
    }
    
    if (res && typeof __default_checkurl==='function') {
        res = __default_checkurl(theObj);
    }
    
    if (res && typeof __default_checkpnum==='function') {
        res = __default_checkpnum(theObj);
    }
    
    if (res && typeof __default_checknnnum==='function') {
        res = __default_checknnnum(theObj);
    }
    
    if (res && typeof __default_checkvernum==='function') {
        res = __default_checkvernum(theObj);
    }
    
    if (res && typeof onBeforeSubmit==='function') {
        res = onBeforeSubmit(theObj);
    }
    
    return res;
}

/**
 * Quantity Rounding
 * @param {Number} q quantity
 * @returns {Number}
 */
function qty_round(q) {
    var a = $('#__qty_accuracy').val();
    var rc = Math.round(q * Math.pow(10, a)) / Math.pow(10, a);
    return rc;
}

/**
 * Rate Rounding
 * @param {Number} r rate
 * @returns {Number}
 */
function rate_round(r) {
    var a = $('#__rate_accuracy').val();
    var rc = Math.round(r * Math.pow(10, a)) / Math.pow(10, a);
    return rc;
}

/**
 * Cost Rounding
 * @param {Number} c cost
 * @returns {Number}
 */
function cost_round(c) {
    var a = $('#__cost_accuracy').val();
    var rc = Math.round(c * Math.pow(10, a)) / Math.pow(10, a);
    return rc;
}

/**
 * Percent Rounding
 * @param {Number} p percent
 * @returns {Number}
 */
function percent_round(p) {
    var a = $('#__percent_accuracy').val();
    var rc = Math.round(p * Math.pow(10, a)) / Math.pow(10, a);
    return rc;
}