<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteleaverequests.php,v 1.13 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$ids = "'" . str_replace('**', "','", $id) . "'";
$fyear = isset($_GET['fyear'])?$_GET['fyear']:'';
$serialno = isset($_GET['serialno'])?$_GET['serialno']:'';
$sdate = isset($_GET['sdate'])?$_GET['sdate']:'';
$action = isset($_POST['action'])?$_POST['action']:'';

if ($serialno == "") {
    $fyear = date("Y");

    if ($periodUnit == 'month') {
        $serialno = date("n");
    } else {
        $month = date("n");
        $day = date("j");
        $weekday = date("w", mktime(0, 0, 0, $month, $day, $fyear));

        if ($weekday == '0') {
            $sdate = mktime(0, 0, 0, $month, $day-6, $year);
        } else {
            $sdate = mktime(0, 0, 0, $month, $day-$weekday+1, $year);
        }

        $serialno = intval(date("W", $sdate));
    }
}

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
}

/**
 * Permission check
 */
$querymore0 = " WHERE lea.id IN ($ids)";
$listLeaveRequests = new request();
$listLeaveRequests->openLeaveRequests($querymore0);
$comptListLeaveRequests = count($listLeaveRequests->lea_id);
$querymore1 = " WHERE lea.id IN ($ids) AND lea.owner='$idSession'";
$listLeaveRequests1 = new request();
$listLeaveRequests1->openLeaveRequests($querymore1);
$comptListLeaveRequests1 = count($listLeaveRequests1->lea_id);
$querymore = " WHERE lea.id IN ($ids) AND lea.status='" . enumFileStatus::stNeedsApproval . "'";
$listLeaveRequests2 = new request();
$listLeaveRequests2->openLeaveRequests($querymore);
$comptListLeaveRequests2 = count($listLeaveRequests2->lea_id);

if (($comptListLeaveRequests2 > 0) || (($comptListLeaveRequests != $comptListLeaveRequests1) && $SW_Permissions['Leave Request']['Admin'][$profilSession] == false)) {
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&sdate=$sdate&msg=permissiondenied&toggle_focus=leave_requests");
    exit;
}

for ($i=0; $i<$comptListLeaveRequests; $i++) {
    if (periodLocked($listLeaveRequests->lea_date_start[$i], $listLeaveRequests->lea_date_end[$i])) {   // check if period locked
        header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&sdate=$sdate&msg=periodLocked&toggle_focus=leave_requests");
        exit;
    }
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        // delete work hours if leave request was approved
        for ($i=0; $i<$comptListLeaveRequests; $i++) {
            $tmpsql = "DELETE FROM " . $tablePrefix . "work_hours WHERE project='0' AND work='" . $listLeaveRequests->lea_type[$i] . "' AND owner='" . $listLeaveRequests->lea_owner[$i] . "' AND baseref='" . $listLeaveRequests->lea_id[$i] . "'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        copy2HistoryTable($requestAct, 'leave_requests', $ids, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "leave_requests WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtLeaveRequest . "' AND fil.doc_id IN ($ids)";
        deleteAttachFiles($requestAct, $querymore);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../timesheet/viewtimesheet.php?msg=delete&fyear=$fyear&serialno=$serialno&sdate=$sdate&toggle_focus=leave_requests");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings("timesheet"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate&amp;toggle_focus=leave_requests", "$serialname $fyear", 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/viewleaverequest.php?id=$id&amp;fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings("leave_request") . " #$id", 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_leave_request"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "leaD";
$block1->openForm("../leaves/deleteleaverequests.php?id=$id&amp;fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">\n";
$block1->heading(lang_strings("delete_leave_request"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListLeaveRequests; $i++) {
    $block1->contentRow("", $blockPage->buildLink($listLeaveRequests->lea_owner[$i], '', 'message') . "  " . $strings['HRC__' . $listLeaveRequests->lea_type[$i]] . "  " . createDate($listLeaveRequests->lea_date_start[$i], 'date', false, true) . " ~ " . createDate($listLeaveRequests->lea_date_end[$i], 'date', false, true) . " " . NumberFormatNOD($listLeaveRequests->lea_hours_total[$i], $hourAccuracy, false) . " " . lang_strings('hours') . "  " . $statusFile[$listLeaveRequests->lea_status[$i]]);
}

$block1->contentRow('', "<input type='submit' name='delete' value='" . $strings['delete'] . "'> <input type='button' name='cancel' value='" . $strings['cancel'] . "' onClick='history.back();'>");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
