<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteleaves.php,v 1.16 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$ids = "'" . str_replace("**", "','", $id) . "'";
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

if (!$SW_Permissions['Leave']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = " WHERE lea.id IN ($ids)";
$listLeaves = new request();
$listLeaves->openLeaves($tmpquery);
$comptListLeaves = count($listLeaves->lea_id);

if ($comptListLeaves == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
} else {
    for ($i=0; $i<$comptListLeaves; $i++) {
        $yr = $listLeaves->lea_year[$i];
        $dd = $listLeaves->lea_due_date[$i];

        if (periodLocked($dd)) {    // check if period locked
            $error = lang_strings('period') . ' ' . createDate($period_date_start,'date',false,true) . ' ~ ' . createDate($period_date_end,'date',false,true) . ' ' . lang_strings('locked');
            break;
        }
    }
}

/**
 * Actions
 */
if ($error == '' && $action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'leaves', $ids, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "leaves WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../leaves/listleaves.php?msg=delete");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=company", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/listleaves.php?", lang_strings("leave_management"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_leaves"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "leD";
$block1->openForm("../leaves/deleteleaves.php?id=$id#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">\n";
$block1->heading(lang_strings("delete_leaves"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListLeaves; $i++) {
    $block1->contentRow("", "#" . $listLeaves->lea_id[$i] . "&nbsp;" . $listLeaves->lea_mem_name[$i] . "&nbsp;" . $listLeaves->lea_year[$i] . "&nbsp;" . $strings['HRC__' . $listLeaves->lea_type[$i]] . "&nbsp;" . $listLeaves->lea_hours[$i] . "&nbsp;" . lang_strings("hours"));
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
