<?php // $Revision: 1.28 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editleave.php,v 1.28 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$owner = isset($_POST['owner'])?$_POST['owner']:'';
$yr = isset($_POST['yr'])?$_POST['yr']:'';
$ty = isset($_POST['ty'])?$_POST['ty']:'';
$hr = isset($_POST['hr'])?$_POST['hr']:'';
$ddI = isset($_POST['ddI'])?$_POST['ddI']:'';
$dd = ($ddI=='')?$dateToday:date2Timestamp($ddI);
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$bodyCommand = "onLoad=\"document.leEForm.hr.focus();\"";
$dd_highlight = false;
$hr_highlight = false;
$error = '';

/**
 * Permission check
 */
if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

if ($id != '' && !$SW_Permissions['Leave']['Edit'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
} else if ($id == '' && !$SW_Permissions['Leave']['Write'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore = " WHERE mem.organization='1' ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore);
$comptListMembers = count($listMembers->mem_id);

if ($comptListMembers == '0') {
    header("Location: ../leaves/listleaves.php?msg=noAvailableUsers");
    exit;
}

if ($id != '') {
    $querymore = " WHERE lea.id='$id'";
    $leaveDetail = new request();
    $leaveDetail->openLeaves($querymore);
    $comptLeaveDetail = count($leaveDetail->lea_id);

    if ($comptLeaveDetail == '0') {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
}

/**
 * Fields Check
 */
if ($action != '') {
    if ($hr == '') {
        // required field
        $error = lang_strings('hours') . '&nbsp;' . lang_strings('error_required');
        $bodyCommand = "onLoad=\"document.leEForm.hr.focus();\"";
        $hr_highlight = true;
    } else if (!is_numeric($hr)) {
        // we need this to be numeric
        $error = lang_strings('hours') . '&nbsp;' . lang_strings('error_numerical');
        $bodyCommand = "onLoad=\"document.leEForm.hr.focus();document.leEForm.hr.select();\"";
        $hr_highlight = true;
    } else if ($hr <= 0) {
        // we need this to be greater than zero
        $error = lang_strings('hours') . '&nbsp;' . lang_strings('value_deviate');
        $bodyCommand = "onLoad=\"document.leEForm.hr.focus();document.leEForm.hr.select();\"";
        $hr_highlight = true;
    } else if ($dd < mktime(0,0,0,12,31,intval($yr))) {
        $error = lang_strings('year') . '&nbsp;' . lang_strings('value_deviate');
        $bodyCommand = "onLoad=\"document.leEForm.yr.focus();\"";
        $dd_highlight = true;
    }
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $hr = round($hr, $hourAccuracy);
    $comm = HtmlEntitiesNOD($comm);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($action == "update") {  // case update leave
            $tmpsql = "UPDATE " . $tablePrefix . "leaves SET owner='$owner',year='$yr',type='$ty',hours='$hr',due_date='$dd',comments='$comm',modified='" . time() . "',muser='$idSession' WHERE id='$id'";
        } else {                    // case add leave
            $tmpsql = "INSERT INTO " . $tablePrefix . "leaves (owner,year,type,hours,due_date,comments,created,cuser) VALUES ('$owner','$yr','$ty','$hr','$dd','$comm','" .time() . "','$idSession')";
        }

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        if ($action == "update") {  // case update leave
            copy2HistoryTable($requestAct, 'leaves', $id, 'U');
        } else {                    // case add leave
            $num = $requestAct->newId('leaves');
            copy2HistoryTable($requestAct, 'leaves', $num, 'A');
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($action == "update") {    // case update user
            header("Location: ../leaves/listleaves.php?msg=update");
            exit;
        } else if ($action == "add") {    // case add user
            header("Location: ../leaves/listleaves.php?msg=add");
            exit;
        }
    }
}

/**
 * Set form data
 */
if ($error == '') {
    if ($id != "") {
        // set values in form
        $owner = $leaveDetail->lea_owner[0];
        $yr = $leaveDetail->lea_year[0];
        $ty = $leaveDetail->lea_type[0];
        $hr = $leaveDetail->lea_hours[0];
        $dd = $leaveDetail->lea_due_date[0];
        $comm = $leaveDetail->lea_comments[0];
    } else {
        $yr = date('Y');
        $hr = "8";
        $dd = mktime(0,0,0,12,31,intval($yr));
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=company", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/listleaves.php?", lang_strings("leave_management"), 'in'));

if ($id == "") {
    $blockPage->itemBreadcrumbs(lang_strings("add_leave"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/viewleave.php?id=$id", "#$id", 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_leave"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "leE";

if ($id == "") {
    $block1->openForm("../leaves/editleave.php?#" . $block1->form . "Anchor");
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">\n";
    $block1->heading(lang_strings("add_leave"));
} else {
    $block1->openForm("../leaves/editleave.php?id=$id#" . $block1->form . "Anchor");
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">\n";
    $block1->heading(lang_strings("edit_leave") . " : #" . $leaveDetail->lea_id[0]);
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$ownerSel = "<select name=\"owner\">";

for ($i=0; $i<$comptListMembers; $i++) {
    if ($owner == $listMembers->mem_id[$i]) {
        $ownerSel .= '<option value="' . $listMembers->mem_id[$i] . '" selected>' . $listMembers->mem_name[$i] . '</option>';
    } else {
        $ownerSel .= '<option value="' . $listMembers->mem_id[$i] . '">' . $listMembers->mem_name[$i] . '</option>';
    }
}

$ownerSel .= "</select>";
$block1->contentRow(lang_strings('owner'), $ownerSel);
$yearSel = '<select name="yr">';

for ($i = date('Y')-3; $i < date('Y')+4; $i++) {
    if ($i == $yr) {
        $yearSel .= '<option value="' . $i . '" selected>' . $i . '</option>';
    } else {
        $yearSel .= '<option value="' . $i . '">' . $i . '</option>';
    }
}

$yearSel .= '</select>';
$block1->contentRow(lang_strings("year"), $yearSel);
$typeSel = "<select name=\"ty\">";

foreach ($limitedLeaveCodeArray as $i) {
    $typeSel .= "<option value=\"$i\"" . (($ty==$i)?' selected':'') . ">" . $strings['HRC__' . $i] . "</option>";
}

$typeSel .= "</select>";
$block1->contentRow(lang_strings('type'), $typeSel);
$block1->contentRow("* " . lang_strings("hours"), "<input size='20' value='$hr'" . (($hr_highlight)?" class='highlight":"") . " name='hr' maxlength='6' type='text'>");
setupInputHTML($block1, lang_strings("due_date"), 'ddI', enumFieldType::ftDate, 'Y', '0', $dd, '', '', $dd_highlight);
setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
