<?php // $Revision: 1.41 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editleaverequest.php,v 1.41 2013/02/09 06:37:07 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
$bodyCommand = "onLoad=\"document.leaEForm.ty.focus();\"";

/**
 * Variables init
 */
$dateToday = mktime(0, 0, 0, intval(date('n')), intval(date('j')), intval(date('Y')));
$tomorrow = mktime(0, 0, 0, intval(date('n')), intval(date('j'))+1, intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$fyear = isset($_GET['fyear'])?$_GET['fyear']:'';
$serialno = isset($_GET['serialno'])?$_GET['serialno']:'';
$sdate = isset($_GET['sdate'])?$_GET['sdate']:'';
$applicant = isset($_POST['applicant'])?$_POST['applicant']:$idSession;
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ty = isset($_POST['ty'])?$_POST['ty']:'';
$dateStartI = isset($_POST['dateStartI'])?$_POST['dateStartI']:'';
$dateStart = (($dateStartI=='')?$dateToday:date2Timestamp($dateStartI));
$dateEndI = isset($_POST['dateEndI'])?$_POST['dateEndI']:'';
$dateEnd = (($dateEndI=='')?$dateToday:date2Timestamp($dateEndI));
$tsi = isset($_POST['time_start'])?$_POST['time_start']:"";
$tei = isset($_POST['time_end'])?$_POST['time_end']:"";
$time_start = DbValueEncode(enumFieldType::ftTime, $tsi);
$time_end = DbValueEncode(enumFieldType::ftTime, $tei);
$hours_start = isset($_POST['hours_start'])?$_POST['hours_start']:"0";
$hours_end = isset($_POST['hours_end'])?$_POST['hours_end']:"0";
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$project = '0';
$error = '';

if ($serialno == "") {
    $fyear = date("Y");

    if ($periodUnit == 'month') {
        $serialno = date("n");
    } else {
        $month = date("n");
        $day = date("j");
        $weekday = date("w", mktime(0, 0, 0, $month, $day, $fyear));

        if ($weekday == '0') {
            $sdate = mktime(0, 0, 0, $month, $day-6, $year);
        } else {
            $sdate = mktime(0, 0, 0, $month, $day-$weekday+1, $year);
        }

        $serialno = intval(date("W", $sdate));
    }
}

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
}

/**
 * Permission check
 */
if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

if ($id != '') {
    $querymore = " WHERE lea.id='$id'";
    $leaveRequestDetail = new request();
    $leaveRequestDetail->openLeaveRequests($querymore);
    $applicant = $leaveRequestDetail->lea_owner[0];

    if (($applicant != $idSession && $SW_Permissions['Leave Request']['Edit'][$profilSession] == false) || $leaveRequestDetail->lea_status[0] == enumFileStatus::stNeedsApproval) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    if (periodLocked($leaveRequestDetail->lea_date_start[0], $leaveRequestDetail->lea_date_end[0])) {   // check if period locked
        header("Location: ../general/home.php?msg=periodLocked");
        exit;
    }
}

$querymore = " WHERE mem.id='$applicant' AND mem.active='" . enumBoolean::bTrue . "'";
$memberDetail = new request();
$memberDetail->openMembers($querymore);
$comptMemberDetail = count($memberDetail->mem_id);

if ($comptMemberDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Fields check
 */
// caculate the total hours of leave request
$querymore = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.date>'$dateStart' AND wcd.date<'$dateEnd' ORDER BY wcd.date";
$listWorkCalendarDetail = new request();
$listWorkCalendarDetail->openWorkCalendarsDetail($querymore);
$comptListWorkCalendarDetail = count($listWorkCalendarDetail->wcd_id);
$hours_total = floatval($hours_start);

if ($dateEnd > $dateStart) {
    $hours_total += floatval($hours_end);
}

for ($i32=0; $i32<$comptListWorkCalendarDetail; $i32++) {
    $hours_total += floatval($listWorkCalendarDetail->wcd_hours[$i32]);
}

// get the default start time & end time of start date
$y0 = date('Y', $dateStart);
$w0 = date('N', $dateStart);
$querymore = " WHERE wcw.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcw.year='$y0' AND wcw.day_type='$w0'";
$startWorkCalendarWeekday = new request();
$startWorkCalendarWeekday->openWorkCalendarsWeekday($querymore);

if (count($startWorkCalendarWeekday->wcw_id) > 0) {
    $defaultStartTime = $startWorkCalendarWeekday->wcw_start_time[0];
}

// get the default start time & end time of end date
$y = date('Y', $dateEnd);
$w = date('N', $dateEnd);
$querymore = " WHERE wcw.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcw.year='$y' AND wcw.day_type='$w'";
$endWorkCalendarWeekday = new request();
$endWorkCalendarWeekday->openWorkCalendarsWeekday($querymore);

if (count($endWorkCalendarWeekday->wcw_id) > 0) {
    $defaultEndTime = $endWorkCalendarWeekday->wcw_end_time[0];
}

/**
 * Actions
 */
if (($error == '') && ($action == 'add' || $action == 'update')) {
    // replace quotes by html code in reason
    $comm = HtmlEntitiesNOD($comm);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($action == 'add') {
            $status = enumFileStatus::stNoApprovalsNeeded;
            $cfsqls = setupCustomFieldsInsertSQL('leave_requests');  // Generate custom fields insert sql
            $tmpsql = "INSERT INTO " . $tablePrefix . "leave_requests (owner,type,date_start,date_end,time_start,time_end,hours_total,hours_start,hours_end,status,comments,created,cuser" . $cfsqls[0] . ") VALUES ('$applicant','$ty','$dateStart','$dateEnd','$time_start','$time_end','$hours_total','$hours_start','$hours_end','$status','$comm','" . time() . "','$idSession'" . $cfsqls[1] . ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $sendto = $requestAct->newId('leave_requests');
            $cfsql = setupCustomMediaFieldsUpdateSQL('leave_requests', $sendto);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "leave_requests SET $cfsql WHERE id='$sendto'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $num = $sendto;
            $producer = $applicant;
            $doctype = 'leave_requests';

            if (!defined('INNER_ADDDOCUMENT')) {
                define('INNER_ADDDOCUMENT', 1);
            }

            require('../approvals/adddocument.php');

            if ($status == enumFileStatus::stNoApprovalsNeeded) {
                AddLeaveRequestHours($requestAct, $num, $applicant, $ty, $dateStart, $dateEnd, $hours_start, $hours_end);
            }

            $querymore = " WHERE fil.id='1'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtLeaveRequest, $sendto, $status, '1', $path);
            copy2HistoryTable($requestAct, 'leave_requests', $sendto, 'A');
        } else if ($action == 'update') {
            $status = enumFileStatus::stNoApprovalsNeeded;
            $cfsql = setupCustomFieldsUpdateSQL('leave_requests', $id);  // Generate custom fields update sql
            $tmpsql = "DELETE FROM " . $tablePrefix . "work_hours WHERE project='0' AND work='" . $leaveRequestDetail->lea_type[0]. "' AND owner='" . $leaveRequestDetail->lea_owner[0] . "' AND baseref='$id'";

           if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
           }

            $tmpsql = "UPDATE " . $tablePrefix . "leave_requests SET type='$ty',date_start='$dateStart',date_end='$dateEnd',time_start='$time_start',time_end='$time_end',hours_total='$hours_total',hours_start='$hours_start',hours_end='$hours_end',status='$status',comments='$comm',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $producer = $applicant;
            $num = $id;
            $doctype = 'leave_requests';
            require_once('../approvals/updatedocument.php');

            if ($status == enumFileStatus::stNoApprovalsNeeded) {
                AddLeaveRequestHours($requestAct, $id, $applicant, $ty, $dateStart, $dateEnd, $hours_start, $hours_end);
            }

            copy2HistoryTable($requestAct, 'leave_requests', $id, 'U');
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($action == 'add') {
            header("Location: ../leaves/viewleaverequest.php?id=$sendto&fyear=$fyear&serialno=$serialno&sdate=$sdate&msg=add");
            exit;
        } else {
            header("Location: ../leaves/viewleaverequest.php?id=$id&fyear=$fyear&serialno=$serialno&sdate=$sdate&msg=update");
            exit;
        }
    }
}

/**
 * Set value in form
 */
if ($error == '' && $ty == '') {
    if ($id == '') {
        $ty = enumLeaveType::lvAnnual;
        $dateStart = $tomorrow;
        $dateEnd = $tomorrow;
        $time_start = '';
        $time_end = '';
        $comm = '';
    } else {
        $ty = $leaveRequestDetail->lea_type[0];
        $dateStart = $leaveRequestDetail->lea_date_start[0];
        $dateEnd = $leaveRequestDetail->lea_date_end[0];
        $time_start = $leaveRequestDetail->lea_time_start[0];
        $time_end = $leaveRequestDetail->lea_time_end[0];
        $hours_total = $leaveRequestDetail->lea_hours_total[0];
        $hours_start = strval($leaveRequestDetail->lea_hours_start[0]);
        $hours_end = strval($leaveRequestDetail->lea_hours_end[0]);
        $comm = $leaveRequestDetail->lea_comments[0];
        $querymore = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.date>'$dateStart' AND wcd.date<'$dateEnd' ORDER BY wcd.date";
        $listWorkCalendarDetail = new request();
        $listWorkCalendarDetail->openWorkCalendarsDetail($querymore);
        $comptListWorkCalendarDetail = count($listWorkCalendarDetail->wcd_id);
    }
}

// get the stardard hours of start date & end date
$querymore = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND (wcd.date='$dateStart' OR wcd.date='$dateEnd') ORDER BY wcd.date";
$listStandardHours = new request();
$listStandardHours->openWorkCalendarsDetail($querymore);
$comptListStandardHours = count($listStandardHours->wcd_id);
$k32 = array_search($dateStart, $listStandardHours->wcd_date);

if ($k32 !== false) {
    if (floatval($hours_start) === 0.0) {
        $hours_start = $listStandardHours->wcd_hours[$k32];
    }
}

$k32a = array_search($dateEnd, $listStandardHours->wcd_date);

if ($k32a !== false) {
    if (floatval($hours_end) === 0.0) {
        $hours_end = $listStandardHours->wcd_hours[$k32a];
    }
}

// set default start time & end time
if ($time_start == '') {
    $time_start = $defaultStartTime;
}

if ($time_end == '') {
    $time_end = $defaultEndTime;
}

/**
 * HTML
 */
require_once("../includes/header.php");
echo '<script type="text/javascript" src="../javascript/editleaverequest' . $scriptMinimized . '.js"></script>';
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings("timesheet"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate&amp;toggle_focus=leave_requests", "$serialname $fyear", 'in'));

if ($id != '') {// edit leave request
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/viewleaverequest.php?id=$id&amp;fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings("leave_request") . " #$id", 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_leave_request"));
} else {        // add leave request
    $blockPage->itemBreadcrumbs(lang_strings("add_leave_request"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "leaE";

if ($id != '') {
    $block1->openForm("../leaves/editleaverequest.php?id=$id&amp;fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate#" . $block1->form . "Anchor", 'return checkFormData(this);');
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
    $block1->heading(lang_strings("edit_leave_request") . " : #$id");
} else {
    $block1->openForm("../leaves/editleaverequest.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate#" . $block1->form . "Anchor", 'return checkFormData(this);');
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
    $block1->heading(lang_strings("add_leave_request"));
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));

if ($SW_Permissions['Leave Request']['Edit'][$profilSession]) {
    $querymore = " WHERE mem.id<>'1' AND mem.organization='1' AND mem.active='" . enumBoolean::bTrue . "' ORDER BY mem.name";
    $listApplicant = new request();
    $listApplicant->openMembers($querymore);
    $comptListApplicant = count($listApplicant->mem_id);
    $applicantSel = '<select id="applicant" name="applicant" onchange="getAvailableHours();dateStartChanged();dateEndChanged();updateTotals();">';

    for ($i32=0; $i32<$comptListApplicant; $i32++) {
        if ($listApplicant->mem_id[$i32] == $applicant) {
            $applicantSel .= "<option value=\"" . $listApplicant->mem_id[$i32] . "\" selected>" . $listApplicant->mem_name[$i32] . "</option>";
        } else {
            $applicantSel .= "<option value=\"" . $listApplicant->mem_id[$i32] . "\">" . $listApplicant->mem_name[$i32] . "</option>";
        }
    }

    $applicantSel .= "</select>";
    $block1->contentRow("* " . lang_strings('proposer'), $applicantSel);
} else {
    echo '<input type="hidden" id="applicant" name="applicant" value="' . $applicant . '">';
}

$typeSel = '<select id="ty" name="ty" onchange="getAvailableHours()">';

foreach ($leaveCodeArray as $i32) {
    $typeSel .= "<option value=\"$i32\"" . (($i32 == $ty)?' selected':'') . ">" . $strings['HRC__' . $i32] . "</option>";
}

$typeSel .= '</select> <i id="available"></i>';
$block1->contentRow("* " . lang_strings('type'), $typeSel);
list($uformat, $cformat, $mformat) = preg_split('/\|/', $dateformatSession);
setupInputHTML($block1, lang_strings("date_start"), 'dateStartI', enumFieldType::ftDate, 'Y', '0', $dateStart, '', '', false, '', 'onchange="dateStartChanged()"');
setupInputHTML($block1, lang_strings('time_start'), 'time_start', enumFieldType::ftTime, 'Y', '5', $time_start, '', '', false, ' ');
setupInputHTML($block1, lang_strings('hours_start'), 'hours_start', enumFieldType::ftHours, 'Y', '0', $hours_start, '', '', false, ' ', 'onchange="hoursStartChanged()"');
setupInputHTML($block1, lang_strings("date_end"), 'dateEndI', enumFieldType::ftDate, 'Y', '0', $dateEnd, '', '', false, '', 'onchange="dateEndChanged()"');
setupInputHTML($block1, lang_strings('time_end'), 'time_end', enumFieldType::ftTime, 'Y', '5', $time_end, '', '', false, ' ');
setupInputHTML($block1, lang_strings('hours_end'), 'hours_end', enumFieldType::ftHours, 'Y', '0', $hours_end, '', '', false, ' ', 'onchange="hoursEndChanged()"');
$block1->contentRow(lang_strings('day_details'), '<div id="dayDetails"></div>');
$block1->contentRow(lang_strings('total'), '<div id="total"></div> <strong id="totalS"></strong>');
setupInputHTML($block1, lang_strings('reason'), 'comm', enumFieldType::ftMemo, 'Y', '0', $comm);
setupCustomFieldsInputHTML($block1, 'leave_requests', $id);
$block1->contentRow('', '<input type="submit" name="Save" value="' . $strings["save"] . '">');
$block1->closeContent();

if (($fileManagement == 'true') && ($id == '') && ($SW_Permissions['File']['Write'][$profilSession])) {
    setupAttachFilesHTML(false);
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
