<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editleaverequest_serv.php,v 1.3 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

// check if the request is an AJAX request
if (!is_ajax()) {
    exit;
}

/**
 * Variables init
 */
$action = AddSlashesNOD(isset($_POST['action'])?$_POST['action']:'');   // action

if ($action == '') {
    exit;
}

switch ($action) {
    case 'availableHours':
        /**
         * get available hours for the specified leave type
         */
        $dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
        $applicant = AddSlashesNOD(isset($_POST['applicant'])?$_POST['applicant']:'0');     // applicant user id
        $ty = AddSlashesNOD(isset($_POST['type'])?$_POST['type']:'');                       // leave request type
        $dateEndI = AddSlashesNOD(isset($_POST['end'])?$_POST['end']:'');                   // end date
        $dateEnd = (($dateEndI=='')?$dateToday:date2Timestamp($dateEndI));
        $available = '';
        $hours_available = 0;

        if (in_array($ty, $limitedLeaveCodeArray)) {
            $tmpquery = "SELECT SUM(T0.hours) FROM (
                SELECT hours FROM " . $tablePrefix . "leaves WHERE owner='$applicant' AND type='$ty' AND due_date>='$dateEnd'
                UNION ALL
                SELECT (0-hours) AS hours FROM " . $tablePrefix . "work_hours WHERE work='$ty' AND owner='$applicant'
                UNION ALL
                SELECT (0-hours_total) AS hours FROM " . $tablePrefix . "leave_requests WHERE owner='$applicant' AND type='$ty' AND status='" . enumFileStatus::stNeedsApproval . "'
            ) T0";
            $request1 = new request();
            $request1->connectClass();
            $request1->query($tmpquery);

            if ($request1->fetch()) {
                $hours_available = floatval($row[0]);
            }

            $request1->close();
            $available = $strings['available'] . ' ' . NumberFormatNOD($hours_available, $hourAccuracy, false) . $strings['hours'];
        }

        header("content-type:application/json");
        echo json_encode(array(
            'available' => $available,
            'hours' => "$hours_available"
        ));
        break;
    case 'workcalendarInfo':
        /**
         * get standard work hours, start time & end time of a calendar date
         */
        $applicant = AddSlashesNOD(isset($_POST['applicant'])?$_POST['applicant']:'0');     // applicant user id
        $dateI = AddSlashesNOD(isset($_POST['date'])?$_POST['date']:'');                    // calendar date
        $hourInfo = '';
        $timeInfo = '';

        if ($dateI !== '') {
            $dateT = date2Timestamp($dateI);
            $querymore1 = " WHERE mem.id='$applicant' AND mem.active='" . enumBoolean::bTrue . "'";
            $memberDetail = new request();
            $memberDetail->openMembers($querymore1);
            // get the default start time & end time
            $y0 = date('Y', $dateT);
            $w0 = date('N', $dateT);
            $querymore2 = " WHERE wcw.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcw.year='$y0' AND wcw.day_type='$w0'";
            $startWorkCalendarWeekday = new request();
            $startWorkCalendarWeekday->openWorkCalendarsWeekday($querymore2);

            if (count($startWorkCalendarWeekday->wcw_id) > 0) {
                if ($startWorkCalendarWeekday->wcw_start_time[0] != '' && $startWorkCalendarWeekday->wcw_end_time[0] != '') {
                    $timeInfo = ' ' . $strings['work_time'] . " : " . DbValueDecode(enumFieldType::ftTime, $startWorkCalendarWeekday->wcw_start_time[0]) . " ~ " . DbValueDecode(enumFieldType::ftTime, $startWorkCalendarWeekday->wcw_end_time[0]);
                }
            }
            // get the stardard hours
            $querymore = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.date='$dateT'";
            $listStandardHours = new request();
            $listStandardHours->openWorkCalendarsDetail($querymore);
            $comptListStandardHours = count($listStandardHours->wcd_id);

            if ($comptListStandardHours > 0) {
                $hourInfo = ' ' . $strings['standard'] . " : " . NumberFormatNOD($listStandardHours->wcd_hours[0], $hourAccuracy, false) . " " . $strings['hours'];
            }
        }

        header("content-type:application/json");
        echo json_encode(array(
            'hourInfo' => $hourInfo,
            'timeInfo' => $timeInfo
        ));
        break;
    case 'summary':
        /**
         * update day details & total hours
         */
        $applicant = AddSlashesNOD(isset($_POST['applicant'])?$_POST['applicant']:'0');     // applicant user id
        $dateStartI = AddSlashesNOD(isset($_POST['dateStartI'])?$_POST['dateStartI']:'');   // start date
        $dateStart = date2Timestamp($dateStartI);
        $time_start = AddSlashesNOD(isset($_POST['timeStart'])?$_POST['timeStart']:'');     // start time
        $hours_start = AddSlashesNOD(isset($_POST['hoursStart'])?$_POST['hoursStart']:'');  // hours on start
        $dateEndI = AddSlashesNOD(isset($_POST['dateEndI'])?$_POST['dateEndI']:'');         // end date
        $dateEnd = date2Timestamp($dateEndI);
        $time_end = AddSlashesNOD(isset($_POST['timeEnd'])?$_POST['timeEnd']:'');           // end time
        $hours_end = AddSlashesNOD(isset($_POST['hoursEnd'])?$_POST['hoursEnd']:'');        // hours on end
        $querymore1 = " WHERE mem.id='$applicant' AND mem.active='" . enumBoolean::bTrue . "'";
        $memberDetail = new request();
        $memberDetail->openMembers($querymore1);
        $querymore2 = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.date>'$dateStart' AND wcd.date<'$dateEnd' ORDER BY wcd.date";
        $listWorkCalendarDetail = new request();
        $listWorkCalendarDetail->openWorkCalendarsDetail($querymore2);
        $comptListWorkCalendarDetail = count($listWorkCalendarDetail->wcd_id);
        $hours_total = floatval($hours_start);

        if ($dateEnd > $dateStart) {
            $hours_total += floatval($hours_end);
        }

        for ($i32=0; $i32<$comptListWorkCalendarDetail; $i32++) {
            $hours_total += floatval($listWorkCalendarDetail->wcd_hours[$i32]);
        }

        list($uformat, $cformat, $mformat) = preg_split('/\|/', $dateformatSession);
        $dayDetails = array();

        if (floatval($hours_start) > 0) {
            $dayDetails[] = $dateStartI . ' - ' . NumberFormatNOD($hours_start, $hourAccuracy, false) . ' ' . $strings['hours'];
        }

        for ($i32=0; $i32<$comptListWorkCalendarDetail; $i32++) {
            if (floatval($listWorkCalendarDetail->wcd_hours[$i32]) > 0) {
                $dayDetails[] = date($uformat, $listWorkCalendarDetail->wcd_date[$i32]) . ' - ' . NumberFormatNOD($listWorkCalendarDetail->wcd_hours[$i32], $hourAccuracy, false) . ' ' . $strings['hours'];
            }
        }

        if ($dateEnd > $dateStart && floatval($hours_end) > 0) {
            $dayDetails[] = $dateEndI . ' - ' . NumberFormatNOD($hours_end, $hourAccuracy, false) . ' ' . $strings['hours'];
        }

        header("content-type:application/json");
        echo json_encode(array(
            'dayDetails' => implode('<br>', $dayDetails),
            'total' => NumberFormatNOD($hours_total, $hourAccuracy, false) . ' ' . $strings['hours'],
            'totalHours' => $hours_total
        ));
        break;
    case 'checkFormData':
        /**
         * check form data
         */
        $applicant = AddSlashesNOD(isset($_POST['applicant'])?$_POST['applicant']:'0');     // applicant user id
        $ty = AddSlashesNOD(isset($_POST['type'])?$_POST['type']:'');                       // leave request type
        $dateStartI = AddSlashesNOD(isset($_POST['dateStartI'])?$_POST['dateStartI']:'');   // start date
        $dateStart = date2Timestamp($dateStartI);
        $timeStartI = AddSlashesNOD(isset($_POST['timeStart'])?$_POST['timeStart']:'');     // start time
        $hours_start = AddSlashesNOD(isset($_POST['hoursStart'])?$_POST['hoursStart']:'');  // hours on start
        $dateEndI = AddSlashesNOD(isset($_POST['dateEndI'])?$_POST['dateEndI']:'');         // end date
        $dateEnd = date2Timestamp($dateEndI);
        $timeEndI = AddSlashesNOD(isset($_POST['timeEnd'])?$_POST['timeEnd']:'');           // end time
        $hours_end = AddSlashesNOD(isset($_POST['hoursEnd'])?$_POST['hoursEnd']:'');        // hours on end
        $dateStartO = '';
        $dateEndO = '';
        $timeStartO = '';
        $timeEndO = '';
        $hoursStartO = '';
        $hoursEndO = '';
        $totalO = '';
        $querymore1 = " WHERE mem.id='$applicant' AND mem.active='" . enumBoolean::bTrue . "'";
        $memberDetail = new request();
        $memberDetail->openMembers($querymore1);
        $y0 = date('Y', $dateStart);
        $w0 = date('N', $dateStart);
        $querymore2 = " WHERE wcw.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcw.year='$y0' AND wcw.day_type='$w0'";
        $startWorkCalendarWeekday = new request();
        $startWorkCalendarWeekday->openWorkCalendarsWeekday($querymore2);
        $y = date('Y', $dateEnd);
        $w = date('N', $dateEnd);
        $querymore3 = " WHERE wcw.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcw.year='$y' AND wcw.day_type='$w'";
        $endWorkCalendarWeekday = new request();
        $endWorkCalendarWeekday->openWorkCalendarsWeekday($querymore3);
        $querymore4 = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.date>'$dateStart' AND wcd.date<'$dateEnd' ORDER BY wcd.date";
        $listWorkCalendarDetail = new request();
        $listWorkCalendarDetail->openWorkCalendarsDetail($querymore4);
        $comptListWorkCalendarDetail = count($listWorkCalendarDetail->wcd_id);
        $hours_total = floatval($hours_start);

        if ($dateEnd > $dateStart) {
            $hours_total += floatval($hours_end);
        }

        for ($i32=0; $i32<$comptListWorkCalendarDetail; $i32++) {
            $hours_total += floatval($listWorkCalendarDetail->wcd_hours[$i32]);
        }
        // check if the periods locked
        if (periodLocked($dateStart)) {
            $dateStartO = $strings['period'] . ' ' . createDate($period_date_start,'date',false,true) . ' ~ ' . createDate($period_date_end,'date',false,true) . ' ' . $strings['locked'];
        } else if (periodLocked($dateStart, $dateEnd)) {
            $dateEndO = $strings['period'] . ' ' . createDate($period_date_start,'date',false,true) . ' ~ ' . createDate($period_date_end,'date',false,true) . ' ' . $strings['locked'];
        }

        // start date must not greater than end date
        if ($dateEndO == '' && $dateStart > $dateEnd) {
            $dateEndO = $strings['value_deviate'];
        }

        // Convert input values to database stored values
        $time_start = DbValueEncode(enumFieldType::ftTime, $timeStartI);
        $time_end = DbValueEncode(enumFieldType::ftTime, $timeEndI);
        // start time must between the start time & end time of start date
        if ($time_start < $startWorkCalendarWeekday->wcw_start_time[0] || $time_start > $startWorkCalendarWeekday->wcw_end_time[0]) {
            $timeStartO = $strings['value_deviate'];
        }
        // end time must between the start time & end time of end date
        if ($time_end < $endWorkCalendarWeekday->wcw_start_time[0] || $time_start > $endWorkCalendarWeekday->wcw_end_time[0]) {
            $timeEndO = $strings['value_deviate'];
        }
        // Hours on start must greater than zero
        if (floatval($hours_start) <= 0) {
            $hoursStartO = $strings['value_deviate'];
        } else {
            // Hours on start must not greater than start hours of start date
            $tmpquery = "SELECT id FROM " . $tablePrefix . "workcalendars_detail WHERE workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND date='$dateStart' AND hours<" . $hours_start;

            if (compt($tmpquery) > 0) {
                $hoursStartO = $strings['value_deviate'];
            }
        }
        // More than 1 day
        if ($dateEndI != $dateStartI) {
            if (floatval($hours_end) <= 0) {
                // Hours on end must greater than zero
                $hoursEndO = $strings['value_deviate'];
            } else {
                // Hours on end must not greater than start hours of end date
                $tmpquery = "SELECT id FROM " . $tablePrefix . "workcalendars_detail WHERE workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND date='$dateEnd' AND hours<" . $hours_end;

                if (compt($tmpquery) > 0) {
                    $hoursEndO = $strings['value_deviate'];
                }
            }
        }

        // check if there are enough leave hours available
        if (in_array($ty, $limitedLeaveCodeArray)) {
            $hours_available = 0;
            $tmpquery = "SELECT SUM(T0.hours) FROM (
                SELECT hours FROM " . $tablePrefix . "leaves WHERE owner='$applicant' AND type='$ty' AND due_date>='$dateEnd'
                UNION ALL
                SELECT (0-hours) AS hours FROM " . $tablePrefix . "work_hours WHERE work='$ty' AND owner='$applicant'
                UNION ALL
                SELECT (0-hours_total) AS hours FROM " . $tablePrefix . "leave_requests WHERE owner='$applicant' AND type='$ty' AND status='" . enumFileStatus::stNeedsApproval . "'
            ) T0";
            $request1 = new request();
            $request1->connectClass();
            $request1->query($tmpquery);

            if ($request1->fetch()) {
                $hours_available = floatval($row[0]);
            }

            $request1->close();

            if ($hours_available < $hours_total) {
                $totalO = $strings['no_available_leave_hours'];
            }
        }

        header("content-type:application/json");
        echo json_encode(array(
            'dateStart' => $dateStartO,
            'timeStart' => $timeStartO,
            'hoursStart' => $hoursStartO,
            'dateEnd' => $dateEndO,
            'timeEnd' => $timeEndO,
            'hoursEnd' => $hoursEndO,
            'total' => $totalO
        ));
        break;
}
