<?php // $Revision: 1.18 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listleaves.php,v 1.18 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$error = isset($_GET['error'])?$_GET['error']:'';

/**
 * Permission check
 */
if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

if (!$SW_Permissions['Leave']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=company", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("leave_management"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "leL";
$block1->openForm("../leaves/listleaves.php?#" . $block1->form . "Anchor");
$block1->heading(lang_strings("leave_management"));
$block1->sorting("leaves", (isset($sortingUser['leaves'])?$sortingUser['leaves']:''), "lea.year DESC", $sortingFields = array(0 => 'none', 1 => 'mem.name', 2 => 'mem.department', 3 => "lea.year", 4 => "lea.type", 5 => "lea.hours", 6 => "lea.due_date"));
$tsTomorrow = mktime(0, 0, 0, intval(date('m')), intval(date('d'))+1, intval(date('Y')));
$tmpquery = " WHERE lea.due_date>='$tsTomorrow' ORDER BY " . $block1->sortingValue;
$listLeaves = new request();
$listLeaves->openLeaves($tmpquery);
$comptListLeaves = count($listLeaves->lea_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->field_type = enumFieldType::ftAvatar;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['full_name'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['department'];
$columns[2]->field_type = enumFieldType::ftNumeric;
$columns[2]->linked_table = 'departments';
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['year'];
$columns[3]->field_type = enumFieldType::ftText;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['type'];
$columns[4]->field_type = enumFieldType::ftText;
$columns[5] = new cardviewColumn();
$columns[5]->title = $strings['hours'];
$columns[5]->field_type = enumFieldType::ftHours;
$columns[6] = new cardviewColumn();
$columns[6]->title = $strings['due_date'];
$columns[6]->field_type = enumFieldType::ftText;
$opt[enumCardviewOption::oObject] = 'leaves';
$opt[enumCardviewOption::oTableName] = 'leaves';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;

if ($SW_Permissions['Leave']['Write'][$profilSession]) {
    $opt[enumCardviewOption::oAddUrl] = '../leaves/editleave.php?';
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListLeaves; $i++) {
    $content = array(
        implode(',',
            array(
                $listLeaves->lea_owner[$i],
                $listLeaves->lea_mem_extension_picture[$i],
                $listLeaves->lea_mem_gender[$i])),
        $listLeaves->lea_mem_name[$i],
        $listLeaves->lea_mem_department[$i],
        $listLeaves->lea_year[$i],
        $strings['HRC__' . $listLeaves->lea_type[$i]],
        $listLeaves->lea_hours[$i],
        createDate($listLeaves->lea_due_date[$i],'date',false,true)
    );
    $block1->itemCardView($listLeaves->lea_id[$i], $content);
}

$block1->closeCardView();
$block1->closeFormResults();
require_once("../includes/footer.php");
