<?php // $Revision: 1.27 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewleaverequest.php,v 1.27 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$fyear = isset($_GET['fyear'])?$_GET['fyear']:'';
$serialno = isset($_GET['serialno'])?$_GET['serialno']:'';
$sdate = isset($_GET['sdate'])?$_GET['sdate']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';

/**
 * Permission check
 */
$querymore = " WHERE lea.id='$id'";
$leaveRequestDetail = new request();
$leaveRequestDetail->openLeaveRequests($querymore);
$comptLeaveRequestDetail = count($leaveRequestDetail->lea_id);

if ($comptLeaveRequestDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Set values in form
 */
$owner = $leaveRequestDetail->lea_owner[0];
$status = $leaveRequestDetail->lea_status[0];

if ($serialno == "") {
    $fyear = date('Y', $leaveRequestDetail->lea_date_start[0]);
    $month = date('m', $leaveRequestDetail->lea_date_start[0]);
    $day = date('d', $leaveRequestDetail->lea_date_start[0]);

    if ($periodUnit == 'month') {
        $serialno = intval($month);
    } else {
        $weekday = date("w", mktime(0, 0, 0, $month, $day, $fyear));

        if ($weekday == '0') {
            $sdate = mktime(0, 0, 0, $month, $day-6, $year);
        } else {
            $sdate = mktime(0, 0, 0, $month, $day-$weekday+1, $year);
        }

        $month = date('n', $sdate);
        $serialno = intval(date("W", $sdate));

        if ($sdate == '12' && $serialno == '1') {
            $fyear += 1;
        } else if ($sdate == '1' && $serialno > '50') {
            $fyear -= 1;
        }
    }
}

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
}

/**
 * Load member detail of leave request owner
 */
$querymore0 = " WHERE mem.id='$owner'";
$memberDetail = new request();
$memberDetail->openMembers($querymore0);

/**
 * Load day details
 */
$querymore = " WHERE wkh.project='0' AND wkh.work='" . $leaveRequestDetail->lea_type[0] . "' AND wkh.baseref='$id' ORDER BY wkh.date";
$listWorkHours = new request();
$listWorkHours->openWorkHours($querymore);
$comptListWorkHours = count($listWorkHours->wkh_id);
$dayDetails = array();

if ($comptListWorkHours == '0') {
    $dayDetails[] = createDate($leaveRequestDetail->lea_date_start[0], 'date', false, true) . ' - ' . NumberFormatNOD($leaveRequestDetail->lea_hours_start[0], $hourAccuracy, false) . ' ' . lang_strings('hours');
    $querymore = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.date>'" . $leaveRequestDetail->lea_date_start[0] . "' AND wcd.date<'" . $leaveRequestDetail->lea_date_end[0] . "' ORDER BY wcd.date";
    $listWorkCalendarDetail = new request();
    $listWorkCalendarDetail->openWorkCalendarsDetail($querymore);
    $comptListWorkCalendarDetail = count($listWorkCalendarDetail->wcd_id);

    for ($i=0; $i<$comptListWorkCalendarDetail; $i++) {
        if (floatval($listWorkCalendarDetail->wcd_hours[$i]) > 0) {
            $dayDetails[] = createDate($listWorkCalendarDetail->wcd_date[$i], 'date', false, true) . ' - ' . NumberFormatNOD($listWorkCalendarDetail->wcd_hours[$i], $hourAccuracy, false) . ' ' . lang_strings('hours');
        }
    }

    if (floatval($leaveRequestDetail->lea_hours_end[0]) > 0) {
        $dayDetails[] = createDate($leaveRequestDetail->lea_date_end[0], 'date', false, true) . ' - ' . NumberFormatNOD($leaveRequestDetail->lea_hours_end[0], $hourAccuracy, false) . ' ' . lang_strings('hours');
    }
} else {
    for ($i=0; $i<$comptListWorkHours; $i++) {
        $dayDetails[] = createDate($listWorkHours->wkh_date[$i], 'date', false, true) . ' - ' . NumberFormatNOD($listWorkHours->wkh_hours[$i], $hourAccuracy, false) . ' ' . lang_strings('hours');
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate", lang_strings('timesheet'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate&amp;toggle_focus=leave_requests", "$serialname $fyear", 'in'));
$blockPage->itemBreadcrumbs(lang_strings("leave_request") . " : #$id");
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = "leaD";
$block1->openForm("../leaves/viewleaverequest.php#" . $block1->form . "Anchor");
$block1->headingToggle(lang_strings('leave_request'), !($toggle_focus==''));

if ($status != enumFileStatus::stNeedsApproval && !periodLocked($leaveRequestDetail->lea_date_start[0], $leaveRequestDetail->lea_date_end[0])) {
    $block1->openPaletteIcon();

    if ($owner == $idSession || $SW_Permissions['Leave Request']['Admin'][$profilSession]) {
        $block1->paletteIcon(0, "remove", $strings["delete"]);
    }

    if ($owner == $idSession || $SW_Permissions['Leave Request']['Edit'][$profilSession]) {
        $block1->paletteIcon(1, "edit", $strings["edit"]);
    }

    $block1->closePaletteIcon();
}

$block1->openContent();
$block1->contentRow(lang_strings("proposer"), $blockPage->buildLink($owner, '', 'message'));
$block1->contentRow(lang_strings('type'), $strings['HRC__' . $leaveRequestDetail->lea_type[0]]);
$block1->contentRow(lang_strings('date_start'), createDate($leaveRequestDetail->lea_date_start[0], 'date', false, true));
$block1->contentRow(lang_strings('time_start'), DbValueDecode(enumFieldType::ftTime, $leaveRequestDetail->lea_time_start[0]));
$block1->contentRow(lang_strings('hours_start'), NumberFormatNOD($leaveRequestDetail->lea_hours_start[0], $hourAccuracy, false) . ' ' . lang_strings('hours'));
$block1->contentRow(lang_strings('date_end'), createDate($leaveRequestDetail->lea_date_end[0], 'date', false, true));
$block1->contentRow(lang_strings('time_end'), DbValueDecode(enumFieldType::ftTime, $leaveRequestDetail->lea_time_end[0]));

if ($leaveRequestDetail->lea_date_end[0] != $leaveRequestDetail->lea_date_start[0]) {
    $block1->contentRow(lang_strings('hours_end'), NumberFormatNOD($leaveRequestDetail->lea_hours_end[0], $hourAccuracy, false) . ' ' . lang_strings('hours'));
}

$block1->contentRow(lang_strings('day_details'), implode('<br>', $dayDetails));
$block1->contentRow(lang_strings("total"), NumberFormatNOD($leaveRequestDetail->lea_hours_total[0], $hourAccuracy, false) . ' ' . lang_strings('hours'));
$block1->contentRow(lang_strings("status"), $statusFile[$status]);
$block1->contentRow(lang_strings("reason"), $leaveRequestDetail->lea_comments[0]);
setupCustomFieldsHTML($block1, 'leave_requests', $id);
$block1->closeContent();
$block1->closeToggle();

if ($status != enumFileStatus::stNoApprovalsNeeded) {
    $block1->headingToggle(lang_strings("approval_history"));
    $block1->openContent();
    $querymore = " WHERE dap.docid='$id' AND dap.doctype='leave_requests' ORDER BY dap.id";
    $listDocumentsApproval = new request();
    $listDocumentsApproval->openDocumentsApproval($querymore);
    $comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

    for ($i=0; $i<$comptListDocumentsApproval; $i++) {
        if ($i == 0) {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['submit_at']) . '</i>';
        } else {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['resubmit_at']) . '</i>';
        }

        $querymore = " WHERE daa.document_approval=" . $listDocumentsApproval->dap_id[$i] . " AND daa.status<>'" . enumApprovalStatus::stPending . "' ORDER BY daa.created,daa.modified";
        $listDocumentsApprovalAuthorizer = new request();
        $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($querymore);
        $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

        for ($j=0,$right=''; $j<$comptListDocumentsApprovalAuthorizer; $j++,$right.='<br>') {
            $ahd = '';

            if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stApproved) {
                $ahd = $strings['approval_history_approved'];
            } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stNotApproved) {
                $ahd = $strings['approval_history_rejected'];
            }

            if ($ahd != '') {
                $ahd0 = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
                $ahd1 = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j], 'both'), $ahd0);
                $right .= '<i>' . $ahd1  . '</i>';

                if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                    $right .= '<br>' . $listDocumentsApprovalAuthorizer->daa_comments[$j];
                }
            }
        }

        $block1->contentRow($left, $right);
    }

    $block1->closeContent();
    $block1->closeToggle();
}

$block1->closeForm();

if ($status != enumFileStatus::stNeedsApproval && !periodLocked($leaveRequestDetail->lea_date_start[0], $leaveRequestDetail->lea_date_end[0])) {
    $block1->openPaletteScript();

    if ($owner == $idSession || $SW_Permissions['Leave Request']['Admin'][$profilSession]) {
        $block1->paletteScript(0, "remove", "../leaves/deleteleaverequests.php?id=$id&fyear=$fyear&serialno=$serialno&sdate=$sdate&id=$id", "true,true,true", $strings["delete"]);
    }

    if ($owner == $idSession || $SW_Permissions['Leave Request']['Edit'][$profilSession]) {
        $block1->paletteScript(1, "edit", "../leaves/editleaverequest.php?id=$id&fyear=$fyear&serialno=$serialno&sdate=$sdate&id=$id", "true,true,true", $strings["edit"]);
    }

    $block1->closePaletteScript("", "");
}

if ($fileManagement == "true" && $SW_Permissions['File']['Read'][$profilSession]) {
    $block2 = new block();
    $block2->form = "tdC";
    $block2->openForm("../expenses/viewexpense.php?id=$id#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings("linked_content"), !($toggle_focus=='linked_content'));
    $block2->borne = $blockPage->returnBorne('1');
    $block2->rowsLimit = 12;
    $sortingUser['leaverequest_files'] = 'fil.name ASC';

    if (isset($sortingUser['leaverequest_files']) && strstr($sortingUser['leaverequest_files'], 'fil.published') !== false) {
        $sortingUser['leaverequest_files'] = 'fil.name ASC';
    }

    $block2->sorting("leaverequest_files", (isset($sortingUser['leaverequest_files'])?$sortingUser['leaverequest_files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status'));
    $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtLeaveRequest . "' AND fil.doc_id=$id AND fil.vc_parent=0 ORDER BY " . $block2->sortingValue;
    $recordsTotal = compt($initrequest['files'] . $querymore);
    $block2->recordsTotal = $recordsTotal;
    $listFiles = new request();
    $listFiles->openFiles($querymore, $block2->borne, $block2->rowsLimit);
    $comptListFiles = count($listFiles->fil_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['owner'];
    $columns[1]->field_type = enumFieldType::ftAvatar;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['created'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['approval_tracking'];
    $columns[3]->field_type = enumFieldType::ftText;
    $opt[enumCardviewOption::oTableName] = 'files';
    $opt[enumCardviewOption::oObject] = 'files';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] = "doc_type=" . enumFileRelatedDocumentType::dtLeaveRequest . "&doc_id=$id";

    if ($SW_Permissions['File']['Write'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = "../linkedcontent/addfile.php?doc_type=" . enumFileRelatedDocumentType::dtLeaveRequest . "&doc_id=$id";
    }

    $block2->openCardView($opt);

    for ($i=0; $i<$comptListFiles; $i++) {
        $idStatus = $listFiles->fil_status[$i];
        $content = array(
            $listFiles->fil_name[$i],
            implode(',',
                array(
                    $listFiles->fil_owner[$i],
                    $listFiles->fil_mem_extension_picture[$i],
                    $listFiles->fil_mem_gender[$i])),
            createDate($listFiles->fil_created[$i],'both'),
            $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . enumFileRelatedDocumentType::dtLeaveRequest . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i], $statusFile[$idStatus], 'in')
        );
        $block2->itemCardView($listFiles->fil_id[$i], $content);
    }

    $block2->closeCardView();
    $block2->bornesFooter("1", $blockPage->bornesNumber, "id=$id&toggle_focus=linked_content");
    $block2->closeToggle();
    $block2->closeFormResults();
}

require_once("../includes/footer.php");
