<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: accessfiles.php,v 1.4 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$folder = isset($_GET['folder'])?$_GET['folder']:'';
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');

/**
 * list directory recursively
 *
 * @param string $folders
 * @return void
 */
function list_recursively($folders)
{
    global $files, $idSession;
    $tmpquery = " WHERE fil.parent IN ($folders) AND fil.vc_parent='0' AND fil.dir='" . enumBoolean::bFalse . "'";
    $listFiles = new request();
    $listFiles->openFilesView($idSession, $tmpquery);
    $comptListFiles = count($listFiles->fil_id);

    for ($i=0; $i<$comptListFiles; $i++) {
        if (!in_array($listFiles->fil_id[$i], $files)) {
            $files[] = $listFiles->fil_id[$i];
        }
    }

    $tmpquery = " WHERE fil.parent IN ($folders) AND fil.dir='" . enumBoolean::bTrue . "'";
    $listFolders = new request();
    $listFolders->openFiles($tmpquery);
    $comptListFolders = count($listFolders->fil_id);

    if ($comptListFolders != '0') {
        $subfolders = implode(',', $listFolders->fil_id);
        list_recursively($subfolders);
    }
}

/**
 * Permission check
 */
if ($fileManagement != 'true') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($folder == 'true') {
    $files = array();
    list_recursively(str_replace('**', ',', $id));

    if (count($files) == '0') {
        if (strstr($id, '**') === false) {
            header('Location: ../general/home.php?msg=emptyFolder');
        } else {
            header('Location: ../general/home.php?msg=emptyFolders');
        }

        exit;
    }

    $ids = implode(',', $files);
    $tmpquery = " WHERE fil.id IN ($ids) AND fil.vc_parent='0'";
    $listFiles = new request();
    $listFiles->openFiles($tmpquery);
    $comptListFiles = count($listFiles->fil_id);
} else {
    $ids = str_replace('**', ',', $id);
    $tmpquery = " WHERE fil.id IN ($ids) AND fil.vc_parent='0' AND fil.dir='" . enumBoolean::bFalse . "'";
    $listFiles = new request();
    $listFiles->openFilesView($idSession, $tmpquery);
    $comptListFiles = count($listFiles->fil_id);
    $comptId = count(explode(',', $ids));

    if ($comptListFiles != $comptId) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}


/**
 * get directory name component of path and path depth
 *
 * @param $id
 * @return string
 */
function get_dirname($id)
{
    global $depth;
    $tmpquery = " WHERE fil.id=$id";
    $folderDetail = new request();
    $folderDetail->openFiles($tmpquery);

    if ($folderDetail->fil_parent[0] != '0') {
        $depth += 1;
        return get_dirname($folderDetail->fil_parent[0]) . $folderDetail->fil_name[0] . '/';
    } else {
        return $folderDetail->fil_name[0] . '/';
    }
}


/**
 * Prepare data
 */
$zipfile = 'linkedcontent';
$arraysize = -1;

for ($i=0; $i<$comptListFiles; $i++) {
    $depth = 0;
    $dirname = get_dirname($listFiles->fil_parent[$i]);

    if ($depth > $arraysize) {
        for ($j=$arraysize+1; $j<=$depth; $j++) {
            $names[$j] = array();
            $dirnames[$j] = array();
            $fullpaths[$j] = array();
        }

        $arraysize = $depth;
    }

    $names[$depth][] = $dirname . $listFiles->fil_name[$i];
    $dirnames[$depth][] = $dirname;
    $fullpaths[$depth][] = $listFiles->fil_fullname[$i];
}

// serve the requested files
require_once('../includes/massdownload.php');
