<?php // $Revision: 1.30 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addfile.php,v 1.30 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$doc_type = AddSlashesNOD(isset($_GET['doc_type'])?$_GET['doc_type']:'0');
$doc_type_ex = AddSlashesNOD(isset($_GET['doc_type_ex'])?$_GET['doc_type_ex']:'');
$doc_id = AddSlashesNOD(isset($_GET['doc_id'])?$_GET['doc_id']:'0');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$att1 = isset($_POST['atttmp1'])?$_POST['atttmp1']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$ver = isset($_POST['ver'])?$_POST['ver']:'';
$serialno = '';
$error = '';

/**
 * Permission check
 */
if ($fileManagement != 'true') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($doc_type == '0') {
    if (!$SW_Permissions['File']['Write'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    if ($doc_id != '0') {
        $parent = $doc_id;
        $querymore = " WHERE fil.id='$doc_id' AND fil.dir='" . enumBoolean::bTrue . "'";
        $fileDetail = new request();
        $fileDetail->openFiles($querymore);
        $comptFileDetail = count($fileDetail->fil_id);

        if ($comptFileDetail == '0') {
            header('Location: ../general/permissiondenied.php');
            exit;
        } else {
            $fullname = $fileDetail->fil_fullname[0];
        }
    } else {    // file in root folder is not allowed
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} elseif ($doc_type == enumFileRelatedDocumentType::dtInvoice) {
    $querymore0 = " WHERE inv.id='$doc_id'";
    $invoiceDetail = new request();
    $invoiceDetail->openInvoices($querymore0);

    if (count($invoiceDetail->inv_id) == 0) {
        header('Location: ../invoices/listinvoices.php?msg=permissiondenied' . $urlBornes);
        exit;
    }

    $querymore = " WHERE fil.id='1'";
    $fileDetail = new request();
    $fileDetail->openFiles($querymore);
    $fullname = $fileDetail->fil_fullname[0];
    $parent = '1';
} elseif ($doc_type == enumFileRelatedDocumentType::dtLeaveRequest) {
    $querymore0 = " WHERE lea.id='$doc_id'";
    $leaveRequestDetail = new request();
    $leaveRequestDetail->openLeaveRequests($querymore0);
    $comptLeaveRequestDetail = count($leaveRequestDetail->lea_id);

    if ($comptLeaveRequestDetail == '0') {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $owner = $leaveRequestDetail->lea_owner[0];
    $status = $leaveRequestDetail->lea_status[0];

    if ($serialno == "") {
        $fyear = date('Y', $leaveRequestDetail->lea_date_start[0]);
        $month = date('m', $leaveRequestDetail->lea_date_start[0]);
        $day = date('d', $leaveRequestDetail->lea_date_start[0]);

        if ($periodUnit == 'month') {
            $serialno = intval($month);
        } else {
            $weekday = date("w", mktime(0, 0, 0, $month, $day, $fyear));

            if ($weekday == '0') {
                $sdate = mktime(0, 0, 0, $month, $day-6, $fyear);
            } else {
                $sdate = mktime(0, 0, 0, $month, $day-$weekday+1, $fyear);
            }

            $month = date('n', $sdate);
            $serialno = intval(date("W", $sdate));

            if ($sdate == '12' && $serialno == '1') {
                $fyear += 1;
            } else if ($sdate == '1' && $serialno > '50') {
                $fyear -= 1;
            }
        }
    }

    if ($periodUnit == 'month') {
        $serialname = $monthNameArray[$serialno];
    } else {
        $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    }

    $querymore = " WHERE fil.id='1'";
    $fileDetail = new request();
    $fileDetail->openFiles($querymore);
    $fullname = $fileDetail->fil_fullname[0];
    $parent = '1';
} elseif ($doc_type == enumFileRelatedDocumentType::dtForm) {
    $querymore0 = " WHERE f.id='$doc_id'";
    $formDetail = new request();
    $formDetail->openForms($doc_type_ex, $querymore0);

    if ($formDetail->row_count == '0') {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $tblnam = $doc_type_ex;
    $tbldispnam = tableNameString($tblnam);
    $querymore = " WHERE fil.id='1'";
    $fileDetail = new request();
    $fileDetail->openFiles($querymore);
    $fullname = $fileDetail->fil_fullname[0];
    $parent = '1';
} else {
    switch ($doc_type) {
        case enumFileRelatedDocumentType::dtProject:
            $tmpquery = "SELECT id FROM " . $tablePrefix . "projects WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtPhase:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "phases WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtTask:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "tasks WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtMeeting:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "meetings WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtDiscussion:
            $tmpquery = "SELECT topic.project FROM " . $tablePrefix . "posts pos INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic WHERE pos.id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtNote:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "notes WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtExpense:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "expenses WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtSupportRequest:
            $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_requests req WHERE req.id='$fil_doc_id'";
            break;
        case enumFileRelatedDocumentType::dtSupportPost:
            $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_posts pos INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id WHERE pos.id='$fil_doc_id'";
            break;
        default:
            header('Location: ../general/permissiondenied.php');
            exit;
    }

    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);

    if ($request1->fetch()) {
        $project = ($row[0]);
    } else {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    $request1->close();

    if ($project != '0') {
        $querymore0 = " WHERE pro.id='$project'";
        $projectDetail = new request();
        $projectDetail->openProjects($querymore0);
        $comptProjectDetail = count($projectDetail->pro_id);

        if ($comptProjectDetail == 0) {
            header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
            exit;
        }

        $querymore1 = " WHERE tea.project='$project' AND tea.member='$idSession'";
        $memberDetail = new request();
        $memberDetail->openTeams($querymore1);
        $comptMemberDetail = count($memberDetail->tea_project);

        if ($comptMemberDetail == 0) {
            $querymore = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
        } else {
            $querymore = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
        }

        $permissionDetail = new request();
        $permissionDetail->openProjectPermissions($querymore);
        $comptPermissionDetail = count($permissionDetail->prp_project);

        if ($permissionDetail->prp_add_file[0] != enumBoolean::bTrue) {
            header('Location: ../projects/viewproject.php?toggle_focus=linked_content&id=' . $project . $urlBornes);
            exit;
        }

        $parent = $projectDetail->pro_upload_dir[0];
    } else {
        $parent = '1';
    }

    $querymore = " WHERE fil.id=$parent";
    $fileDetail = new request();
    $fileDetail->openFiles($querymore);
    $fullname = $fileDetail->fil_fullname[0];
}

/**
 * Check fields
 */
if ($action == "add") {
    if ($att1 == '') {
        $error = lang_strings("no_file");
    }

    if ($error == '') {
        $error = checkCustomFields('files', '');
    }
}

/**
 * Actions
 */
if ($action == "add" && $error == "") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($ver == "") {
            $ver = "1.0";
        } else if (strstr($ver, '.') === false) {
            $ver = sprintf('%d.0', intval($ver));
        } else {
            list($major, $minor) = explode('.', $ver);
            $ver = sprintf('%d.%d', intval($major), intval($minor));
        }

        $num = uploadSingleFile($requestAct, '1', $doc_type, $doc_type_ex, $doc_id, $parent, $fullname, $ver, '0', $c, enumPublished::pbNo);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../linkedcontent/viewfile.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex&doc_id=$doc_id&id=$num&msg=addFile" . $urlBornes);
        exit;
    }
}

/**
 * Functions
 */
function item_bread_crumbs($id) {
    global $blockPage, $urlBornes;

    if ($id == '0') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=0" . $urlBornes, lang_strings('documents'), 'in'));
    } else {
        $querymore = " WHERE fil.id='$id'";
        $fileDetail = new request();
        $fileDetail->openFiles($querymore);
        item_bread_crumbs($fileDetail->fil_parent[0]);
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=$id" . $urlBornes, $fileDetail->fil_name[0], 'in'));
    }
}

/**
 * Prepare data
 */
switch ($doc_type) {
    case enumFileRelatedDocumentType::dtPhase:
        $querymore = " WHERE pha.id='$doc_id'";
        $phaseDetail = new request();
        $phaseDetail->openPhases($querymore);
        break;
    case enumFileRelatedDocumentType::dtTask:
        $querymore = " WHERE tas.id='$doc_id'";
        $taskDetail = new request();
        $taskDetail->openTasks($querymore);

        if ($projectDetail->pro_phase_set[0] != "0") {
            $querymore = " WHERE pha.project='$project' AND pha.order_num='" . $taskDetail->tas_parent_phase[0] . "'";
            $targetPhase = new request();
            $targetPhase->openPhases($querymore);
        }

        break;
    case enumFileRelatedDocumentType::dtMeeting:
        $querymore = " WHERE mee.id='$doc_id'";
        $meetingDetail = new request();
        $meetingDetail->openMeetings($querymore);
        break;
    case enumFileRelatedDocumentType::dtDiscussion:
        $querymore = " WHERE pos.id='$doc_id'";
        $postDetail = new request();
        $postDetail->openPosts($querymore);
        break;
    case enumFileRelatedDocumentType::dtNote:
        $querymore = " WHERE note.id='$doc_id'";
        $noteDetail = new request();
        $noteDetail->openNotes($querymore);
        break;
    case enumFileRelatedDocumentType::dtExpense:
        $querymore = " WHERE exp.id='$doc_id'";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($querymore);
        break;
    case enumFileRelatedDocumentType::dtSupportRequest:
        $querymore = " WHERE sr.id='$doc_id'";
        $supportRequestDetail = new request();
        $supportRequestDetail->openSupportRequests($querymore);
    case enumFileRelatedDocumentType::dtSupportPost:
        $querymore = " WHERE sp.id='$doc_id'";
        $supportPostDetail = new request();
        $supportPostDetail->openSupportPosts($querymore);
        break;
}

if ($error == '') {
    $ver = '1.0';
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($doc_type == '0') {
    item_bread_crumbs($parent);
} elseif ($doc_type == enumFileRelatedDocumentType::dtInvoice) {
    $blockPage->itemBreadcrumbs(lang_strings("accounting"));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/listinvoices.php?" . $urlBornes, lang_strings("invoices"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../invoices/viewinvoice.php?id=' . $doc_id . $urlBornes, $invoiceDetail->inv_invoice_no[0], 'in'));
} elseif ($doc_type == enumFileRelatedDocumentType::dtLeaveRequest) {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate" . $urlBornes, lang_strings('timesheet'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate" . $urlBornes, "$serialname $fyear", 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/viewleaverequest.php?id=$doc_id&amp;fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate&amp;toggle_focus=linked_content" . $urlBornes, lang_strings("leave_request") . " #$doc_id", 'in'));
} elseif ($doc_type == enumFileRelatedDocumentType::dtForm) {
    $blockPage->itemBreadcrumbs(lang_strings('forms'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/listforms.php?tblnam=' . $tblnam . $urlBornes, $tbldispnam, 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/viewform.php?tblnam=' . $tblnam . '&id=' . $doc_id . $urlBornes, HtmlEntityDecodeNOD($formDetail->rows[0]['description']), 'in'));
} else {
    if ($project != '0') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=linked_content&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
    }

    switch ($doc_type) {
        case enumFileRelatedDocumentType::dtPhase:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project" . $urlBornes, lang_strings("phases"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $phaseDetail->pha_id[0] . $urlBornes, $phaseDetail->pha_description[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtTask:
            if ($projectDetail->pro_phase_set[0] != "0") {
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project" . $urlBornes, lang_strings("phases"), 'in'));
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $targetPhase->pha_id[0] . $urlBornes, $targetPhase->pha_description[0], 'in'));
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project" . $urlBornes, lang_strings("tasks"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$doc_id" . $urlBornes, $taskDetail->tas_name[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtMeeting:
            if ($project == '0') {
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$project" . $urlBornes, lang_strings("my_meetings"), 'in'));
            } else {
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$project" . $urlBornes, lang_strings("meetings"), 'in'));
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=$doc_id" . $urlBornes, $meetingDetail->mee_name[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtDiscussion:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/listtopics.php?project=$project" . $urlBornes, lang_strings('discussions'), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/viewtopic.php?id=" . $postDetail->pos_topic[0] . $urlBornes, $postDetail->pos_topic_subject[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtNote:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/listnotes.php?project=$project" . $urlBornes, lang_strings("notes"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/viewnote.php?id=" . $noteDetail->note_id[0] . $urlBornes, $noteDetail->note_subject[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtExpense:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $project . $urlBornes, lang_strings("expenses"), 'in'));

            if ($currencyOnRight == 'true') {
                $amount = $expenseDetail->exp_amount[0] . " " . $expenseDetail->exp_currency[0];
            } else {
                $amount = $expenseDetail->exp_currency[0] . " " . $expenseDetail->exp_amount[0];
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/viewexpense.php?toggle_focus=linked_content&amp;id=" . $expenseDetail->exp_id[0] . $urlBornes, $expenseDetail->exp_ext_name_print[0] . " " . $amount, 'in'));
            break;
        case enumFileRelatedDocumentType::dtSupportRequest:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project" . $urlBornes, lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportRequestDetail->sr_id[0] . $urlBornes, $supportRequestDetail->sr_subject[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtSupportPost:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project" . $urlBornes, lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportPostDetail->sp_request_id[0] . $urlBornes, $supportPostDetail->sp_sr_subject[0], 'in'));
            break;
    }

    $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=$doc_type&doc_id=$doc_id" . $urlBornes, lang_strings("linked_content"), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("add_file"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "adF";
$block1->openForm("../linkedcontent/addfile.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex&doc_id=$doc_id" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="add">';
$block1->heading(lang_strings("add_file"));
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow("*&nbsp;" . lang_strings("upload"), setupUploadFileHTML('1', '', true));
setupInputHTML($block1, lang_strings('comments'), 'c', enumFieldType::ftMemo, 'N', '0', $c);
setupInputHTML($block1, lang_strings('vc_version'), 'ver', array(enumFieldType::ftText, enumFieldOption::foVersionNumber), 'N', '255', $ver);
setupCustomFieldsInputHTML($block1, 'files');
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
