<?php // $Revision: 1.20 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletefiles.php,v 1.20 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$doc_type = isset($_GET['doc_type'])?$_GET['doc_type']:'0';
$doc_type_ex = AddSlashesNOD(isset($_GET['doc_type_ex'])?$_GET['doc_type_ex']:'');
$doc_id = AddSlashesNOD(isset($_GET['doc_id'])?$_GET['doc_id']:'0');
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$sendto = isset($_GET['sendto'])?$_GET['sendto']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = "'" . str_replace('**', "','", $id) . "'";

/**
 * Permission check
 */
if ($fileManagement != 'true') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore = " WHERE fil.id IN ($ids) ORDER BY fil.name";
$listFiles = new request();
$listFiles->openFiles($querymore);
$comptListFiles = count($listFiles->fil_id);

if ($comptListFiles == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($doc_type == '0') {
    if (!$SW_Permissions['File']['Admin'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    $querymore = " WHERE fil.id='$doc_id' AND fil.dir='" . enumBoolean::bTrue . "'";
    $folderDetail = new request();
    $folderDetail->openFiles($querymore);
    $comptFolderDetail = count($folderDetail->fil_id);

    if ($comptFolderDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} elseif ($doc_type == enumFileRelatedDocumentType::dtInvoice) {
    $querymore = " INNER JOIN " . $tablePrefix . "invoices inv ON inv.id=fil.doc_id WHERE fil.id IN ($ids) AND fil.doc_type='" . enumFileRelatedDocumentType::dtInvoice . "'";
    $listInvoiceFiles = new request();
    $listInvoiceFiles->openFiles($querymore);
    $comptListInvoiceFiles = count($listInvoiceFiles->fil_id);

    if ($comptListInvoiceFiles != $comptListFiles) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} elseif ($doc_type == enumFileRelatedDocumentType::dtLeaveRequest) {
    $querymore = " INNER JOIN " . $tablePrefix . "leave_requests lea ON lea.id=fil.doc_id WHERE fil.id IN ($ids) AND fil.doc_type='" . enumFileRelatedDocumentType::dtLeaveRequest . "' AND lea.owner=$idSession";
    $listLeaveRequestFiles = new request();
    $listLeaveRequestFiles->openFiles($querymore);
    $comptListLeaveRequestFiles = count($listLeaveRequestFiles->fil_id);

    if ($comptListLeaveRequestFiles != $comptListFiles) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    $owner = $leaveRequestDetail->lea_owner[0];
    $status = $leaveRequestDetail->lea_status[0];

    if ($serialno == "") {
        $fyear = date('Y', $leaveRequestDetail->lea_date_start[0]);
        $month = date('m', $leaveRequestDetail->lea_date_start[0]);
        $day = date('d', $leaveRequestDetail->lea_date_start[0]);

        if ($periodUnit == 'month') {
            $serialno = intval($month);
        } else {
            $weekday = date("w", mktime(0, 0, 0, $month, $day, $fyear));

            if ($weekday == '0') {
                $sdate = mktime(0, 0, 0, $month, $day-6, $year);
            } else {
                $sdate = mktime(0, 0, 0, $month, $day-$weekday+1, $year);
            }

            $month = date('n', $sdate);
            $serialno = intval(date("W", $sdate));

            if ($sdate == '12' && $serialno == '1') {
                $fyear += 1;
            } else if ($sdate == '1' && $serialno > '50') {
                $fyear -= 1;
            }
        }
    }

    if ($periodUnit == 'month') {
        $serialname = $monthNameArray[$serialno];
    } else {
        $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    }
} elseif ($doc_type == enumFileRelatedDocumentType::dtForm) {
    $querymore = " WHERE f.id IN ($ids)";
    $listForms = new request();
    $listForms->openForms($doc_type_ex, $querymore);

    if ($listForms->row_count != $comptListFiles) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $tblnam = $doc_type_ex;
    $tbldispnam = tableNameString($tblnam);
}

for ($i=0; $i<$comptListFiles; $i++) {
    $fil_doc_type = $listFiles->fil_doc_type[$i];
    $fil_doc_id = $listFiles->fil_doc_id[$i];
    $linkedProject = '0';

    switch ($fil_doc_type) {
        case enumFileRelatedDocumentType::dtProject:
            $tmpquery = "SELECT id FROM " . $tablePrefix . "projects WHERE id=$fil_doc_id";
            break;
        case enumFileRelatedDocumentType::dtPhase:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "phases WHERE id=$fil_doc_id";
            break;
        case enumFileRelatedDocumentType::dtTask:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "tasks WHERE id=$fil_doc_id";
            break;
        case enumFileRelatedDocumentType::dtMeeting:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "meetings WHERE id=$fil_doc_id";
            break;
        case enumFileRelatedDocumentType::dtDiscussion:
            $tmpquery = "SELECT topic.project FROM " . $tablePrefix . "posts pos INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic WHERE pos.id=$fil_doc_id";
            break;
        case enumFileRelatedDocumentType::dtNote:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "notes WHERE id=$fil_doc_id";
            break;
        case enumFileRelatedDocumentType::dtExpense:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "expenses WHERE id=$fil_doc_id";
            break;
        case enumFileRelatedDocumentType::dtSupportRequest:
            $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_requests req WHERE req.id=$fil_doc_id";
            break;
        case enumFileRelatedDocumentType::dtSupportPost:
            $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_posts pos INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id WHERE pos.id=$fil_doc_id";
            break;
        default:
            $tmpquery = '';
    }

    if ($tmpquery != '') {
        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery);

        if ($request1->fetch()) {
            $linkedProject = ($row[0]);
        }

        $request1->close();
    }

    if ($linkedProject != '0') {
        $querymore1 = " WHERE pro.id='$linkedProject'";
        $projectDetail = new request();
        $projectDetail->openProjects($querymore1);
        $comptProjectDetail = count($projectDetail->pro_id);

        if ($comptProjectDetail == 0) {
            header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
            exit;
        }

        $querymore2 = " WHERE tea.project='$linkedProject' AND tea.member='$idSession'";
        $memberDetail = new request();
        $memberDetail->openTeams($querymore2);
        $comptMemberDetail = count($memberDetail->tea_project);

        if ($comptMemberDetail == 0) {
            $querymore = " WHERE prp.project='$linkedProject' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
        } else {
            $querymore = " WHERE prp.project='$linkedProject' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
        }

        $permissionDetail = new request();
        $permissionDetail->openProjectPermissions($querymore);
        $comptPermissionDetail = count($permissionDetail->prp_project);

        if ($action == "publish") {
            if ($permissionDetail->prp_publish_file[0] != enumBoolean::bTrue) {
                header('Location: ../projects/viewproject.php?toggle_focus=linked_content&id=' . $linkedProject . $urlBornes);
                exit;
            }
        } else if ($action == 'delete') {
            if ($permissionDetail->prp_delete_file[0] != enumBoolean::bTrue) {
                header('Location: ../projects/viewproject.php?toggle_focus=linked_content&id=' . $linkedProject . $urlBornes);
                exit;
            }
        } else {
            if ($permissionDetail->prp_view_file[0] != enumBoolean::bTrue) {
                header('Location: ../projects/viewproject.php?toggle_focus=linked_content&id=' . $linkedProject . $urlBornes);
                exit;
            }
        }
    }
}

/**
 * Actions
 */
if ($action == 'delete') {
    $querymore3 = " WHERE fil.id IN ($ids) OR fil.vc_parent IN ($ids)";
    $listFiles1 = new request();
    $listFiles1->openFiles($querymore3);
    $ids1 = "'" . implode("','", $listFiles1->fil_id) . "'";
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        deleteFiles($listFiles->fil_fullname);
        $querymore = " WHERE fil.vc_parent IN ($ids)";
        $listVCFiles = clone $requestAct;
        $listVCFiles->openFiles($querymore);
        $comptListVCFiles = count($listVCFiles->fil_id);

        if ($comptListVCFiles != '0') {
            deleteFiles($listVCFiles->fil_fullname);
        }

        copy2HistoryTable($requestAct, 'files', $ids1, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "files WHERE id IN ($ids) OR vc_parent IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($sendto == "filedetails") {
            if ($listFiles->fil_vc_parent[0] == '0') {
                header('Location: ../linkedcontent/listfiles.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
            } else {
                header('Location: ../linkedcontent/viewfile.php?doc_type=' . $doc_type . '&doc_type_ex=' . $doc_type_ex . '&doc_id=' . $doc_id . '&id=' . $listFiles->fil_vc_parent[0] . '&msg=deleteFile' . $urlBornes);
            }
        } else {
            switch ($doc_type) {
                case enumFileRelatedDocumentType::dtProject:
                    header('Location: ../projects/viewproject.php?toggle_focus=linked_content&id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
                    break;
                case enumFileRelatedDocumentType::dtPhase:
                    header('Location: ../phases/viewphase.php?id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
                    break;
                case enumFileRelatedDocumentType::dtTask:
                    header('Location: ../tasks/viewtask.php?id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
                    break;
                case enumFileRelatedDocumentType::dtMeeting:
                    header('Location: ../meetings/viewmeeting.php?id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
                    break;
                case enumFileRelatedDocumentType::dtDiscussion:
                    $querymore = " WHERE pos.id='$doc_id'";
                    $postDetail = new request();
                    $postDetail->openPosts($querymore);
                    header('Location: ../topics/viewtopics.php?id=' . $postDetail->pos_topic[0] . '&msg=deleteFile' . $urlBornes);
                    break;
                case enumFileRelatedDocumentType::dtNote:
                    header('Location: ../notes/viewnote.php?id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
                    break;
                case enumFileRelatedDocumentType::dtExpense:
                    header('Location: ../expenses/viewexpense.php?id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
                    break;
                case enumFileRelatedDocumentType::dtSupportRequest:
                    $querymore = " WHERE sr.id='$doc_id'";
                    $supportRequestDetail = new request();
                    $supportRequestDetail->openSupportRequests($querymore);
                    header('Location: ../support/viewrequest.php?id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
                    break;
                case enumFileRelatedDocumentType::dtSupportPost:
                    $querymore = " WHERE sp.id='$doc_id'";
                    $supportPostDetail = new request();
                    $supportPostDetail->openSupportPosts($querymore);
                    header('Location: ../support/viewrequest.php?id=' . $supportPostDetail->sp_request_id[0] . '&msg=deleteFile' . $urlBornes);
                    break;
                case enumFileRelatedDocumentType::dtLeaveRequest:
                    header('Location: ../leaves/viewleaverequest.php?id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
                    break;
                case enumFileRelatedDocumentType::dtInvoice:
                    header('Location: ../invoices/viewinvoice.php?id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
                    break;
                case enumFileRelatedDocumentType::dtForm:
                    header('Location: ../forms/viewform.php?tblnam=' . $doc_type_ex . '&id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
                    break;
                default:
                    header('Location: ../linkedcontent/listfiles.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&msg=deleteFile' . $urlBornes);
                    break;
            }
        }

        exit;
    }
}

/**
 * Functions
 */
function item_bread_crumbs($id) {
    global $blockPage, $urlBornes;

    if ($id == '0') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=0" . $urlBornes, lang_strings('documents'), 'in'));
    } else {
        $querymore = " WHERE fil.id='$id'";
        $listFiles = new request();
        $listFiles->openFiles($querymore);
        item_bread_crumbs($listFiles->fil_parent[0]);
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=$id" . $urlBornes, $listFiles->fil_name[0], 'in'));
    }
}

/**
 * Prepare data
 */
switch ($doc_type) {
    case enumFileRelatedDocumentType::dtPhase:
        $querymore = " WHERE pha.id='$doc_id'";
        $phaseDetail = new request();
        $phaseDetail->openPhases($querymore);
        break;
    case enumFileRelatedDocumentType::dtTask:
        $querymore = " WHERE tas.id='$doc_id'";
        $taskDetail = new request();
        $taskDetail->openTasks($querymore);

        if ($projectDetail->pro_phase_set[0] != "0") {
            $querymore = " WHERE pha.project='$project' AND pha.order_num='" . $taskDetail->tas_parent_phase[0] . "'";
            $targetPhase = new request();
            $targetPhase->openPhases($querymore);
        }

        break;
    case enumFileRelatedDocumentType::dtMeeting:
        $querymore = " WHERE mee.id='$doc_id'";
        $meetingDetail = new request();
        $meetingDetail->openMeetings($querymore);
        break;
    case enumFileRelatedDocumentType::dtDiscussion:
        $querymore = " WHERE pos.id='$doc_id'";
        $postDetail = new request();
        $postDetail->openPosts($querymore);
        break;
    case enumFileRelatedDocumentType::dtNote:
        $querymore = " WHERE note.id='$doc_id'";
        $noteDetail = new request();
        $noteDetail->openNotes($querymore);
        break;
    case enumFileRelatedDocumentType::dtExpense:
        $querymore = " WHERE exp.id='$doc_id'";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($querymore);
        break;
    case enumFileRelatedDocumentType::dtSupportRequest:
        $querymore = " WHERE sr.id='$doc_id'";
        $supportRequestDetail = new request();
        $supportRequestDetail->openSupportRequests($querymore);
    case enumFileRelatedDocumentType::dtSupportPost:
        $querymore = " WHERE sp.id='$doc_id'";
        $supportPostDetail = new request();
        $supportPostDetail->openSupportPosts($querymore);
        break;
    case enumFileRelatedDocumentType::dtInvoice:
        $querymore = " WHERE inv.id='$doc_id'";
        $invoiceDetail = new request();
        $invoiceDetail->openInvoices($querymore);
        break;
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($doc_type == '0') {
    item_bread_crumbs($doc_id);
} elseif ($doc_type == enumFileRelatedDocumentType::dtInvoice) {
    $blockPage->itemBreadcrumbs(lang_strings("accounting"));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/listinvoices.php?" . $urlBornes, lang_strings("invoices"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../invoices/viewinvoice.php?id=' . $doc_id . $urlBornes, $invoiceDetail->inv_invoice_no[0], 'in'));
} elseif ($doc_type == enumFileRelatedDocumentType::dtLeaveRequest) {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate" . $urlBornes, lang_strings('timesheet'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate" . $urlBornes, "$serialname $fyear", 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/viewleaverequest.php?id=$doc_id&amp;fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate" . $urlBornes, lang_strings("leave_request") . " #$doc_id", 'in'));
} elseif ($doc_type == enumFileRelatedDocumentType::dtForm) {
    $blockPage->itemBreadcrumbs(lang_strings('forms'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/listforms.php?tblnam=' . $tblnam . $urlBornes, $tbldispnam, 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/viewform.php?tblnam=' . $tblnam . '&id=' . $doc_id . $urlBornes, HtmlEntityDecodeNOD($formDetail->rows[0]['description']), 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=linked_content&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));

    switch ($doc_type) {
        case enumFileRelatedDocumentType::dtPhase:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project" . $urlBornes, lang_strings("phases"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $phaseDetail->pha_id[0] . $urlBornes, $phaseDetail->pha_description[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtTask:
            if ($projectDetail->pro_phase_set[0] != "0") {
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project" . $urlBornes, lang_strings("phases"), 'in'));
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $targetPhase->pha_id[0] . $urlBornes, $targetPhase->pha_description[0], 'in'));
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project" . $urlBornes, lang_strings("tasks"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$doc_id" . $urlBornes, $taskDetail->tas_name[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtMeeting:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$project" . $urlBornes, lang_strings("meetings"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=$doc_id" . $urlBornes, $meetingDetail->mee_name[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtDiscussion:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/listtopics.php?project=$project" . $urlBornes, lang_strings('discussions'), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/viewtopic.php?id=" . $postDetail->pos_topic[0] . $urlBornes, $postDetail->pos_topic_subject[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtNote:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/listnotes.php?project=$project" . $urlBornes, lang_strings("notes"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/viewnote.php?id=" . $noteDetail->note_id[0] . $urlBornes, $noteDetail->note_subject[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtExpense:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $project . $urlBornes, lang_strings("expenses"), 'in'));

            if ($currencyOnRight == 'true') {
                $amount = $expenseDetail->exp_amount[0] . " " . $expenseDetail->exp_currency[0];
            } else {
                $amount = $expenseDetail->exp_currency[0] . " " . $expenseDetail->exp_amount[0];
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/viewexpense.php?id=" . $expenseDetail->exp_id[0] . $urlBornes, $expenseDetail->exp_ext_name_print[0] . " " . $amount, 'in'));
            break;
        case enumFileRelatedDocumentType::dtSupportRequest:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project" . $urlBornes, lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportRequestDetail->sr_id[0] . $urlBornes, $supportRequestDetail->sr_subject[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtSupportPost:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project" . $urlBornes, lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportPostDetail->sp_request_id[0] . $urlBornes, $supportPostDetail->sp_sr_subject[0], 'in'));
            break;
    }

    $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=$doc_type&doc_id=$doc_id" . $urlBornes, lang_strings("linked_content"), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("unlink_files"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "delF";
$block1->openForm("../linkedcontent/deletefiles.php?doc_type=$doc_type&doc_type_ex=$doc_type_ex&doc_id=$doc_id&id=$id&sendto=$sendto" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="delete">';
$block1->heading(lang_strings("unlink_files"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListFiles; $i++) {
    $block1->contentRow('', $listFiles->fil_name[$i]);
}

$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["delete"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
