<?php // $Revision: 1.11 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletefolder.php,v 1.11 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$parent = AddSlashesNOD(isset($_GET['parent'])?$_GET['parent']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if ($fileManagement != 'true') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (!$SW_Permissions['File']['Admin'][$profilSession] || $id == '0' || $id == '1') {
    header("Location: ../general/permissiondenied.php");
    exit;
}


if ($parent != '0') {
    $querymore = " WHERE fil.id='$parent' AND fil.dir='" . enumBoolean::bTrue . "'";
    $parentDetail = new request();
    $parentDetail->openFiles($querymore);
    $comptParentDetail = count($parentDetail->fil_id);

    if ($comptParentDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

$querymore = " WHERE fil.id='$id' AND fil.dir='" . enumBoolean::bTrue . "'";
$folderDetail = new request();
$folderDetail->openFiles($querymore);
$comptFolderDetail = count($folderDetail->fil_id);

if ($comptFolderDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($folderDetail->fil_parent[0] != $parent) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Functions
 */
function item_bread_crumbs($id, $buildLink = true) {
    global $blockPage, $urlBornes;

    if ($id == '0') {
        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=0" . $urlBornes, lang_strings('documents'), 'in'));
        } else {
            $blockPage->itemBreadcrumbs(lang_strings('documents'));
        }
    } else {
        $querymore = " WHERE fil.id='$id'";
        $fileDetail = new request();
        $fileDetail->openFiles($querymore);
        item_bread_crumbs($fileDetail->fil_parent[0]);

        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=$id" . $urlBornes, $fileDetail->fil_name[0], 'in'));
        } else {
            $blockPage->itemBreadcrumbs($fileDetail->fil_name[0]);
        }
    }
}

function subfolder($id) {
    global $ida;
    $querymore = " WHERE fil.parent='$id'";
    $listFiles = new request();
    $listFiles->openFiles($querymore);
    $comptListFiles = count($listFiles->fil_id);

    for ($i=0; $i<$comptListFiles; $i++) {
        if ($listFiles->fil_dir[$i] == enumBoolean::bTrue) {
            subfolder($listFiles->fil_id[$i]);
        }

        $ida[] = $listFiles->fil_id[$i];
    }
}

/**
 * Actions
 */
if ($action == 'delete') {
    $ida[] = $id;
    subfolder($id);
    $ids = "'" . implode("','", $ida) . "'";
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'files', $ids, 'D');
        $tmpsql = 'DELETE FROM ' . $tablePrefix . "files WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        delDir($folderDetail->fil_fullname[0]);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../linkedcontent/listfiles.php?doc_type=0&doc_id=' . $parent . '&msg=delete' . $urlBornes);
        exit;
    }
}

/**
 * Prepare data
 */
$tmpquery = "SELECT * FROM " . $tablePrefix . "files WHERE dir='" . enumBoolean::bTrue . "' AND parent='$id'";
$folders = compt($tmpquery);
$tmpquery = "SELECT * FROM " . $tablePrefix . "files WHERE vc_parent=0 AND dir='" . enumBoolean::bFalse . "' AND parent='$id'";
$files = compt($tmpquery);

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
item_bread_crumbs($id);
$blockPage->itemBreadcrumbs(lang_strings('delete_folder'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'dFo';
$block1->openForm("../linkedcontent/deletefolder.php?parent=$parent&id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings('delete_folder'));
$block1->openContent();
$block1->contentTitle(lang_strings('delete_following'));
$block1->contentRow(lang_strings("name"), $folderDetail->fil_name[0]);
$block1->contentRow(lang_strings("description"), $folderDetail->fil_comments[0]);
$block1->contentRow(lang_strings("size"), convertSize(folder_size($folderDetail->fil_id[0])));
$block1->contentRow(lang_strings("contains"), $folders . '&nbsp;' . lang_strings("folders") . ",&nbsp;&nbsp;" . $files . '&nbsp;' . lang_strings("files"));
$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
require_once('../includes/footer.php');
