<?php // $Revision: 1.15 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editfile.php,v 1.15 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$doc_type = isset($_GET['doc_type'])?$_GET['doc_type']:'0';
$doc_id = AddSlashesNOD(isset($_GET['doc_id'])?$_GET['doc_id']:$id);
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$error = '';

/**
 * Permission check
 */
if ($fileManagement != 'true') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore = " WHERE fil.id='$id'";
$fileDetail = new request();
$fileDetail->openFiles($querymore);
$comptFileDetail = count($fileDetail->fil_id);

if ($comptFileDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

switch ($fileDetail->fil_doc_type[0]) {
    case enumFileRelatedDocumentType::dtProject:
        $tmpquery = "SELECT id FROM " . $tablePrefix . "projects WHERE id='" . $fileDetail->fil_doc_id[0] . "'";
        break;
    case enumFileRelatedDocumentType::dtPhase:
        $tmpquery = "SELECT project FROM " . $tablePrefix . "phases WHERE id='" . $fileDetail->fil_doc_id[0] . "'";
        break;
    case enumFileRelatedDocumentType::dtTask:
        $tmpquery = "SELECT project FROM " . $tablePrefix . "tasks WHERE id='" . $fileDetail->fil_doc_id[0] . "'";
        break;
    case enumFileRelatedDocumentType::dtMeeting:
        $tmpquery = "SELECT project FROM " . $tablePrefix . "meetings WHERE id='" . $fileDetail->fil_doc_id[0] . "'";
        break;
    case enumFileRelatedDocumentType::dtDiscussion:
        $tmpquery = "SELECT topic.project FROM " . $tablePrefix . "posts pos INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic WHERE pos.id='" . $fileDetail->fil_doc_id[0] . "'";
        break;
    case enumFileRelatedDocumentType::dtNote:
        $tmpquery = "SELECT project FROM " . $tablePrefix . "notes WHERE id='" . $fileDetail->fil_doc_id[0] . "'";
        break;
    case enumFileRelatedDocumentType::dtExpense:
        $tmpquery = "SELECT project FROM " . $tablePrefix . "expenses WHERE id='" . $fileDetail->fil_doc_id[0] . "'";
        break;
    case enumFileRelatedDocumentType::dtSupportRequest:
        $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_requests req WHERE req.id='" . $fileDetail->fil_doc_id[0] . "'";
        break;
    case enumFileRelatedDocumentType::dtSupportPost:
        $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_posts pos INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id WHERE pos.id='" . $fileDetail->fil_doc_id[0] . "'";
        break;
    default:
        $tmpquery = '';
}

if ($tmpquery === '') {
    if (!$SW_Permissions['File']['Edit'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} else {
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);

    if ($request1->fetch()) {
        $project = ($row[0]);
    } else {
        $project = '0';
    }

    $request1->close();
    $querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore2);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore3);

    if (!isset($permissionDetail->prp_update_file[0]) || $permissionDetail->prp_update_file[0]!=enumBoolean::bTrue) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}
if ($action == 'update') {
    $error = checkCustomFields('files', $id);
}

/**
 * Actions
 */
if ($error == '' && $action == 'update') {
    $c = HtmlEntitiesNOD($c);
    $cfsql = setupCustomFieldsUpdateSQL('files', $id);  // Generate custom fields update sql
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "UPDATE " . $tablePrefix . "files SET comments='$c'$cfsql WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'files', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../linkedcontent/viewfile.php?doc_type=$doc_type&doc_id=$doc_id&id=$id&msg=update" . $urlBornes);
        exit;
    }
}

/**
 * Set value in form
 */
if ($error == '') {
    $c = $fileDetail->fil_comments[0];
}

$type = file_info_type($fileDetail->fil_extension[0]);
$displayname = $fileDetail->fil_name[0];

switch ($doc_type) {
    case enumFileRelatedDocumentType::dtPhase:
        $querymore = " WHERE pha.id='$doc_id'";
        $phaseDetail = new request();
        $phaseDetail->openPhases($querymore);
        break;
    case enumFileRelatedDocumentType::dtTask:
        $querymore = " WHERE tas.id='$doc_id'";
        $taskDetail = new request();
        $taskDetail->openTasks($querymore);

        if ($projectDetail->pro_phase_set[0] != "0") {
            $querymore = " WHERE pha.project='$linkedProject' AND pha.order_num='" . $taskDetail->tas_parent_phase[0] . "'";
            $targetPhase = new request();
            $targetPhase->openPhases($querymore);
        }

        break;
    case enumFileRelatedDocumentType::dtMeeting:
        $querymore = " WHERE mee.id='$doc_id'";
        $meetingDetail = new request();
        $meetingDetail->openMeetings($querymore);
        break;
    case enumFileRelatedDocumentType::dtDiscussion:
        $querymore = " WHERE pos.id='$doc_id'";
        $postDetail = new request();
        $postDetail->openPosts($querymore);
        break;
    case enumFileRelatedDocumentType::dtNote:
        $querymore = " WHERE note.id='$doc_id'";
        $noteDetail = new request();
        $noteDetail->openNotes($querymore);
        break;
    case enumFileRelatedDocumentType::dtExpense:
        $querymore = " WHERE exp.id='$doc_id'";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($querymore);
        break;
    case enumFileRelatedDocumentType::dtSupportRequest:
        $querymore = " WHERE sr.id='$doc_id'";
        $supportRequestDetail = new request();
        $supportRequestDetail->openSupportRequests($querymore);
    case enumFileRelatedDocumentType::dtSupportPost:
        $querymore = " WHERE sp.id='$doc_id'";
        $supportPostDetail = new request();
        $supportPostDetail->openSupportPosts($querymore);
        break;
    case enumFileRelatedDocumentType::dtInvoice:
        $querymore = " WHERE inv.id='$doc_id'";
        $invoiceDetail = new request();
        $invoiceDetail->openInvoices($querymore);
        break;
}

/**
 * Functions
 */
function item_bread_crumbs($id) {
    global $blockPage, $urlBornes;

    if ($id == '0') {
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=0" . $urlBornes, lang_strings('documents'), 'in'));
    } else {
        $querymore = " WHERE fil.id='$id'";
        $fileDetail = new request();
        $fileDetail->openFiles($querymore);
        item_bread_crumbs($fileDetail->fil_parent[0]);
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&doc_id=$id" . $urlBornes, $fileDetail->fil_name[0], 'in'));
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($doc_type == '0') {
    item_bread_crumbs($doc_id);
} elseif ($doc_type == enumFileRelatedDocumentType::dtInvoice) {
    $blockPage->itemBreadcrumbs(lang_strings("accounting"));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../invoices/listinvoices.php?" . $urlBornes, lang_strings("invoices"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../invoices/viewinvoice.php?id=' . $doc_id . $urlBornes, $invoiceDetail->inv_invoice_no[0], 'in'));
} elseif ($doc_type == enumFileRelatedDocumentType::dtLeaveRequest) {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate" . $urlBornes, lang_strings('timesheet'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate" . $urlBornes, "$serialname $fyear", 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/viewleaverequest.php?id=$doc_id&amp;fyear=$fyear&amp;serialno=$serialno&amp;sdate=$sdate" . $urlBornes, lang_strings("leave_request") . " #$doc_id", 'in'));
} elseif ($doc_type == enumFileRelatedDocumentType::dtForm) {
    $blockPage->itemBreadcrumbs(lang_strings('forms'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/listforms.php?tblnam=' . $tblnam . $urlBornes, $tbldispnam, 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../forms/viewform.php?tblnam=' . $tblnam . '&id=' . $doc_id . $urlBornes, HtmlEntityDecodeNOD($formDetail->rows[0]['description']), 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=linked_content&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));

    switch ($doc_type) {
        case enumFileRelatedDocumentType::dtPhase:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$linkedProject" . $urlBornes, lang_strings("phases"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$linkedProject&id=" . $phaseDetail->pha_id[0] . $urlBornes, $phaseDetail->pha_description[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtTask:
            if ($projectDetail->pro_phase_set[0] != "0") {
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$linkedProject" . $urlBornes, lang_strings("phases"), 'in'));
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$linkedProject&id=" . $targetPhase->pha_id[0] . $urlBornes, $targetPhase->pha_description[0], 'in'));
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$linkedProject" . $urlBornes, lang_strings("tasks"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$doc_id" . $urlBornes, $taskDetail->tas_name[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtMeeting:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$linkedProject" . $urlBornes, lang_strings("meetings"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=$doc_id" . $urlBornes, $meetingDetail->mee_name[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtDiscussion:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/listtopics.php?project=$linkedProject" . $urlBornes, lang_strings('discussions'), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/viewtopic.php?id=" . $postDetail->pos_topic[0] . $urlBornes, $postDetail->pos_topic_subject[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtNote:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/listnotes.php?project=$linkedProject" . $urlBornes, lang_strings("notes"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/viewnote.php?id=" . $noteDetail->note_id[0] . $urlBornes, $noteDetail->note_subject[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtExpense:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $linkedProject . $urlBornes, lang_strings("expenses"), 'in'));

            if ($currencyOnRight == 'true') {
                $amount = $expenseDetail->exp_amount[0] . " " . $expenseDetail->exp_currency[0];
            } else {
                $amount = $expenseDetail->exp_currency[0] . " " . $expenseDetail->exp_amount[0];
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/viewexpense.php?id=" . $expenseDetail->exp_id[0] . $urlBornes, $expenseDetail->exp_ext_name_print[0] . " " . $amount, 'in'));
            break;
        case enumFileRelatedDocumentType::dtSupportRequest:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$linkedProject" . $urlBornes, lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportRequestDetail->sr_id[0] . $urlBornes, $supportRequestDetail->sr_subject[0], 'in'));
            break;
        case enumFileRelatedDocumentType::dtSupportPost:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$linkedProject" . $urlBornes, lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportPostDetail->sp_request_id[0] . $urlBornes, $supportPostDetail->sp_sr_subject[0], 'in'));
            break;
    }

    $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=$doc_type&doc_id=$doc_id" . $urlBornes, lang_strings("linked_content"), 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/viewfile.php?doc_type=$doc_type&doc_id=$doc_id&id=$id" . $urlBornes, $fileDetail->fil_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings('edit_file'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "eFi";
$block1->openForm("../linkedcontent/editfile.php?doc_type=$doc_type&doc_id=$doc_id&id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
$block1->heading(lang_strings('edit_file') . ' : ' . $fileDetail->fil_name[0]);
$block1->openContent();
$block1->contentTitle(lang_strings('details'));
$block1->contentRow(lang_strings('name'), $block1->buildLink("../linkedcontent/viewfile.php?doc_type=$doc_type&doc_id=$doc_id&id=$id" . $urlBornes, $fileDetail->fil_name[0], 'in'));
setupInputHTML($block1, lang_strings('description'), 'c', enumFieldType::ftMemo, 'N', '0', $c);
setupCustomFieldsInputHTML($block1, 'files', $id);
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once('../includes/footer.php');
