<?php // $Revision: 1.15 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editfolder.php,v 1.15 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
$bodyCommand = 'onLoad="document.eFoForm.nm.focus();"';

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$parent = AddSlashesNOD(isset($_GET['parent'])?$_GET['parent']:'0');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$nm = isset($_POST['nm'])?$_POST['nm']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$error = '';

/**
 * Permission check
 */
if ($fileManagement != 'true') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($id == '') {
    if (!$SW_Permissions['File']['Write'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
} else {
    if (!$SW_Permissions['File']['Edit'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

if ($parent != '0') {
    $querymore = " WHERE fil.id='$parent' AND fil.dir='" . enumBoolean::bTrue . "'";
    $parentDetail = new request();
    $parentDetail->openFiles($querymore);
    $comptParentDetail = count($parentDetail->fil_id);

    if ($comptParentDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    } else {
        $path = $parentDetail->fil_fullname[0] . '/';
    }
} else {
    $path = '';
}

if ($id != '') {
    $querymore = " WHERE fil.id='$id' AND fil.dir='" . enumBoolean::bTrue . "'";
    $folderDetail = new request();
    $folderDetail->openFiles($querymore);
    $comptFolderDetail = count($folderDetail->fil_id);

    if ($comptFolderDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    if ($folderDetail->fil_parent[0] != $parent) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

if ($action == 'add' || $action == 'update') {
    $error = checkCustomFields('files', $id);
}

/**
 * Actions
 */
if ($error == '' && ($action == 'add' || $action == 'update')) {
    $nm = HtmlEntitiesNOD($nm);
    $c = HtmlEntitiesNOD($c);

    if ($action == 'add') {
        $cfsqls = setupCustomFieldsInsertSQL('files');  // Generate custom fields insert sql
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "files (owner,doc_type,doc_type_ex,doc_id,name,size,comments,published,status,vc_status,vc_version,vc_parent,dir,parent,project,created,cuser" . $cfsqls[0] . ") VALUES ('$idSession','0','','0','$nm','0','$c','" . enumPublished::pbNo . "','0','','','0','" . enumBoolean::bTrue . "','$parent','0','" . time() . "','$idSession'" . $cfsqls[1] . ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('files');
            $cfsql = setupCustomMediaFieldsUpdateSQL('files', $num);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "files SET $cfsql WHERE id='$num'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $fullname = $path . urlencode($nm) . '--' . $num;
            createDir($fullname);
            $tmpsql = "UPDATE " . $tablePrefix . "files SET fullname='$fullname' WHERE id='$num'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'files', $num, 'A');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../linkedcontent/listfiles.php?doc_type=0&doc_id=$num&id=$num&msg=add" . $urlBornes);
            exit;
        }
    } else if ($action == 'update') {
        $cfsql = setupCustomFieldsUpdateSQL('files', $id);  // Generate custom fields update sql
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "files SET name='$nm',comments='$c'$cfsql WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'files', $id, 'U');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../linkedcontent/listfiles.php?doc_type=0&doc_id=$id&id=$id&msg=update" . $urlBornes);
            exit;
        }
    }
}

/**
 * Set value in form
 */
if ($error == '') {
    if ($id != '') {
        $nm = $folderDetail->fil_name[0];
        $c = $folderDetail->fil_comments[0];
    }
}

/**
 * Functions
 */
function item_bread_crumbs($id, $buildLink = true) {
    global $blockPage, $urlBornes;

    if ($id == '0') {
        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=0" . $urlBornes, lang_strings('documents'), 'in'));
        } else {
            $blockPage->itemBreadcrumbs(lang_strings('documents'));
        }
    } else {
        $querymore = " WHERE fil.id='$id'";
        $fileDetail = new request();
        $fileDetail->openFiles($querymore);
        item_bread_crumbs($fileDetail->fil_parent[0]);

        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=$id" . $urlBornes, $fileDetail->fil_name[0], 'in'));
        } else {
            $blockPage->itemBreadcrumbs($fileDetail->fil_name[0]);
        }
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($id == '') {
    item_bread_crumbs($parent);
    $blockPage->itemBreadcrumbs(lang_strings('add_folder'));
} else {
    item_bread_crumbs($id);
    $blockPage->itemBreadcrumbs(lang_strings('edit_folder'));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "eFo";

if ($id == '') {
    $block1->openForm("../linkedcontent/editfolder.php?parent=$parent" . $urlBornes . "#" . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
} else {
    $block1->openForm("../linkedcontent/editfolder.php?parent=$parent&id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
}

if ($id == '') {
    $block1->heading(lang_strings('add_folder'));
} else {
    $block1->heading(lang_strings('edit_folder') . ' : ' . $folderDetail->fil_name[0]);
}

$block1->openContent();
$block1->contentTitle(lang_strings('details'));
setupInputHTML($block1, lang_strings("name"), 'nm', enumFieldType::ftText, 'Y', '255', $nm);
setupInputHTML($block1, lang_strings('description'), 'c', enumFieldType::ftMemo, 'N', '0', $c);
setupCustomFieldsInputHTML($block1, 'files', $id);
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once('../includes/footer.php');
