<?php // $Revision: 1.21 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listfiles.php,v 1.21 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$doc_type = isset($_GET['doc_type'])?$_GET['doc_type']:'0';
$doc_id = AddSlashesNOD(isset($_GET['doc_id'])?$_GET['doc_id']:$id);
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSiteFile = isset($_GET['addToSiteFile'])?$_GET['addToSiteFile']:'';
$removeToSiteFile = isset($_GET['removeToSiteFile'])?$_GET['removeToSiteFile']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$error = '';

/**
 * Permission check
 */
if ($fileManagement != 'true') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($doc_type == '0') {
    if (!$SW_Permissions['File']['Read'][$profilSession]) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    if ($doc_id != '0') {
        $querymore = " WHERE fil.id='$doc_id' AND fil.dir='" . enumBoolean::bTrue . "'";
        $fileDetail = new request();
        $fileDetail->openFiles($querymore);
        $comptFileDetail = count($fileDetail->fil_id);

        if ($comptFileDetail == '0') {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    }
} else if ($doc_type == enumFileRelatedDocumentType::dtLeaveRequest || $doc_type == enumFileRelatedDocumentType::dtForm) {
    header('Location: ../general/permissiondenied.php');
    exit;
} else {
    switch ($doc_type) {
        case enumFileRelatedDocumentType::dtProject:
            $tmpquery = "SELECT id FROM " . $tablePrefix . "projects WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtPhase:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "phases WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtTask:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "tasks WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtMeeting:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "meetings WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtDiscussion:
            $tmpquery = "SELECT topic.project FROM " . $tablePrefix . "posts pos INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic WHERE pos.id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtNote:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "notes WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtExpense:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "expenses WHERE id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtSupportRequest:
            $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_requests req WHERE req.id='$doc_id'";
            break;
        case enumFileRelatedDocumentType::dtSupportPost:
            $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_posts pos INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id WHERE pos.id='$doc_id'";
            break;
        default:
            header('Location: ../general/permissiondenied.php');
            exit;
    }

    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);

    if ($request1->fetch()) {
        $project = ($row[0]);
    } else {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    $request1->close();
    $querymore1 = " WHERE pro.id='$project'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore1);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    $querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore2);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore3);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if (!$SW_Permissions['Project']['Admin'][$profilSession] && $permissionDetail->prp_view_file[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?toggle_focus=linked_content&id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }
}

/**
 * Actions
 */
if ($action == "publish") {
    $ids = "'" . str_replace('**', "','", $id) . "'";
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($addToSiteFile == 'true') {
            $tmpsql = 'UPDATE ' . $tablePrefix . "files SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids) OR vc_parent IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = 'addToSite';
        } else if ($removeToSiteFile == 'true') {
            $tmpsql = 'UPDATE ' . $tablePrefix . "files SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids) OR vc_parent IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = 'removeToSite';
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
}

/**
 * Functions
 */
function item_bread_crumbs($id, $buildLink = true) {
    global $blockPage, $urlBornes;

    if ($id == '0') {
        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=0" . $urlBornes, lang_strings('documents'), 'in'));
        } else {
            $blockPage->itemBreadcrumbs(lang_strings('documents'));
        }
    } else {
        $querymore = " WHERE fil.id='$id'";
        $fileDetail = new request();
        $fileDetail->openFiles($querymore);
        item_bread_crumbs($fileDetail->fil_parent[0]);

        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=$id" . $urlBornes, $fileDetail->fil_name[0], 'in'));
        } else {
            $blockPage->itemBreadcrumbs($fileDetail->fil_name[0]);
        }
    }
}

/**
 * Prepare data
 */
switch ($doc_type) {
    case enumFileRelatedDocumentType::dtPhase:
        $querymore = " WHERE pha.id='$doc_id'";
        $phaseDetail = new request();
        $phaseDetail->openPhases($querymore);
        break;
    case enumFileRelatedDocumentType::dtTask:
        $querymore = " WHERE tas.id='$doc_id'";
        $taskDetail = new request();
        $taskDetail->openTasks($querymore);

        if ($projectDetail->pro_phase_set[0] != "0") {
            $querymore = " WHERE pha.project='$project' AND pha.order_num='" . $taskDetail->tas_parent_phase[0] . "'";
            $targetPhase = new request();
            $targetPhase->openPhases($querymore);
        }

        break;
    case enumFileRelatedDocumentType::dtMeeting:
        $querymore = " WHERE mee.id='$doc_id'";
        $meetingDetail = new request();
        $meetingDetail->openMeetings($querymore);
        break;
    case enumFileRelatedDocumentType::dtDiscussion:
        $querymore = " WHERE pos.id='$doc_id'";
        $postDetail = new request();
        $postDetail->openPosts($querymore);
        break;
    case enumFileRelatedDocumentType::dtNote:
        $querymore = " WHERE note.id='$doc_id'";
        $noteDetail = new request();
        $noteDetail->openNotes($querymore);
        break;
    case enumFileRelatedDocumentType::dtExpense:
        $querymore = " WHERE exp.id='$doc_id'";
        $expenseDetail = new request();
        $expenseDetail->openExpenses($querymore);
        break;
    case enumFileRelatedDocumentType::dtSupportRequest:
        $querymore = " WHERE sr.id='$doc_id'";
        $supportRequestDetail = new request();
        $supportRequestDetail->openSupportRequests($querymore);
    case enumFileRelatedDocumentType::dtSupportPost:
        $querymore = " WHERE sp.id='$doc_id'";
        $supportPostDetail = new request();
        $supportPostDetail->openSupportPosts($querymore);
        break;
    case '0':
        $tmpquery = $initrequest["files"] . " WHERE fil.dir='" . enumBoolean::bTrue . "' AND fil.parent='$doc_id'";
        $folders = compt($tmpquery);
        $tmpquery = str_replace('%member%', $idSession, $initrequest["files_view"]) . " WHERE fil.parent='$doc_id' AND fil.vc_parent='0'";
        $files = compt($tmpquery);
}

if ($toggle_focus == '') {
    if ($doc_type == '0') {
        if ($files > 0) {
            $toggle_focus = 'file';
        } else {
            $toggle_focus = 'folder';
        }
    } else {
        $toggle_focus = 'file';
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($doc_type == '0') {
    item_bread_crumbs($doc_id, false);

    if ($doc_id == '0') {
        $title = '';
    } else {
        $title = $strings["folder"] . " : " . $fileDetail->fil_name[0];
    }
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=linked_content&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));

    switch ($doc_type) {
        case enumFileRelatedDocumentType::dtPhase:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project" . $urlBornes, lang_strings("phases"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $phaseDetail->pha_id[0] . $urlBornes, $phaseDetail->pha_description[0], 'in'));
            $title = $strings['linked_content'] . ' (' . $strings['phase'] . ' ' . $phaseDetail->pha_description[0] . ')';
            break;
        case enumFileRelatedDocumentType::dtTask:
            if ($projectDetail->pro_phase_set[0] != "0") {
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project" . $urlBornes, lang_strings("phases"), 'in'));
                $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $targetPhase->pha_id[0] . $urlBornes, $targetPhase->pha_description[0], 'in'));
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project" . $urlBornes, lang_strings("tasks"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$doc_id" . $urlBornes, $taskDetail->tas_name[0], 'in'));
            $title = $strings['linked_content'] . ' (' . $strings['task'] . ' ' . $taskDetail->tas_name[0] . ')';
            break;
        case enumFileRelatedDocumentType::dtMeeting:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$project" . $urlBornes, lang_strings("meetings"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=$doc_id" . $urlBornes, $meetingDetail->mee_name[0], 'in'));
            $title = $strings['linked_content'] . ' (' . $strings['meeting'] . ' ' . $meetingDetail->mee_name[0] . ')';
            break;
        case enumFileRelatedDocumentType::dtDiscussion:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/listtopics.php?project=$project" . $urlBornes, lang_strings('discussions'), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/viewtopic.php?id=" . $postDetail->pos_topic[0] . $urlBornes, $postDetail->pos_topic_subject[0], 'in'));
            $title = $strings['linked_content'] . ' (' . $strings['discussion'] . ' ' . $postDetail->pos_topic_subject[0] . ')';
            break;
        case enumFileRelatedDocumentType::dtNote:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/listnotes.php?project=$project" . $urlBornes, lang_strings("notes"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/viewnote.php?id=" . $noteDetail->note_id[0] . $urlBornes, $noteDetail->note_subject[0], 'in'));
            $title = $strings['linked_content'] . ' (' . $strings['note'] . ' ' . $noteDetail->note_subject[0] . ')';
            break;
        case enumFileRelatedDocumentType::dtExpense:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/listexpenses.php?project=" . $project . $urlBornes, lang_strings("expenses"), 'in'));

            if ($currencyOnRight == 'true') {
                $amount = $expenseDetail->exp_amount[0] . " " . $expenseDetail->exp_currency[0];
            } else {
                $amount = $expenseDetail->exp_currency[0] . " " . $expenseDetail->exp_amount[0];
            }

            $blockPage->itemBreadcrumbs($blockPage->buildLink("../expenses/viewexpense.php?id=" . $expenseDetail->exp_id[0] . $urlBornes, $expenseDetail->exp_ext_name_print[0] . " " . $amount, 'in'));
            $title = $strings['linked_content'] . ' (' . $strings['expense'] . ' ' . $expenseDetail->exp_ext_name_print[0] . ')';
            break;
        case enumFileRelatedDocumentType::dtSupportRequest:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project" . $urlBornes, lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportRequestDetail->sr_id[0] . $urlBornes, $supportRequestDetail->sr_subject[0], 'in'));
            $title = $strings['linked_content'] . ' (' . $strings['support_request'] . ' ' . $supportRequestDetail->sr_subject[0] . ')';
            break;
        case enumFileRelatedDocumentType::dtSupportPost:
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=$project" . $urlBornes, lang_strings("support_requests"), 'in'));
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportPostDetail->sp_request_id[0] . $urlBornes, $supportPostDetail->sp_sr_subject[0], 'in'));
            $title = $strings['linked_content'] . ' (' . $strings['support_request'] . ' ' . $supportPostDetail->sp_sr_subject[0] . ')';
            break;
        default:
            $title = $strings['linked_content'] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
    }

    $blockPage->itemBreadcrumbs(lang_strings("linked_content"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '16';

if ($title != '') {
    logURL($title, "../linkedcontent/listfiles.php?id=$id&doc_type=$doc_type&doc_id=$doc_id");
}

if ($doc_type == '0' && $doc_id != '0') {
    $block1 = new block();
    $block1->form = "vvD";
    $block1->openForm("../linkedcontent/listfiles.php?id=$id&doc_type=$doc_type&doc_id=$doc_id" . $urlBornes . "#" . $block1->form . "Anchor");
    $block1->headingToggle(lang_strings("folder") . " : " . $fileDetail->fil_name[0]);
    $block1->openPaletteIcon();

    if ($SW_Permissions['File']['Admin'][$profilSession] && $doc_id != '1') {
        $block1->paletteIcon(0, "remove", $strings["delete"]);
    }

    if ($SW_Permissions['File']['Edit'][$profilSession]) {
        $block1->paletteIcon(1, "edit", $strings["edit"]);
        $block1->paletteIcon(2, "copy", $strings["copy"]);
        $block1->paletteIcon(3, "move", $strings["move"]);
    }

    $block1->paletteIcon(4, "export", $strings["export"]);
    $block1->closePaletteIcon();
    $block1->openContent();
    $block1->contentTitle(lang_strings("info"));
    $block1->contentRow(lang_strings("description"), $fileDetail->fil_comments[0]);
    $block1->contentRow(lang_strings("size"), convertSize(folder_size($fileDetail->fil_id[0])));
    $block1->contentRow(lang_strings("contains"), $folders . '&nbsp;' . lang_strings("folders") . ",&nbsp;&nbsp;" . $files . '&nbsp;' . lang_strings("files"));
    $block1->contentRow(lang_strings("created"), createDate($fileDetail->fil_created[0],'both'));
    setupCustomFieldsHTML($block1, 'files', $fileDetail->fil_id[0]);
    $block1->closeContent();
    $block1->closeToggle();
    $block1->closeForm();
    $block1->openPaletteScript();

    if ($SW_Permissions['File']['Admin'][$profilSession] && $doc_id != '1') {
        $block1->paletteScript(0, "remove", "../linkedcontent/deletefolder.php?parent=" . $fileDetail->fil_parent[0] . "&id=$doc_id" . $urlBornes, "true,true,false", $strings["delete"]);
    }

    if ($SW_Permissions['File']['Edit'][$profilSession]) {
        $block1->paletteScript(1, "edit", "../linkedcontent/editfolder.php?parent=" . $fileDetail->fil_parent[0] . "&id=$doc_id" . $urlBornes, "true,true,false", $strings["edit"]);
        $block1->paletteScript(2, "copy", "../linkedcontent/movefiles.php?cpy=true&parent=" . $fileDetail->fil_parent[0] . "&id=$doc_id" . $urlBornes, "true,true,false", $strings["copy"]);
        $block1->paletteScript(3, "move", "../linkedcontent/movefiles.php?parent=" . $fileDetail->fil_parent[0] . "&id=$doc_id" . $urlBornes, "true,true,false", $strings["move"]);
    }

    $block1->paletteScript(4, "export", "../linkedcontent/accessfiles.php?folder=true&id=" . $fileDetail->fil_parent[0] . $urlBornes, "true,true,true", $strings['export']);
    $block1->closePaletteScript("", "");
}

if ($doc_type != '0' || $doc_id != '0') {
    $block3 = new block();
    $block3->form = "lsF";
    $block3->openForm("../linkedcontent/listfiles.php?doc_type=$doc_type&doc_id=$doc_id" . $urlBornes . "#" . $block3->form . "Anchor");

    if ($doc_type == '0') {
        $block3->headingToggle(lang_strings("files"), !($toggle_focus=='file'));
    } else {
        $block3->headingToggle(lang_strings("linked_content"), !($toggle_focus=='file'));
    }

    $block3->borne = $blockPage->returnBorne('15');
    $block3->rowsLimit = '12';
    $listFiles = new request();

    if ($doc_type == '0') {
        if (isset($sortingUser['files']) && strstr($sortingUser['files'], 'fil.published') !== false) {
            $sortingUser['files'] = 'fil.name ASC';
        }

        $block3->sorting('files', (isset($sortingUser['files'])?$sortingUser['files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.extension', 2 => 'fil.size', 3 => 'fil.created', 4 => 'fil.status'));
        $querymore = " WHERE fil.parent='$doc_id' AND fil.vc_parent='0' ORDER BY " . $block3->sortingValue;
        $sql0 = $initrequest["files_view"];
        $sql = str_replace('%member%', $idSession, $sql0);
        $block3->recordsTotal = compt($sql . ' ' . $querymore);
        $listFiles->openFilesView($idSession, $querymore, $block3->borne, $block3->rowsLimit);
    } else {
        if (!isset($projectDetail->pro_published) || $projectDetail->pro_published[0] == enumPublished::pbYes) {
            $block3->sorting('files', (isset($sortingUser['files'])?$sortingUser['files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.extension', 2 => 'fil.size', 3 => 'fil.created', 4 => 'fil.status', 5 => 'fil.published'));
        } else {
            $block3->sorting('files', (isset($sortingUser['files'])?$sortingUser['files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.extension', 2 => 'fil.size', 3 => 'fil.created', 4 => 'fil.status'));
        }

        if ($doc_type == enumFileRelatedDocumentType::dtProject) {
            $querymore = " WHERE fil.vc_parent='0' ORDER BY " . $block3->sortingValue;
            $sql0 = $initrequest["project_files"];
            $sql = str_replace('%project%', $project, $sql0);
            $block3->recordsTotal = compt($sql . ' ' . $querymore);
            $listFiles->openProjectFiles($project, $querymore, $block3->borne, $block3->rowsLimit);
        } else if ($doc_type == enumFileRelatedDocumentType::dtSupportRequest) {
            $querymore = " WHERE sp.request_id='$doc_id'";
            $listSupportPosts = new request();
            $listSupportPosts->openSupportPosts($querymore);
            $comptListSupportPosts = count($listSupportPosts->sp_id);

            if ($comptListSupportPosts == '0') {
                $querymore = " WHERE doc_type='" . enumFileRelatedDocumentType::dtSupportRequest . "' AND doc_id='$doc_id' AND fil.vc_parent='0' ORDER BY " . $block3->sortingValue;
                $block3->recordsTotal = compt($initrequest["files"] . ' ' . $querymore);
                $listFiles->openFiles($querymore, $block3->borne, $block3->rowsLimit);
            } else {
                $querymore = " WHERE ((doc_type='" . enumFileRelatedDocumentType::dtSupportRequest . "' AND doc_id='$doc_id') OR (doc_type='" . enumFileRelatedDocumentType::dtSupportPost . "' AND doc_id IN (" . implode(',', $listSupportPosts->sp_id) . "))) AND fil.vc_parent='0' ORDER BY " . $block3->sortingValue;
                $block3->recordsTotal = compt($initrequest["files"] . ' ' . $querymore);
                $listFiles->openFiles($querymore, $block3->borne, $block3->rowsLimit);
            }
        } else if ($doc_type == enumFileRelatedDocumentType::dtSupportPost) {
            $querymore = " WHERE sp.request_id='" . $supportPostDetail->sp_request_id[0] . "'";
            $listSupportPosts = new request();
            $listSupportPosts->openSupportPosts($querymore);
            $querymore = " WHERE ((doc_type='" . enumFileRelatedDocumentType::dtSupportRequest . "' AND doc_id='" . $supportPostDetail->sp_request_id[0] . "') OR (doc_type='" . enumFileRelatedDocumentType::dtSupportPost . "' AND doc_id IN (" . implode(',', $listSupportPosts->sp_id) . "))) AND fil.vc_parent='0' ORDER BY " . $block3->sortingValue;
            $block3->recordsTotal = compt($initrequest["files"] . ' ' . $querymore);
            $listFiles->openFiles($querymore, $block3->borne, $block3->rowsLimit);
        } else {
            $querymore = " WHERE doc_type='$doc_type' AND doc_id=$doc_id AND fil.vc_parent='0' ORDER BY " . $block3->sortingValue;
            $block3->recordsTotal = compt($initrequest["files"] . ' ' . $querymore);
            $listFiles->openFiles($querymore, $block3->borne, $block3->rowsLimit);
        }
    }

    $comptListFiles = count($listFiles->fil_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['FIE__files_extension'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['size'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['created'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['approval_tracking'];
    $columns[4]->field_type = enumFieldType::ftText;

    if (($doc_type !== '0') && (!isset($projectDetail->pro_published) || $projectDetail->pro_published[0] == enumPublished::pbYes) && $sitePublish == 'true') {
        $columns[5] = new cardviewColumn();
        $columns[5]->title = $strings['published'];
        $columns[5]->field_type = enumFieldType::ftText;
    }

    $opt[enumCardviewOption::oTableName] = 'files';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oObject] = 'files';
    $opt[enumCardviewOption::oExtraParameters] = "doc_type=$doc_type&doc_id=$doc_id" . $urlBornes . "&borne15=" . $block3->borne;
    $opt[enumCardviewOption::oSearch] = true;

    if ($doc_type == '0') {
        if ($SW_Permissions['File']['Write'][$profilSession]) {
            $opt[enumCardviewOption::oAddUrl] = '../linkedcontent/addfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . $urlBornes;
        }
    } else {
        if ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = '../linkedcontent/addfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . $urlBornes;
        }
    }

    $block3->openCardView($opt);

    for ($i=0; $i<$comptListFiles; $i++) {
        $fileType = file_info_type($listFiles->fil_extension[$i]);
        $idStatus = $listFiles->fil_status[$i];
        $content = array(
            $listFiles->fil_name[$i],
            '<img src="../interface/icones/' . $fileType . '" border="0" alt="' . $listFiles->fil_extension[$i] . '">',
            convertSize($listFiles->fil_size[$i]),
            createDate($listFiles->fil_created[$i],'both'),
            $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . $doc_type . '&doc_id=' . $doc_id . '&id=' . $listFiles->fil_id[$i] . $urlBornes, $statusFile[$idStatus], 'in')
        );

        if (($doc_type !== '0') && (!isset($projectDetail->pro_published) || $projectDetail->pro_published[0] == enumPublished::pbYes) && $sitePublish == 'true') {
            $content[] = $statusPublish[$listFiles->fil_published[$i]];
        }

        $block3->itemCardView($listFiles->fil_id[$i], $content);
    }

    $block3->closeCardView();
    $block3->bornesFooter("15", $blockPage->bornesNumber, "doc_type=$doc_type&doc_id=$doc_id&toggle_focus=file" . $urlBornes);
    $block3->closeToggle();
    $block3->closeFormResults();
}

if ($doc_type == '0') {
    $block2 = new block();
    $block2->form = 'lsD';
    $block2->openForm("../linkedcontent/listfiles.php?doc_type=$doc_type&doc_id=$doc_id" . $urlBornes . "#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings('subfolders'), !($toggle_focus=='folder'));
    $block2->borne = $blockPage->returnBorne('16');
    $block2->rowsLimit = '12';
    $block2->sorting('folders', (isset($sortingUser['folders'])?$sortingUser['folders']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.comments', 2 => 'none'));
    $querymore = " WHERE fil.dir='" . enumBoolean::bTrue . "' AND fil.parent='$doc_id' ORDER BY " . $block2->sortingValue;
    $block2->recordsTotal = compt($initrequest["files"] . ' ' . $querymore);
    $listFolders = new request();
    $listFolders->openFiles($querymore, $block2->borne, $block2->rowsLimit);
    $comptListFolders = count($listFolders->fil_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['description'];
    $columns[1]->field_type = enumFieldType::ftMemo;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['size'];
    $columns[2]->field_type = enumFieldType::ftText;
    $opt[enumCardviewOption::oTableName] = 'files';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oObject] = 'folders';
    $opt[enumCardviewOption::oExtraParameters] = "doc_type=$doc_type&doc_id=$doc_id" . $urlBornes . '&borne16=' . $block2->borne;
    $opt[enumCardviewOption::oSearch] = true;

    if ($SW_Permissions['File']['Write'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../linkedcontent/editfolder.php?parent=' . $doc_id . $urlBornes;
    }

    $block2->openCardView($opt);

    for ($i=0; $i<$comptListFolders; $i++) {
        $content = array(
            $listFolders->fil_name[$i],
            $listFolders->fil_comments[$i],
            convertSize(folder_size($listFolders->fil_id[$i]))
        );
        $block2->itemCardView($listFolders->fil_id[$i], $content);
    }

    $block2->closeCardView();
    $block2->bornesFooter("16", $blockPage->bornesNumber, "doc_type=$doc_type&doc_id=$doc_id&toggle_focus=folder" . $urlBornes);
    $block2->closeToggle();
    $block2->closeFormResults();
}

require_once("../includes/footer.php");
