<?php // $Revision: 1.12 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: movefiles.php,v 1.12 2013/01/29 08:46:18 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$ids = str_replace('**', ',', $id);
$ida = explode('**', $id);
$parent = AddSlashesNOD(isset($_GET['parent'])?$_GET['parent']:'0');
$cpy = isset($_GET['cpy'])?$_GET['cpy']:'';
$action = isset($_POST['action'])?$_POST['action']:'';
$dest = isset($_POST['dest'])?$_POST['dest']:'0';

/**
 * Permission check
 */
if ($fileManagement != 'true') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$tmpquery = " WHERE fil.id IN ($ids) AND fil.vc_parent=0 ORDER BY fil.dir,fil.name";
$listFiles = new request();
$listFiles->openFiles($tmpquery);
$comptListFiles = count($listFiles->fil_id);

if ($comptListFiles != count($ida)) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

for ($i=0; $i<$comptListFiles; $i++) {
    switch ($listFiles->fil_doc_type[$i]) {
        case enumFileRelatedDocumentType::dtProject:
            $tmpquery = "SELECT id FROM " . $tablePrefix . "projects WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtPhase:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "phases WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtTask:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "tasks WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtMeeting:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "meetings WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtDiscussion:
            $tmpquery = "SELECT topic.project FROM " . $tablePrefix . "posts pos INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic WHERE pos.id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtNote:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "notes WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtExpense:
            $tmpquery = "SELECT project FROM " . $tablePrefix . "expenses WHERE id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtSupportRequest:
            $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_requests req WHERE req.id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        case enumFileRelatedDocumentType::dtSupportPost:
            $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_posts pos INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id WHERE pos.id='" . $listFiles->fil_doc_id[$i] . "'";
            break;
        default:
            $tmpquery = '';
    }

    if ($tmpquery === '') {
        if (!$SW_Permissions['File']['Edit'][$profilSession]) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else {
        $request1 = new request();
        $request1->connectClass();
        $request1->query($tmpquery);

        if ($request1->fetch()) {
            $project = ($row[0]);
        } else {
            $project = '0';
        }

        $request1->close();
        $querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
        $memberDetail = new request();
        $memberDetail->openTeams($querymore2);
        $comptMemberDetail = count($memberDetail->tea_project);

        if ($comptMemberDetail == 0) {
            $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
        } else {
            $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
        }

        $permissionDetail = new request();
        $permissionDetail->openProjectPermissions($querymore3);

        if (!isset($permissionDetail->prp_update_file[0]) || $permissionDetail->prp_update_file[0]!=enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    }
}

if ($action == 'move' && $dest != '0') {
    $tmpquery = " WHERE fil.id=$dest";
    $destFolder = new request();
    $destFolder->openFiles($tmpquery);
    $comptDestFolder = count($destFolder->fil_id);

    if ($comptDestFolder == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

/**
 * Functions
 */
function item_bread_crumbs($id, $buildLink = true) {
    global $blockPage;

    if ($id == '0') {
        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=0", lang_strings('documents'), 'in'));
        } else {
            $blockPage->itemBreadcrumbs(lang_strings('documents'));
        }
    } else {
        $tmpquery = " WHERE fil.id=$id";
        $fileDetail = new request();
        $fileDetail->openFiles($tmpquery);
        item_bread_crumbs($fileDetail->fil_parent[0]);

        if ($buildLink) {
            $blockPage->itemBreadcrumbs($blockPage->buildLink("../linkedcontent/listfiles.php?doc_type=0&id=$id", $fileDetail->fil_name[0], 'in'));
        } else {
            $blockPage->itemBreadcrumbs($fileDetail->fil_name[0]);
        }
    }
}

function bof($id, $root = '')
{
    global $ids, $parent, $fol_id, $fol_path;
    $tmpquery = " WHERE fil.id NOT IN ($ids) AND fil.parent=$id AND fil.dir='" . enumBoolean::bTrue . "' ORDER BY fil.name";
    $listFolders = new request();
    $listFolders->openFiles($tmpquery);
    $comptListFolders = count($listFolders->fil_id);

    for ($i=0; $i<$comptListFolders; $i++) {
        if ($listFolders->fil_id[$i] != $parent) {
            $fol_id[] = $listFolders->fil_id[$i];
            $fol_path[] = $root .'/' . $listFolders->fil_name[$i];
        }

        bof($listFolders->fil_id[$i], $root .'/' . $listFolders->fil_name[$i]);
    }
}

function copy_more_files($requestAct, $org_id, $new_id, $org_fullname, $new_fullname)
{
    global $tablePrefix,$orgPath,$newPath,$nums,$idSession;
    $tmpquery = " WHERE fil.parent=$org_id AND fil.vc_parent=0 ORDER BY fil.dir,fil.name";
    $listFiles = clone $requestAct;
    $listFiles->openFiles($tmpquery);
    $comptListFiles = count($listFiles->fil_id);

    for ($i=0; $i<$comptListFiles; $i++) {
        $status = enumFileStatus::stNoApprovalsNeeded;
        $tmpsql = "INSERT INTO " . $tablePrefix . "files (owner,doc_type,doc_id,name,size,extension,comments,published,status,vc_version,vc_parent,dir,parent,fullname,project,created,cuser) VALUES ($idSession,'0',$new_id,'" . HtmlEntitiesNOD($listFiles->fil_name[$i]) . "','" . $listFiles->fil_size[$i] . "','" . $listFiles->fil_extension[$i] . "','" . HtmlEntitiesNOD($listFiles->fil_comments[$i]) . "','" . enumPublished::pbNo . "','$status','" . $listFiles->fil_vc_version[$i] . "','0','" . $listFiles->fil_dir[$i] . "',$new_id,'','" . $listFiles->fil_project[$i] . "','" . time() . "','$idSession')";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $num = $requestAct->newId("files");
        $nums[] = $num;
        $extension_len = strlen($listFiles->fil_extension[$i]) + 1;
        $filename_len = strlen($listFiles->fil_name[$i]);
        $filename_prefix = substr($listFiles->fil_name[$i], 0, $filename_len - $extension_len);
        $filename_prefix = urlencode($filename_prefix);

        if ($listFiles->fil_dir[$i] == enumBoolean::bTrue) {
            $realname = $filename_prefix . '--' . $num;
        } else {
            $realname = $filename_prefix . '--' . $num . '.v' . $listFiles->fil_vc_version[$i] . '.' . $listFiles->fil_extension[$i];
        }

        $fullname = $new_fullname . '/' . $realname;
        $orgPath[] = $listFiles->fil_fullname[$i];
        $newPath[] = $fullname;
        $tmpsql = 'UPDATE ' . $tablePrefix . "files SET fullname='" . HtmlEntitiesNOD($fullname) . "' WHERE id='$num'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        if ($listFiles->fil_dir[$i] == enumBoolean::bTrue) {
            copy_more_files($requestAct, $listFiles->fil_id[$i], $num, $listFiles->fil_fullname[$i], $fullname);
        }
    }
}

function move_more_files($requestAct, $id, $org_fullname, $new_fullname)
{
    global $tablePrefix,$idSession;
    $querymore = " WHERE fil.parent='$id'";
    $listFiles = clone $requestAct;
    $listFiles->openFiles($querymore);
    $comptListFiles = count($listFiles->fil_id);

    for ($i=0; $i<$comptListFiles; $i++) {
        $fullname = str_replace($org_fullname, $new_fullname, $listFiles->fil_fullname[$i]);

        if ($listFiles->fil_dir[$i] == enumBoolean::bTrue) {
            move_more_files($requestAct, $listFiles->fil_id[$i], $listFiles->fil_fullname[$i], $fullname);
        }

        $tmpsql = "UPDATE " . $tablePrefix . "files SET fullname='" . HtmlEntitiesNOD($fullname) . "',modified='" . time() . "',muser='$idSession' WHERE id='" . $listFiles->fil_id[$i] . "'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'files', $listFiles->fil_id[$i], 'U');
    }
}

/**
 * Actions
 */
if ($action == "move") {
    if ($cpy == 'true') {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();

            for ($i=0; $i<$comptListFiles; $i++) {
                $status = enumFileStatus::stNoApprovalsNeeded;
                $tmpsql = "INSERT INTO " . $tablePrefix . "files (owner,doc_type,doc_id,name,size,extension,comments,published,status,vc_version,vc_parent,dir,parent,fullname,project,created,cuser) VALUES ($idSession,'0',$dest,'" . HtmlEntitiesNOD($listFiles->fil_name[$i]) . "','" . $listFiles->fil_size[$i] . "','" . $listFiles->fil_extension[$i] . "','" . HtmlEntitiesNOD($listFiles->fil_comments[$i]) . "','" . enumPublished::pbNo . "','$status','" . $listFiles->fil_vc_version[$i] . "','0','" . $listFiles->fil_dir[$i] . "',$dest,'','" . $listFiles->fil_project[$i] . "','" . time() . "','$idSession')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $num = $requestAct->newId("files");
                $nums[] = $num;
                $extension_len = strlen($listFiles->fil_extension[$i]) + 1;
                $filename_len = strlen($listFiles->fil_name[$i]);
                $filename_prefix = substr($listFiles->fil_name[$i], 0, $filename_len - $extension_len);
                $filename_prefix = urlencode($filename_prefix);

                if ($listFiles->fil_dir[$i] == enumBoolean::bTrue) {
                    $realname = $filename_prefix . '--' . $num;
                } else {
                    $realname = $filename_prefix . '--' . $num . '.v' . $listFiles->fil_vc_version[$i] . '.' . $listFiles->fil_extension[$i];
                }

                if ($dest == '0') {
                    $fullname = $realname;
                } else {
                    $fullname = $destFolder->fil_fullname[0] . '/' . $realname;
                }

                $orgPath[] = $listFiles->fil_fullname[$i];
                $newPath[] = $fullname;
                $tmpsql = 'UPDATE ' . $tablePrefix . "files SET fullname='" . HtmlEntitiesNOD($fullname) . "' WHERE id=$num";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                if ($listFiles->fil_dir[$i] == enumBoolean::bTrue) {
                    copy_more_files($requestAct, $listFiles->fil_id[$i], $num, $listFiles->fil_fullname[$i], $fullname);
                }
            }

            foreach ($nums as $num) {
                $producer = $idSession;
                $doctype = 'files';

                if (!defined('INNER_ADDDOCUMENT')) {
                    define('INNER_ADDDOCUMENT', 1);
                }

                require('../approvals/adddocument.php');
            }

            copyFiles($orgPath, $newPath);
            copy2HistoryTable($requestAct, 'files', "'" . implode("','", $nums) . "'", 'A');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header('Location: ../linkedcontent/listfiles.php?doc_type=0&doc_id=' . $dest . '&msg=copy');
            exit;
        }
    } else {
        $tmpquery = " WHERE fil.id IN ($ids) ORDER BY fil.dir,fil.name";
        $listFiles = new request();
        $listFiles->openFiles($tmpquery);
        $comptListFiles = count($listFiles->fil_id);
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();

            for ($i=0; $i<$comptListFiles; $i++) {
                if ($dest == '0') {
                    $fullname = substr(strrchr($listFiles->fil_fullname[$i], '/'), 1);
                } else {
                    if (strrchr($listFiles->fil_fullname[$i], '/') === false) {
                        $fullname = $destFolder->fil_fullname[0] . '/' . $listFiles->fil_fullname[$i];
                    } else {
                        $fullname = $destFolder->fil_fullname[0] . strrchr($listFiles->fil_fullname[$i], '/');
                    }
                }

                if ($listFiles->fil_dir[$i] == enumBoolean::bTrue) {
                    move_more_files($requestAct, $listFiles->fil_id[$i], $listFiles->fil_fullname[$i], $fullname);
                }

                $tmpsql = "UPDATE " . $tablePrefix . "files SET parent='$dest',fullname='" . HtmlEntitiesNOD($fullname) . "' WHERE id='" . $listFiles->fil_id[$i] . "'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            moveFiles($listFiles->fil_fullname, $destFolder->fil_fullname[0]);
            copy2HistoryTable($requestAct, 'files', $ids, 'U');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header('Location: ../linkedcontent/listfiles.php?doc_type=0&doc_id=' . $dest . '&msg=move' . $urlBornes);
            exit;
        }
    }
}

/**
 * Prepare data
 */
if (!in_array(enumBoolean::bFalse, $listFiles->fil_dir) && $parent != '0') {
    $fol_id[] = '0';
    $fol_path[] = '/';
}

bof('0');

if (count($fol_id) == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
item_bread_crumbs($parent);

if ($cpy == 'true') {
    $blockPage->itemBreadcrumbs(lang_strings('copy_files'));
} else {
    $blockPage->itemBreadcrumbs(lang_strings('move_files'));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'mvF';
$block1->openForm("../linkedcontent/movefiles.php?cpy=$cpy&parent=$parent&id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"move\">";
echo "<input type=\"hidden\" name=\"dest\" value=\"\">";

if ($cpy == 'true') {
    $block1->heading(lang_strings('copy_files'));
} else {
    $block1->heading(lang_strings('move_files'));
}

$block1->openContent();

if ($cpy == 'true') {
    $block1->contentTitle(lang_strings('copy_following'));
} else {
    $block1->contentTitle(lang_strings('move_following'));
}

for ($i=0; $i<$comptListFiles; $i++) {
    if ($listFiles->fil_dir[$i] == enumBoolean::bTrue) {
        $block1->contentRow('', $listFiles->fil_name[$i] . '(' . lang_strings('folder') . ')');
    } else {
        $block1->contentRow('', $listFiles->fil_name[$i]);
    }
}

$block1->contentTitle(lang_strings('destination'));

for ($i=0; $i<count($fol_id); $i++) {
    $right = '<a href="javascript:document.mvFForm.dest.value=' . $fol_id[$i] . ';document.mvFForm.submit();">' . $fol_path[$i] . '</a>';
    $block1->contentRow('', $right);
}

$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
