<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletematerials.php,v 1.5 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$idSet = "'" . str_replace("**", "','", $id) . "'";

/**
 * Permission check
 */
if ($enableMaterial != 'true' || !$SW_Permissions['Material']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = "SELECT res.id FROM " . $tablePrefix . "tasks_resource res WHERE res.resource IN ($idSet) AND type='" . enumResourceType::rtMaterial . "'";

if (compt($tmpquery) > 0) {
    header("Location: ../materials/listmaterials.php?msg=materialInUse" . $urlBornes);
    exit;
}

/**
 * Action
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'materials', $idSet, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "materials WHERE id IN ($idSet)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../materials/listmaterials.php?msg=delete" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=utility", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../materials/listmaterials.php?" . $urlBornes, lang_strings("material_management"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_materials"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "matD";
$block1->openForm("../materials/deletematerials.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="delete">';
$block1->heading(lang_strings("delete_materials"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));
$querymore = " WHERE mat.id IN ($idSet) ORDER BY mat.name";
$listMaterials = new request();
$listMaterials->openMaterials($querymore);
$comptListMaterials = count($listMaterials->mat_id);

for ($i=0; $i<$comptListMaterials; $i++) {
    $block1->contentRow('#' . $listMaterials->mat_id[$i], $listMaterials->mat_name[$i] . ' (' . $listMaterials->mat_name_print[$i] . ')');
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
