<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editmaterial.php,v 1.5 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
$bodyCommand = "onLoad=\"document.maEForm.n.focus();\"";

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$cpy = isset($_GET['cpy'])?$_GET['cpy']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$n = isset($_POST['n'])?$_POST['n']:'';                         // name
$d = isset($_POST['d'])?$_POST['d']:'';                         // name print
$ui = isset($_POST['ui'])?$_POST['ui']:'';                      // unit
$cr = isset($_POST['cr'])?$_POST['cr']:'';                      // cost rate
$curr = isset($_POST['curr'])?$_POST['curr']:$defaultCurrency;  // currency
$l = isset($_POST['l'])?$_POST['l']:'';                         // locked
$cr_highlight = false;
$lk = DbValueEncode(enumFieldType::ftBoolean, $l);
$error = '';

/**
 * Permission check
 */
if ($enableMaterial != 'true') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($id != "") {
    if ($cpy != 'true') {
        if (!$SW_Permissions['Material']['Edit'][$profilSession]) {
            header("Location: ../general/permissiondenied.php");
            exit;
        }
    } else {
        if (!$SW_Permissions['Material']['Write'][$profilSession]) {
            header("Location: ../general/permissiondenied.php");
            exit;
        }
    }

    $querymore = " WHERE mat.id='$id'";
    $detailMaterial = new request();
    $detailMaterial->openMaterials($querymore);
    $comptDetailMaterial = count($detailMaterial->mat_id);

    if ($comptDetailMaterial == '0') {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['Material']['Write'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
}

/**
 * Check fields
 */
if ($action == 'add' || $action == 'update') {
    if (floatval($cr) < 0 || floatval($cr) != round($cr, $rateAccuracy)) {
        $error = lang_strings('costrate') . ' ' . lang_strings("value_deviate");
        $bodyCommand = "onLoad=\"document.maEForm.cr.focus();document.maEForm.cr.select();\"";
        $cr_highlight = true;
    }

    if ($error == '') {
        $error = checkCustomFields('materials', $id);
    }
}

/**
 * Actions
 */
if ($error == '' && ($action == "add" || $action == "update")) {
    $cr = round($cr, $rateAccuracy);
    $ui = HtmlEntitiesNOD($ui);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == "update") {
        try {
            $requestAct->startTransaction();
            $cfsql = setupCustomFieldsUpdateSQL('materials', $id);  // Generate custom fields update sql
            $tmpsql = "UPDATE " . $tablePrefix . "materials SET name='$n',costrate='$cr',unit='$ui',currency='$curr',locked='$lk',modified='" . time() . "',muser='$idSession'$cfsql WHERE id=$id";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'materials', $id, 'U');
            updateString($requestAct, 'MAT__' . $n, $d);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../materials/listmaterials.php?msg=update" . $urlBornes);
            exit;
        }
    } else if ($action == "add") {
        try {
            $requestAct->startTransaction();
            $cfsqls = setupCustomFieldsInsertSQL('materials');  // Generate custom fields insert sql
            $tmpsql = "INSERT INTO " . $tablePrefix . "materials (name,costrate,unit,currency,locked,created,cuser" . $cfsqls[0] . ") VALUES ('$n','$cr','$ui','$curr','$lk','" . time() . "','$idSession'" . $cfsqls[1] . ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('materials');
            $cfsql = setupCustomMediaFieldsUpdateSQL('materials', $num);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "materials SET $cfsql WHERE id='$num'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            copy2HistoryTable($requestAct, 'materials', $num, 'A');
            updateString($requestAct, 'MAT__' . $n, $d);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../materials/listmaterials.php?msg=add");
            exit;
        }
    }
}

if ($error == '') {
    if ($id != '') {
        $n = $detailMaterial->mat_name[0];
        $d = $detailMaterial->mat_name_print[0];
        $cr = $detailMaterial->mat_costrate[0];
        $ui = $detailMaterial->mat_unit[0];
        $curr = $detailMaterial->mat_currency[0];
        $lk = $detailMaterial->mat_locked[0];
    } else {
        $curr = $defaultCurrency;
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=utility", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../materials/listmaterials.php?" . $urlBornes, lang_strings("material_management"), 'in'));

if ($id == "" || $cpy == 'true') {
    $blockPage->itemBreadcrumbs(lang_strings("add_material"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../materials/viewmaterial.php?id=$id" . $urlBornes, $detailMaterial->mat_name[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_material"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "maE";

if ($id == "" || $cpy == 'true') {
    $block1->openForm("../materials/editmaterial.php?#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_material"));
} else {
    $block1->openForm("../materials/editmaterial.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="update">';
    $block1->heading(lang_strings("edit_material") . " : " . $detailMaterial->mat_name[0]);
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));
setupInputHTML($block1, lang_strings("name"), 'n', enumFieldType::ftAlphaNumeric, 'Y', '155', $n, '', '', false, '', 'onblur="nameChanged()"');
setupInputHTML($block1, lang_strings("name_print"), 'd', enumFieldType::ftText, 'Y', '65535', $d, '', '', false, '', 'onblur="nameChanged()"');
setupInputHTML($block1, lang_strings("unit"), 'ui', enumFieldType::ftText, 'Y', '50', $ui);
$helpStr = '<table>';
$currencyStr = '<select name="curr">';

foreach ($CurrencyMatrix['active'] as $currCode) {
    $currName = $CurrencyMatrix['name'][$currCode];
    $helpStr .= '<tr><th>' . $currCode . '</th><td>' . $currName . '</td></tr>';

    if ($currCode == $curr) {
        $currencyStr .= '<option value="' . $currCode . '" selected>' . $currCode . '</option>';
    } else {
        $currencyStr .= '<option value="' . $currCode . '">' . $currCode . '</option>';
    }
}

$currencyStr .= '</select>';
$helpStr .= '</table>';
$block1->contentRow(lang_strings('currency') . ' ' . $blockPage->printHelp($helpStr, true), $currencyStr);
setupInputHTML($block1, lang_strings('costrate') . ' ' . $blockPage->printHelp($strings['costrate_help'], true), 'cr', enumFieldType::ftRate, 'N', '', $cr, '', '', $cr_highlight);

if ($id != '' && $cpy != 'true') {
    setupInputHTML($block1, lang_strings('locked'), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
}

setupCustomFieldsInputHTML($block1, 'materials', $id);
$block1->contentRow('', '<input type="submit" name="Save" value="' . $strings["save"] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
    function nameChanged() {
        var np = document.getElementById('d').value;

        if (np == '') {
            var n = document.getElementById('n').value;
            document.getElementById('d').value = n;
        }
    }
</script>
<?php
require_once("../includes/footer.php");
