<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listmaterials.php,v 1.3 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if ($enableMaterial != 'true' || !$SW_Permissions['Material']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=utility", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("material_management"));
$blockPage->closeBreadcrumbs();
logURL($strings['material_management'], "../materials/listmaterials.php");
$block1 = new block();
$block1->form = "matL";
$block1->openForm("../materials/listmaterials.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings("material_management"));
$blockPage->bornesNumber = '1';
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = '12';
$block1->sorting('materials', (isset($sortingUser['materials'])?$sortingUser['materials']:''), "mat.name ASC", $sortingFields = array(0 => 'mat.name', 1 => 'none', 2 => 'mat.unit', 3 => 'mat.currency', 4 => 'mat.costrate', 5 => 'mat.locked'));
$querymore = " ORDER BY " . $block1->sortingValue;
$block1->recordsTotal = compt($initrequest['materials'] . ' ' . $querymore);
$listMaterials = new request();
$listMaterials->openMaterials($querymore, $block1->borne, $block1->rowsLimit);
$comptListMaterials = count($listMaterials->mat_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['name'];
$columns[0]->field_type = enumFieldType::ftAlphaNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['name_print'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['unit'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['currency'];
$columns[3]->field_type = enumFieldType::ftText;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['costrate'];
$columns[4]->field_type = enumFieldType::ftRate;
$columns[5] = new cardviewColumn();
$columns[5]->title = $strings['locked'];
$columns[5]->field_type = enumFieldType::ftBoolean;
$opt[enumCardviewOption::oObject] = 'materials';
$opt[enumCardviewOption::oTableName] = 'materials';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;
$opt[enumCardviewOption::oExtraParameters] = '&borne1=' . $block1->borne;

if ($SW_Permissions['Material']['Write'][$profilSession]) {
    $opt[enumCardviewOption::oAddUrl] = '../materials/editmaterial.php?';
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListMaterials; $i++) {
    $content = array(
        $listMaterials->mat_name[$i],
        $listMaterials->mat_name_print[$i],
        $listMaterials->mat_unit[$i],
        $listMaterials->mat_currency[$i],
        $listMaterials->mat_costrate[$i],
        $listMaterials->mat_locked[$i]
    );
    $block1->itemCardView($listMaterials->mat_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter("1", $blockPage->bornesNumber);
$block1->closeFormResults();
require_once("../includes/footer.php");
