<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewmaterial.php,v 1.4 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');

/**
 * Permission check
 */
if ($enableMaterial != 'true' || !$SW_Permissions['Material']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore = " WHERE mat.id='$id'";
$detailMaterial = new request();
$detailMaterial->openMaterials($querymore);
$comptDetailMaterial = count($detailMaterial->mat_id);

if ($comptDetailMaterial == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=utility", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../materials/listmaterials.php?" . $urlBornes, lang_strings("material_management"), 'in'));
$blockPage->itemBreadcrumbs($detailMaterial->mat_name[0]);
$blockPage->closeBreadcrumbs();
$title = $strings['material'] . ' : ' . $detailMaterial->mat_name[0];
logURL($title, "../materials/viewmaterial.php?id=$id");
$block1 = new block();
$block1->form = "materialD";
$block1->openForm("../materials/viewmaterial.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("material"));
$block1->openPaletteIcon();

if ($SW_Permissions['Material']['Write'][$profilSession]) {
    $block1->paletteIcon(4, "copy", $strings["copy"]);
}

if ($SW_Permissions['Material']['Admin'][$profilSession]) {
    $block1->paletteIcon(0, "remove", $strings["delete"]);
}

if ($SW_Permissions['Material']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, "edit", $strings["edit"]);
}

$block1->paletteIcon(99, 'search', 'materials');
$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow(lang_strings("name"), $detailMaterial->mat_name[0]);
$block1->contentRow(lang_strings("name_print"), $detailMaterial->mat_name_print[0]);
$block1->contentRow(lang_strings("unit"), $detailMaterial->mat_unit[0]);

if ($currencyOnRight == 'true') {
    $block1->contentRow(lang_strings("costrate") . ' ' . $blockPage->printHelp($strings['costrate_help'], true), NumberFormatNOD($detailMaterial->mat_costrate[0], $rateAccuracy, false) . " " . $detailMaterial->mat_currency[0]);
} else {
    $block1->contentRow(lang_strings("costrate") . ' ' . $blockPage->printHelp($strings['costrate_help'], true), $detailMaterial->mat_currency[0] . " " . NumberFormatNOD($detailMaterial->mat_costrate[0], $rateAccuracy, false));
}

$block1->contentRow(lang_strings('locked'), $detailMaterial->mat_locked[0]);
setupCustomFieldsHTML($block1, 'materials', $id);
$block1->closeContent();
$block1->closeForm();
$block1->openPaletteScript();

if ($SW_Permissions['Material']['Write'][$profilSession]) {
    $block1->paletteScript(4, "copy", "../materials/editmaterial.php?id=$id&cpy=true", "true,true,true", $strings["copy"]);
}

if ($SW_Permissions['Material']['Admin'][$profilSession]) {
    $block1->paletteScript(0, "remove", "../materials/deletematerials.php?id=$id" . $urlBornes, "true,true,true", $strings["delete"]);
}

if ($SW_Permissions['Material']['Edit'][$profilSession]) {
    $block1->paletteScript(1, "edit", "../materials/editmaterial.php?id=$id" . $urlBornes, "true,true,true", $strings["edit"]);
}

$block1->paletteScript(99, 'search', 'materials');
$block1->closePaletteScript("", "");
require_once("../includes/footer.php");
