<?php // $Revision: 1.29 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addmeetingtime.php,v 1.29 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ldI = isset($_POST['ldI'])?$_POST['ldI']:'';
$ld = ($ldI=='')?$dateToday:date2Timestamp($ldI);
$hr = isset($_POST['hr'])?$_POST['hr']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$bodyCommand = 'onLoad="document.saMForm.hr.focus();"';

/**
 * Permission check
 */
$querymore0 = " WHERE mee.id='$id'";
$meetingDetail = new request();
$meetingDetail->openMeetings($querymore0);
$comptMeetingDetail = count($meetingDetail->mee_id);

if ($comptMeetingDetail == '0') {
    header('Location: ../general/home.php?msg=blankMeeting');
    exit;
} else if ($meetingDetail->mee_status[0] == enumMeetingStatus::stScheduling || $meetingDetail->mee_status[0] == enumMeetingStatus::stCanceled) {
    header('Location: ../meetings/viewmeeting.php?id=' . $id . '&msg=permissiondenied' . $urlBornes);
    exit;
}

$querymore1 = " WHERE att.meeting='$id'";
$listAttendees = new request();
$listAttendees->openAttendees($querymore1);
$comptListAttendees = count($listAttendees->att_meeting);
$project = $meetingDetail->mee_project[0];

if (array_search($idSession, $listAttendees->att_member) === FALSE) {
    header('Location: ../meetings/viewmeeting.php?id=' . $id . '&msg=permissiondenied' . $urlBornes);
    exit;
}

if ($project == '0') {
    if (!$SW_Permissions['Meeting']['Write'][$profilSession]) {
        header('Location: ../general/permissiondenied.php?');
        exit;
    }
} else {
    $querymore2 = " WHERE pro.id='$project'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore2);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../projects/viewproject.php?toggle_focus=meetings&id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }

    $querymore = " WHERE tea.project='$project' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore);
    $comptPermissionDetail = count($permissionDetail->prp_project);
    $ld = ($ld=='')?mktime(0,0,0,intval(date('m',$meetingDetail->mee_start_time[0])),intval(date('d',$meetingDetail->mee_start_time[0])),intval(date('Y',$meetingDetail->mee_start_time[0]))):$ld;

    if ($permissionDetail->prp_log_meeting_hours[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?toggle_focus=meetings&id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }
}

/**
 * Fields check
 */
if ($action == 'add') {
    $error = ''; // init

    // make sure we have the required information
    if (!empty($hr)) {
        if (!is_numeric($hr)) {
            // we need this to be numeric
            $error = lang_strings('worked_hours') . ' ' . lang_strings('error_numerical');
            $bodyCommand = 'onLoad="document.saMForm.hr.focus();"';
            $hr_highlight = true;
        }
    } else {
        // we need this to be numeric
        $error = lang_strings('worked_hours') . ' ' . lang_strings('error_required');
        $bodyCommand = 'onLoad="document.saMForm.hr.focus();"';
        $hr_highlight = true;
    }

    if ($error == '') {
        if ($ld < mktime(0,0,0,intval(date('m',$meetingDetail->mee_start_time[0])),intval(date('d',$meetingDetail->mee_start_time[0])),intval(date('Y',$meetingDetail->mee_start_time[0])))) {
            $error = lang_strings("date_deviate");
            $bodyCommand = 'onLoad="document.saMForm.ldI.focus();"';
            $ld_highlight = true;
        } else if (periodLocked($ld)) {
            $error = lang_strings('period') . ' ' . createDate($period_date_start,'date',false,true) . ' ~ ' . createDate($period_date_end,'date',false,true) . ' ' . lang_strings('locked');
            $bodyCommand = 'onLoad="document.saMForm.ldI.focus();"';
            $ld_highlight = true;
        } else if ($enableTimesheet == 'true') {
            $fyear = intval(date('Y', $ld));
            $month = intval(date('m', $ld));
            $day = intval(date('d', $ld));
            $weekday = date("w", mktime(0, 0, 0, $month, $day, $fyear));

            if ($weekday == '0') {
                $sdate = mktime(0, 0, 0, $month, $day-6, $fyear);
            } else {
                $sdate = mktime(0, 0, 0, $month, $day-$weekday+1, $fyear);
            }

            if ($periodUnit == 'month') {
                $serialno = date("n");
            } else {
                $serialno = intval(date("W", $sdate));
            }

            $querymore = " WHERE tim.owner='$idSession' AND per.fyear='$fyear' AND per.serial_no='$serialno'";
            $timesheetDetail = new request();
            $timesheetDetail->openTimesheet($querymore);
            $comptTimesheetDetail = count($timesheetDetail->tim_owner);

            if ($comptTimesheetDetail == '0') {
                $timesheetReadOnly = false;
            } else if ($timesheetDetail->tim_status[0] == enumFileStatus::stNeedsApproval) {
                $timesheetReadOnly = true;
            } else {
                $timesheetReadOnly = false;
            }

            if ($timesheetReadOnly) {
                $error = lang_strings("no_permissions");
            }
        }
    }
}

/**
 * Actions
 */
if ($action == "add" && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        // insert meeting time in database
        $hr = round($hr, $hourAccuracy);
        $comm = HtmlEntitiesNOD($comm);
        $tmpsql = 'INSERT INTO ' . $tablePrefix . "meetings_time (owner,project,meeting,date,hours,comments,created,cuser) VALUES ('$idSession','$project','$id','$ld',$hr,'$comm','" . time() . "','$idSession')";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $hr = '';
        $comm = '';
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
        // successful insert
        $msg = 'add';
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
}

/**
 * Prepare data
 */
if ($error == '') {
    $ld = $meetingDetail->mee_start_time[0];
    $hr = floatval($meetingDetail->mee_duration[0]);
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '0') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../general/home.php?", lang_strings('home'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?" . $urlBornes, lang_strings("my_meetings"), 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=meetings&id=$project" . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$project" . $urlBornes, lang_strings("meetings"), 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=$id" . $urlBornes, $meetingDetail->mee_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_meeting_time"));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '8';     // 1st for listprojects, 6th for viewproject, 7th for viewmeeting
$block1 = new block();
$block1->form = "saM";
$block1->openForm("../meetings/addmeetingtime.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="add">';
$block1->headingToggle(lang_strings("add_meeting_time"), !($toggle_focus==''));
$block1->openContent();
setupInputHTML($block1, lang_strings("date"), 'ldI', enumFieldType::ftDate, 'Y', '0', $ld, '', '', $ld_highlight);
$block1->contentRow("* " . lang_strings("worked_hours"), '<input value="' . $hr . '"' . (($hr_highlight)?' class="highlight"':'') . ' name="hr" maxlength="6" type="text">');
setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
$block1->contentRow('', "<input type='SUBMIT' value='" . $strings["save"] . "'>");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeToggle();
$block1->closeForm();
// This will display time log detail for the current meeting
$block2 = new block();
$block2->form = "ahT";
$block2->openForm("../meetings/addmeetingtime.php?id=$id" . $urlBornes . "#" . $block2->form . "Anchor");
$block2->headingToggle(lang_strings("meeting_time"), !($toggle_focus=='meeting_time'));
$block2->borne = $blockPage->returnBorne("8");
$block2->rowsLimit = 12;
$block2->sorting('meetings_time', (isset($sortingUser['meetings_time'])?$sortingUser['meetings_time']:''), 'mti.date ASC', $sortingFields = array(0 => 'mti.date', 1 => 'mti.hours', 2 => 'mti.created', 3 => 'mti.modified', 4 => 'mti.comments'));
$querymore = " WHERE mti.meeting='$id' AND mti.owner='$idSession' ORDER BY " . $block2->sortingValue;
$recordsTotal = compt($initrequest['meetings_time'] . $querymore);
$block2->recordsTotal = $recordsTotal;
$listMeetingTimes = new request();
$listMeetingTimes->openMeetingTime($querymore);
$comptListMeetingTimes = count($listMeetingTimes->mti_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['date'];
$columns[0]->field_type = enumFieldType::ftText;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['hours'];
$columns[1]->field_type = enumFieldType::ftHours;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['created'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['modified'];
$columns[3]->field_type = enumFieldType::ftText;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['comment'];
$columns[4]->field_type = enumFieldType::ftMemo;
$opt[enumCardviewOption::oTableName] = 'meetings_time';
$opt[enumCardviewOption::oObject] = 'meeting_time';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oExtraParameters] = "meeting=$id&borne8=" . $block2->borne;
$block2->openCardView($opt);

// display logged hours for this meeting
for ($i=0; $i<$comptListMeetingTimes; $i++) {
    $comm = strip_tags($listMeetingTimes->mti_comments[$i]);
    $content = array(
        createDate($listMeetingTimes->mti_date[$i],'date',false,true),
        $listMeetingTimes->mti_hours[$i],
        createDate($listMeetingTimes->mti_created[$i], 'both'),
        createDate($listMeetingTimes->mti_modified[$i], 'both'),
        $comm
    );
    $block2->itemCardView($listMeetingTimes->mti_id[$i], $content);
}

$block2->closeCardView();
$block2->bornesFooter("8", $blockPage->bornesNumber, "meeting=$id&toggle_focus=meeting_time" . $urlBornes);
$block2->closeToggle();
$block2->closeFormResults();
require_once("../includes/footer.php");
