<?php // $Revision: 1.19 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletemeetingtime.php,v 1.19 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$meeting = AddSlashesNOD(isset($_GET['meeting'])?$_GET['meeting']:'');
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = "'" . str_replace('**', "','", $id) . "'";

/**
 * Permission check
 */
$querymore = " WHERE mee.id='$meeting'";
$meetingDetail = new request();
$meetingDetail->openMeetings($querymore);
$comptMeetingDetail = count($meetingDetail->mee_id);

if ($comptMeetingDetail == '0') {
    header('Location: ../general/home.php?msg=blankMeeting');
    exit;
}

$project = $meetingDetail->mee_project[0];
$querymore = " WHERE mti.id IN ($ids)";
$listMeetingTime = new request();
$listMeetingTime->openMeetingTime($querymore);
$comptListMeetingTime = count($listMeetingTime->mti_id);

if ($comptListMeetingTime == '0') {
    header('Location: ../general/home.php?msg=permissiondenied');
    exit;
} else if ($comptListMeetingTime == '1') {
    if (periodLocked($listMeetingTime->mti_date[0])) {      // check if period locked
        header('Location: ../general/home.php?msg=periodLocked');
        exit;
    }
} else {
    if (periodLocked(min($listMeetingTime->mti_date), max($listMeetingTime->mti_date))) {   // check if period locked
        header('Location: ../general/home.php?msg=periodLocked');
        exit;
    }
}

$listOwners = array_count_values($listMeetingTime->mti_owner);

if ((count($listOwners) != '1') || (reset($listOwners) != $idSession)) {
    header('Location: ../general/home.php?msg=permissiondenied');
    exit;
}

$querymore = " WHERE att.meeting='$meeting'";
$listAttendees = new request();
$listAttendees->openAttendees($querymore);
$comptListAttendees = count($listAttendees->att_meeting);

if (array_search($idSession, $listAttendees->att_member) === FALSE) {
    header('Location: ../meetings/viewmeeting.php?id=' . $meeting . '&msg=permissiondenied' . $urlBornes);
    exit;
}

if ($project == '0') {
    if (!$SW_Permissions['Meeting']['Write'][$profilSession]) {
        header('Location: ../general/permissiondenied.php?');
        exit;
    }
} else {
    $querymore = " WHERE pro.id='$project'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../projects/viewproject.php?toggle_focus=meetings&id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }

    $querymore = " WHERE tea.project='$project' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($permissionDetail->prp_log_meeting_hours[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?toggle_focus=meetings&id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = 'DELETE FROM ' . $tablePrefix . "meetings_time WHERE id IN ($ids)";
        if ($requestAct->query($tmpsql) === false)
            throw new Exception($tmpsql);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../meetings/addmeetingtime.php?id=$meeting&msg=delete" . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '0') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../general/home.php?", lang_strings('home'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?" . $urlBornes, lang_strings("my_meetings"), 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=meetings&id=$project" . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$project" . $urlBornes, lang_strings("meetings"), 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=" . $meetingDetail->mee_id[0] . $urlBornes, $meetingDetail->mee_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_meeting_time"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'dmT';
$block1->openForm("../meetings/deletemeetingtime.php?meeting=$meeting&amp;id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="delete">';
$block1->heading(lang_strings("delete_meeting_time"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListMeetingTime; $i++) {
    echo "<tr class='odd'><td valign='top' class='leftvalue'>#"
     . $listMeetingTime->mti_id[$i] . "</td><td> : " . lang_strings('worked_hours')
     . " = " . $listMeetingTime->mti_hours[$i] . ", " . $listMeetingTime->mti_comments[$i]
     . "</td></tr>";
}

$block1->contentRow('', "<input type='submit' name='delete' value='" . $strings['delete'] . "'> <input type='button' name='cancel' value='" . $strings['cancel'] . "' onClick='history.back();'>");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
