<?php // $Revision: 1.28 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editmeetingtime.php,v 1.28 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$meeting = AddSlashesNOD(isset($_GET['meeting'])?$_GET['meeting']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ldI = isset($_POST['ldI'])?$_POST['ldI']:'';
$ld = ($ldI=='')?$dateToday:date2Timestamp($ldI);
$hr = isset($_POST['hr'])?$_POST['hr']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$bodyCommand = "onload=\"document.saMForm.hr.focus();\"";

/**
 * Permission check
 */
$querymore0 = " WHERE mee.id='$meeting'";
$meetingDetail = new request();
$meetingDetail->openMeetings($querymore0);
$comptMeetingDetail = count($meetingDetail->mee_id);

if ($comptMeetingDetail == '0') {
    header('Location: ../general/home.php?msg=blankMeeting');
    exit;
}

$querymore1 = " WHERE att.meeting='$meeting'";
$listAttendees = new request();
$listAttendees->openAttendees($querymore1);
$comptListAttendees = count($listAttendees->att_meeting);
$project = $meetingDetail->mee_project[0];

if (array_search($idSession, $listAttendees->att_member) === FALSE) {
    header('Location: ../meetings/viewmeeting.php?id=' . $meeting . '&msg=permissiondenied');
    exit;
}

$querymore = " WHERE mti.id='$id'";
$meetingTimeDetail = new request();
$meetingTimeDetail->openMeetingTime($querymore);
$comptMeetingTimeDetail = count($meetingTimeDetail->mti_id);

if ($comptMeetingTimeDetail == '0') {
    header('Location: ../meetings/viewmeeting.php?id=' . $meeting . '&msg=permissiondenied');
    exit;
} else {
    if (periodLocked($meetingTimeDetail->mti_date[0])) {      // check if period locked
        header('Location: ../meetings/viewmeeting.php?id=' . $meeting . 'msg=periodLocked');
        exit;
    }
}

if ($project == '0') {
    if (!$SW_Permissions['Meeting']['Write'][$profilSession]) {
        header('Location: ../general/permissiondenied.php?');
        exit;
    }
} else {
    $querymore2 = " WHERE pro.id='$project'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore2);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: ../projects/listprojects.php?msg=blankProject');
        exit;
    }

    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../projects/viewproject.php?toggle_focus=meetings&id=' . $project . '&msg=permissiondenied');
        exit;
    }

    $querymore = " WHERE tea.project='$project' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($permissionDetail->prp_log_meeting_hours[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?toggle_focus=meetings&id=' . $project . '&msg=permissiondenied');
        exit;
    }
}

/**
 * Fields check
 */
if ($action == 'update') {
    $error = ''; // init

    // make sure we have the required information
    if (!empty($hr)) {
        if (!is_numeric($hr)) {
            // we need this to be numeric
            $error = lang_strings('worked_hours') . ' ' . lang_strings('error_numerical');
            $bodyCommand = 'onLoad="document.saMForm.hr.focus();"';
            $hr_highlight = true;
        }
    } else {
        // we need this to be numeric
        $error = lang_strings('worked_hours') . ' ' . lang_strings('error_required');
        $bodyCommand = 'onLoad="document.saMForm.hr.focus();"';
        $hr_highlight = true;
    }

    if ($error == '') {
        if ($ld < mktime(0,0,0,intval(date('m',$meetingDetail->mee_start_time[0])),intval(date('d',$meetingDetail->mee_start_time[0])),intval(date('Y',$meetingDetail->mee_start_time[0])))) {
            $error = lang_strings("date_deviate");
            $bodyCommand = 'onLoad="document.saMForm.ldI.focus();"';
            $ld_highlight = true;
        } else if (periodLocked($ld)) {
            $error = lang_strings('period') . ' ' . createDate($period_date_start,'date',false,true) . ' ~ ' . createDate($period_date_end,'date',false,true) . ' ' . lang_strings('locked');
            $bodyCommand = 'onLoad="document.saMForm.ldI.focus();"';
            $ld_highlight = true;
        } else if ($enableTimesheet == 'true') {
            $fyear = intval(date('Y', $ld));
            $month = intval(date('m', $ld));
            $day = intval(date('d', $ld));
            $weekday = date("w", mktime(0, 0, 0, $month, $day, $fyear));

            if ($weekday == '0') {
                $sdate = mktime(0, 0, 0, $month, $day-6, $fyear);
            } else {
                $sdate = mktime(0, 0, 0, $month, $day-$weekday+1, $fyear);
            }

            if ($periodUnit == 'month') {
                $serialno = date("n");
            } else {
                $serialno = intval(date("W", $sdate));
            }

            $querymore = " WHERE tim.owner='$idSession' AND per.fyear='$fyear' AND per.serial_no='$serialno'";
            $timesheetDetail = new request();
            $timesheetDetail->openTimesheet($querymore);
            $comptTimesheetDetail = count($timesheetDetail->tim_owner);

            if ($comptTimesheetDetail == '0') {
                $timesheetReadOnly = false;
            } else if ($timesheetDetail->tim_status[0] == enumFileStatus::stNeedsApproval) {
                $timesheetReadOnly = true;
            } else {
                $timesheetReadOnly = false;
            }

            if ($timesheetReadOnly) {
                $error = lang_strings("no_permissions");
            }
        }
    }
}

/**
 * Actions
 */
if ($action == 'update' && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        // update meeting time in database
        $hr = round($hr, $hourAccuracy);
        $comm = HtmlEntitiesNOD($comm);
        $tmpsql  = "UPDATE " . $tablePrefix . "meetings_time SET date='$ld',hours=$hr,comments='$comm',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../meetings/addmeetingtime.php?id=$meeting&msg=update");
        exit;
    }
}

/**
 * Set values in form
 */
if ($error == '') {
    $ld = $meetingTimeDetail->mti_date[0];
    $hr = $meetingTimeDetail->mti_hours[0];
    $comm = $meetingTimeDetail->mti_comments[0];
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '0') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../general/home.php?", lang_strings('home'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?", lang_strings("my_meetings"), 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=meetings&id=$project", $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$project", lang_strings("meetings"), 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=$meeting", $meetingDetail->mee_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_meeting_time"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "saM";
$block1->openForm("../meetings/editmeetingtime.php?id=$id&meeting=$meeting#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="update">';
$block1->heading(lang_strings("edit_meeting_time"));
$block1->openContent();
setupInputHTML($block1, lang_strings("date"), 'ldI', enumFieldType::ftDate, 'Y', '0', $ld, '', '', $ld_highlight);
$block1->contentRow("* " . lang_strings("worked_hours"), '<input value="' . $hr . '"' . (($hr_highlight)?' class="highlight"':'') . ' name="hr" maxlength="6" type="text">');
setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings["update"] . '"><input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
