<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: historymeeting.php,v 1.13 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');

/**
 * Permission check
 */
$querymore = " WHERE mee.id='$id'";
$meetingDetail = new request();
$meetingDetail->openMeetings($querymore);
$comptMeetingDetail = count($meetingDetail->mee_id);

if ($comptMeetingDetail == '0') {
    header('Location: ../general/home.php?msg=blankMeeting');
    exit;
}

$project = $meetingDetail->mee_project[0];

if ($project == '0') {
    if (!$SW_Permissions['Meeting']['Read'][$profilSession]) {
        header('Location: ../general/permissiondenied.php?');
        exit;
    }
} else {
    $querymore = " WHERE pro.id='$project'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    $querymore = " WHERE tea.project='$project' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($permissionDetail->prp_view_meeting[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?toggle_focus=meetings&id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '0') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../general/home.php?", lang_strings('home'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?" . $urlBornes, lang_strings("my_meetings"), 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=meetings&id=$project" . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/listmeetings.php?project=$project" . $urlBornes, lang_strings("meetings"), 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../meetings/viewmeeting.php?id=$id" . $urlBornes, $meetingDetail->mee_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("updates_meeting"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "mdP";
$block1->openForm("");
$block1->heading(lang_strings("meeting") . " : " . $meetingDetail->mee_name[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$querymore = " WHERE upd.type='M' AND upd.item='$id' ORDER BY upd.created DESC";
$listUpdates = new request();
$listUpdates->openUpdates($querymore);
$comptListUpdates = count($listUpdates->upd_id);

for ($i=0; $i<$comptListUpdates; $i++) {
    $upd_comm = $listUpdates->upd_comments[$i];

    if (preg_match("|\[status:([0-9])\]|i", $upd_comm, $matches) === 1) {
        $upd_comm = preg_replace_callback("|\[status:([0-9])\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
        $upd_comm .= lang_strings("status") . " " . $status[$matches[1]];
    }

    if (preg_match("|\[priority:([0-9])\]|i", $upd_comm, $matches) === 1) {
        $upd_comm = preg_replace_callback("|\[priority:([0-9])\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
        $upd_comm .= lang_strings("priority") . " " . $priority[$matches[1]];
    }

    if (preg_match("|\[location:(.)\]|i", $upd_comm, $matches) === 1) {
        $upd_comm = preg_replace_callback("|\[location:(.)\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
        $upd_comm .= lang_strings("location") . " " . $matches[1];
    }

    $block1->contentRow(lang_strings("posted_by"), $blockPage->buildLink($listUpdates->upd_member[$i], '', 'message'));

    if ($listUpdates->upd_created[$i] > $lastvisiteSession) {
        $block1->contentRow(lang_strings("when"), "<b>" . createDate($listUpdates->upd_created[$i], 'both') . "</b>");
    } else {
        $block1->contentRow(lang_strings("when"), createDate($listUpdates->upd_created[$i], 'both'));
    }

    $block1->contentRow("", $upd_comm);
    $block1->contentRow("", "", "true");
}

$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
