<?php // $Revision: 1.21 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listmeetings.php,v 1.21 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');

/**
 * Permission check
 */
if ($project != '0') {
    $querymore1 = " WHERE pro.id='$project'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore1);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    $querymore = " WHERE tea.project='$project' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if (!$SW_Permissions['Project']['Admin'][$profilSession] && $permissionDetail->prp_view_meeting[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?toggle_focus=meetings&id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project == '0') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../general/home.php?", lang_strings('home'), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings('my_meetings'));
    $title = $strings['my_meetings'];
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=meetings&id=$project" . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings('meetings'));
    $title = $strings['meetings'] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = "7";     // 1st for listprojects, 6th for viewproject
logURL($title, "../meetings/listmeetings.php?project=$project");
$block1 = new block();
$block1->form = "saM";
$block1->openForm("../meetings/listmeetings.php?project=$project" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading($title);
$block1->borne = $blockPage->returnBorne('7');
$block1->rowsLimit = 12;
$block1->sorting("meetings", (isset($sortingUser['meetings'])?$sortingUser['meetings']:''), 'mee.start_time DESC', $sortingFields = array(0 => 'mee.id', 1 => 'mee.name', 2 => 'mee.priority', 3 => 'mee.status', 4 => 'mee.start_time', 5 => 'mee.duration'));

if ($project == '0') {
    $querymore = " WHERE EXISTS (SELECT att.meeting FROM " . $tablePrefix . "attendees att WHERE att.meeting=mee.id AND att.member='$idSession' AND (mee.status IN ('" . enumMeetingStatus::stScheduling . "','" . enumMeetingStatus::stScheduled . "') OR (mee.status IN ('" . enumMeetingStatus::stCompleted . "','" . enumMeetingStatus::stOpen . "') AND att.attended='" . enumBoolean::bTrue . "'))) ORDER BY " . $block1->sortingValue;
} else {
    $querymore = " WHERE mee.project='$project' ORDER BY " . $block1->sortingValue;
}

$block1->recordsTotal = compt($initrequest["meetings"] . " " . $querymore);
$listMeetings = new request();
$listMeetings->openMeetings($querymore, $block1->borne, $block1->rowsLimit);
$comptListMeetings = count($listMeetings->mee_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['id'];
$columns[0]->field_type = enumFieldType::ftNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['meeting'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['priority'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['status'];
$columns[3]->field_type = enumFieldType::ftText;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['start_time'];
$columns[4]->field_type = enumFieldType::ftText;
$columns[5] = new cardviewColumn();
$columns[5]->title = $strings['duration'];
$columns[5]->field_type = enumFieldType::ftText;
$opt = array();
$opt[enumCardviewOption::oObject] = 'meetings';
$opt[enumCardviewOption::oTableName] = 'meetings';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;
$opt[enumCardviewOption::oExtraParameters] =  $urlBornes . '&borne7=' . $block1->borne;

if ($project == '0') {
    if ($SW_Permissions['Meeting']['Write'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../meetings/editmeeting.php?' . $urlBornes;
    }
} else {
    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_create_meeting[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = '../meetings/editmeeting.php?project=' . $project . $urlBornes;
        }
    }
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListMeetings; $i++) {
    $idStatus = $listMeetings->mee_status[$i];
    $idPriority = $listMeetings->mee_priority[$i];

    if ($idStatus == enumMeetingStatus::stCompleted || $idStatus == enumMeetingStatus::stCanceled) {
        $mee_name = '<del>' . $listMeetings->mee_name[$i] . '</del>';
    } else {
        $mee_name = $listMeetings->mee_name[$i];
    }

    if ($idStatus == enumMeetingStatus::stScheduling) {
        $start_time = '--';
    } else {
        if ($listMeetings->mee_start_time[$i] <= time() && $idStatus != enumMeetingStatus::stCompleted && $idStatus != enumMeetingStatus::stCanceled) {
            $start_time = "<b>" . createDate($listMeetings->mee_start_time[$i], 'both') . "</b>";
        } else {
            $start_time = createDate($listMeetings->mee_start_time[$i], 'both');
        }
    }

    $content = array(
        $listMeetings->mee_id[$i] . (($listMeetings->mee_reminder[$i] == '1')?' <img src="../themes/' . THEME . '/bell.gif">':''),
        $mee_name,
        $priority[$idPriority],
        $statusMeeting[$idStatus],
        $start_time,
        sprintf("%.1f %s", $listMeetings->mee_duration[$i], lang_strings("hours"))
    );
    $block1->itemCardView($listMeetings->mee_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter(7, $blockPage->bornesNumber, "project=$project" . $urlBornes);
$block1->closeFormResults();
require_once("../includes/footer.php");
