<?php // $Revision: 1.18 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: noti_locationmeetingchange.php,v 1.18 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

if (!defined('INNER_NOTI_LOCMEETCHG')) {
    return;
}

$querymore = " WHERE mee.id='$id'";
$meetingNoti = new request();
$meetingNoti->openMeetings($querymore);
$project = $meetingNoti->mee_project[0];

if ($project != '0') {
    $querymore = " WHERE pro.id='$project'";
    $projectNoti = new request();
    $projectNoti->openProjects($querymore);
}

$notiid = 'locationmeetingchanged';
$querymore = " WHERE att.meeting='$id' AND att.member<>'$idSession' AND NOT EXISTS (SELECT noti.member FROM " . $tablePrefix . "notifications noti WHERE noti.member=att.member AND notiid='$notiid' AND block='" . enumBoolean::bTrue . "') ORDER BY mem.language";
$listNotifications = new request();
$listNotifications->openAttendees($querymore);
$comptListNotifications = count($listNotifications->att_meeting);

if ($comptListNotifications == 0) {
    return;
}

// backup timezone session
$timezoneBackup = $timezoneSession;

for ($i37a=0; $i37a<$comptListNotifications; $i37a++) {
    // change timezone
    if ($listNotifications->att_loc_timezone[$i37a] == '') {
        $timezoneSession = $defaultTimezone;
    } else {
        $timezoneSession = $listNotifications->att_loc_timezone[$i37a];
    }
    // change language
    if (selectLanguage($listNotifications->att_mem_language[$i37a])) {
        // currency matrix
        require('../includes/currency.inc.php');
        // load array definitions
        require('../includes/arrays.lib.php');
    }

    $mail = new notification();
    $mail->getUserinfo($idSession, "from");
    $mail->getUserinfo($listNotifications->att_member[$i37a], "to");
    $mail->partSubject = $strings["noti_locationmeetingchange1"];
    $mail->partMessage = $strings["noti_locationmeetingchange2"];
    $mail->Priority = ($meetingNoti->mee_priority[0] == enumPriority::prNone)?3:(6 - intval($meetingNoti->mee_priority[0]));
    $idStatus = $meetingNoti->mee_status[0];
    $idPriority = $meetingNoti->mee_priority[0];
    $mail->openBody();
    $mail->openContent();
    $mail->contentRow($strings["meeting"], $meetingNoti->mee_name[0]);
    $mail->contentRow($strings["me_agenda"], $meetingNoti->mee_agenda[0]);
    $mail->contentRow($strings["me_location"], $meetingNoti->mee_location[0]);
    $mail->contentRow($strings["priority"], $priority[$idPriority]);
    $mail->contentRow($strings["status"], $statusMeeting[$idStatus]);

    if ($project != '0') {
        $mail->contentRow($strings["project"], $projectNoti->pro_name[0] . " (" . $projectNoti->pro_id[0] . ")");
        
        if ($projectNoti->pro_org_id[0] != "1") {
            $mail->contentRow($strings["organization"], $projectNoti->pro_org_name[0]);
        }
    }

    $mail->contentRow($strings["duration"], sprintf("%.1f %s", $meetingNoti->mee_duration[0], $strings['hours']));
    $mail->contentRow($strings['start_time'], createDate($meetingNoti->mee_start_time[0], 'both'));
    $mail->contentRow($strings["user_timezone"], $timezoneTable[$timezoneSession]);
    $mail->closeContent();

    if ($project == '0' || $listNotifications->att_mem_organization[$i37a] == '1') {
        $mail->note("$root/general/login.php?url=meetings/viewmeeting.php%3Fid=$id");
    } else {
        $mail->note("$root/general/login.php?url=service_site/home.php%3Fproject=$project");
    }

    $mail->closeBody($notiid);
    $subject = $mail->partSubject . " " . $meetingNoti->mee_name[0];
    $mail->Subject = $subject;
    $mail->SendItOut();
}

// restore timezone session
$timezoneSession = $timezoneBackup;
// restore language
if (selectLanguage($languageSession)) {
    // currency matrix
    require('../includes/currency.inc.php');
    // load array definitions
    require('../includes/arrays.lib.php');
}
