<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: noti_meetingassignment.php,v 1.16 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

if (!defined('INNER_NOTI_MEETASSIGN')) {
    return;
}

if ($num == "") {
    $num = $id;
}

$tmpquery = " WHERE mee.id='$num'";
$meetingNoti = new request();
$meetingNoti->openMeetings($tmpquery);
$project = $meetingNoti->mee_project[0];

if ($project != '0') {
    $tmpquery = " WHERE pro.id='$project'";
    $projectNoti = new request();
    $projectNoti->openProjects($tmpquery);
}

$notiid = 'meetingassignment';
$querymore = " WHERE att.meeting='$num' AND att.member<>'$idSession' AND NOT EXISTS (SELECT noti.member FROM " . $tablePrefix . "notifications noti WHERE noti.member=att.member AND notiid='$notiid' AND block='" . enumBoolean::bTrue . "') ORDER BY mem.language";
$listNotifications = new request();
$listNotifications->openAttendees($querymore);
$comptListNotifications = count($listNotifications->att_meeting);

if ($comptListNotifications == 0) {
    return;
}

// backup timezone session
$timezoneBackup = $timezoneSession;

for ($ib1=0; $ib1<$comptListNotifications; $ib1++) {
    // change timezone
    if ($listNotifications->att_loc_timezone[$ib1] == '') {
        $timezoneSession = $defaultTimezone;
    } else {
        $timezoneSession = $listNotifications->att_loc_timezone[$ib1];
    }
    // change language
    if (selectLanguage($listNotifications->att_mem_language[$ib1])) {
        // currency matrix
        require('../includes/currency.inc.php');
        // load array definitions
        require('../includes/arrays.lib.php');
    }

    $mail = new notification();
    $mail->getUserinfo($idSession, "from");
    $mail->getUserinfo($listNotifications->att_member[$ib1], "to");
    $mail->partSubject = $strings["noti_meetingassignment1"];
    $mail->partMessage = $strings["noti_meetingassignment2"];

    if ($meetingNoti->mee_priority[0] == enumPriority::prHigh || $meetingNoti->mee_priority[0] == enumPriority::prVeryHigh) {
        $mail->Priority = "1";
    } else {
        $mail->Priority = "3";
    }

    $idStatus = $meetingNoti->mee_status[0];
    $idPriority = $meetingNoti->mee_priority[0];
    $mail->openBody();
    $mail->openContent();
    $mail->contentRow($strings["meeting"], $meetingNoti->mee_name[0]);
    $mail->contentRow($strings["me_agenda"], $meetingNoti->mee_agenda[0]);
    $mail->contentRow($strings["date"], createDate($meetingNoti->mee_start_time[0]));
    $mail->contentRow($strings["start_time"], createDate($meetingNoti->mee_start_time[0], 'time'));
    $mail->contentRow($strings["end_time"], createDate($meetingNoti->mee_end_time[0], 'time'));
    $mail->contentRow($strings["user_timezone"], $timezoneTable[$timezoneSession]);
    $mail->contentRow($strings["me_location"], $meetingNoti->mee_location[0]);
    $mail->contentRow($strings["priority"], $priority[$idPriority]);
    $mail->contentRow($strings["status"], $status[$idStatus]);

    if ($project != '0') {
        $mail->contentRow($strings["project"], $projectNoti->pro_name[0] . " (" . $projectNoti->pro_id[0] . ")");
        
        if ($projectNoti->pro_org_id[0] != "1") {
            $mail->contentRow($strings["organization"], $projectNoti->pro_org_name[0]);
        }
    }

    $mail->closeContent();

    if ($meetingNoti->mee_mem_organization[0] == "1") {
        $mail->note("$root/general/login.php?url=meetings/viewmeeting.php%3Fid=$num");
    } else if ($meetingNoti->mee_mem_organization[0] != "1" && $projectNoti->pro_published[0] == enumPublished::pbYes) {
        $mail->note("$root/general/login.php?url=service_site/home.php%3Fproject=" . $projectNoti->pro_id[0]);
    }

    $mail->closeBody($notiid);
    $subject = $mail->partSubject . " " . $meetingNoti->mee_name[0];
    $mail->Subject = $subject;
    $mail->SendItOut();
}

// restore timezone session
$timezoneSession = $timezoneBackup;
// restore language
if (selectLanguage($languageSession)) {
    // currency matrix
    require('../includes/currency.inc.php');
    // load array definitions
    require('../includes/arrays.lib.php');
}
