<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: noti_meetinginvitation.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

if (!defined('INNER_NOTI_MEETINVITE')) {
    return;
}

if ($num=='') {
    $num = $id;
}

$querymore = " WHERE mee.id='$num'";
$meetingNoti = new request();
$meetingNoti->openMeetings($querymore);
$project = $meetingNoti->mee_project[0];

if ($project != '0') {
    $querymore = " WHERE pro.id='$project'";
    $projectNoti = new request();
    $projectNoti->openProjects($querymore);
}

$notiid = 'meetinginvitation';
$querymore = " WHERE att.meeting='$num' AND att.member<>'$idSession' AND NOT EXISTS (SELECT noti.member FROM " . $tablePrefix . "notifications noti WHERE noti.member=att.member AND notiid='$notiid' AND block='" . enumBoolean::bTrue . "') ORDER BY mem.language";
$listNotifications = new request();
$listNotifications->openAttendees($querymore);
$comptListNotifications = count($listNotifications->att_meeting);

if ($comptListNotifications == 0) {
    return;
}

// backup timezone session
$timezoneBackup = $timezoneSession;
$querymore = " WHERE msc.meeting='$num' AND msc.canceled<>'" . enumBoolean::bTrue . "'";
$listSchedules = new request();
$listSchedules->openMeetingSchedule($querymore);
$comptListSchedules = count($listSchedules->msc_id);

for ($ibd=0; $ibd<$comptListNotifications; $ibd++) {
    // change timezone
    if ($listNotifications->att_loc_timezone[$ibd] == '') {
        $timezoneSession = $defaultTimezone;
    } else {
        $timezoneSession = $listNotifications->att_loc_timezone[$ibd];
    }
    // change language
    if (selectLanguage($listNotifications->att_mem_language[$ibd])) {
        // currency matrix
        require('../includes/currency.inc.php');
        // load array definitions
        require('../includes/arrays.lib.php');
    }

    $mail = new notification();
    $mail->getUserinfo($idSession, "from");
    $mail->getUserinfo($listNotifications->att_member[$ibd], "to");
    $mail->partSubject = $strings["noti_meetinginvitation1"];
    $mail->partMessage = sprintf($strings["noti_meetinginvitation2"], $nameSession);
    $mail->Priority = ($meetingNoti->mee_priority[0] == enumPriority::prNone)?3:(6 - intval($meetingNoti->mee_priority[0]));
    $idStatus = $meetingNoti->mee_status[0];
    $idPriority = $meetingNoti->mee_priority[0];
    $mail->openBody();
    $mail->openContent();
    $mail->contentRow($strings["meeting"], $meetingNoti->mee_name[0]);
    $mail->contentRow($strings["me_agenda"], $meetingNoti->mee_agenda[0]);
    $mail->contentRow($strings["me_location"], $meetingNoti->mee_location[0]);
    $mail->contentRow($strings["priority"], $priority[$idPriority]);
    $mail->contentRow($strings["status"], $statusMeeting[$idStatus]);

    if ($project != '0') {
        $mail->contentRow($strings["project"], $projectNoti->pro_name[0] . " (" . $projectNoti->pro_id[0] . ")");
        
        if ($projectNoti->pro_org_id[0] != "1") {
            $mail->contentRow($strings["organization"], $projectNoti->pro_org_name[0]);
        }
    }

    $mail->contentRow($strings["duration"], sprintf("%.1f %s", $meetingNoti->mee_duration[0], $strings['hours']));

    if ($idStatus == enumMeetingStatus::stScheduling) {
        for ($jbd=0; $jbd<$comptListSchedules; $jbd++) {
            $mail->contentRow((($jbd==0)?$strings["proposed_dates_times"]:''), createDate($listSchedules->msc_start_time[$jbd], 'both'));
        }
    } else {
        $mail->contentRow($strings['start_time'], createDate($meetingNoti->mee_start_time[0], 'both'));
    }

    $mail->contentRow($strings["user_timezone"], $timezoneTable[$timezoneSession]);
    $mail->closeContent();
    $mail->note("$root/meetings/replymeetinginvitation.php?id=$num&auth=" . $listNotifications->att_schedule_string[$ibd], $strings['noti_meetinginvitation3']);
    $mail->closeBody($notiid);
    $subject = $mail->partSubject . " " . $meetingNoti->mee_name[0];
    $mail->Subject = $subject;
    $mail->SendItOut();
}

// restore timezone session
$timezoneSession = $timezoneBackup;
// restore language
if (selectLanguage($languageSession)) {
    // currency matrix
    require('../includes/currency.inc.php');
    // load array definitions
    require('../includes/arrays.lib.php');
}
