<?php // $Revision: 1.19 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: noti_meetingminutes.php,v 1.19 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

if (!defined('INNER_NOTI_MEETMINUTE')) {
    return;
}

$querymore = " WHERE mee.id='$meeting'";
$meetingNoti = new request();
$meetingNoti->openMeetings($querymore);
$project = $meetingNoti->mee_project[0];

if ($project != '0') {
    $querymore = " WHERE pro.id='$project'";
    $projectNoti = new request();
    $projectNoti->openProjects($querymore);
}

$notiid = 'meetingminutes';
$querymore = " WHERE att.meeting='$meeting' AND att.member<>'$idSession' AND NOT EXISTS (SELECT noti.member FROM " . $tablePrefix . "notifications noti WHERE noti.member=att.member AND notiid='$notiid' AND block='" . enumBoolean::bTrue . "') ORDER BY mem.language";
$listNotifications = new request();
$listNotifications->openAttendees($querymore);
$comptListNotifications = count($listNotifications->att_meeting);

if ($comptListNotifications == 0) {
    return;
}

$querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtMeeting . "' AND fil.doc_id='$meeting' AND fil.vc_parent=0";
$attachmentsNoti = new request();
$attachmentsNoti->openFiles($querymore);
$comptAttachmentsNoti = count($attachmentsNoti->fil_id);
$att_id = array();
$att_name = array();
$att_path = array();
$attp_id = array();
$attp_name = array();
$attp_path = array();

for ($i7d=0; $i7d<$comptAttachmentsNoti; $i7d++) {
    $att_id[$i7d] = $attachmentsNoti->fil_id[$i7d];
    $att_name[$i7d] = $attachmentsNoti->fil_name[$i7d];

    if ($mkdirMethod == 'FTP') {
        $tmpfname = tempnam ("../files", "FOO");
        $ftp = ftp_connect(FTPSERVER);
        ftp_login($ftp, FTPLOGIN, FTPPASSWORD);
        ftp_get($ftp, $tmpfname, $ftpRoot . "/" . $attachmentsNoti->fil_fullname[$i7d], FTP_BINARY);
        ftp_quit($ftp);
        $att_path[$i7d] = $tmpfname;
    } else {
        $att_path[$i7d] = "../files/" . $attachmentsNoti->fil_fullname[$i7d];
    }

    if ($attachmentsNoti->fil_published[$i7d] == enumPublished::pbYes) {
        $attp_id[] = $att_id[$i7d];
        $attp_name[] = $att_name[$i7d];
        $attp_path[] = $att_path[$i7d];
    }
}

for ($i7d=0; $i7d<$comptListNotifications; $i7d++) {
    // change language
    if (selectLanguage($listNotifications->att_mem_language[$i7d])) {
        // currency matrix
        require('../includes/currency.inc.php');
        // load array definitions
        require('../includes/arrays.lib.php');
    }

    $mail = new notification();
    $mail->getUserinfo($idSession, "from");
    $mail->getUserinfo($listNotifications->att_member[$i7d], "to");
    $mail->partSubject = $strings["noti_meetingminutes1"];
    $mail->partMessage = $strings["noti_meetingminutes2"];

    if ($meetingNoti->mee_priority[0] == enumPriority::prHigh || $meetingNoti->mee_priority[0] == enumPriority::prVeryHigh) {
        $mail->Priority = "1";
    } else {
        $mail->Priority = "3";
    }

    $idStatus = $meetingNoti->mee_status[0];
    $idPriority = $meetingNoti->mee_priority[0];
    $mail->openBody();
    $mail->openContent();
    $mail->contentRow($strings["meeting"], $meetingNoti->mee_name[0]);
    $mail->contentRow($strings["me_agenda"], $meetingNoti->mee_agenda[0]);
    $mail->contentRow($strings["me_location"], $meetingNoti->mee_location[0]);
    $mail->contentRow($strings["priority"], $priority[$idPriority]);
    $mail->contentRow($strings["status"], $statusMeeting[$idStatus]);

    if ($project != '0') {
        $mail->contentRow($strings["project"], $projectNoti->pro_name[0] . " (" . $projectNoti->pro_id[0] . ")");
        
        if ($projectNoti->pro_org_id[0] != "1") {
            $mail->contentRow($strings["organization"], $projectNoti->pro_org_name[0]);
        }
    }

    $mail->contentRow($strings["me_minutes"], $meetingNoti->mee_minutes[0]);
    $mail->closeContent();
    
    if ($project == '0' || $listNotifications->att_mem_organization[$i7d] == '1') {
        $mail->note("$root/general/login.php?url=meetings/viewmeeting.php%3Fid=$meeting");
    } else {
        $mail->note("$root/general/login.php?url=service_site/home.php%3Fproject=" . $projectNoti->pro_id[0]);
    }
    
    $mail->closeBody($notiid);
    $subject = $mail->partSubject . " " . $meetingNoti->mee_name[0];
    $mail->Subject = $subject;

    for ($j7d=0; $j7d<count($att_name); $j7d++) {
        $mail->AddAnAttach($att_path[$j7d], $att_name[$j7d], $att_id[$j7d]);
    }

    $mail->SendItOut();
}

// restore language
if (selectLanguage($languageSession)) {
    // currency matrix
    require('../includes/currency.inc.php');
    // load array definitions
    require('../includes/arrays.lib.php');
}
