<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletenotes.php,v 1.13 2013/01/29 08:46:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$error = '';

/**
 * Permission check
 */
$querymore0 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore0);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?toggle_focus=notes&id=' . $project . '&msg=permissiondenied' . $urlBornes);
    exit;
}

$querymore1 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore1);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_delete_note[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?toggle_focus=notes&id=' . $project . '&msg=permissiondenied' . $urlBornes);
    exit;
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'notes', $ids, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "notes WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtNote . "' AND fil.doc_id IN ($ids)";
        deleteAttachFiles($requestAct, $querymore);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../notes/listnotes.php?project=$project&msg=delete" . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=notes&id=$project" . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/listnotes.php?project=$project" . $urlBornes, lang_strings("notes"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_note"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "deN";
$block1->openForm("../notes/deletenotes.php?project=$project&amp;id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
echo '<input type="hidden" name="action" value="delete">';
$block1->heading(lang_strings("delete_note"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));
$querymore = " WHERE note.id IN ($ids) ORDER BY note.subject";
$listNotes = new request();
$listNotes->openNotes($querymore);
$comptListNotes = count($listNotes->note_id);

for ($i = 0;$i < $comptListNotes;$i++) {
    $block1->contentRow("#" . $listNotes->note_id[$i], $listNotes->note_subject[$i]);
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
