<?php // $Revision: 1.32 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editnote.php,v 1.32 2013/01/29 08:46:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
$bodyCommand = "onLoad=\"document.ntEForm.subject.focus();\"";

/**
 * Variables init
 */
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$topic = isset($_POST['topic'])?$_POST['topic']:'';
$subject = isset($_POST['subject'])?$_POST['subject']:'';
$description = isset($_POST['description'])?$_POST['description']:'';
$ddI = isset($_POST['ddI'])?$_POST['ddI']:'';
$dd = ($ddI=='')?$dateToday:date2Timestamp($ddI);
$new_project = isset($_POST['new_project'])?$_POST['new_project']:'';
$error = '';

if ($new_project != '' && is_numeric($new_project)) {
    $old_project = $project;
    $project = $new_project;
}

/**
 * Permission check
 */
if ($id != '') {
    $querymore = " WHERE note.id='$id'";
    $noteDetail = new request();
    $noteDetail->openNotes($querymore);
    $comptNoteDetail = count($noteDetail->note_id);

    if ($comptNoteDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

$querymore0 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore0);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?toggle_focus=notes&id=' . $project . '&msg=permissiondenied' . $urlBornes);
    exit;
}

$querymore = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($id == '') {
    if ($permissionDetail->prp_add_note[0] != enumBoolean::bTrue) {
        header("Location: ../notes/listnotes.php?project=$new_project&msg=permissiondenied" . $urlBornes);
        exit;
    }
} else {
    if ($permissionDetail->prp_modify_note_properties[0] != enumBoolean::bTrue) {
        header("Location: ../notes/listnotes.php?project=$new_project&msg=permissiondenied" . $urlBornes);
        exit;
    }
}

/**
 * Check fields
 */
if ($action != '') {
    $error = checkCustomFields('notes', $id);
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $subject = HtmlEntitiesNOD($subject);
    $description = HtmlEntitiesNOD($description);

    // case update note entry
    if ($action == "update") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsql = setupCustomFieldsUpdateSQL('notes', $id);  // Generate custom fields update sql
            $tmpsql = "UPDATE " . $tablePrefix . "notes SET project='$new_project',topic='$topic',subject='$subject',description='$description',date='$dd',owner='$idSession',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            if ($new_project != $old_project) {
                $tmpquery = "SELECT upload_dir FROM " . $tablePrefix . "projects WHERE id='$old_project'";
                $folderFrom = clone $requestAct;
                $folderFrom->query($tmpquery);
                $folderFrom->fetch();
                $folderFrom->upload_dir = ($row[0]);
                $tmpquery = "SELECT upload_dir FROM " . $tablePrefix . "projects WHERE id='$new_project'";
                $folderTo = clone $requestAct;
                $folderTo->query($tmpquery);
                $folderTo->fetch();
                $folderTo->upload_dir = ($row[0]);
                $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtNote . "' AND fil.doc_id='$id'";
                $listFiles = clone $requestAct;
                $listFiles->openFiles($querymore);
                $comptListFiles = count($listFiles->fil_id);

                if ($folderFrom->upload_dir != $folderTo->upload_dir && $comptListFiles != '0') {
                    $querymore = " WHERE fil.id='" . $folderTo->upload_dir . "'";
                    $folderDetail = clone $requestAct;
                    $folderDetail->openFiles($querymore);
                    $path = $folderDetail->fil_fullname[0];
                    moveFiles($listFiles->fil_fullname, $path);

                    for ($i=0; $i<$comptListFiles; $i++) {
                        $fullname = $path . strrchr($listFiles->fil_fullname[$i], '/');
                        $tmpsql = "UPDATE " . $tablePrefix . "files SET parent=" . $folderTo->upload_dir . ",fullname='" . HtmlEntitiesNOD($fullname) . "',modified='" . time() . "',muser='$idSession' WHERE id='" . $listFiles->fil_id[$i] . "'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        copy2HistoryTable($requestAct, 'files', $listFiles->fil_id[$i], 'U');
                    }
                }
            }

            copy2HistoryTable($requestAct, 'notes', $id, 'U');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../notes/viewnote.php?id=$id&msg=update" . $urlBornes);
            exit;
        }
    }
    // case add note entry
    if ($action == "add") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsqls = setupCustomFieldsInsertSQL('notes');  // Generate custom fields insert sql
            $tmpsql = "INSERT INTO " . $tablePrefix . "notes(project,topic,subject,description,date,owner,published,created,cuser" . $cfsqls[0] . ") VALUES('$new_project','$topic','$subject','$description','$dd',$idSession,'" . enumPublished::pbNo . "','" . time() . "','$idSession'" . $cfsqls[1] . ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $sendto = $requestAct->newId("notes");
            $cfsql = setupCustomMediaFieldsUpdateSQL('notes', $sendto);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "notes SET $cfsql WHERE id='$sendto'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $querymore = " WHERE fil.id='" . $projectDetail->pro_upload_dir[0] . "'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtNote, $sendto, enumFileStatus::stNoApprovalsNeeded, $projectDetail->pro_upload_dir[0], $path);
            copy2HistoryTable($requestAct, 'notes', $sendto, 'A');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../notes/viewnote.php?id=$sendto&msg=add" . $urlBornes);
            exit;
        }
    }
}

/**
 * Set value in form
 */
if ($error == '') {
    if ($id != '') {
        $dd = $noteDetail->note_date[0];
        $subject = $noteDetail->note_subject[0];
        $description = $noteDetail->note_description[0];
        $topic = $noteDetail->note_topic[0];
    } else {
        $dd = $dateToday;
        $topic = '';
    }
}


/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=notes&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/listnotes.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("notes"), 'in'));

if ($id == "") {
    $blockPage->itemBreadcrumbs(lang_strings("add_note"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../notes/viewnote.php?id=" . $noteDetail->note_id[0] . $urlBornes, $noteDetail->note_subject[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_note"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "ntE";
$block1->openForm("../notes/editnote.php?project=$project&amp;id=$id" . $urlBornes . "#" . $block1->form . "Anchor");

if ($id == "") {
    $block1->heading(lang_strings("add_note"));
    echo '<input type="hidden" name="action" value="add">';
} else {
    $block1->heading(lang_strings("edit_note") . " : " . $noteDetail->note_subject[0]);
    echo '<input type="hidden" name="action" value="update">';
}

$block1->openContent();
$block1->contentTitle(lang_strings("info"));

if ($SW_Permissions['Project']['Admin'][$profilSession]) {
    $querymore = " WHERE pro.status IN ('" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "') OR pro.id='$project'";
} else {
    $querymore = " LEFT OUTER JOIN " . $tablePrefix . "teams teams ON teams.project=pro.id ";
    $querymore .= " WHERE (teams.member='$idSession' AND pro.status IN ('" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "')) OR pro.id='$project'";
}

$listProjects = new request();
$listProjects->openProjects($querymore);
$comptListProjects = count($listProjects->pro_id);
$projectSel = "<select name=\"new_project\" onchange=\"change_project(this);\">";

for ($i = 0;$i < $comptListProjects;$i++) {
    if ($listProjects->pro_id[$i] == $projectDetail->pro_id[0]) {
        $projectSel .= "<option value=\"" . $listProjects->pro_id[$i] . "\" selected>" . $listProjects->pro_name[$i] . "</option>";
    } else {
        $projectSel .= "<option value=\"" . $listProjects->pro_id[$i] . "\">" . $listProjects->pro_name[$i] . "</option>";
    }

    $org_name = ($listProjects->pro_organization[$i]=='1')?lang_strings('none'):htmlspecialchars($listProjects->pro_org_name[$i]);
    echo '<input type="hidden" id="orgName' . $listProjects->pro_id[$i] . '" value="' . $org_name . '">';
}

$projectSel .= "</select>";
$block1->contentRow(lang_strings("project"), $projectSel);
$org_name = ($projectDetail->pro_organization[0]=='1')?lang_strings('none'):$projectDetail->pro_org_name[0];
$block1->contentRow(lang_strings("organization"), '<div id="orgName">' . $org_name . '</div>');
$block1->contentTitle(lang_strings("details"));
setupInputHTML($block1, lang_strings("date"), 'ddI', enumFieldType::ftDate, 'Y', '0', $dd);
$topSel = populateSelect('notes', 'topic', 'topic', $topic);
$block1->contentRow("* " . lang_strings("topic"), $topSel);
setupInputHTML($block1, lang_strings("subject"), 'subject', enumFieldType::ftText, 'Y', '255', $subject);
setupInputHTML($block1, lang_strings("description"), 'description', enumFieldType::ftMemo, 'Y', '0', $description);
setupCustomFieldsInputHTML($block1, 'notes', $id);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();

if ($fileManagement == 'true' && (($id == '') && ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue))) {
    setupAttachFilesHTML(($sitePublish=='true'));
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
function change_project(theObj)
{
    var proId = theObj.value;
    var newOrg = document.getElementById('orgName' + proId);
    document.getElementById('orgName').innerHTML = newOrg.value;
}
</script>
<?php
require_once("../includes/footer.php");
