<?php // $Revision: 1.15 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listnotes.php,v 1.15 2013/01/29 08:46:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSite = isset($_GET['addToSiteNote'])?$_GET['addToSiteNote']:'';
$removeToSite = isset($_GET['removeToSiteNote'])?$_GET['removeToSiteNote']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$error = '';

/**
 * Permission check
 */
$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore);
$comptPermissionDetail = count($permissionDetail->prp_project);

if (!$SW_Permissions['Project']['Admin'][$profilSession] && $permissionDetail->prp_view_note[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?toggle_focus=notes&id=' . $project . '&msg=permissiondenied' . $urlBornes);
    exit;
}

if ($action == "publish") {
    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../projects/viewproject.php?toggle_focus=notes&id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }

    if ($permissionDetail->prp_publish_note[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?toggle_focus=notes&id=' . $project . '&msg=permissiondenied' . $urlBornes);
        exit;
    }
}

/**
 * Actions
 */
if ($action == "publish") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $chg = false;
        $requestAct->startTransaction();

        if ($addToSite == "true") {
            $querymore2 = " WHERE note.id IN ($ids) AND note.published<>'" . enumPublished::pbYes . "'";
            $listNotes = clone $requestAct;
            $listNotes->openNotes($querymore2);

            if (count($listNotes->note_id) > 0) {
                $chg = true;
                $ids2 = implode(',', $listNotes->note_id);
                $tmpsql = "UPDATE " . $tablePrefix . "notes SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids2)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                copy2HistoryTable($requestAct, 'notes', $ids2, 'U');
            }

            $msg = "addToSite";
            $id = $project;
        } else if ($removeToSite == "true") {
            $querymore3 = " WHERE note.id IN ($ids) AND note.published<>'" . enumPublished::pbNo . "'";
            $listNotes = clone $requestAct;
            $listNotes->openNotes($querymore3);

            if (count($listNotes->note_id) > 0) {
                $chg = true;
                $ids3 = implode(',', $listNotes->note_id);
                $tmpsql = "UPDATE " . $tablePrefix . "notes SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids3)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                copy2HistoryTable($requestAct, 'notes', $ids3, 'U');
            }

            $msg = "removeToSite";
            $id = $project;
        }

        if ($chg) {
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } else {
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=notes&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("notes"));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '6';     // 1st for listprojects, 5th for viewproject
$title = $strings['notes'] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
logURL($title, "../notes/listnotes.php?project=$project");
$block1 = new block();
$block1->form = "lsN";
$block1->openForm("../notes/listnotes.php?project=$project" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("notes"));
$block1->borne = $blockPage->returnBorne('6');
$block1->rowsLimit = '12';

if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
    $block1->sorting("notes", (isset($sortingUser['notes'])?$sortingUser['notes']:''), "note.date DESC", $sortingFields = array(0 => "note.subject", 1 => "note.topic", 2 => "note.date", 3 => "mem.name", 4 => "note.published"));
} else {
    $block1->sorting("notes", (isset($sortingUser['notes'])?$sortingUser['notes']:''), "note.date DESC", $sortingFields = array(0 => "note.subject", 1 => "note.topic", 2 => "note.date", 3 => "mem.name"));
}

$querymore = " WHERE note.project='$project' ORDER BY " . $block1->sortingValue;
$block1->recordsTotal = compt($initrequest['notes'] . ' ' . $querymore);
$listNotes = new request();
$listNotes->openNotes($querymore, $block1->borne, $block1->rowsLimit);
$comptListNotes = count($listNotes->note_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['subject'];
$columns[0]->field_type = enumFieldType::ftText;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['topic'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['date'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['owner'];
$columns[3]->field_type = enumFieldType::ftAvatar;

if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['published'];
    $columns[4]->field_type = enumFieldType::ftText;
}

$opt[enumCardviewOption::oObject] = 'notes';
$opt[enumCardviewOption::oTableName] = 'notes';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;
$opt[enumCardviewOption::oExtraParameters] = 'project=' . $project . '&org_url=' . urlencode("notes/listnotes.php?project=$project" . $urlBornes . "&borne6=" . $block1->borne);

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_add_note[0] == enumBoolean::bTrue) {
        $opt[enumCardviewOption::oAddUrl] = '../notes/editnote.php?project=' . $project . $urlBornes;
    }
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListNotes; $i++) {
    $content = array(
        $listNotes->note_subject[$i],
        fieldValidValueString('notes', 'topic', $listNotes->note_topic[$i]),
        createDate($listNotes->note_date[$i],'date',false,true),
        implode(',',
            array(
                $listNotes->note_owner[$i],
                $listNotes->note_mem_extension_picture[$i],
                $listNotes->note_mem_gender[$i]))
    );

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
        $idPublish = $listNotes->note_published[$i];
        $content[] = $statusPublish[$idPublish];
    }

    $block1->itemCardView($listNotes->note_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter("6", $blockPage->bornesNumber, "project=$project" . $urlBornes);
$block1->closeFormResults();
require_once("../includes/footer.php");
