<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletepayments.php,v 1.16 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$inv = AddSlashesNOD(isset($_GET['inv'])?$_GET['inv']:'');
$ids = str_replace('**', ',', $id);
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Payment']['Admin'][$profilSession]) {
    header('Location: ../payments/listpayments.php?msg=permissiondenied' . $urlBornes);
    exit;
}

if ($inv != '') {
    $querymore0 = " WHERE pay.id IN ($ids) AND pay.invoice='$inv'";
    $listPayments0 = new request();
    $listPayments0->openPayments($querymore0);
    $comptListPayments0 = count($listPayments0->pay_id);
}

$querymore1 = " WHERE pay.id IN ($ids)";
$listPayments = new request();
$listPayments->openPayments($querymore1);
$comptListPayments = count($listPayments->pay_id);

if ($comptListPayments == 0) {
    header('Location: ../payments/listpayments.php?msg=permissiondenied' . $urlBornes);
    exit;
}

$inva = array_unique($listPayments->pay_invoice);

if ($inv != '' && (count($inva) != 1 || $inva[0] != $inv)) {
    header('Location: ../invoices/viewinvoice.php?id=' . $inv . '&msg=permissiondenied' . $urlBornes);
    exit;
}

for ($i=0; $i<$comptListPayments; $i++) {
    if (periodLocked($listPayments->pay_doc_date[$i])) {     // check if period locked
        if ($inv != '') {
            header('Location: ../invoices/viewinvoice.php?id=' . $inv . '&msg=periodLocked' . $urlBornes);
            exit;
        } else {
            header('Location: ../payments/listpayments.php?msg=periodLocked' . $urlBornes);
            exit;
        }
    }
}

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'payments', $ids, 'D');
        // delete payments
        $tmpsql = 'DELETE FROM ' . $tablePrefix . "payments WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
        // delete linked contents
        $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtPayment . "' AND fil.doc_id IN ($ids)";
        deleteAttachFiles($requestAct, $querymore);
        // update invoices
        $tmpquery = "SELECT inv.id,inv.amount,inv.paid,(SELECT SUM(pay.amount) FROM " . $tablePrefix . "payments pay WHERE pay.invoice=inv.id) AS paidnew FROM " . $tablePrefix . "invoices inv WHERE inv.id IN ('" . implode("','", $inva) . "')";
        $listInvoices = clone $requestAct;
        $listInvoices->query($tmpquery);
        $comptListInvoices = $listInvoices->rowCount();
        // check if invoices missing
        if ($comptListInvoices != count($inva)) {
            throw new Exception($strings['blank_invoice']);
        }

        $listInvoices->inv_id = null;
        $listInvoices->inv_amount = null;
        $listInvoices->inv_paid = null;
        $listInvoices->inv_paid_new = null;
        // load invoices data
        while ($listInvoices->fetch()) {
            $listInvoices->inv_id[] = ($row[0]);    // invoice id
            $listInvoices->inv_amount[] = DbValueDecode(enumFieldType::ftTotals, $row[1]);    // invoice total
            $listInvoices->inv_paid[] = DbValueDecode(enumFieldType::ftTotals, $row[2]);      // invoice paid
            $listInvoices->inv_paid_new[] = (is_numeric($row[3]))?DbValueDecode(enumFieldType::ftTotals, $row[3]):0;   // new invoice paid
        }

        for ($i=0; $i<$comptListInvoices; $i++) {
            if ($listInvoices->inv_paid_new[$i] != $listInvoices->inv_paid[$i]) {
                // invoice new status
                if ($listInvoices->inv_paid_new[$i] >= $listInvoices->inv_amount[$i]) {
                    $status = enumDocumentStatus::stClosed;
                } else {
                    $status = enumDocumentStatus::stOpen;
                }
                // update invoice
                $tmpsql = "UPDATE " . $tablePrefix . "invoices SET paid='" . $listInvoices->inv_paid_new[$i] . "',status='$status',modified='" . time() . "',muser='$idSession' WHERE id='" . $listInvoices->inv_id[$i] . "'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                copy2HistoryTable($requestAct, 'invoices', $listInvoices->inv_id[$i], 'U');
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($inv == '') {
            header('Location: ../payments/listpayments.php?msg=delete' . $urlBornes);
            exit;
        } else {
            header('Location: ../invoices/viewinvoice.php?id=' . $inv . '&msg=delete' . $urlBornes);
            exit;
        }
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings("accounting"));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../payments/listpayments.php?" . $urlBornes, lang_strings("payments"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('delete_payments'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'dPy';
$block1->openForm("../payments/deletepayments.php?id=$id&inv=$inv" . $urlBornes . "#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings('delete_payments'));
$block1->openContent();
$block1->contentTitle(lang_strings('delete_following'));

for ($i=0; $i<$comptListPayments; $i++) {
    $block1->contentRow('#' . $listPayments->pay_id[$i], CurrencyFormatNOD($listPayments->pay_amount[$i], $listPayments->pay_currency[$i], $costAccuracy));
}

$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
require_once('../includes/footer.php');
