<?php // $Revision: 1.36 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editpayment.php,v 1.36 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$error = '';
$dt_highlight = false;
$inv = isset($_REQUEST['inv'])?$_REQUEST['inv']:''; // invoice id
$dtI = isset($_POST['dtI'])?$_POST['dtI']:'';       // The input value of payment date
$dt = ($dtI=='')?$dateToday:date2Timestamp($dtI);   // The timestamp of payment date
$cu = isset($_POST['cu'])?$_POST['cu']:'';          // currency
$pym = isset($_POST['pym'])?$_POST['pym']:'';       // payment method
$amt = isset($_POST['amt'])?$_POST['amt']:'0';      // payment total
$note = isset($_POST['note'])?$_POST['note']:'';    // payment notes
$bodyCommand = 'onLoad="document.edPForm.inv.focus();"';

/**
 * Permission check
 */
if ($id != '') {
    // test exists selected payment, redirect to list if not
    $querymore0 = " WHERE pay.id='$id'";
    $paymentDetail = new request();
    $paymentDetail->openPayments($querymore0);
    $comptPaymentDetail = count($paymentDetail->pay_id);

    if ($comptPaymentDetail == 0) {
        header('Location: ../payments/listpayments.php?msg=permissiondenied' . $urlBornes);
        exit;
    }

    if (!$SW_Permissions['Payment']['Edit'][$profilSession]) {
        header('Location: ../payments/listpayments.php?msg=permissiondenied' . $urlBornes);
        exit;
    }

    if (periodLocked($paymentDetail->pay_doc_date[0])) {     // check if period locked
        header('Location: ../payments/listpayments.php?msg=periodLocked' . $urlBornes);
        exit;
    }
} else if (!$SW_Permissions['Payment']['Write'][$profilSession]) {
    header('Location: ../payments/listpayments.php?msg=permissiondenied' . $urlBornes);
    exit;
}

/**
 * get open invoices
 */
$querymore1 = " WHERE inv.status='" . enumDocumentStatus::stOpen . "'";

if ($id != '') {
    $querymore1 .= " OR inv.id='" . $paymentDetail->pay_invoice[0] . "'";
}

$querymore1 .= " ORDER BY inv.invoice_no";
$listOpenInvoices = new request();
$listOpenInvoices->openInvoices($querymore1);
$comptListOpenInvoices = count($listOpenInvoices->inv_id);

if ($comptListOpenInvoices == 0) {
    header('Location: ../payments/listpayments.php?msg=noAvailableInvoices' . $urlBornes);
    exit;
}

$invVV = array();

for ($i=0; $i<$comptListOpenInvoices; $i++) {
    $invVV[$listOpenInvoices->inv_id[$i]] = $listOpenInvoices->inv_invoice_no[$i];
}

/**
 * Check fields
 */
if ($action != '') {
    if (periodLocked($dt)) {
        $error = lang_strings('period') . ' ' . createDate($period_date_start,'date',false,true) . ' ~ ' . createDate($period_date_end,'date',false,true) . ' ' . lang_strings('locked');
        $bodyCommand = 'onLoad="document.edPForm.dtI.focus();"';
        $dt_highlight = true;
    } else {
        $error = checkCustomFields('payments', $id);
    }
}

/**
 * Actions
 */
if ($action != '' && $error == '') {
    $note = HtmlEntitiesNOD($note);
    $amt = DbValueEncode(enumFieldType::ftTotals, $amt);

    if ($action == 'update') { // case update payment
        $oldinv = $paymentDetail->pay_invoice[0];   // origin invoice id
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsql = setupCustomFieldsUpdateSQL('payments', $id);  // Generate custom fields update sql
            $tmpsql = 'UPDATE ' . $tablePrefix . "payments SET invoice='$inv',currency='$cu',amount='$amt',doc_date='$dt',payment_method='$pym',notes='$note',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            // check invoices
            $tmpquery = "SELECT inv.id,inv.amount,inv.paid,(SELECT SUM(pay.amount) FROM " . $tablePrefix . "payments pay WHERE pay.invoice=inv.id) AS paidnew FROM " . $tablePrefix . "invoices inv WHERE inv.id='$oldinv'";

            if ($inv != $oldinv) {
                $tmpquery .= " OR inv.id='$inv'";
            }

            $listInvoices = clone $requestAct;
            $listInvoices->query($tmpquery);
            $comptListInvoices = $listInvoices->rowCount();
            // check if invoices missing
            if (($comptListInvoices == 0) || ($comptListInvoices == 1 && $inv != $oldinv)) {
                throw new Exception($strings['blank_invoice']);
            }

            $listInvoices->inv_id = null;
            $listInvoices->inv_amount = null;
            $listInvoices->inv_paid = null;
            $listInvoices->inv_paid_new = null;
            // load invoices data
            while ($listInvoices->fetch()) {
                $listInvoices->inv_id[] = ($row[0]);    // invoice id
                $listInvoices->inv_amount[] = DbValueDecode(enumFieldType::ftTotals, $row[1]);    // invoice total
                $listInvoices->inv_paid[] = DbValueDecode(enumFieldType::ftTotals, $row[2]);      // invoice paid
                $listInvoices->inv_paid_new[] = (is_numeric($row[3]))?DbValueDecode(enumFieldType::ftTotals, $row[3]):0;   // new invoice paid
            }

            for ($i=0; $i<$comptListInvoices; $i++) {
                if ($listInvoices->inv_paid_new[$i] != $listInvoices->inv_paid[$i]) {
                    // invoice new status
                    if ($listInvoices->inv_paid_new[$i] >= $listInvoices->inv_amount[$i]) {
                        $status = enumDocumentStatus::stClosed;
                    } else {
                        $status = enumDocumentStatus::stOpen;
                    }
                    // update invoice
                    $tmpsql = "UPDATE " . $tablePrefix . "invoices SET paid='" . $listInvoices->inv_paid_new[$i] . "',status='$status',modified='" . time() . "',muser='$idSession' WHERE id='" . $listInvoices->inv_id[$i] . "'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    copy2HistoryTable($requestAct, 'invoices', $listInvoices->inv_id[$i], 'U');
                }
            }
            // upload attachments
            $querymore2 = " WHERE fil.id='1'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore2);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtPayment, $id, enumFileStatus::stNoApprovalsNeeded, '1', $path);
            copy2HistoryTable($requestAct, 'payments', $id, 'U');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../invoices/viewinvoice.php?id=$inv&msg=updatePayment" . $urlBornes);
            exit;
        }
    } else if ($action == 'add') { // case add payment
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsqls = setupCustomFieldsInsertSQL('payments');  // Generate custom fields insert sql
            // insert into payments and redirect to new payment detail (last id)
            $tmpsql = "INSERT INTO " . $tablePrefix . "payments (invoice,currency,amount,doc_date,payment_method,notes,created,cuser" . $cfsqls[0] . ") VALUES ('$inv','$cu','$amt','$dt','$pym','$note','" . time() . "','$idSession'" . $cfsqls[1] . ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('payments');
            $cfsql = setupCustomMediaFieldsUpdateSQL('payments', $num);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "payments SET $cfsql WHERE id='$num'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            // check invoice
            $querymore1 = " WHERE inv.id='$inv'";
            $invoiceDetail = clone $requestAct;
            $invoiceDetail->openInvoices($querymore1);

            if (count($invoiceDetail->inv_id) == 0) {
                throw new Exception($strings['blank_invoice']);
            }
            // invoice paid
            $paid = $invoiceDetail->inv_paid[0] + $amt;
            // invoice new status
            if ($paid >= $invoiceDetail->inv_amount[0]) {
                $status = enumDocumentStatus::stClosed;
            } else {
                $status = enumDocumentStatus::stOpen;
            }
            // update invoice
            $tmpsql = "UPDATE " . $tablePrefix . "invoices SET paid='$paid',status='$status',modified='" . time() . "',muser='$idSession' WHERE id='$inv'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'invoices', $inv, 'U');
            // upload attachments
            $querymore2 = " WHERE fil.id='1'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore2);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtPayment, $num, enumFileStatus::stNoApprovalsNeeded, '1', $path);
            copy2HistoryTable($requestAct, 'payments', $num, 'A');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../invoices/viewinvoice.php?id=$inv&msg=addPayment" . $urlBornes);
            exit;
        }
    }
}

/**
 * get payment method list
 */
$querymore2 = " WHERE pym.locked='" . enumBoolean::bFalse . "' ORDER BY pym.name";
$listPaymentMethods = new request();
$listPaymentMethods->openPaymentMethods($querymore2);
$comptListPaymentMethods = count($listPaymentMethods->pym_id);
$pymVV = array();

for ($i=0; $i<$comptListPaymentMethods; $i++) {
    $pymVV[$listPaymentMethods->pym_id[$i]] = $listPaymentMethods->pym_name_print[$i];
}

/**
 * Form variables init
 */
if ($error == '') {
    // set value in form
    if ($id != '') {
        $inv = $paymentDetail->pay_invoice[0];
        $cu = $paymentDetail->pay_currency[0];
        $amt = $paymentDetail->pay_amount[0];
        $dt = $paymentDetail->pay_doc_date[0];
        $pym = $paymentDetail->pay_payment_method[0];
        $note = $paymentDetail->pay_notes[0];
    } else {
        if ($inv == '' || $inv == '0') {
            $inv = $listOpenInvoices->inv_id[0];
        }

        $dt = time();
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
echo '<script type="text/javascript" src="../javascript/editpayment' . $scriptMinimized . '.js"></script>';
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings("accounting"));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../payments/listpayments.php?' . $urlBornes, lang_strings('payments'), 'in'));

if ($id == '') {
    $blockPage->itemBreadcrumbs(lang_strings('add_payment'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../payments/viewpayment.php?id=' . $paymentDetail->pay_id[0] . $urlBornes, $paymentDetail->pay_id[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings('edit_payment'));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "edP";

if ($id == '') {
    $block1->openForm('../payments/editpayment.php?' . $urlBornes . '#' . $block1->form . 'Anchor');
    $block1->heading(lang_strings('add_payment'));
    echo '<input type="hidden" id="action" name="action" value="add">';
} else {
    $block1->openForm("../payments/editpayment.php?id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
    $block1->heading(lang_strings('edit_payment') . ' : ' . $id);
    echo '<input type="hidden" id="action" name="action" value="update">';
}

$block1->openContent();
$block1->contentTitle(lang_strings('details'));
setupInputHTML($block1, lang_strings('invoice'), 'inv', enumFieldType::ftNumeric, 'Y', '11', $inv, $invVV, '', false, '', 'onchange="invchg()"');
setupInputHTML($block1, lang_strings('date'), 'dtI', enumFieldType::ftDate, 'Y', '8', $dt, '', '', $dt_highlight);
$block1->contentRow(lang_strings('currency'), '<div id="cu">' . $cu . '</div><input type="hidden" id="cuH" name="cu" value="' . $cu . '">');
setupInputHTML($block1, lang_strings('amount'), 'amt', array(enumFieldType::ftTotals, enumFieldOption::foPositiveNumber), 'Y', '0', $amt);
setupInputHTML($block1, lang_strings('payment_method'), 'pym', enumFieldType::ftAlphaNumeric, 'N', '155', $pym, $pymVV);
setupInputHTML($block1, lang_strings('notes'), 'note', enumFieldType::ftMemo, 'N', '0', $note);
setupCustomFieldsInputHTML($block1, 'payments', $id);
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();

if ($fileManagement == 'true' && $SW_Permissions['File']['Write'][$profilSession]) {
    setupAttachFilesHTML(false);
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once('../includes/footer.php');
