<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listpayments.php,v 1.3 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Payment']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings("accounting"));
$blockPage->itemBreadcrumbs(lang_strings("payments"));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '3';     // 1st for listinvoices, 2nd for viewinvoice
logURL($strings['payments'], "../payments/listpayments.php");
$block1 = new block();
$block1->form = "pyL";
$block1->openForm("../payments/listpayments.php?" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("payments"));
$block1->borne = $blockPage->returnBorne('3');
$block1->rowsLimit = '12';
$block1->sorting('payments', (isset($sortingUser['payments'])?$sortingUser['payments']:''), "pay.doc_date DESC", $sortingFields = array(0 => 'pay.id', 1 => 'inv.invoice_no', 2 => 'pay.currency', 3 => 'pay.doc_date', 4 => 'pay.amount', 5 => 'pay.payment_method'));
$querymore = " ORDER BY " . $block1->sortingValue;
$block1->recordsTotal = compt($initrequest['payments'] . ' ' . $querymore);
$listPayments = new request();
$listPayments->openPayments($querymore, $block1->borne, $block1->rowsLimit);
$comptListPayments = count($listPayments->pay_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['id'];
$columns[0]->field_type = enumFieldType::ftNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['invoice'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['currency'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['date'];
$columns[3]->field_type = enumFieldType::ftText;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['total'];
$columns[4]->field_type = enumFieldType::ftTotals;
$columns[5] = new cardviewColumn();
$columns[5]->title = $strings['payment_method'];
$columns[5]->field_type = enumFieldType::ftText;
$opt[enumCardviewOption::oObject] = 'payments';
$opt[enumCardviewOption::oTableName] = 'payments';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oExtraParameters] = $urlBornes . '&borne3=' . $block1->borne;

if ($SW_Permissions['Payment']['Write'][$profilSession]) {
    $opt[enumCardviewOption::oAddUrl] = '../payments/editpayment.php?' . $urlBornes;
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListPayments; $i++) {
    $content = array(
        $listPayments->pay_id[$i],
        $block1->buildLink('../invoices/viewinvoice.php?id=' . $listPayments->pay_invoice[$i] . $urlBornes, $listPayments->pay_inv_invoice_no[$i], 'in'),
        $listPayments->pay_currency[$i],
        createDate($listPayments->pay_doc_date[$i], 'date', false, true),
        $listPayments->pay_amount[$i],
        $listPayments->pay_pym_name_print[$i]
    );
    $block1->itemCardView($listPayments->pay_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter("3", $blockPage->bornesNumber, $urlBornes);
$block1->closeFormResults();
require_once("../includes/footer.php");
