<?php // $Revision: 1.21 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: printpayments.php,v 1.21 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$plt = isset($_POST['plt'])?$_POST['plt']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";

/**
 * Permission check
 */
if (!$SW_Permissions['Payment']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore0 = " WHERE pay.id IN ($ids)";
$listPayments = new request();
$listPayments->openPayments($querymore0);
$comptListPayments = count($listPayments->pay_id);

if ($comptListPayments == 0) {
    header('Location: ../payments/listpayments.php?msg=permissiondenied' . $urlBornes);
    exit;
}

if ($plt == '') {
    $querymore1 = " WHERE plt.doc_type='" . enumFileRelatedDocumentType::dtPayment . "' ORDER BY plt.description";
} else {
    $querymore1 = "WHERE plt.id='$plt'";
}

if ($comptListPayments == 1) {
    $redirect2 = "/payments/viewpayment.php?id=$id";
} else {
    $redirect2 = "/payments/listpayments.php?";
}

$listPrintLayouts = new request();
$listPrintLayouts->openPrintLayouts($querymore1);
$comptListPrintLayouts = count($listPrintLayouts->plt_id);

if ($comptListPrintLayouts == 0) {
    header("Location: ..$redirect2&msg=permissiondenied" . $urlBornes);
    exit;
}

if ($comptListPrintLayouts == 1) {  // print output payment(s)
    $path = unzipPrintLayout($listPrintLayouts->plt_path[0]);

    if ($path === false) {
        header("Location: ..$redirect2&msg=permissiondenied" . $urlBornes);
        exit;
    }

    $urlx = $root . $redirect2 . '&msg=requestProcessed';
    $a = preg_split('#/#', str_replace('\\', '/', $path));
    $url0 = $root . '/files/' . $a[count($a)-1];
    $html0 = file_get_contents($path . '/' . $listPrintLayouts->plt_start_page[0]);
    // load built-in variables
    $html02 = loadReportBuiltInVariables($html0);
    // load my company information
    $html01 = loadReportDataSources($html02, 'mycompany', 'organizations', "mycompany.id='1'");
    // load login user information
    $html1 = loadReportDataSources($html01, 'loginuser', 'members', "loginuser.id='$idSession'");
    echo '<!DOCTYPE html>' . $setCopyright . '<html><head><meta content="text/html; charset=UTF-8" http-equiv="content-type"><title>payment</title><script type="text/javascript" src="../javascript/jquery-1.11.1.min.js"></script><script type="text/javascript">$(document).ready(function() { $.each($(\'input[type=hidden]\'), function(i,val) { var url=$(this).val(); window.open(url); }); window.location.replace("' . $urlx . '"); });</script></head><body>';

    for ($i=0; $i<$comptListPayments; $i++) {
        // load payment information
        $html2 = loadReportDataSources($html1, 'payments', 'payments', "payments.id='" . $listPayments->pay_id[$i] . "'");
        // load multi-rows information
        $html3 = loadReportMultiRowsDataSources($html2, $listPayments->pay_id[$i]);
        $newfile = $path . '/' . $i . $listPrintLayouts->plt_start_page[0];
        file_put_contents($newfile, $html3);
        echo '<input type="hidden" name="url' . $i . '" value="' . $url0 . '/' . $i . $listPrintLayouts->plt_start_page[0] . '">';
    }

    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = 'UPDATE ' . $tablePrefix . "payments SET printed='" . enumBoolean::bTrue . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'payments', $ids, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
    echo '</body></html>';
} else {        // choose print layout
    /**
     * Html
     */
    require_once("../includes/header.php");
    $blockPage = new block();
    $blockPage->openBreadcrumbs();
    $blockPage->itemBreadcrumbs(lang_strings("accounting"));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../payments/listpayments.php?" . $urlBornes, lang_strings("payments"), 'in'));

    if ($comptListPayments == 1) {
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../payments/viewpayment.php?id=$id" . $urlBornes, $id, 'in'));
    }

    $blockPage->itemBreadcrumbs(lang_strings('print'));
    $blockPage->closeBreadcrumbs();
    $block1 = new block();
    $block1->form = 'pPy';
    $block1->openForm('../payments/printpayments.php?id=' . $id . $urlBornes . '#' . $block1->form . 'Anchor');
    $block1->heading(lang_strings('print'));
    $block1->openContent();
    $block1->contentTitle(lang_strings('info'));
    $block1->contentRow(lang_strings('id'), implode(',', $listPayments->pay_id));
    $block1->contentTitle(lang_strings("choose_print_layout"));

    for ($i=0; $i<$comptListPrintLayouts; $i++) {
        $block1->contentRow('<input type="radio" name="plt" value="' . $listPrintLayouts->plt_id[$i] . '"' . (($listPrintLayouts->plt_defaults[$i]==enumBoolean::bTrue)?' checked':'') . '>', $listPrintLayouts->plt_description[$i]);
    }

    $block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["choose"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
    $block1->closeContent();
    $block1->closeToggle();
    $block1->closeForm();
    require_once('../includes/footer.php');
}