<?php // $Revision: 1.21 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewpayment.php,v 1.21 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Payment']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore = " WHERE pay.id='$id'";
$paymentDetail = new request();
$paymentDetail->openPayments($querymore);
$comptPaymentDetail = count($paymentDetail->pay_id);

if ($comptPaymentDetail <= 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings("accounting"));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../payments/listpayments.php?' . $urlBornes, lang_strings('payments'), 'in'));
$blockPage->itemBreadcrumbs("#$id");
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '4';     // 1st for listinvoices, 2nd for viewinvoice, 3rd for listpayments
$title = $strings['payment'] . ' : #' . $id;
logURL($title, '../payments/viewpayment.php?id=' . $id);
$block1 = new block();
$block1->form = 'vPy';
$block1->openForm('../payments/viewpayment.php?id=' . $id . $urlBornes . '#' . $block1->form . 'Anchor');
$block1->headingToggle($strings['payment'], !($toggle_focus==''));
$block1->openPaletteIcon();

if ($SW_Permissions['Payment']['Admin'][$profilSession]) {
    $block1->paletteIcon(0, 'remove', $strings['delete']);
}

if ($SW_Permissions['Payment']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, 'edit', $strings['edit']);
}

$block1->paletteIcon(2, 'print', $strings['print']);
$block1->closePaletteIcon();
$block1->openContent();
$block1->contentRow(lang_strings('invoice'), $block1->buildLink('../invoices/viewinvoice.php?id=' . $paymentDetail->pay_invoice[0] . $urlBornes, $paymentDetail->pay_inv_invoice_no[0], 'in'));
$block1->contentRow(lang_strings('date'), createDate($paymentDetail->pay_doc_date[0],'date',false,true));
$block1->contentRow(lang_strings('amount') . '&nbsp;' . $blockPage->printHelp($CurrencyMatrix['name'][$paymentDetail->pay_currency[0]], true), CurrencyFormatNOD($paymentDetail->pay_amount[0], $paymentDetail->pay_currency[0], $costAccuracy));
$block1->contentRow(lang_strings('payment_method'), $paymentDetail->pay_pym_name_print[0]);
$block1->contentRow(lang_strings('notes'), $paymentDetail->pay_notes[0]);
$block1->contentRow(lang_strings('printed'), DbValueDecode(enumFieldType::ftBoolean, $paymentDetail->pay_printed[0]));
setupCustomFieldsHTML($block1, 'payments', $id);
$block1->closeContent();
$block1->closeToggle();
$block1->closeForm();
$block1->openPaletteScript();

if ($SW_Permissions['Payment']['Admin'][$profilSession]) {
    $block1->paletteScript(0, 'remove', '../payments/deletepayments.php?id=' . $id . $urlBornes, 'true,true,false', $strings['delete']);
}

if ($SW_Permissions['Payment']['Edit'][$profilSession]) {
    $block1->paletteScript(1, 'edit', '../payments/editpayment.php?id=' . $id . $urlBornes, 'true,true,false', $strings['edit']);
}

$block1->paletteScript(2, 'print', '../payments/printpayments.php?id=' . $id . $urlBornes, 'true,true,false', $strings['print']);
$block1->closePaletteScript('', '');

if (($fileManagement == "true") && ($SW_Permissions['File']['Read'][$profilSession])) {
    $block2 = new block();
    $block2->form = "pyF";
    $block2->openForm("../payments/viewpayment.php?id=$id" . $urlBornes . "#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings("linked_content"), !($toggle_focus=='linked_content'));
    $block2->borne = $blockPage->returnBorne('4');
    $block2->rowsLimit = 12;
    $block2->sorting("payment_files", isset($sortingUser['payment_files'])?$sortingUser['payment_files']:'', 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status'));
    $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtPayment . "' AND fil.doc_id='$id' AND fil.vc_parent='0' ORDER BY " . $block2->sortingValue;
    $recordsTotal = compt($initrequest['files'] . $querymore);
    $block2->recordsTotal = $recordsTotal;
    $listFiles = new request();
    $listFiles->openFiles($querymore, $block2->borne, $block2->rowsLimit);
    $comptListFiles = count($listFiles->fil_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['owner'];
    $columns[1]->field_type = enumFieldType::ftAvatar;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['created'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['approval_tracking'];
    $columns[3]->field_type = enumFieldType::ftText;
    $opt[enumCardviewOption::oTableName] = 'files';
    $opt[enumCardviewOption::oObject] = 'files';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] = "doc_type=" . enumFileRelatedDocumentType::dtPayment . "&doc_id=$id" . $urlBornes . "&borne4=" . $block2->borne;

    if ($SW_Permissions['File']['Write'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = "../linkedcontent/addfile.php?doc_type=" . enumFileRelatedDocumentType::dtPayment . "&doc_id=$id" . $urlBornes;
    }

    $block2->openCardView($opt);

    for ($i=0; $i<$comptListFiles; $i++) {
        $idStatus = $listFiles->fil_status[$i];
        $content = array(
            $listFiles->fil_name[$i],
            implode(',',
                array(
                    $listFiles->fil_owner[$i],
                    $listFiles->fil_mem_extension_picture[$i],
                    $listFiles->fil_mem_gender[$i])),
            createDate($listFiles->fil_created[$i],'both'),
            $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . enumFileRelatedDocumentType::dtPayment . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i], $statusFile[$idStatus], 'in')
        );
        $block2->itemCardView($listFiles->fil_id[$i], $content);
    }

    $block2->closeCardView();
    $block2->bornesFooter("4", $blockPage->bornesNumber, "id=$id&toggle_focus=linked_content" . $urlBornes);
    $block2->closeToggle();
    $block2->closeFormResults();
}

require_once('../includes/footer.php');
