<?php // $Revision: 1.27 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editphase.php,v 1.27 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');       // The unique id of phase
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$st = isset($_POST['st'])?$_POST['st']:'';      // The status of phase
$sdI = isset($_POST['sdI'])?$_POST['sdI']:'';   // The display field of start date
$sd = ($sdI=='')?'0':date2Timestamp($sdI);      // The start date of phase
$edI = isset($_POST['edI'])?$_POST['edI']:'';   // The display field of end date
$ed = ($edI=='')?'0':date2Timestamp($edI);      // The end date of phase
$c = isset($_POST['c'])?$_POST['c']:'';         // The remarks of phase
$error = '';

/**
 * Permission check
 */
$querymore0 = " WHERE pha.id='$id'";
$phaseDetail = new request();
$phaseDetail->openPhases($querymore0);
$comptPhaseDetail = count($phaseDetail->pha_id);

if ($comptPhaseDetail == '0') {                 // Phase not found
    header("Location: ../general/permissiondenied.php");
    exit;
}

$project = $phaseDetail->pha_project[0];        // The project id of phase
$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {                 // Project not found
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=phases' . $urlBornes);
    exit;
}

$querymore = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_modify_phase_properties[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=phases' . $urlBornes);
    exit;
}

/**
 * Check fields
 */
if ($action == 'update') {
    if ($st == enumPhaseStatus::stOpen && $sd == '0') {     // start date required if phase open
        $error = lang_strings('date_start') . ' ' . lang_strings('error_required');
        $sd_highlight = true;
    } else if ($st == enumPhaseStatus::stCompleted) {
        if ($sd == '0') {                   // start date required if phase completed
            $error = lang_strings('date_start') . ' ' . lang_strings('error_required');
            $sd_highlight = true;
        } else if ($ed == '0') {            // end date required if phase completed
            $error = lang_strings('date_end') . ' ' . lang_strings('error_required');
            $ed_highlight = true;
        } else if ($ed < $sd) {             // end date must greater than or equals to start date
            $error = lang_strings('date_end') . ' ' . lang_strings('value_deviate');
            $ed_highlight = true;
        }
    }

    if ($error == '') {
        $error = checkCustomFields('phases', $id);
    }
}

/**
 * Actions
 */
if ($action == "update" && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $c = HtmlEntitiesNOD($c);   // Convert all applicable characters to HTML entities

        if ($st != enumPhaseStatus::stCompleted) {   // Clear end date value if phase not complete
            $ed = '0';
        }

        $cfsql = setupCustomFieldsUpdateSQL('phases', $id);  // Generate custom fields update sql
        $tmpsql = "UPDATE " . $tablePrefix . "phases SET status='$st',date_start='$sd',date_end='$ed',comments='$c',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $querymore = " WHERE fil.id='" . $projectDetail->pro_upload_dir[0] . "'";
        $folderDetail = clone $requestAct;
        $folderDetail->openFiles($querymore);
        $path = $folderDetail->fil_fullname[0];
        uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtPhase, $id, enumFileStatus::stNoApprovalsNeeded, $projectDetail->pro_upload_dir[0], $path);
        copy2HistoryTable($requestAct, 'phases', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../phases/viewphase.php?id=$id" . $urlBornes);
        exit;
    }
}

/**
 * Set values in form
 */
if ($error == '') {
    $st = $phaseDetail->pha_status[0];      // The status of phase
    $sd = $phaseDetail->pha_date_start[0];  // The start date of phase
    $ed = $phaseDetail->pha_date_end[0];    // The end date of phase
    $c = $phaseDetail->pha_comments[0];     // The remarks of phase
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=$project&toggle_focus=phases" . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($phaseDetail->pha_description[0]);
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "phE";
$block1->openForm("../phases/editphase.php?id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
$block1->heading(lang_strings("phase") . " : " . $phaseDetail->pha_description[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow(lang_strings("name"), $phaseDetail->pha_description[0]);    // The name of phase
$block1->contentRow(lang_strings("phase_id"), $phaseDetail->pha_id[0]);         // The unique id of phase
$stSel = '<select name="st" onchange="changest();">';

foreach ($phaseStatus as $val => $desc) {
    if ($val == $st) {
        $stSel .= '<option value="' . $val . '" selected>' . $desc . '</option>';
    } else {
        $stSel .= '<option value="' . $val . '">' . $desc . '</option>';
    }
}

$stSel .= '</select>';
$block1->contentRow(lang_strings("status"), $stSel);        // The status of phase
// The start date of phase
setupInputHTML($block1, lang_strings("date_start"), 'sdI', enumFieldType::ftDate, 'N', '0', $sd, '', '', $sd_highlight);
// The end date of phase
setupInputHTML($block1, lang_strings("date_end"), 'edI', enumFieldType::ftDate, 'N', '0', $ed, '', '', $ed_highlight);
setupInputHTML($block1, lang_strings('comments'), 'c', enumFieldType::ftMemo, 'N', '0', $c);    // The comments of phase
setupCustomFieldsInputHTML($block1, 'phases', $id);     // The custom fields of phase
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();

if ($fileManagement == 'true' && $permissionDetail->prp_add_file[0] == enumBoolean::bTrue) {
    setupAttachFilesHTML(($sitePublish=='true'));       // The attach files of phase
}

$block1->closeForm();
?>
<script type="text/javascript">
// status changed function
function changest()
{
    var st = document.phEForm.st.value;     // The status of phase
    var sdI = document.getElementById('sdI');      // The input field of start date
    var edI = document.getElementById('edI');      // The input field of end date

    switch (st) {
        case '0':   // Not start
            sdI.value = '';
            edI.value = '';
            break;
        case '1':   // Open
            edI.value = '';
            break;
        case '2':   // Completed
            break;
        case '3':   // Suspended
            edI.value = '';
            break;
    }
}

changest();     // Call funation 'status changed' when form initialization
</script>
<?php
require_once("../includes/footer.php");
