<?php // $Revision: 1.18 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listphases.php,v 1.18 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
$querymore = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore);
$comptPermissionDetail = count($permissionDetail->prp_project);

if (!$SW_Permissions['Project']['Admin'][$profilSession] && $permissionDetail->prp_view_phase[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=phases' . $urlBornes);
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=phases&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("phases"));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '8';     // 1st for listprojects, 7th for viewproject
$title = $strings['phases'] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
logURL($title, "../phases/listphases.php?project=$project");
$block1 = new block();
$block1->form = "wbSe";
$block1->openForm("../phases/listphases.php?project=$project" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("phases"));
$block1->borne = $blockPage->returnBorne('8');
$block1->rowsLimit = '12';
$block1->sorting("phases", (isset($sortingUser['phases'])?$sortingUser['phases']:''), "pha.order_num ASC", $sortingFields = array(0 => 'pha.order_num', 1 => 'none', 2 => 'pha.status', 3 => 'pha.date_start', 4 => 'pha.date_end'));
$querymore = " WHERE pha.project='$project' ORDER BY " . $block1->sortingValue;
$recordsTotal = compt($initrequest['phases'] . $querymore);
$block1->recordsTotal = $recordsTotal;
$listPhases = new request();
$listPhases->openPhases($querymore, $block1->borne, $block1->rowsLimit);
$comptListPhases = count($listPhases->pha_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['order'];
$columns[0]->field_type = enumFieldType::ftNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['name'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['status'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['date_start'];
$columns[3]->field_type = enumFieldType::ftText;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['date_end'];
$columns[4]->field_type = enumFieldType::ftText;
$opt[enumCardviewOption::oObject] = 'phases';
$opt[enumCardviewOption::oTableName] = 'phases';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oMultipleSelection] = false;
$opt[enumCardviewOption::oSearch] = true;
$opt[enumCardviewOption::oExtraParameters] = "project=$project" . $urlBornes . "&borne8=" . $block1->borne;
$block1->openCardView($opt);

for ($i=0; $i<$comptListPhases; $i++) {
    if ($listPhases->pha_status[$i] == enumPhaseStatus::stNotStarted) {
        $phaseStart = '--';
        $phaseEnd = '--';
    } else if ($listPhases->pha_status[$i] == enumPhaseStatus::stCompleted) {
        $phaseStart = createDate($listPhases->pha_date_start[$i],'date',false,true);
        $phaseEnd = createDate($listPhases->pha_date_end[$i],'date',false,true);
    } else {
        $phaseStart = createDate($listPhases->pha_date_start[$i],'date',false,true);
        $phaseEnd = '--';
    }

    $content = array(
        $listPhases->pha_order_num[$i],
        $listPhases->pha_description[$i],
        $phaseStatus[$listPhases->pha_status[$i]],
        $phaseStart,
        $phaseEnd
    );
    $block1->itemCardView($listPhases->pha_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter("8", $blockPage->bornesNumber, "project=$project" . $urlBornes);
$block1->closeFormResults();
require_once("../includes/footer.php");
