<?php // $Revision: 1.48 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewphase.php,v 1.48 2013/01/29 08:46:25 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
$taskgroupList = array();

/**
 * Functions
 */
function add_taskgroup_to_changelist($requestAct, $parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList)) {
        return;
    }

    $taskgroupList[$parent] = $level;
    $querymore = " WHERE tas.id='$parent'";
    $parentDetail = clone $requestAct;
    $parentDetail->openTasks($querymore);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($requestAct, $parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

function change_parent_task($requestAct, $parent)
{
    global $tablePrefix, $idSession;
    $querymore = " WHERE tas.parent_task='$parent'";
    $subtaskList = clone $requestAct;
    $subtaskList->openTasks($querymore);
    $newSubtask = count($subtaskList->tas_id);

    for ($i = 0;$i < $newSubtask;$i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }

            if ($status == enumStatus::stNotStarted || $newStatus == enumStatus::stNotStarted) {
                $newStatus = enumStatus::stNotStarted;
            } else if ($status == enumStatus::stOpen || $newStatus == enumStatus::stOpen) {
                $newStatus = enumStatus::stOpen;
            } else if ($status == enumStatus::stSuspended || $newStatus == enumStatus::stSuspended) {
                $newStatus = enumStatus::stSuspended;
            } else if ($status == enumStatus::stClientCompleted || $newStatus == enumStatus::stClientCompleted) {
                $newStatus = enumStatus::stClientCompleted;
            }

            $newCompletion += $completion;

            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }

            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }

            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = '--';
            }

            if ($published == enumPublished::pbYes) {
                $newPublished = enumPublished::pbYes;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = '--';
            }

            $newPublished = $published;
        }
    }

    $newCompletion = substr($newCompletion / $newSubtask, 0, 1);
    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', task_group='" . enumTaskGroup::tgYes . "', subtask='$newSubtask', modified='" . time() . "', muser='$idSession' WHERE id='$parent'";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }
}

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$phase = AddSlashesNOD(isset($_GET['phase'])?$_GET['phase']:'0');
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSite = isset($_GET['addToSiteTask'])?$_GET['addToSiteTask']:'';
$removeToSite = isset($_GET['removeToSiteTask'])?$_GET['removeToSiteTask']:'';
$addToSiteFile = isset($_GET['addToSiteFile'])?$_GET['addToSiteFile']:'';
$removeToSiteFile = isset($_GET['removeToSiteFile'])?$_GET['removeToSiteFile']:'';
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$base = isset($_GET['base'])?$_GET['base']:'1';
$gantt_sd = isset($_GET['gantt_sd'])?$_GET['gantt_sd']:'';
$error = isset($_GET['error'])?$_GET['error']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$showNext = '';

/**
 * Permission check
 */
if ($action == "publish") {
    $querymore1 = " WHERE pha.id='$phase'";
} else {
    $querymore1 = " WHERE pha.id='$id'";
}

$phaseDetail = new request();
$phaseDetail->openPhases2($querymore1);
$comptPhaseDetail = count($phaseDetail->pha_id);

if ($comptPhaseDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$project = $phaseDetail->pha_project[0];
$phase = $phaseDetail->pha_id[0];
$querymore2 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore2);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore3 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore3);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore4);
$comptPermissionDetail = count($permissionDetail->prp_project);

if (!$SW_Permissions['Project']['Admin'][$profilSession] && $permissionDetail->prp_view_phase[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=phases' . $urlBornes);
    exit;
}

if ($action == 'publish') {
    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=phases' . $urlBornes);
        exit;
    }

    if ($addToSite == 'true' || $removeToSite == 'true') {
        if ($permissionDetail->prp_publish_task[0] != enumBoolean::bTrue) {
            header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=phases' . $urlBornes);
            exit;
        }
    } else if ($addToSiteFile == "true" || $removeToSiteFile == "true") {
        if ($permissionDetail->prp_publish_file[0] != enumBoolean::bTrue) {
            header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=phases' . $urlBornes);
            exit;
        }
    }
}

/**
 * Actions
 */
if ($action == "publish") {
    if ($addToSite == "true") {
        $criticalSection = enter_critical_section();

        if ($criticalSection == -1) {
            header("Location: ../tasks/viewphase.php?id=$id&msg=$msg" . $urlBornes);
            exit;
        }

        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "tasks SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = "addToSite";
            $id = $phase;
            $querymore = " WHERE tas.id IN ($ids)";
            $listTasks = clone $requestAct;
            $listTasks->openTasks($querymore);
            $comptListTasks = count($listTasks->tas_id);

            for ($i=0; $i<$comptListTasks; $i++) {
                add_taskgroup_to_changelist($requestAct, $listTasks->tas_parent_task[$i], $listTasks->tas_level[$i]);
            }

            if (count($taskgroupList) > 0) {
                arsort($taskgroupList, SORT_NUMERIC);
                reset($taskgroupList);

                while (list($parentTask, $level) = each($taskgroupList)) {
                    change_parent_task($requestAct, $parentTask);
                }
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
        leave_critical_section($criticalSection);
    } else if ($removeToSite == "true") {
        $criticalSection = enter_critical_section();

        if ($criticalSection == -1) {
            header("Location: ../tasks/viewphase.php?id=$id&msg=$msg" . $urlBornes . $urlBornes);
            exit;
        }

        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "tasks SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = "removeToSite";
            $id = $phase;
            $querymore = " WHERE tas.id IN ($ids)";
            $listTasks = clone $requestAct;
            $listTasks->openTasks($querymore);
            $comptListTasks = count($listTasks->tas_id);

            for ($i=0; $i<$comptListTasks; $i++) {
                add_taskgroup_to_changelist($requestAct, $listTasks->tas_parent_task[$i], $listTasks->tas_level[$i]);
            }

            if (count($taskgroupList) > 0) {
                arsort($taskgroupList, SORT_NUMERIC);
                reset($taskgroupList);

                while (list($parentTask, $level) = each($taskgroupList)) {
                    change_parent_task($requestAct, $parentTask);
                }
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
        leave_critical_section($criticalSection);
    } else if ($addToSiteFile == "true") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "files SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = "addToSite";
            $id = $phase;
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    } else if ($removeToSiteFile == "true") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "files SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = "removeToSite";
            $id = $phase;
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=phases&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("phases"), 'in'));
$blockPage->itemBreadcrumbs($phaseDetail->pha_description[0]);
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '10';    // 1st for listprojects, 7th for viewproject, 8th for listphases
$title = $strings['phase'] . ' : ' . $phaseDetail->pha_description[0] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
logURL($title, "../phases/viewphase.php?id=$id");
$block1 = new block();
$block1->form = "pppD";
$block1->openForm("../projects/listprojects.php?" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->headingToggle($strings['phase'], !($toggle_focus==''));
$block1->openPaletteIcon();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_modify_phase_properties[0] == enumBoolean::bTrue) {
        $block1->paletteIcon(0, "edit", $strings["edit"]);
    }
}

$block1->paletteIcon(99, 'search', 'phases');
$block1->closePaletteIcon();

if ($phaseDetail->pha_status[0] == enumPhaseStatus::stNotStarted) {
    $phaseStart = '--';
    $phaseEnd = '--';
} else if ($phaseDetail->pha_status[0] == enumPhaseStatus::stCompleted) {
    $phaseStart = createDate($phaseDetail->pha_date_start[0],'date',false,true);
    $phaseEnd = createDate($phaseDetail->pha_date_end[0],'date',false,true);
} else {
    $phaseStart = createDate($phaseDetail->pha_date_start[0],'date',false,true);
    $phaseEnd = '--';
}

$block1->openContent();
$block1->contentRow(lang_strings("name"), $phaseDetail->pha_description[0]);
$block1->contentRow(lang_strings("phase_id"), $phaseDetail->pha_id[0]);
$block1->contentRow(lang_strings("status"), $phaseStatus[$phaseDetail->pha_status[0]]);
$block1->contentRow(lang_strings("total_tasks"), $phaseDetail->pha_total_tasks[0]);
$block1->contentRow(lang_strings("uncomplete_tasks"), $phaseDetail->pha_uncompleted_tasks[0]);
$block1->contentRow(lang_strings("milestone"), $phaseDetail->pha_milestones[0]);
$block1->contentRow(lang_strings("date_start"), $phaseStart);
$block1->contentRow(lang_strings("date_end"), $phaseEnd);
$block1->contentRow(lang_strings("comments"), $phaseDetail->pha_comments[0]);
setupCustomFieldsHTML($block1, 'phases', $id);
$block1->closeContent();
$block1->closeToggle();
$block1->closeForm();
$block1->openPaletteScript();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_modify_phase_properties[0] == enumBoolean::bTrue) {
        $block1->paletteScript(0, "edit", "../phases/editphase.php?id=$id" . $urlBornes, "true,true,true", $strings["edit"]);
    }
}

$block1->paletteScript(99, 'search', 'phases');
$block1->closePaletteScript($comptPhaseDetail, $phaseDetail->pha_id);

if ($permissionDetail->prp_view_task[0] == enumBoolean::bTrue) {
    $block2 = new block();
    $block2->form = "saP";
    $block2->openForm("../phases/viewphase.php?id=$id" . $urlBornes . "#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings("tasks"), !($toggle_focus=='tasks'));
    $block2->borne = $blockPage->returnBorne('9');
    $block2->rowsLimit = 12;

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
        $block2->sorting("phase_tasks", (isset($sortingUser['phase_tasks'])?$sortingUser['phase_tasks']:''), "tas.name ASC", $sortingFields = array(0 => "tas.id", 1 => "tas.name", 2 => "tas.priority", 3 => "tas.status", 4 => "tas.completion", 5 => "tas.due_date", 6 => "tas.assigned_to", 7 => "tas.published"));
    } else {
        $block2->sorting("phase_tasks", (isset($sortingUser['phase_tasks'])?$sortingUser['phase_tasks']:''), "tas.name ASC", $sortingFields = array(0 => "tas.id", 1 => "tas.name", 2 => "tas.priority", 3 => "tas.status", 4 => "tas.completion", 5 => "tas.due_date", 6 => "tas.assigned_to"));
    }

    $querymore = " WHERE tas.project='$project' AND tas.parent_phase='" . $phaseDetail->pha_order_num[0] . "' AND tas.level='0' ORDER BY " . $block2->sortingValue;
    $block2->recordsTotal = compt($initrequest['tasks'] . ' ' . $querymore);
    $listTasks = new request();
    $listTasks->openTasks($querymore, $block2->borne, $block2->rowsLimit);
    $comptListTasks = count($listTasks->tas_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['id'];
    $columns[0]->field_type = enumFieldType::ftNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['priority'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['status'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['completion'];
    $columns[4]->field_type = enumFieldType::ftText;
    $columns[5] = new cardviewColumn();
    $columns[5]->title = $strings['due_date'];
    $columns[5]->field_type = enumFieldType::ftText;
    $columns[6] = new cardviewColumn();
    $columns[6]->title = $strings['assigned_to'];
    $columns[6]->field_type = enumFieldType::ftAvatar;

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
        $columns[7] = new cardviewColumn();
        $columns[7]->title = $strings['published'];
        $columns[7]->field_type = enumFieldType::ftText;
    }

    $opt = array();
    $opt[enumCardviewOption::oObject] = 'tasks';
    $opt[enumCardviewOption::oTableName] = 'tasks';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] = 'org_url=' . urlencode("phases/viewphase.php?toggle_focus=tasks&phase=$phase" . $urlBornes . "&borne9=" . $block2->borne);

    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_create_task[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = "../tasks/edittask.php?project=$project&phase=" . $phaseDetail->pha_order_num[0] . $urlBornes;
        }
    }

    $block2->openCardView($opt);
    $today = mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y')));

    for ($i=0; $i<$comptListTasks; $i++) {
        $tmpquery = "SELECT id FROM " . $tablePrefix . "tasks WHERE parent_task='" . $listTasks->tas_id[$i] . "'";
        $comptSubTasks = compt($tmpquery);

        if ($comptSubTasks > 0) {
            $namePostfix = "&nbsp;&nbsp;($comptSubTasks&nbsp;" . lang_strings('subtasks') . ")";
        } else {
            $namePostfix = '';
        }

        $idStatus = $listTasks->tas_status[$i];
        $idPriority = $listTasks->tas_priority[$i];
        $idPublish = $listTasks->tas_published[$i];
        $complValue = ($listTasks->tas_completion[$i] > 0) ? $listTasks->tas_completion[$i] . "0 %": $listTasks->tas_completion[$i] . " %";

        if ($idStatus == 1) {
            $nameTxt = '<del>' . $listTasks->tas_name[$i] . $namePostfix . '</del>';
        } else {
            $nameTxt = $listTasks->tas_name[$i] . $namePostfix;
        }

        if ($listTasks->tas_milestone[$i] == enumMilestone::msYes) {
            $priorityTxt = '';
            $statusTxt = '';
            $completionTxt = '';
        } else {
            $priorityTxt = $priority[$idPriority];
            $statusTxt = $status[$idStatus];
            $completionTxt = $complValue;
        }

        if ($listTasks->tas_milestone[$i] == enumMilestone::msYes) {
            $duedateTxt = createDate($listTasks->tas_due_date[$i],'date',false,true);
        } else if ($listTasks->tas_due_date[$i] <= $today && $listTasks->tas_completion[$i] != '10') {
            $duedateTxt = '<div class="overdue">' . createDate($listTasks->tas_due_date[$i],'date',false,true) . "</div>";
        } else {
            $duedateTxt = createDate($listTasks->tas_due_date[$i],'date',false,true);
        }

        if ($listTasks->tas_start_date[$i] != "0" && $listTasks->tas_due_date[$i] != "0") {
            $gantt = "true";
        }

        $content = array(
            $listTasks->tas_id[$i],
            $nameTxt,
            $priorityTxt,
            $statusTxt,
            $completionTxt,
            $duedateTxt
        );

        if ($listTasks->tas_milestone[$i] == enumMilestone::msYes) {
            $content[] = '';
        } else {
            $tmpquery = " AND res.task=" . $listTasks->tas_id[$i];
            $resourceUsage = new request();
            $resourceUsage->openTaskHumanResource($tmpquery);
            $comptResourceUsage = count($resourceUsage->res_id);

            if ($comptResourceUsage > 0) {
                $assigned_to = array();

                for ($j=0; $j<$comptResourceUsage; $j++) {
                    $assigned_to[] = implode(",", array(
                        $resourceUsage->res_resource[$j],
                        $resourceUsage->res_mem_extension_picture[$j],
                        $resourceUsage->res_mem_gender[$j]
                    ));
                }

                $content[] = $assigned_to;
            } else {
                $content[] = '';
            }
        }

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
            $content[] = $statusPublish[$idPublish];
        }

        $block2->itemCardView($listTasks->tas_id[$i], $content);
    }

    $block2->closeCardView();
    $block2->bornesFooter('9', $blockPage->bornesNumber, "id=$id&toggle_focus=tasks" . $urlBornes);
    $block2->closeToggle();
    $block2->closeFormResults();

    if ($comptListTasks > 0 && $activeJpgraph == "true" && $gantt == "true") {
        $block2->headingToggle($strings['charts'], !($toggle_focus=='charts'));

        if ($gantt_sd != '') {
            echo "<a href='viewphase.php?toggle_focus=charts&amp;id=$id&amp;base=$base'>&lt;&lt;</a>&nbsp;";

            if ($base == '1') {
                $gantt_sd_prev = mktime(0,0,0,intval(date('m',$gantt_sd))-5,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
            } else {
                $gantt_sd_prev = mktime(0,0,0,intval(date('m',$gantt_sd))-1,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
            }
        }

        $tmpquery = "SELECT MIN(start_date),MAX(due_date) FROM " . $tablePrefix . "tasks WHERE project='$project' AND parent_phase='" . $phaseDetail->pha_order_num[0] . "' AND start_date!='0' AND due_date!='0'";

        if ($gantt_sd != '') {
            if ($base == '1') {
                $gantt_sd_next = mktime(0,0,0,intval(date('m',$gantt_sd))+5,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
            } else {
                $gantt_sd_next = mktime(0,0,0,intval(date('m',$gantt_sd))+1,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
            }

            $tmpquery .= " AND due_date>='$gantt_sd_next'";
        }

        $boundaries = new request();
        $boundaries->connectClass();
        $boundaries->query($tmpquery);

        if ($boundaries->fetch()) {
            $start_date_b = ($row[0]);
            $due_date_b = ($row[1]);

            if ($gantt_sd == '') {
                if ($base == '1') {
                    $gantt_sd_next = mktime(0,0,0,intval(date('m',$start_date_b))+5,intval(date('d',$start_date_b)),intval(date('Y',$start_date_b)));
                } else {
                    $gantt_sd_next = mktime(0,0,0,intval(date('m',$start_date_b))+1,intval(date('d',$start_date_b)),intval(date('Y',$start_date_b)));
                }

                $gantt_sd = $start_date_b;
            } else {
                if ($gantt_sd_prev < $start_date_b) {
                    echo "<a href='viewphase.php?toggle_focus=charts&amp;id=$id&amp;base=$base'>&lt;</a>&nbsp;";
                } else {
                    echo "<a href='viewphase.php?toggle_focus=charts&amp;id=$id&amp;base=$base&amp;gantt_sd=$gantt_sd_prev'>&lt;</a>&nbsp;";
                }
            }

            if ($gantt_sd_next <= $due_date_b) {
                $showNext = 'true';

                if ($base == '1') {
                    $gantt_sd_last = mktime(0,0,0,intval(date('m',$due_date_b))-5,intval(date('d',$due_date_b))+1,intval(date('Y',$due_date_b)));
                } else {
                    $gantt_sd_last = mktime(0,0,0,intval(date('m',$due_date_b))-1,intval(date('d',$due_date_b))+1,intval(date('Y',$due_date_b)));
                }
            }
        }

        // show the expanded or compact Gantt Chart
        if ($base == 1) {
            echo "<a href='viewphase.php?toggle_focus=charts&amp;id=$id&amp;base=0'>expand</a>";
        } else {
            echo "<a href='viewphase.php?toggle_focus=charts&amp;id=$id&amp;base=1'>compact</a>";
        }

        if ($showNext == 'true') {
            echo "&nbsp;<a href='viewphase.php?id=$id&amp;base=$base&amp;gantt_sd=$gantt_sd_next'>&gt;</a>";
            echo "&nbsp;<a href='viewphase.php?id=$id&amp;base=$base&amp;gantt_sd=$gantt_sd_last'>&gt;&gt;</a>";
        }

        if ($gantt_sd != '') {
            echo "<br><img src=\"graphtasks.php?project=" . $projectDetail->pro_id[0] . "&amp;phase=" . $phaseDetail->pha_order_num[0] . "&amp;base=$base&amp;gantt_sd=$gantt_sd\" alt=\"\"><br><span class=\"listEvenBold\">" . $blockPage->buildLink("http://www.aditus.nu/jpgraph/", "JpGraph", 'powered') . "</span>";
        }

        $block2->closeToggle();
    }
}

if (($fileManagement == "true") && ($SW_Permissions['Project']['Admin'][$profilSession] || $permissionDetail->prp_view_file[0] == enumBoolean::bTrue)) {
    $block3 = new block();
    $block3->form = "tdC";
    $block3->openForm("../phases/viewphase.php?id=$id" . $urlBornes . "#" . $block3->form . "Anchor");
    $block3->headingToggle(lang_strings("linked_content"), !($toggle_focus=='linked_content'));
    $block3->borne = $blockPage->returnBorne('10');
    $block3->rowsLimit = '12';

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        $block3->sorting("phase_files", (isset($sortingUser['phase_files'])?$sortingUser['phase_files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status', 4 => 'fil.published'));
    } else {
        $block3->sorting("phase_files", (isset($sortingUser['phase_files'])?$sortingUser['phase_files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status'));
    }

    $querymore = " WHERE fil.vc_parent='0' ORDER BY " . $block3->sortingValue;
    $sql0 = $initrequest["phase_files"];
    $sql = str_replace('%phase%', $id, $sql0);
    $block3->recordsTotal = compt($sql . $querymore);
    $listFiles = new request();
    $listFiles->openPhaseFiles($id, $querymore, $block3->borne, $block3->rowsLimit);
    $comptListFiles = count($listFiles->fil_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['owner'];
    $columns[1]->field_type = enumFieldType::ftAvatar;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['created'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['approval_tracking'];
    $columns[3]->field_type = enumFieldType::ftText;

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        $columns[4] = new cardviewColumn();
        $columns[4]->title = $strings['published'];
        $columns[4]->field_type = enumFieldType::ftText;
    }

    $opt[enumCardviewOption::oTableName] = 'files';
    $opt[enumCardviewOption::oObject] = 'files';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] = "doc_type=" . enumFileRelatedDocumentType::dtPhase . "&doc_id=$id" . $urlBornes . "&borne10=" . $block3->borne;

    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = "../linkedcontent/addfile.php?doc_type=" . enumFileRelatedDocumentType::dtPhase . "&doc_id=$id" . $urlBornes;
        }
    }

    $block3->openCardView($opt);

    for ($i=0; $i<$comptListFiles; $i++) {
        $idStatus = $listFiles->fil_status[$i];
        $idPublish = $listFiles->fil_published[$i];
        $content = array(
            $listFiles->fil_name[$i],
            implode(',',
                array(
                    $listFiles->fil_owner[$i],
                    $listFiles->fil_mem_extension_picture[$i],
                    $listFiles->fil_mem_gender[$i])),
            createDate($listFiles->fil_created[$i],'both'),
            $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . enumFileRelatedDocumentType::dtPhase . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i] . $urlBornes, $statusFile[$idStatus], 'in')
        );

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
            $content[] = $statusPublish[$idPublish];
        }

        $block3->itemCardView($listFiles->fil_id[$i], $content);
    }

    $block3->closeCardView();
    $block3->bornesFooter("10", $blockPage->bornesNumber, "id=$id&toggle_focus=linked_content" . $urlBornes);
    $block3->closeToggle();
    $block3->closeFormResults();
}

require_once("../includes/footer.php");
