<?php // $Revision: 1.14 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: updatepassword.php,v 1.14 2013/02/19 14:15:27 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = "onLoad=\"document.change_passwordForm.opw.focus();\"";
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$opw = isset($_POST['opw'])?$_POST['opw']:'';
$npw = isset($_POST['npw'])?$_POST['npw']:'';
$pwa = isset($_POST['pwa'])?$_POST['pwa']:'';
$error = '';

/**
 * Permission check
 */
$querymore1 = " WHERE mem.id='$idSession'";
$userDetail = new request();
$userDetail->openMembers($querymore1);
$comptUserDetail = count($userDetail->mem_id);

if ($comptUserDetail == "0") {
    header("Location: ../users/listusers.php?msg=blankUser");
    exit;
}

/**
 * Check fields
 */
if ($action == "update") {
    if (!is_password_match($opw, $userDetail)) {
        $error = lang_strings("old_password_error");
    } else if ($npw== '' || $npw != $pwa) {
        $error = lang_strings("new_password_error");
    }
}

/**
 * Actions
 */
if (($action == 'update') && ($error == '')) {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $cnpw = get_password($npw);

        if ($htaccessAuth == "true") {
            require_once("../includes/htpasswd.class.php");
            $Htpasswd = new Htpasswd;
            $tmpquery = " WHERE tea.member='$idSession'";
            $listProjects = new request();
            $listProjects->openTeams($tmpquery);
            $comptListProjects = count($listProjects->tea_project);

            if ($comptListProjects != "0") {
                for ($i = 0;$i < $comptListProjects;$i++) {
                    $Htpasswd->initialize("../files/" . $listProjects->tea_pro_id[$i] . "/.htpasswd");
                    $Htpasswd->changePass($loginSession, $cnpw);
                }
            }
        }

        if ($useLDAP == 'true' && $idSession != '1') {
            $ds = ldap_connect($configLDAP['ldapserver']) or die("Could not connect to ldap server");
            ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, $configLDAP['ldapversion']);
            $dn = $userDetail->mem_ldap_cn[0] . ',' . $configLDAP['basedn'];

            if (!ldap_bind($ds, $dn, $opwI)) {
                die("LDAP bind failed");
            }

            if (!ldap_mod_replace($ds, $dn, array('userPassword' => '{MD5}' . base64_encode(pack('H*', md5($npw)))))) {
                $error = 'Update password failed';
            }

            ldap_close($ds);
        } else {
            $tmpsql = "UPDATE " . $tablePrefix . "members SET password='$cnpw',modified='" . time() . "',muser='$idSession' WHERE id = '$idSession'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'members', $idSession, 'U');
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../preferences/pref.php?msg=update");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../preferences/pref.php?", lang_strings("preferences"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("change_password"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "change_password";
$block1->openForm("../preferences/updatepassword.php?");
echo '<input type="hidden" name="action" value="update">';
echo '<input type="hidden" id="pass1" name="pass1" value="">';
echo '<input type="hidden" id="pass2" name="pass2" value="">';
echo '<input type="hidden" id="txt0" name="txt0" value="' . $strings['type_password'] . '"/>';
echo '<input type="hidden" id="txt1" name="txt1" value="' . $strings['more_characters'] . '"/>';
echo '<input type="hidden" id="txt2" name="txt2" value="' . $strings['strength_weak'] . '"/>';
echo '<input type="hidden" id="txt3" name="txt3" value="' . $strings['strength_medium'] . '"/>';
echo '<input type="hidden" id="txt4" name="txt4" value="' . $strings['strength_strong'] . '"/>';
echo '<input type="hidden" id="txt5" name="txt5" value="' . $strings['password_not_match'] . '"/>';
$block1->heading(lang_strings("change_password"));
$block1->openContent();
$block1->contentTitle(lang_strings("change_password_intro"));
$block1->contentRow("* " . lang_strings("old_password"), '<input style="width: 150px;" type="password" name="opw" value=""/>');
$block1->contentRow("* " . lang_strings("new_password"), '<input style="width: 150px;" type="password" id="npw" name="npw" value="" onkeyup="passwordChanged()"/> <strong id="strength"></strong>');
$block1->contentRow("* " . lang_strings("confirm_password"), '<input style="width: 150px;" type="password" id="pwa" name="pwa" value="" onkeyup="confirmChanged()"/> <strong id="match"></strong>');
$block1->contentRow('', '<input type="submit" name="Save" value="' . $strings["save"] . '" onclick="return saveClicked()"/>');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
function passwordChanged() {
    var strength = document.getElementById('strength');
    var strongRegex = new RegExp("^(?=.{8,})(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])(?=.*\\W).*$", "g");
    var mediumRegex = new RegExp("^(?=.{7,})(((?=.*[A-Z])(?=.*[a-z]))|((?=.*[A-Z])(?=.*[0-9]))|((?=.*[a-z])(?=.*[0-9]))).*$", "g");
    var enoughRegex = new RegExp("(?=.{6,}).*", "g");
    var pwd = document.getElementById("npw");
    var pass1 = document.getElementById("pass1");

    if (pwd.value.length === 0) {
        // new password empty
        var x = document.getElementById('txt0');
        strength.innerHTML = x.value;
        pass1.value = '';
    } else if (!enoughRegex.test(pwd.value)) {
        // new password length too short
        var x = document.getElementById('txt1');
        strength.innerHTML = x.value;
        pass1.value = '';
    } else if (strongRegex.test(pwd.value)) {
        // new password strength passed
        var x = document.getElementById('txt4');
        strength.innerHTML = '<span style="color:green">' + x.value + '</span>';
        pass1.value = 'Y';
    } else if (mediumRegex.test(pwd.value)) {
        // new password strength medium
        var x = document.getElementById('txt3');
        strength.innerHTML = '<span style="color:orange">' + x.value + '</span>';
        pass1.value = 'Y';
    } else {
        // new password strength weak
        var x = document.getElementById('txt2');
        strength.innerHTML = '<span style="color:red">' + x.value + '</span>';
        pass1.value = '';
    }
}

function confirmChanged() {
    var npw = document.getElementById("npw");
    var pwa = document.getElementById("pwa");
    var match = document.getElementById("match");
    var pass2 = document.getElementById("pass2");

    if (npw.value === pwa.value) {
        match.innerHTML = '';
        pass2.value = 'Y';
    } else {
        var x = document.getElementById('txt5');
        match.innerHTML = x.value;
        pass2.value = '';
    }
}

function saveClicked() {
    var pass1 = document.getElementById("pass1");
    var pass2 = document.getElementById("pass2");

    if (pass1.value === 'Y' && pass2.value === 'Y') {
        return true;
    } else {
        return false;
    }
}
</script>
<?php
require_once("../includes/footer.php");
