<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: budgetwizard.php,v 1.6 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$step = isset($_POST['step'])?$_POST['step']:'0';
$tas = isset($_POST['tas'])?$_POST['tas']:'';
$lcm = isset($_POST['lcm'])?$_POST['lcm']:$defaultCostMethod;   // labor cost method
$lcc = isset($_POST['lcc'])?$_POST['lcc']:'';                   // labor cost currency
$lc = isset($_POST['lc'])?$_POST['lc']:'';                      // labor cost
$cc = isset($_POST['cc'])?$_POST['cc']:'';                      // material cost currency
$mc = isset($_POST['mc'])?$_POST['mc']:'';                      // material cost
$oc = isset($_POST['oc'])?$_POST['oc']:'';                      // other costs
$occ = isset($_POST['occ'])?$_POST['occ']:'';                   // other costs currency
$ot = isset($_POST['ot'])?$_POST['ot']:'';                      // other cost types

if (is_array($tas)) {
    $tas = implode(',', $tas);
}

if ($action == 'reload') {
    switch ($step) {
        case '2':   // Labor
            $lc = '';
            $lcc = '';
            break;
        case '3':   // Material
            $mc = '';
            $cc = '';
            break;
    }
}

if (is_array($lcc)) {
    for ($i=0; $i<count($lc); $i++) {
        $lc[$i] = round($lc[$i], $costAccuracy);
    }

    $lcc = implode(',', $lcc);
    $lc = implode(',', $lc);
}

if (is_array($cc)) {
    for ($i=0; $i<count($mc); $i++) {
        $mc[$i] = round($mc[$i], $costAccuracy);
    }

    $cc = implode(',', $cc);
    $mc = implode(',', $mc);
}

if (is_array($oc)) {
    for ($i=0; $i<count($oc); $i++) {
        $oc[$i] = round($oc[$i], $costAccuracy);
    }

    $oc = implode(',', $oc);
    $ot = implode(',', $ot);
}

/**
 * Permission check
 */
$querymore1 = " WHERE pro.id='$id'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewprojectaccount.php?id=' . $project . '&msg=permissiondenied' . $urlBornes);
    exit;
}

if ($lcm == '') {
    $lcm = $projectDetail->pro_cost_method[0];
}

$querymore2 = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore2);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore3 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore3 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore3);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_modify_project_properties[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    if ($projectsFilter == 'true') {
        header('Location: ../projects/viewproject.php?id=' . $id . $urlBornes);
        exit;
    } else {
        header("Location: ../teams/joinprojectteam.php?project=$id" . $urlBornes);
        exit;
    }
}

/**
 * Action
 */
if ($action == 'cancel') {
    header("Location: ../projects/viewprojectaccounting.php?id=$id" . $urlBornes);
    exit;
} else if ($action == 'update' && $step == '6') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        // update labor cost method
        if ($lcm != '' && $lcm != $projectDetail->pro_cost_method[0]) {
            $tmpsql = "UPDATE " . $tablePrefix . "projects SET cost_method='$lcm',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'projects', $id, 'U');
        }

        // update labor costs
        if ($lcc == '') {
            $querymore4 = " WHERE pjb.project='$id' AND pjb.costtype='" . enumCostType::ctLabor . "'";
            $listLaborCost = clone $requestAct;
            $listLaborCost->openProjectsBudget($querymore4);

            if (count($listLaborCost->pjb_id) > 0) {
                $ids4 = implode(',', $listLaborCost->pjb_id);
                copy2HistoryTable($requestAct, 'projects_budget', $ids4, 'D');
                $tmpsql = "DELETE FROM " . $tablePrefix . "projects_budget WHERE id IN ($ids4)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        } else {
            $lca = explode(',', $lc);
            $lcca = explode(',', $lcc);

            for ($i=0; $i<count($lcca); $i++) {
                $querymore5 = " WHERE pjb.project='$id' AND pjb.costtype='" . enumCostType::ctLabor . "' AND pjb.currency='" . $lcca[$i] . "'";
                $laborCostDetail = clone $requestAct;
                $laborCostDetail->openProjectsBudget($querymore5);

                if (count($laborCostDetail->pjb_id) > 0) {
                    $id5 = $laborCostDetail->pjb_id[0];
                    $tmpsql = "UPDATE " . $tablePrefix . "projects_budget SET amount='" . $lca[$i] . "',modified='" . time() . "',muser='$idSession' WHERE id='$id5'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    copy2HistoryTable($requestAct, 'projects_budget', $id5, 'U');
                } else {
                    $tmpsql = "INSERT INTO " . $tablePrefix . "projects_budget (project,costtype,currency,amount,created,cuser) VALUES ('$id','" . enumCostType::ctLabor . "','" . $lcca[$i] . "','" . $lca[$i] . "','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num5 = $requestAct->newId("projects_budget");
                    copy2HistoryTable($requestAct, 'projects_budget', $num5, 'A');
                }
            }

            $querymore6 = " WHERE pjb.project='$id' AND pjb.costtype='" . enumCostType::ctLabor . "' AND pjb.currency NOT IN ('" . implode("','", $lcca) . "')";
            $listLaborCostDel = clone $requestAct;
            $listLaborCostDel->openProjectsBudget($querymore6);

            if (count($listLaborCostDel->pjb_id) > 0) {
                $ids6 = implode(',', $listLaborCostDel->pjb_id);
                copy2HistoryTable($requestAct, 'projects_budget', $ids6, 'D');
                $tmpsql = "DELETE FROM " . $tablePrefix . "projects_budget WHERE id IN ($ids6)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        // update material costs
        if ($cc == '') {
            $querymore7 = " WHERE pjb.project='$id' AND pjb.costtype='" . enumCostType::ctMaterial . "'";
            $listMaterialCost = clone $requestAct;
            $listMaterialCost->openProjectsBudget($querymore7);

            if (count($listMaterialCost->pjb_id) > 0) {
                $ids7 = implode(',', $listMaterialCost->pjb_id);
                copy2HistoryTable($requestAct, 'projects_budget', $ids7, 'D');
                $tmpsql = "DELETE FROM " . $tablePrefix . "projects_budget WHERE id IN ($ids7)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        } else {
            $mca = explode(',', $mc);
            $mcca = explode(',', $cc);

            for ($i=0; $i<count($mcca); $i++) {
                $querymore8 = " WHERE pjb.project='$id' AND pjb.costtype='" . enumCostType::ctMaterial . "' AND pjb.currency='" . $mcca[$i] . "'";
                $materialCostDetail = clone $requestAct;
                $materialCostDetail->openProjectsBudget($querymore8);

                if (count($materialCostDetail->pjb_id) > 0) {
                    $id8 = $materialCostDetail->pjb_id[0];
                    $tmpsql = "UPDATE " . $tablePrefix . "projects_budget SET amount='" . $mca[$i] . "',modified='" . time() . "',muser='$idSession' WHERE id='$id8'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    copy2HistoryTable($requestAct, 'projects_budget', $id8, 'U');
                } else {
                    $tmpsql = "INSERT INTO " . $tablePrefix . "projects_budget (project,costtype,currency,amount,created,cuser) VALUES ('$id','" . enumCostType::ctMaterial . "','" . $mcca[$i] . "','" . $mca[$i] . "','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num8 = $requestAct->newId("projects_budget");
                    copy2HistoryTable($requestAct, 'projects_budget', $num8, 'A');
                }
            }

            $querymore9 = " WHERE pjb.project='$id' AND pjb.costtype='" . enumCostType::ctMaterial . "' AND pjb.currency NOT IN ('" . implode("','", $mcca) . "')";
            $listMaterialCostDel = clone $requestAct;
            $listMaterialCostDel->openProjectsBudget($querymore9);

            if (count($listMaterialCostDel->pjb_id) > 0) {
                $ids9 = implode(',', $listMaterialCostDel->pjb_id);
                copy2HistoryTable($requestAct, 'projects_budget', $ids9, 'D');
                $tmpsql = "DELETE FROM " . $tablePrefix . "projects_budget WHERE id IN ($ids9)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        // update other costs
        if ($oc == '') {
            $querymore10 = " WHERE pjb.project='$id' AND pjb.costtype NOT IN ('" . enumCostType::ctLabor . "','" . enumCostType::ctMaterial . "')";
            $listOtherCost = clone $requestAct;
            $listOtherCost->openProjectsBudget($querymore10);

            if (count($listOtherCost->pjb_id) > 0) {
                $ids10 = implode(',', $listOtherCost->pjb_id);
                copy2HistoryTable($requestAct, 'projects_budget', $ids10, 'D');
                $tmpsql = "DELETE FROM " . $tablePrefix . "projects_budget WHERE id IN ($ids10)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        } else {
            $oca = explode(',', $oc);
            $ota = explode(',', $ot);

            for ($i=0; $i<count($oca); $i++) {
                $querymore11 = " WHERE pjb.project='$id' AND pjb.costtype='" . $ota[$i] . "' AND pjb.currency='" . $occ . "'";
                $otherCostDetail = clone $requestAct;
                $otherCostDetail->openProjectsBudget($querymore11);

                if (count($otherCostDetail->pjb_id) > 0) {
                    $id11 = $otherCostDetail->pjb_id[0];
                    $tmpsql = "UPDATE " . $tablePrefix . "projects_budget SET amount='" . $oca[$i] . "',modified='" . time() . "',muser='$idSession' WHERE id='$id11'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    copy2HistoryTable($requestAct, 'projects_budget', $id11, 'U');
                } else {
                    $tmpsql = "INSERT INTO " . $tablePrefix . "projects_budget (project,costtype,currency,amount,created,cuser) VALUES ('$id','" . $ota[$i] . "','" . $occ . "','" . $oca[$i] . "','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num11 = $requestAct->newId("projects_budget");
                    copy2HistoryTable($requestAct, 'projects_budget', $num11, 'A');
                }

                $querymore12 = " WHERE pjb.project='$id' AND pjb.costtype='" . $ota[$i] . "' AND pjb.currency<>'" . $occ . "'";
                $listOtherCostDel = clone $requestAct;
                $listOtherCostDel->openProjectsBudget($querymore12);

                if (count($listOtherCostDel->pjb_id) > 0) {
                    $ids12 = implode(',', $listOtherCostDel->pjb_id);
                    copy2HistoryTable($requestAct, 'projects_budget', $ids12, 'D');
                    $tmpsql = "DELETE FROM " . $tablePrefix . "projects_budget WHERE id IN ($ids12)";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../projects/viewprojectaccounting.php?id=$id&msg=update" . $urlBornes);
        exit;
    }
}

/**
 * Prepare data
 */
// set default currency
if ($projectDetail->pro_currency[0] == '') {
    $defCurr = $defaultCurrency;
} else {
    $defCurr = $projectDetail->pro_currency[0];
}
// get project task list
$querymore4 = " WHERE tas.project='$id' AND EXISTS (SELECT id FROM " . $tablePrefix . "tasks_resource WHERE task=tas.id) ORDER BY tas.start_date";
$listTasks = new request();
$listTasks->openTasks($querymore4);
$comptListTasks = count($listTasks->tas_id);
// get claim type list
$querymore5 = " WHERE clt.locked='" . enumBoolean::bFalse . "' ORDER BY clt.name";
$listClaimType = new request();
$listClaimType->openClaimType($querymore5);
$comptListClaimType = count($listClaimType->clt_id);

switch ($step) {
    case '0':   // Introduction
        if ($comptListTasks === 0) {
            $pstep = '0';     // previous step
            $nstep = '2';     // next step
        } else {
            $pstep = '0';     // previous step
            $nstep = '1';     // next step
        }

        break;
    case '1':   // Task
        $pstep = '0';     // previous step
        $nstep = '2';     // next step
        break;
    case '2':   // Labor
        $lcArray = array();

        if ($comptListTasks === 0) {
            $pstep = '0';     // previous step
            $nstep = '3';     // next step
        } else {
            $pstep = '1';     // previous step
            $nstep = '3';     // next step
        }

        if ($lcc != '') {
            $lca = explode(',', $lc);
            $lcca = explode(',', $lcc);

            for ($i=0; $i<count($lcca); $i++) {
                $lcArray[$lcca[$i]] = floatval($lca[$i]);
            }
        }

        if (count($lcArray) == '0' && $tas != '') {
            switch ($lcm) {
                case '1':   // Use the cost rate of member only
                    $tmpquery = "SELECT svc.currency,svc.hourly_rate_i,tas.estimated_time FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=res.task INNER JOIN " . $tablePrefix . "teams tea ON tea.project=tas.project AND tea.member=res.resource INNER JOIN " . $tablePrefix . "services svc ON svc.id=tea.service WHERE res.task IN ($tas) AND res.type='" . enumResourceType::rtUser . "'";
                    break;
                case '2':   // Use the hourly rate of service first and use the cost rate of member if no service specified
                    $tmpquery = "SELECT svc.currency,svc.hourly_rate_i,tas.estimated_time FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=res.task INNER JOIN " . $tablePrefix . "services svc ON svc.id=tas.service WHERE res.task IN ($tas) AND res.type='" . enumResourceType::rtUser . "' AND tas.service<>'0'
    UNION ALL
    SELECT svc.currency,svc.hourly_rate_i,tas.estimated_time FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=res.task INNER JOIN " . $tablePrefix . "teams tea ON tea.project=tas.project AND tea.member=res.resource INNER JOIN " . $tablePrefix . "services svc ON svc.id=tea.service WHERE res.task IN ($tas) AND res.type='" . enumResourceType::rtUser . "' AND tas.service='0'";
                    break;
                case '3':   // Use the hourly rate of service only
                    $tmpquery = "SELECT svc.currency,svc.hourly_rate_i,tas.estimated_time FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=res.task INNER JOIN " . $tablePrefix . "services svc ON svc.id=tas.service WHERE res.task IN ($tas) AND res.type='" . enumResourceType::rtUser . "'";
                    break;
            }

            $request1 = new request();
            $request1->connectClass();
            $request1->query($tmpquery);

            while ($request1->fetch()) {
                $curr = ($row[0]);
                $hrt = (is_numeric($row[1]))?floatval($row[1]):0;
                $etm = (is_numeric($row[2]))?floatval($row[2]):0;

                if (array_key_exists($curr, $lcArray)) {
                    $lcArray[$curr] += $hrt * $etm;
                } else {
                    $lcArray[$curr] = $hrt * $etm;
                }
            }

            $request1->close();
        }

        if (count($lcArray) == '0') {
            $querymore = " WHERE pjb.project='$id' AND pjb.costtype='" . enumCostType::ctLabor . "'";
            $listProjectBudget = new request();
            $listProjectBudget->openProjectsBudget($querymore);
            $comptListProjectBudget = count($listProjectBudget->pjb_project);

            if ($comptListProjectBudget != '0') {
                for ($i=0; $i<$comptListProjectBudget; $i++) {
                    if (!array_key_exists($listProjectBudget->pjb_currency[$i], $lcArray)) {
                        $lcArray[$listProjectBudget->pjb_currency[$i]] = floatval($listProjectBudget->pjb_amount[$i]);
                    }
                }
            }
        }

        break;
    case '3':   // Material
        $mcArray = array();

        if ($comptListClaimType === 0) {
            $pstep = '2';     // previous step
            $nstep = '5';     // next step
        } else {
            $pstep = '2';     // previous step
            $nstep = '4';     // next step
        }

        if ($cc != '') {
            $mca = explode(',', $mc);
            $cca = explode(',', $cc);

            for ($i=0; $i<count($cca); $i++) {
                $mcArray[$cca[$i]] = floatval($mca[$i]);
            }
        }

        if (count($mcArray) == '0' && $tas != '') {
            $tmpquery = "SELECT mat.id,mat.name,mat.currency,SUM(mat.costrate*res.quantity) AS cost FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "materials mat ON mat.id=res.resource WHERE res.task IN ($tas) AND res.type='" . enumResourceType::rtMaterial . "' AND res.quantity>0 GROUP BY mat.id,mat.name,mat.currency ORDER BY mat.name,mat.currency";
            $listMaterialCost = new request();
            $listMaterialCost->connectClass();
            $listMaterialCost->query($tmpquery);

            while ($listMaterialCost->fetch()) {
                $i = 0;
                $listMaterialCost->id[] = ($row[$i++]);
                $listMaterialCost->name[] = HtmlEntityDecodeNOD($row[$i++]);
                $curr = ($row[$i++]);
                $listMaterialCost->currency[] = $curr;
                $c = ($row[$i++]);
                $cost = is_numeric($c)?round($c, $costAccuracy):'0';
                $listMaterialCost->cost[] = $cost;

                if (!array_key_exists($curr, $mcArray)) {
                    $mcArray[$curr] = floatval($cost);
                } else {
                    $mcArray[$curr] += floatval($cost);
                }
            }

            $listMaterialCost->close();
        }

        if (count($mcArray) == '0') {
            $querymore = " WHERE pjb.project='$id' AND pjb.costtype='" . enumCostType::ctMaterial . "'";
            $listProjectBudget = new request();
            $listProjectBudget->openProjectsBudget($querymore);
            $comptListProjectBudget = count($listProjectBudget->pjb_project);

            if ($comptListProjectBudget != '0') {
                for ($i=0; $i<$comptListProjectBudget; $i++) {
                    if (!array_key_exists($listProjectBudget->pjb_currency[$i], $mcArray)) {
                        $mcArray[$listProjectBudget->pjb_currency[$i]] = floatval($listProjectBudget->pjb_amount[$i]);
                    }
                }
            }
        }

        break;
    case '4':   // Other cost types
        $ocArray = array();
        $pstep = '3';     // previous step
        $nstep = '5';     // next step

        if ($oc != '') {
            $oca = explode(',', $oc);
            $ota = explode(',', $ot);

            for ($i=0; $i<count($oca); $i++) {
                $ocArray[$ota[$i]] = floatval($oca[$i]);
            }
        }

        if ($occ == '') {
            $occ = $defCurr;
        }

        if (count($ocArray) == '0') {
            $querymore = " WHERE pjb.project='$id' AND pjb.costtype NOT IN ('" . enumCostType::ctLabor . "','" . enumCostType::ctMaterial . "')";
            $listProjectBudget = new request();
            $listProjectBudget->openProjectsBudget($querymore);
            $comptListProjectBudget = count($listProjectBudget->pjb_project);

            if ($comptListProjectBudget > 0) {
                for ($i=0; $i<$comptListProjectBudget; $i++) {
                    if (!array_key_exists($listProjectBudget->pjb_costtype[$i], $ocArray)) {
                        $ocArray[$listProjectBudget->pjb_costtype[$i]] = floatval($listProjectBudget->pjb_amount[$i]);
                    }
                }
            }
        }

        break;
    case '5':   // Completing the Wizard
        $lcArray = array();
        $mcArray = array();
        $ocArray = array();

        if ($comptListClaimType === 0) {
            $pstep = '3';     // previous step
            $nstep = '6';     // next step
        } else {
            $pstep = '4';     // previous step
            $nstep = '6';     // next step
        }

        if ($cc != '') {
            $cca = explode(',', $cc);
            $mca = explode(',', $mc);

            for ($i=0; $i<count($cca); $i++) {
                if (is_numeric($mca[$i]) && floatval($mca[$i]) != 0) {
                    $mcArray[$cca[$i]] = floatval($mca[$i]);
                }
            }
        }

        if ($lcc != '') {
            $lcca = explode(',', $lcc);
            $lca = explode(',', $lc);

            for ($i=0; $i<count($lcca); $i++) {
                if (is_numeric($lca[$i]) && floatval($lca[$i]) != 0) {
                    $lcArray[$lcca[$i]] = floatval($lca[$i]);
                }
            }
        }

        if ($oc != '') {
            $oca = explode(',', $oc);
            $ota = explode(',', $ot);

            for ($i=0; $i<count($oca); $i++) {
                if (is_numeric($oca[$i]) && floatval($oca[$i]) != 0) {
                    $ocArray[$ota[$i]] = floatval($oca[$i]);
                }
            }
        }

        break;
}

/**
 * Html
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php' . $urlBornes, lang_strings('projects'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/viewproject.php?id=' . $id . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/viewprojectaccounting.php?id=' . $id . $urlBornes, lang_strings('project_accounting'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('project_budget_wizard'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'pbW';
$block1->openForm('../projects/budgetwizard.php?id=' . $id . $urlBornes . '#' . $block1->form . 'Anchor');
echo '<input type="hidden" name="action" value="update">';
echo '<input type="hidden" name="pstep" value="' . $pstep . '">';
echo '<input type="hidden" name="cstep" value="' . $step . '">';
echo '<input type="hidden" name="step" value="' . $nstep . '">';

switch ($step) {
    case '0':   // Introduction to the Project Budget Wizard
        $block1->openContent();
        $block1->contentTitle(lang_strings('project_budget_wizard_step0_title'));
        $block1->closeContent();
        $block1->note(lang_strings('project_budget_wizard_step0_note'));
        echo '<input type="submit" value="' . $strings['next'] . '">';
        break;
    case '1':   // Task
        $block1->openContent();
        $block1->contentTitle(lang_strings('project_budget_wizard_step1_title'));
        $block1->closeContent();
        $block1->note(lang_strings('project_budget_wizard_step1_note'));

        if ($comptListTasks == '0') {
            $block1->noresults();
        } else {
            if ($tas == '') {
                $allChecked = '';
            } else {
                $allChecked = ' checked';
                $tasA = explode(',', $tas);

                for ($i=0; $i<$comptListTasks; $i++) {
                    if (!in_array($listTasks->tas_id[$i], $tasA)) {
                        $allChecked = '';
                        break;
                    }
                }
            }

            echo '<div class="listing"><table><tr><th><input type="checkbox" name="checkAllAuto" id="checkAllAuto" value="0" onclick="selectall();"' . $allChecked . '></th><th>' . lang_strings('id') . '</th><th>' . lang_strings('name') . '</th><th>' . lang_strings('start_date') . '</th><th>' . lang_strings('due_date') . '</th><th>' . lang_strings('service') . '</th></tr>';

            for ($i=0; $i<$comptListTasks; $i++) {
                $tchk = '';

                if ($tas != '' && in_array($listTasks->tas_id[$i], $tasA)) {
                    $tchk = ' checked';
                }

                echo '<tr>
    <td><input type="checkbox" name="tas[]" value="' . $listTasks->tas_id[$i] . '" onclick="uncheckselall(this);"' . $tchk . '></td>
    <td>' . $listTasks->tas_id[$i] . '</td>
    <td>' . $listTasks->tas_name[$i] . '</td>
    <td>' . createDate($listTasks->tas_start_date[$i], 'date',false,true) . '</td>
    <td>' . createDate($listTasks->tas_due_date[$i], 'date',false,true) . '</td>
    <td>' . $listTasks->tas_svc_name[$i] . '</td>
</tr>';
            }

            echo '</table></div>
<script type="text/javascript">
function selectall() {
    $("INPUT[type=\'checkbox\']").attr(\'checked\', $(\'#checkAllAuto\').is(\':checked\'));
}

function uncheckselall(obj) {
    if (obj.checked == false && $(\'#checkAllAuto\').is(\':checked\')) {
        $(\'#checkAllAuto\').attr(\'checked\', false);
    }
}
</script>
';
        }

        echo '<input type="button" value="' . $strings['back'] . '" onclick="prevstep();">';
        echo ' <input type="submit" value="' . $strings['next'] . '">';
        break;
    case '2':   // Labor
        $block1->openContent();
        $block1->contentTitle(lang_strings('project_budget_wizard_step2_title'));
        $block1->closeContent();
        $block1->note(lang_strings('project_budget_wizard_step2_note'));
        echo '<div>';
        echo '<input type="radio" name="lcm" value="1"' . (($lcm=='1')?' checked':'') . ' onclick="reload();">' . fieldValidValueString('projects', 'cost_method', '1') . '<br>';
        echo '<input type="radio" name="lcm" value="2"' . (($lcm=='2')?' checked':'') . ' onclick="reload();">' . fieldValidValueString('projects', 'cost_method', '2') . '<br>';
        echo '<input type="radio" name="lcm" value="3"' . (($lcm=='3')?' checked':'') . ' onclick="reload();">' . fieldValidValueString('projects', 'cost_method', '3') . '<br>';
        echo '</div><br>';
        echo '<div class="listing"><table><tr><th>' . lang_strings('currency') . '</th><th>' . lang_strings('amount') . '</th></tr>';

        if (count($lcArray) > 0) {
            foreach ($lcArray as $k => $v) {
                echo '<tr><td>' . $k . '</td><td><input type="text" name="lc[]" id="lc' . $k . '" value="' . $v . '" maxlength="30"><strong id="lc' . $k . 'S"></strong><input type="hidden" name="lcc[]" value="' . $k . '"></td></tr>';
                $__default_floata[] = 'lc' . $k;
            }
        } else {
            $k = $defCurr;
            $v = '0';
            echo '<tr><td>' . $k . '</td><td><input type="text" name="lc[]" id="lc' . $k . '" value="' . $v . '" maxlength="30"><strong id="lc' . $k . 'S"></strong><input type="hidden" name="lcc[]" value="' . $k . '"></td></tr>';
            $__default_floata[] = 'lc' . $k;
        }

        echo '</table></div>';
        echo '<input type="hidden" name="tas" value="' . $tas . '">';
        echo '<input type="button" value="' . $strings['back'] . '" onclick="prevstep();">';
        echo ' <input type="submit" value="' . $strings['next'] . '">';
        break;
    case '3':   // Material
        $block1->openContent();
        $block1->contentTitle(lang_strings('project_budget_wizard_step3_title'));
        $block1->closeContent();
        $block1->note(lang_strings('project_budget_wizard_step3_note'));
        echo '<div><a href="javascript:reload()">' . lang_strings('reset_material_cost') . '</a></div><br>';
        echo '<div class="listing"><table><tr><th>' . lang_strings('currency') . '</th><th>' . lang_strings('amount') . '</th></tr>';

        if (count($mcArray) > 0) {
            foreach ($mcArray as $k => $v) {
                echo '<tr><td>' . $k . '</td><td><input type="text" name="mc[]" id="mc' . $k . '" value="' . $v . '" maxlength="30"><strong id="mc' . $k . 'S"></strong><input type="hidden" name="cc[]" value="' . $k . '"></td></tr>';
                $__default_floata[] = 'mc' . $k;
            }
        } else {
            $k = $defCurr;
            $v = '0';
            echo '<tr><td>' . $k . '</td><td><input type="text" name="mc[]" id="mc' . $k . '" value="' . $v . '" maxlength="30"><strong id="mc' . $k . 'S"></strong><input type="hidden" name="cc[]" value="' . $k . '"></td></tr>';
            $__default_floata[] = 'mc' . $k;
        }

        echo '</table></div>';
        echo '<input type="hidden" name="tas" value="' . $tas . '">';
        echo '<input type="hidden" name="lcm" value="' . $lcm . '">';
        echo '<input type="hidden" name="lc" value="' . $lc . '">';
        echo '<input type="hidden" name="lcc" value="' . $lcc . '">';
        echo '<input type="button" value="' . $strings['back'] . '" onclick="prevstep();">';
        echo ' <input type="submit" value="' . $strings['next'] . '">';
        break;
    case '4':   // Other cost types
        $block1->openContent();
        $block1->contentTitle(lang_strings('project_budget_wizard_step4_title'));
        $block1->closeContent();
        $block1->note(lang_strings('project_budget_wizard_step4_note'));
        echo '<div class="listing"><table><tr><th>' . lang_strings('cost_type') . '</th><th>' . lang_strings('currency') . '</th><th>' . lang_strings('total') . '</th></tr>';

        for ($i=0; $i<$comptListClaimType; $i++) {
            $ot = $listClaimType->clt_id[$i];
            echo '<tr><td>' . $listClaimType->clt_name_print[$i] . '<input type="hidden" name="ot[]" value="' . $ot . '"/></td><td>' . $occ . '</td><td><input type="text" name="oc[]" id="oc' . $ot . '" value="' . $ocArray[$ot] . '" maxlength="30"><strong id="oc' . $ot . 'S"></strong></td></tr>';
            $__default_floata[] = 'oc' . $ot;
        }

        echo '</table></div>';
        echo '<input type="hidden" name="tas" value="' . $tas . '">';
        echo '<input type="hidden" name="lcm" value="' . $lcm . '">';
        echo '<input type="hidden" name="lc" value="' . $lc . '">';
        echo '<input type="hidden" name="lcc" value="' . $lcc . '">';
        echo '<input type="hidden" name="cc" value="' . $cc . '">';
        echo '<input type="hidden" name="mc" value="' . $mc . '">';
        echo '<input type="hidden" name="occ" value="' . $occ . '">';
        echo '<input type="button" value="' . $strings['back'] . '" onclick="prevstep();">';
        echo ' <input type="submit" value="' . $strings['next'] . '">';
        break;
    case '5':   // Completing the Wizard
        $block1->openContent();
        $block1->contentTitle(lang_strings('project_budget_wizard_step5_title'));
        $block1->closeContent();
        $block1->note(lang_strings('project_budget_wizard_step5_note'));
        echo '<div class="listing"><table><tr><th>' . lang_strings('type') . '</th><th>' . lang_strings('currency') . '</th><th>' . lang_strings('total') . '</th></tr>';
        ksort($lcArray);
        ksort($mcArray);
        ksort($ocArray);
        $totalArray = array();

        foreach ($lcArray as $k => $v) {
            if ($v != 0) {
                echo '<tr><td>' . lang_strings('labor') . '</td><td>' . $k . '</td><td>' . NumberFormatNOD($lcArray[$k], $costAccuracy) . '</td></tr>';
                $totalArray[$k] = $lcArray[$k];
            }
        }

        foreach ($mcArray as $k => $v) {
            echo '<tr><td>' . lang_strings('material') . '</td><td>' . $k . '</td><td>' . NumberFormatNOD($mcArray[$k], $costAccuracy) . '</td></tr>';

            if (array_key_exists($k, $totalArray)) {
                $totalArray[$k] += $mcArray[$k];
            } else {
                $totalArray[$k] = $mcArray[$k];
            }
        }

        foreach ($ocArray as $k => $v) {
            $querymore = " WHERE clt.id='$k'";
            $claimTypeDetail = new request();
            $claimTypeDetail->openClaimType($querymore);
            echo '<tr><td>' . $claimTypeDetail->clt_name_print[0] . '</td><td>' . $occ . '</td><td>' . NumberFormatNOD($ocArray[$k], $costAccuracy) . '</td></tr>';

            if (array_key_exists($occ, $totalArray)) {
                $totalArray[$occ] += $ocArray[$k];
            } else {
                $totalArray[$occ] = $ocArray[$k];
            }
        }

        if (count($totalArray) > 0) {
            ksort($totalArray);
            echo '<tr><td><b>' . lang_strings('total') . '</td></b><td></td><td></td></tr>';

            foreach ($totalArray as $k => $v) {
                echo '<tr><td></td><td><b>' . $k . '</b></td><td><b>' . NumberFormatNOD($v, $costAccuracy) . '</b></td></tr>';
            }
        }

        echo '</table></div>';
        echo '<input type="hidden" name="tas" value="' . $tas . '">';
        echo '<input type="hidden" name="lcm" value="' . $lcm . '">';

        if (count($lcArray) > 0) {
            echo '<input type="hidden" name="lcc" value="' . implode(',', array_keys($lcArray)) . '">';
            echo '<input type="hidden" name="lc" value="' . implode(',', $lcArray) . '">';
        }

        if (count($mcArray) > 0) {
            echo '<input type="hidden" name="cc" value="' . implode(',', array_keys($mcArray)) . '">';
            echo '<input type="hidden" name="mc" value="' . implode(',', $mcArray) . '">';
        }

        if (count($ocArray) > 0) {
            echo '<input type="hidden" name="ot" value="' . implode(',', array_keys($ocArray)) . '">';
            echo '<input type="hidden" name="oc" value="' . implode(',', $ocArray) . '">';
        }

        echo '<input type="hidden" name="occ" value="' . $occ . '">';
        echo '<input type="button" value="' . $strings['back'] . '" onclick="prevstep();">';

        if (count($totalArray) > 0) {
            echo ' <input type="submit" value="' . $strings['save'] . '">';
        }

        break;
}

echo ' <input type="button" value="' . $strings['cancel'] . '" onclick="cancel();">';
?>
<script type="text/javascript">
function prevstep() {
    var step = document.pbWForm.step;
    step.value = document.pbWForm.pstep.value;
    document.pbWForm.submit();
}

function cancel() {
    document.pbWForm.action.value = 'cancel';
    document.pbWForm.submit();
}
function reload() {
    var step = document.pbWForm.step;
    step.value = document.pbWForm.cstep.value;
    document.pbWForm.action.value = 'reload';
    document.pbWForm.submit();
}
</script>
<?php
$block1->closeForm();
require_once('../includes/footer.php');
