<?php // $Revision: 1.21 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteproject.php,v 1.21 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_REQUEST['id'])?$_REQUEST['id']:'0');
$action = isset($_REQUEST['action'])?$_REQUEST['action']:'';

/**
 * Permission check
 */
$querymore0 = " WHERE pro.id='$id'";
$projectDetail = new request();
$projectDetail->openProjects($querymore0);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {   // project not found
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {  // project is waiting for approval
    header("Location: ../projects/viewproject.php?id=$id&msg=permissiondenied" . $urlBornes);
    exit;
}

$querymore1 = " WHERE tea.project='$id' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore1);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {  // user not in the project team
    $querymore2 = " WHERE prp.project='$id' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore2 = " WHERE prp.project='$id' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore2);
$comptPermissionDetail = count($permissionDetail->prp_project);
// check project specified & system wide permissions
if ($permissionDetail->prp_delete_project[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    header("Location: ../projects/viewproject.php?id=$id&msg=permissiondenied" . $urlBornes);
    exit;
}

$tmpquery = "SELECT project FROM " . $tablePrefix . "expenses WHERE project='$id' AND status<>'" . enumDocumentStatus::stDraft . "' "
    . "UNION ALL SELECT project FROM " . $tablePrefix . "files WHERE project='$id' "
    . "UNION ALL SELECT t1.project FROM " . $tablePrefix . "invoice_rows t1 INNER JOIN invoices t0 ON t0.id=t1.invoice WHERE t1.project='$id' AND t0.status<>'" . enumDocumentStatus::stDraft . "' "
    . "UNION ALL SELECT project FROM " . $tablePrefix . "material_issue WHERE project='$id' "
    . "UNION ALL SELECT project FROM " . $tablePrefix . "meetings_time WHERE project='$id' "
    . "UNION ALL SELECT project FROM " . $tablePrefix . "tasks_time WHERE project='$id' "
    . "UNION ALL SELECT project FROM " . $tablePrefix . "work_hours WHERE project='$id' ";
$querymore11 = " WHERE fdf.sysdef='N' AND fdf.linkedtable='projects'";
$listFieldsDefinitions = new request();
$listFieldsDefinitions->openFieldsDefinitions($querymore11);
$comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
    $tmpquery .= "UNION ALL SELECT " . $listFieldsDefinitions->fdf_dbfieldname[$i] . " AS project FROM " . $tablePrefix . $listFieldsDefinitions->fdf_dbtablename[$i] . " WHERE " . $listFieldsDefinitions->fdf_dbfieldname[$i] . "='$id' ";
}

if (compt($tmpquery) > 0) {
    header("Location: ../projects/viewproject.php?id=$id&msg=permissiondenied" . $urlBornes);
    exit;
}

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        // delete project calendars
        $tmpsql = "DELETE FROM " . $tablePrefix . "calendars WHERE target='" . enumCalendarTarget::tProject . "' AND target_id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
        // delete project calendar events
        $tmpsql = "DELETE FROM " . $tablePrefix . "calendar_events WHERE target='" . enumCalendarTarget::tProject . "' AND target_id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        // delete project related meetings
        $querymore3 = " WHERE mee.project='$id'";
        $listMeetings = clone $requestAct;
        $listMeetings->openMeetings($querymore3);

        if (count($listMeetings->mee_id) > 0) {
            $ids3 = implode(',', $listMeetings->mee_id);
            copy2HistoryTable($requestAct, 'meetings', $ids3, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "attendees WHERE meeting IN ($ids3)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "DELETE FROM " . $tablePrefix . "meetings_available WHERE meeting IN ($ids3)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "DELETE FROM " . $tablePrefix . "meetings_schedule WHERE meeting IN ($ids3)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "DELETE FROM " . $tablePrefix . "meetings WHERE id IN ($ids3)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        // delete project notes
        $querymore4 = " WHERE note.project='$id'";
        $listNotes = clone $requestAct;
        $listNotes->openNotes($querymore4);

        if (count($listNotes->note_id) > 0) {
            $ids4 = implode(',', $listNotes->note_id);
            copy2HistoryTable($requestAct, 'notes', $ids4, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "notes WHERE id IN ($ids4)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        // delete project phases
        $querymore5 = " WHERE pha.project='$id'";
        $listPhases = clone $requestAct;
        $listPhases->openPhases($querymore5);

        if (count($listPhases->pha_id) > 0) {
            $ids5 = implode(',', $listPhases->pha_id);
            copy2HistoryTable($requestAct, 'phases', $ids5, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "phases WHERE id IN ($ids5)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        // delete project budget
        $querymore6 = " WHERE pjb.project='$id'";
        $listProjectsBudget = clone $requestAct;
        $listProjectsBudget->openProjectsBudget($querymore6);

        if (count($listProjectsBudget->pjb_id) > 0) {
            $ids6 = implode(',', $listProjectsBudget->pjb_id);
            copy2HistoryTable($requestAct, 'projects_budget', $ids6, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "projects_budget WHERE id IN ($ids6)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        // delete project forms
        $tmpsql = "DELETE FROM " . $tablePrefix . "projects_form WHERE project='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        // delete project permissions
        $querymore7 = " WHERE prp.project='$id'";
        $listProjectPermissions = clone $requestAct;
        $listProjectPermissions->openProjectPermissions($querymore7);

        if (count($listProjectPermissions->prp_id) > 0) {
            $ids7 = implode(',', $listProjectPermissions->prp_id);
            copy2HistoryTable($requestAct, 'project_permissions', $ids7, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "project_permissions WHERE id IN ($ids7)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        // delete project support posts
        $querymore8 = " WHERE sp.project='$id'";
        $listSupportPosts = clone $requestAct;
        $listSupportPosts->openSupportPosts($querymore8);

        if (count($listSupportPosts->sp_id) > 0) {
            $ids8 = implode(',', $listSupportPosts->sp_id);
            copy2HistoryTable($requestAct, 'support_posts', $ids8, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "support_posts WHERE id IN ($ids8)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        // delete project support requests
        $querymore9 = " WHERE sr.project='$id'";
        $listSupportRequests = clone $requestAct;
        $listSupportRequests->openSupportRequests($querymore9);

        if (count($listSupportRequests->sr_id) > 0) {
            $ids9 = implode(',', $listSupportRequests->sr_id);
            copy2HistoryTable($requestAct, 'support_requests', $ids9, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "support_requests WHERE id IN ($ids9)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        // delete project tasks
        $querymore10 = " WHERE tas.project='$id'";
        $listTasks = clone $requestAct;
        $listTasks->openTasks($querymore10);

        if (count($listTasks->tas_id) > 0) {
            $ids10 = implode(',', $listTasks->tas_id);
            copy2HistoryTable($requestAct, 'tasks', $ids10, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "tasks WHERE id IN ($ids10)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "DELETE FROM " . $tablePrefix . "assignments WHERE task IN ($ids10)";
            // delete task assignments
            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $querymore11 = " WHERE pre.task IN ($ids10) OR pre.predecessor IN ($ids10)";
            $listTaskPredecessors = clone $requestAct;
            $listTaskPredecessors->openTaskPredecessor($querymore11);

            if (count($listTaskPredecessors->pre_id) > 0) {
                $ids11 = implode(',', $listTaskPredecessors->pre_id);
                copy2HistoryTable($requestAct, 'tasks_predecessor', $ids11, 'D');
                $tmpsql = "DELETE FROM " . $tablePrefix . "tasks_predecessor WHERE id IN ($ids11)";
                // delete task dependencies
                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $querymore12 = " WHERE res.task IN ($ids10)";
            $listTaskResources = clone $requestAct;
            $listTaskResources->openTaskResource($querymore12);

            if (count($listTaskResources->res_id) > 0) {
                $ids12 = implode(',', $listTaskResources->res_id);
                copy2HistoryTable($requestAct, 'tasks_resource', $ids12, 'D');
                $tmpsql = "DELETE FROM " . $tablePrefix . "tasks_resource WHERE id IN ($ids12)";
                // delete task resources
                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        // delete project team
        $querymore13 = " WHERE tea.project='$id'";
        $listTeams = clone $requestAct;
        $listTeams->openTeams($querymore13);
        $ids13 = implode(',', $listTeams->tea_id);
        copy2HistoryTable($requestAct, 'teams', $ids13, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "teams WHERE id IN ($ids13)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        // delete project related timeclocks
        $tmpsql = "DELETE FROM " . $tablePrefix . "timeclock WHERE project='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $querymore14 = " WHERE topic.project='$id'";
        $listTopics = clone $requestAct;
        $listTopics->openTopics($querymore14);

        if (count($listTopics->top_id) > 0) {
            $ids14 = implode(',', $listTopics->top_id);
            copy2HistoryTable($requestAct, 'topics', $ids14, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "topics WHERE id IN ($ids14)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $querymore15 = " WHERE pos.topic IN ($ids14)";
            $listPosts = clone $requestAct;
            $listPosts->openPosts($querymore15);

            if (count($listPosts->pos_id) > 0) {
                $ids15 = implode(',', $listPosts->pos_id);
                copy2HistoryTable($requestAct, 'posts', $ids15, 'D');
                $tmpsql = "DELETE FROM " . $tablePrefix . "posts WHERE id IN ($ids15)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        // delete project
        copy2HistoryTable($requestAct, 'projects', $id, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "projects WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ../projects/listprojects.php?msg=delete' . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php?' . $urlBornes, lang_strings('projects'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('delete_projects'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'saP';
$block1->openForm('../projects/deleteproject.php?action=delete&id=' . $id . $urlBornes . '#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('delete_projects'));
$block1->openContent();
$block1->contentTitle(lang_strings('delete_following'));
$block1->contentRow('#' . $projectDetail->pro_id[0], $projectDetail->pro_name[0]);
$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
require_once('../includes/footer.php');
