<?php // $Revision: 1.59 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editproject.php,v 1.59 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ISSUE: type, client organization, currency CAN NOT be changed if the project is not EMPTY
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
require_once('../includes/permissions-config.inc.php');

if ($htaccessAuth == 'true') {
    require_once('../includes/htpasswd.class.php');
    $Htpasswd = new Htpasswd;
}

/**
 * Initial the permissions of the project roles
 * @global array $projectRoles
 * @global string $tablePrefix
 * @global array $PS_Permissions
 * @global array $PS_PermissionsSets
 * @global array $rolePermissionMatrix
 * @global integer $idSession
 * @param class $requestAct
 * @param integer $id
 * @param string $pset
 * @throws Exception
 */
function init_all_roles_permissions($requestAct, $id, $pset)
{
    global $projectRoles,$tablePrefix,$PS_Permissions,$PS_PermissionsSets,$rolePermissionMatrix,$idSession;
    $tmpsql = "INSERT INTO " . $tablePrefix . "project_permissions (project,profil%key%,created,cuser) VALUES ('$id','%profil%'%val%,'" . time() . "','$idSession')";
    $search = array('%key%', '%val%', '%profil%');

    foreach ($projectRoles as $roleId => $role) {
        $key = "";
        $val = "";

        foreach ($rolePermissionMatrix as $obj => $level1Matrix) {
            $idx = 0;

            foreach ($level1Matrix[1] as $fieldName => $dispName) {
                $key .= ",$fieldName";

                if ($pset == enumPermissionLevel::plCustom) {
                    $val .= ",'" . (($PS_Permissions[$obj][$level1Matrix[2][$idx++]][$roleId])?enumBoolean::bTrue:enumBoolean::bFalse) . "'";
                } else {
                    $val .= ",'" . (($PS_PermissionsSets[$pset][$obj][$level1Matrix[2][$idx++]][$roleId])?enumBoolean::bTrue:enumBoolean::bFalse) . "'";
                }
            }
        }

        $replace = array($key, $val, $roleId);
        $tmpsql0 = str_replace($search, $replace, $tmpsql);

        if ($requestAct->query($tmpsql0) === false) {
            throw new Exception($tmpsql0);
        }

        $num = $requestAct->newId('project_permissions');
        copy2HistoryTable($requestAct, 'project_permissions', $num, 'A');
    }
}
/**
 * Build the folder tree listings
 * @global integer $fol_id
 * @global string $fol_path
 * @param integer $id
 * @param string $root
 */
function bof($id, $root = '')
{
    global $fol_id, $fol_path;
    $querymore = " WHERE fil.parent='$id' AND fil.dir='" . enumBoolean::bTrue . "' ORDER BY fil.name";
    $listFolders = new request();
    $listFolders->openFiles($querymore);
    $comptListFolders = count($listFolders->fil_id);

    for ($i=0; $i<$comptListFolders; $i++) {
        $fol_id[] = $listFolders->fil_id[$i];
        $fol_path[] = $root .'/' . $listFolders->fil_name[$i];
        bof($listFolders->fil_id[$i], $root .'/' . $listFolders->fil_name[$i]); // find the next level folder listing
    }
}

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.epDForm.pn.focus();"';
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$cpy = isset($_GET['cpy'])?$_GET['cpy']:'';
$organization = AddSlashesNOD(isset($_GET['organization'])?$_GET['organization']:'');

if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'editproject' && $_SESSION['SOURCE'] == '') {
    // return from add client page and restore all user input values from the session variables
    $clod = $_SESSION['PARAMS']['clod'];
    $pt = ($clod=='1')?enumProjectType::tyInternal:enumProjectType::tyExternal;
    $pn = $_SESSION['PARAMS']['pn'];
    $pr = $_SESSION['PARAMS']['pr'];
    $d = $_SESSION['PARAMS']['d'];
    $pown = $_SESSION['PARAMS']['pown'];
    $thisPhase = $_SESSION['PARAMS']['pha'];
    $st = $_SESSION['PARAMS']['st'];
    $upPath = $_SESSION['PARAMS']['up'];
    $pset = $_SESSION['PARAMS']['pset'];
    $curr = $_SESSION['PARAMS']['curr'];
    $lcm = $_SESSION['PARAMS']['lcm'];
    $pfmc = $_SESSION['PARAMS']['pfmc'];

    if ($pfmc != '0') {
        $pfmna = $_SESSION['PARAMS']['pfmna'];
        $pfmpa = $_SESSION['PARAMS']['pfmpa'];
    }

    $_SESSION['TARGET'] = '';
    $icp = 'true';
} else {
    $pn = isset($_POST['pn'])?$_POST['pn']:'';
    $pr = isset($_POST['pr'])?$_POST['pr']:'';
    $d = isset($_POST['d'])?$_POST['d']:'';
    $pown = isset($_POST['pown'])?$_POST['pown']:'';
    $clod = isset($_POST['clod'])?$_POST['clod']:'';
    $pt = isset($_POST['pt'])?$_POST['pt']:'';
    $thisPhase = isset($_POST['thisPhase'])?$_POST['thisPhase']:'';
    $st = isset($_REQUEST['st'])?$_REQUEST['st']:'';
    $upPath = isset($_POST['upPath'])?$_POST['upPath']:'1';
    $pset = isset($_POST['pset'])?$_POST['pset']:enumPermissionLevel::plCustom;
    $curr = isset($_POST['curr'])?$_POST['curr']:'';
    $lcm = isset($_POST['lcm'])?$_POST['lcm']:'';
    $wc = isset($_POST['wc'])?$_POST['wc']:'1';
    $pfmc = isset($_POST['pfmc'])?$_POST['pfmc']:'0';
    $icp = '';

    if ($pfmc != '0') {
        $pfmna = array();
        $pfmpa = array();

        for ($i=0; $i<intval($pfmc); $i++) {
            $pfmna[] = $_POST['pfmh' . $i];
            $pfmpa[] = (($_POST['pfmp' . $i]=='Y')?$_POST['pfmp' . $i]:'N');
        }
    }
}

$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$error = '';

/**
 * Permission check
 */
if ($id != '') {
    // test exists selected project, redirect to list if not
    $querymore2 = " WHERE pro.id='$id'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore2);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }
    // changing to the project that approval needed is not allowed
    if ($projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval && $cpy != 'true') {
        header("Location: ../projects/viewproject.php?id=$id&msg=permissiondenied" . $urlBornes);
        exit;
    }
    // check user permissions
    $querymore3 = " WHERE tea.project='$id' AND tea.member='$idSession'";
    $teamMemberDetail = new request();
    $teamMemberDetail->openTeams($querymore3);
    $comptTeamMemberDetail = count($teamMemberDetail->tea_project);

    if ($comptTeamMemberDetail == 0) {
        $querymore4 = " WHERE prp.project='$id' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore4 = " WHERE prp.project='$id' AND prp.profil='" . $teamMemberDetail->tea_profil[0] . "'";
    }

    $projectPermissionsDetail = new request();
    $projectPermissionsDetail->openProjectPermissions($querymore4);
    $comptProjectPermissionsDetail = count($projectPermissionsDetail->prp_project);
    $prp_add_file = $projectPermissionsDetail->prp_add_file[0];

    if (!$SW_Permissions['Project']['Admin'][$profilSession]) {
        if ($cpy == 'true') {
            if ($projectPermissionsDetail->prp_copy_project[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
                header("Location: ../projects/viewproject.php?id=$id&msg=permissiondenied" . $urlBornes);
                exit;
            }
        } else {
            if ($projectPermissionsDetail->prp_modify_project_properties[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
                header("Location: ../projects/viewproject.php?id=$id&msg=permissiondenied" . $urlBornes);
                exit;
            }
        }
    }
} else {
    if (!$SW_Permissions['Project']['Write'][$profilSession]) { // check permission of adding project
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $prp_add_file = enumBoolean::bTrue;
}

/**
 * Add New Client Organization
 */
if ($clod == "-1") {
    // store all user input values in session variables and redirect to add client page
    $_SESSION['TARGET'] = 'editclient';
    $_SESSION['SOURCE'] = 'editproject';
    $_SESSION['LOCATION'] = '../projects/editproject.php';
    $params = array();
    $params['pn'] = $pn;
    $params['pr'] = $pr;
    $params['d'] = $d;
    $params['pown'] = $pown;
    $params['pha'] = $thisPhase;
    $params['st'] = $st;
    $params['up'] = $upPath;
    $params['pset'] = $pset;
    $params['curr'] = $curr;
    $params['lcm'] = $lcm;
    $params['pfmc'] = $pfmc;

    if ($pfmc != '0') {
        $params['pfmna'] = $pfmna;
        $params['pfmpa'] = $pfmpa;
    }

    $_SESSION['PARAMS'] = $params;
    header("Location: ../clients/editclient.php");
    exit;
}

/**
 * Fields check
 */
if ($action != '') {
    $error = checkCustomFields('projects', $id);
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    // replace quotes by html codes
    $pn = HtmlEntitiesNOD($pn);
    $d = HtmlEntitiesNOD($d);

    if ($action == 'add') {    // case add project
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            // insert into projects and teams (with last id project)
            $cfsqls = setupCustomFieldsInsertSQL('projects');  // Generate custom fields insert sql
            $tmpsql = 'INSERT INTO ' . $tablePrefix . "projects (name,priority,description,owner,organization,status,status_next,status_approval,published,phase_set,type,upload_dir,currency,permission_set,cost_method,workcalendar,created,cuser" . $cfsqls[0] . ") VALUES ('$pn','$pr','$d','$pown','$clod','" . enumProjectStatus::stInitiation . "','$st','" . enumFileStatus::stNoApprovalsNeeded . "','" . enumPublished::pbNo . "','$thisPhase','$pt',$upPath,'$curr','$pset','$lcm','$wc','" . time() . "','$idSession'" . $cfsqls[1] . ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $newProId = $requestAct->newId('projects');
            $cfsql = setupCustomMediaFieldsUpdateSQL('projects', $newProId);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "projects SET $cfsql WHERE id='$newProId'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $tmpsql = 'INSERT INTO ' . $tablePrefix . "teams (project,member,published,authorized,profil,created,cuser) VALUES ('$newProId','$pown','" . enumPublished::pbNo . "','" . enumAuthorized::auYes . "','" . enumProjectProfile::ppLeader . "','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $newTeam = $requestAct->newId('teams');
            copy2HistoryTable($requestAct, 'teams', $newTeam, 'A');
            // create phase structure if enable phase was selected as true
            if ($thisPhase != '0') {
                $querymore = " WHERE phs.id='$thisPhase'";
                $requestAct->openPhaseSets($querymore);
                $comptPhaseSetDetail = count($requestAct->phs_id);

                if ($comptPhaseSetDetail != '0') {
                    for ($i=1; $i<=$requestAct->phs_phase_num[0]; $i++) {
                        $tmpsql = 'INSERT INTO ' . $tablePrefix . "phases (project,phase_set,order_num,status,created,cuser) VALUES ('$newProId','$thisPhase','$i','" . enumPhaseStatus::stNotStarted . "','" . time() . "','$idSession')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $newPhase = $requestAct->newId('phases');
                        copy2HistoryTable($requestAct, 'phases', $newPhase, 'A');
                    }
                }
            }

            init_all_roles_permissions($requestAct, $newProId, $pset);

            // create project folder
            if ($autoCreateDir == 'true') {
                $querymore = " WHERE fil.id='1'";
                $defaultFolder = clone $requestAct;
                $defaultFolder->openFiles($querymore);
                $nm = $pn;
                $tmpsql = "INSERT INTO " . $tablePrefix . "files (owner,doc_type,doc_id,name,size,comments,published,status,vc_status,vc_version,vc_parent,dir,parent,project,created,cuser) VALUES ('$idSession','0',0,'$nm',0,'$nm','" . enumPublished::pbNo . "','0','','','0','" . enumBoolean::bTrue . "',1,'0','" . time() . "','$idSession')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $num = $requestAct->newId('files');
                $fullname = $defaultFolder->fil_fullname[0] . '/' . urlencode($nm) . '--' . $num;
                createDir($fullname);
                $tmpsql = "UPDATE " . $tablePrefix . "files SET fullname='" . HtmlEntitiesNOD($fullname) . "' WHERE id='$num'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                copy2HistoryTable($requestAct, 'files', $num, 'A');
                $tmpsql = "UPDATE " . $tablePrefix . "projects SET upload_dir='$num' WHERE id='$newProId'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $upPath = $num;
                $path = $fullname;
            } else {
                $querymore = " WHERE fil.id='$upPath'";
                $folderDetail = clone $requestAct;
                $folderDetail->openFiles($querymore);
                $path = $folderDetail->fil_fullname[0];
            }

            // project form templates
            if ($pfmc != '0') {
                $pfmnaa = array();

                for ($i=0; $i<intval($pfmc); $i++) {
                    if (in_array($pfmna[$i], $pfmnaa)) {
                        continue;
                    }

                    $querymore = " WHERE tdf.tablename='" . $pfmna[$i] . "'";
                    $tableDefinitionDetail = clone $requestAct;
                    $tableDefinitionDetail->openTablesDefinitions($querymore);

                    if (count($tableDefinitionDetail->tdf_tablename) == 0) {
                        continue;
                    }

                    $pfmp = (($tableDefinitionDetail->tdf_publishenabled[0]=='Y')?$pfmpa[$i]:'N');
                    $tmpsql = "INSERT INTO " . $tablePrefix . "projects_form (project,tablename,publishenabled,created,cuser) VALUES ('$newProId','" . $pfmna[$i] . "','$pfmp','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $pfmnaa[] = $pfmna[$i];
                }
            }

            $status = enumFileStatus::stNoApprovalsNeeded;
            $num = $newProId;
            $producer = $idSession;
            $doctype = 'projects';

            if (!defined('INNER_ADDDOCUMENT')) {
                define('INNER_ADDDOCUMENT', 1);
            }

            require('../approvals/adddocument.php');
            // upload attach files
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtProject, $newProId, $status, $upPath, $path);

            if ($status == enumFileStatus::stNoApprovalsNeeded) {
                $tmpsql = "UPDATE " . $tablePrefix . "projects SET status=status_next";

                if ($st == enumProjectStatus::stOpen) {
                    $tmpsql .= ",open_date='" . time() . "'";
                } else if ($st == enumProjectStatus::stCompleted) {
                    $tmpsql .= ",complete_date='" . time() . "'";
                }

                $tmpsql .= " WHERE id='$newProId'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            copy2HistoryTable($requestAct, 'projects', $newProId, 'A');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header('Location: ../projects/viewproject.php?id=' . $newProId . '&msg=add' . $urlBornes);
            exit;
        }
    } else if ($action == 'update') {
        if ($cpy == 'true') {    // case copy project
            $requestAct = new request();
            $requestAct->connectClass();     // connect to database server

            try {
                $requestAct->startTransaction();
                // insert into projects and teams (with last id project)
                $cfsqls = setupCustomFieldsInsertSQL('projects');  // Generate custom fields insert sql
                $tmpsql = 'INSERT INTO ' . $tablePrefix . "projects (name,priority,description,owner,organization,status,status_next,status_approval,published,phase_set,type,upload_dir,currency,permission_set,cost_method,workcalendar,created,cuser" . $cfsqls[0] . ") VALUES ('$pn','$pr','$d','$pown','$clod','" . enumProjectStatus::stInitiation . "','$st','" . enumFileStatus::stNoApprovalsNeeded . "','" . enumPublished::pbNo . "','$thisPhase','$pt',$upPath,'$curr','$pset','$lcm','$wc','" . time() . "','$idSession'" . $cfsqls[1] . ")";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $projectNew = $requestAct->newId('projects');
                $cfsql = setupCustomMediaFieldsUpdateSQL('projects', $projectNew);    // Upload custom fields images & generate custom fields update sql

                if ($cfsql !== '') {
                    $tmpsql = "UPDATE " . $tablePrefix . "projects SET $cfsql WHERE id='$projectNew'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }

                $tmpsql = 'INSERT INTO ' . $tablePrefix . "teams (project,member,published,authorized,profil,created,cuser) VALUES ('$projectNew','$pown','" . enumPublished::pbNo . "','" . enumAuthorized::auYes . "','" . enumProjectProfile::ppLeader . "','" . time() . "','$idSession')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $newTeam = $requestAct->newId('teams');
                copy2HistoryTable($requestAct, 'teams', $newTeam, 'A');
                $querymore = " WHERE tas.project='$id'";
                $listTasks = clone $requestAct;
                $listTasks->openTasks($querymore);
                $comptListTasks = count($listTasks->tas_id);
                $IdMap = array();

                for ($i=0; $i<$comptListTasks; $i++) {
                    $assigned = '0';
                    $tn = $listTasks->tas_name[$i];
                    $d = $listTasks->tas_description[$i];
                    $ow = $listTasks->tas_owner[$i];
                    $at = $listTasks->tas_assigned_to[$i];
                    $pr = $listTasks->tas_priority[$i];
                    $sd = $listTasks->tas_start_date[$i];
                    $dd = $listTasks->tas_due_date[$i];
                    $cd = $listTasks->tas_complete_date[$i];
                    $etm = $listTasks->tas_estimated_time[$i];
                    $atm = $listTasks->tas_actual_time[$i];
                    $c = $listTasks->tas_comments[$i];
                    $pha = $listTasks->tas_parent_phase[$i];
                    $published = $listTasks->tas_published[$i];
                    $compl = $listTasks->tas_completion[$i];
                    $sv = $listTasks->tas_service[$i];
                    $fixd = $listTasks->tas_fixed_duration[$i];
                    $miles = $listTasks->tas_milestone[$i];
                    $ty = $listTasks->tas_type[$i];
                    $tg = $listTasks->tas_task_group[$i];
                    $lvl = $listTasks->tas_level[$i];
                    $pt = $listTasks->tas_parent_task[$i];
                    $subt = $listTasks->tas_subtask[$i];

                    if ($at != '0') {
                        $assigned = time();
                    }

                    $tmpsql = 'INSERT INTO ' . $tablePrefix . "tasks (project,name,description,owner,assigned_to,status,priority,start_date,due_date,complete_date,estimated_time,actual_time,comments,assigned,published,completion,parent_phase,service,fixed_duration,milestone,type,task_group,level,parent_task,subtask,created,cuser) VALUES ('$projectNew','$tn','$d','$ow','0','" . enumStatus::stNotStarted . "',$pr,'$sd','$dd','0','$etm','0','$c','','$published','0','$pha','$sv','$fixd','$miles','$ty','$tg','$lvl','$pt','$subt','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $taskNew = $requestAct->newId('tasks');
                    $IdMap[$listTasks->tas_id[$i]] = $taskNew;
                }

                foreach ($IdMap as $OId => $NId) {
                    $tmpsql = 'UPDATE ' . $tablePrefix . "tasks SET parent_task='$NId',modified='" . time() . "',muser='$idSession' WHERE project='$projectNew' AND parent_task='$OId'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    copy2HistoryTable($requestAct, 'tasks', $NId, 'A');
                    $querymore = " WHERE pre.task='$OId'";
                    $listTaskPredecessors = clone $requestAct;
                    $listTaskPredecessors->openTaskPredecessor($querymore);
                    $comptListTaskPredecessors = count($listTaskPredecessors->pre_id);

                    for ($preL=0; $preL<$comptListTaskPredecessors; $preL++) {
                        $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_predecessor (task,predecessor,type,lag,created,cuser) VALUES ('$NId','" . $IdMap[$listTaskPredecessors->pre_predecessor[$preL]] . "','" . $listTaskPredecessors->pre_type[$preL] . "','" . $listTaskPredecessors->pre_lag[$preL] . "','" . time() . "','$idSession')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $newTP = $requestAct->newId('tasks_predecessor');
                        copy2HistoryTable($requestAct, 'tasks_predecessor', $newTP, 'A');
                    }
                }

                // create phase structure if enable phase was selected as true
                if ($thisPhase != '0') {
                    $querymore = " WHERE phs.id='$thisPhase'";
                    $phaseSetDetail = clone $requestAct;
                    $phaseSetDetail->openPhaseSets($querymore);
                    $comptPhaseSetDetail = count($phaseSetDetail->phs_id);

                    for ($i=0; $i<$phaseSetDetail->phs_phase_num[0]; $i++) {
                        $tmpsql = 'INSERT INTO ' . $tablePrefix . "phases (project,phase_set,order_num,status,created,cuser) VALUES ('$projectNew','$thisPhase','$i','" . enumPhaseStatus::stNotStarted . "','" . time() . "','$idSession')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $newPhase = $requestAct->newId('phases');
                        copy2HistoryTable($requestAct, 'phases', $newPhase, 'A');
                    }
                }

                if ($pset == enumPermissionLevel::plCustom) {
                    $tmpsql = "INSERT INTO " . $tablePrefix . "project_permissions (project,profil,created,cuser";
                    $subquery = ") SELECT '$projectNew',profil,'" . time() . "','$idSession'";

                    foreach ($rolePermissionMatrix as $level1Matrix) {
                        foreach ($level1Matrix[1] as $fieldName => $dispName) {
                            $tmpsql .= ',' . $fieldName;
                            $subquery .= ',' . $fieldName;
                        }
                    }

                    $tmpsql =$tmpsql . $subquery . " FROM " . $tablePrefix . "project_permissions WHERE project='$id'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $querymore5 = " WHERE prp.project='$projectNew'";
                    $listProjectPermissionsNew = clone $requestAct;
                    $listProjectPermissionsNew->openProjectPermissions($querymore5);
                    $ids5 = implode(',', $listProjectPermissionsNew->prp_id);
                    copy2HistoryTable($requestAct, 'project_permissions', $ids5, 'A');
                } else {
                    init_all_roles_permissions($requestAct, $projectNew, $pset);
                }

                // create project folder
                if ($autoCreateDir == 'true') {
                    $querymore = " WHERE fil.id='1'";
                    $defaultFolder = $requestAct();
                    $defaultFolder->openFiles($querymore);
                    $nm = $pn;
                    $tmpsql = "INSERT INTO " . $tablePrefix . "files (owner,doc_type,doc_id,name,size,comments,published,status,vc_status,vc_version,vc_parent,dir,parent,project,created,cuser) VALUES ($idSession,'0',0,'$nm',0,'$nm','" . enumPublished::pbNo . "','0','','','0','" . enumBoolean::bTrue . "',1,'0','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num = $requestAct->newId('files');
                    $fullname = $defaultFolder->fil_fullname[0] . '/' . urlencode($nm) . '--' . $num;
                    createDir($fullname);
                    $tmpsql = "UPDATE " . $tablePrefix . "files SET fullname='$fullname' WHERE id='$num'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    copy2HistoryTable($requestAct, 'files', $num, 'A');
                    $tmpsql = "UPDATE " . $tablePrefix . "projects SET upload_dir='$num' WHERE id='$projectNew'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $upPath = $num;
                    $path = $fullname;
                } else {
                    $querymore = " WHERE fil.id='$upPath'";
                    $folderDetail = clone $requestAct;
                    $folderDetail->openFiles($querymore);
                    $path = $folderDetail->fil_fullname[0];
                }

                // project form templates
                if ($pfmc != '0') {
                    $pfmnaa = array();

                    for ($i=0; $i<intval($pfmc); $i++) {
                        if (in_array($pfmna[$i], $pfmnaa)) {
                            continue;
                        }

                        $querymore = " WHERE tdf.tablename='" . $pfmna[$i] . "'";
                        $tableDefinitionDetail = clone $requestAct;
                        $tableDefinitionDetail->openTablesDefinitions($querymore);

                        if (count($tableDefinitionDetail->tdf_tablename) == 0) {
                            continue;
                        }

                        $pfmp = (($tableDefinitionDetail->tdf_publishenabled[0]=='Y')?$pfmpa[$i]:'N');
                        $tmpsql = "INSERT INTO " . $tablePrefix . "projects_form (project,tablename,publishenabled,created,cuser) VALUES ('$projectNew','" . $pfmna[$i] . "','$pfmp','" . time() . "','$idSession')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $pfmnaa[] = $pfmna[$i];
                    }
                }

                $status = enumFileStatus::stNoApprovalsNeeded;
                $num = $projectNew;
                $producer = $idSession;
                $doctype = 'projects';

                if (!defined('INNER_ADDDOCUMENT')) {
                    define('INNER_ADDDOCUMENT', 1);
                }

                require('../approvals/adddocument.php');
                // upload attach files
                uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtProject, $projectNew, $status, $upPath, $path);

                if ($status == enumFileStatus::stNoApprovalsNeeded) {
                    $tmpsql = "UPDATE " . $tablePrefix . "projects SET status=status_next";

                    if ($st == enumProjectStatus::stOpen) {
                        $tmpsql .= ",open_date='" . time() . "'";
                    } else if ($st == enumProjectStatus::stCompleted) {
                        $tmpsql .= ",complete_date='" . time() . "'";
                    }

                    $tmpsql .= " WHERE id='$num'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }

                copy2HistoryTable($requestAct, 'projects', $projectNew, 'A');
                $requestAct->endTransaction(enumTransactionEndType::etCommit);
            } catch (Exception $e) {
                $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
                error_log($e->getMessage());
                $requestAct->endTransaction(enumTransactionEndType::etRollBack);
            }

            $requestAct->close();

            if ($error == '') {
                header('Location: ../projects/viewproject.php?id=' . $projectNew . '&msg=add' . $urlBornes);
                exit;
            }
        } else {    // case update project
            $requestAct = new request();
            $requestAct->connectClass();     // connect to database server

            try {
                $requestAct->startTransaction();
                // if project owner change, add new to team members (only if doesn't already exist)
                if ($pown != $projectDetail->pro_owner[0]) {
                    $tmpsql = "UPDATE " . $tablePrefix . "teams SET profil='" . enumProjectProfile::ppMember . "',modified='" . time() . "',muser='$idSession' WHERE project='$id' AND profil='" . enumProjectProfile::ppLeader . "'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $querymore = " WHERE tea.project='$id' AND tea.member='$pown'";
                    $testinTeam = clone $requestAct;
                    $testinTeam->openTeams($querymore);
                    $comptTestinTeam = count($testinTeam->tea_project);

                    if ($comptTestinTeam == '0') {
                        $tmpsql = 'INSERT INTO ' . $tablePrefix . "teams (project,member,published,authorized,profil,created,cuser) VALUES ('$id','$pown','" . enumPublished::pbNo . "','" . enumAuthorized::auYes . "','" . enumProjectProfile::ppLeader . "','" . time() . "','$idSession')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $num = $requestAct->newId('teams');
                        copy2HistoryTable($requestAct, 'teams', $num, 'A');

                        if ($htaccessAuth == 'true') {
                            $querymore = " WHERE mem.id='$pown'";
                            $detailMember = clone $requestAct;
                            $detailMember->openMembers($querymore);
                            $Htpasswd->initialize('../files/' . $id . '/.htpasswd');
                            $Htpasswd->addUser($detailMember->mem_login[0], $detailMember->mem_password[0]);
                        }
                    } else {
                        $tmpsql = "UPDATE " . $tablePrefix . "teams SET profil='" . enumProjectProfile::ppLeader . "',modified='" . time() . "',muser='$idSession' WHERE project='$id' AND member='$pown'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        copy2HistoryTable($requestAct, 'teams', $testinTeam->tea_id[0], 'U');
                    }
                }

                // if organization change, delete old organization permitted users from teams
                if ($clod != $projectDetail->pro_organization[0]) {
                    $querymore = " WHERE tea.project='$id' AND mem.organization<>'1'";
                    $suppTeamClient = clone $requestAct;
                    $suppTeamClient->openTeams($querymore);
                    $comptSuppTeamClient = count($suppTeamClient->tea_id);

                    if ($comptSuppTeamClient > 0) {
                        if ($htaccessAuth == 'true') {
                            for ($i=0; $i<$comptSuppTeamClient; $i++) {
                                $Htpasswd->initialize('../files/' . $id . '/.htpasswd');
                                $Htpasswd->deleteUser($suppTeamClient->mem_login[$i]);
                            }
                        }

                        $ids = implode(',', $suppTeamClient->tea_id);
                        copy2HistoryTable($requestAct, 'teams', $ids, 'D');
                        $tmpsql = 'DELETE FROM ' . $tablePrefix . "teams WHERE id IN ($ids)";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                }

                // -------------------------------------------------------------------------------------------------
                $querymore3 = " WHERE pro.id='$id'";
                $targetProject = clone $requestAct;
                $targetProject->openProjects($querymore3);

                // Project phase set changed
                if ($targetProject->pro_phase_set[0] != $thisPhase) {
                    // Delete old phases
                    $querymore6 = " WHERE pha.project='$id'";
                    $listPhasesOld = clone $requestAct;
                    $listPhasesOld->openPhases($querymore6);

                    if (count($listPhasesOld->pha_id) > 0) {
                        $ids6 = implode(',', $listPhasesOld->pha_id);
                        copy2HistoryTable($requestAct, 'phases', $ids6, 'D');
                        $tmpsql = 'DELETE FROM ' . $tablePrefix . "phases WHERE id IN ($ids6)";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }

                    // Create new Phases
                    $querymore = " WHERE phs.id='$thisPhase'";
                    $phaseSetDetail = clone $requestAct;
                    $phaseSetDetail->openPhaseSets($querymore);
                    $comptPhaseSetDetail = count($phaseSetDetail->phs_id);

                    for ($i=0; $i<$phaseSetDetail->phs_phase_num[0]; $i++) {
                        $tmpsql = 'INSERT INTO ' . $tablePrefix . "phases (project,phase_set,order_num,status,created,cuser) VALUES ('$id','$thisPhase','$i','" . enumPhaseStatus::stNotStarted . "','" . time() . "','$idSession')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $num6 = $requestAct->newId('phases');
                        copy2HistoryTable($requestAct, 'phases', $num6, 'A');
                    }
                    // Get a listing of project tasks and files and re-assign them to new phases if the phase set of a project is changed.
                    $querymore = " WHERE tas.project='" . $targetProject->pro_id[0] . "'";
                    $listTasks = clone $requestAct;
                    $listTasks->openTasks($querymore);
                    $comptListTasks = count($listTasks->tas_id);
                    $querymore = " LEFT OUTER JOIN " . $tablePrefix . "phases pha ON pha.id=fil.doc_id WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtPhase . "' AND pha.project='" . $targetProject->pro_id[0] . "'";
                    $listFiles = clone $requestAct;
                    $listFiles->openFiles($querymore);
                    $comptListFiles = count($listFiles->fil_id);
                    $querymore = " WHERE pha.project='" . $targetProject->pro_id[0] . "' AND pha.order_num='0'";
                    $targetPhase = clone $requestAct;
                    $targetPhase->openPhases($querymore);
                    $comptTargetPhase = count($targetPhase->pha_id);

                    for ($i=0; $i<$comptListTasks; $i++) {
                        $tmpsql = 'UPDATE ' . $tablePrefix . "tasks SET parent_phase='0',modified='" . time() . "',muser='$idSession' WHERE id='" . $listTasks->tas_id[$i] . "'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        copy2HistoryTable($requestAct, 'tasks', $listTasks->tas_id[$i], 'U');
                    }

                    for ($i=0; $i<$comptListFiles; $i++) {
                        $tmpsql = 'UPDATE ' . $tablePrefix . "files SET doc_id='" . $targetPhase->pha_id[0] . "',modified='" . time() . "',muser='$idSession' WHERE id='" . $listFiles->fil_id[$i] . "'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        copy2HistoryTable($requestAct, 'files', $listFiles->fil_id[$i], 'U');
                    }
                }

                // update project
                $cfsql = setupCustomFieldsUpdateSQL('projects', $id);  // Generate custom fields update sql
                $tmpsql = 'UPDATE ' . $tablePrefix . "projects SET name='$pn',priority='$pr',description='$d',owner='$pown',organization='$clod',status_next='$st',status_approval='" . enumFileStatus::stNoApprovalsNeeded . "',phase_set='$thisPhase',type='$pt',upload_dir='$upPath',currency='$curr',cost_method='$lcm',workcalendar='$wc',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                // project form templates
                $pfmnaa = array();

                if ($pfmc != '0') {
                    for ($i=0; $i<intval($pfmc); $i++) {
                        if (in_array($pfmna[$i], $pfmnaa)) {
                            continue;
                        }

                        $querymore = " WHERE tdf.tablename='" . $pfmna[$i] . "'";
                        $tableDefinitionDetail = clone $requestAct;
                        $tableDefinitionDetail->openTablesDefinitions($querymore);

                        if (count($tableDefinitionDetail->tdf_tablename) == 0) {
                            continue;
                        }

                        $pfmp = (($tableDefinitionDetail->tdf_publishenabled[0]=='Y')?$pfmpa[$i]:'N');
                        $querymore = " WHERE pfm.project='$id' AND pfm.tablename='" . $pfmna[$i] . "'";
                        $projectFormDetail = clone $requestAct;
                        $projectFormDetail->openProjectsForm($querymore);

                        if (count($projectFormDetail->pfm_project) == '0') {
                            $tmpsql = "INSERT INTO " . $tablePrefix . "projects_form (project,tablename,publishenabled,created,cuser) VALUES ('$id','" . $pfmna[$i] . "','$pfmp','" . time() . "','$idSession')";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }
                        } else if ($pfmp != $projectFormDetail->pfm_publishenabled[0]) {
                            $tmpsql = "UPDATE " . $tablePrefix . "projects_form SET publishenabled='$pfmp',modified='" . time() . "',muser='$idSession' WHERE project='$id' AND tablename='" . $pfmna[$i] . "'";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }
                        }

                        $pfmnaa[] = $pfmna[$i];
                    }
                }

                $querymore = " WHERE pfm.project='$id'";

                if (count($pfmnaa) > 0) {
                    $querymore .= " AND pfm.tablename NOT IN ('" . implode("','", $pfmnaa) . "')";
                }

                $listProjectForms = clone $requestAct;
                $listProjectForms->openProjectsForm($querymore);

                if (count($listProjectForms->pfm_project) > 0) {
                    $tmpsql = "DELETE FROM " . $tablePrefix . "projects_form WHERE project='$id'";

                    if (count($pfmnaa) > 0) {
                        $tmpsql .= " AND tablename NOT IN ('" . implode("','", $pfmnaa) . "')";
                    }

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }

                $status = enumFileStatus::stNoApprovalsNeeded;
                $num = $id;
                $producer = $idSession;
                $doctype = 'projects';

                if (!defined('INNER_ADDDOCUMENT')) {
                    define('INNER_ADDDOCUMENT', 1);
                }

                require('../approvals/adddocument.php');
                $querymore5 = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtProject . "' AND fil.doc_id='$id'";
                $listFiles = clone $requestAct;
                $listFiles->openFiles($querymore5);

                if (count($listFiles->fil_id) > 0) {
                    $tmpsql = 'UPDATE ' . $tablePrefix . "files SET status='$status' WHERE doc_type='" . enumFileRelatedDocumentType::dtProject . "' AND doc_id='$id'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }

                if ($status == enumFileStatus::stNoApprovalsNeeded) {
                    $tmpsql = "UPDATE " . $tablePrefix . "projects SET status=status_next";

                    if ($st == enumProjectStatus::stOpen) {
                        $tmpsql .= ",open_date='" . time() . "'";
                    } else if ($st == enumProjectStatus::stCompleted) {
                        $tmpsql .= ",complete_date='" . time() . "'";
                    }

                    $tmpsql .= " WHERE id='$id'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }

                copy2HistoryTable($requestAct, 'projects', $id, 'U');
                $requestAct->endTransaction(enumTransactionEndType::etCommit);
            } catch (Exception $e) {
                $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
                error_log($e->getMessage());
                $requestAct->endTransaction(enumTransactionEndType::etRollBack);
            }

            $requestAct->close();

            if ($error == '') {
                header('Location: ../projects/viewproject.php?id=' . $id . '&msg=update' . $urlBornes);
                exit;
            }
        }
    }
}

/**
 * Form init
 */
if ($error == '') {
    if ($id == '') {
        if ($icp == 'true') {
            $querymore = " WHERE org.id='$clod'";
            $organizationDetail = new request();
            $organizationDetail->openOrganizations($querymore);
            $comptOrganizationDetail = count($organizationDetail->org_id);

            if ($comptOrganizationDetail == '0') {
                $clod = '1';
            }
        }

        if ($icp != 'true') {
            $pn = '';
            $pr = enumPriority::prMedium;
            $d = '';
            $pown = $idSession;
            $thisPhase = '0';
            $st = enumProjectStatus::stInitiation;
            $upPath = '1';
            $pset = enumPermissionLevel::plCustom;
            $clod = (($organization=='')?'1':$organization);
            $lcm = $defaultCostMethod;
            $pfmc = '0';

            if ($clod != '1') {
                $querymore = " WHERE org.id='$clod'";
                $organizationDetail = new request();
                $organizationDetail->openOrganizations($querymore);
            }
        }

        $pt = ($clod=='1')?enumProjectType::tyInternal:enumProjectType::tyExternal;
        $curr = ($clod=='1')?$defaultCurrency:$organizationDetail->org_currency[0];
        $wc = ($clod=='1')?'1':$organizationDetail->org_workcalendar[0];
    } else {
        $pn = (($cpy == 'true')?($strings['copy_of'] . ' '):'') . $projectDetail->pro_name[0];
        $pr = $projectDetail->pro_priority[0];
        $d = $projectDetail->pro_description[0];
        $pown = ($cpy == 'true')?$idSession:$projectDetail->pro_mem_id[0];
        $clod = $projectDetail->pro_org_id[0];
        $thisPhase = $projectDetail->pro_phase_set[0];
        $st = ($cpy == 'true')?enumProjectStatus::stInitiation:$projectDetail->pro_status[0];
        $pt = $projectDetail->pro_type[0];
        $upPath = $projectDetail->pro_upload_dir[0];
        $curr = $projectDetail->pro_currency[0];
        $lcm = $projectDetail->pro_cost_method[0];
        $pset = $projectDetail->pro_permission_set[0];
        $wc = $projectDetail->pro_workcalendar[0];
        $querymore = " WHERE pfm.project='$id'";
        $listProjectForms = new request();
        $listProjectForms->openProjectsForm($querymore);
        $comptListProjectForms = count($listProjectForms->pfm_project);
        $pfmc = $comptListProjectForms;

        if ($comptListProjectForms > 0) {
            $pfmna = $listProjectForms->pfm_tablename;
            $pfmpa = $listProjectForms->pfm_publishenabled;
        }
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php?' . $urlBornes, lang_strings('projects'), 'in'));

if ($id == '') { // case add project
    $blockPage->itemBreadcrumbs(lang_strings('add_project'));
} else { // case update or copy project
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));

    if ($cpy == 'true') {
        $blockPage->itemBreadcrumbs(lang_strings('copy_project'));
    } else {
        $blockPage->itemBreadcrumbs(lang_strings('edit_project'));
    }
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'epD';

if ($id == '') { // case add project
    $block1->openForm('../projects/editproject.php?#' . $block1->form . 'Anchor');
    echo '<input type="hidden" name="action" value="add">';
} else { // case update or copy project
    $block1->openForm('../projects/editproject.php?id=' . $id . '&cpy=' . $cpy . $urlBornes . '#' . $block1->form . 'Anchor');
    echo '<input type="hidden" name="action" value="update">';
}

if ($id == '') { // case add project
    $block1->heading(lang_strings('add_project'));
} else { // case update or copy project
    if ($cpy == 'true') {
        $block1->heading(lang_strings('copy_project') . ' : ' . $projectDetail->pro_name[0]);
    } else {
        $block1->heading(lang_strings('edit_project') . ' : ' . $projectDetail->pro_name[0]);
    }
}

$block1->openContent(true);
$block1->contentTitle(lang_strings('details'));
setupInputHTML($block1, lang_strings('name'), 'pn', enumFieldType::ftText, 'Y', '255', $pn);
$prSel = '<select name="pr">';

foreach ($priority as $key => $val) {
    if ($key == $pr) {
        $prSel .= '<option value="' . $key . '" selected>' . $val . '</option>';
    } else {
        $prSel .= '<option value="' . $key . '">' . $val . '</option>';
    }
}

$prSel .= "</select>";
$block1->contentRow(lang_strings('priority'), $prSel);
setupInputHTML($block1, lang_strings('description'), 'd', enumFieldType::ftMemo, 'N', '0', $d);

if ($SW_Permissions['Project']['Admin'][$profilSession]) {
    $swPermissionsProfiles = '';

    foreach ($SW_Permissions['Project']['Write'] as $key => $val) {
        if ($val) {
            if ($swPermissionsProfiles != '') {
                $swPermissionsProfiles .= ',';
            }

            $swPermissionsProfiles .= "'$key'";
        }
    }

    $querymore = " WHERE (mem.profil IN ($swPermissionsProfiles) AND mem.active='" . enumBoolean::bTrue . "') OR mem.id='$pown' ORDER BY mem.name";
    $assignOwner = new request();
    $assignOwner->openMembers($querymore);
    $comptAssignOwner = count($assignOwner->mem_id);
    $pownSel = "<select name=\"pown\">";

    for ($i=0; $i<$comptAssignOwner; $i++) {
        if ($assignOwner->mem_id[$i] == $pown) {
            $pownSel .= '<option value="' . $assignOwner->mem_id[$i] . '" selected>' . $assignOwner->mem_name[$i] . '</option>';
        } else {
            $pownSel .= '<option value="' . $assignOwner->mem_id[$i] . '">' . $assignOwner->mem_name[$i] . '</option>';
        }
    }

    $pownSel .= '</select>';
    $block1->contentRow(lang_strings('owner'), $pownSel);
} else {
    $block1->contentRow(lang_strings('owner'), $nameSession);
    echo '<input type="hidden" value="' . $idSession . '" name="pown">';
}

if (!$SW_Permissions['Project']['Admin'][$profilSession]) {
    $querymore = " WHERE org.owner='$idSession' AND org.id<>'1' AND org.locked='" . enumBoolean::bFalse . "' ORDER BY org.name";
} else {
    $querymore = " WHERE org.id<>'1' AND org.locked='" . enumBoolean::bFalse . "' ORDER BY org.name";
}

$listClients = new request();
$listClients->openOrganizations($querymore);
$comptListClients = count($listClients->org_id);
$ptSel = '<select name="pt" onchange="pt_changed()">';

foreach ($projectType as $k => $v) {
    if ($comptListClients == '0' && $k == enumProjectType::tyExternal) {
        continue;
    }

    if ($k == $pt || ($organization != '' && $organization != '1' && $k == enumProjectType::tyExternal)) {
        $ptSel .= '<option value="' . $k . '" selected>' . $v . '</option>';
    } else {
        $ptSel .= '<option value="' . $k . '">' . $v . '</option>';
    }
}

$ptSel .= '</select>';
$block1->contentRow(lang_strings('type'), $ptSel);
echo '<input type="hidden" id="crc1" value=""><input type="hidden" id="cwc1" value="1">';
$clodSel = '<select name="clod" onchange="clod_changed()">';
$clodSel .= '<option value="1"' . (($clod == '1')?' selected':'') . '></option>';

for ($i=0; $i<$comptListClients; $i++) {
    echo '<input type="hidden" id="crc' . $listClients->org_id[$i] . '" value="' . $listClients->org_currency[$i] . '"><input type="hidden" id="cwc' . $listClients->org_id[$i] . '" value="' . $listClients->org_workcalendar[$i] . '">';

    if ($listClients->org_id[$i] == $clod) {
        $clodSel .= '<option value="' . $listClients->org_id[$i] . '" selected>' . $listClients->org_name[$i] . '</option>';
    } else {
        $clodSel .= '<option value="' . $listClients->org_id[$i] . '">' . $listClients->org_name[$i] . '</option>';
    }
}

if ($SW_Permissions['Client']['Write'][$profilSession] && $id == '') {
    $clodSel .= '<option value="-1">' . $strings['add_new_client'] . '</option>';
}

$clodSel .= '</select>';
$block1->contentRow(lang_strings('organization'), $clodSel);

if ($id != '' && $cpy != "true") {
    echo '<input type="hidden" name="thisPhase" value="' . $projectDetail->pro_phase_set[0] . '">';

    if ($projectDetail->pro_phase_set[0] != '0') {
        $block1->contentRow(lang_strings('enable_phases'), $projectDetail->phs_description[0]);
    }
} else {
    $querymore = " ORDER BY phs.name";
    $listPhaseSets = new request();
    $listPhaseSets->openPhaseSets($querymore);
    $comptListPhaseSets = count($listPhaseSets->phs_id);

    if ($comptListPhaseSets == '0') {
        echo '<input type="hidden" name="thisPhase" value="0">';
    } else {
        $phaSel = '<select name="thisPhase" onchange="phase_changed();">';
        $phasesetsstr = '<input type="hidden" id="phaset0" value="">';

        if ($thisPhase == '0') {
            $phaSel .= '<option value="0" selected>' . lang_strings('none') . '</option>';
        } else {
            $phaSel .= '<option value="0">' . lang_strings('none') . '</option>';
        }

        for ($i=0; $i<$comptListPhaseSets; $i++) {
            if ($listPhaseSets->phs_id[$i] == $thisPhase) {
                $phaSel .= '<option value="' . $listPhaseSets->phs_id[$i] . '" selected>' . $listPhaseSets->phs_description[$i] . '</option>';
            } else {
                $phaSel .= '<option value="' . $listPhaseSets->phs_id[$i] . '">' . $listPhaseSets->phs_description[$i] . '</option>';
            }

            $phasesetsstr .= '<input type="hidden" id="phaset' . $listPhaseSets->phs_id[$i] . '" value="';

            for ($j=1; $j<=$listPhaseSets->phs_phase_num[$i]; $j++) {
                $phasesetsstr .= strval($j) . "-" . $strings['PHS__' . $listPhaseSets->phs_name[$i] . '_' . $j] . "&nbsp;&nbsp;";
            }

            $phasesetsstr .= '">';
        }

        $phaSel .= '</select>&nbsp;<dfn id="phases"></dfn>' . $phasesetsstr;
        $block1->contentRow(lang_strings('enable_phases'), $phaSel);
    }
}

$stSel = '<select name="st">';

foreach ($statusProject as $code => $desc) {
    if ($code == $st) {
        $stSel .= '<option value="' . $code . '" selected>' . $desc . '</option>';
    } else {
        $stSel .= '<option value="' . $code . '">' . $desc . '</option>';
    }
}

$stSel .= '</select>';
$block1->contentRow(lang_strings('status'), $stSel);

if ($fileManagement == 'true') {
    if ($autoCreateDir != 'true' || ($id != '' && $cpy != 'true')) {
        bof('0');
        $upPathSel = '<select name="upPath">';

        for ($i=0; $i<count($fol_id); $i++) {
            if ($fol_id[$i] == $upPath) {
                $upPathSel .= '<option value="' . $fol_id[$i] . '" selected>' . $fol_path[$i] . '</option>';
            } else {
                $upPathSel .= '<option value="' . $fol_id[$i] . '">' . $fol_path[$i] . '</option>';
            }
        }

        $upPathSel .= '</select>';
        $block1->contentRow(lang_strings('upload_filepath'), $upPathSel);
    }
}

$helpStr = '<table>';
$currSel = '<select name="currs" onchange="currs_changed()"><option value="">' . $strings['CRC'] . '</option>';

foreach ($CurrencyMatrix['active'] as $currCode) {
    $currName = $CurrencyMatrix['name'][$currCode];
    $helpStr .= '<tr><th>' . $currCode . '</th><td>' . $currName . '</td></tr>';

    if ($curr == $currCode) {
        $currSel .= '<option value="' . $currCode . '" selected>' . $currCode . '</option>';
    } else {
        $currSel .= '<option value="' . $currCode . '">' . $currCode . '</option>';
    }
}

$currSel .= '</select>';
$helpStr .= '</table>';
$block1->contentRow(lang_strings('currency') . '&nbsp;' . $blockPage->printHelp($helpStr, true), $currSel);
echo '<input type="hidden" name="curr" value="' . $curr . '">';
$block1->contentRow(lang_strings('cost_method'), '
<input type="radio" name="lcm" value="1"' . (($lcm=='1')?' checked':'') . '>' . fieldValidValueString('projects', 'cost_method', '1') . '<br>
<input type="radio" name="lcm" value="2"' . (($lcm=='2')?' checked':'') . '>' . fieldValidValueString('projects', 'cost_method', '2') . '<br>
<input type="radio" name="lcm" value="3"' . (($lcm=='3')?' checked':'') . '>' . fieldValidValueString('projects', 'cost_method', '3'));

if ($id == '' || $cpy == 'true') {
    $psetSel = '<select name="pset">';

    foreach ($permissionLevels as $val => $desc) {
        if ($val == $pset) {
            $psetSel .= '<option value="' . $val . '" selected>' . $desc . '</option>';
        } else {
            $psetSel .= '<option value="' . $val . '">' . $desc . '</option>';
        }
    }

    $psetSel .= '</select>';
    $block1->contentRow(lang_strings('permission_set'), $psetSel);
}

$querymore1 = " ORDER BY wca.name";
$listWorkCalendars = new request();
$listWorkCalendars->openWorkCalendars($querymore1);
$comptListWorkCalendars = count($listWorkCalendars->wca_id);
$wcSel = '<select name="wc">';

for ($i=0; $i<$comptListWorkCalendars; $i++) {
    if ($listWorkCalendars->wca_id[$i] == $wc) {
        $wcSel .= '<option value="' . $listWorkCalendars->wca_id[$i] . '" selected>' . $listWorkCalendars->wca_name[$i] . '</option>';
    } else {
        $wcSel .= '<option value="' . $listWorkCalendars->wca_id[$i] . '">' . $listWorkCalendars->wca_name[$i] . '</option>';
    }
}

$wcSel .= '</select>';
$block1->contentRow(lang_strings('workcalendar'), $wcSel);
$querymore = " WHERE tdf.sysdef='N' AND tdf.fathertable='' ORDER BY tdf.tablename";
$listTableDefinitions = new request();
$listTableDefinitions->openTablesDefinitions($querymore);
$comptListTableDefinitions = count($listTableDefinitions->tdf_id);
echo '<input type="hidden" name="pfmc" value="' . $pfmc . '">';

if ($comptListTableDefinitions == '0') {
    echo '<input type="hidden" name="pfmsel" value="">';
} else {
    $headrow = '<tr><td>' . $strings['form_template'] . '</td><td>' . $strings['enable_publish'] .'</td><td>&nbsp</td></tr>';
    echo '<input type="hidden" name="headrow" value="' . htmlentities($headrow, ENT_QUOTES, $htmlEntityCharset) . '">';
    $pfmSel = '<select name="pfmnNNN" onchange="chgpfm(this, NNN);"><option value=""></option>';

    for ($i=0; $i<$comptListTableDefinitions; $i++) {
        $pfmSel .= '<option value="' . $listTableDefinitions->tdf_tablename[$i] . '">' . tableNameString($listTableDefinitions->tdf_tablename[$i]) . '</option>';
    }

    $pfmSel .= '</select>';
    $pfmCnt = $blockPage->buildLink("javascript:addpfm();", lang_strings("add"), 'in');
    $block1->contentRow(lang_strings('project_form_templates'), $pfmCnt);
    echo '<input type="hidden" name="pfmsel" value="' . htmlentities($pfmSel, ENT_QUOTES, $htmlEntityCharset) . '">';
    $pfmlst = '<div class="valuelist"><table id="pfmlst">';

    if ($pfmc != '0') {
        $pfmlst .= $headrow;

        for ($i=0; $i<$pfmc; $i++) {
            $pfmlst .= '<tr><td>' . str_replace('NNN', $i, $pfmSel) . '<input type="hidden" name="pfmh' . $i . '" value="' . $pfmna[$i] . '"></td>';
            $pfmlst .= '<td><input type="checkbox" name="pfmp' . $i . '" value="Y"' . (($pfmpa[$i]=='Y')?' checked':'') . '></td>';
            $pfmlst .= '<td><a href="javascript:delpfm(' . $i . ');" class="delete-link">&#8722;</a></td></tr>';
        }
    }

    $pfmlst .= '</table></div>';
    $block1->contentRow('', $pfmlst);
}

setupCustomFieldsInputHTML($block1, 'projects', $id);
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
$block1->closeContent();

if ($fileManagement == 'true' && ($id == '' || $cpy == 'true') && ($SW_Permissions['Project']['Write'][$profilSession] || $prp_add_file == enumBoolean::bTrue)) {
    setupAttachFilesHTML(false);
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
function pt_changed() {
    var x = document.epDForm.pt.value;
    var y = document.epDForm.clod;

    if (x == '0') {
        y.selectedIndex = 0;
    } else {
        y.selectedIndex = 1;
    }

    clod_changed();
}

function clod_changed() {
    var x = document.epDForm.clod.selectedIndex;
    var y = document.epDForm.clod.options[x].value;
    var z = document.getElementById('crc' + String(y));
    var w = document.epDForm.currs;
    var v = document.epDForm.curr;
    var u = document.epDForm.pt;
    var t = document.getElementById('cwc' + String(y));
    var s = document.epDForm.wc;

    if (y == -1) {
        document.epDForm.action.value = '';
        document.epDForm.submit();
    }

    if (y == 1) {
        u.value = '0';
    } else {
        u.value = '1';
    }

    if (z == null || z.value == '') {
        w.disabled = false;
    } else {
        w.disabled = true;
        w.value = z.value;
        v.value = z.value;
    }

    if (t == null || t.value == '') {
        s.value = '1';
    } else {
        s.value = t.value;
    }

    currs_changed();
}

function currs_changed() {
    var w = document.epDForm.currs;
    var v = document.epDForm.curr;
    v.value = w.value;
}

function phase_changed()
{
    var x = document.epDForm.thisPhase.selectedIndex;

    if (typeof(x) != 'undefined') {
        var y = document.epDForm.thisPhase.options[x].value;
        var z = document.getElementById('phaset' + y);
        var w = document.getElementById('phases');
        w.innerHTML = z.value;
    }
}

function refresh_pfmlist() {
    var x = document.epDForm.pfmsel.value;
    var y = document.epDForm.pfmc.value;
    if (x == '' || y == '0')
        return;

    for (var i=0; i<Number(y); i++) {
        var z = document.epDForm.elements['pfmh' + String(i)];
        var w = document.epDForm.elements['pfmn' + String(i)];

        for (var j=0; j<w.length; j++) {
            if (w.options[j].value == z.value) {
                w.selectedIndex = j;
                break;
            }
        }
    }
}

function addpfm() {
    var y = document.epDForm.pfmc;
    var pfmsel = document.epDForm.pfmsel.value;
    var x = '';
    if (y.value == '0')
        x = document.epDForm.headrow.value;
    x = x + '<tr><td>' + pfmsel.replace(/NNN/g, y.value) + '<input type="hidden" name="pfmh' + y.value + '" value=""></td>';
    x = x + '<td><input type="checkbox" name="pfmp' + y.value + '" value="Y"></td>';
    x = x + '<td><a href="javascript:delpfm(' + y.value + ');" class="delete-link">&#8722;</a></td></tr>';
    $("#pfmlst").append(x);
    y.value = String(Number(y.value) + 1);
}

function delpfm(idx) {
    var y = document.epDForm.pfmc;
    var yy = Number(y.value);

    if (yy == 1) {
        $("#pfmlst").html('');
        yy = 0;
    } else {
        var pfmha = new Array();
        var pfmpa = new Array();

        for (var i=0; i<yy; i++) {
            if (Number(i) == Number(idx))
                continue;
            var pfmh = document.epDForm.elements["pfmh" + String(i)];
            var pfmp = document.epDForm.elements["pfmp" + String(i)];
            pfmha.push(pfmh.value);

            if (pfmp.checked) {
                pfmpa.push('Y');
            } else {
                pfmpa.push('N');
            }
        }

        yy = yy - 1;
        var pfmsel = document.epDForm.pfmsel.value;
        var x = document.epDForm.headrow.value;

        for (var i=0; i<yy; i++) {
            x = x + '<tr><td>' + pfmsel.replace(/NNN/g, String(i)) + '<input type="hidden" name="pfmh' + String(i) + '" value="' + pfmha[i] + '"></td>';
            x = x + '<td><input type="checkbox" name="pfmp' + String(i) + '" value="Y"';
            if (pfmpa[i] == 'Y')
                x = x + ' checked';
            x = x + '></td>';
            x = x + '<td><a href="javascript:delpfm(' + String(i) + ');" class="delete-link">&#8722;</a></td></tr>';
        }

        $("#pfmlst").html(x);
    }

    y.value = String(yy);
    refresh_pfmlist();
}

function chgpfm(theObj, idx) {
    var y = document.epDForm.elements["pfmh" + idx];
    var z = theObj.selectedIndex;
    y.value = theObj.options[z].value;
}

clod_changed();
phase_changed();
refresh_pfmlist();
</script>
<?php
require_once('../includes/footer.php');
