<?php // $Revision: 1.17 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportproject.php,v 1.17 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$pi = isset($_POST['pi'])?$_POST['pi']:'';
$tm = isset($_POST['tm'])?$_POST['tm']:'';
$td = isset($_POST['td'])?$_POST['td']:'';
$tr = isset($_POST['tr'])?$_POST['tr']:'';

/**
 * Permission check
 */
// test exists selected project, redirect to list if not
$querymore1 = " WHERE pro.id='$id'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore2 = " WHERE tea.project='$id' AND tea.member='$idSession'";
$teamMemberDetail = new request();
$teamMemberDetail->openTeams($querymore2);
$comptTeamMemberDetail = count($teamMemberDetail->tea_project);

if ($comptTeamMemberDetail == 0) {
    $querymore3 = " WHERE prp.project='$id' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore3 = " WHERE prp.project='$id' AND prp.profil='" . $teamMemberDetail->tea_profil[0] . "'";
}

$projectPermissionsDetail = new request();
$projectPermissionsDetail->openProjectPermissions($querymore3);
$comptProjectPermissionsDetail = count($projectPermissionsDetail->prp_project);

if (!$SW_Permissions['Project']['Admin'][$profilSession] && ($projectPermissionsDetail->prp_export_project[0] != enumBoolean::bTrue || !$SW_Permissions['Project']['Edit'][$profilSession])) {
    header("Location: ../projects/viewproject.php?id=$id&msg=permissiondenied" . $urlBornes);
    exit;
}

/**
 * Actions
 */
if ($action == "export") {
    // default start time & finish time
    $querymore4 = " WHERE wcw.workcalendar='" . $projectDetail->pro_workcalendar[0] . "' AND wcw.hours>0 ORDER BY wcw.year DESC";
    $listWorkCalendarWeekday = new request();
    $listWorkCalendarWeekday->openWorkCalendarsWeekday($querymore4, '0', '1');
    $comptListWorkCalendarWeekday = count($listWorkCalendarWeekday->wcw_id);

    if ($comptListWorkCalendarWeekday == '0') {
        $defaultStartTime = '09:00:00';
        $defaultFinishTime = '17:00:00';
    } else {
        $defaultStartTime = $listWorkCalendarWeekday->wcw_start_time[0] . ':00';
        $defaultFinishTime = $listWorkCalendarWeekday->wcw_end_time[0] . ':00';
        $defaultStartTime = substr($defaultStartTime, 0, 2) . ':' . substr($defaultStartTime, 2) . ':00';
        $defaultFinishTime = substr($defaultFinishTime, 0, 2) . ':' . substr($defaultFinishTime, 2) . ':00';
    }

    // create a new XML document
    $doc = new DOMDocument('1.0', 'UTF-8');
    $doc->formatOutput = true;
    $elementProject = $doc->createElementNS("http://schemas.microsoft.com/project", "Project");   // Project Element
    $doc->appendChild($elementProject);

    // Include project information
    if ($pi == 'Y') {
        $elementProject->appendChild($doc->createElement("Title", $projectDetail->pro_name[0]));    // The title of the project

        if ($projectDetail->pro_currency[0] != '') {
            $elementProject->appendChild($doc->createElement("CurrencyCode", $projectDetail->pro_currency[0])); // A three letter currency character code.
            $elementProject->appendChild($doc->createElement("CurrencySymbol", $CurrencyMatrix['symbol'][$projectDetail->pro_currency[0]]));    // The currency symbol used to represent the type of currency used in the project.
            $elementProject->appendChild($doc->createElement("CurrencySymbolPosition", (($currencyOnRight=='true')?'1':'0')));  // The position of the currency symbol.
        }

        if ($projectDetail->pro_phase_set[0] == '0') {
            $elementProject->appendChild($doc->createElement("Category", ""));  // no phase set for project
        } else {
            $elementProject->appendChild($doc->createElement("Category", $projectDetail->phs_name[0])); // The phase set of project
        }
    }

    // Include tasks & milestones
    if ($tm == 'Y') {
        $elementTasks = $doc->createElement("Tasks");   // The collection of tasks that make up the project.
        $querymore5 = " WHERE tas.project='$id'";    // get all tasks of project
        $listTasks = new request();
        $listTasks->openHierarchyOfTasks($querymore5);
        $comptListTasks = count($listTasks->tas_id);
        $posid = 0;

        if ($projectDetail->pro_phase_set[0] != '0') {
            $querymore6 = " WHERE pha.project='$id' ORDER BY pha.order_num"; // get all phases of project
            $listPhases = new request();
            $listPhases->openPhases($querymore6);
            $comptListPhases = count($listPhases->pha_id);

            if ($comptListPhases > 0) {
                $phaseUID=(max($listTasks->tas_id)+1);
                // rebuild task list array
                $listTasks->tas_id = array();
                $listTasks->tas_name = array();
                $listTasks->tas_fixed_duration = array();
                $listTasks->tas_priority = array();
                $listTasks->tas_start_date = array();
                $listTasks->tas_due_date = array();
                $listTasks->tas_milestone = array();
                $listTasks->tas_estimated_time = array();
                $listTasks->tas_parent_phase = array();
                $listTasks->tas_wbs = array();
                $listTasks->tas_level = array();
                $listTasks->tas_published = array();

                for ($i=0; $i<$comptListPhases; $i++,$phaseUID++) {
                    $elementTask = $doc->createElement("Task");
                    $elementTask->appendChild($doc->createElement("UID", $phaseUID));   // The UID element is a unique identifier.
                    $elementTask->appendChild($doc->createElement("ID", $posid++));     // It is the position identifier of the task in the list of tasks.
                    $elementTask->appendChild($doc->createElement("Name", $listPhases->pha_description[$i]));   // The name of task
                    $elementTask->appendChild($doc->createElement("Milestone", "0"));   // not a milestone
                    // A unique code (work breakdown structure) that represents a task's position within the hierarchical structure of the project.
                    $elementTask->appendChild($doc->createElement("WBS", $listPhases->pha_order_num[$i]));
                    // Indicates the exact position of a task in the outline.
                    $elementTask->appendChild($doc->createElement("OutlineNumber", $listPhases->pha_order_num[$i]));
                    // The number that indicates the level of a task in the project outline hierarchy.
                    $elementTask->appendChild($doc->createElement("OutlineLevel", '0'));
                    // Indicates whether the task is a summary task or the assignment is on a summary task.
                    $elementTask->appendChild($doc->createElement("Summary", '1'));
                    $elementTasks->appendChild($elementTask);
                    // get all tasks of phase
                    $querymore7 = " WHERE tas.project='$id' AND tas.parent_phase='" . $listPhases->pha_order_num[$i]. "'";
                    $listPhaseTasks = new request();
                    $listPhaseTasks->openHierarchyOfTasks($querymore7);
                    $comptListPhaseTasks = count($listPhaseTasks->tas_id);

                    if ($comptListPhaseTasks > 0) { // append phase tasks to task list
                        $listTasks->tas_id = array_merge($listTasks->tas_id, $listPhaseTasks->tas_id);
                        $listTasks->tas_name = array_merge($listTasks->tas_name, $listPhaseTasks->tas_name);
                        $listTasks->tas_fixed_duration = array_merge($listTasks->tas_fixed_duration, $listPhaseTasks->tas_fixed_duration);
                        $listTasks->tas_priority = array_merge($listTasks->tas_priority, $listPhaseTasks->tas_priority);
                        $listTasks->tas_start_date = array_merge($listTasks->tas_start_date, $listPhaseTasks->tas_start_date);
                        $listTasks->tas_due_date = array_merge($listTasks->tas_due_date, $listPhaseTasks->tas_due_date);
                        $listTasks->tas_milestone = array_merge($listTasks->tas_milestone, $listPhaseTasks->tas_milestone);
                        $listTasks->tas_estimated_time = array_merge($listTasks->tas_estimated_time, $listPhaseTasks->tas_estimated_time);
                        $listTasks->tas_parent_phase = array_merge($listTasks->tas_parent_phase, $listPhaseTasks->tas_parent_phase);
                        $listTasks->tas_wbs = array_merge($listTasks->tas_wbs, $listPhaseTasks->tas_wbs);
                        $listTasks->tas_level = array_merge($listTasks->tas_level, $listPhaseTasks->tas_level);
                        $listTasks->tas_published = array_merge($listTasks->tas_published, $listPhaseTasks->tas_published);
                    }
                }

                $comptListTasks = count($listTasks->tas_id);    // recaculate task count
            }
        } else {
            $comptListPhases = 0;
        }

        if ($comptListTasks != '0') {
            for ($i=0; $i<$comptListTasks; $i++) {
                $elementTask = $doc->createElement("Task");
                $elementTask->appendChild($doc->createElement("UID", $listTasks->tas_id[$i]));  // The UID element is a unique identifier.
                $elementTask->appendChild($doc->createElement("ID", $posid++));   //  It is the position identifier of the task in the list of tasks.
                $elementTask->appendChild($doc->createElement("Name", $listTasks->tas_name[$i]));   // The name of task
                // The type of task
                if ($listTasks->tas_fixed_duration[$i] == enumFixedDuration::fdYes) {
                    $elementTask->appendChild($doc->createElement("Type", "1"));    // Fixed duration
                } else {
                    $elementTask->appendChild($doc->createElement("Type", "0"));    // Fixed units
                }
                // Indicates the level of importance assigned to a task
                switch ($listTasks->tas_priority[$i]) {
                    case enumPriority::prVeryLow:
                        $elementTask->appendChild($doc->createElement("Priority", "100"));
                        break;
                    case enumPriority::prLow:
                        $elementTask->appendChild($doc->createElement("Priority", "300"));
                        break;
                    case enumPriority::prHigh:
                        $elementTask->appendChild($doc->createElement("Priority", "700"));
                        break;
                    case enumPriority::prVeryHigh:
                        $elementTask->appendChild($doc->createElement("Priority", "900"));
                        break;
                    default:
                        $elementTask->appendChild($doc->createElement("Priority", "500"));
                }
                // Date and time that a task is scheduled to begin.
                $elementTask->appendChild($doc->createElement("Start", createDate($listTasks->tas_start_date[$i], 'date', false, true) . 'T' . $defaultStartTime));
                // The date and time that a task is scheduled to be completed.
                $elementTask->appendChild($doc->createElement("Finish", createDate($listTasks->tas_due_date[$i], 'date', false, true) . 'T' . $defaultFinishTime));
                // Indicates whether a task is a milestone.
                if ($listTasks->tas_milestone[$i] == enumMilestone::msYes) {
                    $elementTask->appendChild($doc->createElement("Milestone", "1"));
                } else {
                    $elementTask->appendChild($doc->createElement("Milestone", "0"));
                    // Total span of active working time for a task.
                    $elementTask->appendChild($doc->createElement("Duration", "PT" . $listTasks->tas_estimated_time[$i] . "H0M0S"));
                    // Format used to show the duration of the task.
                    $elementTask->appendChild($doc->createElement("DurationFormat", "5"));  // hours
                }
                // A unique code (work breakdown structure) that represents a task's position within the hierarchical structure of the project.
                if ($comptListPhases > 0) {
                    $WBS = $listTasks->tas_parent_phase[$i] . '.' . $listTasks->tas_wbs[$i];
                } else {
                    $WBS = $listTasks->tas_wbs[$i];
                }

                $elementTask->appendChild($doc->createElement("WBS", $WBS));
                // Indicates the exact position of a task in the outline.
                $elementTask->appendChild($doc->createElement("OutlineNumber", $WBS));
                // The number that indicates the level of a task in the project outline hierarchy.
                $elementTask->appendChild($doc->createElement("OutlineLevel", $listTasks->tas_level[$i]+1));
                // Indicates whether the task is published.
                $elementTask->appendChild($doc->createElement("IsPublished", (($listTasks->tas_published[$i]==enumPublished::pbYes)?'1':'0')));
                // Indicates whether the task is a summary task or the assignment is on a summary task.
                $elementTask->appendChild($doc->createElement("Summary", '0'));
                // Include task dependencies
                if ($td == 'Y') {
                    $querymore8 = " WHERE pre.task='" . $listTasks->tas_id[$i] . "'";
                    $listTaskPredecessors = new request();
                    $listTaskPredecessors->openTaskPredecessor($querymore8);
                    $comptListTaskPredecessors = count($listTaskPredecessors->pre_id);

                    if ($comptListTaskPredecessors != '0') {
                        for ($j=0; $j<$comptListTaskPredecessors; $j++) {
                            // Defines the predecessor task on which this task depends for its start or finish date.
                            $elementPredecessor = $doc->createElement("PredecessorLink");
                            // Unique ID number for the predecessor task.
                            $elementPredecessor->appendChild($doc->createElement("PredecessorUID", $listTaskPredecessors->pre_predecessor[$j]));
                            // Type of predecessor task link (FF, FS, SF, SS)
                            switch ($listTaskPredecessors->pre_type[$j]) {
                                case 'FF':  // finish-to-finish
                                    $elementPredecessor->appendChild($doc->createElement("Type", '0'));
                                    break;
                                case 'FS':  // finish-to-start
                                    $elementPredecessor->appendChild($doc->createElement("Type", '1'));
                                    break;
                                case 'SF':  // start-to-finish
                                    $elementPredecessor->appendChild($doc->createElement("Type", '2'));
                                    break;
                                case 'SS':  // start-to-start
                                    $elementPredecessor->appendChild($doc->createElement("Type", '3'));
                            }

                            $elementTask->appendChild($elementPredecessor);
                        }
                    }
                }

                $elementTasks->appendChild($elementTask);
            }

            $elementProject->appendChild($elementTasks);

            if ($tr == 'Y') {
                $resUID = 1;    // The unique ID for the resource
                // collect work resources from the resource of all tasks
                $tmpquery = "SELECT res.resource,mem.name FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=res.task INNER JOIN " . $tablePrefix . "members mem ON mem.id=res.resource WHERE tas.project='$id' AND res.type='" . enumResourceType::rtUser . "' GROUP BY res.resource,mem.name";
                $listWorkResources = new request();
                $listWorkResources->connectClass();
                $listWorkResources->query($tmpquery);
                $listWorkResources->uid = array();

                while ($listWorkResources->fetch()) {
                    $listWorkResources->uid[] = ($row[0]);
                    $listWorkResources->name[] = HtmlEntityDecodeNOD($row[1]);
                    $listWorkResources->resUID[] = $resUID++;
                }

                $listWorkResources->close();
                $comptListWorkResources = count($listWorkResources->uid);
                // collect material resources from the resources of all tasks
                $tmpquery = "SELECT res.resource,mat.name FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=res.task INNER JOIN " . $tablePrefix . "materials mat ON mat.id=res.resource WHERE tas.project='$id' AND res.type='" . enumResourceType::rtMaterial . "' GROUP BY res.resource,mat.name";
                $listMaterialResources = new request();
                $listMaterialResources->connectClass();
                $listMaterialResources->query($tmpquery);
                $listMaterialResources->uid = array();

                while ($listMaterialResources->fetch()) {
                    $listMaterialResources->uid[] = ($row[0]);
                    $listMaterialResources->name[] = HtmlEntityDecodeNOD($row[1]);
                    $listMaterialResources->resUID[] = $resUID++;
                }

                $listMaterialResources->close();
                $comptListMaterialResources = count($listMaterialResources->uid);

                if ($comptListWorkResources > 0 || $comptListMaterialResources > 0) {
                    // The collection of all resources that make up the project.
                    $elementResources = $doc->createElement("Resources");

                    // work resources
                    for ($i=0; $i<$comptListWorkResources; $i++) {
                        $elementResource = $doc->createElement("Resource");
                        $elementResource->appendChild($doc->createElement("UID", $listWorkResources->resUID[$i])); // The unique ID for the resource.
                        $elementResource->appendChild($doc->createElement("ID", $listWorkResources->resUID[$i]));   // The position identifier of the resource within the list of resources.
                        $elementResource->appendChild($doc->createElement("Name", $listWorkResources->name[$i])); // The name of the resource
                        $elementResource->appendChild($doc->createElement("Type", "1"));    // The resource type
                        $elementResources->appendChild($elementResource);
                    }

                    // material resources
                    for ($i=0; $i<$comptListMaterialResources; $i++) {
                        $elementResource = $doc->createElement("Resource");
                        $elementResource->appendChild($doc->createElement("UID", $listMaterialResources->resUID[$i])); // The unique ID for the resource.
                        $elementResource->appendChild($doc->createElement("ID", $listMaterialResources->resUID[$i]));   // The position identifier of the resource within the list of resources.
                        $elementResource->appendChild($doc->createElement("Name", $listMaterialResources->name[$i])); // The name of the resource
                        $elementResource->appendChild($doc->createElement("Type", "0"));    // The resource type
                        $elementResources->appendChild($elementResource);
                    }

                    $elementProject->appendChild($elementResources);
                }

                $querymore = " WHERE tas.project='$id'";
                $listTaskResources = new request();
                $listTaskResources->openTaskResource($querymore);
                $comptListTaskResources = count($listTaskResources->res_id);

                if ($comptListTaskResources != '0') {
                    // The collection of assignments in a project.
                    $elementAssignments = $doc->createElement("Assignments");

                    for ($i=0; $i<$comptListTaskResources; $i++) {
                        // find the unique ID for the resource.
                        if ($listTaskResources->res_type[$i] == enumResourceType::rtUser) {
                            $key = array_search($listTaskResources->res_resource[$i], $listWorkResources->uid);
                            $resUID = $listWorkResources->resUID[$key];
                        } else if ($listTaskResources->res_type[$i] == enumResourceType::rtMaterial) {
                            $key = array_search($listTaskResources->res_resource[$i], $listMaterialResources->uid);
                            $resUID = $listMaterialResources->resUID[$key];
                        } else {
                            $key = array_search($listTaskResources->res_resource[$i], $listEquipmentResources->uid);
                            $resUID = $listEquipmentResources->resUID[$key];
                        }

                        $elementAssignment = $doc->createElement("Assignment");
                        $elementAssignment->appendChild($doc->createElement("UID", $listTaskResources->res_id[$i]));    // The unique ID for the assignment.
                        $elementAssignment->appendChild($doc->createElement("TaskUID", $listTaskResources->res_task[$i]));  // The unique ID for the task.
                        $elementAssignment->appendChild($doc->createElement("ResourceUID", $resUID));  // The unique ID for the resource.

                        if ($listTaskResources->res_type[$i] == enumResourceType::rtMaterial) {
                            $elementAssignment->appendChild($doc->createElement("Cost", $listTaskResources->res_quantity[$i]));
                        }

                        $elementAssignment->appendChild($doc->createElement("HasFixedRateUnits", "1")); // Indicates whether an assignment has fixed-rate units.
                        $elementAssignment->appendChild($doc->createElement("FixedMaterial", "0")); // Indicates whether the consumption of the assigned material resource occurs in a single, fixed amount.
                        $elementAssignment->appendChild($doc->createElement("Units", "1")); // The number of units for which a resource is assigned to a task, expressed as a percentage, assuming a resource's MaxUnits value is 100%.
                        $elementAssignments->appendChild($elementAssignment);
                    }

                    $elementProject->appendChild($elementAssignments);
                }
            }
        }
    }

    $dump = $doc->saveXML();    // Dumps the internal XML tree back into a string
    $size = strlen($dump);
    $name = $projectDetail->pro_name[0] . '.xml';
    // Output
    header('Content-Length: ' . $size);
    header('Content-Type: text/xml');
    header("Content-Disposition: attachment; filename=$name");
    echo $dump;
    exit;
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php?' . $urlBornes, lang_strings('projects'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("export_project"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "exP";
$block1->openForm("../projects/exportproject.php?id=$id"  . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="export">';
$block1->heading(lang_strings("export_project"));
$block1->openContent();
$block1->contentTitle(lang_strings('details'));
$block1->contentRow('', '<input type="checkbox" name="pi" value="Y" checked> ' . lang_strings('project_information'));
$block1->contentRow('', '<input type="checkbox" name="tm" value="Y" onchange="tmchanged();" checked> ' . lang_strings('tasks_milestones'));
$block1->contentRow('', '<input type="checkbox" name="td" value="Y" onchange="tdchanged();" checked> ' . lang_strings('task_dependencies'));
$block1->contentRow('', '<input type="checkbox" name="tr" value="Y" onchange="trchanged();" checked> ' . lang_strings('tasks_resources'));
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["export"] . "\">");
$block1->closeContent();
$block1->note(lang_strings('exportproject_help'));
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
function tmchanged() {
    var tm = document.exPForm.tm;
    var td = document.exPForm.td;
    var tr = document.exPForm.tr;

    if (!tm.checked) {
        td.checked = false;
        tr.checked = false;
    }
}

function tdchanged() {
    var tm = document.exPForm.tm;
    var td = document.exPForm.td;

    if (td.checked) {
        tm.checked = true;
    }
}

function trchanged() {
    var tm = document.exPForm.tm;
    var tr = document.exPForm.tr;

    if (tr.checked) {
        tm.checked = true;
    }
}
</script>
<?php
require_once("../includes/footer.php");
