<?php // $Revision: 1.12 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: importproject.php,v 1.12 2013/02/09 06:36:54 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$atttmp = isset($_POST['atttmp1'])?$_POST['atttmp1']:'';
$attnam = isset($_POST['attnam1'])?$_POST['attnam1']:'';
$error = '';

/**
 * Permission check
 */
// test exists selected project, redirect to list if not
$querymore1 = " WHERE pro.id='$id'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore2 = " WHERE tea.project='$id' AND tea.member='$idSession'";
$teamMemberDetail = new request();
$teamMemberDetail->openTeams($querymore2);
$comptTeamMemberDetail = count($teamMemberDetail->tea_project);

if ($comptTeamMemberDetail == 0) {
    $querymore3 = " WHERE prp.project='$id' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore3 = " WHERE prp.project='$id' AND prp.profil='" . $teamMemberDetail->tea_profil[0] . "'";
}

$projectPermissionsDetail = new request();
$projectPermissionsDetail->openProjectPermissions($querymore3);
$comptProjectPermissionsDetail = count($projectPermissionsDetail->prp_project);

if ($projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval || ($projectPermissionsDetail->prp_import_project[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession])) {
    header("Location: ../projects/viewproject.php?id=$id&msg=permissiondenied" . $urlBornes);
    exit;
}

/**
 * Actions
 */
if ($action == "import") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $doc = new DOMDocument();

        if ($doc->load($atttmp) === false) {    // check if file exists
            throw new Exception(str_replace('%FILE%', $attnam, $strings['load_file_fail']));
        }

        $project = $doc->getElementsByTagName("Project");

        if ($project->length != 1) {  // check file format
            throw new Exception(lang_strings('invalid_fileformat'));
        }
        // import resources
        $listResources = $doc->getElementsByTagName("Resource");
        $res2mem = array();                                         // resource <-> member mapping table
        $res2mat = array();                                         // resource <-> material mapping talbe

        if ($listResources->length > 0) {
            foreach ($listResources as $resource) {
                $elementsUID = $resource->getElementsByTagName("UID");     // resource uid
                $uid = $elementsUID->item(0)->nodeValue;
                $elementsName = $resource->getElementsByTagName("Name");    // resource name
                $nm0 = (($elementsName->length==0)?'':$elementsName->item(0)->nodeValue);
                $nm = strtoupper(HtmlEntitiesNOD($nm0));
                $elementsType = $resource->getElementsByTagName("Type");    // resource type
                $ty = (($elementsType->length==0)?'1':$elementsType->item(0)->nodeValue);

                if ($ty == '0') {   // material resource
                    // check if material exist
                    $querymore = " WHERE UPPER(mat.name)='$nm'";
                    $materialDetail = clone $requestAct;
                    $materialDetail->openMaterials($querymore);
                    $comptMaterialDetail = count($materialDetail->mat_id);

                    if ($comptMaterialDetail == '0') {
                        continue;
                    }

                    $matid = $materialDetail->mat_id[0];
                    $res2mat[$uid] = $matid;
                } else if ($ty == '1') {    // work resource
                    // check if user exist
                    $querymore = " WHERE (UPPER(mem.login)='$nm' OR UPPER(mem.name)='$nm') AND mem.active='" . enumBoolean::bTrue . "'";
                    $memberDetail = clone $requestAct;
                    $memberDetail->openMembers($querymore);
                    $comptMemberDetail = count($memberDetail->mem_id);

                    if ($comptMemberDetail == '0') {
                        continue;
                    }

                    $memid = $memberDetail->mem_id[0];
                    $res2mem[$uid] = $memid;
                    // check if project team already exist
                    $querymore = " WHERE tea.project='$id' AND tea.member='$memid'";
                    $teamDetail = clone $requestAct;
                    $teamDetail->openTeams($querymore);
                    $comptTeamDetail = count($teamDetail->tea_member);

                    if ($comptTeamDetail != '0') {
                        continue;
                    }

                    // add the user to project team
                    $tmpsql = "INSERT INTO " . $tablePrefix . "teams (project,member,published,authorized,profil,created,cuser) VALUES ('$id','$memid','" . enumPublished::pbNo . "','" . enumAuthorized::auYes . "','" . enumProjectProfile::ppMember . "','" . time() . "','$idSession')";
                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num = $requestAct->newId('teams');
                    copy2HistoryTable($requestAct, 'teams', $num, 'A');
                }
            }
        }

        // import phases
        $category = $project->item(0)->getElementsByTagName("Category");

        if ($category->length > 0 && $category->item(0)->nodeValue != '') {
            $nm = $category->item(0)->nodeValue;
            // check if phase set exist
            $querymore = " WHERE UPPER(phs.name)='$nm'";
            $phaseSetDetail = clone $requestAct;
            $phaseSetDetail->openPhaseSets($querymore);
            $comptPhaseSetDetail = count($phaseSetDetail->phs_id);

            if ($comptPhaseSetDetail == '0') {
                throw new Exception(lang_strings('blank_phaseset'), 1);
            } else if ($phaseSetDetail->phs_id[0] != $projectDetail->pro_phase_set[0]) {
                throw new Exception(lang_strings('project_with_different_phaseset'), 1);
            }
        } else if ($projectDetail->pro_phase_set[0] != '0') {
            throw new Exception(lang_strings('project_with_different_phaseset'), 1);
        }

        // import tasks
        $listTasks = $doc->getElementsByTagName("Task");
        $listAssignments = $doc->getElementsByTagName("Assignment");
        $task2Task = array();                                           // ms task uid <-> webTareas task id mapping table
        $taskGroups = array();                                          // task group list
        $taskGroupsN = array();                                         // webTareas task group id list
        $oln2Task = array();                                            // outline position <-> webTareas task id mapping table

        if ($listTasks->length > 0) {
            if ($projectDetail->pro_phase_set[0] != '0') {              // mapping summary tasks to phase sets
                $querymore = " WHERE pha.project='$id' ORDER BY pha.order_num";
                $listPhases = clone $requestAct;
                $listPhases->openPhases($querymore);
                $comptListPhases = count($listPhases->pha_id);
                $comptSummaryTasks = 0;

                foreach ($listTasks as $task) {
                    $elements = $task->getElementsByTagName("UID");             // task uid
                    $uid = $elements->item(0)->nodeValue;
                    $elements = $task->getElementsByTagName("OutlineNumber");   // the exact position of a task in the outline
                    $oln = $elements->item(0)->nodeValue;
                    $elements = $task->getElementsByTagName("OutlineLevel");    // the level of a task in the project outline hierarchy
                    $oll = $elements->item(0)->nodeValue;
                    $elements = $task->getElementsByTagName("Summary");         // Indicates whether the task is a summary task or the assignment is on a summary task.
                    $sum = $elements->item(0)->nodeValue;

                    if ($oll != '0' || $sum != '1') {                           // convert level 0 summary tasks to phases only
                        continue;
                    }

                    $key = array_search($oln, $listPhases->pha_order_num);

                    if ($key === false) {
                        throw new Exception(lang_strings('project_with_different_phaseset'), 1);
                    }

                    $comptSummaryTasks++;
                }

                if ($comptSummaryTasks != $comptListPhases) {
                    throw new Exception(lang_strings('project_with_different_phaseset'), 1);
                }
            }

            foreach ($listTasks as $task) {
                $elements = $task->getElementsByTagName("UID");             // task uid
                $uid = $elements->item(0)->nodeValue;
                $fixd = enumFixedDuration::fdYes;                                             // fixed duration
                $elements = $task->getElementsByTagName("Name");            // task name
                $nm = $elements->item(0)->nodeValue;
                $tn = HtmlEntitiesNOD($nm);
                $elements = $task->getElementsByTagName("OutlineNumber");   // the exact position of a task in the outline
                $oln = $elements->item(0)->nodeValue;

                if ($projectDetail->pro_phase_set[0] != '0') {              // project with phase set
                    $pp = substr($oln, 0, strpos($oln, '.'));
                } else {
                    $pp = '0';
                }

                $elements = $task->getElementsByTagName("OutlineLevel");    // the level of a task in the project outline hierarchy
                $oll = $elements->item(0)->nodeValue;

                if ($oll == '0') {                                          // skip level 0 tasks
                    continue;
                }

                $lvl = intval($oll) - 1;
                $elements = $task->getElementsByTagName("Priority");        // task priority
                $pri = $elements->item(0)->nodeValue;

                if ($pri == 500) {
                    $pr = enumPriority::prMedium;
                } else if ($pri > 500) {
                    if ($pri == 900) {
                        $pr = enumPriority::prVeryHigh;
                    } else {
                        $pr = enumPriority::prHigh;
                    }
                } else {
                    if ($pri == 100) {
                        $pr = enumPriority::prVeryLow;
                    } else {
                        $pr = enumPriority::prLow;
                    }
                }

                $elements = $task->getElementsByTagName("Start");           // task start date
                $sd = $elements->item(0)->nodeValue;
                $sd = mktime(0, 0, 0, intval(substr($sd, 5, 2)), intval(substr($sd, 8, 2)), intval(substr($sd, 0, 4)));
                $elements = $task->getElementsByTagName("Finish");          // task due date
                $dd = $elements->item(0)->nodeValue;
                $dd = mktime(0, 0, 0, intval(substr($dd, 5, 2)), intval(substr($dd, 8, 2)), intval(substr($dd, 0, 4)));
                $elements = $task->getElementsByTagName("Duration");        // task duration
                $du = $elements->item(0)->nodeValue;
                $dua = preg_split('/[P|T|H|M|S]/', $du);
                $etm = ($dua[2]=='')?'0':$dua[2];                           // retrieve hours only
                $elements = $task->getElementsByTagName("Milestone");       // whether a task is a milestone
                $miles = enumMilestone::msNo;

                if ($elements->length > 0) {
                    $miles = ($elements->item(0)->nodeValue=='1')?enumMilestone::msYes:enumMilestone::msNo;
                }

                $elements = $task->getElementsByTagName("IsPublished");     // whether the task is published
                $pub = enumPublished::pbNo;

                if ($elements->length > 0) {
                    $pub = ($elements->item(0)->nodeValue=='1')?enumPublished::pbYes:enumPublished::pbNo;
                }

                $sta = 0;                                                   // sub-tasks count
                $resCount = 0;                                              // resources count

                if ($miles == enumMilestone::msNo) {
                    if ($listAssignments->length > 0) {
                        // resource counting
                        foreach ($listAssignments as $assignment) {
                            $elements = $assignment->getElementsByTagName("TaskUID");         // task uid
                            $taskuid = $elements->item(0)->nodeValue;

                            if ($taskuid == $uid) {
                                $resCount++;
                            }
                        }
                    }

                    // assignment time
                    if ($resCount == 0) {
                        $tasAssigned = '0';
                    } else {
                        $tasAssigned = time();
                    }

                    // check whether this is a task group
                    $needle = $oln . '.';

                    foreach ($listTasks as $subtask) {
                        $elements = $subtask->getElementsByTagName("OutlineNumber");   // the exact position of a task in the outline
                        $suboln = $elements->item(0)->nodeValue;
                        $elements = $subtask->getElementsByTagName("OutlineLevel");    // the level of a task in the project outline hierarchy
                        $suboll = $elements->item(0)->nodeValue;

                        if (($suboll==($oll+1)) && (strpos($suboln, $needle)===0)) {
                            $sta++;
                        }
                    }

                    $tg = ($sta==0)?enumTaskGroup::tgNo:enumTaskGroup::tgYes;

                    if ($tg == enumTaskGroup::tgYes) {
                        $taskGroups[] = $uid;
                    }
                } else {
                    $tg = enumTaskGroup::tgNo;
                }

                $tmpsql = "INSERT INTO " . $tablePrefix . "tasks (project,name,description,owner,assigned_to,status,priority,start_date,due_date,estimated_time,comments,published,parent_phase,completion,service,fixed_duration,milestone,type,task_group,level,parent_task,subtask,assigned,created,cuser) VALUES ('$id','$tn','','$idSession','$resCount','" . enumStatus::stNotStarted . "','$pr','$sd','$dd','$etm','','$pub','$pp','0','0','$fixd','$miles','99999','$tg','$lvl','0','$sta','$tasAssigned','" . time() . "','$idSession')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $num = $requestAct->newId("tasks");

                if ($tg == enumTaskGroup::tgYes) {
                    $taskGroupsN[] = $num;
                }

                if ($resCount == '0') {
                    $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('$num','$idSession','0','" . time() . "')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }

                $task2Task[$uid] = $num;
                $oln2Task[$oln] = $num;
            }
        }

        if ($listAssignments->length > 0) {
            // import task assignments
            foreach ($listAssignments as $assignment) {
                $elements = $assignment->getElementsByTagName("TaskUID");       // The unique ID for the task.
                $taskuid = $elements->item(0)->nodeValue;
                $elements = $assignment->getElementsByTagName("ResourceUID");   // The unique ID for the resource.
                $resuid = $elements->item(0)->nodeValue;

                if (!array_key_exists($taskuid, $task2Task)) {                  // check if the task is in the ms task uid <-> webTareas task id mapping table
                    continue;
                }

                $tas = $task2Task[$taskuid];                                    // webTareas task id

                if (array_key_exists($resuid, $res2mat)) {                      // material resource
                    $mat = $res2mat[$resuid];
                    $elements = $assignment->getElementsByTagName("Cost");      // The total scheduled (or projected) cost for an assignment.

                    if ($elements.length == 0) {
                        continue;
                    }

                    $qty = $elements->item(0)->nodeValue;

                    if (!is_numeric($qty) || floatval($qty) <= 0) {
                        continue;
                    }

                    $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_resource (task,resource,type,quantity,created,cuser) VALUES ('$tas','$mat','" . enumResourceType::rtMaterial . "','$qty','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num1 = $requestAct->newId('tasks_resource');
                    copy2HistoryTable($requestAct, 'tasks_resource', $num1, 'A');
                } else if (array_key_exists($resuid, $res2mem)) {               // work resource
                    $mem = $res2mem[$resuid];
                    $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('$tas','$idSession','$mem','" . time() . "')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_resource (task,resource,type,created,cuser) VALUES ('$tas','$mem','" . enumResourceType::rtUser . "','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num1 = $requestAct->newId('tasks_resource');
                    copy2HistoryTable($requestAct, 'tasks_resource', $num1, 'A');
                }
            }
        }

        if ($listTasks->length > 0) {
            // import task predecessors
            foreach ($listTasks as $task) {
                $elements = $task->getElementsByTagName("UID");             // task uid
                $uid = $elements->item(0)->nodeValue;

                if (in_array($uid, $taskGroups)) {                          // task group predecessor not support
                    continue;
                }

                $elements = $task->getElementsByTagName("OutlineLevel");    // the level of a task in the project outline hierarchy
                $oll = $elements->item(0)->nodeValue;

                if ($oll == '0') {                                          // skip level 0 tasks
                    continue;
                }

                $elements = $task->getElementsByTagName("PredecessorLink"); // task predecessor

                if ($elements->length == 0) {
                    continue;
                }

                foreach ($elements as $predecessor) {
                    $elements = $predecessor->getElementsByTagName("PredecessorUID");   // predecessor uid
                    $puid = $elements->item(0)->nodeValue;

                    if (in_array($puid, $taskGroups)) {                     // task group predecessor not support
                        continue;
                    }

                    $elements = $predecessor->getElementsByTagName("Type"); // predecessor type
                    $ty = $elements->item(0)->nodeValue;

                    switch ($ty) {
                        case '0':           // finish-to-finish
                            $ty = 'FF';
                            break;
                        case '1':           // finish-to-start
                            $ty = 'FS';
                            break;
                        case '2':           // start-to-finish
                            $ty = 'SF';
                            break;
                        case '3':           // start-to-start
                            $ty = 'SS';
                            break;
                    }

                    if ($task2Task[$uid] != '' && $task2Task[$puid] != '') {
                        $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_predecessor (task,predecessor,type,lag,created,cuser) VALUES('" . $task2Task[$uid] . "','" . $task2Task[$puid] . "','$ty','0','" . time() . "','$idSession')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $num2 = $requestAct->newId('tasks_predecessor');
                        copy2HistoryTable($requestAct, 'tasks_predecessor', $num2, 'A');
                    }
                }
            }

            // update parent task id
            foreach ($listTasks as $task) {
                $elements = $task->getElementsByTagName("UID");             // task uid
                $uid = $elements->item(0)->nodeValue;
                $elements = $task->getElementsByTagName("OutlineLevel");    // the level of a task in the project outline hierarchy
                $oll = $elements->item(0)->nodeValue;

                if ($oll == '0' || $oll == '1') {                           // skip level 0,1 tasks
                    continue;
                }

                $elements = $task->getElementsByTagName("OutlineNumber");   // the exact position of a task in the outline
                $oln = $elements->item(0)->nodeValue;
                $poln = substr($oln, 0, strrpos($oln, "."));                // the exact position of the parent task

                if ($oln2Task[$poln] != '' && $task2Task[$uid] != '') {
                    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET parent_task='" . $oln2Task[$poln] . "' WHERE id='" . $task2Task[$uid] . "'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }

            // update task groups estimated time
            if (count($taskGroupsN) > 0) {
                $querymore = " WHERE tas.id IN ('" . implode("','", $taskGroupsN) . "') ORDER BY tas.level DESC";
                $listTaskGroups = clone $requestAct;
                $listTaskGroups->openTasks($querymore);
                $comptListTaskGroups = count($listTaskGroups->tas_id);

                for ($i=0; $i<$comptListTaskGroups; $i++) {
                    $tmpquery = "SELECT SUM(estimated_time) FROM " . $tablePrefix . "tasks WHERE project='$id' AND parent_task='" . $listTaskGroups->tas_id[$i] . "'";
                    $request1 = clone $requestAct;
                    $request1->query($tmpquery);
                    $etm = '0';

                    if ($request1->fetch()) {
                        $etm = $row[0];
                    }

                    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET estimated_time='$etm' WHERE id='" . $listTaskGroups->tas_id[$i] . "'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }
        }

        if (count($oln2Task) > 0) {
            $ids = implode(',', $oln2Task);
            copy2HistoryTable($requestAct, 'tasks', $ids, 'A');
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        if ($e->getCode() === 1) {
            $error = $e->getMessage();
        } else {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
        }

        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../projects/viewproject.php?id=$id&msg=add" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php?' . $urlBornes, lang_strings('projects'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("import_project"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "imP";
$block1->openForm("../projects/importproject.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="import">';
$block1->heading(lang_strings("import_project"));
$block1->openContent();
$block1->contentRow("*&nbsp;" . lang_strings("upload"), setupUploadFileHTML('1', '.xml', true));
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["import"] . "\">");
$block1->closeContent();
$block1->note(lang_strings('importproject_help'));
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
