<?php // $Revision: 1.24 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listprojects.php,v 1.24 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$show = isset($_GET['show'])?$_GET['show']:enumProjectStatus::stOpen;
$client = AddSlashesNOD(isset($_GET['client'])?$_GET['client']:'');
$cview = isset($_GET['cview'])?$_GET['cview']:'';
$datefrom = isset($_GET['datefrom'])?$_GET['datefrom']:'';
$dateto = isset($_GET['dateto'])?$_GET['dateto']:'';
$cstatus = isset($_GET['cstatus'])?$_GET['cstatus']:'';
$cnum = isset($_GET['cnum'])?$_GET['cnum']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Project']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Load data
 */
if ($client != '' && $cstatus != '' && $cnum != '') {
    $tmpquery = " WHERE org.id='" . $client . "'";
    $clientDetail = new request();
    $clientDetail->openOrganizations($tmpquery);
    $comptClientDetail = count($clientDetail->org_id);

    if ($comptClientDetail == '0') {
        header('Location: ../clients/listclients.php?msg=blankClient');
        exit;
    }

    $show = 'client';
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs(lang_strings('projects'));

if ($show == 'client') {
    if ($cstatus == 'open') {
        $blockPage->itemBreadcrumbs(lang_strings('client') . '&nbsp;' . $clientDetail->org_name[0] . '&nbsp;' . lang_strings($cstatus) . ' (' . $cnum . ')');
    } else {
        $blockPage->itemBreadcrumbs(lang_strings('client') . '&nbsp;' . $clientDetail->org_name[0] . '&nbsp;' . lang_strings($cstatus) . '&nbsp;' . lang_strings($cview) . ' (' . $cnum . ')');
    }

    $title = $strings['projects'] . ' (' . $strings['client'] . ' ' . $clientDetail->org_name[0] . ') : ' . $strings[$cstatus];
} else {
    switch ($show) {
        case 'all':
            $blockPage->itemBreadcrumbs(lang_strings('all'));
            $title = $strings['projects'] . ' : ' . $strings['all'];
            break;
        case enumProjectStatus::stInitiation:
            $blockPage->itemBreadcrumbs(lang_strings('initiation'));
            $title = $strings['projects'] . ' : ' . $strings['initiation'];
            break;
        case enumProjectStatus::stCanceled:
            $blockPage->itemBreadcrumbs(lang_strings('canceled'));
            $title = $strings['projects'] . ' : ' . $strings['canceled'];
            break;
        case enumProjectStatus::stPlanning:
            $blockPage->itemBreadcrumbs(lang_strings('planning'));
            $title = $strings['projects'] . ' : ' . $strings['planning'];
            break;
        case enumProjectStatus::stOpen:
            $blockPage->itemBreadcrumbs(lang_strings('open'));
            $title = $strings['projects'] . ' : ' . $strings['open'];
            break;
        case enumProjectStatus::stCompleted:
            $blockPage->itemBreadcrumbs(lang_strings('completed'));
            $title = $strings['projects'] . ' : ' . $strings['completed'];
            break;
        case enumProjectStatus::stSuspended:
            $blockPage->itemBreadcrumbs(lang_strings('suspended'));
            $title = $strings['projects'] . ' : ' . $strings['suspended'];
            break;
    }
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
logURL($title, '../projects/listprojects.php?show=' . $show . '&cstatus=' . $cstatus);
$block1 = new block();
$block1->openHeading(lang_strings('projects'));
$block1->openViewOptions();

foreach (array('all' => lang_strings('all'), enumProjectStatus::stInitiation => lang_strings('initiation'), enumProjectStatus::stCanceled => lang_strings('canceled'), enumProjectStatus::stPlanning => lang_strings('planning'), enumProjectStatus::stOpen => lang_strings('open'), enumProjectStatus::stCompleted => lang_strings('completed'), enumProjectStatus::stSuspended => lang_strings('suspended')) as $i => $x) {
    if ($i != $show) {
        $block1->itemViewOptions($block1->buildLink('../projects/listprojects.php?show=' . $i, $x, 'in'));
    }
}

$block1->closeViewOptions();
$block1->closeHeading();
$block1->form = 'saP';
$block1->openForm('../projects/listprojects.php?show=' . $show . '&cstatus=' . $cstatus . '#' . $block1->form . 'Anchor');
$block1->borne = $blockPage->returnBorne('1');
$block1->rowsLimit = 12;
$block1->sorting('projects', (isset($sortingUser['projects'])?$sortingUser['projects']:''), 'pro.name ASC', $sortingFields = array(0 => 'pro.id', 1 => 'pro.name', 2 => 'pro.priority', 3 => 'org.name', 4 => 'pro.status', 5 => 'mem.name'));

if ($projectsFilter == 'true' && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    switch ($show) {
        case 'all':
            $tmpquery = ' LEFT OUTER JOIN ' . $tablePrefix . 'teams tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tablePrefix . 'project_permissions prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE tea.member=' . $idSession . " AND prp.view_project='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
            break;
        case enumProjectStatus::stInitiation:
            $tmpquery = ' LEFT OUTER JOIN ' . $tablePrefix . 'teams tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tablePrefix . "project_permissions prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . enumProjectStatus::stInitiation . "' AND tea.member=$idSession AND prp.view_project='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
            break;
        case enumProjectStatus::stCanceled:
            $tmpquery = ' LEFT OUTER JOIN ' . $tablePrefix . 'teams tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tablePrefix . "project_permissions prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . enumProjectStatus::stCanceled . "' AND tea.member=$idSession AND prp.view_project='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
            break;
        case enumProjectStatus::stPlanning:
            $tmpquery = ' LEFT OUTER JOIN ' . $tablePrefix . 'teams tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tablePrefix . "project_permissions prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . enumProjectStatus::stPlanning . "' AND tea.member=$idSession AND prp.view_project='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
            break;
        case enumProjectStatus::stOpen:
            $tmpquery = ' LEFT OUTER JOIN ' . $tablePrefix . 'teams tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tablePrefix . "project_permissions prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . enumProjectStatus::stOpen . "' AND tea.member=$idSession AND prp.view_project='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
            break;
        case enumProjectStatus::stCompleted:
            $tmpquery = ' LEFT OUTER JOIN ' . $tablePrefix . 'teams tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tablePrefix . "project_permissions prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . enumProjectStatus::stCompleted . "' AND tea.member=$idSession AND prp.view_project='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
            break;
        case enumProjectStatus::stSuspended:
            $tmpquery = ' LEFT OUTER JOIN ' . $tablePrefix . 'teams tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tablePrefix . "project_permissions prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.status='" . enumProjectStatus::stSuspended . "' AND tea.member=$idSession AND prp.view_project='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
            break;
        case 'client':
            if ($cstatus == 'open') {
                $tmpquery = ' LEFT OUTER JOIN ' . $tablePrefix . 'teams tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tablePrefix . "project_permissions prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.organization=$client AND pro.status='" . enumProjectStatus::stOpen . "' AND tea.member=$idSession AND prp.view_project='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
            } else {
                $tmpquery = ' LEFT OUTER JOIN ' . $tablePrefix . 'teams tea ON tea.project=pro.id LEFT OUTER JOIN ' . $tablePrefix . "project_permissions prp ON prp.project=pro.id AND prp.profil=tea.profil WHERE pro.organization=$client AND pro.complete_date>='$datefrom' AND pro.complete_date<='$dateto' AND pro.status='" . enumProjectStatus::stCompleted . "' AND tea.member=$idSession AND prp.view_project='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
            }

            break;
    }
} else {
    switch ($show) {
        case 'all':
            $tmpquery = ' ORDER BY ' . $block1->sortingValue;
            break;
        case enumProjectStatus::stInitiation:
            $tmpquery = " WHERE pro.status='" . enumProjectStatus::stInitiation . "' ORDER BY " . $block1->sortingValue;
            break;
        case enumProjectStatus::stCanceled:
            $tmpquery = " WHERE pro.status='" . enumProjectStatus::stCanceled . "' ORDER BY " . $block1->sortingValue;
            break;
        case enumProjectStatus::stPlanning:
            $tmpquery = " WHERE pro.status='" . enumProjectStatus::stPlanning . "' ORDER BY " . $block1->sortingValue;
            break;
        case enumProjectStatus::stOpen:
            $tmpquery = " WHERE pro.status='" . enumProjectStatus::stOpen . "' ORDER BY " . $block1->sortingValue;
            break;
        case enumProjectStatus::stCompleted:
            $tmpquery = " WHERE pro.status='" . enumProjectStatus::stCompleted . "' ORDER BY " . $block1->sortingValue;
            break;
        case enumProjectStatus::stSuspended:
            $tmpquery = " WHERE pro.status='" . enumProjectStatus::stSuspended . "' ORDER BY " . $block1->sortingValue;
            break;
        case 'client':
            if ($cstatus == 'open') {
                $tmpquery = " WHERE pro.organization=$client AND pro.status='" . enumProjectStatus::stOpen . "' ORDER BY " . $block1->sortingValue;
            } else {
                $tmpquery = " WHERE pro.organization=$client AND pro.complete_date>='$datefrom' AND pro.complete_date<='$dateto' AND pro.status='" . enumProjectStatus::stCompleted . "' ORDER BY " . $block1->sortingValue;
            }

            break;
    }
}

$recordsTotal = compt($initrequest['projects'] . $tmpquery);
$block1->recordsTotal = $recordsTotal;
$listProjects = new request();
$listProjects->openProjects($tmpquery, $block1->borne, $block1->rowsLimit);
$comptListProjects = count($listProjects->pro_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['id'];
$columns[0]->field_type = enumFieldType::ftNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['name'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['priority'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['status'];
$columns[3]->field_type = enumFieldType::ftText;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['owner'];
$columns[4]->field_type = enumFieldType::ftNumeric;
$columns[4]->linked_table = 'members';
$opt = array();
$opt[enumCardviewOption::oObject] = 'projects';
$opt[enumCardviewOption::oTableName] = 'projects';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;
$opt[enumCardviewOption::oMultipleSelection] = false;
$opt[enumCardviewOption::oExtraParameters] = 'borne1=' . $block1->borne;

if ($SW_Permissions['Project']['Write'][$profilSession]) {
    if ($show == 'client') {
        $opt[enumCardviewOption::oAddUrl] = '../projects/editproject.php?organization=' . $clientDetail->org_id[0];
    } else {
        $opt[enumCardviewOption::oAddUrl] = '../projects/editproject.php';
    }
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListProjects; $i++) {
    $idStatus = $listProjects->pro_status[$i];
    $idPriority = $listProjects->pro_priority[$i];
    $content = array(
        $listProjects->pro_id[$i],
        $listProjects->pro_name[$i],
        $priority[$idPriority],
        $statusProject[$idStatus],
        $listProjects->pro_owner[$i]
    );
    $block1->itemCardView($listProjects->pro_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter(1, $blockPage->bornesNumber, 'show=' . $show);
$block1->closeFormResults();
require_once('../includes/footer.php');
