<?php // $Revision: 1.79 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewproject.php,v 1.79 2013/02/09 06:36:53 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$taskgroupList = array();
$id = AddSlashesNOD(isset($_REQUEST['id'])?$_REQUEST['id']:'');     // project id
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';                         // message
$base = isset($_GET['base'])?$_GET['base']:'1';                     // gantt chart mode
$num = isset($_GET['num'])?$_GET['num']:'';
$gantt_sd = isset($_GET['gantt_sd'])?$_GET['gantt_sd']:'';
$error = isset($_GET['error'])?$_GET['error']:'';                   // error message
$ids = "'" . str_replace("**", "','", $id) . "'";
$action = isset($_GET['action'])?$_GET['action']:'';                // action
$showNext = '';

if ($action != '') {
    $project = AddSlashesNOD($_GET['project']);                // project id
    $closeTopic = isset($_GET['closeTopic'])?$_GET['closeTopic']:'';                                    // close a topic
    $addToSiteTask = isset($_GET['addToSiteTask'])?$_GET['addToSiteTask']:'';                           // publish a task
    $removeToSiteTask = isset($_GET['removeToSiteTask'])?$_GET['removeToSiteTask']:'';                  // un-publish a task
    $addToSiteTopic = isset($_GET['addToSiteTopic'])?$_GET['addToSiteTopic']:'';                        // publish a topic
    $removeToSiteTopic = isset($_GET['removeToSiteTopic'])?$_GET['removeToSiteTopic']:'';               // un-publish a topic
    $addToSiteTeam = isset($_GET['addToSiteTeam'])?$_GET['addToSiteTeam']:'';                           // publish a team member
    $removeToSiteTeam = isset($_GET['removeToSiteTeam'])?$_GET['removeToSiteTeam']:'';                  // un-publish a team member
    $addToSiteFile = isset($_GET['addToSiteFile'])?$_GET['addToSiteFile']:'';                           // publish a file
    $removeToSiteFile = isset($_GET['removeToSiteFile'])?$_GET['removeToSiteFile']:'';                  // un-publish a file
    $addToSiteNote = isset($_GET['addToSiteNote'])?$_GET['addToSiteNote']:'';                           // publish a note
    $removeToSiteNote = isset($_GET['removeToSiteNote'])?$_GET['removeToSiteNote']:'';                  // un-publish a note
}

/**
 * Permission check
 */
if (!$SW_Permissions['Project']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($action == 'publish') {
    $querymore = " WHERE pro.id='$project'";
} else {
    $querymore = " WHERE pro.id='$id'";
}
// check if the project exists
$projectDetail = new request();
$projectDetail->openProjects($querymore);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

// check if the user is a team member of this project
$querymore = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

// load project permission matrix and check the users permission
$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($action == 'publish') {
    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    if ($closeTopic == 'true') {
        if ($permissionDetail->prp_close_discussion_topic[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else if ($addToSiteTask == 'true') {
        if ($permissionDetail->prp_publish_task[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else if ($removeToSiteTask == 'true') {
        if ($permissionDetail->prp_publish_task[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else if ($addToSiteTopic == 'true') {
        if ($permissionDetail->prp_publish_discussion_topic[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else if ($removeToSiteTopic == 'true') {
        if ($permissionDetail->prp_publish_discussion_topic[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else if ($addToSiteTeam == 'true') {
        if ($permissionDetail->prp_publish_team_member[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else if ($removeToSiteTeam == 'true') {
        if ($permissionDetail->prp_publish_team_member[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else if ($addToSiteFile == 'true') {
        if ($permissionDetail->prp_publish_file[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else if ($removeToSiteFile == 'true') {
        if ($permissionDetail->prp_publish_file[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else if ($addToSiteNote == 'true') {
        if ($permissionDetail->prp_publish_note[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    } else if ($removeToSiteNote == 'true') {
        if ($permissionDetail->prp_publish_note[0] != enumBoolean::bTrue) {
            header('Location: ../general/permissiondenied.php');
            exit;
        }
    }

    if ($permissionDetail->prp_view_project[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Admin'][$profilSession]) {
        if ($projectsFilter == 'true') {
            header('Location: ../general/permissiondenied.php');
            exit;
        } else {
            header("Location: ../teams/joinprojectteam.php?project=$project");
            exit;
        }
    }
} else {
    if ($permissionDetail->prp_view_project[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Admin'][$profilSession]) {
        if ($projectsFilter == 'true') {
            header('Location: ../general/permissiondenied.php');
            exit;
        } else {
            header("Location: ../teams/joinprojectteam.php?project=$id");
            exit;
        }
    }
}

/**
 * Functions
 */
function add_taskgroup_to_changelist($requestAct, $parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList)) {
        return;
    }

    $taskgroupList[$parent] = $level;
    $querymore = " WHERE tas.id='$parent'";
    $parentDetail = clone $requestAct;
    $parentDetail->openTasks($querymore);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($requestAct, $parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

function change_parent_task($requestAct, $parent)
{
    global $tablePrefix,$idSession;
    $querymore = " WHERE tas.parent_task='$parent'";
    $subtaskList = clone $requestAct;
    $subtaskList->openTasks($querymore);
    $newSubtask = count($subtaskList->tas_id);
    $newPriority = 0;
    $newStatus = '';
    $newCompletion = 0;
    $newStartDate = 0;
    $newDueDate = 0;
    $newEstimatedTime = 0;
    $newActualTime = 0;
    $newCompleteDate = 0;
    $newPublished = enumPublished::pbNo;

    for ($i = 0;$i < $newSubtask;$i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }

            if ($status == enumStatus::stNotStarted || $newStatus == enumStatus::stNotStarted) {
                $newStatus = enumStatus::stNotStarted;
            } else if ($status == enumStatus::stOpen || $newStatus == enumStatus::stOpen) {
                $newStatus = enumStatus::stOpen;
            } else if ($status == enumStatus::stSuspended || $newStatus == enumStatus::stSuspended) {
                $newStatus = enumStatus::stSuspended;
            } else if ($status == enumStatus::stClientCompleted || $newStatus == enumStatus::stClientCompleted) {
                $newStatus = enumStatus::stClientCompleted;
            }

            $newCompletion += $completion;

            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }

            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }

            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = 0;
            }

            if ($published == enumPublished::pbYes) {
                $newPublished = enumPublished::pbYes;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = 0;
            }

            $newPublished = $published;
        }
    }

    $newCompletion1 = substr($newCompletion / $newSubtask, 0, 1);
    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET priority='$newPriority', status='$newStatus', completion='$newCompletion1', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', task_group='" . enumTaskGroup::tgYes . "', subtask='$newSubtask', modified='" . time() . "', muser='$idSession' WHERE id='$parent'";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }
}

// get Upload Dir
function getUploadDir($fid)
{
    $querymore = " WHERE fil.id='$fid'";
    $fileDetail = new request();
    $fileDetail->openFiles($querymore);

    if ($fileDetail->fil_parent[0] == '0') {
        return '/' . $fileDetail->fil_name[0];
    } else {
        return getUploadDir($fileDetail->fil_parent[0]) . '/' . $fileDetail->fil_name[0];
    }
}

/**
 * Actions
 */
if ($action == 'publish') {
    if ($closeTopic == 'true') {
        /**
         * close discussion action
         */
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = 'UPDATE ' . $tablePrefix . "topics SET status='0' WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = 'closeTopic';
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    } else if ($addToSiteTask == 'true') {
        /**
         * publish task action
         */
        $criticalSection = enter_critical_section();

        if ($criticalSection == -1) {
            header("Location: ../tasks/viewproject.php?id=$id&msg=$msg");
            exit;
        }

        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = 'UPDATE ' . $tablePrefix . "tasks SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $querymore = " WHERE tas.id IN ($ids)";
            $listTasks = clone $requestAct;
            $listTasks->openTasks($querymore);
            $comptListTasks = count($listTasks->tas_id);

            for ($i=0; $i<$comptListTasks; $i++) {
                add_taskgroup_to_changelist($requestAct, $listTasks->tas_parent_task[$i], $listTasks->tas_level[$i]);
            }

            if (count($taskgroupList) > 0) {
                arsort($taskgroupList, SORT_NUMERIC);
                reset($taskgroupList);

                while (list($parentTask, $level) = each($taskgroupList)) {
                    change_parent_task($requestAct, $parentTask);
                }
            }

            $msg = 'addToSite';
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
        leave_critical_section($criticalSection);
    } else if ($removeToSiteTask == 'true') {
        /**
         * un-publish task action
         */
        $criticalSection = enter_critical_section();

        if ($criticalSection == -1) {
            header("Location: ../tasks/viewproject.php?id=$id&msg=$msg");
            exit;
        }

        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = 'UPDATE ' . $tablePrefix . "tasks SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $querymore = " WHERE tas.id IN ($ids)";
            $listTasks = clone $requestAct;
            $listTasks->openTasks($querymore);
            $comptListTasks = count($listTasks->tas_id);

            for ($i=0; $i<$comptListTasks; $i++) {
                add_taskgroup_to_changelist($requestAct, $listTasks->tas_parent_task[$i], $listTasks->tas_level[$i]);
            }

            if (count($taskgroupList) > 0) {
                arsort($taskgroupList, SORT_NUMERIC);
                reset($taskgroupList);

                while (list($parentTask, $level) = each($taskgroupList)) {
                    change_parent_task($requestAct, $parentTask);
                }
            }

            $msg = 'removeToSite';
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
        leave_critical_section($criticalSection);
    } else if ($addToSiteTopic == 'true') {
        /**
         * publish discussion action
         */
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = 'UPDATE ' . $tablePrefix . "topics SET published='" . enumPublished::pbYes . "' WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = 'addToSite';
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    } else if ($removeToSiteTopic == 'true') {
        /**
         * un-publish discussion action
         */
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = 'UPDATE ' . $tablePrefix . "topics SET published='" . enumPublished::pbNo . "' WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = 'removeToSite';
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    } else if ($addToSiteTeam == 'true') {
        /**
         * publish team member action
         */
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = 'UPDATE ' . $tablePrefix . "teams SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids) AND project='$project'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'teams', $ids, 'U');
            $msg = 'addToSite';
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    } else if ($removeToSiteTeam == 'true') {
        /**
         * un-publish team member action
         */
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = 'UPDATE ' . $tablePrefix . "teams SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids) AND project='$project'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'teams', $ids, 'U');
            $msg = 'removeToSite';
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    } else if ($addToSiteFile == 'true') {
        /**
         * publish linked content action
         */
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = 'UPDATE ' . $tablePrefix . "files SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids) OR vc_parent IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = 'addToSite';
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    } else if ($removeToSiteFile == 'true') {
        /**
         * un-publish linked content action
         */
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = 'UPDATE ' . $tablePrefix . "files SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids) OR vc_parent IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = 'removeToSite';
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    } else if ($addToSiteNote == 'true') {
        /**
         * publish note action
         */
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = 'UPDATE ' . $tablePrefix . "notes SET published='". enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = 'addToSite';
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    } else if ($removeToSiteNote == 'true') {
        /**
         * un-publish note action
         */
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = 'UPDATE ' . $tablePrefix . "notes SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $msg = 'removeToSite';
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    }

    $id = $project;
}

/**
 * Prepare data
 */
$querymore = " WHERE tas.project='" . $projectDetail->pro_id[0] . "' AND tas.milestone<>'" . enumMilestone::msYes . "' AND tas.level='0' ORDER BY tas.name";
$listTasksTime = new request();
$listTasksTime->openTasks($querymore);
$comptListTasksTime = count($listTasksTime->tas_id);
$estimated_time = 0;

if ($comptListTasksTime > 0) {
    for ($i = 0; $i < $comptListTasksTime; $i++) {
        $estimated_time += $listTasksTime->tas_estimated_time[$i];
    }
}

// get Project Actual Time
$projActualTime = new request();
$proj_time = $projActualTime->getProjectTime($id);
// Project Scope Creep
$diff_time = $proj_time - $estimated_time ;

if ($diff_time > 0) {
    $diff_time = '<b>+' . $diff_time . '</b>';
}

if ($enableHelpSupport == 'true') {
    $querymore = " WHERE sr.status='" . enumRequestStatus::stNew . "' AND sr.project='" . $projectDetail->pro_id[0] . "'";
    $listNewRequests = new request();
    $listNewRequests->openSupportRequests($querymore);
    $comptListNewRequests = count($listNewRequests->sr_id);
    $querymore = " WHERE sr.status='" . enumRequestStatus::stOpen . "' AND sr.project='" . $projectDetail->pro_id[0] . "'";
    $listOpenRequests = new request();
    $listOpenRequests->openSupportRequests($querymore);
    $comptListOpenRequests = count($listOpenRequests->sr_id);
    $querymore = " WHERE sr.status='" . enumRequestStatus::stCompleted . "' AND sr.project='" . $projectDetail->pro_id[0] . "'";
    $listCompleteRequests = new request();
    $listCompleteRequests->openSupportRequests($querymore);
    $comptListCompleteRequests = count($listCompleteRequests->sr_id);
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php?' . $urlBornes, lang_strings('projects'), 'in'));
$blockPage->itemBreadcrumbs($projectDetail->pro_name[0]);
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '9';     // 1st for listprojects
$title = $strings['project'] . ' : ' . $projectDetail->pro_name[0];
logURL($title, '../projects/viewproject.php?id=' . $projectDetail->pro_id[0]);
$idStatus = $projectDetail->pro_status[0];
$idPriority = $projectDetail->pro_priority[0];
$block1 = new block();
$block1->form = 'pdD';
$block1->openForm('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes . '#' . $block1->form . 'Anchor');
$block1->headingToggle($strings['project'], !($toggle_focus==''));
$block1->openPaletteIcon();

if ($projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_delete_project[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteIcon(0, 'remove', $strings['delete']);
    }
}

if ($permissionDetail->prp_copy_project[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, 'copy', $strings['copy']);
}

if ($projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_import_project[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteIcon(9, 'import', $strings['import']);
    }
}

if ($permissionDetail->prp_export_project[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(2, 'export', $strings['export']);
}

if ($projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_modify_project_properties[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteIcon(3, 'edit', $strings['edit']);
    }
}

$block1->paletteIcon(5, 'bug', $strings['support_requests']);

if ($idSession == $projectDetail->pro_owner[0] || $SW_Permissions['Project']['Admin'][$profilSession]) {
    $block1->paletteIcon(6, 'lock', $strings['permissions']);
}

$block1->paletteIcon(7, 'calendar', $strings['calendar']);

if ($permissionDetail->prp_view_project_budget[0] == enumBoolean::bTrue || $permissionDetail->prp_view_project_cost[0] == enumBoolean::bTrue || $permissionDetail->prp_view_expense[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteIcon(8, 'account', $strings['project_accounting']);
}

$block1->paletteIcon(99, 'search', 'projects');
$block1->closePaletteIcon();
$block1->openContent(true);
$block1->contentRow(lang_strings('name'), $projectDetail->pro_name[0]);
$block1->contentRow(lang_strings('project_id'), $projectDetail->pro_id[0]);

if ($idPriority != enumPriority::prNone) {
    $block1->contentRow(lang_strings('priority'), $priority[$idPriority]);
}

// List open phases and link to phase details
if ($projectDetail->pro_phase_set[0] != '0') {
    $querymore = " WHERE pha.project='" . $projectDetail->pro_id[0] . "' AND status='" . enumPhaseStatus::stOpen . "' ORDER BY pha.order_num";
    $currentPhase = new request();
    $currentPhase->openPhases($querymore);
    $comptCurrentPhase = count($currentPhase->pha_id);

    if ($comptCurrentPhase == 0) {
        $block1->contentRow(lang_strings('current_phase'), lang_strings('no_current_phase'));
    } else {
        for ($i = 0; $i < $comptCurrentPhase; $i++) {
            if ($i != $comptCurrentPhase) {
                $pnum = $i + 1;
                $phasesList .= "$pnum.<a href=\"../phases/viewphase.php?id=" . $currentPhase->pha_id[$i] . '">' . $currentPhase->pha_description[$i] . '</a>  ';
            }
        }

        $block1->contentRow(lang_strings('current_phase'), $phasesList);
    }
}

$block1->contentRow(lang_strings('description'), $projectDetail->pro_description[0]);
$block1->contentRow(lang_strings('owner'), $blockPage->buildLink($projectDetail->pro_mem_id[0], '', 'message'));
$block1->contentRow(lang_strings('created'), createDate($projectDetail->pro_created[0],'both'));

if ($projectDetail->pro_modified[0] != '0') {
    $block1->contentRow(lang_strings('modified'), createDate($projectDetail->pro_modified[0],'both'));
}

if ($projectDetail->pro_org_id[0] != '1') {
    $block1->contentRow(lang_strings('organization'), $blockPage->buildLink('../clients/viewclient.php?id=' . $projectDetail->pro_org_id[0], $projectDetail->pro_org_name[0], 'in'));
}

$block1->contentRow(lang_strings('status'), $statusProject[$idStatus]);
$block1->contentRow(lang_strings('type'), $projectType[$projectDetail->pro_type[0]]);
$block1->contentRow(lang_strings('workcalendar'), $blockPage->buildLink('../workcalendars/viewworkcalendar.php?id=' . $projectDetail->pro_workcalendar[0], $projectDetail->pro_wca_name[0], 'in'));

if ($fileManagement == 'true') {
    $request1 = new request();
    $request1->openProjectFolderSize($id);
    $project_folder_size = $request1->project_folder_size;

    if ($project_folder_size > 0) {
        $exportLink = "&nbsp;&nbsp;" . $blockPage->buildLink('../projects/accessfiles.php?zipfile=project&project=' . $projectDetail->pro_id[0] . '&folder=' . $projectDetail->pro_upload_dir[0], lang_strings('export'), 'in');
    } else {
        $exportLink = '';
    }

    $block1->contentRow(lang_strings('upload_filepath'), $blockPage->buildLink('../linkedcontent/listfiles.php?id=' . $projectDetail->pro_upload_dir[0], getUploadDir($projectDetail->pro_upload_dir[0]), 'in') . $exportLink);
    $block1->contentRow(lang_strings('project_folder_size') . $blockPage->printHelp('project_disk_space'), convertSize($project_folder_size));
}

$block1->contentRow(lang_strings('estimated_time'), $estimated_time . ' ' . lang_strings('hours'));
$block1->contentRow(lang_strings('actual_time'), $proj_time . ' ' . lang_strings('hours'));
$block1->contentRow(lang_strings('scope_creep') . $blockPage->printHelp('project_scope_creep'), $diff_time . ' ' . lang_strings('hours'));
setupCustomFieldsHTML($block1, 'projects', $projectDetail->pro_id[0]);

if ($sitePublish == 'true' && $projectDetail->pro_org_id[0] != '1') {
    if ($projectDetail->pro_published[0] != enumPublished::pbYes) {
        $block1->contentRow(lang_strings('customer_service_site'), '&lt;' . $blockPage->buildLink('../projects/addservicesite.php?id=' . $projectDetail->pro_id[0] . $urlBornes, lang_strings('create') . '...', 'in') . '&gt;');
    } else {
        $block1->contentRow(lang_strings('customer_service_site'), '&lt;' . $blockPage->buildLink('../projects/viewservicesite.php?id=' . $projectDetail->pro_id[0] . $urlBornes, lang_strings('details'), 'in') . '&gt;');
    }
}

$block1->closeContent();
$block1->closeToggle();

if ($SW_Permissions['Project']['Admin'][$profilSession] || ($enableHelpSupport == 'true' && $permissionDetail->prp_view_support_request[0] == enumBoolean::bTrue)) {
    $block1->headingToggle(lang_strings('support'), !($toggle_focus=='support'));
    $block1->openContent();
    $block1->contentRow(lang_strings('new_requests'), $comptListNewRequests . ' - ' . $blockPage->buildLink('../support/support.php?action=new&project=' . $projectDetail->pro_id[0] . $urlBornes, lang_strings('manage_new_requests'), 'in'));
    $block1->contentRow(lang_strings('open_requests'), $comptListOpenRequests . ' - ' . $blockPage->buildLink('../support/support.php?action=open&project=' . $projectDetail->pro_id[0] . $urlBornes, lang_strings('manage_open_requests'), 'in'));
    $block1->contentRow(lang_strings('closed_requests'), $comptListCompleteRequests . ' - ' . $blockPage->buildLink('../support/support.php?action=complete&project=' . $projectDetail->pro_id[0] . $urlBornes, lang_strings('manage_closed_requests'), 'in'));
    $block1->closeContent();
    $block1->closeToggle();
}

$querymore = " WHERE tas.project='" . $projectDetail->pro_id[0] . "' AND tas.milestone='" . enumMilestone::msYes . "' AND tas.due_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y'))) . "' AND tas.status<>'" . enumStatus::stCompleted . "' ORDER BY tas.due_date";
$listLate = new request();
$listLate->openTasks($querymore);
$comptListLate = count($listLate->tas_id);
$querymore = " WHERE tas.project='" . $projectDetail->pro_id[0] . "' AND tas.milestone='" . enumMilestone::msYes . "' AND tas.due_date>='" . mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y'))) . "' AND tas.status<>'" . enumStatus::stCompleted . "' ORDER BY tas.due_date";
$listUpcoming = new request();
$listUpcoming->openTasks($querymore, 0, 1);
$comptListUpcoming = count($listUpcoming->tas_id);

if ($comptListLate != '0' || $comptListUpcoming != '0') {
    $block1->headingToggle(lang_strings('milestones'), !($toggle_focus=='mile'));
    $block1->openContent();
    $lateContent = '';
    $upcomingContent = '';

    if ($comptListLate != '0') {
        for ($i=0; $i<$comptListLate; $i++) {
            $lateContent .= '<div class="clear"><div class="left">' . $blockPage->buildLink('../tasks/viewtask.php?id=' . $listLate->tas_id[$i], $listLate->tas_name[$i], 'in') . '</div>';
            $days = diff_date(time(), $listLate->tas_due_date[$i]) - 1;
            $lateContent .= '<div class="left overdue">&nbsp;&nbsp;';

            if ($days == '1') {
                $lateContent .= lang_strings('daylate1');
            } else {
                $lateContent .= str_replace('%N%', $days, $strings['daylaten']);
            }

            $lateContent .= '</div>';
        }

        $block1->contentRow(lang_strings('late'), $lateContent);
    }

    if ($comptListUpcoming != '0') {
        $upcomingContent .= $blockPage->buildLink('../tasks/viewtask.php?id=' . $listUpcoming->tas_id[0], $listUpcoming->tas_name[0], 'in');
        $days = diff_date($listUpcoming->tas_due_date[0], time()) - 1;
        $upcomingContent .= "&nbsp;&nbsp;<b>";

        if ($days == '0') {
            $upcomingContent .= lang_strings('due_today');
        } else if ($days == '1') {
            $upcomingContent .= lang_strings('due_in_1_day');
        } else {
            $upcomingContent .= str_replace('%N%', $days, $strings['due_in_n_days']);
        }

        $upcomingContent .= '</b>';
        $block1->contentRow(lang_strings('upcoming'), $upcomingContent);
    }

    $block1->closeContent();
    $block1->closeToggle();
}

$querymore0 = " WHERE dap.docid='" . $projectDetail->pro_id[0] . "' AND dap.doctype='projects' ORDER BY dap.id";
$listDocumentsApproval = new request();
$listDocumentsApproval->openDocumentsApproval($querymore0);
$comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

if ($comptListDocumentsApproval != '0') {
    $block1->headingToggle(lang_strings("approval_history"));
    $block1->openContent();

    for ($i=0; $i<$comptListDocumentsApproval; $i++) {
        if ($i == 0) {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i],'both'), $strings['submit_at']) . '</i>';
        } else {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i],'both'), $strings['resubmit_at']) . '</i>';
        }

        $querymore = " WHERE daa.document_approval='" . $listDocumentsApproval->dap_id[$i] . "' AND daa.status<>'" . enumApprovalStatus::stPending . "' ORDER BY daa.created,daa.modified";
        $listDocumentsApprovalAuthorizer = new request();
        $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($querymore);
        $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

        for ($j=0,$right=''; $j<$comptListDocumentsApprovalAuthorizer; $j++,$right.='<br>') {
            $ahd = '';

            if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stApproved) {
                $ahd = $strings['approval_history_approved'];
            } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stNotApproved) {
                $ahd = $strings['approval_history_rejected'];
            }

            if ($ahd != '') {
                $ahd0 = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
                $ahd1 = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j],'both'), $ahd0);
                $right .= '<i>' . $ahd1  . '</i>';

                if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                    $right .= '<br>' . $listDocumentsApprovalAuthorizer->daa_comments[$j];
                }
            }
        }

        $block1->contentRow($left, $right);
    }

    $block1->closeContent();
    $block1->closeToggle();
}

$block1->closeForm();
$block1->openPaletteScript();

if ($projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_delete_project[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteScript(0, 'remove', '../projects/deleteproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes, 'true,true,false', $strings['delete']);
    }
}

if ($permissionDetail->prp_copy_project[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(1, 'copy', '../projects/editproject.php?id=' . $projectDetail->pro_id[0] . '&cpy=true' . $urlBornes, 'true,true,false', $strings['copy']);
}

if ($projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_import_project[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteScript(9, 'import', '../projects/importproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes, 'true,true,false', $strings['import']);
    }
}

if ($permissionDetail->prp_export_project[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(2, 'export', '../projects/exportproject.php?languageSession=' . $languageSession . '&type=project&id=' . $projectDetail->pro_id[0] . $urlBornes, 'true,true,false', $strings['export']);
}

if ($projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_modify_project_properties[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
        $block1->paletteScript(3, 'edit', '../projects/editproject.php?id=' . $projectDetail->pro_id[0] . '&cpy=false' . $urlBornes, 'true,true,false', $strings['edit']);
    }
}

$block1->paletteScript(5, 'bug', '../support/listrequests.php?id=' . $projectDetail->pro_id[0] . $urlBornes, 'true,true,false', $strings['support_requests']);

if ($idSession == $projectDetail->pro_owner[0] || $SW_Permissions['Project']['Admin'][$profilSession]) {
    $block1->paletteScript(6, 'lock', '../projects/editrolepermissions.php?id=' . $projectDetail->pro_id[0] . $urlBornes, 'true,true,false', $strings['permissions']);
}

$block1->paletteScript(7, 'calendar', '../calendar/viewcalendar.php?pc=true&id=' . $projectDetail->pro_id[0] . $urlBornes, 'true,true,false', $strings['calendar']);

if ($permissionDetail->prp_view_project_budget[0] == enumBoolean::bTrue || $permissionDetail->prp_view_project_cost[0] == enumBoolean::bTrue || $permissionDetail->prp_view_expense[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession]) {
    $block1->paletteScript(8, 'account', '../projects/viewprojectaccounting.php?id=' . $projectDetail->pro_id[0] . $urlBornes, 'true,true,false', $strings['project_accounting']);
}

$block1->paletteScript(99, 'search', 'projects');
$block1->closePaletteScript('', '');

// Phase or Task list block
if ($projectDetail->pro_phase_set[0] != '0') {
    if ($SW_Permissions['Project']['Admin'][$profilSession] || $permissionDetail->prp_view_phase[0] == enumBoolean::bTrue) {
        $block7 = new block();
        $block7->form = 'wbSe';
        $block7->openForm('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes . '#' . $block7->form . 'Anchor');
        $block7->headingToggle(lang_strings('phases'), !($toggle_focus=='phases'));
        $block7->borne = $blockPage->returnBorne('7');
        $block7->rowsLimit = '12';
        $block7->sorting("phases", (isset($sortingUser['phases'])?$sortingUser['phases']:''), "pha.order_num ASC", $sortingFields = array(0 => 'pha.order_num', 1 => 'none', 2 => 'pha.status', 3 => 'pha.date_start', 4 => 'pha.date_end'));
        $querymore = " WHERE pha.project='" . $projectDetail->pro_id[0] . "' ORDER BY " . $block7->sortingValue;
        $recordsTotal = compt($initrequest['phases'] . $querymore);
        $block7->recordsTotal = $recordsTotal;
        $listPhases = new request();
        $listPhases->openPhases($querymore, $block7->borne, $block7->rowsLimit);
        $comptListPhases = count($listPhases->pha_id);
        $columns = array();
        $columns[0] = new cardviewColumn();
        $columns[0]->title = $strings['order'];
        $columns[0]->field_type = enumFieldType::ftNumeric;
        $columns[1] = new cardviewColumn();
        $columns[1]->title = $strings['name'];
        $columns[1]->field_type = enumFieldType::ftText;
        $columns[2] = new cardviewColumn();
        $columns[2]->title = $strings['status'];
        $columns[2]->field_type = enumFieldType::ftText;
        $columns[3] = new cardviewColumn();
        $columns[3]->title = $strings['date_start'];
        $columns[3]->field_type = enumFieldType::ftText;
        $columns[4] = new cardviewColumn();
        $columns[4]->title = $strings['date_end'];
        $columns[4]->field_type = enumFieldType::ftText;
        $opt[enumCardviewOption::oObject] = 'phases';
        $opt[enumCardviewOption::oTableName] = 'phases';
        $opt[enumCardviewOption::oColumns] = $columns;
        $opt[enumCardviewOption::oMultipleSelection] = false;
        $opt[enumCardviewOption::oSearch] = true;
        $opt[enumCardviewOption::oExtraParameters] = "project=" . $projectDetail->pro_id[0] . $urlBornes . '&borne7=' . $block7->borne;
        $block7->openCardView($opt);

        for ($i=0; $i<$comptListPhases; $i++) {
            if ($listPhases->pha_status[$i] == enumPhaseStatus::stNotStarted) {
                $phaseStart = '--';
                $phaseEnd = '--';
            } else if ($listPhases->pha_status[$i] == enumPhaseStatus::stCompleted) {
                $phaseStart = createDate($listPhases->pha_date_start[$i],'date',false,true);
                $phaseEnd = createDate($listPhases->pha_date_end[$i],'date',false,true);
            } else {
                $phaseStart = createDate($listPhases->pha_date_start[$i],'date',false,true);
                $phaseEnd = '--';
            }

            $content = array(
                $listPhases->pha_order_num[$i],
                $listPhases->pha_description[$i],
                $phaseStatus[$listPhases->pha_status[$i]],
                $phaseStart,
                $phaseEnd
            );
            $block7->itemCardView($listPhases->pha_id[$i], $content);
        }

        $block7->closeCardView();
        $block7->bornesFooter("7", $blockPage->bornesNumber, "toggle_focus=phases&id=" . $projectDetail->pro_id[0] . $urlBornes);
        $block7->closeToggle();
        $block7->closeFormResults();
    }
} else {
    if ($SW_Permissions['Project']['Admin'][$profilSession] || $permissionDetail->prp_view_task[0] == enumBoolean::bTrue) {
        $block2 = new block();
        $block2->form = 'wbTuu';
        $block2->openForm('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes . '#' . $block2->form . 'Anchor');
        $block2->headingToggle(lang_strings('tasks'), !($toggle_focus=='tasks'));
        $block2->borne = $blockPage->returnBorne('9');
        $block2->rowsLimit = '12';

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
            $block2->sorting('project_tasks', (isset($sortingUser['project_tasks'])?$sortingUser['project_tasks']:''), 'tas.name ASC', $sortingFields = array(0 => 'tas.id', 1 => 'tas.name', 2 => 'tas.priority', 3 => 'tas.status', 4 => 'tas.completion', 5 => 'tas.due_date', 6 => 'tas.assigned_to', 7 => 'tas.published'));
        } else {
            $block2->sorting('project_tasks', (isset($sortingUser['project_tasks'])?$sortingUser['project_tasks']:''), 'tas.name ASC', $sortingFields = array(0 => 'tas.id', 1 => 'tas.name', 2 => 'tas.priority', 3 => 'tas.status', 4 => 'tas.completion', 5 => 'tas.due_date', 6 => 'tas.assigned_to'));
        }

        $querymore = " WHERE tas.project='" . $projectDetail->pro_id[0] . "' AND tas.level='0' ORDER BY " . $block2->sortingValue;
        $block2->recordsTotal = compt($initrequest['tasks'] . ' ' . $querymore);
        $listTasks = new request();
        $listTasks->openTasks($querymore, $block2->borne, $block2->rowsLimit);
        $comptListTasks = count($listTasks->tas_id);
        $columns = array();
        $columns[0] = new cardviewColumn();
        $columns[0]->title = $strings['id'];
        $columns[0]->field_type = enumFieldType::ftNumeric;
        $columns[1] = new cardviewColumn();
        $columns[1]->title = $strings['name'];
        $columns[1]->field_type = enumFieldType::ftText;
        $columns[2] = new cardviewColumn();
        $columns[2]->title = $strings['priority'];
        $columns[2]->field_type = enumFieldType::ftText;
        $columns[3] = new cardviewColumn();
        $columns[3]->title = $strings['status'];
        $columns[3]->field_type = enumFieldType::ftText;
        $columns[4] = new cardviewColumn();
        $columns[4]->title = $strings['completion'];
        $columns[4]->field_type = enumFieldType::ftText;
        $columns[5] = new cardviewColumn();
        $columns[5]->title = $strings['due_date'];
        $columns[5]->field_type = enumFieldType::ftText;
        $columns[6] = new cardviewColumn();
        $columns[6]->title = $strings['assigned_to'];
        $columns[6]->field_type = enumFieldType::ftAvatar;

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
            $columns[7] = new cardviewColumn();
            $columns[7]->title = $strings['published'];
            $columns[7]->field_type = enumFieldType::ftText;
        }

        $opt = array();
        $opt[enumCardviewOption::oObject] = 'tasks';
        $opt[enumCardviewOption::oTableName] = 'tasks';
        $opt[enumCardviewOption::oColumns] = $columns;
        $opt[enumCardviewOption::oSearch] = true;
        $opt[enumCardviewOption::oExtraParameters] = 'org_url=' . urlencode("projects/viewproject.php?toggle_focus=tasks&project=" . $projectDetail->pro_id[0]) . $urlBornes . '&borne8=' . $block2->borne;

        if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
            if ($permissionDetail->prp_create_task[0] == enumBoolean::bTrue) {
                $opt[enumCardviewOption::oAddUrl] = "../tasks/edittask.php?project=" . $projectDetail->pro_id[0] . $urlBornes;
            }
        }

        $block2->openCardView($opt);
        $today = mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y')));

        for ($i=0; $i<$comptListTasks; $i++) {
            $tmpquery = "SELECT id FROM " . $tablePrefix . "tasks WHERE parent_task='" . $listTasks->tas_id[$i] . "'";
            $comptSubTasks = compt($tmpquery);

            if ($comptSubTasks > 0) {
                $namePostfix = "&nbsp;&nbsp;($comptSubTasks&nbsp;" . lang_strings('subtasks') . ")";
            } else {
                $namePostfix = '';
            }

            $idStatus = $listTasks->tas_status[$i];
            $idPriority = $listTasks->tas_priority[$i];
            $idPublish = $listTasks->tas_published[$i];
            $complValue = ($listTasks->tas_completion[$i] > 0) ? $listTasks->tas_completion[$i] . "0 %": $listTasks->tas_completion[$i] . " %";

            if ($idStatus == 1) {
                $nameTxt = '<del>' . $listTasks->tas_name[$i] . $namePostfix . '</del>';
            } else {
                $nameTxt = $listTasks->tas_name[$i] . $namePostfix;
            }

            if ($listTasks->tas_milestone[$i] == enumMilestone::msYes) {
                $priorityTxt = '';
                $statusTxt = '';
                $completionTxt = '';
            } else {
                $priorityTxt = $priority[$idPriority];
                $statusTxt = $status[$idStatus];
                $completionTxt = $complValue;
            }

            if ($listTasks->tas_milestone[$i] == enumMilestone::msYes) {
                $duedateTxt = createDate($listTasks->tas_due_date[$i],'date',false,true);
            } else if ($listTasks->tas_due_date[$i] <= $today && $listTasks->tas_completion[$i] != '10') {
                $duedateTxt = '<div class="overdue">' . createDate($listTasks->tas_due_date[$i],'date',false,true) . "</div>";
            } else {
                $duedateTxt = createDate($listTasks->tas_due_date[$i],'date',false,true);
            }

            if ($listTasks->tas_start_date[$i] != "0" && $listTasks->tas_due_date[$i] != "0") {
                $gantt = "true";
            }

            $content = array(
                $listTasks->tas_id[$i],
                $nameTxt,
                $priorityTxt,
                $statusTxt,
                $completionTxt,
                $duedateTxt
            );

            if ($listTasks->tas_milestone[$i] == enumMilestone::msYes) {
                $content[] = '';
            } else {
                $tmpquery = " AND res.task=" . $listTasks->tas_id[$i];
                $resourceUsage = new request();
                $resourceUsage->openTaskHumanResource($tmpquery);
                $comptResourceUsage = count($resourceUsage->res_id);

                if ($comptResourceUsage > 0) {
                    $assigned_to = array();

                    for ($j=0; $j<$comptResourceUsage; $j++) {
                        $assigned_to[] = implode(",", array(
                            $resourceUsage->res_resource[$j],
                            $resourceUsage->res_mem_extension_picture[$j],
                            $resourceUsage->res_mem_gender[$j]
                        ));
                    }

                    $content[] = $assigned_to;
                } else {
                    $content[] = '';
                }
            }

            if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
                $content[] = $statusPublish[$idPublish];
            }

            $block2->itemCardView($listTasks->tas_id[$i], $content);
        }

        $block2->closeCardView();
        $block2->bornesFooter('9', $blockPage->bornesNumber, "toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes);
        $block2->closeToggle();
        $block2->closeFormResults();

        if ($comptListTasks > 0 && $activeJpgraph == "true" && $gantt == "true") {
            $block2->headingToggle($strings['charts'], !($toggle_focus=='charts'));

            if ($gantt_sd != '') {
                echo "<a href='viewproject.php?toggle_focus=charts&amp;id=" . $projectDetail->pro_id[0] . "&amp;base=$base'>&lt;&lt;</a>&nbsp;";

                if ($base == '1') {
                    $gantt_sd_prev = mktime(0,0,0,intval(date('m',$gantt_sd))-5,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
                } else {
                    $gantt_sd_prev = mktime(0,0,0,intval(date('m',$gantt_sd))-1,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
                }
            }

            $tmpquery = "SELECT MIN(start_date),MAX(due_date) FROM " . $tablePrefix . "tasks WHERE project='$id' AND start_date!='0' AND due_date!='0'";

            if ($gantt_sd != '') {
                if ($base == '1') {
                    $gantt_sd_next = mktime(0,0,0,intval(date('m',$gantt_sd))+5,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
                } else {
                    $gantt_sd_next = mktime(0,0,0,intval(date('m',$gantt_sd))+1,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
                }

                $tmpquery .= " AND due_date>='$gantt_sd_next'";
            }

            $boundaries = new request();
            $boundaries->connectClass();
            $boundaries->query($tmpquery);

            if ($boundaries->fetch()) {
                $start_date_b = ($row[0]);
                $due_date_b = ($row[1]);

                if ($gantt_sd == '') {
                    if ($base == '1') {
                        $gantt_sd_next = mktime(0,0,0,intval(date('m',$start_date_b))+5,intval(date('d',$start_date_b)),intval(date('Y',$start_date_b)));
                    } else {
                        $gantt_sd_next = mktime(0,0,0,intval(date('m',$start_date_b))+1,intval(date('d',$start_date_b)),intval(date('Y',$start_date_b)));
                    }

                    $gantt_sd = $start_date_b;
                } else {
                    if ($gantt_sd_prev < $start_date_b) {
                        echo "<a href='viewproject.php?toggle_focus=charts&amp;id=" . $projectDetail->pro_id[0] . "&amp;base=$base'>&lt;</a>&nbsp;";
                    } else {
                        echo "<a href='viewproject.php?toggle_focus=charts&amp;id=" . $projectDetail->pro_id[0] . "&amp;base=$base&amp;gantt_sd=$gantt_sd_prev'>&lt;</a>&nbsp;";
                    }
                }

                if ($gantt_sd_next <= $due_date_b) {
                    $showNext = 'true';

                    if ($base == '1') {
                        $gantt_sd_last = mktime(0,0,0,intval(date('m',$due_date_b))-5,intval(date('d',$due_date_b))+1,intval(date('Y',$due_date_b)));
                    } else {
                        $gantt_sd_last = mktime(0,0,0,intval(date('m',$due_date_b))-1,intval(date('d',$due_date_b))+1,intval(date('Y',$due_date_b)));
                    }
                }
            }

            // show the expanded or compact Gantt Chart
            if ($base == '1') {
                echo "<a href='../projects/viewproject.php?toggle_focus=charts&amp;id=" . $projectDetail->pro_id[0] . "&amp;base=0'>expand</a>";
            } else {
                echo "<a href='../projects/viewproject.php?toggle_focus=charts&amp;id=" . $projectDetail->pro_id[0] . "&amp;base=1'>compact</a>";
            }

            if ($showNext == 'true') {
                echo "&nbsp;<a href='viewproject.php?toggle_focus=charts&amp;id=" . $projectDetail->pro_id[0] . "&amp;base=$base&amp;gantt_sd=$gantt_sd_next'>&gt;</a>";
                echo "&nbsp;<a href='viewproject.php?toggle_focus=charts&amp;id=" . $projectDetail->pro_id[0] . "&amp;base=$base&amp;gantt_sd=$gantt_sd_last'>&gt;&gt;</a>";
            }

            if ($gantt_sd != '') {
                echo '<br><img src="../projects/graphtasks.php?toggle_focus=charts&amp;project=' . $projectDetail->pro_id[0] . '&amp;base=' . $base . '&amp;gantt_sd=' . $gantt_sd . '" alt=""><br><span class="listEvenBold">' . $blockPage->buildLink('http://www.aditus.nu/jpgraph/', 'JpGraph', 'powered') . '</span>';
            }

            $block2->closeToggle();
        }
    }
}

if ($SW_Permissions['Project']['Admin'][$profilSession] || $permissionDetail->prp_view_discussion[0] == enumBoolean::bTrue) {
    $block3 = new block();
    $block3->form = 'pdH';
    $block3->openForm('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes . '#' . $block3->form . 'Anchor');
    $block3->headingToggle(lang_strings('discussions'), !($toggle_focus=='discussions'));
    $block3->borne = $blockPage->returnBorne('2');
    $block3->rowsLimit = '12';

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        $block3->sorting('project_discussions', (isset($sortingUser['project_discussions'])?$sortingUser['project_discussions']:''), 'topic.last_post DESC', $sortingFields = array(0 => 'topic.subject', 1 => 'mem.name', 2 => 'topic.posts', 3 => 'topic.last_post', 4 => 'topic.status', 5 => 'topic.published'));
    } else {
        $block3->sorting('project_discussions', (isset($sortingUser['project_discussions'])?$sortingUser['project_discussions']:''), 'topic.last_post DESC', $sortingFields = array(0 => 'topic.subject', 1 => 'mem.name', 2 => 'topic.posts', 3 => 'topic.last_post', 4 => 'topic.status'));
    }

    $querymore = " WHERE topic.project='" . $projectDetail->pro_id[0] . "' ORDER BY " . $block3->sortingValue;
    $block3->recordsTotal = compt($initrequest['topics'] . ' ' . $querymore);
    $listTopics = new request();
    $listTopics->openTopics($querymore, $block3->borne, $block3->rowsLimit);
    $comptListTopics = count($listTopics->top_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['topic'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['owner'];
    $columns[1]->field_type = enumFieldType::ftAvatar;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['posts'];
    $columns[2]->field_type = enumFieldType::ftNumeric;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['last_post'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['status'];
    $columns[4]->field_type = enumFieldType::ftText;

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        $columns[5] = new cardviewColumn();
        $columns[5]->title = $strings['published'];
        $columns[5]->field_type = enumFieldType::ftText;
    }

    $opt = array();
    $opt[enumCardviewOption::oObject] = 'topics';
    $opt[enumCardviewOption::oTableName] = 'topics';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] = 'project=' . $projectDetail->pro_id[0] . '&org_url=' . urlencode("projects/viewproject.php?toggle_focus=discussions&project=" . $projectDetail->pro_id[0]) . $urlBornes . '&borne2=' . $block3->borne;

    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_add_discussion_topic[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = '../topics/addtopic.php?project=' . $projectDetail->pro_id[0] . $urlBornes;
        }
    }

    $block3->openCardView($opt);

    for ($i = 0;$i < $comptListTopics;$i++) {
        $idStatus = $listTopics->top_status[$i];
        $idPublish = $listTopics->top_published[$i];

        if ($listTopics->top_last_name[$i] == '') {
            $lastName = "";
        } else {
            $lastName = " (".$listTopics->top_last_name[$i].")";
        }

        if ($listTopics->top_last_post[$i] > $lastvisiteSession) {
            $last_post = "<b>" . createDate($listTopics->top_last_post[$i], 'both') . "$lastName</b>";
        } else {
            $last_post = createDate($listTopics->top_last_post[$i], 'both') . $lastName;
        }

        $content = array(
            $listTopics->top_subject[$i],
            implode(',',
                array(
                    $listTopics->top_owner[$i],
                    $listTopics->top_mem_extension_picture[$i],
                    $listTopics->top_mem_gender[$i])),
            $listTopics->top_posts[$i],
            $last_post,
            $statusTopic[$idStatus]
        );

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
            $content[] = $statusPublish[$idPublish];
        }

        $block3->itemCardView($listTopics->top_id[$i], $content);
    }

    $block3->closeCardView();
    $block3->bornesFooter('2', $blockPage->bornesNumber, 'toggle_focus=discussions&id=' . $projectDetail->pro_id[0] . $urlBornes);
    $block3->closeToggle();
    $block3->closeFormResults();
}

if ($SW_Permissions['Project']['Admin'][$profilSession] || $permissionDetail->prp_view_team[0] == enumBoolean::bTrue) {
    $block4 = new block();
    $block4->form = 'pdM';
    $block4->openForm('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes . '#' . $block4->form . 'Anchor');
    $block4->headingToggle(lang_strings('team'), !($toggle_focus=='team'));
    $block4->borne = $blockPage->returnBorne('3');
    $block4->rowsLimit = '12';

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        $block4->sorting('project_team', (isset($sortingUser['project_team'])?$sortingUser['project_team']:''), 'mem.name ASC', $sortingFields = array(0 => 'mem.name', 1 => 'tea.profil', 2 => 'mem.title', 3 => 'mem.phone_work', 4 => 'log.email_work', 5 => 'tea.published'));
    } else {
        $block4->sorting('project_team', (isset($sortingUser['project_team'])?$sortingUser['project_team']:''), 'mem.name ASC', $sortingFields = array(0 => 'mem.name', 1 => 'tea.profil', 2 => 'mem.title', 3 => 'mem.phone_work', 4 => 'log.email_work'));
    }

    $querymore = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND mem.organization='1' ORDER BY " . $block4->sortingValue;
    $block4->recordsTotal = compt($initrequest['teams'] . $querymore);
    $listTeam = new request();
    $listTeam->openTeams($querymore, $block4->borne, $block4->rowsLimit);
    $comptListTeam = count($listTeam->tea_project);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->field_type = enumFieldType::ftAvatar;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['full_name'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['role'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['title'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['work_phone'];
    $columns[4]->field_type = enumFieldType::ftText;
    $columns[5] = new cardviewColumn();
    $columns[5]->title = $strings['email'];
    $columns[5]->field_type = enumFieldType::ftEmail;

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        $columns[6] = new cardviewColumn();
        $columns[6]->title = $strings['published'];
        $columns[6]->field_type = enumFieldType::ftText;
    }

    $opt = array();
    $opt[enumCardviewOption::oObject] = 'teams';
    $opt[enumCardviewOption::oTableName] = 'teams';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oExtraParameters] = 'project=' . $projectDetail->pro_id[0] . '&org_url=' . urlencode("projects/viewproject.php?toggle_focus=team&project=" . $projectDetail->pro_id[0]) . $urlBornes . '&borne3=' . $block4->borne;

    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_add_team_member[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = '../teams/adduser.php?project=' . $projectDetail->pro_id[0] . $urlBornes;
        }
    }

    $block4->openCardView($opt);

    for ($i=0; $i<$comptListTeam; $i++) {
        $idPublish = $listTeam->tea_published[$i];
        $content = array(
            implode(',', array(
                $listTeam->tea_member[$i],
                $listTeam->tea_mem_extension_picture[$i],
                $listTeam->tea_mem_gender[$i]
            )),
            $listTeam->tea_mem_name[$i],
            $projectRoles[$listTeam->tea_profil[$i]],
            $listTeam->tea_mem_title[$i],
            $listTeam->tea_mem_phone_work[$i],
            $listTeam->tea_mem_email_work[$i]
        );

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
            $content[] = $statusPublish[$idPublish];
        }

        $block4->itemCardView($listTeam->tea_id[$i], $content);
    }

    $block4->closeCardView();
    $block4->bornesFooter('3', $blockPage->bornesNumber, 'toggle_focus=team&id=' . $projectDetail->pro_id[0] . $urlBornes);
    $block4->closeToggle();
    $block4->closeFormResults();
}

if ($fileManagement == 'true' && ($SW_Permissions['Project']['Admin'][$profilSession] || $permissionDetail->prp_view_file[0] == enumBoolean::bTrue)) {
    $block5 = new block();
    $block5->form = 'tdC';
    $block5->openForm('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes . '#' . $block5->form . 'Anchor');
    $block5->headingToggle(lang_strings('linked_content'), !($toggle_focus=='linked_content'));
    $block5->borne = $blockPage->returnBorne('4');
    $block5->rowsLimit = '12';

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        $block5->sorting('project_files', (isset($sortingUser['project_files'])?$sortingUser['project_files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status', 4 => 'fil.published'));
    } else {
        $block5->sorting('project_files', (isset($sortingUser['project_files'])?$sortingUser['project_files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status'));
    }

    $querymore = " WHERE fil.vc_parent='0' ORDER BY " . $block5->sortingValue;
    $sql0 = $initrequest["project_files"];
    $sql = str_replace('%project%', $projectDetail->pro_id[0], $sql0);
    $block5->recordsTotal = compt($sql . $querymore);
    $listFiles = new request();
    $listFiles->openProjectFiles($id, $querymore, $block5->borne, $block5->rowsLimit);
    $comptListFiles = count($listFiles->fil_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['owner'];
    $columns[1]->field_type = enumFieldType::ftAvatar;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['created'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['approval_tracking'];
    $columns[3]->field_type = enumFieldType::ftText;

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        $columns[4] = new cardviewColumn();
        $columns[4]->title = $strings['published'];
        $columns[4]->field_type = enumFieldType::ftText;
    }

    $opt[enumCardviewOption::oTableName] = 'files';
    $opt[enumCardviewOption::oObject] = 'files';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] = "doc_type=" . enumFileRelatedDocumentType::dtProject . "&doc_id=" . $projectDetail->pro_id[0] . $urlBornes . '&borne4=' . $block5->borne;

    if ($SW_Permissions['File']['Write'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = "../linkedcontent/addfile.php?doc_type=" . enumFileRelatedDocumentType::dtProject . "&doc_id=" . $projectDetail->pro_id[0] . $urlBornes;
    }

    $block5->openCardView($opt);

    for ($i=0; $i<$comptListFiles; $i++) {
        $idStatus = $listFiles->fil_status[$i];
        $idPublish = $listFiles->fil_published[$i];
        $content = array(
            $listFiles->fil_name[$i],
            implode(',',
                array(
                    $listFiles->fil_owner[$i],
                    $listFiles->fil_mem_extension_picture[$i],
                    $listFiles->fil_mem_gender[$i])),
            createDate($listFiles->fil_created[$i],'both'),
            $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . enumFileRelatedDocumentType::dtProject . '&doc_id=' . $projectDetail->pro_id[0] . '&id=' . $listFiles->fil_id[$i] . $urlBornes, $statusFile[$idStatus], 'in')
        );

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
            $content[] = $statusPublish[$idPublish];
        }

        $block5->itemCardView($listFiles->fil_id[$i], $content);
    }

    $block5->closeCardView();
    $block5->bornesFooter('4', $blockPage->bornesNumber, 'toggle_focus=linked_content&id=' . $projectDetail->pro_id[0] . $urlBornes);
    $block5->closeToggle();
    $block5->closeFormResults();
}

if ($SW_Permissions['Project']['Admin'][$profilSession] || $permissionDetail->prp_view_note[0] == enumBoolean::bTrue) {
    $block6 = new block();
    $block6->form = 'wbJ';
    $block6->openForm('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes . '#' . $block6->form . 'Anchor');
    $block6->headingToggle(lang_strings('notes'), !($toggle_focus=='notes'));
    $block6->borne = $blockPage->returnBorne('5');
    $block6->rowsLimit = '12';

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        $block6->sorting('project_notes', (isset($sortingUser['project_notes'])?$sortingUser['project_notes']:''), 'note.date DESC', $sortingFields = array(0 => 'note.subject', 1 => 'note.topic', 2 => 'note.date', 3 => 'mem.name', 4 => 'note.published'));
    } else {
        $block6->sorting('project_notes', (isset($sortingUser['project_notes'])?$sortingUser['project_notes']:''), 'note.date DESC', $sortingFields = array(0 => 'note.subject', 1 => 'note.topic', 2 => 'note.date', 3 => 'mem.name'));
    }

    $querymore = " WHERE note.project='" . $projectDetail->pro_id[0] . "' ORDER BY " . $block6->sortingValue;
    $block6->recordsTotal = compt($initrequest['notes'] . ' ' . $querymore);
    $listNotes = new request();
    $listNotes->openNotes($querymore, $block6->borne, $block6->rowsLimit);
    $comptListNotes = count($listNotes->note_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['subject'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['topic'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['date'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['owner'];
    $columns[3]->field_type = enumFieldType::ftAvatar;

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
        $columns[4] = new cardviewColumn();
        $columns[4]->title = $strings['published'];
        $columns[4]->field_type = enumFieldType::ftText;
    }

    $opt[enumCardviewOption::oObject] = 'notes';
    $opt[enumCardviewOption::oTableName] = 'notes';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] = 'project=' . $projectDetail->pro_id[0] . '&org_url=' . urlencode("projects/viewproject.php?project=" . $projectDetail->pro_id[0]) . $urlBornes . '&borne5=' . $block6->borne;

    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_add_note[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = '../notes/editnote.php?project=' . $projectDetail->pro_id[0] . $urlBornes;
        }
    }

    $block6->openCardView($opt);

    for ($i=0; $i<$comptListNotes; $i++) {
        $content = array(
            $listNotes->note_subject[$i],
            fieldValidValueString('notes', 'topic', $listNotes->note_topic[$i]),
            createDate($listNotes->note_date[$i],'date',false,true),
            implode(',',
                array(
                    $listNotes->note_owner[$i],
                    $listNotes->note_mem_extension_picture[$i],
                    $listNotes->note_mem_gender[$i]))
        );

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
            $idPublish = $listNotes->note_published[$i];
            $content[] = $statusPublish[$idPublish];
        }

        $block6->itemCardView($listNotes->note_id[$i], $content);
    }

    $block6->closeCardView();
    $block6->bornesFooter('5', $blockPage->bornesNumber, 'toggle_focus=notes&id=' . $projectDetail->pro_id[0] . $urlBornes);
    $block6->closeToggle();
    $block6->closeFormResults();
}

if ($permissionDetail->prp_view_meeting[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Admin'][$profilSession]) {
    $block8 = new block();
    $block8->form = 'wbK';
    $block8->openForm('../projects/viewproject.php?id=' . $projectDetail->pro_id[0] . $urlBornes . '#' . $block8->form . 'Anchor');
    $block8->headingToggle(lang_strings('meetings'), !($toggle_focus=='meetings'));
    $block8->borne = $blockPage->returnBorne('6');
    $block8->rowsLimit = '12';
    $block8->sorting('project_meetings', (isset($sortingUser['project_meetings'])?$sortingUser['project_meetings']:''), 'mee.start_time DESC', $sortingFields = array(0 => 'mee.id', 1 => 'mee.name', 2 => 'mee.priority', 3 => 'mee.status', 4 => 'mee.start_time', 5 => 'mee.duration'));
    $querymore = " WHERE mee.project='" . $projectDetail->pro_id[0] . "' ORDER BY " . $block8->sortingValue;
    $block8->recordsTotal = compt($initrequest['meetings'] . ' ' . $querymore);
    $listMeetings = new request();
    $listMeetings->openMeetings($querymore, $block8->borne, $block8->rowsLimit);
    $comptListMeetings = count($listMeetings->mee_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['id'];
    $columns[0]->field_type = enumFieldType::ftNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['meeting'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['priority'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['status'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['start_time'];
    $columns[4]->field_type = enumFieldType::ftText;
    $columns[5] = new cardviewColumn();
    $columns[5]->title = $strings['duration'];
    $columns[5]->field_type = enumFieldType::ftText;
    $opt = array();
    $opt[enumCardviewOption::oObject] = 'meetings';
    $opt[enumCardviewOption::oTableName] = 'meetings';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] =  $urlBornes . '&borne6=' . $block8->borne;

    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_create_meeting[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = '../meetings/editmeeting.php?project=' . $projectDetail->pro_id[0] . $urlBornes;
        }
    }

    $block8->openCardView($opt);

    for ($i=0; $i<$comptListMeetings; $i++) {
        $idStatus = $listMeetings->mee_status[$i];
        $idPriority = $listMeetings->mee_priority[$i];

        if ($idStatus == enumMeetingStatus::stCompleted || $idStatus == enumMeetingStatus::stCanceled) {
            $mee_name = '<del>' . $listMeetings->mee_name[$i] . '</del>';
        } else {
            $mee_name = $listMeetings->mee_name[$i];
        }

        if ($idStatus == enumMeetingStatus::stScheduling) {
            $start_time = '--';
        } else {
            if ($listMeetings->mee_start_time[$i] <= time() && $idStatus != enumMeetingStatus::stCompleted && $idStatus != enumMeetingStatus::stCanceled) {
                $start_time = "<b>" . createDate($listMeetings->mee_start_time[$i], 'both') . "</b>";
            } else {
                $start_time = createDate($listMeetings->mee_start_time[$i], 'both');
            }
        }

        $content = array(
            $listMeetings->mee_id[$i] . (($listMeetings->mee_reminder[$i] == '1')?' <img src="../themes/' . THEME . '/bell.gif">':''),
            $mee_name,
            $priority[$idPriority],
            $statusMeeting[$idStatus],
            $start_time,
            sprintf("%.1f %s", $listMeetings->mee_duration[$i], lang_strings("hours"))
        );
        $block8->itemCardView($listMeetings->mee_id[$i], $content);
    }

    $block8->closeCardView();
    $block8->bornesFooter('6', $blockPage->bornesNumber, 'toggle_focus=meetings&id=' . $projectDetail->pro_id[0] . $urlBornes);
    $block8->closeToggle();
    $block8->closeFormResults();
}

$querymore = " WHERE pfm.project='" . $projectDetail->pro_id[0] . "' ORDER BY pfm.tablename";
$listProjectForms = new request();
$listProjectForms->openProjectsForm($querymore);
$comptListProjectForms = count($listProjectForms->pfm_project);

if ($comptListProjectForms > 0) {
    $block9 = new block();
    $block9->headingToggle(lang_strings('project_forms'));
    $block9->openContent(($comptListProjectForms>10));

    for ($i=0; $i<$comptListProjectForms; $i++) {
        $tblnam = $listProjectForms->pfm_tablename[$i];
        $tbldesc = tableNameString($listProjectForms->pfm_tablename[$i]);
        $block9->contentRow('', $blockPage->buildLink('../forms/listforms.php?tblnam=' . $tblnam . '&project=' . $projectDetail->pro_id[0] . $urlBornes, $tbldesc, 'in'));
    }

    $block9->closeContent();
    $block9->closeToggle();
}

require_once('../includes/footer.php');
