<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewprojectaccounting.php,v 1.9 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Project']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore1 = " WHERE pro.id='$id'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore2 = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore2);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore3 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore3 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore3);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_view_project_budget[0] != enumBoolean::bTrue && $permissionDetail->prp_view_project_cost[0] != enumBoolean::bTrue && $permissionDetail->prp_view_expense[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    if ($projectsFilter == 'true') {
        header('Location: ../general/permissiondenied.php');
        exit;
    } else {
        header("Location: ../teams/joinprojectteam.php?project=$id" . $urlBornes);
        exit;
    }
}

/**
 * Prepare data
 */
$showExchangeNotFoundNote = false;
// display currency
if ($projectDetail->pro_currency[0] == '') {
    $cud = $defaultCurrency;
} else {
    $cud = $projectDetail->pro_currency[0];
}

// get budget currency list
$tmpquery1 = "SELECT DISTINCT currency FROM " . $tablePrefix . "projects_budget WHERE project='$id' AND currency<>'$cud' AND amount>0";
$listCurrencies = new request();
$listCurrencies->connectClass();
$listCurrencies->query($tmpquery1);
$listCurrencies->currency = array();
$listCurrencies->exchange_rate = array();

while ($listCurrencies->fetch()) {
    $listCurrencies->currency[] = ($row[0]);
}

$listCurrencies->close();

// get currency exchange rate list
if (count($listCurrencies->currency) > 0) {
    for ($i=0; $i<count($listCurrencies->currency); $i++) {
        $cu = $listCurrencies->currency[$i];
        $querymore4 = " WHERE cur.currency_to='$cud' AND cur.currency_from='$cu' AND cur.reference_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d'))+1,intval(date('Y'))) . "' ORDER BY cur.reference_date DESC";
        $listCurrencyRates = new request();
        $listCurrencyRates->openCurrencyRates($querymore4);

        if (count($listCurrencyRates->cur_currency_from) > 0) {
            $listCurrencies->exchange_rate[$cu] = $listCurrencyRates->cur_exchange_rate[0];
        } else {
            $listCurrencies->exchange_rate[$cu] = -1;
        }
    }
}

// get project budget cost type list
$tmpquery2 = "SELECT pjb.costtype,clt.name FROM " . $tablePrefix . "projects_budget pjb LEFT OUTER JOIN " . $tablePrefix . "claim_type clt ON CAST(clt.id AS char(10))=CAST(pjb.costtype AS char(10)) WHERE pjb.project='$id' GROUP BY clt.name,pjb.costtype";
$listProjectBudget = new request();
$listProjectBudget->connectClass();
$listProjectBudget->query($tmpquery2);
$listProjectBudget->costtype = array();
$listProjectBudget->name_print = array();
$listProjectBudget->amount = array();
$listProjectBudget->total = 0;

while ($listProjectBudget->fetch()) {
    $ct = ($row[0]);
    $n = ($row[1]);
    $listProjectBudget->costtype[] = $ct;
    $listProjectBudget->amount[] = 0;

    switch ($ct) {
        case enumCostType::ctLabor:
            $listProjectBudget->name_print[] = $strings['labor'];
            break;
        case enumCostType::ctMaterial:
            $listProjectBudget->name_print[] = $strings['material'];
            break;
        default:
            $listProjectBudget->name_print[] = $strings['CLT__' . $n];
    }
}

$listProjectBudget->close();

// get project budget details
for ($i=0; $i<count($listProjectBudget->costtype); $i++) {
    $tmpquery3 = "SELECT currency,amount FROM " . $tablePrefix . "projects_budget WHERE project='$id' AND costtype='" . $listProjectBudget->costtype[$i] . "' AND amount>0";
    $listProjectBudget->connectClass();
    $listProjectBudget->query($tmpquery3);

    while ($listProjectBudget->fetch()) {
        $cu = ($row[0]);
        $am = ($row[1]);

        if ($cu == $cud) {
            $amount = (is_numeric($am))?round($am, $costAccuracy):0;
        } else {
            if ($listCurrencies->exchange_rate[$cu] === -1) {
                $amount = '--';
            } else {
                $amount = ((is_numeric($am))?round($am, $costAccuracy):0) * $listCurrencies->exchange_rate[$cu];
            }
        }

        if ($amount === '--') {
            $showExchangeNotFoundNote = true;
            $listProjectBudget->amount[$i] = '--';
            $listProjectBudget->total = '--';
            break;
        } else {
            $listProjectBudget->amount[$i] += $amount;

            if ($listProjectBudget->total !== '--') {
                $listProjectBudget->total += $amount;
            }
        }
    }

    $listProjectBudget->close();
}

// get project cost (labor)
switch ($projectDetail->pro_cost_method[0]) {
    case '1':   // Use the cost rate of member only
        $tmpquery = "SELECT svc.currency,SUM(svc.hourly_rate_i*t0.hours) AS amount FROM
(SELECT wkh.project AS project,wkh.owner AS member,wkh.hours AS hours
FROM " . $tablePrefix . "work_hours wkh
WHERE wkh.project='$id' AND EXISTS (
    SELECT * FROM " . $tablePrefix . "timesheet ts1
    INNER JOIN " . $tablePrefix . "periods pe1 ON pe1.id=ts1.period
    WHERE ts1.owner=wkh.owner AND ts1.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND wkh.date>=pe1.date_start AND wkh.date<=pe1.date_end
)
UNION ALL
SELECT tim.project AS project,tim.owner AS member,tim.hours AS hours
FROM " . $tablePrefix . "tasks_time tim
WHERE tim.project='$id' AND EXISTS (
    SELECT * FROM " . $tablePrefix . "timesheet ts2
    INNER JOIN " . $tablePrefix . "periods pe2 ON pe2.id=ts2.period
    WHERE ts2.owner=tim.owner AND ts2.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND tim.date>=pe2.date_start AND tim.date<=pe2.date_end
)
UNION ALL
SELECT mti.project AS project,mti.owner AS member,mti.hours AS hours
FROM " . $tablePrefix . "meetings_time mti
WHERE mti.project='$id' AND EXISTS (
    SELECT * FROM " . $tablePrefix . "timesheet ts3
    INNER JOIN " . $tablePrefix . "periods pe3 ON pe3.id=ts3.period
    WHERE ts3.owner=mti.owner AND ts3.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND mti.date>=pe3.date_start AND mti.date<=pe3.date_end
)) t0
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=t0.project AND tea.member=t0.member
INNER JOIN " . $tablePrefix . "services svc ON svc.id=tea.service
WHERE t0.hours>0 AND svc.hourly_rate_i>0
GROUP BY svc.currency ORDER BY svc.currency
";
        break;
    case '2':   // Use the hourly rate of service first and use the cost rate of member if no service specified
        $tmpquery = "SELECT tx.currency,SUM(tx.rate*tx.hours) AS amount FROM
(SELECT svc.currency AS currency,svc.hourly_rate_i AS rate,t0.hours AS hours FROM
(SELECT wkh.service AS service,wkh.hours AS hours
FROM " . $tablePrefix . "work_hours wkh
WHERE wkh.project='$id' AND EXISTS (
    SELECT * FROM " . $tablePrefix . "timesheet ts1
    INNER JOIN " . $tablePrefix . "periods pe1 ON pe1.id=ts1.period
    WHERE ts1.owner=wkh.owner AND ts1.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND wkh.date>=pe1.date_start AND wkh.date<=pe1.date_end
)
UNION ALL
SELECT tas.service AS service,tim.hours AS hours
FROM " . $tablePrefix . "tasks_time tim
LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id=tim.task
WHERE tim.project='$id' AND EXISTS (
    SELECT * FROM " . $tablePrefix . "timesheet ts2
    INNER JOIN " . $tablePrefix . "periods pe2 ON pe2.id=ts2.period
    WHERE ts2.owner=tim.owner AND ts2.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND tim.date>=pe2.date_start AND tim.date<=pe2.date_end
)) t0
INNER JOIN " . $tablePrefix . "services svc ON svc.id=t0.service
WHERE t0.hours>0 AND svc.hourly_rate_i>0
UNION ALL
SELECT svc.currency AS currency,svc.hourly_rate_i AS rate,t0.hours AS hours FROM
(SELECT wkh.project AS project,wkh.owner AS member,wkh.hours AS hours
FROM " . $tablePrefix . "work_hours wkh
WHERE wkh.project='$id' AND wkh.service='0' AND EXISTS (
    SELECT * FROM " . $tablePrefix . "timesheet ts1
    INNER JOIN " . $tablePrefix . "periods pe1 ON pe1.id=ts1.period
    WHERE ts1.owner=wkh.owner AND ts1.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND wkh.date>=pe1.date_start AND wkh.date<=pe1.date_end
)
UNION ALL
SELECT tim.project AS project,tim.owner AS member,tim.hours AS hours
FROM " . $tablePrefix . "tasks_time tim
INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=tim.task
WHERE tim.project='$id' AND tas.service='0' AND EXISTS (
    SELECT * FROM " . $tablePrefix . "timesheet ts2
    INNER JOIN " . $tablePrefix . "periods pe2 ON pe2.id=ts2.period
    WHERE ts2.owner=tim.owner AND ts2.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND tim.date>=pe2.date_start AND tim.date<=pe2.date_end
)
UNION ALL
SELECT mti.project AS project,mti.owner AS member,mti.hours AS hours
FROM " . $tablePrefix . "meetings_time mti
WHERE mti.project='$id' AND EXISTS (
    SELECT * FROM " . $tablePrefix . "timesheet ts3
    INNER JOIN " . $tablePrefix . "periods pe3 ON pe3.id=ts3.period
    WHERE ts3.owner=mti.owner AND ts3.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND mti.date>=pe3.date_start AND mti.date<=pe3.date_end
)) t0
INNER JOIN " . $tablePrefix . "teams tea ON tea.project=t0.project AND tea.member=t0.member
INNER JOIN " . $tablePrefix . "services svc ON svc.id=tea.service
WHERE t0.hours>0 AND svc.hourly_rate_i>0
) tx GROUP BY tx.currency ORDER BY tx.currency
";
        break;
    case '3':   // Use the hourly rate of service only
        $tmpquery = "SELECT svc.currency,SUM(svc.hourly_rate_i*t0.hours) AS amount FROM
(SELECT wkh.service AS service,wkh.hours AS hours
FROM " . $tablePrefix . "work_hours wkh
WHERE wkh.project='$id' AND EXISTS (
    SELECT * FROM " . $tablePrefix . "timesheet ts1
    INNER JOIN " . $tablePrefix . "periods pe1 ON pe1.id=ts1.period
    WHERE ts1.owner=wkh.owner AND ts1.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND wkh.date>=pe1.date_start AND wkh.date<=pe1.date_end
)
UNION ALL
SELECT tas.service AS service,tim.hours AS hours
FROM " . $tablePrefix . "tasks_time tim
LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id=tim.task
WHERE tim.project='$id' AND EXISTS (
    SELECT * FROM " . $tablePrefix . "timesheet ts2
    INNER JOIN " . $tablePrefix . "periods pe2 ON pe2.id=ts2.period
    WHERE ts2.owner=tim.owner AND ts2.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND tim.date>=pe2.date_start AND tim.date<=pe2.date_end
)) t0
INNER JOIN " . $tablePrefix . "services svc ON svc.id=t0.service
WHERE t0.hours>0 AND svc.hourly_rate_i>0
GROUP BY svc.currency ORDER BY svc.currency
";
        break;
}

$listProjectCost = new request();
$listProjectCost->connectClass();
$listProjectCost->query($tmpquery);
$listProjectCost->costtype = array();
$listProjectCost->name_print = array();
$listProjectCost->amount = array();
$listProjectCost->total = 0;
$laborCost = 0;
$compt1 = 0;

while ($listProjectCost->fetch()) {
    $cu = ($row[0]);
    $am = ($row[1]);

    if ($cu == $cud) {
        $amount = (is_numeric($am))?round($am, $costAccuracy):0;
    } else {
        if (!in_array($cu, $listCurrencies->currency)) {
            $listCurrencies->currency[] = $cu;
            // get currency exchange rate
            $querymore4 = " WHERE cur.currency_to='$cud' AND cur.currency_from='$cu' AND cur.reference_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d'))+1,intval(date('Y'))) . "' ORDER BY cur.reference_date DESC";
            $listCurrencyRates = new request();
            $listCurrencyRates->openCurrencyRates($querymore4);

            if (count($listCurrencyRates->cur_currency_from) > 0) {
                $listCurrencies->exchange_rate[$cu] = $listCurrencyRates->cur_exchange_rate[0];
            } else {
                $listCurrencies->exchange_rate[$cu] = -1;
            }
        }

        if ($listCurrencies->exchange_rate[$cu] === -1) {
            $amount = '--';
        } else {
            $amount = ((is_numeric($am))?round($am, $costAccuracy):0) * $listCurrencies->exchange_rate[$cu];
        }
    }

    if ($amount === '--') {
        $showExchangeNotFoundNote = true;
        $laborCost = '--';
        break;
    } else {
        $laborCost += $amount;
    }
}

$listProjectCost->close();

if ($laborCost !== 0) {
    $listProjectCost->costtype[$compt1] = enumCostType::ctLabor;
    $listProjectCost->name_print[$compt1] = $strings['labor'];
    $listProjectCost->amount[$compt1] = $laborCost;
    $listProjectCost->total = $laborCost;
    $compt1++;
}

// get project cost (material)
$tmpquery = "SELECT t0.currency,SUM(t0.amount) AS amount FROM
(SELECT mat.currency,mat.costrate*iss.quantity AS amount
FROM " . $tablePrefix . "material_issue iss
INNER JOIN " . $tablePrefix . "materials mat ON mat.id=iss.material
WHERE iss.project='$id' AND mat.costrate>0 AND iss.quantity>0
) t0 GROUP BY t0.currency ORDER BY t0.currency
";
$listProjectCost->connectClass();
$listProjectCost->query($tmpquery);
$materialCost = 0;

while ($listProjectCost->fetch()) {
    $cu = ($row[0]);
    $am = ($row[1]);

    if ($cu == $cud) {
        $amount = (is_numeric($am))?round($am, $costAccuracy):0;
    } else {
        if (!in_array($cu, $listCurrencies->currency)) {
            $listCurrencies->currency[] = $cu;
            // get currency exchange rate
            $querymore4 = " WHERE cur.currency_to='$cud' AND cur.currency_from='$cu' AND cur.reference_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d'))+1,intval(date('Y'))) . "' ORDER BY cur.reference_date DESC";
            $listCurrencyRates = new request();
            $listCurrencyRates->openCurrencyRates($querymore4);

            if (count($listCurrencyRates->cur_currency_from) > 0) {
                $listCurrencies->exchange_rate[$cu] = $listCurrencyRates->cur_exchange_rate[0];
            } else {
                $listCurrencies->exchange_rate[$cu] = -1;
            }
        }

        if ($listCurrencies->exchange_rate[$cu] === -1) {
            $amount = '--';
        } else {
            $amount = ((is_numeric($am))?round($am, $costAccuracy):0) * $listCurrencies->exchange_rate[$cu];
        }
    }

    if ($amount === '--') {
        $showExchangeNotFoundNote = true;
        $materialCost = '--';
        break;
    } else {
        $materialCost += $amount;
    }
}

$listProjectCost->close();

if ($materialCost !== 0) {
    $listProjectCost->costtype[$compt1] = enumCostType::ctMaterial;
    $listProjectCost->name_print[$compt1] = $strings['material'];
    $listProjectCost->amount[$compt1] = $materialCost;
    $compt1++;

    if ($materialCost === '--' || $listProjectCost->total === '--') {
        $listProjectCost->total = '--';
    } else {
        $listProjectCost->total += $materialCost;
    }
}

// get project cost (expense)
$tmpquery = "SELECT exp.claimtype,clt.name FROM " . $tablePrefix . "expenses exp LEFT OUTER JOIN " . $tablePrefix . "claim_type clt ON clt.id=exp.claimtype WHERE exp.project='$id' AND exp.status<>'" . enumDocumentStatus::stDraft . "' AND exp.amount>0 GROUP BY exp.claimtype,clt.name ORDER BY clt.name";
$listProjectCost->connectClass();
$listProjectCost->query($tmpquery);
$ctList = array();

while ($listProjectCost->fetch()) {
    $ctList[($row[0])] = ($row[1]);
}

$listProjectCost->close();

foreach ($ctList as $ct => $n) {
    $tmpquery = "SELECT currency,SUM(amount) FROM " . $tablePrefix . "expenses WHERE project='$id' AND status<>'" . enumDocumentStatus::stDraft . "' AND status_approval NOT IN ('" . enumFileStatus::stNeedsApproval . "','" . enumFileStatus::stNotApproved . "') AND claimtype='$ct' AND amount>0 GROUP BY currency";
    $listProjectCost->connectClass();
    $listProjectCost->query($tmpquery);
    $expenseCost = 0;

    while ($listProjectCost->fetch()) {
        $cu = ($row[0]);
        $am = ($row[1]);

        if ($cu == $cud) {
            $amount = (is_numeric($am))?round($am, $costAccuracy):0;
        } else {
            if (!in_array($cu, $listCurrencies->currency)) {
                $listCurrencies->currency[] = $cu;
                // get currency exchange rate
                $querymore4 = " WHERE cur.currency_to='$cud' AND cur.currency_from='$cu' AND cur.reference_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d'))+1,intval(date('Y'))) . "' ORDER BY cur.reference_date DESC";
                $listCurrencyRates = new request();
                $listCurrencyRates->openCurrencyRates($querymore4);

                if (count($listCurrencyRates->cur_currency_from) > 0) {
                    $listCurrencies->exchange_rate[$cu] = $listCurrencyRates->cur_exchange_rate[0];
                } else {
                    $listCurrencies->exchange_rate[$cu] = -1;
                }
            }

            if ($listCurrencies->exchange_rate[$cu] === -1) {
                $amount = '--';
            } else {
                $amount = ((is_numeric($am))?round($am, $costAccuracy):0) * $listCurrencies->exchange_rate[$cu];
            }
        }

        if ($amount === '--') {
            $showExchangeNotFoundNote = true;
            $expenseCost = '--';
            break;
        } else {
            $expenseCost += $amount;
        }
    }

    $listProjectCost->close();

    if ($expenseCost !== 0) {
        $listProjectCost->costtype[$compt1] = $ct;
        $listProjectCost->name_print[$compt1] = $strings['CLT__' . $n];
        $listProjectCost->amount[$compt1] = $expenseCost;
        $compt1++;

        if ($expenseCost === '--' || $listProjectCost->total === '--') {
            $listProjectCost->total = '--';
        } else {
            $listProjectCost->total += $expenseCost;
        }
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/listprojects.php' . $urlBornes, lang_strings('projects'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../projects/viewproject.php?id=' . $id . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings('project_accounting'));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '2';     // 1st for listprojects
$title = $strings['project_accounting'] . ' : ' . $projectDetail->pro_name[0];
logURL($title, '../projects/viewprojectaccounting.php?id=' . $id);
$block1 = new block();
$block1->form = 'pdA';
$block1->openForm('../projects/viewprojectaccounting.php?id=' . $id . $urlBornes . '#' . $block1->form . 'Anchor');
$block1->headingToggle(lang_strings('project_accounting'), !($toggle_focus==''));
$block1->openContent();
$block1->contentTitle(lang_strings('details'));
$helpStr = '<table>';

foreach ($CurrencyMatrix['active'] as $currCode) {
    $currName = $CurrencyMatrix['name'][$currCode];
    $helpStr .= '<tr><th>' . $currCode . '</th><td>' . $currName . '</td></tr>';
}

$helpStr .= '</table>';

if ($projectDetail->pro_currency[0] == '') {
    $block1->contentRow(lang_strings('currency') . '&nbsp;' . $blockPage->printHelp($helpStr, true), lang_strings('CRC'));
} else {
    $block1->contentRow(lang_strings('currency') . '&nbsp;' . $blockPage->printHelp($helpStr, true), $projectDetail->pro_currency[0]);
}

$block1->contentRow(lang_strings('cost_method'), fieldValidValueString('projects', 'cost_method', $projectDetail->pro_cost_method[0]));
$block1->closeContent();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval && $permissionDetail->prp_modify_project_properties[0] == enumBoolean::bTrue) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(1, 'edit', $strings['edit']);
    $block1->closePaletteIcon();
}

$block1->openContent();
$block1->contentTitle(lang_strings('project_budget'));

if ($permissionDetail->prp_view_project_budget[0] == enumBoolean::bTrue) {
    for ($i=0; $i<count($listProjectBudget->costtype); $i++) {
        if ($listProjectBudget->amount[$i] === '--') {
            $block1->contentRow($listProjectBudget->name_print[$i], '--');
        } else {
            $block1->contentRow($listProjectBudget->name_print[$i], CurrencyFormatNOD($listProjectBudget->amount[$i], $cud, $costAccuracy));
        }
    }

    if ($listProjectBudget->total === '--') {
        $block1->contentRow(lang_strings('total'), '--');
    } else {
        $block1->contentRow(lang_strings('total'), CurrencyFormatNOD($listProjectBudget->total, $cud, $costAccuracy));
    }
}

$block1->contentTitle(lang_strings('project_cost'));

if ($permissionDetail->prp_view_project_cost[0] == enumBoolean::bTrue) {
    for ($i=0; $i<count($listProjectCost->costtype); $i++) {
        if ($listProjectCost->amount[$i] === '--') {
            $block1->contentRow($listProjectCost->name_print[$i], '--');
        } else {
            $block1->contentRow($listProjectCost->name_print[$i], CurrencyFormatNOD($listProjectCost->amount[$i], $cud, $costAccuracy));
        }
    }

    if ($listProjectCost->total === '--') {
        $block1->contentRow(lang_strings('total'), '--');
    } else {
        $block1->contentRow(lang_strings('total'), CurrencyFormatNOD($listProjectCost->total, $cud, $costAccuracy));
    }
}

$block1->closeContent();

if ($showExchangeNotFoundNote) {
    $block1->note("-- " . lang_strings('exchange_rate_not_found'));
}

$block1->closeToggle();
$block1->closeForm();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval && $permissionDetail->prp_modify_project_properties[0] == enumBoolean::bTrue) {
    $block1->openPaletteScript();
    $block1->paletteScript(1, 'edit', '../projects/budgetwizard.php?id=' . $id . $urlBornes, 'true,true,false', $strings['edit']);
    $block1->closePaletteScript('', '');
}

if ($permissionDetail->prp_view_expense[0] == enumBoolean::bTrue) {
    $block2 = new block();
    $block2->form = 'exL';
    $block2->openForm('../projects/viewprojectaccounting.php?id=' . $id . $urlBornes . '#' . $block2->form . 'Anchor');
    $block2->headingToggle(lang_strings('expenses'), !($toggle_focus=='expenses'));
    $block2->borne = $blockPage->returnBorne('2');
    $block2->rowsLimit = '12';
    $block2->sorting('expense', (isset($sortingUser['expense'])?$sortingUser['expense']:''), 'exp.docdate ASC', $sortingFields = array(0 => 'exp.docdate', 1 => 'mem.name', 2 => 'exp.status', 3 => 'exp.expensetype', 4 => 'exp.billable', 5 => 'exp.currency', 6 => 'exp.amount'));
    $querymore = " WHERE exp.project='$id' ORDER BY " . $block2->sortingValue;
    $block2->recordsTotal = compt($initrequest['expenses'] . ' ' . $querymore);
    $listExpenses = new request();
    $listExpenses->openExpenses($querymore, $block2->borne, $block2->rowsLimit);
    $comptListExpenses = count($listExpenses->exp_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['date'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['owner'];
    $columns[1]->field_type = enumFieldType::ftNumeric;
    $columns[1]->linked_table = 'members';
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['status'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['expense_type'];
    $columns[3]->field_type = enumFieldType::ftNumeric;
    $columns[3]->linked_table = 'expense_type';
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['bill_client'];
    $columns[4]->field_type = enumFieldType::ftBoolean;
    $columns[5] = new cardviewColumn();
    $columns[5]->title = $strings['currency'];
    $columns[5]->field_type = enumFieldType::ftText;
    $columns[6] = new cardviewColumn();
    $columns[6]->title = $strings['amount'];
    $columns[6]->field_type = enumFieldType::ftTotals;
    $opt[enumCardviewOption::oTableName] = 'expenses';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oObject] = 'expenses';
    $opt[enumCardviewOption::oExtraParameters] = 'project=' . $id . $urlBornes . '&borne2=' . $block2->borne;

    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_create_expense[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = '../expenses/editexpense.php?project=' . $id . $urlBornes;
        }
    }

    $block2->openCardView($opt);

    for ($i=0; $i<$comptListExpenses; $i++) {
        $content = array(
            createDate($listExpenses->exp_docdate[$i],'date',false,true),
            $listExpenses->exp_owner[$i],
            $statusAccountDoc[$listExpenses->exp_status[$i]],
            $listExpenses->exp_expensetype[$i],
            $listExpenses->exp_billable[$i],
            $listExpenses->exp_currency[$i],
            $listExpenses->exp_amount[$i]
        );
        $block2->itemCardView($listExpenses->exp_id[$i], $content);
    }

    $block2->closeCardView();
    $block2->bornesFooter("2", $blockPage->bornesNumber, 'toggle_focus=expenses&id=' . $id . $urlBornes);
    $block2->closeToggle();
    $block2->closeFormResults();
}

require_once('../includes/footer.php');
