<?php // $Revision: 1.17 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: completed.php,v 1.17 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/completed.php
 *
 * show completed tasks for a particular timespan
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Variables init
 */
$S_dep = (isset($_POST['S_DEPSEL'])?$_POST['S_DEPSEL']:'');
$S_mem = (isset($_POST['S_ATSEL'])?$_POST['S_ATSEL']:'');
$S_date1 = (isset($_POST['S_DATE1'])?$_POST['S_DATE1']:'');
$S_date2 = (isset($_POST['S_DATE2'])?$_POST['S_DATE2']:'');

if ($S_dep !== '' && !is_array($S_dep)) {
    $S_dep = explode("**", $S_dep);
}

if ($S_mem !== '' && !is_array($S_mem)) {
    $S_mem = explode("**", $S_mem);
}

// load report info
$querymore = " WHERE rep.name='completed_task_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selectcompleted.php', lang_strings("completed_task_report"), 'in'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/completed.php#" . $block1->form . "Anchor");
echo '<input type="hidden" name="S_DEPSEL" value="' . ((is_array($S_dep))?implode("**", $S_dep):$S_dep) . '">';
echo '<input type="hidden" name="S_ATSEL" value="' . ((is_array($S_mem))?implode("**", $S_mem):$S_mem) . '">';
echo '<input type="hidden" name="S_DATE1" value="' . $S_date1 . '">';
echo '<input type="hidden" name="S_DATE2" value="' . $S_date2 . '">';
$block1->openContent();
$block1->sorting("tasks", (isset($sortingUser['tasks'])?$sortingUser['tasks']:''), "tas.name ASC", $sortingFields = array(0 => "tas.assigned_to", 1 => "tas.name", 2 => "tas.project", 3 => "tas.complete_date"));
$query = " WHERE tas.status=" . enumStatus::stCompleted . " AND tas.milestone<>'" . enumMilestone::msYes . "'";

if ($S_dep !== '' || $S_mem !== '') {
    $query .= " AND EXISTS (SELECT * FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "members resm ON resm.id=res.resource WHERE res.task=tas.id AND res.type='" . enumResourceType::rtUser . "'";

    // a department selection was made
    if ($S_dep !== '') {
        $query .= " AND resm.department" . ((is_array($S_dep))?" IN ('" . implode("','", $S_dep) . "')":"='$S_dep'");
    }

    // a member selection was made
    if ($S_mem !== '') {
        $query .= " AND res.resource" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
    }

    $query .= ")";
} else {
    $query .= " AND tas.assigned_to='0'";
}

if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $query .= " AND tas.complete_date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $query .= " AND tas.complete_date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}

$queryS = " ORDER BY " . $block1->sortingValue;
$listTasks = new request();
$listTasks->openHierarchyOfTasks($query, $queryS);
$comptListTasks = count($listTasks->tas_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListTasks == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListTasks == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListTasks . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListTasks > 0) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", $strings["export"]);
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $_SESSION['TARGET'] = 'exportcompleted';
    $params = array();
    // department selection
    $params['S_DEPSEL'] = $S_dep;
    // member selection
    $params['S_ATSEL'] = $S_mem;
    // handle date ranges
    $params['S_DATE1'] = $S_date1;
    $params['S_DATE2'] = $S_date2;
    $_SESSION['PARAMS'] = $params;
    $block1->paletteScript(0, "export", "../reports/exportcompleted.php", "true,false,false", $strings["export"]);
    $block1->closePaletteScript($comptListOrganizations, $listOrganizations->org_id);
}

// set up the header string
$block1->heading(lang_strings('completed_task_report'));

if ($comptListTasks > 0) {
    $labels = array(lang_strings("assigned_to"), lang_strings("task"), lang_strings("project"), lang_strings("complete_date"));
    $block1->openResults(false);
    $block1->labels($labels, "false");

    for ($i=0; $i<$comptListTasks; $i++) {
        $block1->openRow();

        if ($listTasks->tas_assigned_to[$i] == "0") {
            $block1->cellRow(lang_strings("unassigned"));
        } else {
            $tmpquery = " AND res.task='" . $listTasks->tas_id[$i] . "'";
            $resourceUsage = new request();
            $resourceUsage->openTaskHumanResource($tmpquery);
            $comptResourceUsage = count($resourceUsage->res_id);
            $assignedToStrings = "";

            for ($j = 0;$j < $comptResourceUsage;$j++) {
                if ($j > 0) {
                    $assignedToStrings .= "&nbsp;";
                }

                $assignedToStrings .= $blockPage->buildLink($resourceUsage->res_resource[$j], '', 'message');
            }

            $block1->cellRow($assignedToStrings);
        }

        $block1->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], 'in'));
        $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTasks->tas_project[$i], $listTasks->tas_pro_name[$i], 'in'));
        $block1->cellRow(createDate($listTasks->tas_complete_date[$i],'date',false,true));
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeFormResults();
require_once("../includes/footer.php");
