<?php // $Revision: 1.29 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: createreport.php,v 1.29 2013/01/18 09:50:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$cat = AddSlashesNOD(isset($_GET['cat'])?$_GET['cat']:'');
$step = isset($_GET['step'])?$_GET['step']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$error = '';
$n_highlight = false;

if ((isset($_SESSION['PARAMS'])) && is_array($_SESSION['PARAMS'])) {
    $params = $_SESSION['PARAMS'];
} else {
    $params = array();
}

if ($step == '') {
    $step = '0';
}

switch ($step) {
    case '1':   // Report Name, Description & Target table
        $n = isset($params['n'])?$params['n']:'';             // report name
        $np = isset($params['np'])?$params['np']:'';          // report name print
        $d = isset($params['d'])?$params['d']:'';             // report description
        $tbl = isset($params['tbl'])?$params['tbl']:'';       // target table id
        break;
    case '2':   // Related tables
        $lt = isset($_POST['lt'])?$_POST['lt']:'';          // path of related tables
        $ltt = isset($_POST['ltt'])?$_POST['ltt']:'';       // table name of related tables
        $ltd = isset($_POST['ltd'])?$_POST['ltd']:'';       // description of related tables
        $ltx = isset($_POST['ltx'])?$_POST['ltx']:'';       // path of new related table
        $lttx = isset($_POST['lttx'])?$_POST['lttx']:'';    // table name of new related table
        $ltdx = isset($_POST['ltdx'])?$_POST['ltdx']:'';    // description of new related table
        break;
    case '3':   // Conditions and Parameters
        $ctbl = isset($_POST['ctbl'])?$_POST['ctbl']:'';    // table index
        $cfld = isset($_POST['cfld'])?$_POST['cfld']:'';    // field name
        $cop = isset($_POST['cop'])?$_POST['cop']:'';       // field operation
        $cval = isset($_POST['cval'])?$_POST['cval']:'';    // field value
        $cval1 = isset($_POST['cval1'])?$_POST['cval1']:''; // field value 1
        $cval2 = isset($_POST['cval2'])?$_POST['cval2']:''; // field value 2
        $ccmp = isset($_POST['ccmp'])?$_POST['ccmp']:'';    // compare to another field
        $cvtb = isset($_POST['cvtb'])?$_POST['cvtb']:'';    // table path of another field
        $cpam = isset($_POST['cpam'])?$_POST['cpam']:'';    // field as paramenter
        $cpi = isset($_POST['cpi'])?$_POST['cpi']:'';       // deletion index
        break;
    case '4':   // Fields and Sorting Orders
        $otbl = isset($_POST['otbl'])?$_POST['otbl']:array();    // table index
        $ofld = isset($_POST['ofld'])?$_POST['ofld']:array();    // field name
        $otit = isset($_POST['otit'])?$_POST['otit']:array();    // title
        $osto = isset($_POST['osto'])?$_POST['osto']:array();    // sorting order
        $ostt = isset($_POST['ostt'])?$_POST['ostt']:array();    // sorting type
        $ogrp = isset($_POST['ogrp'])?$_POST['ogrp']:array();    // field grouping
        $ofun = isset($_POST['ofun'])?$_POST['ofun']:array();    // field function
        $outi = isset($_POST['outi'])?$_POST['outi']:'';    // deletion index
        break;
}

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Edit'][$profilSession]) {
    header('Location: ../reports/listreports.php?cat=' . $cat . '&msg=permissiondenied');
    exit;
}

/**
 * Check Report Categories
 */
if ($cat !== '') {
    $querymore1 = " WHERE repc.id='$cat'";
    $reportCategory = new request();
    $reportCategory->openReportCategory($querymore1);

    if (count($reportCategory->repc_id) === 0) {
        $cat = '';
    }
}

if ($cat == '') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Fields check
 */
if ($action != '') {
    switch ($step) {
        case '1':   // Report Name, Description & Target table
            $n = isset($_POST['n'])?$_POST['n']:'';             // report name
            $np = isset($_POST['np'])?$_POST['np']:'';          // report name print
            $d = isset($_POST['d'])?$_POST['d']:'';             // report description
            $tbl = isset($_POST['tbl'])?$_POST['tbl']:'';       // target table id
            $querymore = " WHERE rep.name='$n'";
            $reportTest = new request();
            $reportTest->openReports($querymore);

            if (count($reportTest->rep_id) > 0) {
                $error = lang_strings("report_name_already_exists");
                $bodyCommand = "onLoad=\"document.crepForm.n.focus();\"";
                $n_highlight = true;
            }

            break;
        case '2':   // Related tables
            $lt1 = array();
            $ltt1 = array();
            $ltd1 = array();

            if (is_array($lt)) {
                $lt1 = $lt;
                $ltt1 = $ltt;
                $ltd1 = $ltd;
            } else if ($lt != '') {
                $lt1[] = $lt;
                $ltt1[] = $ltt;
                $ltd1[] = $ltd;
            }

            if ($ltx != '') {
                if ($action == 'addlt') {
                    $lt1[] = $ltx;
                    $ltt1[] = $lttx;
                    $ltd1[] = $ltdx;
                } else if ($action == 'dellt') {
                    $k = array_search($ltx, $lt1);

                    if ($k !== false) {
                        unset($lt1[$k]);
                        unset($ltt1[$k]);
                        unset($ltd1[$k]);
                    }
                }
            }

            break;
        case '3':   // Conditions and Parameters
            if ($action == 'addcp') {
                if ($cop != enumRatio::rInRange && $cop != enumRatio::rNotInRange) {
                    if ($cval == '' || (is_array($cval) && count($cval) == 0)) {
                        $error = lang_strings('alert_mandatory_field');
                    }
                }
            }

            break;
        case '4':   // Fields and Sorting Orders
            if ($action == 'add') {
                $cnt1 = 0;      // field count
                $cnt2 = 0;      // grouping count
                $cnt3 = 0;      // function count
                $ltt = (isset($params['ltt'])?$params['ltt']:array());  // related table names
                $tbl = $params['tbl'];  // main table name

                for ($i=0; (($i<count($otbl)) && ($error=='')); $i++) {
                    if ($ofld[$i] == '') {
                        continue;
                    }

                    $cnt1++;        // count output field

                    if ($ogrp[$i] == 'Y') {
                        $cnt2++;    // count field grouping
                    }

                    if ($ofun[$i] == '') {
                        continue;
                    }
                    // table name
                    if ($otbl[$i] == 'x') {
                        $t = $tbl;
                    } else {
                        $k = str_replace('x', '', $otbl[$i]);
                        $t = $ltt[$k];
                    }
                    // get field definition
                    $querymore = " WHERE fdf.tablename='$t' AND fdf.fieldname='" . $ofld[$i] . "'";
                    $fieldDef = new request();
                    $fieldDef->openFieldsDefinitions($querymore);

                    switch ($fieldDef->fdf_fieldtype[0]) {
                        case enumFieldType::ftText:
                        case enumFieldType::ftAlphaNumeric:
                        case enumFieldType::ftMemo:
                        case enumFieldType::ftBoolean:
                        case enumFieldType::ftEmail:
                        case enumFieldType::ftUrl:
                            // only 'count' available for text-based field
                            if ($ofun[$i] != 'count') {
                                $error = lang_strings('sql_comp_error');
                            }

                            break;
                        case enumFieldType::ftNumeric:
                        case enumFieldType::ftDate:
                        case enumFieldType::ftTime:
                        case enumFieldType::ftSerial:
                        case enumFieldType::ftTimestamp:
                            // 'avg' & 'sum' only for float type fields
                            if ($ofun[$i] == 'avg' || $ofun[$i] == 'sum') {
                                $error = lang_strings('sql_comp_error');
                            }

                            break;
                    }

                    $cnt3++;        // count field function
                }

                if ($error == '') {
                    if ($cnt1 === 0) {
                        $action = '';   // no output field selected
                    } else if ((($cnt2 + $cnt3) > 0) && ($cnt1 !== ($cnt2 + $cnt3))) {
                        $error = lang_strings('sql_comp_error');
                    }
                }
            }

            break;
    }
}

/**
 * Actions
 */
if (($error == '') && ($action != '')) {
    switch ($step) {
        case '0':   // Introduction to the Report Wizard
            if (isset($_SESSION['PARAMS'])) {
                unset($_SESSION['PARAMS']);
            }

            header("Location: ../reports/createreport.php?step=1&cat=$cat");
            exit;
        case '1':   // Report Name, Description & Target table
            $params['n'] = $n;
            $params['np'] = $np;
            $params['d'] = $d;
            $params['tbl'] = $tbl;
            $params['tbldesc'] = tableNameString($tbl);
            // unset related tables
            unset($params['lt'], $params['ltt'], $params['ltd']);
            $_SESSION['PARAMS'] = $params;
            $_SESSION['SOURCE'] = 'createreport';
            $_SESSION['LOCATION'] = "../reports/createreport.php?step=$step&cat=$cat";
            header("Location: ../reports/createreport.php?step=2&cat=$cat");
            exit;
        case '2':   // Related tables
            $params['lt'] = $lt1;
            $params['ltt'] = $ltt1;
            $params['ltd'] = $ltd1;
            // unset conditions and parameters
            unset($params['ctbl'], $params['cfld'], $params['cop'], $params['ccmp'], $params['cvtb'], $params['cpam'], $params['cval'], $params['cstr']);
            $_SESSION['PARAMS'] = $params;
            $_SESSION['SOURCE'] = 'createreport';
            $_SESSION['LOCATION'] = "../reports/createreport.php?step=$step&cat=$cat";

            if ($action == 'add') {
                header("Location: ../reports/createreport.php?step=3&cat=$cat");
                exit;
            }

            break;
        case '3':   // Conditions and Parameters
            if ($action == 'addcp') {
                $lt = (isset($params['lt'])?$params['lt']:array());
                $ltt = (isset($params['ltt'])?$params['ltt']:array());
                $ltd = (isset($params['ltd'])?$params['ltd']:array());
                $cstr = '';

                if ($ctbl == 'x') {
                    $cstr .= $params['tbldesc'];
                    $t = $params['tbl'];
                } else {
                    $k = str_replace('x', '', $ctbl);
                    $cstr .= $ltd[$k];
                    $t = $ltt[$k];
                }

                $querymore = " WHERE fdf.tablename='$t' AND fdf.fieldname='$cfld' ORDER BY fdf.disporder";
                $fieldDefinitionDetail = new request();
                $fieldDefinitionDetail->openFieldsDefinitions($querymore);
                $fldtyp = $fieldDefinitionDetail->fdf_fieldtype[0];
                $cstr .= '.' . $fieldDefinitionDetail->fdf_fielddesc[0];
                $cstr .= ' ' . $ratioArray[$cop];

                if ($cpam != 'Y') {
                    if ($ccmp == 'Y') {
                        if ($cvtb == 'x') {
                            $cstr .= ' ' . $params['tbldesc'];
                            $t = $params['tbl'];
                        } else {
                            $k = str_replace('x', '', $cvtb);
                            $cstr .= ' ' . $ltd[$k];
                            $t = $ltt[$k];
                        }

                        $cstr .= '.' . fieldNameString($t, $cval);
                    } else {
                        if ($cop == enumRatio::rInRange || $cop == enumRatio::rNotInRange) {
                            $cstr .= ' ' . DbValueDecode($fldtyp, $cval1) . ' ' . $strings['and'] . ' ' . DbValueDecode($fldtyp, $cval2);
                        } else if (is_array($cval)) {
                            $querymore = " WHERE fvd.tablename='$t' AND fvd.fieldname='$cfld' AND fvd.fieldvalue IN ('" . implode("','", $cval) . "') ORDER BY fvd.fieldvalue";
                            $listFieldValueDef = new request();
                            $listFieldValueDef->openFieldsValuesDefinitions($querymore);
                            $cstr .= ' ' . implode(",", $listFieldValueDef->fvd_fieldvalue_desc);
                        } else {
                            $cstr .= ' ' . DbValueDecode($fldtyp, $cval);
                        }
                    }
                }

                $ctblx = isset($params['ctbl'])?$params['ctbl']:array();    // table index
                $cfldx = isset($params['cfld'])?$params['cfld']:array();    // field name
                $copx = isset($params['cop'])?$params['cop']:array();       // field operation
                $cvalx = isset($params['cval'])?$params['cval']:array();    // field value
                $ccmpx = isset($params['ccmp'])?$params['ccmp']:array();    // compare to another field
                $cvtbx = isset($params['cvtb'])?$params['cvtb']:array();    // table path of another field
                $cpamx = isset($params['cpam'])?$params['cpam']:array();    // field as paramenter
                $cstrx = isset($params['cstr'])?$params['cstr']:array();    // description for conditions/parameters
                $ctblx[] = $ctbl;
                $cfldx[] = $cfld;
                $copx[] = $cop;
                $ccmpx[] = $ccmp;
                $cvtbx[] = $cvtb;
                $cpamx[] = $cpam;
                $cstrx[] = $cstr;

                if ($cpam != 'Y') {
                    if ($cop == enumRatio::rInRange || $cop == enumRatio::rNotInRange) {
                        $cvalx[] = array(DbValueEncode($fldtyp, $cval1), DbValueEncode($fldtyp, $cval2));
                    } else {
                        $cvalx[] = DbValueEncode($fldtyp, $cval);
                    }
                } else {
                    $cvalx[] = $cval;
                }

                $params['ctbl'] = $ctblx;
                $params['cfld'] = $cfldx;
                $params['cop'] = $copx;
                $params['ccmp'] = $ccmpx;
                $params['cvtb'] = $cvtbx;
                $params['cpam'] = $cpamx;
                $params['cval'] = $cvalx;
                $params['cstr'] = $cstrx;
                // reset all condition and parameter variables
                $ctbl = $cfld = $cop = $ccmp = $cvtb = $cpam = $cval = $cval1 = $cval2 = '';
            } else if ($action == 'delcp') {
                $ctblx = isset($params['ctbl'])?$params['ctbl']:array();    // table index
                $cfldx = isset($params['cfld'])?$params['cfld']:array();    // field name
                $copx = isset($params['cop'])?$params['cop']:array();       // field operation
                $cvalx = isset($params['cval'])?$params['cval']:array();    // field value
                $ccmpx = isset($params['ccmp'])?$params['ccmp']:array();    // compare to another field
                $cvtbx = isset($params['cvtb'])?$params['cvtb']:array();    // table path of another field
                $cpamx = isset($params['cpam'])?$params['cpam']:array();    // field as paramenter
                $cstrx = isset($params['cstr'])?$params['cstr']:array();    // description for conditions/parameters
                unset($ctblx[$cpi], $cfldx[$cpi], $copx[$cpi], $cvalx[$cpi], $ccmpx[$cpi], $cvtbx[$cpi], $cpamx[$cpi], $cstrx[$cpi]);
                $params['ctbl'] = $ctblx;
                $params['cfld'] = $cfldx;
                $params['cop'] = $copx;
                $params['ccmp'] = $ccmpx;
                $params['cvtb'] = $cvtbx;
                $params['cpam'] = $cpamx;
                $params['cval'] = $cvalx;
                $params['cstr'] = $cstrx;
            }

            $_SESSION['PARAMS'] = $params;
            $_SESSION['SOURCE'] = 'createreport';
            $_SESSION['LOCATION'] = "../reports/createreport.php?step=$step&cat=$cat";

            if ($action == 'add') {
                header("Location: ../reports/createreport.php?step=4&cat=$cat");
                exit;
            }

            break;
        case '4':   // Fields and Sorting Orders
            if ($action == 'delout') {
                unset($otbl[$outi], $ofld[$outi], $otit[$outi], $osto[$outi], $ostt[$outi], $ogrp[$outi], $ofun[$outi]);
                $otbl = array_values($otbl);
                $ofld = array_values($ofld);
                $otit = array_values($otit);
                $osto = array_values($osto);
                $ostt = array_values($ostt);
                $ogrp = array_values($ogrp);
                $ofun = array_values($ofun);
            } else if ($action == 'add') {
                $otblx = array();
                $ofldx = array();
                $otitx = array();
                $ostox = array();
                $osttx = array();
                $ogrpx = array();
                $ofunx = array();

                for ($i=0; $i<count($otbl); $i++) {
                    if ($ofld[$i] != '') {
                        $otblx[] = $otbl[$i];
                        $ofldx[] = $ofld[$i];
                        $otitx[] = $otit[$i];
                        $ostox[] = $osto[$i];
                        $osttx[] = $ostt[$i];
                        $ogrpx[] = $ogrp[$i];
                        $ofunx[] = $ofun[$i];
                    }
                }

                $params['otbl'] = $otblx;
                $params['ofld'] = $ofldx;
                $params['otit'] = $otitx;
                $params['osto'] = $ostox;
                $params['ostt'] = $osttx;
                $params['ogrp'] = $ogrpx;
                $params['ofun'] = $ofunx;
            }

            $_SESSION['PARAMS'] = $params;
            $_SESSION['SOURCE'] = 'createreport';
            $_SESSION['LOCATION'] = "../reports/createreport.php?step=$step&cat=$cat";

            if ($action == 'add') {
                $requestAct = new request();
                $requestAct->connectClass();     // connect to database server

                try {
                    $requestAct->startTransaction();
                    // Report Name, Description & Target table
                    $tmpsql = "INSERT INTO " . $tablePrefix . "reports (category,name,url,tablename,sysdef,created,cuser) VALUES ('$cat','" . $params['n'] . "','','" . $params['tbl'] . "','N','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num = $requestAct->newId("reports");
                    updateString($requestAct, 'REP__' . $params['n'], $params['np']);       // report name print
                    updateString($requestAct, 'REPDESC__' . $params['n'], $params['d']);    // report description
                    // Related tables
                    $tbl = $params['tbl'];
                    $lt = (isset($params['lt'])?$params['lt']:array());
                    $ltt = (isset($params['ltt'])?$params['ltt']:array());
                    $lti = array();
                    $c = 1;     // current depth
                    $m = 0;     // maximum depth
                    // determine the maximum depth of related tables
                    foreach ($lt as $k => $t) {
                        $lti[$k] = 0;
                        $c1 = substr_count($t, '.');

                        if ($c1 > $m) {
                            $m = $c1;
                        }
                    }

                    while ((count($lt) > 0) && ($c <= $m)) {
                        foreach ($lt as $k => $t) {
                            $c1 = substr_count($t, '.');

                            if ($c1 == $c) {
                                if ($c1 === 1) {
                                    $table_left = 0;
                                } else {
                                    $k1 = array_search(substr($t, 0, strrpos($t, '.')), $lt);
                                    $table_left = $lti[$k1];
                                }

                                $field_left = substr(strrchr($t, '.'), 1);
                                $tmpsql = "INSERT INTO " . $tablePrefix . "reports_rel_tables (report,tablename,table_left) VALUES ('$num','" . $ltt[$k] . "','$table_left')";

                                if ($requestAct->query($tmpsql) === false) {
                                    throw new Exception($tmpsql);
                                }

                                $lti[$k] = $requestAct->newId("reports_rel_tables");
                                $tmpsql = "INSERT INTO " . $tablePrefix . "reports_rel_fields (report,rel_table,field_left,field_right) VALUES ('$num','" . $lti[$k] . "','$field_left','id')";

                                if ($requestAct->query($tmpsql) === false) {
                                    throw new Exception($tmpsql);
                                }
                            }
                        }

                        $c++;
                    }
                    // Conditions and Parameters
                    $ctblx = isset($params['ctbl'])?$params['ctbl']:array();    // table index

                    if (count($ctblx) > 0) {
                        $cfldx = isset($params['cfld'])?$params['cfld']:array();    // field name
                        $copx = isset($params['cop'])?$params['cop']:array();       // field operation
                        $cvalx = isset($params['cval'])?$params['cval']:array();    // field value
                        $ccmpx = isset($params['ccmp'])?$params['ccmp']:array();    // compare to another field
                        $cvtbx = isset($params['cvtb'])?$params['cvtb']:array();    // table path of another field
                        $cpamx = isset($params['cpam'])?$params['cpam']:array();    // field as paramenter

                        foreach ($ctblx as $k => $v) {
                            if ($v == 'x') {
                                $rel_table = 0;
                            } else {
                                $kx = str_replace('x', '', $v);
                                $rel_table = $lti[$kx];
                            }

                            if (is_array($cvalx[$k])) {
                                $cvalEa = array();

                                foreach ($cvalx[$k] as $v) {
                                    $cvalEa[] = HtmlEntitiesNOD($v);
                                }

                                $cvalE = implode('**', $cvalEa);
                            } else {
                                $cvalE = HtmlEntitiesNOD($cvalx[$k]);
                            }

                            if ($ccmpx[$k] == 'Y') {
                                $ccmpE = enumBoolean::bTrue;

                                if ($cvtbx[$k] == 'x') {
                                    $cvtbE = 0;
                                } else {
                                    $kx = str_replace('x', '', $cvtbx[$k]);
                                    $cvtbE = $lti[$kx];
                                }
                            } else {
                                $ccmpE = enumBoolean::bFalse;
                                $cvtbE = 0;
                            }

                            $cpamE = (($cpamx[$k]=='Y')?enumBoolean::bTrue:enumBoolean::bFalse);
                            $tmpsql = "INSERT INTO " . $tablePrefix . "reports_criteria (report,rel_table,fieldname,ratio,value,table_right,compare_fields,parameter) VALUES ('$num','$rel_table','" . $cfldx[$k] . "','" . $copx[$k] . "','$cvalE','$cvtbE','$ccmpE','$cpamE')";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }
                        }
                    }
                    // Fields and Sorting Orders
                    $otblx = isset($params['otbl'])?$params['otbl']:array();    // table index

                    if (count($otblx) > 0) {
                        $ofldx = isset($params['ofld'])?$params['ofld']:array();    // field name
                        $otitx = isset($params['otit'])?$params['otit']:array();    // title
                        $ostox = isset($params['osto'])?$params['osto']:array();    // sorting order
                        $osttx = isset($params['ostt'])?$params['ostt']:array();    // sorting type
                        $ogrpx = isset($params['ogrp'])?$params['ogrp']:array();    // field grouping
                        $ofunx = isset($params['ofun'])?$params['ofun']:array();    // field function

                        foreach ($otblx as $k => $v) {
                            if ($v == 'x') {
                                $rel_table = 0;
                            } else {
                                $kx = str_replace('x', '', $v);
                                $rel_table = $lti[$kx];
                            }

                            $otitE = HtmlEntitiesNOD($otitx[$k]);
                            $ostoE = (($ostox[$k]=='')?'0':$ostox[$k]);
                            $ogrpE = (($ogrpx[$k]=='Y')?enumBoolean::bTrue:enumBoolean::bFalse);
                            $tmpsql = "INSERT INTO " . $tablePrefix . "reports_output (report,rel_table,fieldname,title,disp_order,sort_order,sort_type,field_group,field_function) VALUES ('$num','$rel_table','" . $ofldx[$k] . "','$otitE','$k','$ostoE','" . $osttx[$k] . "','$ogrpE','" . $ofunx[$k] . "')";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }
                        }
                    }
                    /**
                     * Generate report query text
                     */
                    $querymore1 = " WHERE rep.id='$num'";
                    $reportDetail = clone $requestAct;
                    $reportDetail->openReports($querymore1);
                    // Get report parameters
                    $querymore3 = " WHERE repr.report='$num' AND repr.parameter='" . enumBoolean::bTrue . "' ORDER BY repr.id";
                    $listParameters = clone $requestAct;
                    $listParameters->openReportsCriteria($querymore3);
                    $comptListParameters = count($listParameters->repr_report);
                    // Get report output and field grouping
                    $querymore6 = " WHERE repo.report='$num' ORDER BY repo.disp_order";
                    $listReportOutput = clone $requestAct;
                    $listReportOutput->openReportsOutput($querymore6);
                    $comptListReportOutput = count($listReportOutput->repo_id);
                    $select_expr = array();
                    $select_group = array();

                    for ($i=0; $i<$comptListReportOutput; $i++) {
                        if ($listReportOutput->repo_field_function[$i] == '') {
                            $expr = '';
                        } else {
                            $expr = $listReportOutput->repo_field_function[$i] . '(';
                        }

                        $expr .= 't' . $listReportOutput->repo_rel_table[$i] . '.' . $listReportOutput->repo_fdf_dbfieldname[$i];

                        if ($listReportOutput->repo_field_function[$i] != '') {
                            $expr .= ')';
                        }

                        $select_expr[] = $expr;

                        if ($listReportOutput->repo_field_group[$i] == enumBoolean::bTrue) {
                            $select_group[] = 't' . $listReportOutput->repo_rel_table[$i] . '.' . $listReportOutput->repo_fdf_dbfieldname[$i];
                        }
                    }
                    // Get related tables
                    $querymore7 = " WHERE repl.report='$num' ORDER BY repl.table_left";
                    $listReportRelatedTables = clone $requestAct;
                    $listReportRelatedTables->openReportsRelatedTables($querymore7);
                    $comptListReportRelatedTables = count($listReportRelatedTables->repl_id);
                    $table_references = " FROM [[" . $reportDetail->rep_tablename[0] . "]] t0";

                    for ($i=0; $i<$comptListReportRelatedTables; $i++) {
                        $t1 = 't' . $listReportRelatedTables->repl_id[$i];
                        $t2 = 't' . $listReportRelatedTables->repl_table_left[$i];
                        $table_references .= " LEFT OUTER JOIN [[" . $listReportRelatedTables->repl_tablename[$i] . "]] $t1 ON ";
                        $querymore8 = " WHERE replf.rel_table='" . $listReportRelatedTables->repl_id[$i] . "'";
                        $listReportRelatedFields = clone $requestAct;
                        $listReportRelatedFields->openReportsRelatedFields($querymore8);
                        $comptListReportRelatedFields = count($listReportRelatedFields->repl_id);

                        for ($j=0; $j<$comptListReportRelatedFields; $j++) {
                            if ($j > 0) {
                                $table_references .= " AND ";
                            }

                            if (($listReportRelatedFields->repl_fdfl_fieldtype[$j]!=$listReportRelatedFields->repl_fdfr_fieldtype[$j]) || ($listReportRelatedFields->repl_fdfl_length[$j]!=$listReportRelatedFields->repl_fdfr_length[$j])) {
                                $typ = DbCastType($listReportRelatedFields->repl_fdfl_fieldtype[$j], $listReportRelatedFields->repl_fdfl_length[$j], $listReportRelatedFields->repl_fdfr_fieldtype[$j], $listReportRelatedFields->repl_fdfr_length[$j]);
                                $table_references .= "CAST(" . $t1 . "." . $listReportRelatedFields->repl_fdfr_dbfieldname[$j] . " AS $typ)" . "=CAST(" . $t2 . "." . $listReportRelatedFields->repl_fdfl_dbfieldname[$j] . " AS $typ)";
                            } else {
                                $table_references .= $t1 . "." . $listReportRelatedFields->repl_fdfr_dbfieldname[$j] . "=" . $t2 . "." . $listReportRelatedFields->repl_fdfl_dbfieldname[$j];
                            }
                        }
                    }

                    $where_conditions = array();

                    for ($i=0,$uid=1; $i<$comptListParameters; $i++,$uid++) {
                        $fldtyp = (($listParameters->repr_fieldtype[$i]=='')?$listParameters->repr_fdf_fieldtype[$i]:$listParameters->repr_fieldtype[$i]);

                        if ($listParameters->repr_ratio[$i] == enumRatio::rEqual) {
                            $where_conditions[] = "(t" . $listParameters->repr_rel_table[$i] . "." . $listParameters->repr_fdf_dbfieldname[$i] . "='[[$" . $uid . "]]' OR '[[$" . $uid . "]]'='" . DbValueEncode($fldtyp, '') . "')";
                        } else {
                            $where_conditions[] = "((t" . $listParameters->repr_rel_table[$i] . "." . $listParameters->repr_fdf_dbfieldname[$i] . ">='[[$" . $uid . ".1]]' OR '[[$" . $uid . ".1]]'='" . DbValueEncode($fldtyp, '') . "') AND (t" . $listParameters->repr_rel_table[$i] . "." . $listParameters->repr_fdf_dbfieldname[$i] . "<='[[$" . $uid . ".2]]' OR '[[$" . $uid . ".2]]'='" . DbValueEncode($fldtyp, '') . "'))";
                        }
                    }
                    // Get report criteria
                    $querymore8 = " WHERE repr.report='$num' AND repr.parameter<>'" . enumBoolean::bTrue . "'";
                    $listReportCriteria = clone $requestAct;
                    $listReportCriteria->openReportsCriteria($querymore8);
                    $comptListReportCriteria = count($listReportCriteria->repr_id);

                    for ($i=0; $i<$comptListReportCriteria; $i++) {
                        if ($listReportCriteria->repr_compare_fields[$i] == enumBoolean::bTrue) {
                            if (($listReportCriteria->repr_fdf_fieldtype[$i] != $listReportCriteria->repr_fdf_fieldtype_right[$i]) || ($listReportCriteria->repr_fdf_length[$i] != $listReportCriteria->repr_fdf_length_right[$i])) {
                                $typ = DbCastType($listReportCriteria->repr_fdf_fieldtype[$i], $listReportCriteria->repr_fdf_length[$i], $listReportCriteria->repr_fdf_fieldtype_right[$i], $listReportCriteria->repr_fdf_length_right[$i]);
                                $where_conditions[] = "CAST(t" . $listReportCriteria->repr_rel_table[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname[$i] . " AS $typ)" . $sqlOparators[$listReportCriteria->repr_ratio[$i]] . "CAST(t" . $listReportCriteria->repr_table_right[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname_right[$i] . " AS $typ)";
                            } else {
                                $where_conditions[] = "t" . $listReportCriteria->repr_rel_table[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname[$i] . $sqlOparators[$listReportCriteria->repr_ratio[$i]] . "t" . $listReportCriteria->repr_table_right[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname_right[$i];
                            }
                        } else {
                            $pattern = '/^.+\*\*.+$/';

                            if (preg_match($pattern, $listReportCriteria->repr_value[$i])) {
                                $cval = explode('**', $listReportCriteria->repr_value[$i]);

                                switch ($listReportCriteria->repr_ratio[$i]) {
                                    case enumRatio::rInRange:
                                        $where_conditions[] = "t" . $listReportCriteria->repr_rel_table[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname[$i] . ">='" . HtmlEntitiesNOD($cval[0]) . "' AND t" . $listReportCriteria->repr_rel_table[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname[$i] . "<='" . HtmlEntitiesNOD($cval[1]) . "'";
                                        break;
                                    case enumRatio::rNotInRange:
                                        $where_conditions[] = "NOT (t" . $listReportCriteria->repr_rel_table[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname[$i] . ">='" . HtmlEntitiesNOD($cval[0]) . "' AND t" . $listReportCriteria->repr_rel_table[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname[$i] . "<='" . HtmlEntitiesNOD($cval[1]) . "')";
                                        break;
                                    default:
                                        $where_conditions[] = "t" . $listReportCriteria->repr_rel_table[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname[$i] . " IN ('" . implode("','", $cval) . "')";
                                }
                            } else {
                                $cval = HtmlEntitiesNOD($listReportCriteria->repr_value[$i]);

                                switch ($listReportCriteria->repr_ratio[$i]) {
                                    case enumRatio::rContains:
                                        $where_conditions[] = "t" . $listReportCriteria->repr_rel_table[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname[$i] . " LIKE '%" . $cval . "%'";
                                        break;
                                    case enumRatio::rBeginWith:
                                        $where_conditions[] = "t" . $listReportCriteria->repr_rel_table[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname[$i] . " LIKE '" . $cval . "%'";
                                        break;
                                    case enumRatio::rEndWith:
                                        $where_conditions[] = "t" . $listReportCriteria->repr_rel_table[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname[$i] . " LIKE '%" . $cval . "'";
                                        break;
                                    default:
                                        $where_conditions[] = "t" . $listReportCriteria->repr_rel_table[$i] . "." . $listReportCriteria->repr_fdf_dbfieldname[$i] . $sqlOparators[$listReportCriteria->repr_ratio[$i]] . "'$cval'";
                                }
                            }
                        }
                    }
                    // Get field sorting orders
                    $querymore9 = " WHERE repo.report='$num' AND repo.sort_order>0 ORDER BY repo.sort_order";
                    $listReportOrders = clone $requestAct;
                    $listReportOrders->openReportsOutput($querymore9);
                    $comptListReportOrders = count($listReportOrders->repo_id);
                    $select_sort = array();

                    for ($i=0; $i<$comptListReportOrders; $i++) {
                        $select_sort[] = 't' . $listReportOrders->repo_rel_table[$i] . '.' . $listReportOrders->repo_fdf_dbfieldname[$i] . (($listReportOrders->repo_sort_type[$i]==0)?' ASC':' DESC');
                    }

                    $userquery = "SELECT " . implode(",", $select_expr) . " " . $table_references;

                    if (count($where_conditions) > 0) {
                        $where_condition_str = '';

                        foreach ($where_conditions as $val) {
                            if ($where_condition_str != '') {
                                $where_condition_str .= ' AND ';
                            }

                            $where_condition_str .= $val;
                        }

                        $userquery .= " WHERE $where_condition_str";
                    }

                    if (count($select_group) > 0) {
                        $userquery .= " GROUP BY " . implode(",", $select_group);
                    }

                    if (count($select_sort) > 0) {
                        $userquery .= " ORDER BY " . implode(",", $select_sort);
                    }

                    $tmpsql = "UPDATE " . $tablePrefix . "reports SET userquery='" . HtmlEntitiesNOD($userquery) . "' WHERE id='$num'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $requestAct->endTransaction(enumTransactionEndType::etCommit);
                } catch (Exception $e) {
                    $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
                    error_log($e->getMessage());
                    $requestAct->endTransaction(enumTransactionEndType::etRollBack);
                }

                $requestAct->close();

                if ($error == '') {
                    header("Location: ../reports/listreports.php?cat=$cat&msg=add");
                    exit;
                }
            }

            break;
    }
}

/**
 * Prepare data
 */
switch ($step) {
    case '1':   // Report Name, Description & Target table
        // get tables definitions
        $querymore = " ORDER BY tdf.sysdef DESC,tdf.tablename";
        $listTablesDefinitions = new request();
        $listTablesDefinitions->openTablesDefinitions($querymore);
        $comptListTablesDefinitions = count($listTablesDefinitions->tdf_id);
        $tblVV = array();

        for ($i=0; $i<$comptListTablesDefinitions; $i++) {
            $tblnam = $listTablesDefinitions->tdf_tablename[$i];
            $tblVV[$tblnam] = tableNameString($tblnam);
        }

        break;
    case '2':   // Related tables
        $tbl = $params['tbl'];
        $tbldesc = $params['tbldesc'];
        $lt = (isset($params['lt'])?$params['lt']:array());
        $ltt = (isset($params['ltt'])?$params['ltt']:array());
        $ltd = (isset($params['ltd'])?$params['ltd']:array());
        $tmpquery = "SELECT fdf.fieldname,fdf.linkedtable FROM " . $tablePrefix . "fields_def fdf WHERE fdf.tablename='$tbl' AND fdf.linkedtable<>'' ORDER BY fdf.disporder";
        $listRelatedTables = new request();
        $listRelatedTables->connectClass();
        $listRelatedTables->query($tmpquery);

        while ($listRelatedTables->fetch()) {
            $fldnam = ($row[0]);
            $fldpath = $tbl . '.' . $fldnam;
            $k = array_search($fldpath, $lt);

            if ($k === false) {
                $listRelatedTables->tablename[] = ($row[1]);
                $listRelatedTables->fieldname[] = $fldpath;
                $listRelatedTables->fielddesc[] = $tbldesc . '.' . fieldNameString($tbl, $fldnam);
            }
        }

        $c = 1;     // current depth
        $m = 0;     // maximum depth
        // determine the maximum depth of related tables
        foreach ($lt as $k => $t) {
            $c1 = substr_count($t, '.');

            if ($c1 > $m) {
                $m = $c1;
            }
        }

        while ((count($lt) > 0) && ($c <= $m)) {
            foreach ($lt as $k => $t) {
                $c1 = substr_count($t, '.');

                if ($c1 == $c) {
                    $querymore = " WHERE fdf.tablename='" . $ltt[$k] . "' AND fdf.linkedtable<>'' ORDER BY fdf.disporder";
                    $listFieldDef = new request();
                    $listFieldDef->openFieldsDefinitions($querymore);
                    $comptListFieldDef = count($listFieldDef->fdf_tablename);

                    for ($i=0; $i<$comptListFieldDef; $i++) {
                        $fldnam = $t . '.' . $listFieldDef->fdf_fieldname[$i];
                        $k1 = array_search($fldnam, $lt);

                        if ($k1 === false) {
                            $listRelatedTables->tablename[] = $listFieldDef->fdf_linkedtable[$i];
                            $listRelatedTables->fieldname[] = $fldnam;
                            $listRelatedTables->fielddesc[] = $ltd[$k] . '.' . $listFieldDef->fdf_fielddesc[$i];
                        }
                    }
                }
            }

            $c++;
        }

        break;
    case '3':   // Conditions and Parameters
        $lt = (isset($params['lt'])?$params['lt']:array());
        $ltt = (isset($params['ltt'])?$params['ltt']:array());
        $ltd = (isset($params['ltd'])?$params['ltd']:array());
        $tbl = $params['tbl'];
        $tbldesc = $params['tbldesc'];
        $ctblVV = array('x' => $tbldesc);

        foreach ($lt as $k => $t) {
            $ctblVV['x' . $k] = $ltd[$k];
        }

        if ($ctbl == '' || $ctbl == 'x') {
            $ctbl = 'x';
            $t = $tbl;
        } else {
            $k = str_replace('x', '', $ctbl);
            $t = $ltt[$k];
        }

        $querymore = " WHERE fdf.tablename='$t' AND fdf.fieldtype NOT IN ('" . enumFieldType::ftImage . "','" . enumFieldType::ftAudio . "','" . enumFieldType::ftVideo . "') ORDER BY fdf.disporder";
        $listFieldDef = new request();
        $listFieldDef->openFieldsDefinitions($querymore);
        $comptListFieldDef = count($listFieldDef->fdf_tablename);
        $cfldVV = array('' => '');

        for ($i=0; $i<$comptListFieldDef; $i++) {
            $cfldVV[$listFieldDef->fdf_fieldname[$i]] = $listFieldDef->fdf_fielddesc[$i];
        }

        if ($cfld != '') {
            $querymore = " WHERE fvd.tablename='$t' AND fvd.fieldname='$cfld' ORDER BY fvd.fieldvalue";
            $listFieldValueDef = new request();
            $listFieldValueDef->openFieldsValuesDefinitions($querymore);
            $comptListFieldValueDef = count($listFieldValueDef->fvd_tablename);
            $copVV = array('' => '');
            $k = array_search($cfld, $listFieldDef->fdf_fieldname);
            $fldtyp = $listFieldDef->fdf_fieldtype[$k];
            $fldlen = $listFieldDef->fdf_length[$k];

            if ($cpam == 'Y') {         // field as parameter
                if ($comptListFieldValueDef > 0) {
                    $copVV[enumRatio::rEqual] = $ratioArray[enumRatio::rEqual];
                } else {
                    $copVV[enumRatio::rEqual] = $ratioArray[enumRatio::rEqual];
                    $copVV[enumRatio::rInRange] = $ratioArray[enumRatio::rInRange];
                }
            } else if ($ccmp == 'Y') {  // compare to another field
                $copVV[enumRatio::rGreaterThan] = $ratioArray[enumRatio::rGreaterThan];
                $copVV[enumRatio::rGreaterOrEqual] = $ratioArray[enumRatio::rGreaterOrEqual];
                $copVV[enumRatio::rLessThan] = $ratioArray[enumRatio::rLessThan];
                $copVV[enumRatio::rLessOrEqual] = $ratioArray[enumRatio::rLessOrEqual];
                $copVV[enumRatio::rEqual] = $ratioArray[enumRatio::rEqual];
                $copVV[enumRatio::rNotEqual] = $ratioArray[enumRatio::rNotEqual];

                if ($cvtb == '' || $cvtb == 'x') {
                    $cvtb = 'x';
                    $tv = $tbl;
                } else {
                    $k = str_replace('x', '', $cvtb);
                    $tv = $ltt[$k];
                }

                $querymore = " WHERE fdf.tablename='$tv' AND fdf.fieldtype='$fldtyp' ORDER BY fdf.disporder";
                $listFieldDefV = new request();
                $listFieldDefV->openFieldsDefinitions($querymore);
                $comptListFieldDefV = count($listFieldDefV->fdf_tablename);
                $cfldvVV = array('' => '');

                for ($i=0; $i<$comptListFieldDefV; $i++) {
                    $cfldvVV[$listFieldDefV->fdf_fieldname[$i]] = $listFieldDefV->fdf_fielddesc[$i];
                }
            } else if (($comptListFieldValueDef > 0) || ($fldtyp == enumFieldType::ftBoolean)) {
                $copVV[enumRatio::rEqual] = $ratioArray[enumRatio::rEqual];
            } else {
                switch ($fldtyp) {
                    case enumFieldType::ftText:
                    case enumFieldType::ftAlphaNumeric:
                    case enumFieldType::ftNumeric:
                    case enumFieldType::ftMemo:
                    case enumFieldType::ftEmail:
                    case enumFieldType::ftUrl:
                        $copVV = $ratioArray;
                        break;
                    case enumFieldType::ftDate:
                    case enumFieldType::ftTime:
                    case enumFieldType::ftHours:
                    case enumFieldType::ftQuantity:
                    case enumFieldType::ftMeasure:
                    case enumFieldType::ftRate:
                    case enumFieldType::ftTotals:
                    case enumFieldType::ftSerial:
                    case enumFieldType::ftTimestamp:
                    case enumFieldType::ftPercentage:
                        $copVV[enumRatio::rGreaterThan] = $ratioArray[enumRatio::rGreaterThan];
                        $copVV[enumRatio::rGreaterOrEqual] = $ratioArray[enumRatio::rGreaterOrEqual];
                        $copVV[enumRatio::rLessThan] = $ratioArray[enumRatio::rLessThan];
                        $copVV[enumRatio::rLessOrEqual] = $ratioArray[enumRatio::rLessOrEqual];
                        $copVV[enumRatio::rEqual] = $ratioArray[enumRatio::rEqual];
                        $copVV[enumRatio::rNotEqual] = $ratioArray[enumRatio::rNotEqual];
                        $copVV[enumRatio::rInRange] = $ratioArray[enumRatio::rInRange];
                        $copVV[enumRatio::rNotInRange] = $ratioArray[enumRatio::rNotInRange];
                        break;
                    default:
                        break;
                }
            }

            if (count($copVV) > 0) {
                if ($cop == '' || !array_key_exists($cop, $copVV)) {
                    $x = array_keys($copVV);
                    $cop = $x[0];
                }
            }
        }

        break;
    case '4':   // Fields and Sorting Orders
        $lt = (isset($params['lt'])?$params['lt']:array());
        $ltt = (isset($params['ltt'])?$params['ltt']:array());
        $ltd = (isset($params['ltd'])?$params['ltd']:array());
        $tbl = $params['tbl'];
        $tbldesc = $params['tbldesc'];
        $otblVV = array('x' => $tbldesc);

        foreach ($lt as $k => $t) {
            $otblVV['x' . $k] = $ltd[$k];
        }

        if (count($otbl) == 0 || (count($otbl)>0 && $ofld[count($otbl)-1] != '')) {
            $otbl[] = 'x';
            $ofld[] = '';
            $otit[] = '';
            $osto[] = '';
            $ostt[] = '0';
            $ogrp[] = '';
            $ofun[] = '';
        }

        break;
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportCategory->repc_id[0], $reportCategory->repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings('report_wizard'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'crep';
$block1->openForm("../reports/createreport.php?step=$step&cat=$cat#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="add">';

switch ($step) {
    case '0':   // Introduction to the Report Wizard
        $block1->openContent();
        $block1->contentTitle(lang_strings('report_wizard_step0_title'));
        $block1->closeContent();
        $block1->note(lang_strings('report_wizard_step0_note'));
        echo '<input type="submit" value="' . $strings['next'] . '"> <input type="button" value="' . $strings['cancel'] . '" onClick="location.href=\'../reports/listreports.php?cat=' . $cat . '\'">';
        break;
    case '1':   // Report Name, Description & Target table
        $block1->openContent();
        $block1->contentTitle(lang_strings("report_wizard_step1_title"));
        $block1->closeContent();
        $block1->note(lang_strings('report_wizard_step1_note'));
        $block1->openContent();
        setupInputHTML($block1, lang_strings('name'), 'n', enumFieldType::ftAlphaNumeric, 'Y', '155', $n, '', '', $n_highlight);
        setupInputHTML($block1, lang_strings('name_print'), 'np', enumFieldType::ftText, 'Y', '65535', $np);
        setupInputHTML($block1, lang_strings('description'), 'd', enumFieldType::ftMemo, 'Y', '65535', $d);
        setupInputHTML($block1, lang_strings('tablename'), 'tbl', enumFieldType::ftNumeric, 'Y', '8', $tbl, $tblVV);
        $block1->contentRow('', '<input type="submit" value="' . $strings['next'] . '"> <input type="button" value="' . $strings['cancel'] . '" onClick="location.href=\'../reports/listreports.php?cat=' . $cat . '\'">');
        $block1->closeContent();
        $block1->note("*&nbsp;" . lang_strings('required'));
        break;
    case '2':   // Related tables
        $block1->openContent();
        $block1->contentTitle(lang_strings("report_wizard_step2_title"));
        $block1->closeContent();
        $block1->note(lang_strings('report_wizard_step2_note'));
        $block1->openContent();
        $lt = (isset($params['lt'])?$params['lt']:array());
        $ltt = (isset($params['ltt'])?$params['ltt']:array());
        $ltd = (isset($params['ltd'])?$params['ltd']:array());
        echo '<input type="hidden" name="ltx" value="">';
        echo '<input type="hidden" name="lttx" value="">';
        echo '<input type="hidden" name="ltdx" value="">';
        $ltstr = '|' . implode('|', $lt) . '|';

        foreach ($lt as $k => $t) {
            if (preg_match('/' . $t . '\./', $ltstr) === 1) {
                $block1->contentRow('', $ltd[$k]);
            } else {
                $block1->contentRow('', '<div class="right"><a href="javascript:dellt(\'' . $t . '\');">X</a></div>'. $ltd[$k]);
            }

            echo '<input type="hidden" name="lt[]" value="' . $t . '">';
            echo '<input type="hidden" name="ltt[]" value="' . $ltt[$k] . '">';
            echo '<input type="hidden" name="ltd[]" value="' . $ltd[$k] . '">';
        }

        if (count($listRelatedTables->tablename) > 0) {
            $ltSel = '<select name="nlt" onchange="addlt();"><option value="" selected></option>';

            for ($i=0; $i<count($listRelatedTables->tablename); $i++) {
                $ltSel .= '<option value="' . $i . '">' . $listRelatedTables->fielddesc[$i] . '</option>';
                echo '<input type="hidden" id="lt' . $i . '" name="lt' . $i . '" value="' . $listRelatedTables->fieldname[$i] . '">';
                echo '<input type="hidden" id="ltt' . $i . '" name="ltt' . $i . '" value="' . $listRelatedTables->tablename[$i] . '">';
                echo '<input type="hidden" id="ltd' . $i . '" name="ltd' . $i . '" value="' . $listRelatedTables->fielddesc[$i] . '">';
            }

            $ltSel .= '</select>';
            $block1->contentRow('', $ltSel);
        }

        $block1->contentRow('', '<input type="submit" value="' . $strings['next'] . '"> <input type="button" value="' . $strings['back'] . '" onClick="location.href=\'../reports/createreport.php?step=1&cat=' . $cat . '\'"> <input type="button" value="' . $strings['cancel'] . '" onClick="location.href=\'../reports/listreports.php?cat=' . $cat . '\'">');
        $block1->closeContent();
        break;
    case '3':   // Conditions and Parameters
        $block1->openContent();
        $block1->contentTitle(lang_strings("report_wizard_step3_title"));
        $block1->closeContent();
        $block1->note(lang_strings('report_wizard_step3_note'));
        $block1->openContent();
        echo '<input type="hidden" name="cpi" value="">';
        $cstr = isset($params['cstr'])?$params['cstr']:array();
        $cpamx = isset($params['cpam'])?$params['cpam']:array();

        foreach ($cstr as $k => $str) {
            $block1->contentRow((($cpamx[$k]=='Y')?$strings['parameter']:$strings['condition']), '<div class="right"><a href="javascript:delcp(\'' . $k . '\');">X</a></div>' . $str);
        }

        $cpamSel = '<select name="cpam" onchange="reload()">';
        $cpamSel .= '<option value="N"' . (($cpam!='Y')?' selected':'') . '>' . $strings['condition'] . '</option>';
        $cpamSel .= '<option value="Y"' . (($cpam=='Y')?' selected':'') . '>' . $strings['parameter'] . '</option>';
        $cpamSel .= '</select>';
        $newLine = '<select name="ctbl" onchange="reload()">';

        foreach ($ctblVV as $k => $v) {
            $newLine .= '<option value="' . $k . '"' . (($ctbl==$k)?' selected':'') . '>' . $v . '</option>';
        }

        $newLine .= '</select>';
        $newLine .= '<select name="cfld" onchange="reload()">';

        foreach ($cfldVV as $k => $v) {
            $newLine .= '<option value="' . $k . '"' . (($cfld==$k)?' selected':'') . '>' . $v . '</option>';
        }

        $newLine .= '</select>';

        if ($cfld != '') {
            if ($cpam != 'Y') {
                $newLine .= '<input type="checkbox" name="ccmp" value="Y"' . (($ccmp=='Y')?' checked':'') . ' onchange="reload()">' . lang_strings('compare_fields');
            }

            $newLine .= '<select name="cop" onchange="reload()">';

            if (!array_key_exists($cop, $copVV)) {
                $cop = '';
            }

            foreach ($copVV as $k => $v) {
                $newLine .= '<option value="' . $k . '"' . (($k==$cop)?' selected':'') . '>' . $v . '</option>';
            }

            $newLine .= '</select>';

            if ($ccmp == 'Y') {  // compare to another field
                $newLine .= '<select name="cvtb" onchange="reload()">';

                foreach ($ctblVV as $k => $v) {
                    $newLine .= '<option value="' . $k . '"' . (($cvtb==$k)?' selected':'') . '>' . $v . '</option>';
                }

                $newLine .= '</select>';
                $newLine .= '<select name="cval" onchange="reload()">';

                if (!array_key_exists($cval, $cfldvVV)) {
                    $cval = '';
                }

                foreach ($cfldvVV as $k => $v) {
                    $newLine .= '<option value="' . $k . '"' . (($cval==$k)?' selected':'') . '>' . $v . '</option>';
                }

                $newLine .= '</select>';

                if ($cval != '') {
                    $newLine .= '<input type="button" value="' . $strings['add'] . '" onclick="addcp()">';
                }
            } else if ($cpam != 'Y') {         // NOT field as parameter
                switch ($cop) {
                    case enumRatio::rGreaterThan:
                    case enumRatio::rGreaterOrEqual:
                    case enumRatio::rLessThan:
                    case enumRatio::rLessOrEqual:
                    case enumRatio::rEqual:
                    case enumRatio::rNotEqual:
                        if ($fldtyp == enumFieldType::ftBoolean) {
                            $newLine .= '<select name="cval">';
                            $newLine .= '<option value="' . enumBoolean::bTrue . '"' . (($cval==enumBoolean::bTrue)?' selected':'') . '>' . $strings['yes'] . '</option>';
                            $newLine .= '<option value="' . enumBoolean::bFalse . '"' . (($cval!=enumBoolean::bTrue)?' selected':'') . '>' . $strings['no'] . '</option>';
                            $newLine .= '</select>';
                        } else if ($comptListFieldValueDef > 0) {
                            for ($i=0; $i<$comptListFieldValueDef; $i++) {
                                $newLine .= '<input type="checkbox" name="cval[]" value="' . $listFieldValueDef->fvd_fieldvalue[$i] . '"' . (((is_array($cval)) && (in_array($listFieldValueDef->fvd_fieldvalue[$i], $cval)))?' checked':'') . '>' . $listFieldValueDef->fvd_fieldvalue_desc[$i] . ' ';
                            }
                        } else {
                            $newLine .= setupInputHTML(null, '', 'cval', $fldtyp, 'Y', $fldlen, $cval);
                        }

                        break;
                    case enumRatio::rInRange:
                    case enumRatio::rNotInRange:
                        $newLine .= setupInputHTML(null, '', 'cval1', enumFieldType::ftText, 'Y', 255, $cval1);
                        $newLine .= ' ' . $strings['and'] . ' ';
                        $newLine .= setupInputHTML(null, '', 'cval2', enumFieldType::ftText, 'Y', 255, $cval2);
                        break;
                    case enumRatio::rContains:
                    case enumRatio::rBeginWith:
                    case enumRatio::rEndWith:
                        $newLine .= setupInputHTML(null, '', 'cval', enumFieldType::ftText, 'Y', 255, $cval);
                        break;
                }

                if ($cop != '') {
                    $newLine .= '<input type="button" value="' . $strings['add'] . '" onclick="addcp()">';
                }
            } else {    // field as parameter
                if ($cval == '') {
                    $cval = $cfldVV[$cfld];
                }

                $newLine .= '<input type="text" id="cval" name="cval" value="' . $cval . '" maxlength="255" placeholder="' . $strings['name'] . '">';

                if ($cop != '') {
                    $newLine .= '<input type="button" value="' . $strings['add'] . '" onclick="addcp()">';
                }
            }
        }

        $block1->contentRow($cpamSel, $newLine, "false", "");
        $block1->contentRow('', '<input type="submit" value="' . $strings['next'] . '"> <input type="button" value="' . $strings['back'] . '" onClick="location.href=\'../reports/createreport.php?step=2&cat=' . $cat . '\'"> <input type="button" value="' . $strings['cancel'] . '" onClick="location.href=\'../reports/listreports.php?cat=' . $cat . '\'">');
        $block1->closeContent();
        break;
    case '4':   // Fields and Sorting Orders
        $block1->openContent();
        $block1->contentTitle(lang_strings("report_wizard_step4_title"));
        $block1->closeContent();
        $block1->note(lang_strings('report_wizard_step4_note'));
        echo '<input type="hidden" name="outi" value="">';
        $labels = array('&nbsp;', $strings['table'], $strings['field'], $strings['title'], $strings['sorting_order'], $strings['sorting_type'], $strings['grouping'], $strings['function']);
        $block1->openResults(false);
        $block1->labels($labels, 'false', 'false', array('-1', ''));

        for ($i=0; $i<count($otbl); $i++) {
            $block1->openRow();

            if ($i == (count($otbl)-1)) {
                $block1->cellRow("&nbsp;");
            } else {
                $block1->cellRow('<a href="javascript:delout(\'' . $i . '\');">X</a>');
            }

            $otblSel = '<select name="otbl[]" id="otbl' . $i . '" onchange="otblchg(\'' . $i . '\')">';

            foreach ($otblVV as $k => $v) {
                $otblSel .= '<option value="' . $k . '"' . (($otbl[$i]==$k)?' selected':'') . '>' . $v . '</option>';
            }

            $otblSel .= '</select>';
            // table name
            $block1->cellRow($otblSel);

            if ($otbl[$i] == 'x') {
                $t = $tbl;
            } else {
                $k = str_replace('x', '', $otbl[$i]);
                $t = $ltt[$k];
            }

            $querymore = " WHERE fdf.tablename='$t' ORDER BY fdf.disporder";
            $listFieldDef = new request();
            $listFieldDef->openFieldsDefinitions($querymore);
            $comptListFieldDef = count($listFieldDef->fdf_tablename);
            $ofldSel = '<select name="ofld[]" id="ofld' . $i . '" onchange="ofldchg(\'' . $i . '\')">';
            $ofldSel .= '<option value=""' . (($ofld[$i]=='')?' selected':'') . '></option>';

            for ($j=0; $j<$comptListFieldDef; $j++) {
                $ofldSel .= '<option value="' . $listFieldDef->fdf_fieldname[$j] . '"' . (($ofld[$i]==$listFieldDef->fdf_fieldname[$j])?' selected':'') . '>' . $listFieldDef->fdf_fielddesc[$j] . '</option>';
            }

            $ofldSel .= '</select>';
            // field name
            $block1->cellRow($ofldSel);

            if ($ofld[$i] != '') {
                $k = array_search($ofld[$i], $listFieldDef->fdf_fieldname);
                $fldtyp = $listFieldDef->fdf_fieldtype[$k];
                $fldlen = $listFieldDef->fdf_length[$k];

                if ($otit[$i] == '') {
                    $otit[$i] = $listFieldDef->fdf_fielddesc[$k];
                }
            }

            // field title
            $block1->cellRow('<input type="text" name="otit[]" id="otit' . $i . '" value="' . $otit[$i] . '">');
            $ostoSel = '<select name="osto[]" id="osto' . $i . '">';
            $ostoSel .= '<option value=""' . (($osto[$i]=='')?' selected':'') . '></option>';

            for ($j=1; $j<10; $j++) {
                $ostoSel .= '<option value="' . $j . '"' . (($osto[$i]==$j)?' selected':'') . '>' . $j . '</option>';
            }

            $ostoSel .= '</select>';
            // sorting order
            $block1->cellRow($ostoSel);
            $osttSel = '<select name="ostt[]" id="ostt' . $i . '">';

            foreach ($sortingArray as $k => $v) {
                $osttSel .= '<option value="' . $k . '"' . (($ostt[$i]==$k)?' selected':'') . '>' . $v . '</otpion>';
            }

            $osttSel .= '</select>';
            // sorting type
            $block1->cellRow($osttSel);
            // grouping
            $block1->cellRow('<input type="checkbox" name="ogrp[]" id="ogrp' . $i . '" value="Y"' . (($ogrp[$i]=='Y')?' checked':'') . ' onclick="ogrpchg(\'' . $i . '\')">');
            $ofunSel = '<select name="ofun[]" id="ofun' . $i . '" onchange="ofunchg(\'' . $i . '\')">';
            $ofunSel .= '<option value=""' . (($ofun[$i]=='')?' selected':'') . '></option>';

            foreach ($sqlFunctions as $k => $v) {
                $ofunSel .= '<option value="' . $k . '"' . (($ofun[$i]==$k)?' selected':'') . '>' . $v . '</option>';
            }

            $ofunSel .= '</select>';
            $block1->cellRow($ofunSel);
            $block1->closeRow();
        }

        $block1->closeResults();
        $block1->openContent();
        $block1->contentRow('', '<input type="submit" value="' . $strings['save'] . '"> <input type="button" value="' . $strings['back'] . '" onClick="location.href=\'../reports/createreport.php?step=3&cat=' . $cat . '\'"> <input type="button" value="' . $strings['cancel'] . '" onClick="location.href=\'../reports/listreports.php?cat=' . $cat . '\'">');
        $block1->closeContent();
        break;
}

$block1->closeForm();
?>
<script type="text/javascript">
    function addlt() {
        var x = document.crepForm.action;
        var nlt = document.crepForm.nlt;
        var i = nlt.options[nlt.selectedIndex].value;
        var lt = document.getElementById('lt' + i);
        var ltt = document.getElementById('ltt' + i);
        var ltd = document.getElementById('ltd' + i);
        var ltx = document.crepForm.ltx;
        var lttx = document.crepForm.lttx;
        var ltdx = document.crepForm.ltdx;
        ltx.value = lt.value;
        lttx.value = ltt.value;
        ltdx.value = ltd.value;
        x.value = 'addlt';
        document.crepForm.submit();
    }

    function dellt(t) {
        var x = document.crepForm.action;
        var y = document.crepForm.ltx;
        x.value = 'dellt';
        y.value = t;
        document.crepForm.submit();
    }

    function reload() {
        var x = document.crepForm.action;
        x.value = '';
        document.crepForm.submit();
    }

    function addcp() {
        var x = document.crepForm.action;
        x.value = 'addcp';
        document.crepForm.submit();
    }

    function delcp(i) {
        var x = document.crepForm.action;
        var y = document.crepForm.cpi;
        x.value = 'delcp';
        y.value = i;
        document.crepForm.submit();
    }

    function otblchg(i) {
        var x = document.crepForm.action;
        var ofld = document.getElementById('ofld' + i);
        var otit = document.getElementById('otit' + i);
        var osto = document.getElementById('osto' + i);
        var ostt = document.getElementById('ostt' + i);
        var ogrp = document.getElementById('ogrp' + i);
        var ofun = document.getElementById('ofun' + i);
        ofld.selectedIndex = 0;
        otit.value = '';
        osto.selectedIndex = 0;
        ostt.selectedIndex = 0;
        ogrp.checked = false;
        ofun.selectedIndex = 0;
        x.value = '';
        document.crepForm.submit();
    }

    function ofldchg(i) {
        var x = document.crepForm.action;
        var otit = document.getElementById('otit' + i);
        var osto = document.getElementById('osto' + i);
        var ostt = document.getElementById('ostt' + i);
        var ogrp = document.getElementById('ogrp' + i);
        var ofun = document.getElementById('ofun' + i);
        otit.value = '';
        osto.selectedIndex = 0;
        ostt.selectedIndex = 0;
        ogrp.checked = false;
        ofun.selectedIndex = 0;
        x.value = '';
        document.crepForm.submit();
    }

    function ogrpchg(i) {
        var ogrp = document.getElementById('ogrp' + i);
        var ofun = document.getElementById('ofun' + i);

        if (ogrp.checked) {
            ofun.selectedIndex = 0;
        }
    }

    function ofunchg(i) {
        var ogrp = document.getElementById('ogrp' + i);
        var ofun = document.getElementById('ofun' + i);

        if ((ogrp.checked) && (ofun.selectedIndex !== 0)) {
            ogrp.checked = false;
        }
    }

    function delout(i) {
        var x = document.crepForm.action;
        var y = document.crepForm.outi;
        x.value = 'delout';
        y.value = i;
        document.crepForm.submit();
    }
</script>
<?php
require_once('../includes/footer.php');
