<?php // $Revision: 1.10 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletereports.php,v 1.10 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$cat = AddSlashesNOD(isset($_GET['cat'])?$_GET['cat']:'');
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Edit'][$profilSession]) {
    header('Location: ../reports/listreports.php?cat=' . $cat . '&msg=permissiondenied');
    exit;
}

$querymore = " WHERE rep.id IN ($ids) AND rep.sysdef='N' ORDER BY rep.name";
$listReports = new request();
$listReports->openReports($querymore);
$comptListReports = count($listReports->rep_id);

if ($comptListReports != count(explode('**', $id))) {
    header('Location: ../reports/listreports.php?cat=' . $cat . '&msg=permissiondenied');
    exit;
}

$querymore1 = " WHERE repc.id='$cat'";
$reportCategoryDetail = new request();
$reportCategoryDetail->openReportCategory($querymore1);
$comptReportCategoryDetail = count($reportCategoryDetail->repc_id);

if ($comptReportCategoryDetail == 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Action
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "DELETE FROM " . $tablePrefix . "reports WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "DELETE FROM " . $tablePrefix . "reports_rel_tables WHERE report IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "DELETE FROM " . $tablePrefix . "reports_rel_fields WHERE report IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "DELETE FROM " . $tablePrefix . "reports_criteria WHERE report IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "DELETE FROM " . $tablePrefix . "reports_output WHERE report IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../reports/listreports.php?cat=$cat&msg=delete");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportCategoryDetail->repc_id[0], $reportCategoryDetail->repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_reports"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "deR";
$block1->openForm("../reports/deletereports.php?cat=$cat&id=$id#" . $block1->form . 'Anchor');
echo '<input type="hidden" name="action" value="delete">';
$block1->heading(lang_strings("delete_reports"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListReports; $i++) {
    $block1->contentRow("#" . $listReports->rep_id[$i], $listReports->rep_name_print[$i]);
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
