<?php // $Revision: 1.10 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editreport.php,v 1.10 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$cat = AddSlashesNOD(isset($_GET['cat'])?$_GET['cat']:'');
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$ncat = isset($_POST['ncat'])?$_POST['ncat']:'';        // new report category
$nnp = isset($_POST['nnp'])?$_POST['nnp']:'';           // new report name print
$nd = isset($_POST['nd'])?$_POST['nd']:'';              // new report description
$nlk = isset($_POST['nlk'])?$_POST['nlk']:'';           // report locked

if ($nlk == 'Y') {
    $lk = enumBoolean::bTrue;
} else {
    $lk = enumBoolean::bFalse;
}

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Edit'][$profilSession]) {
    header('Location: ../reports/listreports.php?cat=' . $cat . '&msg=permissiondenied');
    exit;
}

$querymore = " WHERE rep.id='$id'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail == 0) {
    header('Location: ../reports/listreports.php?cat=' . $cat . '&msg=permissiondenied');
    exit;
}

/**
 * Action
 */
if ($action == "update") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "UPDATE " . $tablePrefix . "reports SET category='$ncat',locked='$lk' WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        updateString($requestAct, 'REP__' . $reportDetail->rep_name[0], $nnp);       // report name print
        updateString($requestAct, 'REPDESC__' . $reportDetail->rep_name[0], $nd);    // report description
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../reports/listreports.php?cat=$cat&msg=update");
        exit;
    }
}

/**
 * Set value in form
 */
if ($error == '') {
    $ncat = $reportDetail->rep_category[0];
    $nnp = $reportDetail->rep_name_print[0];
    $nd = $reportDetail->rep_description[0];
    $lk = $reportDetail->rep_locked[0];
}

/**
 * Get Report Categories
 */
$querymore1 = " ORDER BY repc.id";
$listReportCategory = new request();
$listReportCategory->openReportCategory($querymore1);
$comptListReportCategory = count($listReportCategory->repc_id);
$catVV = array();

for ($i=0; $i<$comptListReportCategory; $i++) {
    $catVV[$listReportCategory->repc_id[$i]] = $listReportCategory->repc_name_print[$i];
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_report"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "edR";
$block1->openForm("../reports/editreport.php?cat=$cat&id=$id#" . $block1->form . 'Anchor');
echo '<input type="hidden" name="action" value="update">';
$block1->heading(lang_strings("edit_report"));
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings('name'), $reportDetail->rep_name[0]);
setupInputHTML($block1, lang_strings('report_category'), 'ncat', enumFieldType::ftNumeric, 'Y', '6', $ncat, $catVV);
setupInputHTML($block1, lang_strings('name_print'), 'nnp', enumFieldType::ftText, 'Y', '65535', $nnp);
setupInputHTML($block1, lang_strings('description'), 'nd', enumFieldType::ftMemo, 'Y', '65535', $nd);
setupInputHTML($block1, lang_strings('locked'), 'nlk', enumFieldType::ftBoolean, 'Y', '1', $lk);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
