<?php  // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: equipment_allocation.php,v 1.29 2013/01/18 09:50:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Variables init
 */
// set up the equipment selection
$S_equ = (isset($_POST['S_EQUSEL'])?$_POST['S_EQUSEL']:'');
// get the range start date and end date
$S_date1 = (isset($_POST['S_DATE1'])?$_POST['S_DATE1']:'');
$S_date2 = (isset($_POST['S_DATE2'])?$_POST['S_DATE2']:'');

if ($S_equ !== '' && !is_array($S_equ)) {
    $S_equ = explode("**", $S_equ);
}

// load report info
$querymore = " WHERE rep.name='equipment_allocation'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0 || $S_date1 == '' || $S_date2 == '') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Prepare data
 */
// Query equipments that was selected
if ($S_equ === '') {
    $querymore0 = " WHERE equ.id='0' ORDER BY equ.equipment_id";
} else if (is_array($S_equ)) {
    $querymore0 = " WHERE equ.id IN ('" . implode("','", $S_equ) . "') ORDER BY equ.equipment_id";
} else {
    $querymore0 = " WHERE equ.id='$S_equ'";
}

$listEquipments = new request();
$listEquipments->openEquipments($querymore0);
$comptListEquipments = count($listEquipments->equ_id);

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selectea.php', lang_strings("equipment_allocation"), 'in'));
$blockPage->closeBreadcrumbs();
// start the first block
$block1 = new block();
$block1->form = "eaR";
$block1->openForm("../reports/equipment_allocation.php#" . $block1->form . "Anchor");
echo '<input type="hidden" name="S_EQUSEL" value="' . ((is_array($S_equ))?implode("**", $S_equ):$S_equ) . '">';
echo '<input type="hidden" name="S_DATE1" value="' . $S_date1 . '">';
echo '<input type="hidden" name="S_DATE2" value="' . $S_date2 . '">';
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListEquipments == "0") {
    $block0->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListEquipments == "1") {
    $block0->contentRow("", "1 " . lang_strings("match"));
} else {
    $block0->contentRow("", $comptListEquipments . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListEquipments > 0) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", $strings["export"]);
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $_SESSION['TARGET'] = 'exportea';
    $params = array();
    // equipment selection
    $params['S_EQUSEL'] = $S_equ;
    // handle date ranges
    $params['S_DATE1'] = $S_date1;
    $params['S_DATE2'] = $S_date2;
    $_SESSION['PARAMS'] = $params;
    $block1->paletteScript(0, "export", "../reports/exportea.php", "true,false,false", $strings["export"]);
    $block1->closePaletteScript($comptListEquipments, $listEquipments->equ_id);
}

if ($comptListEquipments > 0) {
    /**
     * create labels
     */
    $ts1 = date2Timestamp($S_date1);
    $ts2 = date2Timestamp($S_date2);
    $d1 = $ts1;
    $reportLabels = array();
    $reportLabels[] = lang_strings('project');
    $reportLabels[] = lang_strings('task');

    while ($d1 <= $ts2) {
        $reportLabels[] = date('d', $d1);
        $d1 = mktime(0, 0, 0, intval(date('n', $d1)), intval(date('j', $d1))+1, intval(date('Y', $d1)));
    }

    for ($i=0; $i<$comptListEquipments; $i++) {
        if ($listEquipments->equ_status[$i] === enumEquipmentStatus::stBroken || $listEquipments->equ_status[$i] === enumEquipmentStatus::stSold) {
            $block1->heading($listEquipments->equ_equipment_id[$i] . ' <i>' . $equipmentStatusNames[$listEquipments->equ_status[$i]] . '</i>');
        } else {
            // initial equipment status summary
            $d1 = $ts1;
            $equipmentStatus = array();

            while ($d1 <= $ts2) {
                $x = createDate($d1, 'date', false, true);
                $equipmentStatus[$x] = 0;
                $d1 = mktime(0, 0, 0, intval(date('n', $d1)), intval(date('j', $d1))+1, intval(date('Y', $d1)));
            }
            
            // equipment heading
            $block1->heading($listEquipments->equ_equipment_id[$i] . ' <i>' . $S_date1 . ' ~ ' . $S_date2 . '</i>');
            $block1->openResults(false);
            $block1->labels($reportLabels, "false", "false", array(0=>"-1",1=>""));
            // Query to list only open or not started tasks (currently being worked on or scheduled to be worked on).
            $querymore1 = " AND tas.status IN ('" . enumStatus::stNotStarted . "','" . enumStatus::stOpen . "') AND tas.start_date<'" . mktime(0,0,0,intval(date('n',$ts2)),intval(date('j',$ts2))+1,intval(date('Y',$ts2))) . "' AND tas.due_date>='$ts1' AND res.resource='" . $listEquipments->equ_id[$i] . "' ORDER BY pro.name,tas.name";
            $listEquipmentResources = new request();
            $listEquipmentResources->openTaskEquipmentResource($querymore1);
            $comptListEquipmentResources = count($listEquipmentResources->res_id);
            
            for ($j=0; $j<$comptListEquipmentResources; $j++) {
                $block1->openRow();
                $block1->cellRow($block1->buildLink('../projects/viewproject.php?id=' . $listEquipmentResources->res_project[$j], $listEquipmentResources->res_pro_name[$j], 'in'));    // project name
                $block1->cellRow($block1->buildLink('../tasks/viewtask.php?id=' . $listEquipmentResources->res_task[$j], $listEquipmentResources->res_tas_name[$j], 'in'));    // task name
                $d1 = $ts1;

                while ($d1 <= $ts2) {
                    $x = createDate($d1, 'date', false, true);
                    
                    if ($d1 < $listEquipmentResources->res_tas_start_date[$j] || $d1 >= addDays($listEquipmentResources->res_tas_due_date[$j], 1)) {
                        $block1->cellRow('A');      // available
                    } else {
                        $block1->cellRow('O');      // occupied
                        $equipmentStatus[$x] += 1;
                    }
                    
                    $d1 = mktime(0, 0, 0, intval(date('n', $d1)), intval(date('j', $d1))+1, intval(date('Y', $d1)));
                }

                $block1->closeRow();
            }
            
            // Summary row
            $block1->openRow();
            $block1->cellRow("&nbsp;");
            $block1->cellRow("&nbsp;");
            $d2 = $ts1;

            while ($d2 <= $ts2) {
                $x = createDate($d2, 'date', false, true);
                
                if ($equipmentStatus[$x] === 0) {
                    $block1->cellRow('A');          // availabe
                } else if ($equipmentStatus[$x] === 1) {
                    $block1->cellRow('O');          // occupied
                } else {
                    $block1->cellRow('<b>O</b>');   // occupied by more than one task
                }
                
                $d2 = mktime(0, 0, 0, intval(date('n', $d2)), intval(date('j', $d2))+1, intval(date('Y', $d2)));
            }

            $block1->closeRow();
            $block1->closeResults();
            $block1->note('A - ' . $equipmentStatusNames[enumEquipmentStatus::stAvailable] . '<br>O - ' . $equipmentStatusNames[enumEquipmentStatus::stOccupied]);
        }
        
        echo "<p><br></p>";
    }
} else {
    $block1->noresults();
}

// close block1
$block1->closeFormResults();
require_once("../includes/footer.php");
