<?php // $Revision: 1.14 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: export_leaves.php,v 1.14 2013/01/18 09:50:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
// this is the filename the 'save as' file window will bring up by default
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
require_once('../includes/PhpSpreadsheet/vendor/autoload.php');
$filename = "leaves";
$checkSession = false;
require_once("../includes/library.php");

/**
 * Permission check
 */
if ($enableTimesheet != 'true') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
if (!isset($_SESSION['TARGET']) || $_SESSION['TARGET'] != 'export_leaves') {
    exit;
}

// configuration options
// set up the department selection
$S_dep = $_SESSION['PARAMS']['S_DEPSEL'];
// set up the member selection
$S_mem = $_SESSION['PARAMS']['S_ATSEL'];
// a date range was selected
$S_date1 = $_SESSION['PARAMS']['S_DATE1'];
$S_date2 = $_SESSION['PARAMS']['S_DATE2'];
// end of configuration

@set_time_limit(600);
$query = " WHERE wkh.work IN ('" . enumLeaveType::lvAnnual . "','" . enumLeaveType::lvSick . "','" . enumLeaveType::lvAbsence . "','" . enumLeaveType::lvBankHoliday . "','" . enumLeaveType::lvMourning . "','" . enumLeaveType::lvHoneyMoon . "','" . enumLeaveType::lvMaternity . "')";
// a department selection was made
if ($S_dep != '') {
    $query .= " AND mem.department" . ((is_array($S_dep))?" IN ('" . implode("','", $S_dep) . "')":"='$S_dep'");
}
// a member selection was made
if ($S_mem == '') {
    $query .= " AND wkh.owner='0'";
} else {
    $query .= " AND wkh.owner" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}

if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $query .= " AND wkh.date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $query .= " AND wkh.date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}

$tmpquery = "$query ORDER BY wkh.owner";
$listWorkHours = new request();
$listWorkHours->openWorkHours($tmpquery);
$comptListWorkHours = count($listWorkHours->wkh_id);

if ($comptListWorkHours == '0') {
    exit;
}

// Create new Spreadsheet object
$objSpreadsheet = new Spreadsheet();
// Set document properties
$objSpreadsheet->getProperties()->setCreator("webTareas")
                             ->setLastModifiedBy("webTareas")
                             ->setTitle($strings["leave_report"])
                             ->setSubject($strings["leave_report"])
                             ->setDescription($strings["leave_report"])
                             ->setKeywords($strings["leave_report"]);
/**
 * Construct the headers
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A1', $strings["leave_report"]);
/**
 * Construct the header row
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A2', $strings["user_name"])
            ->setCellValue('B2', $strings['HRC__' . enumLeaveType::lvAnnual])
            ->setCellValue('C2', $strings['HRC__' . enumLeaveType::lvSick])
            ->setCellValue('D2', $strings['HRC__' . enumLeaveType::lvAbsence])
            ->setCellValue('E2', $strings['HRC__' . enumLeaveType::lvBankHoliday])
            ->setCellValue('F2', $strings['HRC__' . enumLeaveType::lvMourning])
            ->setCellValue('G2', $strings['HRC__' . enumLeaveType::lvHoneyMoon])
            ->setCellValue('H2', $strings['HRC__' . enumLeaveType::lvMaternity]);
$lastMember = $listWorkHours->wkh_owner[0];
$lastMemberName = $listWorkHours->wkh_mem_name[0];
$totalMember = array(enumLeaveType::lvAnnual => 0, enumLeaveType::lvSick => 0, enumLeaveType::lvAbsence => 0, enumLeaveType::lvBankHoliday => 0, enumLeaveType::lvMourning => 0, enumLeaveType::lvHoneyMoon => 0, enumLeaveType::lvMaternity => 0);
/*
 * Construct the content
 */
for ($i=0, $pRow=3; $i<$comptListWorkHours; $i++) {
    if ($lastMember != $listWorkHours->wkh_owner[$i]) {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(0, $pRow, $lastMemberName)
                    ->setCellValueByColumnAndRow(1, $pRow, $totalMember[enumLeaveType::lvAnnual])
                    ->setCellValueByColumnAndRow(2, $pRow, $totalMember[enumLeaveType::lvSick])
                    ->setCellValueByColumnAndRow(3, $pRow, $totalMember[enumLeaveType::lvAbsence])
                    ->setCellValueByColumnAndRow(4, $pRow, $totalMember[enumLeaveType::lvBankHoliday])
                    ->setCellValueByColumnAndRow(5, $pRow, $totalMember[enumLeaveType::lvMourning])
                    ->setCellValueByColumnAndRow(6, $pRow, $totalMember[enumLeaveType::lvHoneyMoon])
                    ->setCellValueByColumnAndRow(7, $pRow, $totalMember[enumLeaveType::lvMaternity]);
        $lastMember = $listWorkHours->wkh_owner[$i];
        $lastMemberName = $listWorkHours->wkh_mem_name[$i];
        $totalMember = array(enumLeaveType::lvAnnual => 0, enumLeaveType::lvSick => 0, enumLeaveType::lvAbsence => 0, enumLeaveType::lvBankHoliday => 0, enumLeaveType::lvMourning => 0, enumLeaveType::lvHoneyMoon => 0, enumLeaveType::lvMaternity => 0, 0 => 0);
        $pRow += 1;
    }

    $totalMember[$listWorkHours->wkh_work[$i]] += $listWorkHours->wkh_hours[$i];
}
/**
 * Construct the last row
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValueByColumnAndRow(0, $pRow, $lastMemberName)
            ->setCellValueByColumnAndRow(1, $pRow, $totalMember[enumLeaveType::lvAnnual])
            ->setCellValueByColumnAndRow(2, $pRow, $totalMember[enumLeaveType::lvSick])
            ->setCellValueByColumnAndRow(3, $pRow, $totalMember[enumLeaveType::lvAbsence])
            ->setCellValueByColumnAndRow(4, $pRow, $totalMember[enumLeaveType::lvBankHoliday])
            ->setCellValueByColumnAndRow(5, $pRow, $totalMember[enumLeaveType::lvMourning])
            ->setCellValueByColumnAndRow(6, $pRow, $totalMember[enumLeaveType::lvHoneyMoon])
            ->setCellValueByColumnAndRow(7, $pRow, $totalMember[enumLeaveType::lvMaternity]);
// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objSpreadsheet->setActiveSheetIndex(0);
// Redirect output to a client’s web browser
header('Content-Type: ' . $exportFormats[$expfmtSession]['Content-Type']);
$content_disp = (WEBTAREAS_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $exportFormats[$expfmtSession]['File-Extension'] . '"');
header('Pragma: no-cache');
header('Expires: 0');
$objWriter = IOFactory::createWriter($objSpreadsheet, $exportFormats[$expfmtSession]['PHPExcel-Writer-Type']);
$objWriter->save('php://output');
