<?php // $Revision: 1.14 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: export_report.php,v 1.14 2013/01/18 09:50:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
require_once('../includes/PhpSpreadsheet/vendor/autoload.php');
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    exit;
}

/**
 * Variables init
 */
if (!isset($_SESSION['TARGET']) || $_SESSION['TARGET'] != 'export_report') {
    exit;
}

// report id
$id = $_SESSION['ID'];
// report parameter input values
$params = $_SESSION['PARAMS'];
@set_time_limit(600);

/**
 * Get report info.
 */
$querymore1 = " WHERE rep.id='$id'";
$reportDetail = new request();
$reportDetail->openReports($querymore1);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail == 0) {
    exit;
}

// this is the filename the 'save as' file window will bring up by default
$filename = $reportDetail->rep_name[0];
/**
 * Get report parameters
 */
$querymore3 = " WHERE repr.report='$id' AND repr.parameter='" . enumBoolean::bTrue . "' ORDER BY repr.id";
$listParameters = new request();
$listParameters->openReportsCriteria($querymore3);
$comptListParameters = count($listParameters->repr_report);

/**
 * Get report output and field grouping
 */
$querymore6 = " WHERE repo.report='$id' ORDER BY repo.disp_order";
$listReportOutput = new request();
$listReportOutput->openReportsOutput($querymore6);
$comptListReportOutput = count($listReportOutput->repo_id);

/**
 * Fill parameters
 */
$tmpquery = $reportDetail->rep_userquery[0];

for ($i=0,$uid=1; $i<$comptListParameters; $i++,$uid++) {
    $fldtyp = (($listParameters->repr_fieldtype[$i]=='')?$listParameters->repr_fdf_fieldtype[$i]:$listParameters->repr_fieldtype[$i]);

    if ($listParameters->repr_ratio[$i] == enumRatio::rEqual) {
        $pn = 'p' . $listParameters->repr_id[$i];
        $p = $params[$pn];
        $tmpquery = str_replace("[[$" . $uid . "]]", DbValueEncode($fldtyp, $p), $tmpquery);
    } else {
        $fn = 'f' . $listParameters->repr_id[$i];
        $f = $params[$fn];
        $tn = 't' . $listParameters->repr_id[$i];
        $t = $params[$tn];
        $tmpquery = str_replace("[[$" . $uid . ".1]]", DbValueEncode($fldtyp, $f), $tmpquery);
        $tmpquery = str_replace("[[$" . $uid . ".2]]", DbValueEncode($fldtyp, $t), $tmpquery);
    }
}

$tmpquery = prepareUserQuery($tmpquery);
$requestOut = new request();
$requestOut->connectClass();
$requestOut->query($tmpquery);
$requestOut->rows = array();

while ($requestOut->fetch()) {
    $output = array();

    for ($i=0; $i<$comptListReportOutput; $i++) {
        $fldtyp = (($listReportOutput->repo_fieldtype[$i]=='')?$listReportOutput->repo_fdf_fieldtype[$i]:$listReportOutput->repo_fieldtype[$i]);

        if ($fldtyp == enumFieldType::ftPassword) {
            $output[$i] = (($row[$i]=='')?'':'********');
        } else {
            $output[$i] = DbValueDecode($fldtyp, $row[$i], $listReportOutput->repo_field_validvalues[$i]);
        }
    }

    $requestOut->id[] = 0;
    $requestOut->rows[] = $output;
}

$requestOut->close();
$comptRequestOut = count($requestOut->rows);

if ($comptRequestOut == 0) {
    exit;
}

// Create new Spreadsheet object
$objSpreadsheet = new Spreadsheet();
// Set document properties
$objSpreadsheet->getProperties()->setCreator("webTareas")
                             ->setLastModifiedBy("webTareas")
                             ->setTitle($reportDetail->rep_name_print[0])
                             ->setSubject($reportDetail->rep_name_print[0])
                             ->setDescription($reportDetail->rep_name_print[0])
                             ->setKeywords($reportDetail->rep_name_print[0]);
/**
 * Construct the headers
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A1', $reportDetail->rep_name_print[0]);
/**
 * Construct the header row
 */
for ($i=0; $i<$comptListReportOutput; $i++) {
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow($i, 2, $listReportOutput->repo_title[$i]);
}
/*
 * Construct the content
 */
for ($i=0, $pRow=3; $i<$comptRequestOut; $i++, $pRow++) {
    foreach ($requestOut->rows[$i] as $key => $val) {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow($key, $pRow, $val);
    }
}

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objSpreadsheet->setActiveSheetIndex(0);
// Redirect output to a client’s web browser
header('Content-Type: ' . $exportFormats[$expfmtSession]['Content-Type']);
$content_disp = (WEBTAREAS_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $exportFormats[$expfmtSession]['File-Extension'] . '"');
header('Pragma: no-cache');
header('Expires: 0');
$objWriter = IOFactory::createWriter($objSpreadsheet, $exportFormats[$expfmtSession]['PHPExcel-Writer-Type']);
$objWriter->save('php://output');
