<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportcompleted.php,v 1.16 2013/01/18 09:50:29 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * Includes
 */
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
require_once('../includes/PhpSpreadsheet/vendor/autoload.php');
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
if (!isset($_SESSION['TARGET']) || $_SESSION['TARGET'] != 'exportcompleted') {
    exit;
}

// set up the department selection
$S_dep = $_SESSION['PARAMS']['S_DEPSEL'];
// set up the member selection
$S_mem = $_SESSION['PARAMS']['S_ATSEL'];
// a date range was selected
$S_date1 = $_SESSION['PARAMS']['S_DATE1'];
$S_date2 = $_SESSION['PARAMS']['S_DATE2'];

// this is the filename the 'save as' file window will bring up by default
$filename = "completed";
$export = "true";
@set_time_limit(600);
$querymore = " WHERE tas.status = " . enumStatus::stCompleted . " AND tas.milestone <> '" . enumMilestone::msYes . "'";

if ($S_dep !== '' || $S_mem !== '') {
    $querymore .= " AND EXISTS (SELECT * FROM " . $tablePrefix . "tasks_resource res INNER JOIN " . $tablePrefix . "members resm ON resm.id=res.resource WHERE res.task=tas.id AND res.type='" . enumResourceType::rtUser . "'"; 
    
    // a department selection was made
    if ($S_dep !== '') {
        $querymore .= " AND resm.department" . ((is_array($S_dep))?" IN ('" . implode("','", $S_dep) . "')":"='$S_dep'");
    }
    
    // a member selection was made
    if ($S_mem !== '') {
        $querymore .= " AND res.resource" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
    }
    
    $querymore .= ")";
} else {
    $querymore .= " AND tas.assigned_to='0'";
}

if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $querymore .= " AND tas.complete_date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $querymore .= " AND tas.complete_date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}

$listTasks = new request();
$listTasks->openHierarchyOfTasks($querymore);
$comptListTasks = count($listTasks->tas_id);

if ($comptListTasks == '0') {
    exit;
}

// Create new Spreadsheet object
$objSpreadsheet = new Spreadsheet();
// Set document properties
$objSpreadsheet->getProperties()->setCreator("webTareas")
                             ->setLastModifiedBy("webTareas")
                             ->setTitle($strings["completed_task_report"])
                             ->setSubject($strings["completed_task_report"])
                             ->setDescription($strings["completed_task_report"])
                             ->setKeywords($strings["completed_task_report"]);
/**
 * Construct the headers
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A1', $strings["completed_task_report"]);
/**
 * Construct the header row
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A2', $strings["project"])
            ->setCellValue('B2', $strings["task"])
            ->setCellValue('C2', $strings["complete_date"])
            ->setCellValue('D2', $strings["assigned_to"]);
/*
 * Construct the content
 */
for ($i=0, $pRow=3; $i<$comptListTasks; $i++, $pRow++) {
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(0, $pRow, $listTasks->tas_pro_name[$i])        // project name
                ->setCellValueByColumnAndRow(1, $pRow, $listTasks->tas_name[$i])            // task name
                ->setCellValueByColumnAndRow(2, $pRow, createDate($listTasks->tas_complete_date[$i],'date',false,true));    // complete date
    // member name
    $tmpquery = " AND res.task='" . $listTasks->tas_id[$i] . "'";
    $resourceUsage = new request();
    $resourceUsage->openTaskHumanResource($tmpquery);
    $comptResourceUsage = count($resourceUsage->res_id);
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(3, $pRow, implode(",", $resourceUsage->res_mem_name));       // assigned to
}

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objSpreadsheet->setActiveSheetIndex(0);
// Redirect output to a client’s web browser
header('Content-Type: ' . $exportFormats[$expfmtSession]['Content-Type']);
$content_disp = (WEBTAREAS_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $exportFormats[$expfmtSession]['File-Extension'] . '"');
header('Pragma: no-cache');
header('Expires: 0');
$objWriter = IOFactory::createWriter($objSpreadsheet, $exportFormats[$expfmtSession]['PHPExcel-Writer-Type']);
$objWriter->save('php://output');
