<?php // $Revision: 1.23 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exporthours.php,v 1.23 2013/01/18 09:50:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
require_once('../includes/PhpSpreadsheet/vendor/autoload.php');
$generate_mail_attach = isset($generate_mail_attach)?$generate_mail_attach:'';

if ($generate_mail_attach != 'Y') {
    /**
     * Includes
     */
    $checkSession = true;
    $extractImportVariables = 'false';
    require_once("../includes/library.php");

    /**
     * Variables init
     */
    if (!isset($_SESSION['TARGET']) || $_SESSION['TARGET'] != 'exporthours') {
        exit;
    }
    
    // set up the organization selection
    $S_org = $_SESSION['PARAMS']['S_ORGSEL'];
    // set up the project selection
    $S_prj = $_SESSION['PARAMS']['S_PRJSEL'];
    // set up the department selection
    $S_dep = $_SESSION['PARAMS']['S_DEPSEL'];
    // set up the member selection
    $S_mem = $_SESSION['PARAMS']['S_ATSEL'];
    // a date range was selected
    $S_date1 = $_SESSION['PARAMS']['S_DATE1'];
    $S_date2 = $_SESSION['PARAMS']['S_DATE2'];
    // billing selection
    $billingSelection = $_SESSION['PARAMS']['S_BILLING'];
    // end of configuration
}

// this is the filename the 'save as' file window will bring up by default
$filename = "hours";
@set_time_limit(600);
// a member selection was made
if ($S_mem == '') {
    $query = " WHERE T0.owner='0'";
} else {
    $query = " WHERE T0.owner" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}
// a organization selection was made
if ($S_org != 'ALL' && $S_org != '') {
    $query .= " AND T0.organization" . ((is_array($S_org))?" IN ('" . implode("','", $S_org) . "')":"='$S_org'");
}
// a project selection was made
if ($S_prj != 'ALL' && $S_prj != '') {
    $query .= " AND T0.project" . ((is_array($S_prj))?" IN ('" . implode("','", $S_prj) . "')":"='$S_prj'");
}
// a department selection was made
if ($S_dep != 'ALL' && $S_dep != '') {
    $query .= " AND T0.department" . ((is_array($S_dep))?" IN ('" . implode("','", $S_dep) . "')":"='$S_dep'");
}
// a date range was selected
if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $query .= " AND T0.date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $query .= " AND T0.date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}

// billing selection
if ($billingSelection != 'ALL') {
    $query .= " AND T0.billing='$billingSelection'";
}

$hourCodeSql = "CASE wkh.work";
$listHourCode = new request();
$listHourCode->openHourCode('');
$comptListHourCode = count($listHourCode->hrc_id);

for ($i49a=0; $i49a<$comptListHourCode; $i49a++) {
    $hourCodeSql .= " WHEN '" . $listHourCode->hrc_id[$i49a] . "' THEN '" . HtmlEntitiesNOD($listHourCode->hrc_name_print[$i49a]) . "'";
}

$hourCodeSql .= " ELSE '' END";
$tmpquery = "SELECT T1.organization,T1.org_name,T1.project,T1.pro_name,T1.pro_type,T1.owner,T1.mem_name,T1.date,T1.doc_type,T1.doc_id,T1.doc_name,T1.hours,T1.billing FROM (
SELECT T0.organization,T0.org_name,T0.project,T0.pro_name,T0.pro_type,T0.owner,T0.mem_name,T0.date,T0.doc_type,T0.doc_id,T0.doc_name,T0.hours,T0.billing FROM (
SELECT pro.organization,org.name AS org_name,tim.project,pro.name AS pro_name,pro.type AS pro_type,tim.owner,mem.name AS mem_name,mem.department,tim.date,'T' AS doc_type,tim.task AS doc_id,tas.name AS doc_name,tim.hours,tim.billing
FROM " . $tablePrefix . "tasks_time tim LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=tim.project LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id=tim.task LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=tim.owner
) T0 $query
UNION ALL
SELECT T0.organization,T0.org_name,T0.project,T0.pro_name,T0.pro_type,T0.owner,T0.mem_name,T0.date,T0.doc_type,T0.doc_id,T0.doc_name,T0.hours,T0.billing FROM (
SELECT pro.organization,org.name AS org_name,mti.project,pro.name AS pro_name,pro.type AS pro_type,mti.owner,mem.name AS mem_name,mem.department,mti.date,'M' AS doc_type,mti.meeting AS doc_id,mee.name AS doc_name,mti.hours,CAST('" . enumBoolean::bFalse . "' AS char(1)) AS billing
FROM " . $tablePrefix . "meetings_time mti LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=mti.project LEFT OUTER JOIN " . $tablePrefix . "meetings mee ON mee.id=mti.meeting LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=mti.owner
) T0 $query
UNION ALL
SELECT T0.organization,T0.org_name,T0.project,T0.pro_name,T0.pro_type,T0.owner,T0.mem_name,T0.date,T0.doc_type,T0.doc_id,T0.doc_name,T0.hours,T0.billing FROM (
SELECT pro.organization,org.name AS org_name,wkh.project,pro.name AS pro_name,pro.type AS pro_type,wkh.owner,mem.name AS mem_name,mem.department,wkh.date,'W' AS doc_type,wkh.work AS doc_id,$hourCodeSql AS doc_name,wkh.hours,wkh.billing
FROM " . $tablePrefix . "work_hours wkh LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=wkh.project LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=wkh.owner
) T0 $query
) T1 ORDER BY T1.org_name,T1.pro_name,T1.mem_name,T1.date";
$listHours = new request();
$listHours->connectClass();
$listHours->query($tmpquery);
$listHours->organization = array();

while ($listHours->fetch()) {
    $i = 0;
    $listHours->organization[] = ($row[$i++]);
    $listHours->org_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->project[] = ($row[$i++]);
    $listHours->pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->pro_type[] = ($row[$i++]);
    $listHours->owner[] = ($row[$i++]);
    $listHours->mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->date[] = createDate($row[$i++], 'date', false, true);
    $listHours->doc_type[] = ($row[$i++]);
    $listHours->doc_id[] = ($row[$i++]);
    $listHours->doc_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $hours0 = ($row[$i++]);
    $hours = (is_numeric($hours0))?round($hours0, $hourAccuracy):'0';
    $listHours->hours[] = $hours;
    $listHours->billing[] = ($row[$i++]);
}

$listHours->close();
$comptListHours = count($listHours->organization);

if ($comptListHours == '0') {
    exit;
}

// Create new Spreadsheet object
$objSpreadsheet = new Spreadsheet();
// Set document properties
$objSpreadsheet->getProperties()->setCreator("webTareas")
                             ->setLastModifiedBy("webTareas")
                             ->setTitle($strings["time_report"])
                             ->setSubject($strings["time_report"])
                             ->setDescription($strings["time_report"])
                             ->setKeywords($strings["time_report"]);
/**
 * Construct the headers
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A1', $strings["hours_logged"]);

if ($S_date1 != '') {
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValue('B1', $strings["hours_logged_from"])
                ->setCellValue('C1', $S_date1);
}

if ($S_date2 != '') {
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValue('D1', $strings["hours_logged_to"])
                ->setCellValue('E1', $S_date2);
}
/**
 * Construct the header row
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A2', $strings["organization"])
            ->setCellValue('B2', $strings["project"])
            ->setCellValue('C2', $strings["type"])
            ->setCellValue('D2', $strings["owner"])
            ->setCellValue('E2', $strings["date"])
            ->setCellValue('F2', $strings["task"])
            ->setCellValue('G2', $strings["hours"])
            ->setCellValue('H2', $strings["billing"]);
/*
 * Construct the content
 */
for ($i=0, $pRow=3; $i<$comptListHours; $i++, $pRow++) {
    // organization name
    if ($listHours->organization[$i] != '' && $listHours->organization[$i] != '1') {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(0, $pRow, $listHours->org_name[$i]);
    }
    // project name, project type
    if ($listHours->project[$i] != '' && $listHours->project[$i] != '0') {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(1, $pRow, $listHours->pro_name[$i])
                    ->setCellValueByColumnAndRow(2, $pRow, $projectType[$listHours->pro_type[$i]]);
    }
    // other columns
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(3, $pRow, $listHours->mem_name[$i])    // member name
                ->setCellValueByColumnAndRow(4, $pRow, $listHours->date[$i])        // date
                ->setCellValueByColumnAndRow(5, $pRow, $listHours->doc_name[$i])    // task name
                ->setCellValueByColumnAndRow(6, $pRow, $listHours->hours[$i])       // hours
                ->setCellValueByColumnAndRow(7, $pRow, $billingFlag[$listHours->billing[$i]]);   // billing
}

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objSpreadsheet->setActiveSheetIndex(0);
// Create PHPExcel writer
$objWriter = IOFactory::createWriter($objSpreadsheet, $exportFormats[$expfmtSession]['PHPExcel-Writer-Type']);

if ($generate_mail_attach == 'Y') {
    $attfname = $filename . '.' . $exportFormats[$expfmtSession]['File-Extension'];
    $tmpfname = tempnam("../files", "FOO");
    $objWriter->save($tmpfname);
} else {
    // Redirect output to a client’s web browser
    header('Content-Type: ' . $exportFormats[$expfmtSession]['Content-Type']);
    $content_disp = (WEBTAREAS_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
    header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $exportFormats[$expfmtSession]['File-Extension'] . '"');
    header('Pragma: no-cache');
    header('Expires: 0');
    $objWriter->save('php://output');
}
