<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportma.php,v 1.5 2013/01/18 09:50:29 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
//
// Function to calculate the number of working days
function workDays($start, $end, $wc)
{
    $querymore = " WHERE wcd.workcalendar='$wc' AND wcd.date>='$start' AND wcd.date<'" . mktime(0,0,0,intval(date('n',$end)),intval(date('j',$end))+1,intval(date('Y',$end))) . "' AND wcd.hours>0 ORDER BY wcd.date";
    $request1 = new request();
    $request1->openWorkCalendarsDetail($querymore);
    return count($request1->wcd_id);
}

/**
 * Includes
 */
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
require_once('../includes/PhpSpreadsheet/vendor/autoload.php');
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
if (!isset($_SESSION['TARGET']) || $_SESSION['TARGET'] != 'exportma') {
    exit;
}

// configuration options
// set up the member selection
$S_mem = $_SESSION['PARAMS']['S_ATSEL'];
// a date range was selected
$S_date1 = $_SESSION['PARAMS']['S_DATE1'];
$S_date2 = $_SESSION['PARAMS']['S_DATE2'];
// end of configuration
// this is the filename the 'save as' file window will bring up by default
$filename = "member_allocation";
@set_time_limit(600);
//
// Query to list only open or not started tasks (currently being worked on or scheduled to be worked on).
$querymore = " AND tas.status IN (" . enumStatus::stNotStarted . "," . enumStatus::stOpen . ")";

if ($S_mem == '') {
    $querymore .= " AND res.resource='0'";
} else {
    $querymore .= " AND res.resource" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}

$ts1 = date2Timestamp($S_date1);
$ts2 = date2Timestamp($S_date2);
$querymore .= " AND tas.due_date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "' AND tas.start_date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "' ORDER BY pro.name,tas.name";
$listTaskHumanResource = new request();
$listTaskHumanResource->openTaskHumanResource($querymore);
$comptListTaskHumanResource = count($listTaskHumanResource->res_id);

if ($comptListTaskHumanResource > 0) {
    $acv = array_count_values($listTaskHumanResource->res_resource);
    $memids = "'" . implode("','", array_keys($acv)) . "'";
} else {
    $memids = "'0'";
}

//
// Display Member that was selected
$querymore = " WHERE mem.id IN ($memids) ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore);
$comptListMembers = count($listMembers->mem_id);

if ($comptListMembers == '0') {
    exit;
}

/**
 * create labels
 */
$d1 = $ts1;
$reportLabels = array();
$reportLabels[] = $strings['project'];
$reportLabels[] = $strings['task'];

while ($d1 <= $ts2) {
    $reportLabels[] = date('d', $d1);
    $d1 = mktime(0, 0, 0, intval(date('n', $d1)), intval(date('j', $d1))+1, intval(date('Y', $d1)));
}

// Create new Spreadsheet object
$objSpreadsheet = new Spreadsheet();
// Set document properties
$objSpreadsheet->getProperties()->setCreator("webTareas")
                             ->setLastModifiedBy("webTareas")
                             ->setTitle($strings["member_allocation"])
                             ->setSubject($strings["member_allocation"])
                             ->setDescription($strings["member_allocation"])
                             ->setKeywords($strings["member_allocation"]);

for ($j=0, $pRow=1; $j<$comptListMembers; $j++) {
    //
    // Initialize Member level variables
    $memberName = $listMembers->mem_name[$j];
    $memberId = $listMembers->mem_id[$j];
    $overdueHours = 0;
    /*
     * Load member's workcalendar
     */
    $querymore = " WHERE wcd.workcalendar='" . $listMembers->mem_workcalendar[$j] . "' AND wcd.date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "' AND wcd.date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "' ORDER BY wcd.date";
    $listWorkCalendarsDetail = new request();
    $listWorkCalendarsDetail->openWorkCalendarsDetail($querymore);
    $comptListWorkCalendarsDetail = count($listWorkCalendarsDetail->wcd_id);
    $d1 = $ts1;
    $listWorkHours = array();

    while ($d1 <= $ts2) {
        if (($key = array_search($d1, $listWorkCalendarsDetail->wcd_date))) {
            $listWorkHours[$d1] = $listWorkCalendarsDetail->wcd_hours[$key];
        } else {
            $listWorkHours[$d1] = 0;
        }

        $d1 = mktime(0, 0, 0, intval(date('n', $d1)), intval(date('j', $d1))+1, intval(date('Y', $d1)));
    }
    //
    // Query to list only open or not started tasks (currently being worked on or scheduled to be worked on).
    $querymore = " AND res.resource='$memberId' AND tas.status IN (" . enumStatus::stNotStarted . "," . enumStatus::stOpen . ") AND tas.start_date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "' AND tas.due_date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "' ORDER BY pro.name,tas.name";
    $listTaskHumanResource = new request();
    $listTaskHumanResource->openTaskHumanResource($querymore);
    $comptListTaskHumanResource = count($listTaskHumanResource->res_id);
    /**
     * Construct the headers
     */
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(0, $pRow, $memberName)
                ->setCellValueByColumnAndRow(1, $pRow, $S_date1)
                ->setCellValueByColumnAndRow(2, $pRow, '~')
                ->setCellValueByColumnAndRow(3, $pRow, $S_date2);
    $pRow++;
    /**
     * Construct the header row
     */
    for ($k=0; $k<count($reportLabels); $k++) {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow($k, $pRow, $reportLabels[$k]);
    }

    $pRow++;
    //
    // Initialize Member summary
    $sumHours = array();

    foreach ($listWorkHours as $key => $val) {
        $sumHours[$key] = 0;
    }

    //
    // Sumarize Tasks on each Member
    for ($k=0; $k<$comptListTaskHumanResource; $k++) {
        //
        // Populate task level information
        $projectName = $listTaskHumanResource->res_pro_name[$k];
        $taskName = $listTaskHumanResource->res_tas_name[$k];
        $taskEst = $listTaskHumanResource->res_tas_estimated_time[$k];
        $taskStartDate = $listTaskHumanResource->res_tas_start_date[$k];
        $taskDueDate = $listTaskHumanResource->res_tas_due_date[$k];
        //
        // Determine future number of working days left.
        if ($taskStartDate <= $ts1) {
            $numWorkDays = workDays($ts1, $taskDueDate, $listMembers->mem_workcalendar[$j]);
        } else {
            $numWorkDays = workDays($taskStartDate, $taskDueDate, $listMembers->mem_workcalendar[$j]);
        }
        //
        // Calculate daily hours depending on task percent complete.  Negative numHoursPerDay means its past due
        if ($numWorkDays > 0) {
            $numHoursPerDay = round($taskEst * (10 - $listTaskHumanResource->res_tas_completion[$k]) / 10 / $numWorkDays, $hourAccuracy);
        } else {
            $numHoursPerDay = 0;
            $overdueHours += round($taskEst * (10 - $listTaskHumanResource->res_tas_completion[$k]) / 10 / $numWorkDays, $hourAccuracy);
        }

        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(0, $pRow, $projectName)
                    ->setCellValueByColumnAndRow(1, $pRow, $taskName);
        $k = 2;

        foreach ($listWorkHours as $key => $val) {
            if ($val > 0) {
                if (($key >= $taskStartDate) && ($key<= $taskDueDate)) {
                    $objSpreadsheet->setActiveSheetIndex(0)
                                ->setCellValueByColumnAndRow($k, $pRow, $numHoursPerDay);
                    $sumHours[$key] += $numHoursPerDay;
                } else {
                    $objSpreadsheet->setActiveSheetIndex(0)
                                ->setCellValueByColumnAndRow($k, $pRow, '0');
                }
            }

            $k++;
        }

        $pRow++;
    }

    //
    // Summary blank row
    $pRow++;
    //
    // Summary title row
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(0, $pRow, $strings['ru_total_mem']);
    $pRow++;
    //
    // Summary daily totals row
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(1, $pRow, $strings['daily_total']);
    $k = 2;

    foreach ($listWorkHours as $key => $val) {
        if ($val > 0) {
            $objSpreadsheet->setActiveSheetIndex(0)
                        ->setCellValueByColumnAndRow($k, $pRow, $sumHours[$key]);
        }

        $k++;
    }

    $pRow++;
    //
    // Summary past required hours row
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(1, $pRow, $strings['overdue_hours'])
                ->setCellValueByColumnAndRow(2, $pRow, $overdueHours);
    $pRow+=2;
}

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objSpreadsheet->setActiveSheetIndex(0);
// Redirect output to a client’s web browser
header('Content-Type: ' . $exportFormats[$expfmtSession]['Content-Type']);
$content_disp = (WEBTAREAS_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $exportFormats[$expfmtSession]['File-Extension'] . '"');
header('Pragma: no-cache');
header('Expires: 0');
$objWriter = IOFactory::createWriter($objSpreadsheet, $exportFormats[$expfmtSession]['PHPExcel-Writer-Type']);
$objWriter->save('php://output');
