<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportpc.php,v 1.5 2013/01/18 09:50:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
require_once('../includes/PhpSpreadsheet/vendor/autoload.php');
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
if (!isset($_SESSION['TARGET']) || $_SESSION['TARGET'] != 'exportpc') {
    exit;
}

// set up the organization selection
$S_org = $_SESSION['PARAMS']['S_ORGSEL'];
// set up the project selection
$S_prj = $_SESSION['PARAMS']['S_PRJSEL'];
// end of configuration

// this is the filename the 'save as' file window will bring up by default
$filename = "project_costs";
@set_time_limit(600);

/**
 * Prepare data
 */
$conditions = array();

if ($S_org != '') {
    $conditions[] = "pro.organization" . ((is_array($S_org))?" IN ('" . implode("','", $S_org) . "')":"='$S_org'");
}

if ($S_prj != '') {
    $conditions[] = "pro.id" . ((is_array($S_prj))?" IN ('" . implode("','", $S_prj) . "')":"='$S_prj'");
}

if (!$SW_Permissions['Project']['Edit'][$profilSession]) {
    $conditions[] = "EXISTS (SELECT ppm.project FROM " . $tablePrefix . "project_permissions ppm LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=ppm.project AND tea.profil=ppm.profil WHERE ppm.project=pro.id AND tea.member='$idSession' AND ppm.view_project_budget='" . enumBoolean::bTrue . "' AND ppm.view_project_cost='" . enumBoolean::bTrue . "')";
}

if (count($conditions) > 0) {
    $querymore = " WHERE " .implode(" AND ", $conditions);
} else {
    $querymore = '';
}

$querymore .= " ORDER BY pro.organization,pro.name";
$listProjects = new request();
$listProjects->openProjects($querymore);
$comptListProjects = count($listProjects->pro_id);

if ($comptListProjects == '0') {
    exit;
}

$listProjectBudget = new request();
$listProjectCost = new request();
$showExchangeNotFoundNote = false;

for ($x=0; $x<$comptListProjects; $x++) {
    $project_id = $listProjects->pro_id[$x];
    $cost_method = $listProjects->pro_cost_method[$x];
    // display currency
    if ($projectDetail->pro_currency[0] == '') {
        $cud = $defaultCurrency;
    } else {
        $cud = $projectDetail->pro_currency[0];
    }

    $listProjects->display_currency[$x] = $cud;
    // get budget currency list
    $tmpquery1 = "SELECT DISTINCT currency FROM " . $tablePrefix . "projects_budget WHERE project='$project_id' AND currency<>'$cud' AND amount>0";
    $listCurrencies = new request();
    $listCurrencies->connectClass();
    $listCurrencies->query($tmpquery1);
    $listCurrencies->currency = array();
    $listCurrencies->exchange_rate = array();

    while ($listCurrencies->fetch()) {
        $listCurrencies->currency[] = ($row[0]);
    }

    $listCurrencies->close();

    // get currency exchange rate list
    if (count($listCurrencies->currency) > 0) {
        for ($i=0; $i<count($listCurrencies->currency); $i++) {
            $cu = $listCurrencies->currency[$i];
            $querymore4 = " WHERE cur.currency_to='$cud' AND cur.currency_from='$cu' AND cur.reference_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d'))+1,intval(date('Y'))) . "' ORDER BY cur.reference_date DESC";
            $listCurrencyRates = new request();
            $listCurrencyRates->openCurrencyRates($querymore4);

            if (count($listCurrencyRates->cur_currency_from) > 0) {
                $listCurrencies->exchange_rate[$cu] = $listCurrencyRates->cur_exchange_rate[0];
            } else {
                $listCurrencies->exchange_rate[$cu] = -1;
            }
        }
    }

    // get project budget cost type list
    $tmpquery2 = "SELECT pjb.costtype FROM " . $tablePrefix . "projects_budget pjb WHERE pjb.project='$project_id' GROUP BY pjb.costtype";
    $listProjectBudget->connectClass();
    $listProjectBudget->query($tmpquery2);
    $listProjectBudget->costtype = array();
    $listProjectBudget->total[$project_id] = 0;

    while ($listProjectBudget->fetch()) {
        $ct = ($row[0]);
        $listProjectBudget->costtype[] = $ct;
    }

    $listProjectBudget->close();

    // get project budget details
    for ($i=0; $i<count($listProjectBudget->costtype); $i++) {
        $tmpquery3 = "SELECT currency,amount FROM " . $tablePrefix . "projects_budget WHERE project='$project_id' AND costtype='" . $listProjectBudget->costtype[$i] . "' AND amount>0";
        $listProjectBudget->connectClass();
        $listProjectBudget->query($tmpquery3);

        while ($listProjectBudget->fetch()) {
            $cu = ($row[0]);
            $am = ($row[1]);

            if ($cu == $cud) {
                $amount = (is_numeric($am))?round($am, $costAccuracy):0;
            } else {
                if ($listCurrencies->exchange_rate[$cu] === -1) {
                    $amount = '--';
                } else {
                    $amount = ((is_numeric($am))?round($am, $costAccuracy):0) * $listCurrencies->exchange_rate[$cu];
                }
            }

            if ($amount === '--') {
                $showExchangeNotFoundNote = true;
                $listProjectBudget->total[$project_id] = '--';
                break;
            } else {
                if ($listProjectBudget->total[$project_id] !== '--') {
                    $listProjectBudget->total[$project_id] += $amount;
                }
            }
        }

        $listProjectBudget->close();
    }

    // get project cost (labor)
    switch ($cost_method) {
        case '1':   // Use the cost rate of member only
            $tmpquery = "SELECT svc.currency,SUM(svc.hourly_rate_i*t0.hours) AS amount FROM
    (SELECT wkh.project AS project,wkh.owner AS member,wkh.hours AS hours
    FROM " . $tablePrefix . "work_hours wkh
    WHERE wkh.project='$project_id' " . (($enableTimesheet == 'true')?"AND EXISTS (
        SELECT * FROM " . $tablePrefix . "timesheet ts1
        INNER JOIN " . $tablePrefix . "periods pe1 ON pe1.id=ts1.period
        WHERE ts1.owner=wkh.owner AND ts1.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND wkh.date>=pe1.date_start AND wkh.date<=pe1.date_end
    )":'') . "
    UNION ALL
    SELECT tim.project AS project,tim.owner AS member,tim.hours AS hours
    FROM " . $tablePrefix . "tasks_time tim
    WHERE tim.project='$project_id' " . (($enableTimesheet == 'true')?"AND EXISTS (
        SELECT * FROM " . $tablePrefix . "timesheet ts2
        INNER JOIN " . $tablePrefix . "periods pe2 ON pe2.id=ts2.period
        WHERE ts2.owner=tim.owner AND ts2.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND tim.date>=pe2.date_start AND tim.date<=pe2.date_end
    )":'') . "
    UNION ALL
    SELECT mti.project AS project,mti.owner AS member,mti.hours AS hours
    FROM " . $tablePrefix . "meetings_time mti
    WHERE mti.project='$project_id' " . (($enableTimesheet == 'true')?"AND EXISTS (
        SELECT * FROM " . $tablePrefix . "timesheet ts3
        INNER JOIN " . $tablePrefix . "periods pe3 ON pe3.id=ts3.period
        WHERE ts3.owner=mti.owner AND ts3.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND mti.date>=pe3.date_start AND mti.date<=pe3.date_end
    )":'') . ") t0
    INNER JOIN " . $tablePrefix . "teams tea ON tea.project=t0.project AND tea.member=t0.member
    INNER JOIN " . $tablePrefix . "services svc ON svc.id=tea.service
    WHERE t0.hours>0 AND svc.hourly_rate_i>0
    GROUP BY svc.currency ORDER BY svc.currency
    ";
            break;
        case '2':   // Use the hourly rate of service first and use the cost rate of member if no service specified
            $tmpquery = "SELECT tx.currency,SUM(tx.rate*tx.hours) AS amount FROM
    (SELECT svc.currency AS currency,svc.hourly_rate_i AS rate,t0.hours AS hours FROM
    (SELECT wkh.service AS service,wkh.hours AS hours
    FROM " . $tablePrefix . "work_hours wkh
    WHERE wkh.project='$project_id' " . (($enableTimesheet == 'true')?"AND EXISTS (
        SELECT * FROM " . $tablePrefix . "timesheet ts1
        INNER JOIN " . $tablePrefix . "periods pe1 ON pe1.id=ts1.period
        WHERE ts1.owner=wkh.owner AND ts1.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND wkh.date>=pe1.date_start AND wkh.date<=pe1.date_end
    )":'') . "
    UNION ALL
    SELECT tas.service AS service,tim.hours AS hours
    FROM " . $tablePrefix . "tasks_time tim
    LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id=tim.task
    WHERE tim.project='$project_id' " . (($enableTimesheet == 'true')?"AND EXISTS (
        SELECT * FROM " . $tablePrefix . "timesheet ts2
        INNER JOIN " . $tablePrefix . "periods pe2 ON pe2.id=ts2.period
        WHERE ts2.owner=tim.owner AND ts2.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND tim.date>=pe2.date_start AND tim.date<=pe2.date_end
    )":'') . ") t0
    INNER JOIN " . $tablePrefix . "services svc ON svc.id=t0.service
    WHERE t0.hours>0 AND svc.hourly_rate_i>0
    UNION ALL
    SELECT svc.currency AS currency,svc.hourly_rate_i AS rate,t0.hours AS hours FROM
    (SELECT wkh.project AS project,wkh.owner AS member,wkh.hours AS hours
    FROM " . $tablePrefix . "work_hours wkh
    WHERE wkh.project='$project_id' AND wkh.service='0' " . (($enableTimesheet == 'true')?"AND EXISTS (
        SELECT * FROM " . $tablePrefix . "timesheet ts1
        INNER JOIN " . $tablePrefix . "periods pe1 ON pe1.id=ts1.period
        WHERE ts1.owner=wkh.owner AND ts1.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND wkh.date>=pe1.date_start AND wkh.date<=pe1.date_end
    )":'') . "
    UNION ALL
    SELECT tim.project AS project,tim.owner AS member,tim.hours AS hours
    FROM " . $tablePrefix . "tasks_time tim
    INNER JOIN " . $tablePrefix . "tasks tas ON tas.id=tim.task
    WHERE tim.project='$project_id' AND tas.service='0' " . (($enableTimesheet == 'true')?"AND EXISTS (
        SELECT * FROM " . $tablePrefix . "timesheet ts2
        INNER JOIN " . $tablePrefix . "periods pe2 ON pe2.id=ts2.period
        WHERE ts2.owner=tim.owner AND ts2.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND tim.date>=pe2.date_start AND tim.date<=pe2.date_end
    )":'') . "
    UNION ALL
    SELECT mti.project AS project,mti.owner AS member,mti.hours AS hours
    FROM " . $tablePrefix . "meetings_time mti
    WHERE mti.project='$project_id' " . (($enableTimesheet == 'true')?"AND EXISTS (
        SELECT * FROM " . $tablePrefix . "timesheet ts3
        INNER JOIN " . $tablePrefix . "periods pe3 ON pe3.id=ts3.period
        WHERE ts3.owner=mti.owner AND ts3.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND mti.date>=pe3.date_start AND mti.date<=pe3.date_end
    )":'') . ") t0
    INNER JOIN " . $tablePrefix . "teams tea ON tea.project=t0.project AND tea.member=t0.member
    INNER JOIN " . $tablePrefix . "services svc ON svc.id=tea.service
    WHERE t0.hours>0 AND svc.hourly_rate_i>0
    ) tx GROUP BY tx.currency ORDER BY tx.currency
    ";
            break;
        case '3':   // Use the hourly rate of service only
            $tmpquery = "SELECT svc.currency,SUM(svc.hourly_rate_i*t0.hours) AS amount FROM
    (SELECT wkh.service AS service,wkh.hours AS hours
    FROM " . $tablePrefix . "work_hours wkh
    WHERE wkh.project='$project_id' " . (($enableTimesheet == 'true')?"AND EXISTS (
        SELECT * FROM " . $tablePrefix . "timesheet ts1
        INNER JOIN " . $tablePrefix . "periods pe1 ON pe1.id=ts1.period
        WHERE ts1.owner=wkh.owner AND ts1.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND wkh.date>=pe1.date_start AND wkh.date<=pe1.date_end
    )":'') . "
    UNION ALL
    SELECT tas.service AS service,tim.hours AS hours
    FROM " . $tablePrefix . "tasks_time tim
    LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id=tim.task
    WHERE tim.project='$project_id' " . (($enableTimesheet == 'true')?"AND EXISTS (
        SELECT * FROM " . $tablePrefix . "timesheet ts2
        INNER JOIN " . $tablePrefix . "periods pe2 ON pe2.id=ts2.period
        WHERE ts2.owner=tim.owner AND ts2.status IN ('" . enumFileStatus::stApproved . "','" . enumFileStatus::stNoApprovalsNeeded . "') AND tim.date>=pe2.date_start AND tim.date<=pe2.date_end
    )":'') . ") t0
    INNER JOIN " . $tablePrefix . "services svc ON svc.id=t0.service
    WHERE t0.hours>0 AND svc.hourly_rate_i>0
    GROUP BY svc.currency ORDER BY svc.currency
    ";
            break;
    }

    $listProjectCost->connectClass();
    $listProjectCost->query($tmpquery);
    $listProjectCost->totoal[$project_id] = 0;
    $laborCost = 0;

    while ($listProjectCost->fetch()) {
        $cu = ($row[0]);
        $am = ($row[1]);

        if ($cu == $cud) {
            $amount = (is_numeric($am))?round($am, $costAccuracy):0;
        } else {
            if (!in_array($cu, $listCurrencies->currency)) {
                $listCurrencies->currency[] = $cu;
                // get currency exchange rate
                $querymore4 = " WHERE cur.currency_to='$cud' AND cur.currency_from='$cu' AND cur.reference_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d'))+1,intval(date('Y'))) . "' ORDER BY cur.reference_date DESC";
                $listCurrencyRates = new request();
                $listCurrencyRates->openCurrencyRates($querymore4);

                if (count($listCurrencyRates->cur_currency_from) > 0) {
                    $listCurrencies->exchange_rate[$cu] = $listCurrencyRates->cur_exchange_rate[0];
                } else {
                    $listCurrencies->exchange_rate[$cu] = -1;
                }
            }

            if ($listCurrencies->exchange_rate[$cu] === -1) {
                $amount = '--';
            } else {
                $amount = ((is_numeric($am))?round($am, $costAccuracy):0) * $listCurrencies->exchange_rate[$cu];
            }
        }

        if ($amount === '--') {
            $showExchangeNotFoundNote = true;
            $laborCost = '--';
            break;
        } else {
            $laborCost += $amount;
        }
    }

    $listProjectCost->close();

    if ($laborCost !== 0) {
        $listProjectCost->total[$project_id] = $laborCost;
    }

    // get project cost (material)
    $tmpquery = "SELECT t0.currency,SUM(t0.amount) AS amount FROM
    (SELECT mat.currency,mat.costrate*iss.quantity AS amount
    FROM " . $tablePrefix . "material_issue iss
    INNER JOIN " . $tablePrefix . "materials mat ON mat.id=iss.material
    WHERE iss.project='$project_id' AND mat.costrate>0 AND iss.quantity>0
    ) t0 GROUP BY t0.currency ORDER BY t0.currency
    ";
    $listProjectCost->connectClass();
    $listProjectCost->query($tmpquery);
    $materialCost = 0;

    while ($listProjectCost->fetch()) {
        $cu = ($row[0]);
        $am = ($row[1]);

        if ($cu == $cud) {
            $amount = (is_numeric($am))?round($am, $costAccuracy):0;
        } else {
            if (!in_array($cu, $listCurrencies->currency)) {
                $listCurrencies->currency[] = $cu;
                // get currency exchange rate
                $querymore4 = " WHERE cur.currency_to='$cud' AND cur.currency_from='$cu' AND cur.reference_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d'))+1,intval(date('Y'))) . "' ORDER BY cur.reference_date DESC";
                $listCurrencyRates = new request();
                $listCurrencyRates->openCurrencyRates($querymore4);

                if (count($listCurrencyRates->cur_currency_from) > 0) {
                    $listCurrencies->exchange_rate[$cu] = $listCurrencyRates->cur_exchange_rate[0];
                } else {
                    $listCurrencies->exchange_rate[$cu] = -1;
                }
            }

            if ($listCurrencies->exchange_rate[$cu] === -1) {
                $amount = '--';
            } else {
                $amount = ((is_numeric($am))?round($am, $costAccuracy):0) * $listCurrencies->exchange_rate[$cu];
            }
        }

        if ($amount === '--') {
            $showExchangeNotFoundNote = true;
            $materialCost = '--';
            break;
        } else {
            $materialCost += $amount;
        }
    }

    $listProjectCost->close();

    if ($materialCost !== 0) {
        if ($materialCost === '--' || $listProjectCost->total[$project_id] === '--') {
            $listProjectCost->total[$project_id] = '--';
        } else {
            $listProjectCost->total[$project_id] += $materialCost;
        }
    }

    // get project cost (expense)
    $tmpquery = "SELECT exp.claimtype FROM " . $tablePrefix . "expenses exp WHERE exp.project='$project_id' AND exp.status<>'" . enumDocumentStatus::stDraft . "' AND exp.amount>0 GROUP BY exp.claimtype";
    $listProjectCost->connectClass();
    $listProjectCost->query($tmpquery);
    $ctList = array();

    while ($listProjectCost->fetch()) {
        $ctList[] = ($row[0]);
    }

    $listProjectCost->close();

    foreach ($ctList as $ct) {
        $tmpquery = "SELECT currency,SUM(amount) FROM " . $tablePrefix . "expenses WHERE project='$project_id' AND status NOT IN ('" . enumFileStatus::stNeedsApproval . "','" . enumFileStatus::stNotApproved . "') AND claimtype='$ct' AND amount>0 GROUP BY currency";
        $listProjectCost->connectClass();
        $listProjectCost->query($tmpquery);
        $expenseCost = 0;

        while ($listProjectCost->fetch()) {
            $cu = ($row[0]);
            $am = ($row[1]);

            if ($cu == $cud) {
                $amount = (is_numeric($am))?round($am, $costAccuracy):0;
            } else {
                if (!in_array($cu, $listCurrencies->currency)) {
                    $listCurrencies->currency[] = $cu;
                    // get currency exchange rate
                    $querymore4 = " WHERE cur.currency_to='$cud' AND cur.currency_from='$cu' AND cur.reference_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d'))+1,intval(date('Y'))) . "' ORDER BY cur.reference_date DESC";
                    $listCurrencyRates = new request();
                    $listCurrencyRates->openCurrencyRates($querymore4);

                    if (count($listCurrencyRates->cur_currency_from) > 0) {
                        $listCurrencies->exchange_rate[$cu] = $listCurrencyRates->cur_exchange_rate[0];
                    } else {
                        $listCurrencies->exchange_rate[$cu] = -1;
                    }
                }

                if ($listCurrencies->exchange_rate[$cu] === -1) {
                    $amount = '--';
                } else {
                    $amount = ((is_numeric($am))?round($am, $costAccuracy):0) * $listCurrencies->exchange_rate[$cu];
                }
            }

            if ($amount === '--') {
                $showExchangeNotFoundNote = true;
                $expenseCost = '--';
                break;
            } else {
                $expenseCost += $amount;
            }
        }

        $listProjectCost->close();

        if ($expenseCost !== 0) {
            if ($expenseCost === '--' || $listProjectCost->total[$project_id] === '--') {
                $listProjectCost->total[$project_id] = '--';
            } else {
                $listProjectCost->total[$project_id] += $expenseCost;
            }
        }
    }
}

// Create new Spreadsheet object
$objSpreadsheet = new Spreadsheet();
// Set document properties
$objSpreadsheet->getProperties()->setCreator("webTareas")
                             ->setLastModifiedBy("webTareas")
                             ->setTitle($strings["project_cost"])
                             ->setSubject($strings["project_cost"])
                             ->setDescription($strings["project_cost"])
                             ->setKeywords($strings["project_cost"]);
/**
 * Construct the headers
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A1', $strings["project_cost"]);
/**
 * Construct the header row
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A3', $strings["organization"])
            ->setCellValue('B3', $strings["project"])
            ->setCellValue('C3', $strings["currency"])
            ->setCellValue('D3', $strings["budget"])
            ->setCellValue('E3', $strings["cost"])
            ->setCellValue('F3', $strings["variance"]);
/*
 * Construct the content
 */
for ($i=0, $pRow=4; $i<$comptListProjects; $i++, $pRow++) {
    /**
     * The individual fields
     */
    // organization name
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(0, $pRow, $listProjects->pro_org_name[$i])         // organization name
                ->setCellValueByColumnAndRow(1, $pRow, $listProjects->pro_name[$i])             // project name
                ->setCellValueByColumnAndRow(2, $pRow, $listProjects->display_currency[$i]);    // currency
    // budget
    if ($listProjectBudget->total[$project_id] === '--') {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(3, $pRow, '--');
    } else {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(3, $pRow, $listProjectBudget->total[$project_id]);
    }
    // cost
    if ($listProjectCost->total[$project_id] === '--') {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(4, $pRow, '--');
    } else {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(4, $pRow, $listProjectCost->total[$project_id]);
    }
    // variance
    if ($listProjectBudget->total[$project_id] === '--' || $listProjectCost->total[$project_id] === '--') {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(5, $pRow, '--');
    } else {
        $variance = $listProjectBudget->total[$project_id] - $listProjectCost->total[$project_id];
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(5, $pRow, $variance);
    }
}

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objSpreadsheet->setActiveSheetIndex(0);
// Redirect output to a client’s web browser
header('Content-Type: ' . $exportFormats[$expfmtSession]['Content-Type']);
$content_disp = (WEBTAREAS_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $exportFormats[$expfmtSession]['File-Extension'] . '"');
header('Pragma: no-cache');
header('Expires: 0');
$objWriter = IOFactory::createWriter($objSpreadsheet, $exportFormats[$expfmtSession]['PHPExcel-Writer-Type']);
$objWriter->save('php://output');
