<?php // $Revision: 1.10 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportreportdefinitions.php,v 1.10 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$tblnamSys = array();
$tblnamCfd = array();

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Edit'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$ids = explode('**', $id);
$id = "'" . implode("','", $ids) . "'";
$querymore1 = " WHERE rep.id IN ($id) AND rep.sysdef='N'";
$listReports = new request();
$listReports->openReports($querymore1);
$comptListReports = count($listReports->rep_id);

if ($comptListReports != count($ids)) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * get field type name
 */
function getFieldTypeName($fldtyp)
{
    $fldnam = '';

    switch ($fldtyp) {
        case enumFieldType::ftText:
            $fldnam = 'text';
            break;
        case enumFieldType::ftNumeric:
            $fldnam = 'numeric';
            break;
        case enumFieldType::ftMemo:
            $fldnam = 'memo';
            break;
        case enumFieldType::ftDate:
            $fldnam = 'date';
            break;
        case enumFieldType::ftTime:
            $fldnam = 'time';
            break;
        case enumFieldType::ftHours:
            $fldnam = 'hours';
            break;
        case enumFieldType::ftRate:
            $fldnam = 'rate';
            break;
        case enumFieldType::ftTotals:
            $fldnam = 'totals';
            break;
        case enumFieldType::ftImage:
            $fldnam = 'image';
            break;
        case enumFieldType::ftBoolean:
            $fldnam = 'boolean';
            break;
        case enumFieldType::ftEmail:
            $fldnam = 'e-mail';
            break;
        case enumFieldType::ftUrl:
            $fldnam = 'url';
            break;
        case enumFieldType::ftAlphaNumeric:
            $fldnam = 'alpha-numeric';
            break;
        case enumFieldType::ftTimestamp:
            $fldnam = 'timestamp';
            break;
        case enumFieldType::ftQuantity:
            $fldnam = 'quantity';
            break;
        case enumFieldType::ftMeasure:
            $fldnam = 'measure';
            break;
        case enumFieldType::ftSerial:
            $fldnam = 'serial';
            break;
        case enumFieldType::ftPercentage:
            $fldnam = 'percentage';
            break;
        case enumFieldType::ftAudio:
            $fldnam = 'audio';
            break;
        case enumFieldType::ftVideo:
            $fldnam = 'video';
            break;
        case enumFieldType::ftPassword:
            $fldnam = 'password';
            break;
    }

    return $fldnam;
}

/**
 * create ZIP file archive
 */
$zip = new ZipArchive();
$tmpfname = tempnam(str_replace('//', '/', $basedir . '/files'), 'tmp');
$zip->open($tmpfname, ZipArchive::OVERWRITE);

/**
 *  create report definitions XML document
 */
$doc1 = new DOMDocument('1.0', 'UTF-8');
$doc1->formatOutput = true;
$reports = $doc1->createElement("reports");
$doc1->appendChild($reports);

for ($i=0; $i<$comptListReports; $i++) {
    $userquery = $listReports->rep_userquery[$i];   // user query text
    // search for system tables
    if (preg_match_all("/\[\[(\w+)\]\]/", $userquery, $matches1) > 0) {
        foreach ($matches1[1] as $tblnam) {
            if (!in_array($tblnam, $tblnamSys)) {
                $tblnamSys[] = $tblnam;
            }
        }
    }
    // search for custom form templates
    if (preg_match_all("/\[\[(@\w+)\]\]/", $userquery, $matches2) > 0) {
        foreach ($matches2[1] as $tblnam) {
            if (!in_array($tblnam, $tblnamCfd)) {
                $tblnamCfd[] = $tblnam;
            }
        }
    }
    /**
     * Get report parameters
     */
    $querymore3 = " WHERE repr.report='" . $listReports->rep_id[$i] . "' AND repr.parameter='" . enumBoolean::bTrue . "' ORDER BY repr.id";
    $listParameters = new request();
    $listParameters->openReportsCriteria($querymore3);
    $comptListParameters = count($listParameters->repr_report);
    /**
     * Get related tables
     */
    $querymore7 = " WHERE repl.report='" . $listReports->rep_id[$i] . "' ORDER BY repl.id";
    $listReportRelatedTables = new request();
    $listReportRelatedTables->openReportsRelatedTables($querymore7);
    $comptListReportRelatedTables = count($listReportRelatedTables->repl_id);
    /**
     * Get report output and field grouping
     */
    $querymore6 = " WHERE repo.report='" . $listReports->rep_id[$i] . "' ORDER BY repo.disp_order";
    $listReportOutput = new request();
    $listReportOutput->openReportsOutput($querymore6);
    $comptListReportOutput = count($listReportOutput->repo_id);
    /**
     * Put report in XML document
     */
    $report = $doc1->createElement("report");
    $reports->appendChild($report);
    $report->appendChild($doc1->createElement('name', $listReports->rep_name[$i]));      // The name of report
    $report->appendChild($doc1->createElement('query', HtmlEntitiesNOD($userquery)));    // report query text
    $report->appendChild($doc1->createElement('name_print', $listReports->rep_name_print[$i]));      // report name print
    $report->appendChild($doc1->createElement('description', $listReports->rep_description[$i]));    // report description

    if ($comptListParameters > 0) {
        $parameters = $doc1->createElement('parameters');
        $report->appendChild($parameters);

        for ($j=0,$uid=1; $j<$comptListParameters; $j++,$uid++) {
            $parameter = $doc1->createElement('parameter');
            $parameters->appendChild($parameter);
            $parameter->appendChild($doc1->createElement('uid', $uid));                                  // 1-based serial number

            if ($listParameters->repr_fieldtype[$j] == '') {
                $parameter->appendChild($doc1->createElement('tablename', $listParameters->repr_repl_tablename[$j]));// table name
                $parameter->appendChild($doc1->createElement('fieldname', $listParameters->repr_fieldname[$j]));     // field name
                $parameter->appendChild($doc1->createElement('fieldtype', ''));                                      // field type
            } else {
                $parameter->appendChild($doc1->createElement('tablename', ''));                                      // table name
                $parameter->appendChild($doc1->createElement('fieldname', ''));                                      // field name
                $parameter->appendChild($doc1->createElement('fieldtype', getFieldTypeName($listParameters->repr_fieldtype[$j])));   // field type
            }

            $parameter->appendChild($doc1->createElement('ratio', (($listParameters->repr_ratio[$j]==enumRatio::rInRange)?'range':'single')));    // field operation
            $parameter->appendChild($doc1->createElement('value', $listParameters->repr_value[$j]));             // parameter name
        }
    }

    $outputs = $doc1->createElement('outputs');
    $report->appendChild($outputs);

    for ($j=0; $j<$comptListReportOutput; $j++) {
        $output = $doc1->createElement('output');
        $outputs->appendChild($output);

        if ($listReportOutput->repo_fieldtype[$j] == '') {
            $output->appendChild($doc1->createElement('tablename', $listReportOutput->repo_tablename[$j]));      // table name
            $output->appendChild($doc1->createElement('fieldname', $listReportOutput->repo_fieldname[$j]));      // field name
            $output->appendChild($doc1->createElement('fieldtype', ''));                                         // field type
        } else {
            $output->appendChild($doc1->createElement('tablename', ''));                                         // table name
            $output->appendChild($doc1->createElement('fieldname', ''));                                         // field name
            $output->appendChild($doc1->createElement('fieldtype', getFieldTypeName($listReportOutput->repo_fieldtype[$j])));    // field type
        }

        $output->appendChild($doc1->createElement('title', $listReportOutput->repo_title[$j]));                  // title
    }
}

// add report definitions XML document to ZIP file archive
$zip->addFromString('reports.xml', $doc1->saveXML());

if (count($tblnamSys) > 0 || count($tblnamCfd) > 0) {
    if (count($tblnamCfd) > 0) {
        $ftdS = "'" . implode("','", $tblnamCfd) . "'";
    } else {
        $ftdS = "'dummy'";
    }
    // export child custom form templates & custom form templates linked to fields along with selected custom form templates
    $querymore = " WHERE tdf.sysdef='N' AND (tdf.tablename IN ($ftdS) OR tdf.fathertable IN ($ftdS) OR tdf.tablename IN (SELECT fdf.linkedtable FROM " . $tablePrefix . "fields_def fdf INNER JOIN " . $tablePrefix . "tables_def tdf1 ON tdf1.tablename=fdf.tablename INNER JOIN " . $tablePrefix . "tables_def tdf2 ON tdf2.tablename=fdf.linkedtable WHERE tdf1.sysdef='N' AND tdf2.sysdef='N' AND (tdf1.tablename IN ($ftdS) OR tdf1.fathertable IN ($ftdS))) OR tdf.fathertable IN (SELECT fdf.linkedtable FROM " . $tablePrefix . "fields_def fdf INNER JOIN " . $tablePrefix . "tables_def tdf1 ON tdf1.tablename=fdf.tablename INNER JOIN " . $tablePrefix . "tables_def tdf2 ON tdf2.tablename=fdf.linkedtable WHERE tdf1.sysdef='N' AND tdf2.sysdef='N' AND (tdf1.tablename IN ($ftdS) OR tdf1.fathertable IN ($ftdS)))";

    if (count($tblnamSys) > 0) {
        $conditions = array();

        foreach ($tblnamSys as $tblnam) {
            $conditions[] = "(fdf.tablename='$tblnam' AND fdf.sysdef='N')";
        }

        $querymore .= " OR tdf.tablename IN (SELECT fdf.linkedtable FROM " . $tablePrefix . "fields_def fdf INNER JOIN " . $tablePrefix . "tables_def tdf1 ON tdf1.tablename=fdf.tablename INNER JOIN " . $tablePrefix . "tables_def tdf2 ON tdf2.tablename=fdf.linkedtable WHERE tdf1.sysdef='N' AND tdf2.sysdef='N' AND (" . implode(" OR ", $conditions) . ")) OR tdf.fathertable IN (SELECT fdf.linkedtable FROM " . $tablePrefix . "fields_def fdf INNER JOIN " . $tablePrefix . "tables_def tdf1 ON tdf1.tablename=fdf.tablename INNER JOIN " . $tablePrefix . "tables_def tdf2 ON tdf2.tablename=fdf.linkedtable WHERE tdf1.sysdef='N' AND tdf2.sysdef='N' AND (" . implode(" OR ", $conditions) . "))";
    }

    $querymore .= ")";
    $listTablesDefinitions = new request();
    $listTablesDefinitions->openTablesDefinitions($querymore);
    $comptListTablesDefinitions = count($listTablesDefinitions->tdf_tablename);

    if ($comptListTablesDefinitions > 0) {
        $doc2 = exportFormTemplates($listTablesDefinitions);
        // add form template definition XML document to ZIP file archive
        $zip->addFromString('form_templates.xml', $doc2->saveXML());
    }
}

if (count($tblnamSys) > 0) {
    $conditions = array();

    foreach ($tblnamSys as $tblnam) {
        $conditions[] = "(fdf.tablename='$tblnam' AND fdf.sysdef='N')";
    }

    $querymore = " WHERE " . implode(" OR ", $conditions);
    $listFieldsDefinitions = new request();
    $listFieldsDefinitions->openFieldsDefinitions($querymore);
    $comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

    if ($comptListFieldsDefinitions > 0) {
        $doc3 = exportCustomFields($listFieldsDefinitions);
        // add custom field definition XML document to ZIP file archive
        $zip->addFromString('custom_fields.xml', $doc3->saveXML());
    }
}

$zip->close();
$name = (($comptListReports==1)?$listReports->rep_name[0]:$listReports->rep_repc_name[0]) . '.zip';
// MIMETypes should be handled using PHP mime.magic once it's out
require_once('../includes/mimetypes.php');
$mimetype = $mimetypes['zip'];

/**
 * Output
 */
header('Content-Length: ' . filesize($tmpfname));
header('Content-Type: ' . $mimetype);
header("Content-Disposition: attachment; filename=" . $name);
// write file as response
readfile($tmpfname);
// delete temp file
unlink($tmpfname);
