<?php // $Revision: 1.15 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportru.php,v 1.15 2013/01/18 09:50:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * Includes
 */
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
require_once('../includes/PhpSpreadsheet/vendor/autoload.php');
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
if (!isset($_SESSION['TARGET']) || $_SESSION['TARGET'] != 'exportru') {
    exit;
}

// set up the organization selection
$S_org = $_SESSION['PARAMS']['S_ORGSEL'];
// set up the project selection
$S_prj = $_SESSION['PARAMS']['S_PRJSEL'];
// set up the department selection
$S_dep = $_SESSION['PARAMS']['S_DEPSEL'];
// set up the member selection
$S_mem = $_SESSION['PARAMS']['S_ATSEL'];
// a date range was selected
$S_date1 = $_SESSION['PARAMS']['S_DATE1'];
$S_date2 = $_SESSION['PARAMS']['S_DATE2'];
// billing selection
$billingSelection = $_SESSION['PARAMS']['S_BILLING'];
// end of configuration

// this is the filename the 'save as' file window will bring up by default
$filename = "rusage";
@set_time_limit(600);
// a member selection was made
if ($S_mem == '') {
    $query = " WHERE T0.owner='0'";
} else {
    $query = " WHERE T0.owner" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}
// a organization selection was made
if ($S_org != '') {
    $query .= " AND T0.organization" . ((is_array($S_org))?" IN ('" . implode("','", $S_org) . "')":"='$S_org'");
}
// a project selection was made
if ($S_prj != '') {
    $query .= " AND T0.project" . ((is_array($S_prj))?" IN ('" . implode("','", $S_prj) . "')":"='$S_prj'");
}
// a department selection was made
if ($S_dep != '') {
    $query .= " AND T0.department" . ((is_array($S_dep))?" IN ('" . implode("','", $S_dep) . "')":"='$S_dep'");
}
// handle date ranges, if supplied
if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $query .= " AND T0.date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $query .= " AND T0.date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}
// billing selection
if ($billingSelection != 'ALL') {
    $query .= " AND T0.billing='$billingSelection'";
}

$hourCodeSql = "CASE wkh.work";
$listHourCode = new request();
$listHourCode->openHourCode('');
$comptListHourCode = count($listHourCode->hrc_id);

for ($iffa=0; $iffa<$comptListHourCode; $iffa++) {
    $hourCodeSql .= " WHEN '" . $listHourCode->hrc_id[$iffa] . "' THEN '" . HtmlEntitiesNOD($listHourCode->hrc_name_print[$iffa]) . "'";
}

$hourCodeSql .= " ELSE '' END";
$tmpquery = "SELECT T1.doc_type,T1.doc_id,T1.doc_name,T1.organization,T1.org_name,T1.project,T1.pro_name,T1.owner,T1.mem_name,SUM(T1.hours) FROM (
SELECT T0.doc_type,T0.doc_id,T0.doc_name,T0.organization,T0.org_name,T0.project,T0.pro_name,T0.owner,T0.mem_name,T0.hours FROM (
SELECT 'T' AS doc_type,tim.task AS doc_id,tas.name AS doc_name,pro.organization,org.name AS org_name,tim.project,pro.name AS pro_name,tim.owner,mem.name AS mem_name,mem.department,tim.date,tim.hours,tim.billing FROM " . $tablePrefix . "tasks_time tim LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id=tim.task LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=tim.project LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=tim.owner
) T0 $query UNION ALL
SELECT T0.doc_type,T0.doc_id,T0.doc_name,T0.organization,T0.org_name,T0.project,T0.pro_name,T0.owner,T0.mem_name,T0.hours FROM (
SELECT 'M' AS doc_type,mti.meeting AS doc_id,mee.name AS doc_name,pro.organization,org.name AS org_name,mti.project,pro.name AS pro_name,mti.owner,mem.name AS mem_name,mem.department,mti.date,mti.hours,CAST('" . enumBoolean::bFalse . "' AS char(1)) AS billing FROM " . $tablePrefix . "meetings_time mti LEFT OUTER JOIN " . $tablePrefix . "meetings mee ON mee.id=mti.meeting LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=mti.project LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=mti.owner
) T0 $query UNION ALL
SELECT T0.doc_type,T0.doc_id,T0.doc_name,T0.organization,T0.org_name,T0.project,T0.pro_name,T0.owner,T0.mem_name,T0.hours FROM (
SELECT 'W' AS doc_type,wkh.work AS doc_id,$hourCodeSql AS doc_name,pro.organization,org.name AS org_name,wkh.project,pro.name AS pro_name,wkh.owner,mem.name AS mem_name,mem.department,wkh.date,wkh.hours,wkh.billing FROM " . $tablePrefix . "work_hours wkh LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=wkh.project LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=wkh.owner
) T0 $query
) T1 GROUP BY T1.doc_type,T1.doc_id,T1.doc_name,T1.organization,T1.org_name,T1.project,T1.pro_name,T1.owner,T1.mem_name
ORDER BY T1.org_name,T1.pro_name,T1.mem_name";
$listHours = new request();
$listHours->connectClass();
$listHours->query($tmpquery);
$listHours->tim_doc_type = array();

while ($listHours->fetch()) {
    $i = 0;
    $listHours->tim_doc_type[] = ($row[$i++]);
    $listHours->tim_doc_id[] = ($row[$i++]);
    $listHours->tim_doc_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->tim_organization[] = ($row[$i++]);
    $listHours->tim_org_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->tim_project[] = ($row[$i++]);
    $listHours->tim_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->tim_owner[] = ($row[$i++]);
    $listHours->tim_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $hours = ($row[$i++]);
    $hours = (is_numeric($hours))?round($hours, $hourAccuracy):'0';
    $listHours->tim_hours[] = $hours;
}

$listHours->close();
$comptListHours = count($listHours->tim_doc_type);

if ($comptListHours == '0') {
    exit;
}

// Create new Spreadsheet object
$objSpreadsheet = new Spreadsheet();
// Set document properties
$objSpreadsheet->getProperties()->setCreator("webTareas")
                             ->setLastModifiedBy("webTareas")
                             ->setTitle($strings["resource_usage"])
                             ->setSubject($strings["resource_usage"])
                             ->setDescription($strings["resource_usage"])
                             ->setKeywords($strings["resource_usage"]);
/**
 * Construct the headers
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A1', $strings["ru_detail"]);
/**
 * Construct the header row
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A2', $strings["organization"])
            ->setCellValue('B2', $strings["project"])
            ->setCellValue('C2', $strings["member"])
            ->setCellValue('D2', $strings["task"])
            ->setCellValue('E2', $strings["hours"]);
/*
 * Construct the content
 */
for ($i=0, $pRow=3; $i<$comptListHours; $i++, $pRow++) {
    // client name
    if ($listHours->tim_organization[$i] != '' && $listHours->tim_organization[$i] != '1') {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(0, $pRow, $listHours->tim_org_name[$i]);
    }
    
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(1, $pRow, $listHours->tim_pro_name[$i])    // project name
                ->setCellValueByColumnAndRow(2, $pRow, $listHours->tim_mem_name[$i])    // member name
                ->setCellValueByColumnAndRow(3, $pRow, $listHours->tim_doc_name[$i])    // docnumet name
                ->setCellValueByColumnAndRow(4, $pRow, $listHours->tim_hours[$i]);      // hours
}

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objSpreadsheet->setActiveSheetIndex(0);
// Redirect output to a client’s web browser
header('Content-Type: ' . $exportFormats[$expfmtSession]['Content-Type']);
$content_disp = (WEBTAREAS_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $exportFormats[$expfmtSession]['File-Extension'] . '"');
header('Pragma: no-cache');
header('Expires: 0');
$objWriter = IOFactory::createWriter($objSpreadsheet, $exportFormats[$expfmtSession]['PHPExcel-Writer-Type']);
$objWriter->save('php://output');
