<?php // $Revision: 1.23 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exporttimeclock.php,v 1.23 2013/01/18 09:50:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * Includes
 */
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
require_once('../includes/PhpSpreadsheet/vendor/autoload.php');
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
if (!isset($_SESSION['TARGET']) || $_SESSION['TARGET'] != 'exporttimeclock') {
    exit;
}

// set up the department selection
$S_dep = $_SESSION['PARAMS']['S_DEPSEL'];
// set up the member selection
$S_mem = $_SESSION['PARAMS']['S_ATSEL'];
// a date range was selected
$S_date1 = $_SESSION['PARAMS']['S_DATE1'];
$S_date2 = $_SESSION['PARAMS']['S_DATE2'];
// billing selection
$billingSelection = $_SESSION['PARAMS']['S_BILLING'];
// end of configuration
// this is the filename the 'save as' file window will bring up by default
$filename = "timeclock";
@set_time_limit(600);
$querymore = " WHERE tck.finish='" . enumBoolean::bTrue . "'";
// a date range was selected
if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $querymore .= " AND tck.clockout>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $querymore .= " AND tck.clockout<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}
// a department selection was made
if ($S_dep == '') {
    $querymore .= " AND mem.department='0'";
} else {
    $querymore .= " AND mem.department" . ((is_array($S_org))?" IN ('" . implode("','", $S_org) . "')":"='$S_org'");
}
// a member selection was made
if ($S_mem == '0') {
    $querymore .= " AND tck.owner='0'";
} else {
    $querymore .= " AND tck.owner" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}
// billing selection
if ($billingSelection != 'ALL') {
    $querymore .= " AND tck.billing='$billingSelection'";
}

$querymore .= " ORDER BY tck.clockout DESC";
$listTimeClock = new request();
$listTimeClock->openTimeClock($querymore);
$comptListTimeClock = count($listTimeClock->tck_id);

if ($comptListTimeClock <= 0) {
    exit;
}

// Create new Spreadsheet object
$objSpreadsheet = new Spreadsheet();
// Set document properties
$objSpreadsheet->getProperties()->setCreator("webTareas")
                             ->setLastModifiedBy("webTareas")
                             ->setTitle($strings["timeclock_report"])
                             ->setSubject($strings["timeclock_report"])
                             ->setDescription($strings["timeclock_report"])
                             ->setKeywords($strings["timeclock_report"]);
/**
 * Construct the headers
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A1', $strings["timeclock_activities"]);
/**
 * Construct the header row
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A2', $strings["owner"])
            ->setCellValue('B2', $strings["clockin"])
            ->setCellValue('C2', $strings['clockout'])
            ->setCellValue('D2', $strings["project"])
            ->setCellValue('E2', $strings["type"])
            ->setCellValue('F2', $strings["description"])
            ->setCellValue('G2', $strings["hours"])
            ->setCellValue('H2', $strings["billing"]);
/*
 * Construct the content
 */
for ($i=0, $pRow=3; $i<$comptListTimeClock; $i++, $pRow++) {
    // owner name, clock-in, clock-out
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(0, $pRow, $listTimeClock->tck_mem_name[$i])
                ->setCellValueByColumnAndRow(1, $pRow, createDate($listTimeClock->tck_clockin[$i], 'both'))
                ->setCellValueByColumnAndRow(2, $pRow, createDate($listTimeClock->tck_clockout[$i], 'both'));
    // project name
    if ($listHours->project[$i] != '0') {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(3, $pRow, $listTimeClock->tck_pro_name[$i]);
    }
    // type, description
    if ($listTimeClock->tck_task[$i] != '0') {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(4, $pRow, $strings['task'])
                    ->setCellValueByColumnAndRow(5, $pRow, $listTimeClock->tck_tas_name[$i]);
    } else if ($listTimeClock->tck_meeting[$i] != '0') {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(4, $pRow, $strings['meeting'])
                    ->setCellValueByColumnAndRow(5, $pRow, $listTimeClock->tck_mee_name[$i]);
    } else {
        $objSpreadsheet->setActiveSheetIndex(0)
                    ->setCellValueByColumnAndRow(4, $pRow, $strings['others'])
                    ->setCellValueByColumnAndRow(5, $pRow, $listTimeClock->tck_hrt_name_print[$i] . ' - ' . $listTimeClock->tck_hrc_name_print[$i]);
    }
    // hours, billing
    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(6, $pRow, $listTimeClock->tck_hours[$i])       // hours
                ->setCellValueByColumnAndRow(7, $pRow, $billingFlag[$listTimeClock->tck_billing[$i]]);   // billing
}

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objSpreadsheet->setActiveSheetIndex(0);
// Create PHPExcel writer
$objWriter = IOFactory::createWriter($objSpreadsheet, $exportFormats[$expfmtSession]['PHPExcel-Writer-Type']);

if ($generate_mail_attach == 'Y') {
    $attfname = $filename . '.' . $exportFormats[$expfmtSession]['File-Extension'];
    $tmpfname = tempnam("../files", "FOO");
    $objWriter->save($tmpfname);
} else {
    // Redirect output to a client’s web browser
    header('Content-Type: ' . $exportFormats[$expfmtSession]['Content-Type']);
    $content_disp = (WEBTAREAS_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
    header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $exportFormats[$expfmtSession]['File-Extension'] . '"');
    header('Pragma: no-cache');
    header('Expires: 0');
    $objWriter->save('php://output');
}
