<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exporttimesheet.php,v 1.6 2013/01/18 09:50:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * Includes
 */
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
require_once('../includes/PhpSpreadsheet/vendor/autoload.php');
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
if (!isset($_SESSION['TARGET']) || $_SESSION['TARGET'] != 'exporttimesheet') {
    exit;
}
// set up the period selection
$A_periods = array();
$S_period1 = $_SESSION['PARAMS']['S_PERIOD1'];
$S_period2 = $_SESSION['PARAMS']['S_PERIOD2'];

if (strlen($S_period1)==6 && strlen($S_period2)==6 && $S_period1<=$S_period2) {
    if ($periodUnit == 'month') {
        while ($S_period1 <= $S_period2) {
            $A_periods[] = $S_period1;
            $fyear = intval(substr($S_period1, 0, 4));
            $serial_no = intval(substr($S_period1, 4, 2));

            if ($serial_no == 12) {
                $fyear += 1;
                $serial_no = 1;
            } else {
                $serial_no += 1;
            }

            $S_period1 = sprintf("%04d%02d", $fyear, $serial_no);
        }
    } else {
        while ($S_period1 <= $S_period2) {
            $A_periods[] = $S_period1;
            $fyear = intval(substr($S_period1, 0, 4));
            $serial_no = intval(substr($S_period1, 4, 2));
            $d = 31;
            $lastWeekofYear = date('W', mktime(0, 0, 0, 12, $d, $fyear));

            while ($lastWeekofYear == '01') {
                $d--;
                $lastWeekofYear = date('W', mktime(0, 0, 0, 12, $d, $fyear));
            }

            if ($serial_no == intval($lastWeekofYear)) {
                $fyear += 1;
                $serial_no = 1;
            } else {
                $serial_no += 1;
            }

            $S_period1 = sprintf("%04d%02d", $fyear, $serial_no);
        }
    }
}

// set up the department selection
$S_dep = $_SESSION['PARAMS']['S_DEPSEL'];
// set up the user selection
$S_mem = $_SESSION['PARAMS']['S_ATSEL'];
// end of configuration
// this is the filename the 'save as' file window will bring up by default
$filename = "timesheet";
@set_time_limit(600);
// user selection
if ($S_mem == '') {
    $query = " WHERE mem.id='0'";
} else {
    $query = " WHERE mem.id" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}
// a department selection was made
if ($S_dep != '') {
    $query .= " AND mem.department" . ((is_array($S_dep))?" IN ('" . implode("','", $S_dep) . "')":"='$S_dep'");
}
// period selection
if (count($A_periods) == 0) {
    $comptListTimesheet = 0;
} else {
    $subquery = array();

    foreach ($A_periods as $period) {
        $fyear = intval(substr($period, 0, 4));
        $serial_no = intval(substr($period, 4, 2));
        $querymore = " WHERE per.fyear='$fyear' AND per.serial_no='$serial_no'";
        $periodDetail = new request();
        $periodDetail->openPeriods($querymore);

        if (count($periodDetail->per_id)==0) {
            $perid = '0';
        } else {
            $perid = $periodDetail->per_id[0];
        }

        $subquery[] = "
SELECT CAST('$period' AS $db_cast_str(20)) AS period, mem.id AS mem_id, mem.name AS mem_name,dep.name AS dep_name,CASE WHEN tim.status IS NULL THEN '" . enumFileStatus::stNeedsApproval . "' ELSE tim.status END AS status,CASE WHEN tim.modified IS NULL THEN tim.created ELSE tim.modified END AS modified
FROM " . $tablePrefix . "members mem LEFT OUTER JOIN " . $tablePrefix . "timesheet tim ON tim.owner=mem.id AND tim.period='$perid' LEFT OUTER JOIN " . $tablePrefix . "departments dep ON dep.id=mem.department
$query";
    }

    $tmpquery = "
SELECT T1.mem_id,T1.mem_name,T1.dep_name,T1.period,T1.status,T1.modified FROM (
" . implode(" UNION ALL ", $subquery) . "
) T1 ORDER BY T1.status";
    $listTimesheet = new request();
    $listTimesheet->connectClass();
    $listTimesheet->query($tmpquery);
    $listTimesheet->mem_id = array();

    while ($listTimesheet->fetch()) {
        $i = 0;
        $listTimesheet->mem_id[] = ($row[$i++]);
        $listTimesheet->mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
        $listTimesheet->dep_name_print[] = $strings['DEP__' . $row[$i++]];
        $listTimesheet->period[] = ($row[$i++]);
        $listTimesheet->status[] = ($row[$i++]);
        $listTimesheet->modified[] = ($row[$i++]);
    }

    $listTimesheet->close();
    $comptListTimesheet = count($listTimesheet->mem_id);
}

if ($comptListTimesheet == '0') {
    exit;
}

// Create new Spreadsheet object
$objSpreadsheet = new Spreadsheet();
// Set document properties
$objSpreadsheet->getProperties()->setCreator("webTareas")
                             ->setLastModifiedBy("webTareas")
                             ->setTitle($strings["timesheet_report"])
                             ->setSubject($strings["timesheet_report"])
                             ->setDescription($strings["timesheet_report"])
                             ->setKeywords($strings["timesheet_report"]);
/**
 * Construct the headers
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A1', $strings["timesheet_report"]);
/**
 * Construct the header row
 */
$objSpreadsheet->setActiveSheetIndex(0)
            ->setCellValue('A2', $strings["user"])
            ->setCellValue('B2', $strings["department"])
            ->setCellValue('C2', $strings["period"])
            ->setCellValue('D2', $strings["status"])
            ->setCellValue('E2', $strings["modified"]);
/*
 * Construct the content
 */
for ($i=0, $pRow=3; $i<$comptListTimesheet; $i++, $pRow++) {
    $fyear = substr($listTimesheet->period[$i], 0, 4);
    $serialno = intval(substr($listTimesheet->period[$i], 4, 2));

    if ($periodUnit == 'month') {
        $serialname = $monthNameArray[$serialno];
    } else {
        $serialname = lang_strings('week') . ' ' . $serialno;
    }

    $objSpreadsheet->setActiveSheetIndex(0)
                ->setCellValueByColumnAndRow(0, $pRow, $listTimesheet->mem_name[$i])    // user name
                ->setCellValueByColumnAndRow(1, $pRow, $listTimesheet->dep_name_print[$i]) // department name print
                ->setCellValueByColumnAndRow(2, $pRow, "$serialname $fyear")            // period
                ->setCellValueByColumnAndRow(3, $pRow, $statusFile[$listTimesheet->status[$i]]) // status
                ->setCellValueByColumnAndRow(4, $pRow, $listTimesheet->modified[$i]);   // last modified date/time
}

// Set active sheet index to the first sheet, so Excel opens this as the first sheet
$objSpreadsheet->setActiveSheetIndex(0);
// Redirect output to a client’s web browser
header('Content-Type: ' . $exportFormats[$expfmtSession]['Content-Type']);
$content_disp = (WEBTAREAS_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $exportFormats[$expfmtSession]['File-Extension'] . '"');
header('Pragma: no-cache');
header('Expires: 0');
$objWriter = IOFactory::createWriter($objSpreadsheet, $exportFormats[$expfmtSession]['PHPExcel-Writer-Type']);
$objWriter->save('php://output');
