<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: flexibalance.php,v 1.5 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/flexibalance.php
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (!$SW_Permissions['User']['Write'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

// check if there are users with flextime enabled
$querymore = " WHERE mem.organization='1' AND mem.enable_flextime='" . enumBoolean::bTrue . "'";
$querymore .= " ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore);
$comptListMembers = count($listMembers->mem_id);

if ($comptListMembers == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
// set up the department selection
$S_dep = (isset($_POST['S_DEPSEL'])?$_POST['S_DEPSEL']:'');

if ($S_dep !== '' && !is_array($S_dep)) {
    $S_dep = explode("**", $S_dep);
}

// set up the member selection
$S_mem = (isset($_POST['S_MEMSEL'])?$_POST['S_MEMSEL']:'');

if ($S_mem !== '' && !is_array($S_mem)) {
    $S_mem = explode("**", $S_mem);
}

// set up the date selection
$dtI = isset($_POST['dt'])?$_POST['dt']:'';
$dt = ($dtI=='')?'0':date2Timestamp($dtI);

// load report info
$querymore = " WHERE rep.name='flexibalance'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selectft.php', lang_strings("flexibalance"), 'in'));
$blockPage->closeBreadcrumbs();
// start the first block
$block1 = new block();
$block1->form = "flt";
$block1->openForm("../reports/flexibalance.php#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"dt\" value=\"$dtI\">";
echo '<input type="hidden" name="S_DEPSEL" value="' . ((is_array($S_dep))?implode("**", $S_dep):$S_dep) . '">';
echo '<input type="hidden" name="S_MEMSEL" value="' . ((is_array($S_mem))?implode("**", $S_mem):$S_mem) . '">';
$block1->openContent();
$block1->sorting("flexibalance", (isset($sortingUser["flexibalance"])?$sortingUser["flexibalance"]:''), "T1.name ASC", $sortingFields = array(0 => "T1.name", 1 => "T1.department", 2 => "T1.balance"));
$tmpquery = "SELECT T1.* FROM (
SELECT T0.id,T0.name,T0.department,((CASE WHEN T0.th IS NULL THEN 0 ELSE T0.th END) + (CASE WHEN T0.mh IS NULL THEN 0 ELSE T0.mh END) +
(CASE WHEN T0.wh IS NULL THEN 0 ELSE T0.wh END) - (CASE WHEN T0.wc IS NULL THEN 0 ELSE T0.wc END) + (CASE WHEN T0.ftah IS NULL THEN 0 ELSE T0.ftah END) + T0.initial_flexibalance) AS balance
FROM (SELECT mem.id,mem.name,dep.name AS department,
(SELECT SUM(tim.hours) FROM " . $tablePrefix . "tasks_time tim WHERE tim.owner=mem.id AND tim.date>=mem.begin_flextime AND tim.date<='$dt') AS th,
(SELECT SUM(mti.hours) FROM " . $tablePrefix . "meetings_time mti WHERE mti.owner=mem.id AND mti.date>=mem.begin_flextime AND mti.date<='$dt') AS mh,
(SELECT SUM(wkh.hours) FROM " . $tablePrefix . "work_hours wkh WHERE wkh.owner=mem.id AND wkh.date>=mem.begin_flextime AND wkh.date<='$dt') AS wh,
(SELECT SUM(wcd.hours) FROM " . $tablePrefix . "workcalendars_detail wcd WHERE wcd.workcalendar=mem.workcalendar AND wcd.date>=mem.begin_flextime AND wcd.date<='$dt') AS wc,
(SELECT SUM(fta.hours) FROM " . $tablePrefix . "flextime_adjustment fta WHERE fta.owner=mem.id AND fta.refdate<='$dt') AS ftah,
mem.initial_flexibalance
FROM " . $tablePrefix . "members mem LEFT OUTER JOIN " . $tablePrefix . "departments dep ON dep.id = mem.department WHERE mem.begin_flextime<='$dt' AND mem.organization='1' AND mem.enable_flextime='" . enumBoolean::bTrue . "'";

// a department selection was made
if ($S_dep != '') {
    $tmpquery .= " AND mem.department" . ((is_array($S_dep))?" IN ('" . implode("','", $S_dep) . "')":"='$S_dep'");
}
// a member selection was made
if ($S_mem == '') {
    $tmpquery .= " AND mem.id='0'";
} else {
    $tmpquery .= " AND mem.id" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}

$tmpquery .= ") T0) T1 ORDER BY " . $block1->sortingValue;
$listFlexiBalance = new request();
$listFlexiBalance->connectClass();
$listFlexiBalance->query($tmpquery);
$listFlexiBalance->fb_id = array();

while ($listFlexiBalance->fetch()) {
    $listFlexiBalance->fb_id[] = ($row[0]);
    $listFlexiBalance->fb_name[] = HtmlEntityDecodeNOD($row[1]);
    $listFlexiBalance->fb_department[] = HtmlEntityDecodeNOD($row[2]);
    $hours0 = ($row[3]);
    $hours = (is_numeric($hours0)?round($hours0, $hourAccuracy):'0');
    $listFlexiBalance->fb_balance[] = $hours;
}

$listFlexiBalance->close();
$comptListFlexiBalance = count($listFlexiBalance->fb_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListFlexiBalance == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListFlexiBalance == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListFlexiBalance . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListFlexiBalance != "0") {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", lang_strings("export"));
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $_SESSION['TARGET'] = 'exportflexibalance';
    $params = array();
    $params['dt'] = $dtI;
    // department selection
    $params['S_DEPSEL'] = $S_dep;
    // member selection
    $params['S_MEMSEL'] = $S_mem;
    $_SESSION['PARAMS'] = $params;
    $block1->paletteScript(0, "export", "../reports/exportflexibalance.php", "true,false,false", lang_strings("export"));
    $block1->closePaletteScript($comptListFlexiBalance, $listFlexiBalance->fb_id);
}

// set up the header string
$block1HeadingText = lang_strings("flexibalance") . " : " . $dtI;
$block1->heading($block1HeadingText);

if ($comptListFlexiBalance > 0) {
    $labels = array(lang_strings("name"), lang_strings("department"), lang_strings("hours"));
    $block1->openResults(false);
    $block1->labels($labels, "false");

    for ($i=0; $i<$comptListFlexiBalance; $i++) {
        $block1->openRow();
        $block1->cellRow($blockPage->buildLink($listFlexiBalance->fb_id[$i], '', 'message'));
        $block1->cellRow($listFlexiBalance->fb_department[$i]);
        $block1->cellRow(NumberFormatNOD($listFlexiBalance->fb_balance[$i], $hourAccuracy));
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

// close block1
$block1->closeFormResults();
require_once("../includes/footer.php");
