<?php // $Revision: 1.19 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: flextime_adjustments.php,v 1.19 2009/11/03 14:29:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/flextime_adjustments.php
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
// set up the department selection
$S_dep = (isset($_POST['S_DEPSEL'])?$_POST['S_DEPSEL']:'');

if ($S_dep !== '' && !is_array($S_dep)) {
    $S_dep = explode("**", $S_dep);
}

// set up the member selection
$S_mem = (isset($_POST['S_MEMSEL'])?$_POST['S_MEMSEL']:'');

if ($S_mem !== '' && !is_array($S_mem)) {
    $S_mem = explode("**", $S_mem);
}
// a date range was selected
$S_date1 = (isset($_POST['S_DATE1'])?$_POST['S_DATE1']:'');
$S_date2 = (isset($_POST['S_DATE2'])?$_POST['S_DATE2']:'');

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (($enableTimesheet != 'true') || ($enableFlextime != 'true')) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

// check if there are users with flextime enabled
$querymore1 = " WHERE mem.organization='1' AND mem.enable_flextime='" . enumBoolean::bTrue . "' ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore1);
$comptListMembers = count($listMembers->mem_id);

if ($comptListMembers == '0') {
    header("Location: ../reports/listreports.php?msg=noAvailableUsers");
    exit;
}

// load report info
$querymore0 = " WHERE rep.name='flextime_adjustments_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore0);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selectfta.php', lang_strings("flextime_adjustments_report"), 'in'));
$blockPage->closeBreadcrumbs();
// start the first block
$block1 = new block();
$block1->form = "flt";
$block1->openForm("../reports/flextime_adjustments.php#" . $block1->form . "Anchor");
echo '<input type="hidden" name="S_DEPSEL" value="' . ((is_array($S_dep))?implode("**", $S_dep):$S_dep) . '">';
echo '<input type="hidden" name="S_MEMSEL" value="' . ((is_array($S_mem))?implode("**", $S_mem):$S_mem) . '">';
echo '<input type="hidden" name="S_DATE1" value="' . $S_date1 . '">';
echo '<input type="hidden" name="S_DATE2" value="' . $S_date2 . '">';
$block1->openContent();
$block1->sorting("fta_report", (isset($sortingUser['fta_report'])?$sortingUser['fta_report']:''), "mem.name ASC", $sortingFields = array(0 => "mem.name", 1 => "fta.date", 2 => "fta.hours", 3 => "fta.reason", 4 => "fta.comments"));

// a member selection was made
if ($S_mem == '') {
    $querymore = " WHERE fta.owner='0'";
} else {
    $querymore = " WHERE fta.owner" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}
// a department selection was made
if ($S_dep != '') {
    $querymore .= " AND mem.department" . ((is_array($S_dep))?" IN ('" . implode("','", $S_dep) . "')":"='$S_dep'");
}
// a date range was selected
if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $querymore .= " AND fta.refdate>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $querymore .= " AND fta.refdate<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}

$querymore .= " ORDER BY " . $block1->sortingValue;
$listFlextimeAdjustment = new request();
$listFlextimeAdjustment->openFlextimeAdjustment($querymore);
$comptListFlextimeAdjustment = count($listFlextimeAdjustment->fta_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListFlextimeAdjustment == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListFlextimeAdjustment == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListFlextimeAdjustment . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListFlextimeAdjustment > 0) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", lang_strings("export"));
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $_SESSION['TARGET'] = 'exportfta';
    $params = array();
    // department selection
    $params['S_DEPSEL'] = $S_dep;
    // member selection
    $params['S_MEMSEL'] = $S_mem;
    // handle date ranges
    $params['S_DATE1'] = $S_date1;
    $params['S_DATE2'] = $S_date2;
    $_SESSION['PARAMS'] = $params;
    $block1->paletteScript(0, "export", "../reports/exportfta.php", "true,false,false", lang_strings("export"));
    $block1->closePaletteScript($comptListFlextimeAdjustment, $listFlextimeAdjustment->fta_id);
}

// set up the header string
$block1HeadingText = lang_strings("flextime_adjustments_report") . " ";
$block1->heading($block1HeadingText);

if ($comptListFlextimeAdjustment > 0) {
    $labels = array(lang_strings("name"), lang_strings("date"), lang_strings("time"), lang_strings('note'));
    $block1->openResults(false);
    $block1->labels($labels, "false");

    for ($i=0; $i<$comptListFlextimeAdjustment; $i++) {
        $block1->openRow();
        $block1->cellRow($blockPage->buildLink($listFlextimeAdjustment->fta_owner[$i], '', 'message'));
        $block1->cellRow(createDate($listFlextimeAdjustment->fta_refdate[$i], 'date', false, true));
        $nice_print = NumberFormatNOD($listFlextimeAdjustment->fta_hours[$i], $hourAccuracy);
        $block1->cellRow($nice_print);
        $block1->cellRow($listFlextimeAdjustment->fta_comments[$i]);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

// close block1
$block1->closeFormResults();
require_once("../includes/footer.php");
