<?php // $Revision: 1.28 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: hours.php,v 1.28 2013/01/18 09:50:29 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/hours.php
 *
 * show hours logged
 *
 * TODO: add month/year selection
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Variables init
 */
$pis = isset($_GET['pis'])?$_GET['pis']:'';     // parameters in session

if ($pis == 'true') {
    if (!isset($_SESSION['TARGET']) || $_SESSION['TARGET'] != 'hours') {
        exit;
    }
    // set up the organization selection
    $S_org = $_SESSION['PARAMS']['S_ORGSEL'];
    // set up the project selection
    $S_prj = $_SESSION['PARAMS']['S_PRJSEL'];
    // set up the department selection
    $S_dep = $_SESSION['PARAMS']['S_DEPSEL'];
    // set up the member selection
    $S_mem = $_SESSION['PARAMS']['S_ATSEL'];
    // a date range was selected
    $S_date1 = $_SESSION['S_DATE1'];
    $S_date2 = $_SESSION['S_DATE2'];
    // billing selection
    $billingSelection = $_SESSION['PARAMS']['S_BILLING'];
} else {
    // set up the organization selection
    $S_org = isset($_POST['S_ORGSEL'])?$_POST['S_ORGSEL']:'';

    if ($S_org !== '' && !is_array($S_org)) {
        $S_org = explode("**", $S_org);
    }

    // set up the project selection
    $S_prj = isset($_POST['S_PRJSEL'])?$_POST['S_PRJSEL']:'';

    if ($S_prj !== '' && !is_array($S_prj)) {
        $S_prj = explode("**", $S_prj);
    }

    // set up the department selection
    $S_dep = isset($_POST['S_DEPSEL'])?$_POST['S_DEPSEL']:'';

    if ($S_dep !== '' && !is_array($S_dep)) {
        $S_dep = explode("**", $S_dep);
    }

    // set up the member selection
    $S_mem = isset($_POST['S_ATSEL'])?$_POST['S_ATSEL']:'';

    if ($S_mem !== '' && !is_array($S_mem)) {
        $S_mem = explode("**", $S_mem);
    }

    // a date range was selected
    $S_date1 = (isset($_POST['S_DATE1'])?$_POST['S_DATE1']:'');
    $S_date2 = (isset($_POST['S_DATE2'])?$_POST['S_DATE2']:'');

    // billing selection
    $billingSelection = (isset($_POST['S_BILLING'])?$_POST['S_BILLING']:'');
}

// load report info
$querymore = " WHERE rep.name='time_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selecthours.php', lang_strings("time_report"), 'in'));
$blockPage->closeBreadcrumbs();
// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/hours.php#" . $block1->form . "Anchor");
echo '<input type="hidden" name="S_ORGSEL" value="' . ((is_array($S_org))?implode("**", $S_org):$S_org) . '">';
echo '<input type="hidden" name="S_PRJSEL" value="' . ((is_array($S_prj))?implode("**", $S_prj):$S_prj) . '">';
echo '<input type="hidden" name="S_DEPSEL" value="' . ((is_array($S_dep))?implode("**", $S_dep):$S_dep) . '">';
echo '<input type="hidden" name="S_ATSEL" value="' . ((is_array($S_mem))?implode("**", $S_mem):$S_mem) . '">';
echo '<input type="hidden" name="S_DATE1" value="' . $S_date1 . '">';
echo '<input type="hidden" name="S_DATE2" value="' . $S_date2 . '">';
echo '<input type="hidden" name="S_BILLING" value="' . $billingSelection . '">';
$block1->openContent();
$block1->sorting("report_tasks_time",(isset($sortingUser['report_tasks_time'])?$sortingUser['report_tasks_time']:''),"T1.date ASC",$sortingFields = array(0=>"T1.org_name",1=>"T1.pro_name",2=>"T1.pro_type",3=>"T1.mem_name",4=>"T1.date",5=>"T1.doc_name",6=>"T1.hours",7=>"T1.billing"));
// a member selection was made
if ($S_mem == '') {
    $query = " WHERE T0.owner='0'";
} else {
    $query = " WHERE T0.owner" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}
// a organization selection was made
if ($S_org != 'ALL' && $S_org != '') {
    $query .= " AND T0.organization" . ((is_array($S_org))?" IN ('" . implode("','", $S_org) . "')":"='$S_org'");
}
// a project selection was made
if ($S_prj != 'ALL' && $S_prj != '') {
    $query .= " AND T0.project" . ((is_array($S_prj))?" IN ('" . implode("','", $S_prj) . "')":"='$S_prj'");
}
// a department selection was made
if ($S_dep != 'ALL' && $S_dep != '') {
    $query .= " AND T0.department" . ((is_array($S_dep))?" IN ('" . implode("','", $S_dep) . "')":"='$S_dep'");
}
// a date range was selected
if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $query .= " AND T0.date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $query .= " AND T0.date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}

// billing selection
if ($billingSelection != 'ALL') {
    $query .= " AND T0.billing='$billingSelection'";
}

$hourCodeSql = "CASE wkh.work";
$listHourCode = new request();
$listHourCode->openHourCode('');
$comptListHourCode = count($listHourCode->hrc_id);

for ($ia7c=0; $ia7c<$comptListHourCode; $ia7c++) {
    $hourCodeSql .= " WHEN '" . $listHourCode->hrc_id[$ia7c] . "' THEN '" . HtmlEntitiesNOD($listHourCode->hrc_name_print[$ia7c]) . "'";
}

$hourCodeSql .= " ELSE '' END";
$tmpquery = "SELECT T1.organization,T1.org_name,T1.project,T1.pro_name,T1.pro_type,T1.owner,T1.mem_name,T1.date,T1.doc_type,T1.doc_id,T1.doc_name,T1.hours,T1.billing FROM (
SELECT T0.organization,T0.org_name,T0.project,T0.pro_name,T0.pro_type,T0.owner,T0.mem_name,T0.date,T0.doc_type,T0.doc_id,T0.doc_name,T0.hours,T0.billing FROM (
SELECT pro.organization,org.name AS org_name,tim.project,pro.name AS pro_name,pro.type AS pro_type,tim.owner,mem.name AS mem_name,mem.department,tim.date,'T' AS doc_type,tim.task AS doc_id,tas.name AS doc_name,tim.hours,tim.billing
FROM " . $tablePrefix . "tasks_time tim LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=tim.project LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id=tim.task LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=tim.owner
) T0 $query
UNION ALL
SELECT T0.organization,T0.org_name,T0.project,T0.pro_name,T0.pro_type,T0.owner,T0.mem_name,T0.date,T0.doc_type,T0.doc_id,T0.doc_name,T0.hours,T0.billing FROM (
SELECT pro.organization,org.name AS org_name,mti.project,pro.name AS pro_name,pro.type AS pro_type,mti.owner,mem.name AS mem_name,mem.department,mti.date,'M' AS doc_type,mti.meeting AS doc_id,mee.name AS doc_name,mti.hours,CAST('" . enumBoolean::bFalse . "' AS char(1)) AS billing
FROM " . $tablePrefix . "meetings_time mti LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=mti.project LEFT OUTER JOIN " . $tablePrefix . "meetings mee ON mee.id=mti.meeting LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=mti.owner
) T0 $query
UNION ALL
SELECT T0.organization,T0.org_name,T0.project,T0.pro_name,T0.pro_type,T0.owner,T0.mem_name,T0.date,T0.doc_type,T0.doc_id,T0.doc_name,T0.hours,T0.billing FROM (
SELECT pro.organization,org.name AS org_name,wkh.project,pro.name AS pro_name,pro.type AS pro_type,wkh.owner,mem.name AS mem_name,mem.department,wkh.date,'W' AS doc_type,wkh.work AS doc_id,$hourCodeSql AS doc_name,wkh.hours,wkh.billing
FROM " . $tablePrefix . "work_hours wkh LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=wkh.project LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=wkh.owner
) T0 $query
) T1 ORDER BY " . $block1->sortingValue;
$listHours = new request();
$listHours->connectClass();
$listHours->query($tmpquery);
$listHours->organization = array();

while ($listHours->fetch()) {
    $i = 0;
    $listHours->organization[] = ($row[$i++]);
    $listHours->org_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->project[] = ($row[$i++]);
    $listHours->pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->pro_type[] = ($row[$i++]);
    $listHours->owner[] = ($row[$i++]);
    $listHours->mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->date[] = createDate($row[$i++], 'date', false, true);
    $listHours->doc_type[] = ($row[$i++]);
    $listHours->doc_id[] = ($row[$i++]);
    $listHours->doc_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $hours0 = ($row[$i++]);
    $hours = (is_numeric($hours0))?round($hours0, $hourAccuracy):'0';
    $listHours->hours[] = $hours;
    $listHours->billing[] = ($row[$i++]);
}

$listHours->close();
$comptListHours = count($listHours->organization);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListHours == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListHours == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListHours . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListHours > 0) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", $strings["export"]);
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $_SESSION['TARGET'] = 'exporthours';
    $params = array();
    // handle date ranges
    $params['S_DATE1'] = $S_date1;
    $params['S_DATE2'] = $S_date2;
    // organization selection
    $params['S_ORGSEL'] = $S_org;
    // project selection
    $params['S_PRJSEL'] = $S_prj;
    // department selection
    $params['S_DEPSEL'] = $S_dep;
    // member selection
    $params['S_ATSEL'] = $S_mem;
    // billing selection
    $params['S_BILLING'] = $billingSelection;
    $_SESSION['PARAMS'] = $params;
    $block1->paletteScript(0, "export", "../reports/exporthours.php", "true,false,false", $strings["export"]);
    $block1->closePaletteScript($comptListHours, $listHours->organization);
}

// set up the header string
$block1HeadingText = lang_strings("hours_logged") . " ";
$block1->heading($block1HeadingText);

if ($comptListHours > 0) {
    $labels = array(lang_strings("organization"), lang_strings("project"), lang_strings("type"), lang_strings("owner"), lang_strings("date"), lang_strings("task"), lang_strings("hours"), lang_strings("billing"));
    $block1->openResults(false);
    $block1->labels($labels, "false");

    for ($i=0; $i<$comptListHours; $i++) {
        $block1->openRow();

        if ($listHours->organization[$i] == '' || $listHours->organization[$i] == '1') {
            $block1->cellRow('');
        } else {
            $block1->cellRow($blockPage->buildLink('../clients/viewclient.php?id=' . $listHours->organization[$i], $listHours->org_name[$i], 'in'));
        }

        if ($listHours->project[$i] == '' || $listHours->project[$i] == '0') {
            $block1->cellRow('');
            $block1->cellRow('');
        } else {
            $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listHours->project[$i], $listHours->pro_name[$i], 'in'));
            $block1->cellRow($projectType[$listHours->pro_type[$i]]);
        }

        $block1->cellRow($blockPage->buildLink($listHours->owner[$i], '', 'message'));
        $block1->cellRow($listHours->date[$i]);

        switch ($listHours->doc_type[$i]) {
            case 'T':
                $block1->cellRow($blockPage->buildLink('../tasks/viewtask.php?id=' . $listHours->doc_id[$i], $listHours->doc_name[$i], 'in'));
                break;
            case 'M':
                $block1->cellRow($blockPage->buildLink('../meetings/viewmeeting.php?id=' . $listHours->doc_id[$i], $listHours->doc_name[$i], 'in'));
                break;
            default:
                $block1->cellRow($listHours->doc_name[$i]);
        }

        $nice_print = NumberFormatNOD($listHours->hours[$i], $hourAccuracy);
        $block1->cellRow($nice_print);
        $block1->cellRow($billingFlag[$listHours->billing[$i]]);
        $block1->closeRow();
    }

    // print the totals
    $block1->openRow();
    $block1->cellRow("");
    $block1->cellRow("");
    $block1->cellRow("");
    $block1->cellRow("");
    $block1->cellRow("");
    $block1->cellRow('<b>' . lang_strings("hours_total") . ":" . '</b>');
    $nice_print = NumberFormatNOD(array_sum($listHours->hours), $hourAccuracy);
    $block1->cellRow('<b>' . $nice_print . '</b>');
    $block1->cellRow("");
    $block1->closeRow();
    $block1->closeResults();
} else {
    $block1->noresults();
}

// close block1
$block1->closeFormResults();
require_once("../includes/footer.php");
