<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: importreportdefinitions.php,v 1.9 2013/02/03 15:14:27 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = isset($_POST['action'])?$_POST['action']:'';
$cat = AddSlashesNOD(isset($_GET['cat'])?$_GET['cat']:'');
$atttmp = isset($_POST['atttmp1'])?$_POST['atttmp1']:'';
$attnam = isset($_POST['attnam1'])?$_POST['attnam1']:'';
$error = '';
$reportdef = '';
$formtemplates = '';
$customfields = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Edit'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore1 = " WHERE repc.id='$cat'";
$reportCategoryDetail = new request();
$reportCategoryDetail->openReportCategory($querymore1, 0, 1);
$comptReportCategoryDetail = count($reportCategoryDetail->repc_id);

if ($comptReportCategoryDetail == 0) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * get field type code
 */
function getFieldTypeCode($fldnam)
{
    $fldtyp = '';

    switch (strtolower($fldnam)) {
        case 'txt':
        case 'text':
            $fldtyp = enumFieldType::ftText;
            break;
        case 'num':
        case 'numeric':
            $fldtyp = enumFieldType::ftNumeric;
            break;
        case 'memo':
            $fldtyp = enumFieldType::ftMemo;
            break;
        case 'date':
            $fldtyp = enumFieldType::ftDate;
            break;
        case 'time':
            $fldtyp = enumFieldType::ftTime;
            break;
        case 'hour':
        case 'hours':
            $fldtyp = enumFieldType::ftHours;
            break;
        case 'price':
        case 'rate':
            $fldtyp = enumFieldType::ftRate;
            break;
        case 'amount':
        case 'total':
        case 'totals':
            $fldtyp = enumFieldType::ftTotals;
            break;
        case 'img':
        case 'image':
        case 'photo':
        case 'pic':
        case 'picture':
            $fldtyp = enumFieldType::ftImage;
            break;
        case 'bool':
        case 'boolean':
        case 'truefalse':
        case 'true-false':
        case 'yesno':
        case 'yes-no':
            $fldtyp = enumFieldType::ftBoolean;
            break;
        case 'email':
        case 'e-mail':
            $fldtyp = enumFieldType::ftEmail;
            break;
        case 'url':
            $fldtyp = enumFieldType::ftUrl;
            break;
        case 'alphanum':
        case 'alpha-num':
        case 'alphanumeric':
        case 'alpha-numeric':
            $fldtyp = enumFieldType::ftAlphaNumeric;
            break;
        case 'timestamp':
            $fldtyp = enumFieldType::ftTimestamp;
            break;
        case 'qty':
        case 'quantity':
            $fldtyp= enumFieldType::ftQuantity;
            break;
        case 'measure':
            $fldtyp = enumFieldType::ftMeasure;
            break;
        case 'serial':
            $fldtyp = enumFieldType::ftSerial;
            break;
        case 'percent':
        case 'percentage':
            $fldtyp = enumFieldType::ftPercentage;
            break;
        case 'audio':
            $fldtyp = enumFieldType::ftAudio;
            break;
        case 'video':
            $fldtyp = enumFieldType::ftVideo;
            break;
        case 'passwd':
        case 'password':
            $fldtyp = enumFieldType::ftPassword;
            break;
    }

    return $fldtyp;
}

/**
 * Actions
 */
if ($action == "import") {
    try {
        $zip = new ZipArchive();

        if ($zip->open($atttmp) !== true) {   // check if file exists
            throw new Exception(str_replace('%FILE%', $attnam, $strings['load_file_fail']));
        }

        for ($i=0; $i<$zip->numFiles; $i++) {
            $x = $zip->getNameIndex($i);

            if ($x == 'reports.xml') {
                $reportdef = $i;
            } elseif ($x == 'form_templates.xml') {
                $formtemplates = $i;
            } elseif ($x == 'custom_fields.xml') {
                $customfields = $i;
            }
        }

        if ($reportdef === '') {
            throw new Exception($strings['invalid_fileformat']);
        }

        $doc1 = new DOMDocument();

        if ($doc1->loadXML($zip->getFromIndex($reportdef)) === false) {
            throw new Exception($strings['invalid_fileformat']);
        }

        if ($formtemplates !== '') {
            $doc2 = new DOMDocument();

            if ($doc2->loadXML($zip->getFromIndex($formtemplates)) === false) {
                throw new Exception($strings['invalid_fileformat']);
            }
        }

        if ($customfields !== '') {
            $doc3 = new DOMDocument();

            if ($doc3->loadXML($zip->getFromIndex($customfields)) === false) {
                throw new Exception($strings['invalid_fileformat']);
            }
        }
    } catch (Exception $e) {
        $error = $e->getMessage();
    }
}

if ($action == "import" && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($formtemplates !== '') {
            importFormTemplates($doc2);
        }

        if ($customfields !== '') {
            importCustomFields($doc3);
        }
        // The collection of reports
        $reports = $doc1->getElementsByTagName("report");

        if ($reports->length > 0) {
            foreach ($reports as $report) {
                $e_rep_name = $report->getElementsByTagName("name");   // The name of report

                if ($e_rep_name->length == 0) {
                    throw new Exception('report name missing');
                } else {
                    $rep_name = $e_rep_name->item(0)->nodeValue;

                    if ($rep_name == '') {
                        throw new Exception('report name missing');
                    }
                }

                // check if report already exists
                $tmpquery = "SELECT id FROM " . $tablePrefix . "reports WHERE name='" . $rep_name . "'";
                $requestAct->query($tmpquery);
                $compt1 = $requestAct->rowCount();

                if ($compt1 > 0) {
                    $rep_name = 'copy_of_' . $rep_name . '_' . $compt1;
                }

                $e_rep_query = $report->getElementsByTagName("query");      // report query text

                if ($e_rep_query->length == 0) {
                    throw new Exception('report query text missing');
                } else {
                    $rep_query = HtmlEntityDecodeNOD($e_rep_query->item(0)->nodeValue);

                    if ($rep_query == '') {
                        throw new Exception('report query text missing');
                    } else {
                        // prevent database modification
                        $rep_query1 = str_ireplace(array('--', '({', '/*', 'insert ', 'update ', 'delete ', 'alter ', 'drop '), array('', '', '', '', '', '', '', ''), $rep_query);

                        if ($rep_query1 != $rep_query) {
                            throw new Exception('invalid report query text');
                        }
                    }
                }

                $e_rep_name_print = $report->getElementsByTagName("name_print");    // report name print

                if ($e_rep_name_print->length == 0) {
                    throw new Exception('report name print missing');
                } else {
                    $rep_name_print = $e_rep_name_print->item(0)->nodeValue;

                    if ($rep_name_print == '') {
                        throw new Exception('report name print missing');
                    }
                }

                $e_rep_description = $report->getElementsByTagName("description");  // report description

                if ($e_rep_description->length == 0) {
                    throw new Exception('report description missing');
                } else {
                    $rep_description = $e_rep_description->item(0)->nodeValue;

                    if ($rep_description == '') {
                        throw new Exception('report description missing');
                    }
                }

                $tmpsql = "INSERT INTO " . $tablePrefix . "reports (category,name,url,tablename,userquery,sysdef,created,cuser) VALUES ('$cat','$rep_name','','','" . HtmlEntitiesNOD($rep_query) . "','N','" . time() . "','$idSession')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $num = $requestAct->newId("reports");
                updateString($requestAct, 'REP__' . $rep_name, $rep_name_print);        // report name print
                updateString($requestAct, 'REPDESC__' . $rep_name, $rep_description);   // report description
                // related tables
                $related_tables = array();
                // Parameters
                $uid = 1;
                $par_reltbl_idx = array();
                $parameters = $report->getElementsByTagName('parameter');

                if ($parameters->length > 0) {
                    foreach ($parameters as $parameter) {
                        $e_par_uid = $parameter->getElementsByTagName('uid');           // 1-based serial number

                        if ($e_par_uid->length == 0) {
                            throw new Exception('parameter uid missing');
                        } else {
                            $par_uid = $e_par_uid->item(0)->nodeValue;

                            if ($par_uid != $uid) {
                                throw new Exception('parameter uid must be 1-based serial number');
                            }
                        }

                        $e_par_tablename = $parameter->getElementsByTagName('tablename');   // table name

                        if ($e_par_tablename->length == 0) {
                            $par_tablename = '';
                        } else {
                            $par_tablename = $e_par_tablename->item(0)->nodeValue;
                        }

                        $e_par_fieldname = $parameter->getElementsByTagName('fieldname');   // field name

                        if ($e_par_fieldname->length == 0) {
                            $par_fieldname = '';
                        } else {
                            $par_fieldname = $e_par_fieldname->item(0)->nodeValue;
                        }

                        $e_par_fieldtype = $parameter->getElementsByTagName('fieldtype');   // field type

                        if ($e_par_fieldtype->length == 0) {
                            $par_fieldtype = '';
                        } else {
                            $par_fieldtype = getFieldTypeCode($e_par_fieldtype->item(0)->nodeValue);
                        }

                        if (($par_tablename == '' || $par_fieldname == '') && $par_fieldtype == '') {
                            throw new Exception('Unable to determine parameter field type');
                        }

                        $e_par_ratio = $parameter->getElementsByTagName('ratio');           // field operation

                        if ($e_par_ratio->length == 0) {
                            throw new Exception('parameter field operation missing');
                        } else {
                            $par_ratio = $e_par_ratio->item(0)->nodeValue;
                            $par_ratio = ((strtolower($par_ratio)=='range')?enumRatio::rInRange:enumRatio::rEqual);
                        }

                        $e_par_value = $parameter->getElementsByTagName('value');           // parameter name

                        if ($e_par_value->length == 0) {
                            throw new Exception('parameter name missing');
                        } else {
                            $par_value = HtmlEntitiesNOD($e_par_value->item(0)->nodeValue);
                        }

                        if ($par_tablename == '') {
                            $rel_table = 0;
                        } else {
                            $rel_table = array_search($par_tablename, $related_tables);

                            if (!$rel_table) {
                                $related_tables[] = $par_tablename;
                                $rel_table = count($related_tables) - 1;
                            }
                        }

                        $tmpsql = "INSERT INTO " . $tablePrefix . "reports_criteria (report,rel_table,fieldname,fieldtype,ratio,value,table_right,compare_fields,parameter) VALUES ('$num','" . $rel_table . "','$par_fieldname','$par_fieldtype','$par_ratio','$par_value','0','" . enumBoolean::bFalse . "','" . enumBoolean::bTrue . "')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $num1 = $requestAct->newId("reports_criteria");
                        $par_reltbl_idx[$num1] = $rel_table;
                        $uid++;
                    }
                }

                // Outputs
                $out_reltbl_idx = array();
                $report_outputs = $report->getElementsByTagName('output');

                if ($report_outputs->length > 0) {
                    $k = 0;

                    foreach ($report_outputs as $report_output) {
                        $e_out_tablename = $report_output->getElementsByTagName('tablename');  // table name

                        if ($e_out_tablename->length == 0) {
                            $out_tablename = '';
                        } else {
                            $out_tablename = $e_out_tablename->item(0)->nodeValue;
                        }

                        $e_out_fieldname = $report_output->getElementsByTagName('fieldname');  // field name

                        if ($e_out_fieldname->length == 0) {
                            $out_fieldname = '';
                        } else {
                            $out_fieldname = $e_out_fieldname->item(0)->nodeValue;
                        }

                        $e_out_fieldtype = $report_output->getElementsByTagName('fieldtype');  // field type

                        if ($e_out_fieldtype->length == 0) {
                            $out_fieldtype = '';
                        } else {
                            $out_fieldtype = getFieldTypeCode($e_out_fieldtype->item(0)->nodeValue);
                        }

                        if (($out_tablename == '' || $out_fieldname == '') && $out_fieldtype == '') {
                            throw new Exception('Unable to determine output field type');
                        }

                        $e_out_title = $report_output->getElementsByTagName('title');          // title

                        if ($e_out_title->length == 0) {
                            throw new Exception('output title missing');
                        } else {
                            $out_title = HtmlEntitiesNOD($e_out_title->item(0)->nodeValue);
                        }

                        if ($out_tablename == '') {
                            $rel_table = 0;
                        } else {
                            $rel_table = array_search($out_tablename, $related_tables);

                            if (!$rel_table) {
                                $related_tables[] = $out_tablename;
                                $rel_table = count($related_tables) - 1;
                            }
                        }

                        $tmpsql = "INSERT INTO " . $tablePrefix . "reports_output (report,rel_table,fieldname,fieldtype,title,disp_order,sort_order,sort_type,field_group,field_function) VALUES ('$num','" . $rel_table . "','$out_fieldname','$out_fieldtype','$out_title','$k','0','A','N','')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $num2 = $requestAct->newId("reports_output");
                        $out_reltbl_idx[$num2] = $rel_table;
                        $k++;
                    }
                }

                // Related tables
                if (count($related_tables) > 0) {
                    foreach ($related_tables as $k => $tblnam) {
                        $tmpsql = "INSERT INTO " . $tablePrefix . "reports_rel_tables (report,tablename,table_left) VALUES ('$num','$tblnam','0')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $num3 = $requestAct->newId("reports_rel_tables");
                        $related_tables[$k] = $num3;
                    }

                    // Update parameters related table id
                    if (count($par_reltbl_idx) > 0) {
                        foreach ($par_reltbl_idx as $k => $l) {
                            $tmpsql = "UPDATE " . $tablePrefix . "reports_criteria SET rel_table='" . $related_tables[$l] . "' WHERE id='$k'";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }
                        }
                    }

                    // Update outputs related table id
                    foreach ($out_reltbl_idx as $k => $l) {
                        $tmpsql = "UPDATE " . $tablePrefix . "reports_output SET rel_table='" . $related_tables[$l] . "' WHERE id='$k'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                }
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../reports/listreports.php?msg=add&cat=$cat");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../reports/listreports.php?cat=$cat", lang_strings("reports"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("import_reports"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "imR";
$block1->openForm("../reports/importreportdefinitions.php?cat=$cat#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="import">';
$block1->heading(lang_strings("import_reports"));
$block1->openContent();
$block1->contentRow("*&nbsp;" . lang_strings("upload"), setupUploadFileHTML('1', '.zip', true));
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["import"] . "\">");
$block1->closeContent();
$block1->note(lang_strings('importreports_help'));
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
