<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: issuetracking_summary.php,v 1.5 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/issuetracking_summary.php
 *
 * select options for report of issue tracking summary
 *
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Variables init
 */
// set up the member selection
$orgSel = isset($_POST['S_ORGSEL'])?$_POST['S_ORGSEL']:'';
$prjSel = isset($_POST['S_PRJSEL'])?$_POST['S_PRJSEL']:'';
$S_BYCLIENT = isset($_POST['S_BYCLIENT'])?$_POST['S_BYCLIENT']:'';
$S_BYPROJECT = isset($_POST['S_BYPROJECT'])?$_POST['S_BYPROJECT']:'';
$S_BYSEVERITY = isset($_POST['S_BYSEVERITY'])?$_POST['S_BYSEVERITY']:'';
$S_BYRESOLUTION = isset($_POST['S_BYRESOLUTION'])?$_POST['S_BYRESOLUTION']:'';
$S_BYPRIORITY = isset($_POST['S_BYPRIORITY'])?$_POST['S_BYPRIORITY']:'';
$S_REPORTERSTATE = isset($_POST['S_REPORTERSTATE'])?$_POST['S_REPORTERSTATE']:'';
$S_HANDLERSTATE = isset($_POST['S_HANDLERSTATE'])?$_POST['S_HANDLERSTATE']:'';
$S_REPORTERBYRESOLUTION = isset($_POST['S_REPORTERBYRESOLUTION'])?$_POST['S_REPORTERBYRESOLUTION']:'';
$S_HANDLERBYRESOLUTION = isset($_POST['S_HANDLERBYRESOLUTION'])?$_POST['S_HANDLERBYRESOLUTION']:'';
$S_date1 = (isset($_POST['S_DATE1'])?$_POST['S_DATE1']:'');
$S_date2 = (isset($_POST['S_DATE2'])?$_POST['S_DATE2']:'');

if ($orgSel !== '' && !is_array($orgSel)) {
    $orgSel = explode("**", $orgSel);
}

if ($prjSel !== '' && !is_array($prjSel)) {
    $prjSel = explode("**", $prjSel);
}

// load report info
$querymore0 = " WHERE rep.name='issue_tracking_summary'";
$reportDetail = new request();
$reportDetail->openReports($querymore0);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selectis.php', lang_strings("issue_tracking_summary"), 'in'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "its1";
$block1->openForm("../reports/issuetracking_summary.php#" . $block1->form . "Anchor");
$conditions = array();

if ($orgSel != '') {
    $conditions[] = "org.id" . ((is_array($orgSel))?" IN ('" . implode("','", $orgSel) . "')":"='$orgSel'");
}

if ($prjSel != '') {
    $conditions[] = "pro.id" . ((is_array($prjSel))?" IN ('" . implode("','", $prjSel) . "')":"='$prjSel'");
}

if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $conditions[] = "sr.date_open>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $conditions[] = "sr.date_open<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}

if (count($conditions) > 0) {
    $querymore = ' WHERE ' . implode(' AND ', $conditions);
} else {
    $querymore = '';
}

if ($S_BYCLIENT == 'TRUE') {
    $tmpquery = "SELECT org.id,org.name,sr.status,COUNT(sr.id) AS num FROM " . $tablePrefix . "support_requests sr INNER JOIN " . $tablePrefix . "projects pro ON pro.id=sr.project INNER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization";
    $tmpquery .= $querymore . " GROUP BY org.id,org.name,sr.status ORDER BY org.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $request1->org_id = array();
    $numnum = 0;

    while ($request1->fetch()) {
        $org_id = ($row[0]);
        $num = ($row[3]);

        if (!in_array($org_id, $request1->org_id)) {
            $request1->org_id[$org_id] = $org_id;
            $request1->org_name[$org_id] = HtmlEntityDecodeNOD($row[1]);
            $request1->sr_new[$org_id] = 0;
            $request1->sr_open[$org_id] = 0;
            $request1->sr_complete[$org_id] = 0;
            $request1->sr_total[$org_id] = 0;
        }

        switch ($row[2]) {
            case enumRequestStatus::stNew:
                $request1->sr_new[$org_id] += $num;
                break;
            case enumRequestStatus::stOpen:
                $request1->sr_open[$org_id] += $num;
                break;
            case enumRequestStatus::stCompleted:
                $request1->sr_complete[$org_id] += $num;
                break;
        }

        $request1->sr_total[$org_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('by_organization'));

    if (count($request1->org_id) > 0 && $numnum > 0) {
        $labels = array(lang_strings("organization"), $requestStatus[enumRequestStatus::stNew], $requestStatus[enumRequestStatus::stOpen], $requestStatus[enumRequestStatus::stCompleted], lang_strings("total"));
        $block1->openResults(false);
        $block1->labels($labels, "true");

        foreach ($request1->org_id as $org_id) {
            if ($request1->sr_total[$org_id] == 0) {
                continue;
            }

            $block1->openRow();
            $block1->cellRow($blockPage->buildLink('../clients/viewclient.php?id=' . $org_id, $request1->org_name[$org_id], 'in'));
            $block1->cellRow($request1->sr_new[$org_id]);
            $block1->cellRow($request1->sr_open[$org_id]);
            $block1->cellRow($request1->sr_complete[$org_id]);
            $block1->cellRow($request1->sr_total[$org_id]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_BYPROJECT == 'TRUE') {
    $tmpquery = "SELECT pro.id,pro.name,sr.status,COUNT(sr.id) AS num FROM " . $tablePrefix . "support_requests sr INNER JOIN " . $tablePrefix . "projects pro ON pro.id=sr.project INNER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization";
    $tmpquery .= $querymore . " GROUP BY pro.id,pro.name,sr.status ORDER BY pro.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $request1->pro_id = array();
    $numnum = 0;

    while ($request1->fetch()) {
        $pro_id = ($row[0]);
        $num = ($row[3]);

        if (!in_array($pro_id, $request1->pro_id)) {
            $request1->pro_id[$pro_id] = $pro_id;
            $request1->pro_name[$pro_id] = HtmlEntityDecodeNOD($row[1]);
            $request1->sr_new[$pro_id] = 0;
            $request1->sr_open[$pro_id] = 0;
            $request1->sr_complete[$pro_id] = 0;
            $request1->sr_total[$pro_id] = 0;
        }

        switch ($row[2]) {
            case enumRequestStatus::stNew:
                $request1->sr_new[$pro_id] += $num;
                break;
            case enumRequestStatus::stOpen:
                $request1->sr_open[$pro_id] += $num;
                break;
            case enumRequestStatus::stCompleted:
                $request1->sr_complete[$pro_id] += $num;
                break;
        }

        $request1->sr_total[$pro_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('by_project'));

    if (count($request1->pro_id) > 0 && $numnum > 0) {
        $labels = array(lang_strings("project"), $requestStatus[enumRequestStatus::stNew], $requestStatus[enumRequestStatus::stOpen], $requestStatus[enumRequestStatus::stCompleted], lang_strings("total"));
        $block1->openResults(false);
        $block1->labels($labels, "true");

        foreach ($request1->pro_id as $pro_id) {
            if ($request1->sr_total[$pro_id] == 0) {
                continue;
            }

            $block1->openRow();
            $block1->cellRow($blockPage->buildLink('../projects/viewproject.php?id=' . $pro_id, $request1->pro_name[$pro_id], 'in'));
            $block1->cellRow($request1->sr_new[$pro_id]);
            $block1->cellRow($request1->sr_open[$pro_id]);
            $block1->cellRow($request1->sr_complete[$pro_id]);
            $block1->cellRow($request1->sr_total[$pro_id]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_BYSEVERITY == 'TRUE') {
    $tmpquery = "SELECT sr.severity,sr.status,COUNT(sr.id) AS num FROM " . $tablePrefix . "support_requests sr INNER JOIN " . $tablePrefix . "projects pro ON pro.id=sr.project INNER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization";
    $tmpquery .= $querymore . " GROUP BY sr.severity,sr.status ORDER BY sr.severity";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $request1->sr_severity = array();
    $numnum = 0;

    while ($request1->fetch()) {
        $sr_severity = ($row[0]);
        $num = ($row[2]);

        if (!in_array($sr_severity, $request1->sr_severity)) {
            $request1->sr_severity[$sr_severity] = $sr_severity;
            $request1->sr_new[$sr_severity] = 0;
            $request1->sr_open[$sr_severity] = 0;
            $request1->sr_complete[$sr_severity] = 0;
            $request1->sr_total[$sr_severity] = 0;
        }

        switch ($row[1]) {
            case enumRequestStatus::stNew:
                $request1->sr_new[$sr_severity] += $num;
                break;
            case enumRequestStatus::stOpen:
                $request1->sr_open[$sr_severity] += $num;
                break;
            case enumRequestStatus::stCompleted:
                $request1->sr_complete[$sr_severity] += $num;
                break;
        }

        $request1->sr_total[$sr_severity] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('by_severity'));

    if (count($request1->sr_severity) > 0 && $numnum > 0) {
        $labels = array(lang_strings("FIE__support_requests_severity"), $requestStatus[enumRequestStatus::stNew], $requestStatus[enumRequestStatus::stOpen], $requestStatus[enumRequestStatus::stCompleted], lang_strings("total"));
        $block1->openResults(false);
        $block1->labels($labels, "true");

        foreach ($request1->sr_severity as $sr_severity) {
            if ($request1->sr_total[$sr_severity] == 0) {
                continue;
            }

            $block1->openRow();
            $block1->cellRow(fieldValidValueString('support_requests', 'severity', $sr_severity));
            $block1->cellRow($request1->sr_new[$sr_severity]);
            $block1->cellRow($request1->sr_open[$sr_severity]);
            $block1->cellRow($request1->sr_complete[$sr_severity]);
            $block1->cellRow($request1->sr_total[$sr_severity]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_BYRESOLUTION == 'TRUE') {
    $tmpquery = "SELECT sr.resolution,sr.status,COUNT(sr.id) AS num FROM " . $tablePrefix . "support_requests sr INNER JOIN " . $tablePrefix . "projects pro ON pro.id=sr.project INNER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization";
    $tmpquery .= $querymore . " GROUP BY sr.resolution,sr.status ORDER BY sr.resolution";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $request1->sr_resolution = array();
    $numnum = 0;

    while ($request1->fetch()) {
        $sr_resolution = ($row[0]);
        $num = ($row[2]);

        if (!in_array($sr_resolution, $request1->sr_resolution)) {
            $request1->sr_resolution[$sr_resolution] = $sr_resolution;
            $request1->sr_new[$sr_resolution] = 0;
            $request1->sr_open[$sr_resolution] = 0;
            $request1->sr_complete[$sr_resolution] = 0;
            $request1->sr_total[$sr_resolution] = 0;
        }

        switch ($row[1]) {
            case enumRequestStatus::stNew:
                $request1->sr_new[$sr_resolution] += $num;
                break;
            case enumRequestStatus::stOpen:
                $request1->sr_open[$sr_resolution] += $num;
                break;
            case enumRequestStatus::stCompleted:
                $request1->sr_complete[$sr_resolution] += $num;
                break;
        }

        $request1->sr_total[$sr_resolution] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('by_resolution'));

    if (count($request1->sr_resolution) > 0 && $numnum > 0) {
        $labels = array(lang_strings("FIE__support_requests_resolution"), $requestStatus[enumRequestStatus::stNew], $requestStatus[enumRequestStatus::stOpen], $requestStatus[enumRequestStatus::stCompleted], lang_strings("total"));
        $block1->openResults(false);
        $block1->labels($labels, "true");

        foreach ($request1->sr_resolution as $sr_resolution) {
            if ($request1->sr_total[$sr_resolution] == 0) {
                continue;
            }

            $block1->openRow();
            $block1->cellRow(fieldValidValueString('support_requests', 'resolution', $sr_resolution));
            $block1->cellRow($request1->sr_new[$sr_resolution]);
            $block1->cellRow($request1->sr_open[$sr_resolution]);
            $block1->cellRow($request1->sr_complete[$sr_resolution]);
            $block1->cellRow($request1->sr_total[$sr_resolution]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_BYPRIORITY == 'TRUE') {
    $tmpquery = "SELECT sr.priority,sr.status,COUNT(sr.id) AS num FROM " . $tablePrefix . "support_requests sr INNER JOIN " . $tablePrefix . "projects pro ON pro.id=sr.project INNER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization";
    $tmpquery .= $querymore . " GROUP BY sr.priority,sr.status ORDER BY sr.priority";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $request1->sr_priority = array();
    $numnum = 0;

    while ($request1->fetch()) {
        $sr_priority = ($row[0]);
        $num = ($row[2]);

        if (!in_array($sr_priority, $request1->sr_priority)) {
            $request1->sr_priority[$sr_priority] = $sr_priority;
            $request1->sr_new[$sr_priority] = 0;
            $request1->sr_open[$sr_priority] = 0;
            $request1->sr_complete[$sr_priority] = 0;
            $request1->sr_total[$sr_priority] = 0;
        }

        switch ($row[1]) {
            case enumRequestStatus::stNew:
                $request1->sr_new[$sr_priority] += $num;
                break;
            case enumRequestStatus::stOpen:
                $request1->sr_open[$sr_priority] += $num;
                break;
            case enumRequestStatus::stCompleted:
                $request1->sr_complete[$sr_priority] += $num;
                break;
        }

        $request1->sr_total[$sr_priority] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('by_priority'));

    if (count($request1->sr_priority) > 0 && $numnum > 0) {
        $labels = array(lang_strings("priority"), $requestStatus[enumRequestStatus::stNew], $requestStatus[enumRequestStatus::stOpen], $requestStatus[enumRequestStatus::stCompleted], lang_strings("total"));
        $block1->openResults(false);
        $block1->labels($labels, "true");

        foreach ($request1->sr_priority as $sr_priority) {
            if ($request1->sr_total[$sr_priority] == 0) {
                continue;
            }

            $block1->openRow();
            $block1->cellRow($priority[$sr_priority]);
            $block1->cellRow($request1->sr_new[$sr_priority]);
            $block1->cellRow($request1->sr_open[$sr_priority]);
            $block1->cellRow($request1->sr_complete[$sr_priority]);
            $block1->cellRow($request1->sr_total[$sr_priority]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_REPORTERSTATE == 'TRUE') {
    $tmpquery = "SELECT mem.id,mem.name,sr.status,COUNT(sr.id) AS num FROM " . $tablePrefix . "support_requests sr INNER JOIN " . $tablePrefix . "projects pro ON pro.id=sr.project INNER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization INNER JOIN " . $tablePrefix . "members mem ON mem.id=sr.owner";
    $tmpquery .= $querymore . " GROUP BY mem.id,mem.name,sr.status ORDER BY mem.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $request1->mem_id = array();
    $numnum = 0;

    while ($request1->fetch()) {
        $mem_id = ($row[0]);
        $num = ($row[3]);

        if (!in_array($mem_id, $request1->mem_id)) {
            $request1->mem_id[$mem_id] = $mem_id;
            $request1->mem_name[$mem_id] = HtmlEntityDecodeNOD($row[1]);
            $request1->sr_new[$mem_id] = 0;
            $request1->sr_open[$mem_id] = 0;
            $request1->sr_complete[$mem_id] = 0;
            $request1->sr_total[$mem_id] = 0;
        }

        switch ($row[2]) {
            case enumRequestStatus::stNew:
                $request1->sr_new[$mem_id] += $num;
                break;
            case enumRequestStatus::stOpen:
                $request1->sr_open[$mem_id] += $num;
                break;
            case enumRequestStatus::stCompleted:
                $request1->sr_complete[$mem_id] += $num;
                break;
        }

        $request1->sr_total[$mem_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('reporter_state'));

    if (count($request1->mem_id) > 0 && $numnum > 0) {
        $labels = array(lang_strings("reporter"), $requestStatus[enumRequestStatus::stNew], $requestStatus[enumRequestStatus::stOpen], $requestStatus[enumRequestStatus::stCompleted], lang_strings("total"));
        $block1->openResults(false);
        $block1->labels($labels, "true");

        foreach ($request1->mem_id as $mem_id) {
            if ($request1->sr_total[$mem_id] == 0) {
                continue;
            }

            $block1->openRow();
            $block1->cellRow($blockPage->buildLink($mem_id, '', 'message'));
            $block1->cellRow($request1->sr_new[$mem_id]);
            $block1->cellRow($request1->sr_open[$mem_id]);
            $block1->cellRow($request1->sr_complete[$mem_id]);
            $block1->cellRow($request1->sr_total[$mem_id]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_HANDLERSTATE == 'TRUE') {
    $tmpquery = "SELECT mem.id,mem.name,sr.status,COUNT(sr.id) AS num FROM " . $tablePrefix . "support_requests sr INNER JOIN " . $tablePrefix . "projects pro ON pro.id=sr.project INNER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization INNER JOIN " . $tablePrefix . "members mem ON mem.id=sr.assigned_to";
    $tmpquery .= $querymore . " GROUP BY mem.id,mem.name,sr.status ORDER BY mem.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $request1->mem_id = array();
    $numnum = 0;

    while ($request1->fetch()) {
        $mem_id = ($row[0]);
        $num = ($row[3]);

        if (!in_array($mem_id, $request1->mem_id)) {
            $request1->mem_id[$mem_id] = $mem_id;
            $request1->mem_name[$mem_id] = HtmlEntityDecodeNOD($row[1]);
            $request1->sr_new[$mem_id] = 0;
            $request1->sr_open[$mem_id] = 0;
            $request1->sr_complete[$mem_id] = 0;
            $request1->sr_total[$mem_id] = 0;
        }

        switch ($row[2]) {
            case enumRequestStatus::stNew:
                $request1->sr_new[$mem_id] += $num;
                break;
            case enumRequestStatus::stOpen:
                $request1->sr_open[$mem_id] += $num;
                break;
            case enumRequestStatus::stCompleted:
                $request1->sr_complete[$mem_id] += $num;
                break;
        }

        $request1->sr_total[$mem_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    $block1->heading(lang_strings('handler_state'));

    if (count($request1->mem_id) > 0 && $numnum > 0) {
        $labels = array(lang_strings("handler"), $requestStatus[enumRequestStatus::stNew], $requestStatus[enumRequestStatus::stOpen], $requestStatus[enumRequestStatus::stCompleted], lang_strings("total"));
        $block1->openResults(false);
        $block1->labels($labels, "true");

        foreach ($request1->mem_id as $mem_id) {
            if ($request1->sr_total[$mem_id] == 0) {
                continue;
            }

            $block1->openRow();
            $block1->cellRow($blockPage->buildLink($mem_id, '', 'message'));
            $block1->cellRow($request1->sr_new[$mem_id]);
            $block1->cellRow($request1->sr_open[$mem_id]);
            $block1->cellRow($request1->sr_complete[$mem_id]);
            $block1->cellRow($request1->sr_total[$mem_id]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_REPORTERBYRESOLUTION == 'TRUE') {
    $tmpquery = "SELECT mem.id,mem.name,sr.resolution,COUNT(sr.id) AS num FROM " . $tablePrefix . "support_requests sr INNER JOIN " . $tablePrefix . "projects pro ON pro.id=sr.project INNER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization INNER JOIN " . $tablePrefix . "members mem ON mem.id=sr.owner";
    $tmpquery .= $querymore . " GROUP BY mem.id,mem.name,sr.resolution ORDER BY mem.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $request1->mem_id = array();
    $numnum = 0;

    while ($request1->fetch()) {
        $mem_id = ($row[0]);
        $num = ($row[3]);

        if (!in_array($mem_id, $request1->mem_id)) {
            $request1->mem_id[$mem_id] = $mem_id;
            $request1->mem_name[$mem_id] = HtmlEntityDecodeNOD($row[1]);
            $tmpquery = " WHERE fvd.tablename='support_requests' AND fvd.fieldname='resolution' ORDER BY fvd.fieldvalue";
            $listFieldsValuesDefinitions = new request();
            $listFieldsValuesDefinitions->openFieldsValuesDefinitions($tmpquery);

            if (is_array($listFieldsValuesDefinitions->fvd_fieldvalue) && count($listFieldsValuesDefinitions->fvd_fieldvalue) > 0) {
                foreach ($listFieldsValuesDefinitions->fvd_fieldvalue as $fv) {
                    $request1->sr_resolution[$mem_id][$fv] = 0;
                }
            }
        }

        $request1->sr_resolution[$mem_id][strval($row[2])] += $num;
        $request1->sr_total[$mem_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    unset($labels);
    $labels[] = lang_strings("reporter");

    if (is_array($listFieldsValuesDefinitions->fvd_fieldvalue_desc) && count($listFieldsValuesDefinitions->fvd_fieldvalue_desc) > 0) {
        foreach ($listFieldsValuesDefinitions->fvd_fieldvalue_desc as $fvdesc) {
            $labels[] = $fvdesc;
        }
    }

    $block1->heading(lang_strings('reporter_by_resolution'));

    if (count($request1->mem_id) > 0 && $numnum > 0) {
        $block1->openResults(false);
        $block1->labels($labels, "true");

        foreach ($request1->mem_id as $mem_id) {
            if ($request1->sr_total[$mem_id] == 0) {
                continue;
            }

            $block1->openRow();
            $block1->cellRow($blockPage->buildLink($mem_id, '', 'message'));

            if (is_array($listFieldsValuesDefinitions->fvd_fieldvalue) && count($listFieldsValuesDefinitions->fvd_fieldvalue) > 0) {
                foreach ($listFieldsValuesDefinitions->fvd_fieldvalue as $fv) {
                    $block1->cellRow($request1->sr_resolution[$mem_id][$fv]);
                }
            }

            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

if ($S_HANDLERBYRESOLUTION == 'TRUE') {
    $tmpquery = "SELECT mem.id,mem.name,sr.resolution,COUNT(sr.id) AS num FROM " . $tablePrefix . "support_requests sr INNER JOIN " . $tablePrefix . "projects pro ON pro.id=sr.project INNER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization INNER JOIN " . $tablePrefix . "members mem ON mem.id=sr.assigned_to";
    $tmpquery .= $querymore . " GROUP BY mem.id,mem.name,sr.resolution ORDER BY mem.name";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);
    $request1->mem_id = array();
    $numnum = 0;

    while ($request1->fetch()) {
        $mem_id = ($row[0]);
        $num = ($row[3]);

        if (!in_array($mem_id, $request1->mem_id)) {
            $request1->mem_id[$mem_id] = $mem_id;
            $request1->mem_name[$mem_id] = HtmlEntityDecodeNOD($row[1]);
            $tmpquery = " WHERE fvd.tablename='support_requests' AND fvd.fieldname='resolution' ORDER BY fvd.fieldvalue";
            $listFieldsValuesDefinitions = new request();
            $listFieldsValuesDefinitions->openFieldsValuesDefinitions($tmpquery);

            if (is_array($listFieldsValuesDefinitions->fvd_fieldvalue) && count($listFieldsValuesDefinitions->fvd_fieldvalue) > 0) {
                foreach ($listFieldsValuesDefinitions->fvd_fieldvalue as $fv) {
                    $request1->sr_resolution[$mem_id][$fv] = 0;
                }
            }
        }

        $request1->sr_resolution[$mem_id][($row[2])] += $num;
        $request1->sr_total[$mem_id] += $num;
        $numnum += $num;
    }

    $request1->close();
    unset($labels);
    $labels[] = lang_strings("handler");

    if (is_array($listFieldsValuesDefinitions->fvd_fieldvalue_desc) && count($listFieldsValuesDefinitions->fvd_fieldvalue_desc) > 0) {
        foreach ($listFieldsValuesDefinitions->fvd_fieldvalue_desc as $fvdesc) {
            $labels[] = $fvdesc;
        }
    }

    $labels[] = lang_strings('fixed_rate');
    $block1->heading(lang_strings('handler_by_resolution'));

    if (count($request1->mem_id) > 0 && $numnum > 0) {
        $block1->openResults(false);
        $block1->labels($labels, "true");

        foreach ($request1->mem_id as $mem_id) {
            if ($request1->sr_total[$mem_id] == 0) {
                continue;
            }

            $block1->openRow();
            $block1->cellRow($blockPage->buildLink($mem_id, '', 'message'));

            if (is_array($listFieldsValuesDefinitions->fvd_fieldvalue) && count($listFieldsValuesDefinitions->fvd_fieldvalue) > 0) {
                foreach ($listFieldsValuesDefinitions->fvd_fieldvalue as $fv) {
                    $block1->cellRow($request1->sr_resolution[$mem_id][$fv]);
                }
            }

            $percentage = intval($request1->sr_resolution[$mem_id]['3'] * 100 / $request1->sr_total[$mem_id]);
            $block1->cellRow($percentage . ' %');
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
}

$block1->closeFormResults();
require_once("../includes/footer.php");
