<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listreports.php,v 1.7 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$cat = AddSlashesNOD(isset($_GET['cat'])?$_GET['cat']:'1');
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Get Report Categories
 */
$querymore1 = " WHERE repc.id='$cat'";
$reportCategoryDetail = new request();
$reportCategoryDetail->openReportCategory($querymore1, 0, 1);
$comptReportCategoryDetail = count($reportCategoryDetail->repc_id);

if ($comptReportCategoryDetail == 0) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// Get Report Categories
$querymore3 = " WHERE repc.id<>'$cat' ORDER BY repc.id";
$listReportCategory = new request();
$listReportCategory->openReportCategory($querymore3);
$comptListReportCategory = count($listReportCategory->repc_id);

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($reportCategoryDetail->repc_name_print[0]);
$blockPage->closeBreadcrumbs();
$title = $strings['reports'] . ' : ' . $reportCategoryDetail->repc_name_print[0];
logURL($title, "../reports/listreports.php?cat=$cat");
$block1 = new block();
$block1->form = "lRpt";
$block1->openForm("../reports/listreports.php?cat=$cat#" . $block1->form . "Anchor");
$block1->openHeading($reportCategoryDetail->repc_name_print[0]);
$block1->openViewOptions();

for ($i=0; $i<$comptListReportCategory; $i++) {
    $block1->itemViewOptions($block1->buildLink('../reports/listreports.php?cat=' . $listReportCategory->repc_id[$i], $listReportCategory->repc_name_print[$i], 'in'));
}

$block1->itemViewOptions($block1->buildLink('../reports/reportcategories.php', lang_strings('manage_categories'), 'in'));
$block1->closeViewOptions();
$block1->closeHeading();

if ($SW_Permissions['Report']['Edit'][$profilSession]) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "add", $strings["add"]);
    $block1->paletteIcon(1, "remove", $strings["delete"]);
    $block1->paletteIcon(3, "edit", $strings['edit']);
    $block1->paletteIcon(5, 'import', $strings['import']);
    $block1->paletteIcon(6, 'export', $strings['export']);
    $block1->closePaletteIcon();
}

$block1->sorting('reports', (isset($sortingUser['reports'])?$sortingUser['reports']:''), '', $sortingFields = array(0 => 'none', 1 => 'none'));
$querymore2 = " WHERE rep.category='$cat'";

if (!$SW_Permissions['Report']['Edit'][$profilSession]) {
    $querymore2 .= " AND rep.locked='" . enumBoolean::bFalse . "'";
}

$querymore2 .= " ORDER BY rep.name";
$listReports = new request();
$listReports->openReports($querymore2);
$comptListReports = count($listReports->rep_id);

if ($comptListReports > 0) {
    $labels = array(lang_strings("name"), lang_strings("description"));

    if ($SW_Permissions['Report']['Edit'][$profilSession]) {
        $block1->openResults();
    } else {
        $block1->openResults(false);
    }

    $block1->labels($labels, "false");

    for ($i=0; $i<$comptListReports; $i++) {
        if ($SW_Permissions['Report']['Edit'][$profilSession]) {
            $block1->openRow($listReports->rep_id[$i]);
        } else {
            $block1->openRow();
        }

        if ($listReports->rep_locked[$i] == enumBoolean::bTrue) {
            $block1->cellRow('<div class="instrike">' . $listReports->rep_name_print[$i] . '</div>');
            $block1->cellRow('<div class="dim">' . $listReports->rep_description[$i] . '</div>', '60');
        } else {
            if ($listReports->rep_sysdef[$i] == 'Y') {
                $block1->cellRow($block1->buildLink('../reports/' . $listReports->rep_url[$i], $listReports->rep_name_print[$i], 'in'));
            } else {
                $block1->cellRow($block1->buildLink('../reports/runreport.php?id=' . $listReports->rep_id[$i], $listReports->rep_name_print[$i], 'in'));
            }

            $block1->cellRow($listReports->rep_description[$i], '60');
        }
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeFormResults();

if ($SW_Permissions['Report']['Edit'][$profilSession]) {
    $block1->openPaletteScript();
    $block1->paletteScript(0, "add", "../reports/createreport.php?cat=$cat", "true,false,false", $strings["add"]);
    $block1->paletteScript(1, "remove", "../reports/deletereports.php?cat=$cat", "false,true,true", $strings["delete"]);
    $block1->paletteScript(3, "edit", "../reports/editreport.php?cat=$cat", "false,true,false", $strings["edit"]);
    $block1->paletteScript(5, 'import', "../reports/importreportdefinitions.php?cat=$cat", 'true,false,false', $strings['import']);
    $block1->paletteScript(6, 'export', '../reports/exportreportdefinitions.php?', 'false,true,true', $strings['export']);
    $block1->closePaletteScript($comptListReports, $listReports->rep_id);
}

require_once("../includes/footer.php");
