<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: material_usage.php,v 1.5 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/material_usage.php
 *
 */
/**
 * Includes
 */
$checkSession = true;
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Variables init
 */
// configuration options
// set up the project selection
$S_prj = isset($_POST['S_PRJSEL'])?$_POST['S_PRJSEL']:'';

if ($S_prj !== '' && !is_array($S_prj)) {
    $S_prj = explode("**", $S_prj);
}
// set up the material selection
$S_mat = isset($_POST['S_MATSEL'])?$_POST['S_MATSEL']:'';

if ($S_mat !== '' && !is_array($S_mat)) {
    $S_mat = explode("**", $S_mat);
}

// a date range was selected
$S_date1 = (isset($_POST['S_DATE1'])?$_POST['S_DATE1']:'');
$S_date2 = (isset($_POST['S_DATE2'])?$_POST['S_DATE2']:'');
// end of configuration

// load report info
$querymore0 = " WHERE rep.name='material_usage'";
$reportDetail = new request();
$reportDetail->openReports($querymore0);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selectmu.php', lang_strings("material_usage"), 'in'));
$blockPage->closeBreadcrumbs();
// start the first block
$block1 = new block();
$block1->form = "xleP";
$block1->openForm("../reports/material_usage.php#" . $block1->form . "Anchor");
echo '<input type="hidden" name="S_PRJSEL" value="' . ((is_array($S_prj))?implode("**", $S_prj):$S_prj) . '">';
echo '<input type="hidden" name="S_MATSEL" value="' . ((is_array($S_mat))?implode("**", $S_mat):$S_mat) . '">';
echo '<input type="hidden" name="S_DATE1" value="' . $S_date1 . '">';
echo '<input type="hidden" name="S_DATE2" value="' . $S_date2 . '">';
$block1->openContent();
$tmpquery = "SELECT iss.project,iss.material,iss.date,SUM(iss.quantity) AS quantity,mat.name,mat.unit,pro.name
FROM " . $tablePrefix . "material_issue iss
LEFT OUTER JOIN " . $tablePrefix . "materials mat ON mat.id=iss.material
LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=iss.project
";
$conditions = array();
// a project selection was made
if ($S_prj != '') {
    $conditions[] = "iss.project" . ((is_array($S_prj))?" IN ('" . implode("','", $S_prj) . "')":"='$S_prj'");
}
// a material selection was made
if ($S_mat != '') {
    $conditions[] = "iss.material" . ((is_array($S_mat))?" IN ('" . implode("','", $S_mat) . "')":"='$S_mat'");
}
// a date range was selected

if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $conditions[] = "iss.date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $conditions[] = "iss.date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}

if (count($conditions) > 0) {
    $tmpquery .= " WHERE " . implode(" AND ", $conditions);
}

$tmpquery .= " GROUP BY iss.project,iss.material,iss.date,mat.name,mat.unit,pro.name ORDER BY pro.name,mat.name,iss.date";
$listMaterialIssue = new request();
$listMaterialIssue->connectClass();
$listMaterialIssue->query($tmpquery);
$listMaterialIssue->iss_project = array();

while ($listMaterialIssue->fetch()) {
    $i = 0;
    $listMaterialIssue->iss_project[] = ($row[$i++]);
    $listMaterialIssue->iss_material[] = ($row[$i++]);
    $listMaterialIssue->iss_date[] = ($row[$i++]);
    $val = ($row[$i++]);
    $qty = (is_numeric($val))?round($val, $quantityAccuracy):0;
    $listMaterialIssue->iss_quantity[] = $qty;
    $matn = ($row[$i++]);
    $listMaterialIssue->iss_mat_name_print[] = $strings['MAT__' . $matn];
    $listMaterialIssue->iss_mat_unit[] = HtmlEntityDecodeNOD($row[$i++]);
    $listMaterialIssue->iss_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
}

$listMaterialIssue->close();
$comptListMaterialIssue = count($listMaterialIssue->iss_project);
// report results
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListMaterialIssue == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListMaterialIssue == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListMaterialIssue . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListMaterialIssue != "0") {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", $strings["export"]);
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $_SESSION['TARGET'] = 'exportmu';
    $params = array();
    // a project selection was made
    $params['S_PRJSEL'] = $S_prj;
    // a material selection was made
    $params['S_MATSEL'] = $S_mat;
    // handle date ranges
    $params['S_DATE1'] = $S_date1;
    $params['S_DATE2'] = $S_date2;
    $_SESSION['PARAMS'] = $params;
    $block1->paletteScript(0, "export", "../reports/exportmu.php", "true,false,false", $strings["export"]);
    $block1->closePaletteScript($comptListMaterialIssue, $listMaterialIssue->iss_project);
}

// set up the header string
$block1HeadingText = lang_strings("material_usage") . " ";
$block1->heading($block1HeadingText);
// initialize counters

if ($comptListMaterialIssue > 0) {
    $labels = array(lang_strings("project"), lang_strings("material"), lang_strings("date"), lang_strings("quantity"), lang_strings('unit'));
    $block1->openResults(false);
    $block1->labels($labels, "false");
    $pro_id = '';
    $mat_id = '';
    $totals = array();

    for ($i=0; $i<$comptListMaterialIssue; $i++) {
        $proChanged = false;
        $matChanged = false;

        // new project
        if ($i == 0 || $listMaterialIssue->iss_project[$i] != $pro_id) {
            $block1->openRow();
            $block1->cellRow($blockPage->buildLink('../projects/viewproject.php?id=' . $listMaterialIssue->iss_project[$i], $listMaterialIssue->iss_pro_name[$i], 'in'));
            $block1->cellRow('');
            $block1->cellRow('');
            $block1->cellRow('');
            $block1->cellRow('');
            $block1->closeRow();
            $pro_id = $listMaterialIssue->iss_project[$i];
            $proChanged = true;
        }

        // new material
        if ($i == 0 || $proChanged || $listMaterialIssue->iss_material[$i] != $mat_id) {
            $block1->openRow();
            $block1->cellRow('');
            $block1->cellRow($blockPage->buildLink('../materials/viewmaterial.php?id=' . $listMaterialIssue->iss_material[$i], $listMaterialIssue->iss_mat_name_print[$i], 'in'));
            $block1->cellRow('');
            $block1->cellRow('');
            $block1->cellRow('');
            $block1->closeRow();
            $mat_id = $listMaterialIssue->iss_material[$i];
            $matChanged = true;
            $matTotal = 0;
            
            if (!array_key_exists($listMaterialIssue->iss_material[$i], $totals)) {
                $totals[strval($listMaterialIssue->iss_material[$i])] = 0;
            }
        }

        // content
        $block1->openRow();
        $block1->cellRow('');
        $block1->cellRow('');
        $block1->cellRow(createDate($listMaterialIssue->iss_date[$i], 'date', false, true));
        $block1->cellRow(NumberFormatNOD($listMaterialIssue->iss_quantity[$i], $quantityAccuracy));
        $block1->cellRow($listMaterialIssue->iss_mat_unit[$i]);
        $block1->closeRow();
        $matTotal += $listMaterialIssue->iss_quantity[$i];
        $totals[strval($listMaterialIssue->iss_material[$i])] += $listMaterialIssue->iss_quantity[$i];

        // material subtotal
        if ($i == ($comptListMaterialIssue - 1) || $listMaterialIssue->iss_project[$i+1] != $pro_id || $listMaterialIssue->iss_material[$i+1] != $mat_id) {
            $block1->openRow();
            $block1->cellRow('');
            $block1->cellRow('');
            $block1->cellRow(lang_strings('mu_subtotal'));
            $block1->cellRow(NumberFormatNOD($matTotal, $quantityAccuracy));
            $block1->cellRow($listMaterialIssue->iss_mat_unit[$i]);
            $block1->closeRow();
        }
    }

    // print the totals
    $block1->openRow();
    $block1->cellRow(lang_strings('mu_total'));
    $block1->cellRow('');
    $block1->cellRow('');
    $block1->cellRow('');
    $block1->cellRow('');
    $block1->closeRow();

    foreach ($totals as $mat_id => $qty) {
        $i = array_search($mat_id, $listMaterialIssue->iss_material);
        $block1->openRow();
        $block1->cellRow('');
        $block1->cellRow($blockPage->buildLink('../materials/viewmaterial.php?id=' . $listMaterialIssue->iss_material[$i], $listMaterialIssue->iss_mat_name_print[$i], 'in'));
        $block1->cellRow('');
        $block1->cellRow(NumberFormatNOD($qty, $quantityAccuracy));
        $block1->cellRow($listMaterialIssue->iss_mat_unit[$i]);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

// close block1
$block1->closeFormResults();
require_once("../includes/footer.php");
