<?php  // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * Author:     Graham Sutcliffe (redesign by Luis Wang)
 * Date:       9/28/2005
 * File:       /reports/member_allocation.php
 * Reference:  /reports/selectma.php
 *
 * Resource allocation within a date range by Employee.  Keep date range within
 * 4 weeks for decient looking report.
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
//
// Function to calculate the number of working days
function workDays($start, $end, $wc)
{
    $querymore = " WHERE wcd.workcalendar='$wc' AND wcd.date>='$start' AND wcd.date<'" . mktime(0,0,0,intval(date('n',$end)),intval(date('j',$end))+1,intval(date('Y',$end))) . "' AND wcd.hours>0 ORDER BY wcd.date";
    $request1 = new request();
    $request1->openWorkCalendarsDetail($querymore);
    return count($request1->wcd_id);
}

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Variables init
 */
// set up the member selection
$S_mem = (isset($_POST['S_ATSEL'])?$_POST['S_ATSEL']:'');

if ($S_mem !== '' && !is_array($S_mem)) {
    $S_mem = explode("**", $S_mem);
}

// get the range start date and end date
$S_date1 = (isset($_POST['S_DATE1'])?$_POST['S_DATE1']:'');
$S_date2 = (isset($_POST['S_DATE2'])?$_POST['S_DATE2']:'');

// load report info
$querymore0 = " WHERE rep.name='member_allocation'";
$reportDetail = new request();
$reportDetail->openReports($querymore0);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0 || $S_date1 == '' || $S_date2 == '') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selectma.php', lang_strings("member_allocation"), 'in'));
$blockPage->closeBreadcrumbs();
// start the first block
$block1 = new block();
$block1->form = "xmaT";
$block1->openForm("../reports/member_allocation.php#" . $block1->form . "Anchor");
echo '<input type="hidden" name="S_ATSEL" value="' . ((is_array($S_mem))?implode("**", $S_mem):$S_mem) . '">';
echo '<input type="hidden" name="S_DATE1" value="' . $S_date1 . '">';
echo '<input type="hidden" name="S_DATE2" value="' . $S_date2 . '">';
$block1->openContent();
$querymore = " AND tas.status IN (" . enumStatus::stNotStarted . "," . enumStatus::stOpen . ")";

if ($S_mem == '') {
    $querymore .= " AND res.resource='0'";
} else {
    $querymore .= " AND res.resource" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}

$ts1 = date2Timestamp($S_date1);
$ts2 = date2Timestamp($S_date2);
$querymore .= " AND tas.due_date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "' AND tas.start_date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "' ORDER BY pro.name,tas.name";
$listTaskHumanResource = new request();
$listTaskHumanResource->openTaskHumanResource($querymore);
$comptListTaskHumanResource = count($listTaskHumanResource->res_id);

if ($comptListTaskHumanResource > 0) {
    $acv = array_count_values($listTaskHumanResource->res_resource);
    $memids = "'" . implode("','", array_keys($acv)) . "'";
} else {
    $memids = "'0'";
}

//
// Display Member that was selected
$querymore = " WHERE mem.id IN ($memids) ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore);
$comptListMembers = count($listMembers->mem_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListMembers == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListMembers == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListMembers . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListMembers > 0) {
    /**
     * create labels
     */
    $d1 = $ts1;
    $reportLabels = array();
    $reportLabels[] = lang_strings('project');
    $reportLabels[] = lang_strings('task');

    while ($d1 <= $ts2) {
        $reportLabels[] = date('d', $d1);
        $d1 = mktime(0, 0, 0, intval(date('n', $d1)), intval(date('j', $d1))+1, intval(date('Y', $d1)));
    }

    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", $strings["export"]);
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $_SESSION['TARGET'] = 'exportma';
    $params = array();
    // member selection
    $params['S_ATSEL'] = $S_mem;
    // handle date ranges
    $params['S_DATE1'] = $S_date1;
    $params['S_DATE2'] = $S_date2;
    $_SESSION['PARAMS'] = $params;
    $block1->paletteScript(0, "export", "../reports/exportma.php?", "true,false,false", $strings["export"]);
    $block1->closePaletteScript($comptListMembers, $listMembers->mem_id);

    for ($j=0; $j<$comptListMembers; $j++) {
        //
        // Initialize Member level variables
        $memberName = $listMembers->mem_name[$j];
        $memberId = $listMembers->mem_id[$j];
        $overdueHours = 0;
        /*
         * Load member's workcalendar
         */
        $querymore = " WHERE wcd.workcalendar='" . $listMembers->mem_workcalendar[$j] . "' AND wcd.date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "' AND wcd.date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "' ORDER BY wcd.date";
        $listWorkCalendarsDetail = new request();
        $listWorkCalendarsDetail->openWorkCalendarsDetail($querymore);
        $comptListWorkCalendarsDetail = count($listWorkCalendarsDetail->wcd_id);
        $d1 = $ts1;
        $listWorkHours = array();

        while ($d1 <= $ts2) {
            if (($key = array_search($d1, $listWorkCalendarsDetail->wcd_date))) {
                $listWorkHours[$d1] = $listWorkCalendarsDetail->wcd_hours[$key];
            } else {
                $listWorkHours[$d1] = 0;
            }

            $d1 = mktime(0, 0, 0, intval(date('n', $d1)), intval(date('j', $d1))+1, intval(date('Y', $d1)));
        }
        //
        // Query to list only open or not started tasks (currently being worked on or scheduled to be worked on).
        $querymore = " AND res.resource='$memberId' AND tas.status IN (" . enumStatus::stNotStarted . "," . enumStatus::stOpen . ") AND tas.start_date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "' AND tas.due_date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "' ORDER BY pro.name,tas.name";
        $listTaskHumanResource = new request();
        $listTaskHumanResource->openTaskHumanResource($querymore);
        $comptListTaskHumanResource = count($listTaskHumanResource->res_id);
        //
        // Block for Member
        $block1->heading($memberName." - <i>$S_date1 to $S_date2</i>");
        //
        // Member headers
        $block1->openResults(false);
        $block1->labels($reportLabels, "false", "false", array(0=>"-1",1=>""));
        //
        // Initialize Member summary
        $sumHours = array();

        foreach ($listWorkHours as $key => $val) {
            $sumHours[$key] = 0;
        }

        //
        // Sumarize Tasks on each Member
        for ($k=0; $k<$comptListTaskHumanResource; $k++) {
            //
            // Populate task level information
            $projectName = $listTaskHumanResource->res_pro_name[$k];
            $taskName = $listTaskHumanResource->res_tas_name[$k];
            $taskEst = $listTaskHumanResource->res_tas_estimated_time[$k];
            $taskStartDate = $listTaskHumanResource->res_tas_start_date[$k];
            $taskDueDate = $listTaskHumanResource->res_tas_due_date[$k];
            //
            // Determine future number of working days left.
            if ($taskStartDate <= $ts1) {
                $numWorkDays = workDays($ts1, $taskDueDate, $listMembers->mem_workcalendar[$j]);
            } else {
                $numWorkDays = workDays($taskStartDate, $taskDueDate, $listMembers->mem_workcalendar[$j]);
            }
            //
            // Calculate daily hours depending on task percent complete.  Negative numHoursPerDay means its past due
            if ($numWorkDays > 0) {
                $numHoursPerDay = round($taskEst * (10 - $listTaskHumanResource->res_tas_completion[$k]) / 10 / $numWorkDays, $hourAccuracy);
            } else {
                $numHoursPerDay = 0;
                $overdueHours += round($taskEst * (10 - $listTaskHumanResource->res_tas_completion[$k]) / 10 / $numWorkDays, $hourAccuracy);
            }

            $block1->openRow();
            $block1->cellRow($projectName);
            $block1->cellRow($taskName);

            foreach ($listWorkHours as $key => $val) {
                if ($val > 0) {
                    if (($key >= $taskStartDate) && ($key<= $taskDueDate)) {
                        $block1->cellRow($numHoursPerDay);
                        $sumHours[$key] += $numHoursPerDay;
                    } else {
                        $block1->cellRow('0');
                    }
                } else {
                    $block1->cellRow("&nbsp;");
                }
            }

            $block1->closeRow();
        }
        //
        // Summary title row
        $block1->openRow();
        $block1->cellRow("<strong>" . lang_strings('ru_total_mem') . "</strong>");

        for ($l=1; $l<count($reportLabels); $l++) {
            $block1->cellRow('&nbsp;');
        }

        $block1->closeRow();
        //
        // Summary daily totals row
        $block1->openRow();
        $block1->cellRow("&nbsp;");
        $block1->cellRow(lang_strings('daily_total') . ":");

        foreach ($listWorkHours as $key => $val) {
            if ($val > 0) {
                if ($sumHours[$key] >= $val) {
                    $block1->cellRow('<strong>' . $sumHours[$key] . '</strong>');
                } else {
                    $block1->cellRow($sumHours[$key]);
                }
            } else {
                $block1->cellRow("&nbsp;");
            }
        }

        $block1->closeRow();
        //
        // Summary past required hours row
        $block1->openRow();
        $block1->cellRow("&nbsp;");
        $block1->cellRow(lang_strings('overdue_hours') . ": $overdueHours");

        foreach ($listWorkHours as $val) {
            $block1->cellRow("&nbsp;");
        }

        $block1->closeRow();
        $block1->closeResults();
        echo "<p><br></p>";
    }
} else {
    $block1->noresults();
}

$block1->closeFormResults();
require_once("../includes/footer.php");
