<?php // $Revision: 1.12 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * Author: Michael Cook <michael@ink.org>
 * Date:   07-14-2003
 *
 * $Id: overdue.php,v 1.12 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/overdue.php
 *
 * show tasks which are overdue
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// load report info
$querymore = " WHERE rep.name='overdue_tasks'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("overdue_tasks"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['overdue_tasks'];
logURL($title, "../reports/overdue.php");
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/overdue.php#" . $block1->form . "Anchor");
$block1->openContent();
$block1->sorting("overdue", isset($sortingUser['overdue'])?$sortingUser['overdue']:'', "tas.priority DESC", $sortingFields = array(0 => "tas.name", 1 => "pro.name", 2 => "tas.status", 3 => "tas.completion", 4 => "tas.due_date", 5 => "tas.assigned_to", 6 => "tas.priority"));

if ($projectsFilter != 'true' || $SW_Permissions['Project']['Admin'][$profilSession]) {
    $query = " WHERE tas.status<>'" . enumStatus::stCompleted . "' AND tas.due_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y'))) . "' AND tas.due_date<>'0'";
} else {
    $query = " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=tas.project AND tea.member=$idSession LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tas.project AND prp.profil=tea.profil WHERE tea.member=$idSession AND prp.view_task='" . enumBoolean::bTrue . "' AND tas.status<>'" . enumStatus::stCompleted . "' AND tas.due_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y'))) . "' AND tas.due_date<>'0'";
}

$queryS = " ORDER BY $block1->sortingValue";
$listTasks = new request();
$listTasks->openHierarchyOfTasks($query, $queryS);
$comptListTasks = count($listTasks->tas_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListTasks == "0") {
    $block0->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListTasks == "1") {
    $block0->contentRow("", "1 " . lang_strings("match"));
} else {
    $block0->contentRow("", $comptListTasks . " " . lang_strings("matches"));
}

$block0->closeContent();
$block1->heading(lang_strings('overdue_tasks'));

if ($comptListTasks > 0) {
    $labels = array(lang_strings("task"), lang_strings("project"), lang_strings("status"), lang_strings("completion"), lang_strings("due_date"), lang_strings("assigned_to"), lang_strings("priority"));
    $block1->openResults(false);
    $block1->labels($labels, "true");

    for ($i=0 ;$i<$comptListTasks; $i++) {
        $idStatus = $listTasks->tas_status[$i];
        $idPriority = $listTasks->tas_priority[$i];
        $complValue = ($listTasks->tas_completion[$i] > 0) ? $listTasks->tas_completion[$i] . "0 %": $listTasks->tas_completion[$i] . " %";
        $block1->openRow();
        $leadingSpace = '';

        for ($j = 0;$j < $listTasks->tas_level[$i];$j++) {
            $leadingSpace .= '&nbsp;&nbsp;';
        }

        $block1->cellRow($leadingSpace . $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], 'in'));
        $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTasks->tas_project[$i], $listTasks->tas_pro_name[$i], 'in'));
        $block1->cellRow($status[$idStatus]);
        $block1->cellRow($complValue);
        $block1->cellRow(createDate($listTasks->tas_due_date[$i],'date',false,true));

        if ($listTasks->tas_assigned_to[$i] == "0") {
            $block1->cellRow(lang_strings("unassigned"));
        } else {
            $tmpquery = " AND res.task=" . $listTasks->tas_id[$i];
            $resourceUsage = new request();
            $resourceUsage->openTaskHumanResource($tmpquery);
            $comptResourceUsage = count($resourceUsage->res_id);
            $assignedToStrings = "";

            for ($j = 0;$j < $comptResourceUsage;$j++) {
                if ($j > 0) {
                    $assignedToStrings .= "&nbsp;";
                }

                $assignedToStrings .= $blockPage->buildLink($resourceUsage->res_resource[$j], '', 'message');
            }

            $block1->cellRow($assignedToStrings);
        }

        $block1->cellRow($priority[$idPriority]);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeFormResults();
require_once("../includes/footer.php");
