<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: pending_approval.php,v 1.4 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/pending_approval.php
 *
 * show pending approval documents
 *
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Variables init
 */
// set up the originators selection
$originators = (isset($_POST['S_ORISEL'])?$_POST['S_ORISEL']:'');

if ($originators !== '' && !is_array($originators)) {
    $originators = explode("**", $originators);
}

// set up the authorizers selection
$authorizers = (isset($_POST['S_AUTSEL'])?$_POST['S_AUTSEL']:'');

if ($authorizers !== '' && !is_array($authorizers)) {
    $authorizers = explode("**", $authorizers);
}

// load report info
$querymore0 = " WHERE rep.name='approval_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore0);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selectapproval.php', lang_strings("approval_report"), 'in'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "paR";
$block1->openForm("../reports/pending_approval.php#" . $block1->form . "Anchor");
echo '<input type="hidden" name="S_ORISEL" value="' . ((is_array($originators))?implode("**", $originators):$originators) . '">';
echo '<input type="hidden" name="S_AUTSEL" value="' . ((is_array($authorizers))?implode("**", $authorizers):$authorizers) . '">';
$block1->sorting("report_approval", (isset($sortingUser['report_approval'])?$sortingUser['report_approval']:''), "dap.created ASC", $sortingFields = array(0 => "dap.doctype", 1 => "dap.docid", 2 => "mem.name", 3 => "dap.comments", 4 => "con.name", 5 => "con.max_requirements", 6 => "con.max_requirements", 7 => "dap.created"));
// prepare data
$querymore = " WHERE dap.canceled='N' AND dap.closed='N' ";

if ($originators == '') {
    $querymore .= " AND dap.owner='0' ";
} else {
    $querymore .= " AND dap.owner" . ((is_array($originators))?" IN ('" . implode("','", $originators) . "')":"='$originators'");
}

if ($authorizers == '') {
    $querymore .= " AND EXISTS (SELECT daa.authorizer FROM " . $tablePrefix . "documents_approval_authorizers daa WHERE daa.document_approval=dap.id AND daa.authorizer='0')";
} else {
    $querymore .= " AND EXISTS (SELECT daa.authorizer FROM " . $tablePrefix . "documents_approval_authorizers daa WHERE daa.document_approval=dap.id AND daa.authorizer" . ((is_array($authorizers))?" IN ('" . implode("','", $authorizers) . "')":"='$authorizers'") . ")";
}

$querymore .= " ORDER BY " . $block1->sortingValue;
$listDocumentsApprovals = new request();
$listDocumentsApprovals->openDocumentsApproval($querymore);
$comptListDocumentsApprovals = count($listDocumentsApprovals->dap_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListDocumentsApprovals == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListDocumentsApprovals == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListDocumentsApprovals . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListDocumentsApprovals > 0) {
    $labels = array(lang_strings("type"), lang_strings("id"), lang_strings("originator"), lang_strings("comments"), lang_strings("approval_stage"), lang_strings("no_of_approvals_required"), lang_strings("authorizers"), lang_strings("created"));
    $block1->openResults(false);
    $block1->labels($labels, "false");

    for ($i=0; $i<$comptListDocumentsApprovals; $i++) {
        $viewDocEnabled = false;
        $querymore = " WHERE daa.document_approval='" . $listDocumentsApprovals->dap_id[$i] . "' AND daa.confirmation_level='" . $listDocumentsApprovals->dap_aps_confirmation_level[$i] . "' ORDER BY daa.status,mem.name";
        $listDocumentsApprovalAuthorizers = new request();
        $listDocumentsApprovalAuthorizers->openDocumentsApprovalAuthorizers($querymore);
        $comptListDocumentsApprovalAuthorizers = count($listDocumentsApprovalAuthorizers->daa_document_approval);

        for ($j=0; $j<$comptListDocumentsApprovalAuthorizers; $j++) {
            if ($listDocumentsApprovalAuthorizers->daa_authorizer[$j] == $idSession) {
                $viewDocEnabled = true;
            }

            if ($listDocumentsApprovalAuthorizers->daa_status[$j] == enumApprovalStatus::stPending) {
                $listDocumentsApprovalAuthorizers->authorizer_status[$j] = $blockPage->buildLink($listDocumentsApprovalAuthorizers->daa_mem_email_work[$j], $listDocumentsApprovalAuthorizers->daa_mem_name[$j], 'mail');
            } else {
                $listDocumentsApprovalAuthorizers->authorizer_status[$j] = $blockPage->buildLink('../users/viewuser.php?id=' . $listDocumentsApprovalAuthorizers->daa_authorizer[$j], $listDocumentsApprovalAuthorizers->daa_mem_name[$j], 'instrike') . ' <i>' . $statusDocumentApproval[$listDocumentsApprovalAuthorizers->daa_status[$j]] . '</i>';

                if ($listDocumentsApprovalAuthorizers->daa_comments[$j] != '') {
                    $listDocumentsApprovalAuthorizers->authorizer_status[$j] .= ' ' . $listDocumentsApprovalAuthorizers->daa_comments[$j];
                }
            }
        }

        $authorizers_status = implode('<br>', $listDocumentsApprovalAuthorizers->authorizer_status);
        $block1->openRow();

        if ($viewDocEnabled) {
            $block1->cellRow($blockPage->buildLink("../approvals/viewdocument.php?id=" . $listDocumentsApprovals->dap_id[$i], tableNameString($listDocumentsApprovals->dap_doctype[$i]), 'in'));
        } else {
            $block1->cellRow(tableNameString($listDocumentsApprovals->dap_doctype[$i]));
        }

        switch ($listDocumentsApprovals->dap_doctype[$i]) {
            case 'files':
                $querymore = " WHERE fil.id='" . $listDocumentsApprovals->dap_docid[$i] . "'";
                $fileDetail = new request();
                $fileDetail->openFiles($querymore);
                $block1->cellRow($blockPage->buildLink("../linkedcontent/viewfile.php?doc_type=" . $fileDetail->fil_doc_type[0] . "&doc_id=" . $fileDetail->fil_doc_id[0] . "&id=" . $listDocumentsApprovals->dap_docid[$i], $listDocumentsApprovals->dap_docid[$i], 'in'));
                break;
            case 'timesheet':
                if ($listDocumentsApprovals->dap_owner[$i] == $idSession) {
                    $querymore = " WHERE tim.id='" . $listDocumentsApprovals->dap_docid[$i] . "'";
                    $timesheetDetail = new request();
                    $timesheetDetail->openTimesheet($querymore);
                    $fyear = date('Y', $timesheetDetail->tim_per_date_start[0]);
                    $month = date('n', $timesheetDetail->tim_per_date_start[0]);
                    $day = date('j', $timesheetDetail->tim_per_date_start[0]);
                    $weekday = date('w', $timesheetDetail->tim_per_date_start[0]);

                    if ($weekday == '0') {
                        $sdate = mktime(0, 0, 0, $month, $day-6, $fyear);
                    } else {
                        $sdate = mktime(0, 0, 0, $month, $day-$weekday+1, $fyear);
                    }

                    $block1->cellRow($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=" . $timesheetDetail->tim_per_fyear[0] . "&serialno=" . $timesheetDetail->tim_per_serial_no[0] . "&sdate=" . $sdate, $listDocumentsApprovals->dap_docid[$i], 'in'));
                } else {
                    $block1->cellRow($listDocumentsApprovals->dap_docid[$i]);
                }

                break;
            case 'leave_requests':
                $block1->cellRow($blockPage->buildLink("../leaves/viewleaverequest.php?id=" . $listDocumentsApprovals->dap_docid[$i], $listDocumentsApprovals->dap_docid[$i], 'in'));
                break;
            case 'expenses':
                $block1->cellRow($blockPage->buildLink("../expenses/viewexpense.php?id=" . $listDocumentsApprovals->dap_docid[$i], $listDocumentsApprovals->dap_docid[$i], 'in'));
                break;
            case 'projects':
                $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listDocumentsApprovals->dap_docid[$i], $listDocumentsApprovals->dap_docid[$i], 'in'));
                break;
            default:
                $block1->cellRow($blockPage->buildLink("../forms/viewform.php?id=" . $listDocumentsApprovals->dap_docid[$i] . "&tblnam=" . $listDocumentsApprovals->dap_doctype[$i], $listDocumentsApprovals->dap_docid[$i], 'in'));
        }

        $block1->cellRow($blockPage->buildLink($listDocumentsApprovals->dap_owner[$i], '', 'message'));
        $comm = strip_tags($listDocumentsApprovals->dap_comments[$i]);
        $block1->cellRow($comm);
        $block1->cellRow($listDocumentsApprovals->dap_con_name[$i]);
        $block1->cellRow($listDocumentsApprovals->dap_con_max_requirements[$i]);
        $block1->cellRow($authorizers_status);
        $block1->cellRow(createDate($listDocumentsApprovals->dap_created[$i],'both'));
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeFormResults();
require_once("../includes/footer.php");
