<?php // $Revision: 1.14 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: phasestatus.php,v 1.14 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/phasestatus.php
 *
 * show a basic overview of all active projects and their phases
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Prepare data
 */
// project list
if ($projectsFilter != 'true' || $SW_Permissions['Project']['Admin'][$profilSession]) {
    $querymore = " WHERE pro.status IN ('" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "') AND pro.phase_set<>'0' ORDER BY pro.name";
} else {
    $querymore = " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=pro.id LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member='$idSession' AND prp.view_project='" . enumBoolean::bTrue . "' AND prp.view_phase='" . enumBoolean::bTrue . "' AND pro.status IN ('" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "') AND pro.phase_set<>'0' ORDER BY pro.name";
}

$listProjects = new request();
$listProjects->openProjects($querymore);
$comptListProjects = count($listProjects->pro_id);

// load report info
$querymore = " WHERE rep.name='project_phasestatus'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("project_phasestatus"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['project_phasestatus'];
logURL($title, "../reports/phasestatus.php");
// show the nice number-of-results header
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListProjects == "0") {
    $blockPage->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListProjects == "1") {
    $blockPage->contentRow("", "1 " . lang_strings("match"));
} else {
    $blockPage->contentRow("", $comptListProjects . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListProjects > 0) {
    for ($j=0; $j<$comptListProjects; $j++) {
        $projectId = $listProjects->pro_id[$j];
        $block1 = new block();
        $block1->openContent();
        $block1->heading($blockPage->buildLink("../projects/viewproject.php?id=" . $projectId, $listProjects->pro_name[$j], 'in'));
        $block1->closeContent();
        $queryPhase = " WHERE pha.project='$projectId' ORDER BY pha.order_num";
        $listPhases = new request();
        $listPhases->openPhases2($queryPhase);
        $comptListPhases = count($listPhases->pha_id);
        $labels = array(lang_strings('order'), lang_strings('name'), lang_strings('total_tasks'), lang_strings('uncomplete_tasks'), lang_strings('milestone'), lang_strings('status'), lang_strings('date_start'), lang_strings('date_end'));
        $block1->openResults(false);
        $block1->labels($labels, "true");

        for ($i=0; $i<$comptListPhases; $i++) {
            if ($listPhases->pha_status[$i] == enumPhaseStatus::stNotStarted) {
                $phaseStart = '--';
                $phaseEnd = '--';
            } else if ($listPhases->pha_status[$i] == enumPhaseStatus::stCompleted) {
                $phaseStart = createDate($listPhases->pha_date_start[$i],'date',false,true);
                $phaseEnd = createDate($listPhases->pha_date_end[$i],'date',false,true);
            } else {
                $phaseStart = createDate($listPhases->pha_date_start[$i],'date',false,true);
                $phaseEnd = '--';
            }

            $block1->openRow();
            $block1->cellRow($listPhases->pha_order_num[$i]);
            $block1->cellRow($blockPage->buildLink("../phases/viewphase.php?id=" . $listPhases->pha_id[$i], $listPhases->pha_description[$i], 'in'));
            $block1->cellRow($listPhases->pha_total_tasks[$i]);
            $block1->cellRow($listPhases->pha_uncompleted_tasks[$i]);
            $block1->cellRow($listPhases->pha_milestones[$i]);
            $block1->cellRow($phaseStatus[$listPhases->pha_status[$i]]);
            $block1->cellRow($phaseStart);
            $block1->cellRow($phaseEnd);
            $block1->closeRow();
        }

        $block1->closeResults();
        print "<p><br></p>";
    }
} else {
    $block0->noresults();
}

require_once("../includes/footer.php");
