<?php // $Revision: 1.11 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: projectbreakdown.php,v 1.11 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/projectbreakdown.php
 *
 * list projects by manager
 *
 * TODO: add export to CSV capabilities
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// load report info
$querymore = " WHERE rep.name='project_breakdown'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("project_breakdown"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['project_breakdown'];
logURL($title, "../reports/projectbreakdown.php");

if ($projectsFilter == 'true' && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    $query = " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=pro.id LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member=$idSession AND prp.view_project='" . enumBoolean::bTrue . "'";
} else {
    $query = '';
}

// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/projectbreakdown.php#" . $block1->form . "Anchor");
$block1->openContent();
$block1->sorting("projectbreakdown", isset($sortingUser['projectbreakdown'])?$sortingUser['projectbreakdown']:'', "mem.name ASC", $sortingFields = array(0 => "mem.name", 1 => "pro.name", 2 => "org.name", 3 => "pro.status"));
$tmpquery = "$query ORDER BY $block1->sortingValue";
$listProjects = new request();
$listProjects->openProjects($tmpquery);
$comptListProjects = count($listProjects->pro_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListProjects == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListProjects == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListProjects . " " . lang_strings("matches"));
}

$block0->closeContent();
// set up the header string
$headerString = lang_strings('project_breakdown');
$block1->heading($headerString);

if ($comptListProjects > 0) {
    $labels = array(lang_strings("owner"), lang_strings("project"), lang_strings("organization"), lang_strings("status"));
    $block1->openResults(false);
    $block1->labels($labels, "false");

    for ($i=0; $i<$comptListProjects; $i++) {
        $idStatus = $listProjects->pro_status[$i];
        $block1->openRow();

        if ($listProjects->pro_owner[$i] == "0") {
            $block1->cellRow(lang_strings("unassigned"));
        } else {
            $block1->cellRow($blockPage->buildLink($listProjects->pro_owner[$i], '', 'message'));
        }

        $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listProjects->pro_id[$i], $listProjects->pro_name[$i], 'in'));

        if ($listProjects->pro_org_id[$i] == '' || $listProjects->pro_org_id[$i] == '1') {
            $block1->cellRow('');
        } else {
            $block1->cellRow($blockPage->buildLink("../clients/viewclient.php?id=" . $listProjects->pro_org_id[$i], $listProjects->pro_org_name[$i], 'in'));
        }

        // $block1->cellRow($listProjects->pro_status[$i]);
        $block1->cellRow($statusProject[$idStatus]);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

// close this block
$block1->closeFormResults();
require_once("../includes/footer.php");
