<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: reportcategories.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'list';
$nam = AddSlashesNOD(isset($_POST['nam'])?$_POST['nam']:'');    // name
$desc = isset($_POST['desc'])?$_POST['desc']:'';                // name print
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$nam_highlight = false;
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Edit'][$profilSession]) {
    header("Location: ../reports/reportcategories.php?mode=list&msg=permissiondenied");
    exit;
}

if ($id != '') {
    if ($mode == 'delete') {
        $tmpquery = "SELECT * FROM " . $tablePrefix . "reports WHERE category IN ($ids)";

        if (compt($tmpquery) > 0) {
            header("Location: ../reports/reportcategories.php?mode=list&msg=permissiondenied");
            exit;
        }

        $querymore = " WHERE repc.id IN ($ids)";
        $listReportCategories = new request();
        $listReportCategories->openReportCategory($querymore);
        $comptListReportCategories = count($listReportCategories->repc_id);

        if ($comptListReportCategories == '0') {
            header("Location: ../reports/reportcategories.php?mode=list&msg=permissiondenied");
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE repc.id='$id'";
        $reportCategoryDetail = new request();
        $reportCategoryDetail->openReportCategory($querymore);
        $comptReportCategoryDetail = count($reportCategoryDetail->repc_id);

        if ($comptReportCategoryDetail == '0') {
            header("Location: ../reports/reportcategories.php?mode=list&msg=permissiondenied");
            exit;
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add') {
    $querymore = " WHERE repc.name='$nam'";
    $reportCategoryTest = new request();
    $reportCategoryTest->openReportCategory($querymore);

    if (count($reportCategoryTest->repc_id) > 0) {
        $error = lang_strings("report_category_already_exists");
        $bodyCommand = "onLoad=\"document.repcForm.nam.focus();\"";
        $nam_highlight = true;
    }
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "report_category (name,created,cuser) VALUES ('$nam','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('report_category');
            updateString($requestAct, 'REPC__' . $nam, $desc);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../reports/reportcategories.php?mode=list&msg=add");
            exit;
        }
    } else if ($action == 'edit') {
        try {
            $requestAct->startTransaction();

            if ($id == '1') {
                updateString($requestAct, $nam, $desc);
            } else {
                updateString($requestAct, 'REPC__' . $nam, $desc);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../reports/reportcategories.php?mode=list&msg=update");
            exit;
        }
    } else if ($action == 'delete') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "DELETE FROM " . $tablePrefix . "report_category WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../reports/reportcategories.php?mode=list&msg=delete");
            exit;
        }
    }
}

// Get Report Categories
$querymore1 = " ORDER BY repc.id";
$listReportCategory = new request();
$listReportCategory->openReportCategory($querymore1);
$comptListReportCategory = count($listReportCategory->repc_id);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings('manage_categories'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/reportcategories.php', lang_strings('manage_categories'), 'in'));
}

if ($mode == 'add') {
    $blockPage->itemBreadcrumbs(lang_strings("add_report_category"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs(lang_strings("edit_report_category"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs(lang_strings("delete_report_categories"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';

if ($mode == 'list') {
    $title = $strings['reports'] . ' : ' . $strings['manage_categories'];
    logURL($title, '../reports/reportcategories.php?mode=' . $mode);
}

$block1 = new block();
$block1->form = "repc";
$block1->openForm("../reports/reportcategories.php?id=$id&mode=$mode#" . $block1->form . "Anchor");

if ($mode == 'list') {
    $block1->openHeading(lang_strings("manage_categories"));
    $block1->openViewOptions();

    for ($i=0; $i<$comptListReportCategory; $i++) {
        $block1->itemViewOptions($block1->buildLink('../reports/listreports.php?cat=' . $listReportCategory->repc_id[$i], $listReportCategory->repc_name_print[$i], 'in'));
    }

    $block1->closeViewOptions();
    $block1->closeHeading();

    if ($SW_Permissions['Report']['Edit'][$profilSession]) {
        $block1->openPaletteIcon();
        $block1->paletteIcon(0, 'add', $strings['add']);
        $block1->paletteIcon(1, 'remove', $strings['delete']);
        $block1->paletteIcon(3, 'edit', $strings['edit']);
        $block1->closePaletteIcon();
    }

    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '20';
    $block1->sorting('report_category', isset($sortingUser['report_category'])?$sortingUser['report_category']:'', 'repc.name ASC', $sortingFields = array(0 => 'repc.name', 1 => 'none'));
    $querymore = " ORDER BY " . $block1->sortingValue;
    $block1->recordsTotal = compt($initrequest['report_category'] . ' ' . $querymore);
    $listReportCategories = new request();
    $listReportCategories->openReportCategory($querymore, $block1->borne, $block1->rowsLimit);
    $comptListReportCategories = count($listReportCategories->repc_id);

    if ($comptListReportCategories > 0) {
        $labels = array(lang_strings('name'), lang_strings('name_print'));
        $block1->openResults();
        $block1->labels($labels, 'false');

        for ($i=0; $i<$comptListReportCategories; $i++) {
            $block1->openRow($listReportCategories->repc_id[$i]);
            $block1->cellRow($listReportCategories->repc_name[$i]);
            $block1->cellRow($listReportCategories->repc_name_print[$i]);
            $block1->closeRow();
        }

        $block1->closeResults();
        $block1->bornesFooter("1", $blockPage->bornesNumber, "id=$id&mode=$mode");
    } else {
        $block1->noresults();
    }

    $block1->closeFormResults();

    if ($SW_Permissions['Report']['Edit'][$profilSession]) {
        $block1->openPaletteScript();
        $block1->paletteScript(0, 'add', '../reports/reportcategories.php?mode=add', 'true,false,false', $strings['add']);
        $block1->paletteScript(1, 'remove', '../reports/reportcategories.php?mode=delete', 'false,true,true', $strings['delete']);
        $block1->paletteScript(3, 'edit', '../reports/reportcategories.php?mode=edit', 'false,true,false', $strings['edit']);
        $block1->closePaletteScript($comptListReportCategories, $listReportCategories->repc_id);
    }
} else if ($mode == 'add') {
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_report_category"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name"), 'nam', enumFieldType::ftAlphaNumeric, 'Y', '155', $nam, '', '', $nam_highlight, '', 'onblur="nameChanged()"');
    setupInputHTML($block1, lang_strings("name_print"), 'desc', enumFieldType::ftText, 'Y', '65535', $desc, '', '', false, '', 'onblur="nameChanged()"');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    if ($error == '') {
        $nam = $reportCategoryDetail->repc_name[0];
        $desc = $reportCategoryDetail->repc_name_print[0];
    }

    echo '<input type="hidden" name="action" value="edit">';
    echo '<input type="hidden" name="nam" value="' . $nam . '">';
    $block1->heading(lang_strings("edit_report_category") . " : " . $reportCategoryDetail->repc_name[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name_print"), 'desc', enumFieldType::ftText, 'Y', '65535', $desc);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_report_categories"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListReportCategories; $i++) {
        $block1->contentRow('#' . $listReportCategories->repc_id[$i], $listReportCategories->repc_name[$i] . ' (' . $listReportCategories->repc_name_print[$i] . ')');
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

?>
<script type="text/javascript">
    function nameChanged() {
        var np = document.getElementById('desc').value;

        if (np === '') {
            var n = document.getElementById('nam').value;
            document.getElementById('desc').value = n;
        }
    }
</script>
<?php
require_once("../includes/footer.php");
