<?php // $Revision: 1.20 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: resource_usage.php,v 1.20 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/resource_usage.php
 *
 * display total hours logged in a given time frame by project and
 * organization
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Variables init
 */
// set up the organization selection
$S_org = (isset($_POST['S_ORGSEL'])?$_POST['S_ORGSEL']:'');

if ($S_org !== '' && !is_array($S_org)) {
    $S_org = explode("**", $S_org);
}

// set up the project selection
$S_prj = (isset($_POST['S_PRJSEL'])?$_POST['S_PRJSEL']:'');

if ($S_prj !== '' && !is_array($S_prj)) {
    $S_prj = explode("**", $S_prj);
}

// set up the department selection
$S_dep = (isset($_POST['S_DEPSEL'])?$_POST['S_DEPSEL']:'');

if ($S_dep !== '' && !is_array($S_dep)) {
    $S_dep = explode("**", $S_dep);
}

// set up the member selection
$S_mem = (isset($_POST['S_ATSEL'])?$_POST['S_ATSEL']:'');

if ($S_mem !== '' && !is_array($S_mem)) {
    $S_mem = explode("**", $S_mem);
}

// a date range was selected
$S_date1 = (isset($_POST['S_DATE1'])?$_POST['S_DATE1']:'');
$S_date2 = (isset($_POST['S_DATE2'])?$_POST['S_DATE2']:'');

// display total project hours
$displayProjTotals = ($_POST['S_PROJTOTAL']=='TRUE')?true:false;
// display total organization hours
$displayOrgTotals = ($_POST['S_ORGTOTAL']=='TRUE')?true:false;
// display total member hours for project
$displayMemTotals = ($_POST['S_MEMTOTAL']=='TRUE')?true:false;
// display total member hours for period
$displayMemPTotals = ($_POST['S_MEMPTOTAL']=='TRUE')?true:false;
// billing selection
$billingSelection = (isset($_POST['S_BILLING'])?$_POST['S_BILLING']:'');

// load report info
$querymore = " WHERE rep.name='resource_usage'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selectru.php', lang_strings("resource_usage"), 'in'));
$blockPage->closeBreadcrumbs();
// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/selectru.php#" . $block1->form . "Anchor");
echo '<input type="hidden" name="S_ORGSEL" value="' . ((is_array($S_org))?implode("**", $S_org):$S_org) . '">';
echo '<input type="hidden" name="S_PRJSEL" value="' . ((is_array($S_prj))?implode("**", $S_prj):$S_prj) . '">';
echo '<input type="hidden" name="S_DEPSEL" value="' . ((is_array($S_dep))?implode("**", $S_dep):$S_dep) . '">';
echo '<input type="hidden" name="S_ATSEL" value="' . ((is_array($S_mem))?implode("**", $S_mem):$S_mem) . '">';
echo '<input type="hidden" name="S_DATE1" value="' . $S_date1 . '">';
echo '<input type="hidden" name="S_DATE2" value="' . $S_date2 . '">';
echo '<input type="hidden" name="S_BILLING" value="' . $billingSelection . '">';

if ($displayProjTotals) {
    echo "<input type=\"hidden\" name=\"S_PROJTOTAL\" value=\"TRUE\">";
}

if ($displayOrgTotals) {
    echo "<input type=\"hidden\" name=\"S_ORGTOTAL\" value=\"TRUE\">";
}

if ($displayMemTotals) {
    echo "<input type=\"hidden\" name=\"S_MEMTOTAL\" value=\"TRUE\">";
}

if ($displayMemPTotals) {
    echo "<input type=\"hidden\" name=\"S_MEMPTOTAL\" value=\"TRUE\">";
}

$block1->openContent();
// a member selection was made
if ($S_mem == '') {
    $query = " WHERE T0.owner='0'";
} else {
    $query = " WHERE T0.owner" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}
// a organization selection was made
if ($S_org != '') {
    $query .= " AND T0.organization" . ((is_array($S_org))?" IN ('" . implode("','", $S_org) . "')":"='$S_org'");
}
// a project selection was made
if ($S_prj != '') {
    $query .= " AND T0.project" . ((is_array($S_prj))?" IN ('" . implode("','", $S_prj) . "')":"='$S_prj'");
}
// a department selection was made
if ($S_dep != '') {
    $query .= " AND T0.department" . ((is_array($S_dep))?" IN ('" . implode("','", $S_dep) . "')":"='$S_dep'");
}
// handle date ranges, if supplied
if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $query .= " AND T0.date>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $query .= " AND T0.date<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}
// billing selection
if ($billingSelection != 'ALL') {
    $query .= " AND T0.billing='$billingSelection'";
}

$hourCodeSql = "CASE wkh.work";
$listHourCode = new request();
$listHourCode->openHourCode('');
$comptListHourCode = count($listHourCode->hrc_id);

for ($i52d=0; $i52d<$comptListHourCode; $i52d++) {
    $hourCodeSql .= " WHEN '" . $listHourCode->hrc_id[$i52d] . "' THEN '" . HtmlEntitiesNOD($listHourCode->hrc_name_print[$i52d]) . "'";
}

$hourCodeSql .= " ELSE '' END";
$tmpquery = "SELECT T1.doc_type,T1.doc_id,T1.doc_name,T1.organization,T1.org_name,T1.project,T1.pro_name,T1.owner,T1.mem_name,SUM(T1.hours) FROM (
SELECT T0.doc_type,T0.doc_id,T0.doc_name,T0.organization,T0.org_name,T0.project,T0.pro_name,T0.owner,T0.mem_name,T0.hours FROM (
SELECT 'T' AS doc_type,tim.task AS doc_id,tas.name AS doc_name,pro.organization,org.name AS org_name,tim.project,pro.name AS pro_name,tim.owner,mem.name AS mem_name,mem.department,tim.date,tim.hours,tim.billing FROM " . $tablePrefix . "tasks_time tim LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id=tim.task LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=tim.project LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=tim.owner
) T0 $query UNION ALL
SELECT T0.doc_type,T0.doc_id,T0.doc_name,T0.organization,T0.org_name,T0.project,T0.pro_name,T0.owner,T0.mem_name,T0.hours FROM (
SELECT 'M' AS doc_type,mti.meeting AS doc_id,mee.name AS doc_name,pro.organization,org.name AS org_name,mti.project,pro.name AS pro_name,mti.owner,mem.name AS mem_name,mem.department,mti.date,mti.hours,CAST('" . enumBoolean::bFalse . "' AS char(1)) AS billing FROM " . $tablePrefix . "meetings_time mti LEFT OUTER JOIN " . $tablePrefix . "meetings mee ON mee.id=mti.meeting LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=mti.project LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=mti.owner
) T0 $query UNION ALL
SELECT T0.doc_type,T0.doc_id,T0.doc_name,T0.organization,T0.org_name,T0.project,T0.pro_name,T0.owner,T0.mem_name,T0.hours FROM (
SELECT 'W' AS doc_type,wkh.work AS doc_id,$hourCodeSql AS doc_name,pro.organization,org.name AS org_name,wkh.project,pro.name AS pro_name,wkh.owner,mem.name AS mem_name,mem.department,wkh.date,wkh.hours,wkh.billing FROM " . $tablePrefix . "work_hours wkh LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=wkh.project LEFT OUTER JOIN " . $tablePrefix . "organizations org ON org.id=pro.organization LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.id=wkh.owner
) T0 $query
) T1 GROUP BY T1.doc_type,T1.doc_id,T1.doc_name,T1.organization,T1.org_name,T1.project,T1.pro_name,T1.owner,T1.mem_name
ORDER BY T1.org_name,T1.pro_name,T1.mem_name";
$listHours = new request();
$listHours->connectClass();
$listHours->query($tmpquery);
$listHours->tim_doc_type = array();

while ($listHours->fetch()) {
    $i = 0;
    $listHours->tim_doc_type[] = ($row[$i++]);
    $listHours->tim_doc_id[] = ($row[$i++]);
    $listHours->tim_doc_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->tim_organization[] = ($row[$i++]);
    $listHours->tim_org_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->tim_project[] = ($row[$i++]);
    $listHours->tim_pro_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $listHours->tim_owner[] = ($row[$i++]);
    $listHours->tim_mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
    $h = ($row[$i++]);
    $hours = (is_numeric($h))?round($h, $hourAccuracy):'0';
    $listHours->tim_hours[] = $hours;
}

$listHours->close();
$comptListHours = count($listHours->tim_doc_type);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListHours == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListHours == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListHours . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListHours != "0") {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", $strings["export"]);
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $_SESSION['TARGET'] = 'exportru';
    $params = array();
    // handle date ranges
    $params['S_DATE1'] = $S_date1;
    $params['S_DATE2'] = $S_date2;
    // organization selection
    $params['S_ORGSEL'] = $S_org;
    // project selection
    $params['S_PRJSEL'] = $S_prj;
    // department selection
    $params['S_DEPSEL'] = $S_dep;
    // member selection
    $params['S_ATSEL'] = $S_mem;
    // billing selection
    $params['S_BILLING'] = $billingSelection;
    $_SESSION['PARAMS'] = $params;
    $block1->paletteScript(0, "export", "../reports/exportru.php", "true,false,false", $strings["export"]);
    $block1->closePaletteScript($comptListHours, $listHours->tim_id);
}

// set up the header string
$block1HeadingText = lang_strings("ru_detail") . " ";
$block1->heading($block1HeadingText);
$total_project_hours = 0;
$total_org_hours = 0;
$total_mem_hours = 0;
$grand_total_member_hours = array();
$grand_total_member_names = array();

if ($comptListHours > 0) {
    $labels = array(lang_strings("organization"), lang_strings("project"), lang_strings("member"), lang_strings("task"), lang_strings("hours"));
    $block1->openResults(false);
    $block1->labels($labels, "true");

    for ($i=0; $i<$comptListHours; $i++) {
        if ($i == 0 || $listHours->tim_organization[$i-1] != $listHours->tim_organization[$i]) {
            // print a organization header row
            $block1->openRow();

            if ($listHours->tim_organization[$i] == '' || $listHours->tim_organization[$i] == '1') {
                $block1->cellRow("");
            } else {
                $block1->cellRow($blockPage->buildLink('../clients/viewclient.php?id=' . $listHours->tim_organization[$i], $listHours->tim_org_name[$i], 'in'));
            }

            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->closeRow();
        }

        if ($i == 0 || $listHours->tim_project[$i-1] != $listHours->tim_project[$i]) {
            // print a project header row
            $block1->openRow();
            $block1->cellRow("");
            $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listHours->tim_project[$i], $listHours->tim_pro_name[$i], 'in'));
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->closeRow();
        }

        $block1->openRow();
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow($blockPage->buildLink($listHours->tim_owner[$i], '', 'message'));

        switch ($listHours->tim_doc_type[$i]) {
            case 'T':
                $block1->cellRow($blockPage->buildLink('../tasks/viewtask.php?id=' . $listHours->tim_doc_id[$i], $listHours->tim_doc_name[$i], 'in'));
                break;
            case 'M':
                $block1->cellRow($blockPage->buildLink('../meetings/viewmeeting.php?id=' . $listHours->tim_doc_id[$i], $listHours->tim_doc_name[$i], 'in'));
                break;
            default:
                $block1->cellRow($listHours->tim_doc_name[$i]);
        }

        $nice_print = NumberFormatNOD($listHours->tim_hours[$i], $hourAccuracy);
        $block1->cellRow($nice_print);
        $block1->closeRow();
        $total_mem_hours += $listHours->tim_hours[$i];
        $total_org_hours += $listHours->tim_hours[$i];
        $total_project_hours += $listHours->tim_hours[$i];

        if (!array_key_exists($listHours->tim_owner[$i], $grand_total_member_names)) {
            $grand_total_member_names[$listHours->tim_owner[$i]] = $listHours->tim_mem_name[$i];
            $grand_total_member_hours[$listHours->tim_owner[$i]] = $listHours->tim_hours[$i];
        } else {
            $grand_total_member_hours[$listHours->tim_owner[$i]] += $listHours->tim_hours[$i];
        }

        if (($i+1) == $comptListHours) {
            $lastOne = true;
        } else {
            $lastOne = false;

            if ($listHours->tim_owner[$i+1] != $listHours->tim_owner[$i]) {
                $memberChanged = true;
            } else {
                $memberChanged = false;
            }
        }

        if ($lastOne || $memberChanged) {
            if ($displayMemTotals) {
                // print the member totoal
                $block1->openRow();
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow('<b>' . $blockPage->buildLink($listHours->tim_owner[$i], '', 'message') . '</b>');
                $block1->cellRow('<b>' . lang_strings('ru_subtotal') . '</b>');
                $nice_print = NumberFormatNOD($total_mem_hours, $hourAccuracy);
                $block1->cellRow('<b>' . $nice_print . '</b>');
                $block1->closeRow();
            }

            $total_mem_hours = 0;
        }

        if ($lastOne || $listHours->tim_project[$i+1] != $listHours->tim_project[$i]) {
            $projectChanged = true;
        } else {
            $projectChanged = false;
        }

        if ($projectChanged) {
            // print the project total
            if ($displayProjTotals) {
                $block1->openRow();
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("<b>" . lang_strings('ru_total_project') . "</b>");
                $nice_print = NumberFormatNOD($total_project_hours, $hourAccuracy);
                $block1->cellRow('<b>' . $nice_print . '</b>');
                $block1->closeRow();
            }

            $total_project_hours = 0;
        }

        if ($lastOne || $listHours->tim_organization[$i+1] != $listHours->tim_organization[$i]) {
            $organizationChanged = true;
        } else {
            $organizationChanged = false;
        }

        if ($organizationChanged) {
            // print the organization total
            if ($displayOrgTotals) {
                $block1->openRow();
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("<b>" . lang_strings('ru_total_org') . "</b>");
                $nice_print = NumberFormatNOD($total_org_hours, $hourAccuracy);
                $block1->cellRow('<b>' . $nice_print . '</b>');
                $block1->closeRow();
            }

            $total_org_hours = 0;
        }
    }

    // show a member total
    if ($displayMemPTotals) {
        $block1->openRow();
        $block1->cellRow("<b>" . lang_strings('ru_total_mem') . "</b>");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->closeRow();

        foreach ($grand_total_member_hours as $mem_id => $hrs) {
            $block1->openRow();
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow($grand_total_member_names[$mem_id]);
            $nice_print = NumberFormatNOD($hrs, $hourAccuracy);
            $block1->cellRow('<b>' . $nice_print . '</b>');
            $block1->closeRow();
        }
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

// close block1
$block1->closeFormResults();
require_once("../includes/footer.php");
