<?php // $Revision: 1.32 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editexpense.php,v 1.32 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');        // The unique id of report
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore1 = " WHERE rep.id='$id'";
$reportDetail = new request();
$reportDetail->openReports($querymore1);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail == 0) {
    header('Location: ../reports/listreports.php?msg=blankReport');
    exit;
}

/**
 * Get report parameters
 */
$querymore3 = " WHERE repr.report='$id' AND repr.parameter='" . enumBoolean::bTrue . "' ORDER BY repr.id";
$listParameters = new request();
$listParameters->openReportsCriteria($querymore3);
$comptListParameters = count($listParameters->repr_report);

/**
 * Generate report outputs
 */
if ($action == 'run' || $comptListParameters == 0) {
    /**
     * Get report output and field grouping
     */
    $querymore6 = " WHERE repo.report='$id' ORDER BY repo.disp_order";
    $listReportOutput = new request();
    $listReportOutput->openReportsOutput($querymore6);
    $comptListReportOutput = count($listReportOutput->repo_id);

    /**
     * Fill parameters
     */
    $tmpquery = $reportDetail->rep_userquery[0];

    for ($i=0,$uid=1; $i<$comptListParameters; $i++,$uid++) {
        $fldtyp = (($listParameters->repr_fieldtype[$i]=='')?$listParameters->repr_fdf_fieldtype[$i]:$listParameters->repr_fieldtype[$i]);

        if ($listParameters->repr_ratio[$i] == enumRatio::rEqual) {
            $pn = 'p' . $listParameters->repr_id[$i];
            $p = isset($_POST[$pn])?$_POST[$pn]:'';
            $tmpquery = str_replace("[[$" . $uid . "]]", DbValueEncode($fldtyp, $p), $tmpquery);
        } else {
            $fn = 'f' . $listParameters->repr_id[$i];
            $f = isset($_POST[$fn])?$_POST[$fn]:'';
            $tn = 't' . $listParameters->repr_id[$i];
            $t = isset($_POST[$tn])?$_POST[$tn]:'';
            $tmpquery = str_replace("[[$" . $uid . ".1]]", DbValueEncode($fldtyp, $f), $tmpquery);
            $tmpquery = str_replace("[[$" . $uid . ".2]]", DbValueEncode($fldtyp, $t), $tmpquery);
        }
    }

    $tmpquery = prepareUserQuery($tmpquery);
    $requestOut = new request();
    $requestOut->connectClass();
    $requestOut->query($tmpquery);
    $requestOut->rows = array();

    while ($requestOut->fetch()) {
        $output = array();

        for ($i=0; $i<$comptListReportOutput; $i++) {
            $fldtyp = (($listReportOutput->repo_fieldtype[$i]=='')?$listReportOutput->repo_fdf_fieldtype[$i]:$listReportOutput->repo_fieldtype[$i]);

            if ($fldtyp == enumFieldType::ftPassword) {
                $output[$i] = (($row[$i]=='')?'':'********');
            } else {
                $output[$i] = DbValueDecode($fldtyp, $row[$i], $listReportOutput->repo_field_validvalues[$i]);
            }
        }

        $requestOut->id[] = 0;
        $requestOut->rows[] = $output;
    }

    $requestOut->close();
    $comptRequestOut = count($requestOut->rows);
    $result = true;
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));

if ($result === true) {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../reports/runreport.php?id=$id", $reportDetail->rep_name_print[0], 'in'));
} else {
    $blockPage->itemBreadcrumbs($reportDetail->rep_name_print[0]);
}

$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $reportDetail->rep_name_print[0];
logURL($title, "../reports/runreport.php?id=$id");
$block1 = new block();
$block1->form = "runR";
$block1->openForm("../reports/runreport.php?id=$id#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"run\">";

if ($result === true && $comptRequestOut > 0) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", $strings["export"]);
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $_SESSION['TARGET'] = 'export_report';
    $_SESSION['ID'] = $id;
    $params = array();

    for ($i=0; $i<$comptListParameters; $i++) {
        if ($listParameters->repr_ratio[$i] == enumRatio::rEqual) {
            $pn = 'p' . $listParameters->repr_id[$i];
            $params[$pn] = isset($_POST[$pn])?$_POST[$pn]:'';
        } else {
            $fn = 'f' . $listParameters->repr_id[$i];
            $params[$fn] = isset($_POST[$fn])?$_POST[$fn]:'';
            $tn = 't' . $listParameters->repr_id[$i];
            $params[$tn] = isset($_POST[$tn])?$_POST[$tn]:'';
        }

    }

    $_SESSION['PARAMS'] = $params;
    $block1->paletteScript(0, "export", "../reports/export_report.php", "true,false,false", $strings["export"]);
    $block1->closePaletteScript($comptRequestOut, $requestOut->id);
}

$block1->heading($reportDetail->rep_name_print[0]);

if ($result === true) {
    $block1->openContent();
    $block1->contentTitle(lang_strings("report_results"));

    if ($comptRequestOut == "0") {
        $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
    } else if ($comptRequestOut == "1") {
        $block1->contentRow("", "1 " . lang_strings("match"));
    } else {
        $block1->contentRow("", $comptRequestOut . " " . lang_strings("matches"));
    }

    $block1->closeContent();

    if ($comptRequestOut == 0) {
        $block1->noresults();
    } else {
        $block1->openResults(false);
        $block1->labels($listReportOutput->repo_title, "false");

        for ($i=0; $i<$comptRequestOut; $i++) {
            $block1->openRow();

            foreach ($requestOut->rows[$i] as $val) {
                $block1->cellRow($val);
            }

            $block1->closeRow();
        }

        $block1->closeResults();
    }
} else {
    $block1->openContent();
    $block1->contentTitle(lang_strings("report_param"));

    for ($i=0; $i<$comptListParameters; $i++) {
        if ($listParameters->repr_fieldtype[$i] == '') {
            $fldtyp = $listParameters->repr_fdf_fieldtype[$i];
            $fldlen = $listParameters->repr_fdf_length[$i];
            $fldlt = $listParameters->repr_fdf_linkedtable[$i];
        } else {
            $fldtyp = $listParameters->repr_fieldtype[$i];
            $fldlen = 1024;
            $fldlt = '';
        }

        $label = $listParameters->repr_value[$i];

        if ($fldtyp == enumFieldType::ftText || $fldtyp == enumFieldType::ftAlphaNumeric || $fldtyp == enumFieldType::ftNumeric) {
            $querymore5 = " WHERE fvd.tablename='" . $listParameters->repr_repl_tablename[$i] . "' AND fvd.fieldname='" . $listParameters->repr_fieldname[$i] . "' ORDER BY fvd.fieldvalue";
            $listFieldsValuesDefinitions = new request();
            $listFieldsValuesDefinitions->openFieldsValuesDefinitions($querymore5);
            $comptListFieldsValuesDefinitions = count($listFieldsValuesDefinitions->fvd_tablename);

            if ($comptListFieldsValuesDefinitions == '0') {
                $vv = '';
            } else {
                unset($vv);

                for ($j=0; $j<$comptListFieldsValuesDefinitions; $j++) {
                    $vv[$listFieldsValuesDefinitions->fvd_fieldvalue[$j]] = $listFieldsValuesDefinitions->fvd_fieldvalue_desc[$j];
                }
            }
        } else {
            $vv = '';
        }

        if ($listParameters->repr_ratio[$i] == enumRatio::rEqual) {
            setupInputHTML($block1, $label, 'p' . $listParameters->repr_id[$i], $fldtyp, 'N', $fldlen, '', $vv, $fldlt);
        } else {
            $fromI = setupInputHTML(null, '', 'f' . $listParameters->repr_id[$i], $fldtyp, 'N', $fldlen, '', $vv, $fldlt);
            $toI = setupInputHTML(null, '', 't' . $listParameters->repr_id[$i], $fldtyp, 'N', $fldlen, '', $vv, $fldlt);
            $block1->contentRow($label, lang_strings('from') . ':' . $fromI . ' ' . lang_strings('to') . ':' . $toI, "false", '');
        }
    }

    $block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["create"] . "\">");
    $block1->closeContent();
}

$block1->closeForm();
require_once('../includes/footer.php');
