<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: selectapproval.php,v 1.4 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/selectapproval.php
 *
 * select options for report of pending approval documents
 *
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// load report info
$querymore = " WHERE rep.name='approval_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("approval_report"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['approval_report'];
logURL($title, "../reports/selectapproval.php");
// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/pending_approval.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings('approval_report'));
$block1->openContent();

if ($SW_Permissions['Report']['Edit'][$profilSession]) {
    $block1->contentTitle(lang_strings("report_param"));
    $querymore = " WHERE mem.organization='1' ORDER BY mem.name";
    $listMembers = new request();
    $listMembers->openMembers($querymore);
    $comptListMembers = count($listMembers->mem_id);
    $originators = '<select name="S_ORISEL[]" multiple>';

    for ($i=0; $i<$comptListMembers; $i++) {
        $originators .= '<option value="' . $listMembers->mem_id[$i] . '">' . $listMembers->mem_name[$i] . '</option>';
    }

    $originators .= "</select>";
    $block1->contentRow(lang_strings("originators"), $originators);
    $authorizers = str_replace("S_ORISEL", "S_AUTSEL", $originators);
    $block1->contentRow(lang_strings("authorizers"), $authorizers);
} else {
    echo '<input type="hidden" name="S_ORISEL" value="' . $idSession . '">';
    echo '<input type="hidden" name="S_AUTSEL" value="' . $idSession . '">';
}

// need a submit button
$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["create"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
