<?php // $Revision: 1.15 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: selectfta.php,v 1.15 2009/11/03 14:29:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/selectfta.php
 *
 * TODO:
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (($enableTimesheet != 'true') || ($enableFlextime != 'true')) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

// load report info
$querymore = " WHERE rep.name='flextime_adjustments_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
} else {
    $cat = $reportDetail->rep_category[0];
}

// check if there are users with flextime enabled
$querymore1 = " WHERE mem.organization='1' AND mem.enable_flextime='" . enumBoolean::bTrue . "' ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore1);
$comptListMembers = count($listMembers->mem_id);

if ($comptListMembers == '0') {
    header("Location: ../reports/listreports.php?cat=$cat&msg=noAvailableUsers");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $cat, $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("flextime_adjustments_report"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['flextime_adjustments_report'];
logURL($title, "../reports/selectfta.php");
$block1 = new block();
$block1->form = "sft";
$block1->openForm("../reports/flextime_adjustments.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings('flextime_adjustments_report'));
$block1->openContent();
$block1->contentTitle(lang_strings("report_param"));

if ($SW_Permissions['User']['Write'][$profilSession]) {
    $querymore = " WHERE mem.id='$idSession'";
    $memberDetail = new request();
    $memberDetail->openMembers($querymore);
    $querymore = " WHERE dep.organization='1' AND dep.locked='" . enumBoolean::bFalse . "' ORDER BY dep.name";
    $listDepartments = new request();
    $listDepartments->openDepartments($querymore);
    $comptListDepartments = count($listDepartments->dep_id);

    if ($comptListDepartments > 0) {
        $depSel .= '<select name="S_DEPSEL[]" multiple>';

        for ($i=0; $i<$comptListDepartments; $i++) {
            $depSel .= '<option value="' . $listDepartments->dep_id[$i] . '" ' . (($memberDetail->mem_department[0] == $listDepartments->dep_id[$i])?' selected':'') . '>' . $listDepartments->dep_name_print[$i] . '</option>';
        }

        $depSel .= '</select>';
        $block1->contentRow(lang_strings('departments'), $depSel);
    }

    $memSel = '<select name="S_MEMSEL[]" multiple>';

    for ($i=0; $i<$comptListMembers; $i++) {
        $memSel .= "<option value=\"" . $listMembers->mem_id[$i] . "\">" . $listMembers->mem_name[$i] . "</option>";
    }

    $memSel .= "</select>";
    $block1->contentRow(lang_strings("user"), $memSel);
} else {
    echo '<input type="hidden" name="S_MEMSEL" value="' . $idSession . '">';
}

$y = intval(date('Y'));
$n = intval(date('n'));
$j = intval(date('j'));
// default date range : this month
setupDateRangeInput($block1, lang_strings('logtime'), 'S_DATE', mktime(0,0,0,$n,1,$y), mktime(0,0,0,$n,$j,$y));
$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["create"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
