<?php // $Revision: 1.20 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: selecthours.php,v 1.20 2013/01/18 09:50:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/selecthours.php
 *
 * select options for report of hours logged
 *
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// load report info
$querymore0 = " WHERE rep.name='time_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore0);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("time_report"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['time_report'];
logURL($title, "../reports/selecthours.php");
$block1 = new block();
$block1->form = "selH";
$block1->openForm("../reports/hours.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings('time_report'));
$block1->openContent();
$block1->contentTitle(lang_strings("report_param"));

if (!$SW_Permissions['Client']['Admin'][$profilSession]) {
    $querymore = " WHERE org.id IN (SELECT pro.organization FROM " . $tablePrefix . "teams tea INNER JOIN " . $tablePrefix . "projects pro ON pro.id=tea.project WHERE tea.member='$idSession') AND org.locked='" . enumBoolean::bFalse . "' ORDER BY org.name";
} else {
    $querymore = " WHERE org.locked='" . enumBoolean::bFalse . "' ORDER BY org.name";
}

$listOrganizations = new request();
$listOrganizations->openOrganizations($querymore);
$comptListOrganizations = count($listOrganizations->org_id);
$orgSel = '<select name="S_ORGSEL[]" multiple>';

for ($i=0; $i<$comptListOrganizations; $i++) {
    $orgSel .= "<option value=\"" . $listOrganizations->org_id[$i] . "\">" . $listOrganizations->org_name[$i] . "</option>";
}

$orgSel .= "</select>";
$block1->contentRow(lang_strings('clients'), $orgSel);

if ($projectsFilter == "true" && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    $tmpquery = "SELECT pro.status FROM " . $tablePrefix . "projects pro WHERE pro.id IN (SELECT tea.project FROM " . $tablePrefix . "teams tea WHERE tea.member='$idSession') GROUP BY pro.status";
} else {
    $tmpquery = "SELECT pro.status FROM " . $tablePrefix . "projects pro GROUP BY pro.status";
}

$listProjectStatus = new request();
$listProjectStatus->connectClass();
$listProjectStatus->query($tmpquery);
$listProjectStatus->pro_status = array();

while ($listProjectStatus->fetch()) {
    $listProjectStatus->pro_status[] = ($row[0]);
}

$listProjectStatus->close();

if (count($listProjectStatus->pro_status) > 0) {
    $prjSel = '<select name="S_PRJSEL[]" multiple>';

    foreach ($listProjectStatus->pro_status as $st) {
        if ($projectsFilter == "true" && !$SW_Permissions['Project']['Admin'][$profilSession]) {
            $querymore = " WHERE pro.id IN (SELECT tea.project FROM " . $tablePrefix . "teams tea WHERE tea.member='$idSession') AND pro.status='$st' ORDER BY pro.name";
        } else {
            $querymore = " WHERE pro.status='$st' ORDER BY pro.name";
        }

        $listProjects = new request();
        $listProjects->openProjects($querymore);
        $comptListProjects = count($listProjects->pro_id);
        $prjSel .= '<optgroup label="' . $statusProject[$st] . '">';
        $selected = (($st==enumProjectStatus::stOpen)?'selected':'');

        for ($i=0; $i<$comptListProjects; $i++) {
            $prjSel .= "<option value=\"" . $listProjects->pro_id[$i] . "\" $selected>" . $listProjects->pro_name[$i] . "</option>";
        }

        $prjSel .= '</optgroup>';
    }

    $prjSel .= '</select>';
    $block1->contentRow(lang_strings('projects'), $prjSel);
}

$querymore = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore);
$querymore = " WHERE dep.organization='1' AND dep.locked='" . enumBoolean::bFalse . "' ORDER BY dep.name";
$listDepartments = new request();
$listDepartments->openDepartments($querymore);
$comptListDepartments = count($listDepartments->dep_id);
$depSel = '';

if ($comptListDepartments > 0) {
    $depSel .= '<select name="S_DEPSEL[]" multiple>';

    for ($i=0; $i<$comptListDepartments; $i++) {
        $depSel .= '<option value="' . $listDepartments->dep_id[$i] . '" ' . (($memberDetail->mem_department[0] == $listDepartments->dep_id[$i])?' selected':'') . '>' . $listDepartments->dep_name_print[$i] . '</option>';
    }

    $depSel .= '</select>';
    $block1->contentRow(lang_strings('departments'), $depSel);
}

if ($projectsFilter != 'true' || $SW_Permissions['Project']['Admin'][$profilSession]) {
    $querymore = " WHERE mem.organization='1'";
} else {
    $querymore = " WHERE mem.organization='1'
AND (mem.id='$idSession'
  OR mem.manager='$idSession'
  OR EXISTS (SELECT * FROM " . $tablePrefix . "teams tea
    WHERE tea.member=mem.id
    AND EXISTS(SELECT * FROM " . $tablePrefix . "teams tea1
      LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp
        ON prp.project=tea1.project
        AND prp.profil=tea1.profil
      WHERE tea1.project=tea.project
      AND tea1.member='$idSession'
      AND prp.arrange_task_resource='" . enumBoolean::bTrue . "'
    )
  )
)";
}

$querymore .= " ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore);
$comptListMembers = count($listMembers->mem_id);
$assignTo = '<select name="S_ATSEL[]" multiple>';

for ($i = 0;$i < $comptListMembers;$i++) {
    if ($listMembers->mem_id[$i] == $idSession) {
        $assignTo .= "<option selected value=\"" . $listMembers->mem_id[$i] . "\">" . $listMembers->mem_name[$i] . "</option>";
    } else {
        $assignTo .= "<option value=\"" . $listMembers->mem_id[$i] . "\">" . $listMembers->mem_name[$i] . "</option>";
    }
}

$assignTo .= "</select>";
$block1->contentRow(lang_strings("loggedby"), $assignTo);
$y = intval(date('Y'));
$n = intval(date('n'));
$j = intval(date('j'));
// default date range : this month
setupDateRangeInput($block1, lang_strings('logtime'), 'S_DATE', mktime(0,0,0,$n,1,$y), mktime(0,0,0,$n+1,0,$y), false, 'forwards');
$billSel = "<select name=\"S_BILLING\" size=\"3\"><option selected value=\"ALL\">" . lang_strings("select_all") . "</option>";

foreach ($billingFlag as $bfKey => $bfVal) {
    $billSel .= "<option value=\"$bfKey\">$bfVal</option>";
}

$billSel .= "</select>";
$block1->contentRow(lang_strings("billing"), $billSel);
$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["create"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
