<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: selectis.php,v 1.5 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/selectis.php
 *
 * select options for report of issue tracking summary
 *
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// load report info
$querymore = " WHERE rep.name='issue_tracking_summary'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("issue_tracking_summary"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['issue_tracking_summary'];
logURL($title, "../reports/selectis.php");
// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/issuetracking_summary.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings('issue_tracking_summary'));
$block1->openContent();
$block1->contentTitle(lang_strings("report_param"));
$tmpquery = " WHERE org.locked='" . enumBoolean::bFalse . "' ORDER BY org.name";
$listOrganizations = new request();
$listOrganizations->openOrganizations($tmpquery);
$comptListOrganizations = count($listOrganizations->org_id);
$clientSel = '<select name="S_ORGSEL[]" multiple>';

for ($i=0; $i<$comptListOrganizations; $i++) {
    $clientSel .= '<option value="' . $listOrganizations->org_id[$i] . '">' . $listOrganizations->org_name[$i] . '</option>';
}

$clientSel .= '</select>';
$block1->contentRow(lang_strings("organizations"), $clientSel);

if ($projectsFilter == "true" && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    $tmpquery = "SELECT pro.status FROM " . $tablePrefix . "projects pro WHERE pro.id IN (SELECT tea.project FROM " . $tablePrefix . "teams tea WHERE tea.member='$idSession') GROUP BY pro.status";
} else {
    $tmpquery = "SELECT pro.status FROM " . $tablePrefix . "projects pro GROUP BY pro.status";
}

$listProjectStatus = new request();
$listProjectStatus->connectClass();
$listProjectStatus->query($tmpquery);
$listProjectStatus->pro_status = array();

while ($listProjectStatus->fetch()) {
    $listProjectStatus->pro_status[] = ($row[0]);
}

$listProjectStatus->close();

if (count($listProjectStatus->pro_status) > 0) {
    $prjSel = '<select name="S_PRJSEL[]" multiple>';

    foreach ($listProjectStatus->pro_status as $st) {
        if ($projectsFilter == "true" && !$SW_Permissions['Project']['Admin'][$profilSession]) {
            $querymore = " WHERE pro.id IN (SELECT tea.project FROM " . $tablePrefix . "teams tea WHERE tea.member='$idSession') AND pro.status='$st' ORDER BY pro.name";
        } else {
            $querymore = " WHERE pro.status='$st' ORDER BY pro.name";
        }

        $listProjects = new request();
        $listProjects->openProjects($querymore);
        $comptListProjects = count($listProjects->pro_id);
        $prjSel .= '<optgroup label="' . $statusProject[$st] . '">';
        $selected = (($st==enumProjectStatus::stOpen)?'selected':'');

        for ($i=0; $i<$comptListProjects; $i++) {
            $prjSel .= "<option value=\"" . $listProjects->pro_id[$i] . "\" $selected>" . $listProjects->pro_name[$i] . "</option>";
        }

        $prjSel .= '</optgroup>';
    }

    $prjSel .= '</select>';
    $block1->contentRow(lang_strings('projects'), $prjSel);
}

$y = intval(date('Y'));
$n = intval(date('n'));
$j = intval(date('j'));
// default date range : this month
setupDateRangeInput($block1, lang_strings('created_date'), 'S_DATE', mktime(0,0,0,$n,1,$y), mktime(0,0,0,$n,$j,$y));
$dispOptions = "<table border=\"0\" cellpadding=\"2\" cellspacing=\"0\">
<tr><td width=\"16\" align=\"center\" class=\"infovalue\"><input checked name=\"S_BYCLIENT\" type=\"checkbox\" value=\"TRUE\"></td><td>" . lang_strings('by_organization') . "</td></tr>
<tr><td width=\"16\" align=\"center\" class=\"infovalue\"><input checked name=\"S_BYPROJECT\" type=\"checkbox\" value=\"TRUE\"></td><td>" . lang_strings('by_project') . "</td></tr>
<tr><td width=\"16\" align=\"center\" class=\"infovalue\"><input checked name=\"S_BYSEVERITY\" type=\"checkbox\" value=\"TRUE\"></td><td>" . lang_strings('by_severity') . "</td></tr>
<tr><td width=\"16\" align=\"center\" class=\"infovalue\"><input checked name=\"S_BYRESOLUTION\" type=\"checkbox\" value=\"TRUE\"></td><td>" . lang_strings('by_resolution') . "</td></tr>
<tr><td width=\"16\" align=\"center\" class=\"infovalue\"><input checked name=\"S_BYPRIORITY\" type=\"checkbox\" value=\"TRUE\"></td><td>" . lang_strings('by_priority') . "</td></tr>
<tr><td width=\"16\" align=\"center\" class=\"infovalue\"><input checked name=\"S_REPORTERSTATE\" type=\"checkbox\" value=\"TRUE\"></td><td>" . lang_strings('reporter_state') . "</td></tr>
<tr><td width=\"16\" align=\"center\" class=\"infovalue\"><input checked name=\"S_HANDLERSTATE\" type=\"checkbox\" value=\"TRUE\"></td><td>" . lang_strings('handler_state') . "</td></tr>
<tr><td width=\"16\" align=\"center\" class=\"infovalue\"><input checked name=\"S_REPORTERBYRESOLUTION\" type=\"checkbox\" value=\"TRUE\"></td><td>" . lang_strings('reporter_by_resolution') . "</td></tr>
<tr><td width=\"16\" align=\"center\" class=\"infovalue\"><input checked name=\"S_HANDLERBYRESOLUTION\" type=\"checkbox\" value=\"TRUE\"></td><td>" . lang_strings('handler_by_resolution') . "</td></tr>";
$dispOptions .= "</table>";
$block1->contentRow(lang_strings("display_options"), $dispOptions);
// need a submit button
$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["create"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
