<?php // $Revision: 1.17 $
/* vim: set expandtab ts=4 sw=4 sts=4: */
/**
 * $Id: selectleaves.php,v 1.17 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/selectleaves.php
 *
 * select options for report of leaves logged
 *
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($enableTimesheet != 'true') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

// load report info
$querymore = " WHERE rep.name='leave_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("leave_report"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['leave_report'];
logURL($title, "../reports/selectleaves.php");

function subordinates($managers) {
    $tmpquery = " WHERE mem.manager IN ($managers)";
    $listMembers = new request();
    $listMembers->openMembers($tmpquery);
    $comptListMembers = count($listMembers->mem_id);

    if ($comptListMembers != '0') {
        $rc = implode(',', $listMembers->mem_id);

        if ($rc != '') {
            $rc1 = subordinates($rc);

            if ($rc1 != '') {
                $rc .= ",$rc1";
            }
        }
    } else {
        $rc = '';
    }

    return $rc;
}

// start the first block
$block1 = new block();
$block1->form = "xwpP";
$block1->openForm("../reports/leaves.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings('leave_report'));
$block1->openContent();
$block1->contentTitle(lang_strings("report_param"));
$tmpquery = "SELECT id FROM " . $tablePrefix . "projects WHERE owner='$idSession'";
$tmpquery .= " UNION ALL ";
$tmpquery .= "SELECT id FROM " . $tablePrefix . "members WHERE manager='$idSession'";
$compt1 = compt($tmpquery);
$depSel = '';

if ($SW_Permissions['Leave']['Read'][$profilSession] || ($compt1 > 0)) {
    $querymore = " WHERE mem.id='$idSession'";
    $memberDetail = new request();
    $memberDetail->openMembers($querymore);
    $querymore = " WHERE dep.organization='1' AND dep.locked='" . enumBoolean::bFalse . "' ORDER BY dep.name";
    $listDepartments = new request();
    $listDepartments->openDepartments($querymore);
    $comptListDepartments = count($listDepartments->dep_id);

    if ($comptListDepartments > '0') {
        $depSel .= '<select name="S_DEPSEL[]" multiple>';

        for ($i=0; $i<$comptListDepartments; $i++) {
            $depSel .= '<option value="' . $listDepartments->dep_id[$i] . '" ' . (($memberDetail->mem_department[0] == $listDepartments->dep_id[$i])?' selected':'') . '>' . $listDepartments->dep_name_print[$i] . '</option>';
        }

        $depSel .= '</select>';
        $block1->contentRow(lang_strings('departments'), $depSel);
    }

    if ($SW_Permissions['Leave']['Read'][$profilSession]) {
        $tmpquery = " WHERE mem.organization='1'";
    } else {
        $tmpquery = " WHERE mem.organization='1' AND (EXISTS (SELECT * FROM " . $tablePrefix . "teams tea INNER JOIN " . $tablePrefix . "projects prj ON prj.id=tea.project AND prj.owner='$idSession' WHERE tea.member=mem.id) OR (mem.id IN ($idSession";
        $subordinatesSet = subordinates($idSession);

        if ($subordinatesSet != '') {
            $tmpquery .= ",$subordinatesSet";
        }

        $tmpquery .= ")))";
    }

    $tmpquery .= " ORDER BY mem.name";
    $listMembers = new request();
    $listMembers->openMembers($tmpquery);
    $comptListMembers = count($listMembers->mem_id);
    $teamSel = '<select name="S_ATSEL[]" multiple>';

    for ($i = 0;$i < $comptListMembers;$i++) {
        if ($listMembers->mem_id[$i] == $idSession) {
            $teamSel .= "<option selected value=\"" . $listMembers->mem_id[$i] . "\">" . $listMembers->mem_name[$i] . "</option>";
        } else {
            $teamSel .= "<option value=\"" . $listMembers->mem_id[$i] . "\">" . $listMembers->mem_name[$i] . "</option>";
        }
    }

    $teamSel .= '</select>';
    $block1->contentRow(lang_strings("users"), $teamSel);
} else {
    echo "<input type=\"hidden\" name=\"S_ATSEL\" value=\"" . $_SESSION['idSession'] . "\">";
}

$y = intval(date('Y'));
$n = intval(date('n'));
$n1 = floor(($n-1)/3)*3+1;
// default date range : this season
setupDateRangeInput($block1, lang_strings('date_restrictions'), 'S_DATE', mktime(0,0,0,$n1,1,$y), mktime(0,0,0,$n1+3,0,$y), false, 'forwards');
$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["create"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
