<?php  // $Revision: 1.10 $
/* vim: set expandtab ts=4 sw=4 sts=4: */
/**
 * Author:     Graham Sutcliffe (redesign by Luis Wang)
 * Date:       9/28/2005
 * File:       /reports/selectma.php
 *
 * Resource allocation within a date range by Employee.  Keep date range within
 * 4 weeks for decient looking report.
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
$checkSession = true;
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// load report info
$querymore = " WHERE rep.name='member_allocation'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("member_allocation"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['member_allocation'];
logURL($title, "../reports/selectma.php");
// start the first block
$block1 = new block();
$block1->form = "smaT";
$block1->openForm("../reports/member_allocation.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings('member_allocation'));
$block1->openContent();
$block1->contentTitle(lang_strings("report_param"));
// Team members selection
if ($projectsFilter != 'true' || $SW_Permissions['Project']['Admin'][$profilSession]) {
    $querymore = " WHERE mem.organization='1' AND mem.active='" . enumBoolean::bTrue . "'";
} else {
    $querymore = " WHERE mem.organization='1' AND mem.active='" . enumBoolean::bTrue . "'
AND (mem.id='$idSession'
  OR mem.manager='$idSession'
  OR EXISTS (SELECT * FROM " . $tablePrefix . "teams tea
    WHERE tea.member=mem.id
    AND EXISTS(SELECT * FROM " . $tablePrefix . "teams tea1
      LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp
        ON prp.project=tea1.project
        AND prp.profil=tea1.profil
      WHERE tea1.project=tea.project
      AND tea1.member='$idSession'
      AND prp.arrange_task_resource='" . enumBoolean::bTrue . "'
    )
  )
)";
}

$querymore .= " ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore);
$comptListMembers = count($listMembers->mem_id);
$teamSel = '<select name="S_ATSEL[]" multiple>';

for ($i=0; $i<$comptListMembers; $i++) {
    $teamSel .= '<option value="' . $listMembers->mem_id[$i] . '"';

    if ($listMembers->mem_id[$i] == $idSession) {
        $teamSel .= ' selected';
    }

    $teamSel .= '>' . $listMembers->mem_name[$i] . '</option>';
}

$teamSel .= "</select>";
$block1->contentRow(lang_strings("team_members"), $teamSel);
$y = intval(date('Y'));
$n = intval(date('n'));
$j = intval(date('j'));
// default date range : this next 4 weeks
setupDateRangeInput($block1, lang_strings('date_restrictions'), 'S_DATE', mktime(0,0,0,$n,$j+1,$y), mktime(0,0,0,$n,$j+28,$y), true, 'forwards');
$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["create"] . "\">");
$block1->closeContent();
$block1->closeForm();
$block1->note("*&nbsp;" . lang_strings('required'));
require_once("../includes/footer.php");
