<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: selectpc.php,v 1.3 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/selectpc.php
 *
 * select options for report of project cost
 *
 * TODO:
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// load report info
$querymore = " WHERE rep.name='project_cost'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("project_cost"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['project_cost'];
logURL($title, "../reports/selectpc.php");
$block1 = new block();
$block1->form = "selC";
$block1->openForm("../reports/projectcost.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings('project_cost'));
$block1->openContent();
$block1->contentTitle(lang_strings("report_param"));

if (!$SW_Permissions['Client']['Admin'][$profilSession]) {
    $tmpquery = " WHERE org.id IN (SELECT pro.organization FROM " . $tablePrefix . "teams tea INNER JOIN " . $tablePrefix . "projects pro ON pro.id=tea.project WHERE tea.member=$idSession) AND org.locked='" . enumBoolean::bFalse . "' ORDER BY org.name";
} else {
    $tmpquery = " WHERE org.locked='" . enumBoolean::bFalse . "' ORDER BY org.name";
}

$listOrganizations = new request();
$listOrganizations->openOrganizations($tmpquery);
$comptListOrganizations = count($listOrganizations->org_id);
$orgSel = '<select name="S_ORGSEL[]" multiple>';

for ($i=0; $i<$comptListOrganizations; $i++) {
    $orgSel .= "<option value=\"" . $listOrganizations->org_id[$i] . "\">" . $listOrganizations->org_name[$i] . "</option>";
}

$orgSel .= "</select>";
$block1->contentRow(lang_strings('clients'), $orgSel);

if ($projectsFilter == "true" && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    $tmpquery = "SELECT pro.status FROM " . $tablePrefix . "projects pro WHERE pro.id IN (SELECT tea.project FROM " . $tablePrefix . "teams tea WHERE tea.member='$idSession') GROUP BY pro.status";
} else {
    $tmpquery = "SELECT pro.status FROM " . $tablePrefix . "projects pro GROUP BY pro.status";
}

$listProjectStatus = new request();
$listProjectStatus->connectClass();
$listProjectStatus->query($tmpquery);
$listProjectStatus->pro_status = array();

while ($listProjectStatus->fetch()) {
    $listProjectStatus->pro_status[] = ($row[0]);
}

$listProjectStatus->close();

if (count($listProjectStatus->pro_status) > 0) {
    $prjSel = '<select name="S_PRJSEL[]" multiple>';

    foreach ($listProjectStatus->pro_status as $st) {
        if ($projectsFilter == "true" && !$SW_Permissions['Project']['Admin'][$profilSession]) {
            $querymore = " WHERE pro.id IN (SELECT tea.project FROM " . $tablePrefix . "teams tea WHERE tea.member='$idSession') AND pro.status='$st' ORDER BY pro.name";
        } else {
            $querymore = " WHERE pro.status='$st' ORDER BY pro.name";
        }

        $listProjects = new request();
        $listProjects->openProjects($querymore);
        $comptListProjects = count($listProjects->pro_id);
        $prjSel .= '<optgroup label="' . $statusProject[$st] . '">';
        $selected = (($st==enumProjectStatus::stOpen)?'selected':'');

        for ($i=0; $i<$comptListProjects; $i++) {
            $prjSel .= "<option value=\"" . $listProjects->pro_id[$i] . "\" $selected>" . $listProjects->pro_name[$i] . "</option>";
        }

        $prjSel .= '</optgroup>';
    }

    $prjSel .= '</select>';
    $block1->contentRow(lang_strings('projects'), $prjSel);
}

$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["create"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
