<?php // $Revision: 1.20 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: selecttimeclock.php,v 1.20 2013/01/18 09:50:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/selecttimeclock.php
 *
 * select options for report of timeclock activities
 *
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// load report info
$querymore0 = " WHERE rep.name='timeclock_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore0);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("timeclock_report"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['timeclock_report'];
logURL($title, "../reports/selecttimeclock.php");
$block1 = new block();
$block1->form = "selT";
$block1->openForm("../reports/timeclock.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings('timeclock_report'));
$block1->openContent();
$block1->contentTitle(lang_strings("report_param"));
$querymore = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore);
$querymore = " WHERE dep.organization='1' AND dep.locked='" . enumBoolean::bFalse . "' ORDER BY dep.name";
$listDepartments = new request();
$listDepartments->openDepartments($querymore);
$comptListDepartments = count($listDepartments->dep_id);
$depSel = '';

if ($comptListDepartments > 0) {
    $depSel .= '<select name="S_DEPSEL[]" multiple>';

    for ($i=0; $i<$comptListDepartments; $i++) {
        $depSel .= '<option value="' . $listDepartments->dep_id[$i] . '" ' . (($memberDetail->mem_department[0] == $listDepartments->dep_id[$i])?' selected':'') . '>' . $listDepartments->dep_name_print[$i] . '</option>';
    }

    $depSel .= '</select>';
    $block1->contentRow(lang_strings('departments'), $depSel);
}

if ($projectsFilter != 'true' || $SW_Permissions['Project']['Admin'][$profilSession]) {
    $querymore = " WHERE mem.organization='1'";
} else {
    $querymore = " WHERE mem.organization='1'
AND (mem.id='$idSession'
  OR mem.manager='$idSession'
  OR EXISTS (SELECT * FROM " . $tablePrefix . "teams tea
    WHERE tea.member=mem.id
    AND EXISTS(SELECT * FROM " . $tablePrefix . "teams tea1
      LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp
        ON prp.project=tea1.project
        AND prp.profil=tea1.profil
      WHERE tea1.project=tea.project
      AND tea1.member='$idSession'
      AND prp.arrange_task_resource='" . enumBoolean::bTrue . "'
    )
  )
)";
}

$querymore .= " ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore);
$comptListMembers = count($listMembers->mem_id);
$assignTo = '<select name="S_ATSEL[]" multiple>';

for ($i = 0;$i < $comptListMembers;$i++) {
    if ($listMembers->mem_id[$i] == $idSession) {
        $assignTo .= "<option selected value=\"" . $listMembers->mem_id[$i] . "\">" . $listMembers->mem_name[$i] . "</option>";
    } else {
        $assignTo .= "<option value=\"" . $listMembers->mem_id[$i] . "\">" . $listMembers->mem_name[$i] . "</option>";
    }
}

$assignTo .= "</select>";
$block1->contentRow(lang_strings("loggedby"), $assignTo);
$y = intval(date('Y'));
$n = intval(date('n'));
$j = intval(date('j'));
// default date range : this month
setupDateRangeInput($block1, lang_strings('logtime'), 'S_DATE', mktime(0,0,0,$n,1,$y), mktime(0,0,0,$n,$j,$y));
$billSel = "<select name=\"S_BILLING\" size=\"3\"><option selected value=\"ALL\">" . lang_strings("select_all") . "</option>";

foreach ($billingFlag as $bfKey => $bfVal) {
    $billSel .= "<option value=\"$bfKey\">$bfVal</option>";
}

$billSel .= "</select>";
$block1->contentRow(lang_strings("billing"), $billSel);
$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["create"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
