<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: selecttimesheet.php,v 1.4 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/selecttimesheet.php
 *
 * select options for report of timesheet status
 *
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if ($enableTimesheet != 'true') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

// load report info
$querymore = " WHERE rep.name='timesheet_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("timesheet_report"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['timesheet_report'];
logURL($title, "../reports/selecttimesheet.php");
$block1 = new block();
$block1->form = "selTS";
$block1->openForm("../reports/timesheet.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings('timesheet_report'));
$block1->openContent();
$block1->contentTitle(lang_strings("report_param"));

if ($periodUnit == 'month') {
    $defaultVal = date('Yn');
    $helpStr = $strings["month_format_help"];
} else {
    $defaultVal = date('YW');
    $helpStr = $strings["week_format_help"];
}

$block1->contentRow('* ' . lang_strings("period") . $block1->printHelp($helpStr, true), '<input type="text" name="S_PERIOD1" value="' . $defaultVal . '" maxlength="6" accept="period"> - <input type="text" name="S_PERIOD2" value="' . $defaultVal . '" maxlength="6" accept="period">');
$__default_requireda[] = 'S_PERIOD1';
$__default_reqtypea[] = enumFieldType::ftNumeric;
$__default_requireda[] = 'S_PERIOD1';
$__default_reqtypea[] = enumFieldType::ftNumeric;
$querymore1 = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore1);
$querymore2 = " WHERE dep.organization='1' AND dep.locked='" . enumBoolean::bFalse . "' ORDER BY dep.name";
$listDepartments = new request();
$listDepartments->openDepartments($querymore2);
$comptListDepartments = count($listDepartments->dep_id);
$depSel = '';

if ($comptListDepartments > 0) {
    $depSel .= '<select name="S_DEPSEL[]" multiple>';

    for ($i=0; $i<$comptListDepartments; $i++) {
        $depSel .= '<option value="' . $listDepartments->dep_id[$i] . '" ' . (($memberDetail->mem_department[0] == $listDepartments->dep_id[$i])?' selected':'') . '>' . $listDepartments->dep_name_print[$i] . '</option>';
    }

    $depSel .= '</select>';
    $block1->contentRow(lang_strings('departments'), $depSel);
}

// Team members selection
if ($projectsFilter != 'true' || $SW_Permissions['Project']['Admin'][$profilSession]) {
    $querymore = " WHERE mem.organization='1' AND mem.active='" . enumBoolean::bTrue . "'";
} else {
    $querymore = " WHERE mem.organization='1' AND mem.active='" . enumBoolean::bTrue . "'
AND (mem.id='$idSession'
  OR mem.manager='$idSession'
  OR EXISTS (SELECT * FROM " . $tablePrefix . "teams tea
    WHERE tea.member=mem.id
    AND EXISTS(SELECT * FROM " . $tablePrefix . "teams tea1
      LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp
        ON prp.project=tea1.project
        AND prp.profil=tea1.profil
      WHERE tea1.project=tea.project
      AND tea1.member='$idSession'
      AND prp.arrange_task_resource='" . enumBoolean::bTrue . "'
    )
  )
)";
}

$querymore .= " ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore);
$comptListMembers = count($listMembers->mem_id);
$teamSel = '<select name="S_ATSEL[]" multiple>';

for ($i=0; $i<$comptListMembers; $i++) {
    $teamSel .= '<option value="' . $listMembers->mem_id[$i] . '"';

    if ($listMembers->mem_id[$i] == $idSession) {
        $teamSel .= ' selected';
    }

    $teamSel .= '>' . $listMembers->mem_name[$i] . '</option>';
}

$teamSel .= "</select>";
$block1->contentRow(lang_strings("team_members"), $teamSel);
$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["create"] . "\">");
$block1->closeContent();
$block1->closeForm();
$block1->note("* " . lang_strings('required'));
require_once("../includes/footer.php");
