<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * Author: Michael Cook <michael@ink.org>
 * Date:   07-14-2003
 *
 * $Id: snapshot.php,v 1.13 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/snapshot.php
 *
 * show a basic overview of all projects for a project manager
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

// load report info
$querymore = " WHERE rep.name='project_snapshot'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("project_snapshot"));
$blockPage->closeBreadcrumbs();
$title = $strings['report'] . ' : ' . $strings['project_snapshot'];
logURL($title, "../reports/snapshot.php");

if ($projectsFilter != 'true' || $SW_Permissions['Project']['Admin'][$profilSession]) {
    $querymore = " WHERE pro.status IN ('" . enumProjectStatus::stInitiation . "','" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "') ORDER BY pro.name";
} else {
    $querymore = " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=pro.id LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member='$idSession' AND prp.view_project='" . enumBoolean::bTrue . "' AND pro.status IN ('" . enumProjectStatus::stInitiation . "','" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "') ORDER BY pro.name";
}

$listProjects = new request();
$listProjects->openProjects($querymore);
$comptListProjects = count($listProjects->pro_id);
// show the nice number-of-results header
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListProjects == "0") {
    $blockPage->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListProjects == "1") {
    $blockPage->contentRow("", "1 " . lang_strings("match"));
} else {
    $blockPage->contentRow("", $comptListProjects . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListProjects != "0") {
    for ($j=0; $j<$comptListProjects; $j++) {
        $projectTitle = $listProjects->pro_name[$j];
        $projectId = $listProjects->pro_id[$j];
        $projectPriority = $listProjects->pro_priority[$j];
        $blockProject = new block();
        $blockProject->openContent();
        $blockProject->heading($blockPage->buildLink("../projects/viewproject.php?id=" . $projectId, $projectTitle, 'in'));
        $blockProject->contentTitle(lang_strings("details"));
        $blockProject->contentRow(lang_strings("priority"), $priority[$projectPriority]);
        $blockProject->contentRow(lang_strings("created"), createDate($listProjects->pro_created[$j], 'both'));
        $blockProject->contentRow(lang_strings("modified"), createDate($listProjects->pro_modified[$j], 'both'));

        if ($listProjects->pro_org_id[$j] != "1") {
            $blockProject->contentRow(lang_strings("organization"), $blockPage->buildLink("../clients/viewclient.php?id=" . $listProjects->pro_org_id[$j], $listProjects->pro_org_name[$j], 'in'));
        }

        $blockProject->contentRow(lang_strings("status"), $statusProject[$listProjects->pro_status[$j]]);
        $blockProject->closeContent();
        $querymore = " LEFT OUTER JOIN " . $tablePrefix . "teams tea ON tea.project=tas.project AND tea.member='$idSession' LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tas.project AND prp.profil=tea.profil WHERE tas.project='$projectId' AND prp.view_task='" . enumBoolean::bTrue . "' ORDER BY tas.due_date";
        $listTasks = new request();
        $listTasks->openTasks($querymore);
        $comptListTasks = count($listTasks->tas_id);

        if ($comptListTasks > 0) {
            $labels = array(lang_strings("task"), lang_strings("priority"), lang_strings("status"), lang_strings("due_date"), lang_strings("completed"), lang_strings("assigned_to"), lang_strings("published"));
            $blockProject->openResults(false);
            $blockProject->labels($labels, "true");

            for ($i=0; $i<$comptListTasks; $i++) {
                $idStatus = $listTasks->tas_status[$i];
                $idPriority = $listTasks->tas_priority[$i];
                $idPublished = $listTasks->tas_published[$i];
                $complValue = ($listTasks->tas_completion[$i] > 0) ? $listTasks->tas_completion[$i] . "0 %": $listTasks->tas_completion[$i] . " %";
                $blockProject->openRow();
                $blockProject->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], 'in'));
                $blockProject->cellRow($priority[$idPriority]);
                $blockProject->cellRow($status[$idStatus]);
                $blockProject->cellRow(($listTasks->tas_due_date[$i] == "0")?lang_strings("none"):createDate($listTasks->tas_due_date[$i],'date',false,true));

                if ($complValue != "100 %") {
                    $blockProject->cellRow($complValue);
                } else {
                    $blockProject->cellRow(createDate($listTasks->tas_complete_date[$i],'date',false,true));
                }

                if ($listTasks->tas_assigned_to[$i] == "0") {
                    $blockProject->cellRow(lang_strings("unassigned"));
                } else {
                    $querymore = " AND res.task='" . $listTasks->tas_id[$i] . "'";
                    $resourceUsage = new request();
                    $resourceUsage->openTaskHumanResource($querymore);
                    $comptResourceUsage = count($resourceUsage->res_id);
                    $assignedToStrings = "";

                    for ($k=0; $k<$comptResourceUsage; $k++) {
                        if ($k > 0) {
                            $assignedToStrings .= "&nbsp;";
                        }

                        $assignedToStrings .= $blockPage->buildLink($resourceUsage->res_resource[$k], '', 'message');
                    }

                    $blockProject->cellRow($assignedToStrings);
                }

                $blockProject->cellRow($statusPublish[$idPublished]);
                $blockProject->closeRow();
            }

            $blockProject->closeResults();
        }

        echo '<br>';
    }
}

require_once("../includes/footer.php");
