<?php // $Revision: 1.28 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: timeclock.php,v 1.28 2013/01/18 09:50:29 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/timeclock.php
 *
 * show timeclock activities
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

/**
 * Variables init
 */
// set up the department selection
$S_dep = (isset($_POST['S_DEPSEL'])?$_POST['S_DEPSEL']:'');

if ($S_dep !== '' && !is_array($S_dep)) {
    $S_dep = explode("**", $S_dep);
}

// set up the member selection
$S_mem = (isset($_POST['S_ATSEL'])?$_POST['S_ATSEL']:'');

if ($S_mem !== '' && !is_array($S_mem)) {
    $S_mem = explode("**", $S_mem);
}

// a date range was selected
$S_date1 = (isset($_POST['S_DATE1'])?$_POST['S_DATE1']:'');
$S_date2 = (isset($_POST['S_DATE2'])?$_POST['S_DATE2']:'');
// billing selection
$billingSelection = $_POST['S_BILLING'];
// load report info
$querymore = " WHERE rep.name='timeclock_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selecttimeclock.php', lang_strings("timeclock_report"), 'in'));
$blockPage->closeBreadcrumbs();
// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/timeclock.php#" . $block1->form . "Anchor");
echo '<input type="hidden" name="S_DEPSEL" value="' . ((is_array($S_dep))?implode("**", $S_dep):$S_dep) . '">';
echo '<input type="hidden" name="S_ATSEL" value="' . ((is_array($S_mem))?implode("**", $S_mem):$S_mem) . '">';
echo '<input type="hidden" name="S_DATE1" value="' . $S_date1 . '">';
echo '<input type="hidden" name="S_DATE2" value="' . $S_date2 . '">';
echo '<input type="hidden" name="S_BILLING" value="' . $billingSelection . '">';
$block1->openContent();
$querymore = " WHERE tck.finish='" . enumBoolean::bTrue . "'";
// a date range was selected
if ($S_date1 !== '') {
    $ts1 = date2Timestamp($S_date1);
    $querymore .= " AND tck.clockout>='" . mktime(0, 0, 0, date('n', $ts1), date('j', $ts1), date('Y', $ts1)) . "'";
}

if ($S_date2 !== '') {
    $ts2 = date2Timestamp($S_date2);
    $querymore .= " AND tck.clockout<'" . mktime(0, 0, 0, date('n', $ts2), intval(date('j', $ts2))+1, date('Y', $ts2)) . "'";
}
// a department selection was made
if ($S_dep == '') {
    $querymore .= " AND mem.department='0'";
} else {
    $querymore .= " AND mem.department" . ((is_array($S_org))?" IN ('" . implode("','", $S_org) . "')":"='$S_org'");
}
// a member selection was made
if ($S_mem == '0') {
    $querymore .= " AND tck.owner='0'";
} else {
    $querymore .= " AND tck.owner" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}
// billing selection
if ($billingSelection != 'ALL') {
    $querymore .= " AND tck.billing='$billingSelection'";
}

$querymore .= " ORDER BY tck.clockout DESC";
$listTimeClock = new request();
$listTimeClock->openTimeClock($querymore);
$comptListTimeClock = count($listTimeClock->tck_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListTimeClock == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListTimeClock == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListTimeClock . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListTimeClock > 0) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", $strings["export"]);
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $_SESSION['TARGET'] = 'exporttimeclock';
    $params = array();
    // handle date ranges
    $params['S_DATE1'] = $S_date1;
    $params['S_DATE2'] = $S_date2;
    // department selection
    $params['S_DEPSEL'] = $S_dep;
    // member selection
    $params['S_ATSEL'] = $S_mem;
    // billing selection
    $params['S_BILLING'] = $billingSelection;
    $_SESSION['PARAMS'] = $params;
    $block1->paletteScript(0, "export", "../reports/exporttimeclock.php", "true,false,false", $strings["export"]);
    $block1->closePaletteScript($comptListTimeClock, $listTimeClock->tck_id);
}

// set up the header string
$block1HeadingText = lang_strings("timeclock_activities") . " ";
$block1->heading($block1HeadingText);

if ($comptListTimeClock > 0) {
    $labels = array(lang_strings("owner"), lang_strings("clockin"), lang_strings('clockout'), lang_strings("project"), lang_strings("type"), lang_strings("description"), lang_strings("hours"), lang_strings("billing"));
    $block1->openResults(false);
    $block1->labels($labels, "false");

    for ($i=0; $i<$comptListTimeClock; $i++) {
        $block1->openRow();
        $block1->cellRow($blockPage->buildLink($listTimeClock->tck_owner[$i], '', 'message'));
        $block1->cellRow(createDate($listTimeClock->tck_clockin[$i], 'both'));
        $block1->cellRow(createDate($listTimeClock->tck_clockout[$i], 'both'));

        if ($listTimeClock->tck_project[$i] == '0') {
            $block1->cellRow('');
        } else {
            $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTimeClock->tck_project[$i], $listTimeClock->tck_pro_name[$i], 'in'));
        }

        if ($listTimeClock->tck_task[$i] != '0') {
            $block1->cellRow($strings['task']);
            $block1->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTimeClock->tck_task[$i], $listTimeClock->tck_tas_name[$i], 'in'));
        } else if ($listTimeClock->tck_meeting[$i] != '0') {
            $block1->cellRow($strings['meeting']);
            $block1->cellRow($blockPage->buildLink("../meetings/viewmeeting.php?id=" . $listTimeClock->tck_meeting[$i], $listTimeClock->tck_mee_name[$i], 'in'));
        } else {
            $block1->cellRow($strings['others']);
            $block1->cellRow($listTimeClock->tck_hrt_name_print[$i] . ' - ' . $listTimeClock->tck_hrc_name_print[$i]);
        }

        $nice_print = NumberFormatNOD($listTimeClock->tck_hours[$i], $hourAccuracy);
        $block1->cellRow($nice_print);
        $block1->cellRow($billingFlag[$listTimeClock->tck_billing[$i]]);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

// close block1
$block1->closeFormResults();
require_once("../includes/footer.php");
