<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: timesheet.php,v 1.9 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ../reports/timesheet.php
 *
 * Show timesheet status for all employees
 *
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Permission check
 */
if (!$SW_Permissions['Report']['Read'][$profilSession]) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

if (!$SW_Permissions['User']['Write'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
// set up the period selection
$A_periods = array();
$S_period1 = ($js_enabled == 'Y' && isset($_POST['S_PERIOD1']))?$_POST['S_PERIOD1']:'';
$S_period2 = ($js_enabled == 'Y' && isset($_POST['S_PERIOD2']))?$_POST['S_PERIOD2']:'';

if (strlen($S_period1)==6 && strlen($S_period2)==6 && $S_period1<=$S_period2) {
    if ($periodUnit == 'month') {
        while ($S_period1 <= $S_period2) {
            $A_periods[] = $S_period1;
            $fyear = intval(substr($S_period1, 0, 4));
            $serial_no = intval(substr($S_period1, 4, 2));

            if ($serial_no == 12) {
                $fyear += 1;
                $serial_no = 1;
            } else {
                $serial_no += 1;
            }

            $S_period1 = sprintf("%04d%02d", $fyear, $serial_no);
        }
    } else {
        while ($S_period1 <= $S_period2) {
            $A_periods[] = $S_period1;
            $fyear = intval(substr($S_period1, 0, 4));
            $serial_no = intval(substr($S_period1, 4, 2));
            $d = 31;
            $lastWeekofYear = date('W', mktime(0, 0, 0, 12, $d, $fyear));

            while ($lastWeekofYear == '01') {
                $d--;
                $lastWeekofYear = date('W', mktime(0, 0, 0, 12, $d, $fyear));
            }

            if ($serial_no == intval($lastWeekofYear)) {
                $fyear += 1;
                $serial_no = 1;
            } else {
                $serial_no += 1;
            }

            $S_period1 = sprintf("%04d%02d", $fyear, $serial_no);
        }
    }
}

// set up the department selection
$S_dep = (isset($_POST['S_DEPSEL'])?$_POST['S_DEPSEL']:'');

if ($S_dep !== '' && !is_array($S_dep)) {
    $S_dep = explode("**", $S_dep);
}

// set up the user selection
$S_mem = (isset($_POST['S_ATSEL'])?$_POST['S_ATSEL']:'');

if ($S_mem !== '' && !is_array($S_mem)) {
    $S_mem = explode("**", $S_mem);
}

// load report info
$querymore = " WHERE rep.name='timesheet_report'";
$reportDetail = new request();
$reportDetail->openReports($querymore);
$comptReportDetail = count($reportDetail->rep_id);

if ($comptReportDetail === 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?', lang_strings('reports'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/listreports.php?cat=' . $reportDetail->rep_category[0], $reportDetail->rep_repc_name_print[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/selecttimesheet.php', lang_strings("timesheet_report"), 'in'));
$blockPage->closeBreadcrumbs();
// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/timesheet.php#" . $block1->form . "Anchor");
echo '<input type="hidden" name="S_PERIOD1" value="' . $S_period1 . '">';
echo '<input type="hidden" name="S_PERIOD2" value="' . $S_period2 . '">';
echo '<input type="hidden" name="S_DEPSEL" value="' . ((is_array($S_dep))?implode("**", $S_dep):$S_dep) . '">';
echo '<input type="hidden" name="S_ATSEL" value="' . ((is_array($S_mem))?implode("**", $S_mem):$S_mem) . '">';
$block1->openContent();
$block1->sorting("timesheet_report",(isset($sortingUser["timesheet_report"])?$sortingUser["timesheet_report"]:''),"T1.status ASC",$sortingFields = array(0=>"T1.mem_name",1=>"T1.dep_name",2=>"T1.period",3=>"T1.status",4=>"T1.modified"));
// user selection
if ($S_mem == '') {
    $query = " WHERE mem.id='0'";
} else {
    $query = " WHERE mem.id" . ((is_array($S_mem))?" IN ('" . implode("','", $S_mem) . "')":"='$S_mem'");
}
// a department selection was made
if ($S_dep != '') {
    $query .= " AND mem.department" . ((is_array($S_dep))?" IN ('" . implode("','", $S_dep) . "')":"='$S_dep'");
}
// period selection
if (count($A_periods) == 0) {
    $comptListTimesheet = 0;
} else {
    $subquery = array();

    foreach ($A_periods as $period) {
        $fyear = intval(substr($period, 0, 4));
        $serial_no = intval(substr($period, 4, 2));
        $querymore = " WHERE per.fyear='$fyear' AND per.serial_no='$serial_no'";
        $periodDetail = new request();
        $periodDetail->openPeriods($querymore);

        if (count($periodDetail->per_id)==0) {
            $perid = '0';
        } else {
            $perid = $periodDetail->per_id[0];
        }

        $subquery[] = "
SELECT CAST('$period' AS $db_cast_str(20)) AS period, mem.id AS mem_id, mem.name AS mem_name,dep.name AS dep_name,CASE WHEN tim.status IS NULL THEN '" . enumFileStatus::stNeedsApproval . "' ELSE tim.status END AS status,CASE WHEN tim.modified IS NULL THEN tim.created ELSE tim.modified END AS modified
FROM " . $tablePrefix . "members mem LEFT OUTER JOIN " . $tablePrefix . "timesheet tim ON tim.owner=mem.id AND tim.period='$perid' LEFT OUTER JOIN " . $tablePrefix . "departments dep ON dep.id=mem.department
$query";
    }

    $tmpquery = "
SELECT T1.mem_id,T1.mem_name,T1.dep_name,T1.period,T1.status,T1.modified FROM (
" . implode(" UNION ALL ", $subquery) . "
) T1 ORDER BY $block1->sortingValue";
    $listTimesheet = new request();
    $listTimesheet->connectClass();
    $listTimesheet->query($tmpquery);
    $listTimesheet->mem_id = array();

    while ($listTimesheet->fetch()) {
        $i = 0;
        $listTimesheet->mem_id[] = ($row[$i++]);
        $listTimesheet->mem_name[] = HtmlEntityDecodeNOD($row[$i++]);
        $listTimesheet->dep_name_print[] = $strings['DEP__' . $row[$i++]];
        $listTimesheet->period[] = ($row[$i++]);
        $listTimesheet->status[] = ($row[$i++]);
        $listTimesheet->modified[] = ($row[$i++]);
    }

    $listTimesheet->close();
    $comptListTimesheet = count($listTimesheet->mem_id);
}

$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListTimesheet == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListTimesheet == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListTimesheet . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListTimesheet > 0) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", lang_strings("export"));
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $_SESSION['TARGET'] = 'exporttimesheet';
    $params = array();
    $params['S_PERIOD1'] = $_REQUEST['S_PERIOD1'];
    $params['S_PERIOD2'] = $_REQUEST['S_PERIOD2'];
    $params['S_DEPSEL'] = $S_dep;
    $params['S_ATSEL'] = $S_mem;
    $_SESSION['PARAMS'] = $params;
    $block1->paletteScript(0, "export", "../reports/exporttimesheet.php", "true,false,false", lang_strings("export"));
    $block1->closePaletteScript($comptListTimesheet, $listTimesheet->mem_id);
}

// set up the header string
$block1HeadingText = lang_strings("timesheet_report");
$block1->heading($block1HeadingText);

if ($comptListTimesheet > 0) {
    $labels = array(lang_strings("user"), lang_strings("department"), lang_strings("period"), lang_strings("status"), lang_strings("modified"));
    $block1->openResults(false);
    $block1->labels($labels, "false");

    for ($i=0; $i<$comptListTimesheet; $i++) {
        $block1->openRow();
        $block1->cellRow($blockPage->buildLink($listTimesheet->mem_id[$i], '', 'message'));
        $block1->cellRow($listTimesheet->dep_name_print[$i]);
        $fyear = substr($listTimesheet->period[$i], 0, 4);
        $serialno = intval(substr($listTimesheet->period[$i], 4, 2));

        if ($periodUnit == 'month') {
            $serialname = $monthNameArray[$serialno];
        } else {
            $serialname = lang_strings('week') . ' ' . $serialno;
        }

        $block1->cellRow("$serialname $fyear");
        $block1->cellRow($statusFile[$listTimesheet->status[$i]]);
        $block1->cellRow($listTimesheet->modified[$i]);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

// close block1
$block1->closeFormResults();
require_once("../includes/footer.php");
