<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addclienttask.php,v 1.8 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = "onload=\"document.etDForm.tn.focus();\"";
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$sdI = isset($_POST['sdI'])?$_POST['sdI']:'';
$sd = ($sdI=='')?$dateToday:date2Timestamp($sdI);
$ddI = isset($_POST['ddI'])?$_POST['ddI']:'';
$dd = ($ddI=='')?$dateToday:date2Timestamp($ddI);
$tn = isset($_POST['tn'])?$_POST['tn']:'';
$d = isset($_POST['d'])?$_POST['d']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$pr = isset($_POST['pr'])?$_POST['pr']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$topPage = '';
$error = '';

/**
 * Permission check
 */
// Get Project Information
$querymore = " WHERE pro.id='$projectSession'";
$projectDetail = new request();
$projectDetail->openProjects($querymore);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: index.php');
    exit;
}

/**
 * Check fields
 */
if ($action == 'add') {
    $error = checkCustomFields('tasks', '', '0', true);
}

/**
 * Actions
 */
if ($action == "add" && $error == '') {
    // replace quotes by html code in name
    $d = HtmlEntitiesNOD($d);   // The description of task
    $c = HtmlEntitiesNOD($c);   // The remarks of task
    $etm = diff_hour($sd, $dd, $projectDetail->pro_workcalendar[0]);    // The estimated time in hours of task
    $cfsqls = setupCustomFieldsInsertSQL('tasks', '0', true);  // Generate custom fields insert sql
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "INSERT INTO " . $tablePrefix . "tasks (project,name,description,owner,assigned_to,status,priority,start_date,due_date,estimated_time,comments,published,completion,fixed_duration,milestone,type,task_group,level,parent_task,subtask,created,cuser" . $cfsqls[0] . ") VALUES ('$projectSession','$tn','$d','$idSession','0','" . enumStatus::stOpen . "','$pr','$sd','$dd','$etm','$c','" . enumPublished::pbYes . "','0','" . enumFixedDuration::fdNo . "','" . enumMilestone::msNo . "','99999','" . enumTaskGroup::tgNo . "','0','0','0','" . time() . "','$idSession'" . $cfsqls[1] . ")";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $num = $requestAct->newId("tasks");    // The unique id of new task
        $cfsql = setupCustomMediaFieldsUpdateSQL('tasks', $num, '0', true);    // Upload custom fields images & generate custom fields update sql

        if ($cfsql !== '') {
            $tmpsql = "UPDATE " . $tablePrefix . "tasks SET $cfsql WHERE id='$num'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('$num','$idSession','0','" . time() . "')";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'tasks', $num, 'A');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        // send task assignment mail if notifications = true
        if (!defined('INNER_NOTI_CLIENTADDTASK')) {
            define('INNER_NOTI_CLIENTADDTASK', 1);
        }

        require_once("../tasks/noti_clientaddtask.php");
        header('Location: showallclienttasks.php');
        exit;
    }
}

/**
 * Html
 */
require_once ("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?topPage=true', lang_strings("my_projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?', $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('showallclienttasks.php?', lang_strings('client_tasks'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_task"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "etD";
$block1->openForm("../service_site/addclienttask.php?#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="add">';
$block1->heading(lang_strings("add_task"));
$block1->openContent();
setupInputHTML($block1, lang_strings("name"), 'tn', enumFieldType::ftText, 'Y', '255', $tn);      // The name of task
setupInputHTML($block1, lang_strings("description"), 'd', enumFieldType::ftMemo, 'N', '0', $d);   // The description of task
$prSel = '<select name="pr">';

foreach ($priority as $val => $desc) {
    if ($val == $projectDetail->pro_priority[0]) {
        $prSel .= "<option value=\"$val\" selected>$desc</option>";
    } else {
        $prSel .= "<option value=\"$val\">$desc</option>";
    }
}

$prSel .= '</select>';
$block1->contentRow("* " . lang_strings("priority"), $prSel);               // The priority of task
// The start date of task
setupInputHTML($block1, lang_strings("start_date"), 'sdI', enumFieldType::ftDate, 'Y', '0', $sd);
// The due date of task
setupInputHTML($block1, lang_strings("due_date"), 'ddI', enumFieldType::ftDate, 'Y', '0', $dd);
setupInputHTML($block1, lang_strings("comments"), 'c', enumFieldType::ftMemo, 'N', '0', $c);  // The remarks of task
setupCustomFieldsInputHTML($block1, 'tasks', '', '0', true);                    // The custom fields of task
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
$block1->note(lang_strings('client_add_task_note'));
require_once ("../includes/footer.php");
