<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addform.php,v 1.9 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$tblnamSession = isset($_SESSION['tblnamSession'])?$_SESSION['tblnamSession']:'';
$allformPage = (($projectSession=='')?'myforms':'showallforms');
$tbldispnam = tableNameString($tblnamSession);
$topPage = '';
$error = '';

/**
 * Permission check
 */
if ($projectSession == '') {
    // check form published for client
    $querymore = " LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.organization=ogf.organization WHERE mem.id='$idSession' AND ogf.tablename='$tblnamSession'";
    $organizationFormDetail = new request();
    $organizationFormDetail->openOrganizationForms($querymore);
    $comptOrganizationFormDetail = count($organizationFormDetail->ogf_id);

    if ($comptOrganizationFormDetail == '0') {
        header('Location: myforms.php?msg=permissiondenied');
        exit;
    }

    // check permit client user to add form
    if ($organizationFormDetail->ogf_addenabled[0] != 'Y') {
        header('Location: myforms.php?msg=permissiondenied');
        exit;
    }
} else {
    // check if this is a project form and publish enabled
    $querymore1 = " WHERE pfm.project='$projectSession' AND pfm.tablename='$tblnamSession' AND pfm.publishenabled='Y'";
    $projectFormDetail = new request();
    $projectFormDetail->openProjectsForm($querymore1);
    $comptProjectFormDetail = count($projectFormDetail->pfm_project);

    if ($comptProjectFormDetail == '0') {
        header('Location: showallforms.php?msg=permissiondenied');
        exit;
    }

    $querymore2 = " WHERE pro.id='$projectSession'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore2);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: index.php');
        exit;
    }
}

// check form template publish enabled and not a system table
$querymore = " WHERE tdf.tablename='$tblnamSession' AND tdf.sysdef='N' AND tdf.publishenabled='Y'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore);
$comptTableDefinitionDetail = count($tableDefinitionDetail->tdf_tablename);

if ($comptTableDefinitionDetail == '0') {
    header('Location: ' . $allformPage . '.php?msg=permissiondenied');
    exit;
}

// check if there are form fields published
$tmpquery = "SELECT fdf.tablename FROM " . $tablePrefix . "fields_def fdf WHERE fdf.tablename='$tblnamSession' AND fdf.sysdef='N' AND fdf.published='" . enumPublished::pbYes . "'";
$comptCF = compt($tmpquery);

if ($comptCF == '0') {
    header('Location: ' . $allformPage . '.php?msg=permissiondenied');
    exit;
}

/**
 * Actions
 */
if ($action == "add") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $cfsqls = setupCustomFieldsInsertSQL($tblnamSession, '0', true);  // Generate custom fields insert sql
        $dbtblnam = $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0];
        $pro = (($projectSession == '')?'0':$projectSession);
        $status = enumFileStatus::stNoApprovalsNeeded;
        $tmpsql = "INSERT INTO $dbtblnam (status,project,created,cuser,published" . $cfsqls[0] . ") VALUES ('$status','$pro','" . time() . "','$idSession','" . enumPublished::pbYes . "'" . $cfsqls[1] . ")";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $sendto = $requestAct->newId($tblnamSession);
        $cfsql = setupCustomMediaFieldsUpdateSQL($tblnamSession, $sendto, '0', true);    // Upload custom fields images & generate custom fields update sql

        if ($cfsql !== '') {
            $tmpsql = "UPDATE " . $tablePrefix . "$dbtblnam SET $cfsql WHERE id='$sendto'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        updateFormDetails($requestAct, $sendto, $pro);
        $num = $sendto;
        $producer = $idSession;
        $doctype = $tblnamSession;

        if (!defined('INNER_ADDDOCUMENT')) {
            define('INNER_ADDDOCUMENT', 1);
        }

        require('../approvals/adddocument.php');

        if ($projectSession == '') {
            $querymore = " WHERE fil.id='1'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtForm, $sendto, enumFileStatus::stNoApprovalsNeeded, '1', $path, $tblnamSession);
        } else {
            $querymore = " WHERE fil.id='" . $projectDetail->pro_upload_dir[0] . "'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtForm, $sendto, enumFileStatus::stNoApprovalsNeeded, $projectDetail->pro_upload_dir[0], $path, $tblnamSession);
        }

        if ($tableDefinitionDetail->tdf_history[0] == 'Y') {
            copy2HistoryTable($requestAct, $tblnamSession, $sendto, 'A');
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ' . $allformPage . '.php?msg=add');
        exit;
    }
}

/**
 * Html
 */
require_once ("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($projectSession == '') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myforms.php?topPage=true', lang_strings("my_forms"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myforms.php?', $tbldispnam, 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?topPage=true', lang_strings("my_projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?', $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('showallforms.php?topPage=true', lang_strings('forms'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('showallforms.php?', $tbldispnam, 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings('add_form'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "adF";
$block1->openForm("../service_site/addform.php?#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="add">';
$block1->heading(lang_strings('add_form'));

if ($comptCF < 10) {
    $block1->openContent();
} else {
    $block1->openContent(true);
}

setupCustomFieldsInputHTML($block1, $tblnamSession, '', '0', true);
$block1->closeContent();
setupFormDetailsInputHTML($tblnamSession, '', true);
$block1->openContent();
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();

if ($fileManagement == 'true') {
    setupProjectsSiteAttachFilesHTML();
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once ("../includes/footer.php");
