<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addsupport.php,v 1.7 2013/02/02 01:27:21 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.addsupportForm.sub.focus();"';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$re = isset($_POST['re'])?$_POST['re']:'';
$se = isset($_POST['se'])?$_POST['se']:'';
$pr = isset($_POST['pr'])?$_POST['pr']:'';
$sub = isset($_POST['sub'])?$_POST['sub']:'';
$mes = isset($_POST['mes'])?$_POST['mes']:'';
$topPage = '';
$error = '';

/**
 * Permission check
 */
$querymore = " WHERE pro.id='$projectSession'";
$projectDetail = new request();
$projectDetail->openProjects($querymore);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: index.php');
    exit;
}

/**
 * Check fields
 */
if ($action == 'add') {
    $error = checkCustomFields('support_requests', '', '0', true);
}

/**
 * Actions
 */
if ($action == "add" && $error == '') {
    $sub = HtmlEntitiesNOD($sub);
    $mes = HtmlEntitiesNOD($mes);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $cfsqls = setupCustomFieldsInsertSQL('support_requests', '0', true);  // Generate custom fields insert sql
        $tmpsql = "INSERT INTO " . $tablePrefix . "support_requests (owner,reproducibility,severity,priority,subject,message,date_open,project,status,resolution,auto_close,published,created,cuser" . $cfsqls[0] . ") VALUES ('$idSession','$re','$se','$pr','$sub','$mes','" . time() . "',$projectSession,'" . enumRequestStatus::stNew . "','1','Y','" . enumPublished::pbYes . "','" . time() . "','$idSession'" . $cfsqls[1] . ")";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $sendto = $requestAct->newId("support_requests");
        $cfsql = setupCustomMediaFieldsUpdateSQL('support_requests', $sendto, '0', true);    // Upload custom fields images & generate custom fields update sql

        if ($cfsql !== '') {
            $tmpsql = "UPDATE " . $tablePrefix . "support_requests SET $cfsql WHERE id='$sendto'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $querymore = " WHERE fil.id='" . $projectDetail->pro_upload_dir[0] . "'";
        $folderDetail = clone $requestAct;
        $folderDetail->openFiles($querymore);
        $path = $folderDetail->fil_fullname[0];
        uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtSupportRequest, $sendto, enumFileStatus::stNoApprovalsNeeded, $projectDetail->pro_upload_dir[0], $path);
        copy2HistoryTable($requestAct, 'support_requests', $sendto, 'A');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if (!defined('INNER_NOTI_NEWREQUEST')) {
            define('INNER_NOTI_NEWREQUEST', 1);
        }

        $num = $sendto;
        require_once("../support/noti_newrequest.php");
        header("Location: suprequestdetail.php?id=$sendto");
        exit;
    }
}

/**
 * Form init
 */
if ($error == '') {
    $re = fieldDefaultValue('support_requests', 'reproducibility');
    $se = fieldDefaultValue('support_requests', 'severity');
    $pr = enumPriority::prLow;
}

/**
 * Html
 */
require_once ("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?topPage=true', lang_strings("my_projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?', $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('showallsupport.php?', lang_strings('support'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_support_request"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "addsupport";
$block1->openForm("../service_site/addsupport.php?#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
$block1->heading(lang_strings("add_support_request"));
$block1->openContent();
$block1->contentRow(lang_strings("FIE__support_requests_reproducibility"), populateSelect('support_requests', 'reproducibility', 're', strval($re)));
$block1->contentRow(lang_strings("FIE__support_requests_severity"), populateSelect('support_requests', 'severity', 'se', strval($se)));
$priSel = '<select name="pr">';

foreach ($priority as $key => $val) {
    if ($key == '0') {
        continue;
    }

    if (strval($pr) === strval($key)) {
        $priSel .= '<option value="' . $key . '" selected>' . $val . '</option>';
    } else {
        $priSel .= '<option value="' . $key . '">' . $val . '</option>';
    }
}

$priSel .= '</select>';
$block1->contentRow(lang_strings("priority"), $priSel);
setupInputHTML($block1, lang_strings("subject"), 'sub', enumFieldType::ftText, 'Y', '255', $sub);
setupInputHTML($block1, lang_strings("message"), 'mes', enumFieldType::ftMemo, 'Y', '9', $mes);
setupCustomFieldsInputHTML($block1, 'support_requests', '', '0', true);
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings['submit'] . '">');
$block1->closeContent();

if ($fileManagement == 'true') {
    setupProjectsSiteAttachFilesHTML();
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once ("../includes/footer.php");
