<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addsupportpost.php,v 1.7 2013/02/02 01:27:21 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.addsupportForm.mes.focus();"';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$qm = AddSlashesNOD(isset($_GET['qm'])?$_GET['qm']:'');        // quoted messages
$mes = isset($_POST['mes'])?$_POST['mes']:'';
$topPage = '';
$error = '';

/**
 * Permission check
 */
$querymore0 = " WHERE pro.id='$projectSession'";
$projectDetail = new request();
$projectDetail->openProjects($querymore0);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: index.php');
    exit;
}

$querymore1 = " WHERE sr.id='$id'";
$requestDetail = new request();
$requestDetail->openSupportRequests($querymore1);
$comptRequestDetail = count($requestDetail->sr_id);

if ($comptRequestDetail == '0') {
    header('Location: index.php');
    exit;
}

if ($requestDetail->sr_project[0] != $projectSession || $requestDetail->sr_published[0] != enumPublished::pbYes) {
    header("Location: index.php");
    exit;
}

/**
 * Check fields
 */
if ($action == 'add') {
    $error = checkCustomFields('support_posts', '', '0', true);
}

/**
 * Actions
 */
if ($action == "add" && $error == '') {
    $mes = HtmlEntitiesNOD($mes);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $cfsqls = setupCustomFieldsInsertSQL('support_posts', '0', true);  // Generate custom fields insert sql
        $tmpsql = "INSERT INTO " . $tablePrefix . "support_posts(request_id,message,date,owner,project,created,cuser" . $cfsqls[0] . ") VALUES('$id','$mes','" . time() . "','$idSession','" . $requestDetail->sr_project[0] . "','" . time() . "','$idSession'" . $cfsqls[1] . ")";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $num = $requestAct->newId("support_posts");
        $cfsql = setupCustomMediaFieldsUpdateSQL('support_posts', $num, '0', true);    // Upload custom fields images & generate custom fields update sql

        if ($cfsql !== '') {
            $tmpsql = "UPDATE " . $tablePrefix . "support_posts SET $cfsql WHERE id='$num'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $sendto = $num;
        $querymore = " WHERE fil.id='" . $projectDetail->pro_upload_dir[0] . "'";
        $folderDetail = clone $requestAct;
        $folderDetail->openFiles($querymore);
        $path = $folderDetail->fil_fullname[0];
        uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtSupportPost, $sendto, enumFileStatus::stNoApprovalsNeeded, $projectDetail->pro_upload_dir[0], $path);
        copy2HistoryTable($requestAct, 'support_posts', $sendto, 'A');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($mes != "") {
            if (!defined('INNER_NOTI_NEWPOST')) {
                define('INNER_NOTI_NEWPOST', 1);
            }

            $num = $sendto;
            require_once("../support/noti_newpost.php");
        }

        header("Location: suprequestdetail.php?id=$id");
        exit;
    }
}

/**
 * Prepare data
 */
if ($error == '') {
    if ($qm != '') {    // quote messages
        $qma = explode('**', $qm);
        $spid = '';
        $sr = false;
        $mesa = array();

        foreach ($qma as $i) {
            if ($i == '0') {
                $sr = true;
            } else {
                if ($spid != '') {
                    $spid .= ',';
                }

                $spid .= "'" . $i . "'";
            }
        }

        if ($spid != '') {
            $querymore = " WHERE sp.id IN ($spid) ORDER BY sp.date DESC";
            $listSupportPosts = new request();
            $listSupportPosts->openSupportPosts($querymore);
            $comptListSupportPosts = count($listSupportPosts->sp_id);

            for ($i=0; $i<$comptListSupportPosts; $i++) {
                $mesa[] = '>' . implode("\n>", explode("\n", $listSupportPosts->sp_message[$i]));
            }
        }

        if ($sr) {
            $mesa[] = '>' . implode("\n>", explode("\n", $requestDetail->sr_message[0]));
        }

        $mes = implode("\n\n\n", $mesa) . "\n";
    }
}

/**
 * Html
 */
require_once ("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?topPage=true', lang_strings("my_projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?', $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('showallsupport.php?', lang_strings('support'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('suprequestdetail.php?id=' . $id, $requestDetail->sr_subject[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_support_response"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'addsupport';
$block1->openForm("../service_site/addsupportpost.php?id=$id#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
$block1->heading(lang_strings("add_support_response"));
$block1->openContent();
setupInputHTML($block1, lang_strings("message"), 'mes', enumFieldType::ftMemo, 'Y', '9', $mes);
setupCustomFieldsInputHTML($block1, 'support_posts', '', '0', true);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["submit"] . "\">");
$block1->closeContent();

if ($fileManagement == 'true') {
    setupProjectsSiteAttachFilesHTML();
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once ("../includes/footer.php");
