<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: clientfiledetail.php,v 1.7 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$att3 = isset($_POST['atttmp3'])?$_POST['atttmp3']:'';
$att4 = isset($_POST['atttmp4'])?$_POST['atttmp4']:'';
$c3 = isset($_POST['c3'])?$_POST['c3']:'';
$c4 = isset($_POST['c4'])?$_POST['c4']:'';
$revision = isset($_POST['revision'])?$_POST['revision']:'';
$change_file_version = isset($_POST['change_file_version'])?$_POST['change_file_version']:'';
$tblnamSession = isset($_SESSION['tblnamSession'])?$_SESSION['tblnamSession']:'';
$allformPage = (($projectSession=='')?'myforms':'showallforms');
$topPage = '';
$error3 = '';
$error4 = '';
$displayrev = 0;

/**
 * Permission check
 */
$querymore1 = " WHERE fil.id='$id'";
$fileDetail = new request();
$fileDetail->openFiles($querymore1);
$comptFileDetail = count($fileDetail->fil_id);

if ($comptFileDetail == '0' || $fileDetail->fil_published[0] != enumPublished::pbYes) {
    header("Location: index.php");
}

$type = file_info_type($fileDetail->fil_extension[0]);
$displayname = $fileDetail->fil_name[0];
$fil_doc_type = $fileDetail->fil_doc_type[0];
$fil_doc_type_ex = $fileDetail->fil_doc_type_ex[0];
$fil_doc_id = $fileDetail->fil_doc_id[0];

switch ($fil_doc_type) {
    case enumFileRelatedDocumentType::dtProject:
        $tmpquery = "SELECT id FROM " . $tablePrefix . "projects WHERE id='$fil_doc_id'";
        break;
    case enumFileRelatedDocumentType::dtPhase:
        $tmpquery = "SELECT project FROM " . $tablePrefix . "phases WHERE id='$fil_doc_id'";
        break;
    case enumFileRelatedDocumentType::dtTask:
        $tmpquery = "SELECT project FROM " . $tablePrefix . "tasks WHERE id='$fil_doc_id'";
        break;
    case enumFileRelatedDocumentType::dtMeeting:
        $tmpquery = "SELECT project FROM " . $tablePrefix . "meetings WHERE id='$fil_doc_id'";
        break;
    case enumFileRelatedDocumentType::dtDiscussion:
        $tmpquery = "SELECT topic.project FROM " . $tablePrefix . "posts pos INNER JOIN " . $tablePrefix . "topics topic ON topic.id=pos.topic WHERE pos.id='$fil_doc_id'";
        break;
    case enumFileRelatedDocumentType::dtNote:
        $tmpquery = "SELECT project FROM " . $tablePrefix . "notes WHERE id='$fil_doc_id'";
        break;
    case enumFileRelatedDocumentType::dtExpense:
        $tmpquery = "SELECT project FROM " . $tablePrefix . "expenses WHERE id='$fil_doc_id'";
        break;
    case enumFileRelatedDocumentType::dtSupportRequest:
        $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_requests req WHERE req.id='$fil_doc_id'";
        break;
    case enumFileRelatedDocumentType::dtSupportPost:
        $tmpquery = "SELECT req.project FROM " . $tablePrefix . "support_posts pos INNER JOIN " . $tablePrefix . "support_requests req ON req.id=pos.request_id WHERE pos.id='$fil_doc_id'";
        break;
    default:
        $tmpquery = '';
        $querymore = " WHERE f.id='$fil_doc_id' AND f.published='" . enumPublished::pbYes . "'";
        $formDetail = new request();
        $formDetail->openForms($tblnamSession, $querymore);

        if ($formDetail->row_count == '0') {
            header('Location: ' . $allformPage . '.php?msg=permissiondenied');
            exit;
        }
}

if ($tmpquery == '') {
    $linkedProject = '';
} else {
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpquery);

    if ($request1->fetch()) {
        $linkedProject = ($row[0]);
    } else {
        $linkedProject = '';
    }

    $request1->close();
}

if ($projectSession != '' && $linkedProject != $projectSession) {
    header('Location: index.php');
    exit;
}

/**
 * Check fields
 */
if ($action == 'update' || $action == 'add') {
    if ($action == "update") {
        if ($att4 == '') {
            $error4 = lang_strings("no_file");
        } else {
            $error4 = checkCustomFields('files', $id, '4', true);
        }
    } else {
        if ($att3 == '') {
            $error3 = lang_strings("no_file");
        } else {
            $error3 = checkCustomFields('files', '', '3', true);
        }
    }
}

/**
 * Actions
 */
if ($error3 == '' && $error4 == '') {
    if ($action == "update") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            // Update file code
            $path = substr($fileDetail->fil_fullname[0], 0, strrpos($fileDetail->fil_fullname[0], '/'));

            if (strstr($fileDetail->fil_vc_version[0], '.') === false) {
                $major = $fileDetail->fil_vc_version[0];
                $minor = 0;
            } else {
                list($major, $minor) = explode('.', $fileDetail->fil_vc_version[0]);
            }

            if ($change_file_version == '1.0') {
                $major = intval($major) + 1;
            } else {
                $minor = intval($minor) + 1;
            }

            $newversion = sprintf('%d.%d', intval($major), intval($minor));
            $num = uploadSingleFile($requestAct, '4', $fileDetail->fil_doc_type[0], $fileDetail->fil_doc_type_ex[0], $fileDetail->fil_doc_id[0], $fileDetail->fil_parent[0], $path, $newversion, $id, $c4, $fileDetail->fil_published[0], '4', true, true);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error4 = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error4 == '') {
            header("Location: clientfiledetail.php?id=" . $fileDetail->fil_id[0] . "&msg=addFile");
            exit;
        }
    } else if ($action == "add") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            // Add new revision code
            $path = substr($fileDetail->fil_fullname[0], 0, strrpos($fileDetail->fil_fullname[0], '/'));
            $num = uploadSingleFile($requestAct, '3', $fileDetail->fil_doc_type[0], $fileDetail->fil_doc_type_ex[0], $fileDetail->fil_doc_id[0], $fileDetail->fil_parent[0], $path, $fileDetail->fil_vc_version[0], $id, $c3, $fileDetail->fil_published[0], '3', true);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error3 = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error3 == '') {
            header("Location: clientfiledetail.php?id=" . $fileDetail->fil_id[0] . "&msg=addFile");
            exit;
        }
    }
}

/**
 * Html
 */
require_once ("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($projectSession == '') {
    $tbldispnam = tableNameString($tblnamSession);
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myforms.php?topPage=true', lang_strings("my_forms"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myforms.php?', $tbldispnam, 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('formdetail.php?id=' . $fil_doc_id, HtmlEntityDecodeNOD($formDetail->rows[0]['description']), 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?topPage=true', lang_strings("my_projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?', $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('doclists.php?', lang_strings('document_list'), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("document"));
$blockPage->closeBreadcrumbs();

/**
 * File details block
 */
$block1 = new block();
$block1->headingToggle(lang_strings("document"), false);
$block1->openContent();
$block1->contentRow(lang_strings("type"), "<img src=\"../interface/icones/$type\" border=\"0\" alt=\"\">");
$nam = $fileDetail->fil_name[0];
$nam .= '&nbsp;&nbsp;' . $blockPage->buildLink("clientaccessfile.php?mode=view&amp;id=" . $id, lang_strings("view"), 'in');
$nam .= '&nbsp;&nbsp;' . $blockPage->buildLink("clientaccessfile.php?mode=download&amp;id=" . $id, lang_strings("save"), 'in');
$block1->contentRow(lang_strings("name"), $nam);    // file name
$block1->contentRow(lang_strings("vc_version"), $fileDetail->fil_vc_version[0]);
$block1->contentRow(lang_strings("modify_last_time"), ($fileDetail->fil_modified[0]==0)?createDate($fileDetail->fil_created[0],'both'):createDate($fileDetail->fil_modified[0],'both'));
$block1->contentRow(lang_strings("size"), convertSize($fileDetail->fil_size[0]));
$block1->contentRow(lang_strings("owner"), "<a href=\"contactdetail.php?id=" . $fileDetail->fil_owner[0] . "\">" . $fileDetail->fil_mem_name[0] . "</a>");
$block1->contentRow(lang_strings("comments"), $fileDetail->fil_comments[0]);
$idStatus = $fileDetail->fil_status[0];
$block1->contentRow(lang_strings("approval_tracking"), $statusFile[$idStatus]);
setupCustomFieldsHTML($block1, 'files', $id, true);
$block1->closeContent();
$block1->closeToggle();

/**
 * File version history
 */
$querymore = " WHERE fil.vc_parent='$id' AND fil.vc_status='" . enumFileVersionControl::vcVersionUpdate . "' ORDER BY fil.created DESC";
$listVersions = new request();
$listVersions->openFiles($querymore);
$comptListVersions = count($listVersions->fil_vc_parent);

if ($comptListVersions > 0) {
    $block2 = new block();
    $block2->headingToggle(lang_strings("ifc_version_history"));
    $labels = array(lang_strings("name"), lang_strings("vc_version"), lang_strings("owner"), lang_strings('created'), lang_strings('comments'));
    $block2->openResults();
    $block2->labels($labels, "false", "false");

    for ($i=0; $i<$comptListVersions; $i++) {
        $block2->openRow($listVersions->fil_id[$i]);
        $nam = $listVersions->fil_name[$i];
        $existFile = fileExists($listVersions->fil_fullname[$i]);

        if ($existFile) {
            $nam .= '&nbsp;&nbsp;' . $blockPage->buildLink("clientaccessfile.php?mode=view&amp;id=" . $listVersions->fil_id[$i], lang_strings("view"), 'in');
            $nam .= '&nbsp;&nbsp;' . $blockPage->buildLink("clientaccessfile.php?mode=download&amp;id=" . $listVersions->fil_id[$i], lang_strings("save"), 'in');
        } else {
            $nam .= '&nbsp;&nbsp;' . lang_strings("missing_file");
        }

        $block2->cellRow($nam);
        $block2->cellRow($listVersions->fil_vc_version[$i]);
        $block2->cellRow($listVersions->fil_mem_name[$i]);
        $block2->cellRow(createDate($listVersions->fil_created[$i],'both'));
        $block2->cellRow(nl2br($listVersions->fil_comments[$i]));
        $block2->closeRow();
    }

    $block2->closeResults();
    $block2->closeToggle();
}


/**
 * Revision list block
 */
if ($peerReview == "true") {
    $block3 = new block();
    $block3->headingToggle(lang_strings("ifc_revisions"));
    $querymore = " WHERE fil.vc_parent='$id' AND fil.vc_status='" . enumFileVersionControl::vcPeerReview . "' ORDER BY fil.created";
    $listReviews = new request();
    $listReviews->openFiles($querymore);
    $comptListReviews = count($listReviews->fil_vc_parent);

    if ($comptListReviews > 0) {
        $labels = array(lang_strings("name"), lang_strings("revision"), lang_strings("ifc_revision_of"), lang_strings("owner"), lang_strings('created'), lang_strings('comments'));
        $block3->openResults();
        $block3->labels($labels, "false", "false");

        for ($i=0; $i<$comptListReviews; $i++) {
            // Calculate a revision number for display for each listing
            $displayrev = $i + 1;
            $block3->openRow($listReviews->fil_id[$i]);
            $nam = $displayname;
            $existFile = fileExists($listReviews->fil_fullname[$i]);

            if ($existFile) {
                $nam .= '&nbsp;&nbsp;' . $blockPage->buildLink("clientaccessfile.php?mode=view&amp;id=" . $listReviews->fil_id[$i], lang_strings("view"), 'in');
                $nam .= '&nbsp;&nbsp;' . $blockPage->buildLink("clientaccessfile.php?mode=download&amp;id=" . $listReviews->fil_id[$i], lang_strings("save"), 'in');
            } else {
                $nam .= '&nbsp;&nbsp;' . lang_strings("missing_file");
            }

            $block3->cellRow($nam);
            $block3->cellRow($displayrev);
            $block3->cellRow($listReviews->fil_vc_version[$i]);
            $block3->cellRow($listReviews->fil_mem_name[$i]);
            $block3->cellRow(createDate($listReviews->fil_created[$i],'both'));
            $block3->cellRow(nl2br($listReviews->fil_comments[$i]));
            $block3->closeRow();
        }

        $block3->closeResults();
    } else {
        echo '<div class="clear"><p>' . lang_strings("ifc_no_revisions") . '</p></div>';
    }

    $block3->closeToggle();
    /**
     * Add new revision Block
     */
    $block4 = new block();
    $block4->form = "afR";
    $block4->openForm("../service_site/clientfiledetail.php?id=" . $fileDetail->fil_id[0] . "#" . $block4->form . "Anchor");
    echo '<input type="hidden" name="action" value="add">';

    if ($error3 != "") {
        $block4->headingError(lang_strings("errors"));
        $block4->contentError($error3);
    }

    $block4->headingToggle(lang_strings("ifc_add_revision"));
    $block4->openContent();
    $block4->contentTitle(lang_strings("details"));
    // Add one to the number of current revisions
    $revision = $displayrev + 1;
    echo '<input type="hidden" name="revision" value="' . $revision . '">';
    $block4->contentRow(lang_strings("upload"), setupUploadFileHTML('3', '', true));
    setupInputHTML($block4, lang_strings('comments'), 'c3', enumFieldType::ftMemo, 'N', '0', $c3);
    setupCustomFieldsInputHTML($block4, 'files', $id, '3');
    $block4->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
    $block4->closeContent();
    $block4->closeToggle();
    $block4->closeForm();
}


/**
 * Update file Block
 */
$block5 = new block();
$block5->form = "updF";
$block5->openForm("../service_site/clientfiledetail.php?id=" . $fileDetail->fil_id[0] . "#" . $block5->form . "Anchor");
echo '<input type="hidden" name="action" value="update">';

if ($error4 != "") {
    $block5->headingError(lang_strings("errors"));
    $block5->contentError($error4);
}

$block5->headingToggle(lang_strings("ifc_update_file"));
$block5->openContent();
$block5->contentTitle(lang_strings("details"));
$block5->contentRow(lang_strings("version_increm"), "<br>
    <table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
    <tr><td align=\"right\">0.1</td><td width=\"30\" align=\"right\"><input name=\"change_file_version\" type=\"radio\" value=\"0.1\" checked></td></tr>
    <tr><td align=\"right\">1.0</td><td width=\"30\" align=\"right\"><input name=\"change_file_version\" type=\"radio\" value=\"1.0\"></td></tr>
    </table>");
$block5->contentRow(lang_strings("upload"), setupUploadFileHTML('4', '', true));
setupInputHTML($block5, lang_strings('comments'), 'c4', enumFieldType::ftMemo, 'N', '0', $c4);
setupCustomFieldsInputHTML($block5, 'files', $id, '4');
$block5->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["ifc_update_file"] . "\">");
$block5->closeContent();
$block5->closeToggle();
$block5->closeForm();
require_once ("../includes/footer.php");
