<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: clienttaskdetail.php,v 1.7 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$st = isset($_POST['st'])?$_POST['st']:'';
$c = isset($_POST['c'])?$_POST['c']:'';   // The remarks of task

/**
 * Permission check
 */
$querymore = " WHERE tas.id='$id' AND tas.assigned_to<>'0' AND mem2.organization<>'1' AND tas.milestone<>'" . enumMilestone::msYes . "'";   // task owner is client user, published, not milestone, assigned
$taskDetail = new request();
$taskDetail->openTasks($querymore);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0' || $taskDetail->tas_published[0] != enumPublished::pbYes || $taskDetail->tas_project[0] != $projectSession) {
    header("Location: index.php");
}

/**
 * Check fields
 */
if ($action == 'update') {
    $error = checkCustomFields('tasks', $id, '0', true);
}

/**
 * Actions
 */
if ($action == "update" && $error == '') {
    $c = HtmlEntitiesNOD($c);   // concat values from date selector and replace quotes by html code
    $st = (($st=='Y')?enumStatus::stClientCompleted:enumStatus::stOpen);     // The status of task
    $compl = (($st==enumStatus::stClientCompleted)?'10':$taskDetail->tas_completion[0]);  // The completion of task
    $cfsql = setupCustomFieldsUpdateSQL('tasks', $id, '0', true);  // Generate custom fields update sql
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "UPDATE " . $tablePrefix . "tasks SET comments='$c',status='$st',completion='$compl',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'tasks', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: showallclienttasks.php");
        exit;
    }
}

/**
 * Html
 */
$bouton[3] = "over";
require_once ("../includes/header.php");
$block1 = new block();

if ($error != "") {
    echo "<h1 class=\"headingError\">" . lang_strings("errors") . "</h1>\n";
    echo "<table class=\"error\"><tr><td>" . $error . "</td></tr></table>\n";
}

// client task detail
$block1->heading(lang_strings("client_task_details"));
$block1->openContent();
$block1->contentRow(lang_strings("name"), $taskDetail->tas_name[0]);
$block1->contentRow(lang_strings("description"), $taskDetail->tas_description[0]);
$complValue = ($taskDetail->tas_completion[0] > 0) ? $taskDetail->tas_completion[0] . "0 %": $taskDetail->tas_completion[0] . " %";
$block1->contentRow(lang_strings("completion"), $complValue);
$block1->contentRow(lang_strings("comments"), $taskDetail->tas_comments[0]);
$block1->contentRow(lang_strings("start_date"), createDate($taskDetail->tas_start_date[0],'date',false,true));
$block1->contentRow(lang_strings("due_date"), createDate($taskDetail->tas_due_date[0],'date',false,true));
setupCustomFieldsHTML($block1, 'tasks', $id, true);
$block1->closeContent();
// client task update history
$block1->heading(lang_strings("updates_task"));
$block1->openContent();
$querymore = " WHERE upd.type='1' AND upd.item = '$id' ORDER BY upd.created DESC";
$listUpdates = new request();
$listUpdates->openUpdates($querymore);
$comptListUpdates = count($listUpdates->upd_id);

if ($comptListUpdates != "0") {
    $updtxt = '';

    for ($i=0,$j=1; $i<$comptListUpdates; $i++,$j++) {
        if ($i == 5) {
            $updtxt .= "...<br>";
            break;
        }

        $upd_comm = $listUpdates->upd_comments[$i];

        if (preg_match("|\[status:([0-9])\]|i", $upd_comm, $matches) === 1) {
            $upd_comm = preg_replace_callback("|\[status:([0-9])\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
            $upd_comm .= lang_strings("status") . " " . $status[$matches[1]];
        }

        if (preg_match("|\[priority:([0-9])\]|i", $upd_comm, $matches) === 1) {
            $upd_comm = preg_replace_callback("|\[priority:([0-9])\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
            $upd_comm .= lang_strings("priority") . " " . $priority[$matches[1]];
        }

        if (preg_match("|\[datedue:([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\]|i", $upd_comm, $matches) === 1) {
            $upd_comm = preg_replace_callback("|\[datedue:([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
            $upd_comm .= lang_strings("due_date") . " " . $matches[1];
        }

        $abbrev = mb_substr($upd_comm, 0, 100, $setCharset);
        $updtxt .= "<b>" . $j . ".</b> <i>" . createDate($listUpdates->upd_created[$i], 'both') . "</i> $abbrev";

        if (100 < mb_strlen($upd_comm, $setCharset)) {
            $updtxt .= "...<br>";
        } else {
            $updtxt .= "<br>";
        }
    }

    $block1->contentRow('', $updtxt);
} else {
    $block1->contentRow('', lang_strings("no_items"));
}

$block1->closeContent();
$block1->form = "ctU";
$block1->openForm("../service_site/clienttaskdetail.php?id=$id#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="update">';
$block1->heading(lang_strings("client_change_status"));
$block1->openContent();
$block1->contentRow(lang_strings("status"), "<input value=\"Y\" name=\"st\" type=\"checkbox\" " . (($taskDetail->tas_status[0]==enumStatus::stClientCompleted)?'checked':'') . ">&nbsp;" . $status[enumStatus::stClientCompleted]);
setupInputHTML($block1, lang_strings("comments"), 'c', enumFieldType::ftMemo, 'N', '0', $taskDetail->tas_comments[0]);
setupCustomFieldsInputHTML($block1, 'tasks', $id, '0', true);
$block1->contentRow("&nbsp;", "<input name=\"submit\" type=\"submit\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->closeForm();
echo "<br><br>
<a href=\"showallclienttasks.php\">" . lang_strings("show_all") . "</a>";
require_once ("../includes/footer.php");

?>
