<?php // $Revision: 1.10 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editform.php,v 1.10 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$tblnamSession = isset($_SESSION['tblnamSession'])?$_SESSION['tblnamSession']:'';
$allformPage = (($projectSession=='')?'myforms':'showallforms');
$tbldispnam = tableNameString($tblnamSession);
$error = '';

/**
 * Permission check
 */
if ($projectSession == '') {
    // check form published for client
    $querymore = " LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.organization=ogf.organization WHERE mem.id='$idSession' AND ogf.tablename='$tblnamSession'";
    $organizationFormDetail = new request();
    $organizationFormDetail->openOrganizationForms($querymore);
    $comptOrganizationFormDetail = count($organizationFormDetail->ogf_id);

    if ($comptOrganizationFormDetail == '0') {
        header('Location: myforms.php?msg=permissiondenied');
        exit;
    }

    // check permit client user to edit form
    if ($organizationFormDetail->ogf_modenabled[0] != 'Y') {
        header('Location: myforms.php?msg=permissiondenied');
        exit;
    }
} else {
    // check if this is a project form and publish enabled
    $querymore = " WHERE pfm.project='$projectSession' AND pfm.tablename='$tblnamSession' AND pfm.publishenabled='Y'";
    $projectFormDetail = new request();
    $projectFormDetail->openProjectsForm($querymore);
    $comptProjectFormDetail = count($projectFormDetail->pfm_project);

    if ($comptProjectFormDetail == '0') {
        header('Location: showallforms.php?msg=permissiondenied');
        exit;
    }
}

// check form template publish enabled and not a system table
$querymore = " WHERE tdf.tablename='$tblnamSession' AND tdf.sysdef='N' AND tdf.publishenabled='Y'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore);
$comptTableDefinitionDetail = count($tableDefinitionDetail->tdf_tablename);

if ($comptTableDefinitionDetail == '0') {
    header('Location: ' . $allformPage . '.php?msg=permissiondenied');
    exit;
}

// check if form record exists
$querymore = " WHERE f.id='$id' AND f.published='" . enumPublished::pbYes . "'";

if ($projectSession != '') {
    $querymore .= " AND f.project='$projectSession'";
}

$formDetail = new request();
$formDetail->openForms($tblnamSession, $querymore);

if ($formDetail->row_count == '0') {
    header('Location: ' . $allformPage . '.php?msg=permissiondenied');
    exit;
}

// check if there are form fields published
$tmpquery = "SELECT fdf.tablename FROM " . $tablePrefix . "fields_def fdf WHERE fdf.tablename='$tblnamSession' AND fdf.sysdef='N' AND fdf.published='" . enumPublished::pbYes . "'";
$comptCF = compt($tmpquery);

/**
 * Actions
 */
if ($action == "update") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $cfsql = setupCustomFieldsUpdateSQL($tblnamSession, $id, '0', true);  // Generate custom fields update sql
        $dbtblnam = $tablePrefix . $tableDefinitionDetail->tdf_dbtablename[0];
        $status = enumFileStatus::stNoApprovalsNeeded;
        $tmpsql = "UPDATE $dbtblnam SET status='$status',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        updateFormDetails($requestAct, $id, $formDetail->rows[0]['project']);
        $num = $id;
        $producer = $idSession;
        $doctype = $tblnamSession;
        require('../approvals/updatedocument.php');
        $querymore5 = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtForm . "' AND fil.doc_type_ex='$tblnamSession' AND fil.doc_id='$id'";
        $listFiles = clone $requestAct;
        $listFiles->openFiles($querymore5);

        if (count($listFiles->fil_id) > 0) {
            $tmpsql = 'UPDATE ' . $tablePrefix . "files SET status='$status' WHERE doc_type='" . enumFileRelatedDocumentType::dtForm . "' AND doc_type_ex='$tblnamSession' AND doc_id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        if ($projectSession == '') {
            $querymore = " WHERE fil.id='1'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtForm, $id, enumFileStatus::stNoApprovalsNeeded, '1', $path, $tblnamSession);
        } else {
            $querymore = " WHERE fil.id='" . $projectDetail->pro_upload_dir[0] . "'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtForm, $id, enumFileStatus::stNoApprovalsNeeded, $projectDetail->pro_upload_dir[0], $path, $tblnamSession);
        }

        if ($tableDefinitionDetail->tdf_history[0] == 'Y') {
            copy2HistoryTable($requestAct, $tblnamSession, $id, 'U');
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: ' . $allformPage . '.php?msg=update');
        exit;
    }
}

/**
 * Html
 */
require_once ("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($projectSession == '') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myforms.php?topPage=true', lang_strings("my_forms"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myforms.php?', $tbldispnam, 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?topPage=true', lang_strings("my_projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?', $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('showallforms.php?topPage=true', lang_strings('forms'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('showallforms.php?', $tbldispnam, 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink('formdetail.php?id=' . $id, HtmlEntityDecodeNOD($formDetail->rows[0]['description']), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('edit_form'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "edF";
$block1->openForm("../service_site/editform.php?id=$id#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="update">';
$block1->heading(lang_strings('edit_form') . ':' . HtmlEntityDecodeNOD($formDetail->rows[0]['description']));

if ($comptCF < 10) {
    $block1->openContent();
} else {
    $block1->openContent(true);
}

setupCustomFieldsInputHTML($block1, $tblnamSession, $id, '0', true);
$block1->closeContent();
setupFormDetailsInputHTML($tblnamSession, $id, true);
$block1->openContent();
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();

if ($fileManagement == 'true') {
    setupProjectsSiteAttachFilesHTML();
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once ("../includes/footer.php");
