<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: formdetail.php,v 1.7 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$tblnamSession = isset($_SESSION['tblnamSession'])?$_SESSION['tblnamSession']:'';
$allformPage = (($projectSession=='')?'myforms':'showallforms');
$tbldispnam = tableNameString($tblnamSession);

/**
 * Permission check
 */
if ($projectSession == '') {
    // check form published for client
    $querymore = " LEFT OUTER JOIN " . $tablePrefix . "members mem ON mem.organization=ogf.organization WHERE mem.id='$idSession' AND ogf.tablename='$tblnamSession'";
    $organizationFormDetail = new request();
    $organizationFormDetail->openOrganizationForms($querymore);
    $comptOrganizationFormDetail = count($organizationFormDetail->ogf_id);

    if ($comptOrganizationFormDetail == '0') {
        header('Location: myforms.php?msg=permissiondenied');
        exit;
    }
} else {
    // check if this is a project form and publish enabled
    $querymore = " WHERE pfm.project='$projectSession' AND pfm.tablename='$tblnamSession' AND pfm.publishenabled='Y'";
    $projectFormDetail = new request();
    $projectFormDetail->openProjectsForm($querymore);
    $comptProjectFormDetail = count($projectFormDetail->pfm_project);

    if ($comptProjectFormDetail == '0') {
        header('Location: showallforms.php?msg=permissiondenied');
        exit;
    }
}

// check form template publish enabled and not a system table
$querymore = " WHERE tdf.tablename='$tblnamSession' AND tdf.sysdef='N' AND tdf.publishenabled='Y'";
$tableDefinitionDetail = new request();
$tableDefinitionDetail->openTablesDefinitions($querymore);
$comptTableDefinitionDetail = count($tableDefinitionDetail->tdf_tablename);

if ($comptTableDefinitionDetail == '0') {
    header('Location: ' . $allformPage . '.php?msg=permissiondenied');
    exit;
}

// check if form record exists
$querymore = " WHERE f.id='$id' AND f.published='" . enumPublished::pbYes . "'";

if ($projectSession != '') {
    $querymore .= " AND f.project='$projectSession'";
}

$formDetail = new request();
$formDetail->openForms($tblnamSession, $querymore);

if ($formDetail->row_count == '0') {
    header('Location: ' . $allformPage . '.php?msg=permissiondenied');
    exit;
}

// num. of custom fileds
$tmpquery = "SELECT fdf.tablename FROM " . $tablePrefix . "fields_def fdf WHERE fdf.tablename='$tblnamSession' AND fdf.sysdef='N'";
$comptCF = compt($tmpquery);

// num. of published child forms(detail)
$tmpquery = "SELECT tdf.tablename FROM " . $tablePrefix . "tables_def tdf WHERE tdf.tablename='$tblnamSession' AND tdf.publishenabled='Y'";
$comptCT = compt($tmpquery);

// linked content (attachments)
$querymoreAttach = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtForm . "' AND fil.doc_type_ex='$tblnamSession' AND fil.doc_id='$id' AND fil.vc_parent='0'";
$listFiles = new request();
$listFiles->openFiles($querymoreAttach);
$comptListFiles = count($listFiles->fil_id);

/**
 * Html
 */
require_once ("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($projectSession == '') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myforms.php?topPage=true', lang_strings("my_forms"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myforms.php?', $tbldispnam, 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?topPage=true', lang_strings("my_projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?', $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('showallforms.php?topPage=true', lang_strings('forms'), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink('showallforms.php?', $tbldispnam, 'in'));
}

$blockPage->itemBreadcrumbs(HtmlEntityDecodeNOD($formDetail->rows[0]['description']));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->heading($tbldispnam . ' : ' . HtmlEntityDecodeNOD($formDetail->rows[0]['description']));
$block1->openContent();
$block1->contentRow(lang_strings("id"), $formDetail->rows[0]['id']);
$block1->contentRow(lang_strings("created"), createDate($formDetail->rows[0]['created'], 'both'));
$block1->contentRow(lang_strings("created_by"), $block1->buildLink($formDetail->rows[0]['cuser_email_work'], $formDetail->rows[0]['cuser_name'], 'mail'));

if ($formDetail->rows[0]['muser'] != '0') {
    $block1->contentRow(lang_strings("modified"), createDate($formDetail->rows[0]['modified'], 'both'));
    $block1->contentRow(lang_strings("modified_by"), $block1->buildLink($formDetail->rows[0]['muser_email_work'], $formDetail->rows[0]['muser_name'], 'mail'));
}

$block1->closeContent();

if ($comptCF > 0) {
    if ($comptCF < 10) {
        $block1->openContent();
    } else {
        $block1->openContent(true);
    }

    setupCustomFieldsHTML($block1, $tblnamSession, $id, true);
    $block1->closeContent();
}

if ($comptCT > 0) {
    $block1->form = 'fmD';
    setupFormDetailsHTML($block1, $tblnamSession, $id, true, false, "../service_site/formdetail.php?id=$id#");
}

if ($comptListFiles > 0) {
    $block1->openContent();
    $block1->contentRow('', setupAttachListHTML($querymoreAttach));
    $block1->closeContent();
}

if ($projectSession != '' || $organizationFormDetail->ogf_modenabled[0] == 'Y') {
    $block1->heading($block1->buildLink('editform.php?id=' . $id, lang_strings("edit_form"), 'in'));
}

require_once ("../includes/footer.php");
