<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: graphtasks.php,v 1.4 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/jpgraph/jpgraph.php');
require_once('../includes/jpgraph/jpgraph_gantt.php');
require_once('../includes/library.php');

/**
 * Variables init
 */
$project = $projectSession;
$tasks = AddSlashesNOD(isset($_REQUEST['tasks'])?$_REQUEST['tasks']:'0');
$base = isset($_REQUEST['base'])?$_REQUEST['base']:'1';
$gantt_sd = isset($_REQUEST['gantt_sd'])?$_REQUEST['gantt_sd']:'';

/**
 * Permission check
 */
if ($gantt_sd == '') {
    exit;
}

$querymore = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    exit;
}

/**
 * Prepare data
 */
$tasks = "'" . str_replace('**', "','", $tasks) . "'";
$projectDetail->pro_name[0] = str_replace('&quot;', '"', $projectDetail->pro_name[0]);
$projectDetail->pro_name[0] = str_replace("&#39;", "'", $projectDetail->pro_name[0]);
$tmpquery = "SELECT MIN(start_date),MAX(due_date) FROM " . $tablePrefix . "tasks WHERE (id IN ($tasks) OR (project='$project' AND published='" . enumPublished::pbYes . "' AND milestone='" . enumMilestone::msYes . "')) AND start_date<>'0' AND due_date<>'0'";
$weekday_sd = date('w', $gantt_sd);

if ($weekday_sd != '1') {
    if ($weekday_sd == '0') {
        $gantt_sd = mktime(0, 0, 0, intval(date('m',$gantt_sd)), intval(date('d',$gantt_sd))-6, intval(date('Y',$gantt_sd)));
    } else {
        $gantt_sd = mktime(0, 0, 0, intval(date('m',$gantt_sd)), intval(date('d',$gantt_sd))-intval($weekday_sd)+1, intval(date('Y',$gantt_sd)));
    }
}

if ($base == '1') {
    $gantt_dd = mktime(0, 0, 0, intval(date('m',$gantt_sd))+6, intval(date('d',$gantt_sd))-1, intval(date('Y',$gantt_sd)));
} else {
    $gantt_dd = mktime(0, 0, 0, intval(date('m',$gantt_sd))+2, intval(date('d',$gantt_sd))-1, intval(date('Y',$gantt_sd)));
}

$weekday_dd = date('w', mktime(0, 0, 0, intval(date('m',$gantt_dd)), intval(date('d',$gantt_dd)), intval(date('Y',$gantt_dd))));

if ($weekday_dd != '0') {
    $gantt_dd = mktime(0, 0, 0, intval(date('m',$gantt_dd)), intval(date('d',$gantt_dd))-intval($weekday_dd)+7, intval(date('Y',$gantt_dd)));
}

$tmpquery .= " AND start_date<'" . mktime(0, 0, 0, intval(date('m',$gantt_dd)), intval(date('d',$gantt_dd))+1, intval(date('Y',$gantt_dd))) . "' AND due_date>='" . mktime(0,0,0,intval(date('m',$gantt_sd)),intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd))) . "'";
$boundaries = new request();
$boundaries->connectClass();
$boundaries->query($tmpquery);

if ($boundaries->fetch()) {
    $start_date_b = ($row[0]);
    $due_date_b = ($row[1]);
} else {
    exit;
}

$boundaries->close();
// set up the graph
$graph = new GanttGraph();
$graph->SetBox();
$graph->SetShadow();
$graph->SetMargin(20,20,20,20);
$graph->SetMarginColor('gainsboro');
// Set the Locale if you get errors with your environment
//$graph->scale->SetDateLocale('C');
// Add title
$graph->title->Set(' ' . $projectDetail->pro_name[0]);
$graph->title->SetFont(GRAPH_TITLE_FONT,GRAPH_TITLE_FONT_STYLE,12);
$graph->title->SetMargin(10);
$graph->title->SetBox('linen');
$graph->title->SetShadow();
// month and week scales are always displayed
$graph->scale->month->Show(true);
$graph->scale->week->Show(true);

// Condensed Gantt or not?
if ($_GET['base'] == true) {
    $graph->scale->year->Show(true);
    $graph->scale->day->Show(false);
    $graph->scale->month->SetStyle(MONTHSTYLE_SHORTNAME);
} else {
    $graph->scale->year->Show(false);
    $graph->scale->day->Show(true);
    $graph->scale->month->SetStyle(MONTHSTYLE_SHORTNAMEYEAR4);
}

// week scale properties
$graph->scale->week->SetStyle(WEEKSTYLE_FIRSTDAY);
$graph->scale->week->SetFont(GRAPH_WEEK_FONT);
// month scale properties
$graph->scale->month->SetFontColor('white');
$graph->scale->month->SetBackgroundColor('steelblue4');
// year scale properties
$graph->scale->year->SetFontColor('white');
$graph->scale->year->SetBackgroundColor('steelblue4');
// Modify the appearance of the dividing lines
$graph->scale->divider->SetWeight(4);
$graph->scale->divider->SetColor('steelblue4');
$graph->scale->dividerh->SetWeight(1);
$graph->scale->dividerh->SetColor('black');
$graph->SetBox(true,'black',1);
// holiday scale properties
$querymore = " WHERE wcd.workcalendar='" . $projectDetail->pro_workcalendar[0] . "' AND wcd.date>='" . mktime(0,0,0,intval(date('m',$start_date_b)),intval(date('d',$start_date_b)),intval(date('Y',$start_date_b))) . "' AND wcd.date<'" . mktime(0,0,0,intval(date('m',$due_date_b)),intval(date('d',$due_date_b))+1,intval(date('Y',$due_date_b))) . "' AND wcd.hours='0'";
$holidayList = new request();
$holidayList->openWorkCalendarsDetail($querymore);
$comptHolidayList = count($holidayList->wcd_id);

for ($i = 0;$i < $comptHolidayList;$i++) {
    $graph->scale->holidays[] = $holidayList->wcd_date[$i];
}

// webTareas footer, please don't remove
$graph->footer->right->Set('Created by webTareas');
$graph->footer->right->SetColor('gray6');
$graph->footer->right->SetFont(FF_FONT1);
// Column Titles
$graph->scale->actinfo->SetColTitles(array($strings['name'],$strings['duration']));
$graph->scale->actinfo->SetBackgroundColor('steelblue4');
$graph->scale->actinfo->SetFontColor('white');
$graph->scale->actinfo->SetFont(GRAPH_ACTINFO_FONT,GRAPH_ACTINFO_FONT_STYLE);
// query for data
$tmpqueryC = " WHERE (tas.id IN ($tasks) OR (tas.project='$project' AND tas.published='" . enumPublished::pbYes . "' AND tas.milestone='" . enumMilestone::msYes . "')) AND tas.start_date<>'0' AND tas.due_date<>'0' AND tas.start_date<'" . mktime(0, 0, 0, intval(date('m',$gantt_dd)), intval(date('d',$gantt_dd))+1, intval(date('Y',$gantt_dd))) . "' AND tas.due_date>='" . mktime(0,0,0,intval(date('m',$gantt_sd)),intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd))) . "'";
$tmpqueryS = " ORDER BY tas.due_date";
$listTasks = new request();
$listTasks->openHierarchyOfTasks($tmpqueryC, $tmpqueryS);
$comptListTasks = count($listTasks->tas_id);

for ($i = 0;$i < $comptListTasks;$i++) {
    $listTasks->tas_name[$i] = str_replace('&quot;', '"', $listTasks->tas_name[$i]);
    $listTasks->tas_name[$i] = str_replace("&#39;", "'", $listTasks->tas_name[$i]);
    $progress = round($listTasks->tas_completion[$i] / 10, 2);
    $printProgress = $listTasks->tas_completion[$i] * 10;

    // get the duration in hours for this task
    if ($listTasks->tas_estimated_time[$i] == "") {
        $duration = diff_hour($listTasks->tas_start_date[$i], $listTasks->tas_due_date[$i], $projectDetail->pro_workcalendar[0]);
    } else {
        $duration = $listTasks->tas_estimated_time[$i] ;
    }

    // get actual time for task
    $taskActualTime = new request();
    $actualTime = $taskActualTime->getTaskTime($listTasks->tas_id[$i]);
    $duration_label = sprintf("%s / %sh", $actualTime, $duration);
    $start_date = ($listTasks->tas_start_date[$i]<$gantt_sd)?$gantt_sd:$listTasks->tas_start_date[$i];
    $due_date = ($listTasks->tas_due_date[$i]>$gantt_dd)?$gantt_dd:$listTasks->tas_due_date[$i];

    // build an activity group
    if ($listTasks->tas_task_group[$i]==enumTaskGroup::tgYes) {
        $activity = new GanttBar($i, array($listTasks->tas_name[$i],$duration_label), date('Y-m-d',$start_date), date('Y-m-d',$due_date));

        if (constant("ACTIVITY_TITLE_FONT") != "") {
            $activity->title->SetFont(ACTIVITY_TITLE_FONT);
        }

        if ($start_date == $listTasks->tas_start_date[$i]) {
            $activity->leftMark->Show();
            $activity->leftMark->SetType(MARK_LEFTTRIANGLE);
            $activity->leftMark->SetWidth(6);
            $activity->leftMark->SetColor('black');
            $activity->leftMark->SetFillColor('black');
        }

        if ($due_date == $listTasks->tas_due_date[$i]) {
            $activity->rightMark->Show();
            $activity->rightMark->SetType(MARK_RIGHTTRIANGLE);
            $activity->rightMark->SetWidth(6);
            $activity->rightMark->SetColor('black');
            $activity->rightMark->SetFillColor('black');
        }

        $activity->SetHeight(0.3);
        $activity->SetPattern(BAND_SOLID,'black');
    // build an activity bar
    } else if ($listTasks->tas_milestone[$i] != enumMilestone::msYes) {
        $activity = new GanttBar($i, array($listTasks->tas_name[$i],$duration_label), date('Y-m-d',$start_date), date('Y-m-d',$due_date));
        $activity->SetPattern(BAND_LDIAG, 'lightblue');
        $activity->caption->Set($printProgress . '%');
        $activity->caption->SetFont(ACTIVITY_CAPTION_FONT);

        if (constant("ACTIVITY_TITLE_FONT") != "") {
            $activity->title->SetFont(ACTIVITY_TITLE_FONT);
        }

        $activity->SetFillColor('gray');

        if ($listTasks->tas_priority[$i] == enumPriority::prHigh || $listTasks->tas_priority[$i] == enumPriority::prVeryHigh) {
            $activity->progress->SetPattern(BAND_SOLID, '#BB0000');
        } else {
            $activity->progress->SetPattern(BAND_SOLID, '#0000BB');
        }

        $activity->progress->Set($progress);
    // build a milestone
    } else {
        $activity = new MileStone($i, array($listTasks->tas_name[$i],""), date('Y-m-d',$start_date));

        if (constant("ACTIVITY_TITLE_FONT") != "") {
            $activity->title->SetFont(ACTIVITY_TITLE_FONT);
        }
    }

    // query for successors
    $tmpquery = " WHERE pre.predecessor='" . $listTasks->tas_id[$i] . "'";
    $listSuccessor = new request();
    $listSuccessor->openTaskPredecessor($tmpquery);
    $comptListSuccessor = count($listSuccessor->pre_id);

    if ($comptListSuccessor!="0") {
        // set constrains
        for ($j=0;$j<$comptListSuccessor;$j++) {
            for ($k=0;$k<$comptListTasks;$k++) {
                if ($listSuccessor->pre_task[$j]==$listTasks->tas_id[$k]) {
                    break;
                }
            }

            if ($k==$comptListTasks) {
                continue;
            }

            switch ($listSuccessor->pre_type[$j]) {
                case "FF":
                    $activity->SetConstrain($k, CONSTRAIN_ENDEND);
                    break;
                case "FS":
                    $activity->SetConstrain($k, CONSTRAIN_ENDSTART);
                    break;
                case "SF":
                    $activity->SetConstrain($k, CONSTRAIN_STARTEND);
                    break;
                case "SS":
                    $activity->SetConstrain($k, CONSTRAIN_STARTSTART);
                    break;
            }
        }
    }

    $graph->Add($activity);

    // Condensed Gantt or not?
    if ($_GET['base'] == false) {
        // Responsible for formatting individual milestones
        if ($listTasks->tas_milestone[$i]==enumMilestone::msYes) {
            $activity = new GanttVLine(date('Y-m-d',$start_date));
            $graph->Add($activity);
        }
    }
}

$graph->Stroke();
