<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: meetingdetail.php,v 1.8 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$action = isset($_GET['action'])?$_GET['action']:'';
$mscid = AddSlashesNOD(isset($_GET['mscid'])?$_GET['mscid']:'');
$meeting = $id;

/**
 * Permission check
 */
$querymore1 = " WHERE mee.id='$id'";
$meetingDetail = new request();
$meetingDetail->openMeetings($querymore1);
$comptMeetingDetail = count($meetingDetail->mee_id);

if ($comptMeetingDetail == '0') {
    header("Location: home.php?error=blank_meeting");
    exit;
} else if ($meetingDetail->mee_project[0] != $projectSession) {
    header("Location: home.php?error=no_permissions");
    exit;
} else {
    $querymore2 = " WHERE mem.organization<>'1'";
    $listAttendees = new request();
    $listAttendees->openAttendees($querymore2);
    $comptListAttendees = count($listAttendees->att_meeting);

    if ($comptListAttendees == '0') {
        header("Location: home.php?error=no_permissions");
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'email') {
    if (!defined('INNER_NOTI_MEETMINUTE')) {
        define('INNER_NOTI_MEETMINUTE', 1);
    }

    require_once("../meetings/noti_meetingminutes.php");
    $msg = "email";
} else if ($action == 'confirm') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $querymore3 = " WHERE msc.id='$mscid'";
        $scheduleDetail = clone $requestAct;
        $scheduleDetail->openMeetingSchedule($querymore3);
        $tmpsql = "UPDATE " . $tablePrefix . "meetings SET status='" . enumMeetingStatus::stScheduled . "',start_time='" . $scheduleDetail->msc_start_time[0] . "',confirmed='" . time() . "',modified='" . time() . "',muser='$idSession' WHERE id='$meeting'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $querymore4 = " WHERE mav.meeting='$meeting' AND mav.schedule='$mscid'";
        $listAvailable = clone $requestAct;
        $listAvailable->openMeetingAvailable($querymore4);
        $comptListAvailable = count($listAvailable->mav_member);

        if ($comptListAvailable == '0') {
            $tmpsql = "UPDATE " . $tablePrefix . "attendees SET attended='" . enumBoolean::bTrue . "',authorized='" . enumBoolean::bTrue . "' WHERE meeting='$meeting' AND member='$idSession'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        } else {
            if (!in_array($idSession, $listAvailable->mav_member)) {
                $listAvailable->mav_member[] = $idSession;
            }

            foreach ($listAvailable->mav_member as $mem) {
                $tmpsql = "UPDATE " . $tablePrefix . "attendees SET attended='" . enumBoolean::bTrue . "',authorized='" . enumBoolean::bTrue . "' WHERE meeting='$meeting' AND member='$mem'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        copy2HistoryTable($requestAct, 'meetings', $meeting, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if (!defined('INNER_NOTI_MEETSCHED')) {
            define('INNER_NOTI_MEETSCHED', 1);
        }

        require_once("../meetings/noti_meetingscheduled.php");
        $querymore = " WHERE mee.id='$meeting'";
        $meetingDetail = new request();
        $meetingDetail->openMeetings($querymore);
        $msg = 'meetingConfirmed';
    }
} else if ($action == 'cancel') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "UPDATE " . $tablePrefix . "meetings SET status='" . enumMeetingStatus::stCanceled . "',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'meetings', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if (!defined('INNER_NOTI_MEETCANCEL')) {
            define('INNER_NOTI_MEETCANCEL', 1);
        }

        $num = $id;
        require_once("../meetings/noti_meetingcanceled.php");
        header("Location: showallmeetings.php?msg=cancelMeeting");
        exit;
    }
}

/**
 * Prepare data
 */
$idStatus = $meetingDetail->mee_status[0];
$idPriority = $meetingDetail->mee_priority[0];

if ($idStatus == enumMeetingStatus::stScheduling) {
    $querymore5 = " WHERE msc.meeting='$id' AND msc.canceled<>'" . enumBoolean::bTrue . "' ORDER BY msc.start_time";
    $listSchedules = new request();
    $listSchedules->openMeetingSchedule($querymore5);
    $comptListSchedules = count($listSchedules->msc_id);
    $querymore6 = " WHERE att.meeting='$id' ORDER BY mem.name";
    $listAttendees = new request();
    $listAttendees->openAttendees($querymore6);
    $comptListAttendees = count($listAttendees->att_meeting);
} else {
    $querymore7 = " WHERE att.meeting='$id' AND att.attended='" . enumBoolean::bTrue . "' ORDER BY mem.name";
    $listAttendees = new request();
    $listAttendees->openAttendees($querymore7);
    $comptListAttendees = count($listAttendees->att_meeting);
}

/**
 * Html
 */
$bouton[8] = "over";
require_once ("../includes/header.php");
$block1 = new block();
$block1->heading(lang_strings("meeting_details"));
$block1->openContent();
$block1->contentRow(lang_strings("name"), $meetingDetail->mee_name[0]);
$block1->contentRow(lang_strings("me_agenda"), $meetingDetail->mee_agenda[0]);
$block1->contentRow(lang_strings("me_location"), $meetingDetail->mee_location[0]);
$block1->contentRow(lang_strings("priority"), $priority[$idPriority]);
$block1->contentRow(lang_strings("status"), $statusMeeting[$idStatus]);
$block1->contentRow(lang_strings("duration"), sprintf("%.1f %s", $meetingDetail->mee_duration[0], lang_strings("hours")));

if ($idStatus == enumMeetingStatus::stScheduling) {
    $block1->contentTitle(lang_strings("proposed_dates_times"));
    echo "<table cellspacing=\"0\" width=\"90%\" border=\"0\" cellpadding=\"3\" cols=\"4\"><tr><th>&nbsp;<br>";

    if ($idStatus == enumMeetingStatus::stScheduling || ($idStatus == enumMeetingStatus::stScheduled && $meetingDetail->mee_start_time[0] >= time())) {
        echo '<input type="button" onclick="location.href=\'replymeetinginvitation.php?id=' . $id . '\'" value="' . $strings['reply_meetinginvitation'] . '">&nbsp;';
    }

    if ($idSession == $meetingDetail->mee_owner[0]) {
        echo '<input type="button" onclick="location.href=\'meetingdetail.php?action=cancel&id=' . $id . '\'" value="' . $strings['cancel'] . '">';
    }

    echo "</th>";

    for ($i=0; $i<$comptListSchedules; $i++) {
        echo '<th>' . createDate($listSchedules->msc_start_time[$i], 'both');

        if ($idSession == $meetingDetail->mee_owner[0]) {
            echo '<br><input type="button" onclick="location.href=\'meetingdetail.php?action=confirm&&id=' . $id . '&mscid=' . $listSchedules->msc_id[$i] . '\'" value="' . $strings['confirm'] . '">';
        }

        echo '</th>';
    }

    echo "</tr>";

    for ($i=0; $i<$comptListAttendees; $i++) {
        if ($idSession != $meetingDetail->mee_owner[0] && $idSession != $listAttendees->att_member[$i]) {
            continue;
        }

        if ($idSession == $meetingDetail->mee_owner[0]) {
            echo '<tr><td>' . $listAttendees->att_mem_name[$i] . '</td>';
        } else {
            echo '<tr><td></td>';
        }

        $querymore = " WHERE mav.meeting='$id' AND mav.member='" . $listAttendees->att_member[$i] . "' ORDER BY mav.schedule";
        $listMeetingAvailable = new request();
        $listMeetingAvailable->openMeetingAvailable($querymore);
        $comptListMeetingAvailable = count($listMeetingAvailable->mav_meeting);

        if ($listAttendees->att_authorized[$i] == enumBoolean::bFalse || $comptListMeetingAvailable == '0') {
            $c1 = (($listAttendees->att_authorized[$i] == enumBoolean::bFalse)?lang_strings('not_yet_responded'):lang_strings('unavailable'));

            for ($j=0; $j<$comptListSchedules; $j++) {
                echo '<td>' . $c1 . '</td>';
            }
        } else {
            for ($j=0; $j<$comptListSchedules; $j++) {
                if (in_array($listSchedules->msc_id[$j], $listMeetingAvailable->mav_schedule)) {
                    echo '<td>' . lang_strings('available') . '</td>';
                } else {
                    echo '<td>' . lang_strings('unavailable') . '</td>';
                }
            }
        }

        echo '</tr>';
    }

    echo '</table>';
} else {
    if ($meetingDetail->mee_start_time[0] <= time() && $idStatus != enumMeetingStatus::stCompleted && $idStatus != enumMeetingStatus::stCanceled) {
        $block1->contentRow(lang_strings("start_time"), "<b>" . createDate($meetingDetail->mee_start_time[0], 'both') . "</b>");
    } else {
        $block1->contentRow(lang_strings("start_time"), createDate($meetingDetail->mee_start_time[0], 'both'));
    }

    if ($idStatus != enumMeetingStatus::stScheduling && $idStatus != enumMeetingStatus::stCanceled && $comptListAttendees != '0') {
        $att_names_str = implode(" , ", $listAttendees->att_mem_name);
        $block1->contentRow(lang_strings("attendees"), $att_names_str);
    }

    $minutesContent = $meetingDetail->mee_minutes[0];

    if ($meetingDetail->mee_minutes[0] != '') {
        $minutesContent .= '<br><a href="meetingdetail.php?id=' . $id . '&action=email">' . lang_strings('send_meetingminutes') . '</a>';
    }

    $block1->contentRow(lang_strings("me_minutes"), $minutesContent);
    setupCustomFieldsHTML($block1, 'meetings', $id, true);
    $block1->closeContent();
    $block1->heading(lang_strings("updates_meeting"));
    $block1->openContent();
    $tmpquery = " WHERE upd.type='M' AND upd.item='$id' ORDER BY upd.created DESC";
    $listUpdates = new request();
    $listUpdates->openUpdates($tmpquery);
    $comptListUpdates = count($listUpdates->upd_id);
    echo "<tr class=\"odd\"><td valign=\"top\" class=\"leftvalue\">&nbsp;</td><td>";

    if ($comptListUpdates != "0") {
        for ($i=0,$j=1; $i<$comptListUpdates; $i++,$j++) {
            if ($i == 5) {
                echo "...<br>";
                break;
            }

            $upd_comm = $listUpdates->upd_comments[$i];

            if (preg_match("|\[status:([0-9])\]|i", $upd_comm, $matches) === 1) {
                $upd_comm = preg_replace_callback("|\[status:([0-9])\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
                $upd_comm .= lang_strings("status") . " " . $status[$matches[1]];
            }

            if (preg_match("|\[priority:([0-9])\]|i", $upd_comm, $matches) === 1) {
                $upd_comm = preg_replace_callback("|\[priority:([0-9])\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
                $upd_comm .= lang_strings("priority") . " " . $priority[$matches[1]];
            }

            if (preg_match("|\[location:(.)\]|i", $upd_comm, $matches) === 1) {
                $upd_comm = preg_replace_callback("|\[location:(.)\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
                $upd_comm .= lang_strings("location") . " " . $matches[1];
            }

            $abbrev = substr($upd_comm, 0, 100);
            echo "<b>" . $j . ".</b> <i>" . createDate($listUpdates->upd_created[$i], 'both') . "</i> $abbrev";

            if (100 < strlen($upd_comm)) {
                echo "...<br>";
            } else {
                echo "<br>";
            }
        }
    } else {
        echo lang_strings("no_items");
    }

    echo "</td></tr>";
}

$block1->closeContent();
echo "<br><br>
<a href=\"showallmeetings.php\">" . lang_strings("show_all") . "</a>";
require_once ("../includes/footer.php");
