<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: myprojects.php,v 1.5 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$updateProject = isset($_GET['updateProject'])?$_GET['updateProject']:'';
$topPage = isset($_GET['topPage'])?$_GET['topPage']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$error = isset($_GET['error'])?$_GET['error']:'';

if ($topPage == 'true') {
    $_SESSION['tblnamSession'] = null;
}

/**
 * Permission check
 */
if ($updateProject == "true" && $project != '') {
    $querymore = " WHERE tea.member='$idSession' AND pro.id='$project' AND pro.status IN ('" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "') AND pro.published='" . enumPublished::pbYes . "'";
    $testProject = new request();
    $testProject->openTeams($querymore);
    $comptTestProject = count($testProject->tea_project);

    if ($comptTestProject != "0") {
        $_SESSION['projectSession'] = null;
        // unset($_SESSION['projectSession']);
        $projectSession = $project;
        $_SESSION['projectSession'] = $projectSession;
        header("Location: myprojects.php");
        exit;
    } else {
        header("Location: myprojects.php?topPage=true");
        exit;
    }
}

/**
 * Prepare Data
 */
if ($projectSession == "" || $topPage == "true") {
    $querymore = " WHERE tea.member='$idSession' AND pro.status IN ('" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "') AND pro.published='" . enumPublished::pbYes . "' ORDER BY pro.name";
    $listProjects = new request();
    $listProjects->openTeams($querymore);
    $comptListProjects = count($listProjects->tea_project);
} else {
    $querymore1 = " LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.organization=org.id WHERE pro.id='$projectSession'";
    $clientDetail = new request();
    $clientDetail->openOrganizations($querymore1);
    $querymore2 = " WHERE pro.id='$projectSession'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore2);
    $querymore3 = " WHERE tea.project='$projectSession' AND tea.published='" . enumPublished::pbYes . "' ORDER BY mem.name";
    $listContacts = new request();
    $listContacts->openTeams($querymore3);
    $comptListTeams = count($listContacts->tea_project);
    $querymore4 = " WHERE mem2.organization='1' AND tas.project='$projectSession' AND tas.published='" . enumPublished::pbYes . "' ORDER BY tas.due_date";
    $listTasks = new request();
    $listTasks->openTasks($querymore4);
    $comptListTasks = count($listTasks->tas_id);
    $querymore5 = " WHERE note.project='$projectSession' AND note.published='" . enumPublished::pbYes . "' ORDER BY note.subject";
    $listNotes = new request();
    $listNotes->openNotes($querymore5);
    $comptListNotes = count($listNotes->note_id);
    $querymore6 = " WHERE mee.project='$projectSession' AND mee.status<>'" . enumMeetingStatus::stCanceled . "' AND EXISTS (SELECT att.meeting FROM " . $tablePrefix . "attendees att INNER JOIN " . $tablePrefix . "members mem1 ON mem1.id=att.member WHERE att.meeting=mee.id AND mem1.organization<>'1') ORDER BY mee.start_time DESC";
    $listMeetings = new request();
    $listMeetings->openMeetings($querymore6);
    $comptListMeetings = count($listMeetings->mee_id);
    $querymore7 = " WHERE pfm.project='$projectSession' AND pfm.publishenabled='Y' ORDER BY pfm.tablename";
    $listProjectForms = new request();
    $listProjectForms->openProjectsForm($querymore7);
    $comptListProjectForms = count($listProjectForms->pfm_project);
}

/**
 * Html
 */
require_once ("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($projectSession == "" || $topPage == "true") {
    $blockPage->itemBreadcrumbs(lang_strings("my_projects"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?topPage=true', lang_strings("my_projects"), 'in'));
    $blockPage->itemBreadcrumbs($projectDetail->pro_name[0]);
}

$blockPage->closeBreadcrumbs();

if ($projectSession == "" || $topPage == "true") {
    $block1 = new block();
    $block1->heading(lang_strings("my_projects"));

    if ($comptListProjects > 0) {
        $labels = array(lang_strings("name"), lang_strings("priority"), lang_strings("status"));
        $block1->openResults(false);
        $block1->labels($labels, "false", "false");

        for ($i=0; $i<$comptListProjects; $i++) {
            $block1->openRow();
            $idStatus = $listProjects->tea_pro_status[$i];
            $idPriority = $listProjects->tea_pro_priority[$i];
            $block1->cellRow($block1->buildLink("myprojects.php?updateProject=true&project=" . $listProjects->tea_pro_id[$i], $listProjects->tea_pro_name[$i], 'in'));
            $block1->cellRow($priority[$idPriority]);
            $block1->cellRow($statusProject[$idStatus]);
            $block1->closeRow();
        }

        $block1->closeResults();
    } else {
        $block1->noresults();
    }
} else {
    $pathLogo = getLogo($clientDetail->org_id[0], $clientDetail->org_extension_logo[0]);

    if ($pathLogo != '') {
        echo "<div><img src=\"$pathLogo\"></div>";
    }

    $block2 = new block();
    $block2->heading(lang_strings('information'));
    $block2->openContent();
    $block2->contentRow(lang_strings("name"), $projectDetail->pro_name[0]);
    $block2->contentRow(lang_strings("description"), $projectDetail->pro_description[0]);
    $idStatus = $projectDetail->pro_status[0];
    $idPriority = $projectDetail->pro_priority[0];
    $block2->contentRow(lang_strings("status"), $statusProject[$idStatus]);

    if ($idPriority != enumPriority::prNone) {
        $block2->contentRow(lang_strings("priority"), $priority[$idPriority]);
    }

    // Dispaly project active phase
    if ($projectDetail->pro_phase_set[0] != "0") {
        $pha = '';
        $querymore = " WHERE pha.project='" . $projectDetail->pro_id[0] . "' AND pha.status='" . enumPhaseStatus::stOpen . "'";
        $currentPhase = new request();
        $currentPhase->openPhases($querymore);
        $comptCurrentPhase = count($currentPhase->pha_id);

        if ($comptCurrentPhase == 0) {
            $pha = lang_strings("no_current_phase");
        } else {
            for ($i = 0;$i < $comptCurrentPhase;$i++) {
                if ($i != $comptCurrentPhase) {
                    $pnum = $i + 1;
                    $pha .= "$pnum." . $currentPhase->pha_description[$i] . "  ";
                }
            }
        }

        $block2->contentRow(lang_strings("current_phase"), $pha);
    }

    $block2->contentRow(lang_strings("created"), createDate($projectDetail->pro_created[0], 'both'));

    if ($projectDetail->pro_modified[0] != '0') {
        $block2->contentRow(lang_strings("modified"), createDate($projectDetail->pro_modified[0], 'both'));
    }

    setupCustomFieldsHTML($block2, 'projects', $projectDetail->pro_id[0], true);
    $block2->closeContent();
    $querymore = " WHERE tas.project='" . $projectDetail->pro_id[0] . "' AND tas.milestone='" . enumMilestone::msYes . "' AND tas.due_date<'" . mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y'))) . "' AND tas.status<>'" . enumStatus::stCompleted . "' AND tas.published='" . enumPublished::pbYes . "' ORDER BY tas.due_date";
    $listLate = new request();
    $listLate->openTasks($querymore);
    $comptListLate = count($listLate->tas_id);
    $querymore = " WHERE tas.project='" . $projectDetail->pro_id[0] . "' AND tas.milestone='" . enumMilestone::msYes . "' AND tas.due_date>='" . mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y'))) . "' AND tas.status<>'" . enumStatus::stCompleted . "' AND tas.published='" . enumPublished::pbYes . "' ORDER BY tas.due_date";
    $listUpcoming = new request();
    $listUpcoming->openTasks($querymore, 0, 1);
    $comptListUpcoming = count($listUpcoming->tas_id);

    if ($comptListLate > 0 || $comptListUpcoming > 0) {
        $block2->heading(lang_strings('milestones'));
        $block2->openContent();

        if ($comptListLate > 0) {
            $lateContent = '';

            for ($i=0; $i<$comptListLate; $i++) {
                if ($i>0) {
                    $lateContent .= '<br>';
                }

                $lateContent .= $listLate->tas_name[$i];

                if ($listLate->tas_assign_to[$i] != '0') {
                    $querymore = " AND tas.id='" . $listLate->tas_id[$i] . "' ORDER BY mem.name";
                    $listTaskHumanResources = new request();
                    $listTaskHumanResources->openTaskHumanResource($querymore);
                    $comptListTaskHumanResources = count($listTaskHumanResources->res_id);
                    $lateContent .= "&nbsp;&nbsp;" . lang_strings('assigned_to') . "&nbsp;" . implode(',', $listTaskHumanResources->res_mem_name);
                }

                $days = diff_date(time(), $listLate->tas_due_date[$i]) - 1;
                $lateContent .= "&nbsp;&nbsp;<b style=\"color: red;\">";

                if ($days == '1') {
                    $lateContent .= $strings['daylate1'];
                } else {
                    $lateContent .= str_replace('%N%', $days, $strings['daylaten']);
                }

                $latecontent .= '</b>';
            }

            $block2->contentRow(lang_strings('late'), $lateContent);
        }

        if ($comptListUpcoming > 0) {
            $upcomingContent = $listUpcoming->tas_name[0];

            if ($listUpcoming->tas_assign_to[0] != '0') {
                $querymore = " AND tas.id='" . $listUpcoming->tas_id[0] . "' ORDER BY mem.name";
                $listTaskHumanResources = new request();
                $listTaskHumanResources->openTaskHumanResource($querymore);
                $comptListTaskHumanResources = count($listTaskHumanResources->res_id);
                $upcomingContent .= "&nbsp;&nbsp;" . lang_strings('assigned_to') . "&nbsp;" . implode(',', $listTaskHumanResources->res_mem_name);
            }

            $days = diff_date($listUpcoming->tas_due_date[0], time()) - 1;
            $upcomingContent .= "&nbsp;&nbsp;<b>";

            if ($days == '0') {
                $upcomingContent .= $strings['due_today'];
            } else if ($days == '1') {
                $upcomingContent .= $strings['due_in_1_day'];
            } else {
                $upcomingContent .= str_replace('%N%', $days, $strings['due_in_n_days']);
            }

            $upcomingContent .= '</b>';
            $block2->contentRow(lang_strings('upcoming'), $upcomingContent);
        }

        $block2->closeContent();
    }

    $links = array();

    if ($comptListTeams > 0) {
        $links[] = $blockPage->buildLink('showallcontacts.php', lang_strings("project_team"), 'in');
    }

    if ($comptListTasks > 0) {
        $links[] = $blockPage->buildLink('showallteamtasks.php', lang_strings("team_tasks"), 'in');
    }

    if ($projectDetail->pro_organization[0] != "" && $projectDetail->pro_organization[0] != "1") {
        $links[] = $blockPage->buildLink('showallclienttasks.php', lang_strings("client_tasks"), 'in');
    }

    if ($fileManagement == "true") {
        $links[] = $blockPage->buildLink('doclists.php', lang_strings("document_list"), 'in');
    }

    $links[] = $blockPage->buildLink('showallthreadtopics.php', lang_strings("bulletin_board"), 'in');

    if ($enableHelpSupport == "true") {
        $links[] = $blockPage->buildLink('showallsupport.php', lang_strings("support"), 'in');
    }

    if ($comptListNotes > 0) {
        $links[] = $blockPage->buildLink('showallnotes.php', lang_strings("notes"), 'in');
    }

    if ($comptListMeetings > 0) {
        $links[] = $blockPage->buildLink('showallmeetings.php', lang_strings("meetings"), 'in');
    }

    if ($comptListProjectForms > 0) {
        $links[] = $blockPage->buildLink('showallforms.php', lang_strings("forms"), 'in');
    }

    $block2->heading(implode(' | ', $links));
    // -------------------------------------------------------------------------------------------
    $querymore = " WHERE tea.project='$projectSession' AND tea.member='" . $projectDetail->pro_owner[0] . "' AND tea.published='" . enumPublished::pbYes . "'";
    $detailContact = new request();
    $detailContact->openTeams($querymore);
    $comptDetailContact = count($detailContact->tea_project);

    if ($comptDetailContact != '0') {
        $block2->note(lang_strings("contact_projectsite") . ', ' . $block2->buildLink($projectDetail->pro_owner[0], '', 'message'));
    }
}

require_once ("../includes/footer.php");
