<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: newnotifications.php,v 1.4 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = isset($_GET['action'])?$_GET['action']:'';
$topPage = "";
$error = '';

/**
 * Actions
 */
if ($action == 'allread') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "UPDATE " . $tablePrefix . "messages SET seen='Y' WHERE to_id='$idSession' AND message_type='S' AND seen='N'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: newnotifications.php");
        exit;
    }
}

/**
 * Prepare data
 */
$querymore = " WHERE mes.to_id='$idSession' AND mes.message_type='S' AND mes.seen='N'";
$testUnread = new request();
$testUnread->openMessages($querymore, 0, 1);
$tmpquery1 = "SELECT mes.from_id,mem.name,mem.gender,mem.extension_picture,COUNT(mes.id) AS unread FROM " . $tablePrefix . "messages mes INNER JOIN " . $tablePrefix . "members mem ON mem.id=mes.from_id WHERE mes.to_id='$idSession' AND mes.message_type='P' AND mes.seen='N' GROUP BY mes.from_id,mem.name,mem.gender,mem.extension_picture";
$listUsers = new request();
$listUsers->connectClass();
$listUsers->query($tmpquery1);
$listUsers->mes_from_id = array();
$listUsers->mem_name = array();
$listUsers->mem_gender = array();
$listUsers->mem_extension_picture = array();
$listUsers->mes_unread = array();

while ($listUsers->fetch()) {
    $listUsers->mes_from_id[] = ($row[0]);
    $listUsers->mem_name[] = HtmlEntityDecodeNOD($row[1]);
    $listUsers->mem_gender[] = ($row[2]);
    $listUsers->mem_extension_picture[] = ($row[3]);
    $listUsers->mes_unread[] = ($row[4]);
}

$comptListUsers = count($listUsers->mes_from_id);

/**
 * Html
 */
require_once ("../includes/header.php");
$block0 = new block();
$block0->heading($strings['new_messages']);

if ($comptListUsers > 0) {
    echo '<div  class="user-unread-messages"><ul>';

    for ($i=0; $i<$comptListUsers; $i++) {
        $avatar = getAvatar($listUsers->mes_from_id[$i], $listUsers->mem_extension_picture[$i], $listUsers->mem_gender[$i]);
        echo '<li>'
            . '<img src="' . $avatar . '">'
            . '<span>' . $listUsers->mem_name[$i] . '</span>'
            . '<span>' . $listUsers->mes_unread[$i] . '</span>'
            . '<input type="hidden" value="' . $listUsers->mes_from_id[$i] . '">'
            . '</li>';
    }

    echo '</ul></div>';
} else {
    $block0->noresults();
}

$block1 = new block();
$block1->form = "lMN";
$block1->openForm('../service_site/newnotifications.php?#' . $block1->form . 'Anchor');
$x = $strings["new_notifications"];

if (count($testUnread->mes_id) > 0) {
    $x .= ' | ' . $block1->buildLink('../service_site/newnotifications.php?action=allread', $strings['mark_all_read'], 'in');
}

$block1->heading($x);
$querymore1 = " WHERE mes.to_id='$idSession' AND mes.message_type='S' AND mes.archived='N' ORDER BY mes.seen,mes.created DESC";
$listMessages = new request();
$listMessages->openMessages($querymore1, '0', '100');
$comptListMessages = count($listMessages->mes_id);

if ($comptListMessages > 0) {
    $labels = array($strings['from'], $strings['subject'], $strings['created']);
    $block1->openResults(false);
    $block1->labels($labels, 'false', 'false');

    for ($i=0; $i<$comptListMessages; $i++) {
        $block1->openRow();
        $block1->cellRow($block1->buildLink($listMessages->mes_from_id[$i], '', 'message'));

        if ($listMessages->mes_seen[$i] == 'Y') {
            $sub = $listMessages->mes_subject[$i];
        } else {
            $sub = '<b>' . $listMessages->mes_subject[$i] . '</b>';
        }

        $block1->cellRow($block1->buildLink('../service_site/viewnotification.php?id=' . $listMessages->mes_id[$i], $sub, 'in'));
        $block1->cellRow(createDate($listMessages->mes_created[$i], 'both', true));
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

require_once ("../includes/footer.php");
