<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: showallthreads.php,v 1.4 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'';
$post = isset($_GET['post'])?$_GET['post']:'';
$action = ($js_enabled == 'Y' && isset($_REQUEST['action']))?$_REQUEST['action']:'';
$topPage = '';
$error = '';

/**
 * Permission check
 */
$querymore = " WHERE topic.id='$id'";
$detailTopic = new request();
$detailTopic->openTopics($querymore);

if ($detailTopic->top_published[0] != enumPublished::pbYes || $detailTopic->top_project[0] != $projectSession) {
    header('Location: index.php');
    exit;
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $detailTopic->top_posts[0] = $detailTopic->top_posts[0] - 1;
        copy2HistoryTable($requestAct, 'posts', $post, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "posts WHERE id='$post'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "UPDATE " . $tablePrefix . "topics SET posts='" . $detailTopic->top_posts[0] . "' WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'topics', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: showallthreads.php?id=$id");
        exit;
    }
}

/**
 * Prepare data
 */
$querymore = " WHERE pos.topic='" . $detailTopic->top_id[0] . "' ORDER BY pos.created DESC";
$listPosts = new request();
$listPosts->openPosts($querymore);
$comptListPosts = count($listPosts->pos_id);

/**
 * Html
 */
require_once ("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?topPage=true', lang_strings("my_projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?', $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('showallthreadtopics.php?', lang_strings('bulletin_board'), 'in'));
$blockPage->itemBreadcrumbs($detailTopic->top_subject[0]);
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->heading(lang_strings("bulletin_board_topic") . ' : ' . $detailTopic->top_subject[0]);
$idStatus = $detailTopic->top_status[0];
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("owner"), $blockPage->buildLink($detailTopic->top_mem_email_work[0], $detailTopic->top_mem_name[0], 'mail'));
$block1->contentRow(lang_strings("retired"), $statusTopicBis[$idStatus]);
$block1->contentRow(lang_strings("posts"), $detailTopic->top_posts[0]);
$block1->contentRow(lang_strings("last_post"), createDate($detailTopic->top_last_post[0], 'both'));
setupCustomFieldsHTML($block1, 'topics', $id, true);
$block1->contentTitle(lang_strings("discussion"));
$block1->contentRow("", $blockPage->buildLink("threadpost.php?id=$id", lang_strings("post_reply"), 'in'));

for ($i=0; $i<$comptListPosts; $i++) {
    $block1->contentRow('');
    $block1->contentRow(lang_strings("posted_by"), $blockPage->buildLink($listPosts->pos_mem_email_work[$i], $listPosts->pos_mem_name[$i], "mail"));

    if ($listPosts->pos_created[$i] > $lastvisiteSession) {
        $block1->contentRow(lang_strings("when"), "<b>" . createDate($listPosts->pos_created[$i], 'both') . "</b>");
    } else {
        $block1->contentRow(lang_strings("when"), createDate($listPosts->pos_created[$i], 'both'));
    }

    if ($projectDetail->pro_owner[0] == $idSession || $listPosts->pos_member[$i] == $idSession) {
        $block1->contentRow($blockPage->buildLink("../service_site/showallthreads.php?id=$id&amp;action=delete&amp;post=" . $listPosts->pos_id[$i], lang_strings("delete_message"), 'in'), $listPosts->pos_message[$i]);
    } else {
        $block1->contentRow('', $listPosts->pos_message[$i]);
    }

    setupCustomFieldsHTML($block1, 'posts', $listPosts->pos_id[$i], true);
    $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtDiscussion . "' AND fil.doc_id='" . $listPosts->pos_id[$i] . "' AND fil.vc_parent=0 ORDER BY fil.name";
    $block1->contentRow('', setupAttachListHTML($querymore));
}

$block1->closeContent();
require_once ("../includes/footer.php");
