<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: uploadfile.php,v 1.5 2013/01/29 08:46:14 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$att1 = isset($_POST['atttmp1'])?$_POST['atttmp1']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$ver = isset($_POST['ver'])?$_POST['ver']:'';
$error = '';
$topPage = '';

/**
 * Permission check
 */
$querymore = " WHERE pro.id='$projectSession'";
$projectDetail = new request();
$projectDetail->openProjects($querymore);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail <= 0) {
    header('Location: index.php');
    exit;
}

/**
 * Check fields
 */
if ($action == 'add') {
    if ($att1 == '') {
        $error = lang_strings("no_file");
    }

    if ($error == '') {
        $error = checkCustomFields('files', '', '0', true);
    }
}

/**
 * Actions
 */
if ($action == "add" && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($ver == "") {
            $ver = "1.0";
        } else if (strstr($ver, '.') === false) {
            $ver = sprintf('%d.0', intval($ver));
        } else {
            list($major, $minor) = explode('.', $ver);
            $ver = sprintf('%d.%d', intval($major), intval($minor));
        }

        $num = uploadSingleFile($requestAct, '1', enumFileRelatedDocumentType::dtProject, '', $projectSession, $projectDetail->pro_upload_dir[0], $folderDetail->fil_fullname[0], $ver, '0', $c, enumPublished::pbYes, '0', true);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header('Location: doclists.php');
        exit;
    }
}

if ($error == '') {
    $ver = '1.0';
}

/**
 * Html
 */
require_once ("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?topPage=true', lang_strings("my_projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('myprojects.php?', $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('doclists.php', lang_strings('document_list'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("upload_file"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "adF";
$block1->openForm("../service_site/uploadfile.php?#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="add">';
$block1->heading(lang_strings("upload_file"));
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow("*&nbsp;" . lang_strings("upload"), setupUploadFileHTML('1', '', true));
setupInputHTML($block1, lang_strings('comments'), 'c', enumFieldType::ftMemo, 'N', '0', $c);
setupInputHTML($block1, lang_strings('vc_version'), 'ver', array(enumFieldType::ftText, enumFieldOption::foVersionNumber), 'N', '255', $ver);
setupCustomFieldsInputHTML($block1, 'files');
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once ("../includes/footer.php");
