<?php // $Revision: 1.14 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteservices.php,v 1.14 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Service']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$idSet = "'" . str_replace("**", "','", $id) . "'";
$tmpquery = "SELECT tas.id FROM " . $tablePrefix . "tasks tas WHERE tas.service IN ($idSet)";
$tmpquery .= " UNION ALL ";
$tmpquery .= "SELECT tim.id FROM " . $tablePrefix . "tasks_time tim WHERE tim.service IN ($idSet)";
$tmpquery .= " UNION ALL ";
$tmpquery .= "SELECT wkh.id FROM " . $tablePrefix . "work_hours wkh WHERE wkh.service IN ($idSet)";
$tmpquery .= " UNION ALL ";
$tmpquery .= "SELECT hrt.id FROM " . $tablePrefix . "hour_type hrt WHERE hrt.service IN ($idSet)";
$tmpquery .= " UNION ALL ";
$tmpquery .= "SELECT hrc.id FROM " . $tablePrefix . "hour_code hrc WHERE hrc.service IN ($idSet)";

if (compt($tmpquery) > 0) {
    header("Location: ../services/listservices.php?msg=serviceInUse");
    exit;
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'services', $idSet, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "services WHERE id IN ($idSet)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../services/listservices.php?msg=delete");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=accounting", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../services/listservices.php?", lang_strings("service_management"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_services"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "deS";
$block1->openForm("../services/deleteservices.php?id=$id#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings("delete_services"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));
$querymore = " WHERE serv.id IN ($idSet) ORDER BY serv.name";
$listServices = new request();
$listServices->openServices($querymore);
$comptListServices = count($listServices->serv_id);

for ($i=0; $i<$comptListServices; $i++) {
    $block1->contentRow('#' . $listServices->serv_id[$i], $listServices->serv_name[$i] . ' (' . $listServices->serv_name_print[$i] . ')');
}

$block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
