<?php // $Revision: 1.26 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editservice.php,v 1.26 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');
$bodyCommand = "onLoad=\"document.svEForm.n.focus();\"";

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$cpy = isset($_GET['cpy'])?$_GET['cpy']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$n = isset($_POST['n'])?$_POST['n']:'';                         // name
$np = isset($_POST['np'])?$_POST['np']:'';                      // name print
$hr = isset($_POST['hr'])?$_POST['hr']:'';                      // hourly rate
$hri = isset($_POST['hri'])?$_POST['hri']:'';                   // internal hourly rate
$curr = isset($_POST['curr'])?$_POST['curr']:$defaultCurrency;  // currency
$l = isset($_POST['l'])?$_POST['l']:'';                         // locked
$hr_highlight = false;
$hri_highlight = false;
$lk = DbValueEncode(enumFieldType::ftBoolean, $l);
$error = '';
$serviceInUse = false;

/**
 * Permission check
 */
if ($id != "") {
    if ($cpy != 'true') {
        if (!$SW_Permissions['Service']['Edit'][$profilSession]) {
            header("Location: ../general/permissiondenied.php");
            exit;
        }
    } else {
        if (!$SW_Permissions['Service']['Write'][$profilSession]) {
            header("Location: ../general/permissiondenied.php");
            exit;
        }
    }

    $querymore = " WHERE serv.id='$id'";
    $detailService = new request();
    $detailService->openServices($querymore);
    $comptDetailService = count($detailService->serv_id);

    if ($comptDetailService == '0') {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $tmpquery = "SELECT tas.id FROM " . $tablePrefix . "tasks tas WHERE tas.service='$id'";
    $tmpquery .= " UNION ALL ";
    $tmpquery .= "SELECT tim.id FROM " . $tablePrefix . "tasks_time tim WHERE tim.service='$id'";
    $tmpquery .= " UNION ALL ";
    $tmpquery .= "SELECT wkh.id FROM " . $tablePrefix . "work_hours wkh WHERE wkh.service='$id'";
    $serviceInUse = (compt($tmpquery) > 0);
} else {
    if (!$SW_Permissions['Service']['Write'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
}

/**
 * Check fields
 */
if ($action == 'add' || $action == 'update') {
    if (floatval($hr) < 0 || floatval($hr) != round($hr, $rateAccuracy)) {
        $error = lang_strings('hourly_rate') . ' ' . lang_strings("value_deviate");
        $bodyCommand = "onLoad=\"document.svEForm.hr.focus();document.svEForm.hr.select();\"";
        $hr_highlight = true;
    } else if (floatval($hri) < 0 || floatval($hri) != round($hri, $rateAccuracy)) {
        $error = lang_strings('hourly_rate_i') . ' ' . lang_strings("value_deviate");
        $bodyCommand = "onLoad=\"document.svEForm.hri.focus();document.svEForm.hri.select();\"";
        $hri_highlight = true;
    } else if ($serviceInUse) {
        if ($curr != $detailService->serv_currency[0]) {
            $error = lang_strings('service_in_use');
            $bodyCommand = "onLoad=\"document.svEForm.curr.focus();\"";
        }
    }

    if ($error == '') {
        $error = checkCustomFields('services', $id);
    }
}

/**
 * Actions
 */
if ($error == '' && ($action == "add" || $action == "update")) {
    $hr = round($hr, $rateAccuracy);
    $hri = round($hri, $rateAccuracy);

    if ($action == "update") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsql = setupCustomFieldsUpdateSQL('services', $id);  // Generate custom fields update sql
            $tmpsql = "UPDATE " . $tablePrefix . "services SET name='$n',hourly_rate='$hr',hourly_rate_i='$hri',currency='$curr',locked='$lk',modified='" . time() . "',muser='$idSession'$cfsql WHERE id=$id";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'services', $id, 'U');
            updateString($requestAct, 'SVC__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../services/listservices.php?msg=update");
            exit;
        }
    } else if ($action == "add") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsqls = setupCustomFieldsInsertSQL('services');  // Generate custom fields insert sql
            $tmpsql = "INSERT INTO " . $tablePrefix . "services (name,hourly_rate,hourly_rate_i,currency,locked,created,cuser" . $cfsqls[0] . ") VALUES ('$n','$hr','$hri','$curr','$lk','" . time() . "','$idSession'" . $cfsqls[1] . ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('services');
            $cfsql = setupCustomMediaFieldsUpdateSQL('services', $num);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "services SET $cfsql WHERE id='$num'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            copy2HistoryTable($requestAct, 'services', $num, 'A');
            updateString($requestAct, 'SVC__' . $n, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'editservice') {
                $_SESSION['PARAMS']['serv'] = $num;
                $_SESSION['TARGET'] = $_SESSION['SOURCE'];
                $_SESSION['SOURCE'] = '';
                header("Location: " . $_SESSION['LOCATION']);
            } else {
                header("Location: ../services/listservices.php?msg=add");
            }

            exit;
        }
    }
}

if ($error == '') {
    if ($id != '') {
        $n = $detailService->serv_name[0];
        $np = $detailService->serv_name_print[0];
        $hr = $detailService->serv_hourly_rate[0];
        $hri = $detailService->serv_hourly_rate_i[0];
        $curr = $detailService->serv_currency[0];
        $lk = $detailService->serv_locked[0];
    } else {
        $curr = $defaultCurrency;
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=accounting", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../services/listservices.php?", lang_strings("service_management"), 'in'));

if ($id == "" || $cpy == 'true') {
    $blockPage->itemBreadcrumbs(lang_strings("add_service"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../services/viewservice.php?id=$id", $detailService->serv_name[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_service"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "svE";

if ($id == "" || $cpy == 'true') {
    $block1->openForm("../services/editservice.php?#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_service"));
} else {
    $block1->openForm("../services/editservice.php?id=$id#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="update">';
    $block1->heading(lang_strings("edit_service") . " : " . $detailService->serv_name[0]);
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));
setupInputHTML($block1, lang_strings("name"), 'n', enumFieldType::ftAlphaNumeric, 'Y', '155', $n, '', '', false, '', 'onblur="nameChanged()"');
setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np, '', '', false, '', 'onblur="nameChanged()"');

if ($serviceInUse) {
    $block1->contentRow(lang_strings('currency') . ' ' . $curr);
    echo '<input type="hidden" name="curr" value="' . $curr . '">';
} else {
    $helpStr = '<table>';
    $currencyStr = '<select name="curr">';

    foreach ($CurrencyMatrix['active'] as $currCode) {
        $currName = $CurrencyMatrix['name'][$currCode];
        $helpStr .= '<tr><th>' . $currCode . '</th><td>' . $currName . '</td></tr>';

        if ($currCode == $curr) {
            $currencyStr .= '<option value="' . $currCode . '" selected>' . $currCode . '</option>';
        } else {
            $currencyStr .= '<option value="' . $currCode . '">' . $currCode . '</option>';
        }
    }

    $currencyStr .= '</select>';
    $helpStr .= '</table>';
    $block1->contentRow(lang_strings('currency') . ' ' . $blockPage->printHelp($helpStr, true), $currencyStr);
}

setupInputHTML($block1, lang_strings('hourly_rate_e') . ' ' . $blockPage->printHelp($strings['hourly_rate_e_help'], true), 'hr', enumFieldType::ftRate, 'Y', '', $hr, '', '', $hr_highlight);
setupInputHTML($block1, lang_strings('hourly_rate_i') . ' ' . $blockPage->printHelp($strings['hourly_rate_i_help'], true), 'hri', enumFieldType::ftRate, 'Y', '', $hri, '', '', $hri_highlight);

if ($id != '') {
    setupInputHTML($block1, lang_strings('locked'), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
}

setupCustomFieldsInputHTML($block1, 'services', $id);
$block1->contentRow('', '<input type="submit" name="Save" value="' . $strings["save"] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
    function nameChanged() {
        var np = document.getElementById('np').value;

        if (np == '') {
            var n = document.getElementById('n').value;
            document.getElementById('np').value = n;
        }
    }
</script>
<?php
require_once("../includes/footer.php");
