<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: graphservice.php,v 1.6 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/jpgraph/jpgraph.php');
require_once('../includes/jpgraph/jpgraph_line.php');
require_once('../includes/library.php');

/**
 * Variables init
 */
$service = AddSlashesNOD(isset($_REQUEST['service'])?$_REQUEST['service']:'0');

/**
 * Permission check
 */
if (!$SW_Permissions['Service']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = " WHERE serv.id='$service'";
$serviceDetail = new request();
$serviceDetail->openServices($tmpquery);
$comptServiceDetail = count($serviceDetail->serv_id);

if ($comptServiceDetail == '0') {
    exit;
}

/**
 * Prepare data
 */
$hourly_rate = $serviceDetail->serv_hourly_rate[0];
list($uformat, $cformat, $mformat) = preg_split('/\|/', $dateformatSession);
$tmpquery = "SELECT t0.month, SUM(t0.hours) FROM (";

for ($i=-12; $i<=0; $i++) {
    if ($i>-12) {
        $tmpquery .= " UNION ALL ";
    }
    
    $sd = mktime(0,0,0,intval(date('m'))+$i,1,intval(date('Y')));
    $dd = mktime(0,0,0,intval(date('m'))+$i+1,1,intval(date('Y')));
    $m = date($mformat, $sd);
    $s = date('Ym', $sd);
    $tmpquery .= "
    SELECT '$m' AS month, '$s' AS m, tim.hours AS hours FROM " . $tablePrefix . "tasks_time tim WHERE tim.date>='$sd' AND tim.date<'$dd' AND tim.service='$service'
    UNION ALL
    SELECT '$m' AS month, '$s' AS m, wkh.hours AS hours FROM " . $tablePrefix . "work_hours wkh WHERE wkh.date>='$sd' AND wkh.date<'$dd' AND wkh.service='$service'
        ";
}

$tmpquery = "
    ) t0 GROUP BY t0.month,t0.m ORDER BY t0.m";
$request1 = new request();
$request1->connectClass();
$request1->query($tmpquery);

while ($request1->fetch()) {
    $request1->hours[($row[0])] = ($row[1]);
}

$request1->close();

for ($i=-12; $i<=0; $i++) {
    $sd = mktime(0,0,0,intval(date('m'))+$i,1,intval(date('Y')));
    $m = date($mformat, $sd);

    if (isset($request1->hours[$m])) {
        $hours = round($request1->hours[$m], $hourAccuracy);
    } else {
        $hours = 0;
    }

    $datax[] = $m;
    $datay[] = $hours;
}

function toAmount($val)
{
    global $hourly_rate, $costAccuracy;
    return round($val*$hourly_rate, $costAccuracy);
}

// set up the graph
$graph = new Graph(1000, 160);
$graph->SetMargin(50,70,40,40);
$graph->SetMarginColor('white');
// Setup the scales for X,Y and Y2 axis
$graph->SetScale("intlin"); // X and Y axis
$graph->SetY2Scale("lin"); // Y2 axis
// Add title
$graph->title->Set(' ' . $strings['service'] . ' ' . $serviceDetail->serv_name_print[0]);
$graph->title->SetFont(GRAPH_TITLE_FONT,GRAPH_TITLE_FONT_STYLE,12);
// Setup X-axis labels
$graph->xaxis->SetTickLabels($datax);
// CCreate Y data set
$graph->yaxis->title->Set($strings['hours']);
$graph->yaxis->title->SetMargin(10);
if (defined("YAXIS_TITLE_ANGLE")) $graph->yaxis->title->SetAngle(YAXIS_TITLE_ANGLE);
$graph->yaxis->title->SetFont(GRAPH_TITLE_FONT);
$lineplot=new LinePlot($datay);
// ... and add the plot to the Y-axis
$graph->Add($lineplot);
// Create Y2 scale data set
$l2plot = new LinePlot($datay);
$l2plot->SetWeight(0);
$graph->y2axis->title->Set($strings['amount'] . ' (' . $serviceDetail->serv_currency[0] . ')');
$graph->y2axis->title->SetMargin(10); // Some extra margin to clear labels
if (defined("YAXIS_TITLE_ANGLE")) $graph->y2axis->title->SetAngle(YAXIS_TITLE_ANGLE);
$graph->y2axis->title->SetFont(GRAPH_TITLE_FONT);
$graph->y2axis->SetLabelFormatCallback('toAmount');
$graph->y2axis->SetColor('navy');
// ... and add the plot to the Y2-axis
$graph->AddY2($l2plot);
// webTareas footer, please don't remove
$graph->footer->right->Set('Created by webTareas');
$graph->footer->right->SetColor('gray6');
$graph->footer->right->SetFont(FF_FONT1);
$graph->Stroke();
