<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listservices.php,v 1.16 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$view = isset($_GET['view'])?$_GET['view']:'this_year';

/**
 * Permission check
 */
if (!$SW_Permissions['Service']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=accounting", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("service_management"));
$blockPage->closeBreadcrumbs();
logURL($strings['service_management'], "../services/listservices.php");
$block1 = new block();
$block1->form = "servList";
$block1->openForm("../services/listservices.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings("service_management"));
$querymore = " ORDER BY serv.name ASC";
$listServices = new request();

switch ($view) {
    case 'this_year':
        $datefrom = mktime(0, 0, 0, 1, 1, intval(date('Y')));
        $dateto = mktime(0, 0, 0, 1, 0, intval(date('Y'))+1);
        break;
    case 'recent_month':
        $datefrom = mktime(0, 0, 0, intval(date('n'))-1, intval(date('j'))+1, intval(date('Y')));
        $dateto = mktime(0, 0, 0, intval(date('n')), intval(date('j'))+1, intval(date('Y')));
        break;
    case 'recent_quarter':
        $datefrom = mktime(0, 0, 0, intval(date('n'))-3, intval(date('j'))+1, intval(date('Y')));
        $dateto = mktime(0, 0, 0, intval(date('n')), intval(date('j'))+1, intval(date('Y')));
        break;
    case 'recent_year':
        $datefrom = mktime(0, 0, 0, intval(date('n')), intval(date('j'))+1, intval(date('Y'))-1);
        $dateto = mktime(0, 0, 0, intval(date('n')), intval(date('j'))+1, intval(date('Y')));
        break;
}

$listServices->openServices1($querymore, $datefrom, $dateto);
$comptListServices = count($listServices->serv_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['name'];
$columns[0]->field_type = enumFieldType::ftAlphaNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['hourly_rate_e'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['hourly_rate_i'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['total'] . ' *';
$columns[3]->field_type = enumFieldType::ftText;
$opt[enumCardviewOption::oObject] = 'services';
$opt[enumCardviewOption::oTableName] = 'services';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;

if ($SW_Permissions['Service']['Write'][$profilSession]) {
    $opt[enumCardviewOption::oAddUrl] = '../services/editservice.php?';
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListServices; $i++) {
    if ($currencyOnRight == 'true') {
        $rate_e = NumberFormatNOD($listServices->serv_hourly_rate[$i], $rateAccuracy, false) . " " . $listServices->serv_currency[$i];
        $rate_i = NumberFormatNOD($listServices->serv_hourly_rate_i[$i], $rateAccuracy, false) . " " . $listServices->serv_currency[$i];
    } else {
        $rate_e = $listServices->serv_currency[$i] . " " . NumberFormatNOD($listServices->serv_hourly_rate[$i], $rateAccuracy, false);
        $rate_i = $listServices->serv_currency[$i] . " " . NumberFormatNOD($listServices->serv_hourly_rate_i[$i], $rateAccuracy, false);
    }

    $content = array(
        $listServices->serv_name[$i],
        $rate_e,
        $rate_i,
        $listServices->serv_total[$i] . ' ' . lang_strings('hours')
    );
    $block1->itemCardView($listServices->serv_id[$i], $content);
}

$block1->closeCardView();

if ($comptListServices > 0) {
    $linkStr = '';

    foreach (array('this_year','recent_month','recent_quarter','recent_year') as $val) {
        if ($linkStr != '') {
            $linkStr .= "&nbsp;|&nbsp;";
        }

        if ($val == $view) {
            $linkStr .= lang_strings($val);
        } else {
            $linkStr .= $blockPage->buildLink('../services/listservices.php?view=' . $val, lang_strings($val), 'in');
        }
    }

    $block1->note("*&nbsp;" . lang_strings('total_hours') . "&nbsp;&nbsp;&nbsp;&nbsp;" . $linkStr);
}

$block1->closeFormResults();
require_once("../includes/footer.php");
