<?php // $Revision: 1.17 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewservice.php,v 1.17 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');

/**
 * Permission check
 */
if (!$SW_Permissions['Service']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore = " WHERE serv.id='$id'";
$detailService = new request();
$detailService->openServices($querymore);
$comptDetailService = count($detailService->serv_id);

if ($comptDetailService == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=accounting", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../services/listservices.php?", lang_strings("service_management"), 'in'));
$blockPage->itemBreadcrumbs($detailService->serv_name[0]);
$blockPage->closeBreadcrumbs();
$title = $strings['service'] . ' : ' . $detailService->serv_name[0];
logURL($title, "../services/viewservice.php?id=$id");
$block1 = new block();
$block1->form = "serviceD";
$block1->openForm("../services/viewservice.php?id=$id#" . $block1->form . "Anchor");
$block1->heading(lang_strings("service"));
$block1->openPaletteIcon();

if ($SW_Permissions['Service']['Write'][$profilSession]) {
    $block1->paletteIcon(4, "copy", $strings["copy"]);
}

if ($SW_Permissions['Service']['Admin'][$profilSession]) {
    $block1->paletteIcon(0, "remove", $strings["delete"]);
}

if ($SW_Permissions['Service']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, "edit", $strings["edit"]);
}

$block1->paletteIcon(99, 'search', 'services');
$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow(lang_strings("name"), $detailService->serv_name[0]);
$block1->contentRow(lang_strings("name_print"), $detailService->serv_name_print[0]);

if ($currencyOnRight == 'true') {
    $block1->contentRow(lang_strings("hourly_rate_e") . ' ' . $blockPage->printHelp($strings['hourly_rate_e_help'], true), NumberFormatNOD($detailService->serv_hourly_rate[0], $rateAccuracy, false) . " " . $detailService->serv_currency[0]);
    $block1->contentRow(lang_strings("hourly_rate_i") . ' ' . $blockPage->printHelp($strings['hourly_rate_i_help'], true), NumberFormatNOD($detailService->serv_hourly_rate_i[0], $rateAccuracy, false) . " " . $detailService->serv_currency[0]);
} else {
    $block1->contentRow(lang_strings("hourly_rate_e") . ' ' . $blockPage->printHelp($strings['hourly_rate_e_help'], true), $detailService->serv_currency[0] . " " . NumberFormatNOD($detailService->serv_hourly_rate[0], $rateAccuracy, false));
    $block1->contentRow(lang_strings("hourly_rate_i") . ' ' . $blockPage->printHelp($strings['hourly_rate_i_help'], true), $detailService->serv_currency[0] . " " . NumberFormatNOD($detailService->serv_hourly_rate_i[0], $rateAccuracy, false));
}

$block1->contentRow(lang_strings('locked'), DbValueDecode(enumFieldType::ftBoolean, $detailService->serv_locked[0]));
setupCustomFieldsHTML($block1, 'services', $id);
$block1->closeContent();
echo "<br><img src=\"graphservice.php?service=$id\" alt=\"\"><br><span class=\"listEvenBold\">" . $blockPage->buildLink("http://www.aditus.nu/jpgraph/", "JpGraph", 'powered') . "</span>";
$block1->closeForm();
$block1->openPaletteScript();

if ($SW_Permissions['Service']['Write'][$profilSession]) {
    $block1->paletteScript(4, "copy", "../services/editservice.php?id=$id&cpy=true", "true,true,true", $strings["copy"]);
}

if ($SW_Permissions['Service']['Admin'][$profilSession]) {
    $block1->paletteScript(0, "remove", "../services/deleteservices.php?id=$id", "true,true,true", $strings["delete"]);
}

if ($SW_Permissions['Service']['Edit'][$profilSession]) {
    $block1->paletteScript(1, "edit", "../services/editservice.php?id=$id", "true,true,true", $strings["edit"]);
}

$block1->paletteScript(99, 'search', 'services');
$block1->closePaletteScript("", "");
require_once("../includes/footer.php");
