<?php // $Revision: 1.28 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addpost.php,v 1.28 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$qm = AddSlashesNOD(isset($_GET['qm'])?$_GET['qm']:'');        // quoted messages
$sta = isset($_POST['sta'])?$_POST['sta']:'';
$mes = isset($_POST['mes'])?$_POST['mes']:'';
$error = '';

/**
 * Permission check
 */
if ($enableHelpSupport != "true") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore1 = " WHERE sr.id='$id'";
$supportRequestDetail = new request();
$supportRequestDetail->openSupportRequests($querymore1);
$comptSupportRequestDetail = count($supportRequestDetail->sr_id);

if ($comptSupportRequestDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$project = $supportRequestDetail->sr_project[0];
$querymore2 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore2);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
    exit;
}

$querymore3 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore3);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore4);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($action == 'status' || $action == 'edit') {
    if ($permissionDetail->prp_modify_support_request_status[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
        exit;
    }
} else {
    if ($permissionDetail->prp_add_support_response[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
        exit;
    }
}

/**
 * Check fields
 */
if ($js_enabled == 'Y' && ($action == 'edit' || $action == 'add')) {
    $error = checkCustomFields('support_requests', $id);
}

/**
 * Actions
 */
if ($js_enabled == 'Y' && $error == '') {
    if ($action == "edit") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsql = setupCustomFieldsUpdateSQL('support_requests', $id);  // Generate custom fields update sql

            if ($sta == enumRequestStatus::stCompleted) {
                $tmpsql = "UPDATE " . $tablePrefix . "support_requests SET status='$sta',date_close='" . time() . "',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";
            } else {
                $tmpsql = "UPDATE " . $tablePrefix . "support_requests SET status='$sta',date_close='0',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";
            }

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            if ($supportRequestDetail->sr_status[0] != $sta) {
                $statusChanged = 'true';
            }

            copy2HistoryTable($requestAct, 'support_requests', $id, 'U');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if ($statusChanged == 'true') {
                if (!defined('INNER_NOTI_STATUSREQUEST')) {
                    define('INNER_NOTI_STATUSREQUEST', 1);
                }

                require_once("../support/noti_statusrequestchange.php");
            }

            header("Location: ../support/viewrequest.php?id=$id" . $urlBornes);
            exit;
        }
    } else if ($action == "add") {
        $mes = HtmlEntitiesNOD($mes);
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsqls = setupCustomFieldsInsertSQL('support_posts');  // Generate custom fields insert sql
            $tmpsql = "INSERT INTO " . $tablePrefix . "support_posts (request_id,message,date,owner,project,created,cuser" . $cfsqls[0] . ") VALUES ('$id','$mes','" . time() . "','$idSession','$project','" . time() . "','$idSession'" . $cfsqls[1] . ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId("support_posts");
            $cfsql = setupCustomMediaFieldsUpdateSQL('support_posts', $num);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "support_posts SET $cfsql WHERE id='$num'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $sendto = $num;
            $updir = $projectDetail->pro_upload_dir[0];
            $querymore = " WHERE fil.id='$updir'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtSupportPost, $sendto, enumFileStatus::stNoApprovalsNeeded, $updir, $path);
            copy2HistoryTable($requestAct, 'support_posts', $sendto, 'A');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if (!defined('INNER_NOTI_NEWPOST')) {
                define('INNER_NOTI_NEWPOST', 1);
            }

            $num = $sendto;
            require_once("../support/noti_newpost.php");
            header("Location: ../support/viewrequest.php?id=$id" . $urlBornes);
            exit;
        }
    }
}

/**
 * Prepare data
 */
if ($action != 'status' && $error == '') {
    if ($qm != '') {    // quote messages
        $qma = explode('**', $qm);
        $spid = '';
        $sr = false;
        $mesa = array();

        foreach ($qma as $i) {
            if ($i == '0') {
                $sr = true;
            } else {
                if ($spid != '') {
                    $spid .= ',';
                }

                $spid .= "'" . $i . "'";
            }
        }

        if ($spid != '') {
            $querymore = " WHERE sp.id IN ($spid) ORDER BY sp.date DESC";
            $listSupportPosts = new request();
            $listSupportPosts->openSupportPosts($querymore);
            $comptListSupportPosts = count($listSupportPosts->sp_id);
        }

        if ($spid != '') {
            for ($i=0; $i<$comptListSupportPosts; $i++) {
                $mesa[] = '&lt;blockquote&gt;' . $listSupportPosts->sp_message[$i] . '&lt;/blockquote&gt;';
            }
        }

        if ($sr) {
            $mesa[] = '&lt;blockquote&gt;' . $supportRequestDetail->sr_message[0] . '&lt;/blockquote&gt;';
        }

        $mes = implode("&lt;br&gt;", $mesa) . "&lt;br&gt;";
    }
}

if ($action != 'status') {
    $querymore = " WHERE sp.request_id='$id' ORDER BY sp.date DESC";
    $listSupportPosts = new request();
    $listSupportPosts->openSupportPosts($querymore);
    $comptListSupportPosts = count($listSupportPosts->sp_id);
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=support&id=" . $supportRequestDetail->sr_project[0] . $urlBornes, $supportRequestDetail->sr_pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $supportRequestDetail->sr_project[0] . $urlBornes, lang_strings("support_requests"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportRequestDetail->sr_id[0] . $urlBornes, $supportRequestDetail->sr_subject[0], 'in'));

if ($action == "status") {
    $blockPage->itemBreadcrumbs(lang_strings("edit_status"));
} else {
    $blockPage->itemBreadcrumbs(lang_strings("add_support_response"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "srA";

if ($action == "status") {
    $block1->openForm("../support/addpost.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
    $block1->heading(lang_strings("edit_status"));
    echo '<input type="hidden" name="action" value="edit">';
} else {
    $block1->openForm("../support/addpost.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
    $block1->heading(lang_strings("add_support_response"));
    echo '<input type="hidden" name="action" value="add">';
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$orgmsg = $supportRequestDetail->sr_message[0];
$block1->contentRow(lang_strings("message"), $orgmsg);
setupCustomFieldsHTML($block1, 'support_requests', $id);

if (($fileManagement == "true") && ($permissionDetail->prp_view_file[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession])) {
    $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtSupportRequest . "' AND fil.doc_id='$id' AND fil.vc_parent='0' ORDER BY fil.name";
    $block1->contentRow('', setupAttachListHTML($querymore));
}

if ($action == "status") {
    $prSel = "<select name=\"sta\">";
    $comptSta = count($requestStatus);

    for ($i=0; $i<$comptSta; $i++) {
        if ($supportRequestDetail->sr_status[0] == $i) {
            $prSel .= "<option value=\"$i\" selected>$requestStatus[$i]</option>";
        } else {
            $prSel .= "<option value=\"$i\">$requestStatus[$i]</option>";
        }
    }

    $prSel .= "</select>";
    $block1->contentRow(lang_strings("status"), $prSel);
    setupCustomFieldsInputHTML($block1, 'support_requests', $id);
} else {
    setupInputHTML($block1, lang_strings("message"), 'mes', enumFieldType::ftMemo, 'Y', '9', $mes);
    setupCustomFieldsInputHTML($block1, 'support_posts');
}

$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["submit"] . "\">");
$block1->closeContent();

if (($action != "status") && ($fileManagement == 'true') && ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession])) {
    setupAttachFilesHTML(($sitePublish=='true'));
}

if ($action != "status") {
    $block1->note("*&nbsp;" . lang_strings('required'));

    if ($comptListSupportPosts != '0') {
        $block1->openContent();
        $block1->contentTitle(lang_strings("responses"));

        for ($i=0; $i<$comptListSupportPosts; $i++) {
            $block1->contentRow(lang_strings("posted_by"), $blockPage->buildLink($listSupportPosts->sp_owner[$i], '', 'message'));
            $block1->contentRow(lang_strings("date"), createDate($listSupportPosts->sp_date[$i],'both'));
            $block1->contentRow("", $listSupportPosts->sp_message[$i]);
            setupCustomFieldsHTML($block1, 'support_posts', $listSupportPosts->sp_id[$i]);

            if (($fileManagement == "true") && ($permissionDetail->prp_view_file[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession])) {
                $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtSupportPost . "' AND fil.doc_id='" . $listSupportPosts->sp_id[$i] . "' AND fil.vc_parent=0 ORDER BY fil.name";
                $block1->contentRow('', setupAttachListHTML($querymore));
            }

            $block1->contentRow("", "", "true");
        }

        $block1->closeContent();
    }
}

$block1->closeForm();
require_once("../includes/footer.php");
