<?php // $Revision: 1.19 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addsupport.php,v 1.19 2013/02/02 01:27:21 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * TODO: field 'published' in support requests
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableHelpSupport != "true") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$re = isset($_POST['re'])?$_POST['re']:'';
$se = isset($_POST['se'])?$_POST['se']:'';
$pr = isset($_POST['pr'])?$_POST['pr']:'';
$sub = isset($_POST['sub'])?$_POST['sub']:'';
$mes = isset($_POST['mes'])?$_POST['mes']:'';
$error = '';

/**
 * Permission check
 */
$querymore0 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore0);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
    exit;
}

$querymore1 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore1);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore2 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore2 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore2);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_add_support_response[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
    exit;
}

/**
 * Check fields
 */
if ($action == 'add') {
    $error = checkCustomFields('support_requests', '');
}

/**
 * Actions
 */
if ($action == "add" && $error == '') {
    $sub = HtmlEntitiesNOD($sub);
    $mes = HtmlEntitiesNOD($mes);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $cfsqls = setupCustomFieldsInsertSQL('support_requests');  // Generate custom fields insert sql
        $tmpsql = "INSERT INTO " . $tablePrefix . "support_requests (owner,reproducibility,severity,priority,subject,message,date_open,project,status,resolution,auto_close,published,created,cuser" . $cfsqls[0] . ") VALUES ('$idSession','$re','$se','$pr','$sub','$mes','" . time() . "','$project','" . enumRequestStatus::stNew . "','1','Y','" . enumPublished::pbNo . "','" . time() . "','$idSession'" . $cfsqls[1] . ")";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $num = $requestAct->newId("support_requests");
        $cfsql = setupCustomMediaFieldsUpdateSQL('support_requests', $num);    // Upload custom fields images & generate custom fields update sql

        if ($cfsql !== '') {
            $tmpsql = "UPDATE " . $tablePrefix . "support_requests SET $cfsql WHERE id='$num'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $sendto = $num;
        $updir = $projectDetail->pro_upload_dir[0];
        $querymore = " WHERE fil.id='$updir'";
        $folderDetail = clone $requestAct;
        $folderDetail->openFiles($querymore);
        $path = $folderDetail->fil_fullname[0];
        uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtSupportRequest, $sendto, enumFileStatus::stNoApprovalsNeeded, $updir, $path);
        copy2HistoryTable($requestAct, 'support_requests', $sendto, 'A');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if (!defined('INNER_NOTI_NEWREQUEST')) {
            define('INNER_NOTI_NEWREQUEST', 1);
        }

        $num = $sendto;
        require_once("../support/noti_newrequest.php");
        header("Location: ../support/listrequests.php?id=$project&msg=add" . $urlBornes);
        exit;
    }
}

/**
 * Set value in form
 */
if ($error == '') {
    $re = fieldDefaultValue('support_requests', 'reproducibility');
    $se = fieldDefaultValue('support_requests', 'severity');
    $pr = enumPriority::prMedium;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=support&id=" . $project . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $project . $urlBornes, lang_strings("support_requests"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_support_request"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "aDs";
$block1->openForm("../support/addsupport.php?project=$project" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="add">';
$block1->heading(lang_strings("add_support_request"));
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$reSel = populateSelect('support_requests', 'reproducibility', 're', strval($re));
$block1->contentRow(lang_strings('FIE__support_requests_reproducibility'), $reSel);
$seSel = populateSelect('support_requests', 'severity', 'se', strval($se));
$block1->contentRow(lang_strings('FIE__support_requests_severity'), $seSel);
$prSel = '<select name="pr">';

foreach ($priority as $key => $val) {
    if ($key == $pr) {
        $prSel .= '<option value="' . $key . '" selected>' . $val . '</option>';
    } else {
        $prSel .= '<option value="' . $key . '">' . $val . '</option>';
    }
}

$prSel .= '</select>';
$block1->contentRow(lang_strings('priority'), $prSel);
setupInputHTML($block1, lang_strings("subject"), 'sub', enumFieldType::ftText, 'Y', '255', $sub);
setupInputHTML($block1, lang_strings('message'), 'mes', enumFieldType::ftMemo, 'Y', '9', $mes);
setupCustomFieldsInputHTML($block1, 'support_requests');
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["submit"] . "\">");
$block1->closeContent();

if (($fileManagement == 'true') && ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession])) {
    setupAttachFilesHTML(($sitePublish=='true'));
}

$block1->note("*&nbsp;" . lang_strings('required'));
require_once("../includes/footer.php");
