<?php // $Revision: 1.14 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleterequests.php,v 1.14 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableHelpSupport != "true") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$ids = "'" . str_replace('**', "','", $id) . "'";
$sendto = isset($_GET['sendto'])?$_GET['sendto']:'';
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
$tmpquery = "SELECT DISTINCT project FROM " . $tablePrefix . "support_requests WHERE id IN ($ids)";

if (compt($tmpquery) != '1') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore1 = " WHERE sr.id IN ($ids)";
$listSupportRequests = new request();
$listSupportRequests->openSupportRequests($querymore1);
$comptListSupportRequests = count($listSupportRequests->sr_id);
$project = $listSupportRequests->sr_project[0];
$querymore2 = " WHERE sp.request_id IN ($ids)";
$listSupportPosts = new request();
$listSupportPosts->openSupportPosts($querymore2);
$comptListSupportPosts = count($listSupportPosts->sp_id);
$querymore3 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore3);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
    exit;
}

$querymore4 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore4);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore5 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore5 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore5);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_delete_support_request[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
    exit;
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'support_requests', $ids, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "support_requests WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        if ($comptListSupportPosts > 0) {
            $ids1 = "'" . implode("','", $listSupportPosts->sp_id) . "'";
            copy2HistoryTable($requestAct, 'support_posts', $ids1, 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "support_posts WHERE request_id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $querymore = " WHERE (fil.doc_type='" . enumFileRelatedDocumentType::dtSupportRequest . "' AND fil.doc_id IN ($ids)) OR (fil.doc_type='" . enumFileRelatedDocumentType::dtSupportPost . "' AND fil.doc_id IN (SELECT id FROM " . $tablePrefix . "support_posts WHERE request_id IN ($ids)))";
        deleteAttachFiles($requestAct, $querymore);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($sendto == '') {
            header("Location: ../support/listrequests.php?msg=delete&id=$project" . $urlBornes);
        } else {
            header("Location: ../support/support.php?msg=delete&action=$sendto&project=$project" . $urlBornes);
        }

        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=support&id=" . $project . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $project, lang_strings("support_requests"), 'in'));

if ($sendto == "new") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project . $urlBornes, lang_strings("new_requests"), 'in'));
} else if ($sendto == "open") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project . $urlBornes, lang_strings("open_requests"), 'in'));
} else if ($sendto == "complete") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project . $urlBornes, lang_strings("closed_requests"), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("delete_support_requests"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "dsR";
$block1->openForm("../support/deleterequests.php?id=$id&sendto=$sendto" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="delete">';
$block1->heading(lang_strings("delete_support_requests"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListSupportRequests; $i++) {
    $block1->contentRow('', $listSupportRequests->sr_subject[$i]);
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
