<?php // $Revision: 1.25 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editpost.php,v 1.25 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableHelpSupport != "true") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$sendto = isset($_GET['sendto'])?$_GET['sendto']:'';
$re = isset($_POST['re'])?$_POST['re']:'';
$reso = isset($_POST['reso'])?$_POST['reso']:'';
$se = isset($_POST['se'])?$_POST['se']:'';
$pr = isset($_POST['pr'])?$_POST['pr']:'';
$sta = isset($_POST['sta'])?$_POST['sta']:'';
$c = isset($_POST['c'])?$_POST['c']:'';
$at = isset($_POST['at'])?$_POST['at']:'';
$old_at = isset($_POST['old_at'])?$_POST['old_at']:'';
$ta = isset($_POST['ta'])?$_POST['ta']:'';
$autoc = isset($_POST['autoc'])?$_POST['autoc']:'';
$tn = isset($_POST['tn'])?$_POST['tn']:'';
$d = isset($_POST['d'])?$_POST['d']:'';
$pha = isset($_POST['pha'])?$_POST['pha']:'';
$fixd = isset($_POST['fixd'])?$_POST['fixd']:'';
$sdI = isset($_POST['sdI'])?$_POST['sdI']:'';
$sd = ($sdI=='')?$dateToday:date2Timestamp($sdI);
$ddI = isset($_POST['ddI'])?$_POST['ddI']:'';
$dd = ($ddI=='')?$dateToday:date2Timestamp($ddI);
$etm = isset($_POST['etm'])?$_POST['etm']:'';
$serv = isset($_POST['serv'])?$_POST['serv']:'';

/**
 * Permission check
 */
$querymore1 = " WHERE sr.id='$id'";
$supportRequestDetail = new request();
$supportRequestDetail->openSupportRequests($querymore1);
$comptSupportRequestDetail = count($supportRequestDetail->sr_id);

if ($comptSupportRequestDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$project = $supportRequestDetail->sr_project[0];
$querymore2 = " WHERE tas.support_request='$id' AND tas.status<>'" . enumStatus::stCompleted . "'";
$taskDetail = new request();
$taskDetail->openTasks($querymore2);
$comptTaskDetail = count($taskDetail->tas_id);
$querymore3 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore3);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
    exit;
}

$querymore4 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore4);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore5 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore5 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore5);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($action == '') {
    if ($permissionDetail->prp_assign_support_request[0] != enumBoolean::bTrue && $permissionDetail->prp_close_support_request[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
        exit;
    }
} else if ($sta == enumRequestStatus::stCompleted) {
    if ($permissionDetail->prp_close_support_request[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
        exit;
    }
} else {
    if ($permissionDetail->prp_assign_support_request[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
        exit;
    }
}

/**
 * Fields check
 */
$error = '';

if ($action == 'update') {
    if ($ta == 'Y') {
        if ($tn == "") {
            $error = lang_strings('name') . ' ' . lang_strings('error_required');
            $tn_highlight = true;
            $bodyCommand = "onload=\"document.srAForm.compl.value = document.srAForm.completion.selectedIndex;document.srAForm.tn.focus();\"";
        } else if ($etm == "") {
            $error = lang_strings('estimated_time') . ' ' . lang_strings('error_required');
            $etm_highlight = true;
            $bodyCommand = "onload=\"document.srAForm.compl.value = document.srAForm.completion.selectedIndex;document.srAForm.etm.focus();\"";
        } else if (!is_numeric($etm)) {
            $error = lang_strings('estimated_time') . ' ' . lang_strings('error_numerical');
            $etm_highlight = true;
            $bodyCommand = "onload=\"document.srAForm.compl.value = document.srAForm.completion.selectedIndex;document.srAForm.etm.focus();\"";
        } else if ($etm <= 0 || $etm > 29200) {
            $error = lang_strings('estimated_time') . ' ' . lang_strings('value_deviate');
            $etm_highlight = true;
            $bodyCommand = "onload=\"document.srAForm.compl.value = document.srAForm.completion.selectedIndex;document.srAForm.etm.focus();\"";
        } else if (diff_date($dd, $sd) >= 3650) {
            $error = lang_strings('due_date') . ' ' . lang_strings('value_deviate');
        }
    }

    if ($error == '' && $c == '') {
        $ac = isset($_POST['attcnt'])?$_POST['attcnt']:'0';
        $ac1 = 0;

        for ($attIdx=1; $attIdx<=$ac; $attIdx++) {
            $attchk = $_POST['attchk' . $attIdx];

            if ($attchk == 'Y') {
                $ac1++;
            }
        }

        if ($ac1 == '1') {
            $c = $ac1 . ' ' . $strings['attach_document'];
        } else if ($ac1 != '0') {
            $c = $ac1 . ' ' . $strings['attach_documents'];
        }
    }

    if ($error == '') {
        $error = checkCustomFields('support_requests', $id, 'r');
    }

    if ($error == '' && $c != '') {
        $error = checkCustomFields('support_posts', '', 'p');
    }

    if ($error == '' && $sta != enumRequestStatus::stCompleted && $ta == 'Y') {
        if ($comptTaskDetail == '0') {
            $error = checkCustomFields('tasks', '', 't');
        } else {
            $error = checkCustomFields('tasks', $taskDetail->tas_id[0], 't');
        }
    }
}

/**
 * Actions
 */
if ($action == "update" && $error == '') {
    $tn = HtmlEntitiesNOD($tn);
    $d = HtmlEntitiesNOD($d);
    $c = HtmlEntitiesNOD($c);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $cfsql = setupCustomFieldsUpdateSQL('support_requests', $id, 'r');  // Generate custom fields update sql

        if ($c != '') {
            $cfsqls = setupCustomFieldsInsertSQL('support_posts', 'p');  // Generate custom fields insert sql
            $tmpsql = "INSERT INTO " . $tablePrefix . "support_posts (request_id,message,date,owner,project" . $cfsqls[0] . ") VALUES ('$id','$c','" . time() . "','$idSession','$project'" . $cfsqls[1] . ")";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId("support_posts");
            $cfsql = setupCustomMediaFieldsUpdateSQL('support_posts', $num, 'p');    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "support_posts SET $cfsql WHERE id='$num'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            $spNewId = $num;
            $newPostNum = $num;
            $newPost = 'true';
            $updir = $projectDetail->pro_upload_dir[0];
            $querymore6 = " WHERE fil.id='$updir'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore6);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtSupportPost, $spNewId, enumFileStatus::stNoApprovalsNeeded, $updir, $path);
            copy2HistoryTable($requestAct, 'support_posts', $spNewId, 'A');
        }

        if ($sta == enumRequestStatus::stCompleted) {
            $tmpsql = "UPDATE " . $tablePrefix . "support_requests SET reproducibility='$re',severity='$se',resolution='$reso',priority='$pr',status='$sta',date_close='" . time() . "'$cfsql WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'support_requests', $id, 'U');
        } else {
            if ($autoc != 'Y') {
                $autoc = 'N';
            }

            $tmpsql = "UPDATE " . $tablePrefix . "support_requests SET reproducibility='$re',severity='$se',resolution='$reso',priority='$pr',status='$sta',date_close='0',assigned_to='$at',auto_close='$autoc'$cfsql WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'support_requests', $id, 'U');

            if ($ta == 'Y') {
                $tt = '0';

                if ($comptTaskDetail == '0') {
                    $cfsqls = setupCustomFieldsInsertSQL('tasks', 't');  // Generate custom fields insert sql

                    if ($projectDetail->pro_phase_set[0] != '0') {
                        $tmpsql = "INSERT INTO " . $tablePrefix . "tasks (project,priority,status,owner,assigned_to,name,description,start_date,due_date,estimated_time,actual_time,assigned,published,parent_phase,service,fixed_duration,milestone,type,task_group,support_request,created,cuser" . $cfsqls[0] . ") VALUES ('$project','$pr','" . enumStatus::stNotStarted . "','$idSession','1','$tn','$d','$sd','$dd','$etm','0','" . time() . "','" . enumPublished::pbNo . "',$pha,$serv,'$fixd','" . enumMilestone::msNo . "','$tt','" . enumTaskGroup::tgNo . "',$id,'" . time() . "','$idSession'" . $cfsqls[1] . ")";
                    } else {
                        $tmpsql = "INSERT INTO " . $tablePrefix . "tasks (project,priority,status,owner,assigned_to,name,description,start_date,due_date,estimated_time,actual_time,assigned,published,service,fixed_duration,milestone,type,task_group,support_request,created,cuser" . $cfsqls[0] . ") VALUES ('$project','$pr','" . enumStatus::stNotStarted . "','$idSession','1','$tn','$d','$sd','$dd','$etm','0','" . time() . "','" . enumPublished::pbNo . "',$serv,'$fixd','" . enumMilestone::msNo . "','$tt','" . enumTaskGroup::tgNo . "',$id,'" . time() . "','$idSession'" . $cfsqls[1] . ")";
                    }

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num = $requestAct->newId("tasks");
                    $cfsql = setupCustomMediaFieldsUpdateSQL('tasks', $num, 't');    // Upload custom fields images & generate custom fields update sql

                    if ($cfsql !== '') {
                        $tmpsql = "UPDATE " . $tablePrefix . "tasks SET $cfsql WHERE id='$num'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }

                    $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('$num','$idSession','$at','" . time() . "')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_resource (task,resource,type,created,cuser) VALUES ('$num','$at','" . enumResourceType::rtUser . "','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                } else {
                    $cfsql = setupCustomFieldsUpdateSQL('tasks', $taskDetail->tas_id[0], 't');  // Generate custom fields update sql
                    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET priority='$pr',name='$tn',description='$d',start_date='$sd',due_date='$dd',estimated_time='$etm',service='$serv',fixed_duration='$fixd',modified='" . time() . "',muser='$idSession'$cfsql WHERE support_request='$id'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    if (strval($at) != strval($old_at)) {
                        $tmpsql = "DELETE FROM " . $tablePrefix . "tasks_resource WHERE task='" . $taskDetail->tas_id[0] . "' AND resource='$old_at' AND type='" . enumResourceType::rtUser . "'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('" . $taskDetail->tas_id[0] . "','$idSession','$at','" . time() . "')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_resource (task,resource,type,created,cuser) VALUES ('" . $taskDetail->tas_id[0] . "','$at','" . enumResourceType::rtUser . "','" . time() . "','$idSession')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }
                }
            }
        }

        if ($supportRequestDetail->sr_status[0] != $sta) {
            $statusChanged = 'true';
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($newPost == 'true') {
            if (!defined('INNER_NOTI_NEWPOST')) {
                define('INNER_NOTI_NEWPOST', 1);
            }

            $num = $newPostNum;
            require_once("../support/noti_newpost.php");
        }

        if ($statusChanged == 'true') {
            if (!defined('INNER_NOTI_STATUSREQUEST')) {
                define('INNER_NOTI_STATUSREQUEST', 1);
            }

            require_once("../support/noti_statusrequestchange.php");
        }

        header("Location: ../support/viewrequest.php?sendto=$sendto&id=$id&msg=update" . $urlBornes);
        exit;
    }
}

/**
 * Prepare data
 */
$querymore7 = " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.project='" . $project . "' AND prp.view_task='" . enumBoolean::bTrue . "'";
$listTeams = new request();
$listTeams->openTeams($querymore7);
$comptListTeams = count($listTeams->tea_project);

/**
 * Set value in form
 */
if ($action == '') {
    $sta = $supportRequestDetail->sr_status[0];
    $re = $supportRequestDetail->sr_reproducibility[0];
    $se = $supportRequestDetail->sr_severity[0];
    $reso = $supportRequestDetail->sr_resolution[0];
    $pr = $supportRequestDetail->sr_priority[0];
    $at = $supportRequestDetail->sr_assigned_to[0];
    $autoc = $supportRequestDetail->sr_auto_close[0];

    if ($comptTaskDetail != '0') {
        $ta = 'Y';
        $tn = $taskDetail->tas_name[0];
        $d = $taskDetail->tas_description[0];
        $sd = $taskDetail->tas_start_date[0];
        $dd = $taskDetail->tas_due_date[0];
        $etm = $taskDetail->tas_estimated_time[0];
        $fixd = $taskDetail->tas_fixed_duration[0];
        $serv = $taskDetail->tas_service[0];
    }
}

if ($ta == 'Y') {
    if ($error == '') {
        $tn = $strings['issue_tracking'] . ' - ' . $supportRequestDetail->sr_subject[0];
        $d = str_replace('%SR%', $supportRequestDetail->sr_subject[0], $strings['createdbysr']);
        $sd = mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y')));
        $etm = '8';
        $dd = hours_after($sd, $etm, $projectDetail->pro_workcalendar[0]);
        $serv = '0';
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=support&id=" . $supportRequestDetail->sr_project[0] . $urlBornes, $supportRequestDetail->sr_pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $supportRequestDetail->sr_project[0] . $urlBornes, lang_strings("support_requests"), 'in'));

if ($sendto == "new") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project . $urlBornes, lang_strings("new_requests"), 'in'));
} else if ($sendto == "open") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project . $urlBornes, lang_strings("open_requests"), 'in'));
} else if ($sendto == "complete") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project . $urlBornes, lang_strings("closed_requests"), 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../support/viewrequest.php?id=" . $supportRequestDetail->sr_id[0] . $urlBornes, $supportRequestDetail->sr_subject[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_support_request"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "srA";
$block1->openForm("../support/editpost.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="update">';
$block1->heading(lang_strings("edit_support_request"));
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$staSel = "<select name=\"sta\" id=\"sta\" onchange=\"sta_changed();\">";

if ($comptTaskDetail == '0') {
    if (strval($sta) === strval(enumRequestStatus::stNew)) {
        $staSel .= '<option value="' . enumRequestStatus::stNew . '" selected>' . $requestStatus[enumRequestStatus::stNew] . '</option>';
    } else if (strval($supportRequestDetail->sr_status[0]) == strval(enumRequestStatus::stNew)) {
        $staSel .= '<option value="' . enumRequestStatus::stNew . '">' . $requestStatus[enumRequestStatus::stNew] . '</option>';
    }
} else {
    echo '<input type="hidden" name="old_at" value="' . $at . '">';
}

if ($permissionDetail->prp_assign_support_request[0] == enumBoolean::bTrue) {
    if (strval($sta) === strval(enumRequestStatus::stOpen)) {
        $staSel .= '<option value="' . enumRequestStatus::stOpen . '" selected>' . $requestStatus[enumRequestStatus::stOpen] . '</option>';
    } else {
        $staSel .= '<option value="' . enumRequestStatus::stOpen . '">' . $requestStatus[enumRequestStatus::stOpen] . '</option>';
    }
}

if ($permissionDetail->prp_close_support_request[0] == enumBoolean::bTrue) {
    if (strval($sta) === strval(enumRequestStatus::stCompleted)) {
        $staSel .= '<option value="' . enumRequestStatus::stCompleted . '" selected>' . $requestStatus[enumRequestStatus::stCompleted] . '</option>';
    } else {
        $staSel .= '<option value="' . enumRequestStatus::stCompleted . '">' . $requestStatus[enumRequestStatus::stCompleted] . '</option>';
    }
}

$staSel .= "</select>";
$block1->contentRow(lang_strings("status"), $staSel);
$reSel = populateSelect('support_requests', 'reproducibility', 're', strval($re));
$block1->contentRow(lang_strings('FIE__support_requests_reproducibility'), $reSel);
$seSel = populateSelect('support_requests', 'severity', 'se', strval($se));
$block1->contentRow(lang_strings('FIE__support_requests_severity'), $seSel);
$resoSel = populateSelect('support_requests', 'resolution', 'reso', strval($reso));
$block1->contentRow(lang_strings('FIE__support_requests_resolution'), $resoSel);
$prSel = '<select name="pr">';

foreach ($priority as $key => $val) {
    if ($key == '0') {
        continue;
    }

    if (strval($key) === strval($pr)) {
        $prSel .= '<option value="' . $key . '" selected>' . $val . '</option>';
    } else {
        $prSel .= '<option value="' . $key . '">' . $val . '</option>';
    }
}

$prSel .= '</select>';
$block1->contentRow(lang_strings('priority'), $prSel);
$block1->contentRow(lang_strings("message"), $supportRequestDetail->sr_message[0]);
setupCustomFieldsInputHTML($block1, 'support_requests', $id, 'r');
$block1->closeContent();
ob_start();
$block1->openContent();
$atSel = '<select name="at">';

for ($i=0; $i<$comptListTeams; $i++) {
    $atSel .= '<option value="' . $listTeams->tea_member[$i] . '" ' . (($listTeams->tea_member[$i]==$at)?'selected':'') . '>' . $listTeams->tea_mem_name[$i] . '</option>';
}

$atSel .= '</select>';
$block1->contentRow(lang_strings('assigned_to'), $atSel);

if ($comptTaskDetail == '0') {
    $block1->contentRow(lang_strings('add_task'), '<input type="checkbox" name="ta1" value="Y" ' . (($ta=='Y')?'checked':'') . ' onclick="ta_clicked(this);">');
    echo '<input type="hidden" name="ta" id="ta" value="' . $ta . '">';
} else {
    $block1->contentRow(lang_strings('add_task'), '<input type="checkbox" name="ta1" value="Y" checked disabled>');
    echo '<input type="hidden" name="ta" id="ta" value="Y">';
}

$block1->closeContent();
$open_contents = ob_get_contents();
ob_clean();
$block1->openContent();
$block1->contentRow(lang_strings('auto_close') . $blockPage->printHelp('auto_close_help'), '<input type="checkbox" name="autoc" value="Y" ' . (($autoc=='Y')?'checked':'') . '>');
setupInputHTML($block1, lang_strings("name"), 'tn', enumFieldType::ftText, 'Y', '255', $tn);
setupInputHTML($block1, lang_strings('description'), 'd', enumFieldType::ftMemo, 'N', '0', $d);

// select phase
if ($projectDetail->pro_phase_set[0] != '0') {
    $projectTarget = $projectDetail->pro_id[0];
    $querymore8 = " WHERE pha.project='$projectTarget' ORDER BY pha.order_num";
    $projectPhaseList = new request();
    $projectPhaseList->openPhases($querymore8);
    $comptlistPhase = count($projectPhaseList->pha_id);
    $phaseSel = "<select name=\"pha\">";

    for ($i = 0;$i < $comptlistPhase;$i++) {
        $phaseNum = $projectPhaseList->pha_order_num[$i];

        if ($taskDetail->tas_parent_phase[0] == $phaseNum || $phase == $phaseNum) {
            $phaseSel .= "<option value=\"$phaseNum\" selected>" . $projectPhaseList->pha_description[$i] . "</option>";
        } else {
            $phaseSel .= "<option value=\"$phaseNum\">" . $projectPhaseList->pha_description[$i] . "</option>";
        }
    }

    $phaseSel .= "</select>";
    $block1->contentRow(lang_strings('phase'), $phaseSel);
}

$block1->contentRow(lang_strings("fixed_duration"), "<input size=\"32\" value=\"Y\" name=\"fixd\" type=\"checkbox\" " . (($fixd==enumFixedDuration::fdYes)?'checked':'') . ">");
setupInputHTML($block1, lang_strings("start_date"), 'sdI', enumFieldType::ftDate, 'Y', '0', $sd);
setupInputHTML($block1, lang_strings("due_date"), 'ddI', enumFieldType::ftDate, 'Y', '0', $dd);
setupInputHTML($block1, lang_strings("estimated_time"), 'etm', enumFieldType::ftHours, 'Y', '0', $etm);

if ($projectDetail->pro_currency[0] != '') {
    $querymore9 = " WHERE serv.currency='" . $projectDetail->pro_currency[0] . "' AND serv.locked='" . enumBoolean::bFalse . "' ORDER BY serv.name";
} else {
    $querymore9 = " WHERE serv.locked='" . enumBoolean::bFalse . "' ORDER BY serv.name";
}

$listServices = new request();
$listServices->openServices($querymore9);
$comptServiceDetail = count($listServices->serv_id);
$servSel = "<select name=\"serv\"><option value=\"0\">" . $strings["none"] . "</option>";

for ($i=0; $i<$comptServiceDetail; $i++) {
    if (strval($listServices->serv_id[$i]) == strval($serv)) {
        $servSel .= "<option value='" . $listServices->serv_id[$i] . "' selected>" . $listServices->serv_name_print[$i] . '</option>';
    } else {
        $servSel .= "<option value='" . $listServices->serv_id[$i] . "'>" . $listServices->serv_name_print[$i] . '</option>';
    }
}

$servSel .= "</select>";
$block1->contentRow(lang_strings("service"), $servSel);
setupCustomFieldsInputHTML($block1, 'tasks', '', 't');
$block1->closeContent();
$task_contents = ob_get_contents();
ob_end_clean();
echo "<input type=\"hidden\" id=\"open_contents\" value=\"" . htmlentities($open_contents, ENT_QUOTES, $htmlEntityCharset) . "\">";
echo "<input type=\"hidden\" id=\"task_contents\" value=\"" . htmlentities($task_contents, ENT_QUOTES, $htmlEntityCharset) . "\">";
echo '<div id="opendiv">';

if (strval($sta) == strval(enumRequestStatus::stOpen)) {
    echo $open_contents;
}

echo '</div><div id="taskdiv">';

if (strval($sta) == strval(enumRequestStatus::stOpen) && $ta == 'Y') {
    echo $task_contents;
}

echo '</div>';
$block1->openContent();
$block1->contentTitle(lang_strings("responses"));
setupInputHTML($block1, lang_strings('message'), 'c', enumFieldType::ftMemo, 'N', '9', $c);
setupCustomFieldsInputHTML($block1, 'support_posts', '', 'p');
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["submit"] . "\">");
$block1->closeContent();

if (($fileManagement == 'true') && ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession])) {
    setupAttachFilesHTML(($sitePublish=='true'));
}

$block1->note("*&nbsp;" . lang_strings('required'));
?>
<script type="text/javascript">
function sta_changed() {
    var x = document.getElementById('sta');

    if (x.value == '1') {
        var y = document.getElementById('open_contents');
        $("#opendiv").html(y.value);
        ta_changed();
    } else {
        $("#opendiv").html('');
        $("#taskdiv").html('');
    }
}

function ta_clicked(theObj) {
    var x = document.getElementById('ta');

    if (theObj.checked) {
        x.value = 'Y';
    } else {
        x.value = '';
    }

    ta_changed();
}

function ta_changed() {
    var x = document.getElementById('ta');

    if (x.value == 'Y') {
        var y = document.getElementById('task_contents');
        $("#taskdiv").html(y.value);
    } else {
        $("#taskdiv").html('');
    }
}
</script>
<?php
require_once("../includes/footer.php");
