<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: support.php,v 1.13 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableHelpSupport != "true") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
$action = AddSlashesNOD(isset($_GET['action'])?$_GET['action']:'');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore2);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore3);
$comptPermissionDetail = count($permissionDetail->prp_project);

if (!$SW_Permissions['Project']['Admin'][$profilSession] && ($permissionDetail->prp_view_support_request[0] != enumBoolean::bTrue || !$SW_Permissions['Project']['Read'][$profilSession])) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=support&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("support_requests"), 'in'));

if ($action == "new") {
    $blockPage->itemBreadcrumbs(lang_strings("new_requests"));
    $title = $strings['new_requests'] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
} else if ($action == "open") {
    $blockPage->itemBreadcrumbs(lang_strings("open_requests"));
    $title = $strings['open_requests'] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
} else if ($action == "complete") {
    $blockPage->itemBreadcrumbs(lang_strings("closed_requests"));
    $title = $strings['closed_requests'] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '2';     // 1st for listprojects
logURL($title, "../support/support.php?action=$action&project=$project");
$block1 = new block();
$block1->form = "srs";
$block1->openForm("../support/support.php?action=$action&amp;project=$project" . $urlBornes . "#" . $block1->form . "Anchor");

if ($action == "new") {
    $block1->heading(lang_strings("new_requests"));
} elseif ($action == "open") {
    $block1->heading(lang_strings("open_requests"));
} elseif ($action == "complete") {
    $block1->heading(lang_strings("closed_requests"));
}

$block1->borne = $blockPage->returnBorne('2');
$block1->rowsLimit = 12;
$block1->sorting("support_requests", (isset($sortingUser['support_requests'])?$sortingUser['support_requests']:''), "sr.id ASC", $sortingFields = array(0 => "sr.id", 1 => "sr.subject", 2 => "sr.status", 3 => "sr.reproducibility", 4 => "sr.severity", 5 => "sr.resolution", 6 => "sr.priority", 7 => "sr.date_open", 8 => "sr.date_close", 9 => "sr.owner"));

if ($action == "new") {
    $querymore = " WHERE sr.status='" . enumRequestStatus::stNew . "' AND sr.project='$project' ORDER BY $block1->sortingValue";
} elseif ($action == "open") {
    $querymore = " WHERE sr.status='" . enumRequestStatus::stOpen . "' AND sr.project='$project' ORDER BY $block1->sortingValue";
} elseif ($action == "complete") {
    $querymore = " WHERE sr.status='" . enumRequestStatus::stCompleted . "' AND sr.project='$project' ORDER BY $block1->sortingValue";
}

$recordsTotal = compt($initrequest['support_requests'] . $querymore);
$block1->recordsTotal = $recordsTotal;
$listSupportRequests = new request();
$listSupportRequests->openSupportRequests($querymore, $block1->borne, $block1->rowsLimit);
$comptListSupportRequests = count($listSupportRequests->sr_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['id'];
$columns[0]->field_type = enumFieldType::ftNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['subject'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['status'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['FIE__support_requests_reproducibility'];
$columns[3]->field_type = enumFieldType::ftText;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['FIE__support_requests_severity'];
$columns[4]->field_type = enumFieldType::ftText;
$columns[5] = new cardviewColumn();
$columns[5]->title = $strings['FIE__support_requests_resolution'];
$columns[5]->field_type = enumFieldType::ftText;
$columns[6] = new cardviewColumn();
$columns[6]->title = $strings['priority'];
$columns[6]->field_type = enumFieldType::ftText;
$columns[7] = new cardviewColumn();
$columns[7]->title = $strings['date_open'];
$columns[7]->field_type = enumFieldType::ftDate;
$columns[8] = new cardviewColumn();
$columns[8]->title = $strings['date_close'];
$columns[8]->field_type = enumFieldType::ftDate;
$columns[9] = new cardviewColumn();
$columns[9]->title = $strings['owner'];
$columns[9]->field_type = enumFieldType::ftAvatar;
$opt = array();
$opt[enumCardviewOption::oObject] = 'support_requests';
$opt[enumCardviewOption::oTableName] = 'support_requests';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;
$opt[enumCardviewOption::oExtraParameters] = $urlBornes . '&borne2=' . $block1->borne;

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_add_support_response[0] == enumBoolean::bTrue) {
        $opt[enumCardviewOption::oAddUrl] = "../support/addsupport.php?project=$project" . $urlBornes;
    }
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListSupportRequests; $i++) {
    $content = array(
        $listSupportRequests->sr_id[$i],
        $listSupportRequests->sr_subject[$i],
        $requestStatus[$listSupportRequests->sr_status[$i]],
        fieldValidValueString('support_requests', 'reproducibility', $listSupportRequests->sr_reproducibility[$i]),
        fieldValidValueString('support_requests', 'severity', $listSupportRequests->sr_severity[$i]),
        fieldValidValueString('support_requests', 'resolution', $listSupportRequests->sr_resolution[$i]),
        $priority[$listSupportRequests->sr_priority[$i]],
        $listSupportRequests->sr_date_open[$i],
        $listSupportRequests->sr_date_close[$i],
        implode(',',
            array(
                $listSupportRequests->sr_owner[$i],
                $listSupportRequests->sr_mem_extension_picture[$i],
                $listSupportRequests->sr_mem_gender[$i])),
        $listSupportRequests->sr_project[$i]
    );
    $block1->itemCardView($listSupportRequests->sr_id[$i], $content);
}

$block1->closeCardView();
$block1->bornesFooter(2, $blockPage->bornesNumber, "action=$action&project=$project" . $urlBornes);
$block1->closeFormResults();
require_once("../includes/footer.php");
