<?php // $Revision: 1.22 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewrequest.php,v 1.22 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableHelpSupport != "true") {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$sendto = isset($_GET['sendto'])?$_GET['sendto']:'';

/**
 * Permission check
 */
$querymore1 = " WHERE sr.id='$id'";
$supportRequestDetail = new request();
$supportRequestDetail->openSupportRequests($querymore1);
$comptSupportRequestDetail = count($supportRequestDetail->sr_id);

if ($comptSupportRequestDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$project = $supportRequestDetail->sr_project[0];
$querymore2 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore2);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore3 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore3);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore4);
$comptPermissionDetail = count($permissionDetail->prp_project);

if (!$SW_Permissions['Project']['Admin'][$profilSession] && ($permissionDetail->prp_view_support_request[0] != enumBoolean::bTrue || !$SW_Permissions['Project']['Read'][$profilSession])) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=support' . $urlBornes);
    exit;
}

/**
 * Prepare Data
 */
$querymore5 = " WHERE sp.request_id='$id' ORDER BY sp.date DESC";
$listSupportPosts = new request();
$listSupportPosts->openSupportPosts($querymore5);
$comptListSupportPosts = count($listSupportPosts->sp_id);
$querymore6 = " WHERE tas.support_request='$id' ORDER BY tas.created DESC";
$listTasks = new request();
$listTasks->openTasks($querymore6);
$comptListTasks = count($listTasks->tas_id);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=support&id=" . $supportRequestDetail->sr_project[0] . $urlBornes, $supportRequestDetail->sr_pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $supportRequestDetail->sr_project[0] . $urlBornes, lang_strings("support_requests"), 'in'));

if ($sendto == "new") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project . $urlBornes, lang_strings("new_requests"), 'in'));
} else if ($sendto == "open") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project . $urlBornes, lang_strings("open_requests"), 'in'));
} else if ($sendto == "complete") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../support/support.php?action=$sendto&project=" . $project . $urlBornes, lang_strings("closed_requests"), 'in'));
}

$blockPage->itemBreadcrumbs($supportRequestDetail->sr_subject[0]);
$blockPage->closeBreadcrumbs();
$title = $strings["support_request"] . " : " . $supportRequestDetail->sr_subject[0] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
logURL($title, "../support/viewrequest.php?id=$id&sendto=$sendto");
$block1 = new block();
$block1->form = "sdt";
$block1->openForm("../support/viewrequest.php?id=$id&project=$project" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("support_request") . " : " . $supportRequestDetail->sr_subject[0]);
$block1->openPaletteIcon();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_assign_support_request[0] == enumBoolean::bTrue || $permissionDetail->prp_close_support_request[0] == enumBoolean::bTrue) {
        $block1->paletteIcon(1, "edit", $strings["edit"]);
    }

    if ($permissionDetail->prp_delete_support_request[0] == enumBoolean::bTrue) {
        $block1->paletteIcon(2, "remove", $strings["delete"]);
    }
}

$block1->paletteIcon(99, 'search', 'support_requests');
$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $blockPage->buildLink("../projects/viewproject.php?toggle_focus=support&id=" . $supportRequestDetail->sr_project[0] . $urlBornes, $supportRequestDetail->sr_pro_name[0], 'in'));
$block1->contentRow(lang_strings("support_id"), $supportRequestDetail->sr_id[0]);
$block1->contentRow(lang_strings("owner"), $blockPage->buildLink($supportRequestDetail->sr_owner[0], '', 'message'));
$block1->contentRow(lang_strings("subject"), $supportRequestDetail->sr_subject[0]);
$block1->contentRow(lang_strings("status"), $requestStatus[$supportRequestDetail->sr_status[0]]);
$block1->contentRow(lang_strings("FIE__support_requests_reproducibility"), fieldValidValueString('support_requests', 'reproducibility', $supportRequestDetail->sr_reproducibility[0]));
$block1->contentRow(lang_strings("FIE__support_requests_severity"), fieldValidValueString('support_requests', 'severity', $supportRequestDetail->sr_severity[0]));
$block1->contentRow(lang_strings("FIE__support_requests_resolution"), fieldValidValueString('support_requests', 'resolution', $supportRequestDetail->sr_resolution[0]));
$block1->contentRow(lang_strings("priority"), $priority[$supportRequestDetail->sr_priority[0]]);
$block1->contentRow(lang_strings("date_open"), createDate($supportRequestDetail->sr_date_open[0],'both'));

if ($supportRequestDetail->sr_status[0] == enumRequestStatus::stCompleted) {
    $block1->contentRow(lang_strings("date_close"), createDate($supportRequestDetail->sr_date_close[0],'both'));
}

$orgmsg = $supportRequestDetail->sr_message[0];

if ($permissionDetail->prp_add_support_response[0] == enumBoolean::bTrue) {
    $orgmsg .= '<br><input type="checkbox" value="0">' . lang_strings('quote_message');
}

$block1->contentRow(lang_strings("message"), $orgmsg);

if ($supportRequestDetail->sr_status[0] != enumRequestStatus::stNew) {
    $block1->contentRow(lang_strings("assigned_to"), $blockPage->buildLink($supportRequestDetail->sr_mem2_email_work[0], $supportRequestDetail->sr_mem2_name[0], 'mail'));

    if ($comptListTasks == '1') {
        $block1->contentRow(lang_strings("task"), $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[0], $listTasks->tas_name[0], (($listTasks->tas_status[0]==enumStatus::stCompleted)?'instrike':'in')));
    } else if ($comptListTasks > 1) {
        for ($i=0; $i<$comptListTasks; $i++) {
            $taskArray[] = $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], (($listTasks->tas_status[$i]==enumStatus::stCompleted)?'instrike':'in'));
        }

        $block1->contentRow(lang_strings('tasks'), implode(' , ', $taskArray));
    }
}

setupCustomFieldsHTML($block1, 'support_requests', $id);

if (($fileManagement == "true") && ($permissionDetail->prp_view_file[0] == enumBoolean::bTrue)) {
    $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtSupportRequest . "' AND fil.doc_id='$id' AND fil.vc_parent='0' ORDER BY fil.name";
    $block1->contentRow('', setupAttachListHTML($querymore));
}

$block1->contentTitle(lang_strings("responses"));

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_add_support_response[0] == enumBoolean::bTrue) {
        $block1->contentRow("", '<a href="#" onclick="addpost(' . $supportRequestDetail->sr_id[0] . ')">' . lang_strings("add_support_response") . '</a>');
    }
}

for ($i=0; $i<$comptListSupportPosts; $i++) {
    $block1->contentRow(lang_strings("posted_by"), $blockPage->buildLink($listSupportPosts->sp_owner[$i], '', 'message'));
    $block1->contentRow(lang_strings("date"), createDate($listSupportPosts->sp_date[$i],'both'));

    if ($permissionDetail->prp_add_support_response[0] == enumBoolean::bTrue) {
        $block1->contentRow($blockPage->buildLink("../support/deletepost.php?sendto=$sendto&amp;id=" . $listSupportPosts->sp_id[$i], lang_strings("delete_message"), 'in'), $listSupportPosts->sp_message[$i] . '<br><input type="checkbox" value="' . $listSupportPosts->sp_id[$i] . '">' . lang_strings('quote_message'));
    } else {
        $block1->contentRow("", $listSupportPosts->sp_message[$i]);
    }

    setupCustomFieldsHTML($block1, 'support_posts', $listSupportPosts->sp_id[$i]);

    if (($fileManagement == "true") && ($permissionDetail->prp_view_file[0] == enumBoolean::bTrue)) {
        $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtSupportPost . "' AND fil.doc_id='" . $listSupportPosts->sp_id[$i] . "' AND fil.vc_parent=0 ORDER BY fil.name";
        $block1->contentRow('', setupAttachListHTML($querymore));
    }

    $block1->contentRow("", "", "true");
}

if ($status == $requestStatus[0]) {
    $status = "new";
} elseif ($status == $requestStatus[1]) {
    $status = "open";
} elseif ($status == $requestStatus[2]) {
    $status = "complete";
}

$block1->closeContent();
$block1->openPaletteScript();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_assign_support_request[0] == enumBoolean::bTrue || $permissionDetail->prp_close_support_request[0] == enumBoolean::bTrue) {
        $block1->paletteScript(1, "edit", "../support/editpost.php?sendto=$sendto&id=$id" . $urlBornes, "true,true,true", $strings["edit"]);
    }

    if ($permissionDetail->prp_delete_support_request[0] == enumBoolean::bTrue) {
        $block1->paletteScript(2, "remove", "../support/deleterequests.php?sendto=$sendto&id=$id" . $urlBornes, "true,true,true", $strings["delete"]);
    }
}

$block1->paletteScript(99, 'search', 'support_requests');
$block1->closePaletteScript($comptSupportRequestDetail, $supportRequestDetail->sr_id);
$block1->closeForm();
?>
<script type="text/javascript">
function addpost(id) {
    var x = '';
    $('[type=checkbox]:checked').each(function() { if (x!='') x = x + '**'; x = x + $(this).val(); });
    window.open('../support/addpost.php?id=' + id + '&qm=' + x,'_self');
}
</script>
<?php
require_once("../includes/footer.php");
