<?php // $Revision: 1.22 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addequipment.php,v 1.22 2013/01/29 08:46:20 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$task = AddSlashesNOD(isset($_GET['task'])?$_GET['task']:'');
$action = isset($_GET['action'])?$_GET['action']:'';
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');

/**
 * Permission check
 */
$querymore0 = " WHERE tas.id='$task'";
$taskDetail = new request();
$taskDetail->openTasks($querymore0);
$comptTaskDetail = count($taskDetail->tas_id);
$project = $taskDetail->tas_project[0];
$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

if ($projectDetail->pro_phase_set[0] != "0") {
    $tPhase = $taskDetail->tas_parent_phase[0];
    $querymore2 = " WHERE pha.project='$project' AND pha.order_num='$tPhase'";
    $targetPhase = new request();
    $targetPhase->openPhases($querymore2);
}

$querymore3 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore3);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore4);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_arrange_task_resource[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header("Location: ../teams/listusers.php?project=$project&msg=permissiondenied" . $urlBornes);
    exit;
}

/**
 * Actions
 */
if ($action == "add") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $pieces = explode("**", $id);
        $comptAjout = count($pieces);

        for($i=0; $i<$comptAjout; $i++) {
            $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_resource (project,task,resource,type,quantity,created,cuser) VALUES ('$project','$task','" . $pieces[$i] . "','" . enumResourceType::rtEquipment . "','1','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('tasks_resource');
            copy2HistoryTable($requestAct, 'tasks_resource', $num, 'A');
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../tasks/viewtask.php?project=$project&id=$task&msg=add" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));

if ($projectDetail->pro_phase_set[0] != "0") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project" . $urlBornes, lang_strings("phases"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $targetPhase->pha_id[0] . $urlBornes, $targetPhase->pha_description[0], 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project" . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?project=$project&id=$task" . $urlBornes, $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_equipment_usage"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "adE";
$block1->openForm("../tasks/addequipment.php?task=$task" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("add_equipment_usage"));
$block1->openPaletteIcon();
$block1->paletteIcon(0, "add", $strings["add"]);
$block1->closePaletteIcon();
$block1->sorting("task_equipment", (isset($sortingUser['task_equipment'])?$sortingUser['task_equipment']:''), "equ.name ASC", $sortingFields = array(0 => "equ.equipment_id", 1 => "equ.equipment_category", 2 => "equ.equipment_type", 3 => "equ.name"));
$querymore5 = " WHERE equ.status NOT IN ('" . enumEquipmentStatus::stBroken . "','" . enumEquipmentStatus::stSold . "') AND equ.locked='" . enumBoolean::bFalse . "' AND NOT EXISTS (SELECT res.id FROM " . $tablePrefix . "tasks_resource res WHERE res.task='$task' AND res.resource=equ.id AND res.type='" . enumResourceType::rtEquipment . "') ORDER BY " . $block1->sortingValue;
$listEquipments = new request();
$listEquipments->openEquipments($querymore5);
$comptListEquipments = count($listEquipments->equ_id);

if ($comptListEquipments > 0) {
    $labels = array(lang_strings("equipment_id"), lang_strings("equipment_category"), lang_strings("equipment_type"), lang_strings("name_print"));
    $block1->openResults();
    $block1->labels($labels, "false");

    for ($i=0; $i<$comptListEquipments; $i++) {
        $block1->openRow($listEquipments->equ_id[$i]);
        $block1->cellRow($blockPage->buildLink("../equipments/viewequipment.php?id=" . $listEquipments->equ_id[$i], $listEquipments->equ_equipment_id[$i], 'in'));
        $block1->cellRow($listEquipments->equ_eqc_name_print[$i]);
        $block1->cellRow($listEquipments->equ_eqt_name_print[$i]);
        $block1->cellRow($listEquipments->equ_name_print[$i]);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();
$block1->paletteScript(0, "add", "../tasks/addequipment.php?task=$task&action=add" . $urlBornes, "false,true,true", $strings["add"]);
$block1->closePaletteScript($comptListEquipments, $listEquipments->equ_id);
require_once("../includes/footer.php");
