<?php
// $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addmaterialissue.php,v 1.9 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$mat = AddSlashesNOD(isset($_REQUEST['mat'])?$_REQUEST['mat']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$qty = isset($_POST['qty'])?$_POST['qty']:'';
$ldI = isset($_POST['ldI'])?$_POST['ldI']:'';
$ld = ($ldI == '')?$dateToday:date2Timestamp($ldI);
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if ($enableMaterial != 'true') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore1 = " WHERE tas.id='$id'";
$taskDetail = new request();
$taskDetail->openTasks($querymore1);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$project = $taskDetail->tas_project[0];
$querymore2 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore2);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

if ($mat != '') {
    // get material resource detail
    $querymore3 = " AND res.task='$id' AND res.resource='$mat'";
    $taskResourceDetail = new request();
    $taskResourceDetail->openTaskMaterialResource($querymore3);
    $comptTaskResourceDetail = count($taskResourceDetail->res_id);

    if ($comptTaskResourceDetail == '0') {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
        exit;
    }
}

$querymore4 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore4);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore5 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore5 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore5);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_material_issue[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

/**
 * Fields check
 */
$error = '';

if ($action == 'add') {
    if (periodLocked($ld)) {     // check if period locked
        $error = lang_strings('period') . ' ' . createDate($period_date_start, 'date', false, true) . ' ~ ' . createDate($period_date_end, 'date', false, true) . ' ' . lang_strings('locked');
        $bodyCommand = 'onLoad="document.amIForm.ldI.focus();"';
        $ld_highlight = true;
    }
}

/**
 * Actions
 */
if ($action == 'add' && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $qty1 = round($qty, $quantityAccuracy);
        $tmpsql = 'INSERT INTO ' . $tablePrefix . "material_issue (project,task,owner,material,date,quantity,created,cuser) VALUES ('$project','$id','$idSession','$mat','$ld','$qty1','" . time() . "','$idSession')";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $num = $requestAct->newId('material_issue');
        copy2HistoryTable($requestAct, 'material_issue', $num, 'A');
        $qty = null;
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        $msg = 'add';
    }
}

/**
 * Set value in form
 */
if ($mat != '') {
    // get material total issue quantities for task
    $querymore = " WHERE iss.task='$id' AND iss.material='$mat'";
    $listMaterialIssue = new request();
    $listMaterialIssue->openMaterialIssue($querymore);
    $comptListMaterialIssue = count($listMaterialIssue->iss_id);
    $actual_qty = (($comptListMaterialIssue > 0) ? array_sum($listMaterialIssue->iss_quantity) : 0);
    $issue_qty = $taskResourceDetail->res_quantity[0] - $actual_qty;
}

// get material resource list for task
$querymore = " AND res.task='$id'";
$listTaskResources = new request();
$listTaskResources->openTaskMaterialResource($querymore);
$comptListTaskResources = count($listTaskResources->res_id);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_material_issue"));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = "14";
$block1 = new block();
$block1->form = "amI";
$block1->openForm("../tasks/addmaterialissue.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
$block1->heading(lang_strings("add_material_issue") . " : " . $taskDetail->tas_name[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $blockPage->buildLink('../projects/viewproject.php?toggle_focus=tasks&id=' . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$block1->contentRow(lang_strings("tasks"), $blockPage->buildLink('../tasks/viewtask.php?id=' . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));
$block1->contentRow(lang_strings("description"), $taskDetail->tas_description[0]);
$matSel = '<select name="mat" onchange="document.amIForm.action.value=\'\';document.amIForm.submit();">';

if ($mat == '') {
    $matSel .= '<option value="" selected></option>';
}

for ($i=0; $i<$comptListTaskResources; $i++) {
    $matSel .= '<option value="' . $listTaskResources->res_resource[$i] . '"';

    if ($mat == $listTaskResources->res_resource[$i]) {
        $matSel .= ' selected';
    }

    $matSel .= '>' . $listTaskResources->res_mat_name_print[$i] . '</option>';
}

$matSel .= '</select>';
$block1->contentRow(lang_strings("material"), $matSel);

if ($mat != '') {
    $block1->contentRow(lang_strings('unit'), $taskResourceDetail->res_mat_unit[0]);
    $block1->contentRow(lang_strings("estimated_qty"), NumberFormatNOD($taskResourceDetail->res_quantity[0], $quantityAccuracy, false));

    if ($issue_qty < 0) {
        $block1->contentRow(lang_strings("actual_qty"), '<b>' . NumberFormatNOD($actual_qty, $quantityAccuracy, false) . '</b>');
    } else {
        $block1->contentRow(lang_strings("actual_qty"), NumberFormatNOD($actual_qty, $quantityAccuracy, false));
    }

    $block1->contentTitle(lang_strings("add_material_issue"));
    setupInputHTML($block1, lang_strings('date'), 'ldI', enumFieldType::ftDate, 'Y', '0', $ld, '', '', $ld_highlight);
    setupInputHTML($block1, lang_strings('quantity'), 'qty', array(enumFieldType::ftQuantity, enumFieldOption::foPositiveNumber), 'Y', '0', $qty);
    $block1->contentRow('', "<input type='SUBMIT' value='" . $strings["save"] . "'>");
}

$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();

if ($mat != '') {
    // This will display material issue detail for the current task
    $block2 = new block();
    $block2->form = "ahT";
    $block2->openForm("../tasks/addmaterialissue.php?id=$id&mat=$mat" . $urlBornes . "#" . $block2->form . "Anchor");
    $block2->heading(lang_strings("material_issue") . ' : ' . lang_strings("details"));
    $block2->openPaletteIcon();
    $block2->paletteIcon(0, "remove", $strings["delete"]);
    $block2->paletteIcon(1, "edit", $strings["edit"]);
    $block2->closePaletteIcon();
    $block2->borne = $blockPage->returnBorne("14");
    $block2->rowsLimit = "20";
    $block2->sorting('material_issue', (isset($sortingUser['material_issue'])?$sortingUser['material_issue']:''), 'iss.date ASC', $sortingFields = array(0 => 'mem.name', 1 => 'iss.date', 2 => 'iss.quantity', 3 => 'iss.created', 4 => 'iss.modified'));
    $querymore = " WHERE iss.task='$id' AND iss.material='$mat' ORDER BY " . $block2->sortingValue;
    $block2->recordsTotal = $comptListMaterialIssue;
    $listMaterialIssue = new request();
    $listMaterialIssue->openMaterialIssue($querymore, $block2->borne, $block2->rowsLimit);
    $comptListMaterialIssue = count($listMaterialIssue->iss_task);

    if ($comptListMaterialIssue > 0) {
        $labels = array(lang_strings('owner'), lang_strings("date"), lang_strings("quantity"), lang_strings("created"), lang_strings("modified"));
        $block2->openResults();
        $block2->labels($labels, "false");

        // display material issue for task
        for ($i=0; $i<$comptListMaterialIssue; $i++) {
            $block2->openRow($listMaterialIssue->iss_id[$i]);
            $block2->cellRow($blockPage->buildLink($listMaterialIssue->iss_owner[$i], '', 'message'));
            $block2->cellRow(createDate($listMaterialIssue->iss_date[$i], 'date', false, true));
            $block2->cellRow(NumberFormatNOD($listMaterialIssue->iss_quantity[$i], $quantityAccuracy, false));
            $block2->cellRow(createDate($listMaterialIssue->iss_created[$i], 'both'));
            $block2->cellRow(createDate($listMaterialIssue->iss_modified[$i], 'both'));
            $block2->closeRow();
        }

        $block2->closeResults();
        $block2->bornesFooter("14", $blockPage->bornesNumber, "id=$id&mat=$mat" . $urlBornes);
    } else {
        $block2->noresults();
    }

    $block2->closeFormResults();
    $block2->openPaletteScript();
    $block2->paletteScript(0, "remove", "../tasks/deletematerialissue.php?task=$id&mat=$mat" . $urlBornes, "false,true,true", $strings["delete"]);
    $block2->paletteScript(1, "edit", "../tasks/editmaterialissue.php?" . $urlBornes, "false,true,false", $strings["edit"]);
    $block2->closePaletteScript($comptListMaterialIssue, $listMaterialIssue->iss_id);
}

require_once("../includes/footer.php");
