<?php // $Revision: 1.22 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addpredecessor.php,v 1.22 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.apDForm.pr.focus();"';
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$pr = isset($_POST['pr'])?$_POST['pr']:'';
$ty = isset($_POST['ty'])?$_POST['ty']:'';
$la = isset($_POST['la'])?$_POST['la']:'';
$taskgroupList = array();
$error = '';
$la_highlight = false;

/**
 * Functions
 */
function add_taskgroup_to_changelist($requestAct, $parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList)) {
        return;
    }

    $taskgroupList[$parent] = $level;
    $querymore = " WHERE tas.id='$parent'";
    $parentDetail = clone $requestAct;
    $parentDetail->openTasks($querymore);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($requestAct, $parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

function change_parent_task($requestAct, $parent)
{
    global $tablePrefix,$idSession;
    $querymore = " WHERE tas.parent_task='$parent'";
    $subtaskList = clone $requestAct;
    $subtaskList->openTasks($querymore);
    $newSubtask = count($subtaskList->tas_id);
    $newPriority = enumPriority::prVeryLow;
    $newStatus = enumStatus::stNotStarted;
    $newCompletion0 = 0;
    $newStartDate = -1;
    $newDueDate = -1;
    $newEstimatedTime = 0;
    $newActualTime = 0;
    $newPublished = enumPublished::pbNo;

    for ($i=0; $i<$newSubtask; $i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];
        $newCompletion0 += $completion;
        $newEstimatedTime += $estimated_time;
        $newActualTime += $actual_time;
        $newCompleteDate = 0;

        if ($newPriority < $priority) {
            $newPriority = $priority;
        }

        if ($status == enumStatus::stOpen || $newStatus == enumStatus::stOpen) {
            $newStatus = enumStatus::stOpen;
        } else if ($status == enumStatus::stSuspended || $newStatus == enumStatus::stSuspended) {
            $newStatus = enumStatus::stSuspended;
        } else if ($status == enumStatus::stNotStarted || $newStatus == enumStatus::stNotStarted) {
            $newStatus = enumStatus::stNotStarted;
        } else if ($status == enumStatus::stClientCompleted || $newStatus == enumStatus::stClientCompleted) {
            $newStatus = enumStatus::stClientCompleted;
        }

        if ($newStartDate > $start_date || $newStartDate < 0) {
            $newStartDate = $start_date;
        }

        if ($newDueDate < $due_date) {
            $newDueDate = $due_date;
        }

        if ($newStatus == enumStatus::stCompleted) {
            if ($newCompleteDate < $complete_date) {
                $newCompleteDate = $complete_date;
            }
        } else {
            $newCompleteDate = '0';
        }

        if ($published == enumPublished::pbYes) {
            $newPublished = enumPublished::pbYes;
        }
    }

    $newCompletion = substr($newCompletion0 / $newSubtask, 0, 1);
    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', task_group='" . enumTaskGroup::tgYes . "', subtask='$newSubtask', modified='" . time() . "', muser='$idSession' WHERE id='$parent'";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }

    copy2HistoryTable($requestAct, 'tasks', $parent, 'U');
}

/**
 * Permission check
 */
$querymore0 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore0);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

$querymore1 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore1);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore2 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore2 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore2);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_edit_task_relationships[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

$querymore3 = " WHERE tas.id='$id'";
$taskDetail = new request();
$taskDetail->openTasks($querymore3);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0') {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
} else if ($taskDetail->tas_task_group[0] == enumTaskGroup::tgYes) {
    header('Location: ../tasks/viewtask.php?id=' . $id . '&msg=permissiondenied' . $urlBornes);
    exit;
} else if ($taskDetail->tas_start_date[0] == '0' || $taskDetail->tas_due_date[0] == '0') {
    header("Location: ../tasks/viewtask.php?id=$id&msg=dateLack" . $urlBornes);
    exit;
}

$querymore4 = " WHERE tas.project='$project' AND tas.id<>'$id'";

if ($projectDetail->pro_phase_set[0] != "0") {
    $querymore4 .= " AND tas.parent_phase='" . $taskDetail->tas_parent_phase[0]. "'";
}

$listTasksP = new request();
$listTasksP->openTasks($querymore4);
$comptListTasksP = count($listTasksP->tas_id);
$querymore5 = " WHERE (pre.task='$id' OR pre.predecessor='$id') AND tas.start_date<>'0' AND tas.due_date<>'0' AND tas2.start_date<>'0' AND tas2.due_date<>'0'";
$listTasksL = new request();
$listTasksL->openTaskPredecessor($querymore5);
$comptListTasksL = count($listTasksL->pre_id);
$prSets = array();

for ($i=0; $i<$comptListTasksP; $i++) {
    for ($j=0; $j<$comptListTasksL; $j++) {
        if ($listTasksP->tas_id[$i] == $listTasksL->pre_task[$j] || $listTasksP->tas_id[$i] == $listTasksL->pre_predecessor[$j]) {
            break;
        }
    }

    if ($j != $comptListTasksL || $listTasksP->tas_task_group[$i] == enumTaskGroup::tgYes) {
        continue;
    }

    $prSets[$listTasksP->tas_id[$i]] = $listTasksP->tas_name[$i];
}

if (count($prSets) == 0) {
    header("Location: ../tasks/viewtask.php?id=$id&err=no_possible_tasks" . $urlBornes);
    exit;
}

/**
 * Check Fields
 */
if ($action == "add") {
    if (!is_numeric($la)) {
        $error = lang_strings('lag') . ' ' . lang_strings('error_numerical');
        $bodyCommand = 'onLoad="document.apDForm.la.focus();"';
        $la_highlight = true;
    }
}

/**
 * Actions
 */
if ($action == "add" && $error == '') {
    $criticalSection = enter_critical_section();
    $la = (is_numeric($la))?round($la, $hourAccuracy):'0';

    if ($criticalSection == -1) {
        header("Location: ../tasks/viewtask.php?id=$id&msg=$msg" . $urlBornes);
        exit;
    }

    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $querymore6 = " WHERE tas.id='$id'";
        $orgTask = clone $requestAct;
        $orgTask->openTasks($querymore6);
        // Adjust task start & due date with predecessor tasks
        $querymore7 = " WHERE pre.task = '$id'";
        $predecessorList = clone $requestAct;
        $predecessorList->openTaskPredecessor($querymore7);
        $comptPredecessorList = count($predecessorList->pre_id);
        $querymore8 = " WHERE tas.id='$pr'";
        $task1Detail = clone $requestAct;
        $task1Detail->openTasks($querymore8);
        $predecessorList->pre_tas2_start_date[$comptPredecessorList] = $task1Detail->tas_start_date[0];
        $predecessorList->pre_tas2_due_date[$comptPredecessorList] = $task1Detail->tas_due_date[0];
        $predecessorList->pre_lag[$comptPredecessorList] = $la;
        $predecessorList->pre_type[$comptPredecessorList] = $ty;
        $comptPredecessorList += 1;
        $sdLowerLimit = -1;
        $sdUpperLimit = -1;
        $ddLowerLimit = -1;
        $ddUpperLimit = -1;
        $timestampSD = date2timestamp($orgTask->tas_start_date[0]);
        $timestampDD = date2timestamp($orgTask->tas_due_date[0]);

        for ($i = 0; $i < $comptPredecessorList; $i++) {
            $timestampSD2 = $predecessorList->pre_tas2_start_date[$i];
            $timestampDD2 = $predecessorList->pre_tas2_due_date[$i];
            $timestampSD3 = hours_after($timestampSD2, $predecessorList->pre_lag[$i]+1, $projectDetail->pro_workcalendar[0]);
            $timestampDD3 = hours_after($timestampDD2, $predecessorList->pre_lag[$i]+1, $projectDetail->pro_workcalendar[0]);

            switch ($predecessorList->pre_type[$i]) {
                case 'FF':
                    if ($ddLowerLimit < $timestampDD2) {
                        $ddLowerLimit = $timestampDD2;
                    }

                    if ($ddUpperLimit == -1 || $ddUpperLimit > $timestampDD3) {
                        $ddUpperLimit = $timestampDD3;
                    }

                    break;
                case 'FS':
                    if ($sdLowerLimit < $timestampDD2) {
                        $sdLowerLimit = $timestampDD2;
                    }

                    if ($sdUpperLimit == -1 || $sdUpperLimit > $timestampDD3) {
                        $sdUpperLimit = $timestampDD3;
                    }

                    break;
                case 'SF':
                    if ($ddLowerLimit < $timestampSD2) {
                        $ddLowerLimit = $timestampSD2;
                    }

                    if ($ddUpperLimit == -1 || $ddUpperLimit > $timestampSD3) {
                        $ddUpperLimit = $timestampSD3;
                    }

                    break;
                case 'SS':
                    if ($sdLowerLimit < $timestampSD2) {
                        $sdLowerLimit = $timestampSD2;
                    }

                    if ($sdUpperLimit == -1 || $sdUpperLimit > $timestampSD3) {
                        $sdUpperLimit = $timestampSD3;
                    }

                    break;
            }

            if (($sdLowerLimit != -1 && $sdUpperLimit != -1 && $sdLowerLimit > $sdUpperLimit)
             || ($ddLowerLimit != -1 && $ddUpperLimit != -1 && $ddLowerLimit > $ddUpperLimit)
             || ($orgTask->tas_fixed_duration[0] == enumFixedDuration::fdYes && $sdUpperLimit != -1 && $ddLowerLimit != -1 && hours_after($sdUpperLimit, $orgTask->tas_estimated_time[0], $projectDetail->pro_workcalendar[0]) < $ddLowerLimit)
             || ($orgTask->tas_fixed_duration[0] == enumFixedDuration::fdYes && $sdLowerLimit != -1 && $ddUpperLimit != -1 && hours_after($sdLowerLimit, $orgTask->tas_estimated_time[0], $projectDetail->pro_workcalendar[0]) > $ddUpperLimit)
             || ($orgTask->tas_milestone[0] == enumMilestone::msYes && $sdUpperLimit != -1 && $ddLowerLimit != -1 && $sdUpperLimit < $ddLowerLimit)) {
                $requestAct->endTransaction(enumTransactionEndType::etRollBack);
                $requestAct->close();
                leave_critical_section($criticalSection);
                header("Location: ../tasks/viewtask.php?id=$id&msg=taskDependency" . $urlBornes);
                exit;
            }

            if ($orgTask->tas_milestone[0] == enumMilestone::msYes) {
                if ($ddLowerLimit != -1 && $sdLowerLimit < $ddLowerLimit) {
                    $sdLowerLimit = $ddLowerLimit;
                }

                if ($sdUpperLimit != -1 && $sdUpperLimit < $ddUpperLimit) {
                    $ddUpperLimit = $sdUpperLimit;
                }

                switch ($predecessorList->pre_type[$i]) {
                    case 'FF':
                    case 'SF':
                        if ($timestampDD < $ddLowerLimit || $timestampDD > $ddUpperLimit) {
                            $timestampDD = $ddUpperLimit;
                            $timestampSD = $timestampDD;
                        }

                        break;
                    case 'FS':
                    case 'SS':
                        if ($timestampSD < $sdLowerLimit || $timestampSD > $sdUpperLimit) {
                            $timestampDD = $sdUpperLimit;
                            $timestampSD = $timestampDD;
                        }

                        break;
                }
            } else if ($orgTask->tas_fixed_duration[0] == enumFixedDuration::fdYes) {
                if ($sdLowerLimit != -1 && $ddLowerLimit != -1 && hours_after($sdLowerLimit, $orgTask->tas_estimated_time[0], $projectDetail->pro_workcalendar[0]) < $ddLowerLimit) {
                    $sdLowerLimit = hours_before($ddLowerLimit, $orgTask->tas_estimated_time[0], $projectDetail->pro_workcalendar[0]);
                }

                if ($sdUpperLimit != -1 && $ddUpperLimit != -1 && hours_after($sdUpperLimit, $orgTask->tas_estimated_time[0], $projectDetail->pro_workcalendar[0]) < $ddUpperLimit) {
                    $ddUpperLimit = hours_after($sdUpperLimit, $orgTask->tas_estimated_time[0], $projectDetail->pro_workcalendar[0]);
                }

                switch ($predecessorList->pre_type[$i]) {
                    case 'FF':
                    case 'SF':
                        if ($timestampDD <= $ddLowerLimit) {
                            if ($predecessorList->pre_lag[$i] < "8") {
                                $timestampDD = $ddLowerLimit;
                            } else {
                                $timestampDD = hours_after($ddLowerLimit, 9, $projectDetail->pro_workcalendar[0]);
                            }
                        } else if ($timestampDD > $ddUpperLimit) {
                            $timestampDD = $ddUpperLimit;
                        }

                        $timestampSD = hours_before($timestampDD, $orgTask->tas_estimated_time[0], $projectDetail->pro_workcalendar[0]);
                        break;
                    case 'FS':
                    case 'SS':
                        if ($timestampSD <= $sdLowerLimit) {
                            if ($predecessorList->pre_lag[$i] < "8") {
                                $timestampSD = $sdLowerLimit;
                            } else {
                                $timestampSD = hours_after($sdLowerLimit, 9, $projectDetail->pro_workcalendar[0]);
                            }
                        } else if ($timestampSD > $sdUpperLimit) {
                            $timestampSD = $sdUpperLimit;
                        }

                        $timestampDD = hours_after($timestampSD, $orgTask->tas_estimated_time[0], $projectDetail->pro_workcalendar[0]);
                        break;
                }
            } else {
                switch ($predecessorList->pre_type[$i]) {
                    case 'FF':
                    case 'SF':
                        if ($timestampDD <= $ddLowerLimit) {
                            if ($predecessorList->pre_lag[$i] < "8") {
                                $timestampDD = $ddLowerLimit;
                            } else {
                                $timestampDD = hours_after($ddLowerLimit, 9, $projectDetail->pro_workcalendar[0]);
                            }
                        } else if ($timestampDD > $ddUpperLimit) {
                            $timestampDD = $ddUpperLimit;
                        }

                        if ($timestampSD > $timestampDD) {
                            $timestampSD = $timestampDD;
                        }

                        break;
                    case 'FS':
                    case 'SS':
                        if ($timestampSD <= $sdLowerLimit) {
                            if ($predecessorList->pre_lag[$i] < "8") {
                                $timestampSD = $sdLowerLimit;
                            } else {
                                $timestampSD = hours_after($sdLowerLimit, 9, $projectDetail->pro_workcalendar[0]);
                            }
                        } else if ($timestampSD > $sdUpperLimit) {
                            $timestampSD = $sdUpperLimit;
                        }

                        if ($timestampDD < $timestampSD) {
                            $timestampDD = $timestampSD;
                        }

                        break;
                }
            }
        }

        $sd = $timestampSD;
        $dd = $timestampDD;

        if ($orgTask->tas_fixed_duration[0] == enumFixedDuration::fdNo) {
            $diffHours = diff_hour($sd, $dd, $projectDetail->pro_workcalendar[0]);

            if ($diffHours < $etm) {
                $etm = $diffHours;
            }
        }

        $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_predecessor (task,predecessor,type,lag,created,cuser) VALUES('$id','$pr','$ty','$la','" . time() . "','$idSession')";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $num = $requestAct->newId("tasks_predecessor");
        copy2HistoryTable($requestAct, 'tasks_predecessor', $num, 'A');
        $tmpsql = "";

        if ($sd != $orgTask->tas_start_date[0]) {
            $tmpsql .= "start_date='$sd',";
        }

        if ($dd != $orgTask->tas_due_date[0]) {
            $tmpsql .= "due_date='$dd',";
        }

        if ($orgTask->tas_milestone[0] != enumMilestone::msYes && $orgTask->tas_fixed_duration[0] != enumFixedDuration::fdYes && $etm != $orgTask->tas_estimated_time[0]) {
            $tmpsql .= "estimated_time='$etm',";
        }

        if ($tmpsql != "") {
            $tmpsql = "UPDATE " . $tablePrefix . "tasks SET " . $tmpsql . "modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'tasks', $id, 'U');
            $cUp = "\n[datedue:" . createDate($dd,'date',false,true) . "]";
            $cUp = HtmlEntitiesNOD($cUp);
            $tmpsql = "INSERT INTO " . $tablePrefix . "updates (type,item,member,comments,created) VALUES ('1','$id','$idSession','$cUp','" . time() . "')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            if ($orgTask->tas_parent_task[0] != '0') {
                add_taskgroup_to_changelist($requestAct, $orgTask->tas_parent_task[0], $orgTask->tas_level[0]);
            }
            // Adjust task successors
            $adjArray = array($id);

            while (count($adjArray) > 0) {
                $adjTaskID = array_shift($adjArray);
                $tmpquery2 = " WHERE pre.predecessor='$adjTaskID'";
                $successorList = clone $requestAct;
                $successorList->openTaskPredecessor($tmpquery2);
                $comptSuccessorList = count($successorList->pre_id);

                for ($i = 0; $i < $comptSuccessorList; $i++) {
                    $timestampSD = $successorList->pre_tas_start_date[$i];
                    $timestampDD = $successorList->pre_tas_due_date[$i];
                    $timestampSD2 = $successorList->pre_tas2_start_date[$i];
                    $timestampDD2 = $successorList->pre_tas2_due_date[$i];
                    $timestampSD3 = hours_after($timestampSD2, $successorList->pre_lag[$i]+1, $projectDetail->pro_workcalendar[0]);
                    $timestampDD3 = hours_after($timestampDD2, $successorList->pre_lag[$i]+1, $projectDetail->pro_workcalendar[0]);

                    switch ($successorList->pre_type[$i]) {
                        case 'FF':
                            if ($timestampDD>$timestampDD3) {
                                $timestampDD = $timestampDD3;
                            } else if ($timestampDD<=$timestampDD2) {
                                if ($successorList->pre_lag[$i]<"8") {
                                    $timestampDD = $timestampDD2;
                                } else {
                                    $timestampDD = hours_after($timestampDD2, 9, $projectDetail->pro_workcalendar[0]);
                                }
                            }

                            if ($successorList->pre_tas_milestone[$i]==enumMilestone::msYes) {
                                $timestampSD = $timestampDD;
                            } else if ($successorList->pre_tas_fixed_duration[$i] == enumFixedDuration::fdYes) {
                                $timestampSD = hours_before($timestampDD, $successorList->pre_tas_estimated_time[$i], $projectDetail->pro_workcalendar[0]);
                            } else {
                                $timestampSD = hours_before($timestampDD, (($successorList->pre_tas_estimated_time[$i]>9)?9:$successorList->pre_tas_estimated_time[$i]), $projectDetail->pro_workcalendar[0]);
                            }

                            break;
                        case 'FS':
                            if ($timestampSD>$timestampDD3) {
                                $timestampSD = $timestampDD3;
                            } else if ($timestampSD<=$timestampDD2) {
                                if ($successorList->pre_lag[$i]<"8") {
                                    $timestampSD = $timestampDD2;
                                } else {
                                    $timestampSD = hours_after($timestampDD2, 9, $projectDetail->pro_workcalendar[0]);
                                }
                            }

                            if ($successorList->pre_tas_milestone[$i]==enumMilestone::msYes) {
                                $timestampDD = $timestampSD;
                            } else if ($successorList->pre_tas_fixed_duration[$i] == enumFixedDuration::fdYes) {
                                $timestampDD = hours_after($timestampSD, $successorList->pre_tas_estimated_time[$i], $projectDetail->pro_workcalendar[0]);
                            } else {
                                $timestampDD = hours_after($timestampSD, (($successorList->pre_tas_estimated_time[$i]>9)?9:$successorList->pre_tas_estimated_time[$i]), $projectDetail->pro_workcalendar[0]);
                            }

                            break;
                        case 'SF':
                            if ($timestampDD>$timestampSD3) {
                                $timestampDD = $timestampSD3;
                            } else if ($timestampDD<=$timestampSD2) {
                                if ($successorList->pre_lag[$i]<"8") {
                                    $timestampDD = $timestampSD2;
                                } else {
                                    $timestampDD = hours_after($timestampSD2, 9, $projectDetail->pro_workcalendar[0]);
                                }
                            }

                            if ($successorList->pre_tas_milestone[$i]==enumMilestone::msYes) {
                                $timestampSD = $timestampDD;
                            } else if ($successorList->pre_tas_fixed_duration[$i] == enumFixedDuration::fdYes) {
                                $timestampSD = hours_before($timestampDD, $successorList->pre_tas_estimated_time[$i], $projectDetail->pro_workcalendar[0]);
                            } else {
                                $timestampSD = hours_before($timestampDD, (($successorList->pre_tas_estimated_time[$i]>9)?9:$successorList->pre_tas_estimated_time[$i]), $projectDetail->pro_workcalendar[0]);
                            }

                            break;
                        case 'SS':
                            if ($timestampSD>$timestampSD3) {
                                $timestampSD = $timestampSD3;
                            } else if ($timestampSD<=$timestampSD2) {
                                if ($successorList->pre_lag[$i]<"8") {
                                    $timestampSD = $timestampSD2;
                                } else {
                                    $timestampSD = hours_after($timestampSD2, 9, $projectDetail->pro_workcalendar[0]);
                                }
                            }

                            if ($successorList->pre_tas_milestone[$i]==enumMilestone::msYes) {
                                $timestampDD = $timestampSD;
                            } else if ($successorList->pre_tas_fixed_duration[$i] == enumFixedDuration::fdYes) {
                                $timestampDD = hours_after($timestampSD, $successorList->pre_tas_estimated_time[$i], $projectDetail->pro_workcalendar[0]);
                            } else {
                                $timestampDD = hours_after($timestampSD, (($successorList->pre_tas_estimated_time[$i]>9)?9:$successorList->pre_tas_estimated_time[$i]), $projectDetail->pro_workcalendar[0]);
                            }

                            break;
                    }

                    $new_sd = $timestampSD;
                    $new_dd = $timestampDD;
                    $new_etm = diff_hour($new_sd, $new_dd, $projectDetail->pro_workcalendar[0]);
                    $tmpsql = "";

                    if ($new_sd != $successorList->pre_tas_start_date[$i]) {
                        $tmpsql .= "start_date='$new_sd',";
                    }

                    if ($new_dd != $successorList->pre_tas_due_date[$i]) {
                        $tmpsql .= "due_date='$new_dd',";
                    }

                    if ($successorList->pre_tas_milestone[$i] != enumMilestone::msYes && $successorList->pre_tas_fixed_duration[$i] != enumFixedDuration::fdYes && $new_etm != $successorList->pre_tas_estimated_time[$i]) {
                        $tmpsql .= "estimated_time='$new_etm',";
                    }

                    if ($tmpsql != "") {
                        array_push($adjArray, $successorList->pre_task[$i]);
                        $tmpsql = "UPDATE " . $tablePrefix . "tasks SET " . $tmpsql . "modified='" . time() . "',muser='$idSession' WHERE id='" . $successorList->pre_task[$i] . "'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        copy2HistoryTable($requestAct, 'tasks', $successorList->pre_task[$i], 'U');
                        $cUp = "\n[datedue:" . createDate($new_dd,'date',false,true) . "]";
                        $cUp = htmlentities($cUp, ENT_QUOTES, $htmlEntityCharset);
                        $tmpsql = "INSERT INTO " . $tablePrefix . "updates (type,item,member,comments,created) VALUES ('1','" . $successorList->pre_task[$i] . "','$idSession','$cUp','" . time() . "')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        if ($successorList->pre_tas_parent_task[$i] != '0') {
                            add_taskgroup_to_changelist($requestAct, $successorList->pre_tas_parent_task[$i], $successorList->pre_tas_level[$i]);
                        }
                    }
                }
            }

            if (count($taskgroupList) > 0) {
                arsort($taskgroupList, SORT_NUMERIC);
                reset($taskgroupList);

                while (list($parentTask, $level) = each($taskgroupList)) {
                    change_parent_task($requestAct, $parentTask);
                }
            }

            if ($projectDetail->pro_phase_set[0] != "0") {
                // change parent phase status
                $querymore = " WHERE tas.parent_phase='" . $orgTask->tas_parent_phase[0] . "'";
                $statusList = clone $requestAct;
                $statusList->openTasks($querymore);
                $comptStatusList = count($statusList->tas_id);
                $statusArray = array(0, 0, 0, 0, 0);

                for ($i = 0;$i < $comptStatusList; $i++) {
                    $statusArray[$statusList->status[$i]]++;
                }

                if ($comptStatusList == 0) {
                    $parentPhaseStatus = enumPhaseStatus::stNotStarted;
                } else if ($statusArray[enumStatus::stCompleted] == $comptStatusList) {
                    $parentPhaseStatus = enumPhaseStatus::stCompleted;
                } else if ($statusArray[enumStatus::stNotStarted] == $comptStatusList) {
                    $parentPhaseStatus = enumPhaseStatus::stNotStarted;
                } else if ($statusArray[enumStatus::stSuspended] == $comptStatusList) {
                    $parentPhaseStatus = enumPhaseStatus::stSuspended;
                } else {
                    $parentPhaseStatus = enumPhaseStatus::stOpen;
                }

                $querymore = " WHERE pha.id='" . $orgTask->tas_parent_phase[0] . "'";
                $phaseStatus = clone $requestAct;
                $phaseStatus->openPhases($querymore);

                if ($phaseStatus->pha_status[0] != $parentPhaseStatus) {
                    $tmpsql = "UPDATE " . $tablePrefix . "phases SET status='$parentPhaseStatus',modified='" . time() . "',muser='$idSession' WHERE id='" . $orgTask->tas_parent_phase[0] . "'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    copy2HistoryTable($requestAct, 'phases', $orgTask->tas_parent_phase[0], 'U');
                }
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
    leave_critical_section($criticalSection);

    if ($error == '') {
        header("Location: ../tasks/viewtask.php?id=$id&msg=add" . $urlBornes);
        exit;
    }
}

if ($error == '') {
    $la = '8';
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=$project" . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project" . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$id" . $urlBornes, $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_predecessor"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "apD";
$block1->openForm("../tasks/addpredecessor.php?project=$project&id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
$block1->heading(lang_strings("add_predecessor"));
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$prSel = "<select name=\"pr\">";

foreach ($prSets as $key => $val) {
    $prSel .= "<option value=\"$key\">$val</option>";
}

$prSel .= "</select>";
$block1->contentRow(lang_strings("predecessor"), $prSel);
$tySel = "<select name=\"ty\">";

foreach ($taskPredecessorTypes as $key => $val) {
    $tySel.= "<option value=\"$key\">$val</option>";
}

$tySel .= "</select>";
$block1->contentRow(lang_strings("type"), $tySel);
$block1->contentRow(lang_strings("lag"), "<input value=\"$la\"" . (($la_highlight)?' class="highlight"':'') . " name=\"la\" maxlength=\"5\" type=\"TEXT\">&nbsp;" . lang_strings('hours'));
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
