<?php // $Revision: 1.40 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addtasktime.php,v 1.40 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$hr = isset($_POST['hr'])?$_POST['hr']:'';
$ldI = isset($_POST['ldI'])?$_POST['ldI']:'';
$ld = ($ldI=='')?$dateToday:date2Timestamp($ldI);
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$serv = isset($_POST['serv'])?$_POST['serv']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
$querymore0 = " WHERE tas.id='$id'";
$taskDetail = new request();
$taskDetail->openTasks($querymore0);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$project = $taskDetail->tas_project[0];
$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

$querymore2 = " AND res.task='$id' AND res.resource='$idSession'";
$resourceUsage = new request();
$resourceUsage->openTaskHumanResource($querymore2);
$comptResourceUsage = count($resourceUsage->res_id);

if ($comptResourceUsage == '0') {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

$querymore3 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore3);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_log_task_hours[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

/**
 * Fields check
 */
$error = '';

if ($action == 'add') {
    if (!empty($hr)) {
        if (!is_numeric($hr)) {
            $error = lang_strings('worked_hours') . ' ' . lang_strings('error_numerical');
            $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
            $hr_highlight = true;
        } else if ($hr > 24 || $hr <= 0) {
            $error = lang_strings('worked_hours') . ' ' . lang_strings('error_hours');
            $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
            $hr_highlight = true;
        }
    } else {
        $error = lang_strings('worked_hours') . ' ' . lang_strings('error_required');
        $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
        $hr_highlight = true;
    }

    if ($error == '' && periodLocked($ld)) {    // check if period locked
        $error = lang_strings('period') . ' ' . createDate($period_date_start,'date',false,true) . ' ~ ' . createDate($period_date_end,'date',false,true) . ' ' . lang_strings('locked');
        $bodyCommand = 'onLoad="document.saTForm.ldI.focus();"';
        $ld_highlight = true;
    }
}

/**
 * Actions
 */
if ($action == 'add' && $error == '') {
    $hr = round($hr, $hourAccuracy);
    $comm = HtmlEntitiesNOD($comm);
    $bf = ($serv=='0')?enumBoolean::bFalse:enumBoolean::bTrue;
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = 'INSERT INTO ' . $tablePrefix . "tasks_time (project,task,owner,date,hours,comments,billing,service,created,cuser) VALUES ('" . $projectDetail->pro_id[0] . "','$id','$idSession','$ld','$hr','$comm','$bf',$serv,'" . time() . "','$idSession')";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        $hr = null;
        $comm = null;
        // successful insert
        $msg = 'hoursUpdated';
    }
}

/**
 * Set value in form
 */
if ($action == '' && $error == '') {
    if ($ld == '') {
        $ld = $dateToday;
    }
}

// get actual time for task
$taskActualTime = new request();
$actualTime = $taskActualTime->getTaskTime($id);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("add_task_time"));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = "14";
$block1 = new block();
$block1->form = "saT";
$block1->openForm("../tasks/addtasktime.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
$block1->heading(lang_strings("add_task_time") . " : " . $taskDetail->tas_name[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $blockPage->buildLink('../projects/viewproject.php?toggle_focus=tasks&id=' . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$block1->contentRow(lang_strings("tasks"), $blockPage->buildLink('../tasks/viewtask.php?id=' . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));
$block1->contentRow(lang_strings("description"), $taskDetail->tas_description[0]);
$block1->contentRow(lang_strings("estimated_time"), $taskDetail->tas_estimated_time[0] . " " . lang_strings("hours"));
$block1->contentRow(lang_strings("actual_time"), $actualTime . " " . lang_strings("hours"));
$block1->contentTitle(lang_strings("add_task_time"));
setupInputHTML($block1, lang_strings("date"), 'ldI', enumFieldType::ftDate, 'Y', '0', $ld, '', '', $ld_highlight);
$servSel = "<select name=\"serv\">";

if ($taskDetail->tas_service[0] != '0') {
    $querymore = " WHERE serv.id='" . $taskDetail->tas_service[0] . "'";
    $serviceDetail = new request();
    $serviceDetail->openServices($querymore);

    if ($taskDetail->tas_service[0] == $serv) {
        $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
    } else {
        $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
    }
} else if ($memberDetail->tea_service[0] != '0') {
    $querymore = " WHERE serv.id='" . $memberDetail->tea_service[0] . "'";
    $serviceDetail = new request();
    $serviceDetail->openServices($querymore);

    if ($memberDetail->tea_service[0] == $serv) {
        $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
    } else {
        $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
    }
}

if ($serv == '0') {
    $servSel .= "<option value='0' selected>" . $strings["none"] . "</option>";
} else {
    $servSel .= "<option value='0'>" . $strings["none"] . "</option>";
}

$servSel .= "</select>";
$block1->contentRow(lang_strings("service"), $servSel);
// hours
$block1->contentRow("* " . lang_strings("worked_hours"), "<input size='20' value='$hr'" . (($hr_highlight)?' class="highlight"':'') . " name='hr' maxlength='6' type='text'>");
// comments
setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
$block1->contentRow('', "<input type='SUBMIT' value='" . $strings["save"] . "'>");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
// This will display time log detail for the current task
$block2 = new block();
$block2->form = "ahT";
$block2->openForm("../tasks/addtasktime.php?id=$id" . $urlBornes . "#" . $block2->form . "Anchor");
$block2->heading(lang_strings("task_time") . ' : ' . lang_strings("details"));
$block2->openPaletteIcon();
$block2->paletteIcon(0, "remove", $strings["delete"]);
$block2->paletteIcon(1, "edit", $strings["edit"]);
$block2->closePaletteIcon();
$block2->borne = $blockPage->returnBorne("14");
$block2->rowsLimit = "20";
$block2->sorting('tasks_time', (isset($sortingUser['tasks_time'])?$sortingUser['tasks_time']:''), 'tim.date ASC', $sortingFields = array(0 => 'mem.name', 1 => 'tim.date', 2 => 'tim.hours', 3 => 'tim.created', 4 => 'tim.modified', 5 => 'tim.comments', 6 => 'tim.billing'));
$querymore = " WHERE tim.task='$id' ORDER BY $block2->sortingValue";
$block2->recordsTotal = compt($initrequest["tasks_time"] . " " . $querymore);
$listTaskTimes = new request();
$listTaskTimes->openTaskTime($querymore, $block2->borne, $block2->rowsLimit);
$comptListTaskTimes = count($listTaskTimes->tim_id);

if ($comptListTaskTimes > 0) {
    $labels = array(lang_strings("owner"), lang_strings("date"), ucfirst(lang_strings("hours")), lang_strings("created"), lang_strings("modified"), lang_strings('comment'), lang_strings('billing'));
    $block2->openResults();
    $block2->labels($labels, "false");

    // display logged hours for project
    for ($i = 0;$i < $comptListTaskTimes;$i++) {
        $block2->openRow($listTaskTimes->tim_id[$i]);
        $block2->cellRow($blockPage->buildLink($listTaskTimes->tim_owner[$i], '', 'message'));
        $block2->cellRow(createDate($listTaskTimes->tim_date[$i],'date',false,true));
        $block2->cellRow($listTaskTimes->tim_hours[$i]);
        $block2->cellRow(createDate($listTaskTimes->tim_created[$i], 'both'));
        $block2->cellRow(createDate($listTaskTimes->tim_modified[$i], 'both'));
        $comm = strip_tags($listTaskTimes->tim_comments[$i]);
        $block2->cellRow($comm);
        $block2->cellRow($billingFlag[$listTaskTimes->tim_billing[$i]]);
        $block2->closeRow();
    }

    $block2->closeResults();
    $block2->bornesFooter("14", $blockPage->bornesNumber, "id=$id" . $urlBornes);
} else {
    $block2->noresults();
}

$block2->closeFormResults();
$block2->openPaletteScript();
$block2->paletteScript(0, "remove", "../tasks/deletetasktime.php?task=$id" . $urlBornes, "false,true,true", $strings["delete"]);
$block2->paletteScript(1, "edit", "../tasks/edittasktime.php?task=$id" . $urlBornes, "false,true,false", $strings["edit"]);
$block2->closePaletteScript($comptListTaskTimes, $listTaskTimes->tim_id);
require_once("../includes/footer.php");
