<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletedependencies.php,v 1.13 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$error = '';

/**
 * Permission check
 */
$querymore0 = " WHERE tas.id='$id'";
$taskDetail = new request();
$taskDetail->openTasks($querymore0);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0' || $taskDetail->tas_project[0] != $project) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

$querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore2);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore3);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_edit_task_relationships[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

/**
 * Prepare Data
 */
$querymore4 = " WHERE pre.task='$id' OR pre.predecessor='$id'";
$listDependencies = new request();
$listDependencies->openTaskPredecessor($querymore4);
$comptListDependencies = count($listDependencies->pre_id);

/**
 * Actions
 */
if ($action == 'delete') {
    $criticalSection = enter_critical_section();

    if ($criticalSection == -1) {
        header("Location: ../tasks/viewtask.php?id=$id&msg=$msg");
        exit;
    }

    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $ids = implode(',', $listDependencies->pre_id);
        copy2HistoryTable($requestAct, 'tasks_predecessor', $ids, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "tasks_predecessor WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
    leave_critical_section($criticalSection);

    if ($error == '') {
        header("Location: ../tasks/viewtask.php?id=$id&msg=deleteDependencies" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $taskDetail->tas_project[0] . $urlBornes, $taskDetail->tas_pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $taskDetail->tas_project[0] . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_dependencies"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "dTD";
$block1->openForm("../tasks/deletedependencies.php?id=$id&project=$project" . $urlBornes . "#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings("delete_dependencies"));
$block1->openContent();

if ($comptListDependencies == '0') {
    $block1->noresults();
    $block1->contentRow('', "<input type=\"BUTTON\" value=\"" . $strings["goback"] . "\" onClick=\"history.back();\">");
} else {
    $block1->contentTitle(lang_strings("delete_following"));

    for ($i=0; $i<$comptListDependencies; $i++) {
        $block1->contentRow("", $listDependencies->pre_tas2_name[$i] . "&nbsp;&nbsp;<b><i>" . $taskPredecessorTypes[$listDependencies->pre_type[$i]] . "</i></b>&nbsp;&nbsp;" . $listDependencies->pre_tas_name[$i]);
    }

    $block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["delete"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
}

$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
