<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletematerialissue.php,v 1.6 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$mat = AddSlashesNOD(isset($_GET['mat'])?$_GET['mat']:'');
$task = AddSlashesNOD(isset($_GET['task'])?$_GET['task']:'');
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";

/**
 * Permission check
 */
$querymore1 = " WHERE tas.id='$task'";
$taskDetail = new request();
$taskDetail->openTasks($querymore1);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0' || $id == '') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$project = $taskDetail->tas_project[0];
$querymore2 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore2);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

$tmpquery = "SELECT id FROM " . $tablePrefix . "material_issue WHERE id IN ($ids) AND (task<>'$task' OR material<>'$mat' OR owner<>'$idSession')";

if (compt($tmpquery) > 0) {
    header("Location: ../tasks/viewtask.php?id=$task&msg=permissiondenied" . $urlBornes);
    exit;
}

$querymore3 = " WHERE iss.id IN ($ids) ORDER BY iss.date";
$listMaterialIssue = new request();
$listMaterialIssue->openMaterialIssue($querymore3);
$comptListMaterialIssue = count($listMaterialIssue->iss_id);

if ($comptListMaterialIssue == '0') {
    header("Location: ../tasks/viewtask.php?id=$task&msg=permissiondenied" . $urlBornes);
    exit;
}

// check if period locked
for ($i=0,$dt=''; $i<$comptListMaterialIssue; $i++) {
    if ($dt == $listMaterialIssue->iss_date[$i]) {
        continue;
    }

    $dt = $listMaterialIssue->iss_date[$i];

    if (periodLocked($dt)) {
        header("Location: ../tasks/viewtask.php?id=$task&msg=periodLocked" . $urlBornes);
        exit;
    }
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'material_issue', $ids, 'D');
        $tmpsql = 'DELETE FROM ' . $tablePrefix . "material_issue WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../tasks/addmaterialissue.php?id=$task&mat=$mat&msg=delete" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_material_issue"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'dmI';
$block1->openForm("../tasks/deletematerialissue.php?task=$task&mat=$mat&id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings("delete_material_issue"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

if ($comptListMaterialIssue == '0') {
    $block1->noresults();
    $block1->contentRow('', "<input type=\"BUTTON\" value=\"" . $strings["goback"] . "\" onClick=\"history.back();\">");
} else {
    for ($i=0; $i<$comptListMaterialIssue; $i++) {
        $block1->contentRow("#" . $listMaterialIssue->iss_id[$i], createDate($listMaterialIssue->iss_date[$i],'date',false,true) . " " . $listMaterialIssue->iss_mat_name_print[$i] . " " . NumberFormatNOD($listMaterialIssue->iss_quantity[$i], $quantityAccuracy, false) . " " . $listMaterialIssue->iss_mat_unit[$i]);
    }

    $block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["delete"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
}

$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
