<?php // $Revision: 1.18 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletematerials.php,v 1.18 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$task = AddSlashesNOD(isset($_GET['task'])?$_GET['task']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";

/**
 * Permission check
 */
$querymore1 = " WHERE tas.id='$task'";
$taskDetail = new request();
$taskDetail->openTasks($querymore1);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0' || $taskDetail->tas_project[0] != $project) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore2 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore2);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

$querymore3 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore3);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore4);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_arrange_task_resource[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

if ($taskDetail->tas_support_request[0] != '0') {
    $tmpquery = "SELECT task FROM " . $tablePrefix . "tasks_resource WHERE id NOT IN ($ids) AND task='$task' AND type='" . enumResourceType::rtUser . "'";
    $compt = compt($tmpquery);

    if ($compt == '0') {
        header('Location: ../tasks/viewtask.php?id=' . $task . '&msg=permissiondenied' . $urlBornes);
        exit;
    }
}

// material resource cannot be deleted if issue exist
$querymore5 = " AND res.id IN ($ids)";
$listResources = new request();
$listResources->openTaskMaterialResource($querymore5);
$comptListResources = count($listResources->res_id);

if ($comptListResources > '0') {
    $tmpquery = "SELECT iss.id FROM " . $tablePrefix . "material_issue iss WHERE iss.task='$task' AND iss.material IN ('" . implode("','", $listResources->res_resource) . "')";

    if (compt($tmpquery) != '0') {
        header('Location: ../tasks/viewtask.php?id=' . $task . '&msg=permissiondenied' . $urlBornes);
        exit;
    }
} else {
    header('Location: ../tasks/viewtask.php?id=' . $task . '&msg=permissiondenied' . $urlBornes);
    exit;
}

/**
 * Actions
 */
if ($action == 'delete') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'tasks_resource', $ids, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "tasks_resource WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../tasks/viewtask.php?id=$task&msg=delete" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_material_usage"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "rsD";
$block1->openForm("../tasks/deletematerials.php?project=$project&task=$task&id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings("delete_material_usage"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

if ($comptListResources == '0') {
    $block1->noresults();
    $block1->contentRow('', "<input type=\"BUTTON\" value=\"" . $strings["goback"] . "\" onClick=\"history.back();\">");
} else {
    for ($i=0; $i<$comptListResources;$i++) {
        $block1->contentRow("#" . $listResources->res_id[$i], $listResources->res_mat_name_print[$i] . ' ' . NumberFormatNOD($listResources->res_quantity[$i], $quantityAccuracy, false) . ' ' . $listResources->res_mat_unit[$i]);
    }

    $block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["delete"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
}

$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
