<?php // $Revision: 1.18 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletetasktime.php,v 1.18 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$task = AddSlashesNOD(isset($_GET['task'])?$_GET['task']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";

/**
 * Permission check
 */
$querymore = " WHERE tas.id='$task'";
$taskDetail = new request();
$taskDetail->openTasks($querymore);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$project = $taskDetail->tas_project[0];
$querymore = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

$tmpquery = "SELECT COUNT(id) AS cnt FROM " . $tablePrefix . "tasks_time WHERE id IN ($ids) UNION ALL SELECT COUNT(id) AS cnt FROM " . $tablePrefix . "tasks_time WHERE id IN ($ids) AND owner='$idSession'";
$request1 = new request();
$request1->connectClass();
$request1->query($tmpquery);
$cnt = array();

while ($request1->fetch()) {
    $cnt[] = ($row[0]);
}

$request1->close();

if ($cnt[0] == '0' || $cnt[0] != $cnt[1]) {
    header("Location: ../tasks/viewtask.php?id=$task&msg=permissiondenied" . $urlBornes);
    exit;
}

// check if period locked
$querymore = " WHERE tim.id IN ($ids) ORDER BY tim.date";
$listTasksTime = new request();
$listTasksTime->openTaskTime($querymore);
$comptListTasksTime = count($listTasksTime->tim_id);

for ($i=0,$dt=''; $i<$comptListTasksTime; $i++) {
    if ($dt == $listTasksTime->tim_date[$i]) {
        continue;
    }

    $dt = $listTasksTime->tim_date[$i];

    if (periodLocked($dt)) {
        header("Location: ../tasks/viewtask.php?id=$task&msg=periodLocked" . $urlBornes);
        exit;
    }
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = 'DELETE FROM ' . $tablePrefix . "tasks_time WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../tasks/addtasktime.php?id=$task&msg=delete" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_task_time"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = 'dtT';
$block1->openForm("../tasks/deletetasktime.php?task=$task&amp;id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings("delete_task_time"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

if ($comptListTasksTime == '0') {
    $block1->noresults();
    $block1->contentRow('', "<input type=\"BUTTON\" value=\"" . $strings["goback"] . "\" onClick=\"history.back();\">");
} else {
    for ($i=0; $i<$comptListTasksTime; $i++) {
        if ($listTasksTime->tim_comments[$i] == '') {
            $block1->contentRow('', "<i>#" . $listTasksTime->tim_id[$i] . "&nbsp;" . createDate($listTasksTime->tim_date[$i],'date',false,true) . "&nbsp;" . $listTasksTime->tim_hours[$i] . "&nbsp;" . lang_strings('hours') . '</i>');
        } else {
            $block1->contentRow('', "<i>#" . $listTasksTime->tim_id[$i] . "&nbsp;" . createDate($listTasksTime->tim_date[$i],'date',false,true) . "&nbsp;" . $listTasksTime->tim_hours[$i] . "&nbsp;" . lang_strings('hours') . '</i><br>' . $listTasksTime->tim_comments[$i]);
        }
    }

    $block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["delete"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
}

$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
