<?php // $Revision: 1.26 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editmaterial.php,v 1.26 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$task = AddSlashesNOD(isset($_GET['task'])?$_GET['task']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$mat = isset($_POST['mat'])?$_POST['mat']:'';
$qty = isset($_POST['qty'])?$_POST['qty']:'';

/**
 * Permission check
 */
$querymore1 = " WHERE tas.id='$task'";
$taskDetail = new request();
$taskDetail->openTasks($querymore1);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0' || $taskDetail->tas_project[0] != $project) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($id != '') {
    $querymore2 = " AND res.id='$id'";
    $taskResourceDetail = new request();
    $taskResourceDetail->openTaskMaterialResource($querymore2);
    $comptTaskResourceDetail = count($taskResourceDetail->res_id);

    if ($comptTaskResourceDetail == '0') {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
}

$querymore3 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore3);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

$querymore4 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore4);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == '0') {
    $querymore5 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore5 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore5);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_arrange_task_resource[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

/**
 * Actions
 */
if ($action == "add") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $qty = is_numeric($qty)?round($qty, $quantityAccuracy):'0';
        $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_resource (task,resource,type,quantity,created,cuser) VALUES ('$task','$mat','" . enumResourceType::rtMaterial . "','$qty','" . time() . "','$idSession')";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $num = $requestAct->newId('tasks_resource');
        copy2HistoryTable($requestAct, 'tasks_resource', $num, 'A');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../tasks/viewtask.php?id=$task&msg=add" . $urlBornes);
        exit;
    }
} else if ($action == "update") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $qty = is_numeric($qty)?round($qty, $quantityAccuracy):'0';
        $tmpsql = "UPDATE " . $tablePrefix . "tasks_resource SET quantity='$qty',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'tasks_resource', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../tasks/viewtask.php?id=$task&msg=update" . $urlBornes);
        exit;
    }
}

/**
 * Form init
 */
if ($id == '') {
    $querymore6 = " WHERE NOT EXISTS (SELECT res.id FROM " . $tablePrefix . "tasks_resource res WHERE res.task='$task' AND res.resource=mat.id AND res.type='" . enumResourceType::rtMaterial . "')";

    if ($projectDetail->pro_currency[0] != '') {
        $querymore6 .= " AND mat.currency='" . $projectDetail->pro_currency[0] . "'";
    }

    $querymore6 .= " AND mat.locked='" . enumBoolean::bFalse . "' ORDER BY mat.name";
    $listMaterials = new request();
    $listMaterials->openMaterials($querymore6);
    $comptListMaterials = count($listMaterials->mat_id);
}

if ($error == '') {
    if ($id == '') {
        if ($comptListMaterials > 0) {
            $mat = $listMaterials->mat_id[0];
            $unit = $listMaterials->mat_unit[0];
        } else {
            $mat = '';
            $unit = '';
        }

        $qty = 0;
    } else {
        $mat = $taskResourceDetail->res_resource[0];
        $qty = $taskResourceDetail->res_quantity[0];
        $unit = $taskResourceDetail->res_mat_unit[0];
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=$project" . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project" . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$task" . $urlBornes, $taskDetail->tas_name[0], 'in'));

if ($id == '') {
    $blockPage->itemBreadcrumbs(lang_strings("add_material_usage"));
} else {
    $blockPage->itemBreadcrumbs(lang_strings("edit_material_usage"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "eMU";
$block1->openForm("../tasks/editmaterial.php?project=$project&amp;task=$task&amp;id=$id" . $urlBornes . "#" . $block1->form . "Anchor");

if ($id == '') {
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">\n";
    $block1->heading(lang_strings("add_material_usage"));
} else {
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">\n";
    $block1->heading(lang_strings("edit_material_usage"));
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));

if ($id == "") {
    $matOpt = array();

    for ($i=0; $i<$comptListMaterials; $i++) {
        if ($mat == $listMaterials->mat_id[$i]) {
            $matOpt[] = '<option value="' . $listMaterials->mat_id[$i] . '" selected>' . $listMaterials->mat_name_print[$i] . '</option>';
        } else {
            $matOpt[] = '<option value="' . $listMaterials->mat_id[$i] . '">' . $listMaterials->mat_name_print[$i] . '</option>';
        }

        echo '<input type="hidden" id="u' . $listMaterials->mat_id[$i] . '" value="' . $listMaterials->mat_unit[$i] . '">';
    }

    $block1->contentRow(lang_strings('material'), '<select name="mat" onchange="changeMaterial(this)">' . implode('', $matOpt) . '</select>');
    $block1->contentRow(lang_strings('unit'), '<div id="unit">' . $unit . '</div>');
} else {
    $block1->contentRow(lang_strings("material"), $taskResourceDetail->res_mat_name_print[0]);
    $block1->contentRow(lang_strings('unit'), $unit);
}

setupInputHTML($block1, lang_strings('quantity'), 'qty', array(enumFieldType::ftQuantity, enumFieldOption::foPositiveNumber), 'Y', '0', $qty);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->closeForm();
?>
<script type="text/javascript">
function changeMaterial(theObj) {
    var m = theObj.options[theObj.selectedIndex].value;
    var u = document.getElementById('u' + m);
    var v = document.getElementById('unit');
    v.innerHTML = u.value;
}
</script>
<?php
require_once("../includes/footer.php");
