<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editmaterialissue.php,v 1.8 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.emIForm.qty.focus();"';
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$action = isset($_POST['action'])?$_POST['action']:'';
$qty = isset($_POST['qty'])?$_POST['qty']:'';
$ldI = isset($_POST['ldI'])?$_POST['ldI']:'';
$ld = ($ldI=='')?$dateToday:date2Timestamp($ldI);

/**
 * Permission check
 */
if ($enableMaterial != 'true') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore1 = " WHERE iss.id='$id'";
$materialIssueDetail = new request();
$materialIssueDetail->openMaterialIssue($querymore1);
$comptMaterialIssueDetail = count($materialIssueDetail->iss_id);

if ($comptMaterialIssueDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$project = $materialIssueDetail->iss_project[0];
$task = $materialIssueDetail->iss_task[0];
$mat = $materialIssueDetail->iss_material[0];
$querymore2 = " WHERE tas.id='$task'";
$taskDetail = new request();
$taskDetail->openTasks($querymore2);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore3 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore3);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
} else if ($materialIssueDetail->iss_owner[0] != $idSession) {
    header('Location: ../tasks/viewtask.php?id=' . $task . '&msg=permissiondenied' . $urlBornes);
    exit;
} else if (periodLocked($materialIssueDetail->iss_date[0])) {
    header('Location: ../tasks/viewtask.php?id=' . $task . '&msg=periodLocked' . $urlBornes);
    exit;
}

// get material resource detail
$querymore4 = " AND res.task='$task' AND res.resource='$mat'";
$taskResourceDetail = new request();
$taskResourceDetail->openTaskMaterialResource($querymore4);
$comptTaskResourceDetail = count($taskResourceDetail->res_id);

if ($comptTaskResourceDetail == '0') {
    header('Location: ../tasks/viewtask.php?id=' . $task . '&msg=permissiondenied' . $urlBornes);
    exit;
}

/**
 * Fields check
 */
$error = '';

if ($action == 'edit') {
    if (periodLocked($ld)) {
        $error = lang_strings('period') . ' ' . createDate($period_date_start, 'date', false, true) . ' ~ ' . createDate($period_date_end, 'date', false, true) . ' ' . lang_strings('locked');
        $bodyCommand = 'onLoad="document.emIForm.ldI.focus();"';
        $ld_highlight = true;
    }
}

/**
 * Actions
 */
if ($action == 'edit' && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $qty = round($qty, $quantityAccuracy);
        $tmpsql  = "UPDATE " . $tablePrefix . "material_issue SET date='$ld',quantity='$qty',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'material_issue', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../tasks/addmaterialissue.php?id=$task&mat=$mat&msg=update" . $urlBornes);
        exit;
    }
}

/**
 * Set value in form
 */
if ($error == '') {
    $ld = $materialIssueDetail->iss_date[0];
    $qty = $materialIssueDetail->iss_quantity[0];
}

/**
 * Prepare data
 */
// get material total issue quantities for task
$querymore = " WHERE iss.task='$task' AND iss.material='$mat'";
$listMaterialIssue = new request();
$listMaterialIssue->openMaterialIssue($querymore);
$comptListMaterialIssue = count($listMaterialIssue->iss_id);
$actual_qty = (($comptListMaterialIssue > 0) ? array_sum($listMaterialIssue->iss_quantity) : 0);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_material_issue"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "emI";
$block1->openForm("../tasks/editmaterialissue.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"edit\">";
$block1->heading(lang_strings("edit_material_issue") . " : " . $taskDetail->tas_name[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $projectDetail->pro_name[0]);
$block1->contentRow(lang_strings("tasks"), $taskDetail->tas_name[0]);
$block1->contentRow(lang_strings("description"), $taskDetail->tas_description[0]);
$block1->contentRow(lang_strings('material'), $materialIssueDetail->iss_mat_name_print[0]);
$block1->contentRow(lang_strings('unit'), $materialIssueDetail->iss_mat_unit[0]);
$block1->contentRow(lang_strings("estimated_qty"), NumberFormatNOD($taskResourceDetail->res_quantity[0], $quantityAccuracy, false));

if ($actual_qty > $taskResourceDetail->res_quantity[0]) {
    $block1->contentRow(lang_strings("actual_qty"), '<b>' . NumberFormatNOD($actual_qty, $quantityAccuracy, false) . '</b>');
} else {
    $block1->contentRow(lang_strings("actual_qty"), NumberFormatNOD($actual_qty, $quantityAccuracy, false));
}

$block1->contentTitle(lang_strings("edit_material_issue"));
setupInputHTML($block1, lang_strings('date'), 'ldI', enumFieldType::ftDate, 'Y', '0', $ld, '', '', $ld_highlight);
setupInputHTML($block1, lang_strings('quantity'), 'qty', array(enumFieldType::ftQuantity, enumFieldOption::foPositiveNumber), 'Y', '0', $qty);
$block1->contentRow('', "<input type='SUBMIT' value='" . $strings["update"] . "'><input type='button' name='cancel' value='" . $strings['cancel'] . "' onClick='history.back();'>");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
