<?php // $Revision: 1.77 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: edittask.php,v 1.77 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$taskgroupList = array();
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));  // The timestamp of today
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');                            // The unique id of task
$task = AddSlashesNOD(isset($_GET['task'])?$_GET['task']:'');                      // The id of task
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');             // The project id of task
$phase = AddSlashesNOD(isset($_GET['phase'])?$_GET['phase']:'');                   // The phase order number of task
$cpy = isset($_GET['cpy'])?$_GET['cpy']:'';                         // Indicate whether copy existing task
$dateCalend = isset($_GET['dateCalend'])?$_GET['dateCalend']:'';
$action = isset($_REQUEST['action'])?$_REQUEST['action']:'';
$atm = isset($_POST['atm'])?$_POST['atm']:'';                       // The actual time in hours of task
$c = isset($_POST['c'])?$_POST['c']:'';                             // The remarks of task
$cdI = isset($_POST['cdI'])?$_POST['cdI']:'';                       // The display field of complete date
$cd = ($cdI=='')?'0':date2Timestamp($cdI);                          // The complete date of task
$compl = isset($_POST['compl'])?$_POST['compl']:'';                 // The completion of task
$d = isset($_POST['d'])?$_POST['d']:'';                             // The description of task
$ddI = isset($_POST['ddI'])?$_POST['ddI']:'';                       // The display field of due date
$dd = ($ddI=='')?$dateToday:date2Timestamp($ddI);                   // The due date of task
$etm = isset($_POST['etm'])?$_POST['etm']:'';                       // The estimated time in hours of task
$fixd = isset($_POST['fixd'])?$_POST['fixd']:'';                    // Indicate whether task is fixed duration
$lvl = isset($_POST['lvl'])?$_POST['lvl']:'';                       // The WBS level of task
$miles = isset($_POST['miles'])?$_POST['miles']:'';                 // Indicate whether a milestone
$old_compl = isset($_POST['old_compl'])?$_POST['old_compl']:'';     // The original completion of task
$old_dd = isset($_POST['old_dd'])?$_POST['old_dd']:'0';             // The original due date of task
$old_pr = isset($_POST['old_pr'])?$_POST['old_pr']:'';              // The original priority of task
$old_sd = isset($_POST['old_sd'])?$_POST['old_sd']:'0';             // The original start date of task
$old_st = isset($_POST['old_st'])?$_POST['old_st']:'';              // The original status of task
$pr = isset($_POST['pr'])?$_POST['pr']:'';                          // The priority of task
$pta = isset($_POST['pta'])?$_POST['pta']:'';                       // The parent task id of task
$pub = isset($_POST['pub'])?$_POST['pub']:'';                       // Indicate whether task published
$sdI = isset($_POST['sdI'])?$_POST['sdI']:'';                       // The display field of start date
$sd = ($sdI=='')?$dateToday:date2Timestamp($sdI);                   // The start date of task
$serv = isset($_POST['serv'])?$_POST['serv']:'';                    // The service id of task
$st = isset($_POST['st'])?$_POST['st']:'';                          // The status of task
$sta = isset($_POST['sta'])?$_POST['sta']:'';                       // The sub-task count of task
$tg = isset($_POST['tg'])?$_POST['tg']:'';                          // Indicate whether a task group
$thr = isset($_POST['thr'])?$_POST['thr']:'';                       // The resource list of task
$tn = isset($_POST['tn'])?$_POST['tn']:'';                          // The name of task
$tt = isset($_POST['tt'])?$_POST['tt']:'';                          // The type of task
$subtaskids = isset($_POST['subtaskids'])?$_POST['subtaskids']:'';
$cUp = isset($_POST['cUp'])?$_POST['cUp']:'';
$mes = isset($_POST['mes'])?$_POST['mes']:'';
$etm_highlight = false;
$checkedPub = '';
$pubDisabled = '';
$notiAssign = '';

if (($action == 'add' || $action == 'update') && $js_enabled != 'Y') {
    $action = '';
}

if ($tt == '') {
    $tt = '0';
}

$bodyCommand = "onload=\"document.etDForm.compl.value = document.etDForm.completion.selectedIndex;document.etDForm.tn.focus();\"";

/**
 * add task group to change list
 *
 * @global array $taskgroupList
 * @param object $requestAct
 * @param int $parent
 * @param int $level
 */
function add_taskgroup_to_changelist($requestAct, $parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList)) {
        return;
    }

    $taskgroupList[$parent] = $level;
    $querymore = " WHERE tas.id='$parent'";
    $parentDetail = clone $requestAct;
    $parentDetail->openTasks($querymore);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($requestAct, $parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

/**
 * update parent task's attributes
 *
 * @global string $tablePrefix
 * @global string $idSession
 * @param object $requestAct
 * @param int $parent
 * @throws Exception
 */
function change_parent_task($requestAct, $parent)
{
    global $tablePrefix,$idSession;
    $querymore = " WHERE tas.parent_task='$parent'";
    $subtaskList = clone $requestAct;
    $subtaskList->openTasks($querymore);
    $newSubtask = count($subtaskList->tas_id);
    $newPriority = -1;
    $newStatus = '';
    $newStartDate = PHP_INT_MAX;
    $newDueDate = 0;
    $newCompleteDate = 0;

    for ($i = 0;$i < $newSubtask;$i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }

            if ($status == enumStatus::stOpen || $newStatus == enumStatus::stOpen) {
                $newStatus = enumStatus::stOpen;
            } else if ($status == enumStatus::stSuspended || $newStatus == enumStatus::stSuspended) {
                $newStatus = enumStatus::stSuspended;
            } else if ($status == enumStatus::stNotStarted || $newStatus == enumStatus::stNotStarted) {
                $newStatus = enumStatus::stNotStarted;
            } else if ($status == enumStatus::stClientCompleted || $newStatus == enumStatus::stClientCompleted) {
                $newStatus = enumStatus::stClientCompleted;
            }

            $newCompletion += $completion;

            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }

            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }

            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = '0';
            }

            if ($published == enumPublished::pbYes) {
                $newPublished = enumPublished::pbYes;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = '0';
            }

            $newPublished = $published;
        }
    }

    $newCompletion = floor($newCompletion / $newSubtask);
    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', task_group='" . enumTaskGroup::tgYes . "', subtask='$newSubtask', modified='" . time() . "', muser='$idSession' WHERE id='$parent'";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }

    copy2HistoryTable($requestAct, 'tasks', $parent, 'U');
}

/**
 * change sub-tasks' level
 *
 * @global string $tablePrefix
 * @global string $idSession
 * @param object $requestAct
 * @param int $id
 * @throws Exception
 */
function change_subtasks_level($requestAct, $id)
{
    global $tablePrefix,$idSession;
    $querymore = " WHERE tas.parent_task='$id'";
    $subtasksList = clone $requestAct;
    $subtasksList->openTasks($querymore);
    $comptSubtasksList = count($subtasksList->tas_id);

    for ($i = 0;$i < $comptSubtasksList;$i++) {
        $newLevel = $subtasksList->tas_level[$i] + 1;
        $tmpsql = "UPDATE " . $tablePrefix . "tasks SET level='$newLevel', modified='" . time() . "', muser='$idSession' WHERE id='" . $subtasksList->tas_id[$i] . "'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'tasks', $subtasksList->tas_id[$i], 'U');

        if ($subtasksList->tas_task_group[$i] == enumTaskGroup::tgYes) {
            change_subtasks_level($requestAct, $subtasksList->tas_id[$i]);
        }
    }
}

/**
 * determine page header
 *
 * @global int $project
 * @global int $task
 * @param string $msg
 */
function header_switch($msg)
{
    global $project, $task, $urlBornes;

    if ($project != '') {
        header("Location: ../tasks/listtasks.php?project=$project&msg=$msg" . $urlBornes);
    } else if ($task != '') {
        header("Location: ../tasks/viewtask.php?id=$task&msg=$msg" . $urlBornes);
    } else {
        header("Location: ../general/home.php?msg=$msg" . $urlBornes);
    }
}

/**
 * copy sub tasks
 *
 * @global string $tablePrefix
 * @global string $idSession
 * @global array $strings
 * @param object $requestAct
 * @param int $parent
 * @param int $new_parent
 * @throws Exception
 */
function copy_subtasks($requestAct, $parent, $new_parent)
{
    global $tablePrefix, $idSession, $strings;
    $querymore = " WHERE tas.parent_task='$parent'";
    $listTasks = clone $requestAct;
    $listTasks->openTasks($querymore);
    $comptListTasks = count($listTasks->tas_id);

    for ($i=0; $i<$comptListTasks; $i++) {
        $tmpsql = "INSERT INTO " . $tablePrefix . "tasks (project,name,description,owner,assigned_to,status,priority,start_date,due_date,estimated_time,comments,published,completion,service,fixed_duration,milestone,type,task_group,level,parent_task,subtask,parent_phase,created,cuser) VALUES ('" . $listTasks->tas_project[$i] . "','" . HtmlEntitiesNOD($strings['copy_of'] . ' ' . $listTasks->tas_name[$i]) . "','" . HtmlEntitiesNOD($listTasks->tas_description[$i]) . "','$idSession','0','" . $listTasks->tas_status[$i] . "','" . $listTasks->tas_priority[$i] . "','" . $listTasks->tas_start_date[$i] . "','" . $listTasks->tas_due_date[$i] . "','" . $listTasks->tas_estimated_time[$i] . "','" . HtmlEntitiesNOD($listTasks->tas_comments[$i]) . "','" . $listTasks->tas_published[$i] . "'," . $listTasks->tas_completion[$i] . "," . $listTasks->tas_service[$i] . ",'" . $listTasks->tas_fixed_duration[$i] . "','" . $listTasks->tas_milestone[$i] . "','" . $listTasks->tas_type[$i] . "','" . $listTasks->tas_task_group[$i] . "'," . $listTasks->tas_level[$i] . ",$new_parent," . $listTasks->tas_subtask[$i] . "," . $listTasks->tas_parent_phase[$i] . ",'" . time() . "','$idSession')";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $num = $requestAct->newId('tasks');
        copy2HistoryTable($requestAct, 'tasks', $num, 'A');
        $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('$num','$idSession','0','" . time() . "')";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        if ($listTasks->tas_task_group[$i] == enumTaskGroup::tgYes) {
            copy_subtasks($requestAct, $listTasks->tas_id[$i], $num);
        }
    }
}

if ($action == "taskgroup") {
    $subtaskids = str_replace("**", ",", $id);
} else if ($subtaskids != '') {
    $subtaskids = str_replace("**", ",", $subtaskids);
}

if ($subtaskids != "") {
    $querymore = " WHERE tas.id IN ($subtaskids)";
    $subtaskList = new request();
    $subtaskList->openTasks($querymore);
    $comptSubtaskList = count($subtaskList->tas_id);
    $st = $subtaskList->tas_status[0];
    $compl0 = $subtaskList->tas_completion[0];
    $pr = $subtaskList->tas_priority[0];
    $sd = $subtaskList->tas_start_date[0];
    $dd = $subtaskList->tas_due_date[0];
    $cd = $subtaskList->tas_complete_date[0];
    $etm = $subtaskList->tas_estimated_time[0];
    $atm = $subtaskList->tas_actual_time[0];
    $pub = $subtaskList->tas_published[0];
    $tg = enumTaskGroup::tgYes;
    $lvl = $subtaskList->tas_level[0];
    $pta = $subtaskList->tas_parent_task[0];
    $sta = $comptSubtaskList;
    $pha = $subtaskList->tas_parent_phase[0];

    for ($i = 1;$i < $comptSubtaskList;$i++) {
        if ($subtaskList->tas_level[$i] != $lvl) {
            header_switch('diffLevel');
            exit;
        }

        if ($subtaskList->tas_parent_task[$i] != $pta) {
            header_switch('diffParent');
            exit;
        }

        if ($subtaskList->tas_parent_phase[$i] != $pha) {
            header_switch('diffPhase');
            exit;
        }

        if ($subtaskList->tas_milestone[$i] == enumMilestone::msYes) {
            header_switch('noMilestoneGroup');
            exit;
        }

        if ($pr < $subtaskList->tas_priority[$i]) {
            $pr = $subtaskList->tas_priority[$i];
        }

        if ($subtaskList->tas_status[$i] == enumStatus::stOpen || $st == enumStatus::stOpen) {
            $st = enumStatus::stOpen;
        } else if ($subtaskList->tas_status[$i] == enumStatus::stSuspended || $st == enumStatus::stSuspended) {
            $st = enumStatus::stSuspended;
        } else if ($subtaskList->tas_status[$i] == enumStatus::stNotStarted || $st == enumStatus::stNotStarted) {
            $st = enumStatus::stNotStarted;
        } else if ($subtaskList->tas_status[$i] == enumStatus::stClientCompleted || $st == enumStatus::stClientCompleted) {
            $st = enumStatus::stClientCompleted;
        }

        $compl0 += $subtaskList->tas_completion[$i];

        if ($sd > $subtaskList->tas_start_date[$i]) {
            $sd = $subtaskList->tas_start_date[$i];
        }

        if ($dd < $subtaskList->tas_due_date[$i]) {
            $dd = $subtaskList->tas_due_date[$i];
        }

        $etm += $subtaskList->tas_estimated_time[$i];
        $atm += $subtaskList->tas_actual_time[$i];

        if ($subtaskList->tas_published[$i] == enumPublished::pbYes) {
            $pub = enumPublished::pbYes;
        }

        if ($st == enumStatus::stCompleted) {
            if ($cd < $subtaskList->tas_complete_date[$i]) {
                $cd = $subtaskList->tas_complete_date[$i];
            }
        } else {
            $cd = '0';
        }
    }

    $compl = floor($compl0 / $comptSubtaskList);
    $id = "";
} else {
    // case multiple edit tasks
    $multi = strstr($id, "**");

    if ($multi != "") {
        header("Location: ../tasks/updatetasks.php?task=$task&project=$project&id=$id" . $urlBornes);
        exit;
    }
}

/**
 * Permission check
 */
if ($id != '') {
    $querymore = " WHERE tas.id='$id'";
    $taskDetail = new request();
    $taskDetail->openTasks($querymore);
    $comptTaskDetail = count($taskDetail->tas_id);

    if ($comptTaskDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }
}

if (($id == '' || $cpy == 'true') && $project != '') {
    if (!is_numeric($project)) {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    $querymore = " WHERE pro.id='$project'";
} else {
    $querymore = " WHERE pro.id='" . $taskDetail->tas_project[0] . "'";
}

$projectDetail = new request();
$projectDetail->openProjects($querymore);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header_switch('permissiondenied');
    exit;
}

$querymore = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($cpy == 'true') {
    if ($permissionDetail->prp_copy_task[0] != enumBoolean::bTrue) {
        header_switch('permissiondenied');
        exit;
    }
} else {
    if ($id == '') {
        if ($permissionDetail->prp_create_task[0] != enumBoolean::bTrue) {
            header_switch('permissiondenied');
            exit;
        }
    } else {
        if ($permissionDetail->prp_modify_task_status[0] != enumBoolean::bTrue && $permissionDetail->prp_modify_task_properties[0] != enumBoolean::bTrue) {
            header_switch('permissiondenied');
            exit;
        }
    }
}

if (($action == 'add' || $action == 'update') && $id != '' && $cpy != 'true') {
    if (!is_array($thr) || count($thr) == '0' || (count($thr)=='1' && $thr[0]=='0')) {
        if ($taskDetail->tas_support_request[0] != '0') {
            header_switch('permissiondenied');
            exit;
        }
    }
}

/**
 * Fields check
 */
$error = '';

if ($action == 'add' || $action == 'update') {
    try {
        if ($miles != enumMilestone::msYes) {
            if ($etm == "") {   // Estimated time is required for tasks
                $etm_highlight = true;
                $bodyCommand = "onload=\"document.etDForm.compl.value = document.etDForm.completion.selectedIndex;document.etDForm.etm.focus();\"";
                throw new Exception(lang_strings('estimated_time') . ' ' . lang_strings('error_required'));
            }

            if ($etm <= 0 || $etm > 29200) {    // Estimated time deviates from permissible range
                $etm_highlight = true;
                $bodyCommand = "onload=\"document.etDForm.compl.value = document.etDForm.completion.selectedIndex;document.etDForm.etm.focus();\"";
                throw new Exception(lang_strings('estimated_time') . ' ' . lang_strings('value_deviate'));
            }

            if (diff_date($dd, $sd) >= 3650 || $dd < $sd) {     // Due date deviates from permissible range
                throw new Exception(lang_strings('due_date') . ' ' . lang_strings('value_deviate'));
            }

            if ($st == enumStatus::stCompleted && $cd < $sd) {             // Complete date deviates from permissible range
                throw new Exception(lang_strings('complete_date') . ' ' . lang_strings('value_deviate'));
            }
        }

        $error = checkCustomFields('tasks', $id);   // Check custom fields
    } catch (Exception $e) {
        $error = $e->getMessage();
    }
}

if ($id == "") {
    $comptListTaskResources = 0;
    $comptListTaskHumanResources = 0;
} else {
    $querymore = " AND res.task='$id'";
    $listTaskHumanResources = new request();
    $listTaskHumanResources->openTaskHumanResource($querymore);
    $comptListTaskHumanResources = count($listTaskHumanResources->res_id);
    $querymore = " WHERE sr.id='" . $taskDetail->tas_support_request[0] . "'";
    $supportRequestDetail = new request();
    $supportRequestDetail->openSupportRequests($querymore);
}

/**
 * Actions
 */
if (($error == '') && ($action == 'add' || $action == 'update')) {
    // concat values from date selector and replace quotes by html code
    $tn = HtmlEntitiesNOD($tn);
    $d = HtmlEntitiesNOD($d);
    $c = HtmlEntitiesNOD($c);

    if ($tg != enumTaskGroup::tgYes) {
        $tg = enumTaskGroup::tgNo;
    }

    if ($compl == "10") {
        $st = enumStatus::stCompleted;
    }

    if ($pub != enumPublished::pbYes) {
        $pub = enumPublished::pbNo;
    }

    if ($fixd != enumFixedDuration::fdNo) {
        $fixd = enumFixedDuration::fdYes;
    }

    if ($miles != enumMilestone::msYes) {
        $miles = enumMilestone::msNo;
    }

    if ($lvl == "") {
        $lvl = "0";
    }

    if ($pta == "") {
        $pta = "0";
    }

    if ($miles == enumMilestone::msYes) {
        unset($thr);
        $st = enumStatus::stNotStarted;
        $pr = enumPriority::prNone;
        $sd = $dd;
        $etm = "0";
        $compl = "0";
        $serv = "0";
        $fixd = enumFixedDuration::fdNo;
        $tt = "0";
    }

    if ($tg != enumTaskGroup::tgYes) {
        $tg = enumTaskGroup::tgNo;
        $sta = "0";
    } else {
        $serv = "0";
        $fixd = enumFixedDuration::fdNo;
        $miles = enumMilestone::msNo;
    }

    $resCount = 0;

    for ($i=0; $i<count($thr); $i++) {
        if ($thr[$i] != "0") {
            $resCount++;
        }
    }

    // Adjust task due date & estimated time
    if ($miles == enumMilestone::msNo && $tg == enumTaskGroup::tgNo) {
        $diffHours = diff_hour($sd, $dd, $projectDetail->pro_workcalendar[0]);

        if ($fixd == enumFixedDuration::fdYes) {
            if ($diffHours < $etm) {
                $dd = hours_after($sd, $etm, $projectDetail->pro_workcalendar[0]);
            }
        } else {
            if ($diffHours < $etm) {
                $etm = $diffHours;
            }
        }
    }

    if ($resCount == 0) {
        $tasAssigned = '0';
    } else {
        $tasAssigned = time();
    }

    if ($action == 'add') {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $cfsqls = setupCustomFieldsInsertSQL('tasks');  // Generate custom fields insert sql
            $tmpsql1 = "INSERT INTO " . $tablePrefix . "tasks (project,parent_phase,name,description,owner,assigned_to,status,priority,start_date,due_date,estimated_time,comments,published,completion,service,fixed_duration,milestone,type,task_group,level,parent_task,subtask,assigned,created,cuser";
            $tmpsql2 = $cfsqls[0] . ") VALUES ('$project','" . (($phase=='')?'0':$phase) . "','$tn','$d','$idSession','$resCount','$st','$pr','$sd','$dd','$etm','$c','$pub','$compl','$serv','$fixd','$miles',$tt,'$tg','$lvl','$pta','$sta','$tasAssigned','" . time() . "','$idSession'";

            // complete date
            if ($st == enumStatus::stCompleted) {
                $tmpsql1 .= ",complete_date";
                $tmpsql2 .= ",'$cd'";
            }

            $tmpsql = $tmpsql1 . $tmpsql2 . $cfsqls[1] . ')';

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId("tasks");
            $cfsql = setupCustomMediaFieldsUpdateSQL('tasks', $num);    // Upload custom fields images & generate custom fields update sql

            if ($cfsql !== '') {
                $tmpsql = "UPDATE " . $tablePrefix . "tasks SET $cfsql WHERE id='$num'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            if ($resCount == 0) {
                $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('$num','$idSession','0','" . time() . "')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $assids = $requestAct->newId("assignments");
            } else {
                $assids = "";

                for ($i=0; $i<count($thr); $i++) {
                    if ($thr[$i] == "0") {
                        continue;
                    }

                    $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('$num','$idSession','" . $thr[$i] . "','" . time() . "')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_resource (task,resource,type,created,cuser) VALUES ('$num','" . $thr[$i] . "','" . enumResourceType::rtUser . "','" . time() . "','$idSession')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $num1 = $requestAct->newId('tasks_resource');
                    copy2HistoryTable($requestAct, 'tasks_resource', $num1, 'A');

                    if ($assids != "") {
                        $assids .= "**";
                    }

                    $assids .= $requestAct->newId("assignments");
                }
            }

            // task group
            if ($tg == enumTaskGroup::tgYes) {
                $tmpsql = "UPDATE " . $tablePrefix . "tasks SET parent_task='$num',modified='" . time() . "',muser='$idSession' WHERE id IN ($subtaskids)";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                change_subtasks_level($requestAct, $num);
            }

            // send task assignment mail if notifications = true
            if ($resCount > 0) {
                $notiAssign = 'true';
            }

            // update parent tasks
            if ($pta != "0") {
                add_taskgroup_to_changelist($requestAct, $pta, $lvl);
                arsort($taskgroupList, SORT_NUMERIC);
                reset($taskgroupList);

                while (list($parentTask, $level) = each($taskgroupList)) {
                    change_parent_task($requestAct, $parentTask);
                }
            }

            $sendto = $num;
            $querymore = " WHERE fil.id='" . $projectDetail->pro_upload_dir[0] . "'";
            $folderDetail = clone $requestAct;
            $folderDetail->openFiles($querymore);
            $path = $folderDetail->fil_fullname[0];
            uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtTask, $sendto, enumFileStatus::stNoApprovalsNeeded, $projectDetail->pro_upload_dir[0], $path);
            copy2HistoryTable($requestAct, 'tasks', $sendto, 'A');
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if ($notiAssign == 'true') {
                if (!defined('INNER_NOTI_TASKASSIGN')) {
                    define('INNER_NOTI_TASKASSIGN', 1);
                }

                $num = $sendto;
                require_once("../tasks/noti_taskassignment.php");
            }

            if ($miles == enumMilestone::msYes) {
                header("Location: ../tasks/viewtask.php?id=$sendto&msg=add" . $urlBornes);
            } else {
                header("Location: ../tasks/viewtask.php?id=$sendto&assids=$assids&msg=addAssignment" . $urlBornes);
            }

            exit;
        }
    } else {
        if ($cpy == "true") {
            $requestAct = new request();
            $requestAct->connectClass();     // connect to database server

            try {
                $requestAct->startTransaction();
                $cfsqls = setupCustomFieldsInsertSQL('tasks');  // Generate custom fields insert sql
                $tmpquery1 = "INSERT INTO " . $tablePrefix . "tasks (project,parent_phase,name,description,owner,assigned_to,status,priority,start_date,due_date,estimated_time,comments,published,completion,service,fixed_duration,milestone,type,task_group,level,parent_task,subtask,assigned,created,cuser";
                $tmpquery2 = $cfsqls[0] . ") VALUES ('" . $taskDetail->tas_project[0] . "','" . $taskDetail->tas_parent_phase[0] . "','$tn','$d','$idSession','$resCount','$st','$pr','$sd','$dd','$etm','$c','$pub','$compl','$serv','$fixd','$miles','$tt','$tg','$lvl','$pta','$sta','$tasAssigned','" . time() . "','$idSession'";

                // complete date
                if ($st == enumStatus::stCompleted) {
                    $tmpquery1 .= ",complete_date";
                    $tmpquery2 .= ",'$cd'";
                }

                $tmpsql = $tmpquery1 . $tmpquery2 . $cfsqls[1] . ')';

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $num = $requestAct->newId("tasks");
                $cfsql = setupCustomMediaFieldsUpdateSQL('tasks', $num);    // Upload custom fields images & generate custom fields update sql

                if ($cfsql !== '') {
                    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET $cfsql WHERE id='$num'";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }

                if ($resCount == 0) {
                    $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('$num','$idSession','0','" . time() . "')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $assids = $requestAct->newId("assignments");
                } else {
                    $assids = "";

                    for ($i=0; $i<count($thr); $i++) {
                        if ($thr[$i] == "0") {
                            continue;
                        }

                        $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('$num','$idSession','" . $thr[$i] . "','" . time() . "')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_resource (task,resource,type,created,cuser) VALUES ('$num','" . $thr[$i] . "','" . enumResourceType::rtUser . "','" . time() . "','$idSession')";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }

                        $num2 = $requestAct->newId('tasks_resource');
                        copy2HistoryTable($requestAct, 'tasks_resource', $num2, 'A');

                        if ($assids != "") {
                            $assids .= "**";
                        }

                        $assids .= $requestAct->newId("assignments");
                    }
                }

                // send task assignment mail if notifications = true
                if ($resCount > 0) {
                    $notiAssign = 'true';
                }

                $sendto = $num;
                $querymore = " WHERE fil.id='" . $projectDetail->pro_upload_dir[0] . "'";
                $folderDetail = clone $requestAct;
                $folderDetail->openFiles($querymore);
                $path = $folderDetail->fil_fullname[0];
                uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtTask, $sendto, enumFileStatus::stNoApprovalsNeeded, $projectDetail->pro_upload_dir[0], $path);

                if ($tg == enumTaskGroup::tgYes) {
                    copy_subtasks($requestAct, $id, $sendto);
                }

                copy2HistoryTable($requestAct, 'tasks', $sendto, 'A');
                $requestAct->endTransaction(enumTransactionEndType::etCommit);
            } catch (Exception $e) {
                $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
                error_log($e->getMessage());
                $requestAct->endTransaction(enumTransactionEndType::etRollBack);
            }

            $requestAct->close();

            if ($error == '') {
                if ($notiAssign == 'true') {
                    if (!defined('INNER_NOTI_TASKASSIGN')) {
                        define('INNER_NOTI_TASKASSIGN', 1);
                    }

                    $num = $sendto;
                    require_once("../tasks/noti_taskassignment.php");
                }

                if ($miles == enumMilestone::msYes) {
                    header("Location: ../tasks/viewtask.php?id=$sendto&msg=add" . $urlBornes);
                } else {
                    header("Location: ../tasks/viewtask.php?id=$sendto&assids=$assids&msg=addAssignment" . $urlBornes);
                }

                exit;
            }
        } else {
            // case update task
            $criticalSection = enter_critical_section();

            if ($criticalSection == -1) {
                header("Location: ../tasks/viewtask.php?id=$id&msg=$msg" . $urlBornes);
                exit;
            }

            $requestAct = new request();
            $requestAct->connectClass();     // connect to database server

            try {
                $requestAct->startTransaction();
                $oldTHR = array();
                $newTHR = array();

                for ($i=0; $i<$comptListTaskHumanResources; $i++) {
                    $oldTHR[] = $listTaskHumanResources->res_resource[$i];
                }

                foreach ($thr as $thrOption) {
                    if ($thrOption == "0") {
                        continue;
                    }

                    $newTHR[] = $thrOption;
                }

                if (count(array_diff($oldTHR, $newTHR))>0 || count(array_diff($newTHR, $oldTHR))>0) {
                    $assignmentChanged = true;
                } else {
                    $assignmentChanged = false;
                }

                $resCount = count($newTHR);
                // Adjust task start & due date with predecessor tasks
                $querymore1 = " WHERE pre.task='$id'";
                $predecessorList = clone $requestAct;
                $predecessorList->openTaskPredecessor($querymore1);
                $comptPredecessorList = count($predecessorList->pre_id);

                if (($dd != $old_dd || $sd != $old_sd) && $comptPredecessorList > 0) {
                    $sdLowerLimit = -1;
                    $sdUpperLimit = -1;
                    $ddLowerLimit = -1;
                    $ddUpperLimit = -1;
                    $timestampSD = $sd;
                    $timestampDD = $dd;

                    for ($i=0; $i<$comptPredecessorList; $i++) {
                        $timestampSD2 = $predecessorList->pre_tas2_start_date[$i];
                        $timestampDD2 = $predecessorList->pre_tas2_due_date[$i];
                        $timestampSD3 = hours_after($timestampSD2, $predecessorList->pre_lag[$i]+1, $projectDetail->pro_workcalendar[0]);
                        $timestampDD3 = hours_after($timestampDD2, $predecessorList->pre_lag[$i]+1, $projectDetail->pro_workcalendar[0]);

                        switch ($predecessorList->pre_type[$i]) {
                            case 'FF':
                                if ($ddLowerLimit < $timestampDD2) {
                                    $ddLowerLimit = $timestampDD2;
                                }

                                if ($ddUpperLimit == -1 || $ddUpperLimit > $timestampDD3) {
                                    $ddUpperLimit = $timestampDD3;
                                }

                                break;
                            case 'FS':
                                if ($sdLowerLimit < $timestampDD2) {
                                    $sdLowerLimit = $timestampDD2;
                                }

                                if ($sdUpperLimit == -1 || $sdUpperLimit > $timestampDD3) {
                                    $sdUpperLimit = $timestampDD3;
                                }

                                break;
                            case 'SF':
                                if ($ddLowerLimit < $timestampSD2) {
                                    $ddLowerLimit = $timestampSD2;
                                }

                                if ($ddUpperLimit == -1 || $ddUpperLimit > $timestampSD3) {
                                    $ddUpperLimit = $timestampSD3;
                                }

                                break;
                            case 'SS':
                                if ($sdLowerLimit < $timestampSD2) {
                                    $sdLowerLimit = $timestampSD2;
                                }

                                if ($sdUpperLimit == -1 || $sdUpperLimit > $timestampSD3) {
                                    $sdUpperLimit = $timestampSD3;
                                }

                                break;
                        }

                        if (($sdLowerLimit != -1 && $sdUpperLimit != -1 && $sdLowerLimit > $sdUpperLimit)
                         || ($ddLowerLimit != -1 && $ddUpperLimit != -1 && $ddLowerLimit > $ddUpperLimit)
                         || ($fixd == enumFixedDuration::fdYes && $sdUpperLimit != -1 && $ddLowerLimit != -1 && hours_after($sdUpperLimit, $etm, $projectDetail->pro_workcalendar[0]) < $ddLowerLimit)
                         || ($fixd == enumFixedDuration::fdYes && $sdLowerLimit != -1 && $ddUpperLimit != -1 && hours_after($sdLowerLimit, $etm, $projectDetail->pro_workcalendar[0]) > $ddUpperLimit)
                         || ($miles == enumMilestone::msYes && $sdUpperLimit != -1 && $ddLowerLimit != -1 && $sdUpperLimit < $ddLowerLimit)) {
                            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
                            leave_critical_section($criticalSection);
                            header("Location: ../tasks/viewtask.php?id=$id&msg=taskDependency" . $urlBornes);
                            exit;
                        }

                        if ($miles == enumMilestone::msYes) {
                            if ($ddLowerLimit != -1 && $sdLowerLimit < $ddLowerLimit) {
                                $sdLowerLimit = $ddLowerLimit;
                            }

                            if ($sdUpperLimit != -1 && $sdUpperLimit < $ddUpperLimit) {
                                $ddUpperLimit = $sdUpperLimit;
                            }

                            switch ($predecessorList->pre_type[$i]) {
                                case 'FF':
                                case 'SF':
                                    if ($timestampDD < $ddLowerLimit || $timestampDD > $ddUpperLimit) {
                                        $timestampDD = $ddUpperLimit;
                                        $timestampSD = $timestampDD;
                                    }

                                    break;
                                case 'FS':
                                case 'SS':
                                    if ($timestampSD < $sdLowerLimit || $timestampSD > $sdUpperLimit) {
                                        $timestampDD = $sdUpperLimit;
                                        $timestampSD = $timestampDD;
                                    }

                                    break;
                            }
                        } else if ($fixd == enumFixedDuration::fdYes) {
                            if ($sdLowerLimit != -1 && $ddLowerLimit != -1 && hours_after($sdLowerLimit, $etm, $projectDetail->pro_workcalendar[0]) < $ddLowerLimit) {
                                $sdLowerLimit = hours_before($ddLowerLimit, $etm, $projectDetail->pro_workcalendar[0]);
                            }

                            if ($sdUpperLimit != -1 && $ddUpperLimit != -1 && hours_after($sdUpperLimit, $etm, $projectDetail->pro_workcalendar[0]) < $ddUpperLimit) {
                                $ddUpperLimit = hours_after($sdUpperLimit, $etm, $projectDetail->pro_workcalendar[0]);
                            }

                            switch ($predecessorList->pre_type[$i]) {
                                case 'FF':
                                case 'SF':
                                    if ($timestampDD <= $ddLowerLimit) {
                                        if ($predecessorList->pre_lag[$i] < "8") {
                                            $timestampDD = $ddLowerLimit;
                                        } else {
                                            $timestampDD = hours_after($ddLowerLimit, 9, $projectDetail->pro_workcalendar[0]);
                                        }
                                    } else if ($timestampDD > $ddUpperLimit) {
                                        $timestampDD = $ddUpperLimit;
                                    }

                                    $timestampSD = hours_before($timestampDD, $etm, $projectDetail->pro_workcalendar[0]);
                                    break;
                                case 'FS':
                                case 'SS':
                                    if ($timestampSD <= $sdLowerLimit) {
                                        if ($predecessorList->pre_lag[$i] < "8") {
                                            $timestampSD = $sdLowerLimit;
                                        } else {
                                            $timestampSD = hours_after($sdLowerLimit, 9, $projectDetail->pro_workcalendar[0]);
                                        }
                                    } else if ($timestampSD > $sdUpperLimit) {
                                        $timestampSD = $sdUpperLimit;
                                    }

                                    $timestampDD = hours_after($timestampSD, $etm, $projectDetail->pro_workcalendar[0]);
                                    break;
                            }
                        } else {
                            switch ($predecessorList->pre_type[$i]) {
                                case 'FF':
                                case 'SF':
                                    if ($timestampDD <= $ddLowerLimit) {
                                        if ($predecessorList->pre_lag[$i] < "8") {
                                            $timestampDD = $ddLowerLimit;
                                        } else {
                                            $timestampDD = hours_after($ddLowerLimit, 9, $projectDetail->pro_workcalendar[0]);
                                        }
                                    } else if ($timestampDD > $ddUpperLimit) {
                                        $timestampDD = $ddUpperLimit;
                                    }

                                    if ($timestampSD > $timestampDD) {
                                        $timestampSD = $timestampDD;
                                    }

                                    break;
                                case 'FS':
                                case 'SS':
                                    if ($timestampSD <= $sdLowerLimit) {
                                        if ($predecessorList->pre_lag[$i] < "8") {
                                            $timestampSD = $sdLowerLimit;
                                        } else {
                                            $timestampSD = hours_after($sdLowerLimit, 9, $projectDetail->pro_workcalendar[0]);
                                        }
                                    } else if ($timestampSD > $sdUpperLimit) {
                                        $timestampSD = $sdUpperLimit;
                                    }

                                    if ($timestampDD < $timestampSD) {
                                        $timestampDD = $timestampSD;
                                    }

                                    break;
                            }
                        }
                    }

                    $sd = $timestampSD;
                    $dd = $timestampDD;

                    if ($fixd == enumFixedDuration::fdNo) {
                        $diffHours = diff_hour($sd, $dd, $projectDetail->pro_workcalendar[0]);

                        if ($diffHours < $etm) {
                            $etm = $diffHours;
                        }
                    }
                }

                $cfsql = setupCustomFieldsUpdateSQL('tasks', $id);  // Generate custom fields update sql
                $tmpsql = "UPDATE " . $tablePrefix . "tasks SET name='$tn',description='$d',status='$st',priority='$pr',start_date='$sd',due_date='$dd',complete_date='$cd',estimated_time='$etm',comments='$c',completion='$compl',published='$pub',service='$serv',fixed_duration='$fixd',milestone='$miles',type='$tt',assigned_to='$resCount',modified='" . time() . "',muser='$idSession'";

                if ($assignmentChanged) {
                    $tmpsql .= ",assigned='" . time() . "'";
                }

                $tmpsql .= "$cfsql WHERE id='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                // automatically close this support request when task completed
                if ($taskDetail->tas_support_request[0] != '0' && $st != $old_st) {
                    if ($supportRequestDetail->sr_auto_close[0] == 'Y') {
                        if ($supportRequestDetail->sr_status[0] == enumRequestStatus::stOpen && $st == enumStatus::stCompleted) {
                            $tmpsql = "UPDATE " . $tablePrefix . "support_requests SET status='" . enumRequestStatus::stCompleted . "',date_close='" . time() . "' WHERE id='" . $taskDetail->tas_support_request[0] . "'";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }

                            copy2HistoryTable($requestAct, 'support_requests', $taskDetail->tas_support_request[0], 'U');
                        } else if ($supportRequestDetail->sr_status[0] == enumRequestStatus::stCompleted && $st != enumStatus::stCompleted) {
                            $tmpsql = "UPDATE " . $tablePrefix . "support_requests SET status='" . enumRequestStatus::stOpen . "',date_close='0' WHERE id='" . $taskDetail->tas_support_request[0] . "'";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }

                            copy2HistoryTable($requestAct, 'support_requests', $taskDetail->tas_support_request[0], 'U');
                        }
                    }
                }

                // add support post
                if ($taskDetail->tas_support_request[0] != '0' && $mes != '') {
                    $mes = HtmlEntitiesNOD($mes);
                    $cfsqls = setupCustomFieldsInsertSQL('support_posts', 'sp');  // Generate custom fields insert sql
                    $tmpsql = "INSERT INTO " . $tablePrefix . "support_posts (request_id,message,date,owner,project" . $cfsqls[0] . ") VALUES ('" . $taskDetail->tas_support_request[0] . "','$mes','" . time() . "','$idSession','" . $taskDetail->tas_project[0] . "'" . $cfsqls[1] . ")";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }

                    $sp_num = $requestAct->newId("support_posts");
                    $cfsql = setupCustomMediaFieldsUpdateSQL('support_posts', $sp_num, 'sp');    // Upload custom fields images & generate custom fields update sql

                    if ($cfsql !== '') {
                        $tmpsql = "UPDATE " . $tablePrefix . "support_posts SET $cfsql WHERE id='$sp_num'";

                        if ($requestAct->query($tmpsql) === false) {
                            throw new Exception($tmpsql);
                        }
                    }

                    copy2HistoryTable($requestAct, 'support_posts', $sp_num, 'A');
                }

                // reload task
                $querymore = " WHERE tas.id='$id'";
                $taskDetail = clone $requestAct;
                $taskDetail->openTasks($querymore);
                $at = '';
                $assids = "";

                if ($assignmentChanged) {
                    $diffTHR = array_diff($oldTHR, $newTHR);

                    if (count($diffTHR) > 0) {
                        $ids = implode(',', $diffTHR);
                        $querymore2 = " WHERE res.task='$id' AND res.resource IN ($ids) AND res.type='" . enumResourceType::rtUser . "'";
                        $listDiff = clone $requestAct;
                        $listDiff->openTaskResource($querymore2);

                        if (count($listDiff->res_id) > 0) {
                            $ids1 = implode(',', $listDiff->res_id);
                            copy2HistoryTable($requestAct, 'tasks_resource', $ids1, 'D');
                            $tmpsql = "DELETE FROM " . $tablePrefix . "tasks_resource WHERE id IN ($ids1)";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }
                        }
                    }

                    if (count($newTHR) == 0) {
                        $querymore = " AND res.task='$id'";
                        $resourceNoti = clone $requestAct;
                        $resourceNoti->openTaskHumanResource($querymore);

                        if (count($resourceNoti->res_id) == 0) {
                            $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('$id','$idSession','0','" . time() . "')";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }

                            $assids = $requestAct->newId("assignments");
                        }
                    } else {
                        if ($taskDetail->tas_support_request[0] != '0') {
                            $srat = $supportRequestDetail->sr_assigned_to[0];

                            if (!in_array($srat, $newTHR)) {
                                $tmpsql = "UPDATE " . $tablePrefix . "support_requests SET assigned_to='" . $newTHR[0] . "' WHERE id='" . $taskDetail->tas_support_request[0] . "'";

                                if ($requestAct->query($tmpsql) === false) {
                                    throw new Exception($tmpsql);
                                }

                                copy2HistoryTable($requestAct, 'support_requests', $taskDetail->tas_support_request[0], 'U');
                            }
                        }

                        $diffTHR = array_diff($newTHR, $oldTHR);
                        $at = implode('**', $diffTHR);

                        foreach ($diffTHR as $i) {
                            $tmpsql = "INSERT INTO " . $tablePrefix . "assignments (task,owner,assigned_to,assigned) VALUES ('$id','$idSession','$i','" . time() . "')";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }

                            $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_resource (task,resource,type,created,cuser) VALUES ('$id','$i','" . enumResourceType::rtUser . "','" . time() . "','$idSession')";

                            if ($requestAct->query($tmpsql) === false) {
                                throw new Exception($tmpsql);
                            }

                            $num3 = $requestAct->newId('tasks_resource');
                            copy2HistoryTable($requestAct, 'tasks_resource', $num3, 'A');

                            if ($assids != "") {
                                $assids .= "**";
                            }

                            $assids .= $requestAct->newId("assignments");
                        }
                    }

                    if ($at != "") {
                        $notiAssign = 'true';
                    }
                }

                if (in_array($taskDetail->tas_owner[0], $newTHR)) {
                    $notiList = $newTHR;
                } else {
                    $notiList = array_merge((array)($taskDetail->tas_owner[0]), $newTHR);
                }

                if (($k = array_search($idSession, $notiList)) !== false) {
                    unset($notiList[$k]);
                }

                if (count($notiList) > 0) {
                    $at = "'" . implode("','", $notiList) . "'";

                    // send status task change mail if notifications = true
                    if ($st != $old_st) {
                        $stChanged = 'true';
                    }

                    // send priority task change mail if notifications = true
                    if ($pr != $old_pr) {
                        $prChanged = 'true';
                    }

                    // send due date task change mail if notifications = true
                    if ($dd != $old_dd) {
                        $ddChanged = 'true';
                    }
                }

                if ($st != $old_st) {
                    $cUp .= "\n[status:$st]";
                }

                if ($pr != $old_pr) {
                    $cUp .= "\n[priority:$pr]";
                }

                if ($dd != $old_dd) {
                    $cUp .= "\n[datedue:" . createDate($dd,'date',false,true) . "]";
                }

                if ($cUp != "" || $st != $old_st || $pr != $old_pr || $dd != $old_dd) {
                    $cUp = HtmlEntitiesNOD($cUp);
                    $tmpsql = "INSERT INTO " . $tablePrefix . "updates (type,item,member,comments,created) VALUES ('1','$id','$idSession','$cUp','" . time() . "')";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }

                if ($taskDetail->tas_parent_task[0] != "0" && ($cUp != "" || $st != $old_st || $pr != $old_pr || $sd != $old_sd || $dd != $old_dd || $compl != $old_compl)) {
                    add_taskgroup_to_changelist($requestAct, $taskDetail->tas_parent_task[0], $taskDetail->tas_level[0]);
                }

                // Adjust task successors
                if ($dd != $old_dd || $sd != old_sd) {
                    $adjArray = array($id);

                    while (count($adjArray) > 0) {
                        $adjTaskID = array_shift($adjArray);
                        $tmpquery8 = " WHERE pre.predecessor='$adjTaskID'";
                        $successorList = clone $requestAct;
                        $successorList->openTaskPredecessor($tmpquery8);
                        $comptSuccessorList = count($successorList->pre_id);

                        for ($i = 0; $i < $comptSuccessorList; $i++) {
                            $timestampSD = $successorList->pre_tas_start_date[$i];
                            $timestampDD = $successorList->pre_tas_due_date[$i];
                            $timestampSD2 = $successorList->pre_tas2_start_date[$i];
                            $timestampDD2 = $successorList->pre_tas2_due_date[$i];
                            $timestampSD3 = hours_after($timestampSD2, $successorList->pre_lag[$i]+1, $projectDetail->pro_workcalendar[0]);
                            $timestampDD3 = hours_after($timestampDD2, $successorList->pre_lag[$i]+1, $projectDetail->pro_workcalendar[0]);

                            switch ($successorList->pre_type[$i]) {
                                case 'FF':
                                    if ($timestampDD>$timestampDD3) {
                                        $timestampDD = $timestampDD3;
                                    } else if ($timestampDD<=$timestampDD2) {
                                        if ($successorList->pre_lag[$i]<"8") {
                                            $timestampDD = $timestampDD2;
                                        } else {
                                            $timestampDD = hours_after($timestampDD2, 9, $projectDetail->pro_workcalendar[0]);
                                        }
                                    }

                                    if ($successorList->pre_tas_milestone[$i]==enumMilestone::msYes) {
                                        $timestampSD = $timestampDD;
                                    } else if ($successorList->pre_tas_fixed_duration[$i] == enumFixedDuration::fdYes) {
                                        $timestampSD = hours_before($timestampDD, $successorList->pre_tas_estimated_time[$i], $projectDetail->pro_workcalendar[0]);
                                    } else {
                                        $timestampSD = hours_before($timestampDD, (($successorList->pre_tas_estimated_time[$i]>9)?9:$successorList->pre_tas_estimated_time[$i]), $projectDetail->pro_workcalendar[0]);
                                    }

                                    break;
                                case 'FS':
                                    if ($timestampSD>$timestampDD3) {
                                        $timestampSD = $timestampDD3;
                                    } else if ($timestampSD<=$timestampDD2) {
                                        if ($successorList->pre_lag[$i]<"8") {
                                            $timestampSD = $timestampDD2;
                                        } else {
                                            $timestampSD = hours_after($timestampDD2, 9, $projectDetail->pro_workcalendar[0]);
                                        }
                                    }

                                    if ($successorList->pre_tas_milestone[$i]==enumMilestone::msYes) {
                                        $timestampDD = $timestampSD;
                                    } else if ($successorList->pre_tas_fixed_duration[$i] == enumFixedDuration::fdYes) {
                                        $timestampDD = hours_after($timestampSD, $successorList->pre_tas_estimated_time[$i], $projectDetail->pro_workcalendar[0]);
                                    } else {
                                        $timestampDD = hours_after($timestampSD, (($successorList->pre_tas_estimated_time[$i]>9)?9:$successorList->pre_tas_estimated_time[$i]), $projectDetail->pro_workcalendar[0]);
                                    }

                                    break;
                                case 'SF':
                                    if ($timestampDD>$timestampSD3) {
                                        $timestampDD = $timestampSD3;
                                    } else if ($timestampDD<=$timestampSD2) {
                                        if ($successorList->pre_lag[$i]<"8") {
                                            $timestampDD = $timestampSD2;
                                        } else {
                                            $timestampDD = hours_after($timestampSD2, 9, $projectDetail->pro_workcalendar[0]);
                                        }
                                    }

                                    if ($successorList->pre_tas_milestone[$i]==enumMilestone::msYes) {
                                        $timestampSD = $timestampDD;
                                    } else if ($successorList->pre_tas_fixed_duration[$i] == enumFixedDuration::fdYes) {
                                        $timestampSD = hours_before($timestampDD, $successorList->pre_tas_estimated_time[$i], $projectDetail->pro_workcalendar[0]);
                                    } else {
                                        $timestampSD = hours_before($timestampDD, (($successorList->pre_tas_estimated_time[$i]>9)?9:$successorList->pre_tas_estimated_time[$i]), $projectDetail->pro_workcalendar[0]);
                                    }

                                    break;
                                case 'SS':
                                    if ($timestampSD>$timestampSD3) {
                                        $timestampSD = $timestampSD3;
                                    } else if ($timestampSD<=$timestampSD2) {
                                        if ($successorList->pre_lag[$i]<"8") {
                                            $timestampSD = $timestampSD2;
                                        } else {
                                            $timestampSD = hours_after($timestampSD2, 9, $projectDetail->pro_workcalendar[0]);
                                        }
                                    }

                                    if ($successorList->pre_tas_milestone[$i]==enumMilestone::msYes) {
                                        $timestampDD = $timestampSD;
                                    } else if ($successorList->pre_tas_fixed_duration[$i] == enumFixedDuration::fdYes) {
                                        $timestampDD = hours_after($timestampSD, $successorList->pre_tas_estimated_time[$i], $projectDetail->pro_workcalendar[0]);
                                    } else {
                                        $timestampDD = hours_after($timestampSD, (($successorList->pre_tas_estimated_time[$i]>9)?9:$successorList->pre_tas_estimated_time[$i]), $projectDetail->pro_workcalendar[0]);
                                    }

                                    break;
                            }

                            $new_sd = $timestampSD;
                            $new_dd = $timestampDD;
                            $new_etm = diff_hour($new_sd, $new_dd, $projectDetail->pro_workcalendar[0]);
                            $tmpsql = "";

                            if ($new_sd != $successorList->pre_tas_start_date[$i]) {
                                $tmpsql .= "start_date='$new_sd',";
                            }

                            if ($new_dd != $successorList->pre_tas_due_date[$i]) {
                                $tmpsql .= "due_date='$new_dd',";
                            }

                            if ($successorList->pre_tas_milestone[$i] == enumMilestone::msNo && $successorList->pre_tas_fixed_duration[$i] == enumFixedDuration::fdNo && $new_etm < $successorList->pre_tas_estimated_time[$i]) {
                                $tmpsql .= "estimated_time='$new_etm',";
                            }

                            if ($tmpsql != "") {
                                array_push($adjArray, $successorList->pre_task[$i]);
                                $tmpsql = "UPDATE " . $tablePrefix . "tasks SET " . $tmpsql . "modified='" . time() . "',muser='$idSession' WHERE id='" . $successorList->pre_task[$i] . "'";

                                if ($requestAct->query($tmpsql) === false) {
                                    throw new Exception($tmpsql);
                                }

                                copy2HistoryTable($requestAct, 'tasks', $successorList->pre_task[$i], 'U');
                                $cUp = "\n[datedue:" . createDate($new_dd,'date',false,true) . "]";
                                $cUp = HtmlEntitiesNOD($cUp);
                                $tmpsql = "INSERT INTO " . $tablePrefix . "updates (type,item,member,comments,created) VALUES ('1','" . $successorList->pre_task[$i] . "','$idSession','$cUp','" . time() . "')";

                                if ($requestAct->query($tmpsql) === false) {
                                    throw new Exception($tmpsql);
                                }

                                if ($successorList->pre_tas_parent_task[$i] != '0') {
                                    add_taskgroup_to_changelist($requestAct, $successorList->pre_tas_parent_task[$i], $successorList->pre_tas_level[$i]);
                                }
                            }
                        }
                    }
                }

                if (count($taskgroupList) > 0) {
                    arsort($taskgroupList, SORT_NUMERIC);
                    reset($taskgroupList);

                    while (list($parentTask, $level) = each($taskgroupList)) {
                        change_parent_task($requestAct, $parentTask);
                    }
                }

                copy2HistoryTable($requestAct, 'tasks', $id, 'U');
                $requestAct->endTransaction(enumTransactionEndType::etCommit);
            } catch (Exception $e) {
                $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
                error_log($e->getMessage());
                $requestAct->endTransaction(enumTransactionEndType::etRollBack);
            }

            $requestAct->close();
            leave_critical_section($criticalSection);

            if ($error == '') {
                if ($notiAssign == 'true') {
                        if (!defined('INNER_NOTI_TASKASSIGN')) {
                            define('INNER_NOTI_TASKASSIGN', 1);
                        }

                        $num = $id;
                        require_once("../tasks/noti_taskassignment.php");
                }

                if ($stChanged == 'true') {
                    if (!defined('INNER_NOTI_STATUSTASKCHG')) {
                        define('INNER_NOTI_STATUSTASKCHG', 1);
                    }

                    require_once("../tasks/noti_statustaskchange.php");
                }

                if ($prChanged == 'true') {
                    if (!defined('INNER_NOTI_PRITASKCHG')) {
                        define('INNER_NOTI_PRITASKCHG', 1);
                    }

                    require_once("../tasks/noti_prioritytaskchange.php");
                }

                if ($ddChanged == 'true') {
                    if (!defined('INNER_NOTI_DUETASKCHG')) {
                        define('INNER_NOTI_DUETASKCHG', 1);
                    }

                    require_once("../tasks/noti_duedatetaskchange.php");
                }

                if ($assids == "" || $miles == enumMilestone::msYes) {
                    header("Location: ../tasks/viewtask.php?id=$id&msg=update" . $urlBornes);
                } else {
                    header("Location: ../tasks/viewtask.php?id=$id&assids=$assids&msg=updateAssignment" . $urlBornes);
                }

                exit;
            }
        }
    }
}

if ($error == '') {
    // set default values
    if ($id != "") {
        $projActualTime = new request();
        $atm = $projActualTime->getProjectTime($projectDetail->pro_id[0]);
        // set value in form
        $tn = $taskDetail->tas_name[0];
        $d = $taskDetail->tas_description[0];
        $sd = $taskDetail->tas_start_date[0];
        $dd = $taskDetail->tas_due_date[0];
        $cd = $taskDetail->tas_complete_date[0];
        $etm = $taskDetail->tas_estimated_time[0];
        $c = $taskDetail->tas_comments[0];
        $pub = $taskDetail->tas_published[0];
        $fixd = $taskDetail->tas_fixed_duration[0];
        $miles = $taskDetail->tas_milestone[0];
        $tt = $taskDetail->tas_type[0];
        $tg = $taskDetail->tas_task_group[0];
        $lvl = $taskDetail->tas_level[0];
        $pta = $taskDetail->tas_parent_task[0];
        $sta = $taskDetail->tas_subtask[0];
        $serv = $taskDetail->tas_service[0];
        unset($thr);

        for ($i=0; $i<$comptListTaskHumanResources; $i++) {
            $thr[] = $listTaskHumanResources->res_resource[$i];
        }

        if ($tg != enumTaskGroup::tgYes) {
            // stand-alone task
            $tg = enumTaskGroup::tgNo;
            $sta = "0";
            $pr = $taskDetail->tas_priority[0];
            $st = $taskDetail->tas_status[0];
            $compl = $taskDetail->tas_completion[0];
        } else {
            // task group
            $tmpquery = " WHERE tas.parent_task=$id";
            $subtaskList = new request();
            $subtaskList->openTasks($tmpquery);
            $comptSubtaskList = count($subtaskList->tas_id);
            $pub = $subtaskList->tas_published[0];
            $st = $subtaskList->tas_status[0];
            $compl0 = $subtaskList->tas_completion[0];
            $pr = $subtaskList->tas_priority[0];
            $sd = $subtaskList->tas_start_date[0];
            $dd = $subtaskList->tas_due_date[0];
            $cd = $subtaskList->tas_complete_date[0];
            $etm = $subtaskList->tas_estimated_time[0];
            $atm = $subtaskList->tas_actual_time[0];
            $tg = enumTaskGroup::tgYes;
            $lvl1 = $subtaskList->tas_level[0];
            $pta1 = $subtaskList->tas_parent_task[0];
            $sta = $comptSubtaskList;

            for ($i=1; $i<$comptSubtaskList; $i++) {
                if ($subtaskList->tas_level[$i] != $lvl1) {
                    header("Location: ../tasks/listtasks.php?project=$project&msg=diffLevel" . $urlBornes);
                    exit;
                }

                if ($subtaskList->tas_parent_task[$i] != $pta1) {
                    header("Location: ../tasks/listtasks.php?project=$project&msg=diffParent" . $urlBornes);
                    exit;
                }

                if ($subtaskList->tas_published[$i] == enumPublished::pbYes) {
                    $pub = enumPublished::pbYes;
                }

                if ($pr < $subtaskList->tas_priority[$i]) {
                    $pr = $subtaskList->tas_priority[$i];
                }

                if ($subtaskList->tas_status[$i] == enumStatus::stOpen || $st == enumStatus::stOpen) {
                    $st = enumStatus::stOpen;
                } else if ($subtaskList->tas_status[$i] == enumStatus::stSuspended || $st == enumStatus::stSuspended) {
                    $st = enumStatus::stSuspended;
                } else if ($subtaskList->tas_status[$i] == enumStatus::stNotStarted || $st == enumStatus::stNotStarted) {
                    $st = enumStatus::stNotStarted;
                } else if ($subtaskList->tas_status[$i] == enumStatus::stClientCompleted || $st == enumStatus::stClientCompleted) {
                    $st = enumStatus::stClientCompleted;
                }

                $compl0 += $subtaskList->tas_completion[$i];

                if ($sd > $subtaskList->tas_start_date[$i]) {
                    $sd = $subtaskList->tas_start_date[$i];
                }

                if ($dd < $subtaskList->tas_due_date[$i]) {
                    $dd = $subtaskList->tas_due_date[$i];
                }

                $etm += $subtaskList->tas_estimated_time[$i];
                $atm += $subtaskList->tas_actual_time[$i];

                if ($st == enumStatus::stCompleted) {
                    if ($cd < $subtaskList->tas_complete_date[$i]) {
                        $cd = $subtaskList->tas_complete_date[$i];
                    }
                } else {
                    $cd = '0';
                }
            }

            $compl = floor($compl0 / $comptSubtaskList);
        }
    } else {
        // case add task
        $thr = '';
        $pr = $projectDetail->pro_priority[0];
        $st = enumStatus::stNotStarted;
        $miles = enumMilestone::msNo;
        $pub = enumPublished::pbNo;
        $fixd = enumFixedDuration::fdYes;
        $compl = '0';
        $cd = '0';
        $serv = '0';
        $tt = '0';

        if ($dateCalend != '') {
            $sd = $dateCalend;
            $dd = $dateCalend;
        }

        $etm = diff_hour($sd, $dd, $projectDetail->pro_workcalendar[0]);
    }
}

if ($miles == enumMilestone::msYes) {
    $checkedMileS = "checked";
    $thrDisabled = "disabled";
    $stDisabled = "disabled";
    $complDisabled = "disabled";
    $prDisabled = "disabled";
    $servDisabled = "disabled";
} else {
    $checkedMileS = "";
    $thrDisabled = "";
    $stDisabled = "";
    $complDisabled = "";
    $prDisabled = "";
    $servDisabled = "";
}

if ($pub == enumPublished::pbYes) {
    $checkedPub = "checked";
} else {
    $checkedPub = "";
}

if ($fixd == enumFixedDuration::fdYes) {
    $checkedFixD = "checked";
} else {
    $checkedFixD = "";
}

if ($projectDetail->pro_phase_set[0] != "0") {
    if ($id != "") {
        $querymore = " WHERE pha.project='" . $taskDetail->tas_project[0] . "' AND pha.order_num='"  . $taskDetail->tas_parent_phase[0] . "'";
    } else {
        $querymore = " WHERE pha.project='$project' AND pha.order_num='$phase'";
    }

    $targetPhase = new request();
    $targetPhase->openPhases($querymore);
}
/**
 * get service valid values
 */
$querymore = " WHERE (serv.locked='" . enumBoolean::bFalse . "'";

if ($projectDetail->pro_currency[0] != '') {
    $querymore .= " AND serv.currency='" . $projectDetail->pro_currency[0] . "'";
}

$querymore .= ")";

if ($id != '') {
    $querymore .= " OR serv.id='" . $taskDetail->tas_service[0] . "'";
}

$querymore .= " ORDER BY serv.name";
$listServices = new request();
$listServices->openServices($querymore);
$comptListServices = count($listServices->serv_id);
$servVV = array();
$servVV['0'] = '';

for ($i=0; $i<$comptListServices; $i++) {
    $servVV[$listServices->serv_id[$i]] = $listServices->serv_name_print[$i];
}
/**
 * get hour code valid values
 */
if ($id != '') {
    $querymore = " WHERE (hrc.hourtype='" . enumHourType::htProject . "' AND hrc.locked='" . enumBoolean::bFalse . "') OR hrc.id='" . $taskDetail->tas_type[0] . "' ORDER BY hrc.id";
} else {
    $querymore = " WHERE hrc.hourtype='" . enumHourType::htProject . "' AND hrc.locked='" . enumBoolean::bFalse . "' ORDER BY hrc.id";
}

$listHourCode = new request();
$listHourCode->openHourCode($querymore);
$comptListHourCode = count($listHourCode->hrc_id);
$ttVV['0'] = '';

for ($i=0; $i<$comptListHourCode; $i++) {
    $ttVV[$listHourCode->hrc_id[$i]] = $listHourCode->hrc_id[$i] . ' - ' . $listHourCode->hrc_name_print[$i];
}

/**
 * Html
 */
require_once("../includes/header.php");
echo '<script type="text/javascript" src="../javascript/edittask' . $scriptMinimized . '.js"></script>';
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));

if ($projectDetail->pro_phase_set[0] != "0") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("phases"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=" . $projectDetail->pro_id[0] . "&id=" . $targetPhase->pha_id[0] . $urlBornes, $targetPhase->pha_description[0], 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("tasks"), 'in'));

if ($id == "") {
    if ($task == "") {
        if ($subtaskids == "") {
            $blockPage->itemBreadcrumbs(lang_strings("add_task"));
        } else {
            $blockPage->itemBreadcrumbs(lang_strings("add_taskgroup"));
        }
    } else {
        $querymore = " WHERE tas.id='$task'";
        $parentTaskDetail = new request();
        $parentTaskDetail->openTasks($querymore);
        $pta = $parentTaskDetail->tas_id[0];
        $lvl = $parentTaskDetail->tas_level[0] + 1;
        $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$task" . $urlBornes, $parentTaskDetail->tas_name[0], 'in'));
        $blockPage->itemBreadcrumbs(lang_strings("add_subtask"));
    }
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));

    if ($taskDetail->tas_task_group[0] == enumTaskGroup::tgYes) {
        $blockPage->itemBreadcrumbs(lang_strings("edit_taskgroup"));
    } else {
        $blockPage->itemBreadcrumbs(lang_strings("edit_task"));
    }
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "etD";

if ($id == "") {
    $block1->openForm("../tasks/edittask.php?project=$project&phase=$phase" . $urlBornes . "#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="add">';
} else {
    $block1->openForm("../tasks/edittask.php?project=$project&phase=$phase&id=$id&cpy=$cpy" . $urlBornes . "#" . $block1->form . "Anchor");
    echo '<input type="hidden" name="action" value="update">';
    echo "<input type=\"hidden\" name=\"old_assigned\" value=\"" . $taskDetail->tas_assigned[0] . "\">";
    echo "<input type=\"hidden\" name=\"old_pr\" value=\"" . $taskDetail->tas_priority[0] . "\">";
    echo "<input type=\"hidden\" name=\"old_st\" value=\"" . $taskDetail->tas_status[0] . "\">";
    echo "<input type=\"hidden\" name=\"old_dd\" value=\"" . $taskDetail->tas_due_date[0] . "\">";
    echo "<input type=\"hidden\" name=\"old_sd\" value=\"" . $taskDetail->tas_start_date[0] . "\">";
    echo "<input type=\"hidden\" name=\"old_tt\" value=\"" . $taskDetail->tas_type[0] . "\">";
    echo "<input type=\"hidden\" name=\"old_compl\" value=\"" . $taskDetail->tas_completion[0] . "\">";
}

if ($id == "") {
    if ($task == "") {
        if ($subtaskids == "") {
            $block1->heading(lang_strings("add_task"));
        } else {
            $block1->heading(lang_strings("add_taskgroup"));
        }
    } else {
        $block1->heading(lang_strings("add_subtask"));
    }
} else {
    if ($taskDetail->tas_task_group[0] == enumTaskGroup::tgYes) {
        if ($cpy == "true") {
            $block1->heading(lang_strings("copy_taskgroup") . " : " . $taskDetail->tas_name[0]);
        } else {
            $block1->heading(lang_strings("edit_taskgroup") . " : " . $taskDetail->tas_name[0]);
        }
    } else {
        if ($cpy == "true") {
            $block1->heading(lang_strings("copy_task") . " : " . $taskDetail->tas_name[0]);
        } else {
            $block1->heading(lang_strings("edit_task") . " : " . $taskDetail->tas_name[0]);
        }
    }
}

echo '<input type="hidden" name="wca" value="' . $projectDetail->pro_workcalendar[0] . '">';
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $projectDetail->pro_name[0]);
// Display task's phase
if ($projectDetail->pro_phase_set[0] != "0") {
    $block1->contentRow(lang_strings("phase"), $blockPage->buildLink("../phases/viewphase.php?id=" . $targetPhase->pha_id[0] . $urlBornes, $targetPhase->pha_description[0], 'in'));
}

$org_name = ($projectDetail->pro_organization[0]=='1')?lang_strings('none'):$projectDetail->pro_org_name[0];
$block1->contentRow(lang_strings("organization"), $org_name);

if ($id != '' && $taskDetail->tas_support_request[0] != '0') {
    $block1->contentRow(lang_strings("support_request"), $blockPage->buildLink("../support/viewrequest.php?id=" . $taskDetail->tas_support_request[0] . $urlBornes, '#' . $taskDetail->tas_support_request[0], 'in') . " " . $taskDetail->tas_sr_subject[0]);
}

$block1->closeContent();
$block1->openContent(true);
$block1->contentTitle(lang_strings("details"));

if ($cpy == "true") {
    $tn = $strings["copy_of"] . $tn;
}

setupInputHTML($block1, lang_strings("name"), 'tn', enumFieldType::ftText, 'Y', '255', $tn);
setupInputHTML($block1, lang_strings('description'), 'd', enumFieldType::ftMemo, 'N', '0', $d);
$assignedToSel = "<select name=\"thr[]\" multiple=\"multiple\" $thrDisabled>";

if (!isset($thr) || !is_array($thr) || count($thr) == '0' || (count($thr)=='1' && $thr[0]=='0')) {
    $assignedToSel .= "<option value=\"0\" selected>" . lang_strings("unassigned") . "</option>";
} else {
    $assignedToSel .= "<option value=\"0\">" . lang_strings("unassigned") . "</option>";
}

$querymore = " WHERE tea.project='" . (($id=='')?$project:$taskDetail->tas_project[0]) . "' ORDER BY mem.name";
$assignto = new request();
$assignto->openTeams($querymore);
$comptAssignto = count($assignto->tea_mem_id);

for ($i=0; $i<$comptAssignto; $i++) {
    $clientUser = "";

    if ($assignto->tea_mem_organization[$i] != "1") {
        $clientUser = " (" . lang_strings("client_user") . ")";
    }

    if (isset($thr) && is_array($thr) && in_array($assignto->tea_mem_id[$i], $thr)) {
        $assignedToSel .= "<option value=\"" . $assignto->tea_mem_id[$i] . "\" selected>" . $assignto->tea_mem_name[$i] . "$clientUser</option>";
    } else {
        $assignedToSel .= "<option value=\"" . $assignto->tea_mem_id[$i] . "\">" . $assignto->tea_mem_name[$i] . "$clientUser</option>";
    }
}

$assignedToSel .= "</select>";
$block1->contentRow(lang_strings("assigned_to"), $assignedToSel);

if ($id == '' || (isset($taskDetail) && $taskDetail->tas_mem2_organization[0] == '1')) {   // new task or team task
    echo '<input type="hidden" name="ctas" value="N">';
} else {
    echo '<input type="hidden" name="ctas" value="Y">';
}

// edit task group
if ($subtaskids != "" || (isset($taskDetail) && $taskDetail->tas_task_group[0] == enumTaskGroup::tgYes)) {
    echo "<input type=\"hidden\" name=\"miles\" value=\"$miles\">";
    echo "<input name=\"st\" type=\"hidden\" value=\"$st\">";
    echo "<input name=\"compl\" type=\"hidden\" value=\"$compl\">";
    echo "<input name=\"pr\" type=\"hidden\" value=\"$pr\">";
    echo "<input type=\"hidden\" name=\"fixd\" value=\"$fixd\">";
    list($uformat, $cformat, $mformat) = preg_split('/\|/', $dateformatSession);
    $sdI = ($sd=='0')?'':date($uformat, $sd);
    $ddI = ($dd=='0')?'':date($uformat, $dd);
    $cdI = ($cd=='0')?'':date($uformat, $cd);
    echo "<input type=\"hidden\" name=\"sdI\" value=\"$sdI\">";
    echo "<input type=\"hidden\" name=\"ddI\" value=\"$ddI\">";
    echo "<input type=\"hidden\" name=\"cdI\" value=\"$cdI\">";
    echo "<input type=\"hidden\" name=\"etm\" value=\"$etm\">";
    echo "<input type=\"hidden\" name=\"atm\" value=\"$atm\">";
    echo "<input type=\"hidden\" name=\"tg\" value=\"$tg\">";
    echo "<input type=\"hidden\" name=\"lvl\" value=\"$lvl\">";
    echo "<input type=\"hidden\" name=\"pta\" value=\"$pta\">";
    echo "<input type=\"hidden\" name=\"sta\" value=\"$sta\">";
    $subtaskids = str_replace(",", "**", $subtaskids);
    echo "<input type=\"hidden\" name=\"subtaskids\" value=\"$subtaskids\">";
// edit task
} else {
    if ($id == '' || $taskDetail->tas_mem2_organization[0] == '1') {   // new task or team task
        $block1->contentRow(lang_strings("milestone"), "<input size=\"32\" value=\"$miles\" name=\"mileS\" type=\"checkbox\" onchange=\"changeMilestone(this)\" $checkedMileS>");
    }

    echo "<input type=\"hidden\" name=\"miles\" value=\"$miles\">";
    $statusSel = "<select name=\"st\" onchange=\"changeSt(this)\" $stDisabled>";

    if ($id == '' || $taskDetail->tas_mem2_organization[0] == '1') {   // new task or team task
        foreach ($statusTeamTask as $key => $val) {
            $statusSel .= "<option value=\"$key\"" . (($key==$st)?' selected':'') . ">$val</option>";
        }
    } else {
        foreach ($statusClientTask as $key => $val) {   // client task
            $statusSel .= "<option value=\"$key\"" . (($key==$st)?' selected':'') . ">$val</option>";
        }
    }

    $statusSel .= "</select>";
    $block1->contentRow(lang_strings("status"), $statusSel);
    $complSel = "<input name=\"compl\" type=\"hidden\" value=\"$compl\"><select name=\"completion\" onchange=\"changeCompletion(this)\" $complDisabled>";

    for ($i = 0;$i < 11;$i++) {
        $complValue = ($i > 0) ? $i . "0 %": $i . " %";

        if ($compl == $i) {
            $complSel .= "<option value=\"" . $i . "\" selected>" . $complValue . "</option>";
        } else {
            $complSel .= "<option value=\"" . $i . "\">" . $complValue . "</option>";
        }
    }

    $complSel .= "</select>";
    $block1->contentRow(lang_strings("completion"), $complSel);
    $priSel = "<select name=\"pr\" $prDisabled>";
    $comptPri = count($priority);

    for ($i=0; $i<$comptPri; $i++) {
        if ($pr == $i) {
            $priSel .= "<option value=\"$i\" selected>$priority[$i]</option>";
        } else {
            $priSel .= "<option value=\"$i\">$priority[$i]</option>";
        }
    }

    $priSel .= "</select>";
    $block1->contentRow(lang_strings("priority"), $priSel);
    $block1->contentRow(lang_strings("fixed_duration"), "<input size=\"32\" value=\"$fixd\" name=\"fixD\" type=\"checkbox\" onchange=\"changeFixedDuration(this)\" $checkedFixD>");
    echo "<input type=\"hidden\" name=\"fixd\" value=\"$fixd\">";
    echo '<input type="hidden" name="today" value="' . createDate($dateToday, 'date', false, true) . '">';
    // start date
    setupInputHTML($block1, lang_strings('start_date'), 'sdI', enumFieldType::ftDate, 'N', '0', $sd, '', '', false, '', 'onchange="calcEstimatedTime()"');
    // due date
    setupInputHTML($block1, lang_strings('due_date'), 'ddI', enumFieldType::ftDate, 'N', '0', $dd, '', '', false, '', 'onchange="calcEstimatedTime()"');
    // complete date
    setupInputHTML($block1, lang_strings('complete_date'), 'cdI', enumFieldType::ftDate, 'N', '0', $cd);
    setupInputHTML($block1, lang_strings('estimated_time'), 'etm', enumFieldType::ftHours, 'N', '0', $etm, '', '', $etm_highlight);
    // service
    setupInputHTML($block1, lang_strings("service"), 'serv', enumFieldType::ftNumeric, 'N', '8', $serv, $servVV);
    echo "<input type=\"hidden\" name=\"tg\" value=\"$tg\">";
    echo "<input type=\"hidden\" name=\"lvl\" value=\"$lvl\">";
    echo "<input type=\"hidden\" name=\"pta\" value=\"$pta\">";
    echo "<input type=\"hidden\" name=\"sta\" value=\"$sta\">";
}

if ($miles != enumMilestone::msYes) {
    setupInputHTML($block1, lang_strings('type'), 'tt', enumFieldType::ftNumeric, 'N', '8', $tt, $ttVV, '', false, '', 'onchange="typeChanged()"');
}

setupInputHTML($block1, lang_strings('comments'), 'c', enumFieldType::ftMemo, 'N', '0', $c);

if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
    if ($id == '' || $taskDetail->tas_mem2_organization[0] == '1') {  // new task or team task
        if ($subtaskids != "" || (isset($taskDetail) && $taskDetail->tas_task_group[0] == enumTaskGroup::tgYes)) {
            echo "<input type=\"hidden\" name=\"pub\" value=\"$pub\">";
        } else {
            $block1->contentRow(lang_strings("published"), "<input size=\"32\" value=\"0\" name=\"pub\" type=\"checkbox\" $checkedPub $pubDisabled>");
        }
    } else {
        echo '<input type="hidden" name="pub" value="' . enumPublished::pbYes . '">';
    }
}

setupCustomFieldsInputHTML($block1, 'tasks', $id);

if ($id == '' || $taskDetail->tas_support_request[0] == '0' || $taskDetail->tas_status[0] == enumStatus::stCompleted) {
    $showsr = 'N';
} else {
    if ($supportRequestDetail->sr_auto_close[0] == 'Y') {
        $showsr = 'Y';
    } else {
        $showsr = 'N';
    }
}

echo '<input type="hidden" name="showsr" value="' . $showsr . '">';

if ($id != "") {
    $block1->contentTitle(lang_strings("updates_task"));
    setupInputHTML($block1, lang_strings('comments'), 'cUp', enumFieldType::ftMemo, 'N', '0', $cUp);

    if ($taskDetail->tas_support_request[0] != '0') {
        $block1->contentTitle(lang_strings('add_support_response'));
        setupInputHTML($block1, lang_strings("message"), 'mes', enumFieldType::ftMemo);
        setupCustomFieldsInputHTML($block1, 'support_posts', '', 'sp');
    }
}

$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();

if (($fileManagement == 'true') && ($id == '' || $cpy == 'true') && ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue)) {
    setupAttachFilesHTML(($sitePublish=='true'));
}

$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
