<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: edittask_serv.php,v 1.3 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

// check if the request is an AJAX request
if (!is_ajax()) {
    exit;
}

/**
 * Variables init
 */
$action = AddSlashesNOD(isset($_POST['action'])?$_POST['action']:'');   // action

if ($action == '') {
    exit;
}

switch ($action) {
    case 'calcEstimatedTime':
        /**
         * calculate estimated time
         */
        $fromI = AddSlashesNOD(isset($_POST['from'])?$_POST['from']:'');    // start date input value
        $toI = AddSlashesNOD(isset($_POST['to'])?$_POST['to']:'');          // due date input value
        $wca = AddSlashesNOD(isset($_POST['wca'])?$_POST['wca']:'');        // workcalendar internal id
        $x = '0';

        if ($fromI !== '' || $toI !== '' || $wca !== '') {
            /**
             * convert input date to timestamp
             */
            $from = date2Timestamp($fromI);
            $to = date2Timestamp($toI);

            /**
             * Calculate time interval in hours
             */
            $tmpquery = "SELECT SUM(wcd.hours) FROM " . $tablePrefix . "workcalendars_detail wcd WHERE wcd.workcalendar='$wca' AND wcd.date>='$from' AND wcd.date<='$to' AND wcd.hours>0";
            $request1 = new request();
            $request1->connectClass();
            $request1->query($tmpquery);

            if ($request1->fetch()) {
                $x = NumberFormatNOD($row[0], $hourAccuracy, false);
            }
        }

        header("content-type:application/json");
        echo json_encode(array(
            'etm' => $x
        ));
        break;
    case 'defaultService':
        /**
         * get service default values
         */
        $hrc = AddSlashesNOD(isset($_POST['hrc'])?$_POST['hrc']:'');    // hour code

        if ($hrc == '') {
            $hrc = '0';
        }

        $querymore = " WHERE hrc.id='$hrc'";
        $hourCodeDetail = new request();
        $hourCodeDetail->openHourCode($querymore);
        $comptHourCodeDetail = count($hourCodeDetail->hrc_id);
        $serv = '0';

        if ($comptHourCodeDetail > 0) {
            $serv = $hourCodeDetail->hrc_service[0];
        }

        header("content-type:application/json");
        echo json_encode(array(
            'service' => $serv
        ));
        break;
}