<?php // $Revision: 1.29 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: edittasktime.php,v 1.29 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$hr = isset($_POST['hr'])?$_POST['hr']:'';
$ldI = isset($_POST['ldI'])?$_POST['ldI']:'';
$ld = ($ldI=='')?$dateToday:date2Timestamp($ldI);
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$serv = isset($_POST['serv'])?$_POST['serv']:'';

/**
 * Permission check
 */
$querymore0 = " WHERE tim.id='$id'";
$taskTimeDetail = new request();
$taskTimeDetail->openTaskTime($querymore0);
$comptTaskTimeDetail = count($taskTimeDetail->tim_id);

if ($comptTaskTimeDetail == '0') {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$project = $taskTimeDetail->tim_project[0];
$task = $taskTimeDetail->tim_task[0];
$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?toggle_focus=tasks&id=' . $project . '&msg=permissiondenied' . $urlBornes);
    exit;
}

if ($taskTimeDetail->tim_owner[0] != $idSession) {
    header('Location: ../tasks/viewtask.php?id=' . $task . '&msg=permissiondenied' . $urlBornes);
    exit;
}

if (periodLocked($taskTimeDetail->tim_date[0])) {   // check if period locked
    header('Location: ../tasks/viewtask.php?id=' . $task . '&msg=periodLocked' . $urlBornes);
    exit;
}

/**
 * Fields check
 */
$error = '';

if ($action == 'edit') {
    if (!empty($hr)) {
        if (!is_numeric($hr)) {
            $error = lang_strings('worked_hours') . ' ' . lang_strings('error_numerical');
            $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
            $hr_highlight = true;
        } else if ($hr > 24 || $hr <= 0) {
            $error = lang_strings('worked_hours') . ' ' . lang_strings('error_hours');
            $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
            $hr_highlight = true;
        }
    } else {
        $error = lang_strings('worked_hours') . ' ' . lang_strings('error_required');
        $bodyCommand = 'onLoad="document.saTForm.hr.focus();"';
        $hr_highlight = true;
    }

    if ($error == '' && periodLocked($ld)) {
        $error = lang_strings('period') . ' ' . createDate($period_date_start,'date',false,true) . ' ~ ' . createDate($period_date_end,'date',false,true) . ' ' . lang_strings('locked');
        $bodyCommand = 'onLoad="document.saTForm.ldI.focus();"';
        $ld_highlight = true;
    }
}

/**
 * Actions
 */
if ($action == 'edit' && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $hr = round($hr, $hourAccuracy);
        $comm = HtmlEntitiesNOD($comm);
        $bf = ($serv=='0')?enumBoolean::bFalse:enumBoolean::bTrue;
        $tmpsql  = "UPDATE " . $tablePrefix . "tasks_time SET date='$ld',hours='$hr',comments='$comm',billing='$bf',service='$serv',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../tasks/addtasktime.php?id=$task&msg=update" . $urlBornes);
        exit;
    }
}

/**
 * Set value in form
 */
if ($action == '' && $error == '') {
    $ld = $taskTimeDetail->tim_date[0];
    $hr = $taskTimeDetail->tim_hours[0];
    $comm = $taskTimeDetail->tim_comments[0];
    $serv = $taskTimeDetail->tim_service[0];
}

/**
 * Prepare data
 */
$taskActualTime = new request();
$actualTime = $taskActualTime->getTaskTime($task);
$querymore2 = " WHERE tas.id='$task'";
$taskDetail = new request();
$taskDetail->openTasks($querymore2);
$querymore = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_task_time"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "saT";
$block1->openForm("../tasks/edittasktime.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"edit\">";
$block1->heading(lang_strings("edit_task_time") . " : " . $taskDetail->tas_name[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $projectDetail->pro_name[0]);
$block1->contentRow(lang_strings("tasks"), $taskDetail->tas_name[0]);
$block1->contentRow(lang_strings("description"), $taskDetail->tas_description[0]);
$block1->contentRow(lang_strings("estimated_time"), $taskDetail->tas_estimated_time[0] . " " . lang_strings("hours"));
$block1->contentRow(lang_strings("actual_time"), $actualTime . " " . lang_strings("hours"));
$block1->contentTitle(lang_strings("edit_task_time"));
setupInputHTML($block1, lang_strings("date"), 'ldI', enumFieldType::ftDate, 'Y', '0', $ld, '', '', $ld_highlight);
$servSel = "<select name=\"serv\">";

if ($taskDetail->tas_service[0] != '0') {
    $querymore = " WHERE serv.id='" . $taskDetail->tas_service[0] . "'";
    $serviceDetail = new request();
    $serviceDetail->openServices($querymore);

    if ($taskDetail->tas_service[0] == $serv) {
        $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
    } else {
        $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
    }
} else if ($memberDetail->tea_service[0] != '0') {
    $querymore = " WHERE serv.id='" . $memberDetail->tea_service[0] . "'";
    $serviceDetail = new request();
    $serviceDetail->openServices($querymore);

    if ($memberDetail->tea_service[0] == $serv) {
        $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
    } else {
        $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
    }
}

if ($serv == '0') {
    $servSel .= "<option value='0' selected>" . $strings["none"] . "</option>";
} else {
    $servSel .= "<option value='0'>" . $strings["none"] . "</option>";
}

$servSel .= "</select>";
$block1->contentRow(lang_strings("service"), $servSel);
// hours
$block1->contentRow("* " . lang_strings("worked_hours"), "<input size='20' value='$hr'" . (($hr_highlight)?' class="highlight"':'') . " name='hr' maxlength='6' type='text'>");
// comments
setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
$block1->contentRow('', "<input type='SUBMIT' value='" . $strings["update"] . "'><input type='button' name='cancel' value='" . $strings['cancel'] . "' onClick='history.back();'>");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
