<?php // $Revision: 1.23 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: indentation.php,v 1.23 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$phase = AddSlashesNOD(isset($_GET['phase'])?$_GET['phase']:'');
$action = isset($_POST['action'])?$_POST['action']:'';
$parent = isset($_POST['parent'])?$_POST['parent']:'';

/**
 * Functions
 */
function indentation_redirect($msg)
{
    global $phase, $project, $urlBornes;

    if ($phase != "") {
        $querymore = " WHERE pha.project='$project' AND pha.order_num='$phase'";
        $phaseDetail = new request();
        $phaseDetail->openPhases($querymore);
        $phaseId = $phaseDetail->pha_id[0];
        header("Location: ../phases/viewphase.php?id=$phaseId&msg=$msg" . $urlBornes);
    } else if ($project != "") {
        header("Location: ../projects/viewproject.php?id=$project&msg=$msg&toggle_focus=tasks" . $urlBornes);
    } else {
        header("Location: ../general/home.php?msg=$msg" . $urlBornes);
    }

    exit;
}

function change_subtasks_level($requestAct, $id)
{
    global $tablePrefix,$idSession;
    $querymore = " WHERE tas.parent_task='$id'";
    $subtasksList = clone $requestAct;
    $subtasksList->openTasks($querymore);
    $comptSubtasksList = count($subtasksList->tas_id);

    for ($i = 0;$i < $comptSubtasksList;$i++) {
        $newLevel = $subtasksList->tas_level[$i] + 1;
        $tmpsql = "UPDATE " . $tablePrefix . "tasks SET level='$newLevel', modified='" . time() . "', muser='$idSession' WHERE id='" . $subtasksList->tas_id[$i] . "'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'tasks', $subtasksList->tas_id[$i], 'U');

        if ($subtasksList->tas_task_group[$i] == enumTaskGroup::tgYes) {
            change_subtasks_level($requestAct, $subtasksList->tas_id[$i]);
        }
    }
}

function change_parent_task($requestAct, $parent)
{
    global $tablePrefix,$idSession;
    $querymore1 = " WHERE tas.parent_task='$parent'";
    $subtaskList = clone $requestAct;
    $subtaskList->openTasks($querymore1);
    $newSubtask = count($subtaskList->tas_id);
    $newPriority = -1;
    $newStatus = '';
    $newStartDate = PHP_INT_MAX;
    $newDueDate = 0;
    $newCompleteDate = 0;

    for ($i = 0;$i < $newSubtask;$i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }

            if ($status == enumStatus::stOpen || $newStatus == enumStatus::stOpen) {
                $newStatus = enumStatus::stOpen;
            } else if ($status == enumStatus::stSuspended || $newStatus == enumStatus::stSuspended) {
                $newStatus = enumStatus::stSuspended;
            } else if ($status == enumStatus::stNotStarted || $newStatus == enumStatus::stNotStarted) {
                $newStatus = enumStatus::stNotStarted;
            } else if ($status == enumStatus::stClientCompleted || $newStatus == enumStatus::stClientCompleted) {
                $newStatus = enumStatus::stClientCompleted;
            }

            $newCompletion += $completion;

            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }

            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }

            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = '0';
            }

            if ($published == enumPublished::pbYes) {
                $newPublished = enumPublished::pbYes;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = '0';
            }

            $newPublished = $published;
        }
    }

    $newCompletion = substr($newCompletion / $newSubtask, 0, 1);
    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', task_group='0', subtask='$newSubtask', modified='" . time() . "', muser='$idSession' WHERE id='$parent'";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }

    copy2HistoryTable($requestAct, 'tasks', $parent, 'U');
    $querymore2 = " WHERE tas.id='$parent'";
    $parentTaskDetail = clone $requestAct;
    $parentTaskDetail->openTasks($querymore2);
    $newParent = $parentTaskDetail->tas_parent_task[0];

    if ($newParent != '0') {
        change_parent_task($requestAct, $newParent);
    }
}

/**
 * Permission check
 */
$querymore3 = " WHERE tas.id='$id'";
$taskDetail = new request();
$taskDetail->openTasks($querymore3);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0' || $taskDetail->tas_project[0] != $project) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore4 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore4);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

$querymore5 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore5);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore6 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore6 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore6);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_edit_task_relationships[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

// check milestone
if ($taskDetail->tas_milestone[0] == enumMilestone::msYes) {
    indentation_redirect("noMilestone");
}

// check loop result
for ($i=0; $i<$comptSubtasksList; $i++) {
    if ($subtasksList->tas_id[$i] != $id) {
        continue;
    }

    $querymore7 = " WHERE (pre.task='$id' AND pre.predecessor='" . $subtasksList->tas_id[$i-1] . "') OR (pre.task='" . $subtasksList->tas_id[$i-1] . "' AND pre.predecessor='$id')";
    $dependencyDetail = new request();
    $dependencyDetail->openTaskPredecessor($querymore7);
    $comptDependencyDetail = count($dependencyDetail->pre_id);

    if ($comptDependencyDetail > 0) {
        indentation_redirect("loopError");
    }

    break;
}

// exclude related tasks
$querymore8 = " WHERE pre.task='$id' OR pre.predecessor='$id'";
$relatedTaskList = new request();
$relatedTaskList->openTaskPredecessor($querymore8);
$comptRelatedTaskList = count($relatedTaskList->pre_id);
$relatedTasks = $id;

for ($i=0; $i<$comptRelatedTaskList; $i++) {
    $relatedTasks .= ',';

    if ($relatedTaskList->pre_task[$i] == $id) {
        $relatedTasks .= $relatedTaskList->pre_predecessor[$i];
    } else {
        $relatedTasks .= $relatedTaskList->pre_task[$i];
    }
}

// check parent tasks available
$querymore9 = " WHERE tas.id NOT IN ($relatedTasks) AND tas.project='$project' AND tas.parent_phase='" . $taskDetail->tas_parent_phase[0] . "' AND tas.milestone='" . enumMilestone::msNo . "' AND tas.level='" . $taskDetail->tas_level[0] . "' AND tas.parent_task='" . $taskDetail->tas_parent_task[0] . "'";
$listTasks = new request();
$listTasks->openTasks($querymore9);
$comptListTasks = count($listTasks->tas_id);

if ($comptListTasks == 0) {
    if ($taskDetail->tas_parent_task[0] == "0") {
        indentation_redirect("leadingTask");
    } else {
        indentation_redirect("leadingSubTask");
    }
}

/**
 * Actions
 */
if ($action == 'indent') {
    $criticalSection = enter_critical_section();

    if ($criticalSection == -1) {
        indentation_redirect($msg);
    }

    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        // change tasks level
        $newLevel = $taskDetail->tas_level[0] + 1;
        $tmpsql = "UPDATE " . $tablePrefix . "tasks SET parent_task='$parent',level='$newLevel', modified='" . time() . "', muser='$idSession' WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        if ($taskDetail->tas_task_group[0] == enumTaskGroup::tgYes) {
            change_subtasks_level($requestAct, $id);
        }

        change_parent_task($requestAct, $parent);
        copy2HistoryTable($requestAct, 'tasks', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
    leave_critical_section($criticalSection);

    if ($error == '') {
        indentation_redirect("indentation");
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));

if ($projectDetail->pro_phase_set[0] != "0") {
    $querymore = " WHERE pha.project='$project' AND pha.order_num='" . $taskDetail->tas_parent_phase[0] . "'";
    $targetPhase = new request();
    $targetPhase->openPhases($querymore);
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("phases"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $targetPhase->pha_id[0] . $urlBornes, $targetPhase->pha_description[0], 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=" . $taskDetail->tas_id[0] . $urlBornes, $taskDetail->tas_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("task_indentation"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "idT";
$block1->openForm("../tasks/indentation.php?id=$id&project=$project" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"indent\">";
$block1->heading(lang_strings("task_indentation") . " : " . $taskDetail->tas_name[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$tasSel = "<select name=\"parent\">\n";

for ($i=0; $i<$comptListTasks; $i++) {
    $tasSel .= "\t<option value=\"" . $listTasks->tas_id[$i] . "\">" . $listTasks->tas_name[$i];

    if ($listTasks->tas_subtask[$i] > 0) {
        $tasSel .= " (" . $listTasks->tas_subtask[$i] . " " . lang_strings('subtasks') . ")";
    }

    $tasSel .= "</option>\n";
}

$tasSel .= "</select>";
$block1->contentRow(lang_strings('parent_task'), $tasSel);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
