<?php // $Revision: 1.34 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listtasks.php,v 1.34 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$taskgroupList = array();
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$phase = AddSlashesNOD(isset($_GET['phase'])?$_GET['phase']:'');
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$base = isset($_GET['base'])?$_GET['base']:'1';
$gantt_sd = isset($_GET['gantt_sd'])?$_GET['gantt_sd']:'';
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSite = isset($_GET['addToSiteTask'])?$_GET['addToSiteTask']:'';
$removeToSite = isset($_GET['removeToSiteTask'])?$_GET['removeToSiteTask']:'';
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$error = '';
$showNext = '';

/**
 * Functions
 */
function add_taskgroup_to_changelist($requestAct, $parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList)) {
        return;
    }

    $taskgroupList[$parent] = $level;
    $querymore = " WHERE tas.id='$parent'";
    $parentDetail = clone $requestAct;
    $parentDetail->openTasks($querymore);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($requestAct, $parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

function change_parent_task($requestAct, $parent)
{
    global $tablePrefix,$idSession;
    $querymore = " WHERE tas.parent_task='$parent'";
    $subtaskList = clone $requestAct;
    $subtaskList->openTasks($querymore);
    $newSubtask = count($subtaskList->tas_id);
    $newPriority = -1;
    $newStatus = '';
    $newStartDate = PHP_INT_MAX;
    $newDueDate = 0;
    $newCompleteDate = 0;

    for ($i = 0;$i < $newSubtask;$i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }

            if ($status == enumStatus::stNotStarted || $newStatus == enumStatus::stNotStarted) {
                $newStatus = enumStatus::stNotStarted;
            } else if ($status == enumStatus::stOpen || $newStatus == enumStatus::stOpen) {
                $newStatus = enumStatus::stOpen;
            } else if ($status == enumStatus::stSuspended || $newStatus == enumStatus::stSuspended) {
                $newStatus = enumStatus::stSuspended;
            } else if ($status == enumStatus::stClientCompleted || $newStatus == enumStatus::stClientCompleted) {
                $newStatus = enumStatus::stClientCompleted;
            }

            $newCompletion += $completion;

            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }

            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }

            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = '0';
            }

            if ($published == enumPublished::pbYes) {
                $newPublished = enumPublished::pbYes;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = '0';
            }

            $newPublished = $published;
        }
    }

    $newCompletion = substr($newCompletion / $newSubtask, 0, 1);
    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', task_group='" . enumTaskGroup::tgYes . "', subtask='$newSubtask', modified='" . time() . "', muser='$idSession' WHERE id='$parent'";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }

    copy2HistoryTable($requestAct, 'tasks', $parent, 'U');
}

/**
 * Permission check
 */
$querymore = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == '0') {
    $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($action == 'publish') {
    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
        exit;
    }

    if ($addToSite == 'true' || $removeToSite == 'true') {
        if ($permissionDetail->prp_publish_task[0] != enumBoolean::bTrue) {
            header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
            exit;
        }
    }
} else {
    if ($permissionDetail->prp_view_task[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Admin'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'publish' && ($addToSite == "true" || $removeToSite == "true")) {
    $criticalSection = enter_critical_section();

    if ($criticalSection == -1) {
        header("Location: ../tasks/listtasks.php?project=$project&msg=$msg" . $urlBornes);
        exit;
    }

    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $ids = "'" . str_replace("**", "','", $id) . "'";

        if ($addToSite == "true") {
            $tmpsql = "UPDATE " . $tablePrefix . "tasks SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";
            $msg = "addToSite";
        } else {
            $tmpsql = "UPDATE " . $tablePrefix . "tasks SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids)";
            $msg = "removeToSite";
        }

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'tasks', $ids, 'U');
        $querymore = " WHERE tas.id IN ($ids)";
        $listTasks = clone $requestAct;
        $listTasks->openTasks($querymore);
        $comptListTasks = count($listTasks->tas_id);

        for ($i=0; $i<$comptListTasks; $i++) {
            add_taskgroup_to_changelist($requestAct, $listTasks->tas_parent_task[$i], $listTasks->tas_level[$i]);
        }

        if (count($taskgroupList) > 0) {
            arsort($taskgroupList, SORT_NUMERIC);
            reset($taskgroupList);

            while (list($parentTask, $level) = each($taskgroupList)) {
                change_parent_task($requestAct, $parentTask);
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();
    leave_critical_section($criticalSection);
}

/**
 * Prepare data
 */
if ($phase != '') {
    $querymore = " WHERE pha.id='$phase'";
    $phaseDetail = new request();
    $phaseDetail->openPhases2($querymore);
    $comptPhaseDetail = count($phaseDetail->pha_id);

    if ($comptPhaseDetail == '0') {
        $phase = '';
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));

if ($phase != '') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("phases"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?id=$phase" . $urlBornes, $phaseDetail->pha_description[0], 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("tasks"));
$blockPage->closeBreadcrumbs();
$title = $strings['tasks'] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
logURL($title, "../tasks/listtasks.php?project=$project&phase=$phase");
$block1 = new block();
$block1->form = "saT";
$block1->openForm("../tasks/listtasks.php?project=$project&phase=$phase" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("tasks"));
$block1->openPaletteIcon();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if (($projectDetail->pro_phase_set[0] == '0') && ($permissionDetail->prp_create_task[0] == enumBoolean::bTrue)) {
        $block1->paletteIcon(0, "add", $strings["add"]);
    }

    if ($permissionDetail->prp_delete_task[0] == enumBoolean::bTrue) {
        $block1->paletteIcon(1, "remove", $strings["delete"]);
    }

    if ($permissionDetail->prp_copy_task[0] == enumBoolean::bTrue) {
        $block1->paletteIcon(2, "copy", $strings["copy"]);
    }

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
        if ($permissionDetail->prp_publish_task[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(4, "add_projectsite", $strings["add_customer_service_site"]);
            $block1->paletteIcon(5, "remove_projectsite", $strings["remove_customer_service_site"]);
        }
    }
}

$block1->paletteIcon(6, "info", $strings["view"]);

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_modify_task_status[0] == enumBoolean::bTrue || $permissionDetail->prp_modify_task_properties[0]) {
        $block1->paletteIcon(7, "edit", $strings["edit"]);
    }

    if ($permissionDetail->prp_log_task_hours[0] == enumBoolean::bTrue) {
        $block1->paletteIcon(8, "timelog", $strings["loghours"]);
    }

    if ($permissionDetail->prp_material_issue[0] == enumBoolean::bTrue) {
        $block1->paletteIcon(14, "material", $strings["material_issue"]);
    }

    if ($permissionDetail->prp_edit_task_relationships[0] == enumBoolean::bTrue) {
        $block1->paletteIcon(9, "dependency", $strings["add_predecessor"]);
        $block1->paletteIcon(10, "unlink", $strings["delete_dependencies"]);
        $block1->paletteIcon(11, "indentation", $strings["indentation"]);
        $block1->paletteIcon(12, "unindentation", $strings["unindentation"]);
        $block1->paletteIcon(13, "add_taskgroup", $strings["add_taskgroup"]);
    }
}

$block1->paletteIcon(99, 'search', 'tasks');
$block1->closePaletteIcon();

if ($projectDetail->pro_published[0] == enumPublished::pbYes) {
    $block1->sorting("tasks", (isset($sortingUser['tasks'])?$sortingUser['tasks']:''), "tas.name ASC", $sortingFields = array(0 => "tas.id", 1 => "tas.name", 2 => "tas.priority", 3 => "tas.status", 4 => "tas.completion", 5 => "tas.due_date", 6 => "tas.assigned_to", 7 => "tas.published"));
} else {
    $block1->sorting("tasks", (isset($sortingUser['tasks'])?$sortingUser['tasks']:''), "tas.name ASC", $sortingFields = array(0 => "tas.id", 1 => "tas.name", 2 => "tas.priority", 3 => "tas.status", 4 => "tas.completion", 5 => "tas.due_date", 6 => "tas.assigned_to"));
}

$tmpqueryC = " WHERE tas.project='$project'";

if ($phase != '') {
    $tmpqueryC .= " AND tas.parent_phase='" . $phaseDetail->pha_order_num[0] . "'";
}

$tmpqueryS = " ORDER BY " . $block1->sortingValue;
$listTasks = new request();
$listTasks->openHierarchyOfTasks($tmpqueryC, $tmpqueryS);
$comptListTasks = count($listTasks->tas_id);

if ($comptListTasks > 0) {
    if ($projectDetail->pro_published[0] == enumPublished::pbYes) {
        $labels = array(lang_strings('id'), lang_strings('task'), lang_strings('priority'), lang_strings('status'), lang_strings('completion'), lang_strings('due_date'), lang_strings('assigned_to'), lang_strings('published'));
        $published = 'true';
    } else {
        $labels = array(lang_strings('id'), lang_strings('task'), lang_strings('priority'), lang_strings('status'), lang_strings('completion'), lang_strings('due_date'), lang_strings('assigned_to'));
        $published = 'false';
    }

    $block1->openResults();
    $block1->labels($labels, $published);
    $today = mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y')));

    for ($i = 0;$i < $comptListTasks;$i++) {
        if ($listTasks->tas_due_date[$i] == '0') {
            $listTasks->tas_due_date_str[$i] = lang_strings('none');
        } else {
            $listTasks->tas_due_date_str[$i] = createDate($listTasks->tas_due_date[$i],'date',false,true);
        }

        $idStatus = $listTasks->tas_status[$i];
        $idPriority = $listTasks->tas_priority[$i];
        $idPublish = $listTasks->tas_published[$i];
        $complValue = ($listTasks->tas_completion[$i] > 0) ? $listTasks->tas_completion[$i] . "0 %": $listTasks->tas_completion[$i] . " %";
        $block1->openRow($listTasks->tas_id[$i]);
        $block1->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i] . $urlBornes, $listTasks->tas_id[$i], 'in'));
        $leadingSpace = '';

        for ($j = 0;$j < $listTasks->tas_level[$i];$j++) {
            $leadingSpace .= '&nbsp;&nbsp;';
        }

        if ($idStatus == enumStatus::stCompleted) {
            $block1->cellRow($leadingSpace . $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i] . $urlBornes, $listTasks->tas_name[$i], 'instrike'));
        } else {
            $block1->cellRow($leadingSpace. $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i] . $urlBornes, $listTasks->tas_name[$i], 'in'));
        }

        if ($listTasks->tas_milestone[$i] == enumMilestone::msYes) {
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow("");
        } else {
            $block1->cellRow($priority[$idPriority]);
            $block1->cellRow($status[$idStatus]);
            $block1->cellRow($complValue);
        }

        if ($listTasks->tas_milestone[$i] == enumMilestone::msYes) {
            $block1->cellRow($listTasks->tas_due_date_str[$i]);
        } else if ($listTasks->tas_due_date[$i] <= $today && $listTasks->tas_completion[$i] != '10') {
            $block1->cellRow('<div class="overdue">' . $listTasks->tas_due_date_str[$i] . '</div>');
        } else {
            $block1->cellRow($listTasks->tas_due_date_str[$i]);
        }

        if ($listTasks->tas_start_date[$i] != "0" && $listTasks->tas_due_date[$i] != "0") {
            $gantt = "true";
        }

        if ($listTasks->tas_milestone[$i] == enumMilestone::msYes) {
            $block1->cellRow("");
        } else if ($listTasks->tas_assigned_to[$i] == "0") {
            $block1->cellRow(lang_strings("unassigned"));
        } else {
            $tmpquery = " AND res.task=" . $listTasks->tas_id[$i];
            $resourceUsage = new request();
            $resourceUsage->openTaskHumanResource($tmpquery);
            $comptResourceUsage = count($resourceUsage->res_id);
            $assigned_to = array();

            for ($j = 0;$j < $comptResourceUsage;$j++) {
                $assigned_to[] = $blockPage->buildLink($resourceUsage->res_resource[$j], '', 'message');
            }

            $block1->cellRow(implode("&nbsp;&nbsp;", $assigned_to));
        }

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
            $block1->cellRow($statusPublish[$idPublish]);
        }

        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeToggle();

if ($comptListTasks > 0) {
    if ($activeJpgraph == "true" && $gantt == "true") {
        $block1->headingToggle($strings['charts'], !($toggle_focus==''));

        if ($gantt_sd != '') {
            echo "<a href='listtasks.php?project=$project&amp;phase=$phase&amp;base=$base'>&lt;&lt;</a>&nbsp;";

            if ($base == '1') {
                $gantt_sd_prev = mktime(0,0,0,intval(date('m',$gantt_sd))-5,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
            } else {
                $gantt_sd_prev = mktime(0,0,0,intval(date('m',$gantt_sd))-1,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
            }
        }

        $tmpquery = "SELECT MIN(start_date),MAX(due_date) FROM " . $tablePrefix . "tasks WHERE project=$project AND start_date<>'0' AND due_date<>'0'";

        if ($gantt_sd != '') {
            if ($base == '1') {
                $gantt_sd_next = mktime(0,0,0,intval(date('m',$gantt_sd))+5,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
            } else {
                $gantt_sd_next = mktime(0,0,0,intval(date('m',$gantt_sd))+1,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
            }

            $tmpquery .= " AND due_date>='$gantt_sd_next'";
        }

        if ($phase != '') {
            $tmpquery .= " AND parent_phase='" . $phaseDetail->pha_order_num[0] . "'";
        }

        $boundaries = new request();
        $boundaries->connectClass();
        $boundaries->query($tmpquery);

        if ($boundaries->fetch()) {
            $start_date_b = ($row[0]);
            $due_date_b = ($row[1]);

            if ($gantt_sd == '') {
                if ($base == '1') {
                    $gantt_sd_next = mktime(0,0,0,intval(date('m',$start_date_b))+5,intval(date('d',$start_date_b)),intval(date('Y',$start_date_b)));
                } else {
                    $gantt_sd_next = mktime(0,0,0,intval(date('m',$start_date_b))+1,intval(date('d',$start_date_b)),intval(date('Y',$start_date_b)));
                }

                $gantt_sd = $start_date_b;
            } else {
                if ($gantt_sd_prev < $start_date_b) {
                    echo "<a href='listtasks.php?project=$project&amp;phase=$phase&amp;base=$base'>&lt;</a>&nbsp;";
                } else {
                    echo "<a href='listtasks.php?project=$project&amp;phase=$phase&amp;base=$base&amp;gantt_sd=$gantt_sd_prev'>&lt;</a>&nbsp;";
                }
            }

            if ($gantt_sd_next <= $due_date_b) {
                $showNext = 'true';

                if ($base == '1') {
                    $gantt_sd_last = mktime(0,0,0,intval(date('m',$due_date_b))-5,intval(date('d',$due_date_b))+1,intval(date('Y',$due_date_b)));
                } else {
                    $gantt_sd_last = mktime(0,0,0,intval(date('m',$due_date_b))-1,intval(date('d',$due_date_b))+1,intval(date('Y',$due_date_b)));
                }
            }
        }

        // show the expanded or compact Gantt Chart
        if ($base == '1') {
            echo "<a href='listtasks.php?project=$project&amp;phase=$phase&amp;base=0'>expand</a>";
        } else {
            echo "<a href='listtasks.php?project=$project&amp;phase=$phase&amp;base=1'>compact</a>";
        }

        if ($showNext == 'true') {
            echo "&nbsp;<a href='listtasks.php?project=$project&amp;phase=$phase&amp;base=$base&amp;gantt_sd=$gantt_sd_next'>&gt;</a>";
            echo "&nbsp;<a href='listtasks.php?project=$project&amp;phase=$phase&amp;base=$base&amp;gantt_sd=$gantt_sd_last'>&gt;&gt;</a>";
        }

        if ($gantt_sd != '') {
            if ($phase == '') {
                echo "<br><img src=\"graphtasks.php?project=" . $projectDetail->pro_id[0] . "&amp;base=$base&amp;gantt_sd=$gantt_sd\" alt=\"\"><br><span class=\"listEvenBold\">" . $blockPage->buildLink("http://www.aditus.nu/jpgraph/", "JpGraph", 'powered') . "</span>";
            } else {
                echo "<br><img src=\"../phases/graphtasks.php?project=" . $projectDetail->pro_id[0] . "&amp;phase=" . $phaseDetail->pha_order_num[0] . "&amp;base=$base&amp;gantt_sd=$gantt_sd\" alt=\"\"><br><span class=\"listEvenBold\">" . $blockPage->buildLink("http://www.aditus.nu/jpgraph/", "JpGraph", 'powered') . "</span>";
            }
        }

        $block1->closeToggle();
    }
}

$block1->closeFormResults();
$block1->openPaletteScript();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if (($projectDetail->pro_phase_set[0] == '0') && ($permissionDetail->prp_create_task[0] == enumBoolean::bTrue)) {
        $block1->paletteScript(0, "add", "../tasks/edittask.php?project=$project" . $urlBornes, "true,false,false", $strings["add"]);
    }

    if ($permissionDetail->prp_delete_task[0] == enumBoolean::bTrue) {
        $block1->paletteScript(1, "remove", "../tasks/deletetasks.php?project=$project" . $urlBornes, "false,true,true", $strings["delete"]);
    }

    if ($permissionDetail->prp_copy_task[0] == enumBoolean::bTrue) {
        $block1->paletteScript(2, "copy", "../tasks/edittask.php?project=$project&cpy=true" . $urlBornes, "false,true,false", $strings["copy"]);
    }

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
        if ($permissionDetail->prp_publish_task[0] == enumBoolean::bTrue) {
            $block1->paletteScript(4, "add_projectsite", "../tasks/listtasks.php?addToSiteTask=true&project=" . $projectDetail->pro_id[0] . "&phase=$phase&action=publish" . $urlBornes, "false,true,true", $strings["add_customer_service_site"]);
            $block1->paletteScript(5, "remove_projectsite", "../tasks/listtasks.php?removeToSiteTask=true&project=" . $projectDetail->pro_id[0] . "&phase=$phase&action=publish" . $urlBornes, "false,true,true", $strings["remove_customer_service_site"]);
        }
    }
}

$block1->paletteScript(6, "info", "../tasks/viewtask.php?" . $urlBornes, "false,true,false", $strings["view"]);

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_modify_task_status[0] == enumBoolean::bTrue || $permissionDetail->prp_modify_task_properties[0]) {
        $block1->paletteScript(7, "edit", "../tasks/edittask.php?project=$project" . $urlBornes, "false,true,true", $strings["edit"]);
    }

    if ($permissionDetail->prp_log_task_hours[0] == enumBoolean::bTrue) {
        $block1->paletteScript(8, "timelog", "../tasks/addtasktime.php?" . $urlBornes, "false,true,false", $strings["loghours"]);
    }

    if ($permissionDetail->prp_material_issue[0] == enumBoolean::bTrue) {
        $block1->paletteScript(14, "material", "../tasks/addmaterialissue.php?" . $urlBornes, "false,true,false", $strings["material_issue"]);
    }

    if ($permissionDetail->prp_edit_task_relationships[0] == enumBoolean::bTrue) {
        $block1->paletteScript(9, "dependency", "../tasks/addpredecessor.php?project=$project" . $urlBornes, "false,true,false", $strings["add_predecessor"]);
        $block1->paletteScript(10, "unlink", "../tasks/deletedependencies.php?project=$project" . $urlBornes, "false,true,false", $strings["delete_dependencies"]);
        $block1->paletteScript(11, "indentation", "../tasks/indentation.php?project=$project" . $urlBornes, "false,true,false", $strings["indentation"]);
        $block1->paletteScript(12, "unindentation", "../tasks/unindentation.php?project=$project" . $urlBornes, "false,true,false", $strings["unindentation"]);
        $block1->paletteScript(13, "add_taskgroup", "../tasks/edittask.php?action=taskgroup&project=$project" . $urlBornes, "false,false,true", $strings["add_taskgroup"]);
    }
}

$block1->paletteScript(99, 'search', 'tasks');
$block1->closePaletteScript($comptListTasks, $listTasks->tas_id);
require_once("../includes/footer.php");
