<?php // $Revision: 1.21 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: noti_statustaskchange.php,v 1.21 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

if (!defined('INNER_NOTI_STATUSTASKCHG')) {
    exit;
}

$querymore1 = " WHERE tas.id='$id'";
$taskNoti = new request();
$taskNoti->openTasks($querymore1);
$comptTaskNoti = count($taskNoti->tas_id);

if ($comptTaskNoti == 0) {
    return;
}

$querymore2 = " WHERE pro.id='" . $taskNoti->tas_project[0] . "'";
$projectNoti = new request();
$projectNoti->openProjects($querymore2);
$querymore3 = " AND res.task='$id'";
$resourceNoti = new request();
$resourceNoti->openTaskHumanResource($querymore3);
$comptResourceNoti = count($resourceNoti->res_id);

if ($comptResourceNoti == 0) {
    $ida = $taskNoti->tas_owner;
} else {
    $ida = array_merge($taskNoti->tas_owner, $resourceNoti->res_resource);
}

$notiid = 'statustaskchanged';
$querymore = " WHERE mem.id IN (" . implode(',', $ida) . ") AND NOT EXISTS (SELECT noti.member FROM " . $tablePrefix . "notifications noti WHERE noti.member=mem.id AND notiid='$notiid' AND block='" . enumBoolean::bTrue . "') ORDER BY mem.language";
$listNotifications = new request();
$listNotifications->openMembers($querymore);
$comptListNotifications = count($listNotifications->mem_id);

if ($comptListNotifications == 0) {
    return;
}

$mailPriority = ($taskNoti->tas_priority[0] == enumPriority::prNone)?3:(6 - intval($taskNoti->tas_priority[0]));
$complValue = ($taskNoti->tas_completion[0] > 0) ? $taskNoti->tas_completion[0] . "0 %": $taskNoti->tas_completion[0] . " %";
$idStatus = $taskNoti->tas_status[0];
$idPriority = $taskNoti->tas_priority[0];
// backup timezone session
$timezoneBackup = $timezoneSession;

for ($i4cb=0; $i4cb<$comptListNotifications; $i4cb++) {
    // change timezone
    if ($listNotifications->mem_timezone[$i4cb] == '') {
        $timezoneSession = $defaultTimezone;
    } else {
        $timezoneSession = $listNotifications->mem_timezone[$i4cb];
    }
    // change language
    if (selectLanguage($listNotifications->mem_language[$i4cb])) {
        // currency matrix
        require('../includes/currency.inc.php');
        // load array definitions
        require('../includes/arrays.lib.php');
    }

    $mail = new notification();
    $mail->getUserinfo($idSession, "from");
    $mail->getUserinfo($listNotifications->mem_id[$i4cb], "to");
    $mail->partSubject = $strings["noti_statustaskchange1"];
    $mail->partMessage = $strings["noti_statustaskchange2"];
    $subject = $mail->partSubject . " " . $taskNoti->tas_name[0];
    $mail->Priority = $mailPriority;
    $mail->openBody();
    $mail->openContent();
    $mail->contentRow($strings["task"], $taskNoti->tas_name[0]);
    $mail->contentRow($strings["start_date"], createDate($taskNoti->tas_start_date[0],'date',false,true));
    $mail->contentRow($strings["due_date"], createDate($taskNoti->tas_due_date[0],'date',false,true));
    $mail->contentRow($strings["completion"], $complValue);
    $mail->contentRow($strings["priority"], $priority[$idPriority]);
    $mail->contentRow($strings["status"], $status[$idStatus]);
    $mail->contentRow($strings["description"], html_entity_decode($taskNoti->tas_description[0], ENT_QUOTES, $htmlEntityCharset));
    $mail->contentRow($strings["project"], $projectNoti->pro_name[0] . " (" . $projectNoti->pro_id[0] . ")");

    if ($projectNoti->pro_org_id[0] != "1") {
        $mail->contentRow($strings["organization"], $projectNoti->pro_org_name[0]);
    }

    $mail->closeContent();

    if ($listNotifications->mem_organization[$i4cb] != '1') {
        $mail->note("$root/general/login.php?url=service_site/home.php%3Fproject=" . $projectNoti->pro_id[0]);
    } else {
        $mail->note("$root/general/login.php?url=tasks/viewtask.php%3Fid=" . $taskNoti->tas_id[0]);
    }

    $mail->closeBody($notiid);
    $mail->Subject = $subject;
    $mail->SendItOut();
}

// restore timezone session
$timezoneSession = $timezoneBackup;
// restore language
if (selectLanguage($languageSession)) {
    // currency matrix
    require('../includes/currency.inc.php');
    // load array definitions
    require('../includes/arrays.lib.php');
}
