<?php // $Revision: 1.13 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: unindentation.php,v 1.13 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$phase = AddSlashesNOD(isset($_GET['phase'])?$_GET['phase']:'');
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Functions
 */
function unindentation_redirect($msg, $error)
{
    global $phase, $project, $urlBornes;

    if ($phase != "") {
        $querymore = " WHERE pha.project='$project' AND pha.order_num='$phase'";
        $phaseDetail = new request();
        $phaseDetail->openPhases($querymore);
        $phaseId = $phaseDetail->pha_id[0];
        header("Location: ../phases/viewphase.php?id=$phaseId&msg=$msg&error=$error" . $urlBornes);
    } else if ($project != "") {
        header("Location: ../projects/viewproject.php?id=$project&msg=$msg&error=$error&toggle_focus=tasks" . $urlBornes);
    } else {
        header("Location: ../general/home.php?msg=$msg&error=$error" . $urlBornes);
    }

    exit;
}

function change_subtasks_level($requestAct, $id)
{
    global $tablePrefix,$idSession;
    $querymore = " WHERE tas.parent_task='$id'";
    $subtasksList = clone $requestAct;
    $subtasksList->openTasks($querymore);
    $comptSubtasksList = count($subtasksList->tas_id);

    for ($i = 0;$i < $comptSubtasksList;$i++) {
        $newLevel = $subtasksList->tas_level[$i] - 1;
        $tmpsql = "UPDATE " . $tablePrefix . "tasks SET level='$newLevel', modified='" . time() . "', muser='$idSession' WHERE id='" . $subtasksList->tas_id[$i] . "'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'tasks', $subtasksList->tas_id[$i], 'U');

        if ($subtasksList->tas_task_group[$i] == enumTaskGroup::tgYes) {
            change_subtasks_level($requestAct, $subtasksList->tas_id[$i]);
        }
    }
}

function change_parent_task($requestAct, $parent)
{
    global $tablePrefix, $idSession, $projectDetail;
    $querymore1 = " WHERE tas.id='$parent'";
    $parentDetail = clone $requestAct;
    $parentDetail->openTasks($querymore1);
    $querymore2 = " WHERE tas.parent_task='$parent'";
    $taskList = clone $requestAct;
    $taskList->openTasks($querymore2);
    $comptTaskList = count($taskList->tas_id);

    if ($comptTaskList == "0") {
        $newPriority =  $projectDetail->pro_priority[0];
        $newStatus = $projectDetail->pro_status[0];

        if ($newStatus == enumStatus::stCompleted) {
            $newCompletion = 10;
        } else {
            $newCompletion = 0;
        }

        $newStartDate = $parentDetail->tas_start_date[0];
        $newDueDate = $parentDetail->tas_start_date[0];
        $newEstimatedTime = "8";
        $newActualTime = "0";
        $newCompleteDate = "0";
        $newTaskGroup = enumTaskGroup::tgNo;
    } else {
        $newPriority = $taskList->tas_priority[0];
        $newStatus = $taskList->tas_status[0];
        $newCompletion0 = $taskList->tas_completion[0];
        $newStartDate = $taskList->tas_start_date[0];
        $newDueDate = $taskList->tas_due_date[0];
        $newEstimatedTime = $taskList->tas_estimated_time[0];
        $newActualTime = $taskList->tas_actual_time[0];
        $newCompleteDate = $taskList->tas_complete_date[0];
        $newTaskGroup = enumTaskGroup::tgYes;

        for ($i = 1;$i < $comptTaskList;$i++) {
            if ($newPriority < $taskList->tas_priority[$i]) {
                $newPriority = $taskList->tas_priority[$i];
            }

            if ($taskList->tas_status[$i] == enumStatus::stOpen || $newStatus == enumStatus::stOpen) {
                $newStatus = enumStatus::stOpen;
            } else if ($taskList->tas_status[$i] == enumStatus::stSuspended || $newStatus == enumStatus::stSuspended) {
                $newStatus = enumStatus::stSuspended;
            } else if ($taskList->tas_status[$i] == enumStatus::stNotStarted || $newStatus == enumStatus::stNotStarted) {
                $newStatus = enumStatus::stNotStarted;
            } else if ($taskList->tas_status[$i] == enumStatus::stClientCompleted || $newStatus == enumStatus::stClientCompleted) {
                $newStatus = enumStatus::stClientCompleted;
            }

            $newCompletion0 += $taskList->tas_completion[$i];

            if ($newStartDate > $taskList->tas_start_date[$i]) {
                $newStartDate = $taskList->tas_start_date[$i];
            }

            if ($newDueDate < $taskList->tas_due_date[$i]) {
                $newDueDate = $taskList->tas_due_date[$i];
            }

            $newEstimatedTime += $taskList->tas_estimated_time[$i];
            $newActualTime += $taskList->tas_actual_time[$i];

            if ($newStatus == enumStatus::stCompleted) {
                if ($newCompleteDate == '0' || $newCompleteDate < $taskList->tas_complete_date[$i]) {
                    $newCompleteDate = $taskList->tas_complete_date[$i];
                }
            } else {
                $newCompleteDate = '0';
            }
        }

        $newCompletion = substr($newCompletion0 / $comptTaskList, 0, 1);
    }

    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', complete_date='$newCompleteDate', task_group='$newTaskGroup', subtask='$comptTaskList', modified='" . time() . "', muser='$idSession' WHERE id='$parent'";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }

    copy2HistoryTable($requestAct, 'tasks', $parent, 'U');

    if ($parentDetail->tas_parent_task[0] != '0') {
        change_parent_task($requestAct, $parentDetail->tas_parent_task[0]);
    }
}

/**
 * Permission check
 */
$querymore3 = " WHERE tas.id='$id'";
$taskDetail = new request();
$taskDetail->openTasks($querymore3);
$comptTaskDetail = count($taskDetail->tas_id);

if ($comptTaskDetail == '0' || $taskDetail->tas_project[0] != $project) {
    header('Location: ../general/permissiondenied.php');
    exit;
}

$querymore4 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore4);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

$querymore5 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore5);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore6 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore6 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore6);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_edit_task_relationships[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
    exit;
}

// check milestone
if ($taskDetail->tas_milestone[0] == enumMilestone::msYes) {
    indentation_redirect("noMilestone");
}

// check parent task
if ($taskDetail->tas_parent_task[0] == '0') {
    unindentation_redirect("noParentTask", '');
} else {
    $querymore7 = " WHERE tas.id='" . $taskDetail->tas_parent_task[0] . "'";
    $parentDetail = new request();
    $parentDetail->openTasks($querymore7);
    $newParentTask = $parentDetail->tas_parent_task[0];
    $oldParentTask = $taskDetail->tas_parent_task[0];
}

/**
 * Action
 */
$criticalSection = enter_critical_section();

if ($criticalSection == -1) {
    unindentation_redirect($msg, '');
}

$requestAct = new request();
$requestAct->connectClass();     // connect to database server

try {
    $requestAct->startTransaction();
    // change tasks level & parent task
    $newLevel = $taskDetail->tas_level[0] - 1;
    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET parent_task='$newParentTask', level='$newLevel', modified='" . time() . "', muser='$idSession' WHERE id='$id'";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }

    if ($taskDetail->tas_task_group[0] == enumTaskGroup::tgYes) {
        change_subtasks_level($requestAct, $id);
    }

    change_parent_task($requestAct, $oldParentTask);
    copy2HistoryTable($requestAct, 'tasks', $id, 'U');
    $requestAct->endTransaction(enumTransactionEndType::etCommit);
} catch (Exception $e) {
    $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
    error_log($e->getMessage());
    $requestAct->endTransaction(enumTransactionEndType::etRollBack);
}

$requestAct->close();
leave_critical_section($criticalSection);

if ($error == '') {
    unindentation_redirect("unindentation", '');
} else {
    unindentation_redirect("", $error);
}
