<?php // $Revision: 1.22 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: updatetasks.php,v 1.22 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$taskgroupList = array();
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$action = isset($_POST['action'])?$_POST['action']:'';
$st = isset($_POST['st'])?$_POST['st']:'';
$compl = isset($_POST['compl'])?$_POST['compl']:'';
$pr = isset($_POST['pr'])?$_POST['pr']:'';
$ids = str_replace("**", ",", $id);

/**
 * Functions
 */
function add_taskgroup_to_changelist($requestAct, $parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList)) {
        return;
    }

    $taskgroupList[$parent] = $level;
    $querymore = " WHERE tas.id='$parent'";
    $parentDetail = clone $requestAct;
    $parentDetail->openTasks($querymore);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($requestAct, $parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

function change_parent_task($requestAct, $parent)
{
    global $tablePrefix,$idSession;
    $querymore = " WHERE tas.parent_task='$parent'";
    $subtaskList = clone $requestAct;
    $subtaskList->openTasks($querymore);
    $newSubtask = count($subtaskList->tas_id);
    $newPriority = -1;
    $newStatus = '';
    $newStartDate = PHP_INT_MAX;
    $newDueDate = 0;
    $newCompleteDate = 0;

    for ($i = 0;$i < $newSubtask;$i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }

            if ($status == enumStatus::stOpen || $newStatus == enumStatus::stOpen) {
                $newStatus = enumStatus::stOpen;
            } else if ($status == enumStatus::stSuspended || $newStatus == enumStatus::stSuspended) {
                $newStatus = enumStatus::stSuspended;
            } else if ($status == enumStatus::stNotStarted || $newStatus == enumStatus::stNotStarted) {
                $newStatus = enumStatus::stNotStarted;
            } else if ($status == enumStatus::stClientCompleted || $newStatus == enumStatus::stClientCompleted) {
                $newStatus = enumStatus::stClientCompleted;
            }

            $newCompletion += $completion;

            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }

            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }

            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = '0';
            }

            if ($published == enumPublished::pbYes) {
                $newPublished = enumPublished::pbYes;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = '0';
            }

            $newPublished = $published;
        }
    }

    $newCompletion = floor($newCompletion / $newSubtask);
    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', task_group='" . enumTaskGroup::tgYes . "', subtask='$newSubtask', modified='" . time() . "', muser='$idSession' WHERE id='$parent'";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }

    copy2HistoryTable($requestAct, 'tasks', $parent, 'U');
}

/**
 * Permission check
 */
$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$compt1 = count($projectDetail->pro_id);

if ($compt1 == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = "SELECT DISTINCT project FROM " . $tablePrefix . "tasks WHERE id IN ($ids)";
$listProjects = new request();
$listProjects->connectClass();
$listProjects->query($tmpquery);
$comptListProjects = 0;

while ($listProjects->fetch()) {
    $listProjects->project[] = ($row[0]);
    $comptListProjects++;
}

$listProjects->close();

for ($i=0; $i<$comptListProjects; $i++) {
    $querymore2 = " WHERE pro.id='" . $listProjects->project[$i] . "'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore2);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }

    $querymore3 = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore3);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore4 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore4 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore4);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($permissionDetail->prp_modify_task_status[0] != enumBoolean::bTrue && $permissionDetail->prp_modify_task_properties[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
}

$tmpquery = "SELECT tas.id FROM " . $tablePrefix . "tasks tas LEFT OUTER JOIN " . $tablePrefix . "members mem2 ON mem2.id=tas.owner WHERE tas.id IN ($ids) AND (tas.milestone='" . enumMilestone::msYes . "' OR mem2.organization<>'1')";

if (compt($tmpquery) != '0') {  // not for milestones and client tasks
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore5 = " WHERE tas.id IN ($ids)";
$listTasks = new request();
$listTasks->openTasks($querymore5);
$comptListTasks = count($listTasks->tas_id);

/**
 * Actions
 */
if ($action == 'update') {
    $notificationList = array();
    $query = "";
    $msg = "";
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($st != '') {
            $query .= "status='$st'";
            $listSupportRequests = clone $requestAct;

            if ($st == enumStatus::stCompleted) {
                $tmpquery = "SELECT DISTINCT sr.id FROM " . $tablePrefix . "tasks tas INNER JOIN " . $tablePrefix . "support_requests sr ON sr.id=tas.support_request WHERE tas.id IN ($ids) AND tas.status<>'" . enumStatus::stCompleted . "' AND sr.status<>'" . enumRequestStatus::stCompleted . "'";
            } else {
                $tmpquery = "SELECT DISTINCT sr.id FROM " . $tablePrefix . "tasks tas INNER JOIN " . $tablePrefix . "support_requests sr ON sr.id=tas.support_request WHERE tas.id IN ($ids) AND tas.status='" . enumStatus::stCompleted . "' AND sr.status='" . enumRequestStatus::stCompleted . "'";
            }

            $listSupportRequests->query($tmpquery);
            $comptListSupportRequests = 0;

            while ($listSupportRequests->fetch()) {
                $listSupportRequests->support_request[] = ($row[0]);
                $comptListSupportRequests++;
            }

            if ($comptListSupportRequests != '0') {
                $srids = implode(',', $listSupportRequests->support_request);

                if ($st == enumStatus::stCompleted) {
                    $tmpsql = "UPDATE " . $tablePrefix . "support_requests SET status='" . enumRequestStatus::stCompleted . "',date_close='" . time() . "' WHERE id IN ($srids)";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                } else {
                    $tmpsql = "UPDATE " . $tablePrefix . "support_requests SET status='" . enumRequestStatus::stOpen . "',date_close='0' WHERE id IN ($srids)";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }

                copy2HistoryTable($requestAct, 'support_requests', $srids, 'U');
            }
        }

        if ($compl != "") {
            if ($query != "") {
                $query .= ",";
            }

            $query .= "completion='$compl'";
        }

        if ($pr != '') {
            if ($query != "") {
                $query .= ",";
            }

            $query .= "priority='$pr'";
        }

        if ($query != "") {
            for ($utc1=0; $utc1<$comptListTasks; $utc1++) {
                if ($listTasks->tas_parent_task[$utc1] != "0") {
                    add_taskgroup_to_changelist($requestAct, $listTasks->tas_parent_task[$utc1], $listTasks->tas_level[$utc1]);
                }

                $tmpsql = "UPDATE " . $tablePrefix . "tasks SET $query,modified='" . time() . "',muser='$idSession' WHERE id='" . $listTasks->tas_id[$utc1] . "'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                $id = $listTasks->tas_id[$utc1];
                copy2HistoryTable($requestAct, 'tasks', $id, 'U');
                $notificationList[$id] = array();

                if ($st != '' && $listTasks->tas_status[$utc1] != $st) {
                    $notificationList[$id][] = 'st';
                }

                if ($pr != '' && $listTasks->tas_priority[$utc1] != $pr) {
                    $notificationList[$id][] = 'pr';
                }
            }

            // update parent tasks
            if (count($taskgroupList) > 0) {
                arsort($taskgroupList, SORT_NUMERIC);

                foreach ($taskgroupList as $parentTask => $lvl) {
                    change_parent_task($requestAct, $parentTask);
                }
            }

            $msg = "update";
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        foreach ($notificationList as $id => $na) {
            foreach ($na as $a) {
                if ($a == 'st') {
                    if (!defined('INNER_NOTI_STATUSTASKCHG')) {
                        define('INNER_NOTI_STATUSTASKCHG', 1);
                    }

                    require("../tasks/noti_statustaskchange.php");
                } else if ($a == 'pr') {
                    if (!defined('INNER_NOTI_PRITASKCHG')) {
                        define('INNER_NOTI_PRITASKCHG', 1);
                    }

                    require("../tasks/noti_prioritytaskchange.php");
                }
            }
        }

        header("Location: ../tasks/listtasks.php?project=$project&msg=$msg" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project" . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_multiple_tasks"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "udT";
$block1->openForm("../tasks/updatetasks.php?id=$id&amp;project=$project" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"update\">";
$block1->heading(lang_strings("edit_multiple_tasks"));
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow("", "$comptListTasks " . lang_strings("tasks_selected"));
$stSel = "<select name=\"st\" onchange=\"changeSt(this)\">
<option value=\"\" selected>" . lang_strings("no_change") . "</option>";

foreach ($statusTeamTask as $key => $val) {
    $stSel .= "<option value=\"$key\">$val</option>";
}

$stSel .= "</select>";
$block1->contentRow(lang_strings("status"), $stSel);
$compSel = "<input name=\"compl\" type=\"hidden\" value=\"\">
<select name=\"completion\" onchange=\"changeCompletion(this)\">
<option value=\"\" selected>" . lang_strings("no_change") . "</option>";

for ($i = 0;$i < 11;$i++) {
    $complValue = ($i > 0) ? $i . "0 %": $i . " %";
    $compSel .= "<option value=\"" . $i . "\">" . $complValue . "</option>";
}

$compSel .= "</select>";
$block1->contentRow(lang_strings("completion"), $compSel);
$prSel = "<select name=\"pr\">
<option value=\"\" selected>" . lang_strings("no_change") . "</option>";
$comptPri = count($priority);

for ($i = 0;$i < $comptPri;$i++) {
    $prSel .= "<option value=\"$i\">$priority[$i]</option>";
}

$prSel .= "</select>";
$block1->contentRow(lang_strings("priority"), $prSel);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["update"] . "\">");
$block1->closeContent();
$block1->closeForm();
?>
<script type="text/javascript">
function changeSt(theObj){
    var x=theObj.selectedIndex;
    var y=theObj.options;

    if (y[x].value == '3') {  // open
        document.udTForm.completion.disabled = false;

        if (document.udTForm.completion.selectedIndex == 11) {
            document.udTForm.completion.selectedIndex = 0;
            document.udTForm.compl.value = '';
        }
    } else if (y[x].value == '') {  // no change
        document.udTForm.completion.disabled = false;
        document.udTForm.completion.selectedIndex = 0;
        document.udTForm.compl.value = '';
    } else {
        if (y[x].value == '1') {  // completed
            document.udTForm.completion.selectedIndex = 11;
            document.udTForm.compl.value = '10';
        } else if (y[x].value == '2') {    // not start
            document.udTForm.completion.selectedIndex = 1;
            document.udTForm.compl.value = '0';
        } else {    // suspend
            document.udTForm.completion.selectedIndex = 0;
            document.udTForm.compl.value = '';
        }

        document.udTForm.completion.disabled = true;
    }
}

function changeCompletion(){
    var x=document.udTForm.completion.selectedIndex;
    var y=document.udTForm.completion.options;
    document.udTForm.compl.value = y[x].value;
}
</script>
<?php
require_once("../includes/footer.php");
