<?php // $Revision: 1.62 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewtask.php,v 1.62 2013/01/29 08:46:15 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$taskgroupList = array();
$id = AddSlashesNOD(isset($_REQUEST['id'])?$_REQUEST['id']:'0');
$task = AddSlashesNOD(isset($_GET['task'])?$_GET['task']:'0');
$assids = AddSlashesNOD(isset($_GET['assids'])?$_GET['assids']:'');
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$err = isset($_GET['err'])?$_GET['err']:'';
$base = isset($_GET['base'])?$_GET['base']:'1';
$gantt_sd = isset($_GET['gantt_sd'])?$_GET['gantt_sd']:'';
$action = isset($_GET['action'])?$_GET['action']:'';
$addToSite = isset($_GET['addToSiteTask'])?$_GET['addToSiteTask']:'';
$removeToSite = isset($_GET['removeToSiteTask'])?$_GET['removeToSiteTask']:'';
$addToSiteFile = isset($_GET['addToSiteFile'])?$_GET['addToSiteFile']:'';
$removeToSiteFile = isset($_GET['removeToSiteFile'])?$_GET['removeToSiteFile']:'';

if ($err != '') {
    $error = $strings[$err];
}

/**
 * Permission check
 */
if ($addToSiteFile == 'true' || $removeToSiteFile == 'true') {
    $querymore1 = " WHERE tas.id='$task'";
} else {
    $querymore1 = " WHERE tas.id='$id'";
}

$taskDetail = new request();
$taskDetail->openTasks($querymore1);
$project = $taskDetail->tas_project[0];
$querymore2 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore2);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == 0) {                 // Project not found
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($action == 'publish') {
    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
        exit;
    }
}

if ($projectDetail->pro_phase_set[0] != "0") {
    $tPhase = $taskDetail->tas_parent_phase[0];
    $querymore3 = " WHERE pha.project='$project' AND pha.order_num='$tPhase'";
    $targetPhase = new request();
    $targetPhase->openPhases($querymore3);
}

$querymore4 = " WHERE tea.project='" . $projectDetail->pro_id[0] . "' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore4);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore5 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore5 = " WHERE prp.project='" . $projectDetail->pro_id[0] . "' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore5);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($taskDetail->tas_milestone[0] == enumMilestone::msYes) {
    if (!$SW_Permissions['Project']['Admin'][$profilSession] && $permissionDetail->prp_view_milestone[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
        exit;
    }

    if ($action == 'publish') {
        if ($addToSite == 'true' || $removeToSite == 'true') {
            if ($permissionDetail->prp_publish_milestone[0] != enumBoolean::bTrue) {
                header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
                exit;
            }
        } else if ($addToSiteFile == "true" || $removeToSiteFile == "true") {
            if ($permissionDetail->prp_publish_file[0] != enumBoolean::bTrue) {
                header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
                exit;
            }
        }
    }
} else {
    if (!$SW_Permissions['Project']['Admin'][$profilSession] && $permissionDetail->prp_view_task[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
        exit;
    }

    if ($action == 'publish') {
        if ($addToSite == 'true' || $removeToSite == 'true') {
            if ($permissionDetail->prp_publish_task[0] != enumBoolean::bTrue) {
                header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
                exit;
            }
        } else if ($addToSiteFile == "true" || $removeToSiteFile == "true") {
            if ($permissionDetail->prp_publish_file[0] != enumBoolean::bTrue) {
                header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=tasks' . $urlBornes);
                exit;
            }
        }
    }
}

/**
 * Functions
 */
function add_taskgroup_to_changelist($requestAct, $parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList)) {
        return;
    }

    $taskgroupList[$parent] = $level;
    $querymore6 = " WHERE tas.id='$parent'";
    $parentDetail = clone $requestAct;
    $parentDetail->openTasks($querymore6);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($requestAct, $parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

function change_parent_task($requestAct, $parent)
{
    global $tablePrefix,$idSession;
    $querymore7 = " WHERE tas.parent_task='$parent'";
    $subtaskList = clone $requestAct;
    $subtaskList->openTasks($querymore7);
    $newSubtask = count($subtaskList->tas_id);
    $newPriority = enumPriority::prNone;
    $newStatus = enumStatus::stNotStarted;
    $newStartDate = 0;
    $newDueDate = 0;
    $newCompleteDate = 0;

    for ($i=0; $i<$newSubtask; $i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }

            if ($status == enumStatus::stNotStarted || $newStatus == enumStatus::stNotStarted) {
                $newStatus = enumStatus::stNotStarted;
            } else if ($status == enumStatus::stOpen || $newStatus == enumStatus::stOpen) {
                $newStatus = enumStatus::stOpen;
            } else if ($status == enumStatus::stSuspended || $newStatus == enumStatus::stSuspended) {
                $newStatus = enumStatus::stSuspended;
            } else if ($status == enumStatus::stClientCompleted || $newStatus == enumStatus::stClientCompleted) {
                $newStatus = enumStatus::stClientCompleted;
            }

            $newCompletion += $completion;

            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }

            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }

            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = '0';
            }

            if ($published == enumPublished::pbYes) {
                $newPublished = enumPublished::pbYes;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;

            if ($newStatus == enumStatus::stCompleted) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = '0';
            }

            $newPublished = $published;
        }
    }

    $newCompletion = substr($newCompletion / $newSubtask, 0, 1);
    $tmpsql = "UPDATE " . $tablePrefix . "tasks SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', task_group='" . enumTaskGroup::tgYes . "', subtask='$newSubtask', modified='" . time() . "', muser='$idSession' WHERE id='$parent'";

    if ($requestAct->query($tmpsql) === false) {
        throw new Exception($tmpsql);
    }

    copy2HistoryTable($requestAct, 'tasks', $parent, 'U');
}

function subtask_ids($id)
{
    $querymore8 = " WHERE tas.parent_task='$id'";
    $listTasks = new request();
    $listTasks->openTasks($querymore8);
    $comptListTasks = count($listTasks->tas_id);

    if ($comptListTasks == '0') {
        return '';
    } else {
        for ($i=0, $ids = ''; $i<$comptListTasks; $i++) {
            if ($ids != '') {
                $ids .= ',';
            }

            if ($listTasks->tas_task_group[$i] == enumTaskGroup::tgYes) {
                $ids .= subtask_ids($listTasks->tas_id[$i]);
            }

            if ($ids != '') {
                $ids .= ',';
            }

            $ids .= $listTasks->tas_id[$i];
        }
    }
}

/**
 * Actions
 */
if ($action == "publish") {
    if ($addToSite == "true") {
        $criticalSection = enter_critical_section();

        if ($criticalSection == -1) {
            header("Location: ../tasks/viewtask.php?id=$id&msg=$msg" . $urlBornes);
            exit;
        }

        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "tasks SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'tasks', $id, 'U');
            $msg = "addToSite";
            $taskDetail->tas_published[0] = enumPublished::pbYes;
            $querymore = " WHERE tas.id='$id'";
            $listTasks = clone $requestAct;
            $listTasks->openTasks($querymore);
            $comptListTasks = count($listTasks->tas_id);

            for ($i=0; $i<$comptListTasks; $i++) {
                add_taskgroup_to_changelist($requestAct, $listTasks->tas_parent_task[$i], $listTasks->tas_level[$i]);
            }

            if (count($taskgroupList) > 0) {
                arsort($taskgroupList, SORT_NUMERIC);
                reset($taskgroupList);

                while (list($parentTask, $level) = each($taskgroupList)) {
                    change_parent_task($requestAct, $parentTask);
                }
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
        leave_critical_section($criticalSection);
    } else if ($removeToSite == "true") {
        $criticalSection = enter_critical_section();

        if ($criticalSection == -1) {
            header("Location: ../tasks/viewtask.php?id=$id&msg=$msg" . $urlBornes);
            exit;
        }

        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "tasks SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'tasks', $id, 'U');
            $msg = "removeToSite";
            $taskDetail->tas_published[0] = enumPublished::pbNo;
            $querymore = " WHERE tas.id='$id'";
            $listTasks = clone $requestAct;
            $listTasks->openTasks($querymore);
            $comptListTasks = count($listTasks->tas_id);

            for ($i=0; $i<$comptListTasks; $i++) {
                add_taskgroup_to_changelist($requestAct, $listTasks->tas_parent_task[$i], $listTasks->tas_level[$i]);
            }

            if (count($taskgroupList) > 0) {
                arsort($taskgroupList, SORT_NUMERIC);
                reset($taskgroupList);

                while (list($parentTask, $level) = each($taskgroupList)) {
                    change_parent_task($requestAct, $parentTask);
                }
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
        leave_critical_section($criticalSection);
    } else if ($addToSiteFile == "true") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $ids = "'" . str_replace("**", "','", $id) . "'";
            $id = $task;
            $tmpsql = "UPDATE " . $tablePrefix . "files SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids) OR vc_parent IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'files', $ids, 'U');
            $msg = "addToSite";
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    } else if ($removeToSiteFile == "true") {
        $requestAct = new request();
        $requestAct->connectClass();     // connect to database server

        try {
            $requestAct->startTransaction();
            $ids = "'" . str_replace("**", "','", $id) . "'";
            $id = $task;
            $tmpsql = "UPDATE " . $tablePrefix . "files SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids) OR vc_parent IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'files', $ids, 'U');
            $msg = "removeToSite";
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();
    }
}

if ($msg == 'addAssignment' || $msg == 'updateAssignment') {
    require_once($path_prefix . 'includes/messages.php');   // assemble message text
    $msgTypeStr = $msgDefinitions[$msg]['type'];
    $msgTextStr = $msgDefinitions[$msg]['text'] . ' <a href="' . "assignmentcomment.php?task=" . $taskDetail->tas_id[0] . "&amp;id=$assids" . '"><b>' . $strings["assignment_comment"] . '</b></a>';
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=tasks&id=$project" . $urlBornes, $projectDetail->pro_name[0], 'in'));

if ($projectDetail->pro_phase_set[0] != "0") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/listphases.php?project=$project" . $urlBornes, lang_strings("phases"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../phases/viewphase.php?project=$project&id=" . $targetPhase->pha_id[0] . $urlBornes, $targetPhase->pha_description[0], 'in'));
}

$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project" . $urlBornes, lang_strings("tasks"), 'in'));
$blockPage->itemBreadcrumbs($taskDetail->tas_name[0]);
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '15';
$title = $strings['task'] . ' : ' . $taskDetail->tas_name[0] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
logURL($title, "../tasks/viewtask.php?id=$id");
$block1 = new block();
$block1->form = "vt1";
$block1->openForm("../tasks/viewtask.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");

if ($taskDetail->tas_task_group[0] == enumTaskGroup::tgYes) {         // Task Group
    $block1->headingToggle(lang_strings("taskgroup"), !($toggle_focus==''));
    $querymore9 = " WHERE tas.parent_task='$id'";
    $listSubTasks = new request();
    $listSubTasks->openTasks($querymore9);
    $comptListSubTasks = count($listSubTasks->tas_id);
} else if ($taskDetail->tas_milestone[0] == enumMilestone::msYes) {   // Milestone
    $block1->headingToggle(lang_strings("milestone"), !($toggle_focus==''));
} else {                                                // Task
    $block1->headingToggle(lang_strings("task"), !($toggle_focus==''));
}

$block1->openPaletteIcon();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($taskDetail->tas_milestone[0] == enumMilestone::msYes) {
        if ($permissionDetail->prp_delete_milestone[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(0, "remove", $strings["delete"]);
        }

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
            if ($permissionDetail->prp_publish_milestone[0] == enumBoolean::bTrue) {
                if ($taskDetail->tas_published[0] == enumPublished::pbNo) {
                    $block1->paletteIcon(3, "add_projectsite", $strings["add_customer_service_site"]);
                } else {
                    $block1->paletteIcon(4, "remove_projectsite", $strings["remove_customer_service_site"]);
                }
            }
        }

        if ($permissionDetail->prp_modify_milestone_properties[0] == enumBoolean::bTrue || $permissionDetail->prp_configure_milestone_security[0]) {
            $block1->paletteIcon(5, "edit", $strings["edit"]);
        }
    } else {
        if ($permissionDetail->prp_delete_task[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(0, "remove", $strings["delete"]);
        }

        if ($permissionDetail->prp_copy_task[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(1, "copy", $strings["copy"]);
        }

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true" && $taskDetail->tas_task_group[0] != enumTaskGroup::tgYes) {
            if ($permissionDetail->prp_publish_task[0] == enumBoolean::bTrue) {
                $block1->paletteIcon(3, "add_projectsite", $strings["add_customer_service_site"]);
                $block1->paletteIcon(4, "remove_projectsite", $strings["remove_customer_service_site"]);
            }
        }

        if ($permissionDetail->prp_modify_task_status[0] == enumBoolean::bTrue || $permissionDetail->prp_modify_task_properties[0]) {
            $block1->paletteIcon(5, "edit", $strings["edit"]);
        }

        if ($permissionDetail->prp_log_task_hours[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(6, "timelog", $strings["loghours"]);
        }

        if ($permissionDetail->prp_material_issue[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(7, "material", $strings["material_issue"]);
        }
    }
}

$block1->paletteIcon(99, 'search', 'tasks');
$block1->closePaletteIcon();
$block1->openContent();

/**
 * Task, Task Group, Milestone Information
 */
$block1->contentTitle(lang_strings("info"));
// Project
$block1->contentRow(lang_strings("project"), $blockPage->buildLink("../projects/viewproject.php?id=$project&toggle_focus=tasks" . $urlBornes, $projectDetail->pro_name[0], 'in'));

// Phase set
if ($projectDetail->pro_phase_set[0] != "0") {
    $block1->contentRow(lang_strings("phase"), $blockPage->buildLink("../phases/viewphase.php?id=" . $targetPhase->pha_id[0] . $urlBornes, $targetPhase->pha_description[0], 'in'));
}

// Parent Task
if ($taskDetail->tas_parent_task[0] != "0") {
    $querymore10 = " WHERE tas.id='" . $taskDetail->tas_parent_task[0] . "'";
    $parentTaskDetail = new request();
    $parentTaskDetail->openTasks($querymore10);
    $block1->contentRow(lang_strings("parent_task"), $blockPage->buildLink("../tasks/viewtask.php?id=" . $parentTaskDetail->tas_id[0], $parentTaskDetail->tas_name[0], 'in'));
}

// Client Organization
if ($projectDetail->pro_org_id[0] != "1") {
    $block1->contentRow(lang_strings("organization"), $blockPage->buildLink('../clients/viewclient.php?id=' . $projectDetail->pro_organization[0], $projectDetail->pro_org_name[0], 'in'));
}

// Reference Support Request
if ($taskDetail->tas_support_request[0] != '0') {
    $block1->contentRow(lang_strings("support_request"), $blockPage->buildLink("../support/viewrequest.php?id=" . $taskDetail->tas_support_request[0], '#' . $taskDetail->tas_support_request[0], 'in') . " " . $taskDetail->tas_sr_subject[0]);
}

// Create Time
$block1->contentRow(lang_strings("created"), createDate($taskDetail->tas_created[0], 'both'));

// Assign Time
if ($taskDetail->tas_milestone[0] != enumMilestone::msYes) {
    $block1->contentRow(lang_strings("assigned"), createDate($taskDetail->tas_assigned[0], 'both'));
}

// Last Modified Time
$block1->contentRow(lang_strings("modified"), createDate($taskDetail->tas_modified[0], 'both'));
$block1->closeContent();
$block1->openContent(true);
/**
 * Task, Task Group, Milestone Details
 */
$block1->contentTitle(lang_strings("details"));
// Name
$block1->contentRow(lang_strings("name"), $taskDetail->tas_name[0]);
// ID
$block1->contentRow(lang_strings('task_id'), $taskDetail->tas_id[0]);
// Description
$block1->contentRow(lang_strings("description"), $taskDetail->tas_description[0]);
// Assign to
$querymore11 = " AND res.task='$id'";
$listAssignments = new request();
$listAssignments->openTaskHumanResource($querymore11);
$comptListAssignments = count($listAssignments->res_id);

if ($comptListAssignments == 0) {
    $block1->contentRow(lang_strings('assigned_to'), lang_strings('unassigned'));
} else {
    $assigned_to = array();

    for ($i=0; $i<$comptListAssignments; $i++) {
        $assigned_to[] = $block1->buildLink($listAssignments->res_resource[$i], '', 'message');
    }

    $block1->contentRow(lang_strings('assigned_to'), implode('', $assigned_to));
}

// Service
if ($taskDetail->tas_milestone[0] != enumMilestone::msYes) {
    $querymore12 = " WHERE id='" . $taskDetail->tas_service[0] . "'";
    $serviceDetail = new request();
    $serviceDetail->openServices($querymore12);
    $comptServiceDetail = count($serviceDetail->serv_id);

    if ($comptServiceDetail != '0') {
        $block1->contentRow(lang_strings("service"), $blockPage->buildLink('../services/viewservice.php?id=' . $taskDetail->tas_service[0], $serviceDetail->serv_name_print[0], 'in'));
    } else {
        $block1->contentRow(lang_strings("service"), lang_strings('none'));
    }
}

$idStatus = $taskDetail->tas_status[0];
$idPriority = $taskDetail->tas_priority[0];
$idPublish = $taskDetail->tas_published[0];
$complValue = ($taskDetail->tas_completion[0] > 0) ? $taskDetail->tas_completion[0] . "0 %": $taskDetail->tas_completion[0] . " %";

if ($taskDetail->tas_milestone[0] != enumMilestone::msYes) {
    // Status
    $block1->contentRow(lang_strings("status"), $status[$idStatus]);
    // Completion Percentage
    $block1->contentRow(lang_strings("completion"), $complValue);
    // Priority
    $block1->contentRow(lang_strings("priority"), $priority[$idPriority]);
    // Fixed duration
    $block1->contentRow(lang_strings("fixed_duration"), (($taskDetail->tas_fixed_duration[0] == enumFixedDuration::fdYes)?lang_strings("yes"):lang_strings("no")));
    // Start Date
    $block1->contentRow(lang_strings("start_date"), createDate($taskDetail->tas_start_date[0],'date',false,true));
    // Due Date
    if ($taskDetail->tas_due_date[0] <= time() && $taskDetail->tas_completion[0] != "10") {
        $block1->contentRow(lang_strings("due_date"), '<div class="overdue">' . createDate($taskDetail->tas_due_date[0],'date',false,true) . "</div>");
    } else {
        $block1->contentRow(lang_strings("due_date"), createDate($taskDetail->tas_due_date[0],'date',false,true));
    }

    $taskActualTime = new request();
    $actual_time = $taskActualTime->getTaskTime($id);

    if ($taskDetail->tas_complete_date[0] != "0" && $taskDetail->tas_due_date[0] != "0") {
        // Completed Date
        $block1->contentRow(lang_strings("complete_date"), createDate($taskDetail->tas_complete_date[0],'date',false,true));
        $diff = $actual_time - $taskDetail->tas_estimated_time[0] ;

        if ($diff > 0) {
            $diff = "<b>+$diff</b>";
        }
        // Scope Creep in Hours
        $block1->contentRow(lang_strings("scope_creep") . $blockPage->printHelp("task_scope_creep"), "$diff " . lang_strings("hours"));
    }

    // Estimated Time in Hours
    $block1->contentRow(lang_strings("estimated_time"), $taskDetail->tas_estimated_time[0] . " " . lang_strings("hours"));
    // Actual Time in Hours
    $block1->contentRow(lang_strings("actual_time"), strval($actual_time) . " " . lang_strings("hours"));
} else {
    // Milestone Due Date
    $block1->contentRow(lang_strings("date"), createDate($taskDetail->tas_due_date[0],'date',false,true));
}

if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {   // Published
    $block1->contentRow(lang_strings("published"), $statusPublish[$idPublish]);
}

// Comments
$block1->contentRow(lang_strings("comments"), $taskDetail->tas_comments[0]);

if ($taskDetail->tas_milestone[0] != enumMilestone::msYes) {
    // Task Type
    if (isset($strings['HRC__' . $taskDetail->tas_type[0]])) {
        $block1->contentRow(lang_strings("type"), $strings['HRC__' . $taskDetail->tas_type[0]]);
    } else {
        $block1->contentRow(lang_strings("type"), '');
    }
}

// Custom Fields
setupCustomFieldsHTML($block1, 'tasks', $id);
/**
 * Task Update History
 */
$block1->contentTitle(lang_strings("updates_task"));
$querymore13 = " WHERE upd.type='1' AND upd.item='$id' ORDER BY upd.created DESC";
$listUpdates = new request();
$listUpdates->openUpdates($querymore13);
$comptListUpdates = count($listUpdates->upd_id);
echo "<tr class=\"odd\"><td valign=\"top\" class=\"leftvalue\">&nbsp;</td><td>";

if ($comptListUpdates != "0") {
    for ($i=0,$j=1; $i<$comptListUpdates; $i++,$j++) {
        if ($i == 5) {
            echo "...<br>";
            break;
        }

        $upd_comm = $listUpdates->upd_comments[$i];

        if (preg_match("|\[status:([0-9])\]|i", $upd_comm, $matches) === 1) {
            $upd_comm = preg_replace_callback("|\[status:([0-9])\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
            $upd_comm .= lang_strings("status") . " " . $status[$matches[1]];
        }

        if (preg_match("|\[priority:([0-9])\]|i", $upd_comm, $matches) === 1) {
            $upd_comm = preg_replace_callback("|\[priority:([0-9])\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
            $upd_comm .= lang_strings("priority") . " " . $priority[$matches[1]];
        }

        if (preg_match("|\[datedue:([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\]|i", $upd_comm, $matches) === 1) {
            $upd_comm = preg_replace_callback("|\[datedue:([0-9]{4}-[0-9]{1,2}-[0-9]{1,2})\]|i", function ($matches) { return ""; }, $upd_comm . "<br>");
            $upd_comm .= lang_strings("due_date") . " " . $matches[1];
        }

        $abbrev = mb_substr($upd_comm, 0, 100, $setCharset);
        echo "<b>" . $j . ".</b> <i>" . createDate($listUpdates->upd_created[$i], 'both') . "</i> $abbrev";

        if (100 < mb_strlen($upd_comm, $setCharset)) {
            echo "...<br>";
        } else {
            echo "<br>";
        }
    }

    echo "<br>" . $blockPage->buildLink("../tasks/historytask.php?id=$id" . $urlBornes, lang_strings("show_details"), 'in');
} else {
    echo lang_strings("no_items");
}

echo "</td></tr>";
$block1->closeContent();
$block1->closeToggle();
$block1->closeForm();
$block1->openPaletteScript();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($taskDetail->tas_milestone[0] == enumMilestone::msYes) {
        if ($permissionDetail->prp_delete_milestone[0] == enumBoolean::bTrue) {
            $block1->paletteScript(0, "remove", "../tasks/deletetasks.php?project=$project&id=$id" . $urlBornes, "true,true,false", $strings["delete"]);
        }

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
            if ($permissionDetail->prp_publish_milestone[0] == enumBoolean::bTrue) {
                if ($taskDetail->tas_published[0] == enumPublished::pbNo) {
                    $block1->paletteScript(3, "add_projectsite", "../tasks/viewtask.php?addToSiteTask=true&id=$id&action=publish" . $urlBornes, "true,true,true", $strings["add_customer_service_site"]);
                } else {
                    $block1->paletteScript(4, "remove_projectsite", "../tasks/viewtask.php?removeToSiteTask=true&id=$id&action=publish" . $urlBornes, "true,true,true", $strings["remove_customer_service_site"]);
                }
            }
        }

        if ($permissionDetail->prp_modify_milestone_properties[0] == enumBoolean::bTrue || $permissionDetail->prp_configure_milestone_security[0]) {
            $block1->paletteScript(5, "edit", "../tasks/edittask.php?id=$id&cpy=false" . $urlBornes, "true,true,false", $strings["edit"]);
        }
    } else {
        if ($permissionDetail->prp_delete_task[0] == enumBoolean::bTrue) {
            $block1->paletteScript(0, "remove", "../tasks/deletetasks.php?project=$project&id=$id" . $urlBornes, "true,true,false", $strings["delete"]);
        }

        if ($permissionDetail->prp_copy_task[0] == enumBoolean::bTrue) {
            $block1->paletteScript(1, "copy", "../tasks/edittask.php?project=$project&id=$id&cpy=true" . $urlBornes, "true,true,false", $strings["copy"]);
        }

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true" && $taskDetail->tas_task_group[0] != enumTaskGroup::tgYes) {
            if ($permissionDetail->prp_publish_task[0] == enumBoolean::bTrue) {
                $block1->paletteScript(3, "add_projectsite", "../tasks/viewtask.php?addToSiteTask=true&id=$id&action=publish" . $urlBornes, "true,true,true", $strings["add_customer_service_site"]);
                $block1->paletteScript(4, "remove_projectsite", "../tasks/viewtask.php?removeToSiteTask=true&id=$id&action=publish" . $urlBornes, "true,true,true", $strings["remove_customer_service_site"]);
            }
        }

        if ($permissionDetail->prp_modify_task_status[0] == enumBoolean::bTrue || $permissionDetail->prp_modify_task_properties[0]) {
            $block1->paletteScript(5, "edit", "../tasks/edittask.php?id=$id&cpy=false" . $urlBornes, "true,true,false", $strings["edit"]);
        }

        if ($permissionDetail->prp_log_task_hours[0] == enumBoolean::bTrue) {
            $block1->paletteScript(6, "timelog", "../tasks/addtasktime.php?id=$id" . $urlBornes, "true,true,false", $strings["loghours"]);
        }

        if ($permissionDetail->prp_material_issue[0] == enumBoolean::bTrue) {
            $block1->paletteScript(7, "material", "../tasks/addmaterialissue.php?id=$id" . $urlBornes, "true,true,false", $strings["material_issue"]);
        }
    }
}

$block1->paletteScript(99, 'search', 'tasks');
$block1->closePaletteScript("", "");

if (($fileManagement == "true") && ($permissionDetail->prp_view_file[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Admin'][$profilSession])) {
    /**
     * Task linked contents block
     */
    $block2 = new block();
    $block2->form = "vt2";
    $block2->openForm("../tasks/viewtask.php?id=$id" . $urlBornes . "#" . $block2->form . "Anchor");
    $block2->headingToggle(lang_strings("linked_content"), !($toggle_focus=='linked_content'));
    $block2->borne = $blockPage->returnBorne('15');
    $block2->rowsLimit = '12';

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        $block2->sorting("task_files", (isset($sortingUser['task_files'])?$sortingUser['task_files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status', 4 => 'fil.published'));
    } else {
        $block2->sorting("task_files", (isset($sortingUser['task_files'])?$sortingUser['task_files']:''), 'fil.name ASC', $sortingFields = array(0 => 'fil.name', 1 => 'fil.owner', 2 => 'fil.created', 3 => 'fil.status'));
    }

    if ($taskDetail->tas_task_group[0] == enumTaskGroup::tgYes) {
        $ids = subtask_ids($id);

        if ($ids != '') {
            $ids .= ',';
        }

        $ids .= $id;
        $querymore14 = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtTask . "' AND fil.doc_id IN ($ids) AND fil.vc_parent=0 ORDER BY " . $block2->sortingValue;
    } else {
        $querymore14 = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtTask . "' AND fil.doc_id='$id' AND fil.vc_parent=0 ORDER BY " . $block2->sortingValue;
    }

    $block2->recordsTotal = compt($initrequest["files"] . $querymore14);
    $listFiles = new request();
    $listFiles->openFiles($querymore14, $block2->borne, $block2->rowsLimit);
    $comptListFiles = count($listFiles->fil_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['name'];
    $columns[0]->field_type = enumFieldType::ftText;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['owner'];
    $columns[1]->field_type = enumFieldType::ftAvatar;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['created'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['approval_tracking'];
    $columns[3]->field_type = enumFieldType::ftText;

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        $columns[4] = new cardviewColumn();
        $columns[4]->title = $strings['published'];
        $columns[4]->field_type = enumFieldType::ftText;
    }

    $opt[enumCardviewOption::oTableName] = 'files';
    $opt[enumCardviewOption::oObject] = 'files';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oSearch] = true;
    $opt[enumCardviewOption::oExtraParameters] = "doc_type=" . enumFileRelatedDocumentType::dtTask . "&doc_id=" . $id . $urlBornes . '&borne15=' . $block2->borne;

    if ($SW_Permissions['File']['Write'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = "../linkedcontent/addfile.php?doc_type=" . enumFileRelatedDocumentType::dtProject . "&doc_id=$id" . $urlBornes;
    }

    $block2->openCardView($opt);

    for ($i=0; $i<$comptListFiles; $i++) {
        $idStatus = $listFiles->fil_status[$i];
        $idPublish = $listFiles->fil_published[$i];
        $content = array(
            $listFiles->fil_name[$i],
            implode(',',
                array(
                    $listFiles->fil_owner[$i],
                    $listFiles->fil_mem_extension_picture[$i],
                    $listFiles->fil_mem_gender[$i])),
            createDate($listFiles->fil_created[$i],'both'),
            $blockPage->buildLink('../linkedcontent/viewfile.php?doc_type=' . enumFileRelatedDocumentType::dtTask . '&doc_id=' . $id . '&id=' . $listFiles->fil_id[$i] . $urlBornes, $statusFile[$idStatus], 'in')
        );

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
            $content[] = $statusPublish[$idPublish];
        }

        $block2->itemCardView($listFiles->fil_id[$i], $content);
    }

    $block2->closeCardView();
    $block2->bornesFooter('15', $blockPage->bornesNumber, 'toggle_focus=linked_content&id=' . $id . $urlBornes);
    $block2->closeToggle();
    $block2->closeFormResults();
}

if ($taskDetail->tas_task_group[0] != enumTaskGroup::tgYes) {
    /**
     * Task dependencies block
     */
    $block4 = new block();
    $block4->form = "vt4";
    $block4->openForm("../tasks/viewtask.php?id=$id" . $urlBornes . "#" . $block4->form . "Anchor");
    $block4->headingToggle(lang_strings("task_dependencies"), !($toggle_focus=='task_dependencies'));
    $block4->borne = $blockPage->returnBorne('14');
    $block4->rowsLimit = '12';
    $block4->sorting("predecessors", (isset($sortingUser['predecessors'])?$sortingUser['predecessors']:''), "tas2.due_date ASC", $sortingFields = array(0 => "tas2.name", 1 => "tas2.start_date", 2 => "tas2.due_date", 3 => "pre.type", 4 => "pre.lag"));
    $querymore15 = " WHERE pre.task='$id' OR pre.predecessor='$id' ORDER BY " . $block4->sortingValue;
    $block4->recordsTotal = compt($initrequest["tasks_predecessor"] . $querymore15);
    $listPredecessor = new request();
    $listPredecessor->openTaskPredecessor($querymore15, $block4->borne, $block4->rowsLimit);
    $comptListPredecessor = count($listPredecessor->pre_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['task'];
    $columns[0]->field_type = enumFieldType::ftNumeric;
    $columns[0]->linked_table = 'tasks';
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['start_date'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['due_date'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['type'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['lag'];
    $columns[4]->field_type = enumFieldType::ftText;
    $opt[enumCardviewOption::oObject] = 'tasks_predecessors';
    $opt[enumCardviewOption::oTableName] = 'tasks_predecessor';
    $opt[enumCardviewOption::oColumns] = $columns;
    $opt[enumCardviewOption::oExtraParameters] = "project=$project&task=" . $taskDetail->tas_id[0] . $urlBornes . '&borne14=' . $block4->borne;

    if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
        if ($permissionDetail->prp_edit_task_relationships[0] == enumBoolean::bTrue) {
            $opt[enumCardviewOption::oAddUrl] = "../tasks/addpredecessor.php?project=$project&id=$id" . $urlBornes;
        }
    }

    $block4->openCardView($opt);

    for ($i=0; $i<$comptListPredecessor; $i++) {
        if ($listPredecessor->pre_task[$i] == $id) {
            $content = array(
                $listPredecessor->pre_predecessor[$i],
                createDate($listPredecessor->pre_tas2_start_date[$i],'date',false,true)
            );

            if ($listPredecessor->pre_tas2_milestone[$i] == enumMilestone::msYes) {
                $content[] = createDate($listPredecessor->pre_tas2_due_date[$i],'date',false,true);
            } else if ($listPredecessor->pre_tas2_due_date[$i] <= time() && $listPredecessor->pre_tas2_completion[$i] != '10') {
                $content[] = '<b>' . createDate($listPredecessor->pre_tas2_due_date[$i],'date',false,true) . '</b>';
            } else {
                $content[] = createDate($listPredecessor->pre_tas2_due_date[$i],'date',false,true);
            }

            $content[] = $taskPredecessorTypes[$listPredecessor->pre_type[$i]];
        } else {
            $content = array(
                $listPredecessor->pre_task[$i],
                createDate($listPredecessor->pre_tas_start_date[$i],'date',false,true)
            );

            if ($listPredecessor->pre_tas_milestone[$i] == enumMilestone::msYes) {
                $content[] = createDate($listPredecessor->pre_tas_due_date[$i],'date',false,true);
            } else if ($listPredecessor->pre_tas_due_date[$i] <= time() && $listPredecessor->pre_tas_completion[$i] != '10') {
                $content[] = '<b>' . createDate($listPredecessor->pre_tas_due_date[$i],'date',false,true) . '</b>';
            } else {
                $content[] = createDate($listPredecessor->pre_tas_due_date[$i],'date',false,true);
            }

            $content[] = $taskPredecessorTypes[$listPredecessor->pre_type[$i]] . "(" . lang_strings('opposite') . ")";
        }

        $content[] = $listPredecessor->pre_lag[$i];
        $block4->itemCardView($listPredecessor->pre_id[$i], $content);
    }

    $block4->closeCardView();
    $block4->bornesFooter('14', $blockPage->bornesNumber, 'toggle_focus=task_dependencies&id=' . $id . $urlBornes);
    $block4->closeToggle();
    $block4->closeFormResults();
}

if ($taskDetail->tas_milestone[0] != enumMilestone::msYes) {
    /**
     * Sub-tasks block
     */
    if ($taskDetail->tas_task_group[0] == enumTaskGroup::tgYes) {
        $block6 = new block();
        $block6->form = "vt6";
        $block6->openForm("../tasks/viewtask.php?id=$id" . $urlBornes . "#" . $block6->form . "Anchor");
        $block6->headingToggle(lang_strings("subtasks"), !($toggle_focus=='subtasks'));
        $block6->borne = $blockPage->returnBorne('13');
        $block6->rowsLimit = '12';

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
            $block6->sorting("subtasks", (isset($sortingUser['subtasks'])?$sortingUser['subtasks']:''), "tas.due_date ASC", $sortingFields = array(0 => "tas.id", 1 => "tas.name", 2 => "tas.priority", 3 => "tas.status", 4 => "tas.completion", 5 => "tas.due_date", 6 => "tas.assigned_to", 7 => "tas.published"));
        } else {
            $block6->sorting("subtasks", (isset($sortingUser['subtasks'])?$sortingUser['subtasks']:''), "tas.due_date ASC", $sortingFields = array(0 => "tas.id", 1 => "tas.name", 2 => "tas.priority", 3 => "tas.status", 4 => "tas.completion", 5 => "tas.due_date", 6 => "tas.assigned_to"));
        }

        $querymore16 = " WHERE tas.parent_task='$id' ORDER BY " . $block6->sortingValue;
        $block6->recordsTotal = compt($initrequest['tasks'] . ' ' . $querymore16);
        $listSubTasks = new request();
        $listSubTasks->openTasks($querymore16, $block6->borne, $block6->rowsLimit);
        $comptListSubTasks = count($listSubTasks->tas_id);
        $columns = array();
        $columns[0] = new cardviewColumn();
        $columns[0]->title = $strings['id'];
        $columns[0]->field_type = enumFieldType::ftNumeric;
        $columns[1] = new cardviewColumn();
        $columns[1]->title = $strings['name'];
        $columns[1]->field_type = enumFieldType::ftText;
        $columns[2] = new cardviewColumn();
        $columns[2]->title = $strings['priority'];
        $columns[2]->field_type = enumFieldType::ftText;
        $columns[3] = new cardviewColumn();
        $columns[3]->title = $strings['status'];
        $columns[3]->field_type = enumFieldType::ftText;
        $columns[4] = new cardviewColumn();
        $columns[4]->title = $strings['completion'];
        $columns[4]->field_type = enumFieldType::ftText;
        $columns[5] = new cardviewColumn();
        $columns[5]->title = $strings['due_date'];
        $columns[5]->field_type = enumFieldType::ftText;
        $columns[6] = new cardviewColumn();
        $columns[6]->title = $strings['assigned_to'];
        $columns[6]->field_type = enumFieldType::ftAvatar;

        if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
            $columns[7] = new cardviewColumn();
            $columns[7]->title = $strings['published'];
            $columns[7]->field_type = enumFieldType::ftText;
        }

        $opt = array();
        $opt[enumCardviewOption::oObject] = 'tasks';
        $opt[enumCardviewOption::oTableName] = 'tasks';
        $opt[enumCardviewOption::oColumns] = $columns;
        $opt[enumCardviewOption::oSearch] = true;
        $opt[enumCardviewOption::oExtraParameters] = 'org_url=' . urlencode("tasks/viewtask.php?toggle_focus=subtasks&id=$id" . $urlBornes);

        if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
            if ($permissionDetail->prp_create_task[0] == enumBoolean::bTrue) {
                $opt[enumCardviewOption::oAddUrl] = "../tasks/edittask.php?project=$project&task=$id" . $urlBornes;
            }
        }

        $block6->openCardView($opt);
        $today = mktime(0,0,0,intval(date('m')),intval(date('d')),intval(date('Y')));

        for ($i=0; $i<$comptListSubTasks; $i++) {
            $tmpquery = "SELECT id FROM " . $tablePrefix . "tasks WHERE parent_task='" . $listSubTasks->tas_id[$i] . "'";
            $comptSubTasks = compt($tmpquery);

            if ($comptSubTasks > 0) {
                $namePostfix = "&nbsp;&nbsp;($comptSubTasks&nbsp;" . lang_strings('subtasks') . ")";
            } else {
                $namePostfix = '';
            }

            $idStatus = $listSubTasks->tas_status[$i];
            $idPriority = $listSubTasks->tas_priority[$i];
            $idPublish = $listSubTasks->tas_published[$i];
            $complValue = ($listSubTasks->tas_completion[$i] > 0) ? $listSubTasks->tas_completion[$i] . "0 %": $listSubTasks->tas_completion[$i] . " %";

            if ($idStatus == 1) {
                $nameTxt = '<del>' . $listSubTasks->tas_name[$i] . $namePostfix . '</del>';
            } else {
                $nameTxt = $listSubTasks->tas_name[$i] . $namePostfix;
            }

            if ($listSubTasks->tas_milestone[$i] == enumMilestone::msYes) {
                $priorityTxt = '';
                $statusTxt = '';
                $completionTxt = '';
            } else {
                $priorityTxt = $priority[$idPriority];
                $statusTxt = $status[$idStatus];
                $completionTxt = $complValue;
            }

            if ($listSubTasks->tas_milestone[$i] == enumMilestone::msYes) {
                $duedateTxt = createDate($listSubTasks->tas_due_date[$i],'date',false,true);
            } else if ($listSubTasks->tas_due_date[$i] <= $today && $listSubTasks->tas_completion[$i] != '10') {
                $duedateTxt = '<div class="overdue">' . createDate($listSubTasks->tas_due_date[$i],'date',false,true) . "</div>";
            } else {
                $duedateTxt = createDate($listSubTasks->tas_due_date[$i],'date',false,true);
            }

            if ($listSubTasks->tas_start_date[$i] != "0" && $listSubTasks->tas_due_date[$i] != "0") {
                $gantt = "true";
            }

            $content = array(
                $listSubTasks->tas_id[$i],
                $nameTxt,
                $priorityTxt,
                $statusTxt,
                $completionTxt,
                $duedateTxt
            );

            if ($listSubTasks->tas_milestone[$i] == enumMilestone::msYes) {
                $content[] = '';
            } else {
                $tmpquery = " AND res.task=" . $listSubTasks->tas_id[$i];
                $resourceUsage = new request();
                $resourceUsage->openTaskHumanResource($tmpquery);
                $comptResourceUsage = count($resourceUsage->res_id);

                if ($comptResourceUsage > 0) {
                    $assigned_to = array();

                    for ($j=0; $j<$comptResourceUsage; $j++) {
                        $assigned_to[] = implode(",", array(
                            $resourceUsage->res_resource[$j],
                            $resourceUsage->res_mem_extension_picture[$j],
                            $resourceUsage->res_mem_gender[$j]
                        ));
                    }

                    $content[] = $assigned_to;
                } else {
                    $content[] = '';
                }
            }

            if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
                $content[] = $statusPublish[$idPublish];
            }

            $block6->itemCardView($listSubTasks->tas_id[$i], $content);
        }

        $block6->closeCardView();
        $block6->bornesFooter('13', $blockPage->bornesNumber, "toggle_focus=subtasks&id=$id" . $urlBornes);
        $block6->closeToggle();
        $block6->closeFormResults();

        if ($comptListSubTasks > 0 && $activeJpgraph == "true" && $gantt == "true") {
            $showNext = '';
            $block6->headingToggle($strings['charts'], !($toggle_focus=='charts'));

            if ($gantt_sd != '') {
                echo "<a href='viewtask.php?toggle_focus=charts&amp;id=$id&amp;base=$base'>&lt;&lt;</a>&nbsp;";

                if ($base == '1') {
                    $gantt_sd_prev = mktime(0,0,0,intval(date('m',$gantt_sd))-5,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
                } else {
                    $gantt_sd_prev = mktime(0,0,0,intval(date('m',$gantt_sd))-1,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
                }
            }

            $tmpquery = "SELECT MIN(start_date),MAX(due_date) FROM " . $tablePrefix . "tasks WHERE parent_task='$id' AND start_date<>'0' AND due_date<>'0'";

            if ($gantt_sd != '') {
                if ($base == '1') {
                    $gantt_sd_next = mktime(0,0,0,intval(date('m',$gantt_sd))+5,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
                } else {
                    $gantt_sd_next = mktime(0,0,0,intval(date('m',$gantt_sd))+1,intval(date('d',$gantt_sd)),intval(date('Y',$gantt_sd)));
                }

                $tmpquery .= " AND due_date>='$gantt_sd_next'";
            }

            $boundaries = new request();
            $boundaries->connectClass();
            $boundaries->query($tmpquery);

            if ($boundaries->fetch()) {
                $start_date_b = ($row[0]);
                $due_date_b = ($row[1]);

                if ($gantt_sd == '') {
                    if ($base == '1') {
                        $gantt_sd_next = mktime(0,0,0,intval(date('m',$start_date_b))+5,intval(date('d',$start_date_b)),intval(date('Y',$start_date_b)));
                    } else {
                        $gantt_sd_next = mktime(0,0,0,intval(date('m',$start_date_b))+1,intval(date('d',$start_date_b)),intval(date('Y',$start_date_b)));
                    }

                    $gantt_sd = $start_date_b;
                } else {
                    if ($gantt_sd_prev < $start_date_b) {
                        echo "<a href='viewtask.php?toggle_focus=charts&amp;id=$id&amp;base=$base'>&lt;</a>&nbsp;";
                    } else {
                        echo "<a href='viewtask.php?toggle_focus=charts&amp;id=$id&amp;base=$base&amp;gantt_sd=$gantt_sd_prev'>&lt;</a>&nbsp;";
                    }
                }

                if ($gantt_sd_next <= $due_date_b) {
                    $showNext = 'true';

                    if ($base == '1') {
                        $gantt_sd_last = mktime(0,0,0,intval(date('m',$due_date_b))-5,intval(date('d',$due_date_b))+1,intval(date('Y',$due_date_b)));
                    } else {
                        $gantt_sd_last = mktime(0,0,0,intval(date('m',$due_date_b))-1,intval(date('d',$due_date_b))+1,intval(date('Y',$due_date_b)));
                    }
                }
            }

            // show the expanded or compact Gantt Chart
            if ($base == '1') {
                echo "<a href='viewtask.php?toggle_focus=charts&amp;id=$id&amp;base=0'>expand</a>";
            } else {
                echo "<a href='viewtask.php?toggle_focus=charts&amp;id=$id&amp;base=1'>compact</a>";
            }

            if ($showNext == 'true') {
                echo "&nbsp;<a href='viewtask.php?toggle_focus=charts&amp;id=$id&amp;base=$base&amp;gantt_sd=$gantt_sd_next'>&gt;</a>";
                echo "&nbsp;<a href='viewtask.php?toggle_focus=charts&amp;id=$id&amp;base=$base&amp;gantt_sd=$gantt_sd_last'>&gt;&gt;</a>";
            }

            if ($gantt_sd != '') {
                echo "<br><img src=\"graphtasks.php?project=$project&amp;parent_task=$id&amp;base=$base&amp;gantt_sd=$gantt_sd\" alt=\"\"><br><span class=\"listEvenBold\">" . $blockPage->buildLink("http://www.aditus.nu/jpgraph/", "JpGraph", 'powered') . "</span>";
            }

            $block6->closeToggle();
        }
    }

    /**
     * Task assignment history block
     */
    $block3 = new block();
    $block3->form = "vt3";
    $block3->openForm("../tasks/viewtask.php?id=$id" . $urlBornes . "#" . $block3->form . "Anchor");
    $block3->headingToggle(lang_strings("assignment_history"));
    $block3->sorting("assignment", (isset($sortingUser['assignment'])?$sortingUser['assignment']:''), "ass.assigned DESC", $sortingFields2 = array(0 => "ass.comments", 1 => "mem1.name", 2 => "mem2.name", 3 => "ass.assigned"));
    $querymore18 = " WHERE ass.task='$id' ORDER BY " . $block3->sortingValue;
    $listAssign = new request();
    $listAssign->openAssignments($querymore18);
    $comptListAssign = count($listAssign->ass_id);
    $labels = array(lang_strings("comment"), lang_strings("assigned_by"), lang_strings("to"), lang_strings("assigned_on"));
    $block3->openResults(false);
    $block3->labels($labels, "false");

    for ($i = 0;$i < $comptListAssign;$i++) {
        $block3->openRow();
        $ass_comm = $listAssign->ass_comments[$i];

        if ($ass_comm != "") {
            $block3->cellRow($ass_comm);
        } else if ($listAssign->ass_assigned_to[$i] == "0") {
            $block3->cellRow(lang_strings("task_unassigned"));
        } else {
            $block3->cellRow(lang_strings("task_assigned") . " " . $blockPage->buildLink($listAssign->ass_assigned_to[$i], '', 'message'));
        }

        $block3->cellRow($blockPage->buildLink($listAssign->ass_owner[$i], '', 'message'));

        if ($listAssign->ass_assigned_to[$i] == "0") {
            $block3->cellRow(lang_strings("unassigned"));
        } else {
            $block3->cellRow($blockPage->buildLink($listAssign->ass_assigned_to[$i], '', 'message'));
        }

        $block3->cellRow(createDate($listAssign->ass_assigned[$i], 'both'));
        $block3->closeRow();
    }

    $block3->closeResults();
    $block3->closeToggle();
    $block3->closeFormResults();

    if ($enableMaterial == 'true') {
        /**
         * Task material usage block
         */
        $block5 = new block();
        $block5->form = "vt5";
        $block5->openForm("../tasks/viewtask.php?id=$id" . $urlBornes . "#" . $block5->form . "Anchor");
        $block5->headingToggle(lang_strings("material_usage"), !($toggle_focus=='material_usage'));
        $block5->borne = $blockPage->returnBorne('12');
        $block5->rowsLimit = '12';
        $block5->sorting("task_material", (isset($sortingUser['task_material'])?$sortingUser['task_material']:''), "mat.name ASC", $sortingFields = array(0 => "mat.name", 1 => "mat.unit", 2 => "res.quantity"));
        $querymore20 = " AND res.task='$id' ORDER BY " . $block5->sortingValue;
        $block5->recordsTotal = compt($initrequest['tasks_material_resource'] . ' ' . $querymore20);
        $listMaterialResources = new request();
        $listMaterialResources->openTaskMaterialResource($querymore20, $block5->borne, $block5->rowsLimit);
        $comptListMaterialResources = count($listMaterialResources->res_id);
        $columns = array();
        $columns[0] = new cardviewColumn();
        $columns[0]->title = $strings['name'];
        $columns[0]->field_type = enumFieldType::ftNumeric;
        $columns[0]->linked_table = 'materials';
        $columns[1] = new cardviewColumn();
        $columns[1]->title = $strings['unit'];
        $columns[1]->field_type = enumFieldType::ftText;
        $columns[2] = new cardviewColumn();
        $columns[2]->title = $strings['quantity'];
        $columns[2]->field_type = enumFieldType::ftQuantity;
        $opt = array();
        $opt[enumCardviewOption::oObject] = 'material_usage';
        $opt[enumCardviewOption::oTableName] = 'tasks_resource';
        $opt[enumCardviewOption::oColumns] = $columns;
        $opt[enumCardviewOption::oExtraParameters] = 'project=' . $projectDetail->pro_id[0] . '&task=' . $id . $urlBornes . '&borne12=' . $block5->borne;

        if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
            if ($permissionDetail->prp_arrange_task_resource[0] == enumBoolean::bTrue) {
                $opt[enumCardviewOption::oAddUrl] = "../tasks/editmaterial.php?project=$project&task=$id" . $urlBornes;
            }
        }

        $block5->openCardView($opt);

        for ($i=0; $i<$comptListMaterialResources; $i++) {
            $content = array(
                $listMaterialResources->res_resource[$i],
                $listMaterialResources->res_mat_unit[$i],
                $listMaterialResources->res_quantity[$i]
            );
            $block5->itemCardView($listMaterialResources->res_id[$i], $content);
        }

        $block5->closeCardView();
        $block5->bornesFooter('12', $blockPage->bornesNumber, 'toggle_focus=material_usage&id=' . $id . $urlBornes);
        $block5->closeToggle();
        $block5->closeFormResults();
    }

    if ($enableEquipment == 'true') {
        /**
         * Task equipment usage block
         */
        $block7 = new block();
        $block7->form = "vt7";
        $block7->openForm("../tasks/viewtask.php?id=$id" . $urlBornes . "#" . $block7->form . "Anchor");
        $block7->headingToggle(lang_strings("equipment_usage"), !($toggle_focus=='equipment_usage'));
        $block7->borne = $blockPage->returnBorne('11');
        $block7->rowsLimit = '12';
        $block7->sorting("task_equipment", (isset($sortingUser['task_equipment'])?$sortingUser['task_equipment']:''), "equ.equipment_id ASC", $sortingFields = array(0 => "equ.equipment_id", 1 => "equ.equipment_category", 2 => "equ.equipment_type", 3 => "equ.name"));
        $querymore19 = " AND res.task='$id' ORDER BY " . $block7->sortingValue;
        $block7->recordsTotal = compt($initrequest['tasks_equipment_resource'] . ' ' . $querymore19);
        $listEquipmentResources = new request();
        $listEquipmentResources->openTaskEquipmentResource($querymore19, $block7->borne, $block7->rowsLimit);
        $comptListEquipmentResources = count($listEquipmentResources->res_id);
        $columns = array();
        $columns[0] = new cardviewColumn();
        $columns[0]->title = $strings['equipment_id'];
        $columns[0]->field_type = enumFieldType::ftNumeric;
        $columns[0]->linked_table = 'equipments';
        $columns[1] = new cardviewColumn();
        $columns[1]->title = $strings['equipment_category'];
        $columns[1]->field_type = enumFieldType::ftText;
        $columns[2] = new cardviewColumn();
        $columns[2]->title = $strings['equipment_type'];
        $columns[2]->field_type = enumFieldType::ftText;
        $columns[3] = new cardviewColumn();
        $columns[3]->title = $strings['name_print'];
        $columns[3]->field_type = enumFieldType::ftText;
        $opt = array();
        $opt[enumCardviewOption::oObject] = 'equipment_usage';
        $opt[enumCardviewOption::oTableName] = 'tasks_resource';
        $opt[enumCardviewOption::oColumns] = $columns;
        $opt[enumCardviewOption::oExtraParameters] = "project=$project&task=$id" . $urlBornes . '&borne11=' . $block7->borne;

        if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
            if ($permissionDetail->prp_arrange_task_resource[0] == enumBoolean::bTrue) {
                $opt[enumCardviewOption::oAddUrl] = "../tasks/addequipment.php?project=$project&task=$id" . $urlBornes;
            }
        }

        $block7->openCardView($opt);

        for ($i=0; $i<$comptListEquipmentResources; $i++) {
            $content = array(
                $listEquipmentResources->res_resource[$i],
                $listEquipmentResources->res_equ_eqc_name_print[$i],
                $listEquipmentResources->res_equ_eqt_name_print[$i],
                $listEquipmentResources->res_equ_name_print[$i]
            );
            $block7->itemCardView($listEquipmentResources->res_id[$i], $content);
        }

        $block7->closeCardView();
        $block7->bornesFooter('11', $blockPage->bornesNumber, 'toggle_focus=equipment_usage&id=' . $id . $urlBornes);
        $block7->closeToggle();
        $block7->closeFormResults();
    }
}

require_once("../includes/footer.php");
