<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addclientuser.php,v 1.16 2013/01/29 08:46:20 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$ids = "'" . str_replace('**', "','", $id) . "'";
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$action = isset($_GET['action'])?$_GET['action']:'';
$error = '';

/**
 * Permission check
 */
$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore2);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore3);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_add_team_member[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header("Location: ../projects/viewproject.php?id=$project&msg=permissiondenied&toggle_focus=team" . $urlBornes);
    exit;
}

/**
 * Actions
 */
if ($action == "add") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $pieces = explode("**", $id);

        if ($htaccessAuth == "true") {
            require_once("../includes/htpasswd.class.php");
            $Htpasswd = new Htpasswd;
            $Htpasswd->initialize("../files/" . $projectDetail->pro_id[0] . "/.htpasswd");
            $querymore = " WHERE mem.id IN ($ids)";
            $listMembers = clone $requestAct;
            $listMembers->openMembers($querymore);
            $comptListMembers = count($listMembers->mem_id);

            for ($i = 0;$i < $comptListMembers;$i++) {
                $Htpasswd->addUser($listMembers->mem_login[$i], $listMembers->mem_password[$i]);
            }
        }

        $comptTeam = count($pieces);

        for($i=0; $i<$comptTeam; $i++) {
            $tmpsql = "INSERT INTO " . $tablePrefix . "teams (project,member,published,authorized,created,cuser) VALUES ('$project','" . $pieces[$i] . "','" . enumPublished::pbYes . "','0','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('teams');
            copy2HistoryTable($requestAct, 'teams', $num, 'A');
        }

        if (!defined('INNER_NOTI_ADDPROJECTTEAM')) {
            define('INNER_NOTI_ADDPROJECTTEAM', 1);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        $id = "'" . implode("','", $pieces) . "'";
        require_once("../teams/noti_addprojectteam.php");
        header("Location: ../projects/viewservicesite.php?id=$project&msg=addClientToSite" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=team&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewservicesite.php?id=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("customer_service_site"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("grant_client"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "acU";
$block1->openForm("../teams/addclientuser.php?project=$project" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("add_team"));
$block1->openPaletteIcon();
$block1->paletteIcon(0, "add", $strings["add"]);
$block1->paletteIcon(1, "info", $strings["view"]);
$block1->paletteIcon(2, "edit", $strings["edit"]);
$block1->closePaletteIcon();
$block1->sorting("team", (isset($sortingUser['team'])?$sortingUser['team']:''), "mem.name ASC", $sortingFields = array(0 => "mem.name", 1 => "mem.title", 2 => "mem.login", 3 => "mem.phone_work", 4 => "log.connected"));
$querymore = " WHERE tea.project='$project' AND mem.organization<>'1'";
$concatMembers = new request();
$concatMembers->openTeams($querymore);
$comptConcatMembers = count($concatMembers->tea_project);
$queryBonus = "";

if ($comptConcatMembers > 0) {
    $membersTeam = "'" . implode("','", $concatMembers->tea_mem_id) . "'";
    $queryBonus = " AND mem.id NOT IN ($membersTeam)";
}

$querymore = " WHERE mem.organization='" . $projectDetail->pro_organization[0] . "' $queryBonus AND mem.organization<>'1' AND mem.active='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
$listMembers = new request();
$listMembers->openMembers($querymore);
$comptListMembers = count($listMembers->mem_id);

if ($comptListMembers > 0) {
    $labels = array(lang_strings("full_name"), lang_strings("title"), lang_strings("user_name"), lang_strings("work_phone"), lang_strings("connected"));
    $block1->openResults();
    $block1->labels($labels, "false");

    for ($i = 0;$i < $comptListMembers;$i++) {
        $block1->openRow($listMembers->mem_id[$i]);
        $block1->cellRow($blockPage->buildLink($listMembers->mem_id[$i], '', 'message'));
        $block1->cellRow($listMembers->mem_title[$i]);
        $block1->cellRow($blockPage->buildLink($listMembers->mem_email_work[$i], $listMembers->mem_login[$i], 'mail'));
        $block1->cellRow($listMembers->mem_phone_work[$i]);

        if ($listMembers->mem_log_connected[$i] > date('U')-5 * 60) {
            $block1->cellRow(lang_strings("yes") . " " . (($listMembers->mem_organization[$i]!='1')?"(" . lang_strings('client_on_customer_service_site') . ")":''));
        } else {
            $block1->cellRow(lang_strings("no"));
        }

        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeFormResults();
$block1->openPaletteScript();
$block1->paletteScript(0, "add", "../teams/addclientuser.php?project=$project&action=add" . $urlBornes, "false,true,true", $strings["add"]);
$block1->paletteScript(1, "info", "../users/viewuser.php?" . $urlBornes, "false,true,false", $strings["view"]);
$block1->paletteScript(2, "edit", "../users/updateclientuser.php?organization=" . $projectDetail->pro_organization[0] . $urlBornes, "false,true,false", $strings["edit"]);
$block1->closePaletteScript($comptListMembers, $listMembers->mem_id);
require_once("../includes/footer.php");
