<?php // $Revision: 1.17 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteclientusers.php,v 1.17 2013/01/29 08:46:20 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";

/**
 * Permission check
 */
$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore2);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore3);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_delete_team_member[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header("Location: ../projects/viewproject.php?id=$project&msg=permissiondenied&toggle_focus=team" . $urlBornes);
    exit;
}

$tmpquery1 = "SELECT project FROM " . $tablePrefix . "teams WHERE id IN ($ids) AND project<>'$project'";

if (compt($tmpquery1) > 0) {
    header("Location: ../teams/listusers.php?project=$project&msg=permissiondenied" . $urlBornes);
    exit;
}

/**
 * Load data
 */
$querymore4 = " WHERE tea.id IN ($ids) ORDER BY mem.name";
$listTeams = new request();
$listTeams->openTeams($querymore4);
$comptListTeams = count($listTeams->tea_id);

/**
 * Action
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($htaccessAuth == "true") {
            require_once("../includes/htpasswd.class.php");
            $Htpasswd = new Htpasswd;
            $Htpasswd->initialize("../files/" . $projectDetail->pro_id[0] . "/.htpasswd");

            for ($i=0; $i<$comptListTeams; $i++) {
                $Htpasswd->deleteUser($listTeams->tea_mem_login[$i]);
            }
        }

        for ($i=0; $i<$comptListTeams; $i++) {
            copy2HistoryTable($requestAct, 'teams', $listTeams->tea_id[$i], 'D');
            $tmpsql = "DELETE FROM " . $tablePrefix . "teams WHERE member='" . $listTeams->tea_id[$i] . "'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if (!defined('INNER_NOTI_DELPROJECTTEAM')) {
            define('INNER_NOTI_DELPROJECTTEAM', 1);
        }

        $id = "'" . implode("','", $pieces) . "'";
        require_once("../teams/noti_removeprojectteam.php");
        header("Location: ../projects/viewservicesite.php?id=$project&msg=removeClientToSite" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=team&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewservicesite.php?id=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("customer_service_site"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("remove_team_client"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "dcU";
$block1->openForm("../teams/deleteclientusers.php?project=$project&amp;id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
echo '<input type="hidden" name="action" value="delete">';
$block1->heading(lang_strings("remove_team_client"));
$block1->openContent();
$block1->contentTitle(lang_strings("remove_team_info"));

for ($i=0; $i<$comptListTeams; $i++) {
    $block1->contentRow("#" . $listTeams->tea_mem_id[$i], $listTeams->tea_mem_name[$i]);
}

$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["delete"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
