<?php // $Revision: 1.10 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: joinprojectteam.php,v 1.10 2013/01/29 08:46:20 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$d = isset($_POST['d'])?$_POST['d']:'';

/**
 * Permission check
 */
$querymore = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectsFilter == 'true' && !$SW_Permissions['Project']['Admin'][$profilSession]) {
    header("Location: ../project/listprojects.php?msg=permissiondenied" . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header("Location: ../project/listprojects.php?msg=permissiondenied" . $urlBornes);
    exit;
}

/**
 * Actions
 */
if ($action == "submit") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        // replace quotes by html code in comments
        $d = HtmlEntitiesNOD($d);
        $querymore = " WHERE tea.project='$project' AND tea.member='$idSession'";
        $teamDetail = new request();
        $teamDetail->openTeams($querymore);
        $comptTeamDetail = count($teamDetail->tea_project);

        if ($comptTeamDetail == 0) {
            $tmpsql = "INSERT INTO " . $tablePrefix . "teams (project,member,published,authorized,profil,comments,created,cuser) VALUES ('$project','$idSession','" . enumPublished::pbNo . "','" . enumBoolean::bFalse . "','" . enumProjectProfile::ppGuest . "','$d','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('teams');
            copy2HistoryTable($requestAct, 'teams', $num, 'A');
        } else {
            $tmpsql = "UPDATE " . $tablePrefix . "teams SET comments='$d',modified='" . time() . "',muser='$idSession' WHERE id='" . $teamDetail->tea_id[0] . "'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'teams', $teamDetail->tea_id[0], 'U');
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if (!defined('INNER_NOTI_JOINPROJECT')) {
            define('INNER_NOTI_JOINPROJECT', 1);
        }

        require_once("../teams/noti_joinprojectteam.php");
        header("Location: ../projects/listprojects.php?msg=addToSubmitted" . $urlBornes);
        exit;
    }
}

/**
 * Prepare data
 */
if ($error == '') {
    $querymore = " WHERE tea.project='$project' AND member='$idSession'";
    $teamDetail = new request();
    $teamDetail->openTeams($querymore);
    $comptTeamDetail = count($teamDetail->tea_project);

    if ($comptTeamDetail == 0) {
        $d = '';
    } else {
        $d = $teamDetail->tea_comments[0];
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("join_project"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "joP";
$block1->openForm("../teams/joinprojectteam.php?project=$project" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="submit">';
$block1->heading(lang_strings("join_project"));
$block1->openContent();
$block1->contentTitle(lang_strings("join_project_info"));
$block1->contentRow(lang_strings("project"), $projectDetail->pro_name[0]);
$block1->contentRow(lang_strings("owner"), $blockPage->buildLink($projectDetail->pro_mem_id[0], '', 'message'));
setupInputHTML($block1, lang_strings('join_reason'), 'd', enumFieldType::ftMemo, 'Y', '0', $d, '', '');
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["submit"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
