<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: updateusers.php,v 1.9 2013/01/29 08:46:20 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'0');
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$role = isset($_POST['role'])?$_POST['role']:'';
$service = isset($_POST['service'])?$_POST['service']:'';
$error = '';

/**
 * Permission check
 */
$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=team' . $urlBornes);
    exit;
}

$querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore2);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore3);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_modify_team_member_properties[0] != enumBoolean::bTrue) {
    header("Location: ../teams/listusers.php?project=$project&msg=permissiondenied" . $urlBornes);
    exit;
}

$ids = "'" . str_replace("**", "','", $id) . "'";
$querymore4 = " WHERE tea.project='$project' AND tea.id IN ($ids)";
$listTeams = new request();
$listTeams->openTeams($querymore4);
$comptListTeams = count($listTeams->tea_project);

if ($role != '' && in_array(enumProjectProfile::ppLeader, $listTeams->tea_profil)) {
    header("Location: ../teams/listusers.php?project=$project&msg=permissiondenied" . $urlBornes);
    exit;
}

/**
 * Action
 */
if ($action == "update" && ($role != '' || $service != '')) {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "UPDATE " . $tablePrefix . "teams SET modified='" . time() . "',muser='$idSession'";

        if ($role != '') {
            $tmpsql .= ",profil='$role'";
        }

        if ($service != '') {
            $tmpsql .= ",service='$service'";
        }

        $tmpsql .= " WHERE project=$project AND id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'teams', $ids, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($role != '') {
            if (!defined('INNER_NOTI_USERROLECHG')) {
                define('INNER_NOTI_USERROLECHG', 1);
            }

            require_once("../teams/noti_usersrolechanged.php");
        }

        header("Location: ../teams/listusers.php?project=$project&msg=update" . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=team&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../teams/listusers.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("team_members"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("edit_teammembers"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "crM";
$block1->openForm("../teams/updateusers.php?project=$project&id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="update">';
$block1->heading(lang_strings("edit_teammembers"));
$block1->openContent();
$block1->contentTitle(lang_strings("team_members"));

for ($i=0; $i<$comptListTeams; $i++) {
    $block1->contentRow('', $blockPage->buildLink($listTeams->tea_member[$i], '', 'message'));
}

$block1->contentTitle(lang_strings("details"));

if (!in_array(enumProjectProfile::ppLeader, $listTeams->tea_profil)) {
    $roleSel = '<select name="role"><option value="">' . $strings['no_change'] . '</option>';

    foreach ($projectRoles as $key => $val) {
        if (($key == enumProjectProfile::ppLeader) || ($key == enumProjectProfile::ppGuest)) {
            continue;
        }

        $roleSel .= '<option value="' . $key . '">' . $val . '</option>';
    }

    $roleSel .= '</select>';
    $block1->contentRow(lang_strings('user_role'), $roleSel);
}

if ($projectDetail->pro_currency[0] != '') {
    $querymore = " WHERE serv.currency='" . $projectDetail->pro_currency[0] . "' AND serv.locked='" . enumBoolean::bFalse . "' ORDER BY serv.name";
} else {
    $querymore = " WHERE serv.locked='" . enumBoolean::bFalse . "' ORDER BY serv.name";
}

$listServices = new request();
$listServices->openServices($querymore);
$comptListServices = count($listServices->serv_id);
$serviceSel = '<select name="service"><option value="">' . $strings['no_change'] . '</option><option value="0">' . $strings['none'] . '</option>';

for ($i=0; $i<$comptListServices; $i++) {
    if ($listServices->serv_id[$i] == $taskDetail->tas_service[0]) {
        $serviceSel .= "<option value='" . $listServices->serv_id[$i] . "' selected>" . $listServices->serv_name_print[$i] . '</option>';
    } else {
        $serviceSel .= "<option value='" . $listServices->serv_id[$i] . "'>" . $listServices->serv_name_print[$i] . '</option>';
    }
}

$serviceSel .= '</select>';
$block1->contentRow(lang_strings("default_service"), $serviceSel);
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["update"] . "\">&#160;<input type=\"BUTTON\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
