<?php // $Revision: 1.39 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editmeetingtime.php,v 1.39 2013/02/09 06:37:06 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$fyear = isset($_GET['fyear'])?$_GET['fyear']:'';
$serialno = isset($_GET['serialno'])?$_GET['serialno']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$commO = isset($_POST['commO'])?$_POST['commO']:'';
$prj = isset($_POST['prj'])?$_POST['prj']:'0';
$mee = isset($_POST['mee'])?$_POST['mee']:'0';
$hours = isset($_POST['hours'])?$_POST['hours']:'';
$error = '';

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
    $date_start_period = mktime(0, 0, 0, intval($serialno), 1, intval($fyear));
    $date_end_period = mktime(0, 0, 0, intval($serialno)+1, 0, intval($fyear));
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    $daysOfWeek = getDaysOfWeek($fyear, $serialno);
    $date_start_period = $daysOfWeek[0];
    $date_end_period = $daysOfWeek[6];
}

/**
 * Permission check
 */
$querymore0 = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore0);
$querymore1 = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.year='$fyear' AND wcd.date>='$date_start_period' AND wcd.date<='$date_end_period' ORDER BY wcd.date";
$listWorkCalendarsDetail = new request();
$listWorkCalendarsDetail->openWorkCalendarsDetail($querymore1);
$comptListWorkCalendarsDetail = count($listWorkCalendarsDetail->wcd_id);

if ($comptListWorkCalendarsDetail == '0') {
    header("Location: ../general/home.php?msg=noWorkCalendar");
    exit;
}

if (periodLocked($date_start_period)) {
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=periodLocked&toggle_focus=logtime");
    exit;
}

$listTimesheetId = array();
$querymore2 = " WHERE tim.owner='$idSession' AND per.fyear='$fyear' AND per.serial_no='$serialno'";
$listTimesheet = new request();
$listTimesheet->openTimesheet($querymore2);
$comptListTimesheet = count($listTimesheet->tim_owner);
$timesheetReadOnly = false;

for ($i=0; $i<$comptListTimesheet; $i++) {
    if ($listTimesheet->tim_status[$i] == enumFileStatus::stNeedsApproval) {
        $timesheetReadOnly = true;
        break;
    } else if ($listTimesheet->tim_status[$i] == enumFileStatus::stNoApprovalsNeeded || $listTimesheet->tim_status[$i] == enumFileStatus::stApproved) {
        $listTimesheetId[] = $listTimesheet->tim_id[$i];
    }
}

if ($timesheetReadOnly) {
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=permissiondenied&toggle_focus=logtime");
    exit;
}

if ($id != "") {
    $querymore3 = " WHERE mti.id='$id'";
    $meetingTimeDetail = new request();
    $meetingTimeDetail->openMeetingTime($querymore3);

    if ($meetingTimeDetail->mti_owner[0] != $idSession) {
        header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=permissiondenied&toggle_focus=logtime");
        exit;
    }

    $prj = $meetingTimeDetail->mti_project[0];
    $mee = $meetingTimeDetail->mti_meeting[0];
}

if ($mee != '' && $mee != '0') {
    $querymore4 = " WHERE mee.id='$mee'";
    $meetingDetail = new request();
    $meetingDetail->openMeetings($querymore4);
    $comptMeetingDetail = count($meetingDetail->mee_id);

    if ($comptMeetingDetail == '0') {
        header('Location: ../general/permissiondenied.php');
        exit;
    }

    if ($meetingDetail->mee_project[0] != '0') {    // check if project canceled, completed, suspended or in the middle of approval procedure
        $querymore5 = " WHERE pro.id='" . $meetingDetail->mee_project[0] . "'";
        $projectDetail = new request();
        $projectDetail->openProjects($querymore5);

        if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
            header('Location: ../timesheet/viewtimesheet.php?msg=permissiondenied&toggle_focus=logtime');
            exit;
        }
    }

    $st = $meetingDetail->mee_start_time[0];
    $dat = mktime(0, 0, 0, date('n', $st), date('j', $st), date('Y', $st));
}

/**
 * Actions
 */
if ($action != '') {
    $comm = HtmlEntitiesNOD($comm);
    $commO = HtmlEntitiesNOD($commO);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($action == 'update') {  // remove old meeting time
            $tmpsql = "DELETE FROM " . $tablePrefix . "meetings_time WHERE project='$prj' AND meeting='$mee' AND owner='$idSession' AND date='$dat' AND comments='$commO'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            if ($resetTimesheet != '') {
                $tmpsql = "UPDATE " . $tablePrefix . "timesheet SET status='" . enumFileStatus::stApprovedWithChanges . "',modified='" . time() . "',muser='$idSession' WHERE id='$resetTimesheet'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        $hours = round($hours, $hourAccuracy);
        $tmpsql = "INSERT INTO " . $tablePrefix . "meetings_time (project,meeting,owner,date,hours,comments,created,cuser) VALUES ('$prj','$mee','$idSession','$dat','$hours','$comm','" . time() . "','$idSession')";    // add new meeting time

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($action == 'update') {
            header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=update&toggle_focus=logtime");
        } else {
            header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=add&toggle_focus=logtime");
        }

        exit;
    }
}

/**
 * Prepare data
 */
if ($error == '') {
    if ($id != '') {
        $comm = $meetingTimeDetail->mti_comments[0];
        $querymore6 = " WHERE mti.project='$prj' AND mti.meeting='$mee' AND mti.owner='$idSession' AND mti.date='" . $meetingTimeDetail->mti_date[0] . "' AND mti.comments='" . HtmlEntitiesNOD($comm) . "'";
        $listMeetingTime = new request();
        $listMeetingTime->openMeetingTime($querymore6);
        $comptListMeetingTime = count($listMeetingTime->mti_id);
        $hours = 0;

        if ($comptListMeetingTime > 0) {
            foreach ($listMeetingTime->mti_hours as $h) {
                $hours += $h;
            }
        }
    } else {
        $comm = '';
        $hours = '';
    }
}

if ($id == '' && $prj != '') {
    $querymore7 = " WHERE mee.project='$prj' AND att.member='$idSession' AND mee.start_time>='$date_start_period' AND mee.start_time<'" . addDays($date_end_period, 1) . "' AND mee.status IN ('" . enumMeetingStatus::stCompleted . "','" . enumMeetingStatus::stOpen . "','" . enumMeetingStatus::stScheduled . "') ORDER BY mee.name";
    $listMeeAttendees = new request();
    $listMeeAttendees->openAttendees($querymore7);
    $comptListMeeAttendees = count($listMeeAttendees->att_meeting);
}

/**
 * Html
 */
require_once("../includes/header.php");
echo '<script type="text/javascript" src="../javascript/editmeetingtime' . $scriptMinimized . '.js"></script>';
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../timesheet/viewtimesheet.php?toggle_focus=logtime', lang_strings('timesheet'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;toggle_focus=logtime", "$serialname $fyear", 'in'));

if ($id != "") {  // edit meeting time
    $blockPage->itemBreadcrumbs(lang_strings('edit_meeting_time'));
} else { // add meeting time
    $blockPage->itemBreadcrumbs(lang_strings('add_meeting_time'));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "em1";
$block1->openForm("../timesheet/editmeetingtime.php?fyear=$fyear&amp;serialno=$serialno&amp;section=workhour&amp;id=$id#" . $block1->form . "Anchor", 'return checkFormData(this);');

if ($id != "") {  // edit meeting time
    $block1->heading(lang_strings('edit_meeting_time'));
    echo '<input type="hidden" name="action" value="update">';
} else { // add meeting time
    $block1->heading(lang_strings('add_meeting_time'));
    echo '<input type="hidden" name="action" value="add">';
}

echo '<input type="hidden" id="dateStartPeriod" value="' . $date_start_period . '">';
echo '<input type="hidden" id="dateEndPeriod" value="' . $date_end_period . '">';
$block1->openContent();
$block1->contentTitle(lang_strings('details'));

if ($id != '') {
    if ($prj != '0') {
        $block1->contentRow(lang_strings("project"), $projectDetail->pro_name[0]);
    }

    $block1->contentRow(lang_strings("meeting"), $meetingDetail->mee_name[0]);
    echo "<input name=\"prj\" type=\"hidden\" value=\"" . $meetingTimeDetail->mti_project[0] . "\">";
    echo "<input name=\"mee\" type=\"hidden\" value=\"" . $meetingTimeDetail->mti_meeting[0] . "\">";
    echo "<input name=\"commO\" type=\"hidden\" value=\"" . str_replace('"', '&quot;', $meetingTimeDetail->mti_comments[0]) ."\">";
    $block1->contentRow(lang_strings("start_time"), createDate($meetingDetail->mee_start_time[0], 'both'));
    $block1->contentRow(lang_strings("duration"), NumberFormatNOD($meetingDetail->mee_duration[0], $hourAccuracy, false) . ' ' . lang_strings('hours'));
} else {
    // project
    $tmpquery = "SELECT pro.status FROM " . $tablePrefix . "teams tea INNER JOIN " . $tablePrefix . "projects pro ON pro.id=tea.project LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member='$idSession' AND prp.log_meeting_hours='" . enumBoolean::bTrue . "' GROUP BY pro.status";
    $listProjectStatus = new request();
    $listProjectStatus->connectClass();
    $listProjectStatus->query($tmpquery);
    $listProjectStatus->pro_status = array();

    while ($listProjectStatus->fetch()) {
        $listProjectStatus->pro_status[] = ($row[0]);
    }

    $listProjectStatus->close();
    $projectSel = '<select id="prj" name="prj" onchange="getMeetingList()"><option value=""></option>';

    if (count($listProjectStatus->pro_status) > 0) {
        foreach ($listProjectStatus->pro_status as $st) {
            $querymore = " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member='$idSession' AND prp.log_meeting_hours='" . enumBoolean::bTrue . "' AND pro.status='$st' ORDER BY pro.name";
            $listProjects = new request();
            $listProjects->openTeams($querymore);
            $comptListProjects = count($listProjects->tea_project);
            $projectSel .= '<optgroup label="' . $statusProject[$st] . '">';

            for ($i=0; $i<$comptListProjects; $i++) {
                $selected = (($listProjects->tea_project[$i]==$prj)?'selected':'');
                $projectSel .= "<option value=\"" . $listProjects->tea_project[$i] . "\" $selected>" . $listProjects->tea_pro_name[$i] . "</option>";
            }

            $projectSel .= '</optgroup>';
        }
    }

    $projectSel .= '</select><strong id="prjS"></strong>';
    $block1->contentRow('* ' . lang_strings("project"), $projectSel);
    $__default_requireda[] = 'prj';
    $__default_reqtypea[] = enumFieldType::ftAlphaNumeric;
    // meeting
    $meeSel = '<select id="mee" name="mee" onchange="getMeetingInfo()">';

    for ($i=0; $i<$comptListMeeAttendees; $i++) {
        if ($listMeeAttendees->att_meeting[$i] == $mee) {
            $meeSel .= '<option value="' . $listMeeAttendees->att_meeting[$i] . '" selected>' . $listMeeAttendees->att_mee_name[$i] . '</option>';
        } else {
            $meeSel .= '<option value="' . $listMeeAttendees->att_meeting[$i] . '">' . $listMeeAttendees->att_mee_name[$i] . '</option>';
        }
    }

    $meeSel .= '</select><strong id="meeS"></strong>';
    $block1->contentRow('* ' . lang_strings("meeting"), $meeSel);
    $__default_requireda[] = 'mee';
    $__default_reqtypea[] = enumFieldType::ftAlphaNumeric;
    // meeting start time
    $block1->contentRow(lang_strings("start_time"), '<div id="startTime"></div>');
    // meeting duration
    $block1->contentRow(lang_strings("duration"), '<div id="duration"></div>');
}

setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
setupInputHTML($block1, lang_strings('work_hours'), 'hours', array(enumFieldType::ftHours, enumFieldOption::foPositiveNumber), 'Y', '0', $hours);
$block1->contentRow('', '<input type="SUBMIT" value="' . $strings["save"] . '">');
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
