<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editmeetingtime_serv.php,v 1.3 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

// check if the request is an AJAX request
if (!is_ajax()) {
    exit;
}

/**
 * Variables init
 */
$action = AddSlashesNOD(isset($_POST['action'])?$_POST['action']:'');   // action

if ($action == '') {
    exit;
}

switch ($action) {
    case 'meetingList':
        /**
         * get meeting list
         */
        $prj = AddSlashesNOD(isset($_POST['project'])?$_POST['project']:'');                    // project id
        $date_start_period = AddSlashesNOD(isset($_POST['dateStart'])?$_POST['dateStart']:'');  // period start date
        $date_end_period = AddSlashesNOD(isset($_POST['dateEnd'])?$_POST['dateEnd']:'');        // period end date
        
        if ($prj == '') {
            $prj = '0';
        }
        
        $querymore = " WHERE mee.project='$prj' AND att.member='$idSession' AND mee.start_time>='$date_start_period' AND mee.start_time<'" . addDays($date_end_period, 1) . "' AND mee.status IN ('" . enumMeetingStatus::stCompleted . "','" . enumMeetingStatus::stOpen . "','" . enumMeetingStatus::stScheduled . "') ORDER BY mee.name";
        $listMeeAttendees = new request();
        $listMeeAttendees->openAttendees($querymore);
        $comptListMeeAttendees = count($listMeeAttendees->att_meeting);
        $options = array();
        $meeting = '';
        $startTime = '';
        $duration = '';
        
        if ($comptListMeeAttendees > 0) {
            $meeting = $listMeeAttendees->att_meeting[0];
            $startTime = createDate($listMeeAttendees->att_mee_start_time[0], 'both');
            $duration = NumberFormatNOD($listMeeAttendees->att_mee_duration[0], $hourAccuracy, false) . ' ' . $strings['hours'];

            for ($i=0; $i<$comptListMeeAttendees; $i++) {
                $options[$listMeeAttendees->att_meeting[$i]] = $listMeeAttendees->att_mee_name[$i];
            }
        }
        
        header("content-type:application/json");
        echo json_encode(array(
            'options' => $options,
            'meeting' => $meeting,
            'startTime' => $startTime,
            'duration' => $duration
        ));
        break;
    case 'meetingInfo':
        /**
         * get meeting start time & duration
         */
        $mee = AddSlashesNOD(isset($_POST['meeting'])?$_POST['meeting']:'');    // meeting id
        
        if ($mee == '') {
            $mee = '0';
        }
        
        $querymore = " WHERE mee.id='$mee'";
        $meetingDetail = new request();
        $meetingDetail->openMeetings($querymore);
        $comptMeetingDetail = count($meetingDetail->mee_id);
        $startTime = '';
        $duration = '';
        
        if ($comptMeetingDetail > 0) {
            $startTime = createDate($meetingDetail->mee_start_time[0], 'both');
            $duration = NumberFormatNOD($meetingDetail->mee_duration[0], $hourAccuracy, false) . ' ' . $strings['hours'];
        }
        
        header("content-type:application/json");
        echo json_encode(array(
            'startTime' => $startTime,
            'duration' => $duration
        ));
        break;
    case 'checkFormData':
        /**
         * check form data
         */
        $hours = AddSlashesNOD(isset($_POST['hours'])?$_POST['hours']:'');  // hours
        $error = '';
        
        if (is_numeric($hours) && $hours > 24) {
            $error = $strings['value_deviate'];
        }
        
        header("content-type:application/json");
        echo json_encode(array(
            'error' => $error
        ));
        break;
}
