<?php // $Revision: 1.46 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: edittasktime.php,v 1.46 2013/02/09 06:37:05 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$fyear = isset($_GET['fyear'])?$_GET['fyear']:'';
$serialno = isset($_GET['serialno'])?$_GET['serialno']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$commO = isset($_POST['commO'])?$_POST['commO']:'';
$prj = isset($_POST['prj'])?$_POST['prj']:'';
$tas = isset($_POST['tas'])?$_POST['tas']:'';
$serv = isset($_POST['serv'])?$_POST['serv']:'';
$servO = isset($_POST['servO'])?$_POST['servO']:'';
$ooy = isset($_POST['ooy'])?$_POST['ooy']:'Y';
$bodyCommand = "onLoad=\"document.et1Form.prj.focus();\"";
$hoursTtl = 0;
$logHours = array();
$svcDisabled = false;
$error = '';
$errorDays = array();

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
    $date_start_period = mktime(0, 0, 0, intval($serialno), 1, intval($fyear));
    $date_end_period = mktime(0, 0, 0, intval($serialno)+1, 0, intval($fyear));
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    $daysOfWeek = getDaysOfWeek($fyear, $serialno);
    $date_start_period = $daysOfWeek[0];
    $date_end_period = $daysOfWeek[6];
}

/**
 * Permission check
 */
$querymore0 = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore0);
$querymore = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.year='$fyear' AND wcd.date>='$date_start_period' AND wcd.date<='$date_end_period' ORDER BY wcd.date";
$listWorkCalendarsDetail = new request();
$listWorkCalendarsDetail->openWorkCalendarsDetail($querymore);
$comptListWorkCalendarsDetail = count($listWorkCalendarsDetail->wcd_id);

if ($comptListWorkCalendarsDetail == '0') {
    header("Location: ../general/home.php?msg=noWorkCalendar");
    exit;
} else {
    for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
        $logHours[$idx] = 0;
    }
}

if ($id != "") {
    $querymore = " WHERE tim.id='$id'";
    $taskTimeDetail = new request();
    $taskTimeDetail->openTaskTime($querymore);

    if ($taskTimeDetail->tim_owner[0] != $idSession) {
        header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=permissiondenied&toggle_focus=logtime");
        exit;
    }

    $prj = $taskTimeDetail->tim_project[0];
    $tas = $taskTimeDetail->tim_task[0];
}

if ($prj != '' && $prj != '0' && ($id != '' || $action != '')) {
    $querymore = " WHERE pro.id='$prj'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {                 // Project not found
        header('Location: ../timesheet/viewtimesheet.php?msg=blankProject&toggle_focus=logtime');
        exit;
    }

    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../timesheet/viewtimesheet.php?msg=permissiondenied&toggle_focus=logtime');
        exit;
    }
}

if (periodLocked($date_start_period)) {
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=periodLocked&toggle_focus=logtime");
    exit;
}

$listTimesheetId = array();
$querymore = " WHERE tim.owner='$idSession' AND per.fyear='$fyear' AND per.serial_no='$serialno'";
$listTimesheet = new request();
$listTimesheet->openTimesheet($querymore);
$comptListTimesheet = count($listTimesheet->tim_owner);
$timesheetReadOnly = false;

for ($i=0; $i<$comptListTimesheet; $i++) {
    if ($listTimesheet->tim_status[$i] == enumFileStatus::stNeedsApproval) {
        $timesheetReadOnly = true;
        break;
    } else if ($listTimesheet->tim_status[$i] == enumFileStatus::stNoApprovalsNeeded || $listTimesheet->tim_status[$i] == enumFileStatus::stApproved) {
        $listTimesheetId[] = $listTimesheet->tim_id[$i];
    }
}

if ($timesheetReadOnly) {
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=permissiondenied&toggle_focus=logtime");
    exit;
}

/**
 * Fields check
 */
if ($action != '') {
    $comm = HtmlEntitiesNOD($comm);
    $commO = HtmlEntitiesNOD($commO);

    // make sure we have the required information
    if ($prj == '' || $prj == '0') {    // check project
        $error = lang_strings('project') . '&nbsp;' . lang_strings('error_required');
    } else if ($tas == '' || $tas == '0') { // check task
        $error = lang_strings('task') . '&nbsp;' . lang_strings('error_required');
    } else {
        for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
            $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
            $x = trim(isset($_POST['h' . $idx])?$_POST['h' . $idx]:'');

            if ($x != '') {
                if (is_numeric($x) && floatval($x) >= 0) {
                    $logHours[$idx] = round(floatval($x), $hourAccuracy);
                    $hoursTtl += $logHours[$idx];
                } else {
                    $error = lang_strings('worked_hours') . '&nbsp;' . lang_strings('error_numerical');
                    $errorDays[] = $idx;
                }
            }
        }

        if ($error == '' && $hoursTtl == 0) {
            $error = lang_strings('worked_hours') . '&nbsp;' . lang_strings('error_required');
        }
    }
}

/**
 * Actions
 */
if ($action != '' && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($action == 'update') {  // remove old tasks time first
            $tmpsql = "DELETE FROM " . $tablePrefix . "tasks_time WHERE project='$prj' AND task='$tas' AND owner='$idSession' AND date>='$date_start_period' AND date<='$date_end_period' AND comments='$commO' AND service=$servO";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $bf = ($serv == '0')?enumBoolean::bFalse:enumBoolean::bTrue;

        for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
            $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);

            if ($logHours[$idx] > 0) {    // add new task hours
                $tmpsql = "INSERT INTO " . $tablePrefix . "tasks_time (project,task,owner,date,hours,comments,billing,service,created,cuser) VALUES ('$prj','$tas','$idSession','" . $listWorkCalendarsDetail->wcd_date[$i] . "','" . $logHours[$idx] . "','$comm','$bf','$serv','" . time() . "','$idSession')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        // check if log hours > 24 in each day
        $tmpquery = "SELECT B.date,B.hours FROM (SELECT A.date,SUM(A.hours) AS hours FROM (SELECT tim.date,tim.hours FROM " . $tablePrefix . "tasks_time tim WHERE tim.owner='$idSession' AND tim.date>='$date_start_period' AND tim.date<='$date_end_period' UNION ALL SELECT mti.date,mti.hours FROM " . $tablePrefix . "meetings_time mti WHERE mti.owner='$idSession' AND mti.date>='$date_start_period' AND mti.date<='$date_end_period' UNION ALL SELECT wkh.date,wkh.hours FROM " . $tablePrefix . "work_hours wkh WHERE wkh.owner='$idSession' AND wkh.date>='$date_start_period' AND wkh.date<='$date_end_period') A GROUP BY A.date) B WHERE B.hours>24";
        $requestAct->query($tmpquery);

        if ($requestAct->rowCount() > 0) {
            while ($requestAct->fetch()) {
                $idx = date('Ymd', $row[0]);
                $errorDays[] = $idx;
            }

            $error = lang_strings('worked_hours') . '&nbsp;' . lang_strings('error_hours');
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        } else {
            if (count($listTimesheetId) > 0) {
                foreach ($listTimesheetId as $tid) {     // update timesheet status
                    $tmpsql = "UPDATE " . $tablePrefix . "timesheet SET status='" . enumFileStatus::stApprovedWithChanges . "',modified='" . time() . "',muser='$idSession' WHERE id=$tid";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        }
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($action == 'update') {
            header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=update&toggle_focus=logtime");
        } else {
            header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=add&toggle_focus=logtime");
        }

        exit;
    }
}

/**
 * Prepare data
 */
$querymore = " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member='$idSession' AND prp.log_task_hours='" . enumBoolean::bTrue . "'";

if ($ooy == 'Y') {
    $querymore .= " AND pro.status='" . enumProjectStatus::stOpen . "' ORDER BY pro.name";
} else {
    $querymore .= " ORDER BY pro.name";
}

$listProjects = new request();
$listProjects->openTeams($querymore);
$comptListProjects = count($listProjects->tea_project);
// get member actual log hours of days
$memberActualHours = new request();
$memberActualHours->getMemberTimeOfDays($idSession, $date_start_period, $date_end_period);

if ($prj == '' && $comptListProjects > 0) {
    $prj = $listProjects->tea_project[0];
}

if ($prj != '') {
    $querymore1 = " WHERE pro.id='$prj'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore1);
    $querymore2 = " AND res.resource='$idSession' AND tas.project='$prj' ORDER BY tas.name";
    $listTasks = new request();
    $listTasks->openTaskHumanResource($querymore2);
    $comptListTasks = count($listTasks->res_id);
    $querymore = " WHERE tea.project='$prj' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore);
} else {
    $comptListTasks = 0;
}

if ($tas == '' && $comptListTasks > 0) {
    $tas = $listTasks->res_task[0];
} else if ($tas != '' && $comptListTasks == 0) {
    $tas = '';
}

if ($tas != '') {
    $querymore = " WHERE tas.id='$tas'";
    $taskDetail = new request();
    $taskDetail->openTasks($querymore);
}

if ($error == '' && $id != '') {
    $comm = $taskTimeDetail->tim_comments[0];
    $serv = $taskTimeDetail->tim_service[0];
    $querymore = " WHERE tim.project='$prj' AND tim.task='$tas' AND tim.owner='$idSession' AND tim.date>='$date_start_period' AND tim.date<='$date_end_period' AND tim.comments='" . HtmlEntitiesNOD($taskTimeDetail->tim_comments[0]) . "' AND tim.service=" . $taskTimeDetail->tim_service[0];
    $listTaskTime = new request();
    $listTaskTime->openTaskTime($querymore);
    $comptListTaskTime = count($listTaskTime->tim_id);

    for ($i=0; $i<$comptListTaskTime; $i++) {
        $idx = date('Ymd', $listTaskTime->tim_date[$i]);
        $logHours[$idx] += $listTaskTime->tim_hours[$i];
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../timesheet/viewtimesheet.php?toggle_focus=logtime', lang_strings('timesheet'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;toggle_focus=logtime", "$serialname $fyear", 'in'));

if ($id != "") {  // edit task time
    $blockPage->itemBreadcrumbs(lang_strings('edit_task_time'));
} else { // add task time
    $blockPage->itemBreadcrumbs(lang_strings('add_task_time'));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "et1";
$block1->openForm("../timesheet/edittasktime.php?fyear=$fyear&amp;serialno=$serialno&amp;section=workhour&amp;id=$id#" . $block1->form . "Anchor");

if ($id != "") {  // edit task time
    $block1->heading(lang_strings('edit_task_time'));
    echo '<input type="hidden" name="action" value="update">';
} else { // add task time
    $block1->heading(lang_strings('add_task_time'));
    echo '<input type="hidden" name="action" value="add">';
}

$block1->openContent();
$block1->contentTitle(lang_strings('details'));

if ($id != "") {
    $block1->contentRow(lang_strings("project"), $projectDetail->pro_name[0]);
    $block1->contentRow(lang_strings("task"), $taskDetail->tas_name[0]);
    echo "<input type=\"hidden\" name=\"prj\" value=\"$prj\">";
    echo "<input type=\"hidden\" name=\"tas\" value=\"$tas\">";
    echo "<input type=\"hidden\" name=\"commO\" value=\"" . str_replace('"', '&quot;', $taskTimeDetail->tim_comments[0]) . "\">";
    echo "<input type=\"hidden\" name=\"servO\" value=\"" . $taskTimeDetail->tim_service[0] . "\">";
} else {
    // project
    $projectSel = "<select name=\"prj\" onchange=\"changeOptions()\">";

    for ($i=0; $i<$comptListProjects; $i++) {
        if ($prj == $listProjects->tea_project[$i]) {
            $projectSel .= "<option value=\"" . $listProjects->tea_project[$i] . "\" selected>" . $listProjects->tea_pro_name[$i] . "</option>";
        } else {
            $projectSel .= "<option value=\"" . $listProjects->tea_project[$i] . "\">" . $listProjects->tea_pro_name[$i] . "</option>";
        }
    }

    $projectSel .= '</select>&nbsp;&nbsp;<input type="checkbox" name="openonly" value="Y" onchange="changeOpenOnly(this)"' . (($ooy=='Y')?' checked':'') . '><input type="hidden" name="ooy" value="' . $ooy . '">' . lang_strings('ongoing_project_only');
    $block1->contentRow('* ' . lang_strings("project"), $projectSel);

    // task
    $taskSel = "<select name=\"tas\" onchange=\"changeOptions()\">";

    for ($i=0; $i<$comptListTasks; $i++) {
        if ($tas == $listTasks->res_task[$i]) {
            $taskSel .= "<option value=\"" . $listTasks->res_task[$i] . "\" selected>" . $listTasks->res_tas_name[$i] . "</option>";
        } else {
            $taskSel .= "<option value=\"" . $listTasks->res_task[$i] . "\">" . $listTasks->res_tas_name[$i] . "</option>";
        }
    }

    $taskSel .= "</select>";
    $block1->contentRow('* ' . lang_strings("task"), $taskSel);
}

$servSel = "<select name=\"serv\">";

if ($tas != '' && $taskDetail->tas_service[0] != '' && $taskDetail->tas_service[0] != '0') {
    $querymore = " WHERE serv.id='" . $taskDetail->tas_service[0] . "'";
    $serviceDetail = new request();
    $serviceDetail->openServices($querymore);

    if ($taskDetail->tas_service[0] == $serv) {
        $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
    } else {
        $servSel .= "<option value=\"" . $taskDetail->tas_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
    }
} else if ($prj != '' && $memberDetail->tea_service[0] != '' && $memberDetail->tea_service[0] != '0') {
    $querymore = " WHERE serv.id='" . $memberDetail->tea_service[0] . "'";
    $serviceDetail = new request();
    $serviceDetail->openServices($querymore);

    if ($memberDetail->tea_service[0] == $serv) {
        $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\" selected>" . $serviceDetail->serv_name_print[0] . "</option>";
    } else {
        $servSel .= "<option value=\"" . $memberDetail->tea_service[0] . "\">" . $serviceDetail->serv_name_print[0] . "</option>";
    }
}

if ($serv == '0') {
    $servSel .= "<option value='0' selected>" . $strings["none"] . "</option>";
} else {
    $servSel .= "<option value='0'>" . $strings["none"] . "</option>";
}

$servSel .= "</select>";
$block1->contentRow(lang_strings("service"), $servSel);
// comments
setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
$block1->closeContent();
$labels1 = array('&nbsp;');
$labels2 = array('&nbsp;');

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $j = date('j', $listWorkCalendarsDetail->wcd_date[$i]);
    $N = date('N', $listWorkCalendarsDetail->wcd_date[$i]);
    $labels1[] = '<abbr title="' . createDate($listWorkCalendarsDetail->wcd_date[$i], 'date', false, true) . ' ' . convert_html2txt($listWorkCalendarsDetail->wcd_comments[$i]) . '">' . $j . '</abbr>';
    $labels2[] = $dayShortNameArray[$N];
}

$block1->openResults(false);
$block1->labels($labels1, 'false', 'false', '');
$block1->labels($labels2, 'false', 'false', '');
$block1->openRow();
$block1->cellRow(lang_strings('standard'));

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $block1->cellRow($listWorkCalendarsDetail->wcd_hours[$i]);
}

$block1->closeRow();
$block1->openRow();
$block1->cellRow(lang_strings('actual'));

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $dt = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
    $block1->cellRow(((isset($memberActualHours->mem_hours[$dt]))?$memberActualHours->mem_hours[$dt]:'0'));
}

$block1->closeRow();
$block1->openRow();
$block1->cellRow('&nbsp;');

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
    $block1->cellRow('<input type="text" ' . (in_array($idx, $errorDays)?'class="highlight"':'') . ' name="h' . $idx . '" size="4" value="' . $logHours[$idx] . '">');
}

$block1->closeRow();
$block1->closeResults();
$block1->openContent();
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
?>
<script type="text/javascript">
function changeOptions()
{
    var x=document.et1Form;
    x.action.value="";
    document.et1Form.submit();
}
function changeOpenOnly(theObj)
{
    if (theObj.checked === true) {
        document.et1Form.ooy.value = 'Y';
    } else {
        document.et1Form.ooy.value = 'N';
    }

    document.et1Form.action.value="";
    document.et1Form.submit();
}
</script>
<?php
require_once("../includes/footer.php");
