<?php // $Revision: 1.46 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editworkhours.php,v 1.46 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$fyear = isset($_GET['fyear'])?$_GET['fyear']:'';
$serialno = isset($_GET['serialno'])?$_GET['serialno']:'';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$commO = isset($_POST['commO'])?$_POST['commO']:'';
$prj = isset($_POST['prj'])?$_POST['prj']:'';
$wt = isset($_POST['wt'])?$_POST['wt']:'';
$wk = isset($_POST['wk'])?$_POST['wk']:'';
$serv = isset($_POST['serv'])?$_POST['serv']:'';
$servO = isset($_POST['servO'])?$_POST['servO']:'';
$ooy = isset($_POST['ooy'])?$_POST['ooy']:'Y';
$bodyCommand = "onLoad=\"document.eh1Form.prj.focus();\"";
$hoursTtl = 0;
$logHours = array();
$svcDisabled = false;
$error = '';
$errorDays = array();

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
    $date_start_period = mktime(0, 0, 0, intval($serialno), 1, intval($fyear));
    $date_end_period = mktime(0, 0, 0, intval($serialno)+1, 0, intval($fyear));
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    $daysOfWeek = getDaysOfWeek($fyear, $serialno);
    $date_start_period = $daysOfWeek[0];
    $date_end_period = $daysOfWeek[6];
}

/**
 * Permission check
 */
$querymore1 = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore1);
$querymore2 = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.year='$fyear' AND wcd.date>='$date_start_period' AND wcd.date<='$date_end_period' ORDER BY wcd.date";
$listWorkCalendarsDetail = new request();
$listWorkCalendarsDetail->openWorkCalendarsDetail($querymore2);
$comptListWorkCalendarsDetail = count($listWorkCalendarsDetail->wcd_id);

if ($comptListWorkCalendarsDetail == '0') {
    header("Location: ../general/home.php?msg=noWorkCalendar");
    exit;
} else {
    for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
        $logHours[$idx] = 0;
    }
}

if ($id != "") {
    $querymore3 = " WHERE wkh.id='$id'";
    $workHoursDetail = new request();
    $workHoursDetail->openWorkHours($querymore3);

    if ($workHoursDetail->wkh_owner[0] != $idSession) {
        header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=permissiondenied&toggle_focus=logtime");
        exit;
    }

    $prj = $workHoursDetail->wkh_project[0];
    $wk = $workHoursDetail->wkh_work[0];
    $wt = $workHoursDetail->wkh_hrc_hourtype[0];
}

if ($prj != '' && $prj != '0' && ($id != '' || $action != '')) {
    $querymore4 = " WHERE pro.id='$prj'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore4);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {                 // Project not found
        header('Location: ../timesheet/viewtimesheet.php?msg=blankProject&toggle_focus=logtime');
        exit;
    }

    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../timesheet/viewtimesheet.php?msg=permissiondenied&toggle_focus=logtime');
        exit;
    }
}

if (periodLocked($date_start_period)) {
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=periodLocked&toggle_focus=logtime");
    exit;
}

$listTimesheetId = array();
$querymore5 = " WHERE tim.owner='$idSession' AND per.fyear='$fyear' AND per.serial_no='$serialno'";
$listTimesheet = new request();
$listTimesheet->openTimesheet($querymore5);
$comptListTimesheet = count($listTimesheet->tim_owner);
$timesheetReadOnly = false;

for ($i=0; $i<$comptListTimesheet; $i++) {
    if ($listTimesheet->tim_status[$i] == enumFileStatus::stNeedsApproval) {
        $timesheetReadOnly = true;
        break;
    } else if ($listTimesheet->tim_status[$i] == enumFileStatus::stNoApprovalsNeeded || $listTimesheet->tim_status[$i] == enumFileStatus::stApproved) {
        $listTimesheetId[] = $listTimesheet->tim_id[$i];
    }
}

if ($timesheetReadOnly) {
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=permissiondenied&toggle_focus=logtime");
    exit;
}

/**
 * Fields check
 */
if ($action != '') {
    $comm = HtmlEntitiesNOD($comm);
    $commO = HtmlEntitiesNOD($commO);

    if ($wt == enumHourType::htProject && $prj == '') {
        $error = lang_strings('project') . '&nbsp;' . lang_strings('error_required');
    } else {
        for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
            $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
            $x = trim(isset($_POST['h' . $idx])?$_POST['h' . $idx]:'');

            if ($x != '') {
                if (is_numeric($x) && floatval($x) >= 0) {
                    $logHours[$idx] = round(floatval($x), $hourAccuracy);
                    $hoursTtl += $logHours[$idx];
                } else {
                    $error = lang_strings('worked_hours') . '&nbsp;' . lang_strings('error_numerical');
                    $errorDays[] = $idx;
                }
            }
        }

        if ($error == '' && $hoursTtl == 0) {
            $error = lang_strings('worked_hours') . '&nbsp;' . lang_strings('error_required');
        }
    }
}

/**
 * Actions
 */
if ($action != '' && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($action == 'update') {  // remove old work hours first
            $tmpsql = "DELETE FROM " . $tablePrefix . "work_hours WHERE project='$prj' AND work='$wk' AND owner='$idSession' AND date>='$date_start_period' AND date<='$date_end_period' AND comments='$commO' AND service='$servO'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $bf = ($serv == '0')?enumBoolean::bFalse:enumBoolean::bTrue;

        for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
            $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);

            if ($logHours[$idx] > 0) {    // add new work hours
                $tmpsql = "INSERT INTO " . $tablePrefix . "work_hours (project,work,owner,date,hours,comments,billing,service,created,cuser) VALUES ('$prj','$wk','$idSession','" . $listWorkCalendarsDetail->wcd_date[$i] . "','" . $logHours[$idx] . "','$comm','$bf','$serv','" . time() . "','$idSession')";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }
        }

        // check if log hours > 24 in each day
        $tmpquery = "SELECT B.date,B.hours FROM (SELECT A.date,SUM(A.hours) AS hours FROM (SELECT tim.date,tim.hours FROM " . $tablePrefix . "tasks_time tim WHERE tim.owner='$idSession' AND tim.date>='$date_start_period' AND tim.date<='$date_end_period' UNION ALL SELECT mti.date,mti.hours FROM " . $tablePrefix . "meetings_time mti WHERE mti.owner='$idSession' AND mti.date>='$date_start_period' AND mti.date<='$date_end_period' UNION ALL SELECT wkh.date,wkh.hours FROM " . $tablePrefix . "work_hours wkh WHERE wkh.owner='$idSession' AND wkh.date>='$date_start_period' AND wkh.date<='$date_end_period') A GROUP BY A.date) B WHERE B.hours>24";
        $requestAct->query($tmpquery);

        if ($requestAct->rowCount() > 0) {
            while ($requestAct->fetch()) {
                $idx = date('Ymd', $row[0]);
                $errorDays[] = $idx;
            }

            $error = lang_strings('worked_hours') . '&nbsp;' . lang_strings('error_hours');
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        } else {
            if (count($listTimesheetId) > 0) {
                foreach ($listTimesheetId as $tid) {     // update timesheet status
                    $tmpsql = "UPDATE " . $tablePrefix . "timesheet SET status='" . enumFileStatus::stApprovedWithChanges . "',modified='" . time() . "',muser='$idSession' WHERE id=$tid";

                    if ($requestAct->query($tmpsql) === false) {
                        throw new Exception($tmpsql);
                    }
                }
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        }
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($action == 'update') {
            header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=update&toggle_focus=logtime");
        } else {
            header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=add&toggle_focus=logtime");
        }

        exit;
    }
}

/**
 * Prepare data
 */
$querymore6 = " LEFT OUTER JOIN " . $tablePrefix . "project_permissions prp ON prp.project=tea.project AND prp.profil=tea.profil WHERE tea.member='$idSession' AND prp.log_task_hours='" . enumBoolean::bTrue . "'";
$listProjects0 = new request();
$listProjects0->openTeams($querymore6);
$comptListProjects0 = count($listProjects0->tea_project);

if ($ooy == 'Y') {
    $querymore6 .= " AND pro.status='" . enumProjectStatus::stOpen . "'";
}

$querymore6 .= " ORDER BY pro.name";
$listProjects = new request();
$listProjects->openTeams($querymore6);
$comptListProjects = count($listProjects->tea_project);
// get member actual log hours of days
$memberActualHours = new request();
$memberActualHours->getMemberTimeOfDays($idSession, $date_start_period, $date_end_period);

if ($id == "") {
    if ($wt == '') {
        if ($comptListProjects0 == '0') {
            $wt = enumHourType::htLeave;
        } else {
            $wt = enumHourType::htProject;
        }
    }

    if ($serv == '') {
        $serv = "0";
    }

    if ($wt != enumHourType::htProject) {
        $serv = "0";
        $svcDisabled = true;
    }

    if ($prj == '') {
        if ($wt == enumHourType::htProject) {
            $prj = $listProjects->tea_project[0];
        } else {
            $prj = '0';
        }
    }

    if ($wk == '') {
        $querymore = " WHERE hrc.hourtype='$wt' AND hrc.locked='" . enumBoolean::bFalse . "' ORDER BY hrc.id";
        $defaultHourCode = new request();
        $defaultHourCode->openHourCode($querymore, 0 , 1);

        if (count($defaultHourCode->hrc_id) > 0) {
            $wk = $defaultHourCode->hrc_id[0];
        }
    }
}

if ($error == '' && $id != '') {
    $comm = $workHoursDetail->wkh_comments[0];
    $serv = $workHoursDetail->wkh_service[0];
    $querymore7 = " WHERE wkh.project='$prj' AND wkh.work='$wk' AND wkh.owner='$idSession' AND wkh.date>='$date_start_period' AND wkh.date<='$date_end_period' AND wkh.comments='" . HtmlEntitiesNOD($workHoursDetail->wkh_comments[0]) . "' AND wkh.service='" . $workHoursDetail->wkh_service[0] . "' ORDER BY wkh.date";
    $listWorkHours = new request();
    $listWorkHours->openWorkHours($querymore7);
    $comptListWorkHours = count($listWorkHours->wkh_id);

    for ($i=0; $i<$comptListWorkHours; $i++) {
        $idx = date('Ymd', $listWorkHours->wkh_date[$i]);
        $logHours[$idx] += $listWorkHours->wkh_hours[$i];
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../timesheet/viewtimesheet.php?toggle_focus=logtime', lang_strings('timesheet'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;toggle_focus=logtime", "$serialname $fyear", 'in'));

if ($id != "") {
    $blockPage->itemBreadcrumbs(lang_strings('edit_work_hours'));
} else {
    $blockPage->itemBreadcrumbs(lang_strings('add_work_hours'));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "eh1";
$block1->openForm("../timesheet/editworkhours.php?fyear=$fyear&amp;serialno=$serialno&amp;section=workhour&amp;id=$id#" . $block1->form . "Anchor");

if ($id != "") {
    echo '<input type="hidden" name="action" value="update">';
    $block1->heading(lang_strings('edit_work_hours'));
} else {
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings('add_work_hours'));
}

$block1->openContent();
$block1->contentTitle(lang_strings('details'));

if ($id != "") {
    $block1->contentRow(lang_strings("hourtype"), $strings['HRT__' . $wt]);

    if (is_array($listProjects->tea_project)) {
        $i = array_search($prj, $listProjects->tea_project);

        if ($i !== FALSE) {
            $block1->contentRow(lang_strings("project"), $listProjects->tea_pro_name[$i]);
        }
    }

    $block1->contentRow(lang_strings("hourcode"), $wk . " - " . $strings['HRC__' . $wk]);
    echo "<input type=\"hidden\" name=\"wt\" value=\"$wt\">";
    echo "<input type=\"hidden\" name=\"prj\" value=\"$prj\">";
    echo "<input type=\"hidden\" name=\"wk\" value=\"$wk\">";
    echo "<input type=\"hidden\" name=\"commO\" value=\"" . str_replace('"', '&quot;', $workHoursDetail->wkh_comments[0]) . "\">";
    echo "<input type=\"hidden\" name=\"servO\" value=\"" . $workHoursDetail->wkh_service[0] . "\">";
} else {
    // work type
    $querymore8 = " WHERE hrt.locked='" . enumBoolean::bFalse . "' ORDER BY hrt.id";
    $listHourType = new request();
    $listHourType->openHourType($querymore8);
    $comptListHourType = count($listHourType->hrt_id);
    $worktypeSel = "<select name=\"wt\" onchange=\"changeOptions()\">";

    for ($i=0; $i<$comptListHourType; $i++) {
        if ($comptListProjects0 > 0 || $listHourType->hrt_id[$i] != enumHourType::htProject) {
            $worktypeSel .= '<option value="' . $listHourType->hrt_id[$i] . '"' . (($wt == $listHourType->hrt_id[$i])?" selected":"") . '>' . $listHourType->hrt_name_print[$i] . '</option>';
        }
    }

    $worktypeSel .= "</select>";
    $block1->contentRow(lang_strings("hourtype"), $worktypeSel);

    if ($wt == enumHourType::htProject) {
        // project
        $projectSel = "<select name=\"prj\" onchange=\"changeOptions()\">";

        for ($i=0; $i<$comptListProjects; $i++) {
            $projectSel .= "<option value=\"" . $listProjects->tea_project[$i] . "\"" . (($prj == $listProjects->tea_project[$i])?" selected":"") . ">" . $listProjects->tea_pro_name[$i] . "</option>";
        }

        $projectSel .= '</select>&nbsp;&nbsp;<input type="checkbox" name="openonly" value="Y" onchange="changeOpenOnly(this)" ' . (($ooy=='Y')?' checked':'') . '><input type="hidden" name="ooy" value="' . $ooy . '">' . lang_strings('ongoing_project_only');
        $block1->contentRow(lang_strings("project"), $projectSel);
    } else {
        echo "<input type=\"hidden\" name=\"prj\" value=\"0\">";
    }

    // work code
    $querymore9 = " WHERE hrc.hourtype='$wt' AND hrc.locked='" . enumBoolean::bFalse . "' ORDER BY hrc.id";
    $listHourCode = new request();
    $listHourCode->openHourCode($querymore9);
    $comptListHourCode = count($listHourCode->hrc_id);
    $workcodeSel = "<select name=\"wk\">";

    for ($i=0; $i<$comptListHourCode; $i++) {
        $workcodeSel .= '<option value="' . $listHourCode->hrc_id[$i] . '"' . (($wk == $listHourCode->hrc_id[$i])?" selected":"") . '>' . $listHourCode->hrc_id[$i] . ' - ' . $listHourCode->hrc_name_print[$i] . '</option>';
    }

    $workcodeSel .= "</select>";
    $block1->contentRow(lang_strings("hourcode"), $workcodeSel);
}

if ($wt == enumHourType::htProject) {
    $querymore = " WHERE serv.locked='" . enumBoolean::bFalse . "'";

    if ($prj != '') {
        $querymore1 = " WHERE pro.id='$prj'";
        $projectDetail = new request();
        $projectDetail->openProjects($querymore1);
        $comptProjectDetail = count($projectDetail->pro_id);

        if ($comptProjectDetail != '0' && $projectDetail->pro_currency[0] != '') {
            $querymore .= " AND serv.currency='" . $projectDetail->pro_currency[0] . "'";
        }
    }

    $querymore .= " ORDER BY serv.name";
    $listServices = new request();
    $listServices->openServices($querymore);
    $comptListServices = count($listServices->serv_id);
    $serviceSel = "<select name=\"serv\"><option value=\"0\">" . lang_strings("none") . "</option>";

    for ($i=0; $i<$comptListServices; $i++) {
        $serviceSel .= "<option value='" . $listServices->serv_id[$i] . "'" . (($listServices->serv_id[$i] == $serv)?' selected':'') . ">" . $listServices->serv_name_print[$i] . '</option>';
    }

    $serviceSel .= "</select>";
    $block1->contentRow(lang_strings("service"), $serviceSel);
} else {
    echo "<input type=\"hidden\" name=\"serv\" value=\"0\">";
}

setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
$block1->closeContent();
$labels1 = array('&nbsp;');
$labels2 = array('&nbsp;');

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $j = date('j', $listWorkCalendarsDetail->wcd_date[$i]);
    $N = date('N', $listWorkCalendarsDetail->wcd_date[$i]);
    $labels1[] = '<abbr title="' . createDate($listWorkCalendarsDetail->wcd_date[$i], 'date', false, true) . ' ' . convert_html2txt($listWorkCalendarsDetail->wcd_comments[$i]) . '">' . $j . '</abbr>';
    $labels2[] = $dayShortNameArray[$N];
}

$block1->openResults(false);
$block1->labels($labels1, 'false', 'false', '');
$block1->labels($labels2, 'false', 'false', '');
$block1->openRow();
$block1->cellRow(lang_strings('standard'));

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $block1->cellRow($listWorkCalendarsDetail->wcd_hours[$i]);
}

$block1->closeRow();
$block1->openRow();
$block1->cellRow(lang_strings('actual'));

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $dt = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
    $block1->cellRow(((isset($memberActualHours->mem_hours[$dt]))?$memberActualHours->mem_hours[$dt]:'0'));
}

$block1->closeRow();
$block1->openRow();
$block1->cellRow('&nbsp;');

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
    $block1->cellRow('<input type="text" ' . (in_array($idx, $errorDays)?'class="highlight"':'') . ' name="h' . $idx . '" size="4" value="' . $logHours[$idx] . '">');
}

$block1->closeRow();
$block1->closeResults();
$block1->openContent();
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->closeForm();
?>
<script>
function changeOptions()
{
    var x=document.eh1Form;
    x.action.value="";
    document.eh1Form.submit();
}
function changeOpenOnly(theObj)
{
    if (theObj.checked === true) {
        document.eh1Form.ooy.value = 'Y';
    } else {
        document.eh1Form.ooy.value = 'N';
    }

    document.eh1Form.action.value="";
    document.eh1Form.submit();
}
</script>
<?php
require_once("../includes/footer.php");
