<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: hour_code.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'list';
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$error = '';
$nid_highlight = false;

if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'hour_code' && $_SESSION['SOURCE'] == '') {
    $nid = $_SESSION['PARAMS']['nid'];                  // new id
    $np = $_SESSION['PARAMS']['np'];                    // name print
    $ht = $_SESSION['PARAMS']['ht'];                    // hour type
    $l = $_SESSION['PARAMS']['l'];                      // locked
    $serv = $_SESSION['PARAMS']['serv'];                // default service
    $_SESSION['TARGET'] = '';
    $icp = 'true';
} else {
    $nid = isset($_POST['nid'])?$_POST['nid']:'';       // new id
    $np = isset($_POST['np'])?$_POST['np']:'';          // name print
    $ht = isset($_POST['ht'])?$_POST['ht']:'';          // hour type
    $l = isset($_POST['l'])?$_POST['l']:'';             // locked
    $serv = isset($_POST['serv'])?$_POST['serv']:'';    // default service
}

if ($serv == '') {
    $serv = '0';
}

$lk = DbValueEncode(enumFieldType::ftBoolean, $l);

/**
 * Permission check
 */
if ($mode == 'list') {
    if (!$SW_Permissions['System Settings']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['System Settings']['Edit'][$profilSession]) {
        header("Location: ../timesheet/hour_code.php?mode=list&msg=permissiondenied");
        exit;
    }
}

if ($id != '') {
    if ($mode == 'delete') {
        $tmpquery = "SELECT work AS x FROM " . $tablePrefix . "work_hours WHERE work IN ($ids) UNION ALL SELECT id as x FROM " . $tablePrefix . "hour_code WHERE id IN ($ids) AND sysdef='Y'";

        if (compt($tmpquery) > 0) {
            header("Location: ../timesheet/hour_code.php?mode=list&msg=permissiondenied");
            exit;
        }

        $querymore = " WHERE hrc.id IN ($ids)";
        $listHourCode = new request();
        $listHourCode->openHourCode($querymore);
        $comptListHourCode = count($listHourCode->hrc_id);

        if ($comptListHourCode == '0') {
            header("Location: ../timesheet/hour_code.php?mode=list&msg=permissiondenied");
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE hrc.id='$id'";
        $hourCodeDetail = new request();
        $hourCodeDetail->openHourCode($querymore);
        $comptHourCodeDetail = count($hourCodeDetail->hrc_id);

        if ($comptHourCodeDetail == '0') {
            header("Location: ../timesheet/hour_code.php?mode=list&msg=permissiondenied");
            exit;
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add') {
    $querymore = " WHERE hrc.id='$nid'";
    $hourCodeTest = new request();
    $hourCodeTest->openHourCode($querymore);

    if (count($hourCodeTest->hrc_id) > 0) {
        $error = lang_strings("hour_code_already_exists");
        $bodyCommand = "onLoad=\"document.hrcForm.nid.focus();\"";
        $nid_highlight = true;
    }
} else if ($action == 'newtype') {
    // store all user input values in session variables
    $params = array();
    $params['nid'] = $nid;
    $params['np'] = $np;
    $params['l'] = $l;
    $params['serv'] = $serv;
    $_SESSION['PARAMS'] = $params;
    $_SESSION['SOURCE'] = 'hour_code';
    $_SESSION['LOCATION'] = '../timesheet/hour_code.php?id=' . $id . '&mode=' . $mode;
    /**
     * Add New Hour Type
     */
    $_SESSION['TARGET'] = 'hour_type';
    header("Location: ../timesheet/hour_type.php?mode=add");
    exit;
} else if ($action == 'newserv') {
    // store all user input values in session variables
    $params = array();
    $params['nid'] = $nid;
    $params['np'] = $np;
    $params['ht'] = $ht;
    $params['l'] = $l;
    $_SESSION['PARAMS'] = $params;
    $_SESSION['SOURCE'] = 'hour_code';
    $_SESSION['LOCATION'] = '../timesheet/hour_code.php?id=' . $id . '&mode=' . $mode;
    /**
     * Add New Service
     */
    $_SESSION['TARGET'] = 'editservice';
    header("Location: ../services/editservice.php?");
    exit;
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "hour_code (id,hourtype,sysdef,locked,service,created,cuser) VALUES ('$nid','$ht','N','$lk','$serv','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            updateString($requestAct, 'HRC__' . $nid, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'hour_code') {
                $_SESSION['PARAMS']['hrc'] = $nid;
                $_SESSION['TARGET'] = $_SESSION['SOURCE'];
                $_SESSION['SOURCE'] = '';
                header("Location: " . $_SESSION['LOCATION']);
            } else {
                header("Location: ../timesheet/hour_code.php?mode=list&msg=add");
            }

            exit;
        }
    } else if ($action == 'edit') {
        try {
            $requestAct->startTransaction();

            if ($hourCodeDetail->hrc_sysdef[0] != 'Y') {
                $tmpsql = "UPDATE " . $tablePrefix . "hour_code SET hourtype='$ht',locked='$lk',service='$serv',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }
            }

            updateString($requestAct, 'HRC__' . $id, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../timesheet/hour_code.php?mode=list&msg=update");
            exit;
        }
    } else if ($action == 'delete') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "DELETE FROM " . $tablePrefix . "hour_code WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../timesheet/hour_code.php?mode=list&msg=delete");
            exit;
        }
    }
}

/**
 * get hour type valid values
 */
$querymore = " WHERE (hrt.locked='" . enumBoolean::bFalse . "'";

if ($id != '') {
    $querymore .= " OR hrt.id='" . $hourCodeDetail->hrc_hourtype[0] . "'";
}

$querymore .= ") AND hrt.id<>'2' ORDER BY hrt.id";
$listHourType = new request();
$listHourType->openHourType($querymore);
$comptListHourType = count($listHourType->hrt_id);
$hrtVV = array();
$hrtVV[''] = '';

for ($i=0; $i<$comptListHourType; $i++) {
    $hrtVV[$listHourType->hrt_id[$i]] = $listHourType->hrt_name_print[$i];
}

$hrtVV['-1'] = $strings['add_new_hour_type'];

/**
 * get service valid values
 */
$querymore = " WHERE serv.locked='" . enumBoolean::bFalse . "'";

if ($id != '') {
    $querymore .= " OR serv.id='" . $hourCodeDetail->hrc_service[0] . "'";
}

$querymore .= " ORDER BY serv.name";
$listServices = new request();
$listServices->openServices($querymore);
$comptListServices = count($listServices->serv_id);
$servVV = array();
$servVV['0'] = '';

for ($i=0; $i<$comptListServices; $i++) {
    $servVV[$listServices->serv_id[$i]] = $listServices->serv_name_print[$i];
}

if ($SW_Permissions['Service']['Write'][$profilSession]) {
    $servVV['-1'] = $strings['add_new_service'];
}

/**
 * Html
 */
require_once("../includes/header.php");
echo '<script type="text/javascript" src="../javascript/hour_code' . $scriptMinimized . '.js"></script>';
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings("hour_code"));
} else if ($mode == 'add') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/hour_code.php?", lang_strings("hour_code"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_hour_code"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/hour_code.php?", lang_strings("hour_code"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_hour_code"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/hour_code.php?", lang_strings("hour_code"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_hour_codes"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = "hrc";
$block1->openForm("../timesheet/hour_code.php?id=$id&mode=$mode#" . $block1->form . "Anchor");

if ($mode == 'list') {
    logURL($strings['hour_code'], "../timesheet/hour_code.php?id=$id&mode=$mode");
    $block1->heading(lang_strings("hour_code"));
    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '12';
    $block1->sorting('hour_code', (isset($sortingUser['hour_code'])?$sortingUser['hour_code']:''), 'hrc.id ASC', $sortingFields = array(0 => 'hrc.id', 1 => 'none', 2 => 'hrc.hourtype', 3 => 'hrc.sysdef', 4 => 'hrc.locked', 5 => 'serv.name'));
    $querymore = " ORDER BY " . $block1->sortingValue;
    $block1->recordsTotal = compt($initrequest['hour_code'] . ' ' . $querymore);
    $listHourCode = new request();
    $listHourCode->openHourCode($querymore, $block1->borne, $block1->rowsLimit);
    $comptListHourCode = count($listHourCode->hrc_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['id'];
    $columns[0]->field_type = enumFieldType::ftNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name_print'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['hour_type'];
    $columns[2]->field_type = enumFieldType::ftNumeric;
    $columns[2]->linked_table = 'hour_type';
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['system_defined'];
    $columns[3]->field_type = enumFieldType::ftText;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['locked'];
    $columns[4]->field_type = enumFieldType::ftBoolean;
    $columns[5] = new cardviewColumn();
    $columns[5]->title = $strings['service'];
    $columns[5]->field_type = enumFieldType::ftNumeric;
    $columns[5]->linked_table = 'services';
    $opt[enumCardviewOption::oObject] = 'hour_code';
    $opt[enumCardviewOption::oTableName] = 'hour_code';
    $opt[enumCardviewOption::oColumns] = $columns;

    if ($SW_Permissions['System Settings']['Edit'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../timesheet/hour_code.php?mode=add';
    }

    $block1->openCardView($opt);

    for ($i=0; $i<$comptListHourCode; $i++) {
        $content = array(
            $listHourCode->hrc_id[$i],
            $listHourCode->hrc_name_print[$i],
            $listHourCode->hrc_hourtype[$i],
            (($listHourCode->hrc_sysdef[$i]=='Y')?lang_strings('yes'):lang_strings('no')),
            $listHourCode->hrc_locked[$i],
            $listHourCode->hrc_service[$i]
        );
        $block1->itemCardView($listHourCode->hrc_id[$i], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "id=$id&mode=$mode");
    $block1->closeFormResults();
} else if ($mode == 'add') {
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_hour_code"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("id"), 'nid', enumFieldType::ftNumeric, 'Y', '6', $nid, '', '', $nid_highlight);
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np);
    setupInputHTML($block1, lang_strings("hour_type"), 'ht', enumFieldType::ftNumeric, 'Y', '6', $ht, $hrtVV, '', false, '', 'onchange="hourTypeChanged()"');
    setupInputHTML($block1, lang_strings("service") . $block1->printHelp('setup_servdefault1'), 'serv', enumFieldType::ftNumeric, 'N', '8', $serv, $servVV, '', false, '', 'onchange="serviceChanged()"');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    if ($error == '') {
        $np = $hourCodeDetail->hrc_name_print[0];
        $ht = $hourCodeDetail->hrc_hourtype[0];
        $lk = $hourCodeDetail->hrc_locked[0];
        $serv = $hourCodeDetail->hrc_service[0];
    }

    echo '<input type="hidden" name="action" value="edit">';
    $block1->heading(lang_strings("edit_hour_code") . " : " . $hourCodeDetail->hrc_id[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np);

    if ($hourCodeDetail->hrc_sysdef[0] != 'Y') {
        setupInputHTML($block1, lang_strings("hour_type"), 'ht', enumFieldType::ftNumeric, 'Y', '6', $ht, $hrtVV, '', false, '', 'onchange="hourTypeChanged()"');
        setupInputHTML($block1, lang_strings('locked'), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
        setupInputHTML($block1, lang_strings("service") . $block1->printHelp('setup_servdefault1'), 'serv', enumFieldType::ftNumeric, 'N', '8', $serv, $servVV, '', false, '', 'onchange="serviceChanged()"');
    }

    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_hour_codes"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListHourCode; $i++) {
        $block1->contentRow('#' . $listHourCode->hrc_id[$i], $listHourCode->hrc_name_print[$i]);
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

require_once("../includes/footer.php");
