<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: hour_type.php,v 1.8 2013/01/29 08:46:12 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$mode = isset($_GET['mode'])?$_GET['mode']:'list';

if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'hour_type' && $_SESSION['SOURCE'] == '') {
    $nid = $_SESSION['PARAMS']['nid'];      // new id
    $np = $_SESSION['PARAMS']['np'];        // name print
    $l = $_SESSION['PARAMS']['l'];          // locked
    $serv = $_SESSION['PARAMS']['serv'];    // default service
    $_SESSION['TARGET'] = '';
    $icp = 'true';
} else {
    $nid = isset($_POST['nid'])?$_POST['nid']:'';   // new id
    $np = isset($_POST['np'])?$_POST['np']:'';      // name print
    $l = isset($_POST['l'])?$_POST['l']:'';         // locked
    $serv = isset($_POST['serv'])?$_POST['serv']:'';    // default service
}

if ($serv == '') {
    $serv = '0';
}

$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$ids = "'" . str_replace("**", "','", $id) . "'";
$lk = DbValueEncode(enumFieldType::ftBoolean, $l);
$error = '';
$nid_highlight = false;

/**
 * Permission check
 */
if ($mode == 'list') {
    if (!$SW_Permissions['System Settings']['Read'][$profilSession]) {
        header("Location: ../general/permissiondenied.php");
        exit;
    }
} else {
    if (!$SW_Permissions['System Settings']['Edit'][$profilSession]) {
        header("Location: ../timesheet/hour_type.php?mode=list&msg=permissiondenied");
        exit;
    }
}

if ($id != '') {
    if ($mode == 'delete') {
        $tmpquery = "SELECT id FROM " . $tablePrefix . "hour_code WHERE hourtype IN ($ids) UNION ALL SELECT id FROM " . $tablePrefix . "hour_type WHERE id IN ($ids) AND sysdef='Y'";

        if (compt($tmpquery) > 0) {
            header("Location: ../timesheet/hour_type.php?mode=list&msg=permissiondenied");
            exit;
        }

        $querymore = " WHERE hrt.id IN ($ids)";
        $listHourType = new request();
        $listHourType->openHourType($querymore);
        $comptListHourType = count($listHourType->hrt_id);

        if ($comptListHourType == '0') {
            header("Location: ../timesheet/hour_type.php?mode=list&msg=permissiondenied");
            exit;
        }
    } else if ($mode == 'edit') {
        $querymore = " WHERE hrt.id='$id'";
        $hourTypeDetail = new request();
        $hourTypeDetail->openHourType($querymore);
        $comptHourTypeDetail = count($hourTypeDetail->hrt_id);

        if ($comptHourTypeDetail == '0') {
            header("Location: ../timesheet/hour_type.php?mode=list&msg=permissiondenied");
            exit;
        }
    }
}

/**
 * Fields check
 */
if ($action == 'add') {
    $querymore = " WHERE hrt.id='$nid'";
    $hourTypeTest = new request();
    $hourTypeTest->openHourType($querymore);

    if (count($hourTypeTest->hrt_id) > 0) {
        $error = lang_strings("hour_type_already_exists");
        $bodyCommand = "onLoad=\"document.hrtForm.nid.focus();\"";
        $nid_highlight = true;
    }
} else if ($action == 'new') {
    // store all user input values in session variables
    $params = array();
    $params['nid'] = $nid;
    $params['np'] = $np;
    $params['l'] = $l;
    $_SESSION['PARAMS'] = $params;
    $_SESSION['SOURCE'] = 'hour_type';
    $_SESSION['LOCATION'] = '../timesheet/hour_type.php?id=' . $id . '&mode=' . $mode;
    /**
     * Add New Service
     */
    $_SESSION['TARGET'] = 'editservice';
    header("Location: ../services/editservice.php?");
    exit;
}

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $serv = ($serv=='')?'0':$serv;
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    if ($action == 'add') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "INSERT INTO " . $tablePrefix . "hour_type (id,sysdef,locked,service,created,cuser) VALUES ('$nid','N','$lk','$serv','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            updateString($requestAct, 'HRT__' . $nid, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            if (isset($_SESSION['TARGET']) && $_SESSION['TARGET'] == 'hour_type') {
                $_SESSION['PARAMS']['ht'] = $nid;
                $_SESSION['PARAMS']['serv'] = $serv;
                $_SESSION['TARGET'] = $_SESSION['SOURCE'];
                $_SESSION['SOURCE'] = '';
                header("Location: " . $_SESSION['LOCATION']);
            } else {
                header("Location: ../timesheet/hour_type.php?mode=list&msg=add");
            }

            exit;
        }
    } else if ($action == 'edit') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "UPDATE " . $tablePrefix . "hour_type SET locked='$lk',service='$serv',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            updateString($requestAct, 'HRT__' . $id, $np);
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../timesheet/hour_type.php?mode=list&msg=update");
            exit;
        }
    } else if ($action == 'delete') {
        try {
            $requestAct->startTransaction();
            $tmpsql = "DELETE FROM " . $tablePrefix . "hour_type WHERE id IN ($ids)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } catch (Exception $e) {
            $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
            error_log($e->getMessage());
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }

        $requestAct->close();

        if ($error == '') {
            header("Location: ../timesheet/hour_type.php?mode=list&msg=delete");
            exit;
        }
    }
}

/**
 * get service valid values
 */
$querymore = " WHERE serv.locked='" . enumBoolean::bFalse . "'";

if ($id != '') {
    $querymore .= " OR serv.id='" . $hourTypeDetail->hrt_service[0] . "'";
}

$querymore .= " ORDER BY serv.name";
$listServices = new request();
$listServices->openServices($querymore);
$comptListServices = count($listServices->serv_id);
$servVV = array();
$servVV['0'] = '';

for ($i=0; $i<$comptListServices; $i++) {
    $servVV[$listServices->serv_id[$i]] = $listServices->serv_name_print[$i];
}

if ($SW_Permissions['Service']['Write'][$profilSession]) {
    $servVV['-1'] = $strings['add_new_service'];
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/hour_code.php?", lang_strings("hour_code"), "in"));

if ($mode == 'list') {
    $blockPage->itemBreadcrumbs(lang_strings("hour_type"));
} else if ($mode == 'add') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/hour_type.php?", lang_strings("hour_type"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("add_hour_type"));
} else if ($mode == 'edit') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/hour_type.php?", lang_strings("hour_type"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("edit_hour_type"));
} else if ($mode == 'delete') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/hour_type.php?", lang_strings("hour_type"), 'in'));
    $blockPage->itemBreadcrumbs(lang_strings("delete_hour_types"));
}

$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$block1 = new block();
$block1->form = "hrt";
$block1->openForm("../timesheet/hour_type.php?id=$id&mode=$mode#" . $block1->form . "Anchor");

if ($mode == 'list') {
    logURL($strings['hour_type'], "../timesheet/hour_type.php?id=$id&mode=$mode");
    $block1->heading(lang_strings("hour_type"));
    $block1->borne = $blockPage->returnBorne('1');
    $block1->rowsLimit = '12';
    $block1->sorting('hour_type', (isset($sortingUser['hour_type'])?$sortingUser['hour_type']:''), 'hrt.id ASC', $sortingFields = array(0 => 'hrt.id', 1 => 'none', 2 => 'hrt.sysdef', 3 => 'hrt.locked', 4 => 'serv.name'));
    $querymore = " ORDER BY " . $block1->sortingValue;
    $block1->recordsTotal = compt($initrequest['hour_type'] . ' ' . $querymore);
    $listHourType = new request();
    $listHourType->openHourType($querymore, $block1->borne, $block1->rowsLimit);
    $comptListHourType = count($listHourType->hrt_id);
    $columns = array();
    $columns[0] = new cardviewColumn();
    $columns[0]->title = $strings['id'];
    $columns[0]->field_type = enumFieldType::ftNumeric;
    $columns[1] = new cardviewColumn();
    $columns[1]->title = $strings['name_print'];
    $columns[1]->field_type = enumFieldType::ftText;
    $columns[2] = new cardviewColumn();
    $columns[2]->title = $strings['system_defined'];
    $columns[2]->field_type = enumFieldType::ftText;
    $columns[3] = new cardviewColumn();
    $columns[3]->title = $strings['locked'];
    $columns[3]->field_type = enumFieldType::ftBoolean;
    $columns[4] = new cardviewColumn();
    $columns[4]->title = $strings['service'];
    $columns[4]->field_type = enumFieldType::ftNumeric;
    $columns[4]->linked_table = 'services';
    $opt[enumCardviewOption::oObject] = 'hour_type';
    $opt[enumCardviewOption::oTableName] = 'hour_type';
    $opt[enumCardviewOption::oColumns] = $columns;

    if ($SW_Permissions['System Settings']['Edit'][$profilSession]) {
        $opt[enumCardviewOption::oAddUrl] = '../timesheet/hour_type.php?mode=add';
    }

    $block1->openCardView($opt);

    for ($i=0; $i<$comptListHourType; $i++) {
        $content = array(
            $listHourType->hrt_id[$i],
            $listHourType->hrt_name_print[$i],
            (($listHourType->hrt_sysdef[$i]=='Y')?lang_strings('yes'):lang_strings('no')),
            $listHourType->hrt_locked[$i],
            $listHourType->hrt_service[$i]
        );
        $block1->itemCardView($listHourType->hrt_id[$i], $content);
    }

    $block1->closeCardView();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "id=$id&mode=$mode");
    $block1->closeFormResults();
} else if ($mode == 'add') {
    echo '<input type="hidden" name="action" value="add">';
    $block1->heading(lang_strings("add_hour_type"));
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("id"), 'nid', enumFieldType::ftNumeric, 'Y', '6', $nid, '', '', $nid_highlight);
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np);
    setupInputHTML($block1, lang_strings("service") . $block1->printHelp('setup_servdefault'), 'serv', enumFieldType::ftNumeric, 'N', '8', $serv, $servVV, '', false, '', 'onchange="serviceChanged()"');
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'edit') {
    if ($error == '') {
        $np = $hourTypeDetail->hrt_name_print[0];
        $serv = $hourTypeDetail->hrt_service[0];
        $lk = $hourTypeDetail->hrt_locked[0];
    }

    echo '<input type="hidden" name="action" value="edit">';
    $block1->heading(lang_strings("edit_hour_type") . " : " . $hourTypeDetail->hrt_id[0]);
    $block1->openContent();
    $block1->contentTitle(lang_strings("details"));
    setupInputHTML($block1, lang_strings("name_print"), 'np', enumFieldType::ftText, 'Y', '65535', $np);
    setupInputHTML($block1, lang_strings("service") . $block1->printHelp('setup_servdefault'), 'serv', enumFieldType::ftNumeric, 'N', '8', $serv, $servVV, '', false, '', 'onchange="serviceChanged()"');
    setupInputHTML($block1, lang_strings("locked"), 'l', enumFieldType::ftBoolean, 'Y', '1', $lk);
    $block1->contentRow('', '<input type="SUBMIT" value="' . $strings['save'] . '">');
    $block1->closeContent();
    $block1->note("*&nbsp;" . lang_strings('required'));
    $block1->closeForm();
} else if ($mode == 'delete') {
    echo '<input type="hidden" name="action" value="delete">';
    $block1->heading(lang_strings("delete_hour_types"));
    $block1->openContent();
    $block1->contentTitle(lang_strings('delete_following'));

    for ($i=0; $i<$comptListHourType; $i++) {
        $block1->contentRow('#' . $listHourType->hrt_id[$i], $listHourType->hrt_name_print[$i]);
    }

    $block1->contentRow('', '<input type="submit" name="delete" value="' . $strings['delete'] . '"> <input type="button" name="cancel" value="' . $strings['cancel'] . '" onClick="history.back();">');
    $block1->closeContent();
    $block1->closeForm();
}

?>
<script type="text/javascript">
    function serviceChanged()
    {
        var x = document.getElementById('serv').selectedIndex;
        var y = document.getElementById('serv').options[x].value;

        if (y === '-1') {
            document.hrtForm.action.value = 'new';
            document.hrtForm.submit();
        }
    }
</script>
<?php
require_once("../includes/footer.php");
