<?php // $Revision: 1.33 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: rejecttimesheet.php,v 1.33 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Variables init
 */
$action = isset($_POST['action'])?$_POST['action']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$id0 = isset($_GET['id'])?$_GET['id']:'';
$doc0 = isset($_GET['doc'])?$_GET['doc']:'';
$auth0 = isset($_GET['auth'])?$_GET['auth']:'';

if ($auth0 == '') {
    $checkSession = true;
} else {
    $blank = 'true';
    $checkSession = false;
}

/**
 * Includes
 */
require_once("../includes/library.php");
$id = AddSlashesNOD($id0);
$doc = AddSlashesNOD($doc0);
$auth = AddSlashesNOD($auth0);

/**
 * Permission check
 */
if ($auth == '') {
    $querymore = " WHERE daa.document_approval='$doc' AND daa.authorizer='$idSession' AND dap.docid='$id' AND dap.doctype='timesheet' AND dap.current_stage=daa.stage AND dap.closed='N'";
} else {
    $querymore = " WHERE daa.document_approval='$doc' AND daa.not_approve_string='$auth' AND daa.string_validto>=" . time() . " AND dap.docid='$id' AND dap.doctype='timesheet' AND dap.current_stage=daa.stage AND dap.canceled='N' AND dap.closed='N'";
}

$documentsApprovalAuthorizerDetail = new request();
$documentsApprovalAuthorizerDetail->openDocumentsApprovalAuthorizers($querymore);
$comptDocumentsApprovalAuthorizerDetail = count($documentsApprovalAuthorizerDetail->daa_document_approval);

if ($comptDocumentsApprovalAuthorizerDetail == '0') {
    if ($auth == '') {
        header("Location: ../general/permissiondenied.php");
        exit;
    } else {
        header("Location: ../general/login.php?url=timesheet/rejecttimesheet.php%3Fid=$id%26doc=$doc");
        exit;
    }
} else if ($documentsApprovalAuthorizerDetail->daa_dap_canceled[0] == 'Y') {
    header("Location: ../general/home.php?msg=docCanceled");
    exit;
}

$document_approval = $documentsApprovalAuthorizerDetail->daa_document_approval[0];
$confirmation_level = $documentsApprovalAuthorizerDetail->daa_confirmation_level[0];
$approval = $documentsApprovalAuthorizerDetail->daa_dap_approval[0];
$producer = $documentsApprovalAuthorizerDetail->daa_dap_owner[0];
$current_stage = $documentsApprovalAuthorizerDetail->daa_dap_current_stage[0];
$document_status = $documentsApprovalAuthorizerDetail->daa_dap_status[0];
$doctype = 'timesheet';
$querymore = " WHERE tim.id='$id'";
$timesheetDetail = new request();
$timesheetDetail->openTimesheet($querymore);
$project = '0';

/**
 * Actions
 */
if ($action == 'reject') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($auth != '') {
            $idSession = $documentsApprovalAuthorizerDetail->daa_authorizer[0];
        }

        if (!defined('INNER_REJECTDOCUMENT')) {
            define('INNER_REJECTDOCUMENT', 1);
        }

        require_once("../approvals/rejectdocument.php");

        if ($document_status == enumApprovalStatus::stNotApproved) {
            $tmpsql = "UPDATE " . $tablePrefix . "timesheet SET status='" . enumFileStatus::stNotApproved . "',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        } else if ($document_status == enumApprovalStatus::stPending) {
            $tmpsql = "UPDATE " . $tablePrefix . "timesheet SET status='" . enumFileStatus::stNeedsApproval . "',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        copy2HistoryTable($requestAct, 'timesheet', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($auth == '') {
            header("Location: ../general/home.php?msg=rejectTimesheet");
            exit;
        } else {
            $msg = 'rejectTimesheet';
        }
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($auth == '') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../general/home.php", lang_strings('home'), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings('reject_timesheet'));
$blockPage->closeBreadcrumbs();
echo '
<form action="../reports/hours.php" id="frm" method="post" style="display: none;">
<input type="text" name="S_ORGSEL" value="ALL">
<input type="text" name="S_PRJSEL" value="ALL">
<input type="text" name="S_DEPSEL" value="ALL">
<input type="text" name="S_ATSEL" value="' . $timesheetDetail->tim_owner[0] . '">
<input type="text" name="S_DATE1" value="' . createDate($timesheetDetail->tim_per_date_start[0],'date',false,true) . '">
<input type="text" name="S_DATE2" value="' . createDate($timesheetDetail->tim_per_date_end[0],'date',false,true) . '">
<input type="text" name="S_BILLING" value="ALL">
</form>
';

$block1 = new block();
$block1->form = 'rjT';

if ($auth == '') {
    $block1->openForm("../timesheet/rejecttimesheet.php?id=$id&doc=$doc");
} else {
    $block1->openForm("../timesheet/rejecttimesheet.php?id=$id&doc=$doc&auth=$auth");
}

$block1->heading(lang_strings("reject_timesheet"));
$block1->openContent();
$block1->contentTitle(lang_strings("reject_following"));

if ($auth == '') {
    $block1->contentRow(lang_strings('proposer'), $blockPage->buildLink($timesheetDetail->tim_owner[0], '', 'message'));
} else {
    $block1->contentRow(lang_strings('proposer'), $timesheetDetail->tim_mem_name[0]);
}

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$timesheetDetail->tim_per_serial_no[0]];
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $timesheetDetail->tim_per_serial_no[0];
}

$block1->contentRow(lang_strings('period'), "$serialname " . $timesheetDetail->tim_per_fyear[0] . " ( " . createDate($timesheetDetail->tim_per_date_start[0],'date',false,true) . " ~ " . createDate($timesheetDetail->tim_per_date_end[0],'date',false,true) . " )");
$block1->contentRow(lang_strings('standard'), $timesheetDetail->tim_standard_hours[0] . " " . lang_strings('hours'));
$block1->contentRow(lang_strings('actual'), $timesheetDetail->tim_actual_hours[0] . " " . lang_strings('hours'));
$block1->contentRow(lang_strings('overtime'), $timesheetDetail->tim_overtime_hours[0] . " " . lang_strings('hours'));
$block1->contentRow(lang_strings('billable'), $timesheetDetail->tim_billable_hours[0] . " " . lang_strings('hours'));
$block1->contentRow(lang_strings("comments"), html_entity_decode($timesheetDetail->tim_comments[0], ENT_QUOTES, $htmlEntityCharset));
$block1->contentRow('', '<a href="javascript:;" onclick="javascript: document.getElementById(\'frm\').submit()">' . lang_strings('show_details') . '</a>');

if (!isset($msg) || $msg=='') {
    setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
    echo "<input type=\"hidden\" name=\"action\" value=\"reject\">";
    $block1->contentRow('', "<input type='submit' name='submit' value='" . $strings['submit'] . "'>");
}

$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
