<?php // $Revision: 1.34 $
/* vim: set expandtab ts=4 sw=4 sts=4: */
/**
 * $Id: submittimesheet.php,v 1.34 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$fyear = AddSlashesNOD(isset($_GET['fyear'])?$_GET['fyear']:'');
$serialno = AddSlashesNOD(isset($_GET['serialno'])?$_GET['serialno']:'');
$action = isset($_POST['action'])?$_POST['action']:'';
$comm = isset($_POST['comm'])?$_POST['comm']:'';
$bodyCommand = 'onLoad="document.tssForm.comm.focus();"';

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
    $date_start_period = mktime(0, 0, 0, intval($serialno), 1, intval($fyear));
    $date_end_period = mktime(0, 0, 0, intval($serialno)+1, 0, intval($fyear));
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    $daysOfWeek = getDaysOfWeek($fyear, $serialno);
    $date_start_period = $daysOfWeek[0];
    $date_end_period = $daysOfWeek[6];
}

/**
 * Permission check
 */
$querymore1 = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore1);
$querymore2 = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.year='$fyear' AND wcd.date>='$date_start_period' AND wcd.date<='$date_end_period' ORDER BY wcd.date";
$listWorkCalendarsDetail = new request();
$listWorkCalendarsDetail->openWorkCalendarsDetail($querymore2);
$comptListWorkCalendarsDetail = count($listWorkCalendarsDetail->wcd_id);

if ($comptListWorkCalendarsDetail == '0') {
    header("Location: ../general/home.php?msg=noWorkCalendar");
    exit;
}

$querymore3 = " WHERE tim.owner='$idSession' AND per.fyear='$fyear' AND per.serial_no='$serialno'";
$timesheetDetail = new request();
$timesheetDetail->openTimesheet($querymore3);
$comptTimesheetDetail = count($timesheetDetail->tim_owner);

if ($comptTimesheetDetail > 0 && $timesheetDetail->tim_status[0] == enumFileStatus::stNeedsApproval) {
    header("Location:../general/permissiondenied.php");
    exit;
}

// Actual hours
$memberTimeOfPeriodDetail = new request();
$actualHours = $memberTimeOfPeriodDetail->getMemberTimeOfPeriod($idSession, $date_start_period, $date_end_period);

if (floatval($actualHours) == 0) {
    header("Location:../general/permissiondenied.php");
    exit;
}

if (periodLocked($date_start_period)) {
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=periodLocked");
    exit;
}

/**
 * Actions
 */
if ($action == 'submit') {
    // variables init
    $standardHours = 0;         // standard hours
    $overtimeHours = 0;         // overtime hours
    $listOvertime = array();    // array for calculate overtime hours
    $listOverLeave = array();   // array for calculate over leave hours

    for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
        $standardHours += $listWorkCalendarsDetail->wcd_hours[$i];              // standard hours
        $listOvertime[$idx] = 0 - $listWorkCalendarsDetail->wcd_hours[$i];      // overtime hours
        $listOverLeave[$idx] = 0;                                               // over leave hours
    }

    // work hours
    $querymore4 = " WHERE wkh.owner='$idSession' AND wkh.date>='$date_start_period' AND wkh.date<='$date_end_period'";
    $listWorkHours = new request();
    $listWorkHours->openWorkHours($querymore4);
    $comptListWorkHours = count($listWorkHours->wkh_id);

    for ($i=0; $i<$comptListWorkHours; $i++) {
        $idx = date('Ymd', $listWorkHours->wkh_date[$i]);
        $listOvertime[$idx] += $listWorkHours->wkh_hours[$i];       // overtime hours

        switch ($listWorkHours->wkh_work[$i]) {
            case enumLeaveType::lvAnnual:
            case enumLeaveType::lvSick:
            case enumLeaveType::lvAbsence:
            case enumLeaveType::lvBankHoliday:
            case enumLeaveType::lvMourning:
            case enumLeaveType::lvHoneyMoon:
            case enumLeaveType::lvMaternity:
                $listOverLeave[$idx] += $listWorkHours->wkh_hours[$i];  // over leave hours
        }
    }

    // task time
    $querymore5 = " WHERE tim.owner='$idSession' AND tim.date>='$date_start_period' AND tim.date<='$date_end_period'";
    $listTaskTime = new request();
    $listTaskTime->openTaskTime($querymore5);
    $comptListTaskTime = count($listTaskTime->tim_id);

    for ($i=0; $i<$comptListTaskTime; $i++) {
        $idx = date('Ymd', $listTaskTime->tim_date[$i]);
        $listOvertime[$idx] += $listTaskTime->tim_hours[$i]; // overtime hours
    }

    // meeting time
    $querymore6 = " WHERE mti.owner='$idSession' AND mti.date>='$date_start_period' AND mti.date<='$date_end_period'";
    $listMeetingTime = new request();
    $listMeetingTime->openMeetingTime($querymore6);
    $comptListMeetingTime = count($listMeetingTime->mti_id);

    for ($i=0; $i<$comptListMeetingTime; $i++) {
        $idx = date('Ymd', $listMeetingTime->mti_date[$i]);
        $listOvertime[$idx] += $listMeetingTime->mti_hours[$i];   // overtime hours
    }

    foreach ($listOvertime as $hours) {
        if ($hours > 0) {
            $overtimeHours += $hours;
        }
    }

    // Billable hours
    $billableHours = $memberTimeOfPeriodDetail->getMemberBillableTimeOfPeriod($idSession, $date_start_period, $date_end_period);
    $comm = HtmlEntitiesNOD($comm);
    $status = enumFileStatus::stNoApprovalsNeeded;
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($comptTimesheetDetail > 0) {
            $tmpsql = "UPDATE " . $tablePrefix . "timesheet SET standard_hours='$standardHours',actual_hours='$actualHours',billable_hours='$billableHours',overtime_hours='$overtimeHours',status='$status',comments='$comm',modified='" . time() . "',muser='$idSession' WHERE id='" . $timesheetDetail->tim_id[0] . "'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $timesheetDetail->tim_id[0];
        } else {
            $querymore = " WHERE per.fyear='$fyear' AND per.serial_no='$serialno'";
            $requestAct->openPeriods($querymore);
            $num0 = $requestAct->per_id[0];
            $tmpsql = "INSERT INTO " . $tablePrefix . "timesheet (owner,period,standard_hours,actual_hours,billable_hours,overtime_hours,status,comments,created,cuser) VALUES ('$idSession','$num0','$standardHours','$actualHours','$billableHours','$overtimeHours','$status','$comm','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $num = $requestAct->newId('timesheet');
        }

        $producer = $idSession;
        $doctype = 'timesheet';

        if (!defined('INNER_ADDDOCUMENT')) {
            define('INNER_ADDDOCUMENT', 1);
        }

        if ($comptTimesheetDetail > 0) {
            copy2HistoryTable($requestAct, 'timesheet', $num, 'U');
        } else {
            copy2HistoryTable($requestAct, 'timesheet', $num, 'A');
        }

        require_once('../approvals/adddocument.php');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=addToSubmitted");
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../timesheet/viewtimesheet.php', lang_strings('timesheet'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno", "$serialname $fyear", 'in'));
$blockPage->itemBreadcrumbs(lang_strings('submit_timesheet'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->heading(lang_strings('submit_timesheet') . " : $serialname $fyear");
$block1->form = "tss";
$block1->openForm("../timesheet/submittimesheet.php?fyear=$fyear&amp;serialno=$serialno#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="submit">';
$block1->openContent();
$block1->contentTitle(lang_strings('details'));
setupInputHTML($block1, lang_strings('comments'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
$block1->contentRow('', "<input type=\"submit\" name=\"Save\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
