<?php // $Revision: 1.20 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewmeetingtime.php,v 1.20 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$fyear = AddSlashesNOD(isset($_GET['fyear'])?$_GET['fyear']:'');
$serialno = AddSlashesNOD(isset($_GET['serialno'])?$_GET['serialno']:'');

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
    $date_start_period = mktime(0, 0, 0, intval($serialno), 1, intval($fyear));
    $date_end_period = mktime(0, 0, 0, intval($serialno)+1, 0, intval($fyear));
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    $daysOfWeek = getDaysOfWeek($fyear, $serialno);
    $date_start_period = $daysOfWeek[0];
    $date_end_period = $daysOfWeek[6];
}

/**
 * Permission check
 */
$querymore = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore);
$querymore = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.year='$fyear' AND wcd.date>='$date_start_period' AND wcd.date<='$date_end_period' ORDER BY wcd.date";
$listWorkCalendarsDetail = new request();
$listWorkCalendarsDetail->openWorkCalendarsDetail($querymore);
$comptListWorkCalendarsDetail = count($listWorkCalendarsDetail->wcd_id);

if ($comptListWorkCalendarsDetail == '0') {
    header("Location: ../general/home.php?msg=noWorkCalendar");
    exit;
}

$querymore = " WHERE mti.id='$id'";
$meetingTimeDetail = new request();
$meetingTimeDetail->openMeetingTime($querymore);

if ($meetingTimeDetail->mti_owner[0] != $idSession) {
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=permissiondenied&toggle_focus=logtime");
    exit;
}

/**
 * Prepare data
 */
$prj = $meetingTimeDetail->mti_project[0];
$mee = $meetingTimeDetail->mti_meeting[0];
$comm = $meetingTimeDetail->mti_comments[0];
$dat = $meetingTimeDetail->mti_date[0];
$querymore = " WHERE mti.project='$prj' AND mti.meeting='$mee' AND mti.owner='$idSession' AND mti.date='$dat' AND mti.comments='" . HtmlEntitiesNOD($meetingTimeDetail->mti_comments[0]) . "'";
$listMeetingTime = new request();
$listMeetingTime->openMeetingTime($querymore);
$comptListMeetingTime = count($listMeetingTime->mti_id);
$hours = 0;

for ($i=0; $i<$comptListMeetingTime; $i++) {
    $hours += $listMeetingTime->mti_hours[$i];
}

$querymore = " WHERE mee.id=$mee";
$meetingDetail = new request();
$meetingDetail->openMeetings($querymore);
$querymore = " WHERE tim.owner='$idSession' AND per.fyear='$fyear' AND per.serial_no='$serialno'";
$listTimesheet = new request();
$listTimesheet->openTimesheet($querymore);
$comptListTimesheet = count($listTimesheet->tim_owner);
$timesheetReadOnly = false;

for ($i=0; $i<$comptListTimesheet; $i++) {
    if ($listTimesheet->tim_status[$i] == enumFileStatus::stNeedsApproval) {
        $timesheetReadOnly = true;
        break;
    }
}

$periodLocked = periodLocked($date_start_period);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../timesheet/viewtimesheet.php?toggle_focus=logtime', lang_strings('timesheet'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;toggle_focus=logtime", "$serialname $fyear", 'in'));
$blockPage->itemBreadcrumbs(lang_strings('view_meeting_time'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "vtm";
$block1->openForm("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;section=meetingtime&amp;toggle_focus=logtime#" . $block1->form . "Anchor");
$block1->heading(lang_strings('view_meeting_time'));

if (!$periodLocked && !$timesheetReadOnly) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(1, "remove", $strings["delete"]);
    $block1->paletteIcon(7, "edit", $strings["edit"]);
    $block1->closePaletteIcon();
}

$block1->openContent();
$block1->contentTitle(lang_strings('details'));
$block1->contentRow(lang_strings('project'), $meetingDetail->mee_pro_name[0]);
$block1->contentRow(lang_strings('meeting'), $meetingDetail->mee_name[0]);
$block1->contentRow(lang_strings("start_time"), createDate($meetingDetail->mee_start_time[0], 'both'));
$block1->contentRow(lang_strings("duration"), NumberFormatNOD($meetingDetail->mee_duration[0], $hourAccuracy, false) . ' ' . lang_strings('hours'));
$block1->contentRow(lang_strings('comments'), $comm);
$block1->contentRow(lang_strings("worked_hours"), $hours);
$block1->closeContent();

if (!$periodLocked && !$timesheetReadOnly) {
    $block1->openPaletteScript();
    $block1->paletteScript(1, "remove", "../timesheet/deleteworkhours.php?fyear=$fyear&serialno=$serialno&id2=$id", "true,true,false", $strings["delete"]);
    $block1->paletteScript(7, "edit", "../timesheet/editmeetingtime.php?fyear=$fyear&serialno=$serialno&id=$id", "true,true,false", $strings["edit"]);
    $block1->closePaletteScript('', '');
}

$block1->closeForm();
require_once("../includes/footer.php");
