<?php // $Revision: 1.55 $
/* vim: set expandtab ts=4 sw=4 sts=4: */
/**
 * $Id: viewtimesheet.php,v 1.55 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$fyear = AddSlashesNOD(isset($_GET['fyear'])?$_GET['fyear']:'');
$serialno = AddSlashesNOD(isset($_GET['serialno'])?$_GET['serialno']:'');
$action = isset($_GET['action'])?$_GET['action']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$toggle_focus = isset($_REQUEST['toggle_focus'])?$_REQUEST['toggle_focus']:'';

if ($serialno == "") {
    if ($periodUnit == 'month') {
        $fyear = date("Y");
        $serialno = date("n");
    } else {
        $x = getWeekOfYear(time());
        $fyear = substr($x, 0, 4);
        $serialno = ltrim(substr($x, 4), '0');
    }
}

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
    $date_start_period = mktime(0, 0, 0, intval($serialno), 1, intval($fyear));
    $date_end_period = mktime(0, 0, 0, intval($serialno)+1, 0, intval($fyear));
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    $daysOfWeek = getDaysOfWeek($fyear, $serialno);
    $date_start_period = $daysOfWeek[0];
    $date_end_period = $daysOfWeek[6];
}

/**
 * Permission check
 */
$querymore1 = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore1);
$querymore2 = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.year='$fyear' AND wcd.date>='$date_start_period' AND wcd.date<='$date_end_period' ORDER BY wcd.date";
$listWorkCalendarsDetail = new request();
$listWorkCalendarsDetail->openWorkCalendarsDetail($querymore2);
$comptListWorkCalendarsDetail = count($listWorkCalendarsDetail->wcd_id);

if ($comptListWorkCalendarsDetail == '0') {
    header("Location: ../general/home.php?msg=noWorkCalendar");
    exit;
}

/**
 * Actions
 */
if ($action == 'chooseEdit') {
    list($wt, $num) = preg_split('/:/', $id);

    if ($wt == enumWorkType::wtNonSpecificTask) {
        header("Location: ../timesheet/editworkhours.php?fyear=$fyear&serialno=$serialno&id=$num");
        exit;
    } else if ($wt == enumWorkType::wtSpecificTask) {
        header("Location: ../timesheet/edittasktime.php?fyear=$fyear&serialno=$serialno&id=$num");
        exit;
    } else if ($wt == enumWorkType::wtSpecificMeeting) {
        header("Location: ../timesheet/editmeetingtime.php?fyear=$fyear&serialno=$serialno&id=$num");
        exit;
    }
} else if ($action == 'chooseDelete') {
    $rowList = explode("**", $id);
    $comptRowList = count($rowList);
    $id0 = '';
    $id1 = '';
    $id2 = '';

    for ($i=0; $i<$comptRowList; $i++) {
        list($wt, $num) = preg_split("/:/", $rowList[$i]);

        if ($wt == enumWorkType::wtNonSpecificTask) {
            if ($id0 != '') {
                $id0 .= '**';
            }

            $id0 .= $num;
        } else if ($wt == enumWorkType::wtSpecificTask) {
            if ($id1 != '') {
                $id1 .= '**';
            }

            $id1 .= $num;
        } else if ($wt == enumWorkType::wtSpecificMeeting) {
            if ($id2 != '') {
                $id2 .= '**';
            }

            $id2 .= $num;
        }
    }

    if ($id0 != '' || $id1 != '' || $id2 != '') {
        header("Location: ../timesheet/deleteworkhours.php?fyear=$fyear&serialno=$serialno&id0=$id0&id1=$id1&id2=$id2");
        exit;
    }
} else if ($action == 'chooseView') {
    list($wt, $num) = preg_split('/:/', $id);

    if ($wt == enumWorkType::wtNonSpecificTask) {
        header("Location: ../timesheet/viewworkhours.php?fyear=$fyear&serialno=$serialno&id=$num");
        exit;
    } else if ($wt == enumWorkType::wtSpecificTask) {
        header("Location: ../timesheet/viewtasktime.php?fyear=$fyear&serialno=$serialno&id=$num");
        exit;
    } else if ($wt == enumWorkType::wtSpecificMeeting) {
        header("Location: ../timesheet/viewmeetingtime.php?fyear=$fyear&serialno=$serialno&id=$num");
        exit;
    }
}

// Initial flexibalance
$initFlexiBalance = '';
// Standard hours
$standardHours = 0;

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $date1 = $listWorkCalendarsDetail->wcd_date[$i];
    $idx = date('Ymd', $date1);
    $standardHours += $listWorkCalendarsDetail->wcd_hours[$i];
    $listOvertime[$idx] = 0 - $listWorkCalendarsDetail->wcd_hours[$i];
    $listOverLeave[$idx] = 0 - $listWorkCalendarsDetail->wcd_hours[$i];
    $dayLabels1[$idx] = date('j', $date1);
    $dayLabels2[$idx] = $dayShortNameArray[date('N', $date1)];
}

if ($memberDetail->mem_enable_flextime[0] == enumBoolean::bFalse) {     // Standard worktime user
    // Overtime hours (Daily)
    $querymore3 = " WHERE wkh.owner='$idSession' AND wkh.date>='$date_start_period' AND wkh.date<='$date_end_period'";
    $listWorkHours = new request();
    $listWorkHours->openWorkHours($querymore3);
    $comptListWorkHours = count($listWorkHours->wkh_id);

    for ($i=0; $i<$comptListWorkHours; $i++) {
        $idx = date('Ymd', $listWorkHours->wkh_date[$i]);
        $listOvertime[$idx] += $listWorkHours->wkh_hours[$i];

        if ($listWorkHours->wkh_work[$i] == enumLeaveType::lvAnnual || $listWorkHours->wkh_work[$i] == enumLeaveType::lvSick || $listWorkHours->wkh_work[$i] == enumLeaveType::lvAbsence || $listWorkHours->wkh_work[$i] == enumLeaveType::lvBankHoliday || $listWorkHours->wkh_work[$i] == enumLeaveType::lvMourning || $listWorkHours->wkh_work[$i] == enumLeaveType::lvHoneyMoon || $listWorkHours->wkh_work[$i] == enumLeaveType::lvMaternity) {
            $listOverLeave[$idx] += $listWorkHours->wkh_hours[$i];
        }
    }

    $querymore4 = " WHERE tim.owner='$idSession' AND tim.date>='$date_start_period' AND tim.date<='$date_end_period'";
    $listTaskTime = new request();
    $listTaskTime->openTaskTime($querymore4);
    $comptListTaskTime = count($listTaskTime->tim_id);

    for ($i=0; $i<$comptListTaskTime; $i++) {
        $idx = date('Ymd', $listTaskTime->tim_date[$i]);
        $listOvertime[$idx] += $listTaskTime->tim_hours[$i];
    }

    $querymore5 = " WHERE mti.owner='$idSession' AND mti.date>='$date_start_period' AND mti.date<='$date_end_period'";
    $listMeetingTime = new request();
    $listMeetingTime->openMeetingTime($querymore5);
    $comptListMeetingTime = count($listMeetingTime->mti_id);

    for ($i=0; $i<$comptListMeetingTime; $i++) {
        $idx = date('Ymd', $listMeetingTime->mti_date[$i]);
        $listOvertime[$idx] += $listMeetingTime->mti_hours[$i];
    }

    // Overtime  hours (total)
    $overtimeHours = 0;

    for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
        $listOvertime[$idx] -= ($listOverLeave[$idx]>0)?$listOverLeave[$idx]:0;

        if ($listOvertime[$idx] < 0) {
            $listOvertime[$idx] = 0;
        }

        $overtimeHours += $listOvertime[$idx];
    }
} else {    // Flex-time user
    $flexiBalance = '0';
    $ftDate = $memberDetail->mem_begin_flextime[0];
    // adjust standard hours if member's begin flextime during this period
    if (($ftDate >= $date_start_period) && ($ftDate <= $date_end_period) && ($memberDetail->mem_initial_flexibalance[0] <> 0)) {
        $initFlexiBalance = '(' . lang_strings('initial_flexibalance') . ' ' . NumberFormatNOD($memberDetail->mem_initial_flexibalance[0], $hourAccuracy, false) . " " . lang_strings('hours') . ')';
        $standardHours -= $memberDetail->mem_initial_flexibalance[0];
    }
    // Flexi balance
    $tmpsql = "SELECT SUM(A.hours) FROM (
    SELECT initial_flexibalance AS hours FROM " . $tablePrefix . "members WHERE id='$idSession'
    UNION ALL
    SELECT hours FROM " . $tablePrefix . "tasks_time WHERE owner='$idSession' AND date>='$ftDate' AND date<='$date_end_period'
    UNION ALL
    SELECT hours FROM " . $tablePrefix . "meetings_time WHERE owner='$idSession' AND date>='$ftDate' AND date<='$date_end_period'
    UNION ALL
    SELECT hours FROM " . $tablePrefix . "work_hours WHERE owner='$idSession' AND date>='$ftDate' AND date<='$date_end_period'
    UNION ALL
    SELECT hours FROM " . $tablePrefix . "flextime_adjustment WHERE owner='$idSession' AND refdate>='$ftDate' AND refdate<='$date_end_period'
    UNION ALL
    SELECT (0 - hours) FROM " . $tablePrefix . "workcalendars_detail WHERE workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND date>='$ftDate' AND date<='$date_end_period'
) A";
    $request1 = new request();
    $request1->connectClass();
    $request1->query($tmpsql);

    if ($request1->fetch()) {
        $fb = ($row[0]);
        $flexiBalance = (is_numeric($fb))?round($fb, $hourAccuracy):'0';
    }

    $request1->close();
}

$date_past7 = addDays($date_start_period, -7);
$comptListTimeSheet = 0;
// Work Hours
$querymore6 = " WHERE wkh.owner='$idSession' AND wkh.date>='$date_past7' AND wkh.date<='$date_end_period' ORDER BY wkh.project, wkh.work, wkh.date";
$listWorkHours = new request();
$listWorkHours->openWorkHours($querymore6);
$comptListWorkHours = count($listWorkHours->wkh_id);

for ($i=0; $i<$comptListWorkHours; $i++) {
    $idx = date('Ymd', $listWorkHours->wkh_date[$i]);

    if ($listWorkHours->wkh_date[$i] < $date_start_period) {
        $hours = 0;
    } else {
        $hours = $listWorkHours->wkh_hours[$i];
    }

    for ($j=0; $j<$comptListTimeSheet; $j++) {
        if ($listTimeSheet->project[$j] == $listWorkHours->wkh_project[$i] && $listTimeSheet->work[$j] == $listWorkHours->wkh_work[$i] && $listTimeSheet->comments[$j] == $listWorkHours->wkh_comments[$i] && $listTimeSheet->service[$j] == $listWorkHours->wkh_service[$i]) {
            break;
        }
    }

    if ($j == $comptListTimeSheet) {
        $listTimeSheet->worktype[$j] = enumWorkType::wtNonSpecificTask;
        $listTimeSheet->id[$j] = enumWorkType::wtNonSpecificTask . ":" . $listWorkHours->wkh_id[$i];
        $listTimeSheet->project[$j] = $listWorkHours->wkh_project[$i];
        $listTimeSheet->work[$j] = $listWorkHours->wkh_work[$i];
        $listTimeSheet->comments[$j] = $listWorkHours->wkh_comments[$i];
        $listTimeSheet->service[$j] = $listWorkHours->wkh_service[$i];
        $listTimeSheet->pro_name[$j] = $listWorkHours->wkh_pro_name[$i];
        $listTimeSheet->period_sum[$j] = 0;

        for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
            $idx1 = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
            $listTimeSheet->hours[$j][$idx1] = 0;
        }

        $listTimeSheet->billing[$j] = $listWorkHours->wkh_billing[$i];
        $comptListTimeSheet++;
    }

    $listTimeSheet->hours[$j][$idx] += $hours;
    $listTimeSheet->period_sum[$j] += $hours;
}

$comptListTimeSheetWorkType = $comptListTimeSheet;
// Task Time
$querymore7 = " WHERE tim.owner='$idSession' AND tim.date>='$date_past7' AND tim.date<='$date_end_period' ORDER BY tim.project, tim.task, tim.date";
$listTaskTime = new request();
$listTaskTime->openTaskTime($querymore7);
$comptListTaskTime = count($listTaskTime->tim_id);

for ($i=0; $i<$comptListTaskTime; $i++) {
    $idx = date('Ymd', $listTaskTime->tim_date[$i]);

    if ($listTaskTime->tim_date[$i] < $date_start) {
        $hours = 0;
    } else {
        $hours = $listTaskTime->tim_hours[$i];
    }

    for ($j=$comptListTimeSheetWorkType; $j<$comptListTimeSheet; $j++) {
        if ($listTimeSheet->project[$j] == $listTaskTime->tim_project[$i] && $listTimeSheet->task[$j] == $listTaskTime->tim_task[$i] && $listTimeSheet->comments[$j] == $listTaskTime->tim_comments[$i] && $listTimeSheet->billing[$j] == $listTaskTime->tim_billing[$i]) {
            break;
        }
    }

    if ($j == $comptListTimeSheet) {
        $listTimeSheet->worktype[$j] = enumWorkType::wtSpecificTask;
        $listTimeSheet->id[$j] = enumWorkType::wtSpecificTask . ":" . $listTaskTime->tim_id[$i];
        $listTimeSheet->project[$j] = $listTaskTime->tim_project[$i];
        $listTimeSheet->task[$j] = $listTaskTime->tim_task[$i];
        $listTimeSheet->comments[$j] = $listTaskTime->tim_comments[$i];
        $listTimeSheet->service[$j] = $listTaskTime->tim_service[$i];
        $listTimeSheet->pro_name[$j] = $listTaskTime->tim_pro_name[$i];
        $listTimeSheet->task_name[$j] = $listTaskTime->tim_task_name[$i];
        $listTimeSheet->period_sum[$j] = 0;

        for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
            $idx1 = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
            $listTimeSheet->hours[$j][$idx1] = 0;
        }

        $listTimeSheet->billing[$j] = $listTaskTime->tim_billing[$i];
        $comptListTimeSheet++;
    }

    $listTimeSheet->hours[$j][$idx] += $hours;
    $listTimeSheet->period_sum[$j] += $hours;
}

$comptListTimeSheetWorkType = $comptListTimeSheet;
// Meeting Time
$querymore8 = " WHERE mti.owner='$idSession' AND mti.date>='$date_past7' AND mti.date<='$date_end_period' ORDER BY mti.project, mti.meeting, mti.date";
$listMeetingTime = new request();
$listMeetingTime->openMeetingTime($querymore8);
$comptListMeetingTime = count($listMeetingTime->mti_id);

for ($i=0; $i<$comptListMeetingTime; $i++) {
    $idx = date('Ymd', $listMeetingTime->mti_date[$i]);

    if ($listMeetingTime->mti_date[$i] < $date_start) {
        $hours = 0;
    } else {
        $hours = $listMeetingTime->mti_hours[$i];
    }

    for ($j=$comptListTimeSheetWorkType; $j<$comptListTimeSheet; $j++) {
        if ($listTimeSheet->project[$j] == $listMeetingTime->mti_project[$i] && $listTimeSheet->meeting[$j] == $listMeetingTime->mti_meeting[$i] && $listTimeSheet->comments[$j] == $listMeetingTime->mti_comments[$i]) {
            break;
        }
    }

    if ($j == $comptListTimeSheet) {
        $listTimeSheet->worktype[$j] = enumWorkType::wtSpecificMeeting;
        $listTimeSheet->id[$j] = enumWorkType::wtSpecificMeeting . ":" . $listMeetingTime->mti_id[$i];
        $listTimeSheet->project[$j] = $listMeetingTime->mti_project[$i];
        $listTimeSheet->meeting[$j] = $listMeetingTime->mti_meeting[$i];
        $listTimeSheet->comments[$j] = $listMeetingTime->mti_comments[$i];
        $listTimeSheet->service[$j] = '0';
        $listTimeSheet->pro_name[$j] = $listMeetingTime->mti_pro_name[$i];
        $listTimeSheet->meeting_name[$j] = $listMeetingTime->mti_mee_name[$i];
        $listTimeSheet->period_sum[$j] = 0;

        for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
            $idx1 = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
            $listTimeSheet->hours[$j][$idx1] = 0;
        }

        $listTimeSheet->billing[$j] = enumBoolean::bFalse;
        $comptListTimeSheet++;
    }

    $listTimeSheet->hours[$j][$idx] += $hours;
    $listTimeSheet->period_sum[$j] += $hours;
}

$comptListTimeSheetWorkType = $comptListTimeSheet;
// Flextime Adjustment
$fta_hours = 0;
$querymore9 = " WHERE fta.owner='$idSession' AND fta.refdate>='$date_past7' AND fta.refdate<='$date_end_period' ORDER BY fta.refdate";
$listFlextimeAdjustment = new request();
$listFlextimeAdjustment->openFlextimeAdjustment($querymore9);
$comptListFlextimeAdjustment = count($listFlextimeAdjustment->fta_id);

for ($i=0; $i<$comptListFlextimeAdjustment; $i++) {
    $idx = date('Ymd', $listFlextimeAdjustment->fta_refdate[$i]);

    if ($listFlextimeAdjustment->fta_refdate[$i] < $date_start) {
        $hours = 0;
    } else {
        $hours = $listFlextimeAdjustment->fta_hours[$i];
    }

    for ($j=$comptListTimeSheetWorkType; $j<$comptListTimeSheet; $j++) {
        if ($listTimeSheet->worktype[$j] == enumWorkType::wtFlextimeAdjustment && $listTimeSheet->comments[$j] == $listFlextimeAdjustment->fta_comments[$i]) {
            break;
        }
    }

    if ($j == $comptListTimeSheet) {
        $listTimeSheet->worktype[$j] = enumWorkType::wtFlextimeAdjustment;
        $listTimeSheet->id[$j] = enumWorkType::wtFlextimeAdjustment . ":" . $listFlextimeAdjustment->fta_id[$i];
        $listTimeSheet->comments[$j] = $listFlextimeAdjustment->fta_comments[$i];
        $listTimeSheet->period_sum[$j] = 0;

        for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
            $idx1 = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
            $listTimeSheet->hours[$j][$idx1] = 0;
        }

        $listTimeSheet->billing[$j] = enumBoolean::bFalse;
        $comptListTimeSheet++;
    }

    $listTimeSheet->hours[$j][$idx] += $hours;
    $listTimeSheet->period_sum[$j] += $hours;
    $fta_hours += $hours;
}

// Actual hours & Billable hours (Period)
$memberTimeOfPeriodDetail = new request();
$actualHours = $memberTimeOfPeriodDetail->getMemberTimeOfPeriod($idSession, $date_start_period, $date_end_period);
$actualHours += $fta_hours;     // Flextime adjustments included
$billableHours = $memberTimeOfPeriodDetail->getMemberBillableTimeOfPeriod($idSession, $date_start_period, $date_end_period);
$querymore10 = " WHERE tim.owner='$idSession' AND per.fyear='$fyear' AND per.serial_no='$serialno'";
$timesheetDetail = new request();
$timesheetDetail->openTimesheet($querymore10);
$comptTimesheetDetail = count($timesheetDetail->tim_owner);

if ($comptTimesheetDetail == '0') {
    $timesheetReadOnly = false;
} else if ($timesheetDetail->tim_status[0] == enumFileStatus::stNeedsApproval) {
    $timesheetReadOnly = true;
} else {
    $timesheetReadOnly = false;
}

$period_locked = periodLocked($date_start_period);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../timesheet/viewtimesheet.php', lang_strings('timesheet'), 'in'));
$blockPage->itemBreadcrumbs("$serialname $fyear");
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = '1';
$title = $strings['timesheet'] . ' : ' . $serialname . ' ' . $fyear;
logURL($title, "../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno");
$block4 = new block();

if ($periodUnit == 'month') {
    if (intval($serialno) == 1) {
        $fyearPrevMonth = intval($fyear) - 1;
        $serialnoPrevMonth = '12';
        $fyearNextMonth = $fyear;
        $serialnoNextMonth = intval($serialno) + 1;
    } elseif (intval($serialno) == 12) {
        $fyearPrevMonth = $fyear;
        $serialnoPrevMonth = intval($serialno) - 1;
        $fyearNextMonth = intval($fyear) + 1;
        $serialnoNextMonth = '1';
    } else {
        $fyearPrevMonth = $fyear;
        $serialnoPrevMonth = intval($serialno) - 1;
        $fyearNextMonth = $fyear;
        $serialnoNextMonth = intval($serialno) + 1;
    }

    $block4->heading('<div class="right"><a href="../timesheet/viewtimesheet.php?fyear=' . $fyearNextMonth . '&amp;serialno=' . $serialnoNextMonth . '"><div class="solid-ball">&gt;</div></a></div><div class="left"><a href="../timesheet/viewtimesheet.php?fyear=' . $fyearPrevMonth . '&amp;serialno=' . $serialnoPrevMonth . '"><div class="solid-ball">&lt;</div></a></div><div class="screen-center">' . "$serialname $fyear</div>");
} else {
    $w1 = getWeekOfYear(addDays($date_start_period, -1));
    $fyearPrevWeek = substr($w1, 0, 4);
    $serialnoPrevWeek = ltrim(substr($w1, 4), '0');
    $w2 = getWeekOfYear(addDays($date_end_period, 1));
    $fyearNextWeek = substr($w2, 0, 4);
    $serialnoNextWeek = ltrim(substr($w2, 4), '0');
    $block4->heading('<div class="right"><a href="../timesheet/viewtimesheet.php?fyear=' . $fyearNextWeek . '&amp;serialno=' . $serialnoNextWeek . '"><div class="solid-ball">&gt;</div></a></div><div class="left"><a href="../timesheet/viewtimesheet.php?fyear=' . $fyearPrevWeek . '&amp;serialno=' . $serialnoPrevWeek . '"><div class="solid-ball">&lt;</div></a></div><div class="screen-center">' . "$serialname $fyear</div>");
}

$block4->form = "ts4";
$block4->openForm("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;section=workhour#" . $block4->form . "Anchor");
$block4->headingToggle($strings['timesheet'], !($toggle_focus==''));

if (!$timesheetReadOnly && !$period_locked && $actualHours > 0) {
    $block4->openPaletteIcon();
    $block4->paletteIcon(13, 'submit_timesheet', $strings['submit_timesheet']);
    $block4->closePaletteIcon();
}

if ($comptTimesheetDetail == '0') {
    $statusText = lang_strings('open');
} else {
    $statusText = $statusFile[$timesheetDetail->tim_status[0]];
}

$block4->openContent();
$block4->contentRow(lang_strings('date_range'), createDate($date_start_period,'date',false,true) . " ~ " . createDate($date_end_period,'date',false,true));
$block4->contentRow(lang_strings('owner'), $blockPage->buildLink($idSession, '', 'message'));
$block4->contentRow(lang_strings('status'), $statusText);
$block4->contentRow(lang_strings('standard'), NumberFormatNOD($standardHours, $hourAccuracy, false) . " " . lang_strings('hours') . $initFlexiBalance);
$block4->contentRow(lang_strings('actual'), NumberFormatNOD($actualHours, $hourAccuracy, false) . " " . lang_strings('hours'));

if ($memberDetail->mem_enable_flextime[0] == enumBoolean::bFalse) {     // Standard worktime user
    $block4->contentRow(lang_strings('overtime'), NumberFormatNOD($overtimeHours, $hourAccuracy, false) . " " . lang_strings('hours'));
} else {                                                    // Flex-time user
    $block4->contentRow(lang_strings('flexibalance'), NumberFormatNOD($flexiBalance, $hourAccuracy, false) . " " . lang_strings('hours'));
}

$block4->contentRow(lang_strings('billable'), NumberFormatNOD($billableHours, $hourAccuracy, false) . " " . lang_strings('hours'));
$block4->closeContent();
$block4->closeToggle();

if ($comptTimesheetDetail != '0' && $timesheetDetail->tim_status[0] != enumFileStatus::stNoApprovalsNeeded) {
    $block4->headingToggle(lang_strings("approval_history"));
    $block4->openContent();
    $querymore = " WHERE dap.docid='" . $timesheetDetail->tim_id[0] . "' AND dap.doctype='timesheet' ORDER BY dap.id";
    $listDocumentsApproval = new request();
    $listDocumentsApproval->openDocumentsApproval($querymore);
    $comptListDocumentsApproval = count($listDocumentsApproval->dap_id);

    for ($i=0; $i<$comptListDocumentsApproval; $i++) {
        if ($i == 0) {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['submit_at']) . '</i>';
        } else {
            $left = '<i>' . str_replace('%TIME%', createDate($listDocumentsApproval->dap_created[$i], 'both'), $strings['resubmit_at']) . '</i>';
        }

        $querymore = " WHERE daa.document_approval=" . $listDocumentsApproval->dap_id[$i] . " AND daa.status<>'" . enumApprovalStatus::stPending . "' ORDER BY daa.created,daa.modified";
        $listDocumentsApprovalAuthorizer = new request();
        $listDocumentsApprovalAuthorizer->openDocumentsApprovalAuthorizers($querymore);
        $comptListDocumentsApprovalAuthorizer = count($listDocumentsApprovalAuthorizer->daa_document_approval);

        for ($j=0,$right=''; $j<$comptListDocumentsApprovalAuthorizer; $j++,$right.='<br>') {
            $ahd = '';

            if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stApproved) {
                $ahd = $strings['approval_history_approved'];
            } else if ($listDocumentsApprovalAuthorizer->daa_status[$j] == enumApprovalStatus::stNotApproved) {
                $ahd = $strings['approval_history_rejected'];
            }

            if ($ahd != '') {
                $ahd0 = str_replace('%AUTHORIZER%', $listDocumentsApprovalAuthorizer->daa_mem_name[$j], $ahd);
                $ahd1 = str_replace('%TIME%', createDate($listDocumentsApprovalAuthorizer->daa_modified[$j], 'both'), $ahd0);
                $right .= '<i>' . $ahd1  . '</i>';

                if ($listDocumentsApprovalAuthorizer->daa_comments[$j] != '') {
                    $right .= '<br>' . $listDocumentsApprovalAuthorizer->daa_comments[$j];
                }
            }
        }

        $block4->contentRow($left, $right);
    }

    $block4->closeContent();
    $block4->closeToggle();
}

if (!$timesheetReadOnly && !$period_locked && $actualHours > 0) {
    $block4->openPaletteScript();
    $block4->paletteScript(13, 'submit_timesheet', "../timesheet/submittimesheet.php?fyear=$fyear&serialno=$serialno", 'true,false,false', $strings['submit_timesheet']);
    $block4->closePaletteScript("", "");
}

$block4->closeForm();
$block3 = new block();
$block3->form = "ts3";
$block3->openForm("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;section=workhour#" . $block3->form . "Anchor");
$block3->headingToggle(lang_strings('logtime'), !($toggle_focus=='logtime'));
$block3->openPaletteIcon();

if (!$timesheetReadOnly && !$period_locked) {
    $block3->paletteIcon(0, "add_work_hours", $strings["add_work_hours"]);
    $block3->paletteIcon(2, "timelog", $strings["add_task_time"]);
    $block3->paletteIcon(3, "add_meeting_time", $strings["add_meeting_time"]);
    $block3->paletteIcon(1, "remove", $strings["delete"]);
    $block3->paletteIcon(7, "edit", $strings["edit"]);
}

$block3->paletteIcon(6, "info", $strings["view"]);
$block3->closePaletteIcon();

if ($comptListTimeSheet > 0) {
    for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
        $listSubTotal[$idx] = 0;
    }

    $listSubTotal['all'] = 0;
    $labels1 = array();
    $labels2 = array();

    if ($periodUnit == 'month') {
        $labels1[] = '&nbsp;';
        $labels2[] = lang_strings('item');
    } else {
        $labels1[] = '&nbsp;';
        $labels1[] = '&nbsp;';
        $labels2[] = lang_strings('project');
        $labels2[] = lang_strings('item');
    }

    for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
        $labels1[] = $dayLabels1[$idx];
        $labels2[] = $dayLabels2[$idx];
    }

    $labels1[] = '&nbsp;';
    $labels2[] = lang_strings('ru_subtotal');
    $block3->openResults();
    $block3->labels($labels1, 'false', 'false');
    $block3->labels($labels2, 'false', 'false', '', true);
    $l = 0;

    for ($i=0; $i<$comptListTimeSheet; $i++) {
        if ($listTimeSheet->period_sum[$i] == 0) {
            continue;
        }

        $l++;

        switch ($listTimeSheet->worktype[$i]) {
            case enumWorkType::wtNonSpecificTask: // nonspecific project task & leave work hours
                $taskSubtotal = 0;
                $block3->openRow($listTimeSheet->id[$i]);

                if ($periodUnit == 'month') {
                    $itemCell = $listTimeSheet->work[$i] . " - " . $strings['HRC__' . $listTimeSheet->work[$i]];

                    if ($listTimeSheet->comments[$i] != '') {
                        $itemCell .= "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>";
                    }

                    $block3->cellRow($itemCell);

                    for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
                        $taskSubtotal += $listTimeSheet->hours[$i][$idx];
                        $listSubTotal[$idx] += $listTimeSheet->hours[$i][$idx];
                        $block3->cellRow($listTimeSheet->hours[$i][$idx]);
                    }

                    $block3->cellRow($taskSubtotal);
                } else {
                    $block3->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTimeSheet->project[$i], $listTimeSheet->pro_name[$i], 'in'));
                    $itemCell = $listTimeSheet->work[$i] . " - " . $strings['HRC__' . $listTimeSheet->work[$i]];

                    if ($listTimeSheet->comments[$i] != '') {
                        $itemCell .= "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>";
                    }

                    $block3->cellRow($itemCell);

                    for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
                        $taskSubtotal += $listTimeSheet->hours[$i][$idx];
                        $listSubTotal[$idx] += $listTimeSheet->hours[$i][$idx];
                        $block3->cellRow($listTimeSheet->hours[$i][$idx]);
                    }

                    $block3->cellRow($taskSubtotal);
                }

                $listSubTotal['all'] += $taskSubtotal;
                $block3->closeRow();
                break;
            case enumWorkType::wtSpecificTask: // specific project tasks time
                $taskSubtotal = 0;
                $block3->openRow($listTimeSheet->id[$i]);

                if ($periodUnit == 'month') {
                    if ($listTimeSheet->comments[$i] == '') {
                        $itemCell = $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTimeSheet->task[$i], $listTimeSheet->task_name[$i], 'in');
                    } else {
                        $itemCell = $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTimeSheet->task[$i], $listTimeSheet->task_name[$i] . "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>", 'in');
                    }

                    $block3->cellRow($itemCell);

                    for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
                        $taskSubtotal += $listTimeSheet->hours[$i][$idx];
                        $listSubTotal[$idx] += $listTimeSheet->hours[$i][$idx];
                        $block3->cellRow($listTimeSheet->hours[$i][$idx]);
                    }

                    $block3->cellRow($taskSubtotal);
                } else {
                    $block3->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTimeSheet->project[$i], $listTimeSheet->pro_name[$i], 'in'));

                    if ($listTimeSheet->comments[$i] == '') {
                        $itemCell = $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTimeSheet->task[$i], $listTimeSheet->task_name[$i], 'in');
                    } else {
                        $itemCell = $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTimeSheet->task[$i], $listTimeSheet->task_name[$i] . "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>", 'in');
                    }

                    $block3->cellRow($itemCell);

                    for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
                        $taskSubtotal += $listTimeSheet->hours[$i][$idx];
                        $listSubTotal[$idx] += $listTimeSheet->hours[$i][$idx];
                        $block3->cellRow($listTimeSheet->hours[$i][$idx]);
                    }

                    $block3->cellRow($taskSubtotal);
                }

                $listSubTotal['all'] += $taskSubtotal;
                $block3->closeRow();
                break;
            case enumWorkType::wtSpecificMeeting: // specific project meetings time
                $taskSubtotal = 0;
                $block3->openRow($listTimeSheet->id[$i]);

                if ($periodUnit == 'month') {
                    if ($listTimeSheet->comments[$i] == '') {
                        $itemCell = $blockPage->buildLink("../meetings/viewmeeting.php?id=" . $listTimeSheet->meeting[$i], $listTimeSheet->meeting_name[$i], 'in');
                    } else {
                        $itemCell = $blockPage->buildLink("../meetings/viewmeeting.php?id=" . $listTimeSheet->meeting[$i], $listTimeSheet->meeting_name[$i] . "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>", 'in');
                    }

                    $block3->cellRow($itemCell);

                    for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
                        $taskSubtotal += $listTimeSheet->hours[$i][$idx];
                        $listSubTotal[$idx] += $listTimeSheet->hours[$i][$idx];
                        $block3->cellRow($listTimeSheet->hours[$i][$idx]);
                    }

                    $block3->cellRow($taskSubtotal);
                } else {
                    $block3->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTimeSheet->project[$i], $listTimeSheet->pro_name[$i], 'in'));

                    if ($listTimeSheet->comments[$i] == '') {
                        $itemCell = $blockPage->buildLink("../meetings/viewmeeting.php?id=" . $listTimeSheet->meeting[$i], $listTimeSheet->meeting_name[$i], 'in');
                    } else {
                        $itemCell = $blockPage->buildLink("../meetings/viewmeeting.php?id=" . $listTimeSheet->meeting[$i], $listTimeSheet->meeting_name[$i] . "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>", 'in');
                    }

                    $block3->cellRow($itemCell);

                    for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
                        $taskSubtotal += $listTimeSheet->hours[$i][$idx];
                        $listSubTotal[$idx] += $listTimeSheet->hours[$i][$idx];
                        $block3->cellRow($listTimeSheet->hours[$i][$idx]);
                    }

                    $block3->cellRow($taskSubtotal);
                }

                $listSubTotal['all'] += $taskSubtotal;
                $block3->closeRow();
                break;
            case enumWorkType::wtFlextimeAdjustment:    // flextime adjustment
                $taskSubtotal = 0;
                $block3->openRow($listTimeSheet->id[$i]);

                if ($periodUnit == 'month') {
                    $itemCell = "<sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>";
                    $block3->cellRow($itemCell, 10);

                    for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
                        $taskSubtotal += $listTimeSheet->hours[$i][$idx];
                        $listSubTotal[$idx] += $listTimeSheet->hours[$i][$idx];
                        $block3->cellRow($listTimeSheet->hours[$i][$idx]);
                    }

                    $block3->cellRow($taskSubtotal);
                } else {
                    $block3->cellRow('&nbsp;');
                    $itemCell = "<sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>";
                    $block3->cellRow($itemCell);

                    for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
                        $taskSubtotal += $listTimeSheet->hours[$i][$idx];
                        $listSubTotal[$idx] += $listTimeSheet->hours[$i][$idx];
                        $block3->cellRow($listTimeSheet->hours[$i][$idx]);
                    }

                    $block3->cellRow($taskSubtotal);
                }

                $listSubTotal['all'] += $taskSubtotal;
                $block3->closeRow();
                break;
        }
    }

    if ($l > 0) {
        $block3->openRow('', true);

        if ($periodUnit == 'month') {
            $block3->cellRow('');

            for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
                $block3->cellRow($listSubTotal[$idx]);
            }

            $block3->cellRow($listSubTotal['all']);
        } else {
            $block3->cellRow('');
            $block3->cellRow('');

            for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$k]);
                $block3->cellRow($listSubTotal[$idx]);
            }

            $block3->cellRow($listSubTotal['all']);
        }

        $block3->closeRow();
    }

    for ($i=0; $i<$comptListTimeSheet; $i++) {
        if ($listTimeSheet->period_sum[$i] != 0) {
            continue;
        }

        if ($listTimeSheet->worktype[$i] == enumWorkType::wtNonSpecificTask) {
        // nonspecific project task & leave work hours
            $taskSubtotal = 0;
            $block3->openRow($listTimeSheet->id[$i]);

            if ($periodUnit == 'month') {
                $itemCell = $listTimeSheet->work[$i] . " - " . $strings['HRC__' . $listTimeSheet->work[$i]];

                if ($listTimeSheet->comments[$i] != '') {
                    $itemCell .= "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>";
                }

                $block3->cellRow($itemCell);

                for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                    $block3->cellRow('');
                }

                $block3->cellRow('');
            } else {
                $block3->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTimeSheet->project[$i], $listTimeSheet->pro_name[$i], 'in'));
                $itemCell = $listTimeSheet->work[$i] . " - " . $strings['HRC__' . $listTimeSheet->work[$i]];

                if ($listTimeSheet->comments[$i] != '') {
                    $itemCell .= "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>";
                }

                $block3->cellRow($itemCell);

                for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                    $block3->cellRow('');
                }

                $block3->cellRow('');
            }

            $block3->closeRow();
        } else if ($listTimeSheet->worktype[$i] == enumWorkType::wtSpecificTask) {
        // specific project tasks time
            $taskSubtotal = 0;
            $block3->openRow($listTimeSheet->id[$i]);

            if ($periodUnit == 'month') {
                if ($listTimeSheet->comments[$i] == '') {
                    $itemCell = $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTimeSheet->task[$i], $listTimeSheet->task_name[$i], 'in');
                } else {
                    $itemCell = $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTimeSheet->task[$i], $listTimeSheet->task_name[$i] . "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>", 'in');
                }

                $block3->cellRow($itemCell);

                for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                    $block3->cellRow('');
                }

                $block3->cellRow('');
            } else {
                $block3->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTimeSheet->project[$i], $listTimeSheet->pro_name[$i], 'in'));

                if ($listTimeSheet->comments[$i] == '') {
                    $itemCell = $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTimeSheet->task[$i], $listTimeSheet->task_name[$i], 'in');
                } else {
                    $itemCell = $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTimeSheet->task[$i], $listTimeSheet->task_name[$i] . "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>", 'in');
                }

                $block3->cellRow($itemCell);

                for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                    $block3->cellRow('');
                }

                $block3->cellRow('');
            }

            $block3->closeRow();
        } else if ($listTimeSheet->worktype[$i] == enumWorkType::wtSpecificMeeting) {
        // specific project meetings time
            $taskSubtotal = 0;
            $block3->openRow($listTimeSheet->id[$i]);

            if ($periodUnit == 'month') {
                if ($listTimeSheet->comments[$i] == '') {
                    $itemCell = $blockPage->buildLink("../meetings/viewmeeting.php?id=" . $listTimeSheet->meeting[$i], $listTimeSheet->meeting_name[$i], 'in');
                } else {
                    $itemCell = $blockPage->buildLink("../meetings/viewmeeting.php?id=" . $listTimeSheet->meeting[$i], $listTimeSheet->meeting_name[$i] . "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>", 'in');
                }

                $block3->cellRow($itemCell);

                for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                    $block3->cellRow('');
                }

                $block3->cellRow('');
            } else {
                $block3->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTimeSheet->project[$i], $listTimeSheet->pro_name[$i], 'in'));

                if ($listTimeSheet->comments[$i] == '') {
                    $itemCell = $blockPage->buildLink("../meetings/viewmeeting.php?id=" . $listTimeSheet->meeting[$i], $listTimeSheet->meeting_name[$i], 'in');
                } else {
                    $itemCell = $blockPage->buildLink("../meetings/viewmeeting.php?id=" . $listTimeSheet->meeting[$i], $listTimeSheet->meeting_name[$i] . "<br><sub>" . convert_html2txt($listTimeSheet->comments[$i]) . "</sub>", 'in');
                }

                $block3->cellRow($itemCell);

                for ($k=0; $k<$comptListWorkCalendarsDetail; $k++) {
                    $block3->cellRow('');
                }

                $block3->cellRow('');
            }

            $block3->closeRow();
        }
    }

    $block3->closeResults();
} else {
    $block3->noresults();
}

$block3->closeToggle();
$block3->closeFormResults();
$block3->openPaletteScript();

if (!$timesheetReadOnly && !$period_locked) {
    $block3->paletteScript(0, "add_work_hours", "../timesheet/editworkhours.php?fyear=$fyear&serialno=$serialno", "true,false,false", $strings["add_work_hours"]);
    $block3->paletteScript(2, "timelog", "../timesheet/edittasktime.php?fyear=$fyear&serialno=$serialno", "true,false,false", $strings["add_task_time"]);
    $block3->paletteScript(3, "add_meeting_time", "../timesheet/editmeetingtime.php?fyear=$fyear&serialno=$serialno", "true,false,false", $strings["add_meeting_time"]);
    $block3->paletteScript(1, "remove", "../timesheet/viewtimesheet.php?action=chooseDelete&fyear=$fyear&serialno=$serialno", "false,true,true", $strings["delete"]);
    $block3->paletteScript(7, "edit", "../timesheet/viewtimesheet.php?action=chooseEdit&fyear=$fyear&serialno=$serialno", "false,true,false", $strings["edit"]);
}

$block3->paletteScript(6, "info", "../timesheet/viewtimesheet.php?action=chooseView&fyear=$fyear&serialno=$serialno", "false,true,false", $strings["view"]);
$block3->closePaletteScript($comptListTimeSheet, isset($listTimeSheet->id)?$listTimeSheet->id:array());
// leave requests
$block5 = new block();
$block5->form = "leaV";
$block5->openForm("../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&amp;section=leaverequest#" . $block5->form . "Anchor");
$block5->headingToggle(lang_strings('leave_requests'), !($toggle_focus=='leave_requests'));
$block5->borne = $blockPage->returnBorne('1');
$block5->rowsLimit = '12';
$block5->sorting('leave_requests', (isset($sortingUser['leave_requests'])?$sortingUser['leave_requests']:''), 'lea.date_start DESC', $sortingFields = array(0 => 'none', 1 => 'none', 2 => 'none', 3 => 'none', 4 => 'none'));
$querymore = " WHERE lea.owner='$idSession' AND (lea.date_start>='$date_start_period' AND lea.date_start<='$date_end_period' OR lea.date_end>='$date_start_period' AND lea.date_end<='$date_end_period') ORDER BY lea.date_start DESC";
$block5->recordsTotal = compt($initrequest['leave_requests'] . ' ' . $querymore);
$listLeaveRequests = new request();
$listLeaveRequests->openLeaveRequests($querymore, $block5->borne, $block5->rowsLimit);
$comptListLeaveRequests = count($listLeaveRequests->lea_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['type'];
$columns[0]->field_type = enumFieldType::ftText;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['date_start'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['date_end'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['hours'];
$columns[3]->field_type = enumFieldType::ftHours;
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['status'];
$columns[4]->field_type = enumFieldType::ftText;
$opt = array();
$opt[enumCardviewOption::oObject] = 'leave_requests';
$opt[enumCardviewOption::oTableName] = 'leave_requests';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oExtraParameters] = "fyear=$fyear&serialno=$serialno";
$opt[enumCardviewOption::oAddUrl] = "../leaves/editleaverequest.php?fyear=$fyear&serialno=$serialno";
$block5->openCardView($opt);

for ($i=0; $i<$comptListLeaveRequests; $i++) {
    $content = array(
        $strings['HRC__' . $listLeaveRequests->lea_type[$i]],
        createDate($listLeaveRequests->lea_date_start[$i], 'date', false, true) . ' ' . DbValueDecode(enumFieldType::ftTime, $listLeaveRequests->lea_time_start[$i]),
        createDate($listLeaveRequests->lea_date_end[$i], 'date', false, true) . ' ' . DbValueDecode(enumFieldType::ftTime, $listLeaveRequests->lea_time_end[$i]),
        $listLeaveRequests->lea_hours_total[$i],
        $statusFile[$listLeaveRequests->lea_status[$i]]
    );
    $block5->itemCardView($listLeaveRequests->lea_id[$i], $content);
}

$block5->closeCardView();
$block5->bornesFooter('1', $blockPage->bornesNumber, "toggle_focus=leave_requests&fyear=$fyear&serialno=$serialno&amp;section=leaverequest");
$block5->closeToggle();
$block5->closeFormResults();
require_once("../includes/footer.php");
