<?php // $Revision: 1.25 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewworkhours.php,v 1.25 2013/01/29 08:46:26 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

if ($enableTimesheet != 'true') {
    header('Location: ../general/home.php');
    exit;
}

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$fyear = AddSlashesNOD(isset($_GET['fyear'])?$_GET['fyear']:'');
$serialno = AddSlashesNOD(isset($_GET['serialno'])?$_GET['serialno']:'');
$logHours = array();

if ($periodUnit == 'month') {
    $serialname = $monthNameArray[$serialno];
    $date_start_period = mktime(0, 0, 0, intval($serialno), 1, intval($fyear));
    $date_end_period = mktime(0, 0, 0, intval($serialno)+1, 0, intval($fyear));
} else {
    $serialname = lang_strings('week') . '&nbsp;' . $serialno;
    $daysOfWeek = getDaysOfWeek($fyear, $serialno);
    $date_start_period = $daysOfWeek[0];
    $date_end_period = $daysOfWeek[6];
}

/**
 * Permission check
 */
$querymore1 = " WHERE mem.id='$idSession'";
$memberDetail = new request();
$memberDetail->openMembers($querymore1);
$querymore2 = " WHERE wcd.workcalendar='" . $memberDetail->mem_workcalendar[0] . "' AND wcd.year='$fyear' AND wcd.date>='$date_start_period' AND wcd.date<='$date_end_period' ORDER BY wcd.date";
$listWorkCalendarsDetail = new request();
$listWorkCalendarsDetail->openWorkCalendarsDetail($querymore2);
$comptListWorkCalendarsDetail = count($listWorkCalendarsDetail->wcd_id);

if ($comptListWorkCalendarsDetail == '0') {
    header("Location: ../general/home.php?msg=noWorkCalendar");
    exit;
} else {
    for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
        $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
        $logHours[$idx] = 0;
    }
}

$querymore3 = " WHERE wkh.id='$id'";
$workHoursDetail = new request();
$workHoursDetail->openWorkHours($querymore3);

if ($workHoursDetail->wkh_owner[0] != $idSession) {
    header("Location: ../timesheet/viewtimesheet.php?fyear=$fyear&serialno=$serialno&msg=permissiondenied&toggle_focus=logtime");
    exit;
}

/**
 * Prepare data
 */
$prj = $workHoursDetail->wkh_project[0];
$wk = $workHoursDetail->wkh_work[0];
$comm = $workHoursDetail->wkh_comments[0];
$serv = $workHoursDetail->wkh_service[0];
$wt = $workHoursDetail->wkh_hrc_hourtype[0];
$querymore4 = " WHERE wkh.project='$prj' AND wkh.work='$wk' AND wkh.owner='$idSession' AND wkh.date>='$date_start_period' AND wkh.date<='$date_end_period' and wkh.comments='" . HtmlEntitiesNOD($workHoursDetail->wkh_comments[0]) . "' AND wkh.service='$serv'";
$listWorkHours = new request();
$listWorkHours->openWorkHours($querymore4);
$comptListWorkHours = count($listWorkHours->wkh_id);

for ($i=0; $i<$comptListWorkHours; $i++) {
    $idx = date('Ymd', $listWorkHours->wkh_date[$i]);
    $logHours[$idx] += $listWorkHours->wkh_hours[$i];
}

$querymore = " WHERE tim.owner='$idSession' AND per.fyear='$fyear' AND per.serial_no='$serialno'";
$listTimesheet = new request();
$listTimesheet->openTimesheet($querymore);
$comptListTimesheet = count($listTimesheet->tim_owner);
$timesheetReadOnly = false;

for ($i=0; $i<$comptListTimesheet; $i++) {
    if ($listTimesheet->tim_status[$i] == enumFileStatus::stNeedsApproval) {
        $timesheetReadOnly = true;
        break;
    }
}

$periodLocked = periodLocked($date_start_period);
// get member actual log hours of days
$memberActualHours = new request();
$memberActualHours->getMemberTimeOfDays($idSession, $date_start_period, $date_end_period);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../timesheet/viewtimesheet.php?toggle_focus=logtime', lang_strings('timesheet'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;toggle_focus=logtime", "$serialname $fyear", 'in'));
$blockPage->itemBreadcrumbs(lang_strings('view_work_hours'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "vwh";
$block1->openForm("../timesheet/viewtimesheet.php?fyear=$fyear&amp;serialno=$serialno&amp;section=workhour&amp;toggle_focus=logtime#" . $block1->form . "Anchor");
$block1->heading(lang_strings('view_work_hours'));

if (!$periodLocked && !$timesheetReadOnly) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(1, "remove", $strings["delete"]);
    $block1->paletteIcon(7, "edit", $strings["edit"]);
    $block1->closePaletteIcon();
}

$block1->openContent();
$block1->contentTitle(lang_strings('details'));
$block1->contentRow(lang_strings("hourtype"), $strings['HRT__' . $wt]);

if ($prj != '0') {
    $block1->contentRow(lang_strings('project'), $listWorkHours->wkh_pro_name[0]);
}

$block1->contentRow(lang_strings("hourcode"), $wk . " - " . $strings['HRC__' . $wk]);

if ($listWorkHours->wkh_service[0] == "0") {
    $servContent = lang_strings('none');
} else {
    $servContent = $listWorkHours->wkh_svc_name_print[0];
}

$block1->contentRow(lang_strings('service'), $servContent);
$block1->contentRow(lang_strings('comments'), $comm);
$block1->closeContent();
$labels1 = array('&nbsp;');
$labels2 = array('&nbsp;');

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $j = date('j', $listWorkCalendarsDetail->wcd_date[$i]);
    $N = date('N', $listWorkCalendarsDetail->wcd_date[$i]);
    $labels1[] = '<abbr title="' . createDate($listWorkCalendarsDetail->wcd_date[$i], 'date', false, true) . ' ' . convert_html2txt($listWorkCalendarsDetail->wcd_comments[$i]) . '">' . $j . '</abbr>';
    $labels2[] = $dayShortNameArray[$N];
}

$block1->openResults(false);
$block1->labels($labels1, 'false', 'false', '');
$block1->labels($labels2, 'false', 'false', '');
$block1->openRow();
$block1->cellRow(lang_strings('standard'));

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $block1->cellRow($listWorkCalendarsDetail->wcd_hours[$i]);
}

$block1->closeRow();
$block1->openRow();
$block1->cellRow(lang_strings('actual'));

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $dt = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
    $block1->cellRow(((isset($memberActualHours->mem_hours[$dt]))?$memberActualHours->mem_hours[$dt]:'0'));
}

$block1->closeRow();
$block1->openRow();
$block1->cellRow(lang_strings('work_hours'));

for ($i=0; $i<$comptListWorkCalendarsDetail; $i++) {
    $idx = date('Ymd', $listWorkCalendarsDetail->wcd_date[$i]);
    $block1->cellRow($logHours[$idx]);
}

$block1->closeRow();
$block1->closeResults();

if (!$periodLocked && !$timesheetReadOnly) {
    $block1->openPaletteScript();
    $block1->paletteScript(1, "remove", "../timesheet/deleteworkhours.php?fyear=$fyear&serialno=$serialno&id0=$id", "true,true,false", $strings["delete"]);
    $block1->paletteScript(7, "edit", "../timesheet/editworkhours.php?fyear=$fyear&serialno=$serialno&id=$id", "true,true,false", $strings["edit"]);
    $block1->closePaletteScript('', '');
}

$block1->closeForm();
require_once("../includes/footer.php");
