<?php // $Revision: 1.30 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addpost.php,v 1.30 2013/01/29 08:46:30 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
$bodyCommand = "onLoad=\"document.ptTForm.tpm.focus();\"";

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$qm = AddSlashesNOD(isset($_GET['qm'])?$_GET['qm']:'');        // quoted messages
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$tpm = isset($_POST['tpm'])?$_POST['tpm']:'';
$error = '';

/**
 * Permission check
 */
$querymore1 = " WHERE topic.id='$id'";
$topicDetail = new request();
$topicDetail->openTopics($querymore1);
$comptTopicDetail = count($topicDetail->top_id);

if ($comptTopicDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$project = $topicDetail->top_project[0];
$querymore2 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore2);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=discussions' . $urlBornes);
    exit;
}

$querymore3 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore3);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore4 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore4);
$comptPermissionDetail = count($permissionDetail->prp_project);

if ($permissionDetail->prp_post_reply[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=discussions' . $urlBornes);
    exit;
}

/**
 * Check fields
 */
if ($action == 'add') {
    $error = checkCustomFields('posts', '');
}

/**
 * Actions
 */
if ($action == "add" && $error == '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        autoLinks($tpm);
        $newText = HtmlEntitiesNOD($newText);
        $cfsqls = setupCustomFieldsInsertSQL('posts');  // Generate custom fields insert sql
        $tmpsql = "INSERT INTO " . $tablePrefix . "posts (topic,member,created,message,cuser" . $cfsqls[0] . ") VALUES ('$id','$idSession','" . time() . "','$newText','$idSession'" . $cfsqls[1] . ")";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $num1 = $requestAct->newId("posts");
        $cfsql = setupCustomMediaFieldsUpdateSQL('posts', $num1);    // Upload custom fields images & generate custom fields update sql

        if ($cfsql !== '') {
            $tmpsql = "UPDATE " . $tablePrefix . "posts SET $cfsql WHERE id='$num1'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        $tmpsql = "UPDATE " . $tablePrefix . "topics SET last_post='" . time() . "',posts=posts+1,modified='" . time() . "',muser='$idSession' WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $querymore = " WHERE fil.id='" . $projectDetail->pro_upload_dir[0] . "'";
        $folderDetail = clone $requestAct;
        $folderDetail->openFiles($querymore);
        $path = $folderDetail->fil_fullname[0];
        uploadAttachFiles($requestAct, enumFileRelatedDocumentType::dtDiscussion, $num1, enumFileStatus::stNoApprovalsNeeded, $projectDetail->pro_upload_dir[0], $path);
        copy2HistoryTable($requestAct, 'posts', $num1, 'A');
        copy2HistoryTable($requestAct, 'topics', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if (!defined('INNER_NOTI_NEWPOST')) {
            define('INNER_NOTI_NEWPOST', 1);
        }

        $num = $id;
        require_once("../topics/noti_newpost.php");
        header("Location: ../topics/viewtopic.php?id=$id&msg=add" . $urlBornes);
        exit;
    }
}

/**
 * Prepare data
 */
if ($error == '') {
    if ($qm != '') {    // quote messages
        $posid = "'" . str_replace("**", "','", $qm) . "'";
        $mesa = array();
        $querymore = " WHERE pos.id IN ($posid) ORDER BY pos.created DESC";
        $listPosts = new request();
        $listPosts->openPosts($querymore);
        $comptListPosts = count($listPosts->pos_id);

        for ($i=0; $i<$comptListPosts; $i++) {
            $mesa[] = '&lt;blockquote&gt;' . $listPosts->pos_message[$i] . '&lt;/blockquote&gt;';
        }

        $tpm = implode("&lt;br&gt;", $mesa) . "&lt;br&gt;";
    }

    $idStatus = $topicDetail->top_status[0];
    $idPublish = $topicDetail->top_published[0];
    $querymore = " WHERE pos.topic='" . $topicDetail->top_id[0] . "' ORDER BY pos.created DESC";
    $listPosts = new request();
    $listPosts->openPosts($querymore);
    $comptListPosts = count($listPosts->pos_id);
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=discussions&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/listtopics.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("discussions"), 'in'));
$blockPage->itemBreadcrumbs($topicDetail->top_subject[0]);
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "ptT";
$block1->openForm("../topics/addpost.php?id=" . $topicDetail->top_id[0] . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="add">';
$block1->heading(lang_strings("post_to_discussion") . " : " . $topicDetail->top_subject[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $blockPage->buildLink("../projects/viewproject.php?toggle_focus=discussions&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0] . " (#" . $projectDetail->pro_id[0] . ")", 'in'));

if ($projectDetail->pro_org_id[0] != "1") {
    $block1->contentRow(lang_strings("organization"), $projectDetail->pro_org_name[0]);
}

$block1->contentRow(lang_strings("owner"), $blockPage->buildLink($projectDetail->pro_mem_id[0], '', 'message'));

if ($sitePublish == "true") {
    $block1->contentRow(lang_strings("published"), $statusPublish[$idPublish]);
}

$block1->contentRow(lang_strings("retired"), $statusTopicBis[$idStatus]);
$block1->contentRow(lang_strings("posts"), $topicDetail->top_posts[0]);
$block1->contentRow(lang_strings("last_post"), createDate($topicDetail->top_last_post[0], 'both'));
$block1->contentTitle(lang_strings("details"));
setupInputHTML($block1, lang_strings("message"), 'tpm', enumFieldType::ftMemo, 'Y', '9', $tpm);
setupCustomFieldsInputHTML($block1, 'posts');
$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . lang_strings("save") . "\">");
$block1->closeContent();

if (($fileManagement == 'true') && ($permissionDetail->prp_add_file[0] == enumBoolean::bTrue || $SW_Permissions['Project']['Edit'][$profilSession])) {
    setupAttachFilesHTML(($sitePublish=='true'));
}

$block1->openContent();
$block1->contentTitle(lang_strings("posts"));

for ($i = 0;$i < $comptListPosts;$i++) {
    $block1->contentRow(lang_strings("posted_by"), $blockPage->buildLink($listPosts->pos_member[$i], '', 'message'));

    if ($listPosts->pos_created[$i] > $lastvisiteSession) {
        $block1->contentRow(lang_strings("when"), "<b>" . createDate($listPosts->pos_created[$i], 'both') . "</b>");
    } else {
        $block1->contentRow(lang_strings("when"), createDate($listPosts->pos_created[$i], 'both'));
    }

    $block1->contentRow("", $listPosts->pos_message[$i]);
    $block1->contentRow("", "", "true");
}

$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
