<?php // $Revision: 1.14 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deletetopics.php,v 1.14 2013/02/01 02:25:48 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$ids = "'" . str_replace('**', "','", $id) . "'";
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';

/**
 * Permission check
 */
$querymore1 = "SELECT DISTINCT project FROM " . $tablePrefix . "topics WHERE id IN ($ids)";
$listProjects = new request();
$listProjects->connectClass();
$listProjects->query($querymore1);
$projects = array();

while ($listProjects->fetch()) {
    $projects[] = ($row[0]);
}

$listProjects->close();
$comptListProjects = count($projects);

if ($comptListProjects == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($project != '') {
    if ($comptListProjects == 1) {
        if ($projects[0] != $project) {
            header("Location: ../topics/deletetopics.php?project=$project&msg=permissiondenied" . $urlBornes);
            exit;
        }
    } else if ($comptListProjects > 1) {
        header("Location: ../topics/deletetopics.php?project=$project&msg=permissiondenied" . $urlBornes);
        exit;
    } else {
        $projects[] = $project;
    }
}

foreach ($projects as $proid) {
    $querymore2 = " WHERE pro.id='$proid'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore2);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
        exit;
    }

    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../projects/viewproject.php?id=' . $proid . '&msg=permissiondenied&toggle_focus=discussions' . $urlBornes);
        exit;
    }

    $querymore3 = " WHERE tea.project='$proid' AND tea.member='$idSession'";
    $memberDetail = new request();
    $memberDetail->openTeams($querymore3);
    $comptMemberDetail = count($memberDetail->tea_project);

    if ($comptMemberDetail == 0) {
        $querymore4 = " WHERE prp.project='$proid' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
    } else {
        $querymore4 = " WHERE prp.project='$proid' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
    }

    $permissionDetail = new request();
    $permissionDetail->openProjectPermissions($querymore4);
    $comptPermissionDetail = count($permissionDetail->prp_project);

    if ($permissionDetail->prp_delete_discussion_topic[0] != enumBoolean::bTrue && !$SW_Permissions['Project']['Edit'][$profilSession]) {
        header('Location: ../projects/viewproject.php?id=' . $proid . '&msg=permissiondenied&toggle_focus=discussions' . $urlBornes);
        exit;
    }
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $querymore5 = " WHERE pos.topic IN ($ids)";
        $listPosts = new request();
        $listPosts->openPosts($querymore5);
        $ids1 = implode(',', $listPosts->pos_id);
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'topics', $ids, 'D');
        $tmpsql= "DELETE FROM " . $tablePrefix . "topics WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'posts', $ids1, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "posts WHERE id IN ($ids1)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $pieces = explode("**", $id);
        $num = count($pieces);
        $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtDiscussion . "' AND fil.doc_id IN ($ids1)";
        deleteAttachFiles($requestAct, $querymore);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($project != "") {
            header("Location: ../projects/viewproject.php?num=$num&msg=deleteTopic&id=$project&toggle_focus=discussions" . $urlBornes);
            exit;
        } else {
            header("Location: ../general/home.php?num=$num&msg=deleteTopic");
            exit;
        }
    }
}

/**
 * Prepare data
 */
if ($project != '' || $comptListProjects == 1) {
    if ($project == '') {
        $querymore = " WHERE pro.id='" . $projects[0] . "'";
    } else {
        $querymore = " WHERE pro.id='$project'";
    }

    $projectDetail = new request();
    $projectDetail->openProjects($querymore);
    $comptProjectDetail = count($projectDetail->pro_id);
}

$querymore = " WHERE topic.id IN ($ids) ORDER BY topic.subject";
$listTopics = new request();
$listTopics->openTopics($querymore);
$comptListTopics = count($listTopics->top_id);

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($project != "" || $comptListProjects == 1) {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=discussions&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/listtopics.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("discussions"), 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../general/home.php?", lang_strings("home"), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("delete_discussions"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "dTp";
$block1->openForm("../topics/deletetopics.php?project=$project&id=$id" . $urlBornes . "#" . $block1->form . 'Anchor');
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">";
$block1->heading(lang_strings("delete_discussions"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListTopics; $i++) {
    $block1->contentRow('#' . $listTopics->top_id[$i], $listTopics->top_subject[$i]);
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
