<?php // $Revision: 1.23 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewtopic.php,v 1.23 2013/01/29 08:46:30 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$action = isset($_REQUEST['action'])?$_REQUEST['action']:'';

if ($js_enabled != 'Y') {
    $action = '';
}

/**
 * Permission check
 */
$querymore0 = " WHERE topic.id='$id'";
$topicDetail = new request();
$topicDetail->openTopics($querymore0);
$comptTopicDetail = count($topicDetail->top_id);

if ($comptTopicDetail == '0') {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

$project = $topicDetail->top_project[0];
$querymore1 = " WHERE pro.id='$project'";
$projectDetail = new request();
$projectDetail->openProjects($querymore1);
$comptProjectDetail = count($projectDetail->pro_id);

if ($comptProjectDetail == '0') {
    header('Location: ../projects/listprojects.php?msg=blankProject' . $urlBornes);
    exit;
}

$querymore2 = " WHERE tea.project='$project' AND tea.member='$idSession'";
$memberDetail = new request();
$memberDetail->openTeams($querymore2);
$comptMemberDetail = count($memberDetail->tea_project);

if ($comptMemberDetail == 0) {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . enumProjectProfile::ppGuest . "'";
} else {
    $querymore3 = " WHERE prp.project='$project' AND prp.profil='" . $memberDetail->tea_profil[0] . "'";
}

$permissionDetail = new request();
$permissionDetail->openProjectPermissions($querymore3);
$comptPermissionDetail = count($permissionDetail->prp_project);

if (!$SW_Permissions['Project']['Admin'][$profilSession] && $permissionDetail->prp_view_discussion[0] != enumBoolean::bTrue) {
    header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=discussions' . $urlBornes);
    exit;
}

if ($action == 'closeTopic' || $action == 'addToSite' || $action == 'removeToSite') {
    if ($projectDetail->pro_status[0] == enumProjectStatus::stCanceled || $projectDetail->pro_status[0] == enumProjectStatus::stCompleted || $projectDetail->pro_status[0] == enumProjectStatus::stSuspended || $projectDetail->pro_status_approval[0] == enumFileStatus::stNeedsApproval) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=discussions' . $urlBornes);
        exit;
    }
}

if ($action == "closeTopic") {
    if ($permissionDetail->prp_close_discussion_topic[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=discussions' . $urlBornes);
        exit;
    }
} else if ($action == "addToSite" || $action == "removeToSite") {
    if ($permissionDetail->prp_publish_discussion_topic[0] != enumBoolean::bTrue) {
        header('Location: ../projects/viewproject.php?id=' . $project . '&msg=permissiondenied&toggle_focus=discussions' . $urlBornes);
        exit;
    }
}

/**
 * Actions
 */
if ($action == 'closeTopic' || $action == 'addToSite' || $action == 'removeToSite') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $chg = false;
        $requestAct->startTransaction();

        if ($action == "closeTopic") {
            if ($topicDetail->top_status[0] != '0') {
                $chg = true;
                $tmpsql = "UPDATE " . $tablePrefix . "topics SET status='0',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                copy2HistoryTable($requestAct, 'topics', $id, 'U');
            }

            $msg = "closeTopic";
        } else if ($action == "addToSite") {
            if ($topicDetail->top_published[0] != enumPublished::pbYes) {
                $chg = true;
                $tmpsql = "UPDATE " . $tablePrefix . "topics SET published='" . enumPublished::pbYes . "',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                copy2HistoryTable($requestAct, 'topics', $id, 'U');
            }

            $msg = "addToSite";
        } else if ($action == "removeToSite") {
            if ($topicDetail->top_published[0] != enumPublished::pbNo) {
                $chg = true;
                $tmpsql = "UPDATE " . $tablePrefix . "topics SET published='" . enumPublished::pbNo . "',modified='" . time() . "',muser='$idSession' WHERE id='$id'";

                if ($requestAct->query($tmpsql) === false) {
                    throw new Exception($tmpsql);
                }

                copy2HistoryTable($requestAct, 'topics', $id, 'U');
            }

            $msg = "removeToSite";
        }

        if ($chg) {
            $requestAct->endTransaction(enumTransactionEndType::etCommit);
        } else {
            $requestAct->endTransaction(enumTransactionEndType::etRollBack);
        }
    } catch (Exception $e) {
        $msg = '';
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {     // reload topic
        $querymore4 = " WHERE topic.id='$id'";
        $topicDetail = new request();
        $topicDetail->openTopics($querymore4);
    }
}

/**
 * Prepare data
 */
$querymore5 = " WHERE pos.topic='$id' ORDER BY pos.created DESC";
$listPosts = new request();
$listPosts->openPosts($querymore5);
$comptListPosts = count($listPosts->pos_id);
$idStatus = $topicDetail->top_status[0];
$idPublish = $topicDetail->top_published[0];

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?" . $urlBornes, lang_strings("projects"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?toggle_focus=discussions&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0], 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../topics/listtopics.php?project=" . $projectDetail->pro_id[0] . $urlBornes, lang_strings("discussions"), 'in'));
$blockPage->itemBreadcrumbs($topicDetail->top_subject[0]);
$blockPage->closeBreadcrumbs();
$title = $strings['discussion'] . ' : ' . $topicDetail->top_subject[0] . ' (' . $strings['project'] . ' ' . $projectDetail->pro_name[0] . ')';
logURL($title, "../topics/viewtopic.php?id=$id");
$block1 = new block();
$block1->form = "tdP";
$block1->openForm("../topics/viewtopic.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("discussion") . " : " . $topicDetail->top_subject[0]);
$block1->openPaletteIcon();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_delete_discussion_topic[0] == enumBoolean::bTrue) {
        $block1->paletteIcon(0, "remove", $strings["remove"]);
    }

    if ($permissionDetail->prp_close_discussion_topic[0] == enumBoolean::bTrue) {
        $block1->paletteIcon(1, "close", $strings["close"]);
    }

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        if ($permissionDetail->prp_publish_discussion_topic[0] == enumBoolean::bTrue) {
            $block1->paletteIcon(2, "add_projectsite", $strings["add_customer_service_site"]);
            $block1->paletteIcon(3, "remove_projectsite", $strings["remove_customer_service_site"]);
        }
    }
}

$block1->paletteIcon(99, 'search', 'topics');
$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("project"), $blockPage->buildLink("../projects/viewproject.php?toggle_focus=discussions&id=" . $projectDetail->pro_id[0] . $urlBornes, $projectDetail->pro_name[0] . " (#" . $projectDetail->pro_id[0] . ")", 'in'));

if ($projectDetail->pro_org_id[0] != "1") {
    $block1->contentRow(lang_strings("organization"), $projectDetail->pro_org_name[0]);
}

$block1->contentRow(lang_strings("owner"), $blockPage->buildLink($projectDetail->pro_mem_id[0], '', 'message'));

if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == "true") {
    $block1->contentRow(lang_strings("published"), $statusPublish[$idPublish]);
}

$block1->contentRow(lang_strings("retired"), $statusTopicBis[$idStatus]);
$block1->contentRow(lang_strings("posts"), $topicDetail->top_posts[0]);
$block1->contentRow(lang_strings("last_post"), createDate($topicDetail->top_last_post[0], 'both'));
setupCustomFieldsHTML($block1, 'topics', $id);
$block1->contentTitle(lang_strings("posts"));

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_post_reply[0] == enumBoolean::bTrue) {
        $block1->contentRow("", '<a href="#" onclick="addpost(' . $id . ')">' . lang_strings("post_reply") . '</a>');
    }
}

for ($i=0; $i<$comptListPosts; $i++) {
    $block1->contentRow(lang_strings("posted_by"), $blockPage->buildLink($listPosts->pos_member[$i], '', 'message'));

    if ($listPosts->pos_created[$i] > $lastvisiteSession) {
        $block1->contentRow(lang_strings("when"), "<b>" . createDate($listPosts->pos_created[$i], 'both') . "</b>");
    } else {
        $block1->contentRow(lang_strings("when"), createDate($listPosts->pos_created[$i], 'both'));
    }

    if ($permissionDetail->prp_delete_discussion_topic[0] == enumBoolean::bTrue || $listPosts->pos_member[$i] == $idSession) {
        $block1->contentRow($blockPage->buildLink("../topics/deletepost.php?topic=$id&id=" . $listPosts->pos_id[$i] . $urlBornes, lang_strings("delete_message"), 'in'), $listPosts->pos_message[$i] . '<br><input type="checkbox" value="' . $listPosts->pos_id[$i] . '">' . lang_strings('quote_message'));
    } else {
        $block1->contentRow("", $listPosts->pos_message[$i]);
    }

    setupCustomFieldsHTML($block1, 'posts', $listPosts->pos_id[$i]);

    if (($fileManagement == "true") && ($permissionDetail->prp_view_file[0] == enumBoolean::bTrue)) {
        $querymore = " WHERE fil.doc_type='" . enumFileRelatedDocumentType::dtDiscussion . "' AND fil.doc_id='" . $listPosts->pos_id[$i] . "' AND fil.vc_parent=0 ORDER BY fil.name";
        $block1->contentRow('', setupAttachListHTML($querymore));
    }

    $block1->contentRow("");
}

$block1->closeContent();
$block1->openPaletteScript();

if ($projectDetail->pro_status[0] != enumProjectStatus::stCanceled && $projectDetail->pro_status[0] != enumProjectStatus::stCompleted && $projectDetail->pro_status[0] != enumProjectStatus::stSuspended && $projectDetail->pro_status_approval[0] != enumFileStatus::stNeedsApproval) {
    if ($permissionDetail->prp_delete_discussion_topic[0] == enumBoolean::bTrue) {
        $block1->paletteScript(0, "remove", "../topics/deletetopics.php?project=$project&id=$id" . $urlBornes, "true,true,false", $strings["remove"]);
    }

    if ($permissionDetail->prp_close_discussion_topic[0] == enumBoolean::bTrue) {
        $block1->paletteScript(1, "close", "../topics/viewtopic.php?id=$id&action=closeTopic" . $urlBornes, "true,true,false", $strings["close"]);
    }

    if ($projectDetail->pro_published[0] == enumPublished::pbYes && $sitePublish == 'true') {
        if ($permissionDetail->prp_publish_discussion_topic[0] == enumBoolean::bTrue) {
            $block1->paletteScript(2, "add_projectsite", "../topics/viewtopic.php?id=$id&action=addToSite" . $urlBornes, "true,true,false", $strings["add_customer_service_site"]);
            $block1->paletteScript(3, "remove_projectsite", "../topics/viewtopic.php?id=$id&action=removeToSite" . $urlBornes, "true,true,false", $strings["remove_customer_service_site"]);
        }
    }
}

$block1->paletteScript(99, 'search', 'topics');
$block1->closePaletteScript("", "");
$block1->closeForm();
?>
<script type="text/javascript">
function addpost(id) {
    var x = '';
    $('[type=checkbox]:checked').each(function() { if (x!='') x = x + '**'; x = x + $(this).val(); });
    window.open('../topics/addpost.php?id=' + id + '&qm=' + x,'_self');
}
</script>
<?php
require_once("../includes/footer.php");
