<?php // $Revision: 1.5 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteuserprofiles.php,v 1.5 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2018 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$idSet = "'" . str_replace("**", "','", $id) . "'";

/**
 * Permission check
 */
if (!$SW_Permissions['Profile']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$tmpquery = "SELECT mem.id FROM " . $tablePrefix . "members mem WHERE mem.profil IN ($idSet)";

if (compt($tmpquery) > 0 || in_array('1', $idSet)) {
    header("Location: ../userprofiles/listuserprofiles.php?msg=profileInUse" . $urlBornes);
    exit;
}

/**
 * Action
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "DELETE FROM " . $tablePrefix . "user_profiles WHERE id IN ($idSet)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "DELETE FROM " . $tablePrefix . "user_profiles_detail WHERE user_profile IN ($idSet)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
        // delete user profiles calendars
        $tmpsql = "DELETE FROM " . $tablePrefix . "calendars WHERE target='" . enumCalendarTarget::tUserProfile . "' AND target_id IN ($idSet)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
        // delete user profiles calendar events
        $tmpsql = "DELETE FROM " . $tablePrefix . "calendar_events WHERE target='" . enumCalendarTarget::tUserProfile . "' AND target_id IN ($idSet)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../userprofiles/listuserprofiles.php?msg=delete" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../userprofiles/listuserprofiles.php?" . $urlBornes, lang_strings("user_profiles"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_user_profiles"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "upfD";
$block1->openForm("../userprofiles/deleteuserprofiles.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo '<input type="hidden" name="action" value="delete">';
$block1->heading(lang_strings("delete_user_profiles"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));
$querymore = " WHERE upf.id IN ($idSet) ORDER BY upf.name";
$listUserProfiles = new request();
$listUserProfiles->openUserProfiles($querymore);
$comptListUserProfiles = count($listUserProfiles->upf_id);

for ($i=0; $i<$comptListUserProfiles; $i++) {
    $block1->contentRow('#' . $listUserProfiles->upf_id[$i], $listUserProfiles->upf_name[$i] . ' (' . $listUserProfiles->upf_name_print[$i] . ')');
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
