<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listuserprofiles.php,v 1.3 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Profile']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("user_profiles"));
$blockPage->closeBreadcrumbs();
logURL($strings['user_profiles'], "../userprofiles/listuserprofiles.php");
$block1 = new block();
$block1->form = "upL";
$block1->openForm("../userprofiles/listuserprofiles.php#" . $block1->form . "Anchor");
$block1->heading(lang_strings("user_profiles"));
$block1->sorting('user_profiles', (isset($sortingUser['user_profiles'])?$sortingUser['user_profiles']:''), "upf.name ASC", $sortingFields = array(0 => 'upf.name', 1 =>'none', 2 => 'upf.sysdef', 3 => 'upf.locked'));
$querymore = " ORDER BY " . $block1->sortingValue;
$listUserProfiles = new request();
$listUserProfiles->openUserProfiles($querymore);
$comptListUserProfiles = count($listUserProfiles->upf_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->title = $strings['name'];
$columns[0]->field_type = enumFieldType::ftAlphaNumeric;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['name_print'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['system_defined'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['locked'];
$columns[3]->field_type = enumFieldType::ftBoolean;
$opt[enumCardviewOption::oObject] = 'user_profiles';
$opt[enumCardviewOption::oTableName] = 'user_profiles';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;
$opt[enumCardviewOption::oAddUrl] = '../userprofiles/edituserprofile.php?';
$block1->openCardView($opt);

for ($i=0; $i<$comptListUserProfiles; $i++) {
    $content = array(
        $listUserProfiles->upf_name[$i],
        $listUserProfiles->upf_name_print[$i],
        ($listUserProfiles->upf_sysdef[$i]=='Y')?$strings['yes']:$strings['no'],
        $listUserProfiles->upf_locked[$i]
    );
    $block1->itemCardView($listUserProfiles->upf_id[$i], $content);
}

$block1->closeCardView();
$block1->closeFormResults();
require_once("../includes/footer.php");
