<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewuserprofile.php,v 1.4 2013/01/29 08:46:31 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');

/**
 * Permission check
 */
if (!$SW_Permissions['Profile']['Admin'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore = " WHERE upf.id='$id'";
$userProfileDetail = new request();
$userProfileDetail->openUserProfiles($querymore);
$comptUserProfileDetail = count($userProfileDetail->upf_id);

if ($comptUserProfileDetail == '0') {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore1 = " WHERE upd.user_profile='$id'";
$listUserProfilesDetail = new request();
$listUserProfilesDetail->openUserProfilesDetail($querymore1);
$comptListUserProfilesDetail = count($listUserProfilesDetail->upd_user_profile);

for ($i=0; $i<$comptListUserProfilesDetail; $i++) {
    $updA[$listUserProfilesDetail->upd_function_name[$i]][$listUserProfilesDetail->upd_access_level[$i]] = (($listUserProfilesDetail->upd_granted[$i])?' checked':'');
}
/**
 * get table definitions
 */
$querymore4 = " WHERE tdf.sysdef='N' AND tdf.fathertable='' ORDER BY tdf.tablename";
$listTablesDefinitions = new request();
$listTablesDefinitions->openTablesDefinitions($querymore4);
$comptListTablesDefinitions = count($listTablesDefinitions->tdf_tablename);
/**
 * get extension list
 */
$querymore5 = " ORDER BY ext.name";
$listExtensions = new request();
$listExtensions->openExtensions($querymore5);
$comptListExtensions = count($listExtensions->ext_name);

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../userprofiles/listuserprofiles.php?" . $urlBornes, lang_strings("user_profiles"), 'in'));
$blockPage->itemBreadcrumbs($userProfileDetail->upf_name_print[0]);
$blockPage->closeBreadcrumbs();
$title = $strings['user_profile'] . ' : ' . $userProfileDetail->upf_name_print[0];
logURL($title, "../userprofiles/viewuserprofile.php?id=$id");
$block1 = new block();
$block1->form = "upfV";
$block1->openForm("../userprofiles/viewuserprofile.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
$block1->heading(lang_strings("user_profile"));
$block1->openPaletteIcon();
$block1->paletteIcon(4, "copy", $strings["copy"]);

if ($id != '1') {
    $block1->paletteIcon(0, "remove", $strings["delete"]);
    $block1->paletteIcon(1, "edit", $strings["edit"]);
}

$block1->closePaletteIcon();
$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$block1->contentRow(lang_strings("name"), $userProfileDetail->upf_name[0]);
$block1->contentRow(lang_strings("name_print"), $userProfileDetail->upf_name_print[0]);
$block1->contentRow(lang_strings('department') . $block1->printHelp('setup_depdefault'), $userProfileDetail->upf_dep_name_print[0]);
$block1->contentRow(lang_strings('location') . $block1->printHelp('setup_locdefault'), $userProfileDetail->upf_loc_name_print[0]);
$block1->contentRow(lang_strings('language') . $block1->printHelp('setup_langdefault'), isset($langValue[$userProfileDetail->upf_language[0]])?$langValue[$userProfileDetail->upf_language[0]]:'');
$block1->contentRow(lang_strings('date_format') . $block1->printHelp('setup_dtftdefault'), $userProfileDetail->upf_date_format[0]);
$block1->contentRow(lang_strings('time_format') . $block1->printHelp('setup_tmftdefault'), $userProfileDetail->upf_time_format[0]);
$block1->contentRow(lang_strings('workcalendar') . $block1->printHelp('setup_wcdefault'), $userProfileDetail->upf_wca_name[0]);
$block1->contentRow(lang_strings('enable_flextime') . $block1->printHelp('setup_eftdefault'), DbValueDecode(enumFieldType::ftBoolean, $userProfileDetail->upf_enable_flextime[0]));
$block1->contentRow(lang_strings("locked"), (($userProfileDetail->upf_locked[0])?lang_strings('yes'):lang_strings('no')));
$block1->closeContent();
$labels = array('', lang_strings("read"), lang_strings("write"), lang_strings("edit"), lang_strings('admin'));
$block1->openResults();
$block1->labels($labels, 'false', 'false', '', true);
$pi = 0;

foreach ($functionsACL as $func => $pa) {
    $block1->openRow('', true);
    $block1->cellRow($functionsName[$func]);    // function name

    foreach (array('Read', 'Write', 'Edit', 'Admin') as $p) {
        if (in_array($p, $pa)) {
            $block1->cellRow('<input type="checkbox" name="vals[' . $pi++ . ']" value="Y"' . $updA[$func][$p] . ' onclick="return false">');
        } else {
            $block1->cellRow('&nbsp;');
        }
    }

    $block1->closeRow();
}

for ($i=0; $i<$comptListTablesDefinitions; $i++) {
    $func = $listTablesDefinitions->tdf_tablename[$i];
    $block1->openRow('', true);
    $block1->cellRow(lang_strings('form') . ' : ' . tableNameString($func));    // function name

    foreach (array('Read','Write','Edit','Admin') as $p) {
        $block1->cellRow('<input type="checkbox" name="vals[' . $pi++ . ']" value="Y"' . $updA[$func][$p] . ' onclick="return false">');
    }

    $block1->closeRow();
}

for ($i=0; $i<$comptListExtensions; $i++) {
    $func = '#' . $listExtensions->ext_name[$i];
    $block1->openRow('', true);
    $block1->cellRow($listExtensions->ext_title[$i]);       // function name

    foreach (array('Read','Write','Edit','Admin') as $p) {
        $block1->cellRow('<input type="checkbox" name="vals[' . $pi++ . ']" value="Y"' . $updA[$func][$p] . ' onclick="return false">');
    }

    $block1->closeRow();
}

$block1->closeResults();
$block1->closeForm();
$block1->openPaletteScript();
$block1->paletteScript(4, "copy", "../userprofiles/edituserprofile.php?id=$id&cpy=true", "true,true,true", $strings["copy"]);

if ($id != '1') {
    $block1->paletteScript(0, "remove", "../userprofiles/deleteuserprofiles.php?id=$id" . $urlBornes, "true,true,true", $strings["delete"]);
    $block1->paletteScript(1, "edit", "../userprofiles/edituserprofile.php?id=$id" . $urlBornes, "true,true,true", $strings["edit"]);
}

$block1->closePaletteScript("", "");
require_once("../includes/footer.php");
