<?php // $Revision: 1.30 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: addflextimeadjust.php,v 1.30 2009/10/06 14:43:23 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.afAForm.hr.focus();"';
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');    // user internal id
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$hr = isset($_POST['hr'])?$_POST['hr']:'';          // hours
$rdI = isset($_POST['rdI'])?$_POST['rdI']:'';       // The input value of reference date
$rd = ($rdI=='')?$dateToday:date2Timestamp($rdI);   // The timestamp of reference date
$comm = isset($_POST['comm'])?$_POST['comm']:'';    // comments
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$hr_highlight = false;
$rd_highlight = false;

/**
 * Permission check
 */
if (($enableTimesheet != 'true') || ($enableFlextime != 'true') || (!$SW_Permissions['User']['Write'][$profilSession])) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore1 = " WHERE mem.id='$id'";
$userDetail = new request();
$userDetail->openMembers($querymore1);
$comptUserDetail = count($userDetail->mem_id);

if ($comptUserDetail == 0) {    // invalid user internal id
    header("Location: ../users/listusers.php?msg=blankUser");
    exit;
}

/**
 * Fields check
 */
$error = '';

if ($action == 'add') {
    if (floatval($hr) == 0) {
        $error = lang_strings('hours') . ' ' . lang_strings('error_required');
        $bodyCommand = 'onLoad="document.afAForm.hr.focus();"';
        $hr_highlight = true;
    } else if ($rd < $userDetail->mem_start_date[0]) {
        $error = lang_strings('date_deviate');
        $bodyCommand = 'onLoad="document.afAForm.rd.focus();"';
        $rd_highlight = true;
    } else if (periodLocked($rd)) {
        $error = lang_strings('period') . ' ' . $period_date_start . ' ~ ' . $period_date_end . ' ' . lang_strings('locked');
        $bodyCommand = 'onLoad="document.afAForm.rd.focus();"';
        $rd_highlight = true;
    }
}

/**
 * Actions
 */
if (($action == 'add') && ($error == '')) {
    $hr = round($hr, $hourAccuracy);
    $comm = HtmlEntitiesNOD($comm);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $cfsqls = setupCustomFieldsInsertSQL('flextime_adjustment');  // Generate custom fields insert sql
        $tmpsql = 'INSERT INTO ' . $tablePrefix . "flextime_adjustment (owner,refdate,hours,comments,created,cuser" . $cfsqls[0] . ") VALUES ('$id','$rd','$hr','$comm','" . time() . "','$idSession'" . $cfsqls[1] . ")";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $num = $requestAct->newId('flextime_adjustment');
        $cfsql = setupCustomMediaFieldsUpdateSQL('flextime_adjustment', $num);    // Upload custom fields images & generate custom fields update sql

        if ($cfsql !== '') {
            $tmpsql = "UPDATE " . $tablePrefix . "flextime_adjustment SET $cfsql WHERE id='$num'";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        copy2HistoryTable($requestAct, 'flextime_adjustment', $num, 'A');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        $hr = '';
        $comm = '';
        // successful insert
        $msg = 'addFlexAdjust';
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=company", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../users/listusers.php?", lang_strings("user_management"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../users/viewuser.php?id=$id", $userDetail->mem_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings('add_flextime_adjust'));
$blockPage->closeBreadcrumbs();
$blockPage->bornesNumber = "1";
$block1 = new block();
$block1->form = "afA";
$block1->openForm("../users/addflextimeadjust.php?id=$id#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
$block1->heading(lang_strings("add_flextime_adjust") . " : " . $userDetail->mem_login[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("user_name"), $userDetail->mem_login[0]);
$block1->contentRow(lang_strings("full_name"), $userDetail->mem_name[0]);
$block1->contentRow(lang_strings("title"), $userDetail->mem_title[0]);
$block1->contentRow(lang_strings("email"), $blockPage->buildLink($userDetail->mem_email_work[0], $userDetail->mem_email_work[0], 'mail'));
$block1->contentRow(lang_strings("work_phone"), $userDetail->mem_phone_work[0]);
$block1->contentTitle(lang_strings("add_flextime_adjust"));
// reference date
setupInputHTML($block1, lang_strings('date'), 'rd', enumFieldType::ftDate, 'Y', '0', $rd, '', '', $rd_highlight);
// hours
setupInputHTML($block1, lang_strings('hours'), 'hr', enumFieldType::ftHours, 'Y', '0', $hr, '', '', $hr_highlight);
// comments
setupInputHTML($block1, lang_strings('note'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
setupCustomFieldsInputHTML($block1, 'flextime_adjustment');
$block1->contentRow('', "<input type='SUBMIT' value='" . $strings["save"] . "'>");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
// This will display time log detail for the current task
$block2 = new block();
$block2->form = "ahT";
$block2->openForm("../users/addflextimeadjust.php?id=$id#" . $block2->form . "Anchor");
$block2->heading(lang_strings("flextime_adjustment") . ' : ' . lang_strings("details"));
$block2->openPaletteIcon();
$block2->paletteIcon(0, "remove", lang_strings("delete"));
$block2->paletteIcon(1, "edit", lang_strings("edit"));
$block2->closePaletteIcon();
$block2->borne = $blockPage->returnBorne("1");
$block2->rowsLimit = "15";
$block2->sorting('flextime_adjustment', (isset($sortingUser['flextime_adjustment'])?$sortingUser['flextime_adjustment']:''), 'fta.refdate DESC', $sortingFields = array(0 => 'fta.refdate', 1 => 'fta.hours', 2 => 'fta.comments'));
// get flextime adjustments for the user
$querymore = " WHERE fta.owner='$id'";
$block2->recordsTotal = compt($initrequest["flextime_adjustment"] . " " . $querymore);
$listFlextimeAdjustment = new request();
$listFlextimeAdjustment->openFlextimeAdjustment($querymore . " ORDER BY " . $block2->sortingValue, $block2->borne, $block2->rowsLimit);
$comptListFlextimeAdjustment = count($listFlextimeAdjustment->fta_id);

if ($comptListFlextimeAdjustment > 0) {
    $labels = array(lang_strings("date"), lang_strings("hours"), lang_strings("note"));
    $block2->openResults();
    $block2->labels($labels, "false");

    for ($i=0; $i<$comptListFlextimeAdjustment; $i++) {
        $block2->openRow($listFlextimeAdjustment->fta_id[$i]);
        $block2->cellRow(createDate($listFlextimeAdjustment->fta_refdate[$i], 'date', false, true));
        $block2->cellRow(NumberFormatNOD($listFlextimeAdjustment->fta_hours[$i], $hourAccuracy, false));
        $comm = strip_tags($listFlextimeAdjustment->fta_comments[$i]);
        $block2->cellRow($comm);
        $block2->closeRow();
    }

    $block2->closeResults();
    $block2->bornesFooter("1", $blockPage->bornesNumber, "id=$id");
} else {
    $block2->noresults();
}

$block2->closeFormResults();
$block2->openPaletteScript();
$block2->paletteScript(0, "remove", "../users/deleteflextimeadjust.php?owner=$id", "false,true,false", lang_strings("delete"));
$block2->paletteScript(1, "edit", "../users/editflextimeadjust.php?owner=$id", "false,true,false", lang_strings("edit"));
$block2->closePaletteScript($comptListFlextimeAdjustment, $listFlextimeAdjustment->fta_id);
require_once("../includes/footer.php");
