<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteclientusers.php,v 1.16 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$organization = AddSlashesNOD(isset($_GET['organization'])?$_GET['organization']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';
$ids = "'" . str_replace('**', "','", $id) . "'";
$ida = explode('**', $id);

/**
 * Permission check
 */
if (!$SW_Permissions['Client']['Edit'][$profilSession]) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

if (!is_numeric($organization)) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

$querymore1 = " WHERE org.id='$organization'";
$clientDetail = new request();
$clientDetail->openOrganizations($querymore1);
$comptClientDetail = count($clientDetail->org_id);

if ($comptClientDetail == '0') {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

// check if users exist
$querymore2 = " WHERE mem.id IN ($ids) AND mem.organization='$organization' ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore2);
$comptListMembers = count($listMembers->mem_id);

if ($comptListMembers != count($ida)) {
    header("Location: ../general/home.php?msg=permissiondenied");
    exit;
}

// check if users transactions exist
$tmpquery = "SELECT producer AS mem FROM " . $tablePrefix . "approvals_producers WHERE producer_type='" . enumProducerType::ptUser . "' AND producer IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "assignments WHERE owner IN ($ids) "
    . "UNION ALL SELECT member AS mem FROM " . $tablePrefix . "attendees WHERE member IN ($ids) "
    . "UNION ALL SELECT authorizer AS mem FROM " . $tablePrefix . "confirmation_levels_detail WHERE authorizer_type='" . enumAuthorizerType::atUser . "' AND authorizer IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "documents_approval WHERE owner IN ($ids) "
    . "UNION ALL SELECT authorizer AS mem FROM " . $tablePrefix . "documents_approval_authorizers WHERE authorizer IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "equipments WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "expenses WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "files WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "flextime_adjustment WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "invoices WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "leaves WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "leave_requests WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "material_issue WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "meetings WHERE owner IN ($ids) "
    . "UNION ALL SELECT member AS mem FROM " . $tablePrefix . "meetings_available WHERE member IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "meetings_time WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "messages WHERE owner IN ($ids) OR sender IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "notes WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "organizations WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "payments WHERE owner IN ($ids) "
    . "UNION ALL SELECT member AS mem FROM " . $tablePrefix . "posts WHERE member IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "projects WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "support_posts WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "support_requests WHERE owner IN ($ids) OR assigned_to IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "tasks WHERE owner IN ($ids) "
    . "UNION ALL SELECT resource AS mem FROM " . $tablePrefix . "tasks_resource WHERE resource IN ($ids) AND type='U' "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "tasks_time WHERE owner IN ($ids) "
    . "UNION ALL SELECT member AS mem FROM " . $tablePrefix . "teams WHERE member IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "timesheet WHERE owner IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "topics WHERE owner IN ($ids) "
    . "UNION ALL SELECT member AS mem FROM " . $tablePrefix . "updates WHERE member IN ($ids) "
    . "UNION ALL SELECT owner AS mem FROM " . $tablePrefix . "work_hours WHERE owner IN ($ids) ";
$querymore3 = " WHERE fdf.sysdef='N' AND fdf.linkedtable='members'";
$listFieldsDefinitions = new request();
$listFieldsDefinitions->openFieldsDefinitions($querymore3);
$comptListFieldsDefinitions = count($listFieldsDefinitions->fdf_tablename);

for ($i=0; $i<$comptListFieldsDefinitions; $i++) {
    $tmpquery .= "UNION ALL SELECT " . $listFieldsDefinitions->fdf_dbfieldname[$i] . " AS mem FROM " . $tablePrefix . $listFieldsDefinitions->fdf_dbtablename[$i] . " WHERE " . $listFieldsDefinitions->fdf_dbfieldname[$i] . " IN ($ids) ";
}

if (compt($tmpquery) > 0) {
    header("Location: ../clients/listclients.php?msg=permissiondenied" . (isset($borne1)?'&borne1=' . $borne1:''));
    exit;
}

/**
 * Actions
 */
if ($action == "delete") {
    $atProject = (($at=='0')?$idSession:$at);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'members', $ids, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "members WHERE id IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }
        // unlink user from contact
        $querymore4 = " WHERE con.member IN ($ids)";
        $listContacts = clone $requestAct;
        $listContacts->openContacts($querymore4);

        if (count($listContacts->con_id) > 0) {
            $ids2 = implode(',', $listContacts->con_id);
            $tmpsql = "UPDATE " . $tablePrefix . "contacts SET member='0',modified='" . time() . "',muser='$idSession' WHERE id IN ($ids2)";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            copy2HistoryTable($requestAct, 'contacts', $ids2, 'U');
        }

        $tmpsql = "DELETE FROM " . $tablePrefix . "notifications WHERE member IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "DELETE FROM " . $tablePrefix . "sorting WHERE member IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $tmpsql = "DELETE FROM " . $tablePrefix . "ui_settings WHERE member IN ($ids)";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        for ($i=0; $i<$comptListMembers; $i++) {
            $picture = 'Avatars/' . $listMembers->mem_id[$i] . '.' . $listMembers->mem_extension_picture[$i];

            if (fileExists($picture)) {
                deleteFile($picture);
            }
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../clients/viewclient.php?id=$organization&msg=delete&toggle_focus=user" . (isset($borne1)?'&borne1=' . $borne1:'') . (isset($borne3)?'&borne3=' . $borne3:''));
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../clients/listclients.php?" . (isset($borne1)?'borne1=' . $borne1:''), lang_strings("clients"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../clients/viewclient.php?id=" . $clientDetail->org_id[0] . "&toggle_focus=user" . (isset($borne1)?'&borne1=' . $borne1:'') . (isset($borne3)?'&borne3=' . $borne3:''), $clientDetail->org_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_users"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "cuD";
$block1->openForm("../users/deleteclientusers.php?organization=$organization&amp;id=$id" . (isset($borne1)?'&borne1=' . $borne1:'') . (isset($borne3)?'&borne3=' . $borne3:'') . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">\n";
$block1->heading(lang_strings("delete_users"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListMembers; $i++) {
    $block1->contentRow('#' . $listMembers->mem_id[$i], $listMembers->mem_name[$i]);
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
