<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteflextimeadjust.php,v 1.8 2009/09/01 15:01:17 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = isset($_GET['id'])?$_GET['id']:'0';
$owner = isset($_GET['owner'])?$_GET['owner']:'0';
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if (($enableTimesheet != 'true') || ($enableFlextime != 'true') || (!$SW_Permissions['User']['Write'][$profilSession])) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

$querymore1 = " WHERE mem.id='$owner'";
$userDetail = new request();
$userDetail->openMembers($querymore1);
$comptUserDetail = count($userDetail->mem_id);

if ($comptUserDetail == 0) {
    header("Location: ../users/listusers.php?msg=blankUser");
    exit;
}

$querymore2 = " WHERE fta.id='$id'";
$flextimeAdjustmentDetail = new request();
$flextimeAdjustmentDetail->openFlextimeAdjustment($querymore2);

if (count($flextimeAdjustmentDetail->fta_id) == 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
} elseif ($flextimeAdjustmentDetail->fta_owner[0] != $owner) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if (periodLocked($flextimeAdjustmentDetail->fta_refdate[0])) {
    header("Location: ../users/addflextimeadjust.php?id=$owner&msg=periodLocked");
    exit;
}

/**
 * Actions
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        copy2HistoryTable($requestAct, 'flextime_adjustment', $id, 'D');
        $tmpsql = "DELETE FROM " . $tablePrefix . "flextime_adjustment WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../users/addflextimeadjust.php?id=$owner&msg=delete");
        exit;
    }
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=company", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../users/listusers.php?", lang_strings("user_management"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../users/viewuser.php?id=$owner", $userDetail->mem_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings('delete_flextime_adjust'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "dfA";
$block1->openForm("../users/deleteflextimeadjust.php?owner=$owner&amp;id=$id");
echo '<input type="hidden" name="action" value="delete">';
$block1->heading(lang_strings("delete_flextime_adjust") . " : " . $userDetail->mem_login[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));
$block1->contentRow(lang_strings("owner"), $flextimeAdjustmentDetail->fta_mem_name[0]);
$block1->contentRow(lang_strings("date"), createDate($flextimeAdjustmentDetail->fta_refdate[0], 'date', false, true));
$block1->contentRow(lang_strings("hours"), $flextimeAdjustmentDetail->fta_hours[0]);
$block1->contentRow(lang_strings("note"), $flextimeAdjustmentDetail->fta_comments[0]);
$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
