<?php // $Revision: 1.18 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editflextimeadjust.php,v 1.18 2009/09/04 08:58:45 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$bodyCommand = 'onLoad="document.dfAForm.hr.focus();"';
$dateToday = mktime(0, 0, 0, intval(date('m')), intval(date('d')), intval(date('Y')));
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');    // flextime adjustment id
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$owner = AddSlashesNOD(isset($_GET['owner'])?$_GET['owner']:'0');   // user internal id
$hr = isset($_POST['hr'])?$_POST['hr']:'';          // hours
$rdI = isset($_POST['rdI'])?$_POST['rdI']:'';       // The input value of reference date
$rd = ($rdI=='')?$dateToday:date2Timestamp($rdI);   // The timestamp of reference date
$comm = isset($_POST['comm'])?$_POST['comm']:'';    // comments
$hr_highlight = false;
$rd_highlight = false;

/**
 * Permission check
 */
if (($enableTimesheet != 'true') || ($enableFlextime != 'true') || (!$SW_Permissions['User']['Write'][$profilSession])) {
    header("Location: ../general/permissiondenied.php");
    exit;
}


$querymore1 = " WHERE mem.id='$owner'";
$userDetail = new request();
$userDetail->openMembers($querymore1);
$comptUserDetail = count($userDetail->mem_id);

if ($comptUserDetail == 0) {    // invalid user internal id
    header("Location: ../users/listusers.php?msg=blankUser");
    exit;
}

$querymore2 = " WHERE fta.id='$id'";
$flextimeAdjustmentDetail = new request();
$flextimeAdjustmentDetail->openFlextimeAdjustment($querymore2);

if (count($flextimeAdjustmentDetail->fta_id) == 0) {
    header("Location: ../general/permissiondenied.php");
    exit;
} elseif ($flextimeAdjustmentDetail->fta_owner[0] != $owner) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if (periodLocked($flextimeAdjustmentDetail->fta_refdate[0])) {
    header("Location: ../users/addflextimeadjust.php?id=$owner&msg=periodLocked");
    exit;
}

/**
 * Fields check
 */
$error = '';

if ($action == 'edit') {
    if (floatval($hr) == 0) {
        $error = lang_strings('hours') . ' ' . lang_strings('error_required');
        $bodyCommand = 'onLoad="document.dfAForm.hr.focus();"';
        $hr_highlight = true;
    } else if ($rd < $userDetail->mem_start_date[0]) {
        $error = lang_strings('date_deviate');
        $bodyCommand = 'onLoad="document.dfAForm.rd.focus();"';
        $rd_highlight = true;
    } else if (periodLocked($rd)) {
        $error = lang_strings('period') . ' ' . $period_date_start . ' ~ ' . $period_date_end . ' ' . lang_strings('locked');
        $bodyCommand = 'onLoad="document.dfAForm.rd.focus();"';
        $rd_highlight = true;
    }
}

/**
 * Actions
 */
if (($action == 'edit') && ($error == '')) {
    $hr = round($hr, $hourAccuracy);
    $comm = HtmlEntitiesNOD($comm);
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $cfsql = setupCustomFieldsUpdateSQL('flextime_adjustment', $id);  // Generate custom fields update sql
        $tmpsql  = "UPDATE " . $tablePrefix . "flextime_adjustment SET refdate='$rd',hours='$hr',comments='$comm',modified='" . time() . "',muser='$idSession'$cfsql WHERE id='$id'";

        if ($requestAct->query($tmpsql) === false) {
            throw new Exception($tmpsql);
        }

        copy2HistoryTable($requestAct, 'flextime_adjustment', $id, 'U');
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../users/addflextimeadjust.php?id=$owner&msg=update");
        exit;
    }
}

/**
 * Set value in form
 */
if (($action == '') && ($error == '')) {
    $rd = $flextimeAdjustmentDetail->fta_refdate[0];
    $hr = $flextimeAdjustmentDetail->fta_hours[0];
    $comm = $flextimeAdjustmentDetail->fta_comments[0];
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=company", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../users/listusers.php?", lang_strings("user_management"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../users/viewuser.php?id=$owner", $userDetail->mem_name[0], 'in'));
$blockPage->itemBreadcrumbs(lang_strings('edit_flextime_adjust'));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "dfA";
$block1->openForm("../users/editflextimeadjust.php?owner=$owner&amp;id=$id#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"edit\">";
$block1->heading(lang_strings("edit_flextime_adjust") . " : " . $userDetail->mem_login[0]);
$block1->openContent();
$block1->contentTitle(lang_strings("info"));
$block1->contentRow(lang_strings("user_name"), $userDetail->mem_login[0]);
$block1->contentRow(lang_strings("full_name"), $userDetail->mem_name[0]);
$block1->contentRow(lang_strings("title"), $userDetail->mem_title[0]);
$block1->contentRow(lang_strings("email"), $blockPage->buildLink($userDetail->mem_email_work[0], $userDetail->mem_email_work[0], 'mail'));
$block1->contentRow(lang_strings("work_phone"), $userDetail->mem_phone_work[0]);
$block1->contentTitle(lang_strings("edit_flextime_adjust"));
// reference date
setupInputHTML($block1, lang_strings('date'), 'rd', enumFieldType::ftDate, 'Y', '0', $rd, '', '', $rd_highlight);
// hours
setupInputHTML($block1, lang_strings('hours'), 'hr', enumFieldType::ftHours, 'Y', '0', $hr, '', '', $hr_highlight);
// comments
setupInputHTML($block1, lang_strings('note'), 'comm', enumFieldType::ftMemo, 'N', '0', $comm);
setupCustomFieldsInputHTML($block1, 'flextime_adjustment', $id);
$block1->contentRow('', "<input type='SUBMIT' value='" . $strings["update"] . "'><input type='button' name='cancel' value='" . $strings['cancel'] . "' onClick='history.back();'>");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
