<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: edituser_serv.php,v 1.3 2013/01/29 08:46:13 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

// check if the request is an AJAX request
if (!is_ajax()) {
    exit;
}

/**
 * Variables init
 */
$action = AddSlashesNOD(isset($_POST['action'])?$_POST['action']:'');   // action

if ($action == '') {
    exit;
}

switch ($action) {
    case 'userProfileDefaults':
        /**
         * get user profile default values
         */
        $upf = AddSlashesNOD(isset($_POST['userProfile'])?$_POST['userProfile']:'');
        
        if ($upf == '') {
            $upf = '0';
        }
        
        $querymore1 = " WHERE upf.id='$upf'";
        $userProfileDetail = new request();
        $userProfileDetail->openUserProfiles($querymore1);
        $comptUserProfileDetail = count($userProfileDetail->upf_id);
        $dep = '0';
        $loc = '0';
        $tz = '';
        $la = '';
        $dtft = '';
        $tmft = '';
        $wc = '0';
        $eft = enumBoolean::bFalse;
        
        if ($comptUserProfileDetail > 0) {
            $dep = $userProfileDetail->upf_department[0];
            $loc = $userProfileDetail->upf_location[0];
            $tz = $userProfileDetail->upf_loc_timezone[0];
            $la = $userProfileDetail->upf_language[0];
            $dtft = $userProfileDetail->upf_date_format[0];
            $tmft = $userProfileDetail->upf_time_format[0];
            $wc = $userProfileDetail->upf_workcalendar[0];
            $eft = $userProfileDetail->upf_enable_flextime[0];
        }
            
        if (isset($timezoneTable[$tz])) {
            $tz = $timezoneTable[$tz];
        } else if (isset($timezoneTable[$defaultTimezone])) {
            $tz = $timezoneTable[$defaultTimezone];
        }
        
        if ($la == '') {
            $la = $langDefault;
        }
        
        header("content-type:application/json");
        echo json_encode(array(
            'department' => $dep,
            'location' => $loc,
            'timezone' => $tz,
            'language' => $la,
            'dateFormat' => $dtft,
            'timeFormat' => $tmft,
            'workcalendar' => $wc,
            'enableFlextime' => $eft
        ));
        break;
    case 'departmentDefaults':
        /**
         * get department default values
         */
        $dep = AddSlashesNOD(isset($_POST['department'])?$_POST['department']:'');      // department id
        
        if ($dep == '') {
            $dep = '0';
        }
        
        $querymore1 = " WHERE dep.id='$dep'";
        $departmentDetail = new request();
        $departmentDetail->openDepartments($querymore1);
        $comptDepartmentDetail = count($departmentDetail->dep_id);
        $loc = '0';
        $tz = '';
        $lang = '';

        if ($comptDepartmentDetail > 0) {
            $loc = $departmentDetail->dep_location[0];
            $tz = $departmentDetail->dep_loc_timezone[0];
            $lang = $departmentDetail->dep_loc_language[0];
        }
            
        if (isset($timezoneTable[$tz])) {
            $tz = $timezoneTable[$tz];
        } else if (isset($timezoneTable[$defaultTimezone])) {
            $tz = $timezoneTable[$defaultTimezone];
        }
        
        if ($lang == '') {
            $lang = $langDefault;
        }
        
        header("content-type:application/json");
        echo json_encode(array(
            'location' => $loc,
            'timezone' => $tz,
            'language' => $lang
        ));
        break;
    case 'locationDefaults':
        /**
         * get location default values
         */
        $loc = AddSlashesNOD(isset($_POST['location'])?$_POST['location']:'');    // location id
        
        if ($loc == '') {
            $loc = '0';
        }
        
        $querymore = " WHERE loc.id='$loc'";
        $locationDetail = new request();
        $locationDetail->openLocations($querymore);
        $comptLocationDetail = count($locationDetail->loc_id);
        $tz = '';
        $lang = '';
        
        if ($comptLocationDetail > 0) {
            $tz = $locationDetail->loc_timezone[0];
            $lang = $locationDetail->loc_language[0];
        }
            
        if (isset($timezoneTable[$tz])) {
            $tz = $timezoneTable[$tz];
        } else if (isset($timezoneTable[$defaultTimezone])) {
            $tz = $timezoneTable[$defaultTimezone];
        }
        
        if ($lang == '') {
            $lang = $langDefault;
        }
        
        header("content-type:application/json");
        echo json_encode(array(
            'timezone' => $tz,
            'language' => $lang
        ));
        break;
}
