<?php // $Revision: 1.22 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: emailusers.php,v 1.22 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");
$bodyCommand = "onLoad=\"document.sdEForm.subject.focus();\"";

/**
 * Variables init
 */
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$subject = isset($_POST['subject'])?$_POST['subject']:'';       // subject
$message = isset($_POST['message'])?$_POST['message']:'';       // message
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');         // The unique id of user
$team = AddSlashesNOD(isset($_GET['team'])?$_GET['team']:'');   // $id store team member id instead of user id
$project = AddSlashesNOD(isset($_GET['project'])?$_GET['project']:'');  // project id
$ids = str_replace("**", ",", $id);
$error = '';

/**
 * Permission check
 */
if (!$SW_Permissions['User']['Read'][$profilSession]) {
    header("Location:../general/permissiondenied.php");
    exit;
}

if ($team == 'true') {
    $querymore0 = " WHERE pro.id='$project'";
    $projectDetail = new request();
    $projectDetail->openProjects($querymore0);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == '0') {
        header('Location: ../projects/listprojects.php?msg=blankProject');
        exit;
    }

    $querymore1 = " WHERE tea.id IN ($ids)";
    $listTeams = new request();
    $listTeams->openTeams($querymore1);

    if (count($listTeams->tea_id) <= 0) {
        header("Location:../general/permissiondenied.php");
        exit;
    } else {
        $ids = implode(',', $listTeams->tea_member);
    }
}

$querymore = " WHERE mem.id IN ($ids) ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($querymore);
$comptListMembers = count($listMembers->mem_id);

if ($comptListMembers <= 0) {
    header("Location:../general/permissiondenied.php");
    exit;
}

/**
 * Actions
 */
if ($action == "email") {
    $idList = preg_split("/,/", $ids);
    $mail = new notification();
    $mail->getUserinfo($idSession, "from");

    foreach ($idList as $val) {
        $mail->getUserinfo($val, "to");
    }

    $mail->partMessage = "";
    $mail->openBody();
    $mail->plainContent($message);
    $mail->closeBody();
    $mail->Subject = stripslashes($subject);
    $mail->Priority = "3";
    $mail->SendItOut();

    if ($team == 'true') {
        header("Location:../teams/listusers.php?project=" . $projectDetail->pro_id[0] . "&msg=email");
    } else {
        header("Location:../users/listusers.php?msg=email");
    }

    exit;
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();

if ($team == 'true') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../teams/listusers.php?project=" . $projectDetail->pro_id[0], lang_strings("team_members"), 'in'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=company", lang_strings("administration"), 'in'));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../users/listusers.php?", lang_strings("user_management"), 'in'));
}

$blockPage->itemBreadcrumbs(lang_strings("email_users"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "sdE";
$block1->openForm("../users/emailusers.php?project=$project&team=$team&id=$id#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"email\">";
$block1->heading(lang_strings("email_users"));
$block1->openContent();
$block1->contentTitle(lang_strings("email_following"));

for ($i = 0;$i < $comptListMembers;$i++) {
    if ($listMembers->mem_email_work[$i] != "") {
        $block1->contentRow("", $blockPage->buildLink("../users/viewuser.php?id=" . $listMembers->mem_id[$i], $listMembers->mem_name[$i], 'in'));
    } else {
        $block1->contentRow("", $blockPage->buildLink("../users/viewuser.php?id=" . $listMembers->mem_id[$i], $listMembers->mem_name[$i], 'in') . "&nbsp;&nbsp;" . lang_strings("no_email"));
    }
}

$block1->contentTitle(lang_strings("email"));
setupInputHTML($block1, lang_strings('subject'), 'subject', enumFieldType::ftText, 'Y', '155', $subject);
setupInputHTML($block1, lang_strings('message'), 'message', enumFieldType::ftMemo, 'Y', '0', $message);
$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["send"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once("../includes/footer.php");
