<?php // $Revision: 1.19 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listusers.php,v 1.19 2013/01/29 08:46:19 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$show = isset($_GET['show'])?$_GET['show']:'';
$msg = isset($_GET['msg'])?$_GET['msg']:'';

if ($show != 'all' && $show != 'inactive') {
    $show = 'active';
}

/**
 * Permission check
 */
if (!$SW_Permissions['User']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=company", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs(lang_strings('user_management'));

switch ($show) {
    case 'active':      // show active users only
        $blockPage->itemBreadcrumbs(lang_strings('users_active'));
        $title = $strings['user_management'] . ' : ' . $strings['users_active'];
        break;
    case 'inactive':    // show inactive users only
        $blockPage->itemBreadcrumbs(lang_strings('users_inactive'));
        $title = $strings['user_management'] . ' : ' . $strings['users_inactive'];
        break;
    default:            // show all users
        $blockPage->itemBreadcrumbs(lang_strings('all'));
        $title = $strings['user_management'] . ' : ' . $strings['all'];
}

$blockPage->closeBreadcrumbs();
logURL($title, "../users/listusers.php?show=$show");
$block1 = new block();
$block1->openHeading(lang_strings('user_management'));
$block1->openViewOptions();

foreach (array('all' => lang_strings('all'), 'active' => lang_strings('users_active'), 'inactive' => lang_strings('users_inactive')) as $s => $desc) {
    if ($s != $show) {
        $block1->itemViewOptions($block1->buildLink('../users/listusers.php?show=' . $s, $desc, 'in'));
    }
}

$block1->closeViewOptions();
$block1->closeHeading();
$block1->form = "ulU";
$block1->openForm("../users/listusers.php?show=$show#" . $block1->form . "Anchor");
$sortingFields = array("none", "mem.name", "mem.title", "mem.department", "mem.email_work", "mem.phone_work");
$block1->sorting("users", (isset($sortingUser['users'])?$sortingUser['users']:''), "mem.name ASC", $sortingFields);

switch ($show) {
    case 'active':
        $querymore = " WHERE mem.id<>'1' AND mem.organization='1' AND mem.active='" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
        break;
    case 'inactive':
        $querymore = " WHERE mem.id<>'1' AND mem.organization='1' AND mem.active<>'" . enumBoolean::bTrue . "' ORDER BY " . $block1->sortingValue;
        break;
    default:
        $querymore = " WHERE mem.id<>'1' AND mem.organization='1' ORDER BY " . $block1->sortingValue;
}

$listMembers = new request();
$listMembers->openMembers($querymore);
$comptListMembers = count($listMembers->mem_id);
$columns = array();
$columns[0] = new cardviewColumn();
$columns[0]->field_type = enumFieldType::ftAvatar;
$columns[1] = new cardviewColumn();
$columns[1]->title = $strings['full_name'];
$columns[1]->field_type = enumFieldType::ftText;
$columns[2] = new cardviewColumn();
$columns[2]->title = $strings['title'];
$columns[2]->field_type = enumFieldType::ftText;
$columns[3] = new cardviewColumn();
$columns[3]->title = $strings['department'];
$columns[3]->field_type = enumFieldType::ftNumeric;
$columns[3]->linked_table = 'departments';
$columns[4] = new cardviewColumn();
$columns[4]->title = $strings['email'];
$columns[4]->field_type = enumFieldType::ftEmail;
$columns[5] = new cardviewColumn();
$columns[5]->title = $strings['phone'];
$columns[5]->field_type = enumFieldType::ftText;
$opt[enumCardviewOption::oObject] = 'users';
$opt[enumCardviewOption::oTableName] = 'members';
$opt[enumCardviewOption::oColumns] = $columns;
$opt[enumCardviewOption::oSearch] = true;

if ($SW_Permissions['User']['Write'][$profilSession]) {
    $opt[enumCardviewOption::oAddUrl] = '../users/edituser.php?';
}

$block1->openCardView($opt);

for ($i=0; $i<$comptListMembers; $i++) {
    $content = array(
        implode(',',
            array(
                $listMembers->mem_id[$i],
                $listMembers->mem_extension_picture[$i],
                $listMembers->mem_gender[$i])),
        $listMembers->mem_name[$i],
        $listMembers->mem_title[$i],
        $listMembers->mem_department[$i],
        $listMembers->mem_email_work[$i],
        $listMembers->mem_phone_work[$i]
    );
    $block1->itemCardView($listMembers->mem_id[$i], $content);
}

$block1->closeCardView();
$block1->closeFormResults();
require_once("../includes/footer.php");
