<?php // $Revision: 1.34 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewuser.php,v 1.34 2013/02/19 14:15:26 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$msg = isset($_GET['msg'])?$_GET['msg']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['User']['Read'][$profilSession]) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if ($id != '') {
    $querymore = " WHERE mem.id='$id'";
    $userDetail = new request();
    $userDetail->openMembers($querymore);
    $comptUserDetail = count($userDetail->mem_id);
} else {
    $comptUserDetail = 0;
}

if ($comptUserDetail == 0) {
    header("Location: ../users/listusers.php?msg=blankUser");
    exit;
} else if ($userDetail->mem_organization[0] != '1') {
    header("Location: ../users/viewclientuser.php?id=$id&organization=" . $userDetail->mem_organization[0]);
    exit;
}

$pathPicture = getAvatar($id, $userDetail->mem_extension_picture[0], $userDetail->mem_gender[0], false);

/**
 * HTML
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=company", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../users/listusers.php?", lang_strings("user_management"), 'in'));
$blockPage->itemBreadcrumbs($userDetail->mem_name[0]);
$blockPage->closeBreadcrumbs();
$title = $strings['user_profile'] . ' : ' . $userDetail->mem_name[0];
logURL($title, "../users/viewuser.php?id=$id");
$block1 = new block();
$block1->form = "userD";
$block1->openForm("../users/viewuser.php?id=$id#" . $block1->form . "Anchor");
$block1->heading(lang_strings("user_profile"));
$block1->openPaletteIcon();

if ($SW_Permissions['User']['Write'][$profilSession]) {
    $block1->paletteIcon(6, "copy", $strings["copy"]);
}

if ($SW_Permissions['User']['Admin'][$profilSession]) {
    $block1->paletteIcon(0, "remove", $strings["delete"]);
}

if ($SW_Permissions['User']['Edit'][$profilSession]) {
    $block1->paletteIcon(1, "edit", $strings["edit"]);
}

$block1->paletteIcon(3, "email", $strings["email"]);

if (($enableTimesheet == 'true') && ($enableFlextime == 'true') && ($SW_Permissions['User']['Write'][$profilSession])) {
    $block1->paletteIcon(4, "timelog", lang_strings("adjust_flextime"));
}

$block1->paletteIcon(99, 'search', 'members');
$block1->closePaletteIcon();
$block1->openContent(true);
$block1->contentTitle(lang_strings("user_details"));
$block1->contentRow(lang_strings("user_name"), $userDetail->mem_login[0]);
$block1->contentRow(lang_strings("full_name"), $userDetail->mem_name[0]);
$block1->contentRow(lang_strings('gender'), $genderArray[$userDetail->mem_gender[0]]);
$block1->contentRow(lang_strings("user_profile"), $userDetail->mem_upf_name_print[0]);

if ($userDetail->mem_department[0] == "0") {
    $block1->contentRow(lang_strings("department"), '&nbsp;');
} else {
    $block1->contentRow(lang_strings("department"), $userDetail->mem_dep_name_print[0]);
}

$block1->contentRow(lang_strings("title"), $userDetail->mem_title[0]);
$block1->contentRow(lang_strings("work_email"), $blockPage->buildLink($userDetail->mem_email_work[0], $userDetail->mem_email_work[0], 'mail'));
$block1->contentRow(lang_strings("home_email"), $blockPage->buildLink($userDetail->mem_email_home[0], $userDetail->mem_email_home[0], 'mail'));
$block1->contentRow(lang_strings("work_phone"), $userDetail->mem_phone_work[0]);
$block1->contentRow(lang_strings("home_phone"), $userDetail->mem_phone_home[0]);
$block1->contentRow(lang_strings("mobile_phone"), $userDetail->mem_mobile[0]);
$block1->contentRow(lang_strings("fax"), $userDetail->mem_fax[0]);

if ($userDetail->mem_manager[0] == "0") {
    $block1->contentRow(lang_strings("manager"), '&nbsp;');
} else {
    $block1->contentRow(lang_strings("manager"), $blockPage->buildLink($userDetail->mem_manager[0], '', 'message'));
}

if ($userDetail->mem_deputy[0] == "0") {
    $block1->contentRow(lang_strings("deputy"), '&nbsp;');
} else {
    $block1->contentRow(lang_strings("deputy"), $blockPage->buildLink($userDetail->mem_deputy[0], '', 'message'));
}

if ($userDetail->mem_location[0] == '0') {
    $block1->contentRow(lang_strings("location"), '&nbsp;');
    $block1->contentRow(lang_strings('timezone'), $timezoneTable[$defaultTimezone]);
} else {
    $block1->contentRow(lang_strings('location'), $userDetail->mem_loc_name_print[0]);
    $block1->contentRow(lang_strings('timezone'), $timezoneTable[$userDetail->mem_timezone[0]]);
}

$block1->contentRow(lang_strings('language'), $langValue[$userDetail->mem_language[0]]);

if ($userDetail->mem_date_format[0] == '') {
    $block1->contentRow(lang_strings("date_format"), $strings["system_default"]);
} else {
    $block1->contentRow(lang_strings("date_format"), $dateFormats[$userDetail->mem_date_format[0]]);
}

if ($userDetail->mem_time_format[0] == '') {
    $block1->contentRow(lang_strings("time_format"), $strings["system_default"]);
} else {
    $block1->contentRow(lang_strings("time_format"), $timeFormats[$userDetail->mem_time_format[0]]);
}

$block1->contentRow(lang_strings('workcalendar'), $blockPage->buildLink("../workcalendars/viewworkcalendar.php?id=" . $userDetail->mem_workcalendar[0], $userDetail->mem_wca_name[0], 'in'));

if (($enableTimesheet == 'true') && ($enableFlextime == 'true')) {
    $block1->contentRow(lang_strings('enable_flextime'), (($userDetail->mem_enable_flextime[0]==enumBoolean::bTrue)?lang_strings('yes'):lang_strings('no')));

    if ($userDetail->mem_enable_flextime[0] == enumBoolean::bTrue) {
        $block1->contentRow(lang_strings('begin_flextime'), createDate($userDetail->mem_begin_flextime[0], 'date', false, false));
        $block1->contentRow(lang_strings('initial_flexibalance'), $userDetail->mem_initial_flexibalance[0]);
    }
}

$block1->contentRow(lang_strings("comments"), $userDetail->mem_comments[0]);

if ($useLDAP == 'true') {
    $block1->contentRow ('LDAP DN', $userDetail->mem_ldap_cn[0] . ',' . $configLDAP['basedn']);
}

if ($pathPicture != '') {
    $block1->contentRow(lang_strings('picture'), setupPhotoBox($pathPicture, $userDetail->mem_login[0] . '.' . $userDetail->mem_extension_picture[0]));
}

$block1->contentRow(lang_strings("account_created"), createDate($userDetail->mem_created[0], 'both'));
setupCustomFieldsHTML($block1, 'members', $id);
$block1->contentTitle(lang_strings("information"));
$tmpquery = "SELECT tea.project FROM " . $tablePrefix . "teams tea LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=tea.project WHERE tea.member=" . $userDetail->mem_id[0] . " AND pro.status IN ('" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "')";
compt($tmpquery);
$valueProjects = $countEnregTotal;
$tmpquery = "SELECT res.id FROM " . $tablePrefix . "tasks_resource res LEFT OUTER JOIN " . $tablePrefix . "tasks tas ON tas.id=res.task LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=tas.project WHERE res.resource=" . $userDetail->mem_id[0] . " AND res.type = '" . enumResourceType::rtUser . "' AND tas.status IN ('" . enumStatus::stClientCompleted . "','" . enumStatus::stNotStarted . "','" . enumStatus::stOpen . "') AND pro.status IN ('" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "')";
compt($tmpquery);
$valueTasks = $countEnregTotal;
$tmpquery = "SELECT note.id FROM " . $tablePrefix . "notes note LEFT OUTER JOIN " . $tablePrefix . "projects pro ON pro.id=note.project WHERE note.owner=" . $userDetail->mem_id[0] . " AND pro.status IN ('" . enumProjectStatus::stPlanning . "','" . enumProjectStatus::stOpen . "')";
compt($tmpquery);
$valueNotes = $countEnregTotal;
$block1->contentRow(lang_strings("projects"), $valueProjects);
$block1->contentRow(lang_strings("tasks"), $valueTasks);
$block1->contentRow(lang_strings("notes"), $valueNotes);

if ($userDetail->mem_log_connected[0] > date('U')-5 * 60) {
    $connected_result = lang_strings("yes");
} else {
    $connected_result = lang_strings("no");
}

$block1->contentRow(lang_strings("connected"), $connected_result);
$block1->contentRow(lang_strings("status"), (($userDetail->mem_active[0] == enumBoolean::bTrue)?lang_strings("status_active"):lang_strings("status_inactive")));
$block1->closeContent();
$block1->closeForm();
$block1->openPaletteScript();

if ($SW_Permissions['User']['Write'][$profilSession]) {
    $block1->paletteScript(6, "copy", "../users/edituser.php?id=$id&cpy=true", "true,true,true", $strings["copy"]);
}

if ($SW_Permissions['User']['Admin'][$profilSession]) {
    $block1->paletteScript(0, "remove", "../users/deleteusers.php?id=$id", "true,true,true", $strings["delete"]);
}

if ($SW_Permissions['User']['Edit'][$profilSession]) {
    $block1->paletteScript(1, "edit", "../users/edituser.php?id=$id", "true,true,true", $strings["edit"]);
}

$block1->paletteScript(3, "email", "../users/emailusers.php?id=$id", "true,true,true", $strings["email"]);

if (($enableTimesheet == 'true') && ($enableFlextime == 'true') && ($SW_Permissions['User']['Write'][$profilSession])) {
    $block1->paletteScript(4, "timelog", "../users/addflextimeadjust.php?id=$id", "true,true,true", lang_strings("adjust_flextime"));
}

$block1->paletteScript(99, 'search', 'members');
$block1->closePaletteScript("", "");
require_once("../includes/footer.php");
