<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: deleteworkcalendars.php,v 1.4 2013/01/29 08:46:30 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once("../includes/library.php");

/**
 * Variables init
 */
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$action = isset($_POST['action'])?$_POST['action']:'';

/**
 * Permission check
 */
if (!$SW_Permissions['Work Calendar']['Admin'][$profilSession]) {
    header('Location: ../workcalendars/listworkcalendars.php?msg=permissiondenied' . $urlBornes);
    exit;
}

$ids = "'" . str_replace('**', "','", $id) . "'";
$querymore = " WHERE id IN ($ids)";
$listWorkCalendars = new request();
$listWorkCalendars->openWorkCalendars($querymore);
$comptListWorkCalendars = count($listWorkCalendars->wca_id);

if ($comptListWorkCalendars == '0') {
    header('Location: ../workcalendars/listworkcalendars.php?msg=blankWorkcalendar' . $urlBornes);
    exit;
}

$tmpsql = "SELECT workcalendar FROM " . $tablePrefix . "organizations WHERE workcalendar IN ($ids) UNION ALL SELECT workcalendar FROM " . $tablePrefix . "projects WHERE workcalendar IN ($ids) UNION ALL SELECT workcalendar FROM " . $tablePrefix . "members WHERE workcalendar IN ($ids)";
$cnt = compt($tmpsql);

if ($cnt != '0') {
    header('Location: ../workcalendars/listworkcalendars.php?msg=workcalendarInUse' . $urlBornes);
    exit;
}

/**
 * Action
 */
if ($action == "delete") {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();
        $tmpsql = "DELETE FROM " . $tablePrefix . "workcalendars WHERE id IN ($ids)";
        if ($requestAct->query($tmpsql) === false)
            throw new Exception($tmpsql);
        $tmpsql = "DELETE FROM " . $tablePrefix . "workcalendars_weekday WHERE workcalendar IN ($ids)";
        if ($requestAct->query($tmpsql) === false)
            throw new Exception($tmpsql);
        $tmpsql = "DELETE FROM " . $tablePrefix . "workcalendars_detail WHERE workcalendar IN ($ids)";
        if ($requestAct->query($tmpsql) === false)
            throw new Exception($tmpsql);
        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        header("Location: ../workcalendars/listworkcalendars.php?msg=delete" . $urlBornes);
        exit;
    }
}

/**
 * Html
 */
require_once("../includes/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?toggle_focus=system", lang_strings("administration"), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../workcalendars/listworkcalendars.php?' . $urlBornes, lang_strings('workcalendar_management'), 'in'));
$blockPage->itemBreadcrumbs(lang_strings("delete_workcalendars"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "wcD";
$block1->openForm("../workcalendars/deleteworkcalendars.php?id=$id" . $urlBornes . "#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"delete\">\n";
$block1->heading(lang_strings("delete_workcalendars"));
$block1->openContent();
$block1->contentTitle(lang_strings("delete_following"));

for ($i=0; $i<$comptListWorkCalendars; $i++) {
    $block1->contentRow("", $blockPage->buildLink("../workcalendars/viewworkcalendar.php?id=" . $listWorkCalendars->wca_id[$i] . $urlBornes, $listWorkCalendars->wca_name[$i], 'in'));
}

$block1->contentRow('', "<input type=\"submit\" name=\"delete\" value=\"" . $strings["delete"] . "\"> <input type=\"button\" name=\"cancel\" value=\"" . $strings["cancel"] . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../includes/footer.php");
