<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editworkcalendar.php,v 1.6 2013/01/29 08:46:30 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$thisYear = date("Y");
$action = ($js_enabled == 'Y' && isset($_POST['action']))?$_POST['action']:'';
$nm = isset($_POST['nm'])?$_POST['nm']:'';
$desc = isset($_POST['desc'])?$_POST['desc']:'';
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'');
$yearCalend = AddSlashesNOD(isset($_GET['yearCalend'])?$_GET['yearCalend']:$thisYear);
$prevYear = $yearCalend - 1;
$nextYear = $yearCalend + 1;
$nm_highlight = false;

for ($i=1; $i<=7; $i++) {
    $hours[$i] = isset($_POST['h' . $i])?$_POST['h' . $i]:'0';      // The work hours of workcalendar weekday
    $start_time[$i] = isset($_POST['s' . $i])?DbValueEncode(enumFieldType::ftTime, $_POST['s' . $i]):'';  // The start time of workcalendar weekday
    $end_time[$i] = isset($_POST['e' . $i])?DbValueEncode(enumFieldType::ftTime, $_POST['e' . $i]):'';    // The end time of workcalendar weekday
}

/**
 * Permission check
 */
if ($id == '') {
    if (!$SW_Permissions['Work Calendar']['Write'][$profilSession]) {
        header('Location: ../workcalendars/listworkcalendars.php?msg=permissiondenied' . $urlBornes);
        exit;
    }
} else {
    if (!$SW_Permissions['Work Calendar']['Edit'][$profilSession]) {
        header('Location: ../workcalendars/listworkcalendars.php?msg=permissiondenied' . $urlBornes);
        exit;
    }
}

if ($id != '') {
    $querymore = " WHERE wca.id='$id'";
    $workCalendarDetail = new request();
    $workCalendarDetail->openWorkCalendars($querymore);
    $comptWorkCalendarDetail = count($workCalendarDetail->wca_id);

    if ($comptWorkCalendarDetail == '0') {
        header('Location: ../workcalendars/listworkcalendars.php?msg=blankWorkcalendar' . $urlBornes);
        exit;
    }
}

/**
 * Fields check
 */
if ($action != '') {
    try {
        if ($action == 'add') {
            $querymore = " WHERE wca.name='$nm'";
            $workCalendarDetail = new request();
            $workCalendarDetail->openWorkCalendars($querymore);
            $comptWorkCalendarDetail = count($workCalendarDetail->wca_id);

            if ($comptWorkCalendarDetail != '0') {
                $nm_highlight = true;
                throw new Exception(lang_strings('workcalendar_already_exists'));
            } else {
                $nm_highlight = false;
            }
        }

        for ($i=1; $i<=7; $i++) {
            if (intval($hours[$i]) > 24 || intval($hours[$i]) < 0) {
                $hours_highlight[$i] = true;
                throw new Exception(lang_strings('worked_hours') . ' ' . lang_strings('error_hours'));
            } else {
                $hours_highlight[$i] = false;
                $hours[$i] = round($hours[$i], $hourAccuracy);
            }
        }
    } catch (Exception $e) {
        $error = $e->getMessage();
    }
} else {
    for ($i=1; $i<=7; $i++) {
        $hours_highlight[$i] = false;
    }
}

/**
 * Initial periods data
 */
$error = initialPeriodsOfYear($yearCalend);

/**
 * Actions
 */
if ($error == '' && $action != '') {
    $requestAct = new request();
    $requestAct->connectClass();     // connect to database server

    try {
        $requestAct->startTransaction();

        if ($action == 'reset') {
            $tmpsql = "DELETE FROM " . $tablePrefix . "workcalendars_weekday WHERE workcalendar='$id' AND year='$yearCalend'";    // remove old weekday settings

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $tmpsql = "DELETE FROM " . $tablePrefix . "workcalendars_detail WHERE workcalendar='$id' AND year='$yearCalend'";     // remove old workcalendar detail

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        } else {
            $desc = HtmlEntitiesNOD($desc);
            $tmpsql = "INSERT INTO " . $tablePrefix . "workcalendars (name,description,created,cuser) VALUES ('$nm','$desc','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $id = $requestAct->newId('workcalendars');
        }

        set_time_limit(0);  // no limits the maximum execution time

        if ($periodUnit == 'month') {
            $currDate = mktime(0, 0, 0, 1, 1, $yearCalend);     // The first day of year
            $lastDate = mktime(0, 0, 0, 12, 31, $yearCalend);   // The last day of year
        } else {
            $daysOfWeek = getDaysOfWeek($yearCalend, '1');
            $currDate = $daysOfWeek[0];
            $daysOfWeek = getDaysOfWeek(intval($yearCalend)+1, '1');
            $lastDate = addDays($daysOfWeek[0], -1);
        }

        for ($i=1; $i<=7; $i++) {    // create weekday settings
            $tmpsql = "INSERT INTO " . $tablePrefix . "workcalendars_weekday (workcalendar,year,day_type,hours,start_time,end_time,created,cuser) VALUES ('$id','$yearCalend','$i','" . $hours[$i] . "','" . $start_time[$i] . "','" . $end_time[$i] . "','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }
        }

        while ($currDate <= $lastDate) {    // create workcalendar detail
            $weekDay = date('N', $currDate);    // ISO-8601 numeric representation of the day of the week
            $dt = (($hours[$weekDay]==0)?enumDayType::dtWeekend:enumDayType::dtWorkday);    // The type of date
            $commentsCalend = HtmlEntitiesNOD($dayType[$dt]);       // The remarks of date type
            $tmpsql = "INSERT INTO " . $tablePrefix . "workcalendars_detail(workcalendar,year,date,type,hours,comments,created,cuser) VALUES ('$id','$yearCalend','$currDate','$dt','" . $hours[$weekDay] . "','$commentsCalend','" . time() . "','$idSession')";

            if ($requestAct->query($tmpsql) === false) {
                throw new Exception($tmpsql);
            }

            $currDate = addDays($currDate, 1);
        }

        $requestAct->endTransaction(enumTransactionEndType::etCommit);
    } catch (Exception $e) {
        $error = 'EXCEPTION CAUGHT! LINE ' . $e->getLine() . ' IN ' . $e->getFile();
        error_log($e->getMessage());
        $requestAct->endTransaction(enumTransactionEndType::etRollBack);
    }

    $requestAct->close();

    if ($error == '') {
        if ($action == 'add') {
            header("Location: ../workcalendars/viewworkcalendar.php?id=$id&yearCalend=$yearCalend&msg=add");
            exit;
        } else {
            header("Location: ../workcalendars/viewworkcalendar.php?id=$id&yearCalend=$yearCalend&msg=update" . $urlBornes);
            exit;
        }
    }
}

/**
 * Variables init
 */
if ($error == '') {
    if ($id == '') {
        $comptListWorkCalendarWeekday = '0';
    } else {
        $querymore = " WHERE wcw.workcalendar='$id' AND wcw.year='$yearCalend' ORDER BY wcw.day_type";
        $listWorkCalendarWeekday = new request();
        $listWorkCalendarWeekday->openWorkCalendarsWeekday($querymore);
        $comptListWorkCalendarWeekday = count($listWorkCalendarWeekday->wcw_id);
    }

    if ($comptListWorkCalendarWeekday == '0') {
        for ($i=1; $i<=7; $i++) {
            if ($i >= 6) {
                $hours[$i] = '0';
                $start_time[$i] = '';
                $end_time[$i] = '';
            } else {
                $hours[$i] = '8';
                $start_time[$i] = '0900';
                $end_time[$i] = '1700';
            }
        }
    } else {
        for ($i=1; $i<=7; $i++) {
            $k = array_search($i, $listWorkCalendarWeekday->wcw_day_type);
            $hours[$i] = strval($listWorkCalendarWeekday->wcw_hours[$k]);
            $start_time[$i] = $listWorkCalendarWeekday->wcw_start_time[$k];
            $end_time[$i] = $listWorkCalendarWeekday->wcw_end_time[$k];
        }
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php?toggle_focus=system', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../workcalendars/listworkcalendars.php?' . $urlBornes, lang_strings('workcalendar_management'), 'in'));

if ($id == '') {
    $blockPage->itemBreadcrumbs(lang_strings('add_workcalendar'));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../workcalendars/viewworkcalendar.php?id=' . $id . '&yearCalend=' . $yearCalend . $urlBornes, $workCalendarDetail->wca_name[0], 'in'));
    $blockPage->itemBreadcrumbs(lang_strings('edit_workcalendar'));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "wcW";
$block1->openForm("../workcalendars/editworkcalendar.php?yearCalend=$yearCalend&amp;id=$id" . $urlBornes . "#" . $block1->form . "Anchor");

if ($id == '') {
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">";
    $block1->heading(lang_strings('add_workcalendar'));
    $block1->openContent();
    setupInputHTML($block1, lang_strings('name'), 'nm', enumFieldType::ftAlphaNumeric, 'Y', '155', $nm, '', '', $nm_highlight);
    setupInputHTML($block1, lang_strings("description"), 'desc', enumFieldType::ftText, 'Y', '65535', $desc);
    $block1->closeContent();
    $block1->heading(lang_strings('workcalendar') . " $yearCalend");
} else {
    echo "<input type=\"hidden\" name=\"action\" value=\"reset\">";
    $block1->heading(lang_strings('edit_workcalendar') . ' ' . $yearCalend . '&nbsp;&nbsp;&nbsp;&nbsp;' . $blockPage->buildLink("../workcalendars/editworkcalendar.php?id=$id&amp;yearCalend=$prevYear", lang_strings("previous_year"), 'in') . " | " . $blockPage->buildLink("../workcalendars/editworkcalendar.php?id=$id&amp;yearCalend=$thisYear", lang_strings("this_year"), 'in') . " | " . $blockPage->buildLink("../workcalendars/editworkcalendar.php?id=$id&amp;yearCalend=$nextYear", lang_strings("next_year"), 'in'));
}

$block1->openContent();

for ($i=$firstDayOfWeek,$j=1; $j<=7; $i=(($i==7)?1:($i+1)),$j++) {
    $block1->contentTitle($dayNameArray[$i]);
    setupInputHTML($block1, lang_strings('worked_hours'), 'h' . $i, enumFieldType::ftHours, 'Y', '0', $hours[$i], '', '', $hours_highlight[$i]);
    setupInputHTML($block1, lang_strings('start_time'), 's' . $i, enumFieldType::ftTime, 'N', '0', $start_time[$i]);
    setupInputHTML($block1, lang_strings('end_time'), 'e' . $i, enumFieldType::ftTime, 'N', '0', $end_time[$i]);
}

$block1->contentRow('', "<input type=\"SUBMIT\" value=\"" . $strings["save"] . "\">");
$block1->closeContent();
$block1->note("*&nbsp;" . lang_strings('required'));
$block1->closeForm();
require_once('../includes/footer.php');
