<?php // $Revision: 1.4 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewworkcalendar.php,v 1.4 2013/01/29 08:46:30 luiswang Exp $
 *
 * Copyright (c) 2016 by the webTareas developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

/**
 * Includes
 */
$checkSession = true;
$extractImportVariables = 'false';
require_once('../includes/library.php');

/**
 * Variables init
 */
$thisYear = date("Y");
$id = AddSlashesNOD(isset($_GET['id'])?$_GET['id']:'0');
$msg = isset($_GET['msg'])?$_GET['msg']:'';
$yearCalend = AddSlashesNOD(isset($_GET['yearCalend'])?$_GET['yearCalend']:$thisYear);
$prevYear = $yearCalend - 1;
$nextYear = $yearCalend + 1;

/**
 * Permission check
 */
if (!$SW_Permissions['Work Calendar']['Read'][$profilSession]) {
    header('Location: ../workcalendars/listworkcalendars.php?msg=permissiondenied' . $urlBornes);
    exit;
}

$querymore0 = " WHERE wca.id='$id'";
$workCalendarDetail = new request();
$workCalendarDetail->openWorkCalendars($querymore0);
$comptWorkCalendarDetail = count($workCalendarDetail->wca_id);

if ($comptWorkCalendarDetail == '0') {
    header('Location: ../workcalendars/listworkcalendars.php?msg=blankWorkcalendar' . $urlBornes);
    exit;
}

$querymore1 = " WHERE wcw.workcalendar='$id' AND wcw.year='$yearCalend' ORDER BY wcw.day_type";
$listWorkCalendarWeekday = new request();
$listWorkCalendarWeekday->openWorkCalendarsWeekday($querymore1);
$comptListWorkCalendarWeekday = count($listWorkCalendarWeekday->wcw_id);
$querymore2 = " WHERE wcd.workcalendar='$id' AND wcd.year='$yearCalend' ORDER BY wcd.date";
$listWorkCalendarDetail = new request();
$listWorkCalendarDetail->openWorkCalendarsDetail($querymore2);
$comptListWorkCalendarDetail = count($listWorkCalendarDetail->wcd_id);

if ($comptListWorkCalendarWeekday == '0') {
    if ($SW_Permissions['Work Calendar']['Edit'][$profilSession]) {
        header('Location: ../workcalendars/editworkcalendar.php?yearCalend=' . $yearCalend . '&id=' . $id . $urlBornes);
        exit;
    } else {
        header('Location: ../workcalendars/listworkcalendars.php?msg=noWorkcalendar' . $urlBornes);
        exit;
    }
}

/**
 * HTML
 */
require_once('../includes/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../administration/admin.php?toggle_focus=system', lang_strings('administration'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../workcalendars/listworkcalendars.php?' . $urlBornes, lang_strings('workcalendar_management'), 'in'));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../workcalendars/viewworkcalendar.php?id=$id&yearCalend=$thisYear" . $urlBornes, $workCalendarDetail->wca_name[0], 'in'));
$blockPage->closeBreadcrumbs();
$title = $strings['workcalendar'] . ' : ' . $yearCalend;
logURL($title, "../workcalendars/viewworkcalendar.php?id=$id&yearCalend=$yearCalend");
$block1 = new block();
$block1->heading('<div class="right"><a href="../workcalendars/viewworkcalendar.php?id=' . $id . '&yearCalend=' . $nextYear . $urlBornes . '"><div class="solid-ball">&gt;</div></a></div><div class="left"><a href="../workcalendars/viewworkcalendar.php?id=' . $id . '&amp;yearCalend=' . $prevYear . '"><div class="solid-ball">&lt;</div></a></div><div class="screen-center">' . lang_strings('workcalendar') . ' ' . $yearCalend . '</div>');
echo '<ul class="workcalendar-view">';

if ($periodUnit == 'month') {
    $currDate = mktime(0, 0, 0, 1, 1, $yearCalend);

    for ($month=1; $month<=12; $month++) {
        echo '<li class="month">';
        echo '<div class="caption">' . $monthNameArray[$month] . '</div>';
        echo '<div class="title">';

        for ($daynumber=$firstDayOfWeek,$wn=1; $wn<=7; $daynumber=(($daynumber==7)?1:$daynumber+1),$wn++) {
            echo '<div>' . $dayShortNameArray[$daynumber] . "</div>";
        }

        echo "</div>";
        $firstDay = date("N", mktime(0, 0, 0, $month, 1, $yearCalend));
        $lastDay = mktime(0, 0, 0, $month+1, 0, $yearCalend);
        $day = 1;
        $leadingSpace = true;

        for ($dayRow=0; $dayRow<6; $dayRow++) {
            echo '<div class="week">';

            for ($dayCol=$firstDayOfWeek,$wn=1; $wn<=7; $dayCol=(($dayCol==7)?1:$dayCol+1),$wn++) {
                if ($leadingSpace && $dayCol==$firstDay) {
                    $leadingSpace = false;
                }

                if ($leadingSpace || ($currDate > $lastDay)) {
                    echo '<div class="empty">&nbsp;</div>';
                } else {
                    $h = array_search($currDate, $listWorkCalendarDetail->wcd_date);
                    $classCell = $dayTypeClass[$listWorkCalendarDetail->wcd_type[$h]];

                    if ($classCell == '') {
                        $classCell = "workday";
                    }

                    $comments = createDate($currDate,'date',false,true) . " " . convert_html2txt($listWorkCalendarDetail->wcd_comments[$h]) . " (" . $listWorkCalendarDetail->wcd_hours[$h] . $strings['hours'] . ")";

                    if ($SW_Permissions['Work Calendar']['Edit'][$profilSession]) {
                        echo $blockPage->buildLink("../workcalendars/editworkcalendardetail.php?id=" . $listWorkCalendarDetail->wcd_id[$h] . $urlBornes, '<div class="' . $classCell . '"><abbr title="' . str_replace('"', '&quot;', $comments) . '">' . $day . '</abbr></div>', 'in');
                    } else {
                        echo '<div class="' . $classCell . '"><abbr title="' . str_replace('"', '&quot;', $comments) . "\">$day</abbr></div>";
                    }

                    $day++;
                    $currDate = addDays($currDate, 1);
                }
            }

            echo "</div>";
        }

        echo '</li>';
    }
} else {
    $daysOfWeek0 = getDaysOfWeek($yearCalend, '1');
    $firstDay = $daysOfWeek0[0];
    $daysOfWeek = getDaysOfWeek(intval($yearCalend)+1, '1');
    $lastDay = addDays($daysOfWeek[0], -1);
    $currYear = date('Y', $firstDay);
    $currMonth = date('n', $firstDay);
    $lastYear = date('Y', $lastDay);
    $lastMonth = date('n', $lastDay);
    $currDate = mktime(0, 0, 0, $currMonth, 1, $currYear);
    $monthRows = (($currYear!=$yearCalend || $lastYear!=$yearCalend)?4:3);

    for ($monthRow=0; $monthRow<$monthRows; $monthRow++) {
        for ($monthCol=0; $monthCol<=3; $monthCol++) {
            if ($currDate > $lastDay) {
                continue;
            }

            echo '<li class="month">';

            if ($currYear != $yearCalend) {
                echo '<div class="caption">' . $monthNameArray[$currMonth] . "($currYear)</div>";
            } else {
                echo '<div class="caption">' . $monthNameArray[$currMonth] . "</div>";
            }

            echo '<div class="title">';

            for ($daynumber=$firstDayOfWeek,$wn=1; $wn<=7; $daynumber=(($daynumber==7)?1:$daynumber+1),$wn++) {
                echo '<div>' . $dayShortNameArray[$daynumber] . "</div>";
            }

            echo "</div>";
            $day1 = date("N", mktime(0, 0, 0, $currMonth, 1, $currYear));
            $lastDayOfMonth = mktime(0, 0, 0, $currMonth+1, 0, $currYear);
            $day = 1;
            $leadingSpace = true;

            for ($dayRow=0; $dayRow<6; $dayRow++) {
                echo '<div class="week">';

                for ($dayCol=$firstDayOfWeek,$wn=1; $wn<=7; $dayCol=(($dayCol==7)?1:$dayCol+1),$wn++) {
                    if ($leadingSpace && ($dayCol == $day1)) {
                        $leadingSpace = false;
                    }

                    if ($leadingSpace || ($currDate < $firstDay) || ($currDate > $lastDayOfMonth) || ($currDate > $lastDay)) {
                        echo "<div class=\"empty\">&nbsp;</div>";
                    } else {
                        $h = array_search($currDate, $listWorkCalendarDetail->wcd_date);
                        $classCell = $dayTypeClass[$listWorkCalendarDetail->wcd_type[$h]];

                        if ($classCell == '') {
                            $classCell = "workday";
                        }

                        $comments = createDate($currDate,'date',false,true) . " " . convert_html2txt($listWorkCalendarDetail->wcd_comments[$h]) . " (" . $listWorkCalendarDetail->wcd_hours[$h] . $strings['hours'] . ")";

                        if ($SW_Permissions['Work Calendar']['Edit'][$profilSession]) {
                            echo $blockPage->buildLink("../workcalendars/editworkcalendardetail.php?id=" . $listWorkCalendarDetail->wcd_id[$h] . $urlBornes, "<div class=\"$classCell\"><abbr title=\"" . str_replace('"', '&quot;', $comments) . "\">" . $day . "</abbr></div>", 'in');
                        } else {
                            echo "<div class=\"$classCell\"><abbr title=\"" . str_replace('"', '&quot;', $comments) . "\">$day</abbr></div>";
                        }
                    }

                    if (!$leadingSpace && ($currDate <= $lastDayOfMonth)) {
                        $day++;
                        $currDate = addDays($currDate, 1);
                    }
                }

                echo "</div>";
            }

            if ($currMonth == '12') {
                $currMonth = '1';
                $currYear++;
            } else {
                $currMonth++;
            }

            echo '</li>';
        }
    }
}

echo '</ul>';
// day type colours
echo '<div class="right"><table cellPadding="5" cellSpacing="5"><tr>';

foreach ($dayType as $k => $d) {
    echo '<td class="' . $dayTypeClass[$k] . '"> ' . $d . ' </td>';
}

echo '</tr></table></div>';
$block2 = new block();
$block2->form = "vwC";
$block2->openForm("../workcalendars/viewworkcalendar.php?id=$id&yearCalend=$yearCalend" . $urlBornes . "#" . $block2->form . "Anchor");
$block2->heading(lang_strings('weekday'));

if ($SW_Permissions['Work Calendar']['Edit'][$profilSession]) {
    $block2->openPaletteIcon();
    $block2->paletteIcon(0, "edit", $strings["edit"]);
    $block2->closePaletteIcon();
}

echo '<div class="weekday-view"><div class="row"><div>&nbsp;</div>';

for ($i=$firstDayOfWeek,$j=1; $j<=7; $i=(($i==7)?1:$i+1),$j++) {
    echo '<div class="title">' . $dayShortNameArray[$i] . '</div>';
}

echo '<div class="title">' . lang_strings('total') . '</div></div>'
    . '<div class="row"><div class="title">' . lang_strings('work_hours') . '</div>';

for ($i=$firstDayOfWeek,$j=1; $j<=7; $i=(($i==7)?1:$i+1),$j++) {
    $k = array_search($i, $listWorkCalendarWeekday->wcw_day_type);
    echo '<div>' . NumberFormatNOD($listWorkCalendarWeekday->wcw_hours[$k], $hourAccuracy, false) . '</div>';
}

echo '<div>' . NumberFormatNOD(array_sum($listWorkCalendarWeekday->wcw_hours), $hourAccuracy, false) . '</div></div>'
    . '<div class="row"><div class="title">' . lang_strings('start_time') . '</div>';

for ($i=$firstDayOfWeek,$j=1; $j<=7; $i=(($i==7)?1:$i+1),$j++) {
    $k = array_search($i, $listWorkCalendarWeekday->wcw_day_type);

    if ($listWorkCalendarWeekday->wcw_start_time[$k] == '') {
        echo '<div>&nbsp;</div>';
    } else {
        echo '<div>' . DbValueDecode(enumFieldType::ftTime, $listWorkCalendarWeekday->wcw_start_time[$k]) . '</div>';
    }
}

echo '<div>&nbsp;</div></div>'
. '<div class="row"><div class="title">' . lang_strings('end_time') . '</div>';

for ($i=$firstDayOfWeek,$j=1; $j<=7; $i=(($i==7)?1:$i+1),$j++) {
    $k = array_search($i, $listWorkCalendarWeekday->wcw_day_type);

    if ($listWorkCalendarWeekday->wcw_end_time[$k] == '') {
        echo '<div>&nbsp;</div>';
    } else {
        echo '<div>' . DbValueDecode(enumFieldType::ftTime, $listWorkCalendarWeekday->wcw_end_time[$k]) . '</div>';
    }
}

echo '<div>&nbsp;</div></div></div>';

if ($SW_Permissions['Work Calendar']['Edit'][$profilSession]) {
    $block2->openPaletteScript();
    $block2->paletteScript(0, "edit", "../workcalendars/editworkcalendar.php?id=$id&yearCalend=$yearCalend" . $urlBornes, "true,true,false", $strings["edit"]);
    $block2->closePaletteScript("", "");
}

$block2->closeForm();
require_once('../includes/footer.php');
